/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/errors","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/platform/policy/common/policy","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(H){for(var e=[],I=0,t=H.length;I<t;I++)e[I]=ee[H[I]];return e};define(ee[120],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function I(R){return R?R.replace(/\$\((.*?)\)/g,(A,k)=>` ${k} `).trim():""}e.getCodiconAriaLabel=I;class t{constructor(A,k,p){this.id=A,this.definition=k,this.description=p,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var C;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function k(y){if(y instanceof t)return["codicon","codicon-"+y.id];const P=A.exec(y.id);if(!P)return k(t.error);const[,E,f]=P,w=["codicon","codicon-"+E];return f&&w.push("codicon-modifier-"+f.substring(1)),w}R.asClassNameArray=k;function p(y){return k(y).join(" ")}R.asClassName=p;function m(y){return"."+k(y).join(".")}R.asCSSSelector=m})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ee[121],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(k,p){const m=Math.pow(10,p);return Math.round(k*m)/m}class t{constructor(p,m,y,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,p))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=I(Math.max(Math.min(1,P),0),3)}static equals(p,m){return p.r===m.r&&p.g===m.g&&p.b===m.b&&p.a===m.a}}e.RGBA=t;class C{constructor(p,m,y,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=I(Math.max(Math.min(1,m),0),3),this.l=I(Math.max(Math.min(1,y),0),3),this.a=I(Math.max(Math.min(1,P),0),3)}static equals(p,m){return p.h===m.h&&p.s===m.s&&p.l===m.l&&p.a===m.a}static fromRGBA(p){const m=p.r/255,y=p.g/255,P=p.b/255,E=p.a,f=Math.max(m,y,P),w=Math.min(m,y,P);let d=0,b=0;const u=(w+f)/2,v=f-w;if(v>0){switch(b=Math.min(u<=.5?v/(2*u):v/(2-2*u),1),f){case m:d=(y-P)/v+(y<P?6:0);break;case y:d=(P-m)/v+2;break;case P:d=(m-y)/v+4;break}d*=60,d=Math.round(d)}return new C(d,b,u,E)}static i(p,m,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?p+(m-p)*6*y:y<1/2?m:y<2/3?p+(m-p)*(2/3-y)*6:p}static toRGBA(p){const m=p.h/360,{s:y,l:P,a:E}=p;let f,w,d;if(y===0)f=w=d=P;else{const b=P<.5?P*(1+y):P+y-P*y,u=2*P-b;f=C.i(u,b,m+1/3),w=C.i(u,b,m),d=C.i(u,b,m-1/3)}return new t(Math.round(f*255),Math.round(w*255),Math.round(d*255),E)}}e.HSLA=C;class R{constructor(p,m,y,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=I(Math.max(Math.min(1,m),0),3),this.v=I(Math.max(Math.min(1,y),0),3),this.a=I(Math.max(Math.min(1,P),0),3)}static equals(p,m){return p.h===m.h&&p.s===m.s&&p.v===m.v&&p.a===m.a}static fromRGBA(p){const m=p.r/255,y=p.g/255,P=p.b/255,E=Math.max(m,y,P),f=Math.min(m,y,P),w=E-f,d=E===0?0:w/E;let b;return w===0?b=0:E===m?b=((y-P)/w%6+6)%6:E===y?b=(P-m)/w+2:b=(m-y)/w+4,new R(Math.round(b*60),d,E,p.a)}static toRGBA(p){const{h:m,s:y,v:P,a:E}=p,f=P*y,w=f*(1-Math.abs(m/60%2-1)),d=P-f;let[b,u,v]=[0,0,0];return m<60?(b=f,u=w):m<120?(b=w,u=f):m<180?(u=f,v=w):m<240?(u=w,v=f):m<300?(b=w,v=f):m<=360&&(b=f,v=w),b=Math.round((b+d)*255),u=Math.round((u+d)*255),v=Math.round((v+d)*255),new t(b,u,v,E)}}e.HSVA=R;class A{static fromHex(p){return A.Format.CSS.parseHex(p)||A.red}static equals(p,m){return!p&&!m?!0:!p||!m?!1:p.equals(m)}get hsla(){return this.i?this.i:C.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(p){if(p)if(p instanceof t)this.rgba=p;else if(p instanceof C)this.i=p,this.rgba=C.toRGBA(p);else if(p instanceof R)this.j=p,this.rgba=R.toRGBA(p);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(p){return!!p&&t.equals(this.rgba,p.rgba)&&C.equals(this.hsla,p.hsla)&&R.equals(this.hsva,p.hsva)}getRelativeLuminance(){const p=A.k(this.rgba.r),m=A.k(this.rgba.g),y=A.k(this.rgba.b),P=.2126*p+.7152*m+.0722*y;return I(P,4)}static k(p){const m=p/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(p){const m=this.getRelativeLuminance(),y=p.getRelativeLuminance();return m>y?(m+.05)/(y+.05):(y+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(p){const m=this.getRelativeLuminance(),y=p.getRelativeLuminance();return m>y}isDarkerThan(p){const m=this.getRelativeLuminance(),y=p.getRelativeLuminance();return m<y}lighten(p){return new A(new C(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*p,this.hsla.a))}darken(p){return new A(new C(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*p,this.hsla.a))}transparent(p){const{r:m,g:y,b:P,a:E}=this.rgba;return new A(new t(m,y,P,E*p))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(p){const m=p.rgba,y=this.rgba.a,P=m.a,E=y+P*(1-y);if(E<1e-6)return A.transparent;const f=this.rgba.r*y/E+m.r*P*(1-y)/E,w=this.rgba.g*y/E+m.g*P*(1-y)/E,d=this.rgba.b*y/E+m.b*P*(1-y)/E;return new A(new t(f,w,d,E))}makeOpaque(p){if(this.isOpaque()||p.rgba.a!==1)return this;const{r:m,g:y,b:P,a:E}=this.rgba;return new A(new t(p.rgba.r-E*(p.rgba.r-m),p.rgba.g-E*(p.rgba.g-y),p.rgba.b-E*(p.rgba.b-P),1))}flatten(...p){const m=p.reduceRight((y,P)=>A.o(P,y));return A.o(this,m)}static o(p,m){const y=1-p.rgba.a;return new A(new t(y*m.rgba.r+p.rgba.a*p.rgba.r,y*m.rgba.g+p.rgba.a*p.rgba.g,y*m.rgba.b+p.rgba.a*p.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(p,m,y){if(p.isLighterThan(m))return p;y=y||.5;const P=p.getRelativeLuminance(),E=m.getRelativeLuminance();return y=y*(E-P)/E,p.lighten(y)}static getDarkerColor(p,m,y){if(p.isDarkerThan(m))return p;y=y||.5;const P=p.getRelativeLuminance(),E=m.getRelativeLuminance();return y=y*(P-E)/P,p.darken(y)}}e.Color=A,A.white=new A(new t(255,255,255,1)),A.black=new A(new t(0,0,0,1)),A.red=new A(new t(255,0,0,1)),A.blue=new A(new t(0,0,255,1)),A.green=new A(new t(0,255,0,1)),A.cyan=new A(new t(0,255,255,1)),A.lightgrey=new A(new t(211,211,211,1)),A.transparent=new A(new t(0,0,0,0)),function(k){let p;(function(m){let y;(function(P){function E(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:k.Format.CSS.formatRGBA(i)}P.formatRGB=E;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}P.formatRGBA=f;function w(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(i)}P.formatHSL=w;function d(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}P.formatHSLA=d;function b(i){const s=i.toString(16);return s.length!==2?"0"+s:s}function u(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}P.formatHex=u;function v(i,s=!1){return s&&i.rgba.a===1?k.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}P.formatHexA=v;function g(i){return i.isOpaque()?k.Format.CSS.formatHex(i):k.Format.CSS.formatRGBA(i)}P.format=g;function h(i){const s=i.length;if(s===0||i.charCodeAt(0)!==35)return null;if(s===7){const n=16*l(i.charCodeAt(1))+l(i.charCodeAt(2)),a=16*l(i.charCodeAt(3))+l(i.charCodeAt(4)),r=16*l(i.charCodeAt(5))+l(i.charCodeAt(6));return new k(new t(n,a,r,1))}if(s===9){const n=16*l(i.charCodeAt(1))+l(i.charCodeAt(2)),a=16*l(i.charCodeAt(3))+l(i.charCodeAt(4)),r=16*l(i.charCodeAt(5))+l(i.charCodeAt(6)),c=16*l(i.charCodeAt(7))+l(i.charCodeAt(8));return new k(new t(n,a,r,c/255))}if(s===4){const n=l(i.charCodeAt(1)),a=l(i.charCodeAt(2)),r=l(i.charCodeAt(3));return new k(new t(16*n+n,16*a+a,16*r+r))}if(s===5){const n=l(i.charCodeAt(1)),a=l(i.charCodeAt(2)),r=l(i.charCodeAt(3)),c=l(i.charCodeAt(4));return new k(new t(16*n+n,16*a+a,16*r+r,(16*c+c)/255))}return null}P.parseHex=h;function l(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=m.CSS||(m.CSS={}))})(p=k.Format||(k.Format={}))}(A=e.Color||(e.Color={}))}),define(ee[53],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(A){return(k,p,m)=>{let y=null,P=null;if(typeof m.value=="function"?(y="value",P=m.value):typeof m.get=="function"&&(y="get",P=m.get),!P)throw new Error("not supported");m[y]=A(P,p)}}function t(A,k,p){let m=null,y=null;if(typeof p.value=="function"?(m="value",y=p.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(m="get",y=p.get),!y)throw new Error("not supported");const P=`$memoize$${k}`;p[m]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,E)}),this[P]}}e.memoize=t;function C(A,k,p){return I((m,y)=>{const P=`$debounce$${y}`,E=`$debounce$result$${y}`;return function(...f){this[E]||(this[E]=p?p():void 0),clearTimeout(this[P]),k&&(this[E]=k(this[E],...f),f=[this[E]]),this[P]=setTimeout(()=>{m.apply(this,f),this[E]=p?p():void 0},A)}})}e.debounce=C;function R(A,k,p){return I((m,y)=>{const P=`$throttle$timer$${y}`,E=`$throttle$result$${y}`,f=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...d){if(this[E]||(this[E]=p?p():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),k&&(this[E]=k(this[E],...d)),this[w])return;const b=this[f]+A;b<=Date.now()?(this[f]=Date.now(),m.apply(this,[this[E]]),this[E]=p?p():void 0):(this[w]=!0,this[P]=setTimeout(()=>{this[w]=!1,this[f]=Date.now(),m.apply(this,[this[E]]),this[E]=p?p():void 0},b-Date.now()))}})}e.throttle=R}),define(ee[14],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?g.isErrorNoTelemetry(i)?new g(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=I,e.errorHandler=new I;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function C(l){p(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=C;function R(l){p(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function A(l){if(l instanceof Error){const{name:i,message:s}=l,n=l.stacktrace||l.stack;return{$isError:!0,name:i,message:s,stack:n,noTelemetry:g.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=A;const k="Canceled";function p(l){return l instanceof m?!0:l instanceof Error&&l.name===k&&l.message===k}e.isCancellationError=p;class m extends Error{constructor(){super(k),this.name=this.message}}e.CancellationError=m;function y(){const l=new Error(k);return l.name=l.message,l}e.canceled=y;function P(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=P;function E(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=E;function f(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function w(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=w;function d(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=d;class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=b;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=u;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class g extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof g)return i;const s=new g;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class h extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(ee[24],te([0,1,14]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,Z=0){return j[j.length-(1+Z)]}e.tail=t;function C(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=C;function R(j,Z,x=(oe,ge)=>oe===ge){if(j===Z)return!0;if(!j||!Z||j.length!==Z.length)return!1;for(let oe=0,ge=j.length;oe<ge;oe++)if(!x(j[oe],Z[oe]))return!1;return!0}e.equals=R;function A(j,Z){const x=j.length-1;Z<x&&(j[Z]=j[x]),j.pop()}e.removeFastWithoutKeepingOrder=A;function k(j,Z,x){return p(j.length,oe=>x(j[oe],Z))}e.binarySearch=k;function p(j,Z){let x=0,oe=j-1;for(;x<=oe;){const ge=(x+oe)/2|0,Me=Z(ge);if(Me<0)x=ge+1;else if(Me>0)oe=ge-1;else return ge}return-(x+1)}e.binarySearch2=p;function m(j,Z){let x=0,oe=j.length;if(oe===0)return 0;for(;x<oe;){const ge=Math.floor((x+oe)/2);Z(j[ge])?oe=ge:x=ge+1}return x}e.findFirstInSorted=m;function y(j,Z,x){if(j=j|0,j>=Z.length)throw new TypeError("invalid index");const oe=Z[Math.floor(Z.length*Math.random())],ge=[],Me=[],Oe=[];for(const Ce of Z){const Le=x(Ce,oe);Le<0?ge.push(Ce):Le>0?Me.push(Ce):Oe.push(Ce)}return j<ge.length?y(j,ge,x):j<ge.length+Oe.length?Oe[0]:y(j-(ge.length+Oe.length),Me,x)}e.quickSelect=y;function P(j,Z){const x=[];let oe;for(const ge of j.slice(0).sort(Z))!oe||Z(oe[0],ge)!==0?(oe=[ge],x.push(oe)):oe.push(ge);return x}e.groupBy=P;function E(j,Z,x){const oe=[];function ge(Ce,Le,be){if(Le===0&&be.length===0)return;const we=oe[oe.length-1];we&&we.start+we.deleteCount===Ce?(we.deleteCount+=Le,we.toInsert.push(...be)):oe.push({start:Ce,deleteCount:Le,toInsert:be})}let Me=0,Oe=0;for(;;){if(Me===j.length){ge(Me,0,Z.slice(Oe));break}if(Oe===Z.length){ge(Me,j.length-Me,[]);break}const Ce=j[Me],Le=Z[Oe],be=x(Ce,Le);be===0?(Me+=1,Oe+=1):be<0?(ge(Me,1,[]),Me+=1):be>0&&(ge(Me,0,[Le]),Oe+=1)}return oe}e.sortedDiff=E;function f(j,Z,x){const oe=E(j,Z,x),ge=[],Me=[];for(const Oe of oe)ge.push(...j.slice(Oe.start,Oe.start+Oe.deleteCount)),Me.push(...Oe.toInsert);return{removed:ge,added:Me}}e.delta=f;function w(j,Z,x){if(x===0)return[];const oe=j.slice(0,x).sort(Z);return b(j,Z,oe,x,j.length),oe}e.top=w;function d(j,Z,x,oe,ge){return x===0?Promise.resolve([]):new Promise((Me,Oe)=>{(async()=>{const Ce=j.length,Le=j.slice(0,x).sort(Z);for(let be=x,we=Math.min(x+oe,Ce);be<Ce;be=we,we=Math.min(we+oe,Ce)){if(be>x&&await new Promise(ye=>setTimeout(ye)),ge&&ge.isCancellationRequested)throw new I.CancellationError;b(j,Z,Le,be,we)}return Le})().then(Me,Oe)})}e.topAsync=d;function b(j,Z,x,oe,ge){for(const Me=x.length;oe<ge;oe++){const Oe=j[oe];if(Z(Oe,x[Me-1])<0){x.pop();const Ce=m(x,Le=>Z(Oe,Le)<0);x.splice(Ce,0,Oe)}}}function u(j){return j.filter(Z=>!!Z)}e.coalesce=u;function v(j){let Z=0;for(let x=0;x<j.length;x++)j[x]&&(j[Z]=j[x],Z+=1);j.length=Z}e.coalesceInPlace=v;function g(j,Z,x){j.splice(x,0,j.splice(Z,1)[0])}e.move=g;function h(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=h;function l(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=l;function i(j,Z=x=>x){const x=new Set;return j.filter(oe=>{const ge=Z(oe);return x.has(ge)?!1:(x.add(ge),!0)})}e.distinct=i;function s(j){const Z=new Set;return x=>{const oe=j(x);return Z.has(oe)?!1:(Z.add(oe),!0)}}e.uniqueFilter=s;function n(j,Z){const x=a(j,Z);if(x!==-1)return j[x]}e.findLast=n;function a(j,Z){for(let x=j.length-1;x>=0;x--){const oe=j[x];if(Z(oe))return x}return-1}e.lastIndex=a;function r(j,Z){return j.length>0?j[0]:Z}e.firstOrDefault=r;function c(j,Z){return j.length>0?j[j.length-1]:Z}e.lastOrDefault=c;function o(j,Z,x=(oe,ge)=>oe===ge){let oe=0;for(let ge=0,Me=Math.min(j.length,Z.length);ge<Me&&x(j[ge],Z[ge]);ge++)oe++;return oe}e.commonPrefixLength=o;function S(j){return[].concat(...j)}e.flatten=S;function M(j,Z){let x=typeof Z=="number"?j:0;typeof Z=="number"?x=j:(x=0,Z=j);const oe=[];if(x<=Z)for(let ge=x;ge<Z;ge++)oe.push(ge);else for(let ge=x;ge>Z;ge--)oe.push(ge);return oe}e.range=M;function L(j,Z,x){return j.reduce((oe,ge)=>(oe[Z(ge)]=x?x(ge):ge,oe),Object.create(null))}e.index=L;function B(j,Z){return j.push(Z),()=>J(j,Z)}e.insert=B;function J(j,Z){const x=j.indexOf(Z);if(x>-1)return j.splice(x,1),Z}e.remove=J;function ae(j,Z,x){const oe=j.slice(0,Z),ge=j.slice(Z);return oe.concat(x,ge)}e.arrayInsert=ae;function X(j,Z){let x;if(typeof Z=="number"){let oe=Z;x=()=>{const ge=Math.sin(oe++)*179426549;return ge-Math.floor(ge)}}else x=Math.random;for(let oe=j.length-1;oe>0;oe-=1){const ge=Math.floor(x()*(oe+1)),Me=j[oe];j[oe]=j[ge],j[ge]=Me}}e.shuffle=X;function Y(j,Z){const x=j.indexOf(Z);x>-1&&(j.splice(x,1),j.unshift(Z))}e.pushToStart=Y;function re(j,Z){const x=j.indexOf(Z);x>-1&&(j.splice(x,1),j.push(Z))}e.pushToEnd=re;function ne(j,Z){for(const x of Z)j.push(x)}e.pushMany=ne;function de(j,Z){return Array.isArray(j)?j.map(Z):Z(j)}e.mapArrayOrNot=de;function K(j){return Array.isArray(j)?j:[j]}e.asArray=K;function le(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=le;function F(j,Z){for(const x of j){const oe=Z(x);if(oe!==void 0)return oe}}e.mapFind=F;function T(j,Z,x){const oe=V(j,Z),ge=j.length,Me=x.length;j.length=ge+Me;for(let Oe=ge-1;Oe>=oe;Oe--)j[Oe+Me]=j[Oe];for(let Oe=0;Oe<Me;Oe++)j[Oe+oe]=x[Oe]}e.insertInto=T;function N(j,Z,x,oe){const ge=V(j,Z),Me=j.splice(ge,x);return T(j,ge,oe),Me}e.splice=N;function V(j,Z){return Z<0?Math.max(Z+j.length,0):Math.min(Z,j.length)}var se;(function(j){function Z(ge){return ge<0}j.isLessThan=Z;function x(ge){return ge>0}j.isGreaterThan=x;function oe(ge){return ge===0}j.isNeitherLessOrGreaterThan=oe,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(se=e.CompareResult||(e.CompareResult={}));function z(j,Z){return(x,oe)=>Z(j(x),j(oe))}e.compareBy=z;function $(...j){return(Z,x)=>{for(const oe of j){const ge=oe(Z,x);if(!se.isNeitherLessOrGreaterThan(ge))return ge}return se.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const D=(j,Z)=>j-Z;e.numberComparator=D;function O(j,Z){if(j.length===0)return;let x=j[0];for(let oe=1;oe<j.length;oe++){const ge=j[oe];Z(ge,x)>0&&(x=ge)}return x}e.findMaxBy=O;function W(j,Z){if(j.length===0)return;let x=j[0];for(let oe=1;oe<j.length;oe++){const ge=j[oe];Z(ge,x)>=0&&(x=ge)}return x}e.findLastMaxBy=W;function U(j,Z){return O(j,(x,oe)=>-Z(x,oe))}e.findMinBy=U;class q{constructor(Z){this.f=Z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let x=this.c;for(;x<this.f.length&&Z(this.f[x]);)x++;const oe=x===this.c?null:this.f.slice(this.c,x);return this.c=x,oe}takeFromEndWhile(Z){let x=this.d;for(;x>=0&&Z(this.f[x]);)x--;const oe=x===this.d?null:this.f.slice(x+1,this.d+1);return this.d=x,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Z=this.f[this.c];return this.c++,Z}removeLast(){const Z=this.f[this.d];return this.d--,Z}takeCount(Z){const x=this.f.slice(this.c,this.c+Z);return this.c+=Z,x}}e.ArrayQueue=q;class Q{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(x=>(Z(x),!0))}toArray(){const Z=[];return this.iterate(x=>(Z.push(x),!0)),Z}filter(Z){return new Q(x=>this.iterate(oe=>Z(oe)?x(oe):!0))}map(Z){return new Q(x=>this.iterate(oe=>x(Z(oe))))}some(Z){let x=!1;return this.iterate(oe=>(x=Z(oe),!x)),x}findFirst(Z){let x;return this.iterate(oe=>Z(oe)?(x=oe,!1):!0),x}findLast(Z){let x;return this.iterate(oe=>(Z(oe)&&(x=oe),!0)),x}findLastMaxBy(Z){let x,oe=!0;return this.iterate(ge=>((oe||se.isGreaterThan(Z(ge,x)))&&(oe=!1,x=ge),!0)),x}}e.CallbackIterable=Q,Q.empty=new Q(j=>{})}),define(ee[122],te([0,1,14]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(p,m){if(!p)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=t;function C(p,m="Unreachable"){throw new Error(m)}e.assertNever=C;function R(p){if(!p)throw new I.BugIndicatingError("Assertion Failed")}e.assert=R;function A(p){if(!p()){debugger;p(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function k(p,m){let y=0;for(;y<p.length-1;){const P=p[y],E=p[y+1];if(!m(P,E))return!1;y++}return!0}e.checkAdjacentItems=k}),define(ee[50],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(t){const C=this;let R=!1,A;return function(){return R||(R=!0,A=t.apply(C,arguments)),A}}e.once=I}),define(ee[67],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(t){function C(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}t.is=C;const R=Object.freeze([]);function A(){return R}t.empty=A;function*k(h){yield h}t.single=k;function p(h){return C(h)?h:k(h)}t.wrap=p;function m(h){return h||R}t.from=m;function y(h){return!h||h[Symbol.iterator]().next().done===!0}t.isEmpty=y;function P(h){return h[Symbol.iterator]().next().value}t.first=P;function E(h,l){for(const i of h)if(l(i))return!0;return!1}t.some=E;function f(h,l){for(const i of h)if(l(i))return i}t.find=f;function*w(h,l){for(const i of h)l(i)&&(yield i)}t.filter=w;function*d(h,l){let i=0;for(const s of h)yield l(s,i++)}t.map=d;function*b(...h){for(const l of h)for(const i of l)yield i}t.concat=b;function u(h,l,i){let s=i;for(const n of h)s=l(s,n);return s}t.reduce=u;function*v(h,l,i=h.length){for(l<0&&(l+=h.length),i<0?i+=h.length:i>h.length&&(i=h.length);l<i;l++)yield h[l]}t.slice=v;function g(h,l=Number.POSITIVE_INFINITY){const i=[];if(l===0)return[i,h];const s=h[Symbol.iterator]();for(let n=0;n<l;n++){const a=s.next();if(a.done)return[i,t.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=g})(I=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function A(i,s=!1){let n=0;const a=i.length;let r="",c=0,o=16,S=0;function M(re){let ne=0,de=0;for(;ne<re;){const K=i.charCodeAt(n);if(K>=48&&K<=57)de=de*16+K-48;else if(K>=65&&K<=70)de=de*16+K-65+10;else if(K>=97&&K<=102)de=de*16+K-97+10;else break;n++,ne++}return ne<re&&(de=-1),de}function L(re){n=re,r="",c=0,o=16,S=0}function B(){const re=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return S=3,i.substring(re,n);let ne=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;ne=n}else S=3;return i.substring(re,ne)}function J(){let re="",ne=n;for(;;){if(n>=a){re+=i.substring(ne,n),S=2;break}const de=i.charCodeAt(n);if(de===34){re+=i.substring(ne,n),n++;break}if(de===92){if(re+=i.substring(ne,n),n++,n>=a){S=2;break}switch(i.charCodeAt(n++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const le=M(4);le>=0?re+=String.fromCharCode(le):S=4;break}default:S=5}ne=n;continue}if(de>=0&&de<=31)if(p(de)){re+=i.substring(ne,n),S=2;break}else S=6;n++}return re}function ae(){if(r="",S=0,c=n,n>=a)return c=a,o=17;let re=i.charCodeAt(n);if(k(re)){do n++,r+=String.fromCharCode(re),re=i.charCodeAt(n);while(k(re));return o=15}if(p(re))return n++,r+=String.fromCharCode(re),re===13&&i.charCodeAt(n)===10&&(n++,r+=`
`),o=14;switch(re){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,r=J(),o=10;case 47:{const ne=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<a&&!p(i.charCodeAt(n));)n++;return r=i.substring(ne,n),o=12}if(i.charCodeAt(n+1)===42){n+=2;const de=a-1;let K=!1;for(;n<de;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,K=!0;break}n++}return K||(n++,S=1),r=i.substring(ne,n),o=13}return r+=String.fromCharCode(re),n++,o=16}case 45:if(r+=String.fromCharCode(re),n++,n===a||!m(i.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=B(),o=11;default:for(;n<a&&X(re);)n++,re=i.charCodeAt(n);if(c!==n){switch(r=i.substring(c,n),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(re),n++,o=16}}function X(re){if(k(re)||p(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let re;do re=ae();while(re>=12&&re<=15);return re}return{setPosition:L,getPosition:()=>n,scan:s?Y:ae,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>S}}e.createScanner=A;function k(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function p(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function P(i,s){const n=[],a=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function S(M,L,B,J){c.value=M,c.offset=L,c.length=B,c.type=J,c.colonOffset=void 0,r=c}try{g(i,{onObjectBegin:(M,L)=>{if(s<=M)throw a;r=void 0,o=s>M,n.push("")},onObjectProperty:(M,L,B)=>{if(s<L||(S(M,L,B,"property"),n[n.length-1]=M,s<=L+B))throw a},onObjectEnd:(M,L)=>{if(s<=M)throw a;r=void 0,n.pop()},onArrayBegin:(M,L)=>{if(s<=M)throw a;r=void 0,n.push(0)},onArrayEnd:(M,L)=>{if(s<=M)throw a;r=void 0,n.pop()},onLiteralValue:(M,L,B)=>{if(s<L||(S(M,L,B,l(M)),s<=L+B))throw a},onSeparator:(M,L,B)=>{if(s<=L)throw a;if(M===":"&&r&&r.type==="property")r.colonOffset=L,o=!1,r=void 0;else if(M===","){const J=n[n.length-1];typeof J=="number"?n[n.length-1]=J+1:(o=!0,n[n.length-1]=""),r=void 0}}})}catch(M){if(M!==a)throw M}return{path:n,previousNode:r,isAtPropertyKey:o,matches:M=>{let L=0;for(let B=0;L<M.length&&B<n.length;B++)if(M[L]===n[B]||M[L]==="*")L++;else if(M[L]!=="**")return!1;return L===M.length}}}e.getLocation=P;function E(i,s=[],n=R.DEFAULT){let a=null,r=[];const c=[];function o(M){Array.isArray(r)?r.push(M):a!==null&&(r[a]=M)}return g(i,{onObjectBegin:()=>{const M={};o(M),c.push(r),r=M,a=null},onObjectProperty:M=>{a=M},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const M=[];o(M),c.push(r),r=M,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:o,onError:(M,L,B)=>{s.push({error:M,offset:L,length:B})}},n),r[0]}e.parse=E;function f(i,s=[],n=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(M){a.type==="property"&&(a.length=M-a.offset,a=a.parent)}function c(M){return a.children.push(M),M}g(i,{onObjectBegin:M=>{a=c({type:"object",offset:M,length:-1,parent:a,children:[]})},onObjectProperty:(M,L,B)=>{a=c({type:"property",offset:L,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:M,offset:L,length:B,parent:a})},onObjectEnd:(M,L)=>{a.length=M+L-a.offset,a=a.parent,r(M+L)},onArrayBegin:(M,L)=>{a=c({type:"array",offset:M,length:-1,parent:a,children:[]})},onArrayEnd:(M,L)=>{a.length=M+L-a.offset,a=a.parent,r(M+L)},onLiteralValue:(M,L,B)=>{c({type:l(M),offset:L,length:B,parent:a,value:M}),r(L+B)},onSeparator:(M,L,B)=>{a.type==="property"&&(M===":"?a.colonOffset=L:M===","&&r(L))},onError:(M,L,B)=>{s.push({error:M,offset:L,length:B})}},n);const S=a.children[0];return S&&delete S.parent,S}e.parseTree=f;function w(i,s){if(!i)return;let n=i;for(const a of s)if(typeof a=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===a){n=c.children[1],r=!0;break}if(!r)return}else{const r=a;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=w;function d(i){if(!i.parent||!i.parent.children)return[];const s=d(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;s.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&s.push(n)}return s}e.getNodePath=d;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const s=Object.create(null);for(const n of i.children){const a=n.children[1];a&&(s[n.children[0].value]=b(a))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=b;function u(i,s,n=!1){return s>=i.offset&&s<i.offset+i.length||n&&s===i.offset+i.length}e.contains=u;function v(i,s,n=!1){if(u(i,s,n)){const a=i.children;if(Array.isArray(a))for(let r=0;r<a.length&&a[r].offset<=s;r++){const c=v(a[r],s,n);if(c)return c}return i}}e.findNodeAtOffset=v;function g(i,s,n=R.DEFAULT){const a=A(i,!1);function r(z){return z?()=>z(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(z){return z?$=>z($,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=r(s.onObjectBegin),S=c(s.onObjectProperty),M=r(s.onObjectEnd),L=r(s.onArrayBegin),B=r(s.onArrayEnd),J=c(s.onLiteralValue),ae=c(s.onSeparator),X=r(s.onComment),Y=c(s.onError),re=n&&n.disallowComments,ne=n&&n.allowTrailingComma;function de(){for(;;){const z=a.scan();switch(a.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:re||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(z){case 12:case 13:re?K(10):X();break;case 16:K(1);break;case 15:case 14:break;default:return z}}}function K(z,$=[],D=[]){if(Y(z),$.length+D.length>0){let O=a.getToken();for(;O!==17;){if($.indexOf(O)!==-1){de();break}else if(D.indexOf(O)!==-1)break;O=de()}}}function le(z){const $=a.getTokenValue();return z?J($):S($),de(),!0}function F(){switch(a.getToken()){case 11:{let z=0;try{z=JSON.parse(a.getTokenValue()),typeof z!="number"&&(K(2),z=0)}catch{K(2)}J(z);break}case 7:J(null);break;case 8:J(!0);break;case 9:J(!1);break;default:return!1}return de(),!0}function T(){return a.getToken()!==10?(K(3,[],[2,5]),!1):(le(!1),a.getToken()===6?(ae(":"),de(),se()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function N(){o(),de();let z=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(z||K(4,[],[]),ae(","),de(),a.getToken()===2&&ne)break}else z&&K(6,[],[]);T()||K(4,[],[2,5]),z=!0}return M(),a.getToken()!==2?K(7,[2],[]):de(),!0}function V(){L(),de();let z=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(z||K(4,[],[]),ae(","),de(),a.getToken()===4&&ne)break}else z&&K(6,[],[]);se()||K(4,[],[4,5]),z=!0}return B(),a.getToken()!==4?K(8,[4],[]):de(),!0}function se(){switch(a.getToken()){case 3:return V();case 1:return N();case 10:return le(!0);default:return F()}}return de(),a.getToken()===17?n.allowEmptyContent?!0:(K(4,[],[]),!1):se()?(a.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=g;function h(i,s){const n=A(i),a=[];let r,c=0,o;do switch(o=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:c!==o&&a.push(i.substring(c,o)),s!==void 0&&a.push(n.getTokenValue().replace(/[^\r\n]/g,s)),c=n.getPosition();break}while(r!==17);return a.join("")}e.stripComments=h;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ee[123],te([0,1,43]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,y,P){let E,f,w,d,b;if(y){for(d=y.offset,b=d+y.length,w=d;w>0&&!p(m,w-1);)w--;let o=b;for(;o<m.length&&!p(m,o);)o++;f=m.substring(w,o),E=A(f,P)}else f=m,E=0,w=0,d=0,b=m.length;const u=k(P,m);let v=!1,g=0,h;P.insertSpaces?h=R(" ",P.tabSize||4):h="	";const l=(0,I.createScanner)(f,!1);let i=!1;function s(){return u+R(h,E+g)}function n(){let o=l.scan();for(v=!1;o===15||o===14;)v=v||o===14,o=l.scan();return i=o===16||l.getTokenError()!==0,o}const a=[];function r(o,S,M){!i&&S<b&&M>d&&m.substring(S,M)!==o&&a.push({offset:S,length:M-S,content:o})}let c=n();if(c!==17){const o=l.getTokenOffset()+w,S=R(h,E);r(S,w,o)}for(;c!==17;){let o=l.getTokenOffset()+l.getTokenLength()+w,S=n(),M="";for(;!v&&(S===12||S===13);){const B=l.getTokenOffset()+w;r(" ",o,B),o=l.getTokenOffset()+l.getTokenLength()+w,M=S===12?s():"",S=n()}if(S===2)c!==1&&(g--,M=s());else if(S===4)c!==3&&(g--,M=s());else{switch(c){case 3:case 1:g++,M=s();break;case 5:case 12:M=s();break;case 13:v?M=s():M=" ";break;case 6:M=" ";break;case 10:if(S===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?M=" ":S!==5&&S!==17&&(i=!0);break;case 16:i=!0;break}v&&(S===12||S===13)&&(M=s())}const L=l.getTokenOffset()+w;r(M,o,L),c=S}return a}e.format=t;function C(m,y){const P=JSON.stringify(m,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?P.replace(/\r\n|\r|\n/g,y.eol):P}e.toFormattedString=C;function R(m,y){let P="";for(let E=0;E<y;E++)P+=m;return P}function A(m,y){let P=0,E=0;const f=y.tabSize||4;for(;P<m.length;){const w=m.charAt(P);if(w===" ")E++;else if(w==="	")E+=f;else break;P++}return Math.floor(E/f)}function k(m,y){for(let P=0;P<y.length;P++){const E=y.charAt(P);if(E==="\r")return P+1<y.length&&y.charAt(P+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=k;function p(m,y){return`\r
`.indexOf(m.charAt(y))!==-1}e.isEOL=p}),define(ee[124],te([0,1,43,123]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(m,y,P){return R(m,y,void 0,P)}e.removeProperty=C;function R(m,y,P,E,f){const w=y.slice(),d=[],b=(0,I.parseTree)(m,d);let u,v;for(;w.length>0&&(v=w.pop(),u=(0,I.findNodeAtLocation)(b,w),u===void 0&&P!==void 0);)typeof v=="string"?P={[v]:P}:P=[P];if(u)if(u.type==="object"&&typeof v=="string"&&Array.isArray(u.children)){const g=(0,I.findNodeAtLocation)(u,[v]);if(g!==void 0)if(P===void 0){if(!g.parent)throw new Error("Malformed AST");const h=u.children.indexOf(g.parent);let l,i=g.parent.offset+g.parent.length;if(h>0){const s=u.children[h-1];l=s.offset+s.length}else l=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return A(m,{offset:l,length:i-l,content:""},E)}else return A(m,{offset:g.offset,length:g.length,content:JSON.stringify(P)},E);else{if(P===void 0)return[];const h=`${JSON.stringify(v)}: ${JSON.stringify(P)}`,l=f?f(u.children.map(s=>s.children[0].value)):u.children.length;let i;if(l>0){const s=u.children[l-1];i={offset:s.offset+s.length,length:0,content:","+h}}else u.children.length===0?i={offset:u.offset+1,length:0,content:h}:i={offset:u.offset+1,length:0,content:h+","};return A(m,i,E)}}else if(u.type==="array"&&typeof v=="number"&&Array.isArray(u.children))if(P!==void 0){const g=`${JSON.stringify(P)}`;let h;if(u.children.length===0||v===0)h={offset:u.offset+1,length:0,content:u.children.length===0?g:g+","};else{const l=v===-1||v>u.children.length?u.children.length:v,i=u.children[l-1];h={offset:i.offset+i.length,length:0,content:","+g}}return A(m,h,E)}else{const g=v,h=u.children[g];let l;if(u.children.length===1)l={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===g){const i=u.children[g-1],s=i.offset+i.length,n=u.offset+u.length;l={offset:s,length:n-2-s,content:""}}else l={offset:h.offset,length:u.children[g+1].offset-h.offset,content:""};return A(m,l,E)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${u.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return A(m,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(P)},E)}}e.setProperty=R;function A(m,y,P){let E=k(m,y),f=y.offset,w=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;f>0&&!(0,t.isEOL)(E,f-1);)f--;for(;w<E.length&&!(0,t.isEOL)(E,w);)w++}const d=(0,t.format)(E,{offset:f,length:w-f},P);for(let u=d.length-1;u>=0;u--){const v=d[u];E=k(E,v),f=Math.min(f,v.offset),w=Math.max(w,v.offset+v.length),w+=v.content.length-v.length}const b=m.length-(E.length-w)-f;return[{offset:f,length:b,content:E.substring(f,w)}]}e.withFormatting=A;function k(m,y){return m.substring(0,y.offset)+y.content+m.substring(y.offset+y.length)}e.applyEdit=k;function p(m,y){const P=y.slice(0).sort((f,w)=>{const d=f.offset-w.offset;return d===0?f.length-w.length:d});let E=m.length;for(let f=P.length-1;f>=0;f--){const w=P[f];if(w.offset+w.length<=E)m=k(m,w);else throw new Error("Overlapping edit");E=w.offset}return m}e.applyEdits=p}),define(ee[125],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(C){this.d=C,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(C){return new I(()=>C(this.getValue()))}}e.Lazy=I}),define(ee[2],te([0,1,50,67]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let R=null;function A(c){R=c}if(e.setDisposableTracker=A,C){const c="__is_disposable_tracked__";A(new class{trackDisposable(o){const S=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(S)},3e3)}setParent(o,S){if(o&&o!==v.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==v.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function k(c){return R?.trackDisposable(c),c}function p(c){R?.markAsDisposed(c)}function m(c,o){R?.setParent(c,o)}function y(c,o){if(!!R)for(const S of c)R.setParent(S,o)}function P(c){return R?.markAsSingleton(c),c}e.markAsSingleton=P;function E(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=E;function f(c){if(t.Iterable.is(c)){const o=[];for(const S of c)if(S)try{S.dispose()}catch(M){o.push(M)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=f;function w(c){for(const o of c)E(o)&&o.dispose();return[]}e.disposeIfDisposable=w;function d(...c){const o=b(()=>f(c));return y(c,o),o}e.combinedDisposable=d;function b(c){const o=k({dispose:(0,I.once)(()=>{p(o),c()})});return o}e.toDisposable=b;class u{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(p(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{f(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return m(o,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this.q=new u,k(this),m(this.q,this)}dispose(){p(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&m(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&m(o,null),o}}e.MutableDisposable=g;class h{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=h;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(o){let S=o;return this.unset=()=>S=void 0,this.isset=()=>S!==void 0,this.dispose=()=>{S&&(S(),S=void 0,p(this))},this}}e.SafeDisposable=l;class i{constructor(){this.a=new Map}acquire(o,...S){let M=this.a.get(o);M||(M={counter:0,object:this.b(o,...S)},this.a.set(o,M));const{object:L}=M,B=(0,I.once)(()=>{--M.counter===0&&(this.c(o,M.object),this.a.delete(o))});return M.counter++,{object:L,dispose:B}}}e.ReferenceCollection=i;class s{constructor(o){this.a=o}async acquire(o,...S){const M=this.a.acquire(o,...S);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(L){throw M.dispose(),L}}}e.AsyncReferenceCollection=s;class n{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=n;function a(c){const o=new u;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=a;class r{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,S,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(o)?.dispose(),this.a.set(o,S)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(ee[96],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(R){this.element=R,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class t{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let R=this.a;for(;R!==I.Undefined;){const A=R.next;R.prev=I.Undefined,R.next=I.Undefined,R=A}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,A){const k=new I(R);if(this.a===I.Undefined)this.a=k,this.b=k;else if(A){const m=this.b;this.b=k,k.prev=m,m.next=k}else{const m=this.a;this.a=k,k.next=m,m.prev=k}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(k))}}shift(){if(this.a!==I.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==I.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==I.Undefined&&R.next!==I.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===I.Undefined&&R.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):R.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):R.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==I.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ee[39],te([0,1]),function(H,e){"use strict";var I,t,C;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(w,d,b){let u=w.get(d);return u===void 0&&(u=b,w.set(d,u)),u}e.getOrSet=R;function A(w){const d=[];return w.forEach((b,u)=>{d.push(`${u} => ${b}`)}),`Map(${w.size}) {${d.join(", ")}}`}e.mapToString=A;function k(w){const d=[];return w.forEach(b=>{d.push(b)}),`Set(${w.size}) {${d.join(", ")}}`}e.setToString=k;class p{constructor(d,b){this.uri=d,this.value=b}}class m{constructor(d,b){this[I]="ResourceMap",d instanceof m?(this.b=new Map(d.b),this.c=b??m.a):(this.b=new Map,this.c=d??m.a)}set(d,b){return this.b.set(this.c(d),new p(d,b)),this}get(d){return this.b.get(this.c(d))?.value}has(d){return this.b.has(this.c(d))}get size(){return this.b.size}clear(){this.b.clear()}delete(d){return this.b.delete(this.c(d))}forEach(d,b){typeof b<"u"&&(d=d.bind(b));for(const[u,v]of this.b)d(v.value,v.uri,this)}*values(){for(const d of this.b.values())yield d.value}*keys(){for(const d of this.b.values())yield d.uri}*entries(){for(const d of this.b.values())yield[d.uri,d.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.b)yield[d.uri,d.value]}}e.ResourceMap=m,m.a=w=>w.toString();class y{constructor(d,b){this[t]="ResourceSet",!d||typeof d=="function"?this.a=new m(d):(this.a=new m(b),d.forEach(this.add,this))}get size(){return this.a.size}add(d){return this.a.set(d,d),this}clear(){this.a.clear()}delete(d){return this.a.delete(d)}forEach(d,b){this.a.forEach((u,v)=>d.call(b,v,v,this))}has(d){return this.a.has(d)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var P;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class E{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(d){return this.a.has(d)}get(d,b=0){const u=this.a.get(d);if(!!u)return b!==0&&this.j(u,b),u.value}set(d,b,u=0){let v=this.a.get(d);if(v)v.value=b,u!==0&&this.j(v,u);else{switch(v={key:d,value:b,next:void 0,previous:void 0},u){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(d,v),this.d++}return this}delete(d){return!!this.remove(d)}remove(d){const b=this.a.get(d);if(!!b)return this.a.delete(d),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const d=this.b;return this.a.delete(d.key),this.i(d),this.d--,d.value}forEach(d,b){const u=this.e;let v=this.b;for(;v;){if(b?d.bind(b)(v.value,v.key,this):d(v.value,v.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const d=this,b=this.e;let u=this.b;const v={[Symbol.iterator](){return v},next(){if(d.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.key,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return v}values(){const d=this,b=this.e;let u=this.b;const v={[Symbol.iterator](){return v},next(){if(d.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.value,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return v}entries(){const d=this,b=this.e;let u=this.b;const v={[Symbol.iterator](){return v},next(){if(d.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:[u.key,u.value],done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return v}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(d){if(d>=this.size)return;if(d===0){this.clear();return}let b=this.b,u=this.size;for(;b&&u>d;)this.a.delete(b.key),b=b.next,u--;this.b=b,this.d=u,b&&(b.previous=void 0),this.e++}g(d){if(!this.b&&!this.c)this.c=d;else if(this.b)d.next=this.b,this.b.previous=d;else throw new Error("Invalid list");this.b=d,this.e++}h(d){if(!this.b&&!this.c)this.b=d;else if(this.c)d.previous=this.c,this.c.next=d;else throw new Error("Invalid list");this.c=d,this.e++}i(d){if(d===this.b&&d===this.c)this.b=void 0,this.c=void 0;else if(d===this.b){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.b=d.next}else if(d===this.c){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.c=d.previous}else{const b=d.next,u=d.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}d.next=void 0,d.previous=void 0,this.e++}j(d,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(d===this.b)return;const u=d.next,v=d.previous;d===this.c?(v.next=void 0,this.c=v):(u.previous=v,v.next=u),d.previous=void 0,d.next=this.b,this.b.previous=d,this.b=d,this.e++}else if(b===2){if(d===this.c)return;const u=d.next,v=d.previous;d===this.b?(u.previous=void 0,this.b=u):(u.previous=v,v.next=u),d.next=void 0,d.previous=this.c,this.c.next=d,this.c=d,this.e++}}}toJSON(){const d=[];return this.forEach((b,u)=>{d.push([u,b])}),d}fromJSON(d){this.clear();for(const[b,u]of d)this.set(b,u)}}e.LinkedMap=E;class f extends E{constructor(d,b=1){super(),this.k=d,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(d){this.k=d,this.m()}get ratio(){return this.l}set ratio(d){this.l=Math.min(Math.max(0,d),1),this.m()}get(d,b=2){return super.get(d,b)}peek(d){return super.get(d,0)}set(d,b){return super.set(d,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f}),define(ee[76],te([0,1,39]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new I.LRUCache(1e4);function C(m){return p(m,"NFC",t)}e.normalizeNFC=C;const R=new I.LRUCache(1e4);function A(m){return p(m,"NFD",R)}e.normalizeNFD=A;const k=/[^\u0000-\u0080]/;function p(m,y,P){if(!m)return m;const E=P.get(m);if(E)return E;let f;return k.test(m)?f=m.normalize(y):f=m,P.set(m,f),f}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(y){return A(y).replace(m,"")}}()}),function(){function H(C){const R=[];typeof C=="number"&&R.push("code/timeOrigin",C);function A(p){R.push(p,Date.now())}function k(){const p=[];for(let m=0;m<R.length;m+=2)p.push({name:R[m],startTime:R[m+1]});return p}return{mark:A,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(C+A.startTime)});return R}};if(typeof process=="object"){const C=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function I(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=I(t))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var t in I)(typeof exports=="object"?exports:H)[t]=I[t]}}(typeof self<"u"?self:this,function(){return function(H){var e={};function I(t){if(e[t])return e[t].exports;var C=e[t]={i:t,l:!1,exports:{}};return H[t].call(C.exports,C,C.exports,I),C.l=!0,C.exports}return I.m=H,I.c=e,I.d=function(t,C,R){I.o(t,C)||Object.defineProperty(t,C,{enumerable:!0,get:R})},I.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},I.t=function(t,C){if(1&C&&(t=I(t)),8&C||4&C&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(I.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&C&&typeof t!="string")for(var A in t)I.d(R,A,function(k){return t[k]}.bind(null,A));return R},I.n=function(t){var C=t&&t.__esModule?function(){return t.default}:function(){return t};return I.d(C,"a",C),C},I.o=function(t,C){return Object.prototype.hasOwnProperty.call(t,C)},I.p="",I(I.s=0)}([function(H,e,I){(function(t){var C;e=H.exports=D,C=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],p=e.src=[],m=0,y=m++;p[y]="0|[1-9]\\d*";var P=m++;p[P]="[0-9]+";var E=m++;p[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=m++;p[f]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var w=m++;p[w]="("+p[P]+")\\.("+p[P]+")\\.("+p[P]+")";var d=m++;p[d]="(?:"+p[y]+"|"+p[E]+")";var b=m++;p[b]="(?:"+p[P]+"|"+p[E]+")";var u=m++;p[u]="(?:-("+p[d]+"(?:\\."+p[d]+")*))";var v=m++;p[v]="(?:-?("+p[b]+"(?:\\."+p[b]+")*))";var g=m++;p[g]="[0-9A-Za-z-]+";var h=m++;p[h]="(?:\\+("+p[g]+"(?:\\."+p[g]+")*))";var l=m++,i="v?"+p[f]+p[u]+"?"+p[h]+"?";p[l]="^"+i+"$";var s="[v=\\s]*"+p[w]+p[v]+"?"+p[h]+"?",n=m++;p[n]="^"+s+"$";var a=m++;p[a]="((?:<|>)?=?)";var r=m++;p[r]=p[P]+"|x|X|\\*";var c=m++;p[c]=p[y]+"|x|X|\\*";var o=m++;p[o]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[u]+")?"+p[h]+"?)?)?";var S=m++;p[S]="[v=\\s]*("+p[r]+")(?:\\.("+p[r]+")(?:\\.("+p[r]+")(?:"+p[v]+")?"+p[h]+"?)?)?";var M=m++;p[M]="^"+p[a]+"\\s*"+p[o]+"$";var L=m++;p[L]="^"+p[a]+"\\s*"+p[S]+"$";var B=m++;p[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var J=m++;p[J]="(?:~>?)";var ae=m++;p[ae]="(\\s*)"+p[J]+"\\s+",k[ae]=new RegExp(p[ae],"g");var X=m++;p[X]="^"+p[J]+p[o]+"$";var Y=m++;p[Y]="^"+p[J]+p[S]+"$";var re=m++;p[re]="(?:\\^)";var ne=m++;p[ne]="(\\s*)"+p[re]+"\\s+",k[ne]=new RegExp(p[ne],"g");var de=m++;p[de]="^"+p[re]+p[o]+"$";var K=m++;p[K]="^"+p[re]+p[S]+"$";var le=m++;p[le]="^"+p[a]+"\\s*("+s+")$|^$";var F=m++;p[F]="^"+p[a]+"\\s*("+i+")$|^$";var T=m++;p[T]="(\\s*)"+p[a]+"\\s*("+s+"|"+p[o]+")",k[T]=new RegExp(p[T],"g");var N=m++;p[N]="^\\s*("+p[o]+")\\s+-\\s+("+p[o]+")\\s*$";var V=m++;p[V]="^\\s*("+p[S]+")\\s+-\\s+("+p[S]+")\\s*$";var se=m++;p[se]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)C(z,p[z]),k[z]||(k[z]=new RegExp(p[z]));function $(_,he){if(_ instanceof D)return _;if(typeof _!="string"||_.length>R||!(he?k[n]:k[l]).test(_))return null;try{return new D(_,he)}catch{return null}}function D(_,he){if(_ instanceof D){if(_.loose===he)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof D))return new D(_,he);C("SemVer",_,he),this.loose=he;var fe=_.trim().match(he?k[n]:k[l]);if(!fe)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var Pe=+ve;if(Pe>=0&&Pe<A)return Pe}return ve}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=$,e.valid=function(_,he){var fe=$(_,he);return fe?fe.version:null},e.clean=function(_,he){var fe=$(_.trim().replace(/^[=v]+/,""),he);return fe?fe.version:null},e.SemVer=D,D.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},D.prototype.toString=function(){return this.version},D.prototype.compare=function(_){return C("SemVer.compare",this.version,this.loose,_),_ instanceof D||(_=new D(_,this.loose)),this.compareMain(_)||this.comparePre(_)},D.prototype.compareMain=function(_){return _ instanceof D||(_=new D(_,this.loose)),W(this.major,_.major)||W(this.minor,_.minor)||W(this.patch,_.patch)},D.prototype.comparePre=function(_){if(_ instanceof D||(_=new D(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var he=0;do{var fe=this.prerelease[he],ve=_.prerelease[he];if(C("prerelease compare",he,fe,ve),fe===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(fe===void 0)return-1;if(fe!==ve)return W(fe,ve)}while(++he)},D.prototype.inc=function(_,he){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,he,fe,ve){typeof fe=="string"&&(ve=fe,fe=void 0);try{return new D(_,fe).inc(he,ve).version}catch{return null}},e.diff=function(_,he){if(j(_,he))return null;var fe=$(_),ve=$(he);if(fe.prerelease.length||ve.prerelease.length){for(var Pe in fe)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&fe[Pe]!==ve[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in fe)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&fe[Pe]!==ve[Pe])return Pe},e.compareIdentifiers=W;var O=/^[0-9]+$/;function W(_,he){var fe=O.test(_),ve=O.test(he);return fe&&ve&&(_=+_,he=+he),fe&&!ve?-1:ve&&!fe?1:_<he?-1:_>he?1:0}function U(_,he,fe){return new D(_,fe).compare(new D(he,fe))}function q(_,he,fe){return U(_,he,fe)>0}function Q(_,he,fe){return U(_,he,fe)<0}function j(_,he,fe){return U(_,he,fe)===0}function Z(_,he,fe){return U(_,he,fe)!==0}function x(_,he,fe){return U(_,he,fe)>=0}function oe(_,he,fe){return U(_,he,fe)<=0}function ge(_,he,fe,ve){var Pe;switch(he){case"===":typeof _=="object"&&(_=_.version),typeof fe=="object"&&(fe=fe.version),Pe=_===fe;break;case"!==":typeof _=="object"&&(_=_.version),typeof fe=="object"&&(fe=fe.version),Pe=_!==fe;break;case"":case"=":case"==":Pe=j(_,fe,ve);break;case"!=":Pe=Z(_,fe,ve);break;case">":Pe=q(_,fe,ve);break;case">=":Pe=x(_,fe,ve);break;case"<":Pe=Q(_,fe,ve);break;case"<=":Pe=oe(_,fe,ve);break;default:throw new TypeError("Invalid operator: "+he)}return Pe}function Me(_,he){if(_ instanceof Me){if(_.loose===he)return _;_=_.value}if(!(this instanceof Me))return new Me(_,he);C("comparator",_,he),this.loose=he,this.parse(_),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(_,he){return W(he,_)},e.major=function(_,he){return new D(_,he).major},e.minor=function(_,he){return new D(_,he).minor},e.patch=function(_,he){return new D(_,he).patch},e.compare=U,e.compareLoose=function(_,he){return U(_,he,!0)},e.rcompare=function(_,he,fe){return U(he,_,fe)},e.sort=function(_,he){return _.sort(function(fe,ve){return e.compare(fe,ve,he)})},e.rsort=function(_,he){return _.sort(function(fe,ve){return e.rcompare(fe,ve,he)})},e.gt=q,e.lt=Q,e.eq=j,e.neq=Z,e.gte=x,e.lte=oe,e.cmp=ge,e.Comparator=Me;var Oe={};function Ce(_,he){if(_ instanceof Ce)return _.loose===he?_:new Ce(_.raw,he);if(_ instanceof Me)return new Ce(_.value,he);if(!(this instanceof Ce))return new Ce(_,he);if(this.loose=he,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Le(_){return!_||_.toLowerCase()==="x"||_==="*"}function be(_,he,fe,ve,Pe,We,Te,qe,Ue,Be,Xe,$e,Ke){return((he=Le(fe)?"":Le(ve)?">="+fe+".0.0":Le(Pe)?">="+fe+"."+ve+".0":">="+he)+" "+(qe=Le(Ue)?"":Le(Be)?"<"+(+Ue+1)+".0.0":Le(Xe)?"<"+Ue+"."+(+Be+1)+".0":$e?"<="+Ue+"."+Be+"."+Xe+"-"+$e:"<="+qe)).trim()}function we(_,he){for(var fe=0;fe<_.length;fe++)if(!_[fe].test(he))return!1;if(he.prerelease.length){for(fe=0;fe<_.length;fe++)if(C(_[fe].semver),_[fe].semver!==Oe&&_[fe].semver.prerelease.length>0){var ve=_[fe].semver;if(ve.major===he.major&&ve.minor===he.minor&&ve.patch===he.patch)return!0}return!1}return!0}function ye(_,he,fe){try{he=new Ce(he,fe)}catch{return!1}return he.test(_)}function De(_,he,fe,ve){var Pe,We,Te,qe,Ue;switch(_=new D(_,ve),he=new Ce(he,ve),fe){case">":Pe=q,We=oe,Te=Q,qe=">",Ue=">=";break;case"<":Pe=Q,We=x,Te=q,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(_,he,ve))return!1;for(var Be=0;Be<he.set.length;++Be){var Xe=he.set[Be],$e=null,Ke=null;if(Xe.forEach(function(G){G.semver===Oe&&(G=new Me(">=0.0.0")),$e=$e||G,Ke=Ke||G,Pe(G.semver,$e.semver,ve)?$e=G:Te(G.semver,Ke.semver,ve)&&(Ke=G)}),$e.operator===qe||$e.operator===Ue||(!Ke.operator||Ke.operator===qe)&&We(_,Ke.semver)||Ke.operator===Ue&&Te(_,Ke.semver))return!1}return!0}Me.prototype.parse=function(_){var he=this.loose?k[le]:k[F],fe=_.match(he);if(!fe)throw new TypeError("Invalid comparator: "+_);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new D(fe[2],this.loose):this.semver=Oe},Me.prototype.toString=function(){return this.value},Me.prototype.test=function(_){return C("Comparator.test",_,this.loose),this.semver===Oe||(typeof _=="string"&&(_=new D(_,this.loose)),ge(_,this.operator,this.semver,this.loose))},Me.prototype.intersects=function(_,he){if(!(_ instanceof Me))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Ce(_.value,he),ye(this.value,fe,he);if(_.operator==="")return fe=new Ce(this.value,he),ye(_.semver,fe,he);var ve=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),We=this.semver.version===_.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),qe=ge(this.semver,"<",_.semver,he)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),Ue=ge(this.semver,">",_.semver,he)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return ve||Pe||We&&Te||qe||Ue},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(_){var he=this.loose;_=_.trim(),C("range",_,he);var fe=he?k[V]:k[N];_=_.replace(fe,be),C("hyphen replace",_),_=_.replace(k[T],"$1$2$3"),C("comparator trim",_,k[T]),_=(_=(_=_.replace(k[ae],"$1~")).replace(k[ne],"$1^")).split(/\s+/).join(" ");var ve=he?k[le]:k[F],Pe=_.split(" ").map(function(We){return function(Te,qe){return C("comp",Te),Te=function(Ue,Be){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){C("caret",$e,Ke);var G=Ke?k[K]:k[de];return $e.replace(G,function(ce,ue,me,Se,Ae){var je;return C("caret",$e,ce,ue,me,Se,Ae),Le(ue)?je="":Le(me)?je=">="+ue+".0.0 <"+(+ue+1)+".0.0":Le(Se)?je=ue==="0"?">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+".0 <"+(+ue+1)+".0.0":Ae?(C("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),je=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+Ae+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+Ae+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+Ae+" <"+(+ue+1)+".0.0"):(C("no pr"),je=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+" <"+(+ue+1)+".0.0"),C("caret return",je),je})}(Xe,Be)}).join(" ")}(Te,qe),C("caret",Te),Te=function(Ue,Be){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){var G=Ke?k[Y]:k[X];return $e.replace(G,function(ce,ue,me,Se,Ae){var je;return C("tilde",$e,ce,ue,me,Se,Ae),Le(ue)?je="":Le(me)?je=">="+ue+".0.0 <"+(+ue+1)+".0.0":Le(Se)?je=">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":Ae?(C("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),je=">="+ue+"."+me+"."+Se+Ae+" <"+ue+"."+(+me+1)+".0"):je=">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0",C("tilde return",je),je})}(Xe,Be)}).join(" ")}(Te,qe),C("tildes",Te),Te=function(Ue,Be){return C("replaceXRanges",Ue,Be),Ue.split(/\s+/).map(function(Xe){return function($e,Ke){$e=$e.trim();var G=Ke?k[L]:k[M];return $e.replace(G,function(ce,ue,me,Se,Ae,je){C("xRange",$e,ce,ue,me,Se,Ae,je);var it=Le(me),xe=it||Le(Se),He=xe||Le(Ae);return ue==="="&&He&&(ue=""),it?ce=ue===">"||ue==="<"?"<0.0.0":"*":ue&&He?(xe&&(Se=0),He&&(Ae=0),ue===">"?(ue=">=",xe?(me=+me+1,Se=0,Ae=0):He&&(Se=+Se+1,Ae=0)):ue==="<="&&(ue="<",xe?me=+me+1:Se=+Se+1),ce=ue+me+"."+Se+"."+Ae):xe?ce=">="+me+".0.0 <"+(+me+1)+".0.0":He&&(ce=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),C("xRange return",ce),ce})}(Xe,Be)}).join(" ")}(Te,qe),C("xrange",Te),Te=function(Ue,Be){return C("replaceStars",Ue,Be),Ue.trim().replace(k[se],"")}(Te,qe),C("stars",Te),Te}(We,he)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(We){return!!We.match(ve)})),Pe=Pe.map(function(We){return new Me(We,he)})},Ce.prototype.intersects=function(_,he){if(!(_ instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(ve){return _.set.some(function(Pe){return Pe.every(function(We){return ve.intersects(We,he)})})})})},e.toComparators=function(_,he){return new Ce(_,he).set.map(function(fe){return fe.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new D(_,this.loose));for(var he=0;he<this.set.length;he++)if(we(this.set[he],_))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(_,he,fe){var ve=null,Pe=null;try{var We=new Ce(he,fe)}catch{return null}return _.forEach(function(Te){We.test(Te)&&(ve&&Pe.compare(Te)!==-1||(Pe=new D(ve=Te,fe)))}),ve},e.minSatisfying=function(_,he,fe){var ve=null,Pe=null;try{var We=new Ce(he,fe)}catch{return null}return _.forEach(function(Te){We.test(Te)&&(ve&&Pe.compare(Te)!==1||(Pe=new D(ve=Te,fe)))}),ve},e.validRange=function(_,he){try{return new Ce(_,he).range||"*"}catch{return null}},e.ltr=function(_,he,fe){return De(_,he,"<",fe)},e.gtr=function(_,he,fe){return De(_,he,">",fe)},e.outside=De,e.prerelease=function(_,he){var fe=$(_,he);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(_,he,fe){return _=new Ce(_,fe),he=new Ce(he,fe),_.intersects(he)},e.coerce=function(_){if(_ instanceof D)return _;if(typeof _!="string")return null;var he=_.match(k[B]);return he==null?null:$((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,I(1))},function(H,e){var I,t,C=H.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function k(b){if(I===setTimeout)return setTimeout(b,0);if((I===R||!I)&&setTimeout)return I=setTimeout,setTimeout(b,0);try{return I(b,0)}catch{try{return I.call(null,b,0)}catch{return I.call(this,b,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:R}catch{I=R}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var p,m=[],y=!1,P=-1;function E(){y&&p&&(y=!1,p.length?m=p.concat(m):P=-1,m.length&&f())}function f(){if(!y){var b=k(E);y=!0;for(var u=m.length;u;){for(p=m,m=[];++P<u;)p&&p[P].run();P=-1,u=m.length}p=null,y=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(b)}}function w(b,u){this.fun=b,this.array=u}function d(){}C.nextTick=function(b){var u=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)u[v-1]=arguments[v];m.push(new w(b,u)),m.length!==1||y||k(f)},w.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=d,C.addListener=d,C.once=d,C.off=d,C.removeListener=d,C.removeAllListeners=d,C.emit=d,C.prependListener=d,C.prependOnceListener=d,C.listeners=function(b){return[]},C.binding=function(b){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(b){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ee[126],te([0,1]),function(H,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(k,p,m){this.level=k,this.key=p,this.value=m,this.forward=[]}}const C=void 0;class R{constructor(k,p=2**16){this.comparator=k,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new t(this.c,C,C)}get size(){return this.f}clear(){this.e=new t(this.c,C,C)}has(k){return Boolean(R.g(this,k,this.comparator))}get(k){return R.g(this,k,this.comparator)?.value}set(k,p){return R.h(this,k,p,this.comparator)&&(this.f+=1),this}delete(k){const p=R.k(this,k,this.comparator);return p&&(this.f-=1),p}forEach(k,p){let m=this.e.forward[0];for(;m;)k.call(p,m.value,m.key,this),m=m.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",p=this.e.forward[0];for(;p;)k+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return k}static g(k,p,m){let y=k.e;for(let P=k.d-1;P>=0;P--)for(;y.forward[P]&&m(y.forward[P].key,p)<0;)y=y.forward[P];if(y=y.forward[0],y&&m(y.key,p)===0)return y}static h(k,p,m,y){const P=[];let E=k.e;for(let f=k.d-1;f>=0;f--){for(;E.forward[f]&&y(E.forward[f].key,p)<0;)E=E.forward[f];P[f]=E}if(E=E.forward[0],E&&y(E.key,p)===0)return E.value=m,!1;{const f=R.j(k);if(f>k.d){for(let w=k.d;w<f;w++)P[w]=k.e;k.d=f}E=new t(f,p,m);for(let w=0;w<f;w++)E.forward[w]=P[w].forward[w],P[w].forward[w]=E;return!0}}static j(k,p=.5){let m=1;for(;Math.random()<p&&m<k.c;)m+=1;return m}static k(k,p,m){const y=[];let P=k.e;for(let E=k.d-1;E>=0;E--){for(;P.forward[E]&&m(P.forward[E].key,p)<0;)P=P.forward[E];y[E]=P}if(P=P.forward[0],!P||m(P.key,p)!==0)return!1;for(let E=0;E<k.d&&y[E].forward[E]===P;E++)y[E].forward[E]=P.forward[E];for(;k.d>0&&k.e.forward[k.d-1]===C;)k.d-=1;return!0}}e.SkipList=R}),define(ee[59],te([0,1,14,2]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(h){const l=h;return l?typeof l.read=="function":!1}e.isReadable=C;function R(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function A(h){const l=h;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=A;function k(h,l){return new p(h,l)}e.newWriteableStream=k;class p{constructor(l,i){this.e=l,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(i=>i(l))}h(l){this.c.error.length===0?(0,I.onUnexpectedError)(l):this.c.error.slice(0).forEach(i=>i(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,i){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(l,i){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const n=s.indexOf(i);n>=0&&s.splice(n,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(h,l){const i=[];let s;for(;(s=h.read())!==null;)i.push(s);return l(i)}e.consumeReadable=m;function y(h,l,i){const s=[];let n;for(;(n=h.read())!==null&&s.length<i;)s.push(n);return n===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof n<"u"){const a=n;return n=void 0,a}return h.read()}}}e.peekReadable=y;function P(h,l){return new Promise((i,s)=>{const n=[];E(h,{onData:a=>{l&&n.push(a)},onError:a=>{l?s(a):i(void 0)},onEnd:()=>{i(l?l(n):void 0)}})})}e.consumeStream=P;function E(h,l){let i=!1;return h.on("error",s=>{i||l.onError(s)}),h.on("end",()=>{i||l.onEnd()}),h.on("data",s=>{i||l.onData(s)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=E;function f(h,l){return new Promise((i,s)=>{const n=new t.DisposableStore,a=[],r=S=>{if(a.push(S),a.length>l)return n.dispose(),h.pause(),i({stream:h,buffer:a,ended:!1})},c=S=>s(S),o=()=>i({stream:h,buffer:a,ended:!0});n.add((0,t.toDisposable)(()=>h.removeListener("error",c))),h.on("error",c),n.add((0,t.toDisposable)(()=>h.removeListener("end",o))),h.on("end",o),n.add((0,t.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}e.peekStream=f;function w(h,l){const i=k(l);return i.end(h),i}e.toStream=w;function d(){const h=k(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function b(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}e.toReadable=b;function u(h,l,i){const s=k(i);return E(h,{onData:n=>s.write(l.data(n)),onError:n=>s.error(l.error?l.error(n):n),onEnd:()=>s.end()}),s}e.transform=u;function v(h,l,i){let s=!1;return{read:()=>{const n=l.read();return s?n:(s=!0,n!==null?i([h,n]):h)}}}e.prefixedReadable=v;function g(h,l,i){let s=!1;const n=k(i);return E(l,{onData:a=>s?n.write(a):(s=!0,n.write(i([h,a]))),onError:a=>n.error(a),onEnd:()=>{s||(s=!0,n.write(h)),n.end()}}),n}e.prefixedStream=g}),define(ee[17],te([0,1,59]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let C,R;class A{static alloc(S){return t?new A(Buffer.allocUnsafe(S)):new A(new Uint8Array(S))}static wrap(S){return t&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new A(S)}static fromString(S,M){return!(M?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(S)):(C||(C=new TextEncoder),new A(C.encode(S)))}static fromByteArray(S){const M=A.alloc(S.length);for(let L=0,B=S.length;L<B;L++)M.buffer[L]=S[L];return M}static concat(S,M){if(typeof M>"u"){M=0;for(let J=0,ae=S.length;J<ae;J++)M+=S[J].byteLength}const L=A.alloc(M);let B=0;for(let J=0,ae=S.length;J<ae;J++){const X=S[J];L.set(X,B),B+=X.byteLength}return L}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=A.alloc(this.byteLength);return S.set(this),S}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(S,M){return new A(this.buffer.subarray(S,M))}set(S,M){if(S instanceof A)this.buffer.set(S.buffer,M);else if(S instanceof Uint8Array)this.buffer.set(S,M);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),M);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return m(this.buffer,S)}writeUInt32BE(S,M){y(this.buffer,S,M)}readUInt32LE(S){return P(this.buffer,S)}writeUInt32LE(S,M){E(this.buffer,S,M)}readUInt8(S){return f(this.buffer,S)}writeUInt8(S,M){w(this.buffer,S,M)}}e.VSBuffer=A;function k(o,S){return o[S+0]<<0>>>0|o[S+1]<<8>>>0}e.readUInt16LE=k;function p(o,S,M){o[M+0]=S&255,S=S>>>8,o[M+1]=S&255}e.writeUInt16LE=p;function m(o,S){return o[S]*2**24+o[S+1]*2**16+o[S+2]*2**8+o[S+3]}e.readUInt32BE=m;function y(o,S,M){o[M+3]=S,S=S>>>8,o[M+2]=S,S=S>>>8,o[M+1]=S,S=S>>>8,o[M]=S}e.writeUInt32BE=y;function P(o,S){return o[S+0]<<0>>>0|o[S+1]<<8>>>0|o[S+2]<<16>>>0|o[S+3]<<24>>>0}e.readUInt32LE=P;function E(o,S,M){o[M+0]=S&255,S=S>>>8,o[M+1]=S&255,S=S>>>8,o[M+2]=S&255,S=S>>>8,o[M+3]=S&255}e.writeUInt32LE=E;function f(o,S){return o[S]}e.readUInt8=f;function w(o,S,M){o[M]=S}e.writeUInt8=w;function d(o){return I.consumeReadable(o,S=>A.concat(S))}e.readableToBuffer=d;function b(o){return I.toReadable(o)}e.bufferToReadable=b;function u(o){return I.consumeStream(o,S=>A.concat(S))}e.streamToBuffer=u;async function v(o){return o.ended?A.concat(o.buffer):A.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=v;function g(o){return I.toStream(o,S=>A.concat(S))}e.bufferToStream=g;function h(o){return I.transform(o,{data:S=>typeof S=="string"?A.fromString(S):A.wrap(S)},S=>A.concat(S))}e.streamToBufferReadableStream=h;function l(o){return I.newWriteableStream(S=>A.concat(S),o)}e.newWriteableBufferStream=l;function i(o,S){return I.prefixedReadable(o,S,M=>A.concat(M))}e.prefixedBufferReadable=i;function s(o,S){return I.prefixedStream(o,S,M=>A.concat(M))}e.prefixedBufferStream=s;function n(o){let S=0,M=0,L=0;const B=new Uint8Array(Math.floor(o.length/4*3)),J=X=>{switch(M){case 3:B[L++]=S|X,M=0;break;case 2:B[L++]=S|X>>>2,S=X<<6,M=3;break;case 1:B[L++]=S|X>>>4,S=X<<4,M=2;break;default:S=X<<2,M=1}};for(let X=0;X<o.length;X++){const Y=o.charCodeAt(X);if(Y>=65&&Y<=90)J(Y-65);else if(Y>=97&&Y<=122)J(Y-97+26);else if(Y>=48&&Y<=57)J(Y-48+52);else if(Y===43||Y===45)J(62);else if(Y===47||Y===95)J(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${o[X]}`)}}const ae=L;for(;M>0;)J(0);return A.wrap(B).slice(0,ae)}e.decodeBase64=n;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},S=!0,M=!1){const L=M?r:a;let B="";const J=o.byteLength%3;let ae=0;for(;ae<o.byteLength-J;ae+=3){const X=o[ae+0],Y=o[ae+1],re=o[ae+2];B+=L[X>>>2],B+=L[(X<<4|Y>>>4)&63],B+=L[(Y<<2|re>>>6)&63],B+=L[re&63]}if(J===1){const X=o[ae+0];B+=L[X>>>2],B+=L[X<<4&63],S&&(B+="==")}else if(J===2){const X=o[ae+0],Y=o[ae+1];B+=L[X>>>2],B+=L[(X<<4|Y>>>4)&63],B+=L[Y<<2&63],S&&(B+="=")}return B}e.encodeBase64=c}),define(ee[12],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(s){return typeof s=="string"}e.isString=I;function t(s){return Array.isArray(s)&&s.every(n=>I(n))}e.isStringArray=t;function C(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=C;function R(s){const n=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof n}e.isTypedArray=R;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function k(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=k;function p(s){return s===!0||s===!1}e.isBoolean=p;function m(s){return typeof s>"u"}e.isUndefined=m;function y(s){return!P(s)}e.isDefined=y;function P(s){return m(s)||s===null}e.isUndefinedOrNull=P;function E(s,n){if(!s)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=E;function f(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=f;function w(...s){const n=[];for(let a=0;a<s.length;a++){const r=s[a];if(P(r))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);n.push(r)}return n}e.assertAllDefined=w;const d=Object.prototype.hasOwnProperty;function b(s){if(!C(s))return!1;for(const n in s)if(d.call(s,n))return!1;return!0}e.isEmptyObject=b;function u(s){return typeof s=="function"}e.isFunction=u;function v(...s){return s.length>0&&s.every(u)}e.areFunctions=v;function g(s,n){const a=Math.min(s.length,n.length);for(let r=0;r<a;r++)h(s[r],n[r])}e.validateConstraints=g;function h(s,n){if(I(n)){if(typeof s!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(u(n)){try{if(s instanceof n)return}catch{}if(!P(s)&&s.constructor===n||n.length===1&&n.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function l(s){return s===null?void 0:s}e.withNullAsUndefined=l;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(ee[44],te([0,1,12]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const v=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,h])=>{v[g]=h&&typeof h=="object"?t(h):h}),v}e.deepClone=t;function C(u){if(!u||typeof u!="object")return u;const v=[u];for(;v.length>0;){const g=v.shift();Object.freeze(g);for(const h in g)if(R.call(g,h)){const l=g[h];typeof l=="object"&&!Object.isFrozen(l)&&!(0,I.isTypedArray)(l)&&v.push(l)}}return u}e.deepFreeze=C;const R=Object.prototype.hasOwnProperty;function A(u,v){return k(u,v,new Set)}e.cloneAndChange=A;function k(u,v,g){if((0,I.isUndefinedOrNull)(u))return u;const h=v(u);if(typeof h<"u")return h;if(Array.isArray(u)){const l=[];for(const i of u)l.push(k(i,v,g));return l}if((0,I.isObject)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const l={};for(const i in u)R.call(u,i)&&(l[i]=k(u[i],v,g));return g.delete(u),l}return u}function p(u,v,g=!0){return(0,I.isObject)(u)?((0,I.isObject)(v)&&Object.keys(v).forEach(h=>{h in u?g&&((0,I.isObject)(u[h])&&(0,I.isObject)(v[h])?p(u[h],v[h],g):u[h]=v[h]):u[h]=v[h]}),u):v}e.mixin=p;function m(u,v){if(u===v)return!0;if(u==null||v===null||v===void 0||typeof u!=typeof v||typeof u!="object"||Array.isArray(u)!==Array.isArray(v))return!1;let g,h;if(Array.isArray(u)){if(u.length!==v.length)return!1;for(g=0;g<u.length;g++)if(!m(u[g],v[g]))return!1}else{const l=[];for(h in u)l.push(h);l.sort();const i=[];for(h in v)i.push(h);if(i.sort(),!m(l,i))return!1;for(g=0;g<l.length;g++)if(!m(u[l[g]],v[l[g]]))return!1}return!0}e.equals=m;function y(u){const v=new Set;return JSON.stringify(u,(g,h)=>{if((0,I.isObject)(h)||Array.isArray(h)){if(v.has(h))return"[Circular]";v.add(h)}return h})}e.safeStringify=y;function P(u,v){const g=Object.create(null);return!u||!v||Object.keys(v).forEach(l=>{const i=u[l],s=v[l];m(i,s)||(g[l]=s)}),g}e.distinct=P;function E(u,v){const g=v.toLowerCase(),h=Object.keys(u).find(l=>l.toLowerCase()===g);return h?u[h]:u[v]}e.getCaseInsensitive=E;function f(u,v){const g=Object.create(null);for(const[h,l]of Object.entries(u))v(h,l)&&(g[h]=l);return g}e.filter=f;function w(u){let v=[],g=Object.getPrototypeOf(u);for(;Object.prototype!==g;)v=v.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return v}e.getAllPropertyNames=w;function d(u){const v=[];for(const g of w(u))typeof u[g]=="function"&&v.push(g);return v}e.getAllMethodNames=d;function b(u,v){const g=l=>function(){const i=Array.prototype.slice.call(arguments,0);return v(l,i)},h={};for(const l of u)h[l]=g(l);return h}e.createProxyObject=b}),define(ee[29],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return I.test(C)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(k){for(let p=0;p<k.length;p++)k[p]=Math.floor(Math.random()*256);return k};const R=new Uint8Array(16),A=[];for(let k=0;k<256;k++)A.push(k.toString(16).padStart(2,"0"));return function(){C(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,m="";return m+=A[R[p++]],m+=A[R[p++]],m+=A[R[p++]],m+=A[R[p++]],m+="-",m+=A[R[p++]],m+=A[R[p++]],m+="-",m+=A[R[p++]],m+=A[R[p++]],m+="-",m+=A[R[p++]],m+=A[R[p++]],m+="-",m+=A[R[p++]],m+=A[R[p++]],m+=A[R[p++]],m+=A[R[p++]],m+=A[R[p++]],m+=A[R[p++]],m}}()}),define(ee[127],te([0,1,77,40,50]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(A,k){if(await new Promise((y,P)=>{const E=t.createReadStream(A),f=I.createHash("sha1");E.pipe(f);const w=(0,C.once)((d,b)=>{E.removeAllListeners(),f.removeAllListeners(),d?P(d):y(b)});E.once("error",w),E.once("end",w),f.once("error",w),f.once("data",d=>w(void 0,d.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=R}),define(ee[128],te([0,1,25]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(A){const k=A.replace(/\-/g,":").toLowerCase();return!t.has(k)}function R(){const A=(0,I.networkInterfaces)();for(const k in A){const p=A[k];if(p){for(const{mac:m}of p)if(C(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(ee[97],te([0,1,78]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(k,p,m,y=1){let P=!1;return new Promise(E=>{const f=setTimeout(()=>{if(!P)return P=!0,E(0)},m);C(k,p,y,w=>{if(!P)return P=!0,clearTimeout(f),E(w)})})}e.findFreePort=t;function C(k,p,m,y){if(p===0)return y(0);const P=new I.Socket;P.once("connect",()=>(A(P),C(k+m,p-1,m,y))),P.once("data",()=>{}),P.once("error",E=>(A(P),E.code!=="ECONNREFUSED"?C(k+m,p-1,m,y):y(k))),P.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(k,p,m,y="127.0.0.1"){let P=!1,E,f=1;const w=I.createServer({pauseOnConnect:!0});function d(b,u){P||(P=!0,w.removeAllListeners(),w.close(),E&&clearTimeout(E),u(b))}return new Promise(b=>{E=setTimeout(()=>{d(0,b)},m),w.on("listening",()=>{d(k,b)}),w.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<p?(k++,f++,w.listen(k,y)):d(0,b)}),w.on("close",()=>{d(0,b)}),w.listen(k,y)})}e.findFreePortFaster=R;function A(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(p){console.error(p)}}}),define(ee[129],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[130],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(C,R){this.a=C,this.onMessage=R}send(C){try{this.a.send("vscode:message",C.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=I}),define(ee[41],te([0,1,13,14]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class C{constructor(){this.a=new WeakMap}on(A,k){const p=(m,...y)=>{this.b(A,m)&&k(m,...y)};return this.a.set(k,p),I.ipcMain.on(A,p),this}once(A,k){return I.ipcMain.once(A,(p,...m)=>{this.b(A,p)&&k(p,...m)}),this}handle(A,k){return I.ipcMain.handle(A,(p,...m)=>this.b(A,p)?k(p,...m):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return I.ipcMain.removeHandler(A),this}removeListener(A,k){const p=this.a.get(k);return p&&(I.ipcMain.removeListener(A,p),this.a.delete(k)),this}b(A,k){if(!A||!A.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const p=k.senderFrame,m=p.url;if(!m)return!0;let y="unknown";try{y=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${m}'.`),!1}return y!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${y}'.`),!1):p.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new C}),define(ee[131],te([0,1,13,41,12,129]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function A(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(p,m,y,P,E)=>{const f=k(p,P,y);f.popup({window:(0,C.withNullAsUndefined)(I.BrowserWindow.fromWebContents(p.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{f&&p.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=A;function k(p,m,y){const P=new I.Menu;return y.forEach(E=>{let f;E.type==="separator"?f=new I.MenuItem({type:E.type}):Array.isArray(E.submenu)?f=new I.MenuItem({submenu:k(p,m,E.submenu),label:E.label}):f=new I.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(w,d,b)=>p.sender.send(m,E.id,b)}),P.append(f)}),P}}),define(ee[132],te([11,10]),function(H,e){return H.create("vs/base/common/date",e)}),define(ee[133],te([0,1,132]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,C=t*60,R=C*24,A=R*7,k=R*30,p=R*365;function m(P,E,f){typeof P!="number"&&(P=P.getTime());const w=Math.round((new Date().getTime()-P)/1e3);if(w<-30)return(0,I.localize)(0,null,m(new Date().getTime()+w*1e3,!1));if(w<30)return(0,I.localize)(1,null);let d;return w<t?(d=w,E?d===1?f?(0,I.localize)(2,null,d):(0,I.localize)(3,null,d):f?(0,I.localize)(4,null,d):(0,I.localize)(5,null,d):d===1?f?(0,I.localize)(6,null,d):(0,I.localize)(7,null,d):f?(0,I.localize)(8,null,d):(0,I.localize)(9,null,d)):w<C?(d=Math.floor(w/t),E?d===1?f?(0,I.localize)(10,null,d):(0,I.localize)(11,null,d):f?(0,I.localize)(12,null,d):(0,I.localize)(13,null,d):d===1?f?(0,I.localize)(14,null,d):(0,I.localize)(15,null,d):f?(0,I.localize)(16,null,d):(0,I.localize)(17,null,d)):w<R?(d=Math.floor(w/C),E?d===1?f?(0,I.localize)(18,null,d):(0,I.localize)(19,null,d):f?(0,I.localize)(20,null,d):(0,I.localize)(21,null,d):d===1?f?(0,I.localize)(22,null,d):(0,I.localize)(23,null,d):f?(0,I.localize)(24,null,d):(0,I.localize)(25,null,d)):w<A?(d=Math.floor(w/R),E?d===1?(0,I.localize)(26,null,d):(0,I.localize)(27,null,d):d===1?(0,I.localize)(28,null,d):(0,I.localize)(29,null,d)):w<k?(d=Math.floor(w/A),E?d===1?f?(0,I.localize)(30,null,d):(0,I.localize)(31,null,d):f?(0,I.localize)(32,null,d):(0,I.localize)(33,null,d):d===1?f?(0,I.localize)(34,null,d):(0,I.localize)(35,null,d):f?(0,I.localize)(36,null,d):(0,I.localize)(37,null,d)):w<p?(d=Math.floor(w/k),E?d===1?f?(0,I.localize)(38,null,d):(0,I.localize)(39,null,d):f?(0,I.localize)(40,null,d):(0,I.localize)(41,null,d):d===1?f?(0,I.localize)(42,null,d):(0,I.localize)(43,null,d):f?(0,I.localize)(44,null,d):(0,I.localize)(45,null,d)):(d=Math.floor(w/p),E?d===1?f?(0,I.localize)(46,null,d):(0,I.localize)(47,null,d):f?(0,I.localize)(48,null,d):(0,I.localize)(49,null,d):d===1?f?(0,I.localize)(50,null,d):(0,I.localize)(51,null,d):f?(0,I.localize)(52,null,d):(0,I.localize)(53,null,d))}e.fromNow=m;function y(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(ee[134],te([11,10]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(ee[45],te([0,1,24,12,134]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(P,E){return E&&(P.stack||P.stacktrace)?C.localize(0,null,k(P),A(P.stack)||A(P.stacktrace)):k(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?C.localize(1,null,P.message):P.message||C.localize(2,null)}function p(P=null,E=!1){if(!P)return C.localize(3,null);if(Array.isArray(P)){const f=I.coalesce(P),w=p(f[0],E);return f.length>1?C.localize(4,null,w,f.length):w}if(t.isString(P))return P;if(P.detail){const f=P.detail;if(f.error)return R(f.error,E);if(f.exception)return R(f.exception,E)}return P.stack?R(P,E):P.message?P.message:C.localize(5,null)}e.toErrorMessage=p;function m(P){const E=P;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=m;function y(P,E){let f;return typeof P=="string"?f=new Error(P):f=P,f.actions=E,f}e.createErrorWithActions=y}),define(ee[135],te([11,10]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(ee[136],te([0,1,135]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(C){switch(C){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ee[137],te([11,10]),function(H,e){return H.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,137]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,C=!1,R=!1,A=!1,k=!1,p=!1,m=!1,y=!1,P=!1,E=!1,f,w=e.LANGUAGE_DEFAULT,d,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const v=typeof u?.versions?.electron=="string",g=v&&u?.type==="renderer";if(typeof navigator=="object"&&!g)b=navigator.userAgent,t=b.indexOf("Windows")>=0,C=b.indexOf("Macintosh")>=0,y=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=b.indexOf("Linux")>=0,E=b?.indexOf("Mobi")>=0,p=!0,f=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,w=f;else if(typeof u=="object"){t=u.platform==="win32",C=u.platform==="darwin",R=u.platform==="linux",A=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,m=v,P=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const S=JSON.parse(o),M=S.availableLanguages["*"];f=S.locale,w=M||e.LANGUAGE_DEFAULT,d=S._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var h;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function l(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let i=0;C?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=C,e.isLinux=R,e.isLinuxSnap=A,e.isNative=k,e.isElectron=m,e.isWeb=p,e.isWebWorker=p&&typeof e.globals.importScripts=="function",e.isIOS=y,e.isMobile=E,e.isCI=P,e.platform=i,e.userAgent=b,e.language=w;var s;(function(o){function S(){return e.language}o.value=S;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=M;function L(){return e.language==="en"}o.isDefault=L})(s=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let L=0,B=o.length;L<B;L++){const J=o[L];if(J.id===M.data.vscodeScheduleAsyncWork){o.splice(L,1),J.callback();return}}});let S=0;return M=>{const L=++S;o.push({id:L,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return o=>setTimeout(o)})();var n;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||y?2:t?1:3;let a=!0,r=!1;function c(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[33],te([0,1,4]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const C=I.globals.vscode.process;t={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ee[9],te([0,1,33]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,C=97,R=90,A=122,k=46,p=47,m=92,y=58,P=63;class E extends Error{constructor(h,l,i){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const n=h.indexOf(".")!==-1?"property":"argument";let a=`The "${h}" ${n} ${s} of type ${l}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(g,h){if(typeof g!="string")throw new E(h,"string",g)}function w(g){return g===p||g===m}function d(g){return g===p}function b(g){return g>=t&&g<=R||g>=C&&g<=A}function u(g,h,l,i){let s="",n=0,a=-1,r=0,c=0;for(let o=0;o<=g.length;++o){if(o<g.length)c=g.charCodeAt(o);else{if(i(c))break;c=p}if(i(c)){if(!(a===o-1||r===1))if(r===2){if(s.length<2||n!==2||s.charCodeAt(s.length-1)!==k||s.charCodeAt(s.length-2)!==k){if(s.length>2){const S=s.lastIndexOf(l);S===-1?(s="",n=0):(s=s.slice(0,S),n=s.length-1-s.lastIndexOf(l)),a=o,r=0;continue}else if(s.length!==0){s="",n=0,a=o,r=0;continue}}h&&(s+=s.length>0?`${l}..`:"..",n=2)}else s.length>0?s+=`${l}${g.slice(a+1,o)}`:s=g.slice(a+1,o),n=o-a-1;a=o,r=0}else c===k&&r!==-1?++r:r=-1}return s}function v(g,h){if(h===null||typeof h!="object")throw new E("pathObject","Object",h);const l=h.dir||h.root,i=h.base||`${h.name||""}${h.ext||""}`;return l?l===h.root?`${l}${i}`:`${l}${g}${i}`:i}e.win32={resolve(...g){let h="",l="",i=!1;for(let s=g.length-1;s>=-1;s--){let n;if(s>=0){if(n=g[s],f(n,"path"),n.length===0)continue}else h.length===0?n=I.cwd():(n=I.env[`=${h}`]||I.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==h.toLowerCase()&&n.charCodeAt(2)===m)&&(n=`${h}\\`));const a=n.length;let r=0,c="",o=!1;const S=n.charCodeAt(0);if(a===1)w(S)&&(r=1,o=!0);else if(w(S))if(o=!0,w(n.charCodeAt(1))){let M=2,L=M;for(;M<a&&!w(n.charCodeAt(M));)M++;if(M<a&&M!==L){const B=n.slice(L,M);for(L=M;M<a&&w(n.charCodeAt(M));)M++;if(M<a&&M!==L){for(L=M;M<a&&!w(n.charCodeAt(M));)M++;(M===a||M!==L)&&(c=`\\\\${B}\\${n.slice(L,M)}`,r=M)}}}else r=1;else b(S)&&n.charCodeAt(1)===y&&(c=n.slice(0,2),r=2,a>2&&w(n.charCodeAt(2))&&(o=!0,r=3));if(c.length>0)if(h.length>0){if(c.toLowerCase()!==h.toLowerCase())continue}else h=c;if(i){if(h.length>0)break}else if(l=`${n.slice(r)}\\${l}`,i=o,o&&h.length>0)break}return l=u(l,!i,"\\",w),i?`${h}\\${l}`:`${h}${l}`||"."},normalize(g){f(g,"path");const h=g.length;if(h===0)return".";let l=0,i,s=!1;const n=g.charCodeAt(0);if(h===1)return d(n)?"\\":g;if(w(n))if(s=!0,w(g.charCodeAt(1))){let r=2,c=r;for(;r<h&&!w(g.charCodeAt(r));)r++;if(r<h&&r!==c){const o=g.slice(c,r);for(c=r;r<h&&w(g.charCodeAt(r));)r++;if(r<h&&r!==c){for(c=r;r<h&&!w(g.charCodeAt(r));)r++;if(r===h)return`\\\\${o}\\${g.slice(c)}\\`;r!==c&&(i=`\\\\${o}\\${g.slice(c,r)}`,l=r)}}}else l=1;else b(n)&&g.charCodeAt(1)===y&&(i=g.slice(0,2),l=2,h>2&&w(g.charCodeAt(2))&&(s=!0,l=3));let a=l<h?u(g.slice(l),!s,"\\",w):"";return a.length===0&&!s&&(a="."),a.length>0&&w(g.charCodeAt(h-1))&&(a+="\\"),i===void 0?s?`\\${a}`:a:s?`${i}\\${a}`:`${i}${a}`},isAbsolute(g){f(g,"path");const h=g.length;if(h===0)return!1;const l=g.charCodeAt(0);return w(l)||h>2&&b(l)&&g.charCodeAt(1)===y&&w(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let h,l;for(let n=0;n<g.length;++n){const a=g[n];f(a,"path"),a.length>0&&(h===void 0?h=l=a:h+=`\\${a}`)}if(h===void 0)return".";let i=!0,s=0;if(typeof l=="string"&&w(l.charCodeAt(0))){++s;const n=l.length;n>1&&w(l.charCodeAt(1))&&(++s,n>2&&(w(l.charCodeAt(2))?++s:i=!1))}if(i){for(;s<h.length&&w(h.charCodeAt(s));)s++;s>=2&&(h=`\\${h.slice(s)}`)}return e.win32.normalize(h)},relative(g,h){if(f(g,"from"),f(h,"to"),g===h)return"";const l=e.win32.resolve(g),i=e.win32.resolve(h);if(l===i||(g=l.toLowerCase(),h=i.toLowerCase(),g===h))return"";let s=0;for(;s<g.length&&g.charCodeAt(s)===m;)s++;let n=g.length;for(;n-1>s&&g.charCodeAt(n-1)===m;)n--;const a=n-s;let r=0;for(;r<h.length&&h.charCodeAt(r)===m;)r++;let c=h.length;for(;c-1>r&&h.charCodeAt(c-1)===m;)c--;const o=c-r,S=a<o?a:o;let M=-1,L=0;for(;L<S;L++){const J=g.charCodeAt(s+L);if(J!==h.charCodeAt(r+L))break;J===m&&(M=L)}if(L!==S){if(M===-1)return i}else{if(o>S){if(h.charCodeAt(r+L)===m)return i.slice(r+L+1);if(L===2)return i.slice(r+L)}a>S&&(g.charCodeAt(s+L)===m?M=L:L===2&&(M=3)),M===-1&&(M=0)}let B="";for(L=s+M+1;L<=n;++L)(L===n||g.charCodeAt(L)===m)&&(B+=B.length===0?"..":"\\..");return r+=M,B.length>0?`${B}${i.slice(r,c)}`:(i.charCodeAt(r)===m&&++r,i.slice(r,c))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const h=e.win32.resolve(g);if(h.length<=2)return g;if(h.charCodeAt(0)===m){if(h.charCodeAt(1)===m){const l=h.charCodeAt(2);if(l!==P&&l!==k)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(b(h.charCodeAt(0))&&h.charCodeAt(1)===y&&h.charCodeAt(2)===m)return`\\\\?\\${h}`;return g},dirname(g){f(g,"path");const h=g.length;if(h===0)return".";let l=-1,i=0;const s=g.charCodeAt(0);if(h===1)return w(s)?g:".";if(w(s)){if(l=i=1,w(g.charCodeAt(1))){let r=2,c=r;for(;r<h&&!w(g.charCodeAt(r));)r++;if(r<h&&r!==c){for(c=r;r<h&&w(g.charCodeAt(r));)r++;if(r<h&&r!==c){for(c=r;r<h&&!w(g.charCodeAt(r));)r++;if(r===h)return g;r!==c&&(l=i=r+1)}}}}else b(s)&&g.charCodeAt(1)===y&&(l=h>2&&w(g.charCodeAt(2))?3:2,i=l);let n=-1,a=!0;for(let r=h-1;r>=i;--r)if(w(g.charCodeAt(r))){if(!a){n=r;break}}else a=!1;if(n===-1){if(l===-1)return".";n=l}return g.slice(0,n)},basename(g,h){h!==void 0&&f(h,"ext"),f(g,"path");let l=0,i=-1,s=!0,n;if(g.length>=2&&b(g.charCodeAt(0))&&g.charCodeAt(1)===y&&(l=2),h!==void 0&&h.length>0&&h.length<=g.length){if(h===g)return"";let a=h.length-1,r=-1;for(n=g.length-1;n>=l;--n){const c=g.charCodeAt(n);if(w(c)){if(!s){l=n+1;break}}else r===-1&&(s=!1,r=n+1),a>=0&&(c===h.charCodeAt(a)?--a===-1&&(i=n):(a=-1,i=r))}return l===i?i=r:i===-1&&(i=g.length),g.slice(l,i)}for(n=g.length-1;n>=l;--n)if(w(g.charCodeAt(n))){if(!s){l=n+1;break}}else i===-1&&(s=!1,i=n+1);return i===-1?"":g.slice(l,i)},extname(g){f(g,"path");let h=0,l=-1,i=0,s=-1,n=!0,a=0;g.length>=2&&g.charCodeAt(1)===y&&b(g.charCodeAt(0))&&(h=i=2);for(let r=g.length-1;r>=h;--r){const c=g.charCodeAt(r);if(w(c)){if(!n){i=r+1;break}continue}s===-1&&(n=!1,s=r+1),c===k?l===-1?l=r:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||s===-1||a===0||a===1&&l===s-1&&l===i+1?"":g.slice(l,s)},format:v.bind(null,"\\"),parse(g){f(g,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return h;const l=g.length;let i=0,s=g.charCodeAt(0);if(l===1)return w(s)?(h.root=h.dir=g,h):(h.base=h.name=g,h);if(w(s)){if(i=1,w(g.charCodeAt(1))){let M=2,L=M;for(;M<l&&!w(g.charCodeAt(M));)M++;if(M<l&&M!==L){for(L=M;M<l&&w(g.charCodeAt(M));)M++;if(M<l&&M!==L){for(L=M;M<l&&!w(g.charCodeAt(M));)M++;M===l?i=M:M!==L&&(i=M+1)}}}}else if(b(s)&&g.charCodeAt(1)===y){if(l<=2)return h.root=h.dir=g,h;if(i=2,w(g.charCodeAt(2))){if(l===3)return h.root=h.dir=g,h;i=3}}i>0&&(h.root=g.slice(0,i));let n=-1,a=i,r=-1,c=!0,o=g.length-1,S=0;for(;o>=i;--o){if(s=g.charCodeAt(o),w(s)){if(!c){a=o+1;break}continue}r===-1&&(c=!1,r=o+1),s===k?n===-1?n=o:S!==1&&(S=1):n!==-1&&(S=-1)}return r!==-1&&(n===-1||S===0||S===1&&n===r-1&&n===a+1?h.base=h.name=g.slice(a,r):(h.name=g.slice(a,n),h.base=g.slice(a,r),h.ext=g.slice(n,r))),a>0&&a!==i?h.dir=g.slice(0,a-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let h="",l=!1;for(let i=g.length-1;i>=-1&&!l;i--){const s=i>=0?g[i]:I.cwd();f(s,"path"),s.length!==0&&(h=`${s}/${h}`,l=s.charCodeAt(0)===p)}return h=u(h,!l,"/",d),l?`/${h}`:h.length>0?h:"."},normalize(g){if(f(g,"path"),g.length===0)return".";const h=g.charCodeAt(0)===p,l=g.charCodeAt(g.length-1)===p;return g=u(g,!h,"/",d),g.length===0?h?"/":l?"./":".":(l&&(g+="/"),h?`/${g}`:g)},isAbsolute(g){return f(g,"path"),g.length>0&&g.charCodeAt(0)===p},join(...g){if(g.length===0)return".";let h;for(let l=0;l<g.length;++l){const i=g[l];f(i,"path"),i.length>0&&(h===void 0?h=i:h+=`/${i}`)}return h===void 0?".":e.posix.normalize(h)},relative(g,h){if(f(g,"from"),f(h,"to"),g===h||(g=e.posix.resolve(g),h=e.posix.resolve(h),g===h))return"";const l=1,i=g.length,s=i-l,n=1,a=h.length-n,r=s<a?s:a;let c=-1,o=0;for(;o<r;o++){const M=g.charCodeAt(l+o);if(M!==h.charCodeAt(n+o))break;M===p&&(c=o)}if(o===r)if(a>r){if(h.charCodeAt(n+o)===p)return h.slice(n+o+1);if(o===0)return h.slice(n+o)}else s>r&&(g.charCodeAt(l+o)===p?c=o:o===0&&(c=0));let S="";for(o=l+c+1;o<=i;++o)(o===i||g.charCodeAt(o)===p)&&(S+=S.length===0?"..":"/..");return`${S}${h.slice(n+c)}`},toNamespacedPath(g){return g},dirname(g){if(f(g,"path"),g.length===0)return".";const h=g.charCodeAt(0)===p;let l=-1,i=!0;for(let s=g.length-1;s>=1;--s)if(g.charCodeAt(s)===p){if(!i){l=s;break}}else i=!1;return l===-1?h?"/":".":h&&l===1?"//":g.slice(0,l)},basename(g,h){h!==void 0&&f(h,"ext"),f(g,"path");let l=0,i=-1,s=!0,n;if(h!==void 0&&h.length>0&&h.length<=g.length){if(h===g)return"";let a=h.length-1,r=-1;for(n=g.length-1;n>=0;--n){const c=g.charCodeAt(n);if(c===p){if(!s){l=n+1;break}}else r===-1&&(s=!1,r=n+1),a>=0&&(c===h.charCodeAt(a)?--a===-1&&(i=n):(a=-1,i=r))}return l===i?i=r:i===-1&&(i=g.length),g.slice(l,i)}for(n=g.length-1;n>=0;--n)if(g.charCodeAt(n)===p){if(!s){l=n+1;break}}else i===-1&&(s=!1,i=n+1);return i===-1?"":g.slice(l,i)},extname(g){f(g,"path");let h=-1,l=0,i=-1,s=!0,n=0;for(let a=g.length-1;a>=0;--a){const r=g.charCodeAt(a);if(r===p){if(!s){l=a+1;break}continue}i===-1&&(s=!1,i=a+1),r===k?h===-1?h=a:n!==1&&(n=1):h!==-1&&(n=-1)}return h===-1||i===-1||n===0||n===1&&h===i-1&&h===l+1?"":g.slice(h,i)},format:v.bind(null,"/"),parse(g){f(g,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return h;const l=g.charCodeAt(0)===p;let i;l?(h.root="/",i=1):i=0;let s=-1,n=0,a=-1,r=!0,c=g.length-1,o=0;for(;c>=i;--c){const S=g.charCodeAt(c);if(S===p){if(!r){n=c+1;break}continue}a===-1&&(r=!1,a=c+1),S===k?s===-1?s=c:o!==1&&(o=1):s!==-1&&(o=-1)}if(a!==-1){const S=n===0&&l?1:n;s===-1||o===0||o===1&&s===a-1&&s===n+1?h.base=h.name=g.slice(S,a):(h.name=g.slice(S,s),h.base=g.slice(S,a),h.ext=g.slice(s,a))}return n>0?h.dir=g.slice(0,n-1):l&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=I.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=I.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=I.platform==="win32"?e.win32.join:e.posix.join,e.resolve=I.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=I.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=I.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=I.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=I.platform==="win32"?e.win32.extname:e.posix.extname,e.format=I.platform==="win32"?e.win32.format:e.posix.format,e.parse=I.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=I.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=I.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=I.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[79],te([0,1,4]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var C;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(C=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(k,...p){const m=p.reduce((E,f)=>(E[f]=!0,E),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(E=>!m[E]).forEach(E=>{for(let f=0;f<y.length;f++)if(E.search(y[f])!==-1){delete k[E];break}})}e.sanitizeProcessEnvironment=R;function A(k){!k||(delete k.DEBUG,I.isMacintosh&&delete k.DYLD_LIBRARY_PATH,I.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ee[80],te([0,1,4]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=I.globals.performance&&typeof I.globals.performance.now=="function";class C{static create(A=!0){return new C(A)}constructor(A){this.a=t&&A,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?I.globals.performance.now():Date.now()}}e.StopWatch=C}),define(ee[3],te([0,1,14,50,2,96,80]),function(H,e,I,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,p=!1;var m;(function(c){c.None=()=>C.Disposable.None;function o(U){if(p){const{onDidAddListener:q}=U,Q=w.create();let j=0;U.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),q?.()}}}function S(U,q){return ne(U,()=>{},0,void 0,void 0,q)}c.defer=S;function M(U){return(q,Q=null,j)=>{let Z=!1,x;return x=U(oe=>{if(!Z)return x?x.dispose():Z=!0,q.call(Q,oe)},null,j),Z&&x.dispose(),x}}c.once=M;function L(U,q,Q){return re((j,Z=null,x)=>U(oe=>j.call(Z,q(oe)),null,x),Q)}c.map=L;function B(U,q,Q){return re((j,Z=null,x)=>U(oe=>{q(oe),j.call(Z,oe)},null,x),Q)}c.forEach=B;function J(U,q,Q){return re((j,Z=null,x)=>U(oe=>q(oe)&&j.call(Z,oe),null,x),Q)}c.filter=J;function ae(U){return U}c.signal=ae;function X(...U){return(q,Q=null,j)=>(0,C.combinedDisposable)(...U.map(Z=>Z(x=>q.call(Q,x),null,j)))}c.any=X;function Y(U,q,Q,j){let Z=Q;return L(U,x=>(Z=q(Z,x),Z),j)}c.reduce=Y;function re(U,q){let Q;const j={onWillAddFirstListener(){Q=U(Z.fire,Z)},onDidRemoveLastListener(){Q?.dispose()}};q||o(j);const Z=new b(j);return q?.add(Z),Z.event}function ne(U,q,Q=100,j=!1,Z,x){let oe,ge,Me,Oe=0;const Ce={leakWarningThreshold:Z,onWillAddFirstListener(){oe=U(be=>{Oe++,ge=q(ge,be),j&&!Me&&(Le.fire(ge),ge=void 0),clearTimeout(Me),Me=setTimeout(()=>{const we=ge;ge=void 0,Me=void 0,(!j||Oe>1)&&Le.fire(we),Oe=0},Q)})},onDidRemoveLastListener(){oe.dispose()}};x||o(Ce);const Le=new b(Ce);return x?.add(Le),Le.event}c.debounce=ne;function de(U,q=0,Q){return c.debounce(U,(j,Z)=>j?(j.push(Z),j):[Z],q,void 0,void 0,Q)}c.accumulate=de;function K(U,q=(j,Z)=>j===Z,Q){let j=!0,Z;return J(U,x=>{const oe=j||!q(x,Z);return j=!1,Z=x,oe},Q)}c.latch=K;function le(U,q,Q){return[c.filter(U,q,Q),c.filter(U,j=>!q(j),Q)]}c.split=le;function F(U,q=!1,Q=[]){let j=Q.slice(),Z=U(ge=>{j?j.push(ge):oe.fire(ge)});const x=()=>{j?.forEach(ge=>oe.fire(ge)),j=null},oe=new b({onWillAddFirstListener(){Z||(Z=U(ge=>oe.fire(ge)))},onDidAddFirstListener(){j&&(q?setTimeout(x):x())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return oe.event}c.buffer=F;class T{constructor(q){this.event=q,this.c=new C.DisposableStore}map(q){return new T(L(this.event,q,this.c))}forEach(q){return new T(B(this.event,q,this.c))}filter(q){return new T(J(this.event,q,this.c))}reduce(q,Q){return new T(Y(this.event,q,Q,this.c))}latch(){return new T(K(this.event,void 0,this.c))}debounce(q,Q=100,j=!1,Z){return new T(ne(this.event,q,Q,j,Z,this.c))}on(q,Q,j){return this.event(q,Q,j)}once(q,Q,j){return M(this.event)(q,Q,j)}dispose(){this.c.dispose()}}function N(U){return new T(U)}c.chain=N;function V(U,q,Q=j=>j){const j=(...ge)=>oe.fire(Q(...ge)),Z=()=>U.on(q,j),x=()=>U.removeListener(q,j),oe=new b({onWillAddFirstListener:Z,onDidRemoveLastListener:x});return oe.event}c.fromNodeEventEmitter=V;function se(U,q,Q=j=>j){const j=(...ge)=>oe.fire(Q(...ge)),Z=()=>U.addEventListener(q,j),x=()=>U.removeEventListener(q,j),oe=new b({onWillAddFirstListener:Z,onDidRemoveLastListener:x});return oe.event}c.fromDOMEventEmitter=se;function z(U){return new Promise(q=>M(U)(q))}c.toPromise=z;function $(U,q){return q(void 0),U(Q=>q(Q))}c.runAndSubscribe=$;function D(U,q){let Q=null;function j(x){Q?.dispose(),Q=new C.DisposableStore,q(x,Q)}j(void 0);const Z=U(x=>j(x));return(0,C.toDisposable)(()=>{Z.dispose(),Q?.dispose()})}c.runAndSubscribeWithStore=D;class O{constructor(q,Q){this.obs=q,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{q.addObserver(this)},onDidRemoveLastListener:()=>{q.removeObserver(this)}};Q||o(j),this.emitter=new b(j),Q&&Q.add(this.emitter)}beginUpdate(q){this.c++}handleChange(q,Q){this.d=!0}endUpdate(q){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(U,q){return new O(U,q).emitter.event}c.fromObservable=W})(m=e.Event||(e.Event={}));class y{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${y.c++}`,y.all.add(this)}start(o){this.d=new A.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=y,y.all=new Set,y.c=0;let P=-1;function E(c){const o=P;return P=c,{dispose(){P=o}}}e.setGlobalLeakWarningThreshold=E;class f{constructor(o,S=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=S,this.d=0}dispose(){this.c?.clear()}check(o,S){const M=this.threshold;if(M<=0||S<M)return;this.c||(this.c=new Map);const L=this.c.get(o.value)||0;if(this.c.set(o.value,L+1),this.d-=1,this.d<=0){this.d=M*.5;let B,J=0;for(const[ae,X]of this.c)(!B||J<X)&&(B=ae,J=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${J}):`),console.warn(B)}return()=>{const B=this.c.get(o.value)||0;this.c.set(o.value,B-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(o,S,M){this.callback=o,this.callbackThis=S,this.stack=M,this.subscription=new C.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class b{constructor(o){this.j=!1,this.d=o,this.f=P>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new y(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const o=Array.from(this.q);queueMicrotask(()=>{for(const S of o)S.subscription.isset()&&(S.subscription.unset(),S.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,S,M)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),C.Disposable.None;const L=this.q.isEmpty();L&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let B,J;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(J=w.create(),B=this.f.check(J,this.q.size+1)),k&&(J=J??w.create());const ae=new d(o,S,J),X=this.q.push(ae);L&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,S);const Y=ae.subscription.set(()=>{B?.(),this.j||(X(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return M instanceof C.DisposableStore?M.add(Y):Array.isArray(M)&&M.push(Y),Y}),this.l}fire(o){if(this.q){this.m||(this.m=new v);for(const S of this.q)this.m.push(this,S,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=b;class u{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(o,S,M){this.c.push(new g(o,S,M))}clear(o){const S=new R.LinkedList;for(const M of this.c)M.emitter!==o&&S.push(M);this.c=S}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(S){(0,I.onUnexpectedError)(S)}}}}e.EventDeliveryQueue=u;class v extends u{clear(o){this.c.clear()}}class g{constructor(o,S,M){this.emitter=o,this.listener=S,this.event=M}}class h extends b{async fireAsync(o,S,M){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const L of this.q)this.c.push([L,o]);for(;this.c.size>0&&!S.isCancellationRequested;){const[L,B]=this.c.shift(),J=[],ae={...B,token:S,waitUntil:X=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");M&&(X=M(X,L.callback)),J.push(X)}};try{L.invoke(ae)}catch(X){(0,I.onUnexpectedError)(X);continue}Object.freeze(J),await Promise.allSettled(J).then(X=>{for(const Y of X)Y.status==="rejected"&&(0,I.onUnexpectedError)(Y.reason)})}}}}e.AsyncEmitter=h;class l extends b{constructor(o){super(o),this.h=0,this.s=new R.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=l;class i extends l{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=i;class s extends b{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(S=>super.fire(S)),this.c=[]}))}}e.MicrotaskEmitter=s;class n{constructor(){this.d=!1,this.f=[],this.c=new b({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const S={event:o,listener:null};this.f.push(S),this.d&&this.j(S);const M=()=>{this.d&&this.k(S);const L=this.f.indexOf(S);this.f.splice(L,1)};return(0,C.toDisposable)((0,t.once)(M))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(S=>this.c.fire(S))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class a{constructor(){this.c=[]}wrapEvent(o){return(S,M,L)=>o(B=>{const J=this.c[this.c.length-1];J?J.push(()=>S.call(M,B)):S.call(M,B)},void 0,L)}bufferEvents(o){const S=[];this.c.push(S);const M=o();return this.c.pop(),S.forEach(L=>L()),M}}e.EventBufferer=a;class r{constructor(){this.c=!1,this.d=m.None,this.f=C.Disposable.None,this.g=new b({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(ee[22],te([0,1,3]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,p){const m=setTimeout(k.bind(p),0);return{dispose(){clearTimeout(m)}}});var C;(function(k){function p(m){return m===k.None||m===k.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}k.isCancellationToken=p,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(C=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new I.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(p){this.a=void 0,this.b=void 0,this.b=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=C.Cancelled}dispose(p=!1){p&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=C.None}}e.CancellationTokenSource=A}),define(ee[138],te([0,1,22]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new I.CancellationTokenSource,p=this.b(k.token);return this.a={promise:p,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=t;class C{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const p=JSON.stringify(k);return this.b!==p&&(this.b=p,this.a=this.c(k)),this.a}}e.LRUCachedFunction=C;class R{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const p=this.b(k);return this.a.set(k,p),p}}e.CachedFunction=R}),define(ee[26],te([0,1,138,125]),function(H,e,I,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=R;const A=/{(\d+)}/g;function k(G,...ce){return ce.length===0?G:G.replace(A,function(ue,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=ce.length?ue:ce[Se]})}e.format=k;const p=/{([^}]+)}/g;function m(G,ce){return G.replace(p,(ue,me)=>ce[me]??ue)}e.format2=m;function y(G){return G.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=y;function P(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function E(G,ce){let ue=0;const me=ce.charCodeAt(0);for(let Se=G.length-1;Se>=0;Se--)G.charCodeAt(Se)===me&&ue++;return ue}e.count=E;function f(G,ce,ue="\u2026"){return G.length<=ce?G:`${G.substr(0,ce)}${ue}`}e.truncate=f;function w(G,ce=" "){const ue=d(G,ce);return b(ue,ce)}e.trim=w;function d(G,ce){if(!G||!ce)return G;const ue=ce.length;if(ue===0||G.length===0)return G;let me=0;for(;G.indexOf(ce,me)===me;)me=me+ue;return G.substring(me)}e.ltrim=d;function b(G,ce){if(!G||!ce)return G;const ue=ce.length,me=G.length;if(ue===0||me===0)return G;let Se=me,Ae=-1;for(;Ae=G.lastIndexOf(ce,Se-1),!(Ae===-1||Ae+ue!==Se);){if(Ae===0)return"";Se=Ae}return G.substring(0,Se)}e.rtrim=b;function u(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function v(G){return G.replace(/\*/g,"")}e.stripWildcards=v;function g(G,ce,ue={}){if(!G)throw new Error("Cannot create regex from empty string");ce||(G=P(G)),ue.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(G,me)}e.createRegExp=g;function h(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function l(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function i(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=i;function s(G){return G.split(/\r\n|\r|\n/)}e.splitLines=s;function n(G){for(let ce=0,ue=G.length;ce<ue;ce++){const me=G.charCodeAt(ce);if(me!==32&&me!==9)return ce}return-1}e.firstNonWhitespaceIndex=n;function a(G,ce=0,ue=G.length){for(let me=ce;me<ue;me++){const Se=G.charCodeAt(me);if(Se!==32&&Se!==9)return G.substring(ce,me)}return G.substring(ce,ue)}e.getLeadingWhitespace=a;function r(G,ce=G.length-1){for(let ue=ce;ue>=0;ue--){const me=G.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=r;function c(G,ce,ue){const me=[];let Se=0;for(const Ae of G.matchAll(ce)){if(me.push(G.slice(Se,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");Se=Ae.index+Ae[0].length,me.push(ue(Ae[0],...Ae.slice(1),Ae.index,G,Ae.groups))}return me.push(G.slice(Se)),Promise.all(me).then(Ae=>Ae.join(""))}e.replaceAsync=c;function o(G,ce){return G<ce?-1:G>ce?1:0}e.compare=o;function S(G,ce,ue=0,me=G.length,Se=0,Ae=ce.length){for(;ue<me&&Se<Ae;ue++,Se++){const xe=G.charCodeAt(ue),He=ce.charCodeAt(Se);if(xe<He)return-1;if(xe>He)return 1}const je=me-ue,it=Ae-Se;return je<it?-1:je>it?1:0}e.compareSubstring=S;function M(G,ce){return L(G,ce,0,G.length,0,ce.length)}e.compareIgnoreCase=M;function L(G,ce,ue=0,me=G.length,Se=0,Ae=ce.length){for(;ue<me&&Se<Ae;ue++,Se++){let xe=G.charCodeAt(ue),He=ce.charCodeAt(Se);if(xe===He)continue;if(xe>=128||He>=128)return S(G.toLowerCase(),ce.toLowerCase(),ue,me,Se,Ae);J(xe)&&(xe-=32),J(He)&&(He-=32);const tt=xe-He;if(tt!==0)return tt}const je=me-ue,it=Ae-Se;return je<it?-1:je>it?1:0}e.compareSubstringIgnoreCase=L;function B(G){return G>=48&&G<=57}e.isAsciiDigit=B;function J(G){return G>=97&&G<=122}e.isLowerAsciiLetter=J;function ae(G){return G>=65&&G<=90}e.isUpperAsciiLetter=ae;function X(G,ce){return G.length===ce.length&&L(G,ce)===0}e.equalsIgnoreCase=X;function Y(G,ce){const ue=ce.length;return ce.length>G.length?!1:L(G,ce,0,ue)===0}e.startsWithIgnoreCase=Y;function re(G,ce){const ue=Math.min(G.length,ce.length);let me;for(me=0;me<ue;me++)if(G.charCodeAt(me)!==ce.charCodeAt(me))return me;return ue}e.commonPrefixLength=re;function ne(G,ce){const ue=Math.min(G.length,ce.length);let me;const Se=G.length-1,Ae=ce.length-1;for(me=0;me<ue;me++)if(G.charCodeAt(Se-me)!==ce.charCodeAt(Ae-me))return me;return ue}e.commonSuffixLength=ne;function de(G){return 55296<=G&&G<=56319}e.isHighSurrogate=de;function K(G){return 56320<=G&&G<=57343}e.isLowSurrogate=K;function le(G,ce){return(G-55296<<10)+(ce-56320)+65536}e.computeCodePoint=le;function F(G,ce,ue){const me=G.charCodeAt(ue);if(de(me)&&ue+1<ce){const Se=G.charCodeAt(ue+1);if(K(Se))return le(me,Se)}return me}e.getNextCodePoint=F;function T(G,ce){const ue=G.charCodeAt(ce-1);if(K(ue)&&ce>1){const me=G.charCodeAt(ce-2);if(de(me))return le(me,ue)}return ue}class N{get offset(){return this.e}constructor(ce,ue=0){this.c=ce,this.d=ce.length,this.e=ue}setOffset(ce){this.e=ce}prevCodePoint(){const ce=T(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=F(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=N;class V{get offset(){return this.c.offset}constructor(ce,ue=0){this.c=new N(ce,ue)}nextGraphemeLength(){const ce=We.getInstance(),ue=this.c,me=ue.offset;let Se=ce.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Ae=ue.offset,je=ce.getGraphemeBreakType(ue.nextCodePoint());if(ve(Se,je)){ue.setOffset(Ae);break}Se=je}return ue.offset-me}prevGraphemeLength(){const ce=We.getInstance(),ue=this.c,me=ue.offset;let Se=ce.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Ae=ue.offset,je=ce.getGraphemeBreakType(ue.prevCodePoint());if(ve(je,Se)){ue.setOffset(Ae);break}Se=je}return me-ue.offset}eol(){return this.c.eol()}}e.GraphemeIterator=V;function se(G,ce){return new V(G,ce).nextGraphemeLength()}e.nextCharLength=se;function z(G,ce){return new V(G,ce).prevGraphemeLength()}e.prevCharLength=z;function $(G,ce){ce>0&&K(G.charCodeAt(ce))&&ce--;const ue=ce+se(G,ce);return[ue-z(G,ue),ue]}e.getCharContainingOffset=$;function D(G){const ce=new V(G);let ue=0;for(;!ce.eol();)ue++,ce.nextGraphemeLength();return ue}e.charCount=D;let O;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(G){return O||(O=W()),O.test(G)}e.containsRTL=U;const q=/^[\t\n\r\x20-\x7E]*$/;function Q(G){return q.test(G)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=j;function Z(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=Z;function x(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=x;function oe(G,ce){if(G.length<ce)return G;const ue=/\b/g;let me=0;for(;ue.test(G)&&!(G.length-ue.lastIndex<ce);)me=ue.lastIndex,ue.lastIndex+=1;return G.substring(me).replace(/^\s/,"")}e.lcut=oe;const ge=/\x1B\x5B[12]?K/g,Me=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function Ce(G){return G&&(G=G.replace(ge,""),G=G.replace(Me,""),G=G.replace(Oe,"")),G}e.removeAnsiEscapeCodes=Ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function be(G){return Le(G)?G.substr(1):G}e.stripUTF8BOM=be;function we(G,ce){if(!G||!ce||G.length<ce.length)return!1;const ue=ce.length,me=G.toLowerCase();let Se=0,Ae=-1;for(;Se<ue;){const je=me.indexOf(ce[Se],Ae+1);if(je<0)return!1;Ae=je,Se++}return!0}e.fuzzyContains=we;function ye(G,ce=!1){return G?(ce&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=ye;function De(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=De;function _(G,ce=1){if(ce===0)return"";let ue=-1;do ue=G.indexOf(`
`,ue+1),ce--;while(ce>0&&ue>=0);return ue===-1?G:(G[ue-1]==="\r"&&ue--,G.substr(0,ue))}e.getNLines=_;function he(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}e.singleLetterHash=he;function fe(G){return We.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=fe;function ve(G,ce){return G===0?ce!==5&&ce!==7:G===2&&ce===3?!1:G===4||G===2||G===3||ce===4||ce===2||ce===3?!0:!(G===8&&(ce===8||ce===9||ce===11||ce===12)||(G===11||G===9)&&(ce===9||ce===10)||(G===12||G===10)&&ce===10||ce===5||ce===13||ce===7||G===1||G===13&&ce===14||G===6&&ce===6)}var Pe;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Te()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const ue=this.d,me=ue.length/3;let Se=1;for(;Se<=me;)if(ce<ue[3*Se])Se=2*Se;else if(ce>ue[3*Se+1])Se=2*Se+1;else return ue[3*Se+2];return 0}}We.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(G,ce){if(G===0)return 0;const ue=Ue(G,ce);if(ue!==void 0)return ue;const me=new N(ce,G);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=qe;function Ue(G,ce){const ue=new N(ce,G);let me=ue.prevCodePoint();for(;Be(me)||me===65039||me===8419;){if(ue.offset===0)return;me=ue.prevCodePoint()}if(!x(me))return;let Se=ue.offset;return Se>0&&ue.prevCodePoint()===8205&&(Se=ue.offset),Se}function Be(G){return 127995<=G&&G<=127999}var Xe;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(ce){return $e.d.get(Array.from(ce))}static getLocales(){return $e.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=$e,C=$e,$e.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.d=new I.LRUCachedFunction(G=>{function ce(He){const tt=new Map;for(let nt=0;nt<He.length;nt+=2)tt.set(He[nt],He[nt+1]);return tt}function ue(He,tt){const nt=new Map(He);for(const[lt,at]of tt)nt.set(lt,at);return nt}function me(He,tt){if(!He)return tt;const nt=new Map;for(const[lt,at]of He)tt.has(lt)&&nt.set(lt,at);return nt}const Se=C.c.getValue();let Ae=G.filter(He=>!He.startsWith("_")&&He in Se);Ae.length===0&&(Ae=["_default"]);let je;for(const He of Ae){const tt=ce(Se[He]);je=me(je,tt)}const it=ce(Se._common),xe=ue(it,je);return new $e(xe)}),$e.e=new t.Lazy(()=>Object.keys($e.c.getValue()).filter(G=>!G.startsWith("_")));class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(ce){return Ke.e().has(ce)}static get codePoints(){return Ke.e()}}e.InvisibleCharacters=Ke,Ke.d=void 0}),define(ee[30],te([0,1,9,4,26,12]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(r){return r===47||r===92}e.isPathSeparator=A;function k(r){return r.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=k;function p(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=p;function m(r,c=I.posix.sep){if(!r)return"";const o=r.length,S=r.charCodeAt(0);if(A(S)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let L=3;const B=L;for(;L<o&&!A(r.charCodeAt(L));L++);if(B!==L&&!A(r.charCodeAt(L+1))){for(L+=1;L<o;L++)if(A(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,c)}}return c}else if(u(S)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+c:r.slice(0,2);let M=r.indexOf("://");if(M!==-1){for(M+=3;M<o;M++)if(A(r.charCodeAt(M)))return r.slice(0,M+1)}return""}e.getRoot=m;function y(r){if(!t.isWindows||!r||r.length<5)return!1;let c=r.charCodeAt(0);if(c!==92||(c=r.charCodeAt(1),c!==92))return!1;let o=2;const S=o;for(;o<r.length&&(c=r.charCodeAt(o),c!==92);o++);return!(S===o||(c=r.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=y;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(r,c=t.isWindows){const o=c?P:E;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||c&&f.test(r)||r==="."||r===".."||c&&r[r.length-1]==="."||c&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=w;function d(r,c,o){const S=r===c;return!o||S?S:!r||!c?!1:(0,C.equalsIgnoreCase)(r,c)}e.isEqual=d;function b(r,c,o,S=I.sep){if(r===c)return!0;if(!r||!c||c.length>r.length)return!1;if(o){if(!(0,C.startsWithIgnoreCase)(r,c))return!1;if(c.length===r.length)return!0;let L=c.length;return c.charAt(c.length-1)===S&&L--,r.charAt(L)===S}return c.charAt(c.length-1)!==S&&(c+=S),r.indexOf(c)===0}e.isEqualOrParent=b;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function v(r,c){return t.isWindows&&r.endsWith(":")&&(r+=I.sep),(0,I.isAbsolute)(r)||(r=(0,I.join)(c,r)),r=(0,I.normalize)(r),t.isWindows?(r=(0,C.rtrim)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,C.rtrim)(r,I.sep),r||(r=I.sep)),r}e.sanitizeFilePath=v;function g(r){const c=(0,I.normalize)(r);return t.isWindows?r.length>3?!1:h(c)&&(r.length===2||c.charCodeAt(2)===92):c===I.posix.sep}e.isRootOrDriveLetter=g;function h(r,c=t.isWindows){return c?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function l(r){return h(r)?r[0]:void 0}e.getDriveLetter=l;function i(r,c,o){return c.length>r.length?-1:r===c?0:(o&&(r=r.toLowerCase(),c=c.toLowerCase()),r.indexOf(c))}e.indexOfPath=i;function s(r){const c=r.split(":");let o,S,M;for(const L of c){const B=Number(L);(0,R.isNumber)(B)?S===void 0?S=B:M===void 0&&(M=B):o=o?[o,L].join(":"):L}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:S!==void 0?S:void 0,column:M!==void 0?M:S!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(r,c,o=8){let S="";for(let L=0;L<o;L++)S+=n.charAt(Math.floor(Math.random()*n.length));let M;return c?M=`${c}-${S}`:M=S,r?(0,I.join)(r,M):M}e.randomPath=a}),define(ee[68],te([0,1,26]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return C(u,0)}e.hash=t;function C(u,v){switch(typeof u){case"object":return u===null?R(349,v):Array.isArray(u)?p(u,v):m(u,v);case"string":return k(u,v);case"boolean":return A(u,v);case"number":return R(u,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=C;function R(u,v){return(v<<5)-v+u|0}e.numberHash=R;function A(u,v){return R(u?433:863,v)}function k(u,v){v=R(149417,v);for(let g=0,h=u.length;g<h;g++)v=R(u.charCodeAt(g),v);return v}e.stringHash=k;function p(u,v){return v=R(104579,v),u.reduce((g,h)=>C(h,g),v)}function m(u,v){return v=R(181387,v),Object.keys(u).sort().reduce((g,h)=>(g=k(h,g),C(u[h],g)),v)}class y{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=C(v,this.g),this.g}}e.Hasher=y;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(u,v,g=32){const h=g-v,l=~((1<<h)-1);return(u<<v|(l&u)>>>h)>>>0}function f(u,v=0,g=u.byteLength,h=0){for(let l=0;l<g;l++)u[v+l]=h}function w(u,v,g="0"){for(;u.length<v;)u=g+u;return u}function d(u,v=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(g=>g.toString(16).padStart(2,"0")).join(""):w((u>>>0).toString(16),v/4)}e.toHexString=d;class b{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const g=v.length;if(g===0)return;const h=this.p;let l=this.r,i=this.u,s,n;for(i!==0?(s=i,n=-1,i=0):(s=v.charCodeAt(0),n=0);;){let a=s;if(I.isHighSurrogate(s))if(n+1<g){const r=v.charCodeAt(n+1);I.isLowSurrogate(r)?(n++,a=I.computeCodePoint(s,r)):a=65533}else{i=s;break}else I.isLowSurrogate(s)&&(a=65533);if(l=this.w(h,l,a),n++,n<g)s=v.charCodeAt(n);else break}this.r=l,this.u=i}w(v,g,h){return h<128?v[g++]=h:h<2048?(v[g++]=192|(h&1984)>>>6,v[g++]=128|(h&63)>>>0):h<65536?(v[g++]=224|(h&61440)>>>12,v[g++]=128|(h&4032)>>>6,v[g++]=128|(h&63)>>>0):(v[g++]=240|(h&1835008)>>>18,v[g++]=128|(h&258048)>>>12,v[g++]=128|(h&4032)>>>6,v[g++]=128|(h&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=b.g,g=this.q;for(let o=0;o<64;o+=4)v.setUint32(o,g.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,E(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let h=this.h,l=this.l,i=this.m,s=this.n,n=this.o,a,r,c;for(let o=0;o<80;o++)o<20?(a=l&i|~l&s,r=1518500249):o<40?(a=l^i^s,r=1859775393):o<60?(a=l&i|l&s|i&s,r=2400959708):(a=l^i^s,r=3395469782),c=E(h,5)+a+n+r+v.getUint32(o*4,!1)&4294967295,n=s,s=i,i=E(l,30),l=h,h=c;this.h=this.h+h&4294967295,this.l=this.l+l&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+n&4294967295}}e.StringSHA1=b,b.g=new DataView(new ArrayBuffer(320))}),define(ee[98],te([0,1,26]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(t||(t={})),function(C){const R="error",A="warning",k="warn",p="info",m="ignore";function y(E){return E?I.equalsIgnoreCase(R,E)?C.Error:I.equalsIgnoreCase(A,E)||I.equalsIgnoreCase(k,E)?C.Warning:I.equalsIgnoreCase(p,E)?C.Info:C.Ignore:C.Ignore}C.fromValue=y;function P(E){switch(E){case C.Error:return R;case C.Warning:return A;case C.Info:return p;default:return m}}C.toString=P}(t||(t={})),e.default=t}),define(ee[60],te([0,1,24,26]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const w=f.charCodeAt(0),d=this.b.charCodeAt(this.c);return w-d}value(){return this.b[this.c]}}e.StringIterator=C;class R{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,t.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class A{constructor(f=!0,w=!0){this.f=f,this.g=w}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let w=f.length-1;w>=0;w--,this.c--){const d=this.b.charCodeAt(w);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,t.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=A;var k;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(k||(k={}));class p{constructor(f,w){this.f=f,this.g=w,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,t.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=p;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(y||(y={}));class P{static forUris(f=()=>!1,w=()=>!1){return new P(new p(f,w))}static forPaths(f=!1){return new P(new A(void 0,!f))}static forStrings(){return new P(new C)}static forConfigKeys(){return new P(new R)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,w){if(w){const d=w.slice(0);(0,I.shuffle)(d);for(const b of d)this.set(b,f)}else{const d=f.slice(0);(0,I.shuffle)(d);for(const b of d)this.set(b[0],b[1])}}set(f,w){const d=this.b.reset(f);let b;this.c||(this.c=new m,this.c.segment=d.value());const u=[];for(b=this.c;;){const g=d.cmp(b.segment);if(g>0)b.left||(b.left=new m,b.left.segment=d.value()),u.push([-1,b]),b=b.left;else if(g<0)b.right||(b.right=new m,b.right.segment=d.value()),u.push([1,b]),b=b.right;else if(d.hasNext())d.next(),b.mid||(b.mid=new m,b.mid.segment=d.value()),u.push([0,b]),b=b.mid;else break}const v=b.value;b.value=w,b.key=f;for(let g=u.length-1;g>=0;g--){const h=u[g][1];h.updateHeight();const l=h.balanceFactor();if(l<-1||l>1){const i=u[g][0],s=u[g+1][0];if(i===1&&s===1)u[g][1]=h.rotateLeft();else if(i===-1&&s===-1)u[g][1]=h.rotateRight();else if(i===1&&s===-1)h.right=u[g+1][1]=u[g+1][1].rotateRight(),u[g][1]=h.rotateLeft();else if(i===-1&&s===1)h.left=u[g+1][1]=u[g+1][1].rotateLeft(),u[g][1]=h.rotateRight();else throw new Error;if(g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}return v}get(f){return this.d(f)?.value}d(f){const w=this.b.reset(f);let d=this.c;for(;d;){const b=w.cmp(d.segment);if(b>0)d=d.left;else if(b<0)d=d.right;else if(w.hasNext())w.next(),d=d.mid;else break}return d}has(f){const w=this.d(f);return!(w?.value===void 0&&w?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,w){const d=this.b.reset(f),b=[];let u=this.c;for(;u;){const v=d.cmp(u.segment);if(v>0)b.push([-1,u]),u=u.left;else if(v<0)b.push([1,u]),u=u.right;else if(d.hasNext())d.next(),b.push([0,u]),u=u.mid;else break}if(!!u){if(w?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const v=this.f(u.right);if(v.key){const{key:g,value:h,segment:l}=v;this.e(v.key,!1),u.key=g,u.value=h,u.segment=l}}else{const v=u.left??u.right;if(b.length>0){const[g,h]=b[b.length-1];switch(g){case-1:h.left=v;break;case 0:h.mid=v;break;case 1:h.right=v;break}}else this.c=v}for(let v=b.length-1;v>=0;v--){const g=b[v][1];g.updateHeight();const h=g.balanceFactor();if(h>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),b[v][1]=g.rotateLeft()):h<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),b[v][1]=g.rotateRight()),v>0)switch(b[v-1][0]){case-1:b[v-1][1].left=b[v][1];break;case 1:b[v-1][1].right=b[v][1];break;case 0:b[v-1][1].mid=b[v][1];break}else this.c=b[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const w=this.b.reset(f);let d=this.c,b;for(;d;){const u=w.cmp(d.segment);if(u>0)d=d.left;else if(u<0)d=d.right;else if(w.hasNext())w.next(),b=d.value||b,d=d.mid;else break}return d&&d.value||b}findSuperstr(f){const w=this.b.reset(f);let d=this.c;for(;d;){const b=w.cmp(d.segment);if(b>0)d=d.left;else if(b<0)d=d.right;else if(w.hasNext())w.next(),d=d.mid;else return d.mid?this.g(d.mid):void 0}}forEach(f){for(const[w,d]of this)f(d,w)}*[Symbol.iterator](){yield*this.g(this.c)}g(f){const w=[];return this.h(f,w),w[Symbol.iterator]()}h(f,w){!f||(f.left&&this.h(f.left,w),f.value&&w.push([f.key,f.value]),f.mid&&this.h(f.mid,w),f.right&&this.h(f.right,w))}_isBalanced(){const f=w=>{if(!w)return!0;const d=w.balanceFactor();return d<-1||d>1?!1:f(w.left)&&f(w.right)};return f(this.c)}}e.TernarySearchTree=P}),define(ee[7],te([0,1,9,4]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function k(n,a){if(!n.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!C.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(n,a){return!n&&!a?"file":n}function m(n,a){switch(n){case"https":case"http":case"file":a?a[0]!==P&&(a=P+a):a=P;break}return a}const y="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(a){return a instanceof f?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,r,c,o,S,M=!1){typeof a=="object"?(this.scheme=a.scheme||y,this.authority=a.authority||y,this.path=a.path||y,this.query=a.query||y,this.fragment=a.fragment||y):(this.scheme=p(a,M),this.authority=r||y,this.path=m(this.scheme,c||y),this.query=o||y,this.fragment=S||y,k(this,M))}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:r,authority:c,path:o,query:S,fragment:M}=a;return r===void 0?r=this.scheme:r===null&&(r=y),c===void 0?c=this.authority:c===null&&(c=y),o===void 0?o=this.path:o===null&&(o=y),S===void 0?S=this.query:S===null&&(S=y),M===void 0?M=this.fragment:M===null&&(M=y),r===this.scheme&&c===this.authority&&o===this.path&&S===this.query&&M===this.fragment?this:new d(r,c,o,S,M)}static parse(a,r=!1){const c=E.exec(a);return c?new d(c[2]||y,s(c[4]||y),s(c[5]||y),s(c[7]||y),s(c[9]||y),r):new d(y,y,y,y,y)}static file(a){let r=y;if(t.isWindows&&(a=a.replace(/\\/g,P)),a[0]===P&&a[1]===P){const c=a.indexOf(P,2);c===-1?(r=a.substring(2),a=P):(r=a.substring(2,c),a=a.substring(c)||P)}return new d("file",r,a,y,y)}static from(a){const r=new d(a.scheme,a.authority,a.path,a.query,a.fragment);return k(r,!0),r}static joinPath(a,...r){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&a.scheme==="file"?c=f.file(I.win32.join(g(a,!0),...r)).path:c=I.posix.join(a.path,...r),a.with({path:c})}toString(a=!1){return h(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof f)return a;{const r=new d(a);return r._formatted=a.external,r._fsPath=a._sep===w?a.fsPath:null,r}}else return a}}e.URI=f;const w=t.isWindows?1:void 0;class d extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=w),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(n,a){let r,c=-1;for(let o=0;o<n.length;o++){const S=n.charCodeAt(o);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||a&&S===47)c!==-1&&(r+=encodeURIComponent(n.substring(c,o)),c=-1),r!==void 0&&(r+=n.charAt(o));else{r===void 0&&(r=n.substr(0,o));const M=b[S];M!==void 0?(c!==-1&&(r+=encodeURIComponent(n.substring(c,o)),c=-1),r+=M):c===-1&&(c=o)}}return c!==-1&&(r+=encodeURIComponent(n.substring(c))),r!==void 0?r:n}function v(n){let a;for(let r=0;r<n.length;r++){const c=n.charCodeAt(r);c===35||c===63?(a===void 0&&(a=n.substr(0,r)),a+=b[c]):a!==void 0&&(a+=n[r])}return a!==void 0?a:n}function g(n,a){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?a?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=g;function h(n,a){const r=a?v:u;let c="",{scheme:o,authority:S,path:M,query:L,fragment:B}=n;if(o&&(c+=o,c+=":"),(S||o==="file")&&(c+=P,c+=P),S){let J=S.indexOf("@");if(J!==-1){const ae=S.substr(0,J);S=S.substr(J+1),J=ae.indexOf(":"),J===-1?c+=r(ae,!1):(c+=r(ae.substr(0,J),!1),c+=":",c+=r(ae.substr(J+1),!1)),c+="@"}S=S.toLowerCase(),J=S.indexOf(":"),J===-1?c+=r(S,!1):(c+=r(S.substr(0,J),!1),c+=S.substr(J))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const J=M.charCodeAt(1);J>=65&&J<=90&&(M=`/${String.fromCharCode(J+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const J=M.charCodeAt(0);J>=65&&J<=90&&(M=`${String.fromCharCode(J+32)}:${M.substr(2)}`)}c+=r(M,!0)}return L&&(c+="?",c+=r(L,!1)),B&&(c+="#",c+=a?B:u(B,!1)),c}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(i)?n.replace(i,a=>l(a)):n}}),define(ee[139],te([0,1,7]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const y=m;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=t;function C(m){const y=[];let P;try{const E=JSON.parse(m.arguments),f=E[E.length-1];f&&f.__$stack&&(E.pop(),P=f.__$stack),y.push(...E)}catch{y.push("Unable to log remote console arguments",m.arguments)}return{args:y,stack:P}}e.parse=C;function R(m){if(typeof m!="string")return R(C(m).stack);const y=m;if(y){const P=A(y),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(E&&E.length===4)return{uri:I.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=R;function A(m){if(!m)return m;const y=m.indexOf(`
`);return y===-1?m:m.substring(0,y)}function k(m,y){const{args:P,stack:E}=C(m),f=typeof P[0]=="string"&&P.length===1;let w=A(E);w&&(w=`(${w.trim()})`);let d=[];if(typeof P[0]=="string"?w&&f?d=[`%c[${y}] %c${P[0]} %c${w}`,p("blue"),p(""),p("grey")]:d=[`%c[${y}] %c${P[0]}`,p("blue"),p(""),...P.slice(1)]:d=[`%c[${y}]%`,p("blue"),...P],w&&!f&&d.push(w),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,d)}e.log=k;function p(m){return`color: ${m}`}}),define(ee[69],te([0,1,17,26,7]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,k)}e.stringify=R;function A(m){let y=JSON.parse(m);return y=p(y),y}e.parse=A;function k(m,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,t.regExpFlags)(y)}:y}function p(m,y=0){if(!m||y>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return C.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof I.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let P=0;P<m.length;++P)m[P]=p(m[P],y+1);else for(const P in m)Object.hasOwnProperty.call(m,P)&&(m[P]=p(m[P],y+1))}return m}e.revive=p}),define(ee[15],te([0,1,4,7]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebook="vscode-notebook",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractive="vscode-interactive",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${C.vscodeRemoteResource}`}set(m,y,P){this.a[m]=y,this.b[m]=P}setConnectionToken(m,y){this.c[m]=y}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)return this.e(m);const y=m.authority;let P=this.a[y];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const E=this.b[y],f=this.c[y];let w=`path=${encodeURIComponent(m.path)}`;return typeof f=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),t.URI.from({scheme:I.isWeb?this.d:C.vscodeRemoteResource,authority:`${P}:${E}`,path:this.f,query:w})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(m){const y=this.b(m,H);return this.uriToBrowserUri(y)}uriToBrowserUri(m){return m.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(m):m.scheme===C.file&&(I.isNative||I.isWebWorker&&I.globals.origin===`${C.vscodeFileResource}://${A.a}`)?m.with({scheme:C.vscodeFileResource,authority:m.authority||A.a,query:null,fragment:null}):m}asFileUri(m){const y=this.b(m,H);return this.uriToFileUri(y)}uriToFileUri(m){return m.scheme===C.vscodeFileResource?m.with({scheme:C.file,authority:m.authority!==A.a?m.authority:null,query:null,fragment:null}):m}b(m,y){return t.URI.isUri(m)?m:t.URI.parse(y.toUrl(m))}}A.a="vscode-app",e.FileAccess=new A;var k;(function(p){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(m.get("3"));const y="vscode-coi";function P(f){let w;typeof f=="string"?w=new URL(f).searchParams:f instanceof URL?w=f.searchParams:t.URI.isUri(f)&&(w=new URL(f.toString(!0)).searchParams);const d=w?.get(y);if(!!d)return m.get(d)}p.getHeadersFromQuery=P;function E(f,w,d){if(!globalThis.crossOriginIsolated)return;const b=w&&d?"3":d?"2":"1";f instanceof URLSearchParams?f.set(y,b):f[y]=b}p.addSearchParam=E})(k=e.COI||(e.COI={}))}),define(ee[20],te([0,1,30,15,9,4,26,7]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(f){return(0,k.uriToFsPath)(f,!0)}e.originalFSPath=p;class m{constructor(w){this.a=w}compare(w,d,b=!1){return w===d?0:(0,A.compare)(this.getComparisonKey(w,b),this.getComparisonKey(d,b))}isEqual(w,d,b=!1){return w===d?!0:!w||!d?!1:this.getComparisonKey(w,b)===this.getComparisonKey(d,b)}getComparisonKey(w,d=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,d,b=!1){if(w.scheme===d.scheme){if(w.scheme===t.Schemas.file)return I.isEqualOrParent(p(w),p(d),this.a(w))&&w.query===d.query&&(b||w.fragment===d.fragment);if((0,e.isEqualAuthority)(w.authority,d.authority))return I.isEqualOrParent(w.path,d.path,this.a(w),"/")&&w.query===d.query&&(b||w.fragment===d.fragment)}return!1}joinPath(w,...d){return k.URI.joinPath(w,...d)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return C.posix.basename(w.path)}extname(w){return C.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let d;return w.scheme===t.Schemas.file?d=k.URI.file(C.dirname(p(w))).path:(d=C.posix.dirname(w.path),w.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),d="/")),w.with({path:d})}normalizePath(w){if(!w.path.length)return w;let d;return w.scheme===t.Schemas.file?d=k.URI.file(C.normalize(p(w))).path:d=C.posix.normalize(w.path),w.with({path:d})}relativePath(w,d){if(w.scheme!==d.scheme||!(0,e.isEqualAuthority)(w.authority,d.authority))return;if(w.scheme===t.Schemas.file){const v=C.relative(p(w),p(d));return R.isWindows?I.toSlashes(v):v}let b=w.path||"/";const u=d.path||"/";if(this.a(w)){let v=0;for(const g=Math.min(b.length,u.length);v<g&&!(b.charCodeAt(v)!==u.charCodeAt(v)&&b.charAt(v).toLowerCase()!==u.charAt(v).toLowerCase());v++);b=u.substr(0,v)+b.substr(v)}return C.posix.relative(b,u)}resolvePath(w,d){if(w.scheme===t.Schemas.file){const b=k.URI.file(C.resolve(p(w),d));return w.with({authority:b.authority,path:b.path})}return d=I.toPosixPath(d),w.with({path:C.posix.resolve(w.path,d)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,d){return w===d||w!==void 0&&d!==void 0&&(0,A.equalsIgnoreCase)(w,d)}hasTrailingPathSeparator(w,d=C.sep){if(w.scheme===t.Schemas.file){const b=p(w);return b.length>I.getRoot(b).length&&b[b.length-1]===d}else{const b=w.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,d=C.sep){return(0,e.hasTrailingPathSeparator)(w,d)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,d=C.sep){let b=!1;if(w.scheme===t.Schemas.file){const u=p(w);b=u!==void 0&&u.length===I.getRoot(u).length&&u[u.length-1]===d}else{d="/";const u=w.path;b=u.length===1&&u.charCodeAt(u.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(w,d)?w.with({path:w.path+"/"}):w}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(f=>f.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(f,w){const d=[];for(let b=0;b<f.length;b++){const u=w(f[b]);f.some((v,g)=>g===b?!1:(0,e.isEqualOrParent)(u,w(v)))||d.push(f[b])}return d}e.distinctParents=y;var P;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function w(d){const b=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(g=>{const[h,l]=g.split(":");h&&l&&b.set(h,l)});const v=d.path.substring(0,d.path.indexOf(";"));return v&&b.set(f.META_DATA_MIME,v),b}f.parseMetaData=w})(P=e.DataUri||(e.DataUri={}));function E(f,w,d){if(w){let b=f.path;return b&&b[0]!==C.posix.sep&&(b=C.posix.sep+b),f.with({scheme:d,authority:w,path:b})}return f.with({scheme:d})}e.toLocalResource=E}),define(ee[8],te([0,1,22,14,3,2,20,4]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p($){return!!$&&typeof $.then=="function"}e.isThenable=p;function m($){const D=new I.CancellationTokenSource,O=$(D.token),W=new Promise((U,q)=>{const Q=D.token.onCancellationRequested(()=>{Q.dispose(),D.dispose(),q(new t.CancellationError)});Promise.resolve(O).then(j=>{Q.dispose(),D.dispose(),U(j)},j=>{Q.dispose(),D.dispose(),q(j)})});return new class{cancel(){D.cancel()}then(U,q){return W.then(U,q)}catch(U){return this.then(void 0,U)}finally(U){return W.finally(U)}}}e.createCancelablePromise=m;function y($,D,O){return new Promise((W,U)=>{const q=D.onCancellationRequested(()=>{q.dispose(),W(O)});$.then(W,U).finally(()=>q.dispose())})}e.raceCancellation=y;function P($,D){return new Promise((O,W)=>{const U=D.onCancellationRequested(()=>{U.dispose(),W(new t.CancellationError)});$.then(O,W).finally(()=>U.dispose())})}e.raceCancellationError=P;async function E($){let D=-1;const O=$.map((U,q)=>U.then(Q=>(D=q,Q))),W=await Promise.race(O);return $.forEach((U,q)=>{q!==D&&U.cancel()}),W}e.raceCancellablePromises=E;function f($,D,O){let W;const U=setTimeout(()=>{W?.(void 0),O?.()},D);return Promise.race([$.finally(()=>clearTimeout(U)),new Promise(q=>W=q)])}e.raceTimeout=f;function w($){return new Promise((D,O)=>{const W=$();p(W)?W.then(D,O):D(W)})}e.asPromise=w;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(D){if(this.a){if(this.d=D,!this.b){const O=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(O,O).then(W)})}return new Promise((O,W)=>{this.b.then(O,W)})}return this.a=D(),new Promise((O,W)=>{this.a.then(U=>{this.a=null,O(U)},U=>{this.a=null,W(U)})})}}e.Throttler=d;class b{constructor(){this.a=Promise.resolve(null)}queue(D){return this.a=this.a.then(()=>D(),()=>D())}}e.Sequencer=b;class u{constructor(){this.a=new Map}queue(D,O){const U=(this.a.get(D)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(D)===U&&this.a.delete(D)});return this.a.set(D,U),U}}e.SequencerByKey=u;const v=($,D)=>{let O=!0;const W=setTimeout(()=>{O=!1,D()},$);return{isTriggered:()=>O,dispose:()=>{clearTimeout(W),O=!1}}},g=$=>{let D=!0;return queueMicrotask(()=>{D&&(D=!1,$())}),{isTriggered:()=>D,dispose:()=>{D=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(D){this.defaultDelay=D,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(D,O=this.defaultDelay){this.g=D,this.h(),this.b||(this.b=new Promise((U,q)=>{this.d=U,this.f=q}).then(()=>{if(this.b=null,this.d=null,this.g){const U=this.g;return this.g=null,U()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=O===e.MicrotaskDelay?g(W):v(O,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=h;class l{constructor(D){this.a=new h(D),this.b=new d}trigger(D,O){return this.a.trigger(()=>this.b.queue(D),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=l;class i{constructor(){this.a=!1,this.b=new Promise((D,O)=>{this.d=D})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class s extends i{constructor(D){super(),this.f=setTimeout(()=>this.open(),D)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function n($,D){return D?new Promise((O,W)=>{const U=setTimeout(()=>{q.dispose(),O()},$),q=D.onCancellationRequested(()=>{clearTimeout(U),q.dispose(),W(new t.CancellationError)})}):m(O=>n($,O))}e.timeout=n;function a($,D=0){const O=setTimeout($,D);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=a;function r($){const D=[];let O=0;const W=$.length;function U(){return O<W?$[O++]():null}function q(Q){Q!=null&&D.push(Q);const j=U();return j?j.then(q):Promise.resolve(D)}return Promise.resolve(null).then(q)}e.sequence=r;function c($,D=W=>!!W,O=null){let W=0;const U=$.length,q=()=>{if(W>=U)return Promise.resolve(O);const Q=$[W++];return Promise.resolve(Q()).then(Z=>D(Z)?Promise.resolve(Z):q())};return q()}e.first=c;function o($,D=W=>!!W,O=null){if($.length===0)return Promise.resolve(O);let W=$.length;const U=()=>{W=-1;for(const q of $)q.cancel?.()};return new Promise((q,Q)=>{for(const j of $)j.then(Z=>{--W>=0&&D(Z)?(U(),q(Z)):W===0&&q(O)}).catch(Z=>{--W>=0&&(U(),Q(Z))})})}e.firstParallel=o;class S{constructor(D){this.a=0,this.d=D,this.f=[],this.b=0,this.g=new C.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(D){return this.a++,new Promise((O,W)=>{this.f.push({factory:D,c:O,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const D=this.f.shift();this.b++;const O=D.factory();O.then(D.c,D.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=S;class M extends S{constructor(){super(1)}}e.Queue=M;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const D=new F;return this.b.add(D),D.p}d(){for(const[,D]of this.a)if(D.size>0)return!1;return!0}queueFor(D,O=A.extUri){const W=O.getComparisonKey(D);let U=this.a.get(W);return U||(U=new M,C.Event.once(U.onDrained)(()=>{U?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,U)),U}f(){!this.d()||this.g()}g(){for(const D of this.b)D.complete();this.b.clear()}dispose(){for(const[,D]of this.a)D.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class B{constructor(D,O){this.a=-1,typeof D=="function"&&typeof O=="number"&&this.setIfNotSet(D,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(D,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,D()},O)}setIfNotSet(D,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,D()},O))}}e.TimeoutTimer=B;class J{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(D,O){this.cancel(),this.a=setInterval(()=>{D()},O)}}e.IntervalTimer=J;class ae{constructor(D,O){this.b=-1,this.a=D,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(D=this.d){this.cancel(),this.b=setTimeout(this.f,D)}get delay(){return this.d}set delay(D){this.d=D}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=ae;class X{constructor(D,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=D,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(D=this.b){D%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${D}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(D/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=X;class Y extends ae{constructor(D,O){super(D,O),this.j=[]}work(D){this.j.push(D),this.isScheduled()||this.schedule()}h(){const D=this.j;this.j=[],this.a?.(D)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=Y;class re extends R.Disposable{constructor(D,O){super(),this.g=D,this.h=O,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(D){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+D.length>this.g.maxBufferedWork)return!1}else if(this.pending+D.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...D),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ae(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,k.setTimeout0)(()=>{if(D)return;const O=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let D=!1;return{dispose(){D||(D=!0)}}}:e.runWhenIdle=($,D)=>{const O=requestIdleCallback($,typeof D=="number"?{timeout:D}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(O))}}}}();class ne{constructor(D){this.d=!1,this.a=()=>{try{this.f=D()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ne;async function de($,D,O){let W;for(let U=0;U<O;U++)try{return await $()}catch(q){W=q,await n(D)}throw W}e.retry=de;class K{hasPending(D){return this.a?typeof D=="number"?this.a.taskId===D:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(D,O,W){return this.a={taskId:D,cancel:()=>W?.(),promise:O},O.then(()=>this.d(D),()=>this.d(D)),O}d(D){this.a&&D===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const D=this.b;this.b=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this.b)this.b.run=D;else{let O,W;const U=new Promise((q,Q)=>{O=q,W=Q});this.b={run:D,promise:U,promiseResolve:O,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=K;class le{constructor(D,O=()=>Date.now()){this.d=D,this.f=O,this.a=0,this.b=0}increment(){const D=this.f();return D-this.a>this.d&&(this.a=D,this.b=0),this.b++,this.b}}e.IntervalCounter=le;class F{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((D,O)=>{this.a=D,this.b=O})}complete(D){return new Promise(O=>{this.a(D),this.f=!0,O()})}error(D){return new Promise(O=>{this.b(D),this.d=!0,O()})}cancel(){new Promise(D=>{this.b(new t.CancellationError),this.d=!0,D()})}}e.DeferredPromise=F;var T;(function($){async function D(W){let U;const q=await Promise.all(W.map(Q=>Q.then(j=>j,j=>{U||(U=j)})));if(typeof U<"u")throw U;return q}$.settled=D;function O(W){return new Promise(async(U,q)=>{try{await W(U,q)}catch(Q){q(Q)}})}$.withAsyncBody=O})(T=e.Promises||(e.Promises={}));var N;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(N||(N={}));class V{static fromArray(D){return new V(O=>{O.emitMany(D)})}static fromPromise(D){return new V(async O=>{O.emitMany(await D)})}static fromPromises(D){return new V(async O=>{await Promise.all(D.map(async W=>O.emitOne(await W)))})}static merge(D){return new V(async O=>{await Promise.all(D.map(async W=>{for await(const U of W)O.emitOne(U)}))})}constructor(D){this.a=0,this.b=[],this.d=null,this.f=new C.Emitter,queueMicrotask(async()=>{const O={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(D(O)),this.j()}catch(W){this.k(W)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let D=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(D<this.b.length)return{done:!1,value:this.b[D++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(D,O){return new V(async W=>{for await(const U of D)W.emitOne(O(U))})}map(D){return V.map(this,D)}static filter(D,O){return new V(async W=>{for await(const U of D)O(U)&&W.emitOne(U)})}filter(D){return V.filter(this,D)}static coalesce(D){return V.filter(D,O=>!!O)}coalesce(){return V.coalesce(this)}static async toPromise(D){const O=[];for await(const W of D)O.push(W);return O}toPromise(){return V.toPromise(this)}g(D){this.a===0&&(this.b.push(D),this.f.fire())}h(D){this.a===0&&(this.b=this.b.concat(D),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(D){this.a===0&&(this.a=2,this.d=D,this.f.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class se extends V{constructor(D,O){super(O),this.l=D}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=se;function z($){const D=new I.CancellationTokenSource,O=$(D.token);return new se(D,async W=>{const U=D.token.onCancellationRequested(()=>{U.dispose(),D.dispose(),W.reject(new t.CancellationError)});try{for await(const q of O){if(D.token.isCancellationRequested)return;W.emitOne(q)}U.dispose(),D.dispose()}catch(q){U.dispose(),D.dispose(),W.reject(q)}})}e.createCancelableAsyncIterable=z}),define(ee[99],te([0,1,24,8,30,39,9,4,26]),function(H,e,I,t,C,R,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",P="[^/\\\\]",E=/\//g;function f(F,T){switch(F){case 0:return"";case 1:return`${P}*?`;default:return`(?:${y}|${P}+${y}${T?`|${y}${P}+`:""})*?`}}function w(F,T){if(!F)return[];const N=[];let V=!1,se=!1,z="";for(const $ of F){switch($){case T:if(!V&&!se){N.push(z),z="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":se=!0;break;case"]":se=!1;break}z+=$}return z&&N.push(z),N}e.splitGlobAware=w;function d(F){if(!F)return"";let T="";const N=w(F,e.GLOB_SPLIT);if(N.every(V=>V===e.GLOBSTAR))T=".*";else{let V=!1;N.forEach((se,z)=>{if(se===e.GLOBSTAR){if(V)return;T+=f(2,z===N.length-1)}else{let $=!1,D="",O=!1,W="";for(const U of se){if(U!=="}"&&$){D+=U;continue}if(O&&(U!=="]"||!W)){let q;U==="-"?q=U:(U==="^"||U==="!")&&!W?q="^":U===e.GLOB_SPLIT?q="":q=(0,p.escapeRegExpCharacters)(U),W+=q;continue}switch(U){case"{":$=!0;continue;case"[":O=!0;continue;case"}":{T+=`(?:${w(D,",").map(j=>d(j)).join("|")})`,$=!1,D="";break}case"]":{T+="["+W+"]",O=!1,W="";break}case"?":T+=P;continue;case"*":T+=f(1);continue;default:T+=(0,p.escapeRegExpCharacters)(U)}}z<N.length-1&&(N[z+1]!==e.GLOBSTAR||z+2<N.length)&&(T+=y)}V=se===e.GLOBSTAR})}return T}const b=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),s=function(){return!1},n=function(){return null};function a(F,T){if(!F)return n;let N;typeof F!="string"?N=F.pattern:N=F,N=N.trim();const V=`${N}_${!!T.trimForExclusions}`;let se=i.get(V);if(se)return r(se,F);let z;return b.test(N)?se=o(N.substr(4),N):(z=u.exec(c(N,T)))?se=S(z[1],N):(T.trimForExclusions?g:v).test(N)?se=M(N,T):(z=h.exec(c(N,T)))?se=L(z[1].substr(1),N,!0):(z=l.exec(c(N,T)))?se=L(z[1],N,!1):se=B(N),i.set(V,se),r(se,F)}function r(F,T){if(typeof T=="string")return F;const N=function(V,se){return(0,C.isEqualOrParent)(V,T.base,!k.isLinux)?F((0,p.ltrim)(V.substr(T.base.length),A.sep),se):null};return N.allBasenames=F.allBasenames,N.allPaths=F.allPaths,N.basenames=F.basenames,N.patterns=F.patterns,N}function c(F,T){return T.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function o(F,T){return function(N,V){return typeof N=="string"&&N.endsWith(F)?T:null}}function S(F,T){const N=`/${F}`,V=`\\${F}`,se=function($,D){return typeof $!="string"?null:D?D===F?T:null:$===F||$.endsWith(N)||$.endsWith(V)?T:null},z=[F];return se.basenames=z,se.patterns=[T],se.allBasenames=z,se}function M(F,T){const N=K(F.slice(1,-1).split(",").map(D=>a(D,T)).filter(D=>D!==n),F),V=N.length;if(!V)return n;if(V===1)return N[0];const se=function(D,O){for(let W=0,U=N.length;W<U;W++)if(N[W](D,O))return F;return null},z=N.find(D=>!!D.allBasenames);z&&(se.allBasenames=z.allBasenames);const $=N.reduce((D,O)=>O.allPaths?D.concat(O.allPaths):D,[]);return $.length&&(se.allPaths=$),se}function L(F,T,N){const V=A.sep===A.posix.sep,se=V?F:F.replace(E,A.sep),z=A.sep+se,$=A.posix.sep+F;let D;return N?D=function(O,W){return typeof O=="string"&&(O===se||O.endsWith(z)||!V&&(O===F||O.endsWith($)))?T:null}:D=function(O,W){return typeof O=="string"&&(O===se||!V&&O===F)?T:null},D.allPaths=[(N?"*/":"./")+F],D}function B(F){try{const T=new RegExp(`^${d(F)}$`);return function(N){return T.lastIndex=0,typeof N=="string"&&T.test(N)?F:null}}catch{return n}}function J(F,T,N){return!F||typeof T!="string"?!1:ae(F)(T,void 0,N)}e.match=J;function ae(F,T={}){if(!F)return s;if(typeof F=="string"||X(F)){const N=a(F,T);if(N===n)return s;const V=function(se,z){return!!N(se,z)};return N.allBasenames&&(V.allBasenames=N.allBasenames),N.allPaths&&(V.allPaths=N.allPaths),V}return ne(F,T)}e.parse=ae;function X(F){const T=F;return T?typeof T.base=="string"&&typeof T.pattern=="string":!1}e.isRelativePattern=X;function Y(F){return F.allBasenames||[]}e.getBasenameTerms=Y;function re(F){return F.allPaths||[]}e.getPathTerms=re;function ne(F,T){const N=K(Object.getOwnPropertyNames(F).map(D=>de(D,F[D],T)).filter(D=>D!==n)),V=N.length;if(!V)return n;if(!N.some(D=>!!D.requiresSiblings)){if(V===1)return N[0];const D=function(U,q){let Q;for(let j=0,Z=N.length;j<Z;j++){const x=N[j](U,q);if(typeof x=="string")return x;(0,t.isThenable)(x)&&(Q||(Q=[]),Q.push(x))}return Q?(async()=>{for(const j of Q){const Z=await j;if(typeof Z=="string")return Z}return null})():null},O=N.find(U=>!!U.allBasenames);O&&(D.allBasenames=O.allBasenames);const W=N.reduce((U,q)=>q.allPaths?U.concat(q.allPaths):U,[]);return W.length&&(D.allPaths=W),D}const se=function(D,O,W){let U,q;for(let Q=0,j=N.length;Q<j;Q++){const Z=N[Q];Z.requiresSiblings&&W&&(O||(O=(0,A.basename)(D)),U||(U=O.substr(0,O.length-(0,A.extname)(D).length)));const x=Z(D,O,U,W);if(typeof x=="string")return x;(0,t.isThenable)(x)&&(q||(q=[]),q.push(x))}return q?(async()=>{for(const Q of q){const j=await Q;if(typeof j=="string")return j}return null})():null},z=N.find(D=>!!D.allBasenames);z&&(se.allBasenames=z.allBasenames);const $=N.reduce((D,O)=>O.allPaths?D.concat(O.allPaths):D,[]);return $.length&&(se.allPaths=$),se}function de(F,T,N){if(T===!1)return n;const V=a(F,N);if(V===n)return n;if(typeof T=="boolean")return V;if(T){const se=T.when;if(typeof se=="string"){const z=($,D,O,W)=>{if(!W||!V($,D))return null;const U=se.replace("$(basename)",O),q=W(U);return(0,t.isThenable)(q)?q.then(Q=>Q?F:null):q?F:null};return z.requiresSiblings=!0,z}}return V}function K(F,T){const N=F.filter(D=>!!D.basenames);if(N.length<2)return F;const V=N.reduce((D,O)=>{const W=O.basenames;return W?D.concat(W):D},[]);let se;if(T){se=[];for(let D=0,O=V.length;D<O;D++)se.push(T)}else se=N.reduce((D,O)=>{const W=O.patterns;return W?D.concat(W):D},[]);const z=function(D,O){if(typeof D!="string")return null;if(!O){let U;for(U=D.length;U>0;U--){const q=D.charCodeAt(U-1);if(q===47||q===92)break}O=D.substr(U)}const W=V.indexOf(O);return W!==-1?se[W]:null};z.basenames=V,z.patterns=se,z.allBasenames=V;const $=F.filter(D=>!D.basenames);return $.push(z),$}function le(F,T){return(0,I.equals)(F,T,(N,V)=>typeof N=="string"&&typeof V=="string"?N===V:typeof N!="string"&&typeof V!="string"?N.base===V.base&&N.pattern===V.pattern:!1)}e.patternsEquals=le}),define(ee[34],te([0,1,24,30,9,4,20,26]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(n,a){const{os:r,tildify:c,relative:o}=a;if(o){const L=m(n,o,r);if(typeof L=="string")return L}let S=n.fsPath;if(r===1&&!R.isWindows?S=S.replace(/\//g,"\\"):r!==1&&R.isWindows&&(S=S.replace(/\\/g,"/")),r!==1&&c?.userHome){const L=c.userHome.fsPath;let B;n.scheme!==c.userHome.scheme&&n.path.startsWith(C.posix.sep)?B=c.userHome.with({path:n.path}).fsPath:B=n.fsPath,S=E(B,L,r)}return(r===1?C.win32:C.posix).normalize(y(S,r===1))}e.getPathLabel=p;function m(n,a,r){const c=r===1?C.win32:C.posix,o=r===3?A.extUri:A.extUriIgnorePathCase,S=a.getWorkspace(),M=(0,I.firstOrDefault)(S.folders);if(!M)return;n.scheme!==M.uri.scheme&&n.path.startsWith(C.posix.sep)&&(n=M.uri.with({path:n.path}));const L=a.getWorkspaceFolder(n);if(!L)return;let B;if(o.isEqual(L.uri,n)?B="":B=o.relativePath(L.uri,n)??"",B&&(B=c.normalize(B)),S.folders.length>1&&!a.noPrefix){const J=L.name?L.name:o.basenameOrAuthority(L.uri);B=B?`${J} \u2022 ${B}`:J}return B}function y(n,a=R.isWindows){return(0,t.hasDriveLetter)(n,a)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=y;let P=Object.create(null);function E(n,a,r=R.OS){if(r===1||!n||!a)return n;let c=P.original===a?P.normalized:void 0;c||(c=a,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,k.rtrim)(c,C.posix.sep)}${C.posix.sep}`,P={original:a,normalized:c});let o=n;return R.isWindows&&(o=(0,t.toSlashes)(o)),(r===3?o.startsWith(c):(0,k.startsWithIgnoreCase)(o,c))?`~/${o.substr(c.length)}`:n}e.tildify=E;function f(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=f;const w="\u2026",d="\\\\",b="~";function u(n,a=C.sep){const r=new Array(n.length);let c=!1;for(let o=0;o<n.length;o++){const S=n[o];if(S===""){r[o]=`.${a}`;continue}if(!S){r[o]=S;continue}c=!0;let M="",L=S;L.indexOf(d)===0?(M=L.substr(0,L.indexOf(d)+d.length),L=L.substr(L.indexOf(d)+d.length)):L.indexOf(a)===0?(M=L.substr(0,L.indexOf(a)+a.length),L=L.substr(L.indexOf(a)+a.length)):L.indexOf(b)===0&&(M=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length));const B=L.split(a);for(let J=1;c&&J<=B.length;J++)for(let ae=B.length-J;c&&ae>=0;ae--){c=!1;let X=B.slice(ae,ae+J).join(a);for(let Y=0;!c&&Y<n.length;Y++)if(Y!==o&&n[Y]&&n[Y].indexOf(X)>-1){const re=ae+J===B.length,ne=ae>0&&n[Y].indexOf(a)>-1?a+X:X,de=n[Y].endsWith(ne);c=!re||de}if(!c){let Y="";(B[0].endsWith(":")||M!=="")&&(ae===1&&(ae=0,J++,X=B[0]+a+X),ae>0&&(Y=B[0]+a),Y=M+Y),ae>0&&(Y=Y+w+a),Y=Y+X,ae+J<B.length&&(Y=Y+a+w),r[o]=Y}}c&&(r[o]=S)}return r}e.shorten=u;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function g(n,a=Object.create(null)){const r=[];let c=!1,o="";for(const S of n)if(S==="$"||c&&S==="{")o&&r.push({value:o,type:v.TEXT}),o="",c=!0;else if(S==="}"&&c){const M=a[o];if(typeof M=="string")M.length&&r.push({value:M,type:v.VARIABLE});else if(M){const L=r[r.length-1];(!L||L.type!==v.SEPARATOR)&&r.push({value:M.label,type:v.SEPARATOR})}o="",c=!1}else o+=S;return o&&!c&&r.push({value:o,type:v.TEXT}),r.filter((S,M)=>{if(S.type===v.SEPARATOR){const L=r[M-1],B=r[M+1];return[L,B].every(J=>J&&(J.type===v.VARIABLE||J.type===v.TEXT)&&J.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=g;function h(n,a){return R.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function l(n,a){return R.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,r=>r==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(n){const a=n.indexOf("/")!==-1?C.posix:C.win32,r=a.basename(n),c=a.dirname(n);return r.length?{name:r,parentPath:c}:{name:c,parentPath:""}}e.splitName=s}),define(ee[140],te([0,1,7]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(y){return y.toJSON()}class C{constructor(P){this.a=P}transformIncoming(P){const E=this.a.transformIncoming(P);return E===P?P:t(I.URI.from(E))}transformOutgoing(P){const E=this.a.transformOutgoing(P);return E===P?P:t(I.URI.from(E))}transformOutgoingURI(P){const E=this.a.transformOutgoing(P);return E===P?P:I.URI.from(E)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function R(y,P,E){if(!y||E>200)return null;if(typeof y=="object"){if(y instanceof I.URI)return P.transformOutgoing(y);for(const f in y)if(Object.hasOwnProperty.call(y,f)){const w=R(y[f],P,E+1);w!==null&&(y[f]=w)}}return null}function A(y,P){const E=R(y,P,0);return E===null?y:E}e.transformOutgoingURIs=A;function k(y,P,E,f){if(!y||f>200)return null;if(typeof y=="object"){if(y.$mid===1)return E?I.URI.revive(P.transformIncoming(y)):P.transformIncoming(y);for(const w in y)if(Object.hasOwnProperty.call(y,w)){const d=k(y[w],P,E,f+1);d!==null&&(y[w]=d)}}return null}function p(y,P){const E=k(y,P,!1,0);return E===null?y:E}e.transformIncomingURIs=p;function m(y,P){const E=k(y,P,!0,0);return E===null?y:E}e.transformAndReviveIncomingURIs=m}),define(ee[81],te([0,1,25,14,60,29,128]),function(H,e,I,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(y){return this.a||(this.a=C.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,P=0;const E=(0,I.networkInterfaces)();for(const f in E){const w=E[f];if(w)for(const{mac:d,internal:b}of w)b||(P+=1,this.c(d.toUpperCase())&&(y+=1))}this.b=P>0?y/P:0}return this.b}};let k;async function p(){return k||(k=(async()=>await m()||R.generateUuid())()),k}e.getMachineId=p;async function m(){try{const y=await new Promise((E,f)=>{H(["crypto"],E,f)}),P=(0,A.getMac)();return y.createHash("sha256").update(P,"utf8").digest("hex")}catch(y){t.onUnexpectedError(y);return}}}),define(ee[23],te([0,1,40,25,141,8,30,76,9,4,20,7]),function(H,e,I,t,C,R,A,k,p,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function f(ne,de=E.UNLINK){if((0,A.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");return de===E.UNLINK?d(ne):w(ne)}async function w(ne){try{const de=(0,A.randomPath)((0,t.tmpdir)());try{await I.promises.rename(ne,de)}catch(K){return K.code==="ENOENT"?void 0:d(ne)}d(de).catch(K=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function d(ne){return(0,C.promisify)(I.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function b(ne){if((0,A.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function u(ne,de){return h(await(de?v(ne):(0,C.promisify)(I.readdir)(ne)))}async function v(ne){try{return await(0,C.promisify)(I.readdir)(ne,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const de=[],K=await u(ne);for(const le of K){let F=!1,T=!1,N=!1;try{const V=await e.Promises.lstat((0,p.join)(ne,le));F=V.isFile(),T=V.isDirectory(),N=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}de.push({name:le,isFile:()=>F,isDirectory:()=>T,isSymbolicLink:()=>N})}return de}function g(ne){return h(I.readdirSync(ne))}e.readdirSync=g;function h(ne){return ne.map(de=>typeof de=="string"?m.isMacintosh?(0,k.normalizeNFC)(de):de:(de.name=m.isMacintosh?(0,k.normalizeNFC)(de.name):de.name,de))}async function l(ne){const de=await u(ne),K=[];for(const le of de)await s.existsDirectory((0,p.join)(ne,le))&&K.push(le);return K}function i(ne,de=1e3){return new Promise(K=>{let le=!1;const F=setInterval(()=>{le||(le=!0,I.access(ne,T=>{le=!1,T&&(clearInterval(F),K(void 0))}))},de)})}e.whenDeleted=i;var s;(function(ne){async function de(F){let T;try{if(T=await e.Promises.lstat(F),!T.isSymbolicLink())return{stat:T}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:T?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(m.isWindows&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw V}throw N}}ne.stat=de;async function K(F){try{const{stat:T,symbolicLink:N}=await ne.stat(F);return T.isFile()&&N?.dangling!==!0}catch{}return!1}ne.existsFile=K;async function le(F){try{const{stat:T,symbolicLink:N}=await ne.stat(F);return T.isDirectory()&&N?.dangling!==!0}catch{}return!1}ne.existsDirectory=le})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function a(ne,de,K){return n.queueFor(P.URI.file(ne),y.extUriBiasedIgnorePathCase).queue(()=>{const le=M(K);return new Promise((F,T)=>o(ne,de,le,N=>N?T(N):F()))})}let r=!0;function c(ne){r=ne}e.configureFlushOnWrite=c;function o(ne,de,K,le){if(!r)return I.writeFile(ne,de,{mode:K.mode,flag:K.flag},le);I.open(ne,K.flag,K.mode,(F,T)=>{if(F)return le(F);I.writeFile(T,de,N=>{if(N)return I.close(T,()=>le(N));I.fdatasync(T,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),c(!1)),I.close(T,se=>le(se))))})})}function S(ne,de,K){const le=M(K);if(!r)return I.writeFileSync(ne,de,{mode:le.mode,flag:le.flag});const F=I.openSync(ne,le.flag,le.mode);try{I.writeFileSync(F,de);try{I.fdatasyncSync(F)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),c(!1)}}finally{I.closeSync(F)}}e.writeFileSync=S;function M(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function L(ne,de){if(ne!==de)try{await e.Promises.rename(ne,de)}catch(K){if(ne.toLowerCase()!==de.toLowerCase()&&K.code==="EXDEV"||ne.endsWith("."))await B(ne,de,{preserveSymlinks:!1}),await f(ne,E.MOVE);else throw K}}async function B(ne,de,K){return ae(ne,de,{root:{source:ne,target:de},options:K,handledSourcePaths:new Set})}const J=511;async function ae(ne,de,K){if(K.handledSourcePaths.has(ne))return;K.handledSourcePaths.add(ne);const{stat:le,symbolicLink:F}=await s.stat(ne);if(F){if(K.options.preserveSymlinks)try{return await re(ne,de,K)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(F.dangling)return}return le.isDirectory()?X(ne,de,le.mode&J,K):Y(ne,de,le.mode&J)}async function X(ne,de,K,le){await e.Promises.mkdir(de,{recursive:!0,mode:K});const F=await u(ne);for(const T of F)await ae((0,p.join)(ne,T),(0,p.join)(de,T),le)}async function Y(ne,de,K){await e.Promises.copyFile(ne,de),await e.Promises.chmod(de,K)}async function re(ne,de,K){let le=await e.Promises.readlink(ne);(0,A.isEqualOrParent)(le,K.root.source,!m.isLinux)&&(le=(0,p.join)(K.root.target,le.substr(K.root.source.length+1))),await e.Promises.symlink(le,de)}e.Promises=new class{get access(){return(0,C.promisify)(I.access)}get stat(){return(0,C.promisify)(I.stat)}get lstat(){return(0,C.promisify)(I.lstat)}get utimes(){return(0,C.promisify)(I.utimes)}get read(){return(ne,de,K,le,F)=>new Promise((T,N)=>{I.read(ne,de,K,le,F,(V,se,z)=>V?N(V):T({bytesRead:se,buffer:z}))})}get readFile(){return(0,C.promisify)(I.readFile)}get write(){return(ne,de,K,le,F)=>new Promise((T,N)=>{I.write(ne,de,K,le,F,(V,se,z)=>V?N(V):T({bytesWritten:se,buffer:z}))})}get appendFile(){return(0,C.promisify)(I.appendFile)}get fdatasync(){return(0,C.promisify)(I.fdatasync)}get truncate(){return(0,C.promisify)(I.truncate)}get rename(){return(0,C.promisify)(I.rename)}get copyFile(){return(0,C.promisify)(I.copyFile)}get open(){return(0,C.promisify)(I.open)}get close(){return(0,C.promisify)(I.close)}get symlink(){return(0,C.promisify)(I.symlink)}get readlink(){return(0,C.promisify)(I.readlink)}get chmod(){return(0,C.promisify)(I.chmod)}get mkdir(){return(0,C.promisify)(I.mkdir)}get unlink(){return(0,C.promisify)(I.unlink)}get rmdir(){return(0,C.promisify)(I.rmdir)}get realpath(){return(0,C.promisify)(I.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return l}get writeFile(){return a}get rm(){return f}get move(){return L}get copy(){return B}}}),define(ee[100],te([0,1,40,9,4,26,23]),function(H,e,I,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(E){if(C.isLinux)return E;const f=(0,t.dirname)(E);if(E===f)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const b=(0,A.readdirSync)(f).filter(u=>u.toLowerCase()===w);if(b.length===1){const u=k(f);if(u)return(0,t.join)(u,b[0])}else if(b.length>1){const u=b.indexOf(w);if(u>=0){const v=k(f);if(v)return(0,t.join)(v,b[u])}}}catch{}return null}e.realcaseSync=k;async function p(E){if(C.isLinux)return E;const f=(0,t.dirname)(E);if(E===f)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const b=(await A.Promises.readdir(f)).filter(u=>u.toLowerCase()===w);if(b.length===1){const u=await p(f);if(u)return(0,t.join)(u,b[0])}else if(b.length>1){const u=b.indexOf(w);if(u>=0){const v=await p(f);if(v)return(0,t.join)(v,b[u])}}}catch{}return null}e.realcase=p;async function m(E){try{return await A.Promises.realpath(E)}catch{const w=P(E);return await A.Promises.access(w,I.constants.R_OK),w}}e.realpath=m;function y(E){try{return I.realpathSync(E)}catch{const w=P(E);return I.accessSync(w,I.constants.R_OK),w}}e.realpathSync=y;function P(E){return(0,R.rtrim)((0,t.normalize)(E),t.sep)}}),define(ee[142],te([0,1,25,9,23]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,A=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var p;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(p||(p={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class P{constructor(l,i,s){this.exePath=l,this.displayName=i,this.a=s}async exists(){return this.a===void 0&&(this.a=await C.SymlinkSupport.existsFile(this.exePath)),this.a}}function E({useAlternateBitness:h=!1}={}){return h?m===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:h=!1,findPreview:l=!1}={}){const i=E({useAlternateBitness:h});if(!i)return null;const s=t.join(i,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(s))return null;let n=-1,a=null;for(const o of await C.Promises.readdir(s)){let S=-1;if(l){const L=o.indexOf("-");if(L<0)continue;const B=o.substring(0,L);if(!R.test(B)||o.substring(L+1)!=="preview")continue;S=parseInt(B,10)}else{if(!R.test(o))continue;S=parseInt(o,10)}if(S<=n)continue;const M=t.join(s,o,"pwsh.exe");!await C.SymlinkSupport.existsFile(M)||(a=M,n=S)}if(!a)return null;const r=i.includes("x86")?" (x86)":"",c=l?" Preview":"";return new P(a,`PowerShell${c}${r}`,!0)}async function w({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=h?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const n of await C.Promises.readdir(l))if(i.test(n)){const a=t.join(l,n,"pwsh.exe");return new P(a,s)}return null}function d(){const h=t.join(I.homedir(),".dotnet","tools","pwsh.exe");return new P(h,".NET Core PowerShell Global Tool")}function b(){const h=t.join(process.env.windir,m===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(h,"Windows PowerShell",!0)}async function*u(){let h=await f();h&&(yield h),h=await f({useAlternateBitness:!0}),h&&(yield h),h=await w(),h&&(yield h),h=d(),h&&(yield h),h=await f({findPreview:!0}),h&&(yield h),h=await w({findPreview:!0}),h&&(yield h),h=await f({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=b(),h&&(yield h)}async function*v(){for await(const h of u())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=v;async function g(){for await(const h of v())return h;return null}e.getFirstAvailablePowerShellInstallation=g}),define(ee[82],te([0,1,9,4,33,79,12,23]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function p(P=C.env){return P.comspec||"cmd.exe"}e.getWindowsShell=p;function m(P){let E=[],f=!1;const w=function(d){if(f){E.push(d);return}(!P.send(d,u=>{if(u&&console.error(u),f=!1,E.length>0){const v=E.slice(0);E=[],v.forEach(g=>w(g))}})||t.isWindows)&&(f=!0)};return{send:w}}e.createQueuedSender=m;var y;(function(P){async function E(f,w,d){if(I.isAbsolute(f))return f;if(w===void 0&&(w=C.cwd()),I.dirname(f)!=="."||(d===void 0&&A.isString(C.env.PATH)&&(d=C.env.PATH.split(I.delimiter)),d===void 0||d.length===0))return I.join(w,f);async function u(v){if(await k.Promises.exists(v)){let g;try{g=await k.Promises.stat(v)}catch(h){h.message.startsWith("EACCES")&&(g=await k.Promises.lstat(v))}return g?!g.isDirectory():!1}return!1}for(const v of d){let g;if(I.isAbsolute(v)?g=I.join(v,f):g=I.join(w,v,f),await u(g))return g;let h=g+".com";if(await u(h)||(h=g+".exe",await u(h)))return h}return I.join(w,f)}P.findExecutable=E})(y=e.win32||(e.win32={}))}),define(ee[101],te([0,1,46,15]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function C(A){return new Promise((k,p)=>{let m;const y=new Map;function P(f,w,d,b,u){const v=y.get(w);if(f===A||v){const g={name:E(d),cmd:d,pid:f,ppid:w,load:b,mem:u};y.set(f,g),f===A&&(m=g),v&&(v.children||(v.children=[]),v.children.push(g),v.children.length>1&&(v.children=v.children.sort((h,l)=>h.pid-l.pid)))}}function E(f){const w=/--vscode-window-kind=shared-process/,d=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,g=/--crashes-directory/,h=/\\pipe\\winpty-control/,l=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(g.exec(f))return"electron-crash-reporter";if(h.exec(f))return"winpty-process";if(l.exec(f))return"console-window-host (Windows internal process)";let s=i.exec(f);if(s&&s.length===2){if(s[1]==="renderer")return w.exec(f)?"shared-process":d.exec(f)?"issue-reporter":b.exec(f)?"process-explorer":"window";if(s[1]==="utility"){if(u.exec(f))return"utility-network-service";if(v.exec(f))return"extension-host"}return s[1]}const n=/[a-zA-Z-]+\.js/g;let a="";do s=n.exec(f),s&&(a+=s+" ");while(s);return a&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${a}`:f}if(process.platform==="win32"){const f=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,d)=>{H(["windows-process-tree"],w,d)}).then(w=>{w.getProcessList(A,d=>{if(!d){p(new Error(`Root process ${A} not found`));return}w.getProcessCpuUsage(d,b=>{const u=new Map;b.forEach(v=>{const g=f(v.commandLine||"");u.set(v.pid,{name:E(g),cmd:g,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),m=u.get(A),m?(u.forEach(v=>{const g=u.get(v.ppid);g&&(g.children||(g.children=[]),g.children.push(v))}),u.forEach(v=>{v.children&&(v.children=v.children.sort((g,h)=>g.pid-h.pid))}),k(m)):p(new Error(`Root process ${A} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{let f=function(){let w=[m];const d=[];for(;w.length;){const u=w.shift();u&&(d.push(u.pid),u.children&&(w=w.concat(u.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+d.join(" "),(0,I.exec)(b,{},(u,v,g)=>{if(u||g)p(u||new Error(g.toString()));else{const h=v.toString().split(`
`);for(let l=0;l<d.length;l++){const i=y.get(d[l]);i.load=parseFloat(h[l])}if(!m){p(new Error(`Root process ${A} not found`));return}k(m)}})};(0,I.exec)("which ps",{},(w,d,b)=>{if(w||b)if(process.platform!=="linux")p(w||new Error(b.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(u,{},(v,g,h)=>{v||h?p(v||new Error(h.toString())):(R(g,P),f())})}else{const u=d.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${u} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,h,l)=>{g||l&&!l.includes("screen size is bogus")?p(g||new Error(l.toString())):(R(h,P),process.platform==="linux"?f():m?k(m):p(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=C;function R(A,k){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=A.toString().split(`
`);for(const y of m){const P=p.exec(y.trim());P&&P.length===6&&k(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(ee[143],te([0,1,25,4,142,82]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(f,w){return f===1?t.isWindows?P():R.getWindowsShell(w):m(f,w)}e.getSystemShell=A;function k(f,w){return f===1?t.isWindows?E(w):R.getWindowsShell(w):m(f,w)}e.getSystemShellSync=k;let p=null;function m(f,w){if(t.isLinux&&f===2||t.isMacintosh&&f===3)return"/bin/bash";if(!p){let d;if(t.isWindows)d="/bin/bash";else{if(d=w.SHELL,!d)try{d=(0,I.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}p=d}return p}let y=null;async function P(){return y||(y=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),y}function E(f){if(y)return y;const w=t.isWindows&&parseFloat((0,I.release)())>=10,d=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${f.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return w?b:R.getWindowsShell(f)}});var pe=this&&this.__decorate||function(H,e,I,t){var C=arguments.length,R=C<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,I):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(H,e,I,t);else for(var k=H.length-1;k>=0;k--)(A=H[k])&&(R=(C<3?A(R):C>3?A(e,I,R):A(e,I))||R);return C>3&&R&&Object.defineProperty(e,I,R),R};define(ee[47],te([0,1,24,8,17,22,53,14,3,2,69,26,12]),function(H,e,I,t,C,R,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var f;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(f||(f={}));function w(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(d||(d={}));function b(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(u||(u={}));class v{constructor(T){this.b=T,this.a=0}read(T){const N=this.b.slice(this.a,this.a+T);return this.a+=N.byteLength,N}}class g{constructor(){this.a=[]}get buffer(){return C.VSBuffer.concat(this.a)}write(T){this.a.push(T)}}var h;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(h||(h={}));function l(F){const T=C.VSBuffer.alloc(4);return T.writeUInt32BE(F,0),T}function i(F){return F.read(4).readUInt32BE(0)}function s(F){const T=C.VSBuffer.alloc(1);return T.writeUInt8(F,0),T}const n={Undefined:s(h.Undefined),String:s(h.String),Buffer:s(h.Buffer),VSBuffer:s(h.VSBuffer),Array:s(h.Array),Object:s(h.Object)},a=typeof Buffer<"u";function r(F,T){if(typeof T>"u")F.write(n.Undefined);else if(typeof T=="string"){const N=C.VSBuffer.fromString(T);F.write(n.String),F.write(l(N.byteLength)),F.write(N)}else if(a&&Buffer.isBuffer(T)){const N=C.VSBuffer.wrap(T);F.write(n.Buffer),F.write(l(N.byteLength)),F.write(N)}else if(T instanceof C.VSBuffer)F.write(n.VSBuffer),F.write(l(T.byteLength)),F.write(T);else if(Array.isArray(T)){F.write(n.Array),F.write(l(T.length));for(const N of T)r(F,N)}else{const N=C.VSBuffer.fromString(JSON.stringify(T));F.write(n.Object),F.write(l(N.byteLength)),F.write(N)}}function c(F){switch(F.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return F.read(i(F)).toString();case h.Buffer:return F.read(i(F)).buffer;case h.VSBuffer:return F.read(i(F));case h.Array:{const N=i(F),V=[];for(let se=0;se<N;se++)V.push(c(F));return V}case h.Object:return JSON.parse(F.read(i(F)).toString())}}class o{constructor(T,N,V=null,se=1e3){this.h=T,this.j=N,this.k=V,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(z=>this.p(z)),this.m({type:200})}registerChannel(T,N){this.b.set(T,N),setTimeout(()=>this.v(T),0)}m(T){switch(T.type){case 200:{const N=this.n([T.type]);this.k?.logOutgoing(N,0,1,b(T.type));return}case 201:case 202:case 204:case 203:{const N=this.n([T.type,T.id],T.data);this.k?.logOutgoing(N,T.id,1,b(T.type),T.data);return}}}n(T,N=void 0){const V=new g;return r(V,T),r(V,N),this.o(V.buffer)}o(T){try{return this.h.send(T),T.byteLength}catch{return 0}}p(T){const N=new v(T),V=c(N),se=c(N),z=V[0];switch(z){case 100:return this.k?.logIncoming(T.byteLength,V[1],1,`${w(z)}: ${V[2]}.${V[3]}`,se),this.q({type:z,id:V[1],channelName:V[2],name:V[3],arg:se});case 102:return this.k?.logIncoming(T.byteLength,V[1],1,`${w(z)}: ${V[2]}.${V[3]}`,se),this.s({type:z,id:V[1],channelName:V[2],name:V[3],arg:se});case 101:return this.k?.logIncoming(T.byteLength,V[1],1,`${w(z)}`),this.t({type:z,id:V[1]});case 103:return this.k?.logIncoming(T.byteLength,V[1],1,`${w(z)}`),this.t({type:z,id:V[1]})}}q(T){const N=this.b.get(T.channelName);if(!N){this.u(T);return}const V=new R.CancellationTokenSource;let se;try{se=N.call(this.j,T.name,T.arg,V.token)}catch(D){se=Promise.reject(D)}const z=T.id;se.then(D=>{this.m({id:z,data:D,type:201}),this.d.delete(T.id)},D=>{D instanceof Error?this.m({id:z,data:{message:D.message,name:D.name,stack:D.stack?D.stack.split?D.stack.split(`
`):D.stack:void 0},type:202}):this.m({id:z,data:D,type:203}),this.d.delete(T.id)});const $=(0,m.toDisposable)(()=>V.cancel());this.d.set(T.id,$)}s(T){const N=this.b.get(T.channelName);if(!N){this.u(T);return}const V=T.id,z=N.listen(this.j,T.name,T.arg)($=>this.m({id:V,data:$,type:204}));this.d.set(T.id,z)}t(T){const N=this.d.get(T.id);N&&(N.dispose(),this.d.delete(T.id))}u(T){let N=this.g.get(T.channelName);N||(N=[],this.g.set(T.channelName,N));const V=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:T,timeoutTimer:V})}v(T){const N=this.g.get(T);if(N){for(const V of N)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.q(V.request);break;case 102:this.s(V.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=o;var S;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(T,N=null){this.l=T,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.r(V)),this.j=N}getChannel(T){const N=this;return{call(V,se,z){return N.a?Promise.reject(new k.CancellationError):N.m(T,V,se,z)},listen(V,se){return N.a?p.Event.None:N.n(T,V,se)}}}m(T,N,V,se=R.CancellationToken.None){const z=this.g++,D={id:z,type:100,channelName:T,name:N,arg:V};if(se.isCancellationRequested)return Promise.reject(new k.CancellationError);let O;return new Promise((U,q)=>{if(se.isCancellationRequested)return q(new k.CancellationError);const Q=()=>{const oe=ge=>{switch(ge.type){case 201:this.f.delete(z),U(ge.data);break;case 202:{this.f.delete(z);const Me=new Error(ge.data.message);Me.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,Me.name=ge.data.name,q(Me);break}case 203:this.f.delete(z),q(ge.data);break}};this.f.set(z,oe),this.o(D)};let j=null;this.b===u.Idle?Q():(j=(0,t.createCancelablePromise)(oe=>this.t()),j.then(()=>{j=null,Q()}));const Z=()=>{j?(j.cancel(),j=null):this.o({id:z,type:101}),q(new k.CancellationError)},x=se.onCancellationRequested(Z);O=(0,m.combinedDisposable)((0,m.toDisposable)(Z),x),this.d.add(O)}).finally(()=>{this.d.delete(O)})}n(T,N,V){const se=this.g++,$={id:se,type:102,channelName:T,name:N,arg:V};let D=null;const O=new p.Emitter({onWillAddFirstListener:()=>{D=(0,t.createCancelablePromise)(U=>this.t()),D.then(()=>{D=null,this.d.add(O),this.o($)})},onDidRemoveLastListener:()=>{D?(D.cancel(),D=null):(this.d.delete(O),this.o({id:se,type:103}))}}),W=U=>O.fire(U.data);return this.f.set(se,W),O.event}o(T){switch(T.type){case 100:case 102:{const N=this.p([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(N,T.id,0,`${w(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const N=this.p([T.type,T.id]);this.j?.logOutgoing(N,T.id,0,w(T.type));return}}}p(T,N=void 0){const V=new g;return r(V,T),r(V,N),this.q(V.buffer)}q(T){try{return this.l.send(T),T.byteLength}catch{return 0}}r(T){const N=new v(T),V=c(N),se=c(N),z=V[0];switch(z){case 200:return this.j?.logIncoming(T.byteLength,0,0,b(z)),this.s({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,V[1],0,b(z),se),this.s({type:V[0],id:V[1],data:se})}}s(T){if(T.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}t(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}pe([A.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class L{get connections(){const T=[];return this.f.forEach(N=>T.push(N)),T}constructor(T){this.a=new Map,this.f=new Set,this.g=new p.Emitter,this.onDidAddConnection=this.g.event,this.h=new p.Emitter,this.onDidRemoveConnection=this.h.event,T(({protocol:N,onDidClientDisconnect:V})=>{p.Event.once(N.onMessage)(z=>{const $=new v(z),D=c($),O=new o(N,D),W=new M(N);this.a.forEach((q,Q)=>O.registerChannel(Q,q));const U={channelServer:O,channelClient:W,ctx:D};this.f.add(U),this.g.fire(U),V(()=>{O.dispose(),W.dispose(),this.f.delete(U),this.h.fire(U)})})})}getChannel(T,N){const V=this;return{call(se,z,$){let D;if((0,E.isFunction)(N)){const W=(0,I.getRandomElement)(V.connections.filter(N));D=W?Promise.resolve(W):p.Event.toPromise(p.Event.filter(V.onDidAddConnection,N))}else D=N.routeCall(V,se,z);const O=D.then(W=>W.channelClient.getChannel(T));return J(O).call(se,z,$)},listen(se,z){if((0,E.isFunction)(N))return V.j(T,N,se,z);const $=N.routeEvent(V,se,z).then(D=>D.channelClient.getChannel(T));return J($).listen(se,z)}}}j(T,N,V,se){const z=this;let $=new m.DisposableStore;const D=new p.Emitter({onWillAddFirstListener:()=>{$=new m.DisposableStore;const O=new p.EventMultiplexer,W=new Map,U=Q=>{const Z=Q.channelClient.getChannel(T).listen(V,se),x=O.add(Z);W.set(Q,x)},q=Q=>{const j=W.get(Q);!j||(j.dispose(),W.delete(Q))};z.connections.filter(N).forEach(U),p.Event.filter(z.onDidAddConnection,N)(U,void 0,$),z.onDidRemoveConnection(q,void 0,$),O.event(D.fire,D,$),$.add(O)},onDidRemoveLastListener:()=>{$.dispose()}});return D.event}registerChannel(T,N){this.a.set(T,N),this.f.forEach(V=>{V.channelServer.registerChannel(T,N)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=L;class B{constructor(T,N,V=null){const se=new g;r(se,N),T.send(se.buffer),this.a=new M(T,V),this.d=new o(T,N,V)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,N){this.d.registerChannel(T,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=B;function J(F){return{call(T,N,V){return F.then(se=>se.call(T,N,V))},listen(T,N){const V=new p.Relay;return F.then(se=>V.input=se.listen(T,N)),V.event}}}e.getDelayedChannel=J;function ae(F){let T=!1;return{call(N,V,se){return T?F.call(N,V,se):(0,t.timeout)(0).then(()=>T=!0).then(()=>F.call(N,V,se))},listen(N,V){if(T)return F.listen(N,V);const se=new p.Relay;return(0,t.timeout)(0).then(()=>T=!0).then(()=>se.input=F.listen(N,V)),se.event}}}e.getNextTickChannel=ae;class X{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const N of T.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await p.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.StaticRouter=X;var Y;(function(F){function T(z,$){const D=z,O=$&&$.disableMarshalling,W=new Map;for(const U in D)V(U)&&W.set(U,p.Event.buffer(D[U],!0));return new class{listen(U,q,Q){const j=W.get(q);if(j)return j;if(se(q)){const Z=D[q];if(typeof Z=="function")return Z.call(D,Q)}throw new Error(`Event not found: ${q}`)}call(U,q,Q){const j=D[q];if(typeof j=="function"){if(!O&&Array.isArray(Q))for(let Z=0;Z<Q.length;Z++)Q[Z]=(0,y.revive)(Q[Z]);return j.apply(D,Q)}throw new Error(`Method not found: ${q}`)}}}F.fromService=T;function N(z,$){const D=$&&$.disableMarshalling;return new Proxy({},{get(O,W){if(typeof W=="string")return $?.properties?.has(W)?$.properties.get(W):se(W)?function(U){return z.listen(W,U)}:V(W)?z.listen(W):async function(...U){let q;$&&!(0,E.isUndefinedOrNull)($.context)?q=[$.context,...U]:q=U;const Q=await z.call(W,q);return D?Q:(0,y.revive)(Q)};throw new Error(`Property not found: ${String(W)}`)}})}F.toService=N;function V(z){return z[0]==="o"&&z[1]==="n"&&P.isUpperAsciiLetter(z.charCodeAt(2))}function se(z){return/^onDynamic/.test(z)&&P.isUpperAsciiLetter(z.charCodeAt(9))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const T=F.toString();if(T!=="[object Object]")return T}return F}function de(F){return Array.isArray(F)?F.map(ne):ne(F)}function K(F,T,N,V,se,z,$){$=de($);const D=re[se],O=D[V%D.length];let W=[`%c[${F}]%c[${String(T).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(z)?(W=W.concat($),W.push(")")):W.push($),console.log.apply(console,W)}class le{constructor(T,N){this.d=T,this.f=N,this.a=0,this.b=0}logOutgoing(T,N,V,se,z){this.b+=T,K(this.d,this.b,T,N,V,se,z)}logIncoming(T,N,V,se,z){this.a+=T,K(this.f,this.a,T,N,V,se,z)}}e.IPCLogger=le}),define(ee[144],te([0,1,17,3,47]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(p){this.a=p,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",m=>I.VSBuffer.wrap(m.data)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}e.Protocol=R;class A extends C.IPCClient{constructor(p,m){const y=new R(p);super(y,m),this.b=y}dispose(){this.b.disconnect()}}e.Client=A}),define(ee[102],te([0,1,17,3,2,47]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(a){a.enableDiagnostics=!1,a.records=[];const r=new WeakMap;let c=0;function o(M,L){if(!r.has(M)){const B=String(++c);r.set(M,B)}return r.get(M)}function S(M,L,B,J){if(!a.enableDiagnostics)return;const ae=o(M,L);if(J instanceof I.VSBuffer||J instanceof Uint8Array||J instanceof ArrayBuffer||ArrayBuffer.isView(J)){const X=I.VSBuffer.alloc(J.byteLength);X.set(J),a.records.push({timestamp:Date.now(),id:ae,label:L,type:B,buff:X})}else a.records.push({timestamp:Date.now(),id:ae,label:L,type:B,data:J})}a.traceSocketEvent=S})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var p;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function y(){return m||(m=I.VSBuffer.alloc(0)),m}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,c){if(r===0)return y();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const L=this.a[0];return c&&(this.a.shift(),this.b-=r),L}if(this.a[0].byteLength>r){const L=this.a[0].slice(0,r);return c&&(this.a[0]=this.a[0].slice(r),this.b-=r),L}const o=I.VSBuffer.alloc(r);let S=0,M=0;for(;r>0;){const L=this.a[M];if(L.byteLength>r){const B=L.slice(0,r);o.set(B,S),S+=r,c&&(this.a[M]=L.slice(r),this.b-=r),r-=r}else o.set(L,S),S+=L.byteLength,c?(this.a.shift(),this.b-=L.byteLength):M++,r-=L.byteLength}return o}}e.ChunkStream=P;var E;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(E||(E={}));function f(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,c,o,S){this.type=r,this.id=c,this.ack=o,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends C.Disposable{constructor(r){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new P,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,S=this.g.id,M=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new d(o,S,M,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=I.VSBuffer.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(c,r.data)}g(r,c){const o=this.f===0;return this.d.push(r,c),this.f+=r.byteLength+c.byteLength,o}h(){const r=I.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,c){this.g(r,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class v extends C.Disposable{constructor(r){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new u(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new d(1,0,0,r))}}e.Protocol=v;class g extends R.IPCClient{static fromSocket(r,c){return new g(new v(r),c)}get onDidDispose(){return this.b.onDidDispose}constructor(r,c,o=null){super(r,c,o),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.Client=g;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.BufferedEmitter=h;class l{constructor(r){this.data=r,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let r=0,c=this.a;for(;c;)c=c.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let c=0,o=this.a;for(;o;)r[c++]=o.data,o=o.next;return r}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const c=new l(r);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const r=Date.now();for(let c=0;c<s.a;c++)this.c[c]=r-1e3*c;setInterval(()=>{for(let c=s.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),c=(1+s.a)*1e3;let o=0;for(let S=0;S<s.a;S++)r-this.c[S]<=c&&o++;return 1-o/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;class n{get unacknowledgedCount(){return this.c-this.d}constructor(r,c=null,o=s.getInstance()){this.t=new h,this.onControlMessage=this.t.event,this.u=new h,this.onMessage=this.u.event,this.v=new h,this.onDidDispose=this.v.event,this.w=new h,this.onSocketClose=this.w.event,this.x=new h,this.onSocketTimeout=this.x.event,this.s=o,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=r,this.p=new u(this.o),this.r.push(this.p),this.q=new b(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(S=>this.y(S))),this.r.push(this.o.onClose(S=>this.w.fire(S))),c&&this.q.acceptChunk(c),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,C.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const r=new d(5,0,0,y());this.p.write(r),this.p.flush()}sendPause(){const r=new d(7,0,0,y());this.p.write(r)}sendResume(){const r=new d(8,0,0,y());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,c){this.a=!0,this.r=(0,C.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=new u(this.o),this.r.push(this.p),this.q=new b(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(o=>this.y(o))),this.r.push(this.o.onClose(o=>this.w.fire(o))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new d(3,0,this.h,y());this.p.write(r);const c=this.b.toArray();for(let o=0,S=c.length;o<S;o++)this.p.write(c[o]);this.A()}acceptDisconnect(){this.v.fire()}y(r){if(r.ack>this.d){this.d=r.ack;do{const c=this.b.peek();if(c&&c.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new d(6,0,0,y())))}else this.g=r.id,this.j=Date.now(),this.z(),this.u.fire(r.data);break}case 2:{this.t.fire(r.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const c=this.b.toArray();for(let o=0,S=c.length;o<S;o++)this.p.write(c[o]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const c=++this.c;this.h=this.g;const o=new d(1,c,this.h,r);this.b.push(o),this.a||(this.p.write(o),this.A())}sendControl(r){const c=new d(2,0,0,r);this.p.write(c)}z(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-r+5)}A(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),c=Date.now()-r.writtenTime,o=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(c>=2e4&&o>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:o});return}const M=Math.max(2e4-c,2e4-o,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.A()},M)}B(){if(this.g<=this.h)return;this.h=this.g;const r=new d(3,0,this.h,y());this.p.write(r)}C(){const r=new d(9,0,0,y());this.p.write(r)}}e.PersistentProtocol=n}),define(ee[145],te([0,1,41,17,3,2,47,130]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function p(y,P){const E=C.Event.fromNodeEventEmitter(I.validatedIpcMain,P,(w,d)=>({event:w,message:d})),f=C.Event.filter(E,({event:w})=>w.sender.id===y);return C.Event.map(f,({message:w})=>w&&t.VSBuffer.wrap(w))}class m extends A.IPCServer{static d(){const P=C.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:E})=>E);return C.Event.map(P,E=>{const f=E.id;m.b.get(f)?.dispose();const d=new C.Emitter;m.b.set(f,(0,R.toDisposable)(()=>d.fire()));const b=p(f,"vscode:message"),u=C.Event.any(C.Event.signal(p(f,"vscode:disconnect")),d.event);return{protocol:new k.Protocol(E,b),onDidClientDisconnect:u}})}constructor(){super(m.d())}}e.Server=m,m.b=new Map}),define(ee[103],te([0,1,41,3,29,144]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class A extends R.Client{constructor(m,y){super({addEventListener:(P,E)=>m.addListener(P,E),removeEventListener:(P,E)=>m.removeListener(P,E),postMessage:P=>m.postMessage(P),start:()=>m.start(),close:()=>m.close()},y)}}e.Client=A;async function k(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,C.generateUuid)();p.webContents.send("vscode:createMessageChannel",m);const y=t.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(E,f)=>({nonce:f,port:E.ports[0]})),{port:P}=await t.Event.toPromise(t.Event.once(t.Event.filter(y,E=>E.nonce===m)));return P}e.connect=k}),define(ee[146],te([0,1,46,8,17,22,139,14,3,2,44,82,79,47]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends f.ChannelServer{constructor(u){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",v=>C.VSBuffer.wrap(Buffer.from(v,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=w;class d{constructor(u,v){this.i=u,this.j=v,this.c=new Set,this.g=new Map,this.h=new p.Emitter,this.onDidProcessExit=this.h.event;const g=v&&v.timeout?v.timeout:6e4;this.b=new t.Delayer(g),this.d=null,this.f=null}getChannel(u){const v=this;return{call(g,h,l){return v.k(u,g,h,l)},listen(g,h){return v.l(u,g,h)}}}k(u,v,g,h=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const l=this.n(u),i=(0,t.createCancelablePromise)(a=>l.call(v,g,a)),s=h.onCancellationRequested(()=>i.cancel()),n=(0,m.toDisposable)(()=>i.cancel());return this.c.add(n),i.finally(()=>{s.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,v,g){if(!this.b)return p.Event.None;this.b.cancel();let h;const l=new p.Emitter({onWillAddFirstListener:()=>{h=this.n(u).listen(v,g)(l.fire,l),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],v=Object.create(null);v.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(v.env={...v.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(v.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,E.removeDangerousEnvVariables)(v.env),this.d=(0,I.fork)(this.i,u,v);const g=new p.Emitter;p.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,A.isRemoteConsoleLog)(r)){(0,A.log)(r,`IPC Library: ${this.j.serverName}`);return}g.fire(C.VSBuffer.wrap(Buffer.from(r,"base64")))});const l=this.j.useQueue?(0,P.createQueuedSender)(this.d):this.d,i=r=>this.d&&this.d.connected&&l.send(r.buffer.toString("base64")),s=g.event,n={send:i,onMessage:s};this.f=new f.ChannelClient(n);const a=()=>this.o();process.once("exit",a),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,c)=>{process.removeListener("exit",a),this.c.forEach(o=>(0,m.dispose)(o)),this.c.clear(),r!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:c})})}return this.f}n(u){let v=this.g.get(u);return v||(v=this.m.getChannel(u),this.g.set(u,v)),v}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=d}),define(ee[83],te([0,1,17,14,3,2,9,4,29,47,102]),function(H,e,I,t,C,R,A,k,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class E{traceSocketEvent(o,S){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,S)}constructor(o,S=""){this.f=!0,this.debugLabel=S,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const S=M=>{this.traceSocketEvent("read",M),o(I.VSBuffer.wrap(M))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(o){const S=M=>{o({type:0,hadError:M,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(o){const S=()=>{o()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,t.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,t.onUnexpectedError)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=E;var f;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var w;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(w||(w={}));class d extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,S){this.socket.traceSocketEvent(o,S)}constructor(o,S,M,L){super(),this.f=this.B(new C.Emitter),this.g=this.B(new C.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:M?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new b(this,S,M,L,this.f,(B,J)=>this.k(B,J))),this.B(this.a.onError(B=>{console.error(B),(0,t.onUnexpectedError)(B),this.g.fire({type:0,hadError:!0,error:B})})),this.b=new y.ChunkStream,this.B(this.socket.onData(B=>this.l(B))),this.B(this.socket.onClose(B=>this.g.fire(B)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,S){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let M=2;o.byteLength<126?M+=0:o.byteLength<2**16?M+=2:M+=8;const L=I.VSBuffer.alloc(M);if(S?L.writeUInt8(194,0):L.writeUInt8(130,0),o.byteLength<126)L.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){L.writeUInt8(126,1);let B=1;L.writeUInt8(o.byteLength>>>8&255,++B),L.writeUInt8(o.byteLength>>>0&255,++B)}else{L.writeUInt8(127,1);let B=1;L.writeUInt8(0,++B),L.writeUInt8(0,++B),L.writeUInt8(0,++B),L.writeUInt8(0,++B),L.writeUInt8(o.byteLength>>>24&255,++B),L.writeUInt8(o.byteLength>>>16&255,++B),L.writeUInt8(o.byteLength>>>8&255,++B),L.writeUInt8(o.byteLength>>>0&255,++B)}this.socket.write(I.VSBuffer.concat([L,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),M=S.readUInt8(0),L=(M&128)>>>7,B=(M&64)>>>6,J=S.readUInt8(1),ae=(J&128)>>>7,X=J&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(X===126?2:0)+(X===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(B)),this.j.firstFrameOfMessage=Boolean(L),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),M=S.readUInt8(1),L=(M&128)>>>7;let B=M&127,J=1;B===126?B=S.readUInt8(++J)*2**8+S.readUInt8(++J):B===127&&(B=S.readUInt8(++J)*0+S.readUInt8(++J)*0+S.readUInt8(++J)*0+S.readUInt8(++J)*0+S.readUInt8(++J)*2**24+S.readUInt8(++J)*2**16+S.readUInt8(++J)*2**8+S.readUInt8(++J));let ae=0;L&&(ae=S.readUInt8(++J)*2**24+S.readUInt8(++J)*2**16+S.readUInt8(++J)*2**8+S.readUInt8(++J)),this.j.state=3,this.j.readLen=B,this.j.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),g(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(S,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class b extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(o,S,M,L,B,J){super(),this.k=o,this.l=B,this.m=J,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,S?(this.b=this.B(new u(this.k,L,M,{windowBits:15})),this.f=this.B(new v(this.k,{windowBits:15})),this.B(this.b.onError(ae=>this.a.fire(ae))),this.B(this.f.onError(ae=>this.a.fire(ae)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const S=await this.r(this.f,o);this.m(S,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,S){return new Promise((M,L)=>{o.write(S),o.flush(B=>M(B))})}acceptFrame(o,S,M){this.h.push({data:o,isCompressed:S,isLastFrameOfMessage:M}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const S=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(S)}else this.l.fire(o.data)}this.s=!1}}u(o,S,M){return new Promise((L,B)=>{o.write(S),M&&o.write(I.VSBuffer.fromByteArray([0,0,255,255])),o.flush(J=>L(J))})}}class u extends R.Disposable{get recordedInflateBytes(){return this.j?I.VSBuffer.concat(this.f):I.VSBuffer.alloc(0)}constructor(o,S,M,L){super(),this.h=o,this.j=S,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(L),this.b.on("error",B=>{this.h.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this.a.fire(B)}),this.b.on("data",B=>{this.h.traceSocketEvent("zlibInflateData",B),this.g.push(I.VSBuffer.wrap(B))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=I.VSBuffer.concat(this.g);this.g.length=0,o(S)})}}class v extends R.Disposable{constructor(o,S){super(),this.g=o,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(I.VSBuffer.wrap(M))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=I.VSBuffer.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),o(S)})}}function g(c,o){if(o===0)return;const S=c.byteLength>>>2;for(let X=0;X<S;X++){const Y=c.readUInt32BE(X*4);c.writeUInt32BE(Y^o,X*4)}const M=S*4,L=c.byteLength-M,B=o>>>24&255,J=o>>>16&255,ae=o>>>8&255;L>=1&&c.writeUInt8(c.readUInt8(M)^B,M),L>=2&&c.writeUInt8(c.readUInt8(M+1)^J,M+1),L>=3&&c.writeUInt8(c.readUInt8(M+2)^ae,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function l(){const c=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,A.join)(P().os.tmpdir(),`vscode-ipc-${c}.sock`),s(o),o}e.createRandomIPCHandle=l;function i(c,o,S){const M=P().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${S}-${o}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${S}-${o}.sock`):L=(0,A.join)(c,`${S}-${o}.sock`),s(L),L}e.createStaticIPCHandle=i;function s(c){const o=h[k.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class n extends m.IPCServer{static b(o){const S=C.Event.fromNodeEventEmitter(o,"connection");return C.Event.map(S,M=>({protocol:new y.Protocol(new E(M,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(M,"close"))}))}constructor(o){super(n.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function a(c){return new Promise((o,S)=>{const M=P().net.createServer();M.on("error",S),M.listen(c,()=>{M.removeListener("error",S),o(new n(M))})})}e.serve=a;function r(c,o){return new Promise((S,M)=>{const L=P().net.createConnection(c,()=>{L.removeListener("error",M),S(y.Client.fromSocket(new E(L,`ipc-client${o}`),o))});L.once("error",M)})}e.connect=r}),define(ee[104],te([0,1,8,3,2,12]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",P[P.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A=e.StorageHint||(e.StorageHint={}));function k(P){const E=P;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var p;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(p=e.StorageState||(e.StorageState={}));class m extends C.Disposable{constructor(E,f=Object.create(null)){super(),this.m=E,this.n=f,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=p.None,this.f=new Map,this.g=new I.ThrottledDelayer(m.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(E=>this.r(E)))}r(E){E.changed?.forEach((f,w)=>this.s(w,f)),E.deleted?.forEach(f=>this.s(f,void 0))}s(E,f){if(this.c===p.Closed)return;let w=!1;(0,R.isUndefinedOrNull)(f)?w=this.f.delete(E):this.f.get(E)!==f&&(this.f.set(E,f),w=!0),w&&this.b.fire(E)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===p.None&&(this.c=p.Initialized,this.n.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(E,f){const w=this.f.get(E);return(0,R.isUndefinedOrNull)(w)?f:w}getBoolean(E,f){const w=this.get(E);return(0,R.isUndefinedOrNull)(w)?f:w==="true"}getNumber(E,f){const w=this.get(E);return(0,R.isUndefinedOrNull)(w)?f:parseInt(w,10)}async set(E,f){if(this.c===p.Closed)return;if((0,R.isUndefinedOrNull)(f))return this.delete(E);const w=String(f);if(this.f.get(E)!==w)return this.f.set(E,w),this.j.set(E,w),this.h.delete(E),this.b.fire(E),this.w()}async delete(E){if(!(this.c===p.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire(E),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=p.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(E).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(E){if(!!this.u)return this.w(E)}async w(E){return this.g.trigger(()=>this.v(),E)}async whenFlushed(){if(!!this.u)return new Promise(E=>this.l.push(E))}isInMemory(){return this.n.hint===A.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=m,m.a=100;class y{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((f,w)=>this.a.set(w,f)),E.delete?.forEach(f=>this.a.delete(f))}async close(){}}e.InMemoryStorageDatabase=y}),define(ee[147],te([0,1,8,3,39,9,23]),function(H,e,I,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return t.Event.None}constructor(y,P=Object.create(null)){this.g=y,this.h=P,this.c=(0,R.basename)(this.g),this.d=new p(this.h.logging),this.f=this.n(this.g)}async getItems(){const y=await this.f,P=new Map;return(await this.s(y,"SELECT * FROM ItemTable")).forEach(f=>P.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${P.size} rows`),P}async updateItems(y){const P=await this.f;return this.j(P,y)}j(y,P){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${P.insert?(0,C.mapToString)(P.insert):"0"}), delete(${P.delete?(0,C.setToString)(P.delete):"0"})`),this.t(y,()=>{const E=P.insert,f=P.delete;if(E&&E.size>0){const w=[];w.push([]);let d=0;E.forEach((b,u)=>{let v=w[d];v.length>k.b&&(d++,v=[],w.push(v)),v.push(u,b)}),w.forEach(b=>{this.u(y,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,u=>u.run(b),()=>{const u=[];let v=0;return E.forEach((g,h)=>{u.push(h),v+=g.length}),`Keys: ${u.join(", ")} Length: ${v}`})})}if(f&&f.size){const w=[];w.push([]);let d=0;f.forEach(b=>{let u=w[d];u.length>k.b&&(d++,u=[],w.push(u)),u.push(b)}),w.forEach(b=>{this.u(y,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,u=>u.run(b),()=>{const u=[];return f.forEach(v=>{u.push(v)}),`Keys: ${u.join(", ")}`})})}})}async close(y){this.d.trace(`[storage ${this.c}] close()`);const P=await this.f;return this.k(P,y)}k(y,P){return new Promise((E,f)=>{y.db.close(w=>(w&&this.o(y,`[storage ${this.c}] close(): ${w}`),this.g===k.IN_MEMORY_PATH?E():!y.isErroneous&&!y.isInMemory?this.l().then(E,d=>(this.d.error(`[storage ${this.c}] backup(): ${d}`),E())):typeof P=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(d=>{const b=()=>this.k(d,void 0);return this.j(d,{insert:P()}).then(()=>b(),u=>(b(),Promise.reject(u)))})).then(E,f):f(w||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const y=this.m(this.g);return A.Promises.copy(this.g,y,{preserveSymlinks:!1})}m(y){return`${y}.backup`}async checkIntegrity(y){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${y})`);const P=await this.f,E=await this.r(P,y?"PRAGMA integrity_check":"PRAGMA quick_check"),f=y?E.integrity_check:E.quick_check;return P.isErroneous?`${f} (last error: ${P.lastError})`:P.isInMemory?`${f} (in-memory!)`:f}async n(y,P=!0){this.d.trace(`[storage ${this.c}] open(${y}, retryOnBusy: ${P})`);try{return await this.p(y)}catch(E){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&P)return await(0,I.timeout)(k.a),this.n(y,!1);try{await A.Promises.unlink(y);try{await A.Promises.rename(this.m(y),y)}catch{}return await this.p(y)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(k.IN_MEMORY_PATH)}}}o(y,P){y.isErroneous=!0,y.lastError=P,this.d.error(P)}p(y){return new Promise((P,E)=>{new Promise((f,w)=>{H(["@vscode/sqlite3"],f,w)}).then(f=>{const w={db:new(this.d.isTracing?f.verbose().Database:f.Database)(y,d=>d?w.db&&d.code!=="SQLITE_CANTOPEN"?w.db.close(()=>E(d)):E(d):this.q(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(w),b=>w.db.close(()=>E(b)))),isInMemory:y===k.IN_MEMORY_PATH};w.db.on("error",d=>this.o(w,`[storage ${this.c}] Error (event): ${d}`)),this.d.isTracing&&w.db.on("trace",d=>this.d.trace(`[storage ${this.c}] Trace (event): ${d}`))},E)})}q(y,P){return new Promise((E,f)=>{y.db.exec(P,w=>w?(this.o(y,`[storage ${this.c}] exec(): ${w}`),f(w)):E())})}r(y,P){return new Promise((E,f)=>{y.db.get(P,(w,d)=>w?(this.o(y,`[storage ${this.c}] get(): ${w}`),f(w)):E(d))})}s(y,P){return new Promise((E,f)=>{y.db.all(P,(w,d)=>w?(this.o(y,`[storage ${this.c}] all(): ${w}`),f(w)):E(d))})}t(y,P){return new Promise((E,f)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),P(),y.db.run("END TRANSACTION",w=>w?(this.o(y,`[storage ${this.c}] transaction(): ${w}`),f(w)):E())})})}u(y,P,E,f){const w=y.db.prepare(P),d=b=>{this.o(y,`[storage ${this.c}] prepare(): ${b} (${P}). Details: ${f()}`)};w.on("error",d),E(w),w.finalize(b=>{b&&d(b),w.removeListener("error",d)})}}e.SQLiteStorageDatabase=k,k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256;class p{constructor(y){y&&typeof y.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.a=y.logTrace),y&&typeof y.logError=="function"&&(this.b=y.logError)}get isTracing(){return!!this.a}trace(y){this.a?.(y)}error(y){this.b?.(y)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[148],te([11,10]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(ee[149],te([11,10]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[150],te([11,10]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[151],te([11,10]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(ee[152],te([11,10]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(ee[153],te([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[154],te([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[155],te([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[156],te([11,10]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[157],te([11,10]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[158],te([11,10]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(ee[159],te([11,10]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(ee[160],te([11,10]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(ee[161],te([11,10]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[162],te([11,10]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[163],te([11,10]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[164],te([11,10]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[165],te([11,10]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[166],te([11,10]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(ee[167],te([11,10]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(ee[168],te([11,10]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[169],te([11,10]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[170],te([11,10]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[171],te([11,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[172],te([11,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[173],te([11,10]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(ee[174],te([11,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[175],te([11,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[176],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(C){return C&&C.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function t(C){return C&&C.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ee[177],te([0,1,7]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(A){return typeof A?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function C(A){let k=[];try{Array.isArray(A.workspaces)&&(k=A.workspaces.map(p=>({workspace:{id:p.id,configPath:I.URI.parse(p.configURIPath)},remoteAuthority:p.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=C;function R(A){let k=[];try{Array.isArray(A.folders)&&(k=A.folders.map(p=>({folderUri:I.URI.parse(p.folderUri),remoteAuthority:p.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=R}),define(ee[178],te([0,1,3,2]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class C{constructor(){this.a=new I.Emitter,this.b=new I.Emitter,this.c=new I.Emitter,this.d=new I.Emitter}call(k,p,m){switch(p){case"close":return Promise.resolve(this.a.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(k,p,m){switch(p){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=C,C.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,p,m){this.b.call("attach",[k,p,m])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,p){this.b.call("terminate",[k,p])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,p){return this.b.call("openExtensionDevelopmentHostWindow",[k,p])}}e.ExtensionHostDebugChannelClient=R}),define(ee[179],te([0,1,133,53,15,9,33,20,7]),function(H,e,I,t,C,R,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,R.dirname)(C.FileAccess.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return p.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return p.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(p.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=A.env.VSCODE_PORTABLE;return d?p.URI.file((0,R.join)(d,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,R.resolve)(d):(0,R.normalize)((0,R.join)(C.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?p.URI.file((0,R.resolve)(d)):p.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,R.resolve)(d);const b=A.env.VSCODE_EXTENSIONS;if(b)return b;const u=A.env.VSCODE_PORTABLE;return u?(0,R.join)(u,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(b=>/^[^:/?#]+?:\/\//.test(b)?p.URI.parse(b):p.URI.file((0,R.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?p.URI.parse(d):p.URI.file((0,R.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const b of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(b);u&&u[1]&&u[2]&&d.push([u[1],u[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return p.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=A.env.VSCODE_PORTABLE;return d?p.URI.file((0,R.join)(d,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,b,u){this.a=d,this.b=b,this.c=u,this.editSessionId=this.args.editSessionId}}pe([t.memoize],m.prototype,"appRoot",null),pe([t.memoize],m.prototype,"userHome",null),pe([t.memoize],m.prototype,"userDataPath",null),pe([t.memoize],m.prototype,"appSettingsHome",null),pe([t.memoize],m.prototype,"tmpDir",null),pe([t.memoize],m.prototype,"cacheHome",null),pe([t.memoize],m.prototype,"stateResource",null),pe([t.memoize],m.prototype,"userRoamingDataHome",null),pe([t.memoize],m.prototype,"userDataSyncHome",null),pe([t.memoize],m.prototype,"userDataSyncLogResource",null),pe([t.memoize],m.prototype,"editSessionsLogResource",null),pe([t.memoize],m.prototype,"sync",null),pe([t.memoize],m.prototype,"machineSettingsResource",null),pe([t.memoize],m.prototype,"workspaceStorageHome",null),pe([t.memoize],m.prototype,"localHistoryHome",null),pe([t.memoize],m.prototype,"keyboardLayoutResource",null),pe([t.memoize],m.prototype,"argvResource",null),pe([t.memoize],m.prototype,"isExtensionDevelopment",null),pe([t.memoize],m.prototype,"untitledWorkspacesHome",null),pe([t.memoize],m.prototype,"installSourcePath",null),pe([t.memoize],m.prototype,"builtinExtensionsPath",null),pe([t.memoize],m.prototype,"extensionsPath",null),pe([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],m.prototype,"extensionDevelopmentKind",null),pe([t.memoize],m.prototype,"extensionTestsLocationURI",null),pe([t.memoize],m.prototype,"debugExtensionHost",null),pe([t.memoize],m.prototype,"logLevel",null),pe([t.memoize],m.prototype,"extensionLogLevel",null),pe([t.memoize],m.prototype,"serviceMachineIdResource",null),pe([t.memoize],m.prototype,"telemetryLogResource",null),pe([t.memoize],m.prototype,"disableWorkspaceTrust",null),pe([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function y(w,d){return f(w["inspect-extensions"],w["inspect-brk-extensions"],5870,d,w.debugId,w.extensionEnvironment)}e.parseExtensionHostPort=y;function P(w,d){return f(w["inspect-search"],w["inspect-brk-search"],5876,d,w.extensionEnvironment)}e.parseSearchPort=P;function E(w,d){return f(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,d,w.extensionEnvironment)}e.parsePtyHostPort=E;function f(w,d,b,u,v,g){const l=Number(d||w)||(u?null:b),i=l?Boolean(!!d):!1;let s;if(g)try{s=JSON.parse(g)}catch{}return{port:l,break:i,debugId:v,env:s}}}),define(ee[105],te([0,1,279,4,151]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,C.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,C.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,C.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},category:{type:"string",cat:"e",description:(0,C.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,C.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,C.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,C.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,C.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,C.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,C.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,C.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,C.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,C.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,C.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(d,b,u=A){const v=d.find(c=>c.length>0&&c[0]!=="-"),g={},h=["_"],l=[],i={};let s;for(const c in b){const o=b[c];o.type==="subcommand"?c===v&&(s=o):(o.alias&&(g[c]=o.alias),o.type==="string"||o.type==="string[]"?(h.push(c),o.deprecates&&h.push(...o.deprecates)):o.type==="boolean"&&(l.push(c),o.deprecates&&l.push(...o.deprecates)),o.global&&(i[c]=o))}if(s&&v){const c=i;for(const L in s.options)c[L]=s.options[L];const o=d.filter(L=>L!==v),S=u.getSubcommandReporter?u.getSubcommandReporter(v):void 0,M=k(o,c,S);return{[v]:M,_:[]}}const n=I(d,{string:h,boolean:l,alias:g}),a={},r=n;a._=n._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(const c in b){const o=b[c];if(o.type==="subcommand")continue;o.alias&&delete r[o.alias];let S=r[c];if(o.deprecates)for(const M of o.deprecates)r.hasOwnProperty(M)&&(S||(S=r[M],S&&u.onDeprecatedOption(M,o.deprecationMessage||(0,C.localize)(36,null,c))),delete r[M]);if(typeof S<"u"){if(o.type==="string[]"){if(Array.isArray(S)||(S=[S]),!o.allowEmptyValue){const M=S.filter(L=>L.length>0);M.length!==S.length&&(u.onEmptyValue(c),S=M.length>0?M:void 0)}}else o.type==="string"&&(Array.isArray(S)?(S=S.pop(),u.onMultipleValues(c,S)):!S&&!o.allowEmptyValue&&(u.onEmptyValue(c),S=void 0));a[c]=S,o.deprecationMessage&&u.onDeprecatedOption(c,o.deprecationMessage)}delete r[c]}for(const c in r)u.onUnknownOption(c);return a}e.parseArgs=k;function p(d,b){let u="";return b.args&&(Array.isArray(b.args)?u=` <${b.args.join("> <")}>`:u=` <${b.args}>`),b.alias?`-${b.alias} --${d}${u}`:`--${d}${u}`}function m(d,b){const u=[];for(const v in d){const g=d[v],h=p(v,g);u.push([h,g.description])}return y(u,b)}e.formatOptions=m;function y(d,b){const v=d.reduce((l,i)=>Math.max(l,i[0].length),12)+2+1;if(b-v<25)return d.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const g=b-v-1,h=[];for(const l of d){const i=l[0],s=E(l[1],g),n=P(v-i.length-2);h.push("  "+i+n+s[0]);for(let a=1;a<s.length;a++)h.push(P(v)+s[a])}return h}function P(d){return" ".repeat(d)}function E(d,b){const u=[];for(;d.length;){const v=d.length<b?d.length:d.lastIndexOf(" ",b),g=d.slice(0,v).trim();d=d.slice(v),u.push(g)}return u}function f(d,b,u,v,g){const h=process.stdout.isTTY&&process.stdout.columns||80,l=g?.noInputFiles!==!0?`[${(0,C.localize)(37,null)}...]`:"",i=[`${d} ${u}`];i.push(""),i.push(`${(0,C.localize)(38,null)}: ${b} [${(0,C.localize)(39,null)}]${l}`),i.push(""),g?.noPipe!==!0&&(t.isWindows?i.push((0,C.localize)(40,null,b)):i.push((0,C.localize)(41,null,b)),i.push(""));const s={},n=[];for(const a in v){const r=v[a];if(r.type==="subcommand")r.description&&n.push({command:a,description:r.description});else if(r.description&&r.cat){let c=s[r.cat];c||(s[r.cat]=c={}),c[a]=r}}for(const a in s){const r=a,c=s[r];c&&(i.push(R[r]),i.push(...m(c,h)),i.push(""))}return n.length&&(i.push((0,C.localize)(42,null)),i.push(...y(n.map(a=>[a.command,a.description]),h)),i.push("")),i.join(`
`)}e.buildHelpMessage=f;function w(d,b){return`${d||(0,C.localize)(43,null)}
${b||(0,C.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=w}),define(ee[180],te([0,1,78,178,105]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,p,m){return p==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(k,p,m)}async g(k,p){const m=(0,C.parseArgs)(k,C.OPTIONS);m.debugRenderer=p;const y=m.extensionDevelopmentPath;if(!y)return{success:!1};const[P]=await this.f.openExtensionDevelopmentHostWindow(y,{context:5,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!p)return{success:!0};const E=P.win;if(!E)return{success:!0};const f=E.webContents.debugger;let w=f.isAttached()?1/0:0;const d=(0,I.createServer)(b=>{w++===0&&f.attach();let u=!1;const v=l=>{u||b.write(JSON.stringify(l)+"\0")},g=(l,i,s,n)=>v({method:i,params:s,sessionId:n});E.on("close",()=>{f.removeListener("message",g),b.end(),u=!0}),f.addListener("message",g);let h=Buffer.alloc(0);b.on("data",l=>{h=Buffer.concat([h,l]);for(let i=h.indexOf(0);i!==-1;i=h.indexOf(0)){let s;try{const n=h.slice(0,i).toString("utf8");h=h.slice(i+1),s=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}f.sendCommand(s.method,s.params,s.sessionId).then(n=>v({id:s.id,sessionId:s.sessionId,result:n})).catch(n=>v({id:s.id,sessionId:s.sessionId,error:{code:0,message:n.message}}))}}),b.on("error",l=>{console.error("error on cdp pipe:",l)}),b.on("close",()=>{u=!0,--w===0&&f.detach()})});return await new Promise(b=>d.listen(0,b)),E.on("close",()=>d.close()),{rendererDebugPort:d.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(ee[61],te([0,1,280,152,105]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function A(E,f){const w=(h,l)=>{console.warn((0,t.localize)(0,null,h,l))},d=h=>{console.warn((0,t.localize)(1,null,h))},b=(h,l)=>{console.warn((0,t.localize)(2,null,h,l))},u=h=>({onUnknownOption:l=>{h!=="tunnel"&&console.warn((0,t.localize)(3,null,l,h))},onMultipleValues:w,onEmptyValue:d,onDeprecatedOption:b,getSubcommandReporter:h!=="tunnel"?u:void 0}),v={onUnknownOption:h=>{console.warn((0,t.localize)(4,null,h))},onMultipleValues:w,onEmptyValue:d,onDeprecatedOption:b,getSubcommandReporter:u},g=(0,C.parseArgs)(E,C.OPTIONS,f?v:void 0);return g.goto&&g._.forEach(h=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(h),(0,t.localize)(5,null))),g["max-memory"]&&I(parseInt(g["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),g}function k(E){const f=E.findIndex(w=>!/^-/.test(w));if(f>-1)return[...E.slice(0,f),...E.slice(f+1)]}function p(E){let[,...f]=E;process.env.VSCODE_DEV&&(f=k(f)||[]);const w=!P(process.env);return A(f,w)}e.parseMainProcessArgv=p;function m(E){let[,,...f]=E;return process.env.VSCODE_DEV&&(f=k(f)||[]),A(f,!0)}e.parseCLIProcessArgv=m;function y(E,...f){const w=E.indexOf("--");return w===-1?E.push(...f):E.splice(w,0,...f),E}e.addArg=y;function P(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),function(){"use strict";function H(e,I,t){function C(A,k){const p=R(A,k),m=[p];return e.isAbsolute(p)||m.unshift(t),e.resolve(...m)}function R(A,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,k);const y=A["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(P,"AppData","Roaming")}break;case"darwin":m=e.join(I.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,k)}return{getUserDataPath:C}}if(typeof define=="function")define(ee[181],te([182,25,33]),function(e,I,t){return H(e,I,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=H(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[183],te([0,1,25,179,181]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(k,p){super(k,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,C.getUserDataPath)(k,p.nameShort)},p)}}e.NativeEnvironmentService=R}),define(ee[184],te([0,1,40,25,30]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(A){const k=(0,C.randomPath)((0,t.tmpdir)());try{return(0,I.writeFileSync)(k,""),A&&console.log(`Marker file for --wait created: ${k}`),k}catch(p){A&&console.error(`Failed to create marker file for --wait: ${p}`);return}}e.createWaitMarkerFileSync=R}),define(ee[185],te([0,1,12,154]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function C(A,k,p){try{R(A,k,p)}catch(m){console.error(m?.message??m)}return A}e.localizeManifest=C;function R(A,k,p){const m=(y,P,E)=>{const f=y[P];if((0,I.isString)(f)){const w=f,d=w.length;if(d>1&&w[0]==="%"&&w[d-1]==="%"){const b=w.substr(1,d-2);let u=k[b];u===void 0&&p&&(u=p[b]);const v=typeof u=="string"?u:u?.message,g=p?.[b],h=typeof g=="string"?g:g?.message;if(!v){h||console.warn(`[${A.name}]: ${(0,t.localize)(0,null,b)}`);return}if(E&&(P==="title"||P==="category")&&h&&h!==v){const l={value:v,original:h};y[P]=l}else y[P]=v}}else if((0,I.isObject)(f))for(const w in f)f.hasOwnProperty(w)&&(w==="commands"?m(f,w,!0):m(f,w,E));else if(Array.isArray(f))for(let w=0;w<f.length;w++)m(f,w,E)};for(const y in A)A.hasOwnProperty(y)&&m(A,y)}}),define(ee[186],te([0,1,14]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,A){this.a.set(R,A)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const A in R.contributes){const k=this.a.get(A);if(!k)continue;const p=R.contributes[A],m=Array.isArray(p)?p:[p];try{k(m,R.activationEvents)}catch(y){(0,I.onUnexpectedError)(y)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ee[187],te([0,1,20,98,156,188]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function p(u){return u=u.trim(),u==="*"||A.test(u)}e.isValidVersionStr=p;function m(u){if(!p(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=u.match(A);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=m;function y(u){if(!u)return null;const v=u.majorBase,g=u.majorMustEqual,h=u.minorBase;let l=u.minorMustEqual;const i=u.patchBase;let s=u.patchMustEqual;u.hasCaret&&(v===0||(l=!1),s=!1);let n=0;if(u.preRelease){const a=k.exec(u.preRelease);if(a){const[,r,c,o]=a;n=Date.UTC(Number(r),Number(c)-1,Number(o))}}return{majorBase:v,majorMustEqual:g,minorBase:h,minorMustEqual:l,patchBase:i,patchMustEqual:s,isMinimum:u.hasGreaterEquals,notBefore:n}}e.normalizeVersion=y;function P(u,v,g){let h;typeof u=="string"?h=y(m(u)):h=u;let l;v instanceof Date?l=v.getTime():typeof v=="string"&&(l=new Date(v).getTime());let i;if(typeof g=="string"?i=y(m(g)):i=g,!h||!i)return!1;const s=h.majorBase,n=h.minorBase,a=h.patchBase;let r=i.majorBase,c=i.minorBase,o=i.patchBase;const S=i.notBefore;let M=i.majorMustEqual,L=i.minorMustEqual,B=i.patchMustEqual;return i.isMinimum?s>r?!0:s<r?!1:n>c?!0:n<c||l&&l<S?!1:a>=o:(s===1&&r===0&&(!M||!L||!B)&&(r=1,c=0,o=0,M=!0,L=!1,B=!1),s<r?!1:s>r?!M:n<c?!1:n>c?!L:a<o?!1:a>o?!B:!(l&&l<S))}e.isValidVersion=P;function E(u,v,g,h,l){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([t.default.Error,C.localize(0,null)]),i;if(typeof h.name!="string")return i.push([t.default.Error,C.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([t.default.Error,C.localize(2,null,"version")]),i;if(!h.engines)return i.push([t.default.Error,C.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([t.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!b(h.extensionDependencies))return i.push([t.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!b(h.activationEvents))return i.push([t.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([t.default.Error,C.localize(7,null,"activationEvents","main")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([t.default.Warning,C.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([t.default.Error,C.localize(9,null,"main")]),i;{const a=(0,I.joinPath)(g,h.main);(0,I.isEqualOrParent)(a,g)||i.push([t.default.Warning,C.localize(10,null,a.path,g.path)])}if(typeof h.activationEvents>"u")return i.push([t.default.Error,C.localize(11,null,"activationEvents","main")]),i}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([t.default.Error,C.localize(12,null,"browser")]),i;{const a=(0,I.joinPath)(g,h.browser);(0,I.isEqualOrParent)(a,g)||i.push([t.default.Warning,C.localize(13,null,a.path,g.path)])}if(typeof h.activationEvents>"u")return i.push([t.default.Error,C.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(h.version))return i.push([t.default.Error,C.localize(15,null)]),i;const s=[];if(!f(u,v,h,l,s))for(const a of s)i.push([t.default.Error,a]);return i}e.validateExtensionManifest=E;function f(u,v,g,h,l){return h||typeof g.main>"u"&&typeof g.browser>"u"?!0:d(u,v,g.engines.vscode,l)}e.isValidExtensionVersion=f;function w(u,v,g){return u==="*"||d(v,g,u)}e.isEngineValid=w;function d(u,v,g,h=[]){const l=y(m(g));if(!l)return h.push(C.localize(16,null,g)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return h.push(C.localize(17,null,g)),!1}else if(!l.majorMustEqual)return h.push(C.localize(18,null,g)),!1;return P(u,v,l)?!0:(h.push(C.localize(19,null,u,g)),!1)}function b(u){if(!Array.isArray(u))return!1;for(let v=0,g=u.length;v<g;v++)if(typeof u[v]!="string")return!1;return!0}}),define(ee[189],te([0,1,17,29]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function C(R,A,k){let p=k&&k.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const y=(await A.readFile(R.serviceMachineIdResource)).value.toString();p=(0,t.isUUID)(y)?y:null}catch{p=null}if(!p){p=(0,t.generateUuid)();try{await A.writeFile(R.serviceMachineIdResource,I.VSBuffer.fromString(p))}catch{}}return k?.store("storage.serviceMachineId",p,-1,1),p}e.getServiceMachineId=C}),define(ee[70],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(C,R=[],A=!1){this.ctor=C,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=I}),define(ee[190],te([0,1,70]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var C;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function R(k,p,m){p instanceof I.SyncDescriptor||(p=new I.SyncDescriptor(p,[],Boolean(m))),t.push([k,p])}e.registerSingleton=R;function A(){return t}e.getSingletonServiceDescriptors=A}),define(ee[191],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const A of this.a.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const k=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(A);k.outgoing.set(p.key,p),p.incoming.set(k.key,k)}removeNode(R){const A=this.b(R);this.a.delete(A);for(const k of this.a.values())k.outgoing.delete(A),k.incoming.delete(A)}lookupOrInsertNode(R){const A=this.b(R);let k=this.a.get(A);return k||(k=new I(A,R),this.a.set(A,k)),k}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[A,k]of this.a)R.push(`${A}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this.a){const k=new Set([R]),p=this.c(A,k);if(p)return p}}c(R,A){for(const[k,p]of R.outgoing){if(A.has(k))return[...A,k].join(" -> ");A.add(k);const m=this.c(p,A);if(m)return m;A.delete(k)}}}e.Graph=t}),define(ee[5],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function k(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=k})(I=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function t(A,k,p){k[I.DI_TARGET]===k?k[I.DI_DEPENDENCIES].push({id:A,index:p}):(k[I.DI_DEPENDENCIES]=[{id:A,index:p}],k[I.DI_TARGET]=k)}function C(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const k=function(p,m,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,p,y)};return k.toString=()=>A,I.serviceIds.set(A,k),k}e.createDecorator=C;function R(A){return A}e.refineServiceDecorator=R}),define(ee[62],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(ee[18],te([0,1,12,7,5]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function R(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=R;function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var k;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function p(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=p;function m(u,v){const g=Object.create(null);for(const h in u)y(g,h,u[h],v);return g}e.toValuesTree=m;function y(u,v,g,h){const l=v.split("."),i=l.pop();let s=u;for(let n=0;n<l.length;n++){const a=l[n];let r=s[a];switch(typeof r){case"undefined":r=s[a]=Object.create(null);break;case"object":break;default:h(`Ignoring ${v} as ${l.slice(0,n+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[i]=g}catch{h(`Ignoring ${v} as ${l.join(".")} is ${JSON.stringify(s)}`)}else h(`Ignoring ${v} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=y;function P(u,v){const g=v.split(".");E(u,g)}e.removeFromValueTree=P;function E(u,v){const g=v.shift();if(v.length===0){delete u[g];return}if(Object.keys(u).indexOf(g)!==-1){const h=u[g];typeof h=="object"&&!Array.isArray(h)&&(E(h,v),Object.keys(h).length===0&&delete u[g])}}function f(u,v,g){function h(s,n){let a=s;for(const r of n){if(typeof a!="object"||a===null)return;a=a[r]}return a}const l=v.split("."),i=h(u,l);return typeof i>"u"?g:i}e.getConfigurationValue=f;function w(u,v,g){Object.keys(v).forEach(h=>{h!=="__proto__"&&(h in u?I.isObject(u[h])&&I.isObject(v[h])?w(u[h],v[h],g):g&&(u[h]=v[h]):u[h]=v[h])})}e.merge=w;function d(u,v,g){const h=u.inspect(v),l=u.inspect(g);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:h.defaultValue}e.getMigratedSettingValue=d;function b(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(ee[71],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(R,A){return this.a[R]?.[A]??null}async setPassword(R,A,k){this.a[R]=this.a[R]??{},this.a[R][A]=k}async deletePassword(R,A){return this.a[R]?.[A]?(delete this.a[R][A],Object.keys(this.a[R]).length===0&&delete this.a[R],!0):!1}async findPassword(R){return JSON.stringify(this.a[R])??null}async findCredentials(R){const A=[];for(const k of Object.keys(this.a[R]||{}))A.push({account:k,password:this.a[R][k]});return A}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(ee[84],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class C{async getPerformanceInfo(A,k){return{}}async getSystemInfo(A,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,k){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=C}),define(ee[106],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(ee[35],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[27],te([0,1,53,9,83,35,183,5]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(R.IEnvironmentService);class p extends A.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,C.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([I.memoize],p.prototype,"cachedLanguagesPath",null),pe([I.memoize],p.prototype,"backupHome",null),pe([I.memoize],p.prototype,"mainIPCHandle",null),pe([I.memoize],p.prototype,"mainLockfile",null),pe([I.memoize],p.prototype,"disableUpdates",null),pe([I.memoize],p.prototype,"disableKeytar",null),pe([I.memoize],p.prototype,"crossOriginIsolated",null),pe([I.memoize],p.prototype,"codeCachePath",null),pe([I.memoize],p.prototype,"useCodeCache",null),e.EnvironmentMainService=p}),define(ee[192],te([0,1,153,5]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function A(u,v){switch(u){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function k(u,v){return v==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function p(u,v,g){return k(v,g)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===g?!0:m(g).includes(u)}e.isTargetPlatformCompatible=p;function m(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function y(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=y;var P;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var E;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var w;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var d;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(v,g){super(v),this.code=g,this.name=g}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,I.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[193],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(ee[194],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[107],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(ee[195],te([0,1,46,15,9,4,79,23,82,157,107]),function(H,e,I,t,C,R,A,k,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=m.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends E{openTerminal(h,l){return this.spawnTerminal(I,h,p.getWindowsShell(),l)}spawnTerminal(h,l,i,s){const n=l.windowsExec||f.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=C.basename(n).toLowerCase();if(a==="cmder"||a==="cmder.exe")return h.spawn(n,s?[s]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return n.indexOf(" ")>=0&&r.push('""'),r.push(n),(a==="wt"||a==="wt.exe")&&r.push("-d ."),new Promise((c,o)=>{const S=b(process),M=h.spawn(i,r,{cwd:s,env:S});M.on("error",o),M.on("exit",()=>c())})}runInTerminal(h,l,i,s,n){const a="windowsExec"in n&&n.windowsExec?n.windowsExec:f.getDefaultTerminalWindows();return new Promise((r,c)=>{const o=`"${l} - ${P}"`,S=`""${i.join('" "')}" & pause"`,M=["/c","start",o,"/wait",a,"/c",S],L=Object.assign({},b(process),s);Object.keys(L).filter(ae=>L[ae]===null).forEach(ae=>delete L[ae]);const B={cwd:l,env:L,windowsVerbatimArguments:!0};I.spawn(f.b,M,B).on("error",ae=>{c(u(ae))}),r(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.WindowsExternalTerminalService=f,f.b="cmd.exe";class w extends E{openTerminal(h,l){return this.spawnTerminal(I,h,l)}runInTerminal(h,l,i,s,n){const a=n.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{if(a===y.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const o=a===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`).fsPath,"-t",h||P,"-w",l];for(const J of i)M.push("-a"),M.push(J);if(s){const J=Object.assign({},b(process),s);for(const ae in J){const X=J[ae];X===null?(M.push("-u"),M.push(ae)):(M.push("-e"),M.push(`${ae}=${X}`))}}let L="";const B=I.spawn(w.b,M);B.on("error",J=>{c(u(J))}),B.stderr.on("data",J=>{L+=J.toString()}),B.on("exit",J=>{if(J===0)r(void 0);else if(L){const ae=L.split(`
`,1);c(new Error(ae[0]))}else c(new Error(m.localize(1,null,o,J)))})}else c(new Error(m.localize(2,null,a)))})}spawnTerminal(h,l,i){const s=l.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((n,a)=>{const r=["-a",s];i&&r.push(i);const c=b(process),o=h.spawn("/usr/bin/open",r,{cwd:i,env:c});o.on("error",a),o.on("exit",()=>n())})}}e.MacExternalTerminalService=w,w.b="/usr/bin/osascript";class d extends E{openTerminal(h,l){return this.spawnTerminal(I,h,l)}runInTerminal(h,l,i,s,n){const a=n.linuxExec?Promise.resolve(n.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{const o=[];a.then(S=>{S.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const M=`${v(i)}; echo; read -p "${d.b}" -n1;`;o.push(`''${M}''`);const L=Object.assign({},b(process),s);Object.keys(L).filter(X=>L[X]===null).forEach(X=>delete L[X]);const B={cwd:l,env:L};let J="";const ae=I.spawn(S,o,B);ae.on("error",X=>{c(u(X))}),ae.stderr.on("data",X=>{J+=X.toString()}),ae.on("exit",X=>{if(X===0)r(void 0);else if(J){const Y=J.split(`
`,1);c(new Error(Y[0]))}else c(new Error(m.localize(4,null,S,X)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!R.isLinux)d.d=Promise.resolve("xterm");else{const h=await k.Promises.exists("/etc/debian_version");d.d=new Promise(l=>{h?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return d.d}spawnTerminal(h,l,i){const s=l.linuxExec?Promise.resolve(l.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((n,a)=>{s.then(r=>{const c=b(process),o=h.spawn(r,[],{cwd:i,env:c});o.on("error",a),o.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=d,d.b=m.localize(3,null);function b(g){const h={...g.env};return(0,A.sanitizeProcessEnvironment)(h),h}function u(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(m.localize(5,null,g.path)):g}function v(g){let h="";for(const l of g)l.indexOf(" ")>=0?h+='"'+l+'"':h+=l,h+=" ";return h}}),define(ee[16],te([0,1,60,9,26,12,7,159,5]),function(H,e,I,t,C,R,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function m(K){return K.create===!0}e.isFileOpenForWriteOptions=m;var y;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var P;(function(K){K[K.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var E;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=f;function w(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=w;function d(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=d;function b(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function u(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=u;function v(K){return f(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var g;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(le,F){super(le),this.code=F}}e.FileSystemProviderError=h;function l(K,le){const F=new h(K.toString(),le);return s(F,le),F}e.createFileSystemProviderError=l;function i(K){return K||l((0,k.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=i;function s(K,le){return K.name=le?`${le} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=s;function n(K){if(!K)return g.Unknown;if(K instanceof h)return K.code;const le=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!le)return g.Unknown;switch(le[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=n;function a(K){if(K instanceof L)return K.fileOperationResult;switch(n(K)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(le,F,T){this.resource=le,this.operation=F,this.target=T}isOperation(le){return this.operation===le}}e.FileOperationEvent=c;var o;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class S{constructor(le,F){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=le;const T=new Map;for(const N of le){const V=T.get(N.type);switch(V?V.push([N.resource,N]):T.set(N.type,[[N.resource,N]]),N.type){case 1:this.rawAdded.push(N.resource);break;case 0:this.rawUpdated.push(N.resource);break;case 2:this.rawDeleted.push(N.resource);break}}for(const[N,V]of T)switch(N){case 1:this.a=I.TernarySearchTree.forUris(()=>F),this.a.fill(V);break;case 0:this.b=I.TernarySearchTree.forUris(()=>F),this.b.fill(V);break;case 2:this.c=I.TernarySearchTree.forUris(()=>F),this.c.fill(V);break}}contains(le,...F){return this.d(le,{includeChildren:!1},...F)}affects(le,...F){return this.d(le,{includeChildren:!0},...F)}d(le,F,...T){if(!le)return!1;const N=T.length>0;return!!((!N||T.includes(1))&&(this.a?.get(le)||F.includeChildren&&this.a?.findSuperstr(le))||(!N||T.includes(0))&&(this.b?.get(le)||F.includeChildren&&this.b?.findSuperstr(le))||(!N||T.includes(2))&&(this.c?.findSubstr(le)||F.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=S;function M(K,le,F){return!K||!le||K===le||le.length>K.length?!1:(le.charAt(le.length-1)!==t.sep&&(le+=t.sep),F?(0,C.startsWithIgnoreCase)(K,le):K.indexOf(le)===0)}e.isParent=M;class L extends Error{constructor(le,F,T){super(le),this.fileOperationResult=F,this.options=T}}e.FileOperationError=L;class B extends L{constructor(le,F,T){super(le,2,T),this.stat=F}}e.NotModifiedSinceFileOperationError=B;var J;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(J=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=X;async function Y(K,le){if(!le.hasProvider(A.URI.from({scheme:K.scheme})))return new Promise(F=>{const T=le.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===K.scheme&&N.added&&(T.dispose(),F())})})}e.whenProviderRegistered=Y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(le){return(0,R.isNumber)(le)||(le=0),le<re.KB?(0,k.localize)(1,null,le.toFixed(0)):le<re.MB?(0,k.localize)(2,null,(le/re.KB).toFixed(2)):le<re.GB?(0,k.localize)(3,null,(le/re.MB).toFixed(2)):le<re.TB?(0,k.localize)(4,null,(le/re.GB).toFixed(2)):(0,k.localize)(5,null,(le/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var ne;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function de(K){return{maxFileSize:K===0?300*re.MB:16*re.GB,maxHeapSize:K===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=de}),define(ee[196],te([0,1,17,45,14,3,2,59,7,29,16]),function(H,e,I,t,C,R,A,k,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends A.Disposable{constructor(f,w){super(),this.a=f,this.b=w,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.h=(0,m.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,w){const{buffer:d}=await this.a.call("readFile",[f,w]);return d}readFileStream(f,w,d){const b=(0,k.newWriteableStream)(v=>I.VSBuffer.concat(v.map(g=>I.VSBuffer.wrap(g))).buffer),u=this.a.listen("readFileStream",[f,w])(v=>{if(v instanceof I.VSBuffer)b.write(v.buffer);else{if(v==="end")b.end();else{let g=v;g instanceof Error||(g=(0,y.createFileSystemProviderError)((0,t.toErrorMessage)(g),y.FileSystemProviderErrorCode.Unknown)),b.error(g),b.end()}u.dispose()}});return d.onCancellationRequested(()=>{b.error((0,C.canceled)()),b.end(),u.dispose()}),b}writeFile(f,w,d){return this.a.call("writeFile",[f,I.VSBuffer.wrap(w),d])}open(f,w){return this.a.call("open",[f,w])}close(f){return this.a.call("close",[f])}async read(f,w,d,b,u){const[v,g]=await this.a.call("read",[f,w,u]);return d.set(v.buffer.slice(0,g),b),g}write(f,w,d,b,u){return this.a.call("write",[f,w,I.VSBuffer.wrap(d),b,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,w){return this.a.call("delete",[f,w])}rename(f,w,d){return this.a.call("rename",[f,w,d])}copy(f,w,d){return this.a.call("copy",[f,w,d])}cloneFile(f,w){return this.a.call("cloneFile",[f,w])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const w=f;this.f.fire(w.map(d=>({resource:p.URI.revive(d.resource),type:d.type})))}else{const w=f;this.g.fire(w)}}))}watch(f,w){const d=(0,m.generateUuid)();return this.a.call("watch",[this.h,d,f,w]),(0,A.toDisposable)(()=>this.a.call("unwatch",[this.h,d]))}}e.DiskFileSystemProviderClient=P}),define(ee[108],te([0,1,17,14,160,16]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(y,P,E,f,w,d){let b;try{await k(y,P,E,f,w,d)}catch(u){b=u}finally{b&&w.errorTransformer&&(b=w.errorTransformer(b)),typeof b<"u"&&E.error(b),E.end()}}e.readFileIntoStream=A;async function k(y,P,E,f,w,d){p(d);const b=await y.open(P,{create:!1});try{p(d);let u=0,v=0,g=w&&typeof w.length=="number"?w.length:void 0,h=I.VSBuffer.alloc(Math.min(w.bufferSize,typeof g=="number"?g:w.bufferSize)),l=w&&typeof w.position=="number"?w.position:0,i=0;do v=await y.read(b,l,h.buffer,i,h.byteLength-i),l+=v,i+=v,u+=v,typeof g=="number"&&(g-=v),i===h.byteLength&&(await E.write(f(h)),h=I.VSBuffer.alloc(Math.min(w.bufferSize,typeof g=="number"?g:w.bufferSize)),i=0);while(v>0&&(typeof g!="number"||g>0)&&p(d)&&m(u,w));if(i>0){let s=i;typeof g=="number"&&(s=Math.min(i,g)),E.write(f(h.slice(0,s)))}}catch(u){throw(0,R.ensureFileSystemProviderError)(u)}finally{await y.close(b)}}function p(y){if(y.isCancellationRequested)throw(0,t.canceled)();return!0}function m(y,P){if(P?.limits){if(typeof P.limits.memory=="number"&&y>P.limits.memory)throw(0,R.createFileSystemProviderError)((0,C.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&y>P.limits.size)throw(0,R.createFileSystemProviderError)((0,C.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[72],te([0,1,99,2,9,4,7,16]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(u){return u.recursive===!0}e.isRecursiveWatchRequest=p;class m extends t.Disposable{constructor(v,g,h,l){super(),this.h=v,this.i=g,this.j=h,this.k=l,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const v=new t.DisposableStore;this.c.value=v,this.b=this.l(v),this.b.setVerboseLogging(this.j),v.add(this.b.onDidChangeFile(g=>this.h(g))),v.add(this.b.onDidLogMessage(g=>this.i(g))),v.add(this.b.onDidError(g=>this.n(g)))}n(v){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${v}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${v}`):this.r(v)}p(v){this.g++,this.m(),this.watch(v)}async watch(v){this.f=v,await this.b?.watch(v)}async setVerboseLogging(v){this.j=v,await this.b?.setVerboseLogging(v)}r(v){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${v}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.a=5;class y extends m{constructor(v,g,h){super(v,g,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class P extends m{constructor(v,g,h){super(v,g,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function E(u){return u.map(v=>({type:v.type,resource:A.URI.file(v.path)}))}e.toFileChanges=E;function f(u){const v=new b;for(const g of u)v.processEvent(g);return v.coalesce()}e.coalesceEvents=f;function w(u,v){return typeof v=="string"&&!v.startsWith(I.GLOBSTAR)&&!(0,C.isAbsolute)(v)?{base:u,pattern:v}:v}e.normalizeWatcherPattern=w;function d(u,v){const g=[];for(const h of v)g.push((0,I.parse)(w(u,h)));return g}e.parseWatcherPatterns=d;class b{constructor(){this.a=new Set,this.b=new Map}c(v){return R.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const g=this.b.get(this.c(v));let h=!1;if(g){const l=g.type,i=v.type;g.path!==v.path&&(v.type===2||v.type===1)?h=!0:l===1&&i===2?(this.b.delete(this.c(v)),this.a.delete(g)):l===2&&i===1?g.type=0:l===1&&i===0||(g.type=i)}else h=!0;h&&(this.a.add(v),this.b.set(this.c(v),v))}coalesce(){const v=[],g=[];return Array.from(this.a).filter(h=>h.type!==2?(v.push(h),!1):!0).sort((h,l)=>h.path.length-l.path.length).filter(h=>g.some(l=>(0,k.isParent)(h.path,l,!R.isLinux))?!1:(g.push(h.path),!0)).concat(v)}}}),define(ee[197],te([0,1,40,8,22,30,2,76,9,4,100,23,72]),function(H,e,I,t,C,R,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends A.Disposable{constructor(b,u,v,g){super(),this.k=b,this.l=u,this.m=v,this.n=g,this.c=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.l(h)),this.f=this.B(new t.ThrottledDelayer(f.b)),this.g=[],this.h=(0,E.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,E.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new C.CancellationTokenSource,this.ready=this.r()}async r(){try{const b=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const u=await P.Promises.stat(b);this.B(await this.t(b,u.isDirectory()))}catch(b){b.code!=="ENOENT"?this.w(b):this.z(b)}}async s(b){let u=b.path;try{u=await P.Promises.realpath(b.path),b.path===u&&(u=await(0,y.realcase)(b.path)??b.path),b.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${u})`)}catch{}return u}async t(b,u){if(m.isMacintosh&&(0,R.isEqualOrParent)(b,"/Volumes/",!0))return this.w(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const v=new C.CancellationTokenSource(this.j.token),g=new A.DisposableStore;try{const h=(0,p.basename)(b),l=(0,I.watch)(b);g.add((0,A.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.z(`Started watching: '${b}'`);const i=new Set;if(u)try{for(const n of await P.Promises.readdir(b))i.add(n)}catch(n){this.w(n)}const s=new Map;g.add((0,A.toDisposable)(()=>{for(const[,n]of s)n.dispose();s.clear()})),l.on("error",(n,a)=>{this.w(`Failed to watch ${b} for changes using fs.watch() (${n}, ${a})`),this.dispose()}),l.on("change",(n,a)=>{if(v.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${a}`);let r="";if(a&&(r=a.toString(),m.isMacintosh&&(r=(0,k.normalizeNFC)(r))),!(!r||n!=="change"&&n!=="rename"))if(u)if(n==="rename"){s.get(r)?.dispose();const c=setTimeout(async()=>{if(s.delete(r),r===h&&!await P.Promises.exists(b)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,p.join)(b,r));if(v.token.isCancellationRequested)return;let S;o?i.has(r)?S=0:(S=1,i.add(r)):(i.delete(r),S=2),this.u({path:(0,p.join)(this.k.path,r),type:S})},f.a);s.set(r,(0,A.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(r)?c=0:(c=1,i.add(r)),this.u({path:(0,p.join)(this.k.path,r),type:c})}else if(n==="rename"||r!==h){const c=setTimeout(async()=>{const o=await P.Promises.exists(b);v.token.isCancellationRequested||(o?(this.u({path:this.k.path,type:0},!0),g.add(await this.t(b,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},f.a);g.clear(),g.add((0,A.toDisposable)(()=>clearTimeout(c)))}else this.u({path:this.k.path,type:0},!0)})}catch(h){await P.Promises.exists(b)&&!v.token.isCancellationRequested&&this.w(`Failed to watch ${b} for changes using fs.watch() (${h.toString()})`)}return(0,A.toDisposable)(()=>{v.dispose(!0),g.dispose()})}async u(b,u=!1){if(!this.j.token.isCancellationRequested){this.n&&this.z(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!u&&this.h.some(v=>v(b.path))?this.n&&this.z(` >> ignored (excluded) ${b.path}`):!u&&this.i&&this.i.length>0&&!this.i.some(v=>v(b.path))?this.n&&this.z(` >> ignored (not included) ${b.path}`):this.g.push(b);try{await this.f.trigger(async()=>{const v=this.g;this.g=[];const g=(0,E.coalesceEvents)(v);if(g.length>0){if(this.n)for(const l of g)this.z(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.c.work(g)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(b){if(m.isLinux)return P.Promises.exists(b);try{const u=(0,p.basename)(b);return(await P.Promises.readdir((0,p.dirname)(b))).some(g=>g===u)}catch(u){return this.z(u),!1}}setVerboseLogging(b){this.n=b}w(b){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}y(b){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}z(b){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.z(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.a=100,f.b=50;async function w(d,b,u,v,g=512){const h=await P.Promises.open(d,"r"),l=Buffer.allocUnsafe(g),i=new C.CancellationTokenSource(v);let s,n=!1;const a={path:d,excludes:[],recursive:!1},r=new f(a,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:S}=await P.Promises.read(h,l,0,g,null);if(!S||i.token.isCancellationRequested)break;b(l.slice(0,S))}}catch(S){s=new Error(S),i.dispose(!0)}finally{n=!1}}})()});return await r.ready,u(),new Promise((c,o)=>{i.token.onCancellationRequested(async()=>{r.dispose();try{await P.Promises.close(h)}catch(S){s=new Error(S)}s?o(s):c()})})}e.watchFileContents=w}),define(ee[198],te([0,1,3,99,2,4,197]),function(H,e,I,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends C.Disposable{constructor(){super(...arguments),this.a=this.B(new I.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new I.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(m){const y=this.i(m),P=y.filter(f=>{const w=this.c.get(f.path);return w?!(0,t.patternsEquals)(w.request.excludes,f.excludes)||!(0,t.patternsEquals)(w.request.includes,f.includes):!0}),E=Array.from(this.c.values()).filter(({request:f})=>!y.find(w=>w.path===f.path&&(0,t.patternsEquals)(w.excludes,f.excludes)&&(0,t.patternsEquals)(w.includes,f.includes))).map(({request:f})=>f.path);P.length&&this.j(`Request to start watching: ${P.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),E.length&&this.j(`Request to stop watching: ${E.join(",")}`);for(const f of E)this.h(f);for(const f of P)this.g(f)}g(m){const y=new A.NodeJSFileWatcherLibrary(m,E=>this.a.fire(E),E=>this.b.fire(E),this.f),P={request:m,instance:y};this.c.set(m.path,P)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const y=this.c.get(m);y&&(this.c.delete(m),y.instance.dispose())}i(m){const y=new Map;for(const P of m){const E=R.isLinux?P.path:P.path.toLowerCase();y.set(E,P)}return Array.from(y.values())}async setVerboseLogging(m){this.f=m;for(const[,y]of this.c)y.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,y){return y?`[File Watcher (node.js)] ${m} (path: ${y.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=k}),define(ee[199],te([0,1,72,198]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class C extends I.AbstractNonRecursiveWatcherClient{constructor(A,k,p){super(A,k,p),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=C}),define(ee[200],te([0,1,15,47,146,72]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends R.AbstractUniversalWatcherClient{constructor(p,m,y){super(p,m,y),this.m()}l(p){const m=p.add(new C.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(m.onDidProcessExit(({code:y,signal:P})=>this.n(`terminated by itself with code ${y}, signal: ${P}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ee[85],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...C){this.a=new Map;for(const[R,A]of C)this.set(R,A)}set(C,R){const A=this.a.get(C);return this.a.set(C,R),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.ServiceCollection=I}),define(ee[201],te([0,1,8,14,2,70,191,5,85,96]),function(H,e,I,t,C,R,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class E{constructor(b=new p.ServiceCollection,u=!1,v,g=y){this.f=b,this.g=u,this.h=v,this.i=g,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=g?v?._globalGraph??new A.Graph(h=>h):void 0}createChild(b){return new E(b,this.g,this,this.i)}invokeFunction(b,...u){const v=w.traceInvocation(this.i,b);let g=!1;try{return b({get:l=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(l,v);if(!i)throw new Error(`[invokeFunction] unknown service '${l}'`);return i}},...u)}finally{g=!0,v.stop()}}createInstance(b,...u){let v,g;return b instanceof R.SyncDescriptor?(v=w.traceCreation(this.i,b.ctor),g=this.j(b.ctor,b.staticArguments.concat(u),v)):(v=w.traceCreation(this.i,b),g=this.j(b,u,v)),v.stop(),g}j(b,u=[],v){const g=k._util.getServiceDependencies(b).sort((i,s)=>i.index-s.index),h=[];for(const i of g){const s=this.m(i.id,v);s||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(s)}const l=g.length>0?g[0].index:u.length;if(u.length!==l){console.trace(`[createInstance] First service dependency of ${b.name} at position ${l+1} conflicts with ${u.length} static arguments`);const i=l-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,l)}return Reflect.construct(b,u.concat(h))}k(b,u){if(this.f.get(b)instanceof R.SyncDescriptor)this.f.set(b,u);else if(this.h)this.h.k(b,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const u=this.f.get(b);return!u&&this.h?this.h.l(b):u}m(b,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const v=this.l(b);return v instanceof R.SyncDescriptor?this.q(b,v,u.branch(b,!0)):(u.branch(b,!1),v)}q(b,u,v){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,u,v)}finally{this.o.delete(b)}}r(b,u,v){const g=new A.Graph(i=>i.id.toString());let h=0;const l=[{id:b,desc:u,_trace:v}];for(;l.length;){const i=l.pop();if(g.lookupOrInsertNode(i),h++>1e3)throw new P(g);for(const s of k._util.getServiceDependencies(i.desc.ctor)){const n=this.l(s.id);if(n||this.u(`[createInstance] ${b} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),n instanceof R.SyncDescriptor){const a={id:s.id,desc:n,_trace:i._trace.branch(s.id,!0)};g.insertEdge(i,a),l.push(a)}}}for(;;){const i=g.roots();if(i.length===0){if(!g.isEmpty())throw new P(g);break}for(const{data:s}of i){if(this.l(s.id)instanceof R.SyncDescriptor){const a=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,a)}g.removeNode(s)}}return this.l(b)}s(b,u,v=[],g,h){if(this.f.get(b)instanceof R.SyncDescriptor)return this.t(b,u,v,g,h);if(this.h)return this.h.s(b,u,v,g,h);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(b,u,v=[],g,h){if(g){const l=new E(void 0,this.g,this,this.i);l.c=String(b);const i=new Map,s=new I.IdleValue(()=>{const n=l.j(u,v,h);for(const[a,r]of i){const c=n[a];if(typeof c=="function")for(const o of r)c.apply(n,o)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,a){if(!s.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let o=i.get(a);return o||(o=new m.LinkedList,i.set(a,o)),(M,L,B)=>{const J=o.push([M,L,B]);return(0,C.toDisposable)(J)}}if(a in n)return n[a];const r=s.value;let c=r[a];return typeof c!="function"||(c=c.bind(r),n[a]=c),c},set(n,a,r){return s.value[a]=r,!0},getPrototypeOf(n){return u.prototype}})}else return this.j(u,v,h)}u(b,u){if(u&&console.warn(b),this.g)throw new Error(b)}}e.InstantiationService=E;var f;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(f||(f={}));class w{static traceInvocation(b,u){return b?new w(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(b,u){return b?new w(0,u.name):w.c}constructor(b,u){this.type=b,this.name=u,this.g=Date.now(),this.h=[]}branch(b,u){const v=new w(2,b.toString());return this.h.push([b,u,v]),v}stop(){const b=Date.now()-this.g;w.f+=b;let u=!1;function v(h,l){const i=[],s=new Array(h+1).join("	");for(const[n,a,r]of l.h)if(a&&r){u=!0,i.push(`${s}CREATES -> ${n}`);const c=v(h+1,r);c&&i.push(c)}else i.push(`${s}uses -> ${n}`);return i.join(`
`)}const g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(b>2||u)&&w.all.add(g.join(`
`))}}e.Trace=w,w.all=new Set,w.c=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w.f=0}),define(ee[6],te([0,1,45,3,2,39,4,7,5]),function(H,e,I,t,C,R,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function m(){return new Date().toISOString()}var y;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function P(c,o,S){switch(o){case y.Trace:c.trace(S);break;case y.Debug:c.debug(S);break;case y.Info:c.info(S);break;case y.Warning:c.warn(S);break;case y.Error:c.error(S);break;case y.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=P;function E(c){let o="";for(let S=0;S<c.length;S++){let M=c[S];if(typeof M=="object")try{M=JSON.stringify(M)}catch{}o+=(S>0?" ":"")+M}return o}e.format=E;class f extends C.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==y.Off&&this.b<=o}}e.AbstractLogger=f;class w extends f{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...S){this.f(y.Trace)&&this.g(y.Trace,E([o,...S]))}debug(o,...S){this.f(y.Debug)&&this.g(y.Debug,E([o,...S]))}info(o,...S){this.f(y.Info)&&this.g(y.Info,E([o,...S]))}warn(o,...S){this.f(y.Warning)&&this.g(y.Warning,E([o,...S]))}error(o,...S){if(this.f(y.Error))if(o instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=o.stack,this.g(y.Error,E(M))}else this.g(y.Error,E([o,...S]))}flush(){}}e.AbstractMessageLogger=w;class d extends f{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!A.isWindows}trace(o,...S){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,o,...S):console.log(`[main ${m()}]`,o,...S))}debug(o,...S){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,o,...S):console.log(`[main ${m()}]`,o,...S))}info(o,...S){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,o,...S):console.log(`[main ${m()}]`,o,...S))}warn(o,...S){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,o,...S):console.warn(`[main ${m()}]`,o,...S))}error(o,...S){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,o,...S):console.error(`[main ${m()}]`,o,...S))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class b extends f{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...S){this.f(y.Trace)&&console.log("%cTRACE","color: #888",o,...S)}debug(o,...S){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",o,...S)}info(o,...S){this.f(y.Info)&&console.log("%c INFO","color: #33f",o,...S)}warn(o,...S){this.f(y.Warning)&&console.log("%c WARN","color: #993",o,...S)}error(o,...S){this.f(y.Error)&&console.log("%c  ERR","color: #f33",o,...S)}dispose(){}flush(){}}e.ConsoleLogger=b;class u extends f{constructor(o,S=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(S)}trace(o,...S){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(o),...S])}debug(o,...S){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(o),...S])}info(o,...S){this.f(y.Info)&&this.g.log(y.Info,[this.h(o),...S])}warn(o,...S){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(o),...S])}error(o,...S){this.f(y.Error)&&this.g.log(y.Error,[this.h(o),...S])}h(o){return typeof o=="string"?o:(0,I.toErrorMessage)(o,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=u;class v extends f{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const S of this.g)S.setLevel(o);super.setLevel(o)}trace(o,...S){for(const M of this.g)M.trace(o,...S)}debug(o,...S){for(const M of this.g)M.debug(o,...S)}info(o,...S){for(const M of this.g)M.info(o,...S)}warn(o,...S){for(const M of this.g)M.warn(o,...S)}error(o,...S){for(const M of this.g)M.error(o,...S)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogService=v;class g extends C.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...S){this.b.trace(o,...S)}debug(o,...S){this.b.debug(o,...S)}info(o,...S){this.b.info(o,...S)}warn(o,...S){this.b.warn(o,...S)}error(o,...S){this.b.error(o,...S)}flush(){this.b.flush()}}e.LogService=g;class h extends C.Disposable{constructor(o,S){super(),this.c=o,this.b=new R.ResourceMap,this.B(S(M=>this.setLevel(M)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,S,M){let L=this.b.get(o)?.logger;return L||(M=S?.always?y.Trace:M,L=this.f(o,M??this.c,S),this.b.set(o,{logger:L,logLevel:M})),L}setLevel(o,S){const M=k.URI.isUri(o)?o:void 0,L=M?S:o;if(M){const B=this.b.get(M);B&&B.logLevel!==L&&(B.logLevel=L,B.logger.setLevel(L))}else this.c=L,this.b.forEach(({logLevel:B,logger:J})=>{B===void 0&&J.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=h;class l{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return y.Info}trace(o,...S){}debug(o,...S){}info(o,...S){}warn(o,...S){}error(o,...S){}critical(o,...S){}dispose(){}flush(){}}e.NullLogger=l;class i extends l{}e.NullLogService=i;class s extends h{constructor(){super(y.Info,t.Event.None)}f(o,S,M){return new l}}e.NullLoggerService=s;function n(c){if(c.verbose)return y.Trace;if(typeof c.logLevel=="string"){const o=r(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function a(c){switch(c){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=a;function r(c){switch(c){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=r});var ie=this&&this.__param||function(H,e){return function(I,t){e(I,t,H)}};define(ee[202],te([0,1,71,3,2,6,4,8]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let p=class Et extends C.Disposable{constructor(y){super(),this.g=y,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(y,P){this.g.trace("Getting password from keytar:",y,P);let E;try{E=await this.h()}catch{return null}const f=await(0,k.retry)(()=>E.getPassword(y,P),50,3);if(!f)return this.g.trace("Did not get a password from keytar for account:",P),f;let w,d;try{const b=JSON.parse(f);w=b.content,d=b.hasNextChunk}catch{}if(!w||!d)return this.g.trace("Got password from keytar for account:",P),f;try{let b=1;for(;d;){const u=await(0,k.retry)(()=>E.getPassword(y,`${P}-${b}`),50,3),v=JSON.parse(u);w+=v.content,d=v.hasNextChunk,b++}return this.g.trace(`Got ${b}-chunked password from keytar for account:`,P),w}catch(b){return this.g.error(b),f}}async setPassword(y,P,E){this.g.trace("Setting password using keytar:",y,P);let f;try{f=await this.h()}catch(w){throw this.i?.(w),w}if(A.isWindows&&E.length>Et.a){let w=0,d=0,b=!0;for(;b;){const u=E.substring(w,w+Et.b);w+=Et.b,b=E.length-w>0;const v={content:u,hasNextChunk:b};await(0,k.retry)(()=>f.setPassword(y,d?`${P}-${d}`:P,JSON.stringify(v)),50,3),d++}this.g.trace(`Got${d?` ${d}-chunked`:""} password from keytar for account:`,P)}else await(0,k.retry)(()=>f.setPassword(y,P,E),50,3),this.g.trace("Got password from keytar for account:",P);this.c.fire({service:y,account:P})}async deletePassword(y,P){this.g.trace("Deleting password using keytar:",y,P);let E;try{E=await this.h()}catch(u){throw this.i?.(u),u}const f=await E.getPassword(y,P);if(!f)return this.g.trace("Did not get a password to delete from keytar for account:",P),!1;let w,d;try{const u=JSON.parse(f);w=u.content,d=u.hasNextChunk}catch{}let b=0;if(w&&d)try{for(b++;d;){const u=`${P}-${b}`,v=await E.getPassword(y,u);await E.deletePassword(y,u),d=JSON.parse(v).hasNextChunk,b++}}catch(u){this.g.error(u)}return await E.deletePassword(y,P)?(this.c.fire({service:y,account:P}),this.g.trace(`Deleted${b?` ${b}-chunked`:""} password from keytar for account:`,P),!0):(this.g.trace(`Keytar failed to delete${b?` ${b}-chunked`:""} password for account:`,P),!1)}async findPassword(y){let P;try{P=await this.h()}catch{return null}return await P.findPassword(y)}async findCredentials(y){let P;try{P=await this.h()}catch{return[]}return await P.findCredentials(y)}clear(){return this.f instanceof I.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};p.a=2500,p.b=p.a-100,p=pe([ie(0,R.ILogService)],p),e.BaseCredentialsMainService=p}),define(ee[203],te([0,1,6]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(R,A){this.a=R,this.b=A}c(){return new Promise((R,A)=>H(["vscode-encrypt"],R,A))}async encrypt(R){let A;try{A=await this.c()}catch{return R}try{return A.encrypt(this.a,R)}catch(k){return this.b.error(k),R}}async decrypt(R){let A;try{A=await this.c()}catch{return R}try{return A.decrypt(this.a,R)}catch(k){return this.b.error(k),R}}};t=pe([ie(1,I.ILogService)],t),e.EncryptionMainService=t}),define(ee[204],te([0,1,24,8,14,3,2,9,72,6]),function(H,e,I,t,C,R,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends A.Disposable{constructor(E,f){super(),this.a=E,this.b=f,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(E,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(E,f):this.u(E,f)}l(E,f){const w={path:this.C(E),excludes:f.excludes,includes:f.includes,recursive:f.recursive},d=(0,I.insert)(this.j,w);return this.m(),(0,A.toDisposable)(()=>{d(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(E=>(0,C.onUnexpectedError)(E))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,p.toFileChanges)(f)),f=>this.z(f),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const E=this.b?.watcher?.recursive?.usePolling;if(E===!0)for(const f of this.j)(0,p.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const f of this.j)(0,p.isRecursiveWatchRequest)(f)&&E.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(E,f){const w={path:this.C(E),excludes:f.excludes,includes:f.includes,recursive:!1},d=(0,I.insert)(this.s,w);return this.v(),(0,A.toDisposable)(()=>{d(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(E=>(0,C.onUnexpectedError)(E))}w(){return this.r||(this.r=this.B(this.y(E=>this.c.fire((0,p.toFileChanges)(E)),E=>this.z(E),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(E){E.type==="error"&&this.g.fire(E.message),this.a[E.type](E.message)}C(E){return(0,k.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(ee[205],te([0,1,24,8,17,22,3,68,67,2,60,15,73,20,59,158,16,108,6]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends m.Disposable{constructor(l){super(),this.b=l,this.a=256*1024,this.c=this.B(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new A.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new A.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new t.ResourceQueue)}registerProvider(l,i){if(this.h.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${l}`);const s=new m.DisposableStore;return this.h.set(l,i),this.c.fire({added:!0,scheme:l,provider:i}),s.add(i.onDidChangeFile(n=>this.Q.fire(new b.FileChangesEvent(n,!this.N(i))))),typeof i.onDidWatchError=="function"&&s.add(i.onDidWatchError(n=>this.R.fire(new Error(n)))),s.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:l}))),(0,m.toDisposable)(()=>{this.c.fire({added:!1,scheme:l,provider:i}),this.h.delete(l),(0,m.dispose)(s)})}getProvider(l){return this.h.get(l)}async activateProvider(l){const i=[];this.f.fire({scheme:l,join(s){i.push(s)}}),!this.h.has(l)&&await t.Promises.settled(i)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.h.has(l.scheme)}hasCapability(l,i){const s=this.h.get(l.scheme);return!!(s&&s.capabilities&i)}listCapabilities(){return p.Iterable.map(this.h,([l,i])=>({scheme:l,capabilities:i.capabilities}))}async j(l){if(!(0,f.isAbsolutePath)(l))throw new b.FileOperationError((0,d.localize)(0,null,this.mb(l)),8);await this.activateProvider(l.scheme);const i=this.h.get(l.scheme);if(!i){const s=new Error;throw s.name="ENOPRO",s.message=(0,d.localize)(1,null,l.toString()),s}return i}async k(l){const i=await this.j(l);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)||(0,b.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(l){const i=await this.j(l);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,i){try{return await this.n(l,i)}catch(s){throw(0,b.toFileSystemProviderErrorCode)(s)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,d.localize)(2,null,this.mb(l)),1):(0,b.ensureFileSystemProviderError)(s)}}async n(l,i){const s=await this.j(l),n=this.N(s),a=i?.resolveTo,r=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,o=await s.stat(l);let S;return this.p(s,l,o,void 0,!!c,(M,L)=>(S||(S=y.TernarySearchTree.forUris(()=>!n),S.set(l,!0),a&&S.fill(!0,a)),S.get(M.resource)||S.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&r?L===1:!1))}async p(l,i,s,n,a,r){const{providerExtUri:c}=this.M(l),o={resource:i,name:c.basename(i),isFile:(s.type&b.FileType.File)!==0,isDirectory:(s.type&b.FileType.Directory)!==0,isSymbolicLink:(s.type&b.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&b.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,b.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(o.isDirectory&&r(o,n)){try{const S=await l.readdir(i),M=await t.Promises.settled(S.map(async([L,B])=>{try{const J=c.joinPath(i,L),ae=a?await l.stat(J):{type:B};return await this.p(l,J,ae,S.length,a,r)}catch(J){return this.b.trace(J),null}}));o.children=(0,I.coalesce)(M)}catch(S){this.b.trace(S),o.children=[]}return o}return o}async resolveAll(l){return t.Promises.settled(l.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(l){const i=await this.j(l),s=await i.stat(l);return this.p(i,l,s,void 0,!0,()=>!1)}async exists(l){const i=await this.j(l);try{return!!await i.stat(l)}catch{return!1}}async canCreateFile(l,i){try{await this.r(l,i)}catch(s){return s}return!0}async r(l,i){if(!i?.overwrite&&await this.exists(l))throw new b.FileOperationError((0,d.localize)(3,null,this.mb(l)),3,i)}async createFile(l,i=C.VSBuffer.fromString(""),s){await this.r(l,s);const n=await this.writeFile(l,i);return this.m.fire(new b.FileOperationEvent(l,0,n)),n}async writeFile(l,i,s){const n=this.kb(await this.l(l),l),{providerExtUri:a}=this.M(n);try{await this.s(n,l,s)||await this.O(n,a.dirname(l));let c;if((0,b.hasReadWriteCapability)(n)&&!(i instanceof C.VSBuffer))if((0,w.isReadableStream)(i)){const o=await(0,w.peekStream)(i,3);o.ended?c=C.VSBuffer.concat(o.buffer):c=o}else c=(0,w.peekReadable)(i,o=>C.VSBuffer.concat(o),3);else c=i;!(0,b.hasOpenReadWriteCloseCapability)(n)||(0,b.hasReadWriteCapability)(n)&&c instanceof C.VSBuffer?await this.bb(n,l,s,c):await this.X(n,l,s,c instanceof C.VSBuffer?(0,C.bufferToReadable)(c):c),this.m.fire(new b.FileOperationEvent(l,4))}catch(r){throw new b.FileOperationError((0,d.localize)(4,null,this.mb(l),(0,b.ensureFileSystemProviderError)(r).toString()),(0,b.toFileOperationResult)(r),s)}return this.resolve(l,{resolveMetadata:!0})}async s(l,i,s){if(!!s?.unlock&&!(l.capabilities&8192))throw new Error((0,d.localize)(5,null,this.mb(i)));let a;try{a=await l.stat(i)}catch{return}if((a.type&b.FileType.Directory)!==0)throw new b.FileOperationError((0,d.localize)(6,null,this.mb(i)),0,s);if(this.lb(i,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==b.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,b.etag)({mtime:s.mtime,size:a.size}))throw new b.FileOperationError((0,d.localize)(7,null),3,s);return a}async readFile(l,i,s){const n=await this.k(l);return i?.atomic?this.t(n,l,i,s):this.u(n,l,i,s)}async t(l,i,s,n){return new Promise((a,r)=>{this.W.queueFor(i,this.M(l).providerExtUri).queue(async()=>{try{const c=await this.u(l,i,s,n);a(c)}catch(c){r(c)}})})}async u(l,i,s,n){const a=await this.v(l,i,{...s,preferUnbuffered:!0},n);return{...a,value:await(0,C.streamToBuffer)(a.value)}}async readFileStream(l,i,s){const n=await this.k(l);return this.v(n,l,i,s)}async v(l,i,s,n){const a=new R.CancellationTokenSource(n),r=this.D(i,s).then(o=>o,o=>{throw a.cancel(),o});let c;try{return typeof s?.etag=="string"&&s.etag!==b.ETAG_DISABLED&&await r,s?.atomic&&(0,b.hasFileAtomicReadCapability)(l)||!((0,b.hasOpenReadWriteCloseCapability)(l)||(0,b.hasFileReadStreamCapability)(l))||(0,b.hasReadWriteCapability)(l)&&s?.preferUnbuffered?c=this.C(l,i,s):(0,b.hasFileReadStreamCapability)(l)?c=this.w(l,i,a.token,s):c=this.z(l,i,a.token,s),{...await r,value:c}}catch(o){c&&await(0,w.consumeStream)(c);const S=(0,d.localize)(8,null,this.mb(i),(0,b.ensureFileSystemProviderError)(o).toString());throw o instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(S,o.stat,s):new b.FileOperationError(S,(0,b.toFileOperationResult)(o),s)}}w(l,i,s,n=Object.create(null)){const a=l.readFileStream(i,n,s);return(0,w.transform)(a,{data:r=>r instanceof C.VSBuffer?r:C.VSBuffer.wrap(r),error:r=>new b.FileOperationError((0,d.localize)(9,null,this.mb(i),(0,b.ensureFileSystemProviderError)(r).toString()),(0,b.toFileOperationResult)(r),n)},r=>C.VSBuffer.concat(r))}z(l,i,s,n=Object.create(null)){const a=(0,C.newWriteableBufferStream)();return(0,u.readFileIntoStream)(l,i,a,r=>r,{...n,bufferSize:this.a,errorTransformer:r=>new b.FileOperationError((0,d.localize)(10,null,this.mb(i),(0,b.ensureFileSystemProviderError)(r).toString()),(0,b.toFileOperationResult)(r),n)},s),a}C(l,i,s){const n=(0,w.newWriteableStream)(a=>C.VSBuffer.concat(a));return(async()=>{try{let a;s?.atomic&&(0,b.hasFileAtomicReadCapability)(l)?a=await l.readFile(i,{atomic:!0}):a=await l.readFile(i),typeof s?.position=="number"&&(a=a.slice(s.position)),typeof s?.length=="number"&&(a=a.slice(0,s.length)),this.F(i,a.byteLength,s),n.end(C.VSBuffer.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async D(l,i){const s=await this.resolve(l,{resolveMetadata:!0});if(s.isDirectory)throw new b.FileOperationError((0,d.localize)(11,null,this.mb(l)),0,i);if(typeof i?.etag=="string"&&i.etag!==b.ETAG_DISABLED&&i.etag===s.etag)throw new b.NotModifiedSinceFileOperationError((0,d.localize)(12,null),s,i);return this.F(l,s.size,i),s}F(l,i,s){if(s?.limits){let n;if(typeof s.limits.memory=="number"&&i>s.limits.memory&&(n=9),typeof s.limits.size=="number"&&i>s.limits.size&&(n=7),typeof n=="number")throw new b.FileOperationError((0,d.localize)(13,null,this.mb(l)),n)}}async canMove(l,i,s){return this.G(l,i,"move",s)}async canCopy(l,i,s){return this.G(l,i,"copy",s)}async G(l,i,s,n){if(l.toString()!==i.toString())try{const a=s==="move"?this.kb(await this.l(l),l):await this.k(l),r=this.kb(await this.l(i),i);await this.L(a,l,r,i,s,n)}catch(a){return a}return!0}async move(l,i,s){const n=this.kb(await this.l(l),l),a=this.kb(await this.l(i),i),r=await this.H(n,l,a,i,"move",!!s),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(l,r==="move"?2:3,c)),c}async copy(l,i,s){const n=await this.k(l),a=this.kb(await this.l(i),i),r=await this.H(n,l,a,i,"copy",!!s),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(l,r==="copy"?3:2,c)),c}async H(l,i,s,n,a,r){if(i.toString()===n.toString())return a;const{exists:c,isSameResourceWithDifferentPathCase:o}=await this.L(l,i,s,n,a,r);if(c&&!o&&r&&await this.del(n,{recursive:!0}),await this.O(s,this.M(s).providerExtUri.dirname(n)),a==="copy"){if(l===s&&(0,b.hasFileFolderCopyCapability)(l))await l.copy(i,n,{overwrite:r});else{const S=await this.resolve(i);S.isDirectory?await this.J(l,S,s,n):await this.I(l,i,s,n)}return a}else return l===s?(await l.rename(i,n,{overwrite:r}),a):(await this.H(l,i,s,n,"copy",r),await this.del(i,{recursive:!0}),"copy")}async I(l,i,s,n){if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(s))return this.db(l,i,s,n);if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasReadWriteCapability)(s))return this.jb(l,i,s,n);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(s))return this.hb(l,i,s,n);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasReadWriteCapability)(s))return this.fb(l,i,s,n)}async J(l,i,s,n){await s.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async a=>{const r=this.M(s).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.J(l,await this.resolve(a.resource),s,r):this.I(l,a.resource,s,r)}))}async L(l,i,s,n,a,r){let c=!1;if(l===s){const{providerExtUri:S,isPathCaseSensitive:M}=this.M(l);if(M||(c=S.isEqual(i,n)),c&&a==="copy")throw new Error((0,d.localize)(14,null,this.mb(i),this.mb(n)));if(!c&&S.isEqualOrParent(n,i))throw new Error((0,d.localize)(15,null,this.mb(i),this.mb(n)))}const o=await this.exists(n);if(o&&!c){if(!r)throw new b.FileOperationError((0,d.localize)(16,null,this.mb(i),this.mb(n)),4);if(l===s){const{providerExtUri:S}=this.M(l);if(S.isEqualOrParent(i,n))throw new Error((0,d.localize)(17,null,this.mb(i),this.mb(n)))}}return{exists:o,isSameResourceWithDifferentPathCase:c}}M(l){const i=this.N(l);return{providerExtUri:i?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:i}}N(l){return!!(l.capabilities&1024)}async createFolder(l){const i=this.kb(await this.j(l),l);await this.O(i,l);const s=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(l,0,s)),s}async O(l,i){const s=[],{providerExtUri:n}=this.M(l);for(;!n.isEqual(i,n.dirname(i));)try{if(((await l.stat(i)).type&b.FileType.Directory)===0)throw new Error((0,d.localize)(18,null,this.mb(i)));break}catch(a){if((0,b.toFileSystemProviderErrorCode)(a)!==b.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(n.basename(i)),i=n.dirname(i)}for(let a=s.length-1;a>=0;a--){i=n.joinPath(i,s[a]);try{await l.mkdir(i)}catch(r){if((0,b.toFileSystemProviderErrorCode)(r)!==b.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(l,i){try{await this.P(l,i)}catch(s){return s}return!0}async P(l,i){const s=this.kb(await this.j(l),l);if(!!i?.useTrash&&!(s.capabilities&4096))throw new Error((0,d.localize)(19,null,this.mb(l)));let a;try{a=await s.stat(l)}catch{}if(a)this.lb(l,a);else throw new b.FileOperationError((0,d.localize)(20,null,this.mb(l)),1);if(!!!i?.recursive){const c=await this.resolve(l);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,d.localize)(21,null,this.mb(l)))}return s}async del(l,i){const s=await this.P(l,i),n=!!i?.useTrash,a=!!i?.recursive;await s.delete(l,{recursive:a,useTrash:n}),this.m.fire(new b.FileOperationEvent(l,1))}async cloneFile(l,i){const s=await this.j(l),n=this.kb(await this.l(i),i);if(s===n&&this.M(s).providerExtUri.isEqual(l,i))return;if(s===n&&(0,b.hasFileCloneCapability)(s))return s.cloneFile(l,i);await this.O(n,this.M(n).providerExtUri.dirname(i));const a=this.W.queueFor(l,this.M(s).providerExtUri);return s===n&&(0,b.hasFileFolderCopyCapability)(s)?a.queue(()=>s.copy(l,i,{overwrite:!0})):a.queue(()=>this.I(s,l,n,i))}watch(l,i={recursive:!1,excludes:[]}){const s=new m.DisposableStore;let n=!1,a=()=>{n=!0};return s.add((0,m.toDisposable)(()=>a())),(async()=>{try{const r=await this.U(l,i);n?(0,m.dispose)(r):a=()=>(0,m.dispose)(r)}catch(r){this.b.error(r)}})(),s}async U(l,i){const s=await this.j(l),n=(0,k.hash)([this.M(s).providerExtUri.getComparisonKey(l),i]);let a=this.S.get(n);return a||(a={count:0,disposable:s.watch(l,i)},this.S.set(n,a)),a.count+=1,(0,m.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,m.dispose)(a.disposable),this.S.delete(n)))})}dispose(){super.dispose();for(const[,l]of this.S)(0,m.dispose)(l.disposable);this.S.clear()}async X(l,i,s,n){return this.W.queueFor(i,this.M(l).providerExtUri).queue(async()=>{const a=await l.open(i,{create:!0,unlock:s?.unlock??!1});try{(0,w.isReadableStream)(n)||(0,w.isReadableBufferedStream)(n)?await this.Y(l,a,n):await this.Z(l,a,n)}catch(r){throw(0,b.ensureFileSystemProviderError)(r)}finally{await l.close(a)}})}async Y(l,i,s){let n=0,a;if((0,w.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=C.VSBuffer.concat(s.buffer);await this.ab(l,i,r,r.byteLength,n,0),n+=r.byteLength}if(s.ended)return;a=s.stream}else a=s;return new Promise((r,c)=>{(0,w.listenStream)(a,{onData:async o=>{a.pause();try{await this.ab(l,i,o,o.byteLength,n,0)}catch(S){return c(S)}n+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>c(o),onEnd:()=>r()})})}async Z(l,i,s){let n=0,a;for(;(a=s.read())!==null;)await this.ab(l,i,a,a.byteLength,n,0),n+=a.byteLength}async ab(l,i,s,n,a,r){let c=0;for(;c<n;)c+=await l.write(i,a+c,s.buffer,r+c,n-c)}async bb(l,i,s,n){return this.W.queueFor(i,this.M(l).providerExtUri).queue(()=>this.cb(l,i,s,n))}async cb(l,i,s,n){let a;n instanceof C.VSBuffer?a=n:(0,w.isReadableStream)(n)?a=await(0,C.streamToBuffer)(n):(0,w.isReadableBufferedStream)(n)?a=await(0,C.bufferedStreamToBuffer)(n):a=(0,C.readableToBuffer)(n),await l.writeFile(i,a.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async db(l,i,s,n){return this.W.queueFor(n,this.M(s).providerExtUri).queue(()=>this.eb(l,i,s,n))}async eb(l,i,s,n){let a,r;try{a=await l.open(i,{create:!1}),r=await s.open(n,{create:!0,unlock:!1});const c=C.VSBuffer.alloc(this.a);let o=0,S=0,M=0;do M=await l.read(a,o,c.buffer,S,c.byteLength-S),await this.ab(s,r,c,M,o,S),o+=M,S+=M,S===c.byteLength&&(S=0);while(M>0)}catch(c){throw(0,b.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof a=="number"?l.close(a):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async fb(l,i,s,n){return this.W.queueFor(n,this.M(s).providerExtUri).queue(()=>this.gb(l,i,s,n))}async gb(l,i,s,n){return s.writeFile(n,await l.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async hb(l,i,s,n){return this.W.queueFor(n,this.M(s).providerExtUri).queue(()=>this.ib(l,i,s,n))}async ib(l,i,s,n){const a=await s.open(n,{create:!0,unlock:!1});try{const r=await l.readFile(i);await this.ab(s,a,C.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,b.ensureFileSystemProviderError)(r)}finally{await s.close(a)}}async jb(l,i,s,n){const a=await(0,C.streamToBuffer)(this.z(l,i,R.CancellationToken.None));await this.bb(s,n,void 0,a)}kb(l,i){if(l.capabilities&2048)throw new b.FileOperationError((0,d.localize)(22,null,this.mb(i)),6);return l}lb(l,i){if((i.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,d.localize)(23,null,this.mb(l)),6)}mb(l){return l.scheme===P.Schemas.file?l.fsPath:l.toString(!0)}};g=pe([ie(0,v.ILogService)],g),e.FileService=g}),define(ee[86],te([0,1,40,281,8,39,17,3,30,2,9,4,20,59,23,162,16,108,204,45,200,199]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(I)}catch(s){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(s)}`)}})();class i extends v.AbstractDiskFileSystemProvider{constructor(n,a){super(n,a),this.onDidChangeCapabilities=k.Event.None,this.H=new R.ResourceMap(r=>E.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,P.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:a,symbolicLink:r}=await w.SymlinkSupport.stat(this.C(n));return{type:this.G(a,r),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.Y(a)}}async readdir(n){try{const a=await w.Promises.readdir(this.C(n),{withFileTypes:!0}),r=[];return await Promise.all(a.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,E.joinPath)(n,c.name))).type:o=this.G(c),r.push([c.name,o])}catch(o){this.a.trace(o)}})),r}catch(a){throw this.Y(a)}}G(n,a){let r;return a?.dangling?r=b.FileType.Unknown:n.isFile()?r=b.FileType.File:n.isDirectory()?r=b.FileType.Directory:r=b.FileType.Unknown,a&&(r|=b.FileType.SymbolicLink),r}async I(n){const a=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let r;for(;r=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await r.wait();const c=new C.Barrier;return this.H.set(n,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,m.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.H.get(n)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),c.open()})}async readFile(n,a){let r;try{a?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),r=await this.I(n));const c=this.C(n);return await w.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{r?.dispose()}}J(n){i.D&&this.a.trace(n)}readFileStream(n,a,r){const c=(0,f.newWriteableStream)(o=>A.VSBuffer.concat(o.map(S=>A.VSBuffer.wrap(S))).buffer);return(0,u.readFileIntoStream)(this,n,c,o=>o.buffer,{...a,bufferSize:256*1024},r),c}async writeFile(n,a,r){let c;try{const o=this.C(n);if(!r.create||!r.overwrite){if(await w.Promises.exists(o)){if(!r.overwrite)throw(0,b.createFileSystemProviderError)((0,d.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,b.createFileSystemProviderError)((0,d.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(c,0,a,0,a.byteLength)}catch(o){throw await this.Z(n,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){i.O=n}async open(n,a){const r=this.C(n);let c;(0,b.isFileOpenForWriteOptions)(a)&&(c=await this.I(n));let o;try{if((0,b.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:M}=await w.SymlinkSupport.stat(r);M.mode&128||await w.Promises.chmod(r,M.mode|128)}catch(M){this.a.trace(M)}let S;if((0,b.isFileOpenForWriteOptions)(a)){if(P.isWindows)try{await w.Promises.truncate(r,0),S="r+"}catch(M){M.code!=="ENOENT"&&this.a.trace(M)}S||(S="w")}else S="r";o=await w.Promises.open(r,S)}catch(S){throw c?.dispose(),(0,b.isFileOpenForWriteOptions)(a)?await this.Z(n,S):this.Y(S)}if(this.L.set(o,0),(0,b.isFileOpenForWriteOptions)(a)&&this.N.set(o,n),c){const S=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.M.set(o,c),S&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),S.dispose())}return o}async close(n){const a=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&i.O)try{await w.Promises.fdatasync(n)}catch(r){i.configureFlushOnWrite(!1),this.a.error(r)}return await w.Promises.close(n)}catch(r){throw this.Y(r)}finally{a&&(this.M.get(n)===a&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),a.dispose())}}async read(n,a,r,c,o){const S=this.P(n,a);let M=null;try{M=(await w.Promises.read(n,r,c,o,S)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(n,S,M)}return M}P(n,a){return a===this.L.get(n)?null:a}Q(n,a,r){const c=this.L.get(n);typeof c=="number"&&(typeof a=="number"||(typeof r=="number"?this.L.set(n,c+r):this.L.delete(n)))}async write(n,a,r,c,o){return(0,C.retry)(()=>this.R(n,a,r,c,o),100,3)}async R(n,a,r,c,o){const S=this.P(n,a);let M=null;try{M=(await w.Promises.write(n,r,c,o,S)).bytesWritten}catch(L){throw await this.Z(this.N.get(n),L)}finally{this.Q(n,S,M)}return M}async mkdir(n){try{await w.Promises.mkdir(this.C(n))}catch(a){throw this.Y(a)}}async delete(n,a){try{const r=this.C(n);a.recursive?await w.Promises.rm(r,w.RimRafMode.MOVE):await w.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(n,a,r){const c=this.C(n),o=this.C(a);if(c!==o)try{await this.S(n,a,"move",r.overwrite),await w.Promises.move(c,o)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,d.localize)(2,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(o)),S.toString()))),this.Y(S)}}async copy(n,a,r){const c=this.C(n),o=this.C(a);if(c!==o)try{await this.S(n,a,"copy",r.overwrite),await w.Promises.copy(c,o,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,d.localize)(3,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(o)),S.toString()))),this.Y(S)}}async S(n,a,r,c){const o=this.C(n),S=this.C(a);let M=!1;if(!!(this.capabilities&1024)||(M=(0,p.isEqual)(o,S,!0)),M&&r==="copy")throw(0,b.createFileSystemProviderError)((0,d.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!M&&await w.Promises.exists(S)){if(!c)throw(0,b.createFileSystemProviderError)((0,d.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(n,a){return this.U(n,a,!1)}async U(n,a,r){const c=this.C(n),o=this.C(a),S=!!(this.capabilities&1024);if((0,p.isEqual)(c,o,!S))return;const M=new m.DisposableStore;try{const[L,B]=await Promise.all([this.I(n),this.I(a)]);M.add(L),M.add(B),r&&await w.Promises.mkdir((0,y.dirname)(o),{recursive:!0}),await w.Promises.copyFile(c,o)}catch(L){if(L.code==="ENOENT"&&!r)return this.U(n,a,!0);throw this.Y(L)}finally{M.dispose()}}p(n,a,r){return new h.UniversalWatcherClient(c=>n(c),c=>a(c),r)}y(n,a,r){return new l.NodeJSWatcherClient(c=>n(c),c=>a(c),r)}Y(n){if(n instanceof b.FileSystemProviderError)return n;let a;switch(n.code){case"ENOENT":a=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=b.FileSystemProviderErrorCode.NoPermissions;break;default:a=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(n,a)}async Z(n,a){let r=this.Y(a);if(n&&r.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await w.SymlinkSupport.stat(this.C(n));c.mode&128||(r=(0,b.createFileSystemProviderError)(a,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return r}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(ee[206],te([0,1,3,86,2,17,59,22]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class p extends C.Disposable{constructor(P,E){super(),this.a=P,this.b=E,this.w=new Map,this.y=new Map}call(P,E,f){const w=this.c(P);switch(E){case"stat":return this.g(w,f[0]);case"readdir":return this.h(w,f[0]);case"open":return this.l(w,f[0],f[1]);case"close":return this.m(f[0]);case"read":return this.n(f[0],f[1],f[2]);case"readFile":return this.i(w,f[0],f[1]);case"write":return this.p(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.k(w,f[0],f[1],f[2]);case"rename":return this.t(w,f[0],f[1],f[2]);case"copy":return this.u(w,f[0],f[1],f[2]);case"cloneFile":return this.v(w,f[0],f[1]);case"mkdir":return this.r(w,f[0]);case"delete":return this.s(w,f[0],f[1]);case"watch":return this.C(w,f[0],f[1],f[2],f[3]);case"unwatch":return this.D(f[0],f[1])}throw new Error(`IPC Command ${E} not found`)}listen(P,E,f){const w=this.c(P);switch(E){case"fileChange":return this.z(w,f[0]);case"readFileStream":return this.j(w,f[0],f[1])}throw new Error(`Unknown event ${E}`)}g(P,E){const f=this.f(P,E,!0);return this.a.stat(f)}h(P,E){const f=this.f(P,E);return this.a.readdir(f)}async i(P,E,f){const w=this.f(P,E,!0),d=await this.a.readFile(w,f);return R.VSBuffer.wrap(d)}j(P,E,f){const w=this.f(P,E,!0),d=new k.CancellationTokenSource,b=new I.Emitter({onDidRemoveLastListener:()=>{d.cancel()}}),u=this.a.readFileStream(w,f,d.token);return(0,A.listenStream)(u,{onData:v=>b.fire(R.VSBuffer.wrap(v)),onError:v=>b.fire(v),onEnd:()=>{b.fire("end"),b.dispose(),d.dispose()}}),b.event}k(P,E,f,w){const d=this.f(P,E);return this.a.writeFile(d,f.buffer,w)}l(P,E,f){const w=this.f(P,E,!0);return this.a.open(w,f)}m(P){return this.a.close(P)}async n(P,E,f){const w=R.VSBuffer.alloc(f),d=0,b=await this.a.read(P,E,w.buffer,d,f);return[w,b]}p(P,E,f,w,d){return this.a.write(P,E,f.buffer,w,d)}r(P,E){const f=this.f(P,E);return this.a.mkdir(f)}s(P,E,f){const w=this.f(P,E);return this.a.delete(w,f)}t(P,E,f,w){const d=this.f(P,E),b=this.f(P,f);return this.a.rename(d,b,w)}u(P,E,f,w){const d=this.f(P,E),b=this.f(P,f);return this.a.copy(d,b,w)}v(P,E,f){const w=this.f(P,E),d=this.f(P,f);return this.a.cloneFile(w,d)}z(P,E){const f=new I.Emitter({onWillAddFirstListener:()=>{this.w.set(E,this.F(P,f))},onDidRemoveLastListener:()=>{(0,C.dispose)(this.w.get(E)),this.w.delete(E)}});return f.event}async C(P,E,f,w,d){const b=this.w.get(E);if(b){const u=this.f(P,w),v=b.watch(f,u,d);this.y.set(E+f,v)}}async D(P,E){const f=P+E,w=this.y.get(f);w&&((0,C.dispose)(w),this.y.delete(f))}dispose(){super.dispose();for(const[,P]of this.y)P.dispose();this.y.clear();for(const[,P]of this.w)P.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=p;class m extends C.Disposable{constructor(P,E,f,w){super(),this.c=P,this.f=f,this.g=w,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(E)}h(P){const E=this.B(new I.Emitter);this.B(E.event(f=>{P.fire(f.map(w=>({resource:this.c.transformOutgoingURI(w.resource),type:w.type})))})),this.B(this.b.onDidChangeFile(f=>E.fire(f))),this.B(this.b.onDidWatchError(f=>P.fire(f)))}i(P){}j(P){}watch(P,E,f){const w=this.j(this.g);return Array.isArray(w)&&(f.excludes=[...f.excludes,...w]),this.a.set(P,this.b.watch(E,f)),(0,C.toDisposable)(()=>{(0,C.dispose)(this.a.get(P)),this.a.delete(P)})}dispose(){super.dispose();for(const[,P]of this.a)P.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=m}),define(ee[207],te([0,1,13,161,4,7,16,9,206,140]),function(H,e,I,t,C,R,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class y extends p.AbstractDiskFileSystemProviderChannel{constructor(f,w,d){super(f,w),this.G=d}c(f){return m.DefaultURITransformer}f(f,w){return R.URI.revive(w)}async s(f,w,d){if(!d.useTrash)return super.s(f,w,d);const b=this.f(f,w),u=(0,k.normalize)(b.fsPath);try{await I.shell.trashItem(u)}catch{throw(0,A.createFileSystemProviderError)(C.isWindows?(0,t.localize)(0,null,(0,k.basename)(u)):(0,t.localize)(1,null,(0,k.basename)(u)),A.FileSystemProviderErrorCode.Unknown)}}F(f,w){return new P(f,w,this.b,this.G)}}e.DiskFileSystemProviderChannel=y;class P extends p.AbstractSessionFileWatcher{watch(f,w,d){if(d.recursive)throw(0,A.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(f,w,d)}}}),define(ee[208],te([0,1,6]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends I.AbstractMessageLogger{constructor(R=I.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(A=>{this.l?.setLevel(A)}))}set logger(R){this.l=R;for(const{level:A,message:k}of this.k)(0,I.log)(R,A,k);this.k=[]}g(R,A){this.l?(0,I.log)(this.l,R,A):this.getLevel()<=R&&this.k.push({level:R,message:A})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(ee[209],te([0,1,3,7,6]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(E,f){this.a=E,this.b=f,this.onDidChangeLogLevel=I.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,f){switch(f){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${f}`)}async call(E,f,w){switch(f){case"setLevel":return w[1]?this.b.setLevel(t.URI.revive(w[1]),w[0]):this.a.setLevel(w[0])}throw new Error(`Call not found: ${f}`)}}e.LogLevelChannel=R;class A{constructor(E){this.a=E}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(E,f){A.setLevel(this.a,E,f)}static setLevel(E,f,w){return E.call("setLevel",[f,w])}}e.LogLevelChannelClient=A;class k{constructor(E){this.b=E,this.a=new Map}listen(E,f){throw new Error(`Event not found: ${f}`)}async call(E,f,w){switch(f){case"createLogger":this.c(t.URI.revive(w[0]),w[1]);return;case"log":return this.e(t.URI.revive(w[0]),w[1]);case"consoleLog":return this.d(w[0],w[1])}throw new Error(`Call not found: ${f}`)}c(E,f){this.a.set(E.toString(),this.b.createLogger(E,f))}d(E,f){let w=console.log;switch(E){case C.LogLevel.Error:w=console.error;break;case C.LogLevel.Warning:w=console.warn;break;case C.LogLevel.Info:w=console.info;break}w.call(console,...f)}e(E,f){const w=this.a.get(E.toString());if(!w)throw new Error("Create the logger before logging");for(const[d,b]of f)(0,C.log)(w,d,b)}}e.LoggerChannel=k;class p extends C.AbstractLoggerService{constructor(E,f,w){super(E,f),this.g=w}createConsoleMainLogger(){return new C.AdapterLogger({log:(E,f)=>{this.g.call("consoleLog",[E,f])}})}f(E,f,w){return new m(this.g,E,f,w)}}e.LoggerChannelClient=p;class m extends C.AbstractMessageLogger{constructor(E,f,w,d){super(d?.always),this.m=E,this.n=f,this.k=!1,this.l=[],this.setLevel(w),this.m.call("createLogger",[f,d]).then(()=>{this.r(this.l),this.k=!0})}g(E,f){const w=[[E,f]];this.k?this.r(w):this.l.push(...w)}r(E){this.m.call("log",[this.n,E])}}class y extends C.LogService{constructor(E,f){super(f),this.c=E,this.B(E.onDidChangeLogLevel(w=>f.setLevel(w)))}setLevel(E){super.setLevel(E),this.c.setLevel(E)}}e.FollowerLogService=y}),define(ee[210],te([0,1,16,6]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var C;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(C||(C={}));async function R(m,y,P,E,f){try{const w=await new Promise((b,u)=>{H(["spdlog"],b,u)});w.setFlushOn(C.Trace);const d=await w.createAsyncRotatingLogger(m,y,P,E);return f?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(w){console.error(w)}return null}function A(m,y,P){switch(y){case t.LogLevel.Trace:m.trace(P);break;case t.LogLevel.Debug:m.debug(P);break;case t.LogLevel.Info:m.info(P);break;case t.LogLevel.Warning:m.warn(P);break;case t.LogLevel.Error:m.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function k(m,y){switch(y){case t.LogLevel.Trace:m.setLevel(C.Trace);break;case t.LogLevel.Debug:m.setLevel(C.Debug);break;case t.LogLevel.Info:m.setLevel(C.Info);break;case t.LogLevel.Warning:m.setLevel(C.Warning);break;case t.LogLevel.Error:m.setLevel(C.Error);break;case t.LogLevel.Off:m.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class p extends t.AbstractMessageLogger{constructor(y,P,E,f,w){super(),this.k=[],this.setLevel(w),this.l=this.n(y,P,E,f),this.B(this.onDidChangeLogLevel(d=>{this.m&&k(this.m,d)}))}async n(y,P,E,f){const w=E?6:1,d=30/w*I.ByteSize.MB,b=await R(y,P,d,w,f);if(b){this.m=b,k(this.m,this.getLevel());for(const{level:u,message:v}of this.k)A(this.m,u,v);this.k=[]}}g(y,P){this.m?A(this.m,y,P):this.getLevel()<=y&&this.k.push({level:y,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=p}),define(ee[211],te([0,1,29,6,210]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(k){super(k.getLevel(),k.onDidChangeLogLevel)}f(k,p,m){return new C.SpdLogLogger(m?.name||(0,I.generateUuid)(),k.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,p)}};R=pe([ie(0,t.ILogService)],R),e.LoggerService=R}),define(ee[212],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(A){return A.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function t(A){return A.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function C(A){return A.uri!==void 0}e.isMenubarMenuItemRecentAction=C;function R(A){return!I(A)&&!t(A)&&!C(A)}e.isMenubarMenuItemAction=R}),define(ee[37],te([0,1,3,67,2,5]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class A extends C.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const y=Object.keys(this.f).length;return this.f={...m,...this.f},y!==Object.keys(this.f).length&&await this.i(m),t.Iterable.reduce(this.g.entries(),(P,[E,f])=>({...P,[E]:f}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(m,[y,P])=>({...m,[y]:{definition:P,value:this.g.get(y)}}),{})}}e.AbstractPolicyService=A;class k{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(ee[213],te([0,1,8,3,67,12,16,6,37]),function(H,e,I,t,C,R,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(P,E){const f=[];for(const w of C.Iterable.concat(P.keys(),E.keys()))P.get(w)!==E.get(w)&&f.push(w);return f}let y=class extends p.AbstractPolicyService{constructor(E,f,w){super(),this.j=E,this.k=f,this.l=w,this.c=this.B(new I.ThrottledDelayer(500));const d=t.Event.filter(f.onDidFilesChange,b=>b.affects(E));this.B(f.watch(E)),this.B(d(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const E=new Map;try{const f=await this.k.readFile(this.j),w=JSON.parse(f.value.toString());if(!(0,R.isObject)(w))throw new Error("Policy file isn't a JSON object");for(const d of Object.keys(w))this.f[d]&&E.set(d,w[d])}catch(f){f.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",f)}return E}async p(){const E=await this.n(),f=m(this.g,E);this.g=E,f.length>0&&this.h.fire(f)}};y=pe([ie(1,A.IFileService),ie(2,k.ILogService)],y),e.FilePolicyService=y}),define(ee[214],te([0,1,3,2,37]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(p){this.b=p,this.a=new t.DisposableStore}listen(p,m){switch(m){case"onDidChange":return I.Event.map(this.b.onDidChange,y=>y.reduce((P,E)=>({...P,[E]:this.b.getPolicyValue(E)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(p,m,y){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.PolicyChannel=R;class A extends C.AbstractPolicyService{constructor(p,m){super(),this.a=m;for(const y in p){const{definition:P,value:E}=p[y];this.f[y]=P,E!==void 0&&this.g.set(y,E)}this.a.listen("onDidChange")(y=>{for(const P in y){const E=y[P];E===null?this.g.delete(P):this.g.set(P,E)}this.h.fire(Object.keys(y))})}async i(p){const m=await this.a.call("updatePolicyDefinitions",p);for(const y in m)this.g.set(y,m[y])}}e.PolicyChannelClient=A}),define(ee[63],te([0,1,4,33]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const R=I.globals.vscode.context.configuration();if(R)C=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:R.version})}}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(ee[19],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[215],te([0,1,77,6,19]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(k,p){this.b=k,this.c=p,this.a=new Map}async isExtensionUrlTrusted(k,p){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(p);if(!m)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",p),!1;const[,y,P]=m;let E=this.a.get(k);if(!E){if(E=this.b.trustedExtensionUrlPublicKeys[k],!E||E.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...E])}const f=Buffer.from(decodeURIComponent(P),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",p),!1;const w=f.slice(0,6),d=f.readUIntBE(0,6),b=Date.now()-d;if(b<0||b>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",p),!1;const u=f.slice(6),v=I.createVerify("SHA256");v.write(w),v.write(Buffer.from(y)),v.end();for(let g=0;g<E.length;g++){let h=E[g];if(h!==null){if(typeof h=="string")try{h=I.createPublicKey({key:Buffer.from(h,"base64"),format:"der",type:"spki"}),E[g]=h}catch(l){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${g+1} for ${k}:`,l),E[g]=null;continue}if(v.verify(h,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",p),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",p),!1}};R=pe([ie(0,C.IProductService),ie(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(ee[216],te([0,1,8,6]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let C=class{constructor(A,k,p){this.a=A,this.b=k,this.c=p}async inspect(A){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,I.timeout)(A);const p=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),p.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};C=pe([ie(2,t.ILogService)],C),e.WindowProfiler=C}),define(ee[64],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(ee[48],te([0,1,122,12]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.a=new Map}add(A,k){I.ok(t.isString(A)),I.ok(t.isObject(k)),I.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,k)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.Registry=new C}),define(ee[217],te([0,1,3,48]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class R{constructor(){this.b=new I.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,m){this.a[C(p)]=m,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const A=new R;t.Registry.add(e.Extensions.JSONContribution,A)}),define(ee[65],te([0,1,24,3,12,149,18,217,48]),function(H,e,I,t,C,R,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=p.Registry.as(k.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const n=this.k(i,s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const s=this.l(i);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const n=[];n.push(...this.l(s)),n.push(...this.k(i,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,I.distinct)(n)})}registerDefaultConfigurations(i){const s=[],n=[];for(const{overrides:a,source:r}of i)for(const c in a)if(s.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.a.get(c),S=o?.valuesSources??new Map;if(r)for(const J of Object.keys(a[c]))S.set(J,r);const M={...o?.value||{},...a[c]};this.a.set(c,{source:r,value:M,valuesSources:S});const L=(0,A.getLanguageTagSettingPlainKey)(c),B={type:"object",default:M,description:R.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:C.isString(r)?void 0:r,defaultValueSource:r};n.push(...d(c)),this.d[c]=B,this.b.properties[c]=B}else{this.a.set(c,{value:a[c],source:r});const o=this.d[c];o&&(this.s(c,o),this.o(c,o))}this.registerOverrideIdentifiers(n),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const s=[];for(const{overrides:n,source:a}of i)for(const r in n){const c=this.a.get(r),o=C.isString(a)?a:a?.id,S=C.isString(c?.source)?c?.source:c?.source?.id;if(o===S)if(s.push(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const M=this.d[r];M&&(this.s(r,M),this.o(r,M))}}this.q(),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const s of i)this.h.add(s);this.q()}k(i,s){const n=[];return i.forEach(a=>{n.push(...this.m(a,s,a.extensionInfo,a.restrictedProperties)),this.c.push(a),this.n(a)}),n}l(i){const s=[],n=a=>{if(a.properties)for(const r in a.properties){s.push(r);const c=this.d[r];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[r],this.p(r,a.properties[r])}a.allOf?.forEach(r=>n(r))};for(const a of i){n(a);const r=this.c.indexOf(a);r!==-1&&this.c.splice(r,1)}return s}m(i,s=!0,n,a,r=3){r=C.isUndefinedOrNull(i.scope)?r:i.scope;const c=[],o=i.properties;if(o)for(const M in o){const L=o[M];if(s&&g(M,L)){delete o[M];continue}if(L.source=n,L.defaultDefaultValue=o[M].default,this.s(M,L),e.OVERRIDE_PROPERTY_REGEX.test(M)?L.scope=void 0:(L.scope=C.isUndefinedOrNull(L.scope)?r:L.scope,L.restricted=C.isUndefinedOrNull(L.restricted)?!!a?.includes(M):L.restricted),o[M].hasOwnProperty("included")&&!o[M].included){this.f[M]=o[M],delete o[M];continue}else this.d[M]=o[M],o[M].policy?.name&&this.e.set(o[M].policy.name,M);!o[M].deprecationMessage&&o[M].markdownDeprecationMessage&&(o[M].deprecationMessage=o[M].markdownDeprecationMessage),c.push(M)}const S=i.allOf;if(S)for(const M of S)c.push(...this.m(M,s,n,a,r));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const s=n=>{const a=n.properties;if(a)for(const c in a)this.o(c,a[c]);n.allOf?.forEach(s)};s(i)}o(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.g.properties[i]=s;break}}p(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const s=`[${i}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(s,n),e.allSettings.properties[s]=n,e.applicationSettings.properties[s]=n,e.machineSettings.properties[s]=n,e.machineOverridableSettings.properties[s]=n,e.windowSettings.properties[s]=n,e.resourceSettings.properties[s]=n}this.i.fire()}r(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,s){const n=this.a.get(i);let a=n?.value,r=n?.source;C.isUndefined(a)&&(a=s.defaultDefaultValue,r=void 0),C.isUndefined(a)&&(a=u(s.type)),s.default=a,s.defaultValueSource=r}}const f="\\[([^\\]]+)\\]",w=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(l){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let s=w.exec(l);for(;s?.length;){const n=s[1].trim();n&&i.push(n),s=w.exec(l)}}return(0,I.distinct)(i)}e.overrideIdentifiersFromKey=d;function b(l){return l.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=b;function u(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const v=new E;p.Registry.add(e.Extensions.Configuration,v);function g(l,i){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?R.localize(7,null,l):v.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,l,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=g;function h(){const l=[],i=v.getConfigurationProperties();for(const s of Object.keys(i))l.push([s,i[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=h}),define(ee[109],te([0,1,24,3,43,2,39,44,12,7,18,65,48]),function(H,e,I,t,C,R,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class f{constructor(s={},n=[],a=[],r){this.c=s,this.d=n,this.f=a,this.raw=r,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof f)return n;const a=new w("");return a.parseRaw(n),a.configurationModel});this.g=s.reduce((n,a)=>a===n?a:n.merge(a),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,y.getConfigurationValue)(this.contents,s):this.contents}inspect(s,n){const a=this.rawConfiguration.getValue(s),r=n?this.rawConfiguration.getOverrideValue(s,n):void 0,c=n?this.rawConfiguration.override(n).getValue(s):a;return{value:a,override:r,merged:c}}getOverrideValue(s,n){const a=this.l(n);return a?s?(0,y.getConfigurationValue)(a,s):a:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const a of this.overrides)a.identifiers.includes(s)&&n.push(...a.keys);return I.distinct(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return I.distinct(s)}override(s){let n=this.b.get(s);return n||(n=this.h(s),this.b.set(s,n)),n}merge(...s){const n=k.deepClone(this.contents),a=k.deepClone(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const o of s)if(c.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(n,o.contents);for(const S of o.overrides){const[M]=a.filter(L=>I.equals(L.identifiers,S.identifiers));M?(this.j(M.contents,S.contents),M.keys.push(...S.keys),M.keys=I.distinct(M.keys)):a.push(k.deepClone(S))}for(const S of o.keys)r.indexOf(S)===-1&&r.push(S)}return new f(n,r,a,c.every(o=>o instanceof f)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new f(k.deepClone(this.contents),[...this.keys],k.deepClone(this.overrides))}h(s){const n=this.l(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const a={};for(const r of I.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[r];const o=n[r];o&&(typeof c=="object"&&typeof o=="object"?(c=k.deepClone(c),this.j(c,o)):c=o),a[r]=c}return new f(a,this.keys,this.overrides)}j(s,n){for(const a of Object.keys(n)){if(a in s&&p.isObject(s[a])&&p.isObject(n[a])){this.j(s[a],n[a]);continue}s[a]=k.deepClone(n[a])}}k(s){return this.a&&!Object.isFrozen(s)?k.deepFreeze(s):s}l(s){let n=null,a=null;const r=c=>{c&&(a?this.j(a,c):a=k.deepClone(c))};for(const c of this.overrides)I.equals(c.identifiers,[s])?n=c.contents:c.identifiers.includes(s)&&r(c.contents);return r(n),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,n){this.m(s),(0,y.addToValueTree)(this.contents,s,n,a=>{throw new Error(a)})}removeValue(s){this.n(s)&&(0,y.removeFromValueTree)(this.contents,s)}m(s){let n=this.keys.length;for(let a=0;a<n;a++)s.indexOf(this.keys[a])===0&&(n=a);this.keys.splice(n,1,s)}n(s){const n=this.keys.indexOf(s);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=f;class w{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!p.isUndefinedOrNull(s)){const a=this.g(s);this.parseRaw(a,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:a,keys:r,overrides:c,restricted:o,hasExcludedProperties:S}=this.h(s,n);this.b=new f(a,r,c,S?[s]:void 0),this.c=o||[]}g(s){let n={},a=null,r=[];const c=[],o=[];function S(L){Array.isArray(r)?r.push(L):a!==null&&(r[a]=L)}const M={onObjectBegin:()=>{const L={};S(L),c.push(r),r=L,a=null},onObjectProperty:L=>{a=L},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const L=[];S(L),c.push(r),r=L,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:S,onError:(L,B,J)=>{o.push({error:L,offset:B,length:J})}};if(s)try{C.visit(s,M),n=r[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return n}h(s,n){const a=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.j(s,a,!0,n);s=r.raw;const c=(0,y.toValuesTree)(s,M=>console.error(`Conflict in settings file ${this.f}: ${M}`)),o=Object.keys(s),S=this.l(s,M=>console.error(`Conflict in settings file ${this.f}: ${M}`));return{contents:c,keys:o,overrides:S,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}j(s,n,a,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:c};const o={},S=[];for(const M in s)if(P.OVERRIDE_PROPERTY_REGEX.test(M)&&a){const L=this.j(s[M],n,!1,r);o[M]=L.raw,c=c||L.hasExcludedProperties,S.push(...L.restricted)}else{const L=n[M],B=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&S.push(M),(B===void 0||r.scopes===void 0||r.scopes.includes(B))&&!(r.skipRestricted&&L?.restricted)?o[M]=s[M]:c=!0}return{raw:o,restricted:S,hasExcludedProperties:c}}l(s,n){const a=[];for(const r of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(r)){const c={};for(const o in s[r])c[o]=s[r][o];a.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(c),contents:(0,y.toValuesTree)(c,n)})}return a}}e.ConfigurationModelParser=w;class d extends R.Disposable{constructor(s,n,a,r){super(),this.f=s,this.g=n,this.h=r,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&a.isEqual(c.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class b{constructor(s,n,a,r,c,o,S,M,L,B,J,ae,X){this.a=s,this.b=n,this.value=a,this.overrideIdentifiers=r,this.c=c,this.d=o,this.f=S,this.g=M,this.h=L,this.j=B,this.k=J,this.l=ae,this.m=X}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(s,n,a,r,c=new f,o=new f,S=new A.ResourceMap,M=new f,L=new A.ResourceMap,B=!0){this.c=s,this.d=n,this.f=a,this.g=r,this.h=c,this.j=o,this.l=S,this.m=M,this.n=L,this.p=B,this.a=null,this.b=new A.ResourceMap,this.q=null}getValue(s,n,a){return this.s(s,n,a).getValue(s)}updateValue(s,n,a={}){let r;a.resource?(r=this.n.get(a.resource),r||(r=new f,this.n.set(a.resource,r))):r=this.m,n===void 0?r.removeValue(s):r.setValue(s,n),a.resource||(this.a=null)}inspect(s,n,a){const r=this.s(s,n,a),c=I.distinct(r.overrides.map(M=>M.identifiers).flat()).filter(M=>r.getOverrideValue(s,M)!==void 0),o=this.w(n.resource,a),S=n.resource?this.n.get(n.resource)||this.m:this.m;return new b(s,n,r.getValue(s),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),a?this.j.freeze():void 0,o?o.freeze():void 0,S.inspect(s,n.overrideIdentifier))}keys(s){const n=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.l.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const a=[];if(!n){const{added:r,updated:c,removed:o}=h(this.c,s);n=[...r,...c,...o]}for(const r of n)for(const c of(0,P.overrideIdentifiersFromKey)(r)){const o=this.c.getKeysForOverrideIdentifier(c),S=s.getKeysForOverrideIdentifier(c),M=[...S.filter(L=>o.indexOf(L)===-1),...o.filter(L=>S.indexOf(L)===-1),...o.filter(L=>!k.equals(this.c.override(c).getValue(L),s.override(c).getValue(L)))];a.push([c,M])}return this.updateDefaultConfiguration(s),{keys:n,overrides:a}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:a,removed:r}=h(this.d,s),c=[...n,...a,...r];return c.length&&this.updatePolicyConfiguration(s),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:a,removed:r,overrides:c}=h(this.applicationConfiguration,s),o=[...n,...a,...r];return o.length&&this.updateApplicationConfiguration(s),{keys:o,overrides:c}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:a,removed:r,overrides:c}=h(this.localUserConfiguration,s),o=[...n,...a,...r];return o.length&&this.updateLocalUserConfiguration(s),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:a,removed:r,overrides:c}=h(this.remoteUserConfiguration,s),o=[...n,...a,...r];return o.length&&this.updateRemoteUserConfiguration(s),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:a,removed:r,overrides:c}=h(this.workspaceConfiguration,s),o=[...n,...a,...r];return o.length&&this.updateWorkspaceConfiguration(s),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(s,n){const a=this.r.get(s),{added:r,updated:c,removed:o,overrides:S}=h(a,n),M=[...r,...c,...o];return(M.length||!a)&&this.updateFolderConfiguration(s,n),{keys:M,overrides:S}}compareAndDeleteFolderConfiguration(s){const n=this.r.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:a,updated:r,removed:c,overrides:o}=h(n,void 0);return{keys:[...a,...r,...c],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,n,a){let r=this.t(n,a);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}t({resource:s},n){let a=this.u();if(n&&s){const r=n.getFolder(s);r&&(a=this.v(r.uri)||a);const c=this.n.get(s);c&&(a=a.merge(c))}return a}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let n=this.b.get(s);if(!n){const a=this.u(),r=this.l.get(s);r?(n=a.merge(r),this.p&&(n=n.freeze()),this.b.set(s,n)):n=a}return n}w(s,n){if(n&&s){const a=n.getFolder(s);if(a)return this.l.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,n)=>{const{contents:a,overrides:r,keys:c}=this.l.get(n);return s.push([n,{contents:a,overrides:r,keys:c}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(n=>s.add(n)),this.userConfiguration.freeze().keys.forEach(n=>s.add(n)),this.j.freeze().keys.forEach(n=>s.add(n)),this.l.forEach(n=>n.freeze().keys.forEach(a=>s.add(a))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.l.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a))),[...s.values()]}y(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>n.add(a)),this.j.getKeysForOverrideIdentifier(s).forEach(a=>n.add(a)),this.l.forEach(a=>a.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r))),[...n.values()]}static parse(s){const n=this.z(s.defaults),a=this.z(s.policy),r=this.z(s.application),c=this.z(s.user),o=this.z(s.workspace),S=s.folders.reduce((M,L)=>(M.set(m.URI.revive(L[0]),this.z(L[1])),M),new A.ResourceMap);return new u(n,a,r,c,new f,o,S,new f,new A.ResourceMap,!1)}static z(s){return new f(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=u;function v(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const s=new Set,n=new Map;for(const r of i)r.keys.forEach(c=>s.add(c)),r.overrides.forEach(([c,o])=>{const S=(0,A.getOrSet)(n,c,new Set);o.forEach(M=>S.add(M))});const a=[];return n.forEach((r,c)=>a.push([c,[...r.values()]])),{keys:[...s.values()],overrides:a}}e.mergeChanges=v;class g{constructor(s,n,a,r){this.change=s,this.b=n,this.c=a,this.d=r,this.f=void 0;const c=new Set;s.keys.forEach(S=>c.add(S)),s.overrides.forEach(([,S])=>S.forEach(M=>c.add(M))),this.affectedKeys=[...c.values()];const o=new f;this.affectedKeys.forEach(S=>o.setValue(S,{})),this.a=o.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=u.parse(this.b.data)),this.f}affectsConfiguration(s,n){if(this.g(this.a,s)){if(n){const a=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.b?.workspace):void 0,r=this.c.getValue(s,n,this.d);return!k.equals(a,r)}return!0}return!1}g(s,n){let a=(0,y.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(s=s[r],!s)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=g;function h(i,s){const{added:n,removed:a,updated:r}=l(s?.rawConfiguration,i?.rawConfiguration),c=[],o=i?.getAllOverrideIdentifiers()||[],S=s?.getAllOverrideIdentifiers()||[];if(s){const M=S.filter(L=>!o.includes(L));for(const L of M)c.push([L,s.getKeysForOverrideIdentifier(L)])}if(i){const M=o.filter(L=>!S.includes(L));for(const L of M)c.push([L,i.getKeysForOverrideIdentifier(L)])}if(s&&i){for(const M of o)if(S.includes(M)){const L=l({contents:i.getOverrideValue(void 0,M)||{},keys:i.getKeysForOverrideIdentifier(M)},{contents:s.getOverrideValue(void 0,M)||{},keys:s.getKeysForOverrideIdentifier(M)});c.push([M,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:a,updated:r,overrides:c}}function l(i,s){const n=i?s?i.keys.filter(c=>s.keys.indexOf(c)===-1):[...i.keys]:[],a=s?i?s.keys.filter(c=>i.keys.indexOf(c)===-1):[...s.keys]:[],r=[];if(i&&s){for(const c of s.keys)if(i.keys.indexOf(c)!==-1){const o=(0,y.getConfigurationValue)(s.contents,c),S=(0,y.getConfigurationValue)(i.contents,c);k.equals(o,S)||r.push(c)}}return{added:n,removed:a,updated:r}}}),define(ee[218],te([0,1,24,3,2,44,12,18,109,65,6,37,48]),function(H,e,I,t,C,R,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class f extends C.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new w(this.f())),this.b}async initialize(){return this.b=void 0,this.B(E.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:g})=>this.c(v,g))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(v,g){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:v})}f(){return{}}}e.DefaultConfiguration=f;class w extends p.ConfigurationModel{constructor(v={}){const g=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(g),l=Object.create(null),i=[];for(const s in g){const n=v[s],a=n!==void 0?n:g[s].default;(0,k.addToValueTree)(l,s,a,r=>console.error(`Conflict in default settings: ${r}`))}for(const s of Object.keys(l))m.OVERRIDE_PROPERTY_REGEX.test(s)&&i.push({identifiers:(0,m.overrideIdentifiersFromKey)(s),keys:Object.keys(l[s]),contents:(0,k.toValuesTree)(l[s],n=>console.error(`Conflict in default settings file: ${n}`))});super(l,h,i)}}e.DefaultConfigurationModel=w;class d{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new p.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let b=class extends C.Disposable{get configurationModel(){return this.b}constructor(v,g,h){super(),this.c=v,this.f=g,this.g=h,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new p.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.i(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.j(await this.h(v),!0))),this.b}async h(v){const g={},h=[],l=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const i of v){const s=l[i];if(!s){h.push(i);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}h.push(i),g[s.policy.name]={type:s.type}}}return(0,A.isEmptyObject)(g)||await this.f.updatePolicyDefinitions(g),h}i(v){const g=E.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),h=(0,I.coalesce)(v.map(l=>g.get(l)));this.j(h,!0)}j(v,g){const h=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),l=[],i=this.b.isEmpty();for(const s of v){const n=h[s]?.policy?.name;if(n){const a=this.f.getPolicyValue(n);(i?a!==void 0:!(0,R.equals)(this.b.getValue(s),a))&&l.push([s,a])}else this.b.getValue(s)!==void 0&&l.push([s,void 0])}if(l.length){const s=this.b;this.b=new p.ConfigurationModel;for(const n of s.keys)this.b.setValue(n,s.getValue(n));for(const[n,a]of l)a===void 0?this.b.removeValue(n):this.b.setValue(n,a);g&&this.a.fire(this.b)}}};b=pe([ie(1,P.IPolicyService),ie(2,y.ILogService)],b),e.PolicyConfiguration=b}),define(ee[219],te([0,1,8,3,2,20,18,109,218,37]),function(H,e,I,t,C,R,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends C.Disposable{constructor(E,f,w,d){super(),this.i=E,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.DefaultConfiguration),this.c=w instanceof m.NullPolicyService?new p.NullPolicyConfiguration:this.B(new p.PolicyConfiguration(this.b,w,d)),this.f=this.B(new k.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,f)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:b,properties:u})=>this.k(b,u))),this.B(this.c.onDidChangeConfiguration(b=>this.l(b))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[E,f,w]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(E,f,new k.ConfigurationModel,w)}getConfigurationData(){return this.a.toData()}getValue(E,f){const w=typeof E=="string"?E:void 0,d=(0,A.isConfigurationOverrides)(E)?E:(0,A.isConfigurationOverrides)(f)?f:{};return this.a.getValue(w,d,void 0)}updateValue(E,f,w,d){return Promise.reject(new Error("not supported"))}inspect(E){return this.a.inspect(E,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const E=await this.f.loadConfiguration();this.j(E)}j(E){const f=this.a.toData(),w=this.a.compareAndUpdateLocalUserConfiguration(E);this.m(w,f,2)}k(E,f){const w=this.a.toData(),d=this.a.compareAndUpdateDefaultConfiguration(E,f);this.m(d,w,7)}l(E){const f=this.a.toData(),w=this.a.compareAndUpdatePolicyConfiguration(E);this.m(w,f,7)}m(E,f,w){const d=new k.ConfigurationChangeEvent(E,{data:f},this.a);d.source=w,d.sourceConfig=this.n(w),this.h.fire(d)}n(E){switch(E){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(ee[220],te([0,1,14,5]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var C;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends I.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof R&&k._code===C.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof R&&k._code===C.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof R&&k._code===C.NoResolverFound}static isHandled(k){return k instanceof R&&k.isHandled}constructor(k,p=C.Unknown,m){super(k),this._message=k,this._code=p,this._detail=m,this.isHandled=p===C.NotAvailable&&m===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(ee[54],te([0,1,15]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===I.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function C(m){if(!m)return;const y=m.indexOf("+");return y<0?m:m.substr(0,y)}e.getRemoteName=C;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function A(m){const{host:y,port:P}=p(m);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:y,port:P}}e.parseAuthorityWithPort=A;function k(m,y){let{host:P,port:E}=p(m);return typeof E>"u"&&(E=y),{host:P,port:E}}e.parseAuthorityWithOptionalPort=k;function p(m){const y=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const P=m.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const E=m.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:m,port:void 0}}}),define(ee[87],te([0,1,26,5,54]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=R;function A(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var p;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(p=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,b){if(typeof d>"u"||d===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof d=="string"||typeof b=="string"){const u=typeof d=="string"?d:d.value,v=typeof b=="string"?b:b.value;return I.equalsIgnoreCase(u,v)}return d.c===b.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=m;function y(w){return P(w)}e.isApplicationScopedExtension=y;function P(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function E(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function f(w,d){if(d){const b=`onResolveRemoteAuthority:${(0,C.getRemoteName)(d)}`;return w.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[110],te([0,1,26,192,87,4,7,14,33]),function(H,e,I,t,C,R,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,I.compareIgnoreCase)(s.id,n.id)===0}e.areSameExtensions=m;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(n){const a=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new P(n.identifier,a,r)}static parse(n){const a=y.exec(n);return a&&a[1]&&a[2]?new P({id:a[1]},a[2],a[4]||void 0):null}constructor(n,a,r="undefined"){this.version=a,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof P?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=P;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(s){const n=E.exec(s);return n&&n[1]?[d(n[1]),n[2]]:[d(s),void 0]}e.getIdAndVersion=f;function w(s,n){return`${s}.${n}`}e.getExtensionId=w;function d(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function b(s,n){return d(w(s,n))}e.getGalleryExtensionId=b;function u(s,n){const a=[],r=c=>{for(const o of a)if(o.some(S=>m(n(S),n(c))))return o;return null};for(const c of s){const o=r(c);o?o.push(c):a.push([c])}return a}e.groupByExtension=u;function v(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function g(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function h(s,n){const a=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&a.every(o=>!m(o.identifier,{id:c}))){const o=s.filter(S=>m(S.identifier,{id:c}));o.length===1&&(a.push(o[0]),r.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=h;async function l(s,n){if(!R.isLinux)return!1;let a;try{a=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){n.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(c))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function i(s,n){const a=await l(s,n),r=(0,t.getTargetPlatform)(a?"alpine":R.platform,p.arch);return n.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=i}),define(ee[221],te([0,1,8,17,22,14,3,2,29,102,220,54]),function(H,e,I,t,C,R,A,k,p,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var f;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function w(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(z){const $=new C.CancellationTokenSource;return setTimeout(()=>$.cancel(),z),$.token}function b(z,$){if(z.isCancellationRequested||$.isCancellationRequested)return C.CancellationToken.Cancelled;const D=new C.CancellationTokenSource;return z.onCancellationRequested(()=>D.cancel()),$.onCancellationRequested(()=>D.cancel()),D.token}class u{get didTimeout(){return this.c==="timedout"}constructor($){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise((D,O)=>{this.f=D,this.g=O}),$.isCancellationRequested?this.h():this.d.add($.onCancellationRequested(()=>this.h()))}registerDisposable($){this.c==="pending"?this.d.add($):$.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f($))}reject($){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g($))}}function v(z,$){const D=new u($);return D.registerDisposable(z.onControlMessage(O=>{const W=JSON.parse(O.toString()),U=F(W);U?D.reject(U):D.resolve(W)})),D.promise}function g(z,$,D,O,W,U,q,Q){const j=new u(Q);return $.connect(D,O,W,U,q,(Z,x)=>{j.didTimeout?(Z&&z.error(Z),x?.dispose()):Z||!x?j.reject(Z):j.resolve(x)}),j.promise}function h(z,$){const D=new u($);return z.then(O=>{D.didTimeout||D.resolve(O)},O=>{D.didTimeout||D.reject(O)}),D.promise}async function l(z,$,D,O){const W=V(z,$);z.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let U;try{U=await g(z.logService,z.socketFactory,z.host,z.port,(0,P.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${w($)}-${z.reconnectionToken}`,O)}catch(x){throw z.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),z.logService.error(x),x}z.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let q,Q;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(U,null),q=z.reconnectionProtocol,Q=!1):(q=new m.PersistentProtocol(U,null),Q=!0),z.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const j=await h(z.signService.createNewMessage((0,p.generateUuid)()),O),Z={type:"auth",auth:z.connectionToken||"00000000000000000000",data:j.data};q.sendControl(t.VSBuffer.fromString(JSON.stringify(Z)));try{const x=await v(q,b(O,d(1e4)));if(x.type!=="sign"||typeof x.data!="string"){const Oe=new Error("Unexpected handshake message");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}if(z.logService.trace(`${W} 4/6. received SignRequest control message.`),!await h(z.signService.validate(j,x.signedData),O)){const Oe=new Error("Refused to connect to unsupported server");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}const ge=await h(z.signService.sign(x.data),O),Me={type:"connectionType",commit:z.commit,signedData:ge,desiredConnectionType:$};return D&&(Me.args=D),z.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),q.sendControl(t.VSBuffer.fromString(JSON.stringify(Me))),{protocol:q,ownsProtocol:Q}}catch(x){throw x&&x.code==="ETIMEDOUT"&&(z.logService.error(`${W} the handshake timed out. Error:`),z.logService.error(x)),x&&x.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${W} received error control message when negotiating connection. Error:`),z.logService.error(x)),Q&&le(q),x}}async function i(z,$,D,O){const W=Date.now(),U=V(z,$),{protocol:q,ownsProtocol:Q}=await l(z,$,D,O),j=new u(O);return j.registerDisposable(q.onControlMessage(Z=>{const x=JSON.parse(Z.toString()),oe=F(x);oe?(z.logService.error(`${U} received error control message when negotiating connection. Error:`),z.logService.error(oe),Q&&le(q),j.reject(oe)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${se(W)}!`),j.resolve({protocol:q,firstMessage:x}))})),j.promise}async function s(z,$){const{protocol:D}=await i(z,1,void 0,$);return{protocol:D}}async function n(z,$,D){const{protocol:O,firstMessage:W}=await i(z,2,$,D),U=W&&W.debugPort;return{protocol:O,debugPort:U}}async function a(z,$,D){const O=Date.now(),W=V(z,3),{protocol:U}=await l(z,3,$,D);return z.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${se(O)}!`),U}async function r(z,$,D){const{host:O,port:W,connectionToken:U}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:O,port:W,connectionToken:U,reconnectionToken:$,reconnectionProtocol:D,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function c(z,$,D){return S(z,async O=>{const{protocol:W}=await s(O,C.CancellationToken.None);return new de(z,$,D,O.reconnectionToken,W)})}e.connectRemoteAgentManagement=c;async function o(z,$){return S(z,async D=>{const{protocol:O,debugPort:W}=await n(D,$,C.CancellationToken.None);return new K(z,$,D.reconnectionToken,O,W)})}e.connectRemoteAgentExtensionHost=o;async function S(z,$){for(let O=1;;O++)try{const W=(0,p.generateUuid)(),U=await r(z,W,null);return await $(U)}catch(W){if(O<5)z.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(W);else throw z.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(W),ne.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(W)),W}}async function M(z,$,D){const O=await r(z,(0,p.generateUuid)(),null);return await a(O,{host:$,port:D},C.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function L(z){return(0,I.createCancelablePromise)($=>new Promise((D,O)=>{const W=setTimeout(D,z*1e3);$.onCancellationRequested(()=>{clearTimeout(W),D()})}))}var B;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(B=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class J{constructor($,D){this.reconnectionToken=$,this.millisSinceLastIncomingData=D,this.type=0}}e.ConnectionLostEvent=J;class ae{constructor($,D,O,W){this.reconnectionToken=$,this.millisSinceLastIncomingData=D,this.durationSeconds=O,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=ae;class X{constructor($,D,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=D,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=X;class Y{constructor($,D,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=D,this.attempt=O,this.type=4}}e.ConnectionGainEvent=Y;class re{constructor($,D,O,W){this.reconnectionToken=$,this.millisSinceLastIncomingData=D,this.attempt=O,this.handled=W,this.type=3}}e.ReconnectionPermanentFailureEvent=re;class ne extends k.Disposable{static triggerPermanentFailure($,D,O){this._permanentFailure=!0,this.f=$,this.g=D,this.h=O,this.i.forEach(W=>W.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach($=>$.r())}static debugPauseSocketWriting(){this.i.forEach($=>$.v())}get k(){return this.c||ne._permanentFailure}constructor($,D,O,W,U){super(),this.m=$,this.n=D,this.reconnectionToken=O,this.protocol=W,this.p=U,this.j=this.B(new A.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new Y(this.reconnectionToken,0,0)),this.B(W.onSocketClose(q=>{const Q=N(this.m,this.reconnectionToken,!0);q?q.type===0?(this.n.logService.info(`${Q} received socket close event (hadError: ${q.hadError}).`),q.error&&this.n.logService.error(q.error)):(this.n.logService.info(`${Q} received socket close event (wasClean: ${q.wasClean}, code: ${q.code}, reason: ${q.reason}).`),q.event&&this.n.logService.error(q.event)):this.n.logService.info(`${Q} received socket close event.`),this.r()})),this.B(W.onSocketTimeout(q=>{const Q=N(this.m,this.reconnectionToken,!0);this.n.logService.info(`${Q} received socket timeout event (unacknowledgedMsgCount: ${q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${q.timeSinceLastReceivedSomeData}).`),this.r()})),ne.i.push(this),this.B((0,k.toDisposable)(()=>{const q=ne.i.indexOf(this);q>=0&&ne.i.splice(q,1)})),this.k&&this.u(ne.f,ne.g,ne.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const $=N(this.m,this.reconnectionToken,!0);this.n.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const W=O<D.length?D[O]:D[D.length-1];try{if(W>0){const q=L(W);this.j.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,q)),this.n.logService.info(`${$} waiting for ${W} seconds before reconnecting...`);try{await q}catch{}}if(this.k){this.n.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this.n.logService.info(`${$} resolving connection...`);const U=await r(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${$} connecting to ${U.host}:${U.port}...`),await this.w(U,d(E)),this.n.logService.info(`${$} reconnected!`),this.j.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this.n.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this.n.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this.n.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(U);continue}if((0,R.isCancellationError)(U)){this.n.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(U);continue}if(U instanceof y.RemoteAuthorityResolverError){this.n.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,y.RemoteAuthorityResolverError.isHandled(U));break}this.n.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this.k)}t($,D,O){this.p?ne.triggerPermanentFailure($,D,O):this.u($,D,O)}u($,D,O){this.j.fire(new re(this.reconnectionToken,$,D,O)),le(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ne,ne._permanentFailure=!1,ne.f=0,ne.g=0,ne.h=!1,ne.i=[];class de extends ne{constructor($,D,O,W,U){super(1,$,W,U,!0),this.client=this.B(new m.Client(U,{remoteAuthority:D,clientId:O},$.ipcLogger))}async w($,D){await s($,D)}}e.ManagementPersistentConnection=de;class K extends ne{constructor($,D,O,W,U){super(2,$,O,W,!1),this.y=D,this.debugPort=U}async w($,D){await n($,this.y,D)}}e.ExtensionHostPersistentConnection=K;function le(z){try{z.acceptDisconnect();const $=z.getSocket();z.dispose(),$.dispose()}catch($){(0,R.onUnexpectedError)($)}}function F(z){if(z&&z.type==="error"){const $=new Error(`Connection error: ${z.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function T(z,$){for(;z.length<$;)z+=" ";return z}function N(z,$,D){return`[remote-connection][${T(w(z),13)}][${$.substr(0,5)}\u2026][${D?"reconnect":"initial"}]`}function V(z,$){return`${N($,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function se(z){return`${Date.now()-z} ms`}}),define(ee[222],te([0,1,78,83]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(C,R,A,k,p,m){const y=E=>m(E,void 0),P=I.createConnection({host:C,port:R},()=>{P.removeListener("error",y);const E=Buffer.alloc(16);for(let b=0;b<16;b++)E[b]=Math.round(Math.random()*256);const f=E.toString("base64"),w=[`GET ws://${/:/.test(C)?`[${C}]`:C}:${R}${A}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(w.join(`\r
`)+`\r
\r
`);const d=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",d),m(void 0,new t.NodeSocket(P,p)))};P.on("data",d)});P.setNoDelay(!0),P.once("error",y)}}}),define(ee[223],te([0,1,25,46,40,182]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let A;async function k(f=!1){return(A===void 0||f)&&(A=p()),A}e.hasWSLFeatureInstalled=k;async function p(){const f=m();if(f===void 0)return!1;if(f>=22e3){const w=P();if(w)return new Promise(d=>{t.execFile(w,["--status"],b=>d(!b))})}else{const w=E();if(w)try{if((await C.promises.stat(w)).isFile())return!0}catch{}}return!1}function m(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(f)return parseInt(f[3])}function y(f){const w=process.env.SystemRoot;if(w){const d=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(w,d?"Sysnative":"System32",f)}}function P(){return y("wsl.exe")}function E(){return y("lxss\\LxssManager.dll")}}),define(ee[55],te([0,1,17,166,65,5,48]),function(H,e,I,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function k(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=k;function p(d){return d.res.statusCode===204}async function m(d){return p(d)?null:(await(0,I.streamToBuffer)(d.stream)).toString()}e.asText=m;async function y(d){if(!k(d))throw new Error("Server returned "+d.res.statusCode);return m(d)}e.asTextOrError=y;async function P(d){if(!k(d))throw new Error("Server returned "+d.res.statusCode);if(p(d))return null;const u=(await(0,I.streamToBuffer)(d.stream)).toString();try{return JSON.parse(u)}catch(v){throw v.message+=`:
`+u,v}}e.asJson=P;function E(d){w(d)}e.updateProxyConfigurationsScope=E;let f;function w(d){const b=A.Registry.as(C.Extensions.Configuration),u=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[f],remove:u?[u]:[]})}w(2)}),define(ee[224],te([0,1,17,22]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class C{constructor(k){this.a=k}listen(k,p){throw new Error("Invalid listen")}call(k,p,m,y=t.CancellationToken.None){switch(p){case"request":return this.a.request(m[0],y).then(async({res:P,stream:E})=>{const f=await(0,I.streamToBuffer)(E);return[{statusCode:P.statusCode,headers:P.headers},f]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=C;class R{constructor(k){this.a=k}async request(k,p){const[m,y]=await this.a.call("request",[k],p);return{res:m,stream:(0,I.bufferToStream)(y)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=R}),define(ee[225],te([0,1,226,12]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function C(A,k){return A.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:A.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function R(A,k,p={}){const m=(0,I.parse)(A),y=p.proxyUrl||C(m,k);if(!y)return null;const P=(0,I.parse)(y);if(!/^https?:$/.test(P.protocol||""))return null;const E={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,t.isBoolean)(p.strictSSL)?p.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((f,w)=>{H(["http-proxy-agent"],f,w)}))(E):new(await new Promise((f,w)=>{H(["https-proxy-agent"],f,w)}))(E)}e.getProxyAgent=R}),define(ee[111],te([0,1,46,9,167,22,45,14,4,29,143,61,8]),function(H,e,I,t,C,R,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const f=1e4;let w;async function d(u,v,g){return v["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(g)&&!v["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(g)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=E.Promises.withAsyncBody(async(h,l)=>{const i=new R.CancellationTokenSource,s=setTimeout(()=>{i.dispose(!0),l(new Error((0,C.localize)(0,null)))},f);try{h(await b(u,i.token))}catch(n){!(0,k.isCancellationError)(n)&&!i.token.isCancellationRequested?l(new Error((0,C.localize)(1,null,(0,A.toErrorMessage)(n)))):h({})}finally{clearTimeout(s),i.dispose()}})),w)}e.getResolvedShellEnv=d;async function b(u,v){const g=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",g);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",h);const l=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",s);const n=await(0,y.getSystemShell)(p.OS,s);return u.trace("getUnixShellEnvironment#shell",n),new Promise((a,r)=>{if(v.isCancellationRequested)return r((0,k.canceled)());const c=(0,t.basename)(n);let o,S;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${M} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,S=["-Login","-Command"]):(o=`'${process.execPath}' ${M} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?S=["-ic"]:S=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),o);const L=(0,I.spawn)(n,[...S,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(L.kill(),r((0,k.canceled)()))),L.on("error",ae=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(ae)),r(ae)});const B=[];L.stdout.on("data",ae=>B.push(ae));const J=[];L.stderr.on("data",ae=>J.push(ae)),L.on("close",(ae,X)=>{const Y=Buffer.concat(B).toString("utf8");u.trace("getUnixShellEnvironment#raw",Y);const re=Buffer.concat(J).toString("utf8");if(re.trim()&&u.trace("getUnixShellEnvironment#stderr",re),ae||X)return r(new Error((0,C.localize)(2,null,ae,X)));const ne=i.exec(Y),de=ne?ne[1]:"{}";try{const K=JSON.parse(de);g?K.ELECTRON_RUN_AS_NODE=g:delete K.ELECTRON_RUN_AS_NODE,h?K.ELECTRON_NO_ATTACH_CONSOLE=h:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",K),a(K)}catch(K){u.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(K)),r(K)}})})}}),define(ee[88],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[227],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.b=new Map}c(){return new Promise((C,R)=>H(["vsda"],C,R))}async createNewMessage(C){try{const R=await this.c(),A=new R.validator;if(A){const k=String(I.a++);return this.b.set(k,A),{id:k,data:A.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,R){if(!C.id)return!0;const A=this.b.get(C.id);if(!A)return!1;this.b.delete(C.id);try{return A.validate(R)==="ok"}catch{return!1}}async sign(C){try{const R=await this.c(),A=new R.signer;if(A)return A.sign(C)}catch{}return C}}e.SignService=I,I.a=1}),define(ee[36],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,I.createDecorator)("stateMainService")}),define(ee[21],te([0,1,13,41,8,3,2,4,33,12,5,6,36,27]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,y.createDecorator)("lifecycleMainService");var w;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(w=e.ShutdownReason||(e.ShutdownReason={}));var d;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class It extends A.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(v,g,h){super(),this.v=v,this.w=g,this.y=h,this.c=this.B(new R.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new R.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(It.b),this.j&&this.w.removeItem(It.b)}C(){const v=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.D(1))};I.app.addListener("before-quit",v);const g=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",g),I.app.once("will-quit",h=>{this.L("Lifecycle#app.on(will-quit)"),h.preventDefault(),this.D(1).finally(()=>{this.H(!1),I.app.removeListener("before-quit",v),I.app.removeListener("window-all-closed",g),I.app.quit()})})}D(v){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const g=[];return this.f.fire({reason:v,join(h){g.push(h)}}),this.s=(async()=>{try{await C.Promises.settled(g)}catch(h){this.v.error(h)}try{await this.w.close()}catch(h){this.v.error(h)}})(),this.s}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===v)return;this.L(`lifecycle (main): phase changed (value: ${v})`),this.k=v;const g=this.u.get(this.k);g&&(g.open(),this.u.delete(this.k))}async when(v){if(v<=this.k)return;let g=this.u.get(v);g||(g=new C.Barrier,this.u.set(v,g)),await g.wait()}registerWindow(v){const g=new A.DisposableStore;this.n++,g.add(v.onWillLoad(l=>this.g.fire({window:v,workspace:l.workspace,reason:l.reason})));const h=(0,m.assertIsDefined)(v.win);h.on("close",l=>{const i=v.id;if(this.l.has(i)){this.l.delete(i);return}this.L(`Lifecycle#window.on('close') - window ID ${v.id}`),l.preventDefault(),this.unload(v,1).then(s=>{if(s){this.l.delete(i);return}this.l.add(i),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this.h.fire(v),v.close()})}),h.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.n--,g.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.D(1)})}async reload(v,g){await this.unload(v,3)||v.reload(g)}unload(v,g){const h=this.t.get(v.id);if(h)return h;const l=this.F(v,g).finally(()=>{this.t.delete(v.id)});return this.t.set(v.id,l),l}async F(v,g){if(!v.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${v.id}`);const h=this.i?2:g,l=await this.I(v,h);return l?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.G(l)):(await this.J(v,h),!1)}G(v){return v?(this.H(!0),this.i=!1,!0):!1}H(v){this.r&&(this.r(v),this.r=void 0,this.p=void 0)}I(v,g){return new Promise(h=>{const l=this.m++,i=`vscode:ok${l}`,s=`vscode:cancel${l}`;t.validatedIpcMain.once(i,()=>{h(!1)}),t.validatedIpcMain.once(s,()=>{h(!0)}),v.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:s,reason:g})})}J(v,g){return new Promise(h=>{const i=`vscode:reply${this.m++}`;t.validatedIpcMain.once(i,()=>h()),v.send("vscode:onWillUnload",{replyChannel:i,reason:g})})}quit(v){return this.L(`Lifecycle#quit() - begin (willRestart: ${v})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(v&&this.w.setItem(It.b,!0),this.p=new Promise(g=>{this.r=g,this.L("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.p)}L(v){this.y.args["enable-smoke-test-driver"]?this.v.info(v):this.v.trace(v)}async relaunch(v){this.L("Lifecycle#relaunch()");const g=process.argv.slice(1);if(v?.addArgs&&g.push(...v.addArgs),v?.removeArgs)for(const i of v.removeArgs){const s=g.indexOf(i);s>=0&&g.splice(s,1)}const h=()=>{try{if(k.isWindows){const i=(0,p.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.v.error(i)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:g})};I.app.once("quit",h),await this.quit(!0)&&I.app.removeListener("quit",h)}async kill(v){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,C.timeout)(1e3),(async()=>{for(const g of I.BrowserWindow.getAllWindows())if(g&&!g.isDestroyed()){let h;g.webContents&&!g.webContents.isDestroyed()?h=new Promise(l=>g.once("closed",l)):h=Promise.resolve(),g.destroy(),await h}})()]),I.app.exit(v)}};b.b="lifecycle.quitAndRestart",b=pe([ie(0,P.ILogService),ie(1,E.IStateMainService),ie(2,f.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(ee[228],te([0,1,4,3,2,5,21]),function(H,e,I,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let k=class extends C.Disposable{constructor(y){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,y.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const y=await new Promise((P,E)=>{H(["native-keymap"],P,E)});this.c=p(y),I.isCI||y.onDidChangeKeyboardLayout(()=>{this.c=p(y),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};k=pe([ie(0,A.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function p(m){const y=m.getKeyMap(),P=m.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:P}}}),define(ee[229],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,I.createDecorator)("stateService")}),define(ee[230],te([0,1,8,17,12,35,16,6]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class p{constructor(P,E,f){this.f=P,this.g=E,this.h=f,this.a=Object.create(null),this.b="",this.c=new I.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(P){P.fileOperationResult!==1&&this.g.error(P)}}getItem(P,E){const f=this.a[P];return(0,C.isUndefinedOrNull)(f)?E:f}setItem(P,E){this.setItems([{key:P,data:E}])}setItems(P){let E=!1;for(const{key:f,data:w}of P)this.a[f]!==w&&((0,C.isUndefinedOrNull)(w)?(0,C.isUndefined)(this.a[f])||(this.a[f]=void 0,E=!0):(this.a[f]=w,E=!0));E&&this.j()}removeItem(P){(0,C.isUndefined)(this.a[P])||(this.a[P]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const P=JSON.stringify(this.a,null,4);if(P!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(P)),this.b=P}catch(E){this.g.error(E)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=p;let m=class{constructor(P,E,f){this.a=new p(P.stateResource,E,f)}async init(){await this.a.init()}getItem(P,E){return this.a.getItem(P,E)}};m=pe([ie(0,R.IEnvironmentService),ie(1,k.ILogService),ie(2,A.IFileService)],m),e.StateService=m}),define(ee[231],te([0,1,230]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends I.StateService{setItem(R,A){this.a.setItem(R,A)}setItems(R){this.a.setItems(R)}removeItem(R){this.a.removeItem(R)}close(){return this.a.close()}}e.StateMainService=t}),define(ee[89],te([0,1,4,33,7,29]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(m){if(I.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function k(m,y,P,E,f,w,d,b,u,v){const g=Object.create(null);g["common.machineId"]=d,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=f,g.version=w,g["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,I.PlatformToString)(I.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=E,g["common.product"]=v||"desktop",b&&(g["common.msftInternal"]=b);let h=0;const l=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),I.isLinuxSnap&&(g["common.snap"]="true");const i=A(P);i&&(g["common.platformDetail"]=i);try{const s=await m.readFile(C.URI.file(u));g["common.source"]=s.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=k;function p(m){const y=t.env.USERDNSDOMAIN;if(!y)return!1;const P=y.toLowerCase();return m.some(E=>P===E)}e.verifyMicrosoftInternalDomain=p}),define(ee[31],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[232],te([0,1,25,8,43,15,9,4,7,81,23,101,84,16,19,31]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const b=new Map;async function u(i,s){const n=`${i}::${s.join(":")}`,a=b.get(n);if(a)return a;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,o=new Map,S=2e4;function M(B,J,ae,X){const Y=J.substring(B.length+1);return t.Promises.withAsyncBody(async re=>{let ne;try{ne=await y.Promises.readdir(J,{withFileTypes:!0})}catch{re();return}if(X.count>=S){X.count+=ne.length,X.maxReached=!0,re();return}let de=ne.length;if(de===0){re();return}let K=ne;X.count+ne.length>S&&(X.maxReached=!0,de=S-X.count,K=ne.slice(0,de)),X.count+=ne.length;for(const le of K)if(le.isDirectory()){if(ae.includes(le.name)||await M(B,(0,A.join)(J,le.name),ae,X),--de===0){re();return}}else{const F=le.name.lastIndexOf(".");if(F>=0){const T=le.name.substring(F+1);T&&c.set(T,(c.get(T)??0)+1)}for(const T of r)T.relativePathPattern?.test(Y)!==!1&&T.filePattern.test(le.name)&&o.set(T.tag,(o.get(T.tag)??0)+1);if(--de===0){re();return}}})}const L=t.Promises.withAsyncBody(async B=>{const J={count:0,maxReached:!1};await M(i,i,s,J);const ae=await h(i);B({configFiles:v(o),fileTypes:v(c),fileCount:J.count,maxFilesReached:J.maxReached,launchConfigFiles:ae})});return b.set(n,L),L}e.collectWorkspaceStats=u;function v(i){return Array.from(i.entries(),([s,n])=>({name:s,count:n})).sort((s,n)=>n.count-s.count)}function g(){const i={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},s=I.cpus();return s&&s.length>0&&(i.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),i}e.getMachineInfo=g;async function h(i){try{const s=new Map,n=(0,A.join)(i,".vscode","launch.json"),a=await y.Promises.readFile(n),r=[],c=(0,C.parse)(a.toString(),r);if(r.length)return console.log(`Unable to parse ${n}`),[];if((0,C.getNodeType)(c)==="object"&&c.configurations)for(const o of c.configurations){const S=o.type;S&&(s.has(S)?s.set(S,s.get(S)+1):s.set(S,1))}return v(s)}catch{return[]}}e.collectLaunchConfigs=h;let l=class{constructor(s,n){this.c=s,this.d=n}f(s){const n=[];return n.push(`OS Version:       ${s.os}`),n.push(`CPUs:             ${s.cpus}`),n.push(`Memory (System):  ${s.memory}`),n.push(`VM:               ${s.vmHint}`),n.join(`
`)}g(s){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const a=I.cpus();return a&&a.length>0&&n.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||n.push(`Load (avg):       ${I.loadavg().map(r=>Math.round(r)).join(", ")}`),n.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${s.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(s,n){return Promise.all([(0,P.listProcesses)(s.mainPID),this.k(s)]).then(async a=>{let[r,c]=a,o=this.m(s,r);return n.forEach(S=>{if((0,E.isRemoteDiagnosticError)(S))o+=`
${S.errorMessage}`,c+=`
${S.errorMessage}`;else if(o+=`

Remote: ${S.hostName}`,S.processes&&(o+=`
${this.m(s,S.processes)}`),S.workspaceMetadata){c+=`
|  Remote: ${S.hostName}`;for(const M of Object.keys(S.workspaceMetadata)){const L=S.workspaceMetadata[M];let B=`${L.fileCount} files`;L.maxFilesReached&&(B=`more than ${B}`),c+=`|    Folder (${M}): ${B}`,c+=this.h(L)}}}),{processInfo:o,workspaceInfo:c}})}async getSystemInfo(s,n){const{memory:a,vmHint:r,os:c,cpus:o}=g(),S={os:c,memory:a,cpus:o,vmHint:r,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:n};return k.isWindows||(S.load=`${I.loadavg().map(M=>Math.round(M)).join(", ")}`),k.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(s,n){const a=[];return(0,P.listProcesses)(s.mainPID).then(async r=>(a.push(""),a.push(this.g(s)),a.push(""),a.push(this.m(s,r)),s.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.k(s))),n.forEach(c=>{if((0,E.isRemoteDiagnosticError)(c))a.push(`
${c.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${c.hostName}`),a.push(this.f(c.machineInfo)),c.processes&&a.push(this.m(s,c.processes)),c.workspaceMetadata)for(const o of Object.keys(c.workspaceMetadata)){const S=c.workspaceMetadata[o];let M=`${S.fileCount} files`;S.maxFilesReached&&(M=`more than ${M}`),a.push(`Folder (${o}): ${M}`),a.push(this.h(S))}}),a.push(""),a.push(""),a.join(`
`)))}h(s){const n=[];let r=0;const c=(L,B)=>{const J=` ${L}(${B})`;r+J.length>60?(n.push(o),o="|                 ",r=o.length):r+=J.length,o+=J};let o="|      File types:";const S=10,M=s.fileTypes.length>S?S:s.fileTypes.length;for(let L=0;L<M;L++){const B=s.fileTypes[L];c(B.name,B.count)}if(n.push(o),s.configFiles.length>=0&&(o="|      Conf files:",r=0,s.configFiles.forEach(L=>{c(L.name,L.count)}),n.push(o)),s.launchConfigFiles.length>0){let L="|      Launch Configs:";s.launchConfigFiles.forEach(B=>{L+=B.count>1?` ${B.name}(${B.count})`:` ${B.name}`}),n.push(L)}return n.join(`
`)}j(s){const n=Math.max(...Object.keys(s).map(a=>a.length));return Object.keys(s).map(a=>`${a}:  ${" ".repeat(n-a.length)}  ${s[a]}`).join(`
                  `)}k(s){const n=[],a=[];return s.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(n.push(`|  Window (${r.title})`),r.folderURIs.forEach(c=>{const o=p.URI.revive(c);if(o.scheme===R.Schemas.file){const S=o.fsPath;a.push(u(S,["node_modules",".git"]).then(M=>{let L=`${M.fileCount} files`;M.maxFilesReached&&(L=`more than ${L}`),n.push(`|    Folder (${(0,A.basename)(S)}): ${L}`),n.push(this.h(M))}).catch(M=>{n.push(`|      Error: Unable to collect workspace stats for folder ${S} (${M.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(r=>n.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(s,n){const a=new Map;s.windows.forEach(c=>a.set(c.pid,c.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),n&&this.n(s.mainPID,a,r,n,0),r.join(`
`)}n(s,n,a,r,c){const o=c===0;let S;o?S=r.pid===s?`${this.d.applicationName} main`:"remote agent":(S=`${"  ".repeat(c)} ${r.name}`,r.name==="window"&&(S=`${S} (${n.get(r.pid)})`));const M=process.platform==="win32"?r.mem:I.totalmem()*(r.mem/100);a.push(`${r.load.toFixed(0).padStart(5," ")}	${(M/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(r.children)&&r.children.forEach(L=>this.n(s,n,a,L,c+1))}async getWorkspaceFileExtensions(s){const n=new Set;for(const{uri:a}of s.folders){const r=p.URI.revive(a);if(r.scheme!==R.Schemas.file)continue;const c=r.fsPath;try{(await u(c,["node_modules",".git"])).fileTypes.forEach(S=>n.add(S.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(s){for(const{uri:n}of s.folders){const a=p.URI.revive(n);if(a.scheme!==R.Schemas.file)continue;const r=a.fsPath;try{const c=await u(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),c.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})}),c.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})}),c.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};l=pe([ie(0,d.ITelemetryService),ie(1,w.IProductService)],l),e.DiagnosticsService=l}),define(ee[233],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(R){this.b=R}listen(R,A){throw new Error(`Event not found: ${A}`)}call(R,A,{eventName:k,data:p}){return this.b.forEach(m=>m.log(k,p)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class t{constructor(R){this.b=R}log(R,A){return this.b.call("log",{eventName:R,data:A}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ee[56],te([0,1,44,12,18,54,89,31]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class p{constructor(c){this.value=c}}e.TrustedTelemetryValue=p;class m{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,o){return Promise.resolve(void 0)}publicLog2(c,o){return this.publicLog(c,o)}publicLogError(c,o){return Promise.resolve(void 0)}publicLogError2(c,o){return this.publicLogError(c,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=m,e.NullTelemetryService=new m;class y{async publicLog(c,o,S){}async publicLogError(c,o,S){}}e.NullEndpointTelemetryService=y,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(r,c){return c.onDidChangeConfiguration(o=>{o.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(o.source),configurationKeys:g(o.sourceConfig)})})}e.configurationTelemetry=P;function E(r,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!r.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=E;function f(r,c){return!(c.isBuilt||c.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.isLoggingOnly=f;function w(r){const c=r.getValue(k.TELEMETRY_SETTING_ID),o=r.getValue("telemetry.enableCrashReporter");if(r.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function d(r){const c={},o={},S={};v(r,S);for(let M in S){M=M.length>150?M.substr(M.length-149):M;const L=S[M];typeof L=="number"?o[M]=L:typeof L=="boolean"?o[M]=L?1:0:typeof L=="string"?(L.length>8192&&console.warn(`Telemetry property: ${M} has been trimmed to 8192, the original length is ${L.length}`),c[M]=L.substring(0,8191)):typeof L<"u"&&L!==null&&(c[M]=L)}return{properties:c,measurements:o}}e.validateTelemetryData=d;const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function u(r){if(!r)return"none";const c=(0,R.getRemoteName)(r);return b.has(c)?c:"other"}e.cleanRemoteAuthority=u;function v(r,c,o=0,S){if(!!r)for(const M of Object.getOwnPropertyNames(r)){const L=r[M],B=S?S+M:M;Array.isArray(L)?c[B]=(0,I.safeStringify)(L):L instanceof Date?c[B]=L.toISOString():(0,t.isObject)(L)?o<2?v(L,c,o+1,B+"."):c[B]=(0,I.safeStringify)(L):c[B]=L}}function g(r){if(!r)return[];const c=[];return h(c,"",r),c}function h(r,c,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(S=>h(r,c?`${c}.${S}`:S,o[S])):r.push(c)}function l(r,c){const o=r.msftInternalDomains||[],S=c.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(o)||S}e.isInternalTelemetry=l;function i(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=i;function s(r,c){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let o=r;const S=[];for(const J of c)for(;;){const ae=J.exec(r);if(!ae)break;S.push([ae.index,J.lastIndex])}const M=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,L=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let B=0;for(o="";;){const J=L.exec(r);if(!J)break;const ae=S.some(([X,Y])=>J.index<Y&&X<L.lastIndex);!M.test(J[0])&&!ae&&(o+=r.substring(B,J.index)+"<REDACTED: user-file-path>",B=L.lastIndex)}return B<r.length&&(o+=r.substr(B)),o}function n(r){if(!r)return r;const c=r.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const S of o)if(S.regex.test(c))return`<REDACTED: ${S.label}>`;return r}function a(r,c){return(0,I.cloneAndChange)(r,o=>{if(o instanceof p)return o.value;if(typeof o=="string"){let S=o.replaceAll("%20"," ");S=s(S,c);for(const M of c)S=S.replace(M,"");return S=n(S),S}})}e.cleanData=a}),define(ee[234],te([0,1,189,56]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function C(R,A,k,p,m,y,P){const E={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${A.nameShort})`};if((0,t.supportsTelemetry)(A,k)&&(0,t.getTelemetryLevel)(p)===3){const f=await(0,I.getServiceMachineId)(k,m,y),{machineId:w}=await P.getTelemetryInfo();E["X-Market-User-Id"]=f,E["VSCode-SessionId"]=w||f}return E}e.resolveMarketplaceHeaders=C}),define(ee[235],te([0,1,14,44,56]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://0.0.0.0/OneCollector/1.0";async function A(p,m,y){const P=await new Promise((b,u)=>{H(["@microsoft/1ds-core-js"],b,u)}),E=await new Promise((b,u)=>{H(["@microsoft/1ds-post-js"],b,u)}),f=new P.AppInsightsCore,w=new E.PostChannel,d={instrumentationKey:p,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(y){d.extensionConfig={};const b={alwaysUseXhrOverride:!0,httpXHROverride:y};d.extensionConfig[w.identifier]=b}return f.initialize(d,[]),f.addTelemetryInitializer(b=>{m&&(b.ext=b.ext??{},b.ext.utc=b.ext.utc??{},b.ext.utc.flags=8462029)}),f}class k{constructor(m,y,P,E,f){this.d=m,this.e=y,this.f=P,this.g=f,this.c=R,this.f||(this.f={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}h(m){if(!!this.a){if(typeof this.a!="string"){m(this.a);return}this.b||(this.b=A(this.a,this.d,this.g)),this.b.then(y=>{m(y)},y=>{(0,I.onUnexpectedError)(y),console.error(y)})}}log(m,y){if(!this.a)return;y=(0,t.mixin)(y,this.f),y=(0,C.validateTelemetryData)(y);const P=this.e+"/"+m;try{this.h(E=>{E.pluginVersionString=y?.properties.version??"Unknown",E.track({name:P,baseData:{name:P,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(m=>{this.h(y=>{y.unload(!0,()=>{this.a=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=k}),define(ee[112],te([0,1,2,44,4,26,168,18,65,63,19,48,31,56]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(u,v,g){this.k=v,this.l=g,this.d={},this.i=new I.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(h.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(u,v){this.d[u]=v}m(){let u=(0,f.getTelemetryLevel)(this.k);const v=this.l.enabledTelemetryLevels;if(v){this.h=this.sendErrorTelemetry?v.error:!1;const g=v.usage?3:v.error?2:0;u=Math.min(u,g)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,v=u.sessionID,g=u["common.machineId"],h=u["common.firstSessionDate"],l=u["common.msftInternal"];return{sessionId:v,machineId:g,firstSessionDate:h,msftInternal:l}}dispose(){this.i.dispose()}n(u,v,g){return this.g<v?Promise.resolve(void 0):this.c.then(h=>{g=(0,t.mixin)(g,this.d),g=(0,f.cleanData)(g,this.j),g=(0,t.mixin)(g,h),this.b.forEach(l=>l.log(u,g))},h=>{console.error(h)})}publicLog(u,v){return this.n(u,3,v)}publicLog2(u,v){return this.publicLog(u,v)}publicLogError(u,v){return this.h?this.n(u,2,v):Promise.resolve(void 0)}publicLogError2(u,v){return this.publicLogError(u,v)}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=pe([ie(1,k.IConfigurationService),ie(2,y.IProductService)],w),e.TelemetryService=w;function d(){const b=(0,A.localize)(0,null,m.default.nameLong),u=m.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=C.isWeb?"":(0,A.localize)(3,null),g=(0,A.localize)(4,null),h=(0,A.localize)(5,null),l=(0,A.localize)(6,null),i=(0,A.localize)(7,null),s=`
|       | ${g} | ${h} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,A.localize)(8,null);return`
${b} ${u} ${v}

&nbsp;

${i}
${s}

&nbsp;

${n}
`}P.Registry.as(p.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(p.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,A.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,A.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[236],te([0,1,282,235]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class C extends t.AbstractOneDataSystemAppender{constructor(A,k,p,m){const y={sendPOST:(P,E)=>{const f={method:"POST",headers:{...P.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(P.data)}};try{const w=I.request(P.urlString,f,d=>{d.on("data",function(b){E(d.statusCode??200,d.headers,b.toString())}),d.on("error",function(b){E(0,{})})});w.write(P.data),w.end()}catch{E(0,{})}}};super(A,k,p,m,y)}}e.OneDataSystemAppender=C}),define(ee[237],te([0,1,4,81,31]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(A){let k=A.getItem(C.machineIdKey);return(typeof k!="string"||I.isMacintosh&&k==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(k=await(0,t.getMachineId)()),k}e.resolveMachineId=R}),define(ee[113],te([0,1,31,237]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function C(R){const A=await(0,t.resolveMachineId)(R);return R.setItem(I.machineIdKey,A),A}e.resolveMachineId=C}),define(ee[238],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var I;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(I=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===I.HIGH_CONTRAST_DARK||R===I.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function C(R){return R===I.DARK||R===I.HIGH_CONTRAST_DARK}e.isDark=C}),define(ee[239],te([0,1,120,3,2,5,48,238]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var p;(function(b){function u(v){return v&&typeof v=="object"&&typeof v.id=="string"}b.isThemeColor=u})(p=e.ThemeColor||(e.ThemeColor={}));function m(b){return{id:b}}e.themeColorFromId=m;var y;(function(b){function u(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||p.isThemeColor(a.color))}b.isThemeIcon=u;const v=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function g(a){const r=v.exec(a);if(!r)return;const[,c]=r;return{id:c}}b.fromString=g;function h(a){return{id:a}}b.fromId=h;function l(a,r){let c=a.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),r&&(c=`${c}~${r}`),{id:c}}b.modify=l;function i(a){const r=a.id.lastIndexOf("~");if(r!==-1)return a.id.substring(r+1)}b.getModifier=i;function s(a,r){return a.id===r.id&&a.color?.id===r.color?.id}b.isEqual=s;function n(a,r){return{id:a.id,color:r?m(r):void 0}}b.asThemeIcon=n,b.asClassNameArray=I.CSSIcon.asClassNameArray,b.asClassName=I.CSSIcon.asClassName,b.asCSSSelector=I.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function P(b){switch(b){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case k.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,C.toDisposable)(()=>{const v=this.a.indexOf(u);this.a.splice(v,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const f=new E;A.Registry.add(e.Extensions.ThemingContribution,f);function w(b){return f.onColorThemeChange(b)}e.registerThemingParticipant=w;class d extends C.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(v=>this.n(v)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,v){let g=this.h.getColor(u);return g&&v&&(g=v(g,this.h)),g?g.toString():null}}e.Themable=d}),define(ee[66],te([0,1,13,3,2,4,18,5,36]),function(H,e,I,t,C,R,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",y="#1E1E1E",P="#000000",E="#FFFFFF",f="theme",w="themeBackground",d="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let b=class extends C.Disposable{constructor(v,g){super(),this.b=v,this.c=g,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,I.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return v.dark?P:E;let g=this.b.getItem(w,null);if(!g)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":g=m;break;case"hc-black":g=P;break;case"hc-light":g=E;break;default:g=y}return R.isMacintosh&&g.toUpperCase()===y&&(g="#171717"),g}saveWindowSplash(v,g){this.b.setItems([{key:f,data:g.baseTheme},{key:w,data:g.colorInfo.background},{key:d,data:g}]),typeof v=="number"&&this.f(v,g)}f(v,g){for(const h of I.BrowserWindow.getAllWindows())if(h.id===v){h.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(d)}};b=pe([ie(0,p.IStateMainService),ie(1,A.IConfigurationService)],b),e.ThemeMainService=b}),define(ee[114],te([0,1,3,18,5,6]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var A;(function(d){d.Http="http",d.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var p;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(p=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function E(d,b,u,v){if(u===1)return!1;if(u===2&&P(b)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(g?.length===4&&parseInt(g[1])>=18)return!1}return d<1024}e.isPortPrivileged=E;class f{constructor(b,u,v){this.remoteAddress=b,this.localAddress=u,this.b=v,this.a=new I.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let w=class{constructor(b,u){this.i=b,this.j=u,this.a=new I.Emitter,this.onTunnelOpened=this.a.event,this.b=new I.Emitter,this.onTunnelClosed=this.b.event,this.c=new I.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const b=this.j.getValue("remote.localPortHost");return!b||b==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(b){return this.e=b,b?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this.f=b.elevation,this.g=b.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const b=[],u=Array.from(this.d.values());for(const v of u){const g=Array.from(v.values());for(const h of g){const l=await h.value;l&&b.push(l)}}return b}async dispose(){for(const b of this.d.values()){for(const{value:u}of b.values())await u.then(v=>v?.dispose());b.clear()}this.d.clear()}setEnvironmentTunnel(b,u,v,g,h){this.o(b,u,Promise.resolve({tunnelRemoteHost:b,tunnelRemotePort:u,localAddress:v,privacy:g,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(b,u){(P(b)||y(b))&&(b=e.LOCALHOST_ADDRESSES[0]);const v=this.q(b,u);if(v)return++v.refcount,v.value}openTunnel(b,u,v,g,h=!1,l,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${v} on local port ${g}.`),!b)return;if(u||(u="localhost"),this.e&&this.h.has(v)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(b,u,v,g,h,l,i);return s?s.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,v);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==v)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const u=this.d.get(b.tunnelRemoteHost);if(u){const v=u.get(b.tunnelRemotePort);v&&(v.refcount--,await this.n(b.tunnelRemoteHost,b.tunnelRemotePort,v))}}}}async n(b,u,v){if(v.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${u}.`);const g=v.value.then(async h=>{h&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.d.has(b)&&this.d.get(b).delete(u),g}}async closeTunnel(b,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${u} `);const v=this.d.get(b);if(v&&v.has(u)){const g=v.get(u);g.refcount=0,await this.n(b,u,g)}}o(b,u,v){this.d.has(b)||this.d.set(b,new Map),this.d.get(b).set(u,{refcount:1,value:v})}async p(b,u){const v=this.d.get(b);v&&(await v.get(u)||v.delete(u),v.size===0&&this.d.delete(b))}q(b,u){const v=[b];y(b)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):P(b)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const g=v.map(h=>this.d.get(h));for(const h of g){const l=h?.get(u);if(l)return l}}canTunnel(b){return!!m(b)}s(b,u,v,g,h,l,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${v} on local port ${g}.`);const s=v;this.h.add(s);const n=g===void 0?v:g,a={elevationRequired:h?this.isPortPrivileged(n):!1},r={remoteAddress:{host:u,port:v},localAddressPort:g,privacy:l,public:l?l!==k.Private:void 0,protocol:i},c=b.forwardPort(r,a);return c?(this.o(u,v,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),c}};w=pe([ie(0,R.ILogService),ie(1,t.IConfigurationService)],w),e.AbstractTunnelService=w}),define(ee[240],te([0,1,78,25,97,222,8,2,18,6,19,221,114,88,4]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function d(h,l,i,s,n){let a;for(let r=3;r&&(a?.dispose(),a=await new b(h,l,i,s,n).waitForReady(),!(n&&C.BROWSER_RESTRICTED_PORTS[n]||!C.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));r--);return a}class b extends k.Disposable{constructor(l,i,s,n,a){super(),this.j=i,this.k=a,this.privacy=E.TunnelPrivacyId.Private,this.i=new Map,this.a=l,this.b=I.createServer(),this.c=new A.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=r=>this.l(r),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const l=this.k??this.tunnelRemotePort,i=(0,E.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let s=await(0,C.findFreePortFaster)(l,2,1e3,i),n=null;return this.b.listen(s,this.j),await this.c.wait(),n=this.b.address(),n||(s=0,this.b.listen(s,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(l){l.pause();const i=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,P.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),n=s.getSocket().socket,a=s.readEntireBuffer();s.dispose(),a.byteLength>0&&l.write(a.buffer),l.on("end",()=>{l.localAddress&&this.i.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this.i.delete(l.localAddress),n.destroy()}),n.on("end",()=>l.end()),n.on("close",()=>l.end()),n.on("error",()=>{l.destroy()}),l.pipe(n),n.pipe(l),l.localAddress&&this.i.set(l.localAddress,()=>{l.end(),n.end()})}}let u=class extends E.AbstractTunnelService{constructor(l,i,s,n,a){super(i,a),this.t=l,this.u=s,this.v=n}isPortPrivileged(l){return(0,E.isPortPrivileged)(l,this.k,w.OS,t.release())}r(l,i,s,n,a,r,c){const o=this.q(i,s);if(o)return++o.refcount,o.value;if(this.e)return this.s(this.e,i,s,n,a,r,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${s} on local port ${n}.`);const S={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:l,signService:this.u,logService:this.i,ipcLogger:null},M=d(S,this.k,i,s,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,s,M),M}}};u=pe([ie(1,m.ILogService),ie(2,f.ISignService),ie(3,y.IProductService),ie(4,p.IConfigurationService)],u),e.BaseTunnelService=u;let v=class extends u{constructor(l,i,s,n){super(R.nodeSocketFactory,l,i,s,n)}};v=pe([ie(0,m.ILogService),ie(1,f.ISignService),ie(2,y.IProductService),ie(3,p.IConfigurationService)],v),e.TunnelService=v;let g=class extends k.Disposable{constructor(l,i,s,n){super(),this.b=l,this.c=i,this.f=s,this.g=n,this.a=new Map}async openTunnel(l,i,s,n,a,r,c,o){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${n} on local port ${a}.`),!this.a.has(l)){const S=new v(this.b,this.f,this.c,this.g);this.B(S),this.a.set(l,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(i,s,n,a,r,c,o)}};g=pe([ie(0,m.ILogService),ie(1,y.IProductService),ie(2,f.ISignService),ie(3,p.IConfigurationService)],g),e.SharedTunnelsService=g}),define(ee[49],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var C;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(C=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,A)=>({type:"idle",updateType:R,error:A}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(ee[241],te([0,1,4,169,65,48]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(C.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[242],te([0,1,3,49]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class C{constructor(k){this.a=k}listen(k,p){switch(p){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${p}`)}call(k,p,m){switch(p){case"checkForUpdates":return this.a.checkForUpdates(m);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(m)}throw new Error(`Call not found: ${p}`)}}e.UpdateChannel=C;class R{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new I.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(p=>this.state=p),this.c.call("_getInitialState").then(p=>this.state=p)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=R}),define(ee[90],te([0,1,8,22,3,18,27,21,6,19,55,49]),function(H,e,I,t,C,R,A,k,p,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(w,d,b){return`${b.updateUrl}/api/update/${w}/${d}/${b.commit}`}e.createUpdateURL=E;let f=class{get state(){return this.b}d(d){this.j.info("update#setState",d.type),this.b=d,this.c.fire(d)}constructor(d,b,u,v,g,h){this.f=d,this.g=b,this.h=u,this.i=v,this.j=g,this.k=h,this.b=P.State.Uninitialized,this.c=new C.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.l(),b=this.m(d);if(!b){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(b),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(P.State.Idle(this.q())),d==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}l(){return(0,R.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(d){return d==="none"?void 0:this.k.quality}n(d=60*60*1e3){return(0,I.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(d){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(d)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(d){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(d){}q(){return 1}r(){}};f=pe([ie(0,k.ILifecycleMainService),ie(1,R.IConfigurationService),ie(2,A.IEnvironmentMainService),ie(3,y.IRequestService),ie(4,p.ILogService),ie(5,m.IProductService)],f),e.AbstractUpdateService=f}),define(ee[243],te([0,1,13,53,3,2,18,27,21,6,19,55,31,49,90]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let d=class extends w.AbstractUpdateService{get v(){return C.Event.fromNodeEventEmitter(I.autoUpdater,"error",(u,v)=>v)}get w(){return C.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get x(){return C.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(u,v,g)=>({url:v,version:g,productVersion:g}))}get y(){return C.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(u,v,g,h)=>({releaseNotes:v,version:g,productVersion:g,date:h}))}constructor(u,v,g,h,l,i,s){super(u,v,h,l,i,s),this.z=g,this.u=new R.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(u){this.j.error("UpdateService error:",u);const g=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(f.State.Idle(1,g))}s(u){let v;this.k.darwinUniversalAssetId?v=this.k.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,w.createUpdateURL)(v,u,this.k);try{I.autoUpdater.setFeedURL({url:g})}catch(h){this.j.error("Failed to set update feed URL",h);return}return g}t(u){this.d(f.State.CheckingForUpdates(u)),I.autoUpdater.checkForUpdates()}D(u){this.state.type==="checking for updates"&&this.d(f.State.Downloading(u))}E(u){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:u.version}),this.d(f.State.Ready(u)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],d.prototype,"v",null),pe([t.memoize],d.prototype,"w",null),pe([t.memoize],d.prototype,"x",null),pe([t.memoize],d.prototype,"y",null),d=pe([ie(0,p.ILifecycleMainService),ie(1,A.IConfigurationService),ie(2,E.ITelemetryService),ie(3,k.IEnvironmentMainService),ie(4,P.IRequestService),ie(5,m.ILogService),ie(6,y.IProductService)],d),e.DarwinUpdateService=d}),define(ee[244],te([0,1,46,40,8,3,9,27,21,6,31,49]),function(H,e,I,t,C,R,A,k,p,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{get state(){return this.a}d(d){this.g.info("update#setState",d.type),this.a=d,this.b.fire(d)}constructor(d,b,u){if(this.f=d,this.g=u,this.a=P.State.Uninitialized,this.b=new R.Emitter,this.onStateChange=this.b.event,b.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(P.State.Idle(this.k())),this.h(30*1e3).then(void 0,v=>this.g.error(v))}h(d=60*60*1e3){return(0,C.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(d){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(d)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(d){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(d){}};E=pe([ie(0,p.ILifecycleMainService),ie(1,k.IEnvironmentMainService),ie(2,m.ILogService)],E);let f=class extends E{constructor(d,b,u,v,g,h){super(u,v,g),this.o=d,this.p=b,this.q=h;const l=(0,t.watch)(A.dirname(this.o)),i=R.Event.fromNodeEventEmitter(l,"change",(r,c)=>c),s=R.Event.filter(i,r=>r==="current"),a=R.Event.debounce(s,(r,c)=>c,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{a.dispose(),l.close()})}m(){this.d(P.State.CheckingForUpdates(!1)),this.u().then(d=>{d?this.d(P.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(P.State.Idle(2)))},d=>{this.g.error(d),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(P.State.Idle(2,d.message||d))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+A.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const d=await new Promise((u,v)=>(0,t.realpath)(`${A.dirname(this.o)}/current`,(g,h)=>g?v(g):u(h))),b=A.basename(d);return this.p!==b}isLatestVersion(){return this.u().then(void 0,d=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=pe([ie(2,p.ILifecycleMainService),ie(3,k.IEnvironmentMainService),ie(4,m.ILogService),ie(5,y.ITelemetryService)],f),e.SnapUpdateService=f}),define(ee[42],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ee[245],te([0,1,42,190,16,20,126,3,2]),function(H,e,I,t,C,R,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(E){this.uri=E,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let y=class{constructor(E){this.g=E,this.c=new p.DisposableStore,this.f=2**16;const f=new Map,w=d=>{let b=f.get(d.scheme);return b===void 0&&(b=E.hasProvider(d)&&!this.g.hasCapability(d,1024),f.set(d.scheme,b)),b};this.c.add(k.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(d=>{f.delete(d.scheme)})),this.extUri=new R.ExtUri(w),this.d=new A.SkipList((d,b)=>this.extUri.compare(d,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(E){this.g.hasProvider(E)&&(E=(0,R.normalizePath)(E));const f=this.d.get(E);return f?f.touch().uri.with({fragment:E.fragment}):(this.d.set(E,new m(E)),this.h(),E)}h(){if(this.d.size<this.f)return;const E=[...this.d.entries()].sort((w,d)=>w[1].touch<d[1].touch?1:w[1].touch>d[1].touch?-1:0);m._clock=0,this.d.clear();const f=this.f*.5;for(let w=0;w<f;w++)this.d.set(E[w][0],E[w][1].touch())}};y=pe([ie(0,C.IFileService)],y),e.UriIdentityService=y,(0,t.registerSingleton)(I.IUriIdentityService,y,1)}),define(ee[115],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(ee[246],te([0,1,7]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(k){this.a=k}listen(k,p){throw new Error(`Event not found: ${p}`)}call(k,p,m){switch(p){case"handleURL":return this.a.handleURL(I.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${p}`)}}e.URLHandlerChannel=t;class C{constructor(k){this.a=k}handleURL(k,p){return this.a.call("handleURL",[k.toJSON(),p])}}e.URLHandlerChannelClient=C;class R{constructor(k){this.a=k}async routeCall(k,p,m,y){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(m){const P=I.URI.revive(m);if(P&&P.query){const E=/\bwindowId=(\d+)/.exec(P.query);if(E){const f=E[1],w=new RegExp(`window:${f}`),d=k.connections.find(b=>w.test(b.ctx));if(d)return d}}}return this.a.routeCall(k,p,m,y)}routeEvent(k,p){throw new Error(`Event not found: ${p}`)}}e.URLHandlerRouter=R}),define(ee[247],te([0,1,8,2,7,19]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class A extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(m,y){const P=[...this.a.values()];return(0,I.first)(P.map(E=>()=>E.handleURL(m,y)),void 0,!1).then(E=>E||!1)}registerHandler(m){return this.a.add(m),(0,t.toDisposable)(()=>this.a.delete(m))}}e.AbstractURLService=A;let k=class extends A{constructor(m){super(),this.b=m}create(m){let{authority:y,path:P,query:E,fragment:f}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&P&&P.indexOf("/")!==0&&(P=`/${P}`),C.URI.from({scheme:this.b.urlProtocol,authority:y,path:P,query:E,fragment:f})}};k=pe([ie(0,R.IProductService)],k),e.NativeURLService=k}),define(ee[248],te([0,1,13,8,3,2,4,7]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function p(y){try{return k.URI.parse(y)}catch{return null}}class m{constructor(P,E,f,w,d){if(this.f=E,this.a=[],this.b=0,this.c=R.Disposable.None,this.d=new R.DisposableStore,this.a=P,A.isWindows){const v=w.isBuilt?[]:[`"${w.appRoot}"`];v.push("--open-url","--"),I.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,v)}const b=C.Event.map(C.Event.fromNodeEventEmitter(I.app,"open-url",(v,g)=>({event:v,url:g})),({event:v,url:g})=>(v.preventDefault(),g));this.d.add(b(v=>{const g=p(v);!g||this.f.open(g,{originalUrl:v})})),f.getWindows().filter(v=>v.isReady).length>0?this.g():C.Event.once(f.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const P=[];for(const E of this.a)await this.f.open(E.uri,{originalUrl:E.url})||P.push(E);P.length!==0&&(this.a=P,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=m}),define(ee[249],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(ee[250],te([0,1,13,2,15,7]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class A extends t.Disposable{constructor(){super();const p=this.b.bind(this);I.protocol.registerFileProtocol(C.Schemas.vscodeWebview,p)}b(p,m){try{const y=R.URI.parse(p.url),P=A.a.get(y.path);if(typeof P=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${P}`,f=C.FileAccess.asFileUri(E);return m({path:decodeURIComponent(f.fsPath),headers:{...C.COI.getHeadersFromQuery(p.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=A,A.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[74],te([0,1,4]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(y){return!!y.workspaceUri}e.isWorkspaceToOpen=t;function C(y){return!!y.folderUri}e.isFolderToOpen=C;function R(y){return!!y.fileUri}e.isFileToOpen=R;function A(y){const P=k(y),E=y.getValue("window.menuBarVisibility");return E==="default"||P==="native"&&E==="compact"||I.isMacintosh&&I.isNative?"classic":E}e.getMenuBarVisibility=A;function k(y){if(I.isWeb)return"custom";const P=y.getValue("window");if(P){if(I.isMacintosh&&P.nativeTabs===!0||I.isMacintosh&&P.nativeFullScreen===!1)return"native";const w=P.titleBarStyle;if(w==="native"||w==="custom")return w}return I.isLinux?"native":"custom"}e.getTitleBarStyle=k;function p(y){if(!I.isWindows||I.isWeb||k(y)==="native")return!1;const P=y.getValue("window.experimental.windowControlsOverlay.enabled");return typeof P=="boolean"?P:!0}e.useWindowControlsOverlay=p;function m(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=m}),define(ee[116],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var t;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const C=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=C;var R;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var A;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(A=e.WindowError||(e.WindowError={}))}),define(ee[32],te([0,1,5]),function(H,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var t;(function(C){C[C.CLI=0]="CLI",C[C.DOCK=1]="DOCK",C[C.MENU=2]="MENU",C[C.DIALOG=3]="DIALOG",C[C.DESKTOP=4]="DESKTOP",C[C.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ee[251],te([0,1,13,22,3,68,2,29,71,106,6,19,32]),function(H,e,I,t,C,R,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let w=class extends A.Disposable{constructor(b,u,v,g,h){super(),this.g=b,this.h=u,this.i=v,this.j=g,this.k=h,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=f.Initial,this.f=void 0,this.l()}l(){const b=C.Event.fromNodeEventEmitter(I.app,"login",(u,v,g,h,l)=>({event:u,webContents:v,req:g,authInfo:h,callback:l}));this.B(b(this.m,this))}async m({event:b,authInfo:u,req:v,callback:g}){if(!u.isProxy)return;if(!this.b&&this.c===f.LoginDialogShown&&v.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let h;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{h=await this.b}finally{this.b=void 0}}g(h?.username,h?.password)}async n(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(b);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const u=String((0,R.hash)({scheme:b.scheme,host:b.host,port:b.port}));let v,g;try{const s=await this.i.getPassword(this.a,u);if(s){const n=JSON.parse(await this.j.decrypt(s));v=n.username,g=n.password}}catch(s){this.g.error(s)}if(this.c!==f.StoredCredentialsUsed&&typeof v=="string"&&typeof g=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=f.StoredCredentialsUsed,{username:v,password:g};const h=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!h){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const l={authInfo:b,username:this.f?.username??v,password:this.f?.password??g,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.c=f.LoginDialogShown;const i=await new Promise(s=>{const n=async(a,r,c)=>{if(r===l.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",n),c){const o={username:c.username,password:c.password};try{if(c.remember){const S=await this.j.encrypt(JSON.stringify(o));await this.i.setPassword(this.a,u,S)}else await this.i.deletePassword(this.a,u)}catch(S){this.g.error(S)}s({username:o.username,password:o.password})}else s(void 0)};h.win?.webContents.on("ipc-message",n)});return this.f=i,i}};w=pe([ie(0,y.ILogService),ie(1,E.IWindowsMainService),ie(2,p.ICredentialsMainService),ie(3,m.IEncryptionMainService),ie(4,P.IProductService)],w),e.ProxyAuthHandler=w}),define(ee[252],te([0,1,71,6,35,19,32,202]),function(H,e,I,t,C,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let p=class extends k.BaseCredentialsMainService{constructor(y,P,E,f){super(y),this.j=P,this.k=E,this.l=f,this.i=w=>{this.l.sendToFocused("vscode:showCredentialsError",w.message??w)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new I.InMemoryCredentialsProvider,this.f;const y=await new Promise((P,E)=>{H(["keytar"],P,E)});return await y.findCredentials("test-keytar-loads"),this.f=y,this.f}};p=pe([ie(0,t.ILogService),ie(1,C.INativeEnvironmentService),ie(2,R.IProductService),ie(3,A.IWindowsMainService)],p),e.CredentialsNativeMainService=p}),define(ee[253],te([0,1,14,2,3,6,21,80,46,283,8,15,44,4,33,13,32]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const u=d.utilityProcess,v=typeof u<"u";let g=class Nt{constructor(s,n,a){this.d=s,this.f=a,this.c=!1,this.b=new Map,n.onWillShutdown(r=>{this.c=!0,r.join(this._waitForAllExit(6e3))})}dispose(){}g(s){const n=this.b.get(s);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(s){return this.g(s).onStdout}onDynamicStderr(s){return this.g(s).onStderr}onDynamicMessage(s){return this.g(s).onMessage}onDynamicError(s){return this.g(s).onError}onDynamicExit(s){return this.g(s).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(s){if(this.c)throw(0,I.canceled)();const n=String(++Nt.a);let a;if(s){if(!v)throw new Error("Cannot use UtilityProcess!");a=new l(n,this.d,this.f)}else a=new h(n,this.d);return this.b.set(n,a),a.onExit(({pid:r,code:c,signal:o})=>{this.d.info(`Extension host with pid ${r} exited with code: ${c}, signal: ${o}.`),setTimeout(()=>{a.dispose(),this.b.delete(n)})}),{id:n}}async start(s,n){if(this.c)throw(0,I.canceled)();return this.g(s).start(n)}async enableInspectPort(s){if(this.c)throw(0,I.canceled)();const n=this.b.get(s);return n?n.enableInspectPort():!1}async kill(s){if(this.c)throw(0,I.canceled)();const n=this.b.get(s);!n||n.kill()}async _killAllNow(){for(const[,s]of this.b)s.kill()}async _waitForAllExit(s){const n=[];for(const[,a]of this.b)n.push(a.waitForExit(s));return y.Promises.settled(n).then(()=>{})}};g.a=0,g=pe([ie(0,R.ILogService),ie(1,A.ILifecycleMainService),ie(2,b.IWindowsMainService)],g),e.ExtensionHostStarter=g;let h=class extends t.Disposable{constructor(s,n){super(),this.id=s,this.c=n,this._onStdout=this.B(new C.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new C.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new C.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new C.Emitter),this.onError=this._onError.event,this._onExit=this.B(new C.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(s){f.isCI&&this.c.info("Calling fork to start extension host...");const n=k.StopWatch.create(!1);this.a=(0,p.fork)(P.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,E.mixin)({cwd:(0,w.cwd)()},s));const a=n.elapsed(),r=this.a.pid;this.c.info(`Starting extension host with pid ${r} (fork() took ${a} ms).`);const c=new m.StringDecoder("utf-8");this.a.stdout?.on("data",S=>{const M=typeof S=="string"?S:c.write(S);this._onStdout.fire(M)});const o=new m.StringDecoder("utf-8");this.a.stderr?.on("data",S=>{const M=typeof S=="string"?S:o.write(S);this._onStderr.fire(M)}),this.a.on("message",S=>{this._onMessage.fire(S)}),this.a.on("error",S=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(S)})}),this.a.on("exit",(S,M)=>{this.b=!0,this._onExit.fire({pid:r,code:S,signal:M})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):f.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(s){if(!this.a)return;const n=this.a.pid;this.c.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([C.Event.toPromise(this.onExit),(0,y.timeout)(s)]),this.b||(this.c.info(`Extension host with pid ${n} did not exit within ${s}ms.`),this.a.kill())}};h=pe([ie(1,R.ILogService)],h);let l=class extends t.Disposable{constructor(s,n,a){super(),this.id=s,this.c=n,this.f=a,this.onError=C.Event.None,this._onStdout=this.B(new C.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new C.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new C.Emitter),this.onMessage=this._onMessage.event,this._onExit=this.B(new C.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(s){const n=this.f.getWindowById(s.responseWindowId);if(!n){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const a=n.win;if(!a||a.isDestroyed()||a.webContents.isDestroyed()){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=`extensionHost${this.id}`,c=P.FileAccess.asFileUri("bootstrap-fork.js").fsPath,o=["--type=extensionHost","--skipWorkspaceStorageLock"],S=s.execArgv||[],M={...s.env},L=!0,B="pipe";for(const ne of Object.keys(M))M[ne]=String(M[ne]);this.c.info(`UtilityProcess<${this.id}>: Creating new...`),this.a=u.fork(c,o,{serviceName:r,env:M,execArgv:S,allowLoadingUnsignedLibraries:L,stdio:B});const J=new m.StringDecoder("utf-8");this.a.stdout?.on("data",ne=>{const de=typeof ne=="string"?ne:J.write(ne);this._onStdout.fire(de)});const ae=new m.StringDecoder("utf-8");this.a.stderr?.on("data",ne=>{const de=typeof ne=="string"?ne:ae.write(ne);this._onStderr.fire(de)}),this.a.on("message",ne=>{this._onMessage.fire(ne)}),this.B(C.Event.fromNodeEventEmitter(this.a,"spawn")(()=>{this.c.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const X=C.Event.fromNodeEventEmitter(this.a,"exit",ne=>ne);this.B(X(ne=>{this.c.info(`UtilityProcess<${this.id}>: received exit event with code ${ne}.`),this.b=!0,this._onExit.fire({pid:this.a.pid,code:ne,signal:""})}));const{port1:Y,port2:re}=new d.MessageChannelMain;this.a.postMessage("null",[re]),a.webContents.postMessage(s.responseChannel,s.responseNonce,[Y])}enableInspectPort(){return this.a?(this.c.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):!1):!1}kill(){!this.a||(this.c.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(s){if(!this.a)return;const n=this.a.pid;this.c.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([C.Event.toPromise(this.onExit),(0,y.timeout)(s)]),this.b||(this.c.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${s}ms, will kill it now.`),this.a.kill())}};l=pe([ie(1,R.ILogService),ie(2,b.IWindowsMainService)],l)}),define(ee[254],te([0,1,13,24,4,7,23,18,61,5,6,115,32]),function(H,e,I,t,C,R,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let f=class{constructor(d,b,u,v){this.a=d,this.b=b,this.c=u,this.d=v}async start(d,b){this.a.trace("Received data from other instance: ",d,b),C.isMacintosh&&I.app.focus({steal:!0});const u=this.e(d);if(u.length){let v=Promise.resolve();if(this.b.getWindowCount()===0){const g=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));g&&(v=g.ready())}v.then(()=>{for(const{uri:g,url:h}of u)this.c.open(g,{originalUrl:h})})}else return this.f(d,b)}e(d){return d["open-url"]&&d._urls&&d._urls.length>0?(0,t.coalesce)(d._urls.map(b=>{try{return{uri:R.URI.parse(b),url:b}}catch{return null}})):[]}async f(d,b){const u=(0,p.isLaunchedFromCli)(b)?0:4;let v=[];const g=d.wait&&d.waitMarkerFilePath?R.URI.file(d.waitMarkerFilePath):void 0,h=d.remote||void 0,l={context:u,cli:d,userEnv:b,waitMarkerFileURI:g,remoteAuthority:h,forceProfile:d.profile,forceTempProfile:d["profile-temp"]};if(d.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(d.extensionDevelopmentPath,l);else if(!d._.length&&!d["folder-uri"]&&!d["file-uri"]){let i=!1;if(d["new-window"]||d["unity-launch"]||l.forceProfile||l.forceTempProfile)i=!0;else if(d["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!C.isMacintosh}if(i)v=await this.b.open({...l,forceNewWindow:!0,forceEmpty:!0});else{const s=this.b.getLastActiveWindow();s?(this.b.openExistingWindow(s,l),v=[s]):v=await this.b.open({...l,forceEmpty:!0})}}else v=await this.b.open({...l,forceNewWindow:d["new-window"],preferNewWindow:!d["reuse-window"]&&!d.wait,forceReuseWindow:d["reuse-window"],diffMode:d.diff,mergeMode:d.merge,addMode:d.add,noRecentEntry:!!d["skip-add-to-recently-opened"],gotoLineMode:d.goto});if(g&&v.length===1&&v[0])return Promise.race([v[0].whenClosedOrLoaded,(0,A.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};f=pe([ie(0,y.ILogService),ie(1,E.IWindowsMainService),ie(2,P.IURLService),ie(3,k.IConfigurationService)],f),e.LaunchMainService=f}),define(ee[255],te([0,1,13,3,2,250,32]),function(H,e,I,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends C.Disposable{constructor(m){super(),this.b=m,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,y){let P;if(typeof m.windowId=="number"){const{windowId:E}=m,f=this.b.getWindowById(E);if(!f?.win)throw new Error(`Invalid windowId: ${E}`);P=f.win.webContents}else{const{webContentsId:E}=m;if(P=I.webContents.fromId(E),!P)throw new Error(`Invalid webContentsId: ${E}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(y)}async findInFrame(m,y,P,E){const w=this.c(m,y);if(typeof w.findInFrame=="function"){w.findInFrame(P,{findNext:E.findNext,forward:E.forward});const d=(b,u)=>{u.finalUpdate&&(this.a.fire(u),w.removeListener("found-in-frame",d))};w.on("found-in-frame",d)}}async stopFindInFrame(m,y,P){const f=this.c(m,y);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}c(m,y){const P=this.b.getWindowById(m.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${m}`);const E=P.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===y);if(!E)throw new Error(`Unknown frame: ${y}`);return E}};k=pe([ie(0,A.IWindowsMainService)],k),e.WebviewMainService=k}),define(ee[256],te([0,1,8,3,2]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends C.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:p,getActiveWindowId:m}){super(),this.a=this.B(new C.DisposableStore),t.Event.latch(t.Event.any(k,p))(this.f,this,this.a),this.b=(0,I.createCancelablePromise)(()=>m()),(async()=>{try{const P=await this.b;this.c=typeof this.c=="number"?this.c:P}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=R}),define(ee[28],te([0,1,173,9,60,20,7,5,15]),function(H,e,I,t,C,R,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function m(s){const n=s;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function y(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,t.basename)(s)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const a=s;if(a.configuration)return{id:a.id,configPath:a.configuration};if(a.folders.length===1)return{id:a.id,uri:a.folders[0].uri}}e.toWorkspaceIdentifier=y;function P(s){const n=s;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=P;function E(s){const n=s;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const a=s;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=E;var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function w(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=w;function d(s){const n=s;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=d;class b{constructor(n,a,r,c,o){this.h=n,this.j=r,this.k=c,this.l=o,this.c=C.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=C.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class u{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function v(s){return new u({uri:s,index:0,name:(0,R.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(s,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(s,n.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function h(s){let n;return A.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=h;function l(s,n){return!g(s,n)&&!h(s)}e.isSavedWorkspace=l;function i(s){return(typeof s=="string"?(0,t.extname)(s):(0,R.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ee[57],te([0,1,13,8,68,34,2,76,4,12,23,150,5,6,28]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,E.createDecorator)("dialogMainService");let d=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(u,v){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,P.localize)(0,null)},v)}pickFolder(u,v){return this.e({...u,pickFolders:!0,title:(0,P.localize)(1,null)},v)}pickFile(u,v){return this.e({...u,pickFiles:!0,title:(0,P.localize)(2,null)},v)}pickWorkspace(u,v){const g=(0,P.localize)(3,null),h=(0,R.mnemonicButtonLabel)((0,P.localize)(4,null)),l=w.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:g,filters:l,buttonLabel:h},v)}async e(u,v){const g={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(g.properties=void 0,u.pickFiles&&u.pickFolders&&(g.properties=["multiSelections","openDirectory","openFile","createDirectory"])),g.properties||(g.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),p.isMacintosh&&g.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(g,(0,m.withNullAsUndefined)(v||I.BrowserWindow.getFocusedWindow()));if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}f(u){if(u){let v=this.b.get(u.id);return v||(v=new t.Queue,this.b.set(u.id,v)),v}else return this.c}showMessageBox(u,v){return this.f(v).queue(async()=>v?I.dialog.showMessageBox(v,u):I.dialog.showMessageBox(u))}async showSaveDialog(u,v){const g=this.i(u,v);if(!g)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(v).queue(async()=>{let h;return v?h=await I.dialog.showSaveDialog(v,u):h=await I.dialog.showSaveDialog(u),h.filePath=this.g(h.filePath),h})}finally{(0,A.dispose)(g)}}g(u){return u&&p.isMacintosh&&(u=(0,k.normalizeNFC)(u)),u}h(u){return u.map(v=>this.g(v))}async showOpenDialog(u,v){u.defaultPath&&(await y.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const g=this.i(u,v);if(!g)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(v).queue(async()=>{let h;return v?h=await I.dialog.showOpenDialog(v,u):h=await I.dialog.showOpenDialog(u),h.filePaths=this.h(h.filePaths),h})}finally{(0,A.dispose)(g)}}i(u,v){if(!v)return A.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let g=this.a.get(v.id);g||(g=new Set,this.a.set(v.id,g));const h=(0,C.hash)(u);if(!g.has(h))return this.d.trace("[DialogMainService]: new file dialog lock created",u),g.add(h),(0,A.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),g?.delete(h),g?.size===0&&this.a.delete(v.id)})}};d=pe([ie(0,f.ILogService)],d),e.DialogMainService=d}),define(ee[257],te([0,1,3,2,69,28]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class A extends t.Disposable{constructor(p,m){super(),this.f=p,this.g=m,this.b=this.B(new I.Emitter),this.c=new Map,this.h(m.applicationStorage,this.b)}h(p,m){this.B(I.Event.debounce(p.onDidChangeStorage,(y,P)=>(y?y.push(P):y=[P],y),A.a)(y=>{y.length&&m.fire(this.i(y,p))}))}i(p,m){const y=new Map,P=new Set;return p.forEach(E=>{const f=m.get(E.key);typeof f=="string"?y.set(E.key,f):P.add(E.key)}),{changed:Array.from(y.entries()),deleted:Array.from(P.values())}}listen(p,m,y){switch(m){case"onDidChangeStorage":{const P=y.profile?(0,C.revive)(y.profile):void 0;if(!P)return this.b.event;let E=this.c.get(P.id);return E||(E=this.B(new I.Emitter),this.h(this.g.profileStorage(P),E),this.c.set(P.id,E)),E.event}}throw new Error(`Event not found: ${m}`)}async call(p,m,y){const P=y.profile?(0,C.revive)(y.profile):void 0,E=(0,R.reviveIdentifier)(y.workspace),f=await this.j(P,E);switch(m){case"getItems":return Array.from(f.items.entries());case"updateItems":{const w=y;if(w.insert)for(const[d,b]of w.insert)f.set(d,b);w.delete?.forEach(d=>f.delete(d));break}case"isUsed":{const w=y.payload;if(typeof w=="string")return this.g.isUsed(w)}default:throw new Error(`Call not found: ${m}`)}}async j(p,m){let y;m?y=this.g.workspaceStorage(m):p?y=this.g.profileStorage(p):y=this.g.applicationStorage;try{await y.init()}catch(P){this.f.error(`StorageIPC#init: Unable to init ${m?"workspace":p?"profile":"application"} storage due to ${P}`)}return y}}e.StorageDatabaseChannel=A,A.a=100}),define(ee[38],te([0,1,68,3,2,20,7,170,35,16,5,6,28,39,42,8,29,26,12]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function g(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.isUserDataProfile=g,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function h(n,a){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:A.URI.revive(n.location).with({scheme:a}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(n.extensionsResource)?.with({scheme:a}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=h;function l(n,a,r,c){return{id:n,name:a,location:r,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=l;let i=class extends C.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(a,r,c,o){super(),this.m=a,this.n=r,this.r=c,this.s=o,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(a){this.f!==a&&(this.t=void 0,this.f=a)}isEnabled(){return this.f}get u(){if(!this.t){const a=[];if(this.f)for(const S of this.H()){if(!S.name||!(0,v.isString)(S.name)||!S.location){this.s.warn("Skipping the invalid stored profile",S.location||S.name);continue}a.push(l((0,R.basename)(S.location),S.name,S.location,{shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}))}let r;const c=new f.ResourceMap,o=l((0,I.hash)(this.m.userRoamingDataHome.path).toString(16),(0,k.localize)(0,null),this.m.userRoamingDataHome);if(a.unshift({...o,extensionsResource:this.M()??o.extensionsResource,isDefault:!0}),a.length){const S=this.J();if(S.workspaces)for(const[M,L]of Object.entries(S.workspaces)){const B=A.URI.parse(M),J=A.URI.parse(L),ae=a.find(X=>this.r.extUri.isEqual(X.location,J));ae&&c.set(B,ae)}if(S.emptyWindow){const M=A.URI.parse(S.emptyWindow);r=a.find(L=>this.r.extUri.isEqual(L.location,M))}}this.t={profiles:a,workspaces:c,emptyWindow:r}}return this.t}async createTransientProfile(a){const r="Temp",c=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let o=0;for(const M of this.profiles){const L=c.exec(M.name),B=L?parseInt(L[1]):0;o=B>o?B:o}const S=`${r} ${o+1}`;return this.createProfile((0,I.hash)((0,b.generateUuid)()).toString(16),S,{transient:!0},a)}async createNamedProfile(a,r,c){return this.createProfile((0,I.hash)((0,b.generateUuid)()).toString(16),a,r,c)}async createProfile(a,r,c,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const S=await this.v(a,r,c);return o&&await this.setProfileForWorkspace(o,S),S}async v(a,r,c){if(!(0,v.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(r);return o||(o=(async()=>{try{const S=this.profiles.find(B=>B.name===r||B.id===a);if(S)return S;const M=l(a,r,(0,R.joinPath)(this.profilesHome,a),c);await this.n.createFolder(M.location);const L=[];return this.h.fire({profile:M,join(B){L.push(B)}}),await d.Promises.settled(L),this.C([M],[],[]),M}finally{this.k.delete(r)}})(),this.k.set(r,o)),o}async updateProfile(a,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(o=>o.id===a.id);if(!c)throw new Error(`Profile '${a.name}' does not exist`);return c=l(c.id,r.name??c.name,c.location,{shortName:r.shortName??c.shortName,transient:r.transient??c.isTransient,useDefaultFlags:r.useDefaultFlags??c.useDefaultFlags}),this.C([],[],[c]),c}async removeProfile(a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(a.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(o=>o.id===a.id);if(!r)throw new Error(`Profile '${a.name}' does not exist`);const c=[];this.i.fire({profile:r,join(o){c.push(o)}});try{await Promise.allSettled(c)}catch(o){this.s.error(o)}r.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const o of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(o){this.s.error(o)}}getOrSetProfileForWorkspace(a,r=this.defaultProfile){if(!this.f)return this.defaultProfile;let c=this.w(a);return c||(c=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(a,c)),c}async setProfileForWorkspace(a,r){this.setProfileForWorkspaceSync(a,r)}setProfileForWorkspaceSync(a,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(o=>o.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);this.F(a,c)}unsetWorkspace(a,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(a,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const a=await this.n.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(r=>r.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(a.map(r=>this.removeProfile(r)))}w(a){const r=this.y(a);return A.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindow??this.u.emptyWindow}y(a){return(0,E.isSingleFolderWorkspaceIdentifier)(a)?a.uri:(0,E.isWorkspaceIdentifier)(a)?a.configPath:"empty-window"}z(a){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,a.location)||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,a.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,a.location)||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,a.location)))}C(a,r,c){const o=[...this.profiles,...a],S=[];this.l.profiles=[];for(let M of o)M.isDefault||r.some(L=>M.id===L.id)||(M=c.find(L=>M.id===L.id)??M,M.isTransient?this.l.profiles.push(M):S.push({location:M.location,name:M.name,shortName:M.shortName,useDefaultFlags:M.useDefaultFlags}));this.I(S),this.t=void 0,this.D(a,r,c)}D(a,r,c){this.g.fire({added:a,removed:r,updated:c,all:this.profiles})}F(a,r,c){c=r?.isTransient?!0:c,c||this.F(a,void 0,!0);const o=this.y(a),S=c?this.l:this.u;A.URI.isUri(o)?(S.workspaces.delete(o),r&&S.workspaces.set(o,r)):S.emptyWindow=r,c||this.G()}G(){const a={};for(const[c,o]of this.u.workspaces.entries())a[c.toString()]=o.location.toString();const r=this.u.emptyWindow?.location.toString();this.L({workspaces:a,emptyWindow:r}),this.t=void 0}H(){return[]}I(a){throw new Error("not implemented")}J(){return{}}L(a){throw new Error("not implemented")}M(){}};i.b="userDataProfiles",i.c="profileAssociations",i=pe([ie(0,p.IEnvironmentService),ie(1,m.IFileService),ie(2,w.IUriIdentityService),ie(3,P.ILogService)],i),e.UserDataProfilesService=i;class s extends i{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(a){this.a=a}J(){return this.P}L(a){this.P=a}}e.InMemoryUserDataProfilesService=s}),define(ee[91],te([0,1,8,17,2,3,39,7,110,87,16,5,6,38,42]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,P.createDecorator)("IExtensionsProfileScannerService");let d=class extends C.Disposable{constructor(v,g,h,l){super(),this.h=v,this.i=g,this.j=h,this.k=l,this.a=this.B(new R.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new R.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new A.ResourceMap}scanProfileExtensions(v){return this.l(v)}async addExtensionsToProfile(v,g){const h=[],l=[];try{return await this.l(g,i=>{const s=[];for(const n of i)v.some(([a])=>(0,p.areSameExtensions)(a.identifier,n.identifier)&&a.manifest.version!==n.version)?h.push(n):s.push(n);for(const[n,a]of v)if(!s.some(r=>(0,p.areSameExtensions)(r.identifier,n.identifier)&&r.version===n.manifest.version)){const r={identifier:n.identifier,version:n.manifest.version,location:n.location,metadata:a};l.push(r),s.push(r)}return l.length&&this.a.fire({extensions:l,profileLocation:g}),h.length&&this.c.fire({extensions:h,profileLocation:g}),s}),l.length&&this.b.fire({extensions:l,profileLocation:g}),h.length&&this.f.fire({extensions:h,profileLocation:g}),l}catch(i){throw l.length&&this.b.fire({extensions:l,error:i,profileLocation:g}),h.length&&this.f.fire({extensions:h,error:i,profileLocation:g}),i}}async removeExtensionFromProfile(v,g){const h=[];this.c.fire({extensions:h,profileLocation:g});try{await this.l(g,l=>{const i=[];for(const s of l)(0,p.areSameExtensions)(s.identifier,v.identifier)?h.push(s):i.push(s);return h.length&&this.c.fire({extensions:h,profileLocation:g}),i}),h.length&&this.f.fire({extensions:h,profileLocation:g})}catch(l){throw h.length&&this.f.fire({extensions:h,error:l,profileLocation:g}),l}}async l(v,g){return this.p(v).queue(async()=>{let h=[],l;try{const i=await this.h.readFile(v);l=JSON.parse(i.value.toString())}catch(i){if((0,y.toFileOperationResult)(i)!==1)throw i;this.j.extUri.isEqual(v,this.i.defaultProfile.extensionsResource)&&(l=await this.n())}if(l)for(const i of l){if(!i.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",i);continue}if(!i.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",i);continue}if(!i.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",i);continue}h.push({identifier:i.identifier,location:k.URI.revive(i.location),version:i.version,metadata:i.metadata})}if(g){h=g(h);const i=h.map(s=>({identifier:s.identifier,version:s.version,location:s.location.toJSON(),metadata:s.metadata}));await this.h.writeFile(v,t.VSBuffer.fromString(JSON.stringify(i)))}return h})}async n(){return this.m||(this.m=(async()=>{const v=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let g;try{g=(await this.h.readFile(v)).value.toString()}catch(l){if((0,y.toFileOperationResult)(l)===1)return;throw l}this.k.info("Migrating extensions from old default profile location",v.toString());let h;try{const l=JSON.parse(g);Array.isArray(l)&&l.every(i=>!!(i&&typeof i=="object"&&(0,m.isIExtensionIdentifier)(i.identifier)&&b(i.location)&&i.version&&typeof i.version=="string"))?h=l:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.k.error(l)}if(h)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(h)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",v.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(l){if((0,y.toFileOperationResult)(l)===3)this.k.info("Migration from old default profile location to new location is done by another window",v.toString(),this.i.defaultProfile.extensionsResource.toString());else throw l}try{await this.h.del(v)}catch(l){(0,y.toFileOperationResult)(l)!==1&&this.k.error(l)}return h})()),this.m}p(v){let g=this.g.get(v);return g||(g=new I.Queue,this.g.set(v,g)),g}};d=pe([ie(0,y.IFileService),ie(1,f.IUserDataProfilesService),ie(2,w.IUriIdentityService),ie(3,E.ILogService)],d),e.ExtensionsProfileScannerService=d;function b(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}}),define(ee[117],te([0,1,24,8,44,17,14,43,136,2,15,9,4,20,188,98,12,7,155,35,110,87,187,16,5,6,19,3,69,91,38,42,185,186]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l,i,s,n,a,r,c,o,S,M,L,B,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ae;(function(le){function F(T,N){if(T===N)return!0;const V=Object.keys(T),se=new Set;for(const z of Object.keys(N))se.add(z);if(V.length!==se.size)return!1;for(const z of V){if(T[z]!==N[z])return!1;se.delete(z)}return se.size===0}le.equals=F})(ae=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let X=class extends m.Disposable{constructor(F,T,N,V,se,z,$,D,O,W,U,q){super(),this.systemExtensionsLocation=F,this.userExtensionsLocation=T,this.l=N,this.m=V,this.n=se,this.p=z,this.r=$,this.s=D,this.t=O,this.u=W,this.v=U,this.w=q,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ne,(0,f.joinPath)(this.m,l.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ne,(0,f.joinPath)(this.m,l.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(re,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,h.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(F,T,N){const[V,se]=await Promise.all([this.scanSystemExtensions(F),this.scanUserExtensions(T)]),z=N?await this.scanExtensionsUnderDevelopment(F,[...V,...se]):[];return this.D(V,se,z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(F){const T=[];T.push(this.F(!!F.useCache,F.language)),T.push(this.G(F.language,!!F.checkControlFile));const[N,V]=await Promise.all(T);return this.C([...N,...V],0,F,!1)}async scanUserExtensions(F){const T=F.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",T);const N=await this.I(T,!!F.profileLocation,1,!F.includeUninstalled,F.language);let se=await(F.useCache&&!N.devMode&&N.excludeObsolete?this.j:this.k).scanExtensions(N);return se=await this.C(se,1,F,!0),this.s.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(F,T){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const N=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(V=>V.scheme===y.Schemas.file).map(async V=>{const se=await this.I(V,!1,1,!0,F.language,!1);return(await this.k.scanOneOrMultipleExtensions(se)).map($=>($.type=T.find(D=>(0,h.areSameExtensions)(D.identifier,$.identifier))?.type??$.type,this.k.validate($,se)))}))).flat();return this.C(N,"development",F,!0)}return[]}async scanExistingExtension(F,T,N){const V=await this.I(F,!1,T,!0,N.language),se=await this.k.scanExtension(V);return!se||!N.includeInvalid&&!se.isValid?null:se}async scanOneOrMultipleExtensions(F,T,N){const V=await this.I(F,!1,T,!0,N.language),se=await this.k.scanOneOrMultipleExtensions(V);return this.C(se,T,N,!0)}async scanMetadata(F){const T=(0,f.joinPath)(F,"package.json"),N=(await this.r.readFile(T)).value.toString();return JSON.parse(N).__metadata}async updateMetadata(F,T){const N=(0,f.joinPath)(F,"package.json"),V=(await this.r.readFile(N)).value.toString(),se=JSON.parse(V);T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0,se.__metadata={...se.__metadata,...T},await this.r.writeFile((0,f.joinPath)(F,"package.json"),R.VSBuffer.fromString(JSON.stringify(se,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const F=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(F))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const T=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(T.map(N=>[N,N.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(F,R.VSBuffer.fromString(""))}catch(T){(0,s.toFileOperationResult)(T)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(T))}}catch(F){throw this.s.error(F),F}})()),this.z}async C(F,T,N,V){return N.includeAllVersions||(F=this.D(T===0?F:void 0,T===1?F:void 0,T==="development"?F:void 0,await this.getTargetPlatform(),V)),N.includeInvalid||(F=F.filter(se=>se.isValid)),F.sort((se,z)=>{const $=P.basename(se.location.fsPath),D=P.basename(z.location.fsPath);return $<D?-1:$>D?1:0})}D(F,T,N,V,se){const z=(D,O,W)=>{if(D.isValid&&!O.isValid)return!1;if(D.isValid===O.isValid){if(se&&w.gt(D.manifest.version,O.manifest.version))return this.s.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${D.location.path} with version ${D.manifest.version}`),!1;if(w.eq(D.manifest.version,O.manifest.version)){if(D.type===0)return this.s.debug(`Skipping extension ${O.location.path} in favour of system extension ${D.location.path} with same version`),!1;if(D.targetPlatform===V)return this.s.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${D.location.path} with ${O.location.path}.`):this.s.debug(`Overwriting user extension ${D.location.path} with ${O.location.path}.`),!0},$=new Map;return F?.forEach(D=>{const O=l.ExtensionIdentifier.toKey(D.identifier.id),W=$.get(O);(!W||z(W,D,!1))&&$.set(O,D)}),T?.forEach(D=>{const O=l.ExtensionIdentifier.toKey(D.identifier.id),W=$.get(O);if(!W&&F&&D.type===0){this.s.debug(`Skipping obsolete system extension ${D.location.path}.`);return}(!W||z(W,D,!1))&&$.set(O,D)}),N?.forEach(D=>{const O=l.ExtensionIdentifier.toKey(D.identifier.id),W=$.get(O);(!W||z(W,D,!0))&&$.set(O,D),$.set(O,D)}),[...$.values()]}async F(F,T){this.s.trace("Started scanning system extensions");const N=await this.I(this.systemExtensionsLocation,!1,0,!0,T),se=await(F&&!N.devMode?this.i:this.k).scanExtensions(N);return this.s.trace("Scanned system extensions:",se.length),se}async G(F,T){const N=this.t.isBuilt?[]:this.u.builtInExtensions;if(!N?.length)return[];this.s.trace("Started scanning dev system extensions");const V=T?await this.H():{},se=[],z=u.URI.file(P.normalize(P.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const D of N){const O=V[D.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":se.push((0,f.joinPath)(z,D.name));break;default:se.push(u.URI.file(O));break}}const $=await Promise.all(se.map(async D=>this.k.scanExtension(await this.I(D,!1,0,!0,F))));return this.s.trace("Scanned dev system extensions:",$.length),(0,I.coalesce)($)}async H(){try{const F=await this.r.readFile(this.l);return JSON.parse(F.value.toString())}catch{return{}}}async I(F,T,N,V,se,z=!0){const $=await this.f(se??E.language),D=await this.J(F),O=T&&!this.v.extUri.isEqual(F,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,W=O?await this.J(O):void 0;return new Y(F,D,O,W,T,N,V,z,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,se,$)}async J(F){try{const T=await this.r.stat(F);if(typeof T.mtime=="number")return T.mtime}catch{}}};X=pe([ie(4,M.IUserDataProfilesService),ie(5,S.IExtensionsProfileScannerService),ie(6,s.IFileService),ie(7,a.ILogService),ie(8,g.IEnvironmentService),ie(9,r.IProductService),ie(10,L.IUriIdentityService),ie(11,n.IInstantiationService)],X),e.AbstractExtensionsScannerService=X;class Y{constructor(F,T,N,V,se,z,$,D,O,W,U,q,Q,j){this.location=F,this.mtime=T,this.applicationExtensionslocation=N,this.applicationExtensionslocationMtime=V,this.profile=se,this.type=z,this.excludeObsolete=$,this.validate=D,this.productVersion=O,this.productDate=W,this.productCommit=U,this.devMode=q,this.language=Q,this.translations=j}static createNlsConfiguration(F){return{language:F.language,pseudo:F.language==="pseudo",devMode:F.devMode,translations:F.translations}}static equals(F,T){return(0,f.isEqual)(F.location,T.location)&&F.mtime===T.mtime&&(0,f.isEqual)(F.applicationExtensionslocation,T.applicationExtensionslocation)&&F.applicationExtensionslocationMtime===T.applicationExtensionslocationMtime&&F.profile===T.profile&&F.type===T.type&&F.excludeObsolete===T.excludeObsolete&&F.validate===T.validate&&F.productVersion===T.productVersion&&F.productDate===T.productDate&&F.productCommit===T.productCommit&&F.devMode===T.devMode&&F.language===T.language&&ae.equals(F.translations,T.translations)}}let re=class extends m.Disposable{constructor(F,T,N,V,se){super(),this.f=F,this.g=T,this.h=N,this.i=V,this.j=se}async scanExtensions(F){const T=F.profile?await this.l(F):await this.k(F);let N={};if(F.excludeObsolete&&F.type===1)try{const V=(await this.i.readFile(this.f)).value.toString();N=JSON.parse(V)}catch{}return(0,b.isEmptyObject)(N)?T:T.filter(V=>!N[h.ExtensionKey.create(V).toString()])}async k(F){const T=await this.i.resolve(F.location);if(!T.children?.length)return[];const N=await Promise.all(T.children.map(async V=>{if(!V.isDirectory||F.type===1&&(0,f.basename)(V.resource).indexOf(".")===0)return null;const se=new Y(V.resource,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(se)}));return(0,I.coalesce)(N).sort((V,se)=>V.location.path<se.location.path?-1:1)}async l(F){let T=await this.m(F.location,()=>!0,F);if(F.applicationExtensionslocation&&!this.h.extUri.isEqual(F.location,F.applicationExtensionslocation)){T=T.filter(V=>!V.metadata?.isApplicationScoped);const N=await this.m(F.applicationExtensionslocation,V=>!!V.metadata?.isApplicationScoped,F);T.push(...N)}return T}async m(F,T,N){const V=await this.g.scanProfileExtensions(F);if(!V.length)return[];const se=await Promise.all(V.map(async z=>{if(T(z)){const $=new Y(z.location,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension($,z.metadata)}return null}));return(0,I.coalesce)(se)}async scanOneOrMultipleExtensions(F){try{if(await this.i.exists((0,f.joinPath)(F.location,"package.json"))){const T=await this.scanExtension(F);return T?[T]:[]}else return await this.scanExtensions(F)}catch(T){return this.j.error(`Error scanning extensions at ${F.location.path}:`,(0,A.getErrorMessage)(T)),[]}}async scanExtension(F,T){try{let N=await this.scanExtensionManifest(F.location);if(N){N.publisher||(N.publisher=l.UNDEFINED_PUBLISHER),T=T??N.__metadata,delete N.__metadata;const V=(0,h.getGalleryExtensionId)(N.publisher,N.name),se=T?.id?{id:V,uuid:T.id}:{id:V},z=T?.isSystem?0:F.type,$=z===0||!!T?.isBuiltin;J.ImplicitActivationEvents.updateManifest(N),N=await this.n(F.location,N,Y.createNlsConfiguration(F));const D={type:z,identifier:se,manifest:N,location:F.location,isBuiltin:$,targetPlatform:T?.targetPlatform??"undefined",metadata:T,isValid:!0,validations:[]};return F.validate?this.validate(D,F):D}}catch(N){F.type!==0&&this.j.error(N)}return null}validate(F,T){let N=!0;const V=(0,i.validateExtensionManifest)(T.productVersion,T.productDate,T.location,F.manifest,F.isBuiltin);for(const[se,z]of V)se===d.default.Error&&(N=!1,this.j.error(this.t(T.location,z)));return F.isValid=N,F.validations=V,F}async scanExtensionManifest(F){const T=(0,f.joinPath)(F,"package.json");let N;try{N=(await this.i.readFile(T)).value.toString()}catch(se){return(0,s.toFileOperationResult)(se)!==1&&this.j.error(this.t(F,(0,v.localize)(0,null,T.path,se.message))),null}let V;try{V=JSON.parse(N)}catch{const z=[];(0,k.parse)(N,z);for(const $ of z)this.j.error(this.t(F,(0,v.localize)(1,null,T.path,$.offset,$.length,(0,p.getParseErrorMessage)($.error))));return null}return(0,k.getNodeType)(V)!=="object"?(this.j.error(this.t(F,(0,v.localize)(2,null,T.path))),null):V}async n(F,T,N){const V=await this.p(F,T,N);if(V)try{const se=[],z=await this.r(V.default,se);if(se.length>0)return se.forEach(D=>{this.j.error(this.t(F,(0,v.localize)(3,null,V.default?.path,(0,p.getParseErrorMessage)(D.error))))}),T;if((0,k.getNodeType)(V)!=="object")return this.j.error(this.t(F,(0,v.localize)(4,null,V.default?.path))),T;const $=V.values||Object.create(null);return(0,B.localizeManifest)(T,$,z)}catch{}return T}async p(F,T,N){const V=(0,f.joinPath)(F,"package.nls.json"),se=(O,W)=>{W.forEach(U=>{this.j.error(this.t(F,(0,v.localize)(5,null,O?.path,(0,p.getParseErrorMessage)(U.error))))})},z=O=>{this.j.error(this.t(F,(0,v.localize)(6,null,O?.path)))},$=`${T.publisher}.${T.name}`,D=N.translations[$];if(D)try{const O=u.URI.file(D),W=(await this.i.readFile(O)).value.toString(),U=[],q=(0,k.parse)(W,U);return U.length>0?(se(O,U),{values:void 0,default:V}):(0,k.getNodeType)(q)!=="object"?(z(O),{values:void 0,default:V}):{values:q.contents?q.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.i.exists(V))return;let W;try{W=await this.s(F,N)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const U=(await this.i.readFile(W.localized)).value.toString(),q=[],Q=(0,k.parse)(U,q);return q.length>0?(se(W.localized,q),{values:void 0,default:W.original}):(0,k.getNodeType)(Q)!=="object"?(z(W.localized),{values:void 0,default:W.original}):{values:Q,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(F,T){if(F)try{const N=(await this.i.readFile(F)).value.toString();return(0,k.parse)(N,T)}catch{}}s(F,T){return new Promise((N,V)=>{const se=z=>{const $=(0,f.joinPath)(F,`package.nls.${z}.json`);this.i.exists($).then(D=>{D&&N({localized:$,original:(0,f.joinPath)(F,"package.nls.json")});const O=z.lastIndexOf("-");O===-1?N({localized:(0,f.joinPath)(F,"package.nls.json"),original:null}):(z=z.substring(0,O),se(z))})};if(T.devMode||T.pseudo||!T.language)return N({localized:(0,f.joinPath)(F,"package.nls.json"),original:null});se(T.language)})}t(F,T){return`[${F.path}]: ${T}`}};re=pe([ie(1,S.IExtensionsProfileScannerService),ie(2,L.IUriIdentityService),ie(3,s.IFileService),ie(4,a.ILogService)],re);let ne=class extends re{constructor(F,T,N,V,se,z){super(T,N,V,se,z),this.y=F,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(F){const T=await this.z();if(this.u=F,T&&T.input&&Y.equals(T.input,this.u))return this.v.trigger(()=>this.D()),T.result.map(V=>(V.location=u.URI.revive(V.location),V));const N=await super.scanExtensions(F);return await this.C({input:F,result:N}),N}async z(){try{const F=await this.i.readFile(this.y),T=JSON.parse(F.value.toString());return{result:T.result,input:(0,o.revive)(T.input)}}catch(F){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,A.getErrorMessage)(F))}return null}async C(F){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify(F)))}catch(T){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,A.getErrorMessage)(T))}}async D(){if(!this.u)return;const F=await this.z();if(!F)return;const T=F.result,N=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!C.equals(N,T))try{await this.i.del(this.y),this.w.fire()}catch(V){this.j.error(V)}}};ne=pe([ie(2,S.IExtensionsProfileScannerService),ie(3,L.IUriIdentityService),ie(4,s.IFileService),ie(5,a.ILogService)],ne);function de(le,F){const T=(0,h.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:T,identifier:new l.ExtensionIdentifier(T),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:F,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.toExtensionDescription=de;class K extends X{constructor(F,T,N,V,se,z,$,D,O,W,U,q){super(F,T,(0,f.joinPath)(N,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(V,l.MANIFEST_CACHE_FOLDER),se,z,$,D,O,W,U,q),this.L=(async()=>{if(E.translationsConfigFile)try{const Q=await this.r.readFile(u.URI.file(E.translationsConfigFile));return JSON.parse(Q.value.toString())}catch{}return Object.create(null)})()}f(F){return this.L}}e.NativeExtensionsScannerService=K}),define(ee[258],te([0,1,7,35,91,117,16,5,6,19,42,38]),function(H,e,I,t,C,R,A,k,p,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let E=class extends R.NativeExtensionsScannerService{constructor(w,d,b,u,v,g,h,l){super(I.URI.file(v.builtinExtensionsPath),I.URI.file(v.extensionsPath),v.userHome,I.URI.file(v.userDataPath),w,d,b,u,v,g,h,l)}};E=pe([ie(0,P.IUserDataProfilesService),ie(1,C.IExtensionsProfileScannerService),ie(2,A.IFileService),ie(3,p.ILogService),ie(4,t.INativeEnvironmentService),ie(5,m.IProductService),ie(6,y.IUriIdentityService),ie(7,k.IInstantiationService)],E),e.ExtensionsScannerService=E}),define(ee[259],te([0,1,13,2,15,9,4,60,7,29,41,35,6,38]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let w=class extends t.Disposable{constructor(b,u,v){super(),this.c=b,this.f=v,this.a=k.TernarySearchTree.forPaths(!A.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:b}=I.session;b.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(u,v)=>this.i(u,v)),b.protocol.interceptFileProtocol(C.Schemas.file,(u,v)=>this.h(u,v)),this.B((0,t.toDisposable)(()=>{b.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(b){const u=(0,R.normalize)(b);return this.a.get(u)?t.Disposable.None:(this.a.set(u,!0),(0,t.toDisposable)(()=>this.a.delete(u)))}h(b,u){const v=p.URI.parse(b.url);return this.f.error(`Refused to load resource ${v.fsPath} from ${C.Schemas.file}: protocol (original URL: ${b.url})`),u({error:-3})}i(b,u){const v=this.j(b);let g;return this.c.crossOriginIsolated&&((0,R.basename)(v)==="workbench.html"||(0,R.basename)(v)==="workbench-dev.html"?g=C.COI.CoopAndCoep:g=C.COI.getHeadersFromQuery(b.url)),this.a.findSubstr(v)?u({path:v,headers:g}):this.b.has((0,R.extname)(v).toLowerCase())?u({path:v}):(this.f.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),u({error:-3}))}j(b){const u=p.URI.parse(b.url),v=C.FileAccess.uriToFileUri(u);return(0,R.normalize)(v.fsPath)}createIPCObjectUrl(){let b;const u=p.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),v=u.toString(),g=async()=>b;return y.validatedIpcMain.handle(v,g),this.f.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:u,update:h=>b=h,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${v}.`),y.validatedIpcMain.removeHandler(v)}}}};w=pe([ie(0,P.INativeEnvironmentService),ie(1,f.IUserDataProfilesService),ie(2,E.ILogService)],w),e.ProtocolMainService=w}),define(ee[260],te([0,1,13,41,8,3,2,15,12,103,27,21,6,63,64,66,45,38,37]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends A.Disposable{constructor(l,i,s,n,a,r,c,o,S){super(),this.g=l,this.h=i,this.i=s,this.j=n,this.k=a,this.l=r,this.m=c,this.n=o,this.p=S,this.a=new C.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new R.Emitter),this.onDidError=R.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,i)=>this.s(l,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,i)=>this.t(l,i)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(l,i){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const s=await this.connect();if(l.sender.isDestroyed())return s.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[s])}t(l,i){this.l.trace("SharedProcess: onWorkerConnection",i);const s=new A.DisposableStore,n=r=>{!this.F()||(this.l.trace(`SharedProcess: disposing worker (reason: '${r}')`,i),s.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",i))},a=I.BrowserWindow.fromId(i.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}s.add(R.Event.filter(this.k.onWillLoadWindow,r=>r.window.win===a)(()=>n("load"))),s.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>n("closed"))),a.webContents.postMessage(i.reply.channel,i.reply.nonce,l.ports)}u(){const l=this.b;!l||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(l.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{l.close()}catch{}this.b=void 0},0))}v(l,...i){if(!this.F()){this.l.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(l,...i)}catch(s){this.l.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,b.toErrorMessage)(s)}`)}}whenReady(){return this.w||(this.w=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),l()}))),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C(),this.D(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),l()}))})()),this.y}C(){const l=this.B(this.p.createIPCObjectUrl());this.b=new I.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:f.default,policiesData:this.m.serialize()}),this.b.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}D(){!this.b||(this.c=l=>{this.l.trace("SharedProcess#close prevented"),l.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(l,i)=>this.f.fire({type:2,details:i})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(l,i,s)=>this.f.fire({type:3,details:{reason:s,exitCode:i}})))}async connect(){await this.z;const l=(0,p.assertIsDefined)(this.b);return(0,m.connect)(l)}async toggle(){await this.z,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}F(){const l=this.b;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};g=pe([ie(2,y.IEnvironmentMainService),ie(3,u.IUserDataProfilesService),ie(4,P.ILifecycleMainService),ie(5,E.ILogService),ie(6,v.IPolicyService),ie(7,d.IThemeMainService),ie(8,w.IProtocolMainService)],g),e.SharedProcess=g}),define(ee[92],te([0,1,8,3,2,73,12,104,5,38]),function(H,e,I,t,C,R,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var y;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var P;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(P=e.StorageScope||(e.StorageScope={}));var E;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));function f(v){const g=v.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=f;class w extends C.Disposable{constructor(g={flushInterval:w.a}){super(),this.j=g,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new I.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new C.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,I.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,C.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,h){if(h===e.TARGET_KEY){switch(g){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:h,target:this.F(g)[h]})}r(g){this.f.fire({reason:g})}get(g,h,l){return this.L(h)?.get(g,l)}getBoolean(g,h,l){return this.L(h)?.getBoolean(g,l)}getNumber(g,h,l){return this.L(h)?.getNumber(g,l)}store(g,h,l,i){if((0,A.isUndefinedOrNull)(h)){this.remove(g,l);return}this.t(()=>{this.u(g,l,i),this.L(l)?.set(g,h)})}remove(g,h){this.t(()=>{this.u(g,h,void 0),this.L(h)?.delete(g)})}t(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,h){const l=[],i=this.F(g);for(const s of Object.keys(i))i[s]===h&&l.push(s);return l}u(g,h,l){const i=this.F(h);typeof l=="number"?i[g]!==l&&(i[g]=l,this.L(h)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[g]=="number"&&(delete i[g],this.L(h)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(g){switch(g){case-1:return this.D;case 0:return this.z;default:return this.w}}G(g){const h=this.L(g);return h?f(h):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=y.NONE){this.f.fire({reason:g});const h=this.L(-1),l=this.L(0),i=this.L(1);switch(g){case y.NONE:await I.Promises.settled([h?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await I.Promises.settled([h?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,h=this.L(0)?.items??new Map,l=this.L(1)?.items??new Map;return u(g,h,l,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,h){return this.r(y.NONE),(0,m.isUserDataProfile)(g)?this.N(g,h):this.O(g,h)}H(g,h){return!(g.id===h.id||d(h)&&d(g))}I(g,h,l,i){this.t(()=>{if(i)for(const[s,n]of g)h.set(s,n);else{const s=new Set;for(const[n,a]of g)s.add(n),h.get(n)!==a&&this.n(l,n);for(const[n]of h.items)s.has(n)||this.n(l,n)}})}}e.AbstractStorageService=w,w.a=60*1e3;function d(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=d;class b extends w{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.B(this.P.onDidChangeStorage(g=>this.n(0,g))),this.B(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.InMemoryStorageService=b;async function u(v,g,h,l,i,s){const n=J=>{try{return JSON.parse(J)}catch{return J}},a=new Map,r=new Map;v.forEach((J,ae)=>{a.set(ae,J),r.set(ae,n(J))});const c=new Map,o=new Map;g.forEach((J,ae)=>{c.set(ae,J),o.set(ae,n(J))});const S=new Map,M=new Map;h.forEach((J,ae)=>{S.set(ae,J),M.set(ae,n(J))}),console.group(l!==i?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const L=[];if(a.forEach((J,ae)=>{L.push({key:ae,value:J})}),console.table(L),console.groupEnd(),console.log(r),l!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const J=[];c.forEach((ae,X)=>{J.push({key:X,value:ae})}),console.table(J),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${s})`);const B=[];S.forEach((J,ae)=>{B.push({key:ae,value:J})}),console.table(B),console.groupEnd(),console.log(M)}e.logStorage=u}),define(ee[261],te([0,1,24,8,3,2,9,80,7,23,104,147,6,92,31,28]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends R.Disposable{get storage(){return this.f}constructor(s,n){super(),this.j=s,this.k=n,this.b=this.B(new C.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new C.Emitter),this.onDidCloseStorage=this.c.event,this.f=new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=y.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===y.StorageState.None)try{const s=await this.n();this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(a=>this.b.fire({key:a}))),await this.m(s);const n=s.getBoolean(f.IS_NEW_KEY);n===void 0?s.set(f.IS_NEW_KEY,!0):n&&s.set(f.IS_NEW_KEY,!1)}catch(s){this.j.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.i=y.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===E.LogLevel.Trace?s=>this.j.trace(s):void 0,logError:s=>this.j.error(s)}}m(s){return s.init()}get items(){return this.f.items}get(s,n){return this.f.get(s,n)}set(s,n){return this.f.set(s,n)}delete(s){return this.f.delete(s)}async close(){const s=new k.StopWatch(!1);await this.s(),s.stop(),s.elapsed()>b.a&&await this.r(s),this.c.fire()}async r(s){if(!!this.path)try{const n=(0,I.top)(Array.from(this.f.items.entries()).map(([r,c])=>({key:r,length:c.length})),(r,c)=>c.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),a=(await this.k.stat(p.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${a}b, Large Keys: ${n}`)}catch(n){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async s(){this.g&&await this.g,this.i=y.StorageState.Closed,await this.f.close()}}b.a=2e3;class u extends b{get path(){if(!this.v.useInMemoryStorage)return(0,A.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(s,n,a,r){super(a,r),this.u=s,this.v=n}async n(){return new y.Storage(new P.SQLiteStorageDatabase(this.path??P.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:y.StorageHint.STORAGE_IN_MEMORY})}}u.t="state.vscdb";class v extends u{constructor(s,n,a,r){super(s,n,a,r)}}e.ProfileStorageMain=v;class g extends u{constructor(s,n,a,r){super(n.defaultProfile,s,a,r)}async m(s){await super.m(s),this.z(s)}z(s){s.get(w.firstSessionDateStorageKey,void 0)===void 0&&s.set(w.firstSessionDateStorageKey,new Date().toUTCString());const a=s.get(w.currentSessionDateStorageKey,void 0),r=new Date().toUTCString();s.set(w.lastSessionDateStorageKey,typeof a>"u"?null:a),s.set(w.currentSessionDateStorageKey,r)}}e.ApplicationStorageMain=g;class h extends b{get path(){if(!this.w.useInMemoryStorage)return(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id,h.t)}constructor(s,n,a,r,c){super(a,c),this.v=s,this.w=n,this.y=r}async n(){const{storageFilePath:s,wasCreated:n}=await this.C();return new y.Storage(new P.SQLiteStorageDatabase(s,{logging:this.l()}),{hint:this.w.useInMemoryStorage?y.StorageHint.STORAGE_IN_MEMORY:n?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:P.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id),n=(0,A.join)(s,h.t);return await m.Promises.exists(s)?{storageFilePath:n,wasCreated:!1}:(await m.Promises.mkdir(s,{recursive:!0}),this.D(s),{storageFilePath:n,wasCreated:!0})}async D(s){let n;if((0,d.isSingleFolderWorkspaceIdentifier)(this.v)?n={folder:this.v.uri.toString()}:(0,d.isWorkspaceIdentifier)(this.v)&&(n={workspace:this.v.configPath.toString()}),n)try{const a=(0,A.join)(s,h.u);await m.Promises.exists(a)||await m.Promises.writeFile(a,JSON.stringify(n,void 0,2))}catch(a){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=h,h.t="state.vscdb",h.u="workspace.json";class l extends b{get path(){}async n(){return new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=l}),define(ee[262],te([0,1,3,2,92]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(k,p,m){super(),this.b=k,this.c=p,this.f=m;const y=this.B(new t.MutableDisposable);this.a=this.B(new I.Emitter({onWillAddFirstListener:()=>y.value=this.g(),onDidRemoveLastListener:()=>y.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new t.DisposableStore;return k.add(I.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(p,m)=>(p?p.push(m.key):p=[m.key],p),100)(p=>this.h(p))),k.add(I.Event.debounce(this.b.onDidChangeProfileStorage,(p,m)=>{p||(p=new Map);let y=p.get(m.profile.id);return y||p.set(m.profile.id,y={profile:m.profile,keys:[],storage:m.storage}),y.keys.push(m.key),p},100)(p=>this.i(p))),k}h(k){const p=k.includes(C.TARGET_KEY)?[this.c.defaultProfile]:[],m=[];if(k=k.filter(y=>y!==C.TARGET_KEY),k.length){const y=(0,C.loadKeyTargets)(this.b.applicationStorage.storage);m.push({profile:this.c.defaultProfile,changes:k.map(P=>({key:P,scope:0,target:y[P]}))})}this.j(p,m)}i(k){const p=[],m=new Map;for(const[y,P]of k.entries()){P.keys.includes(C.TARGET_KEY)&&p.push(P.profile);const E=P.keys.filter(f=>f!==C.TARGET_KEY);if(E.length){const f=(0,C.loadKeyTargets)(P.storage.storage);m.set(y,{profile:P.profile,changes:E.map(w=>({key:w,scope:0,target:f[w]}))})}}this.j(p,[...m.values()])}j(k,p){(k.length||p.length)&&this.a.fire({valueChanges:p,targetChanges:k})}listen(k,p,m){switch(p){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${p}`)}async call(k,p){throw new Error(`Call not found: ${p}`)}}e.ProfileStorageChangesListenerChannel=R}),define(ee[263],te([0,1,69,7,35,16,6,229,42,38]),function(H,e,I,t,C,R,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let y=class Lt extends m.UserDataProfilesService{constructor(E,f,w,d,b){super(w,d,f,b),this.a=E,this.N=w}H(){return(0,I.revive)(this.a.getItem(Lt.b,[]))}J(){return(0,I.revive)(this.a.getItem(Lt.c,{}))}M(){return this.r.extUri.joinPath(t.URI.file(this.N.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y=pe([ie(0,k.IStateService),ie(1,p.IUriIdentityService),ie(2,C.INativeEnvironmentService),ie(3,R.IFileService),ie(4,A.ILogService)],y),e.UserDataProfilesService=y}),define(ee[51],te([0,1,7,35,16,5,6,36,42,38,263]),function(H,e,I,t,C,R,A,k,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let P=class dt extends y.UserDataProfilesService{constructor(f,w,d,b,u){super(f,w,d,b,u),this.R=f}setEnablement(f){super.setEnablement(f),this.f||(this.I([]),this.L({}))}I(f){f.length?this.R.setItem(dt.b,f):this.R.removeItem(dt.b)}L(f){f.emptyWindow||f.workspaces?this.R.setItem(dt.c,f):this.R.removeItem(dt.c)}J(){const f="workspaceAndProfileInfo",w=this.R.getItem(f,void 0);if(w){this.R.removeItem(f);const d=w.reduce((b,{workspace:u,profile:v})=>(b[I.URI.revive(u).toString()]=I.URI.revive(v).toString(),b),{});this.R.setItem(dt.c,{workspaces:d})}return super.J()}};P=pe([ie(0,k.IStateMainService),ie(1,p.IUriIdentityService),ie(2,t.INativeEnvironmentService),ie(3,C.IFileService),ie(4,A.ILogService)],P),e.UserDataProfilesMainService=P}),define(ee[93],te([0,1,7,50,3,2,35,16,5,21,6,92,261,38,51,42]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,p.createDecorator)("storageMainService");let b=class extends R.Disposable{constructor(g,h,l,i,s,n){super(),this.c=g,this.f=h,this.g=l,this.h=i,this.i=s,this.j=n,this.a=void 0,this.b=this.B(new C.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(g=>{g.window.profile&&this.profileStorage(g.window.profile).init(),g.workspace&&this.workspaceStorage(g.workspace).init()})),this.B(this.h.onWillShutdown(g=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=g.reason,g.join(this.applicationStorage.close());for(const[,h]of this.n)g.join(h.close());for(const[,h]of this.r)g.join(h.close())})),this.B(this.g.onWillCreateProfile(g=>{g.join((async()=>{await this.i.exists(g.profile.globalStorageHome)||await this.i.createFolder(g.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(g=>{const h=this.n.get(g.profile.id);h&&g.join(h.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const g=new E.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(g.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),g}profileStorage(g){if((0,P.isProfileUsingDefaultStorage)(g))return this.applicationStorage;let h=this.n.get(g.id);if(!h){this.c.trace(`StorageMainService: creating profile storage (${g.name})`),h=this.p(g),this.n.set(g.id,h);const l=this.B(h.onDidChangeStorage(i=>this.b.fire({...i,storage:h,profile:g})));(0,t.once)(h.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${g.name})`),this.n.delete(g.id),l.dispose()})}return h}p(g){return this.a===2?new E.InMemoryStorageMain(this.c,this.i):new E.ProfileStorageMain(g,this.k(),this.c,this.i)}workspaceStorage(g){let h=this.r.get(g.id);return h||(this.c.trace(`StorageMainService: creating workspace storage (${g.id})`),h=this.s(g),this.r.set(g.id,h),(0,t.once)(h.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${g.id})`),this.r.delete(g.id)})),h}s(g){return this.a===2?new E.InMemoryStorageMain(this.c,this.i):new E.WorkspaceStorageMain(g,this.k(),this.c,this.f,this.i)}isUsed(g){const h=I.URI.file(g);for(const l of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!l.path&&this.j.extUri.isEqualOrParent(I.URI.file(l.path),h))return!0;return!1}};b=pe([ie(0,y.ILogService),ie(1,A.IEnvironmentService),ie(2,w.IUserDataProfilesMainService),ie(3,m.ILifecycleMainService),ie(4,k.IFileService),ie(5,d.IUriIdentityService)],b),e.StorageMainService=b,e.IApplicationStorageMainService=(0,p.createDecorator)("applicationStorageMainService");let u=class extends P.AbstractStorageService{constructor(g,h){super(),this.p=g,this.s=h,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(g){if(g===-1)return this.s.applicationStorage.storage}M(g){if(g===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=pe([ie(0,f.IUserDataProfilesService),ie(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(ee[264],te([0,1,2,21,51]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends I.Disposable{constructor(k,p){super(),this.a=p,this.B(k.onWillLoadWindow(m=>{m.reason===2&&this.b(m.window.openedWorkspace??"empty-window")})),this.B(k.onBeforeCloseWindow(m=>this.b(m.openedWorkspace??"empty-window")))}async b(k){this.a.getOrSetProfileForWorkspace(k).isTransient&&(this.a.unsetWorkspace(k,!0),await this.a.cleanUpTransientProfiles())}};R=pe([ie(0,t.ILifecycleMainService),ie(1,C.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(ee[118],te([0,1,20,7,28]),function(H,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(p,m,y){for(const E of p){const f=E.openedWorkspace;if((0,C.isWorkspaceIdentifier)(f)){const w=await y(f);if(w){if(w.folders.some(d=>I.extUriBiasedIgnorePathCase.isEqualOrParent(m,d.uri)))return E}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(m,f.configPath))return E}}const P=p.filter(E=>(0,C.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(m,E.openedWorkspace.uri));if(P.length)return P.sort((E,f)=>-(E.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function A(p,m){for(const y of p)if((0,C.isWorkspaceIdentifier)(y.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,m)||(0,C.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,m))return y}e.findWindowOnWorkspaceOrFolder=A;function k(p,m){const y=P=>m.some(E=>I.extUriBiasedIgnorePathCase.isEqual(t.URI.file(E),t.URI.file(P)));for(const P of p)if(P.config?.extensionDevelopmentPath?.some(E=>y(E)))return P}e.findWindowOnExtensionDevelopmentPath=k}),define(ee[265],te([0,1,13,2,4,20,7,18,21,6,36,32,116,28]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class Ot extends t.Disposable{get state(){return this.b}constructor(h,l,i,s,n){super(),this.g=h,this.h=l,this.i=i,this.j=s,this.k=n,this.b=d(this.h.getItem(Ot.a)),this.c=void 0,this.f=!1,this.l()}l(){I.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(h=>this.p(h)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(h=>this.p(h))}m(){this.f=!0,this.n()}n(){const h=new Set,l={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!l.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),n&&(l.lastActiveWindow=this.r(n),l.lastActiveWindow.uiState.mode===3&&h.add(l.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(l.lastPluginDevelopmentHostWindow=this.r(i),l.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(l.lastPluginDevelopmentHostWindow.uiState.display)?C.isMacintosh&&!i.win?.isSimpleFullScreen()&&(l.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(l.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(l.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const a=this.r(n);return a.uiState.mode===3&&(h.has(a.uiState.display)?C.isMacintosh&&a.windowId!==l.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(a.uiState.mode=1):h.add(a.uiState.display)),a}));const s=u(l);this.h.setItem(Ot.a,s),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",s)}p(h){if(this.i.quitRequested)return;const l=this.r(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=l:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this.b.openedWindows.forEach(i=>{const s=(0,f.isWorkspaceIdentifier)(h.openedWorkspace)&&i.workspace?.id===h.openedWorkspace.id,n=(0,f.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,h.openedWorkspace.uri);(s||n)&&(i.uiState=l.uiState)}),this.g.getWindowCount()===1&&(this.c=l)}r(h){return{windowId:h.id,workspace:(0,f.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const l=this.s(h),i=this.k.getValue("window");if(l.mode===3){let s;l.hasDefaultState?s=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):s=!!(this.i.wasRestarted||i?.restoreFullscreen),s||(l.mode=1)}return l}s(h){const l=this.g.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=h.workspace;if((0,f.isWorkspaceIdentifier)(c)){const S=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===c.id).map(M=>M.uiState);if(S.length)return S[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(c)){const S=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,c.uri)).map(M=>M.uiState);if(S.length)return S[0]}else if(h.backupPath){const S=this.state.openedWindows.filter(M=>M.backupPath===h.backupPath).map(M=>M.uiState);if(S.length)return S[0]}const o=this.c||this.state.lastActiveWindow;if(!l&&o)return o.uiState}let i;const s=I.screen.getAllDisplays();if(s.length===1)i=s[0];else{if(C.isMacintosh){const c=I.screen.getCursorScreenPoint();i=I.screen.getDisplayNearestPoint(c)}!i&&l&&(i=I.screen.getDisplayMatching(l.getBounds())),i||(i=I.screen.getPrimaryDisplay()||s[0])}let n=(0,E.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const a=this.k.getValue("window");let r=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")n.mode=0,r=!1;else if(a.newWindowDimensions==="fullscreen")n.mode=3,r=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&l){const c=l.serializeWindowState();c.mode===3?n.mode=3:n=c,r=n.mode!==3&&a.newWindowDimensions==="offset"}}return r&&(n=this.t(n)),n.hasDefaultState=!0,n}t(h){if(this.g.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const l=this.g.getWindows().map(i=>i.getBounds());for(;l.some(i=>i.x===h.x||i.y===h.y);)h.x+=30,h.y+=30;return h}};w.a="windowsState",w=pe([ie(0,P.IWindowsMainService),ie(1,y.IStateMainService),ie(2,p.ILifecycleMainService),ie(3,m.ILogService),ie(4,k.IConfigurationService)],w),e.WindowsStateHandler=w;function d(g){const h={openedWindows:[]},l=g||{openedWindows:[]};return l.lastActiveWindow&&(h.lastActiveWindow=b(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=b(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(h.openedWindows=l.openedWindows.map(i=>b(i))),h}e.restoreWindowsState=d;function b(g){const h={uiState:g.uiState};return g.backupPath&&(h.backupPath=g.backupPath),g.remoteAuthority&&(h.remoteAuthority=g.remoteAuthority),g.folder&&(h.folderUri=A.URI.parse(g.folder)),g.workspaceIdentifier&&(h.workspace={id:g.workspaceIdentifier.id,configPath:A.URI.parse(g.workspaceIdentifier.configURIPath)}),h}function u(g){return{lastActiveWindow:g.lastActiveWindow&&v(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&v(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(h=>v(h))}}e.getWindowsStateStoreData=u;function v(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(ee[94],te([0,1,30,43,124,34,15,9,4,20,7,5,54,28]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,P.createDecorator)("workspacesService");function w(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function d(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=d;function b(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=b;function u(M){return v(M)||g(M)}e.isStoredWorkspaceFolder=u;function v(M){const L=M;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function g(M){const L=M;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function h(M,L,B,J,ae){if(M.scheme!==J.scheme)return{name:B,uri:M.toString(!0)};let X=L?void 0:ae.relativePath(J,M);if(X!==void 0)X.length===0?X=".":p.isWindows&&(X=l(X));else if(M.scheme===A.Schemas.file)X=M.fsPath,p.isWindows&&(X=l(X));else if(ae.isEqualAuthority(M.authority,J.authority))X=M.path;else return{name:B,uri:M.toString(!0)};return{name:B,path:X}}e.getStoredWorkspaceFolder=h;function l(M){return M=(0,R.normalizeDriveLetter)(M),(0,I.isUNC)(M)||(M=(0,I.toSlashes)(M)),M}function i(M,L,B){const J=[],ae=new Set,X=B.dirname(L);for(const Y of M){let re;if(v(Y))Y.path&&(re=B.resolvePath(X,Y.path));else if(g(Y))try{re=y.URI.parse(Y.uri),re.path[0]!==k.posix.sep&&(re=re.with({path:k.posix.sep+re.path}))}catch(ne){console.warn(ne)}if(re){const ne=B.getComparisonKey(re);if(!ae.has(ne)){ae.add(ne);const de=Y.name||B.basenameOrAuthority(re);J.push(new f.WorkspaceFolder({uri:re,name:de,index:J.length},Y))}}}return J}e.toWorkspaceFolders=i;function s(M,L,B,J,ae){const X=n(L,M),Y=ae.dirname(L),re=ae.dirname(J),ne=[];for(const F of X.folders){const T=v(F)?ae.resolvePath(Y,F.path):y.URI.parse(F.uri);let N;B?N=!1:N=!v(F)||(0,k.isAbsolute)(F.path),ne.push(h(T,N,F.name,re,ae))}const de={insertSpaces:!1,tabSize:4,eol:p.isLinux||p.isMacintosh?`
`:`\r
`},K=C.setProperty(M,["folders"],ne,de);let le=C.applyEdits(M,K);return(0,m.isEqualAuthority)(X.remoteAuthority,(0,E.getRemoteAuthority)(J))&&(le=C.applyEdits(le,C.removeProperty(le,["remoteAuthority"],de))),le}e.rewriteWorkspaceFileForNewLocation=s;function n(M,L){const B=t.parse(L);if(B&&Array.isArray(B.folders))B.folders=B.folders.filter(J=>u(J));else throw new Error(`${M} looks like an invalid workspace file.`);return B}function a(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function r(M){return typeof M.folderUri=="string"}function c(M){return typeof M.fileUri=="string"}function o(M,L){const B={workspaces:[],files:[]};if(M){const J=function(X,Y){for(let re=0;re<X.length;re++)try{Y(X[re],re)}catch(ne){L.warn(`Error restoring recent entry ${JSON.stringify(X[re])}: ${ne.toString()}. Skip entry.`)}},ae=M;Array.isArray(ae.entries)&&J(ae.entries,X=>{const Y=X.label,re=X.remoteAuthority;a(X)?B.workspaces.push({label:Y,remoteAuthority:re,workspace:{id:X.workspace.id,configPath:y.URI.parse(X.workspace.configPath)}}):r(X)?B.workspaces.push({label:Y,remoteAuthority:re,folderUri:y.URI.parse(X.folderUri)}):c(X)&&B.files.push({label:Y,remoteAuthority:re,fileUri:y.URI.parse(X.fileUri)})})}return B}e.restoreRecentlyOpened=o;function S(M){const L={entries:[]};for(const B of M.workspaces)d(B)?L.entries.push({folderUri:B.folderUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority}):L.entries.push({workspace:{id:B.workspace.id,configPath:B.workspace.configPath.toString()},label:B.label,remoteAuthority:B.remoteAuthority});for(const B of M.files)L.entries.push({fileUri:B.fileUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority});return L}e.toStoreData=S}),define(ee[95],te([0,1,77,15,4,20]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(m){function y(){let P=m.scheme===t.Schemas.file?(0,R.originalFSPath)(m):m.toString();return C.isLinux||(P=P.toLowerCase()),(0,I.createHash)("md5").update(P).digest("hex")}return{id:y(),configPath:m}}e.getWorkspaceIdentifier=A;function k(m,y){function P(){if(m.scheme!==t.Schemas.file)return(0,I.createHash)("md5").update(m.toString()).digest("hex");if(!y)return;let f;return C.isLinux?f=y.ino:C.isMacintosh?f=y.birthtime.getTime():C.isWindows&&(typeof y.birthtimeMs=="number"?f=Math.floor(y.birthtimeMs):f=y.birthtime.getTime()),(0,I.createHash)("md5").update(m.fsPath).update(f?String(f):"").digest("hex")}const E=P();if(typeof E=="string")return{id:E,uri:m}}e.getSingleFolderWorkspaceIdentifier=k;function p(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=p}),define(ee[266],te([0,1,77,30,15,9,4,20,23,177,18,27,36,16,6,176,28,95]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class Tt{constructor(h,l,i,s){this.j=h,this.k=l,this.l=i,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(n,a)=>(0,t.isEqual)(n,a,!A.isLinux)}}async initialize(){const h=await this.n();this.g=await this.x(h.emptyWindows),this.d=await this.v((0,m.deserializeWorkspaceInfos)(h)),this.e=await this.w((0,m.deserializeFolderInfos)(h)),this.D()}async n(){let h=this.m.getItem(Tt.a);if(!h)try{const l=(0,R.join)(this.c,"workspaces.json"),i=await p.Promises.readFile(l,"utf8");try{await p.Promises.unlink(l)}catch{}const s=JSON.parse(i);h={workspaces:Array.isArray(s.rootURIWorkspaces)?s.rootURIWorkspaces:[],folders:Array.isArray(s.folderWorkspaceInfos)?s.folderWorkspaceInfos:[],emptyWindows:Array.isArray(s.emptyWorkspaceInfos)?s.emptyWorkspaceInfos:[]}}catch(l){l.code!=="ENOENT"&&this.l.error(`Backup: Could not migrate legacy backup workspaces metadata: ${l.toString()}`)}return h??{workspaces:[],folders:[],emptyWindows:[]}}o(){return this.s()?[]:this.d.slice(0)}q(){return this.s()?[]:this.e.slice(0)}isHotExitEnabled(){return this.t()!==f.HotExitConfiguration.OFF}s(){return this.t()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}t(){return this.k.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(h,l){this.d.some(s=>h.workspace.id===s.workspace.id)||(this.d.push(h),this.D());const i=(0,R.join)(this.c,h.workspace.id);return l?this.u(i,l).then(()=>i):i}async u(h,l){if(await p.Promises.exists(h)&&await this.A(h),await p.Promises.exists(l))try{await p.Promises.rename(l,h)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(h){return this.e.some(l=>this.h.isEqual(h.folderUri,l.folderUri))||(this.e.push(h),this.D()),(0,R.join)(this.c,this.E(h))}registerEmptyWindowBackup(h){return this.g.some(l=>!!l.backupFolder&&this.i.isEqual(l.backupFolder,h.backupFolder))||(this.g.push(h),this.D()),(0,R.join)(this.c,h.backupFolder)}async v(h){if(!Array.isArray(h))return[];const l=new Set,i=[];for(const s of h){const n=s.workspace;if(!(0,b.isWorkspaceIdentifier)(n))return[];if(!l.has(n.id)){l.add(n.id);const a=(0,R.join)(this.c,n.id);await this.C(a)?n.configPath.scheme!==C.Schemas.file||await p.Promises.exists(n.configPath.fsPath)?i.push(s):await this.A(a):await this.y(a)}}return i}async w(h){if(!Array.isArray(h))return[];const l=[],i=new Set;for(const s of h){const n=s.folderUri,a=this.h.getComparisonKey(n);if(!i.has(a)){i.add(a);const r=(0,R.join)(this.c,this.E(s));await this.C(r)?n.scheme!==C.Schemas.file||await p.Promises.exists(n.fsPath)?l.push(s):await this.A(r):await this.y(r)}}return l}async x(h){if(!Array.isArray(h))return[];const l=[],i=new Set;for(const s of h){const n=s.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const a=(0,R.join)(this.c,n);await this.C(a)?l.push(s):await this.y(a)}}return l}async y(h){try{await p.Promises.rm(h,p.RimRafMode.MOVE)}catch(l){this.l.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}z(){let h=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(l=>!!l.backupFolder&&this.i.isEqual(l.backupFolder,h.id));)h=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:h.id}}async A(h){const l=this.z(),i=(0,R.join)(this.c,l.backupFolder);try{await p.Promises.rename(h,i)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(l),!0}async getDirtyWorkspaces(){const h=[];for(const l of this.d)await this.B(l)&&h.push(l);for(const l of this.e)await this.B(l)&&h.push(l);return h}B(h){let l;return(0,m.isEmptyWindowBackupInfo)(h)?l=(0,R.join)(this.c,h.backupFolder):(0,d.isFolderBackupInfo)(h)?l=(0,R.join)(this.c,this.E(h)):l=(0,R.join)(this.c,h.workspace.id),this.C(l)}async C(h){try{const l=await p.Promises.readdir(h);for(const i of l)try{if((await p.Promises.readdir((0,R.join)(h,i))).length>0)return!0}catch{}}catch{}return!1}D(){const h={workspaces:this.d.map(({workspace:l,remoteAuthority:i})=>{const s={id:l.id,configURIPath:l.configPath.toString()};return i&&(s.remoteAuthority=i),s}),folders:this.e.map(({folderUri:l,remoteAuthority:i})=>{const s={folderUri:l.toString()};return i&&(s.remoteAuthority=i),s}),emptyWindows:this.g.map(({backupFolder:l,remoteAuthority:i})=>{const s={backupFolder:l};return i&&(s.remoteAuthority=i),s})};this.m.setItem(Tt.a,h)}E(h){const l=h.folderUri;let i;return l.scheme===C.Schemas.file?i=A.isLinux?l.fsPath:l.fsPath.toLowerCase():i=l.toString().toLowerCase(),(0,I.createHash)("md5").update(i).digest("hex")}};v.a="backupWorkspaces",v=pe([ie(0,P.IEnvironmentMainService),ie(1,y.IConfigurationService),ie(2,w.ILogService),ie(3,E.IStateMainService)],v),e.BackupMainService=v}),define(ee[52],te([0,1,13,3,43,34,2,15,9,20,12,23,175,62,57,27,5,6,19,51,118,28,94,95]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,b.createDecorator)("workspacesManagementMainService");let n=class extends A.Disposable{constructor(r,c,o,S,M,L){super(),this.g=r,this.h=c,this.i=o,this.j=S,this.k=M,this.l=L,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const r=(await P.Promises.readdir(this.c.fsPath)).map(c=>(0,m.joinPath)(this.c,c,l.UNTITLED_WORKSPACE_NAME));for(const c of r){const o=(0,s.getWorkspaceIdentifier)(c),S=await this.resolveLocalWorkspace(c);S?this.f.push({workspace:o,remoteAuthority:S.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(r){r.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${r}).`)}}resolveLocalWorkspace(r){return this.m(r,c=>P.Promises.readFile(c,"utf8"))}m(r,c){if(!!this.n(r)&&r.scheme===k.Schemas.file)try{const o=c(r.fsPath);return o instanceof Promise?o.then(S=>this.p(r,S),S=>{}):this.p(r,o)}catch{return}}n(r){return(0,l.isUntitledWorkspace)(r,this.g)||(0,l.hasWorkspaceFileExtension)(r)}p(r,c){try{const o=this.r(r,c),S=(0,s.getWorkspaceIdentifier)(r);return{id:S.id,configPath:S.configPath,folders:(0,i.toWorkspaceFolders)(o.folders,S.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}r(r,c){const o=(0,C.parse)(c);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(S=>(0,i.isStoredWorkspaceFolder)(S));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(r,c){const{workspace:o,storedWorkspace:S}=this.s(r,c),M=o.configPath.fsPath;return await P.Promises.mkdir((0,p.dirname)(M),{recursive:!0}),await P.Promises.writeFile(M,JSON.stringify(S,null,"	")),this.f.push({workspace:o,remoteAuthority:c}),o}s(r=[],c){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),S=(0,m.joinPath)(this.c,o),M=(0,m.joinPath)(S,l.UNTITLED_WORKSPACE_NAME),L=[];for(const B of r)L.push((0,i.getStoredWorkspaceFolder)(B.uri,!0,B.name,S,m.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(M),storedWorkspace:{folders:L,remoteAuthority:c}}}async getWorkspaceIdentifier(r){return(0,s.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,l.isUntitledWorkspace)(r.configPath,this.g)}async deleteUntitledWorkspace(r){!this.isUntitledWorkspace(r)||(await this.t(r),this.i.isEnabled()&&this.i.unsetWorkspace(r),this.a.fire(r))}async t(r){const c=(0,m.originalFSPath)(r.configPath);try{await P.Promises.rm((0,p.dirname)(c));const o=(0,p.join)(this.g.workspaceStorageHome.fsPath,r.id);await P.Promises.exists(o)&&await P.Promises.writeFile((0,p.join)(o,"obsolete"),""),this.f=this.f.filter(S=>S.workspace.id!==r.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${c} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(r,c,o){if(!r||!r.win||!r.isReady||!await this.u(r,c,o))return;const M=await this.v(r,(0,s.getWorkspaceIdentifier)(o));if(!!M)return this.b.fire({window:r,workspace:M.workspace}),M}async u(r,c,o){if(!o)return!0;if((0,l.isWorkspaceIdentifier)(r.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,o))return!1;if((0,h.findWindowOnWorkspaceOrFolder)(c,o)){const S={title:this.l.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(0,null))],message:(0,E.localize)(1,null,(0,m.basename)(o)),detail:(0,E.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(S,(0,y.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1}return!0}async v(r,c){if(!r.config)return;r.focus();let o;return r.config.extensionDevelopmentPath||(r.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:r.remoteAuthority},r.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:r.remoteAuthority})),(0,l.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=c,r.config.backupPath=o,{workspace:c,backupPath:o}}};n=pe([ie(0,d.IEnvironmentMainService),ie(1,u.ILogService),ie(2,g.IUserDataProfilesMainService),ie(3,f.IBackupMainService),ie(4,w.IDialogMainService),ie(5,v.IProductService)],n),e.WorkspacesManagementMainService=n}),define(ee[119],te([0,1,13,41,22,5,32,28,52,12,6]),function(H,e,I,t,C,R,A,k,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let P=class{constructor(f,w,d){this.a=f,this.b=w,this.c=d}async getRemoteDiagnostics(f){const w=this.a.getWindows();return(await Promise.all(w.map(async b=>{const u=b.remoteAuthority;if(!u)return;const v=`vscode:getDiagnosticInfoResponse${b.id}`,g={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(h=>{b.sendWhenReady("vscode:getDiagnosticInfo",C.CancellationToken.None,{replyChannel:v,args:g}),t.validatedIpcMain.once(v,(l,i)=>{i||h({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),h(i)}),setTimeout(()=>{h({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const w of I.BrowserWindow.getAllWindows()){const d=this.a.getWindowById(w.id);d?f.push(await this.d(d)):f.push(this.e(w))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async d(f){const w=await this.f(f),d=(0,m.assertIsDefined)(f.win);return this.e(d,w,f.remoteAuthority)}e(f,w=[],d){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:w,remoteAuthority:d}}async f(f){const w=[],d=f.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(d))w.push(d.uri);else if((0,k.isWorkspaceIdentifier)(d)){const b=await this.b.resolveLocalWorkspace(d.configPath);b&&b.folders.forEach(v=>{w.push(v.uri)})}return w}};P=pe([ie(0,A.IWindowsMainService),ie(1,p.IWorkspacesManagementMainService),ie(2,y.ILogService)],P),e.DiagnosticsMainService=P}),define(ee[58],te([0,1,46,13,25,141,53,3,34,2,15,9,4,7,100,81,23,97,165,57,27,5,21,6,19,66,32,28,52,17,223,216,36]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l,i,s,n,a,r,c,o,S,M,L,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let J=class extends m.Disposable{constructor(X,Y,re,ne,de,K,le,F,T,N){super(),this.a=X,this.b=Y,this.c=re,this.f=ne,this.g=de,this.h=K,this.i=le,this.j=F,this.k=T,this.l=N,this.onDidOpenWindow=k.Event.map(this.b.onDidOpenWindow,V=>V.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:V,x:se,y:z})=>({windowId:V.id,x:se,y:z})),({windowId:V})=>!!this.b.getWindowById(V)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(V,se)=>se.id),V=>!!this.b.getWindowById(V)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(V,se)=>se.id),V=>!!this.b.getWindowById(V)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(V,se)=>se.id),V=>!!this.b.getWindowById(V)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),V=>!!V),V=>V.id),k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(V,se)=>se.id),V=>!!this.b.getWindowById(V))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new k.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(V,se,z)=>z),V=>!(Array.isArray(V)&&V.length===1&&V[0]==="workArea")),k.Event.fromNodeEventEmitter(t.screen,"display-added"),k.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(Y=>({id:Y.id,workspace:Y.openedWorkspace??(0,c.toWorkspaceIdentifier)(Y.backupPath,Y.isExtensionDevelopmentHost),title:Y.win?.getTitle()??"",filename:Y.getRepresentedFilename(),dirty:Y.isDocumentEdited()}))}async getWindowCount(X){return this.b.getWindowCount()}async getActiveWindowId(X){const Y=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(Y)return Y.id}openWindow(X,Y,re){return Array.isArray(Y)?this.n(X,Y,re):this.p(X,Y)}async n(X,Y,re=Object.create(null)){Y.length>0&&await this.b.open({context:5,contextWindowId:X,urisToOpen:Y,cli:this.g.args,forceNewWindow:re.forceNewWindow,forceReuseWindow:re.forceReuseWindow,preferNewWindow:re.preferNewWindow,diffMode:re.diffMode,mergeMode:re.mergeMode,addMode:re.addMode,gotoLineMode:re.gotoLineMode,noRecentEntry:re.noRecentEntry,waitMarkerFileURI:re.waitMarkerFileURI,remoteAuthority:re.remoteAuthority||void 0})}async p(X,Y){await this.b.openEmptyWindow({context:5,contextWindowId:X},Y)}async toggleFullScreen(X){this.w(X)?.toggleFullScreen()}async handleTitleDoubleClick(X){this.w(X)?.handleTitleDoubleClick()}async isMaximized(X){const Y=this.w(X);return Y?.win?Y.win.isMaximized():!1}async maximizeWindow(X){const Y=this.w(X);Y?.win&&Y.win.maximize()}async unmaximizeWindow(X){const Y=this.w(X);Y?.win&&Y.win.unmaximize()}async minimizeWindow(X){const Y=this.w(X);Y?.win&&Y.win.minimize()}async updateWindowControls(X,Y){const re=this.w(X);re&&re.updateWindowControls(Y)}async focusWindow(X,Y){Y&&typeof Y.windowId=="number"&&(X=Y.windowId),this.w(X)?.focus({force:Y?.force??!1})}async setMinimumSize(X,Y,re){const ne=this.w(X);if(ne?.win){const[de,K]=ne.win.getSize(),[le,F]=ne.win.getMinimumSize(),[T,N]=[Y??le,re??F],[V,se]=[Math.max(de,T),Math.max(K,N)];(le!==T||F!==N)&&ne.win.setMinimumSize(T,N),(de!==V||K!==se)&&ne.win.setSize(V,se)}}async saveWindowSplash(X,Y){this.j.saveWindowSplash(X,Y)}async installShellCommand(X){const{source:Y,target:re}=await this.r();try{const{symbolicLink:ne}=await b.SymlinkSupport.stat(Y);if(ne&&!ne.dangling){const de=await(0,w.realpath)(Y);if(re===de)return}await b.Promises.unlink(Y)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await b.Promises.symlink(re,Y)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:de}=await this.showMessageBox(X,{title:this.i.nameLong,type:"info",message:(0,v.localize)(0,null,this.i.nameShort),buttons:[(0,p.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,p.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(de===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${re}' '${Y}'\\" with administrator privileges"`;await(0,R.promisify)(I.exec)(K)}catch{throw new Error((0,v.localize)(3,null,Y))}}}async uninstallShellCommand(X){const{source:Y}=await this.r();try{await b.Promises.unlink(Y)}catch(re){switch(re.code){case"EACCES":{const{response:ne}=await this.showMessageBox(X,{title:this.i.nameLong,type:"info",message:(0,v.localize)(4,null,this.i.nameShort),buttons:[(0,p.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,p.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const de=`osascript -e "do shell script \\"rm '${Y}'\\" with administrator privileges"`;await(0,R.promisify)(I.exec)(de)}catch{throw new Error((0,v.localize)(7,null,Y))}break}case"ENOENT":break;default:throw re}}}async r(){const X=(0,P.resolve)(this.g.appRoot,"bin","code"),Y=`/usr/local/bin/${this.i.applicationName}`;if(!await b.Promises.exists(X))throw new Error((0,v.localize)(8,null,X));return{source:Y,target:X}}async showMessageBox(X,Y){return this.c.showMessageBox(Y,this.s(X))}async showSaveDialog(X,Y){return this.c.showSaveDialog(Y,this.s(X))}async showOpenDialog(X,Y){return this.c.showOpenDialog(Y,this.s(X))}s(X){const Y=this.w(X);if(Y?.win)return Y.win}async pickFileFolderAndOpen(X,Y){const re=await this.c.pickFileFolder(Y);re&&await this.t(await Promise.all(re.map(async ne=>await b.SymlinkSupport.existsDirectory(ne)?{folderUri:f.URI.file(ne)}:{fileUri:f.URI.file(ne)})),Y,X)}async pickFolderAndOpen(X,Y){const re=await this.c.pickFolder(Y);re&&await this.t(re.map(ne=>({folderUri:f.URI.file(ne)})),Y,X)}async pickFileAndOpen(X,Y){const re=await this.c.pickFile(Y);re&&await this.t(re.map(ne=>({fileUri:f.URI.file(ne)})),Y,X)}async pickWorkspaceAndOpen(X,Y){const re=await this.c.pickWorkspace(Y);re&&await this.t(re.map(ne=>({workspaceUri:f.URI.file(ne)})),Y,X)}async t(X,Y,re){await this.b.open({context:3,contextWindowId:re,cli:this.g.args,urisToOpen:X,forceNewWindow:Y.forceNewWindow})}async showItemInFolder(X,Y){t.shell.showItemInFolder(Y)}async setRepresentedFilename(X,Y){this.w(X)?.setRepresentedFilename(Y)}async setDocumentEdited(X,Y){this.w(X)?.setDocumentEdited(Y)}async openExternal(X,Y){return E.isLinuxSnap?this.u(Y):t.shell.openExternal(Y),!0}u(X){const Y=process.env.GDK_PIXBUF_MODULE_FILE,re=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(X),process.env.GDK_PIXBUF_MODULE_FILE=Y,process.env.GDK_PIXBUF_MODULEDIR=re}moveItemToTrash(X,Y){return t.shell.trashItem(Y)}async isAdmin(){let X;return E.isWindows?X=(await new Promise((Y,re)=>{H(["native-is-elevated"],Y,re)}))():X=process.getuid()===0,X}async writeElevated(X,Y,re,ne){const de=await new Promise((K,le)=>{H(["@vscode/sudo-prompt"],K,le)});return new Promise((K,le)=>{const F=[`"${this.v}"`];ne?.unlock&&F.push("--file-chmod"),F.push("--file-write",`"${Y.fsPath}"`,`"${re.fsPath}"`);const T={name:this.i.nameLong.replace("-",""),icns:E.isMacintosh&&this.g.isBuilt?(0,P.join)((0,P.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};de.exec(F.join(" "),T,(N,V,se)=>{V&&this.h.trace(`[sudo-prompt] received stdout: ${V}`),se&&this.h.trace(`[sudo-prompt] received stderr: ${se}`),N?le(N):K(void 0)})})}get v(){return E.isWindows?this.g.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,P.join)(this.g.appRoot,"scripts","code-cli.bat"):E.isLinux?this.g.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,P.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,P.join)(this.g.appRoot,"bin","code"):(0,P.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,C.totalmem)(),freemem:(0,C.freemem)(),loadavg:(0,C.loadavg)()}}async getOSProperties(){return{arch:(0,C.arch)(),platform:(0,C.platform)(),release:(0,C.release)(),type:(0,C.type)(),cpus:(0,C.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return E.isWindows&&(0,M.hasWSLFeatureInstalled)()}async killProcess(X,Y,re){process.kill(Y,re)}async readClipboardText(X,Y){return t.clipboard.readText(Y)}async writeClipboardText(X,Y,re){return t.clipboard.writeText(Y,re)}async readClipboardFindText(X){return t.clipboard.readFindText()}async writeClipboardFindText(X,Y){return t.clipboard.writeFindText(Y)}async writeClipboardBuffer(X,Y,re,ne){return t.clipboard.writeBuffer(Y,Buffer.from(re.buffer),ne)}async readClipboardBuffer(X,Y){return S.VSBuffer.wrap(t.clipboard.readBuffer(Y))}async hasClipboard(X,Y,re){return t.clipboard.has(Y,re)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(X,Y){this.w(X)?.updateTouchBar(Y)}async notifyReady(X){this.w(X)?.setReady()}async relaunch(X,Y){return this.f.relaunch(Y)}async reload(X,Y){const re=this.w(X);if(re){if((0,c.isWorkspaceIdentifier)(re.openedWorkspace)){const ne=re.openedWorkspace.configPath;if(ne.scheme===y.Schemas.file&&(await this.l.resolveLocalWorkspace(ne))?.transient)return this.openWindow(re.id,{forceReuseWindow:!0})}return this.f.reload(re,Y?.disableExtensions!==void 0?{_:[],"disable-extensions":Y.disableExtensions}:void 0)}}async closeWindow(X){this.closeWindowById(X,X)}async closeWindowById(X,Y){const re=this.w(Y);if(re?.win)return re.win.close()}async quit(X){const Y=this.b.getLastActiveWindow();Y?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&Y.win?Y.win.close():this.f.quit()}async exit(X,Y){await this.f.kill(Y)}async resolveProxy(X,Y){const ne=this.w(X)?.win?.webContents?.session;if(ne)return ne.resolveProxy(Y)}findFreePort(X,Y,re,ne,de=1){return(0,u.findFreePort)(Y,re,ne,de)}async openDevTools(X,Y){const re=this.w(X);re?.win&&re.win.webContents.openDevTools(Y)}async toggleDevTools(X){const Y=this.w(X);Y?.win&&Y.win.webContents.toggleDevTools()}async sendInputEvent(X,Y){const re=this.w(X);re?.win&&(Y.type==="mouseDown"||Y.type==="mouseUp")&&re.win.webContents.sendInputEvent(Y)}async enableSandbox(X,Y){Y?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(X,Y,re){const ne=this.w(X);if(!ne||!ne.win)throw new Error;return await new L.WindowProfiler(ne.win,Y,this.h).inspect(re)}async windowsGetStringRegKey(X,Y,re,ne){if(!E.isWindows)return;const de=await new Promise((K,le)=>{H(["@vscode/windows-registry"],K,le)});try{return de.GetStringRegKey(Y,re,ne)}catch{return}}w(X){if(typeof X=="number")return this.b.getWindowById(X)}};pe([A.memoize],J.prototype,"v",null),J=pe([ie(1,r.IWindowsMainService),ie(2,g.IDialogMainService),ie(3,i.ILifecycleMainService),ie(4,h.IEnvironmentMainService),ie(5,s.ILogService),ie(6,n.IProductService),ie(7,a.IThemeMainService),ie(8,B.IStateMainService),ie(9,o.IWorkspacesManagementMainService)],J),e.NativeHostMainService=J}),define(ee[267],te([0,1,13,41,25,34,2,15,4,101,163,84,119,57,27,5,6,58,63,19,64,74,30,12]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,d.createDecorator)("issueMainService");let n=class Bt{constructor(r,c,o,S,M,L,B,J,ae){this.g=r,this.h=c,this.i=o,this.j=S,this.k=M,this.l=L,this.m=B,this.n=J,this.o=ae,this.b=null,this.c=null,this.d=null,this.f=null,this.p()}p(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async r=>{const[c,o]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),S=await this.j.getSystemInfo(c,o);this.q(r,"vscode:issueSystemInfoResponse",S)}),t.validatedIpcMain.on("vscode:listProcesses",async r=>{const c=[];try{c.push({name:(0,y.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(S=>{(0,P.isRemoteDiagnosticError)(S)?c.push({name:S.hostName,rootProcess:S}):S.processes&&c.push({name:S.hostName,rootProcess:S.processes})})}catch(o){this.i.error(`Listing processes failed: ${o}`)}this.q(r,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async r=>{const c={title:this.o.nameLong,message:(0,y.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,y.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const o=await this.l.showMessageBox(c,this.b);this.q(r,"vscode:issueReporterClipboardResponse",o.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const c=await this.u();this.q(r,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.o.nameLong,message:(0,y.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,y.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(r,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(r,c)=>{const{id:o,from:S,args:M}=c;let L;switch(S){case"issueReporter":L=this.c;break;case"processExplorer":L=this.f;break;default:throw new Error(`Unexpected command source: ${S}`)}L?.webContents.send("vscode:runAction",{id:o,from:S,args:M})}),t.validatedIpcMain.on("vscode:openExternal",(r,c)=>{this.m.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",r=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",r=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async r=>{const c=await this.k.getMainDiagnostics();this.q(r,"vscode:windowsInfoResponse",c.windows)})}q(r,c,...o){r.sender.isDestroyed()||r.sender.send(c,...o)}async openReporter(r){if(!this.b&&(this.c=I.BrowserWindow.getFocusedWindow(),this.c)){const c=new A.DisposableStore,o=c.add(this.n.createIPCObjectUrl()),S=this.t(this.c,700,800);this.b=this.s(S,o,{backgroundColor:r.styles.backgroundColor,title:(0,y.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:r,disableExtensions:!!this.h.disableExtensions,os:{type:(0,C.type)(),arch:(0,C.arch)(),release:(0,C.release)()},product:v.default}),this.b.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,c.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,c.dispose())})}this.b&&this.r(this.b)}async openProcessExplorer(r){if(!this.d&&(this.f=I.BrowserWindow.getFocusedWindow(),this.f)){const c=new A.DisposableStore,o=c.add(this.n.createIPCObjectUrl()),S=this.t(this.f,800,500);this.d=this.s(S,o,{backgroundColor:r.styles.backgroundColor,title:(0,y.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),o.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:r,product:v.default}),this.d.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,c.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,c.dispose())})}this.d&&this.r(this.d)}r(r){r.isMinimized()&&r.restore(),r.focus()}s(r,c,o,S){const M=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:o.title,backgroundColor:o.backgroundColor||Bt.a,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${S}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return M.setMenuBarVisibility(!1),M}async getSystemStatus(){const[r,c]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(r,c)}t(r,c,o){let S;const M=I.screen.getAllDisplays();if(M.length===1)S=M[0];else{if(p.isMacintosh){const J=I.screen.getCursorScreenPoint();S=I.screen.getDisplayNearestPoint(J)}!S&&r&&(S=I.screen.getDisplayMatching(r.getBounds())),S||(S=I.screen.getPrimaryDisplay()||M[0])}const L={width:c,height:o},B=S.bounds;return L.x=B.x+B.width/2-L.width/2,L.y=B.y+B.height/2-L.height/2,B.width>0&&B.height>0&&(L.x<B.x&&(L.x=B.x),L.y<B.y&&(L.y=B.y),L.x>B.x+B.width&&(L.x=B.x),L.y>B.y+B.height&&(L.y=B.y),L.width>B.width&&(L.width=B.width),L.height>B.height&&(L.height=B.height)),L}async u(){try{const[r,c]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(r,c)}catch(r){throw this.i.warn("issueService#getPerformanceInfo ",r.message),r}}async stopTracing(){if(!this.h.args.trace)return;const r=await I.contentTracing.stopRecording(`${(0,i.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,y.localize)(9,null),detail:(0,y.localize)(10,null,r),buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(11,null))],defaultId:0,noLink:!0},(0,s.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,r)}};n.a="#1E1E1E",n=pe([ie(1,w.IEnvironmentMainService),ie(2,b.ILogService),ie(3,P.IDiagnosticsService),ie(4,E.IDiagnosticsMainService),ie(5,f.IDialogMainService),ie(6,u.INativeHostMainService),ie(7,h.IProtocolMainService),ie(8,g.IProductService)],n),e.IssueMainService=n}),define(ee[268],te([0,1,22,18,27,21,6,58,19,55,31,49,90]),function(H,e,I,t,C,R,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends E.AbstractUpdateService{constructor(d,b,u,v,g,h,l,i){super(d,b,v,g,h,i),this.e=u,this.u=l}s(d){return(0,E.createUpdateURL)(`linux-${process.arch}`,d,this.k)}t(d){!this.a||(this.d(P.State.CheckingForUpdates(d)),this.i.request({url:this.a},I.CancellationToken.None).then(m.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!d}),this.d(P.State.Idle(1))):this.d(P.State.AvailableForDownload(b))}).then(void 0,b=>{this.j.error(b),this.e.publicLog2("update:notAvailable",{explicit:!!d});const u=d?b.message||b:void 0;this.d(P.State.Idle(1,u))}))}async o(d){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):d.update.url&&this.u.openExternal(void 0,d.update.url),this.d(P.State.Idle(1))}};f=pe([ie(0,R.ILifecycleMainService),ie(1,t.IConfigurationService),ie(2,y.ITelemetryService),ie(3,C.IEnvironmentMainService),ie(4,m.IRequestService),ie(5,A.ILogService),ie(6,k.INativeHostMainService),ie(7,p.IProductService)],f),e.LinuxUpdateService=f}),define(ee[269],te([0,1,46,40,25,8,22,53,9,7,127,23,18,27,16,21,6,58,19,55,31,49,90]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(c,o=1e3){for(;!c();)await(0,R.timeout)(o)}let n;function a(){return typeof n>"u"&&(n=t.existsSync(p.join(p.dirname(process.execPath),"unins000.exe"))?0:1),n}let r=class extends i.AbstractUpdateService{get cachePath(){const o=p.join((0,C.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return P.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,S,M,L,B,J,ae,X,Y){super(o,S,L,B,J,Y),this.u=M,this.v=ae,this.w=X}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(o){let S="win32";return process.arch!=="ia32"&&(S+=`-${process.arch}`),a()===1?S+="-archive":this.k.target==="user"&&(S+="-user"),(0,i.createUpdateURL)(S,o,this.k)}t(o){!this.a||(this.d(l.State.CheckingForUpdates(o)),this.i.request({url:this.a},A.CancellationToken.None).then(g.asJson).then(S=>{const M=a();return!S||!S.url||!S.version||!S.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!o}),this.d(l.State.Idle(M)),Promise.resolve(null)):M===1?(this.d(l.State.AvailableForDownload(S)),Promise.resolve(null)):(this.d(l.State.Downloading(S)),this.B(S.version).then(()=>this.A(S.version).then(L=>P.Promises.exists(L).then(B=>{if(B)return Promise.resolve(L);const J=S.url,ae=S.hash,X=`${L}.tmp`;return this.i.request({url:J},A.CancellationToken.None).then(Y=>this.v.writeFile(m.URI.file(X),Y.stream)).then(ae?()=>(0,y.checksum)(X,S.hash):()=>{}).then(()=>P.Promises.rename(X,L)).then(()=>L)})).then(L=>{const B=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:L},B&&S.supportsFastUpdate?this.k.target==="user"?this.p():this.d(l.State.Downloaded(S)):this.d(l.State.Ready(S))})))}).then(void 0,S=>{this.j.error(S),this.u.publicLog2("update:notAvailable",{explicit:!!o});const M=o?S.message||S:void 0;this.d(l.State.Idle(a(),M))}))}async o(o){o.update.url&&this.w.openExternal(void 0,o.update.url),this.d(l.State.Idle(a()))}async A(o){const S=await this.cachePath;return p.join(S,`CodeSetup-${this.k.quality}-${o}.exe`)}async B(o=null){const S=o?J=>!new RegExp(`${this.k.quality}-${o}\\.exe$`).test(J):()=>!0,M=await this.cachePath,B=(await P.Promises.readdir(M)).filter(S).map(async J=>{try{await P.Promises.unlink(p.join(M,J))}catch{}});await Promise.all(B)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const o=this.state.update;this.d(l.State.Updating(o));const S=await this.cachePath;this.e.updateFilePath=p.join(S,`CodeSetup-${this.k.quality}-${o.version}.flag`),await P.Promises.writeFile(this.e.updateFilePath,"flag"),(0,I.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(l.State.Idle(a()))});const L=`${this.k.win32MutexName}-ready`,B=await new Promise((J,ae)=>{H(["windows-mutex"],J,ae)});s(()=>B.isActive(L)).then(()=>this.d(l.State.Ready(o)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,I.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const S=this.g.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!S};this.d(l.State.Downloading(M)),this.e={packagePath:o},S?this.k.target==="user"?this.p():this.d(l.State.Downloaded(M)):this.d(l.State.Ready(M))}};pe([k.memoize],r.prototype,"cachePath",null),r=pe([ie(0,d.ILifecycleMainService),ie(1,E.IConfigurationService),ie(2,h.ITelemetryService),ie(3,f.IEnvironmentMainService),ie(4,g.IRequestService),ie(5,b.ILogService),ie(6,w.IFileService),ie(7,u.INativeHostMainService),ie(8,v.IProductService)],r),e.Win32UpdateService=r}),define(ee[270],te([0,1,13,8,22,45,3,34,2,15,9,73,4,7,171,62,18,57,27,61,16,21,6,19,64,234,93,31,239,66,74,32,28,52,116,121,37,36,51,58,236,112,56,89,25,113]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l,i,s,n,a,r,c,o,S,M,L,B,J,ae,X,Y,re,ne,de,K,le,F,T,N,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var se;(function($){$[$.NONE=0]="NONE",$[$.NAVIGATING=1]="NAVIGATING",$[$.READY=2]="READY"})(se||(se={}));let z=class gt extends p.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const D=this.O.profiles.find(O=>O.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&D?D:this.O.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",D??this.O.defaultProfile)}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(D,O,W,U,q,Q,j,Z,x,oe,ge,Me,Oe,Ce,Le,be,we,ye,De,_){super(),this.L=O,this.M=W,this.N=U,this.O=q,this.P=Q,this.Q=j,this.R=Z,this.S=x,this.U=oe,this.W=ge,this.X=Me,this.Y=Oe,this.Z=Ce,this.ab=Le,this.bb=be,this.db=we,this.eb=ye,this.fb=De,this.gb=_,this.c=this.B(new A.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new A.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new A.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new A.Emitter),this.onDidClose=this.h.event,this.j=this.B(new A.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.db.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[he,fe]=this.sb(D.state);this.r=he,this.L.trace("window#ctor: using window state",he);const ve=this.r.mode===0||this.r.mode===3;typeof gt.b>"u"&&(gt.b=this.fb.getItem("window.experimental.useSandbox",!1));const Pe=this.S.getValue("window");let We=!1;typeof Pe?.experimental?.useSandbox=="boolean"?We=Pe.experimental.useSandbox:this.bb.quality==="stable"&&gt.b?We=!0:We=typeof this.bb.quality=="string"&&this.bb.quality!=="stable";const Te={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.U.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!ve,title:this.bb.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(Pe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...We?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};E.isLinux?Te.icon=(0,y.join)(this.M.appRoot,"resources/linux/code.png"):E.isWindows&&!this.M.isBuilt&&(Te.icon=(0,y.join)(this.M.appRoot,"resources/win32/code_150x150.png")),E.isMacintosh&&!this.zb()&&(Te.fullscreenable=!1),E.isMacintosh&&(Te.acceptFirstMouse=!0,Pe?.clickThroughInactive===!1&&(Te.acceptFirstMouse=!1));const qe=E.isMacintosh&&Pe?.nativeTabs===!0;qe&&(Te.tabbingIdentifier=this.bb.nameShort);const Ue=(0,M.getTitleBarStyle)(this.S)==="custom";if(Ue&&(Te.titleBarStyle="hidden",E.isMacintosh||(Te.frame=!1),(0,M.useWindowControlsOverlay)(this.S))){const Be=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Xe=X.Color.fromHex(Be).isDarker()?"#FFFFFF":"#000000";Te.titleBarOverlay={height:29,color:Be,symbolColor:Xe},this.z=!0}if((0,P.mark)("code/willCreateCodeBrowserWindow"),this.l=new I.BrowserWindow(Te),(0,P.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,E.isMacintosh&&Ue&&this.l.setSheetOffset(22),Ue&&(E.isWindows&&(0,M.useWindowControlsOverlay)(this.S)||E.isMacintosh)){const Be=this.fb.getItem(gt.a);Be&&this.updateWindowControls({height:Be})}E.isWindows&&Ue&&this.l.hookWindowMessage(278,()=>{const[Xe,$e]=this.l.getPosition(),Ke=I.screen.getCursorScreenPoint(),G=Ke.x-Xe,ce=Ke.y-$e;return(()=>!(G>30&&ce>=0&&ce<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:G,y:ce})),0}),(E.isMacintosh||E.isWindows)&&fe&&(!qe||I.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(Be=>typeof Be=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),ve&&((0,P.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.vb(!0),this.l.show(),(0,P.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.M.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.pb(),this.Db(),this.ib()}setRepresentedFilename(D){E.isMacintosh?this.l.setRepresentedFilename(D):this.v=D}getRepresentedFilename(){return E.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(D){E.isMacintosh&&this.l.setDocumentEdited(D),this.w=D}isDocumentEdited(){return E.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(D){E.isMacintosh&&D?.force&&I.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.hb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(D=>{if(this.isReady)return D(this);this.C.push(D)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(D=>{function O(){W.dispose(),U.dispose(),D()}const W=this.onDidClose(()=>O()),U=this.onWillLoad(()=>O())})}ib(){this.l.on("unresponsive",()=>this.lb(1)),this.l.webContents.on("render-process-gone",(O,W)=>this.lb(2,W)),this.l.webContents.on("did-fail-load",(O,W,U)=>this.lb(3,{reason:U,exitCode:W})),this.l.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",O=>{this.n&&(this.n.maximized=!0),I.app.emit("browser-window-maximize",O,this.l)}),this.l.on("unmaximize",O=>{this.n&&(this.n.maximized=!1),I.app.emit("browser-window-unmaximize",O,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",C.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",C.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.S.onDidChangeConfiguration(O=>this.pb(O))),this.B(this.W.onDidDeleteUntitledWorkspace(O=>this.ob(O)));const D=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:D},async(O,W)=>{const U=await this.kb();W({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,U)})})}kb(){return this.jb||(this.jb=(0,a.resolveMarketplaceHeaders)(this.bb.version,this.bb,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(D,O){switch(D){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:D,reason:O?.reason,code:O?.exitCode}),D){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ab.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.ab.quit();return}if(D===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const W=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(0,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(1,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(2,null))],message:(0,w.localize)(3,null),detail:(0,w.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,w.localize)(5,null):void 0},this.l);if(W.response!==1){const U=W.response===0;await this.nb(U,W.checkboxChecked)}}else if(D===2)if(E.isWindows&&O?.reason==="launch-failed"&&O.exitCode===18&&await this.gb.isAdmin(void 0))await this.mb(O);else{let W;O?W=(0,w.localize)(7,null,O.reason,O.exitCode??"<unknown>"):W=(0,w.localize)(6,null);const U=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(8,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(9,null))],message:W,detail:(0,w.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,w.localize)(11,null):void 0},this.l),q=U.response===0;await this.nb(q,U.checkboxChecked)}break}}async mb(D){const O=[],W=(0,F.isInternalTelemetry)(this.bb,this.S);if((0,F.supportsTelemetry)(this.bb,this.M)){this.bb.aiConfig&&this.bb.aiConfig.ariaKey&&O.push(new K.OneDataSystemAppender(W,"monacoworkbench",null,this.bb.aiConfig.ariaKey));const{installSourcePath:U}=this.M,q=await(0,V.resolveMachineId)(this.fb),Q={appenders:O,sendErrorTelemetry:!1,commonProperties:(0,T.resolveCommonProperties)(this.P,(0,N.release)(),(0,N.hostname)(),process.arch,this.bb.commit,this.bb.version,q,W,U),piiPaths:(0,F.getPiiPathsFromEnvironment)(this.M)};await new le.TelemetryService(Q,this.S,this.bb).publicLog2("windowadminerror",{reason:D.reason,code:D.exitCode})}await this.Z.showMessageBox({title:this.bb.nameLong,type:"error",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(12,null))],message:(0,w.localize)(13,null),detail:(0,w.localize)(14,null,this.bb.nameLong),noLink:!0,defaultId:0},this.l),await Promise.all(O.map(U=>U.flush())),await this.nb(!1,!1)}async nb(D,O){const W=this.n?.workspace;if(O&&W)try{const U=this.R.workspaceStorage(W);await U.init(),U.delete("memento/workbench.parts.editor"),await U.close()}catch(U){this.L.error(U)}if(this.j.fire(),this.l?.destroy(),D&&this.n){let U,q;(0,B.isSingleFolderWorkspaceIdentifier)(W)?U={folderUri:W.uri}:(0,B.isWorkspaceIdentifier)(W)?U={workspaceUri:W.configPath}:q=!0;const[Q]=await this.eb.open({context:5,userEnv:this.n.userEnv,cli:{...this.M.args,_:[]},urisToOpen:U?[U]:void 0,forceEmpty:q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});Q.focus()}}ob(D){this.n?.workspace?.id===D.id&&(this.n.workspace=void 0)}pb(D){const O=this.Ab();O!==this.s&&(this.s=O,this.Bb(O));let W=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.F||U!==this.G)){this.F=W,this.G=U;const q=W||"",Q=U?`${U},<local>`:"<local>";this.L.trace(`Setting proxy to '${q}', bypassing '${Q}'`),this.l.webContents.session.setProxy({proxyRules:q,proxyBypassRules:Q,pacScript:""})}}addTabbedWindow(D){E.isMacintosh&&D.win&&this.l.addTabbedWindow(D.win)}load(D,O=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!O.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.bb.nameLong)),this.qb(D,O),this.hb===0?this.n=D:this.I=D,this.hb=1,this.l.loadURL(m.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:D.workspace,reason:O.isReload?3:W?2:1})}qb(D,O){const W=(this.n??this.I)?.userEnv;if(W){const U=(0,g.isLaunchedFromCli)(W)&&!(0,g.isLaunchedFromCli)(D.userEnv),q=this.isExtensionDevelopmentHost;(U||q)&&(D.userEnv={...W,...D.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(D.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(D["disable-extensions"]=O.disableExtensions),D.fullscreen=this.isFullScreen,D.maximized=this.l.isMaximized(),D.partsSplash=this.U.getWindowSplash(),(0,P.mark)("code/willOpenNewWindow"),D.perfMarks=(0,P.getMarks)(),this.H.update(D)}async reload(D){const O=Object.assign({},this.n);O.workspace=await this.rb(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToMerge,delete O.filesToWait,this.isExtensionDevelopmentHost&&D&&(O.verbose=D.verbose,O.debugId=D.debugId,O.extensionEnvironment=D.extensionEnvironment,O["inspect-extensions"]=D["inspect-extensions"],O["inspect-brk-extensions"]=D["inspect-brk-extensions"],O["extensions-dir"]=D["extensions-dir"]),O.isInitialStartup=!1,O.policiesData=this.N.serialize(),O.continueOn=this.M.continueOn,O.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},O.logLevel=this.L.getLevel(),this.load(O,{isReload:!0,disableExtensions:D?.["disable-extensions"]})}async rb(D){if((0,B.isWorkspaceIdentifier)(D.workspace)){const O=D.workspace.configPath;if(O.scheme===m.Schemas.file&&!await this.P.exists(O))return}else if((0,B.isSingleFolderWorkspaceIdentifier)(D.workspace)){const O=D.workspace.uri;if(O.scheme===m.Schemas.file&&!await this.P.exists(O))return}return D.workspace}serializeWindowState(){if(!this.l)return(0,ae.defaultWindowState)();if(this.isFullScreen){let W;try{W=I.screen.getDisplayMatching(this.getBounds())}catch{}const U=(0,ae.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.r.width||U.width,height:this.r.height||U.height,x:this.r.x||0,y:this.r.y||0}}const D=Object.create(null);let O;if(!E.isMacintosh&&this.l.isMaximized()?O=0:O=1,O===0?D.mode=0:D.mode=1,O===1||O===0){let W;O===1?W=this.getBounds():W=this.l.getNormalBounds(),D.x=W.x,D.y=W.y,D.width=W.width,D.height=W.height}return D}updateWindowControls(D){if(D.height&&this.fb.setItem(gt.a,D.height),E.isWindows&&this.z)this.l.setTitleBarOverlay({color:D.backgroundColor?.trim()===""?void 0:D.backgroundColor,symbolColor:D.foregroundColor?.trim()===""?void 0:D.foregroundColor,height:D.height?D.height-1:void 0});else if(E.isMacintosh&&D.height!==void 0){const O=(D.height-15)/2;this.l.setTrafficLightPosition({x:O,y:O})}}sb(D){(0,P.mark)("code/willRestoreCodeWindowState");let O=!1;if(D)try{const W=I.screen.getAllDisplays();O=W.length>1,D=this.tb(D,W)}catch(W){this.L.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,P.mark)("code/didRestoreCodeWindowState"),[D||(0,ae.defaultWindowState)(),O]}tb(D,O){if(this.L.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,D),typeof D.x!="number"||typeof D.y!="number"||typeof D.width!="number"||typeof D.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(D.width<=0||D.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const q=this.ub(O[0]);if(q){let Q=function(){!D||typeof D.x!="number"||typeof D.y!="number"||!q||(D.x<q.x&&(D.x=q.x),D.y<q.y&&(D.y=q.y))};this.L.trace("window#validateWindowState: 1 monitor working area",q),Q(),D.width>q.width&&(D.width=q.width),D.height>q.height&&(D.height=q.height),D.x>q.x+q.width-128&&(D.x=q.x+q.width-D.width),D.y>q.y+q.height-128&&(D.y=q.y+q.height-D.height),Q()}return D}if(D.display&&D.mode===3){const q=O.find(Q=>Q.id===D.display);if(q&&typeof q.bounds?.x=="number"&&typeof q.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const Q=(0,ae.defaultWindowState)(3);return Q.x=q.bounds.x,Q.y=q.bounds.y,Q}}let W,U;try{W=I.screen.getDisplayMatching({x:D.x,y:D.y,width:D.width,height:D.height}),U=this.ub(W)}catch{}if(W&&U&&D.x+D.width>U.x&&D.y+D.height>U.y&&D.x<U.x+U.width&&D.y<U.y+U.height)return this.L.trace("window#validateWindowState: multi-monitor working area",U),D}ub(D){if(D.workArea.width>0&&D.workArea.height>0)return D.workArea;if(D.bounds.width>0&&D.bounds.height>0)return D.bounds}getBounds(){const[D,O]=this.l.getPosition(),[W,U]=this.l.getSize();return{x:D,y:O,width:W,height:U}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(D){this.zb()?this.wb(D):this.yb(D),this.sendWhenReady(D?"vscode:enterFullScreen":"vscode:leaveFullScreen",C.CancellationToken.None),this.s&&this.Bb(this.s,!1)}get isFullScreen(){return E.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}wb(D){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.xb(D)}xb(D){E.isMacintosh&&(this.t=D,this.u=new t.DeferredPromise,Promise.race([this.u.p,(0,t.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(D)}yb(D){this.l.isFullScreen()&&this.xb(!1),this.l.setSimpleFullScreen(D),this.l.webContents.focus()}zb(){const D=this.S.getValue("window");return!D||typeof D.nativeFullScreen!="boolean"||D.nativeTabs?!0:D.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Ab(){let D=(0,M.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(D)<0&&(D="classic"),D}Bb(D,O=!0){E.isMacintosh||(D==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,w.localize)(15,null)),D==="hidden"?setTimeout(()=>{this.Cb(D)}):this.Cb(D))}Cb(D){const O=this.isFullScreen;switch(D){case"classic":this.l.setMenuBarVisibility(!O),this.l.autoHideMenuBar=O;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(E.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(D,O,...W){this.isReady?this.send(D,...W):this.ready().then(()=>{O.isCancellationRequested||this.send(D,...W)})}send(D,...O){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${D}' for window that is destroyed`);return}try{this.l.webContents.send(D,...O)}catch(W){this.L.warn(`Error sending IPC message to channel '${D}' of window ${this.k}: ${(0,R.toErrorMessage)(W)}`)}}}updateTouchBar(D){!E.isMacintosh||this.D.forEach((O,W)=>{const U=D[W];O.segments=this.Fb(U)})}Db(){if(!!E.isMacintosh){for(let D=0;D<10;D++){const O=this.Eb();this.D.push(O)}this.l.setTouchBar(new I.TouchBar({items:this.D}))}}Eb(D=[]){const O=this.Fb(D),W=new I.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",C.CancellationToken.None,{id:W.segments[U].id,from:"touchbar"})}});return W}Fb(D=[]){return D.map(W=>{let U;W.icon&&!o.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===m.Schemas.file&&(U=I.nativeImage.createFromPath(f.URI.revive(W.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let q;return typeof W.title=="string"?q=W.title:q=W.title.value,{id:W.id,label:U?void 0:q,icon:U}})}dispose(){super.dispose(),this.l=null}};z.a="windowControlHeight",z.b=void 0,z=pe([ie(1,i.ILogService),ie(2,v.IEnvironmentMainService),ie(3,Y.IPolicyService),ie(4,ne.IUserDataProfilesMainService),ie(5,h.IFileService),ie(6,r.IApplicationStorageMainService),ie(7,r.IStorageMainService),ie(8,b.IConfigurationService),ie(9,S.IThemeMainService),ie(10,J.IWorkspacesManagementMainService),ie(11,d.IBackupMainService),ie(12,c.ITelemetryService),ie(13,u.IDialogMainService),ie(14,l.ILifecycleMainService),ie(15,s.IProductService),ie(16,n.IProtocolMainService),ie(17,L.IWindowsMainService),ie(18,re.IStateMainService),ie(19,de.INativeHostMainService)],z),e.CodeWindow=z}),define(ee[75],te([0,1,13,24,8,3,34,2,15,4,20,7,23,174,5,21,6,93,94,28,52,39]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,w.createDecorator)("workspacesHistoryMainService");let i=class rt extends k.Disposable{constructor(n,a,r,c){super(),this.f=n,this.g=a,this.h=r,this.j=c,this.c=this.B(new R.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new C.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let a=[],r=[];for(const o of n)if((0,v.isRecentWorkspace)(o))!this.g.isUntitledWorkspace(o.workspace)&&!this.r(a,o.workspace)&&a.push(o);else if((0,v.isRecentFolder)(o))this.s(a,o.folderUri)||a.push(o);else{const S=this.t(r,o.fileUri),M=o.fileUri.scheme===p.Schemas.file&&rt.y.indexOf((0,y.basename)(o.fileUri))>=0;!S&&!M&&(r.push(o),m.isWindows&&o.fileUri.scheme===p.Schemas.file&&I.app.addRecentDocument(o.fileUri.fsPath))}const c=await this.l({workspaces:a,files:r});a=c.workspaces,r=c.files,a.length>rt.a&&(a.length=rt.a),r.length>rt.a&&(r.length=rt.a),await this.n({workspaces:a,files:r}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(n){const a=S=>{const M=this.p(S);for(const L of n)if(y.extUriBiasedIgnorePathCase.isEqual(L,M))return!1;return!0},r=await this.getRecentlyOpened(),c=r.workspaces.filter(a),o=r.files.filter(a);(c.length!==r.workspaces.length||o.length!==r.files.length)&&(await this.n({files:o,workspaces:c}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(n){const a=new l.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o));if(n?.workspaces)for(const o of n.workspaces)a.set(this.p(o),o);const r=new l.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o));if(n?.files)for(const o of n.files)r.set(this.p(o),o);const c=await this.m();for(const o of c.workspaces){const S=a.get(this.p(o));S?S.label=S.label??o.label:a.set(this.p(o),o)}for(const o of c.files){const S=r.get(this.p(o));S?S.label=S.label??o.label:r.set(this.p(o),o)}return{workspaces:[...a.values()],files:[...r.values()]}}async m(){await this.j.whenReady;let n;const a=this.j.get(rt.b,-1);if(typeof a=="string")try{n=JSON.parse(a)}catch(r){this.f.error("Unexpected error parsing opened paths list",r)}return(0,v.restoreRecentlyOpened)(n,this.f)}async n(n){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,v.toStoreData)(n)),-1,1)}p(n){return(0,v.isRecentFolder)(n)?n.folderUri:(0,v.isRecentFile)(n)?n.fileUri:n.workspace.configPath}r(n,a){return!!n.find(r=>(0,v.isRecentWorkspace)(r)&&r.workspace.id===a.id)}s(n,a){return!!n.find(r=>(0,v.isRecentFolder)(r)&&y.extUriBiasedIgnorePathCase.isEqual(r.folderUri,a))}t(n,a){return!!n.find(r=>y.extUriBiasedIgnorePathCase.isEqual(r.fileUri,a))}async C(){!m.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!m.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const o of I.app.getJumpListSettings().removedItems){const S=o.args;if(S){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(S);M&&a.push(P.URI.parse(M[2]))}}await this.removeRecentlyOpened(a);let r=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(o=>{const S=(0,v.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:M,description:L}=this.F(S,o.label);let B;return P.URI.isUri(S)?B=`--folder-uri "${S.toString()}"`:(r=!0,B=`--file-uri "${S.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:L.substr(0,255),program:process.execPath,args:B,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&n.push({type:"custom",name:r?(0,f.localize)(2,null):(0,f.localize)(3,null),items:c})}n.push({type:"recent"});try{const a=I.app.setJumpList(n);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}F(n,a){if(a)return{title:(0,A.splitName)(a).name,description:a};if(P.URI.isUri(n))return{title:(0,y.basename)(n),description:this.G(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,f.localize)(4,null),description:""};let r=(0,y.basename)(n.configPath);return r.endsWith(g.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-g.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,r),description:this.G(n.configPath)}}G(n){return n.scheme==="file"?(0,A.normalizeDriveLetter)(n.fsPath):n.toString()}async H(){if(!m.isMacintosh)return;I.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),a=[];let r=0;for(let o=0;o<n.workspaces.length&&r<rt.u;o++){const S=this.p(n.workspaces[o]);if(S.scheme===p.Schemas.file){const M=(0,y.originalFSPath)(S);await E.Promises.exists(M)&&(a.push(M),r++)}}const c=[];for(let o=0;o<n.files.length&&r<rt.v;o++){const S=this.p(n.files[o]);if(S.scheme===p.Schemas.file){const M=(0,y.originalFSPath)(S);if(rt.y.includes((0,y.basename)(S))||a.includes(M))continue;await E.Promises.exists(M)&&(c.push(M),r++)}}c.reverse().forEach(o=>I.app.addRecentDocument(o)),a.reverse().forEach(o=>I.app.addRecentDocument(o))}};i.a=500,i.b="history.recentlyOpenedPathsList",i.u=7,i.v=10,i.w=7,i.y=["COMMIT_EDITMSG","MERGE_MSG"],i=pe([ie(0,b.ILogService),ie(1,h.IWorkspacesManagementMainService),ie(2,d.ILifecycleMainService),ie(3,u.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(ee[271],te([0,1,13,8,22,34,4,7,164,18,27,21,6,212,58,19,36,31,49,74,32,75]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let s=class Ft{constructor(r,c,o,S,M,L,B,J,ae,X,Y){this.n=r,this.o=c,this.p=o,this.q=S,this.r=M,this.s=L,this.t=B,this.u=J,this.v=ae,this.w=X,this.x=Y,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.E(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.isMacintosh||(0,g.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const r=this.t.getItem(Ft.a);r&&(r.menus&&(this.k=r.menus),r.keybindings&&(this.l=r.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(L,B,J)=>this.p.openEmptyWindow({context:2,contextWindowId:B?.id}),this.m["workbench.action.newWindow"]=(L,B,J)=>this.p.openEmptyWindow({context:2,contextWindowId:B?.id}),this.m["workbench.action.files.openFileFolder"]=(L,B,J)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(J),telemetryExtraData:{from:i}}),this.m["workbench.action.files.openFolder"]=(L,B,J)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(J),telemetryExtraData:{from:i}}),this.m["workbench.action.openWorkspace"]=(L,B,J)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(J),telemetryExtraData:{from:i}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const r=this.x.twitterUrl;r&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(r,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(c,"openUserVoiceUrl"));const o=this.x.reportIssueUrl;o&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(o,"openReportIssues"));const S=this.x.licenseUrl;S&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.language){const L=S.indexOf("?")>0?"&":"?";this.Z(`${S}${L}lang=${A.language}`,"openLicenseUrl")}else this.Z(S,"openLicenseUrl")});const M=this.x.privacyStatementUrl;M&&S&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(M,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(r=>this.F(r)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const r=this.o.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get C(){if(!A.isMacintosh)return!1;const r=this.o.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,c){this.k=r.menus,this.l=r.keybindings,this.t.setItem(Ft.a,r),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(r){!A.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.d=r.newCount===0,this.D())}G(){!A.isMacintosh||(this.f=!I.BrowserWindow.getFocusedWindow(),this.D())}H(){const r=I.Menu.getApplicationMenu();if(r&&this.j.push(r),Object.keys(this.k).length===0){I.Menu.setApplicationMenu(A.isMacintosh?new I.Menu:null);return}const c=new I.Menu;let o;if(A.isMacintosh){const M=new I.Menu;o=new I.MenuItem({label:this.x.nameShort,submenu:M}),this.I(M),c.append(o)}if(A.isMacintosh&&!this.c){this.c=!0;const M=new I.Menu;M.append(new I.MenuItem({label:this.bb(p.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),I.app.dock.setMenu(M)}if(this.K("File")){const M=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(1,null)),submenu:M});this.M(M,"File"),c.append(L)}if(this.K("Edit")){const M=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(2,null)),submenu:M});this.M(M,"Edit"),c.append(L)}if(this.K("Selection")){const M=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(3,null)),submenu:M});this.M(M,"Selection"),c.append(L)}if(this.K("View")){const M=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(4,null)),submenu:M});this.M(M,"View"),c.append(L)}if(this.K("Go")){const M=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(5,null)),submenu:M});this.M(M,"Go"),c.append(L)}if(this.K("Run")){const M=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(6,null)),submenu:M});this.M(M,"Run"),c.append(L)}if(this.K("Terminal")){const M=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(7,null)),submenu:M});this.M(M,"Terminal"),c.append(L)}let S;if(this.K("Window")){const M=new I.Menu;S=new I.MenuItem({label:this.bb(p.localize(8,null)),submenu:M,role:"window"}),this.S(M)}if(S&&c.append(S),this.K("Help")){const M=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(9,null)),submenu:M,role:"help"});this.M(M,"Help"),c.append(L)}c.items&&c.items.length>0?I.Menu.setApplicationMenu(c):I.Menu.setApplicationMenu(null),this.h.schedule()}I(r){const c=this.U(p.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),o=this.T();let S;if(this.K("Preferences")){const re=new I.Menu;this.M(re,"Preferences"),S=new I.MenuItem({label:this.bb(p.localize(11,null)),submenu:re})}const M=new I.Menu,L=new I.MenuItem({label:p.localize(12,null),role:"services",submenu:M}),B=new I.MenuItem({label:p.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),J=new I.MenuItem({label:p.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ae=new I.MenuItem({label:p.localize(15,null),role:"unhide"}),X=new I.MenuItem(this.Y("workbench.action.quit",{label:p.localize(16,null,this.x.nameLong),click:async(re,ne,de)=>{const K=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.J(de)&&this.w.quit(void 0)}})),Y=[c];Y.push(...o),S&&Y.push(n(),S),Y.push(n(),L,n(),B,J,ae,n(),X),Y.forEach(re=>r.append(re))}async J(r){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.Q(r)){const o={title:this.x.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(p.localize(17,null)),(0,R.mnemonicButtonLabel)(p.localize(18,null))],message:p.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:S}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,o);return S===0}return!0}K(r){if(!A.isMacintosh&&(0,g.getTitleBarStyle)(this.o)==="custom")return!1;switch(r){case"File":case"Help":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[r];case"Window":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[r]}}L(r,c){c.forEach(o=>{if((0,f.isMenubarMenuItemSeparator)(o))r.append(n());else if((0,f.isMenubarMenuItemSubmenu)(o)){const S=new I.Menu,M=new I.MenuItem({label:this.bb(o.label),submenu:S});this.L(S,o.submenu.items),r.append(M)}else(0,f.isMenubarMenuItemRecentAction)(o)?r.append(this.O(o)):(0,f.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.N(r),A.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[o.id]?r.append(new I.MenuItem(this.Y(o.id,{label:this.bb(o.label),click:this.m[o.id]}))):r.append(this.U(o.label,o.id,!1,o.checked)):r.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)):r.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)))})}M(r,c){this.k&&this.k[c]&&this.L(r,this.k[c].items)}N(r){const c=this.T();c.length&&(c.forEach(o=>r.append(o)),r.append(n()))}O(r){const c=k.URI.revive(r.uri),o=r.id,S=o==="openRecentFile"?{fileUri:c}:o==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new I.MenuItem(this.Y(o,{label:r.label,click:async(M,L,B)=>{const J=this.P(B);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[S],forceNewWindow:J,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}P(r){return!!(r&&(!A.isMacintosh&&(r.ctrlKey||r.shiftKey)||A.isMacintosh&&(r.metaKey||r.altKey)))}Q(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}R(r,c,o){const S={label:this.bb(r),role:o,enabled:!0};return new I.MenuItem(this.X(c,S))}S(r){const c=new I.MenuItem({label:p.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),o=new I.MenuItem({label:p.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),S=new I.MenuItem({label:p.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),M=this.U(p.localize(23,null),"workbench.action.switchWindow"),L=[];this.C&&(L.push(n()),L.push(this.U(p.localize(24,null),"workbench.action.newWindowTab")),L.push(this.R(p.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.R(p.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.R(p.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.R(p.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,o,n(),M,...L,n(),S].forEach(B=>r.append(B))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.bb(p.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:p.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.bb(p.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:p.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.bb(p.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new I.MenuItem({label:p.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.bb(p.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(r,c,o,S){const M=this.bb(r),L=typeof c=="function"?c:(Y,re,ne)=>{const de=Y?Y.userSettingsLabel:null;let K=c;Array.isArray(c)&&(K=this.P(ne)?c[1]:c[0]),de&&ne.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:de}):this.W({type:"commandId",commandId:K})},B=typeof o=="boolean"?o:this.p.getWindowCount()>0,J=typeof S=="boolean"?S:!1,ae={label:M,click:L,enabled:B};J&&(ae.type="checkbox",ae.checked=J);let X;return typeof c=="string"?X=c:Array.isArray(c)&&(X=c[0]),A.isMacintosh&&(X==="editor.action.clipboardCutAction"?ae.role="cut":X==="editor.action.clipboardCopyAction"?ae.role="copy":X==="editor.action.clipboardPasteAction"&&(ae.role="paste"),X==="undo"?ae.click=this.V(L,{inDevTools:Y=>Y.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):X==="redo"?ae.click=this.V(L,{inDevTools:Y=>Y.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):X==="editor.action.selectAll"&&(ae.click=this.V(L,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.X(X,ae))}V(r,c){return(o,S,M)=>{const L=I.BrowserWindow.getFocusedWindow();if(!L)return c.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return c.inDevTools(L.webContents.devToolsWebContents);r(o,S||L,M)}}W(r){let c=I.BrowserWindow.getFocusedWindow();if(!c){const S=this.p.getLastActiveWindow();S?.isMinimized()&&(c=S.win)}const o=c?this.p.getWindowById(c.id):void 0;if(o){if(this.v.trace("menubar#runActionInRenderer",r),A.isMacintosh&&!this.q.isBuilt&&!o.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const S={id:r.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",C.CancellationToken.None,S)}else{const S={userSettingsLabel:r.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",C.CancellationToken.None,S)}}else this.v.trace("menubar#runActionInRenderer: no active window found",r)}X(r,c){const o=typeof r=="string"?this.l[r]:void 0;if(o?.label){if(o.isNative!==!1)c.accelerator=o.label,c.userSettingsLabel=o.userSettingsLabel;else if(typeof c.label=="string"){const S=c.label.indexOf("[");S>=0?c.label=`${c.label.substr(0,S)} [${o.label}]`:c.label=`${c.label} [${o.label}]`}}else c.accelerator=void 0;return c}Y(r,c,o=!c.accelerator){o&&(c=this.X(r,c));const S=c.click;return c.click=(M,L,B)=>{this.ab(r),S?.(M,L,B)},c}Z(r,c){this.w.openExternal(void 0,r),this.ab(c)}ab(r){this.r.publicLog2("workbenchActionExecuted",{id:r,from:i})}bb(r){return(0,R.mnemonicMenuLabel)(r,!this.B)}};s.a="lastKnownMenubarData",s=pe([ie(0,v.IUpdateService),ie(1,m.IConfigurationService),ie(2,h.IWindowsMainService),ie(3,y.IEnvironmentMainService),ie(4,u.ITelemetryService),ie(5,l.IWorkspacesHistoryMainService),ie(6,b.IStateMainService),ie(7,P.ILifecycleMainService),ie(8,E.ILogService),ie(9,w.INativeHostMainService),ie(10,d.IProductService)],s),e.Menubar=s;function n(){return new I.MenuItem({type:"separator"})}}),define(ee[272],te([0,1,5,21,6,271]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let A=class{constructor(p,m,y){this.b=p,this.c=m,this.d=y,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.Menubar)}async updateMenubar(p,m){this.d.trace("menubarService#updateMenubar",p),(await this.a).updateMenu(m,p)}};A=pe([ie(0,I.IInstantiationService),ie(1,t.ILifecycleMainService),ie(2,C.ILogService)],A),e.MenubarMainService=A}),define(ee[273],te([0,1,13,23,25,24,22,3,30,50,34,2,15,9,73,4,33,20,12,7,172,62,18,57,27,16,5,21,6,63,19,64,54,36,74,270,118,265,28,95,75,52,66,37,51]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l,i,s,n,a,r,c,o,S,M,L,B,J,ae,X,Y,re,ne,de,K,le,F,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function V($){return(0,ne.isWorkspaceIdentifier)($?.workspace)}function se($){return(0,ne.isSingleFolderWorkspaceIdentifier)($?.workspace)}let z=class mt extends P.Disposable{constructor(D,O,W,U,q,Q,j,Z,x,oe,ge,Me,Oe,Ce,Le,be,we,ye){super(),this.k=D,this.l=O,this.m=W,this.n=U,this.r=q,this.s=Q,this.t=j,this.u=Z,this.v=x,this.w=oe,this.z=ge,this.C=Me,this.D=Oe,this.F=Ce,this.G=Le,this.H=be,this.I=we,this.J=ye,this.b=this.B(new k.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new k.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new k.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new k.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new re.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.L()}L(){this.B(this.C.onDidEnterWorkspace(D=>this.c.fire(D.window))),this.B(this.onDidSignalReadyWindow(D=>{if(D.config?.extensionDevelopmentPath||D.config?.extensionTestsPath){const O=new P.DisposableStore;if(O.add(k.Event.any(D.onDidClose,D.onDidDestroy)(()=>O.dispose())),D.config.extensionDevelopmentPath)for(const W of D.config.extensionDevelopmentPath)O.add(this.I.addValidFileRoot(W));D.config.extensionTestsPath&&O.add(this.I.addValidFileRoot(D.config.extensionTestsPath))}}))}openEmptyWindow(D,O){const W=this.s.args,U=O?.remoteAuthority||void 0,q=!0,Q=O?.forceReuseWindow,j=!Q;return this.open({...D,cli:W,forceEmpty:q,forceNewWindow:j,forceReuseWindow:Q,remoteAuthority:U})}openExistingWindow(D,O){D.focus(),this.M(O,[D])}async open(D){this.m.trace("windowsManager#open"),D.addMode&&(D.initialStartup||!this.getLastActiveWindow())&&(D.addMode=!1);const O=[],W=[],U=[],q=[],Q=[];let j,Z=0;const x=await this.S(D);this.m.trace("windowsManager#open pathsToOpen",x);for(const Ce of x)se(Ce)?D.addMode?O.push(Ce):W.push(Ce):V(Ce)?U.push(Ce):Ce.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ce.remoteAuthority}),j.filesToOpenOrCreate.push(Ce)):Ce.backupPath?Q.push({backupFolder:(0,f.basename)(Ce.backupPath),remoteAuthority:Ce.remoteAuthority}):Z++;D.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),D.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&D.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:D.waitMarkerFileURI}),D.initialStartup?(q.push(...this.C.getUntitledWorkspaces()),U.push(...q),Q.push(...this.v.getEmptyWindowBackups())):Q.length=0;const{windows:oe,filesOpenedInWindow:ge}=await this.N(D,U,W,Q,Z,j,O);if(this.m.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${U.length}, foldersToOpen: ${W.length}, emptyToRestore: ${Q.length}, emptyToOpen: ${Z})`),oe.length>1)if(ge)ge.focus();else{const Ce=this.j.state.lastActiveWindow&&!D.forceEmpty&&!D.cli._.length&&!D.cli["file-uri"]&&!D.cli["folder-uri"]&&!(D.urisToOpen&&D.urisToOpen.length);let Le=!0,be=!0;if(Ce){const we=oe.filter(ye=>this.j.state.lastActiveWindow&&ye.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Le=!1,be=!1)}if(Le)for(let we=oe.length-1;we>=0;we--){const ye=oe[we];if(!(ye.openedWorkspace&&q.some(De=>ye.openedWorkspace&&De.workspace.id===ye.openedWorkspace.id)||ye.backupPath&&Q.some(De=>ye.backupPath&&De.backupFolder===(0,f.basename)(ye.backupPath)))){ye.focus(),be=!1;break}}be&&oe[oe.length-1].focus()}const Me=j&&j.filesToDiff.length>0,Oe=j&&j.filesToMerge.length>0;if(!oe.some(Ce=>Ce.isExtensionDevelopmentHost)&&!Me&&!Oe&&!D.noRecentEntry){const Ce=[];for(const Le of x)V(Le)&&!Le.transient?Ce.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):se(Le)?Ce.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Ce.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.z.addRecentlyOpened(Ce)}return this.M(D,oe),oe}M(D,O){const W=D.waitMarkerFileURI;D.context===0&&W&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.G.del(W)}catch{}})()}async N(D,O,W,U,q,Q,j){const Z=[];let x;function oe(we,ye){Z.push(we),ye&&(x=we,Q=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Me}=this.fb(D);if(!D.initialStartup&&j.length>0){const we=j[0].remoteAuthority,ye=this.kb(we);ye&&oe(this.P(ye,j.map(De=>De.workspace.uri)))}const Oe=W.length+O.length+U.length;if(Q&&Oe===0){const we=Q.filesToOpenOrCreate[0]||Q.filesToDiff[0]||Q.filesToMerge[3],ye=this.getWindows().filter(_=>Q&&(0,u.isEqualAuthority)(_.remoteAuthority,Q.remoteAuthority));let De;we?.fileUri&&!Me&&((D.context===4||D.context===0||D.context===1)&&(De=await(0,Y.findWindowOnFile)(ye,we.fileUri,async _=>_.configPath.scheme===E.Schemas.file?this.C.resolveLocalWorkspace(_.configPath):void 0)),De||(De=this.lb(ye))),De?(0,ne.isWorkspaceIdentifier)(De.openedWorkspace)?O.push({workspace:De.openedWorkspace,remoteAuthority:De.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(De.openedWorkspace)?W.push({workspace:De.openedWorkspace,remoteAuthority:De.remoteAuthority}):oe(this.O(D,De,Q),!0):oe(await this.gb({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,filesToOpen:Q,forceNewWindow:!0,remoteAuthority:Q.remoteAuthority,forceNewTabbedWindow:D.forceNewTabbedWindow,forceProfile:D.forceProfile,forceTempProfile:D.forceTempProfile}),!0)}const Ce=(0,R.distinct)(O,we=>we.workspace.id);if(Ce.length>0){const we=(0,R.coalesce)(Ce.map(ye=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(we.length>0){const ye=we[0],De=(0,u.isEqualAuthority)(Q?.remoteAuthority,ye.remoteAuthority)?Q:void 0;oe(this.O(D,ye,De),!!De),ge=!0}for(const ye of Ce){if(we.some(he=>he.openedWorkspace&&he.openedWorkspace.id===ye.workspace.id))continue;const De=ye.remoteAuthority,_=(0,u.isEqualAuthority)(Q?.remoteAuthority,De)?Q:void 0;oe(await this.R(D,ye,ge,_),!!_),ge=!0}}const Le=(0,R.distinct)(W,we=>u.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Le.length>0){const we=(0,R.coalesce)(Le.map(ye=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(we.length>0){const ye=we[0],De=(0,u.isEqualAuthority)(Q?.remoteAuthority,ye.remoteAuthority)?Q:void 0;oe(this.O(D,ye,De),!!De),ge=!0}for(const ye of Le){if(we.some(he=>(0,ne.isSingleFolderWorkspaceIdentifier)(he.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(he.openedWorkspace.uri,ye.workspace.uri)))continue;const De=ye.remoteAuthority,_=(0,u.isEqualAuthority)(Q?.remoteAuthority,De)?Q:void 0;oe(await this.R(D,ye,ge,_),!!_),ge=!0}}const be=(0,R.distinct)(U,we=>we.backupFolder);if(be.length>0)for(const we of be){const ye=we.remoteAuthority,De=(0,u.isEqualAuthority)(Q?.remoteAuthority,ye)?Q:void 0;oe(await this.Q(D,!0,ye,De,we),!!De),ge=!0}if(Z.length===0||Q){Q&&!q&&q++;const we=Q?Q.remoteAuthority:D.remoteAuthority;for(let ye=0;ye<q;ye++)oe(await this.Q(D,ge,we,Q),!!Q),ge=!0}return{windows:(0,R.distinct)(Z),filesOpenedInWindow:x}}O(D,O,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),O.focus();const U={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:D?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",A.CancellationToken.None,U),O}P(D,O){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),D.focus();const W={foldersToAdd:O};return D.sendWhenReady("vscode:addFolders",A.CancellationToken.None,W),D}Q(D,O,W,U,q){this.m.trace("windowsManager#doOpenEmpty",{restore:!!q,remoteAuthority:W,filesToOpen:U,forceNewWindow:O});let Q;return!O&&typeof D.contextWindowId=="number"&&(Q=this.getWindowById(D.contextWindowId)),this.gb({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:W,forceNewWindow:O,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:U,windowToUse:Q,emptyWindowBackupInfo:q,forceProfile:D.forceProfile,forceTempProfile:D.forceTempProfile})}R(D,O,W,U,q){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:U}),!W&&!q&&typeof D.contextWindowId=="number"&&(q=this.getWindowById(D.contextWindowId)),this.gb({workspace:O.workspace,userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:U,windowToUse:q,forceProfile:D.forceProfile,forceTempProfile:D.forceTempProfile})}async S(D){let O,W=!1,U=!1;if(D.urisToOpen&&D.urisToOpen.length>0?(O=await this.U(D),W=!0):D.forceEmpty?O=[Object.create(null)]:D.cli._.length||D.cli["folder-uri"]||D.cli["file-uri"]?(O=await this.W(D.cli),O.length===0&&O.push(Object.create(null)),W=!0):(O=await this.Y(),O.length===0&&O.push(Object.create(null)),U=!0),!D.addMode&&W){const q=O.filter(Q=>se(Q));if(q.length>1){const Q=q[0].remoteAuthority;if(q.every(j=>(0,u.isEqualAuthority)(j.remoteAuthority,Q))){const j=await this.C.createUntitledWorkspace(q.map(Z=>({uri:Z.workspace.uri})));O.push({workspace:j,remoteAuthority:Q}),O=O.filter(Z=>!se(Z))}}}if(D.initialStartup&&!U&&this.w.getValue("window")?.restoreWindows==="preserve"){const q=await this.Y();O.unshift(...q.filter(Q=>V(Q)||se(Q)||Q.backupPath))}return O}async U(D){const O={gotoLineMode:D.gotoLineMode,remoteAuthority:D.remoteAuthority},W=await Promise.all((0,R.coalesce)(D.urisToOpen||[]).map(async U=>{const q=await this.ab(U,O);if(q)return q.label=U.label,q;const Q=this.cb(U),j={title:this.H.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,h.localize)(0,null))],defaultId:0,message:Q.scheme===E.Schemas.file?(0,h.localize)(1,null):(0,h.localize)(2,null),detail:Q.scheme===E.Schemas.file?(0,h.localize)(3,null,(0,y.getPathLabel)(Q,{os:d.OS,tildify:this.s})):(0,h.localize)(4,null,Q.toString(!0)),noLink:!0};this.F.showMessageBox(j,(0,v.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(W)}async W(D){const O=[],W={ignoreFileNotFound:!0,gotoLineMode:D.goto,remoteAuthority:D.remote||void 0,forceOpenWorkspaceAsFile:D.diff&&D._.length===2||D.merge&&D._.length===4},U=D["folder-uri"];if(U){const j=await Promise.all(U.map(Z=>{const x=this.X(Z);if(!!x)return this.ab({folderUri:x},W)}));O.push(...(0,R.coalesce)(j))}const q=D["file-uri"];if(q){const j=await Promise.all(q.map(Z=>{const x=this.X(Z);if(!!x)return this.ab((0,ne.hasWorkspaceFileExtension)(Z)?{workspaceUri:x}:{fileUri:x},W)}));O.push(...(0,R.coalesce)(j))}const Q=await Promise.all(D._.map(j=>W.remoteAuthority?this.eb(j,W):this.db(j,W)));return O.push(...(0,R.coalesce)(Q)),O}X(D){try{const O=g.URI.parse(D);if(!O.scheme){this.m.error(`Invalid URI input string, scheme missing: ${D}`);return}return O}catch(O){this.m.error(`Invalid URI input string: ${D}, ${O.message}`)}}async Y(){const D=this.Z();switch(D){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];D!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const W=await Promise.all(O.map(async U=>{if(U.workspace){const q=await this.ab({workspaceUri:U.workspace.configPath},{remoteAuthority:U.remoteAuthority,rejectTransientWorkspaces:!0});if(V(q))return q}else if(U.folderUri){const q=await this.ab({folderUri:U.folderUri},{remoteAuthority:U.remoteAuthority});if(se(q))return q}else if(D!=="folders"&&U.backupPath)return{backupPath:U.backupPath,remoteAuthority:U.remoteAuthority}}));return(0,R.coalesce)(W)}}}Z(){let D;return this.u.wasRestarted?D="all":(D=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(D)||(D="all")),D}async ab(D,O=Object.create(null)){const W=this.cb(D);return W.scheme===E.Schemas.file?((0,ae.isFileToOpen)(D)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.db(W.fsPath,O)):this.bb(D,O)}bb(D,O){let W=this.cb(D);const U=(0,B.getRemoteAuthority)(W)||O.remoteAuthority;if(W=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(W)),(0,ae.isFileToOpen)(D)){if(O.gotoLineMode){const{path:q,line:Q,column:j}=(0,p.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:q}),options:{selection:Q?{startLineNumber:Q,startColumn:j||1}:void 0},remoteAuthority:U}}return{fileUri:W,remoteAuthority:U}}else if((0,ae.isWorkspaceToOpen)(D))return{workspace:(0,de.getWorkspaceIdentifier)(W),remoteAuthority:U};return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:U}}cb(D){return(0,ae.isWorkspaceToOpen)(D)?D.workspaceUri:(0,ae.isFolderToOpen)(D)?D.folderUri:D.fileUri}async db(D,O){let W,U;O.gotoLineMode&&({path:D,line:W,column:U}=(0,p.parseLineAndColumnAware)(D)),D=(0,p.sanitizeFilePath)((0,f.normalize)(D),(0,b.cwd)());try{const q=await t.Promises.stat(D);if(q.isFile()){if(!O.forceOpenWorkspaceAsFile){const Q=await this.C.resolveLocalWorkspace(g.URI.file(D));if(Q)return Q.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:Q.id,configPath:Q.configPath},type:a.FileType.File,exists:!0,remoteAuthority:Q.remoteAuthority,transient:Q.transient}}return{fileUri:g.URI.file(D),type:a.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:U||1}:void 0}}}else{if(q.isDirectory())return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(g.URI.file(D),q),type:a.FileType.Directory,exists:!0};if(!d.isWindows&&D==="/dev/null")return{fileUri:g.URI.file(D),type:a.FileType.File,exists:!0}}}catch{const Q=g.URI.file(D);if(this.z.removeRecentlyOpened([Q]),O.ignoreFileNotFound)return{fileUri:Q,type:a.FileType.File,exists:!1}}}eb(D,O){const W=D.charCodeAt(0),U=O.remoteAuthority;let q,Q;O.gotoLineMode&&({path:D,line:q,column:Q}=(0,p.parseLineAndColumnAware)(D)),W!==47&&((0,p.isWindowsDriveLetter)(W)&&D.charCodeAt(D.charCodeAt(1))===58&&(D=(0,p.toSlashes)(D)),D=`/${D}`);const j=g.URI.from({scheme:E.Schemas.vscodeRemote,authority:U,path:D});if(D.charCodeAt(D.length-1)!==47){if((0,ne.hasWorkspaceFileExtension)(D))return O.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:q?{startLineNumber:q,startColumn:Q||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,de.getWorkspaceIdentifier)(j),remoteAuthority:U};if(O.gotoLineMode||f.posix.basename(D).indexOf(".")!==-1)return{fileUri:j,options:{selection:q?{startLineNumber:q,startColumn:Q||1}:void 0},remoteAuthority:U}}return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:U}}fb(D){const O=this.w.getValue("window"),W=O?.openFoldersInNewWindow||"default",U=O?.openFilesInNewWindow||"off";let q=(D.preferNewWindow||D.forceNewWindow)&&!D.forceReuseWindow;!D.forceNewWindow&&!D.forceReuseWindow&&(W==="on"||W==="off")&&(q=W==="on");let Q=!1;return D.forceNewWindow||D.forceReuseWindow?Q=!!D.forceNewWindow&&!D.forceReuseWindow:(d.isMacintosh?D.context===1&&(Q=!0):D.context!==3&&D.context!==2&&!(D.userEnv&&D.userEnv.TERM_PROGRAM==="vscode")&&(Q=!0),!D.cli.extensionDevelopmentPath&&(U==="on"||U==="off")&&(Q=U==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:Q}}async openExtensionDevelopmentHostWindow(D,O){const W=(0,Y.findWindowOnExtensionDevelopmentPath)(this.getWindows(),D);if(W)return this.u.reload(W,O.cli),W.focus(),[W];let U=O.cli["folder-uri"]||[],q=O.cli["file-uri"]||[],Q=O.cli._;if(!Q.length&&!U.length&&!q.length&&!O.cli.extensionTestsPath){const x=this.j.state.lastPluginDevelopmentHostWindow,oe=x?.workspace??x?.folderUri;oe&&(g.URI.isUri(oe)?oe.scheme===E.Schemas.file?Q=[oe.fsPath]:U=[oe.toString()]:oe.configPath.scheme===E.Schemas.file?Q=[(0,u.originalFSPath)(oe.configPath)]:q=[oe.configPath.toString()])}let j=O.remoteAuthority;for(const x of D)if(x.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const oe=g.URI.parse(x),ge=(0,B.getRemoteAuthority)(oe);ge&&(j?(0,u.isEqualAuthority)(ge,j)||this.m.error("more than one extension development path authority"):j=ge)}Q=Q.filter(x=>{const oe=g.URI.file(x);return(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:(0,u.isEqualAuthority)((0,B.getRemoteAuthority)(oe),j)}),U=U.filter(x=>{const oe=this.X(x);return oe&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,B.getRemoteAuthority)(oe),j):!1}),q=q.filter(x=>{const oe=this.X(x);return oe&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,B.getRemoteAuthority)(oe),j):!1}),O.cli._=Q,O.cli["folder-uri"]=U,O.cli["file-uri"]=q;const Z={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!Q.length&&!U.length&&!q.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:j,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(Z)}async gb(D){const O=this.w.getValue("window");let W;!D.forceNewWindow&&!D.forceNewTabbedWindow&&(W=D.windowToUse||this.getLastActiveWindow(),W&&W.focus());const U={...this.s.args,...D.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:D.emptyWindowBackupInfo?(0,f.join)(this.s.backupHome,D.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:W?.isExtensionDevelopmentHost&&W?.profile?W.profile:await this.ib(D)},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:D.remoteAuthority,workspace:D.workspace,userEnv:{...this.l,...D.userEnv},filesToOpenOrCreate:D.filesToOpen?.filesToOpenOrCreate,filesToDiff:D.filesToOpen?.filesToDiff,filesToMerge:D.filesToOpen?.filesToMerge,filesToWait:D.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:S.default,isInitialStartup:D.initialStartup,perfMarks:(0,w.getMarks)(),os:{release:(0,C.release)(),hostname:(0,C.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};if(W){const q=W.config;!U.extensionDevelopmentPath&&q?.extensionDevelopmentPath&&(U.extensionDevelopmentPath=q.extensionDevelopmentPath,U.extensionDevelopmentKind=q.extensionDevelopmentKind,U["enable-proposed-api"]=q["enable-proposed-api"],U.verbose=q.verbose,U["inspect-extensions"]=q["inspect-extensions"],U["inspect-brk-extensions"]=q["inspect-brk-extensions"],U.debugId=q.debugId,U.extensionEnvironment=q.extensionEnvironment,U["extensions-dir"]=q["extensions-dir"],U["disable-extensions"]=q["disable-extensions"])}else{const q=this.j.getNewWindowState(U);(0,w.mark)("code/willCreateCodeWindow");const Q=W=this.D.createInstance(X.CodeWindow,{state:q,extensionDevelopmentPath:U.extensionDevelopmentPath,isExtensionTestHost:!!U.extensionTestsPath});(0,w.mark)("code/didCreateCodeWindow"),D.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(Q),mt.a.push(Q),this.b.fire(Q),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(Q.onDidSignalReady)(()=>this.c.fire(Q)),(0,m.once)(Q.onDidClose)(()=>this.jb(Q)),(0,m.once)(Q.onDidDestroy)(()=>this.f.fire(Q)),Q.onDidTriggerSystemContextMenu(({x:Z,y:x})=>this.h.fire({window:Q,x:Z,y:x}));const j=(0,v.assertIsDefined)(Q.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.u.reload(Q)),this.u.registerWindow(Q)}return U.windowId=W.id,W.isReady?this.u.unload(W,4).then(q=>{q||this.hb(W,U,D)}):this.hb(W,U,D),W}hb(D,O,W){O.extensionDevelopmentPath||((0,ne.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.v.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,de.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),D.load(O)}async ib(D){let O;return this.t.isEnabled()&&(D.forceProfile?O=this.t.profiles.find(W=>W.name===D.forceProfile)??await this.t.createNamedProfile(D.forceProfile):D.forceTempProfile&&(O=await this.t.createTransientProfile())),O?D.cli?.extensionDevelopmentPath||this.t.setProfileForWorkspaceSync(D.workspace??"empty-window",O):O=this.t.getOrSetProfileForWorkspace(D.workspace??"empty-window",(D.windowToUse??this.getLastActiveWindow())?.profile??this.t.defaultProfile),O}jb(D){const O=mt.a.indexOf(D);mt.a.splice(O,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const D=I.BrowserWindow.getFocusedWindow();if(D)return this.getWindowById(D.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(D){return this.lb(this.getWindows().filter(O=>(0,u.isEqualAuthority)(O.remoteAuthority,D)))}lb(D){const O=Math.max.apply(Math,D.map(W=>W.lastFocusTime));return D.find(W=>W.lastFocusTime===O)}sendToFocused(D,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(D,A.CancellationToken.None,...O)}sendToAll(D,O,W){for(const U of this.getWindows())W&&W.indexOf(U.id)>=0||U.sendWhenReady(D,A.CancellationToken.None,O)}getWindows(){return mt.a}getWindowCount(){return mt.a.length}getWindowById(D){const O=this.getWindows().filter(W=>W.id===D);return(0,R.firstOrDefault)(O)}getWindowByWebContents(D){const O=I.BrowserWindow.fromWebContents(D);if(!!O)return this.getWindowById(O.id)}};z.a=[],z=pe([ie(2,o.ILogService),ie(3,J.IStateMainService),ie(4,T.IPolicyService),ie(5,n.IEnvironmentMainService),ie(6,N.IUserDataProfilesMainService),ie(7,c.ILifecycleMainService),ie(8,l.IBackupMainService),ie(9,i.IConfigurationService),ie(10,K.IWorkspacesHistoryMainService),ie(11,le.IWorkspacesManagementMainService),ie(12,r.IInstantiationService),ie(13,s.IDialogMainService),ie(14,a.IFileService),ie(15,M.IProductService),ie(16,L.IProtocolMainService),ie(17,F.IThemeMainService)],z),e.WindowsMainService=z}),define(ee[274],te([0,1,62,32,75,52]),function(H,e,I,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let A=class{constructor(p,m,y,P){this.a=p,this.b=m,this.c=y,this.d=P,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(p,m){const y=this.b.getWindowById(p);if(y)return this.a.enterWorkspace(y,this.b.getWindows(),m)}createUntitledWorkspace(p,m,y){return this.a.createUntitledWorkspace(m,y)}deleteUntitledWorkspace(p,m){return this.a.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(p,m){return this.a.getWorkspaceIdentifier(m)}getRecentlyOpened(p){return this.c.getRecentlyOpened()}addRecentlyOpened(p,m){return this.c.addRecentlyOpened(m)}removeRecentlyOpened(p,m){return this.c.removeRecentlyOpened(m)}clearRecentlyOpened(p){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};A=pe([ie(0,R.IWorkspacesManagementMainService),ie(1,t.IWindowsMainService),ie(2,C.IWorkspacesHistoryMainService),ie(3,I.IBackupMainService)],A),e.WorkspacesMainService=A}),define(ee[275],te([0,1,13,41,25,17,45,14,30,50,43,34,2,15,9,4,12,7,29,131,47,145,103,251,148,62,266,18,71,180,84,119,57,106,203,27,61,111,193,215,194,253,107,195,196,16,207,86,70,5,85,267,228,254,21,6,209,272,58,19,54,260,88,36,257,93,89,31,233,112,56,49,242,243,268,244,269,115,246,247,248,249,255,32,273,256,28,94,75,274,52,252,37,214,51,224,55,91,117,258,264,262,8,113]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l,i,s,n,a,r,c,o,S,M,L,B,J,ae,X,Y,re,ne,de,K,le,F,T,N,V,se,z,$,D,O,W,U,q,Q,j,Z,x,oe,ge,Me,Oe,Ce,Le,be,we,ye,De,_,he,fe,ve,Pe,We,Te,qe,Ue,Be,Xe,$e,Ke,G,ce,ue,me,Se,Ae,je,it,xe,He,tt,nt,lt,at,jt,$t,Wt,zt,qt,Ht,Vt,Pt,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let kt=class extends E.Disposable{constructor(Ee,ke,Re,Ie,Fe,ze,_e,et,Ne,Ge,Je){super(),this.c=Ee,this.f=ke,this.g=Re,this.h=Ie,this.i=Fe,this.j=ze,this.k=_e,this.l=et,this.m=Ne,this.n=Ge,this.p=Je,this.r(),this.s()}r(){const Ee=Ne=>Ne?.startsWith(`${f.Schemas.vscodeWebview}://`),ke=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Je(ke.has(Ge)):Je(!1)),I.session.defaultSession.setPermissionCheckHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?ke.has(Ge):!1);const Re=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Ie=Ne=>{for(let Ge=Ne;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ne=>Ne.resourceType==="xhr"||Ie(Ne.frame),ze=Ne=>{const Ge=Ne.frame;if(!Ge||!this.a)return!1;const Je=I.BrowserWindow.getAllWindows();for(const Ze of Je)if(Ge.processId===Ze.webContents.mainFrame.processId)return!0;return!1},_e=(Ne,Ge)=>{if(Ne.path!=="/index.html")return!0;const Je=Ge.frame;if(!Je||!this.a)return!1;for(const Ze of this.a.getWindows())if(Ze.win&&Je.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((Ne,Ge)=>{const Je=u.URI.parse(Ne.url);return Je.scheme===f.Schemas.vscodeWebview&&!_e(Je,Ne)?(this.h.error("Blocked vscode-webview request",Ne.url),Ge({cancel:!0})):Je.scheme===f.Schemas.vscodeFileResource&&!ze(Ne)?(this.h.error("Blocked vscode-file request",Ne.url),Ge({cancel:!0})):Je.path.endsWith(".svg")&&!Re.has(Je.scheme)?Ge({cancel:!Fe(Ne)}):Ge({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((Ne,Ge)=>{const Je=Ne.responseHeaders,Ze=Je["content-type"]||Je["Content-Type"];if(Ze&&Array.isArray(Ze)){const st=u.URI.parse(Ne.url);if(st.path.endsWith(".svg")&&Re.has(st.scheme))return Je["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Je});if(!st.path.endsWith(f.Schemas.vscodeRemoteResource)&&Ze.some(ct=>ct.toLowerCase().includes("image/svg")))return Ge({cancel:!Fe(Ne)})}return Ge({cancel:!1})});const et=I.session.defaultSession;typeof et.setCodeCachePath=="function"&&this.i.codeCachePath&&et.setCodeCachePath((0,w.join)(this.i.codeCachePath,"chrome"))}s(){(0,k.setUnexpectedErrorHandler)(Re=>this.u(Re)),process.on("uncaughtException",Re=>(0,k.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,k.onUnexpectedError)(Re)),this.j.onWillShutdown(()=>this.dispose()),(0,g.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(Re,Ie)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),I.app.on("activate",async(Re,Ie)=>{this.h.trace("app#activate"),Ie||await this.a?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(Re,Ie)=>{Ie.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ie.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],ke;I.app.on("open-file",(Re,Ie)=>{this.h.trace("app#open-file: ",Ie),Re.preventDefault(),Ee.push((0,Ae.hasWorkspaceFileExtension)(Ie)?{workspaceUri:u.URI.file(Ie)}:{fileUri:u.URI.file(Ie)}),ke!==void 0&&(clearTimeout(ke),ke=void 0),ke=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],ke=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Ie=this.a?.getWindowByWebContents(Re.sender);let Fe,ze;return Ie?.config?(Fe=Ie.config,ze={...process.env,...Ie.config.userEnv}):(Fe=this.i.args,ze=process.env),this.J(Fe,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Ie,Fe)=>{const ze=this.t([Ie]);if(!ze||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(ze,R.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Ie)=>{const Fe=this.t(Ie);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}t(Ee){let ke;for(const Re of Ee)typeof Re=="string"&&(typeof ke!="string"?ke=Re:ke=(0,w.join)(ke,Re));if(!(typeof ke!="string"||!(0,w.isAbsolute)(ke)||!(0,p.isEqualOrParent)(ke,this.i.cachedLanguagesPath,!d.isLinux)))return u.URI.file(ke)}u(Ee){if(Ee){const ke={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(ke))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;d.isWindows&&Ee&&I.app.setAppUserModelId(Ee);try{d.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const ke=new l.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&ke.dispose()}),this.h.trace("Resolving machine identifier...");const Re=await(0,Gt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Ie,sharedProcessReady:Fe,sharedProcessClient:ze}=this.w(Re),_e=await this.y(Re,Ie,Fe);this.v(_e),_e.invokeFunction(Ne=>this.z(Ne,ke,ze)),await _e.invokeFunction(Ne=>this.C(Ne,ke)),_e.invokeFunction(Ne=>this.G(Ne,Ie)),this.B(new Pt.RunOnceScheduler(()=>{this.B((0,Pt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(s.ProxyAuthHandler)),this.B(Ee.createInstance(Ht.UserDataTransientProfilesHandler))}w(Ee){const ke=this.B(this.g.createInstance(Oe.SharedProcess,Ee,this.f)),Re=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await ke.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new i.Client(Fe,"main")})(),Ie=(async()=>(await ke.whenReady(),Re))();return{sharedProcess:ke,sharedProcessReady:Ie,sharedProcessClient:Re}}async y(Ee,ke,Re){const Ie=new O.ServiceCollection;switch(process.platform){case"win32":Ie.set(ve.IUpdateService,new $.SyncDescriptor(Ue.Win32UpdateService));break;case"linux":d.isLinuxSnap?Ie.set(ve.IUpdateService,new $.SyncDescriptor(qe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(ve.IUpdateService,new $.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Ie.set(ve.IUpdateService,new $.SyncDescriptor(We.DarwinUpdateService));break}Ie.set(ue.IWindowsMainService,new $.SyncDescriptor(me.WindowsMainService,[Ee,this.f],!1));const Fe=new B.DialogMainService(this.h);Ie.set(B.IDialogMainService,Fe),Ie.set(q.ILaunchMainService,new $.SyncDescriptor(q.LaunchMainService,void 0,!1)),Ie.set(L.IDiagnosticsMainService,new $.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Ie.set(M.IDiagnosticsService,h.ProxyChannel.toService((0,h.getDelayedChannel)(Re.then(et=>et.getChannel("diagnostics"))))),Ie.set(W.IIssueMainService,new $.SyncDescriptor(W.IssueMainService,[this.f])),Ie.set(J.IEncryptionMainService,new $.SyncDescriptor(ae.EncryptionMainService,[Ee])),Ie.set(U.IKeyboardLayoutMainService,new $.SyncDescriptor(U.KeyboardLayoutMainService)),Ie.set(oe.INativeHostMainService,new $.SyncDescriptor(oe.NativeHostMainService,[ke],!1)),Ie.set(o.ICredentialsMainService,new $.SyncDescriptor(tt.CredentialsNativeMainService)),Ie.set(G.IWebviewManagerService,new $.SyncDescriptor(ce.WebviewMainService)),Ie.set(x.IMenubarMainService,new $.SyncDescriptor(x.MenubarMainService)),Ie.set(ne.IExtensionUrlTrustService,new $.SyncDescriptor(de.ExtensionUrlTrustService)),Ie.set(K.IExtensionHostStarter,new $.SyncDescriptor(le.ExtensionHostStarter)),Ie.set(we.IStorageMainService,new $.SyncDescriptor(we.StorageMainService)),Ie.set(we.IApplicationStorageMainService,new $.SyncDescriptor(we.ApplicationStorageMainService)),d.isWindows?Ie.set(F.IExternalTerminalMainService,new $.SyncDescriptor(T.WindowsExternalTerminalService)):d.isMacintosh?Ie.set(F.IExternalTerminalMainService,new $.SyncDescriptor(T.MacExternalTerminalService)):d.isLinux&&Ie.set(F.IExternalTerminalMainService,new $.SyncDescriptor(T.LinuxExternalTerminalService));const ze=new r.BackupMainService(this.i,this.k,this.h,this.l);Ie.set(a.IBackupMainService,ze);const _e=new He.WorkspacesManagementMainService(this.i,this.h,this.p,ze,Fe,this.n);if(Ie.set(He.IWorkspacesManagementMainService,_e),Ie.set(je.IWorkspacesService,new $.SyncDescriptor(xe.WorkspacesMainService,void 0,!1)),Ie.set(it.IWorkspacesHistoryMainService,new $.SyncDescriptor(it.WorkspacesHistoryMainService,void 0,!1)),Ie.set(Be.IURLService,new $.SyncDescriptor($e.NativeURLService,void 0,!1)),(0,fe.supportsTelemetry)(this.n,this.i)){const et=(0,fe.isInternalTelemetry)(this.n,this.k),Ne=(0,h.getDelayedChannel)(Re.then(ct=>ct.getChannel("telemetryAppender"))),Ge=new _.TelemetryAppenderClient(Ne),Je=(0,ye.resolveCommonProperties)(this.m,(0,C.release)(),(0,C.hostname)(),process.arch,this.n.commit,this.n.version,Ee,et,this.i.installSourcePath),Ze=(0,fe.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Je,piiPaths:Ze,sendErrorTelemetry:!0};Ie.set(De.ITelemetryService,new $.SyncDescriptor(he.TelemetryService,[st],!1))}else Ie.set(De.ITelemetryService,fe.NullTelemetryService);return Ie.set(Wt.IExtensionsProfileScannerService,new $.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),Ie.set(zt.IExtensionsScannerService,new $.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await Pt.Promises.settled([ze.initialize(),_e.initialize()]),this.g.createChild(Ie)}z(Ee,ke,Re){const Ie=h.ProxyChannel.fromService(Ee.get(q.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ie);const Fe=h.ProxyChannel.fromService(Ee.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const ze=new lt.PolicyChannel(Ee.get(nt.IPolicyService));ke.registerChannel("policy",ze),Re.then(Ye=>Ye.registerChannel("policy",ze));const _e=this.m.getProvider(f.Schemas.file);(0,b.assertType)(_e instanceof z.DiskFileSystemProvider);const et=new se.DiskFileSystemProviderChannel(_e,this.h,this.i);ke.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et),Re.then(Ye=>Ye.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et));const Ne=h.ProxyChannel.fromService(Ee.get(at.IUserDataProfilesMainService));ke.registerChannel("userDataProfiles",Ne),Re.then(Ye=>Ye.registerChannel("userDataProfiles",Ne));const Ge=new jt.RequestChannel(Ee.get($t.IRequestService));Re.then(Ye=>Ye.registerChannel("request",Ge));const Je=new Pe.UpdateChannel(Ee.get(ve.IUpdateService));ke.registerChannel("update",Je);const Ze=h.ProxyChannel.fromService(Ee.get(W.IIssueMainService));ke.registerChannel("issue",Ze);const st=h.ProxyChannel.fromService(Ee.get(J.IEncryptionMainService));ke.registerChannel("encryption",st);const ct=h.ProxyChannel.fromService(Ee.get(o.ICredentialsMainService));ke.registerChannel("credentials",ct);const Ct=h.ProxyChannel.fromService(Ee.get(Ce.ISignService));ke.registerChannel("sign",Ct);const Qe=h.ProxyChannel.fromService(Ee.get(U.IKeyboardLayoutMainService));ke.registerChannel("keyboardLayout",Qe),this.b=Ee.get(oe.INativeHostMainService);const wt=h.ProxyChannel.fromService(this.b);ke.registerChannel("nativeHost",wt),Re.then(Ye=>Ye.registerChannel("nativeHost",wt));const pt=h.ProxyChannel.fromService(Ee.get(je.IWorkspacesService));ke.registerChannel("workspaces",pt);const yt=h.ProxyChannel.fromService(Ee.get(x.IMenubarMainService));ke.registerChannel("menubar",yt);const Dt=h.ProxyChannel.fromService(Ee.get(Be.IURLService));ke.registerChannel("url",Dt);const Mt=h.ProxyChannel.fromService(Ee.get(ne.IExtensionUrlTrustService));ke.registerChannel("extensionUrlTrust",Mt);const bt=h.ProxyChannel.fromService(Ee.get(G.IWebviewManagerService));ke.registerChannel("webview",bt);const ut=this.B(new be.StorageDatabaseChannel(this.h,Ee.get(we.IStorageMainService)));ke.registerChannel("storage",ut),Re.then(Ye=>Ye.registerChannel("storage",ut));const St=this.B(new Vt.ProfileStorageChangesListenerChannel(Ee.get(we.IStorageMainService),Ee.get(at.IUserDataProfilesMainService),this.h));Re.then(Ye=>Ye.registerChannel("profileStorageListener",St));const vt=h.ProxyChannel.fromService(Ee.get(F.IExternalTerminalMainService));ke.registerChannel("externalTerminal",vt);const ht=new Z.LogLevelChannel(Ee.get(j.ILogService),Ee.get(j.ILoggerService));ke.registerChannel("logLevel",ht),Re.then(Ye=>Ye.registerChannel("logLevel",ht));const Ve=new Z.LoggerChannel(Ee.get(j.ILoggerService));ke.registerChannel("logger",Ve),Re.then(Ye=>Ye.registerChannel("logger",Ve));const ot=new S.ElectronExtensionHostDebugBroadcastChannel(Ee.get(ue.IWindowsMainService));ke.registerChannel("extensionhostdebugservice",ot);const ft=h.ProxyChannel.fromService(Ee.get(K.IExtensionHostStarter));ke.registerChannel(K.ipcExtensionHostStarterChannelName,ft)}async C(Ee,ke){const Re=this.a=Ee.get(ue.IWindowsMainService),Ie=Ee.get(Be.IURLService),Fe=Ee.get(oe.INativeHostMainService);this.j.phase=2;const ze=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ve=>{try{return{uri:u.URI.parse(Ve),url:Ve}}catch{return}}).filter(Ve=>{if(!Ve||this.D(Ve.uri))return!1;const ot=this.F(Ve.uri);return ot?(ze.push(ot),!1):!0}),et=this,Ne=this.i,Ge=this.n,Je=this.h;Ie.registerHandler({async handleURL(Ve,ot){if(Je.trace("app#handleURL: ",Ve.toString(!0),ot),Ve.scheme===Ge.urlProtocol&&Ve.path==="workspace"&&(Ve=Ve.with({authority:"file",path:u.URI.parse(Ve.query).path,query:""})),et.D(Ve))return!0;let ft=!1;const Ye=new URLSearchParams(Ve.query);Ye.get("windowId")==="_blank"&&(Ye.delete("windowId"),Ve=Ve.with({query:Ye.toString()}),ft=!0),ft||=d.isMacintosh&&Re.getWindowCount()===0;const Ut=Ye.get("continueOn");Ut!==null&&(Ne.continueOn=Ut??void 0,Ye.delete("continueOn"),Ve=Ve.with({query:Ye.toString()}));const Rt=et.F(Ve);if(Je.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[At]=await Re.open({context:5,cli:{...Ne.args},urisToOpen:[Rt],forceNewWindow:ft,gotoLineMode:!0});return At.focus(),!0}if(ft){const[At]=await Re.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Me.getRemoteAuthority)(Ve)});return await At.ready(),Ie.open(Ve,ot)}return!1}});const Ze=this.B(new Se.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new h.StaticRouter(Ve=>Ze.getActiveClientId().then(ot=>Ve===ot)),ct=new Xe.URLHandlerRouter(st),Ct=ke.getChannel("urlHandler",ct);Ie.registerHandler(new Xe.URLHandlerChannelClient(Ct)),this.B(new Ke.ElectronURLListener(_e,Ie,Re,this.i,this.n));const Qe=this.i.args,wt=global.macOpenFiles,pt=(0,Y.isLaunchedFromCli)(process.env)?0:4,yt=Qe._.length,Dt=!!Qe["folder-uri"],Mt=!!Qe["file-uri"],bt=Qe["skip-add-to-recently-opened"]===!0,ut=Qe.wait&&Qe.waitMarkerFilePath?u.URI.file(Qe.waitMarkerFilePath):void 0,St=Qe.remote||void 0,vt=Qe.profile,ht=Qe["profile-temp"];if(ze.length>0)return Re.open({context:pt,cli:Qe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});if(!yt&&!Dt&&!Mt){if(Qe["new-window"]||vt||ht)return Re.open({context:pt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:bt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:St,forceProfile:vt,forceTempProfile:ht});if(wt.length)return Re.open({context:1,cli:Qe,urisToOpen:wt.map(Ve=>(0,Ae.hasWorkspaceFileExtension)(Ve)?{workspaceUri:u.URI.file(Ve)}:{fileUri:u.URI.file(Ve)}),noRecentEntry:bt,waitMarkerFileURI:ut,initialStartup:!0})}return Re.open({context:pt,cli:Qe,forceNewWindow:Qe["new-window"]||!yt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:bt,waitMarkerFileURI:ut,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:St,forceProfile:vt,forceTempProfile:ht})}D(Ee){return!!(Ee.authority===f.Schemas.file&&d.isWindows&&I.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,P.mnemonicButtonLabel)((0,n.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,n.localize)(1,null))],defaultId:0,cancelId:1,message:(0,n.localize)(2,null,(0,P.getPathLabel)(Ee,{os:d.OS,tildify:this.i}),this.n.nameShort),detail:(0,n.localize)(3,null),noLink:!0})===1)}F(Ee){if(!!Ee.path){if(Ee.authority===f.Schemas.file){const ke=u.URI.file(Ee.fsPath);return(0,Ae.hasWorkspaceFileExtension)(ke)?{workspaceUri:ke}:{fileUri:ke}}else if(Ee.authority===f.Schemas.vscodeRemote){const ke=Ee.path.indexOf(w.posix.sep,1);if(ke!==-1){const Re=Ee.path.substring(1,ke),Ie=Ee.path.substring(ke),Fe=u.URI.from({scheme:f.Schemas.vscodeRemote,authority:Re,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,Ae.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Fe}:/:[\d]+$/.test(Ie)?{fileUri:Fe}:{folderUri:Fe}}}}}G(Ee,ke){const Re=Ee.get(De.ITelemetryService),Ie=Ee.get(ve.IUpdateService);this.j.phase=3,this.I(Re,ke),this.H(),I.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(Fe,ze)=>{ze({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ie instanceof Ue.Win32UpdateService||Ie instanceof Te.LinuxUpdateService||Ie instanceof We.DarwinUpdateService)&&Ie.initialize(),this.J(this.i.args,process.env,!0),this.L()}async H(){const Ee=this.n.win32MutexName;if(d.isWindows&&Ee)try{const ke=await new Promise((Ie,Fe)=>{H(["windows-mutex"],Ie,Fe)}),Re=new ke.Mutex(Ee);(0,m.once)(this.j.onWillShutdown)(()=>Re.release())}catch(ke){this.h.error(ke)}}I(Ee,ke){let Re=!1;(0,m.once)(this.j.onWillShutdown)(()=>Re=!0),this.B(ke.onDidError(({type:Ie,details:Fe})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,k.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Ie,reason:Fe?.reason,code:Fe?.exitCode,visible:ke.isVisible(),shuttingdown:Re})}))}async J(Ee,ke,Re){try{return await(0,re.getResolvedShellEnv)(this.h,Ee,ke)}catch(Ie){const Fe=(0,A.toErrorMessage)(Ie);Re?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async L(){try{const ke=(await this.m.readFile(this.i.argvResource)).value.toString(),Re=JSON.parse((0,y.stripComments)(ke)),Fe=(0,fe.getTelemetryLevel)(this.k)>=1;if(Re["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],_e=ke.substring(0,ke.length-2).concat(`,
`,ze.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(_e))}else{const ze=ke.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);ze!==ke&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(ze))}}catch(Ee){this.h.error(Ee)}}};kt=pe([ie(2,D.IInstantiationService),ie(3,j.ILogService),ie(4,X.IEnvironmentMainService),ie(5,Q.ILifecycleMainService),ie(6,c.IConfigurationService),ie(7,Le.IStateMainService),ie(8,V.IFileService),ie(9,ge.IProductService),ie(10,at.IUserDataProfilesMainService)],kt),e.CodeApplication=kt}),define(ee[276],te([0,1,37,8,284,2,6]),function(H,e,I,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends I.AbstractPolicyService{constructor(m,y){super(),this.j=m,this.k=y,this.a=new t.Throttler,this.b=this.B(new R.MutableDisposable)}async i(m){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(m).length} policy definitions`),await this.a.queue(()=>new Promise((y,P)=>{try{this.b.value=(0,C.createWatcher)(this.k,m,E=>{this.m(E),y()})}catch(E){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",E),P(E)}}))}m(m){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(m)}`);for(const y in m){const P=m[y];P===void 0?this.g.delete(y):this.g.set(y,P)}this.h.fire(Object.keys(m))}};k=pe([ie(0,A.ILogService)],k),e.NativePolicyService=k}),define(ee[277],te([0,1,226,8,17,14,2,12,18,35,111,6,225,285]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends A.Disposable{constructor(b,u,v){super(),this.h=u,this.i=v,this.j(b.getValue()),this.B(b.onDidChangeConfiguration(()=>this.j(b.getValue()),this))}j(b){this.a=b.http&&b.http.proxy,this.b=!!(b.http&&b.http.proxyStrictSSL),this.f=b.http&&b.http.proxyAuthorization}async request(b,u){this.i.trace("RequestService#request (node) - begin",b.url);const{a:v,b:g}=this;let h;try{h=await(0,y.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(s){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",s))}const l={...process.env,...h},i=b.agent?b.agent:await(0,E.getProxyAgent)(b.url||"",l,{proxyUrl:v,strictSSL:g});b.agent=i,b.strictSSL=g,this.f&&(b.headers={...b.headers||{},"Proxy-Authorization":this.f});try{const s=await this.l(b,u);return this.i.trace("RequestService#request (node) - success",b.url),s}catch(s){throw this.i.trace("RequestService#request (node) - error",b.url,s),s}}async k(b){return((0,I.parse)(b.url).protocol==="https:"?await new Promise((g,h)=>{H(["https"],g,h)}):await new Promise((g,h)=>{H(["http"],g,h)})).request}l(b,u){return t.Promises.withAsyncBody(async(v,g)=>{const h=(0,I.parse)(b.url),l=b.getRawRequest?b.getRawRequest(b):await this.k(b),i={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,k.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(i.auth=b.user+":"+b.password);const s=l(i,n=>{const a=(0,k.isNumber)(b.followRedirects)?b.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&a>0&&n.headers.location)this.l({...b,url:n.headers.location,followRedirects:a-1},u).then(v,g);else{let r=n;!b.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,f.createGunzip)())),v({res:n,stream:(0,C.streamToBufferReadableStream)(r)})}});s.on("error",g),b.timeout&&s.setTimeout(b.timeout),b.isChromiumNetwork&&s.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&s.write(b.data),s.end(),u.onCancellationRequested(()=>{s.abort(),g(new R.CancellationError)})})}async resolveProxy(b){}};w=pe([ie(0,p.IConfigurationService),ie(1,m.INativeEnvironmentService),ie(2,P.ILogService)],w),e.RequestService=w}),define(ee[278],te([0,1,13,277]),function(H,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function C(A){return I.net.request}class R extends t.RequestService{request(k,p){return super.request({...k||{},getRawRequest:C,isChromiumNetwork:!0},p)}}e.RequestMainService=R}),define(ee[286],te([0,1,13,40,7,24,8,45,14,30,50,34,15,9,73,4,33,26,23,47,83,275,10,18,219,232,27,61,184,16,205,86,70,201,85,21,208,6,211,63,19,64,259,114,240,55,278,88,227,36,231,56,66,51,37,276,213,2,42,245,38,241]),function(H,e,I,t,C,R,A,k,p,m,y,P,E,f,w,d,b,u,v,g,h,l,i,s,n,a,r,c,o,S,M,L,B,J,ae,X,Y,re,ne,de,K,le,F,T,N,V,se,z,$,D,O,W,U,q,Q,j,Z,x,oe,ge,Me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Oe{main(){try{this.a()}catch(be){console.error(be.message),I.app.exit(1)}}async a(){(0,p.setUnexpectedErrorHandler)(Pe=>console.error(Pe));const[be,we,ye,De,_,he,fe,ve]=this.b();try{try{await this.d(ye,ve,De,_,fe)}catch(Pe){throw this.f(ye,fe.nameLong,Pe),Pe}await be.invokeFunction(async Pe=>{const We=Pe.get(re.ILogService),Te=Pe.get(X.ILifecycleMainService),qe=Pe.get(S.IFileService),Ue=Pe.get(re.ILoggerService),Be=await this.e(We,ye,Te,be,fe,!0);return v.Promises.writeFile(ye.mainLockfile,String(process.pid)).catch(Xe=>{We.warn(`Error writing main lockfile: ${Xe.stack}`)}),he.logger=Ue.createLogger(C.URI.file((0,f.join)(ye.logsPath,"main.log")),{name:"main"}),(0,y.once)(Te.onWillShutdown)(Xe=>{qe.dispose(),De.dispose(),Xe.join(v.Promises.unlink(ye.mainLockfile).catch(()=>{}))}),be.createInstance(l.CodeApplication,Be,we).startup()})}catch(Pe){be.invokeFunction(this.i,Pe)}}b(){const be=new ae.ServiceCollection,we=new x.DisposableStore;process.once("exit",()=>we.dispose());const ye={_serviceBrand:void 0,...de.default};be.set(K.IProductService,ye);const De=new r.EnvironmentMainService(this.j(),ye),_=this.c(De);be.set(r.IEnvironmentMainService,De);const he=new Y.BufferLogService,fe=we.add(new re.MultiplexLogService([new re.ConsoleMainLogger((0,re.getLogLevel)(De)),he]));be.set(re.ILogService,fe);const ve=new M.FileService(fe);be.set(S.IFileService,ve);const Pe=new L.DiskFileSystemProvider(fe);ve.registerProvider(E.Schemas.file,Pe);const We=new ge.UriIdentityService(ve);be.set(oe.IUriIdentityService,We),be.set(re.ILoggerService,new ne.LoggerService(fe));const Te=new O.StateMainService(De,fe,ve);be.set(D.IStateMainService,Te);const qe=new q.UserDataProfilesMainService(Te,We,De,ve,fe);be.set(q.IUserDataProfilesMainService,qe);const Ue=d.isWindows&&ye.win32RegValueName?we.add(new j.NativePolicyService(fe,ye.win32RegValueName)):De.policyFile?we.add(new Z.FilePolicyService(De.policyFile,ve,fe)):new Q.NullPolicyService;be.set(Q.IPolicyService,Ue);const Be=new n.ConfigurationService(qe.defaultProfile.settingsResource,ve,Ue,fe);return be.set(s.IConfigurationService,Be),be.set(X.ILifecycleMainService,new B.SyncDescriptor(X.LifecycleMainService,void 0,!1)),be.set(V.IRequestService,new B.SyncDescriptor(se.RequestMainService,void 0,!0)),be.set(U.IThemeMainService,new B.SyncDescriptor(U.ThemeMainService)),be.set(z.ISignService,new B.SyncDescriptor($.SignService,void 0,!1)),be.set(T.ITunnelService,new B.SyncDescriptor(N.TunnelService)),be.set(le.IProtocolMainService,new F.ProtocolMainService(De,qe,fe)),[new J.InstantiationService(be,!0),_,De,Be,Te,he,ye,qe]}c(be){const we={VSCODE_IPC_HOOK:be.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ye=>{const De=process.env[ye];typeof De=="string"&&(we[ye]=De)}),Object.assign(process.env,we),we}async d(be,we,ye,De,_){await A.Promises.settled([Promise.all([be.extensionsPath,be.codeCachePath,be.logsPath,we.defaultProfile.globalStorageHome.fsPath,be.workspaceStorageHome.fsPath,be.localHistoryHome.fsPath,be.backupHome].map(he=>he?v.Promises.mkdir(he,{recursive:!0}):void 0)),De.init(),ye.initialize()]),we.setEnablement(_.quality!=="stable"||ye.getValue(Me.PROFILES_ENABLEMENT_CONFIG))}async e(be,we,ye,De,_,he){let fe;try{(0,w.mark)("code/willStartMainServer"),fe=await(0,h.serve)(we.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,y.once)(ye.onWillShutdown)(()=>fe.dispose())}catch(ve){if(ve.code!=="EADDRINUSE")throw this.f(we,_.nameLong,ve),ve;let Pe;try{Pe=await(0,h.connect)(we.mainIPCHandle,"main")}catch(Ue){if(!he||d.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,i.localize)(0,null,_.nameShort),(0,i.localize)(1,null),_.nameLong),Ue;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(Be){throw be.warn("Could not delete obsolete instance handle",Be),Be}return this.e(be,we,ye,De,_,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${_.nameShort} is running.`;throw be.error(Ue),Pe.dispose(),new Error(Ue)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.g((0,i.localize)(2,null,_.nameShort),(0,i.localize)(3,null),_.nameLong)},1e4));const Te=g.ProxyChannel.toService(Pe.getChannel("launch"),{disableMarshalling:!0}),qe=g.ProxyChannel.toService(Pe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return De.invokeFunction(async()=>{const Ue=new a.DiagnosticsService(W.NullTelemetryService,_),Be=await qe.getMainDiagnostics(),Xe=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await Ue.getDiagnostics(Be,Xe);throw console.log($e),new p.ExpectedError});throw d.isWindows&&await this.h(Te,be),be.trace("Sending env to running instance..."),await Te.start(we.args,process.env),Pe.dispose(),We&&clearTimeout(We),new p.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw be.warn(`Warning: The --status argument can only be used if ${_.nameShort} is already running. Please run it again after {0} has started.`),new p.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),fe}f(be,we,ye){if(ye.code==="EACCES"||ye.code==="EPERM"){const De=(0,R.coalesce)([be.userDataPath,be.extensionsPath,h.XDG_RUNTIME_DIR]).map(_=>(0,P.getPathLabel)(C.URI.file(_),{os:d.OS,tildify:be}));this.g((0,i.localize)(4,null),(0,i.localize)(5,null,(0,k.toErrorMessage)(ye),De.join(`
`)),we)}}g(be,we,ye){I.dialog.showMessageBoxSync({title:ye,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,i.localize)(6,null))],message:be,detail:we,defaultId:0,noLink:!0})}async h(be,we){if(d.isWindows){const ye=await be.getMainProcessId();we.trace("Sending some foreground love to the running instance:",ye);try{(await new Promise((De,_)=>{H(["windows-foreground-love"],De,_)})).allowSetForegroundWindow(ye)}catch(De){we.error(De)}}}i(be,we){const ye=be.get(re.ILogService),De=be.get(X.ILifecycleMainService);let _=0;we&&(we.isExpected?we.message&&ye.trace(we.message):(_=1,we.stack?ye.error(we.stack):ye.error(`Startup error: ${we.toString()}`))),De.kill(_)}j(){const be=this.k((0,c.parseMainProcessArgv)(process.argv));if(be.wait&&!be.waitMarkerFilePath){const we=(0,o.createWaitMarkerFileSync)(be.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),be.waitMarkerFilePath=we)}return be}k(be){if(be["open-url"]&&(be._urls=be._,be._=[]),!be.remote){const we=this.l(be._,be.goto);be._=we}return be}l(be,we){const ye=(0,b.cwd)(),De=be.map(fe=>{let ve=String(fe),Pe;we&&(Pe=(0,m.parseLineAndColumnAware)(ve),ve=Pe.path),ve&&(ve=this.m(ye,ve));const We=(0,m.sanitizeFilePath)(ve,ye),Te=(0,f.basename)(We);return Te&&!(0,m.isValidBasename)(Te)?null:we&&Pe?(Pe.path=We,this.n(Pe)):We}),_=d.isWindows||d.isMacintosh,he=(0,R.distinct)(De,fe=>fe&&_?fe.toLowerCase():fe||"");return(0,R.coalesce)(he)}m(be,we){return d.isWindows&&(we=(0,u.rtrim)(we,'"')),we=(0,u.trim)((0,u.trim)(we," "),"	"),d.isWindows&&(we=(0,f.resolve)(be,we),we=(0,u.rtrim)(we,".")),we}n(be){const we=[be.path];return typeof be.line=="number"&&we.push(String(be.line)),typeof be.column=="number"&&we.push(String(be.column)),we.join(":")}}new Oe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-main/main.js.map
