/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/errors","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/arrays","vs/base/common/uri","vs/base/browser/browser","vs/base/browser/keyboardEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/color","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(X){for(var t=[],v=0,i=X.length;v<i;v++)t[v]=be[X[v]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function $t(X){if(Array.isArray(X)){for(var t=0,v=Array(X.length);t<X.length;t++)v[t]=X[t];return v}else return Array.from(X)}var jt=Object.hasOwnProperty,Lt=Object.setPrototypeOf,Kt=Object.isFrozen,Vt=Object.getPrototypeOf,qt=Object.getOwnPropertyDescriptor,et=Object.freeze,ot=Object.seal,Gt=Object.create,Nt=typeof Reflect<"u"&&Reflect,vt=Nt.apply,Ct=Nt.construct;vt||(vt=function(t,v,i){return t.apply(v,i)}),et||(et=function(t){return t}),ot||(ot=function(t){return t}),Ct||(Ct=function(t,v){return new(Function.prototype.bind.apply(t,[null].concat($t(v))))});var Yt=st(Array.prototype.forEach),It=st(Array.prototype.pop),bt=st(Array.prototype.push),ht=st(String.prototype.toLowerCase),Mt=st(String.prototype.match),lt=st(String.prototype.replace),Xt=st(String.prototype.indexOf),Zt=st(String.prototype.trim),at=st(RegExp.prototype.test),Pt=Qt(TypeError);function st(X){return function(t){for(var v=arguments.length,i=Array(v>1?v-1:0),U=1;U<v;U++)i[U-1]=arguments[U];return vt(X,t,i)}}function Qt(X){return function(){for(var t=arguments.length,v=Array(t),i=0;i<t;i++)v[i]=arguments[i];return Ct(X,v)}}function He(X,t){Lt&&Lt(X,null);for(var v=t.length;v--;){var i=t[v];if(typeof i=="string"){var U=ht(i);U!==i&&(Kt(t)||(t[v]=U),i=U)}X[i]=!0}return X}function ut(X){var t=Gt(null),v=void 0;for(v in X)vt(jt,X,[v])&&(t[v]=X[v]);return t}function Dt(X,t){for(;X!==null;){var v=qt(X,t);if(v){if(v.get)return st(v.get);if(typeof v.value=="function")return st(v.value)}X=Vt(X)}function i(U){return console.warn("fallback value for",U),null}return i}var Rt=et(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),At=et(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),St=et(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=et(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),kt=et(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),xt=et(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=et(["#text"]),Bt=et(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ft=et(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ht=et(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=et(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ei=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ti=ot(/<%[\s\S]*|[\s\S]*%>/gm),ii=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ni=ot(/^aria-[\-\w]+$/),si=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ri=ot(/^(?:\w+script|data):/i),oi=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),pt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(X){return typeof X}:function(X){return X&&typeof Symbol=="function"&&X.constructor===Symbol&&X!==Symbol.prototype?"symbol":typeof X};function rt(X){if(Array.isArray(X)){for(var t=0,v=Array(X.length);t<X.length;t++)v[t]=X[t];return v}else return Array.from(X)}var ai=function(){return typeof window>"u"?null:window},li=function(t,v){if((typeof t>"u"?"undefined":pt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,U="data-tt-policy-suffix";v.currentScript&&v.currentScript.hasAttribute(U)&&(i=v.currentScript.getAttribute(U));var H="dompurify"+(i?"#"+i:"");try{return t.createPolicy(H,{createHTML:function(w){return w}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function Ut(){var X=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(ne){return Ut(ne)};if(t.version="2.3.1",t.removed=[],!X||!X.document||X.document.nodeType!==9)return t.isSupported=!1,t;var v=X.document,i=X.document,U=X.DocumentFragment,H=X.HTMLTemplateElement,y=X.Node,w=X.Element,d=X.NodeFilter,m=X.NamedNodeMap,f=m===void 0?X.NamedNodeMap||X.MozNamedAttrMap:m,M=X.Text,o=X.Comment,n=X.DOMParser,e=X.trustedTypes,s=w.prototype,a=Dt(s,"cloneNode"),l=Dt(s,"nextSibling"),h=Dt(s,"childNodes"),r=Dt(s,"parentNode");if(typeof H=="function"){var u=i.createElement("template");u.content&&u.content.ownerDocument&&(i=u.content.ownerDocument)}var b=li(e,v),A=b&&Y?b.createHTML(""):"",N=i,L=N.implementation,T=N.createNodeIterator,c=N.createDocumentFragment,C=N.getElementsByTagName,p=v.importNode,D={};try{D=ut(i).documentMode?i.documentMode:{}}catch{}var _={};t.isSupported=typeof r=="function"&&L&&typeof L.createHTMLDocument<"u"&&D!==9;var V=ei,ge=ti,Z=ii,ie=ni,te=ri,he=oi,re=si,ce=null,Se=He({},[].concat(rt(Rt),rt(At),rt(St),rt(kt),rt(Ot))),x=null,De=He({},[].concat(rt(Bt),rt(Ft),rt(Ht),rt(yt))),se=null,Q=null,le=!0,de=!0,me=!1,ee=!1,k=!1,E=!1,g=!1,R=!1,W=!1,$=!0,Y=!1,F=!0,B=!0,z=!1,S={},I=null,P=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),O=null,j=He({},["audio","video","img","source","image","track"]),J=null,ae=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ue="http://www.w3.org/1998/Math/MathML",ye="http://www.w3.org/2000/svg",Ee="http://www.w3.org/1999/xhtml",Ie=Ee,ke=!1,ve=null,Pe=i.createElement("form"),Re=function(ne){ve&&ve===ne||((!ne||(typeof ne>"u"?"undefined":pt(ne))!=="object")&&(ne={}),ne=ut(ne),ce="ALLOWED_TAGS"in ne?He({},ne.ALLOWED_TAGS):Se,x="ALLOWED_ATTR"in ne?He({},ne.ALLOWED_ATTR):De,J="ADD_URI_SAFE_ATTR"in ne?He(ut(ae),ne.ADD_URI_SAFE_ATTR):ae,O="ADD_DATA_URI_TAGS"in ne?He(ut(j),ne.ADD_DATA_URI_TAGS):j,I="FORBID_CONTENTS"in ne?He({},ne.FORBID_CONTENTS):P,se="FORBID_TAGS"in ne?He({},ne.FORBID_TAGS):{},Q="FORBID_ATTR"in ne?He({},ne.FORBID_ATTR):{},S="USE_PROFILES"in ne?ne.USE_PROFILES:!1,le=ne.ALLOW_ARIA_ATTR!==!1,de=ne.ALLOW_DATA_ATTR!==!1,me=ne.ALLOW_UNKNOWN_PROTOCOLS||!1,ee=ne.SAFE_FOR_TEMPLATES||!1,k=ne.WHOLE_DOCUMENT||!1,R=ne.RETURN_DOM||!1,W=ne.RETURN_DOM_FRAGMENT||!1,$=ne.RETURN_DOM_IMPORT!==!1,Y=ne.RETURN_TRUSTED_TYPE||!1,g=ne.FORCE_BODY||!1,F=ne.SANITIZE_DOM!==!1,B=ne.KEEP_CONTENT!==!1,z=ne.IN_PLACE||!1,re=ne.ALLOWED_URI_REGEXP||re,Ie=ne.NAMESPACE||Ee,ee&&(de=!1),W&&(R=!0),S&&(ce=He({},[].concat(rt(Ot))),x=[],S.html===!0&&(He(ce,Rt),He(x,Bt)),S.svg===!0&&(He(ce,At),He(x,Ft),He(x,yt)),S.svgFilters===!0&&(He(ce,St),He(x,Ft),He(x,yt)),S.mathMl===!0&&(He(ce,kt),He(x,Ht),He(x,yt))),ne.ADD_TAGS&&(ce===Se&&(ce=ut(ce)),He(ce,ne.ADD_TAGS)),ne.ADD_ATTR&&(x===De&&(x=ut(x)),He(x,ne.ADD_ATTR)),ne.ADD_URI_SAFE_ATTR&&He(J,ne.ADD_URI_SAFE_ATTR),ne.FORBID_CONTENTS&&(I===P&&(I=ut(I)),He(I,ne.FORBID_CONTENTS)),B&&(ce["#text"]=!0),k&&He(ce,["html","head","body"]),ce.table&&(He(ce,["tbody"]),delete se.tbody),et&&et(ne),ve=ne)},je=He({},["mi","mo","mn","ms","mtext"]),Ue=He({},["foreignobject","desc","title","annotation-xml"]),We=He({},At);He(We,St),He(We,Jt);var xe=He({},kt);He(xe,xt);var it=function(ne){var Ae=r(ne);(!Ae||!Ae.tagName)&&(Ae={namespaceURI:Ee,tagName:"template"});var Ne=ht(ne.tagName),ze=ht(Ae.tagName);if(ne.namespaceURI===ye)return Ae.namespaceURI===Ee?Ne==="svg":Ae.namespaceURI===ue?Ne==="svg"&&(ze==="annotation-xml"||je[ze]):Boolean(We[Ne]);if(ne.namespaceURI===ue)return Ae.namespaceURI===Ee?Ne==="math":Ae.namespaceURI===ye?Ne==="math"&&Ue[ze]:Boolean(xe[Ne]);if(ne.namespaceURI===Ee){if(Ae.namespaceURI===ye&&!Ue[ze]||Ae.namespaceURI===ue&&!je[ze])return!1;var Ge=He({},["title","style","font","a","script"]);return!xe[Ne]&&(Ge[Ne]||!We[Ne])}return!1},Be=function(ne){bt(t.removed,{element:ne});try{ne.parentNode.removeChild(ne)}catch{try{ne.outerHTML=A}catch{ne.remove()}}},Ve=function(ne,Ae){try{bt(t.removed,{attribute:Ae.getAttributeNode(ne),from:Ae})}catch{bt(t.removed,{attribute:null,from:Ae})}if(Ae.removeAttribute(ne),ne==="is"&&!x[ne])if(R||W)try{Be(Ae)}catch{}else try{Ae.setAttribute(ne,"")}catch{}},Ye=function(ne){var Ae=void 0,Ne=void 0;if(g)ne="<remove></remove>"+ne;else{var ze=Mt(ne,/^[\r\n\t ]+/);Ne=ze&&ze[0]}var Ge=b?b.createHTML(ne):ne;if(Ie===Ee)try{Ae=new n().parseFromString(Ge,"text/html")}catch{}if(!Ae||!Ae.documentElement){Ae=L.createDocument(Ie,"template",null);try{Ae.documentElement.innerHTML=ke?"":Ge}catch{}}var Ze=Ae.body||Ae.documentElement;return ne&&Ne&&Ze.insertBefore(i.createTextNode(Ne),Ze.childNodes[0]||null),Ie===Ee?C.call(Ae,k?"html":"body")[0]:k?Ae.documentElement:Ze},K=function(ne){return T.call(ne.ownerDocument||ne,ne,d.SHOW_ELEMENT|d.SHOW_COMMENT|d.SHOW_TEXT,null,!1)},oe=function(ne){return ne instanceof M||ne instanceof o?!1:typeof ne.nodeName!="string"||typeof ne.textContent!="string"||typeof ne.removeChild!="function"||!(ne.attributes instanceof f)||typeof ne.removeAttribute!="function"||typeof ne.setAttribute!="function"||typeof ne.namespaceURI!="string"||typeof ne.insertBefore!="function"},we=function(ne){return(typeof y>"u"?"undefined":pt(y))==="object"?ne instanceof y:ne&&(typeof ne>"u"?"undefined":pt(ne))==="object"&&typeof ne.nodeType=="number"&&typeof ne.nodeName=="string"},Ce=function(ne,Ae,Ne){!_[ne]||Yt(_[ne],function(ze){ze.call(t,Ae,Ne,ve)})},Te=function(ne){var Ae=void 0;if(Ce("beforeSanitizeElements",ne,null),oe(ne)||Mt(ne.nodeName,/[\u0080-\uFFFF]/))return Be(ne),!0;var Ne=ht(ne.nodeName);if(Ce("uponSanitizeElement",ne,{tagName:Ne,allowedTags:ce}),!we(ne.firstElementChild)&&(!we(ne.content)||!we(ne.content.firstElementChild))&&at(/<[/\w]/g,ne.innerHTML)&&at(/<[/\w]/g,ne.textContent)||Ne==="select"&&at(/<template/i,ne.innerHTML))return Be(ne),!0;if(!ce[Ne]||se[Ne]){if(B&&!I[Ne]){var ze=r(ne)||ne.parentNode,Ge=h(ne)||ne.childNodes;if(Ge&&ze)for(var Ze=Ge.length,Qe=Ze-1;Qe>=0;--Qe)ze.insertBefore(a(Ge[Qe],!0),l(ne))}return Be(ne),!0}return ne instanceof w&&!it(ne)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,ne.innerHTML)?(Be(ne),!0):(ee&&ne.nodeType===3&&(Ae=ne.textContent,Ae=lt(Ae,V," "),Ae=lt(Ae,ge," "),ne.textContent!==Ae&&(bt(t.removed,{element:ne.cloneNode()}),ne.textContent=Ae)),Ce("afterSanitizeElements",ne,null),!1)},Oe=function(ne,Ae,Ne){if(F&&(Ae==="id"||Ae==="name")&&(Ne in i||Ne in Pe))return!1;if(!(de&&!Q[Ae]&&at(Z,Ae))){if(!(le&&at(ie,Ae))){if(!x[Ae]||Q[Ae])return!1;if(!J[Ae]){if(!at(re,lt(Ne,he,""))){if(!((Ae==="src"||Ae==="xlink:href"||Ae==="href")&&ne!=="script"&&Xt(Ne,"data:")===0&&O[ne])){if(!(me&&!at(te,lt(Ne,he,"")))){if(Ne)return!1}}}}}}return!0},$e=function(ne){var Ae=void 0,Ne=void 0,ze=void 0,Ge=void 0;Ce("beforeSanitizeAttributes",ne,null);var Ze=ne.attributes;if(!!Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:x};for(Ge=Ze.length;Ge--;){Ae=Ze[Ge];var nt=Ae,ct=nt.name,Et=nt.namespaceURI;if(Ne=Zt(Ae.value),ze=ht(ct),Qe.attrName=ze,Qe.attrValue=Ne,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,Ce("uponSanitizeAttribute",ne,Qe),Ne=Qe.attrValue,!Qe.forceKeepAttr&&(Ve(ct,ne),!!Qe.keepAttr)){if(at(/\/>/i,Ne)){Ve(ct,ne);continue}ee&&(Ne=lt(Ne,V," "),Ne=lt(Ne,ge," "));var dt=ne.nodeName.toLowerCase();if(!!Oe(dt,ze,Ne))try{Et?ne.setAttributeNS(Et,ct,Ne):ne.setAttribute(ct,Ne),It(t.removed)}catch{}}}Ce("afterSanitizeAttributes",ne,null)}},tt=function Me(ne){var Ae=void 0,Ne=K(ne);for(Ce("beforeSanitizeShadowDOM",ne,null);Ae=Ne.nextNode();)Ce("uponSanitizeShadowNode",Ae,null),!Te(Ae)&&(Ae.content instanceof U&&Me(Ae.content),$e(Ae));Ce("afterSanitizeShadowDOM",ne,null)};return t.sanitize=function(Me,ne){var Ae=void 0,Ne=void 0,ze=void 0,Ge=void 0,Ze=void 0;if(ke=!Me,ke&&(Me="<!-->"),typeof Me!="string"&&!we(Me)){if(typeof Me.toString!="function")throw Pt("toString is not a function");if(Me=Me.toString(),typeof Me!="string")throw Pt("dirty is not a string, aborting")}if(!t.isSupported){if(pt(X.toStaticHTML)==="object"||typeof X.toStaticHTML=="function"){if(typeof Me=="string")return X.toStaticHTML(Me);if(we(Me))return X.toStaticHTML(Me.outerHTML)}return Me}if(E||Re(ne),t.removed=[],typeof Me=="string"&&(z=!1),!z)if(Me instanceof y)Ae=Ye("<!---->"),Ne=Ae.ownerDocument.importNode(Me,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Ae=Ne:Ae.appendChild(Ne);else{if(!R&&!ee&&!k&&Me.indexOf("<")===-1)return b&&Y?b.createHTML(Me):Me;if(Ae=Ye(Me),!Ae)return R?null:A}Ae&&g&&Be(Ae.firstChild);for(var Qe=K(z?Me:Ae);ze=Qe.nextNode();)ze.nodeType===3&&ze===Ge||Te(ze)||(ze.content instanceof U&&tt(ze.content),$e(ze),Ge=ze);if(Ge=null,z)return Me;if(R){if(W)for(Ze=c.call(Ae.ownerDocument);Ae.firstChild;)Ze.appendChild(Ae.firstChild);else Ze=Ae;return $&&(Ze=p.call(v,Ze,!0)),Ze}var nt=k?Ae.outerHTML:Ae.innerHTML;return ee&&(nt=lt(nt,V," "),nt=lt(nt,ge," ")),b&&Y?b.createHTML(nt):nt},t.setConfig=function(Me){Re(Me),E=!0},t.clearConfig=function(){ve=null,E=!1},t.isValidAttribute=function(Me,ne,Ae){ve||Re({});var Ne=ht(Me),ze=ht(ne);return Oe(Ne,ze,Ae)},t.addHook=function(Me,ne){typeof ne=="function"&&(_[Me]=_[Me]||[],bt(_[Me],ne))},t.removeHook=function(Me){_[Me]&&It(_[Me])},t.removeHooks=function(Me){_[Me]&&(_[Me]=[])},t.removeAllHooks=function(){_={}},t}var hi=Ut();define("vs/base/browser/dompurify/dompurify",function(){return hi}),define(be[39],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class v{constructor(y){this.domNode=y,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(y){const w=i(y);this.a!==w&&(this.a=w,this.domNode.style.maxWidth=this.a)}setWidth(y){const w=i(y);this.b!==w&&(this.b=w,this.domNode.style.width=this.b)}setHeight(y){const w=i(y);this.c!==w&&(this.c=w,this.domNode.style.height=this.c)}setTop(y){const w=i(y);this.d!==w&&(this.d=w,this.domNode.style.top=this.d)}setLeft(y){const w=i(y);this.e!==w&&(this.e=w,this.domNode.style.left=this.e)}setBottom(y){const w=i(y);this.f!==w&&(this.f=w,this.domNode.style.bottom=this.f)}setRight(y){const w=i(y);this.g!==w&&(this.g=w,this.domNode.style.right=this.g)}setPaddingTop(y){const w=i(y);this.h!==w&&(this.h=w,this.domNode.style.paddingTop=this.h)}setPaddingLeft(y){const w=i(y);this.i!==w&&(this.i=w,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(y){const w=i(y);this.j!==w&&(this.j=w,this.domNode.style.paddingBottom=this.j)}setPaddingRight(y){const w=i(y);this.k!==w&&(this.k=w,this.domNode.style.paddingRight=this.k)}setFontFamily(y){this.l!==y&&(this.l=y,this.domNode.style.fontFamily=this.l)}setFontWeight(y){this.m!==y&&(this.m=y,this.domNode.style.fontWeight=this.m)}setFontSize(y){const w=i(y);this.n!==w&&(this.n=w,this.domNode.style.fontSize=this.n)}setFontStyle(y){this.o!==y&&(this.o=y,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(y){this.p!==y&&(this.p=y,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(y){this.q!==y&&(this.q=y,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(y){this.r!==y&&(this.r=y,this.domNode.style.textDecoration=this.r)}setLineHeight(y){const w=i(y);this.s!==w&&(this.s=w,this.domNode.style.lineHeight=this.s)}setLetterSpacing(y){const w=i(y);this.t!==w&&(this.t=w,this.domNode.style.letterSpacing=this.t)}setClassName(y){this.u!==y&&(this.u=y,this.domNode.className=this.u)}toggleClassName(y,w){this.domNode.classList.toggle(y,w),this.u=this.domNode.className}setDisplay(y){this.v!==y&&(this.v=y,this.domNode.style.display=this.v)}setPosition(y){this.w!==y&&(this.w=y,this.domNode.style.position=this.w)}setVisibility(y){this.x!==y&&(this.x=y,this.domNode.style.visibility=this.x)}setColor(y){this.y!==y&&(this.y=y,this.domNode.style.color=this.y)}setBackgroundColor(y){this.z!==y&&(this.z=y,this.domNode.style.backgroundColor=this.z)}setLayerHinting(y){this.A!==y&&(this.A=y,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this.C!==y&&(this.C=y,this.domNode.style.boxShadow=y)}setContain(y){this.B!==y&&(this.B=y,this.domNode.style.contain=this.B)}setAttribute(y,w){this.domNode.setAttribute(y,w)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}t.FastDomNode=v;function i(H){return typeof H=="number"?`${H}px`:H}function U(H){return new v(H)}t.createFastDomNode=U}),define(be[67],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let v=!1,i=null;function U(y){if(!y.parent||y.parent===y)return null;try{const w=y.location,d=y.parent.location;if(w.origin!=="null"&&d.origin!=="null"&&w.origin!==d.origin)return v=!0,null}catch{return v=!0,null}return y.parent}class H{static getSameOriginWindowChain(){if(!i){i=[];let w=window,d;do d=U(w),d?i.push({window:w,iframeElement:w.frameElement||null}):i.push({window:w,iframeElement:null}),w=d;while(w)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),v}static getPositionOfChildWindowRelativeToAncestorWindow(w,d){if(!d||w===d)return{top:0,left:0};let m=0,f=0;const M=this.getSameOriginWindowChain();for(const o of M){if(m+=o.window.scrollY,f+=o.window.scrollX,o.window===d||!o.iframeElement)break;const n=o.iframeElement.getBoundingClientRect();m+=n.top,f+=n.left}return{top:m,left:f}}}t.IframeUtils=H}),define(be[68],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var v;(function(H){H[H.Copy=0]="Copy",H[H.Move=1]="Move"})(v=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(y,w){super(`ListError [${y}] ${w}`)}}t.ListError=i;class U{constructor(){this.c=new WeakMap}getHeight(y){return this.c.get(y)??this.d(y)}setDynamicHeight(y,w){w>0&&this.c.set(y,w)}}t.CachedListVirtualDelegate=U}),define(be[69],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class v{constructor(U){this.a=U}splice(U,H,y){this.a.forEach(w=>w.splice(U,H,y))}}t.CombinedSpliceable=v}),define(be[40],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const v=20;class i{constructor(H,y,w,d,m,f){this.a=Math.round(y),this.b=Math.round(w),this.c=Math.round(H),this.d=d,this.e=m,this.f=f,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new i(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const y=Math.round(H);return this.d!==y?(this.d=y,this.m(),!0):!1}setScrollSize(H){const y=Math.round(H);return this.e!==y?(this.e=y,this.m(),!0):!1}setScrollPosition(H){const y=Math.round(H);return this.f!==y?(this.f=y,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,y,w,d,m){const f=Math.max(0,w-H),M=Math.max(0,f-2*y),o=d>0&&d>w;if(!o)return{computedAvailableSize:Math.round(f),computedIsNeeded:o,computedSliderSize:Math.round(M),computedSliderRatio:0,computedSliderPosition:0};const n=Math.round(Math.max(v,Math.floor(w*M/d))),e=(M-n)/(d-w),s=m*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:o,computedSliderSize:Math.round(n),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const H=i.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const y=H-this.c-this.i/2;return Math.round(y/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const y=H-this.c;let w=this.f;return y<this.k?w-=this.d:w+=this.d,w}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const y=this.k+H;return Math.round(y/this.j)}}t.ScrollbarState=i}),define(be[23],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var v;(function(w){w[w.Hidden=0]="Hidden",w[w.Visible=1]="Visible",w[w.Recurse=2]="Recurse"})(v=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(w){w[w.Unknown=0]="Unknown",w[w.Twistie=1]="Twistie",w[w.Element=2]="Element",w[w.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var U;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(U=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(w=!1){return{accept:!0,bubble:0,autoExpand:w}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(w=!1){return{accept:!0,bubble:0,effect:0,autoExpand:w}}};class H extends Error{constructor(d,m){super(`TreeError [${d}] ${m}`)}}t.TreeError=H;class y{constructor(d){this.a=d,this.b=new WeakMap}map(d){let m=this.b.get(d);return m||(m=this.a(d),this.b.set(d,m)),m}}t.WeakMapper=y}),define(be[12],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.Codicon=t.getCodiconAriaLabel=void 0;function v(H){return H?H.replace(/\$\((.*?)\)/g,(y,w)=>` ${w} `).trim():""}t.getCodiconAriaLabel=v;class i{constructor(y,w,d){this.id=y,this.definition=w,this.description=d,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}t.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.commentDraft=new i("comment-draft",{fontCharacter:"\\ec0e"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var U;(function(H){H.iconNameSegment="[A-Za-z0-9]+",H.iconNameExpression="[A-Za-z0-9-]+",H.iconModifierExpression="~[A-Za-z]+",H.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${H.iconNameExpression})(${H.iconModifierExpression})?$`);function w(f){if(f instanceof i)return["codicon","codicon-"+f.id];const M=y.exec(f.id);if(!M)return w(i.error);const[,o,n]=M,e=["codicon","codicon-"+o];return n&&e.push("codicon-modifier-"+n.substring(1)),e}H.asClassNameArray=w;function d(f){return w(f).join(" ")}H.asClassName=d;function m(f){return"."+w(f).join(".")}H.asCSSSelector=m})(U=t.CSSIcon||(t.CSSIcon={}))}),define(be[70],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function v(y,w){const d=Object.create(null);for(const m of y){const f=w(m);let M=d[f];M||(M=d[f]=[]),M.push(m)}return d}t.groupBy=v;function i(y,w){const d=[],m=[];for(const f of y)w.has(f)||d.push(f);for(const f of w)y.has(f)||m.push(f);return{removed:d,added:m}}t.diffSets=i;function U(y,w){const d=[],m=[];for(const[f,M]of y)w.has(f)||d.push(M);for(const[f,M]of w)y.has(f)||m.push(M);return{removed:d,added:m}}t.diffMaps=U;class H{constructor(){this.a=new Map}add(w,d){let m=this.a.get(w);m||(m=new Set,this.a.set(w,m)),m.add(d)}delete(w,d){const m=this.a.get(w);!m||(m.delete(d),m.size===0&&this.a.delete(w))}forEach(w,d){const m=this.a.get(w);!m||m.forEach(d)}}t.SetMap=H}),define(be[41],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function v(w,d){const m=Math.pow(10,d);return Math.round(w*m)/m}class i{constructor(d,m,f,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=v(Math.max(Math.min(1,M),0),3)}static equals(d,m){return d.r===m.r&&d.g===m.g&&d.b===m.b&&d.a===m.a}}t.RGBA=i;class U{constructor(d,m,f,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.l=v(Math.max(Math.min(1,f),0),3),this.a=v(Math.max(Math.min(1,M),0),3)}static equals(d,m){return d.h===m.h&&d.s===m.s&&d.l===m.l&&d.a===m.a}static fromRGBA(d){const m=d.r/255,f=d.g/255,M=d.b/255,o=d.a,n=Math.max(m,f,M),e=Math.min(m,f,M);let s=0,a=0;const l=(e+n)/2,h=n-e;if(h>0){switch(a=Math.min(l<=.5?h/(2*l):h/(2-2*l),1),n){case m:s=(f-M)/h+(f<M?6:0);break;case f:s=(M-m)/h+2;break;case M:s=(m-f)/h+4;break}s*=60,s=Math.round(s)}return new U(s,a,l,o)}static i(d,m,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?d+(m-d)*6*f:f<1/2?m:f<2/3?d+(m-d)*(2/3-f)*6:d}static toRGBA(d){const m=d.h/360,{s:f,l:M,a:o}=d;let n,e,s;if(f===0)n=e=s=M;else{const a=M<.5?M*(1+f):M+f-M*f,l=2*M-a;n=U.i(l,a,m+1/3),e=U.i(l,a,m),s=U.i(l,a,m-1/3)}return new i(Math.round(n*255),Math.round(e*255),Math.round(s*255),o)}}t.HSLA=U;class H{constructor(d,m,f,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.v=v(Math.max(Math.min(1,f),0),3),this.a=v(Math.max(Math.min(1,M),0),3)}static equals(d,m){return d.h===m.h&&d.s===m.s&&d.v===m.v&&d.a===m.a}static fromRGBA(d){const m=d.r/255,f=d.g/255,M=d.b/255,o=Math.max(m,f,M),n=Math.min(m,f,M),e=o-n,s=o===0?0:e/o;let a;return e===0?a=0:o===m?a=((f-M)/e%6+6)%6:o===f?a=(M-m)/e+2:a=(m-f)/e+4,new H(Math.round(a*60),s,o,d.a)}static toRGBA(d){const{h:m,s:f,v:M,a:o}=d,n=M*f,e=n*(1-Math.abs(m/60%2-1)),s=M-n;let[a,l,h]=[0,0,0];return m<60?(a=n,l=e):m<120?(a=e,l=n):m<180?(l=n,h=e):m<240?(l=e,h=n):m<300?(a=e,h=n):m<=360&&(a=n,h=e),a=Math.round((a+s)*255),l=Math.round((l+s)*255),h=Math.round((h+s)*255),new i(a,l,h,o)}}t.HSVA=H;class y{static fromHex(d){return y.Format.CSS.parseHex(d)||y.red}static equals(d,m){return!d&&!m?!0:!d||!m?!1:d.equals(m)}get hsla(){return this.i?this.i:U.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof i)this.rgba=d;else if(d instanceof U)this.i=d,this.rgba=U.toRGBA(d);else if(d instanceof H)this.j=d,this.rgba=H.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&i.equals(this.rgba,d.rgba)&&U.equals(this.hsla,d.hsla)&&H.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=y.k(this.rgba.r),m=y.k(this.rgba.g),f=y.k(this.rgba.b),M=.2126*d+.7152*m+.0722*f;return v(M,4)}static k(d){const m=d/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(d){const m=this.getRelativeLuminance(),f=d.getRelativeLuminance();return m>f?(m+.05)/(f+.05):(f+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const m=this.getRelativeLuminance(),f=d.getRelativeLuminance();return m>f}isDarkerThan(d){const m=this.getRelativeLuminance(),f=d.getRelativeLuminance();return m<f}lighten(d){return new y(new U(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new y(new U(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:m,g:f,b:M,a:o}=this.rgba;return new y(new i(m,f,M,o*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const m=d.rgba,f=this.rgba.a,M=m.a,o=f+M*(1-f);if(o<1e-6)return y.transparent;const n=this.rgba.r*f/o+m.r*M*(1-f)/o,e=this.rgba.g*f/o+m.g*M*(1-f)/o,s=this.rgba.b*f/o+m.b*M*(1-f)/o;return new y(new i(n,e,s,o))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:m,g:f,b:M,a:o}=this.rgba;return new y(new i(d.rgba.r-o*(d.rgba.r-m),d.rgba.g-o*(d.rgba.g-f),d.rgba.b-o*(d.rgba.b-M),1))}flatten(...d){const m=d.reduceRight((f,M)=>y.o(M,f));return y.o(this,m)}static o(d,m){const f=1-d.rgba.a;return new y(new i(f*m.rgba.r+d.rgba.a*d.rgba.r,f*m.rgba.g+d.rgba.a*d.rgba.g,f*m.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=y.Format.CSS.format(this)),this.u}static getLighterColor(d,m,f){if(d.isLighterThan(m))return d;f=f||.5;const M=d.getRelativeLuminance(),o=m.getRelativeLuminance();return f=f*(o-M)/o,d.lighten(f)}static getDarkerColor(d,m,f){if(d.isDarkerThan(m))return d;f=f||.5;const M=d.getRelativeLuminance(),o=m.getRelativeLuminance();return f=f*(M-o)/M,d.darken(f)}}t.Color=y,y.white=new y(new i(255,255,255,1)),y.black=new y(new i(0,0,0,1)),y.red=new y(new i(255,0,0,1)),y.blue=new y(new i(0,0,255,1)),y.green=new y(new i(0,255,0,1)),y.cyan=new y(new i(0,255,255,1)),y.lightgrey=new y(new i(211,211,211,1)),y.transparent=new y(new i(0,0,0,0)),function(w){let d;(function(m){let f;(function(M){function o(A){return A.rgba.a===1?`rgb(${A.rgba.r}, ${A.rgba.g}, ${A.rgba.b})`:w.Format.CSS.formatRGBA(A)}M.formatRGB=o;function n(A){return`rgba(${A.rgba.r}, ${A.rgba.g}, ${A.rgba.b}, ${+A.rgba.a.toFixed(2)})`}M.formatRGBA=n;function e(A){return A.hsla.a===1?`hsl(${A.hsla.h}, ${(A.hsla.s*100).toFixed(2)}%, ${(A.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(A)}M.formatHSL=e;function s(A){return`hsla(${A.hsla.h}, ${(A.hsla.s*100).toFixed(2)}%, ${(A.hsla.l*100).toFixed(2)}%, ${A.hsla.a.toFixed(2)})`}M.formatHSLA=s;function a(A){const N=A.toString(16);return N.length!==2?"0"+N:N}function l(A){return`#${a(A.rgba.r)}${a(A.rgba.g)}${a(A.rgba.b)}`}M.formatHex=l;function h(A,N=!1){return N&&A.rgba.a===1?w.Format.CSS.formatHex(A):`#${a(A.rgba.r)}${a(A.rgba.g)}${a(A.rgba.b)}${a(Math.round(A.rgba.a*255))}`}M.formatHexA=h;function r(A){return A.isOpaque()?w.Format.CSS.formatHex(A):w.Format.CSS.formatRGBA(A)}M.format=r;function u(A){const N=A.length;if(N===0||A.charCodeAt(0)!==35)return null;if(N===7){const L=16*b(A.charCodeAt(1))+b(A.charCodeAt(2)),T=16*b(A.charCodeAt(3))+b(A.charCodeAt(4)),c=16*b(A.charCodeAt(5))+b(A.charCodeAt(6));return new w(new i(L,T,c,1))}if(N===9){const L=16*b(A.charCodeAt(1))+b(A.charCodeAt(2)),T=16*b(A.charCodeAt(3))+b(A.charCodeAt(4)),c=16*b(A.charCodeAt(5))+b(A.charCodeAt(6)),C=16*b(A.charCodeAt(7))+b(A.charCodeAt(8));return new w(new i(L,T,c,C/255))}if(N===4){const L=b(A.charCodeAt(1)),T=b(A.charCodeAt(2)),c=b(A.charCodeAt(3));return new w(new i(16*L+L,16*T+T,16*c+c))}if(N===5){const L=b(A.charCodeAt(1)),T=b(A.charCodeAt(2)),c=b(A.charCodeAt(3)),C=b(A.charCodeAt(4));return new w(new i(16*L+L,16*T+T,16*c+c,(16*C+C)/255))}return null}M.parseHex=u;function b(A){switch(A){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=m.CSS||(m.CSS={}))})(d=w.Format||(w.Format={}))}(y=t.Color||(t.Color={}))}),define(be[24],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function v(y){return(w,d,m)=>{let f=null,M=null;if(typeof m.value=="function"?(f="value",M=m.value):typeof m.get=="function"&&(f="get",M=m.get),!M)throw new Error("not supported");m[f]=y(M,d)}}function i(y,w,d){let m=null,f=null;if(typeof d.value=="function"?(m="value",f=d.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(m="get",f=d.get),!f)throw new Error("not supported");const M=`$memoize$${w}`;d[m]=function(...o){return this.hasOwnProperty(M)||Object.defineProperty(this,M,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,o)}),this[M]}}t.memoize=i;function U(y,w,d){return v((m,f)=>{const M=`$debounce$${f}`,o=`$debounce$result$${f}`;return function(...n){this[o]||(this[o]=d?d():void 0),clearTimeout(this[M]),w&&(this[o]=w(this[o],...n),n=[this[o]]),this[M]=setTimeout(()=>{m.apply(this,n),this[o]=d?d():void 0},y)}})}t.debounce=U;function H(y,w,d){return v((m,f)=>{const M=`$throttle$timer$${f}`,o=`$throttle$result$${f}`,n=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...s){if(this[o]||(this[o]=d?d():void 0),(this[n]===null||this[n]===void 0)&&(this[n]=-Number.MAX_VALUE),w&&(this[o]=w(this[o],...s)),this[e])return;const a=this[n]+y;a<=Date.now()?(this[n]=Date.now(),m.apply(this,[this[o]]),this[o]=d?d():void 0):(this[e]=!0,this[M]=setTimeout(()=>{this[e]=!1,this[n]=Date.now(),m.apply(this,[this[o]]),this[o]=d?d():void 0},a-Date.now()))}})}t.throttle=H}),define(be[71],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class v{constructor(U,H,y,w){this.originalStart=U,this.originalLength=H,this.modifiedStart=y,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=v}),define(be[9],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class v{constructor(){this.b=[],this.a=function(A){setTimeout(()=>{throw A.stack?r.isErrorNoTelemetry(A)?new r(A.message+`

`+A.stack):new Error(A.message+`

`+A.stack):A},0)}}addListener(A){return this.b.push(A),()=>{this.d(A)}}c(A){this.b.forEach(N=>{N(A)})}d(A){this.b.splice(this.b.indexOf(A),1)}setUnexpectedErrorHandler(A){this.a=A}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(A){this.a(A),this.c(A)}onUnexpectedExternalError(A){this.a(A)}}t.ErrorHandler=v,t.errorHandler=new v;function i(b){t.errorHandler.setUnexpectedErrorHandler(b)}t.setUnexpectedErrorHandler=i;function U(b){d(b)||t.errorHandler.onUnexpectedError(b)}t.onUnexpectedError=U;function H(b){d(b)||t.errorHandler.onUnexpectedExternalError(b)}t.onUnexpectedExternalError=H;function y(b){if(b instanceof Error){const{name:A,message:N}=b,L=b.stacktrace||b.stack;return{$isError:!0,name:A,message:N,stack:L,noTelemetry:r.isErrorNoTelemetry(b)}}return b}t.transformErrorForSerialization=y;const w="Canceled";function d(b){return b instanceof m?!0:b instanceof Error&&b.name===w&&b.message===w}t.isCancellationError=d;class m extends Error{constructor(){super(w),this.name=this.message}}t.CancellationError=m;function f(){const b=new Error(w);return b.name=b.message,b}t.canceled=f;function M(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}t.illegalArgument=M;function o(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}t.illegalState=o;function n(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=n;function e(b){const A=new Error(`${b} has been disposed`);return A.name="DISPOSED",A}t.disposed=e;function s(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}t.getErrorMessage=s;class a extends Error{constructor(A){super("NotImplemented"),A&&(this.message=A)}}t.NotImplementedError=a;class l extends Error{constructor(A){super("NotSupported"),A&&(this.message=A)}}t.NotSupportedError=l;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=h;class r extends Error{constructor(A){super(A),this.name="CodeExpectedError"}static fromError(A){if(A instanceof r)return A;const N=new r;return N.message=A.message,N.stack=A.stack,N}static isErrorNoTelemetry(A){return A.name==="CodeExpectedError"}}t.ErrorNoTelemetry=r;class u extends Error{constructor(A){super(A||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype);debugger}}t.BugIndicatingError=u}),define(be[14],pe([1,0,9]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(F,B=0){return F[F.length-(1+B)]}t.tail=i;function U(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}t.tail2=U;function H(F,B,z=(S,I)=>S===I){if(F===B)return!0;if(!F||!B||F.length!==B.length)return!1;for(let S=0,I=F.length;S<I;S++)if(!z(F[S],B[S]))return!1;return!0}t.equals=H;function y(F,B){const z=F.length-1;B<z&&(F[B]=F[z]),F.pop()}t.removeFastWithoutKeepingOrder=y;function w(F,B,z){return d(F.length,S=>z(F[S],B))}t.binarySearch=w;function d(F,B){let z=0,S=F-1;for(;z<=S;){const I=(z+S)/2|0,P=B(I);if(P<0)z=I+1;else if(P>0)S=I-1;else return I}return-(z+1)}t.binarySearch2=d;function m(F,B){let z=0,S=F.length;if(S===0)return 0;for(;z<S;){const I=Math.floor((z+S)/2);B(F[I])?S=I:z=I+1}return z}t.findFirstInSorted=m;function f(F,B,z){if(F=F|0,F>=B.length)throw new TypeError("invalid index");const S=B[Math.floor(B.length*Math.random())],I=[],P=[],O=[];for(const j of B){const J=z(j,S);J<0?I.push(j):J>0?P.push(j):O.push(j)}return F<I.length?f(F,I,z):F<I.length+O.length?O[0]:f(F-(I.length+O.length),P,z)}t.quickSelect=f;function M(F,B){const z=[];let S;for(const I of F.slice(0).sort(B))!S||B(S[0],I)!==0?(S=[I],z.push(S)):S.push(I);return z}t.groupBy=M;function o(F,B,z){const S=[];function I(j,J,ae){if(J===0&&ae.length===0)return;const ue=S[S.length-1];ue&&ue.start+ue.deleteCount===j?(ue.deleteCount+=J,ue.toInsert.push(...ae)):S.push({start:j,deleteCount:J,toInsert:ae})}let P=0,O=0;for(;;){if(P===F.length){I(P,0,B.slice(O));break}if(O===B.length){I(P,F.length-P,[]);break}const j=F[P],J=B[O],ae=z(j,J);ae===0?(P+=1,O+=1):ae<0?(I(P,1,[]),P+=1):ae>0&&(I(P,0,[J]),O+=1)}return S}t.sortedDiff=o;function n(F,B,z){const S=o(F,B,z),I=[],P=[];for(const O of S)I.push(...F.slice(O.start,O.start+O.deleteCount)),P.push(...O.toInsert);return{removed:I,added:P}}t.delta=n;function e(F,B,z){if(z===0)return[];const S=F.slice(0,z).sort(B);return a(F,B,S,z,F.length),S}t.top=e;function s(F,B,z,S,I){return z===0?Promise.resolve([]):new Promise((P,O)=>{(async()=>{const j=F.length,J=F.slice(0,z).sort(B);for(let ae=z,ue=Math.min(z+S,j);ae<j;ae=ue,ue=Math.min(ue+S,j)){if(ae>z&&await new Promise(ye=>setTimeout(ye)),I&&I.isCancellationRequested)throw new v.CancellationError;a(F,B,J,ae,ue)}return J})().then(P,O)})}t.topAsync=s;function a(F,B,z,S,I){for(const P=z.length;S<I;S++){const O=F[S];if(B(O,z[P-1])<0){z.pop();const j=m(z,J=>B(O,J)<0);z.splice(j,0,O)}}}function l(F){return F.filter(B=>!!B)}t.coalesce=l;function h(F){let B=0;for(let z=0;z<F.length;z++)F[z]&&(F[B]=F[z],B+=1);F.length=B}t.coalesceInPlace=h;function r(F,B,z){F.splice(z,0,F.splice(B,1)[0])}t.move=r;function u(F){return!Array.isArray(F)||F.length===0}t.isFalsyOrEmpty=u;function b(F){return Array.isArray(F)&&F.length>0}t.isNonEmptyArray=b;function A(F,B=z=>z){const z=new Set;return F.filter(S=>{const I=B(S);return z.has(I)?!1:(z.add(I),!0)})}t.distinct=A;function N(F){const B=new Set;return z=>{const S=F(z);return B.has(S)?!1:(B.add(S),!0)}}t.uniqueFilter=N;function L(F,B){const z=T(F,B);if(z!==-1)return F[z]}t.findLast=L;function T(F,B){for(let z=F.length-1;z>=0;z--){const S=F[z];if(B(S))return z}return-1}t.lastIndex=T;function c(F,B){return F.length>0?F[0]:B}t.firstOrDefault=c;function C(F,B){return F.length>0?F[F.length-1]:B}t.lastOrDefault=C;function p(F,B,z=(S,I)=>S===I){let S=0;for(let I=0,P=Math.min(F.length,B.length);I<P&&z(F[I],B[I]);I++)S++;return S}t.commonPrefixLength=p;function D(F){return[].concat(...F)}t.flatten=D;function _(F,B){let z=typeof B=="number"?F:0;typeof B=="number"?z=F:(z=0,B=F);const S=[];if(z<=B)for(let I=z;I<B;I++)S.push(I);else for(let I=z;I>B;I--)S.push(I);return S}t.range=_;function V(F,B,z){return F.reduce((S,I)=>(S[B(I)]=z?z(I):I,S),Object.create(null))}t.index=V;function ge(F,B){return F.push(B),()=>Z(F,B)}t.insert=ge;function Z(F,B){const z=F.indexOf(B);if(z>-1)return F.splice(z,1),B}t.remove=Z;function ie(F,B,z){const S=F.slice(0,B),I=F.slice(B);return S.concat(z,I)}t.arrayInsert=ie;function te(F,B){let z;if(typeof B=="number"){let S=B;z=()=>{const I=Math.sin(S++)*179426549;return I-Math.floor(I)}}else z=Math.random;for(let S=F.length-1;S>0;S-=1){const I=Math.floor(z()*(S+1)),P=F[S];F[S]=F[I],F[I]=P}}t.shuffle=te;function he(F,B){const z=F.indexOf(B);z>-1&&(F.splice(z,1),F.unshift(B))}t.pushToStart=he;function re(F,B){const z=F.indexOf(B);z>-1&&(F.splice(z,1),F.push(B))}t.pushToEnd=re;function ce(F,B){for(const z of B)F.push(z)}t.pushMany=ce;function Se(F,B){return Array.isArray(F)?F.map(B):B(F)}t.mapArrayOrNot=Se;function x(F){return Array.isArray(F)?F:[F]}t.asArray=x;function De(F){return F[Math.floor(Math.random()*F.length)]}t.getRandomElement=De;function se(F,B){for(const z of F){const S=B(z);if(S!==void 0)return S}}t.mapFind=se;function Q(F,B,z){const S=de(F,B),I=F.length,P=z.length;F.length=I+P;for(let O=I-1;O>=S;O--)F[O+P]=F[O];for(let O=0;O<P;O++)F[O+S]=z[O]}t.insertInto=Q;function le(F,B,z,S){const I=de(F,B),P=F.splice(I,z);return Q(F,I,S),P}t.splice=le;function de(F,B){return B<0?Math.max(B+F.length,0):Math.min(B,F.length)}var me;(function(F){function B(I){return I<0}F.isLessThan=B;function z(I){return I>0}F.isGreaterThan=z;function S(I){return I===0}F.isNeitherLessOrGreaterThan=S,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(me=t.CompareResult||(t.CompareResult={}));function ee(F,B){return(z,S)=>B(F(z),F(S))}t.compareBy=ee;function k(...F){return(B,z)=>{for(const S of F){const I=S(B,z);if(!me.isNeitherLessOrGreaterThan(I))return I}return me.neitherLessOrGreaterThan}}t.tieBreakComparators=k;const E=(F,B)=>F-B;t.numberComparator=E;function g(F,B){if(F.length===0)return;let z=F[0];for(let S=1;S<F.length;S++){const I=F[S];B(I,z)>0&&(z=I)}return z}t.findMaxBy=g;function R(F,B){if(F.length===0)return;let z=F[0];for(let S=1;S<F.length;S++){const I=F[S];B(I,z)>=0&&(z=I)}return z}t.findLastMaxBy=R;function W(F,B){return g(F,(z,S)=>-B(z,S))}t.findMinBy=W;class ${constructor(B){this.f=B,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(B){let z=this.c;for(;z<this.f.length&&B(this.f[z]);)z++;const S=z===this.c?null:this.f.slice(this.c,z);return this.c=z,S}takeFromEndWhile(B){let z=this.d;for(;z>=0&&B(this.f[z]);)z--;const S=z===this.d?null:this.f.slice(z+1,this.d+1);return this.d=z,S}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const B=this.f[this.c];return this.c++,B}removeLast(){const B=this.f[this.d];return this.d--,B}takeCount(B){const z=this.f.slice(this.c,this.c+B);return this.c+=B,z}}t.ArrayQueue=$;class Y{constructor(B){this.iterate=B}forEach(B){this.iterate(z=>(B(z),!0))}toArray(){const B=[];return this.iterate(z=>(B.push(z),!0)),B}filter(B){return new Y(z=>this.iterate(S=>B(S)?z(S):!0))}map(B){return new Y(z=>this.iterate(S=>z(B(S))))}some(B){let z=!1;return this.iterate(S=>(z=B(S),!z)),z}findFirst(B){let z;return this.iterate(S=>B(S)?(z=S,!1):!0),z}findLast(B){let z;return this.iterate(S=>(B(S)&&(z=S),!0)),z}findLastMaxBy(B){let z,S=!0;return this.iterate(I=>((S||me.isGreaterThan(B(I,z)))&&(S=!1,z=I),!0)),z}}t.CallbackIterable=Y,Y.empty=new Y(F=>{})}),define(be[72],pe([1,0,9]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function i(d,m){if(!d)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}t.ok=i;function U(d,m="Unreachable"){throw new Error(m)}t.assertNever=U;function H(d){if(!d)throw new v.BugIndicatingError("Assertion Failed")}t.assert=H;function y(d){if(!d()){debugger;d(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}t.assertFn=y;function w(d,m){let f=0;for(;f<d.length-1;){const M=d[f],o=d[f+1];if(!m(M,o))return!1;f++}return!0}t.checkAdjacentItems=w}),define(be[42],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function v(i){const U=this;let H=!1,y;return function(){return H||(H=!0,y=i.apply(U,arguments)),y}}t.once=v}),define(be[73],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class v{constructor(U){this.a=U,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=v,t.defaultGenerator=new v("id#")}),define(be[25],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(i){function U(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}i.is=U;const H=Object.freeze([]);function y(){return H}i.empty=y;function*w(u){yield u}i.single=w;function d(u){return U(u)?u:w(u)}i.wrap=d;function m(u){return u||H}i.from=m;function f(u){return!u||u[Symbol.iterator]().next().done===!0}i.isEmpty=f;function M(u){return u[Symbol.iterator]().next().value}i.first=M;function o(u,b){for(const A of u)if(b(A))return!0;return!1}i.some=o;function n(u,b){for(const A of u)if(b(A))return A}i.find=n;function*e(u,b){for(const A of u)b(A)&&(yield A)}i.filter=e;function*s(u,b){let A=0;for(const N of u)yield b(N,A++)}i.map=s;function*a(...u){for(const b of u)for(const A of b)yield A}i.concat=a;function l(u,b,A){let N=A;for(const L of u)N=b(N,L);return N}i.reduce=l;function*h(u,b,A=u.length){for(b<0&&(b+=u.length),A<0?A+=u.length:A>u.length&&(A=u.length);b<A;b++)yield u[b]}i.slice=h;function r(u,b=Number.POSITIVE_INFINITY){const A=[];if(b===0)return[A,u];const N=u[Symbol.iterator]();for(let L=0;L<b;L++){const T=N.next();if(T.done)return[A,i.empty()];A.push(T.value)}return[A,{[Symbol.iterator](){return N}}]}i.consume=r})(v=t.Iterable||(t.Iterable={}))}),define(be[43],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(v=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class U{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,a){this._keyCodeToStr[s]=a,this._strToKeyCode[a.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const H=new U,y=new U,w=new U;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],m=Object.create(null),f=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>m[e]||0,toString:e=>d[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",s=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],a=[],l=[];for(const h of s){const[r,u,b,A,N,L,T,c,C,p]=h;if(l[b]||(l[b]=!0,d[b]=A,m[A]=b,f[A.toLowerCase()]=b,u&&(t.IMMUTABLE_CODE_TO_KEY_CODE[b]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[N]=b))),!a[N]){if(a[N]=!0,!L)throw new Error(`String representation missing for key code ${N} around scan code ${A}`);H.define(N,L),y.define(N,C||L),w.define(N,p||C||L)}T&&(t.EVENT_KEY_CODE_MAP[T]=N),c&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[c]=N)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(e){function s(b){return H.keyCodeToStr(b)}e.toString=s;function a(b){return H.strToKeyCode(b)}e.fromString=a;function l(b){return y.keyCodeToStr(b)}e.toUserSettingsUS=l;function h(b){return w.keyCodeToStr(b)}e.toUserSettingsGeneral=h;function r(b){return y.strToKeyCode(b)||w.strToKeyCode(b)}e.fromUserSettings=r;function u(b){if(b>=93&&b<=108)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(b)}e.toElectronAccelerator=u})(M=t.KeyCodeUtils||(t.KeyCodeUtils={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o=t.KeyMod||(t.KeyMod={}));function n(e,s){const a=(s&65535)<<16>>>0;return(e|a)>>>0}t.KeyChord=n}),define(be[74],pe([1,0,9]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(M){M[M.CtrlCmd=2048]="CtrlCmd",M[M.Shift=1024]="Shift",M[M.Alt=512]="Alt",M[M.WinCtrl=256]="WinCtrl",M[M.KeyCode=255]="KeyCode"})(i||(i={}));function U(M,o){if(M===0)return null;const n=(M&65535)>>>0,e=(M&4294901760)>>>16;return e!==0?new w([H(n,o),H(e,o)]):new w([H(n,o)])}t.createKeybinding=U;function H(M,o){const n=!!(M&2048),e=!!(M&256),s=o===2?e:n,a=!!(M&1024),l=!!(M&512),h=o===2?n:e,r=M&255;return new y(s,a,l,h,r)}t.createSimpleKeybinding=H;class y{constructor(o,n,e,s,a){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyCode=a}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",n=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`${o}${n}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=y;class w{constructor(o){if(o.length===0)throw(0,v.illegalArgument)("parts");this.parts=o}getHashCode(){let o="";for(let n=0,e=this.parts.length;n<e;n++)n!==0&&(o+=";"),o+=this.parts[n].getHashCode();return o}equals(o){if(o===null||this.parts.length!==o.parts.length)return!1;for(let n=0;n<this.parts.length;n++)if(!this.parts[n].equals(o.parts[n]))return!1;return!0}}t.ChordKeybinding=w;class d{constructor(o,n,e,s,a){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.scanCode=a}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=d;class m{constructor(o,n,e,s,a,l){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyLabel=a,this.keyAriaLabel=l}}t.ResolvedKeybindingPart=m;class f{}t.ResolvedKeybinding=f}),define(be[44],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class v{constructor(U){this.d=U,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(U){this.c=U}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(U){return new v(()=>U(this.getValue()))}}t.Lazy=v}),define(be[2],pe([1,0,42,25]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const U=!1;let H=null;function y(C){H=C}if(t.setDisposableTracker=y,U){const C="__is_disposable_tracked__";y(new class{trackDisposable(p){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[C]||console.log(D)},3e3)}setParent(p,D){if(p&&p!==h.None)try{p[C]=!0}catch{}}markAsDisposed(p){if(p&&p!==h.None)try{p[C]=!0}catch{}}markAsSingleton(p){}})}function w(C){return H?.trackDisposable(C),C}function d(C){H?.markAsDisposed(C)}function m(C,p){H?.setParent(C,p)}function f(C,p){if(!!H)for(const D of C)H.setParent(D,p)}function M(C){return H?.markAsSingleton(C),C}t.markAsSingleton=M;function o(C){return typeof C.dispose=="function"&&C.dispose.length===0}t.isDisposable=o;function n(C){if(i.Iterable.is(C)){const p=[];for(const D of C)if(D)try{D.dispose()}catch(_){p.push(_)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}t.dispose=n;function e(C){for(const p of C)o(p)&&p.dispose();return[]}t.disposeIfDisposable=e;function s(...C){const p=a(()=>n(C));return f(C,p),p}t.combinedDisposable=s;function a(C){const p=w({dispose:(0,v.once)(()=>{d(p),C()})});return p}t.toDisposable=a;class l{constructor(){this.c=new Set,this.f=!1,w(this)}dispose(){this.f||(d(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{n(this.c)}finally{this.c.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return m(p,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(p),p}}t.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this.q=new l,w(this),m(this.q,this)}dispose(){d(this),this.q.dispose()}B(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(p)}}t.Disposable=h,h.None=Object.freeze({dispose(){}});class r{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(p){this.b||p===this.a||(this.a?.dispose(),p&&m(p,this),this.a=p)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const p=this.a;return this.a=void 0,p&&m(p,null),p}}t.MutableDisposable=r;class u{constructor(p){this.b=p,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=u;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(p){let D=p;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,d(this))},this}}t.SafeDisposable=b;class A{constructor(){this.a=new Map}acquire(p,...D){let _=this.a.get(p);_||(_={counter:0,object:this.b(p,...D)},this.a.set(p,_));const{object:V}=_,ge=(0,v.once)(()=>{--_.counter===0&&(this.c(p,_.object),this.a.delete(p))});return _.counter++,{object:V,dispose:ge}}}t.ReferenceCollection=A;class N{constructor(p){this.a=p}async acquire(p,...D){const _=this.a.acquire(p,...D);try{return{object:await _.object,dispose:()=>_.dispose()}}catch(V){throw _.dispose(),V}}}t.AsyncReferenceCollection=N;class L{constructor(p){this.object=p}dispose(){}}t.ImmortalReference=L;function T(C){const p=new l;try{C(p)}finally{p.dispose()}}t.disposeOnReturn=T;class c{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{n(this.a.values())}finally{this.a.clear()}}has(p){return this.a.has(p)}get(p){return this.a.get(p)}set(p,D,_=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),_||this.a.get(p)?.dispose(),this.a.set(p,D)}deleteAndDispose(p){this.a.get(p)?.dispose(),this.a.delete(p)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=c}),define(be[45],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class v{constructor(H){this.element=H,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class i{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let H=this.a;for(;H!==v.Undefined;){const y=H.next;H.prev=v.Undefined,H.next=v.Undefined,H=y}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,y){const w=new v(H);if(this.a===v.Undefined)this.a=w,this.b=w;else if(y){const m=this.b;this.b=w,w.prev=m,m.next=w}else{const m=this.a;this.a=w,w.next=m,m.prev=w}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(w))}}shift(){if(this.a!==v.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==v.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==v.Undefined&&H.next!==v.Undefined){const y=H.prev;y.next=H.next,H.next.prev=y}else H.prev===v.Undefined&&H.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):H.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):H.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==v.Undefined;)yield H.element,H=H.next}}t.LinkedList=i}),define(be[75],pe([1,0]),function(X,t){"use strict";var v,i,U;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function H(e,s,a){let l=e.get(s);return l===void 0&&(l=a,e.set(s,l)),l}t.getOrSet=H;function y(e){const s=[];return e.forEach((a,l)=>{s.push(`${l} => ${a}`)}),`Map(${e.size}) {${s.join(", ")}}`}t.mapToString=y;function w(e){const s=[];return e.forEach(a=>{s.push(a)}),`Set(${e.size}) {${s.join(", ")}}`}t.setToString=w;class d{constructor(s,a){this.uri=s,this.value=a}}class m{constructor(s,a){this[v]="ResourceMap",s instanceof m?(this.b=new Map(s.b),this.c=a??m.a):(this.b=new Map,this.c=s??m.a)}set(s,a){return this.b.set(this.c(s),new d(s,a)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,a){typeof a<"u"&&(s=s.bind(a));for(const[l,h]of this.b)s(h.value,h.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}t.ResourceMap=m,m.a=e=>e.toString();class f{constructor(s,a){this[i]="ResourceSet",!s||typeof s=="function"?this.a=new m(s):(this.a=new m(a),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,a){this.a.forEach((l,h)=>s.call(a,h,h,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=f;var M;(function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"})(M=t.Touch||(t.Touch={}));class o{constructor(){this[U]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,a=0){const l=this.a.get(s);if(!!l)return a!==0&&this.j(l,a),l.value}set(s,a,l=0){let h=this.a.get(s);if(h)h.value=a,l!==0&&this.j(h,l);else{switch(h={key:s,value:a,next:void 0,previous:void 0},l){case 0:this.h(h);break;case 1:this.g(h);break;case 2:this.h(h);break;default:this.h(h);break}this.a.set(s,h),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const a=this.a.get(s);if(!!a)return this.a.delete(s),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,a){const l=this.e;let h=this.b;for(;h;){if(a?s.bind(a)(h.value,h.key,this):s(h.value,h.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const s=this,a=this.e;let l=this.b;const h={[Symbol.iterator](){return h},next(){if(s.e!==a)throw new Error("LinkedMap got modified during iteration.");if(l){const r={value:l.key,done:!1};return l=l.next,r}else return{value:void 0,done:!0}}};return h}values(){const s=this,a=this.e;let l=this.b;const h={[Symbol.iterator](){return h},next(){if(s.e!==a)throw new Error("LinkedMap got modified during iteration.");if(l){const r={value:l.value,done:!1};return l=l.next,r}else return{value:void 0,done:!0}}};return h}entries(){const s=this,a=this.e;let l=this.b;const h={[Symbol.iterator](){return h},next(){if(s.e!==a)throw new Error("LinkedMap got modified during iteration.");if(l){const r={value:[l.key,l.value],done:!1};return l=l.next,r}else return{value:void 0,done:!0}}};return h}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let a=this.b,l=this.size;for(;a&&l>s;)this.a.delete(a.key),a=a.next,l--;this.b=a,this.d=l,a&&(a.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const a=s.next,l=s.previous;if(!a||!l)throw new Error("Invalid list");a.previous=l,l.next=a}s.next=void 0,s.previous=void 0,this.e++}j(s,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(s===this.b)return;const l=s.next,h=s.previous;s===this.c?(h.next=void 0,this.c=h):(l.previous=h,h.next=l),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(a===2){if(s===this.c)return;const l=s.next,h=s.previous;s===this.b?(l.previous=void 0,this.b=l):(l.previous=h,h.next=l),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((a,l)=>{s.push([l,a])}),s}fromJSON(s){this.clear();for(const[a,l]of s)this.set(a,l)}}t.LinkedMap=o;class n extends o{constructor(s,a=1){super(),this.k=s,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,a=2){return super.get(s,a)}peek(s){return super.get(s,0)}set(s,a){return super.set(s,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=n}),function(X,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(be[76],pe([0]),t):(X=typeof globalThis<"u"?globalThis:X||self,t(X.marked={}))}(this,function(X){"use strict";function t(F,B){for(var z=0;z<B.length;z++){var S=B[z];S.enumerable=S.enumerable||!1,S.configurable=!0,"value"in S&&(S.writable=!0),Object.defineProperty(F,S.key,S)}}function v(F,B,z){return B&&t(F.prototype,B),z&&t(F,z),Object.defineProperty(F,"prototype",{writable:!1}),F}function i(F,B){if(!!F){if(typeof F=="string")return U(F,B);var z=Object.prototype.toString.call(F).slice(8,-1);if(z==="Object"&&F.constructor&&(z=F.constructor.name),z==="Map"||z==="Set")return Array.from(F);if(z==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(z))return U(F,B)}}function U(F,B){(B==null||B>F.length)&&(B=F.length);for(var z=0,S=new Array(B);z<B;z++)S[z]=F[z];return S}function H(F,B){var z=typeof Symbol<"u"&&F[Symbol.iterator]||F["@@iterator"];if(z)return(z=z.call(F)).next.bind(z);if(Array.isArray(F)||(z=i(F))||B&&F&&typeof F.length=="number"){z&&(F=z);var S=0;return function(){return S>=F.length?{done:!0}:{done:!1,value:F[S++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}X.defaults=y();function w(F){X.defaults=F}var d=/[&<>"']/,m=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,M=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},n=function(B){return o[B]};function e(F,B){if(B){if(d.test(F))return F.replace(m,n)}else if(f.test(F))return F.replace(M,n);return F}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(F){return F.replace(s,function(B,z){return z=z.toLowerCase(),z==="colon"?":":z.charAt(0)==="#"?z.charAt(1)==="x"?String.fromCharCode(parseInt(z.substring(2),16)):String.fromCharCode(+z.substring(1)):""})}var l=/(^|[^\[])\^/g;function h(F,B){F=typeof F=="string"?F:F.source,B=B||"";var z={replace:function(I,P){return P=P.source||P,P=P.replace(l,"$1"),F=F.replace(I,P),z},getRegex:function(){return new RegExp(F,B)}};return z}var r=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(F,B,z){if(F){var S;try{S=decodeURIComponent(a(z)).replace(r,"").toLowerCase()}catch{return null}if(S.indexOf("javascript:")===0||S.indexOf("vbscript:")===0||S.indexOf("data:")===0)return null}B&&!u.test(z)&&(z=c(B,z));try{z=encodeURI(z).replace(/%25/g,"%")}catch{return null}return z}var A={},N=/^[^:]+:\/*[^/]*$/,L=/^([^:]+:)[\s\S]*$/,T=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(F,B){A[" "+F]||(N.test(F)?A[" "+F]=F+"/":A[" "+F]=_(F,"/",!0)),F=A[" "+F];var z=F.indexOf(":")===-1;return B.substring(0,2)==="//"?z?B:F.replace(L,"$1")+B:B.charAt(0)==="/"?z?B:F.replace(T,"$1")+B:F+B}var C={exec:function(){}};function p(F){for(var B=1,z,S;B<arguments.length;B++){z=arguments[B];for(S in z)Object.prototype.hasOwnProperty.call(z,S)&&(F[S]=z[S])}return F}function D(F,B){var z=F.replace(/\|/g,function(P,O,j){for(var J=!1,ae=O;--ae>=0&&j[ae]==="\\";)J=!J;return J?"|":" |"}),S=z.split(/ \|/),I=0;if(S[0].trim()||S.shift(),S.length>0&&!S[S.length-1].trim()&&S.pop(),S.length>B)S.splice(B);else for(;S.length<B;)S.push("");for(;I<S.length;I++)S[I]=S[I].trim().replace(/\\\|/g,"|");return S}function _(F,B,z){var S=F.length;if(S===0)return"";for(var I=0;I<S;){var P=F.charAt(S-I-1);if(P===B&&!z)I++;else if(P!==B&&z)I++;else break}return F.slice(0,S-I)}function V(F,B){if(F.indexOf(B[1])===-1)return-1;for(var z=F.length,S=0,I=0;I<z;I++)if(F[I]==="\\")I++;else if(F[I]===B[0])S++;else if(F[I]===B[1]&&(S--,S<0))return I;return-1}function ge(F){F&&F.sanitize&&!F.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Z(F,B){if(B<1)return"";for(var z="";B>1;)B&1&&(z+=F),B>>=1,F+=F;return z+F}function ie(F,B,z,S){var I=B.href,P=B.title?e(B.title):null,O=F[1].replace(/\\([\[\]])/g,"$1");if(F[0].charAt(0)!=="!"){S.state.inLink=!0;var j={type:"link",raw:z,href:I,title:P,text:O,tokens:S.inlineTokens(O)};return S.state.inLink=!1,j}return{type:"image",raw:z,href:I,title:P,text:e(O)}}function te(F,B){var z=F.match(/^(\s+)(?:```)/);if(z===null)return B;var S=z[1];return B.split(`
`).map(function(I){var P=I.match(/^\s+/);if(P===null)return I;var O=P[0];return O.length>=S.length?I.slice(S.length):I}).join(`
`)}var he=function(){function F(z){this.options=z||X.defaults}var B=F.prototype;return B.space=function(S){var I=this.rules.block.newline.exec(S);if(I&&I[0].length>0)return{type:"space",raw:I[0]}},B.code=function(S){var I=this.rules.block.code.exec(S);if(I){var P=I[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:I[0],codeBlockStyle:"indented",text:this.options.pedantic?P:_(P,`
`)}}},B.fences=function(S){var I=this.rules.block.fences.exec(S);if(I){var P=I[0],O=te(P,I[3]||"");return{type:"code",raw:P,lang:I[2]?I[2].trim():I[2],text:O}}},B.heading=function(S){var I=this.rules.block.heading.exec(S);if(I){var P=I[2].trim();if(/#$/.test(P)){var O=_(P,"#");(this.options.pedantic||!O||/ $/.test(O))&&(P=O.trim())}return{type:"heading",raw:I[0],depth:I[1].length,text:P,tokens:this.lexer.inline(P)}}},B.hr=function(S){var I=this.rules.block.hr.exec(S);if(I)return{type:"hr",raw:I[0]}},B.blockquote=function(S){var I=this.rules.block.blockquote.exec(S);if(I){var P=I[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:I[0],tokens:this.lexer.blockTokens(P,[]),text:P}}},B.list=function(S){var I=this.rules.block.list.exec(S);if(I){var P,O,j,J,ae,ue,ye,Ee,Ie,ke,ve,Pe,Re=I[1].trim(),je=Re.length>1,Ue={type:"list",raw:"",ordered:je,start:je?+Re.slice(0,-1):"",loose:!1,items:[]};Re=je?"\\d{1,9}\\"+Re.slice(-1):"\\"+Re,this.options.pedantic&&(Re=je?Re:"[*+-]");for(var We=new RegExp("^( {0,3}"+Re+")((?:[	 ][^\\n]*)?(?:\\n|$))");S&&(Pe=!1,!(!(I=We.exec(S))||this.rules.block.hr.test(S)));){if(P=I[0],S=S.substring(P.length),Ee=I[2].split(`
`,1)[0],Ie=S.split(`
`,1)[0],this.options.pedantic?(J=2,ve=Ee.trimLeft()):(J=I[2].search(/[^ ]/),J=J>4?1:J,ve=Ee.slice(J),J+=I[1].length),ue=!1,!Ee&&/^ *$/.test(Ie)&&(P+=Ie+`
`,S=S.substring(Ie.length+1),Pe=!0),!Pe)for(var xe=new RegExp("^ {0,"+Math.min(3,J-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,J-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Be=new RegExp("^ {0,"+Math.min(3,J-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,J-1)+"}#");S&&(ke=S.split(`
`,1)[0],Ee=ke,this.options.pedantic&&(Ee=Ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Be.test(Ee)||Ve.test(Ee)||xe.test(Ee)||it.test(S)));){if(Ee.search(/[^ ]/)>=J||!Ee.trim())ve+=`
`+Ee.slice(J);else if(!ue)ve+=`
`+Ee;else break;!ue&&!Ee.trim()&&(ue=!0),P+=ke+`
`,S=S.substring(ke.length+1)}Ue.loose||(ye?Ue.loose=!0:/\n *\n *$/.test(P)&&(ye=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(ve),O&&(j=O[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:P,task:!!O,checked:j,loose:!1,text:ve}),Ue.raw+=P}Ue.items[Ue.items.length-1].raw=P.trimRight(),Ue.items[Ue.items.length-1].text=ve.trimRight(),Ue.raw=Ue.raw.trimRight();var Ye=Ue.items.length;for(ae=0;ae<Ye;ae++){this.lexer.state.top=!1,Ue.items[ae].tokens=this.lexer.blockTokens(Ue.items[ae].text,[]);var K=Ue.items[ae].tokens.filter(function(we){return we.type==="space"}),oe=K.every(function(we){for(var Ce=we.raw.split(""),Te=0,Oe=H(Ce),$e;!($e=Oe()).done;){var tt=$e.value;if(tt===`
`&&(Te+=1),Te>1)return!0}return!1});!Ue.loose&&K.length&&oe&&(Ue.loose=!0,Ue.items[ae].loose=!0)}return Ue}},B.html=function(S){var I=this.rules.block.html.exec(S);if(I){var P={type:"html",raw:I[0],pre:!this.options.sanitizer&&(I[1]==="pre"||I[1]==="script"||I[1]==="style"),text:I[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]);P.type="paragraph",P.text=O,P.tokens=this.lexer.inline(O)}return P}},B.def=function(S){var I=this.rules.block.def.exec(S);if(I){I[3]&&(I[3]=I[3].substring(1,I[3].length-1));var P=I[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:P,raw:I[0],href:I[2],title:I[3]}}},B.table=function(S){var I=this.rules.block.table.exec(S);if(I){var P={type:"table",header:D(I[1]).map(function(ye){return{text:ye}}),align:I[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:I[3]&&I[3].trim()?I[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(P.header.length===P.align.length){P.raw=I[0];var O=P.align.length,j,J,ae,ue;for(j=0;j<O;j++)/^ *-+: *$/.test(P.align[j])?P.align[j]="right":/^ *:-+: *$/.test(P.align[j])?P.align[j]="center":/^ *:-+ *$/.test(P.align[j])?P.align[j]="left":P.align[j]=null;for(O=P.rows.length,j=0;j<O;j++)P.rows[j]=D(P.rows[j],P.header.length).map(function(ye){return{text:ye}});for(O=P.header.length,J=0;J<O;J++)P.header[J].tokens=this.lexer.inline(P.header[J].text);for(O=P.rows.length,J=0;J<O;J++)for(ue=P.rows[J],ae=0;ae<ue.length;ae++)ue[ae].tokens=this.lexer.inline(ue[ae].text);return P}}},B.lheading=function(S){var I=this.rules.block.lheading.exec(S);if(I)return{type:"heading",raw:I[0],depth:I[2].charAt(0)==="="?1:2,text:I[1],tokens:this.lexer.inline(I[1])}},B.paragraph=function(S){var I=this.rules.block.paragraph.exec(S);if(I){var P=I[1].charAt(I[1].length-1)===`
`?I[1].slice(0,-1):I[1];return{type:"paragraph",raw:I[0],text:P,tokens:this.lexer.inline(P)}}},B.text=function(S){var I=this.rules.block.text.exec(S);if(I)return{type:"text",raw:I[0],text:I[0],tokens:this.lexer.inline(I[0])}},B.escape=function(S){var I=this.rules.inline.escape.exec(S);if(I)return{type:"escape",raw:I[0],text:e(I[1])}},B.tag=function(S){var I=this.rules.inline.tag.exec(S);if(I)return!this.lexer.state.inLink&&/^<a /i.test(I[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(I[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(I[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(I[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:I[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]):I[0]}},B.link=function(S){var I=this.rules.inline.link.exec(S);if(I){var P=I[2].trim();if(!this.options.pedantic&&/^</.test(P)){if(!/>$/.test(P))return;var O=_(P.slice(0,-1),"\\");if((P.length-O.length)%2===0)return}else{var j=V(I[2],"()");if(j>-1){var J=I[0].indexOf("!")===0?5:4,ae=J+I[1].length+j;I[2]=I[2].substring(0,j),I[0]=I[0].substring(0,ae).trim(),I[3]=""}}var ue=I[2],ye="";if(this.options.pedantic){var Ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ue);Ee&&(ue=Ee[1],ye=Ee[3])}else ye=I[3]?I[3].slice(1,-1):"";return ue=ue.trim(),/^</.test(ue)&&(this.options.pedantic&&!/>$/.test(P)?ue=ue.slice(1):ue=ue.slice(1,-1)),ie(I,{href:ue&&ue.replace(this.rules.inline._escapes,"$1"),title:ye&&ye.replace(this.rules.inline._escapes,"$1")},I[0],this.lexer)}},B.reflink=function(S,I){var P;if((P=this.rules.inline.reflink.exec(S))||(P=this.rules.inline.nolink.exec(S))){var O=(P[2]||P[1]).replace(/\s+/g," ");if(O=I[O.toLowerCase()],!O||!O.href){var j=P[0].charAt(0);return{type:"text",raw:j,text:j}}return ie(P,O,P[0],this.lexer)}},B.emStrong=function(S,I,P){P===void 0&&(P="");var O=this.rules.inline.emStrong.lDelim.exec(S);if(!!O&&!(O[3]&&P.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=O[1]||O[2]||"";if(!j||j&&(P===""||this.rules.inline.punctuation.exec(P))){var J=O[0].length-1,ae,ue,ye=J,Ee=0,Ie=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ie.lastIndex=0,I=I.slice(-1*S.length+J);(O=Ie.exec(I))!=null;)if(ae=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!ae){if(ue=ae.length,O[3]||O[4]){ye+=ue;continue}else if((O[5]||O[6])&&J%3&&!((J+ue)%3)){Ee+=ue;continue}if(ye-=ue,!(ye>0)){if(ue=Math.min(ue,ue+ye+Ee),Math.min(J,ue)%2){var ke=S.slice(1,J+O.index+ue);return{type:"em",raw:S.slice(0,J+O.index+ue+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var ve=S.slice(2,J+O.index+ue-1);return{type:"strong",raw:S.slice(0,J+O.index+ue+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},B.codespan=function(S){var I=this.rules.inline.code.exec(S);if(I){var P=I[2].replace(/\n/g," "),O=/[^ ]/.test(P),j=/^ /.test(P)&&/ $/.test(P);return O&&j&&(P=P.substring(1,P.length-1)),P=e(P,!0),{type:"codespan",raw:I[0],text:P}}},B.br=function(S){var I=this.rules.inline.br.exec(S);if(I)return{type:"br",raw:I[0]}},B.del=function(S){var I=this.rules.inline.del.exec(S);if(I)return{type:"del",raw:I[0],text:I[2],tokens:this.lexer.inlineTokens(I[2])}},B.autolink=function(S,I){var P=this.rules.inline.autolink.exec(S);if(P){var O,j;return P[2]==="@"?(O=e(this.options.mangle?I(P[1]):P[1]),j="mailto:"+O):(O=e(P[1]),j=O),{type:"link",raw:P[0],text:O,href:j,tokens:[{type:"text",raw:O,text:O}]}}},B.url=function(S,I){var P;if(P=this.rules.inline.url.exec(S)){var O,j;if(P[2]==="@")O=e(this.options.mangle?I(P[0]):P[0]),j="mailto:"+O;else{var J;do J=P[0],P[0]=this.rules.inline._backpedal.exec(P[0])[0];while(J!==P[0]);O=e(P[0]),P[1]==="www."?j="http://"+O:j=O}return{type:"link",raw:P[0],text:O,href:j,tokens:[{type:"text",raw:O,text:O}]}}},B.inlineText=function(S,I){var P=this.rules.inline.text.exec(S);if(P){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(P[0]):e(P[0]):P[0]:O=e(this.options.smartypants?I(P[0]):P[0]),{type:"text",raw:P[0],text:O}}},F}(),re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:C,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=h(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.listItemStart=h(/^( *)(bull) */).replace("bull",re.bullet).getRegex(),re.list=h(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=h(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=h(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.blockquote=h(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=p({},re),re.gfm=p({},re.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.table=h(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.gfm.paragraph=h(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",re.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.pedantic=p({},re.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:C,paragraph:h(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ce={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:C,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:C,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ce._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ce.punctuation=h(ce.punctuation).replace(/punctuation/g,ce._punctuation).getRegex(),ce.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ce.escapedEmSt=/\\\*|\\_/g,ce._comment=h(re._comment).replace("(?:-->|$)","-->").getRegex(),ce.emStrong.lDelim=h(ce.emStrong.lDelim).replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimAst=h(ce.emStrong.rDelimAst,"g").replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimUnd=h(ce.emStrong.rDelimUnd,"g").replace(/punct/g,ce._punctuation).getRegex(),ce._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ce._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ce._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ce.autolink=h(ce.autolink).replace("scheme",ce._scheme).replace("email",ce._email).getRegex(),ce._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ce.tag=h(ce.tag).replace("comment",ce._comment).replace("attribute",ce._attribute).getRegex(),ce._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ce._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ce._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ce.link=h(ce.link).replace("label",ce._label).replace("href",ce._href).replace("title",ce._title).getRegex(),ce.reflink=h(ce.reflink).replace("label",ce._label).replace("ref",re._label).getRegex(),ce.nolink=h(ce.nolink).replace("ref",re._label).getRegex(),ce.reflinkSearch=h(ce.reflinkSearch,"g").replace("reflink",ce.reflink).replace("nolink",ce.nolink).getRegex(),ce.normal=p({},ce),ce.pedantic=p({},ce.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",ce._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ce._label).getRegex()}),ce.gfm=p({},ce.normal,{escape:h(ce.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ce.gfm.url=h(ce.gfm.url,"i").replace("email",ce.gfm._extended_email).getRegex(),ce.breaks=p({},ce.gfm,{br:h(ce.br).replace("{2,}","*").getRegex(),text:h(ce.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Se(F){return F.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(F){var B="",z,S,I=F.length;for(z=0;z<I;z++)S=F.charCodeAt(z),Math.random()>.5&&(S="x"+S.toString(16)),B+="&#"+S+";";return B}var De=function(){function F(z){this.tokens=[],this.tokens.links=Object.create(null),this.options=z||X.defaults,this.options.tokenizer=this.options.tokenizer||new he,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var S={block:re.normal,inline:ce.normal};this.options.pedantic?(S.block=re.pedantic,S.inline=ce.pedantic):this.options.gfm&&(S.block=re.gfm,this.options.breaks?S.inline=ce.breaks:S.inline=ce.gfm),this.tokenizer.rules=S}F.lex=function(S,I){var P=new F(I);return P.lex(S)},F.lexInline=function(S,I){var P=new F(I);return P.inlineTokens(S)};var B=F.prototype;return B.lex=function(S){S=S.replace(/\r\n|\r/g,`
`),this.blockTokens(S,this.tokens);for(var I;I=this.inlineQueue.shift();)this.inlineTokens(I.src,I.tokens);return this.tokens},B.blockTokens=function(S,I){var P=this;I===void 0&&(I=[]),this.options.pedantic?S=S.replace(/\t/g,"    ").replace(/^ +$/gm,""):S=S.replace(/^( *)(\t+)/gm,function(ye,Ee,Ie){return Ee+"    ".repeat(Ie.length)});for(var O,j,J,ae;S;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ye){return(O=ye.call({lexer:P},S,I))?(S=S.substring(O.raw.length),I.push(O),!0):!1}))){if(O=this.tokenizer.space(S)){S=S.substring(O.raw.length),O.raw.length===1&&I.length>0?I[I.length-1].raw+=`
`:I.push(O);continue}if(O=this.tokenizer.code(S)){S=S.substring(O.raw.length),j=I[I.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+O.raw,j.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):I.push(O);continue}if(O=this.tokenizer.fences(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.heading(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.hr(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.blockquote(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.list(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.html(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.def(S)){S=S.substring(O.raw.length),j=I[I.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+O.raw,j.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.lheading(S)){S=S.substring(O.raw.length),I.push(O);continue}if(J=S,this.options.extensions&&this.options.extensions.startBlock&&function(){var ye=1/0,Ee=S.slice(1),Ie=void 0;P.options.extensions.startBlock.forEach(function(ke){Ie=ke.call({lexer:this},Ee),typeof Ie=="number"&&Ie>=0&&(ye=Math.min(ye,Ie))}),ye<1/0&&ye>=0&&(J=S.substring(0,ye+1))}(),this.state.top&&(O=this.tokenizer.paragraph(J))){j=I[I.length-1],ae&&j.type==="paragraph"?(j.raw+=`
`+O.raw,j.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):I.push(O),ae=J.length!==S.length,S=S.substring(O.raw.length);continue}if(O=this.tokenizer.text(S)){S=S.substring(O.raw.length),j=I[I.length-1],j&&j.type==="text"?(j.raw+=`
`+O.raw,j.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):I.push(O);continue}if(S){var ue="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return this.state.top=!0,I},B.inline=function(S,I){return I===void 0&&(I=[]),this.inlineQueue.push({src:S,tokens:I}),I},B.inlineTokens=function(S,I){var P=this;I===void 0&&(I=[]);var O,j,J,ae=S,ue,ye,Ee;if(this.tokens.links){var Ie=Object.keys(this.tokens.links);if(Ie.length>0)for(;(ue=this.tokenizer.rules.inline.reflinkSearch.exec(ae))!=null;)Ie.includes(ue[0].slice(ue[0].lastIndexOf("[")+1,-1))&&(ae=ae.slice(0,ue.index)+"["+Z("a",ue[0].length-2)+"]"+ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ue=this.tokenizer.rules.inline.blockSkip.exec(ae))!=null;)ae=ae.slice(0,ue.index)+"["+Z("a",ue[0].length-2)+"]"+ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ue=this.tokenizer.rules.inline.escapedEmSt.exec(ae))!=null;)ae=ae.slice(0,ue.index)+"++"+ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;S;)if(ye||(Ee=""),ye=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(O=ve.call({lexer:P},S,I))?(S=S.substring(O.raw.length),I.push(O),!0):!1}))){if(O=this.tokenizer.escape(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.tag(S)){S=S.substring(O.raw.length),j=I[I.length-1],j&&O.type==="text"&&j.type==="text"?(j.raw+=O.raw,j.text+=O.text):I.push(O);continue}if(O=this.tokenizer.link(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.reflink(S,this.tokens.links)){S=S.substring(O.raw.length),j=I[I.length-1],j&&O.type==="text"&&j.type==="text"?(j.raw+=O.raw,j.text+=O.text):I.push(O);continue}if(O=this.tokenizer.emStrong(S,ae,Ee)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.codespan(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.br(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.del(S)){S=S.substring(O.raw.length),I.push(O);continue}if(O=this.tokenizer.autolink(S,x)){S=S.substring(O.raw.length),I.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(S,x))){S=S.substring(O.raw.length),I.push(O);continue}if(J=S,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Pe=S.slice(1),Re=void 0;P.options.extensions.startInline.forEach(function(je){Re=je.call({lexer:this},Pe),typeof Re=="number"&&Re>=0&&(ve=Math.min(ve,Re))}),ve<1/0&&ve>=0&&(J=S.substring(0,ve+1))}(),O=this.tokenizer.inlineText(J,Se)){S=S.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Ee=O.raw.slice(-1)),ye=!0,j=I[I.length-1],j&&j.type==="text"?(j.raw+=O.raw,j.text+=O.text):I.push(O);continue}if(S){var ke="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return I},v(F,null,[{key:"rules",get:function(){return{block:re,inline:ce}}}]),F}(),se=function(){function F(z){this.options=z||X.defaults}var B=F.prototype;return B.code=function(S,I,P){var O=(I||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(S,O);j!=null&&j!==S&&(P=!0,S=j)}return S=S.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+e(O,!0)+'">'+(P?S:e(S,!0))+`</code></pre>
`:"<pre><code>"+(P?S:e(S,!0))+`</code></pre>
`},B.blockquote=function(S){return`<blockquote>
`+S+`</blockquote>
`},B.html=function(S){return S},B.heading=function(S,I,P,O){if(this.options.headerIds){var j=this.options.headerPrefix+O.slug(P);return"<h"+I+' id="'+j+'">'+S+"</h"+I+`>
`}return"<h"+I+">"+S+"</h"+I+`>
`},B.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},B.list=function(S,I,P){var O=I?"ol":"ul",j=I&&P!==1?' start="'+P+'"':"";return"<"+O+j+`>
`+S+"</"+O+`>
`},B.listitem=function(S){return"<li>"+S+`</li>
`},B.checkbox=function(S){return"<input "+(S?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},B.paragraph=function(S){return"<p>"+S+`</p>
`},B.table=function(S,I){return I&&(I="<tbody>"+I+"</tbody>"),`<table>
<thead>
`+S+`</thead>
`+I+`</table>
`},B.tablerow=function(S){return`<tr>
`+S+`</tr>
`},B.tablecell=function(S,I){var P=I.header?"th":"td",O=I.align?"<"+P+' align="'+I.align+'">':"<"+P+">";return O+S+("</"+P+`>
`)},B.strong=function(S){return"<strong>"+S+"</strong>"},B.em=function(S){return"<em>"+S+"</em>"},B.codespan=function(S){return"<code>"+S+"</code>"},B.br=function(){return this.options.xhtml?"<br/>":"<br>"},B.del=function(S){return"<del>"+S+"</del>"},B.link=function(S,I,P){if(S=b(this.options.sanitize,this.options.baseUrl,S),S===null)return P;var O='<a href="'+e(S)+'"';return I&&(O+=' title="'+I+'"'),O+=">"+P+"</a>",O},B.image=function(S,I,P){if(S=b(this.options.sanitize,this.options.baseUrl,S),S===null)return P;var O='<img src="'+S+'" alt="'+P+'"';return I&&(O+=' title="'+I+'"'),O+=this.options.xhtml?"/>":">",O},B.text=function(S){return S},F}(),Q=function(){function F(){}var B=F.prototype;return B.strong=function(S){return S},B.em=function(S){return S},B.codespan=function(S){return S},B.del=function(S){return S},B.html=function(S){return S},B.text=function(S){return S},B.link=function(S,I,P){return""+P},B.image=function(S,I,P){return""+P},B.br=function(){return""},F}(),le=function(){function F(){this.seen={}}var B=F.prototype;return B.serialize=function(S){return S.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},B.getNextSafeSlug=function(S,I){var P=S,O=0;if(this.seen.hasOwnProperty(P)){O=this.seen[S];do O++,P=S+"-"+O;while(this.seen.hasOwnProperty(P))}return I||(this.seen[S]=O,this.seen[P]=0),P},B.slug=function(S,I){I===void 0&&(I={});var P=this.serialize(S);return this.getNextSafeSlug(P,I.dryrun)},F}(),de=function(){function F(z){this.options=z||X.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Q,this.slugger=new le}F.parse=function(S,I){var P=new F(I);return P.parse(S)},F.parseInline=function(S,I){var P=new F(I);return P.parseInline(S)};var B=F.prototype;return B.parse=function(S,I){I===void 0&&(I=!0);var P="",O,j,J,ae,ue,ye,Ee,Ie,ke,ve,Pe,Re,je,Ue,We,xe,it,Be,Ve,Ye=S.length;for(O=0;O<Ye;O++){if(ve=S[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Ve=this.options.extensions.renderers[ve.type].call({parser:this},ve),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){P+=Ve||"";continue}switch(ve.type){case"space":continue;case"hr":{P+=this.renderer.hr();continue}case"heading":{P+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,a(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{P+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ie="",Ee="",ae=ve.header.length,j=0;j<ae;j++)Ee+=this.renderer.tablecell(this.parseInline(ve.header[j].tokens),{header:!0,align:ve.align[j]});for(Ie+=this.renderer.tablerow(Ee),ke="",ae=ve.rows.length,j=0;j<ae;j++){for(ye=ve.rows[j],Ee="",ue=ye.length,J=0;J<ue;J++)Ee+=this.renderer.tablecell(this.parseInline(ye[J].tokens),{header:!1,align:ve.align[J]});ke+=this.renderer.tablerow(Ee)}P+=this.renderer.table(Ie,ke);continue}case"blockquote":{ke=this.parse(ve.tokens),P+=this.renderer.blockquote(ke);continue}case"list":{for(Pe=ve.ordered,Re=ve.start,je=ve.loose,ae=ve.items.length,ke="",j=0;j<ae;j++)We=ve.items[j],xe=We.checked,it=We.task,Ue="",We.task&&(Be=this.renderer.checkbox(xe),je?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Be+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Be+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Be}):Ue+=Be),Ue+=this.parse(We.tokens,je),ke+=this.renderer.listitem(Ue,it,xe);P+=this.renderer.list(ke,Pe,Re);continue}case"html":{P+=this.renderer.html(ve.text);continue}case"paragraph":{P+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(ke=ve.tokens?this.parseInline(ve.tokens):ve.text;O+1<Ye&&S[O+1].type==="text";)ve=S[++O],ke+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);P+=I?this.renderer.paragraph(ke):ke;continue}default:{var K='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return P},B.parseInline=function(S,I){I=I||this.renderer;var P="",O,j,J,ae=S.length;for(O=0;O<ae;O++){if(j=S[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(J=this.options.extensions.renderers[j.type].call({parser:this},j),J!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){P+=J||"";continue}switch(j.type){case"escape":{P+=I.text(j.text);break}case"html":{P+=I.html(j.text);break}case"link":{P+=I.link(j.href,j.title,this.parseInline(j.tokens,I));break}case"image":{P+=I.image(j.href,j.title,j.text);break}case"strong":{P+=I.strong(this.parseInline(j.tokens,I));break}case"em":{P+=I.em(this.parseInline(j.tokens,I));break}case"codespan":{P+=I.codespan(j.text);break}case"br":{P+=I.br();break}case"del":{P+=I.del(this.parseInline(j.tokens,I));break}case"text":{P+=I.text(j.text);break}default:{var ue='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(ue);return}else throw new Error(ue)}}}return P},F}();function me(F,B,z){if(typeof F>"u"||F===null)throw new Error("marked(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");if(typeof B=="function"&&(z=B,B=null),B=p({},me.defaults,B||{}),ge(B),z){var S=B.highlight,I;try{I=De.lex(F,B)}catch(ae){return z(ae)}var P=function(ue){var ye;if(!ue)try{B.walkTokens&&me.walkTokens(I,B.walkTokens),ye=de.parse(I,B)}catch(Ee){ue=Ee}return B.highlight=S,ue?z(ue):z(null,ye)};if(!S||S.length<3||(delete B.highlight,!I.length))return P();var O=0;me.walkTokens(I,function(ae){ae.type==="code"&&(O++,setTimeout(function(){S(ae.text,ae.lang,function(ue,ye){if(ue)return P(ue);ye!=null&&ye!==ae.text&&(ae.text=ye,ae.escaped=!0),O--,O===0&&P()})},0))}),O===0&&P();return}function j(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+e(ae.message+"",!0)+"</pre>";throw ae}try{var J=De.lex(F,B);if(B.walkTokens){if(B.async)return Promise.all(me.walkTokens(J,B.walkTokens)).then(function(){return de.parse(J,B)}).catch(j);me.walkTokens(J,B.walkTokens)}return de.parse(J,B)}catch(ae){j(ae)}}me.options=me.setOptions=function(F){return p(me.defaults,F),w(me.defaults),me},me.getDefaults=y,me.defaults=X.defaults,me.use=function(){for(var F=arguments.length,B=new Array(F),z=0;z<F;z++)B[z]=arguments[z];var S=p.apply(void 0,[{}].concat(B)),I=me.defaults.extensions||{renderers:{},childTokens:{}},P;B.forEach(function(O){if(O.extensions&&(P=!0,O.extensions.forEach(function(J){if(!J.name)throw new Error("extension name required");if(J.renderer){var ae=I.renderers?I.renderers[J.name]:null;ae?I.renderers[J.name]=function(){for(var ue=arguments.length,ye=new Array(ue),Ee=0;Ee<ue;Ee++)ye[Ee]=arguments[Ee];var Ie=J.renderer.apply(this,ye);return Ie===!1&&(Ie=ae.apply(this,ye)),Ie}:I.renderers[J.name]=J.renderer}if(J.tokenizer){if(!J.level||J.level!=="block"&&J.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");I[J.level]?I[J.level].unshift(J.tokenizer):I[J.level]=[J.tokenizer],J.start&&(J.level==="block"?I.startBlock?I.startBlock.push(J.start):I.startBlock=[J.start]:J.level==="inline"&&(I.startInline?I.startInline.push(J.start):I.startInline=[J.start]))}J.childTokens&&(I.childTokens[J.name]=J.childTokens)})),O.renderer&&function(){var J=me.defaults.renderer||new se,ae=function(Ee){var Ie=J[Ee];J[Ee]=function(){for(var ke=arguments.length,ve=new Array(ke),Pe=0;Pe<ke;Pe++)ve[Pe]=arguments[Pe];var Re=O.renderer[Ee].apply(J,ve);return Re===!1&&(Re=Ie.apply(J,ve)),Re}};for(var ue in O.renderer)ae(ue);S.renderer=J}(),O.tokenizer&&function(){var J=me.defaults.tokenizer||new he,ae=function(Ee){var Ie=J[Ee];J[Ee]=function(){for(var ke=arguments.length,ve=new Array(ke),Pe=0;Pe<ke;Pe++)ve[Pe]=arguments[Pe];var Re=O.tokenizer[Ee].apply(J,ve);return Re===!1&&(Re=Ie.apply(J,ve)),Re}};for(var ue in O.tokenizer)ae(ue);S.tokenizer=J}(),O.walkTokens){var j=me.defaults.walkTokens;S.walkTokens=function(J){var ae=[];return ae.push(O.walkTokens.call(this,J)),j&&(ae=ae.concat(j.call(this,J))),ae}}P&&(S.extensions=I),me.setOptions(S)})},me.walkTokens=function(F,B){for(var z=[],S=function(){var j=P.value;switch(z=z.concat(B.call(me,j)),j.type){case"table":{for(var J=H(j.header),ae;!(ae=J()).done;){var ue=ae.value;z=z.concat(me.walkTokens(ue.tokens,B))}for(var ye=H(j.rows),Ee;!(Ee=ye()).done;)for(var Ie=Ee.value,ke=H(Ie),ve;!(ve=ke()).done;){var Pe=ve.value;z=z.concat(me.walkTokens(Pe.tokens,B))}break}case"list":{z=z.concat(me.walkTokens(j.items,B));break}default:me.defaults.extensions&&me.defaults.extensions.childTokens&&me.defaults.extensions.childTokens[j.type]?me.defaults.extensions.childTokens[j.type].forEach(function(Re){z=z.concat(me.walkTokens(j[Re],B))}):j.tokens&&(z=z.concat(me.walkTokens(j.tokens,B)))}},I=H(F),P;!(P=I()).done;)S();return z},me.parseInline=function(F,B){if(typeof F>"u"||F===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");B=p({},me.defaults,B||{}),ge(B);try{var z=De.lexInline(F,B);return B.walkTokens&&me.walkTokens(z,B.walkTokens),de.parseInline(z,B)}catch(S){if(S.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+e(S.message+"",!0)+"</pre>";throw S}},me.Parser=de,me.parser=de.parse,me.Renderer=se,me.TextRenderer=Q,me.Lexer=De,me.lexer=De.lex,me.Tokenizer=he,me.Slugger=le,me.parse=me;var ee=me.options,k=me.setOptions,E=me.use,g=me.walkTokens,R=me.parseInline,W=me,$=de.parse,Y=De.lex;X.Lexer=De,X.Parser=de,X.Renderer=se,X.Slugger=le,X.TextRenderer=Q,X.Tokenizer=he,X.getDefaults=y,X.lexer=Y,X.marked=me,X.options=ee,X.parse=W,X.parseInline=R,X.parser=$,X.setOptions=k,X.use=E,X.walkTokens=g,Object.defineProperty(X,"__esModule",{value:!0})}),define(be[77],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class v{constructor(U,H=0,y=U.length,w=H-1){this.a=U,this.b=H,this.c=y,this.d=w}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=v}),define(be[78],pe([1,0,77]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(y=[],w=10){this.h(y),this.b=w,this.d()}getHistory(){return this.j}add(y){this.a.delete(y),this.a.add(y),this.d()}next(){return this.g()!==this.j.length-1?this.c.next():null}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}has(y){return this.a.has(y)}clear(){this.h([]),this.d()}d(){this.f();const y=this.j;this.c=new v.ArrayNavigator(y,0,y.length,y.length)}f(){const y=this.j;y.length>this.b&&this.h(y.slice(y.length-this.b))}g(){const y=this.c.current();return y?this.j.indexOf(y):-1}h(y){this.a=new Set;for(const w of y)this.a.add(w)}get j(){const y=[];return this.a.forEach(w=>y.push(w)),y}}t.HistoryNavigator=i;class U{constructor(y,w=10){if(this.f=w,y.length<1)throw new Error("not supported");this.d=1,this.a=this.b=this.c={value:y[0],previous:void 0,next:void 0};for(let d=1;d<y.length;d++)this.add(y[d])}add(y){const w={value:y,previous:this.b,next:void 0};for(this.b.next=w,this.b=w,this.c=this.b,this.d++;this.d>this.f;)this.a=this.a.next,this.a.previous=void 0,this.d--}replaceLast(y){const w=this.b.value;return this.b.value=y,w}isAtEnd(){return this.c===this.b}current(){return this.c.value}previous(){return this.c.previous&&(this.c=this.c.previous),this.c.value}next(){return this.c.next&&(this.c=this.c.next),this.c.value}has(y){let w=this.a;for(;w;){if(w.value===y)return!0;w=w.next}return!1}resetCursor(){return this.c=this.b,this.c.value}*[Symbol.iterator](){let y=this.a;for(;y;)yield y.value,y=y.next}}t.HistoryNavigator2=U}),define(be[46],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function v(w,d,m){return Math.min(Math.max(w,d),m)}t.clamp=v;function i(w,d){return(d+w%d)%d}t.rot=i;class U{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=U;class H{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=H;class y{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const m=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=y}),define(be[47],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(i){function U(d,m){if(d.start>=m.end||m.start>=d.end)return{start:0,end:0};const f=Math.max(d.start,m.start),M=Math.min(d.end,m.end);return M-f<=0?{start:0,end:0}:{start:f,end:M}}i.intersect=U;function H(d){return d.end-d.start<=0}i.isEmpty=H;function y(d,m){return!H(U(d,m))}i.intersects=y;function w(d,m){const f=[],M={start:d.start,end:Math.min(m.start,d.end)},o={start:Math.max(m.end,d.start),end:d.end};return H(M)||f.push(M),H(o)||f.push(o),f}i.relativeComplement=w})(v=t.Range||(t.Range={}))}),define(be[79],pe([1,0,47]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(d,m){const f=[];for(const M of m){if(d.start>=M.range.end)continue;if(d.end<M.range.start)break;const o=v.Range.intersect(d,M.range);v.Range.isEmpty(o)||f.push({range:o,size:M.size})}return f}t.groupIntersect=i;function U({start:d,end:m},f){return{start:d+f,end:m+f}}t.shift=U;function H(d){const m=[];let f=null;for(const M of d){const o=M.range.start,n=M.range.end,e=M.size;if(f&&e===f.size){f.range.end=n;continue}f={range:{start:o,end:n},size:e},m.push(f)}return m}t.consolidate=H;function y(...d){return H(d.reduce((m,f)=>m.concat(f),[]))}class w{constructor(){this.a=[],this.b=0}splice(m,f,M=[]){const o=M.length-f,n=i({start:0,end:m},this.a),e=i({start:m+f,end:Number.POSITIVE_INFINITY},this.a).map(a=>({range:U(a.range,o),size:a.size})),s=M.map((a,l)=>({range:{start:m+l,end:m+l+1},size:a.size}));this.a=y(n,s,e),this.b=this.a.reduce((a,l)=>a+l.size*(l.range.end-l.range.start),0)}get count(){const m=this.a.length;return m?this.a[m-1].range.end:0}get size(){return this.b}indexAt(m){if(m<0)return-1;let f=0,M=0;for(const o of this.a){const n=o.range.end-o.range.start,e=M+n*o.size;if(m<e)return f+Math.floor((m-M)/o.size);f+=n,M=e}return f}indexAfter(m){return Math.min(this.indexAt(m)+1,this.count)}positionAt(m){if(m<0)return-1;let f=0,M=0;for(const o of this.a){const n=o.range.end-o.range.start,e=M+n;if(m<e)return f+(m-M)*o.size;f+=n*o.size,M=e}return-1}}t.RangeMap=w}),define(be[80],pe([1,0,9,2]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function U(u){const b=u;return b?typeof b.read=="function":!1}t.isReadable=U;function H(u){const b=u;return b?[b.on,b.pause,b.resume,b.destroy].every(A=>typeof A=="function"):!1}t.isReadableStream=H;function y(u){const b=u;return b?H(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}t.isReadableBufferedStream=y;function w(u,b){return new d(u,b)}t.newWriteableStream=w;class d{constructor(b,A){this.e=b,this.f=A,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(A=>this.d.push(A))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(A=>A(b))}h(b){this.c.error.length===0?(0,v.onUnexpectedError)(b):this.c.error.slice(0).forEach(A=>A(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,A){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(A),this.resume();break;case"end":this.c.end.push(A),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(A),this.a.flowing&&this.k();break}}removeListener(b,A){if(this.a.destroyed)return;let N;switch(b){case"data":N=this.c.data;break;case"end":N=this.c.end;break;case"error":N=this.c.error;break}if(N){const L=N.indexOf(A);L>=0&&N.splice(L,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const A=[...this.d];this.d.length=0,A.forEach(N=>N())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(u,b){const A=[];let N;for(;(N=u.read())!==null;)A.push(N);return b(A)}t.consumeReadable=m;function f(u,b,A){const N=[];let L;for(;(L=u.read())!==null&&N.length<A;)N.push(L);return L===null&&N.length>0?b(N):{read:()=>{if(N.length>0)return N.shift();if(typeof L<"u"){const T=L;return L=void 0,T}return u.read()}}}t.peekReadable=f;function M(u,b){return new Promise((A,N)=>{const L=[];o(u,{onData:T=>{b&&L.push(T)},onError:T=>{b?N(T):A(void 0)},onEnd:()=>{A(b?b(L):void 0)}})})}t.consumeStream=M;function o(u,b){let A=!1;return u.on("error",N=>{A||b.onError(N)}),u.on("end",()=>{A||b.onEnd()}),u.on("data",N=>{A||b.onData(N)}),(0,i.toDisposable)(()=>A=!0)}t.listenStream=o;function n(u,b){return new Promise((A,N)=>{const L=new i.DisposableStore,T=[],c=D=>{if(T.push(D),T.length>b)return L.dispose(),u.pause(),A({stream:u,buffer:T,ended:!1})},C=D=>N(D),p=()=>A({stream:u,buffer:T,ended:!0});L.add((0,i.toDisposable)(()=>u.removeListener("error",C))),u.on("error",C),L.add((0,i.toDisposable)(()=>u.removeListener("end",p))),u.on("end",p),L.add((0,i.toDisposable)(()=>u.removeListener("data",c))),u.on("data",c)})}t.peekStream=n;function e(u,b){const A=w(b);return A.end(u),A}t.toStream=e;function s(){const u=w(()=>{throw new Error("not supported")});return u.end(),u}t.emptyStream=s;function a(u){let b=!1;return{read:()=>b?null:(b=!0,u)}}t.toReadable=a;function l(u,b,A){const N=w(A);return o(u,{onData:L=>N.write(b.data(L)),onError:L=>N.error(b.error?b.error(L):L),onEnd:()=>N.end()}),N}t.transform=l;function h(u,b,A){let N=!1;return{read:()=>{const L=b.read();return N?L:(N=!0,L!==null?A([u,L]):u)}}}t.prefixedReadable=h;function r(u,b,A){let N=!1;const L=w(A);return o(b,{onData:T=>N?L.write(T):(N=!0,L.write(A([u,T]))),onError:T=>L.error(T),onEnd:()=>{N||(N=!0,L.write(u)),L.end()}}),L}t.prefixedStream=r}),define(be[29],pe([1,0,80]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u";let U,H;class y{static alloc(D){return i?new y(Buffer.allocUnsafe(D)):new y(new Uint8Array(D))}static wrap(D){return i&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new y(D)}static fromString(D,_){return!(_?.dontUseNodeBuffer||!1)&&i?new y(Buffer.from(D)):(U||(U=new TextEncoder),new y(U.encode(D)))}static fromByteArray(D){const _=y.alloc(D.length);for(let V=0,ge=D.length;V<ge;V++)_.buffer[V]=D[V];return _}static concat(D,_){if(typeof _>"u"){_=0;for(let Z=0,ie=D.length;Z<ie;Z++)_+=D[Z].byteLength}const V=y.alloc(_);let ge=0;for(let Z=0,ie=D.length;Z<ie;Z++){const te=D[Z];V.set(te,ge),ge+=te.byteLength}return V}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=y.alloc(this.byteLength);return D.set(this),D}toString(){return i?this.buffer.toString():(H||(H=new TextDecoder),H.decode(this.buffer))}slice(D,_){return new y(this.buffer.subarray(D,_))}set(D,_){if(D instanceof y)this.buffer.set(D.buffer,_);else if(D instanceof Uint8Array)this.buffer.set(D,_);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),_);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return m(this.buffer,D)}writeUInt32BE(D,_){f(this.buffer,D,_)}readUInt32LE(D){return M(this.buffer,D)}writeUInt32LE(D,_){o(this.buffer,D,_)}readUInt8(D){return n(this.buffer,D)}writeUInt8(D,_){e(this.buffer,D,_)}}t.VSBuffer=y;function w(p,D){return p[D+0]<<0>>>0|p[D+1]<<8>>>0}t.readUInt16LE=w;function d(p,D,_){p[_+0]=D&255,D=D>>>8,p[_+1]=D&255}t.writeUInt16LE=d;function m(p,D){return p[D]*2**24+p[D+1]*2**16+p[D+2]*2**8+p[D+3]}t.readUInt32BE=m;function f(p,D,_){p[_+3]=D,D=D>>>8,p[_+2]=D,D=D>>>8,p[_+1]=D,D=D>>>8,p[_]=D}t.writeUInt32BE=f;function M(p,D){return p[D+0]<<0>>>0|p[D+1]<<8>>>0|p[D+2]<<16>>>0|p[D+3]<<24>>>0}t.readUInt32LE=M;function o(p,D,_){p[_+0]=D&255,D=D>>>8,p[_+1]=D&255,D=D>>>8,p[_+2]=D&255,D=D>>>8,p[_+3]=D&255}t.writeUInt32LE=o;function n(p,D){return p[D]}t.readUInt8=n;function e(p,D,_){p[_]=D}t.writeUInt8=e;function s(p){return v.consumeReadable(p,D=>y.concat(D))}t.readableToBuffer=s;function a(p){return v.toReadable(p)}t.bufferToReadable=a;function l(p){return v.consumeStream(p,D=>y.concat(D))}t.streamToBuffer=l;async function h(p){return p.ended?y.concat(p.buffer):y.concat([...p.buffer,await l(p.stream)])}t.bufferedStreamToBuffer=h;function r(p){return v.toStream(p,D=>y.concat(D))}t.bufferToStream=r;function u(p){return v.transform(p,{data:D=>typeof D=="string"?y.fromString(D):y.wrap(D)},D=>y.concat(D))}t.streamToBufferReadableStream=u;function b(p){return v.newWriteableStream(D=>y.concat(D),p)}t.newWriteableBufferStream=b;function A(p,D){return v.prefixedReadable(p,D,_=>y.concat(_))}t.prefixedBufferReadable=A;function N(p,D){return v.prefixedStream(p,D,_=>y.concat(_))}t.prefixedBufferStream=N;function L(p){let D=0,_=0,V=0;const ge=new Uint8Array(Math.floor(p.length/4*3)),Z=te=>{switch(_){case 3:ge[V++]=D|te,_=0;break;case 2:ge[V++]=D|te>>>2,D=te<<6,_=3;break;case 1:ge[V++]=D|te>>>4,D=te<<4,_=2;break;default:D=te<<2,_=1}};for(let te=0;te<p.length;te++){const he=p.charCodeAt(te);if(he>=65&&he<=90)Z(he-65);else if(he>=97&&he<=122)Z(he-97+26);else if(he>=48&&he<=57)Z(he-48+52);else if(he===43||he===45)Z(62);else if(he===47||he===95)Z(63);else{if(he===61)break;throw new SyntaxError(`Unexpected base64 character ${p[te]}`)}}const ie=V;for(;_>0;)Z(0);return y.wrap(ge).slice(0,ie)}t.decodeBase64=L;const T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:p},D=!0,_=!1){const V=_?c:T;let ge="";const Z=p.byteLength%3;let ie=0;for(;ie<p.byteLength-Z;ie+=3){const te=p[ie+0],he=p[ie+1],re=p[ie+2];ge+=V[te>>>2],ge+=V[(te<<4|he>>>4)&63],ge+=V[(he<<2|re>>>6)&63],ge+=V[re&63]}if(Z===1){const te=p[ie+0];ge+=V[te>>>2],ge+=V[te<<4&63],D&&(ge+="==")}else if(Z===2){const te=p[ie+0],he=p[ie+1];ge+=V[te>>>2],ge+=V[(te<<4|he>>>4)&63],ge+=V[he<<2&63],D&&(ge+="=")}return ge}t.encodeBase64=C}),define(be[6],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function v(N){return typeof N=="string"}t.isString=v;function i(N){return Array.isArray(N)&&N.every(L=>v(L))}t.isStringArray=i;function U(N){return typeof N=="object"&&N!==null&&!Array.isArray(N)&&!(N instanceof RegExp)&&!(N instanceof Date)}t.isObject=U;function H(N){const L=Object.getPrototypeOf(Uint8Array);return typeof N=="object"&&N instanceof L}t.isTypedArray=H;function y(N){return typeof N=="number"&&!isNaN(N)}t.isNumber=y;function w(N){return!!N&&typeof N[Symbol.iterator]=="function"}t.isIterable=w;function d(N){return N===!0||N===!1}t.isBoolean=d;function m(N){return typeof N>"u"}t.isUndefined=m;function f(N){return!M(N)}t.isDefined=f;function M(N){return m(N)||N===null}t.isUndefinedOrNull=M;function o(N,L){if(!N)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}t.assertType=o;function n(N){if(M(N))throw new Error("Assertion Failed: argument is undefined or null");return N}t.assertIsDefined=n;function e(...N){const L=[];for(let T=0;T<N.length;T++){const c=N[T];if(M(c))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);L.push(c)}return L}t.assertAllDefined=e;const s=Object.prototype.hasOwnProperty;function a(N){if(!U(N))return!1;for(const L in N)if(s.call(N,L))return!1;return!0}t.isEmptyObject=a;function l(N){return typeof N=="function"}t.isFunction=l;function h(...N){return N.length>0&&N.every(l)}t.areFunctions=h;function r(N,L){const T=Math.min(N.length,L.length);for(let c=0;c<T;c++)u(N[c],L[c])}t.validateConstraints=r;function u(N,L){if(v(L)){if(typeof N!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(l(L)){try{if(N instanceof L)return}catch{}if(!M(N)&&N.constructor===L||L.length===1&&L.call(void 0,N)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=u;function b(N){return N===null?void 0:N}t.withNullAsUndefined=b;function A(N){return typeof N>"u"?null:N}t.withUndefinedAsNull=A}),define(be[30],pe([1,0,6]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const h=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([r,u])=>{h[r]=u&&typeof u=="object"?i(u):u}),h}t.deepClone=i;function U(l){if(!l||typeof l!="object")return l;const h=[l];for(;h.length>0;){const r=h.shift();Object.freeze(r);for(const u in r)if(H.call(r,u)){const b=r[u];typeof b=="object"&&!Object.isFrozen(b)&&!(0,v.isTypedArray)(b)&&h.push(b)}}return l}t.deepFreeze=U;const H=Object.prototype.hasOwnProperty;function y(l,h){return w(l,h,new Set)}t.cloneAndChange=y;function w(l,h,r){if((0,v.isUndefinedOrNull)(l))return l;const u=h(l);if(typeof u<"u")return u;if(Array.isArray(l)){const b=[];for(const A of l)b.push(w(A,h,r));return b}if((0,v.isObject)(l)){if(r.has(l))throw new Error("Cannot clone recursive data-structure");r.add(l);const b={};for(const A in l)H.call(l,A)&&(b[A]=w(l[A],h,r));return r.delete(l),b}return l}function d(l,h,r=!0){return(0,v.isObject)(l)?((0,v.isObject)(h)&&Object.keys(h).forEach(u=>{u in l?r&&((0,v.isObject)(l[u])&&(0,v.isObject)(h[u])?d(l[u],h[u],r):l[u]=h[u]):l[u]=h[u]}),l):h}t.mixin=d;function m(l,h){if(l===h)return!0;if(l==null||h===null||h===void 0||typeof l!=typeof h||typeof l!="object"||Array.isArray(l)!==Array.isArray(h))return!1;let r,u;if(Array.isArray(l)){if(l.length!==h.length)return!1;for(r=0;r<l.length;r++)if(!m(l[r],h[r]))return!1}else{const b=[];for(u in l)b.push(u);b.sort();const A=[];for(u in h)A.push(u);if(A.sort(),!m(b,A))return!1;for(r=0;r<b.length;r++)if(!m(l[b[r]],h[b[r]]))return!1}return!0}t.equals=m;function f(l){const h=new Set;return JSON.stringify(l,(r,u)=>{if((0,v.isObject)(u)||Array.isArray(u)){if(h.has(u))return"[Circular]";h.add(u)}return u})}t.safeStringify=f;function M(l,h){const r=Object.create(null);return!l||!h||Object.keys(h).forEach(b=>{const A=l[b],N=h[b];m(A,N)||(r[b]=N)}),r}t.distinct=M;function o(l,h){const r=h.toLowerCase(),u=Object.keys(l).find(b=>b.toLowerCase()===r);return u?l[u]:l[h]}t.getCaseInsensitive=o;function n(l,h){const r=Object.create(null);for(const[u,b]of Object.entries(l))h(u,b)&&(r[u]=b);return r}t.filter=n;function e(l){let h=[],r=Object.getPrototypeOf(l);for(;Object.prototype!==r;)h=h.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return h}t.getAllPropertyNames=e;function s(l){const h=[];for(const r of e(l))typeof l[r]=="function"&&h.push(r);return h}t.getAllMethodNames=s;function a(l,h){const r=b=>function(){const A=Array.prototype.slice.call(arguments,0);return h(b,A)},u={};for(const b of l)u[b]=r(b);return u}t.createProxyObject=a}),define(be[81],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(be[82],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class v{constructor(U,H){this.a=U,this.onMessage=H}send(U){try{this.a.send("vscode:message",U.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=v}),define(be[48],pe([7]),{}),define(be[83],pe([7]),{}),define(be[84],pe([7]),{}),define(be[85],pe([7]),{}),define(be[86],pe([1,0,12,84,85]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(U){let H=U.definition;for(;H instanceof v.Codicon;)H=H.definition;return`.codicon-${U.id}:before { content: '${H.fontCharacter}'; }`}t.formatRule=i}),define(be[87],pe([7]),{}),define(be[88],pe([7]),{}),define(be[89],pe([7]),{}),define(be[90],pe([7]),{}),define(be[91],pe([7]),{}),define(be[92],pe([7]),{}),define(be[93],pe([7]),{}),define(be[94],pe([7]),{}),define(be[95],pe([7]),{}),define(be[96],pe([13,10]),function(X,t){return X.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[97],pe([13,10]),function(X,t){return X.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[98],pe([13,10]),function(X,t){return X.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[99],pe([13,10]),function(X,t){return X.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[100],pe([13,10]),function(X,t){return X.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[101],pe([13,10]),function(X,t){return X.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[102],pe([13,10]),function(X,t){return X.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[103],pe([13,10]),function(X,t){return X.create("vs/base/common/actions",t)}),define(be[104],pe([13,10]),function(X,t){return X.create("vs/base/common/platform",t)}),define(be[5],pe([1,0,104]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let i=!1,U=!1,H=!1,y=!1,w=!1,d=!1,m=!1,f=!1,M=!1,o=!1,n,e=t.LANGUAGE_DEFAULT,s,a;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?l=t.globals.vscode.process:typeof process<"u"&&(l=process);const h=typeof l?.versions?.electron=="string",r=h&&l?.type==="renderer";if(typeof navigator=="object"&&!r)a=navigator.userAgent,i=a.indexOf("Windows")>=0,U=a.indexOf("Macintosh")>=0,f=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=a.indexOf("Linux")>=0,o=a?.indexOf("Mobi")>=0,d=!0,n=v.getConfiguredDefaultLocale(v.localize(0,null))||t.LANGUAGE_DEFAULT,e=n;else if(typeof l=="object"){i=l.platform==="win32",U=l.platform==="darwin",H=l.platform==="linux",y=H&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,m=h,M=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,n=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const p=l.env.VSCODE_NLS_CONFIG;if(p)try{const D=JSON.parse(p),_=D.availableLanguages["*"];n=D.locale,e=_||t.LANGUAGE_DEFAULT,s=D._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var u;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(u=t.Platform||(t.Platform={}));function b(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=b;let A=0;U?A=1:i?A=3:H&&(A=2),t.isWindows=i,t.isMacintosh=U,t.isLinux=H,t.isLinuxSnap=y,t.isNative=w,t.isElectron=m,t.isWeb=d,t.isWebWorker=d&&typeof t.globals.importScripts=="function",t.isIOS=f,t.isMobile=o,t.isCI=M,t.platform=A,t.userAgent=a,t.language=e;var N;(function(p){function D(){return t.language}p.value=D;function _(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}p.isDefaultVariant=_;function V(){return t.language==="en"}p.isDefault=V})(N=t.Language||(t.Language={})),t.locale=n,t.translationsConfigFile=s,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const p=[];t.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let V=0,ge=p.length;V<ge;V++){const Z=p[V];if(Z.id===_.data.vscodeScheduleAsyncWork){p.splice(V,1),Z.callback();return}}});let D=0;return _=>{const V=++D;p.push({id:V,callback:_}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return p=>setTimeout(p)})();var L;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(L=t.OperatingSystem||(t.OperatingSystem={})),t.OS=U||f?2:i?1:3;let T=!0,c=!1;function C(){if(!c){c=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,T=new Uint16Array(p.buffer)[0]===(2<<8)+1}return T}t.isLittleEndian=C,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(be[105],pe([1,0,5]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const U=v.globals.vscode.process;i={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(be[21],pe([1,0,105]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,U=97,H=90,y=122,w=46,d=47,m=92,f=58,M=63;class o extends Error{constructor(u,b,A){let N;typeof b=="string"&&b.indexOf("not ")===0?(N="must not be",b=b.replace(/^not /,"")):N="must be";const L=u.indexOf(".")!==-1?"property":"argument";let T=`The "${u}" ${L} ${N} of type ${b}`;T+=`. Received type ${typeof A}`,super(T),this.code="ERR_INVALID_ARG_TYPE"}}function n(r,u){if(typeof r!="string")throw new o(u,"string",r)}function e(r){return r===d||r===m}function s(r){return r===d}function a(r){return r>=i&&r<=H||r>=U&&r<=y}function l(r,u,b,A){let N="",L=0,T=-1,c=0,C=0;for(let p=0;p<=r.length;++p){if(p<r.length)C=r.charCodeAt(p);else{if(A(C))break;C=d}if(A(C)){if(!(T===p-1||c===1))if(c===2){if(N.length<2||L!==2||N.charCodeAt(N.length-1)!==w||N.charCodeAt(N.length-2)!==w){if(N.length>2){const D=N.lastIndexOf(b);D===-1?(N="",L=0):(N=N.slice(0,D),L=N.length-1-N.lastIndexOf(b)),T=p,c=0;continue}else if(N.length!==0){N="",L=0,T=p,c=0;continue}}u&&(N+=N.length>0?`${b}..`:"..",L=2)}else N.length>0?N+=`${b}${r.slice(T+1,p)}`:N=r.slice(T+1,p),L=p-T-1;T=p,c=0}else C===w&&c!==-1?++c:c=-1}return N}function h(r,u){if(u===null||typeof u!="object")throw new o("pathObject","Object",u);const b=u.dir||u.root,A=u.base||`${u.name||""}${u.ext||""}`;return b?b===u.root?`${b}${A}`:`${b}${r}${A}`:A}t.win32={resolve(...r){let u="",b="",A=!1;for(let N=r.length-1;N>=-1;N--){let L;if(N>=0){if(L=r[N],n(L,"path"),L.length===0)continue}else u.length===0?L=v.cwd():(L=v.env[`=${u}`]||v.cwd(),(L===void 0||L.slice(0,2).toLowerCase()!==u.toLowerCase()&&L.charCodeAt(2)===m)&&(L=`${u}\\`));const T=L.length;let c=0,C="",p=!1;const D=L.charCodeAt(0);if(T===1)e(D)&&(c=1,p=!0);else if(e(D))if(p=!0,e(L.charCodeAt(1))){let _=2,V=_;for(;_<T&&!e(L.charCodeAt(_));)_++;if(_<T&&_!==V){const ge=L.slice(V,_);for(V=_;_<T&&e(L.charCodeAt(_));)_++;if(_<T&&_!==V){for(V=_;_<T&&!e(L.charCodeAt(_));)_++;(_===T||_!==V)&&(C=`\\\\${ge}\\${L.slice(V,_)}`,c=_)}}}else c=1;else a(D)&&L.charCodeAt(1)===f&&(C=L.slice(0,2),c=2,T>2&&e(L.charCodeAt(2))&&(p=!0,c=3));if(C.length>0)if(u.length>0){if(C.toLowerCase()!==u.toLowerCase())continue}else u=C;if(A){if(u.length>0)break}else if(b=`${L.slice(c)}\\${b}`,A=p,p&&u.length>0)break}return b=l(b,!A,"\\",e),A?`${u}\\${b}`:`${u}${b}`||"."},normalize(r){n(r,"path");const u=r.length;if(u===0)return".";let b=0,A,N=!1;const L=r.charCodeAt(0);if(u===1)return s(L)?"\\":r;if(e(L))if(N=!0,e(r.charCodeAt(1))){let c=2,C=c;for(;c<u&&!e(r.charCodeAt(c));)c++;if(c<u&&c!==C){const p=r.slice(C,c);for(C=c;c<u&&e(r.charCodeAt(c));)c++;if(c<u&&c!==C){for(C=c;c<u&&!e(r.charCodeAt(c));)c++;if(c===u)return`\\\\${p}\\${r.slice(C)}\\`;c!==C&&(A=`\\\\${p}\\${r.slice(C,c)}`,b=c)}}}else b=1;else a(L)&&r.charCodeAt(1)===f&&(A=r.slice(0,2),b=2,u>2&&e(r.charCodeAt(2))&&(N=!0,b=3));let T=b<u?l(r.slice(b),!N,"\\",e):"";return T.length===0&&!N&&(T="."),T.length>0&&e(r.charCodeAt(u-1))&&(T+="\\"),A===void 0?N?`\\${T}`:T:N?`${A}\\${T}`:`${A}${T}`},isAbsolute(r){n(r,"path");const u=r.length;if(u===0)return!1;const b=r.charCodeAt(0);return e(b)||u>2&&a(b)&&r.charCodeAt(1)===f&&e(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let u,b;for(let L=0;L<r.length;++L){const T=r[L];n(T,"path"),T.length>0&&(u===void 0?u=b=T:u+=`\\${T}`)}if(u===void 0)return".";let A=!0,N=0;if(typeof b=="string"&&e(b.charCodeAt(0))){++N;const L=b.length;L>1&&e(b.charCodeAt(1))&&(++N,L>2&&(e(b.charCodeAt(2))?++N:A=!1))}if(A){for(;N<u.length&&e(u.charCodeAt(N));)N++;N>=2&&(u=`\\${u.slice(N)}`)}return t.win32.normalize(u)},relative(r,u){if(n(r,"from"),n(u,"to"),r===u)return"";const b=t.win32.resolve(r),A=t.win32.resolve(u);if(b===A||(r=b.toLowerCase(),u=A.toLowerCase(),r===u))return"";let N=0;for(;N<r.length&&r.charCodeAt(N)===m;)N++;let L=r.length;for(;L-1>N&&r.charCodeAt(L-1)===m;)L--;const T=L-N;let c=0;for(;c<u.length&&u.charCodeAt(c)===m;)c++;let C=u.length;for(;C-1>c&&u.charCodeAt(C-1)===m;)C--;const p=C-c,D=T<p?T:p;let _=-1,V=0;for(;V<D;V++){const Z=r.charCodeAt(N+V);if(Z!==u.charCodeAt(c+V))break;Z===m&&(_=V)}if(V!==D){if(_===-1)return A}else{if(p>D){if(u.charCodeAt(c+V)===m)return A.slice(c+V+1);if(V===2)return A.slice(c+V)}T>D&&(r.charCodeAt(N+V)===m?_=V:V===2&&(_=3)),_===-1&&(_=0)}let ge="";for(V=N+_+1;V<=L;++V)(V===L||r.charCodeAt(V)===m)&&(ge+=ge.length===0?"..":"\\..");return c+=_,ge.length>0?`${ge}${A.slice(c,C)}`:(A.charCodeAt(c)===m&&++c,A.slice(c,C))},toNamespacedPath(r){if(typeof r!="string")return r;if(r.length===0)return"";const u=t.win32.resolve(r);if(u.length<=2)return r;if(u.charCodeAt(0)===m){if(u.charCodeAt(1)===m){const b=u.charCodeAt(2);if(b!==M&&b!==w)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(a(u.charCodeAt(0))&&u.charCodeAt(1)===f&&u.charCodeAt(2)===m)return`\\\\?\\${u}`;return r},dirname(r){n(r,"path");const u=r.length;if(u===0)return".";let b=-1,A=0;const N=r.charCodeAt(0);if(u===1)return e(N)?r:".";if(e(N)){if(b=A=1,e(r.charCodeAt(1))){let c=2,C=c;for(;c<u&&!e(r.charCodeAt(c));)c++;if(c<u&&c!==C){for(C=c;c<u&&e(r.charCodeAt(c));)c++;if(c<u&&c!==C){for(C=c;c<u&&!e(r.charCodeAt(c));)c++;if(c===u)return r;c!==C&&(b=A=c+1)}}}}else a(N)&&r.charCodeAt(1)===f&&(b=u>2&&e(r.charCodeAt(2))?3:2,A=b);let L=-1,T=!0;for(let c=u-1;c>=A;--c)if(e(r.charCodeAt(c))){if(!T){L=c;break}}else T=!1;if(L===-1){if(b===-1)return".";L=b}return r.slice(0,L)},basename(r,u){u!==void 0&&n(u,"ext"),n(r,"path");let b=0,A=-1,N=!0,L;if(r.length>=2&&a(r.charCodeAt(0))&&r.charCodeAt(1)===f&&(b=2),u!==void 0&&u.length>0&&u.length<=r.length){if(u===r)return"";let T=u.length-1,c=-1;for(L=r.length-1;L>=b;--L){const C=r.charCodeAt(L);if(e(C)){if(!N){b=L+1;break}}else c===-1&&(N=!1,c=L+1),T>=0&&(C===u.charCodeAt(T)?--T===-1&&(A=L):(T=-1,A=c))}return b===A?A=c:A===-1&&(A=r.length),r.slice(b,A)}for(L=r.length-1;L>=b;--L)if(e(r.charCodeAt(L))){if(!N){b=L+1;break}}else A===-1&&(N=!1,A=L+1);return A===-1?"":r.slice(b,A)},extname(r){n(r,"path");let u=0,b=-1,A=0,N=-1,L=!0,T=0;r.length>=2&&r.charCodeAt(1)===f&&a(r.charCodeAt(0))&&(u=A=2);for(let c=r.length-1;c>=u;--c){const C=r.charCodeAt(c);if(e(C)){if(!L){A=c+1;break}continue}N===-1&&(L=!1,N=c+1),C===w?b===-1?b=c:T!==1&&(T=1):b!==-1&&(T=-1)}return b===-1||N===-1||T===0||T===1&&b===N-1&&b===A+1?"":r.slice(b,N)},format:h.bind(null,"\\"),parse(r){n(r,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return u;const b=r.length;let A=0,N=r.charCodeAt(0);if(b===1)return e(N)?(u.root=u.dir=r,u):(u.base=u.name=r,u);if(e(N)){if(A=1,e(r.charCodeAt(1))){let _=2,V=_;for(;_<b&&!e(r.charCodeAt(_));)_++;if(_<b&&_!==V){for(V=_;_<b&&e(r.charCodeAt(_));)_++;if(_<b&&_!==V){for(V=_;_<b&&!e(r.charCodeAt(_));)_++;_===b?A=_:_!==V&&(A=_+1)}}}}else if(a(N)&&r.charCodeAt(1)===f){if(b<=2)return u.root=u.dir=r,u;if(A=2,e(r.charCodeAt(2))){if(b===3)return u.root=u.dir=r,u;A=3}}A>0&&(u.root=r.slice(0,A));let L=-1,T=A,c=-1,C=!0,p=r.length-1,D=0;for(;p>=A;--p){if(N=r.charCodeAt(p),e(N)){if(!C){T=p+1;break}continue}c===-1&&(C=!1,c=p+1),N===w?L===-1?L=p:D!==1&&(D=1):L!==-1&&(D=-1)}return c!==-1&&(L===-1||D===0||D===1&&L===c-1&&L===T+1?u.base=u.name=r.slice(T,c):(u.name=r.slice(T,L),u.base=r.slice(T,c),u.ext=r.slice(L,c))),T>0&&T!==A?u.dir=r.slice(0,T-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...r){let u="",b=!1;for(let A=r.length-1;A>=-1&&!b;A--){const N=A>=0?r[A]:v.cwd();n(N,"path"),N.length!==0&&(u=`${N}/${u}`,b=N.charCodeAt(0)===d)}return u=l(u,!b,"/",s),b?`/${u}`:u.length>0?u:"."},normalize(r){if(n(r,"path"),r.length===0)return".";const u=r.charCodeAt(0)===d,b=r.charCodeAt(r.length-1)===d;return r=l(r,!u,"/",s),r.length===0?u?"/":b?"./":".":(b&&(r+="/"),u?`/${r}`:r)},isAbsolute(r){return n(r,"path"),r.length>0&&r.charCodeAt(0)===d},join(...r){if(r.length===0)return".";let u;for(let b=0;b<r.length;++b){const A=r[b];n(A,"path"),A.length>0&&(u===void 0?u=A:u+=`/${A}`)}return u===void 0?".":t.posix.normalize(u)},relative(r,u){if(n(r,"from"),n(u,"to"),r===u||(r=t.posix.resolve(r),u=t.posix.resolve(u),r===u))return"";const b=1,A=r.length,N=A-b,L=1,T=u.length-L,c=N<T?N:T;let C=-1,p=0;for(;p<c;p++){const _=r.charCodeAt(b+p);if(_!==u.charCodeAt(L+p))break;_===d&&(C=p)}if(p===c)if(T>c){if(u.charCodeAt(L+p)===d)return u.slice(L+p+1);if(p===0)return u.slice(L+p)}else N>c&&(r.charCodeAt(b+p)===d?C=p:p===0&&(C=0));let D="";for(p=b+C+1;p<=A;++p)(p===A||r.charCodeAt(p)===d)&&(D+=D.length===0?"..":"/..");return`${D}${u.slice(L+C)}`},toNamespacedPath(r){return r},dirname(r){if(n(r,"path"),r.length===0)return".";const u=r.charCodeAt(0)===d;let b=-1,A=!0;for(let N=r.length-1;N>=1;--N)if(r.charCodeAt(N)===d){if(!A){b=N;break}}else A=!1;return b===-1?u?"/":".":u&&b===1?"//":r.slice(0,b)},basename(r,u){u!==void 0&&n(u,"ext"),n(r,"path");let b=0,A=-1,N=!0,L;if(u!==void 0&&u.length>0&&u.length<=r.length){if(u===r)return"";let T=u.length-1,c=-1;for(L=r.length-1;L>=0;--L){const C=r.charCodeAt(L);if(C===d){if(!N){b=L+1;break}}else c===-1&&(N=!1,c=L+1),T>=0&&(C===u.charCodeAt(T)?--T===-1&&(A=L):(T=-1,A=c))}return b===A?A=c:A===-1&&(A=r.length),r.slice(b,A)}for(L=r.length-1;L>=0;--L)if(r.charCodeAt(L)===d){if(!N){b=L+1;break}}else A===-1&&(N=!1,A=L+1);return A===-1?"":r.slice(b,A)},extname(r){n(r,"path");let u=-1,b=0,A=-1,N=!0,L=0;for(let T=r.length-1;T>=0;--T){const c=r.charCodeAt(T);if(c===d){if(!N){b=T+1;break}continue}A===-1&&(N=!1,A=T+1),c===w?u===-1?u=T:L!==1&&(L=1):u!==-1&&(L=-1)}return u===-1||A===-1||L===0||L===1&&u===A-1&&u===b+1?"":r.slice(u,A)},format:h.bind(null,"/"),parse(r){n(r,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return u;const b=r.charCodeAt(0)===d;let A;b?(u.root="/",A=1):A=0;let N=-1,L=0,T=-1,c=!0,C=r.length-1,p=0;for(;C>=A;--C){const D=r.charCodeAt(C);if(D===d){if(!c){L=C+1;break}continue}T===-1&&(c=!1,T=C+1),D===w?N===-1?N=C:p!==1&&(p=1):N!==-1&&(p=-1)}if(T!==-1){const D=L===0&&b?1:L;N===-1||p===0||p===1&&N===T-1&&N===L+1?u.base=u.name=r.slice(D,T):(u.name=r.slice(D,N),u.base=r.slice(D,T),u.ext=r.slice(N,T))}return L>0?u.dir=r.slice(0,L-1):b&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=v.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=v.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=v.platform==="win32"?t.win32.join:t.posix.join,t.resolve=v.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=v.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=v.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=v.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=v.platform==="win32"?t.win32.extname:t.posix.extname,t.format=v.platform==="win32"?t.win32.format:t.posix.format,t.parse=v.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=v.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=v.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=v.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(be[106],pe([1,0,21]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},U={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(f){const M=(0,v.extname)(f),o=i[M.toLowerCase()];return o!==void 0?o:y(f)}t.getMediaOrTextMime=H;function y(f){const M=(0,v.extname)(f);return U[M.toLowerCase()]}t.getMediaMime=y;function w(f){for(const M in U)if(U[M]===f)return M}t.getExtensionForMimeType=w;const d=/^(.+)\/(.+?)(;.+)?$/;function m(f,M){const o=d.exec(f);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:M?void 0:f}t.normalizeMimeType=m}),define(be[107],pe([1,0,5]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=v.globals.performance&&typeof v.globals.performance.now=="function";class U{static create(y=!0){return new U(y)}constructor(y){this.a=i&&y,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?v.globals.performance.now():Date.now()}}t.StopWatch=U}),define(be[3],pe([1,0,9,42,2,45,107]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const w=!1,d=!1;var m;(function(C){C.None=()=>U.Disposable.None;function p(W){if(d){const{onDidAddListener:$}=W,Y=e.create();let F=0;W.onDidAddListener=()=>{++F===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function D(W,$){return ce(W,()=>{},0,void 0,void 0,$)}C.defer=D;function _(W){return($,Y=null,F)=>{let B=!1,z;return z=W(S=>{if(!B)return z?z.dispose():B=!0,$.call(Y,S)},null,F),B&&z.dispose(),z}}C.once=_;function V(W,$,Y){return re((F,B=null,z)=>W(S=>F.call(B,$(S)),null,z),Y)}C.map=V;function ge(W,$,Y){return re((F,B=null,z)=>W(S=>{$(S),F.call(B,S)},null,z),Y)}C.forEach=ge;function Z(W,$,Y){return re((F,B=null,z)=>W(S=>$(S)&&F.call(B,S),null,z),Y)}C.filter=Z;function ie(W){return W}C.signal=ie;function te(...W){return($,Y=null,F)=>(0,U.combinedDisposable)(...W.map(B=>B(z=>$.call(Y,z),null,F)))}C.any=te;function he(W,$,Y,F){let B=Y;return V(W,z=>(B=$(B,z),B),F)}C.reduce=he;function re(W,$){let Y;const F={onWillAddFirstListener(){Y=W(B.fire,B)},onDidRemoveLastListener(){Y?.dispose()}};$||p(F);const B=new a(F);return $?.add(B),B.event}function ce(W,$,Y=100,F=!1,B,z){let S,I,P,O=0;const j={leakWarningThreshold:B,onWillAddFirstListener(){S=W(ae=>{O++,I=$(I,ae),F&&!P&&(J.fire(I),I=void 0),clearTimeout(P),P=setTimeout(()=>{const ue=I;I=void 0,P=void 0,(!F||O>1)&&J.fire(ue),O=0},Y)})},onDidRemoveLastListener(){S.dispose()}};z||p(j);const J=new a(j);return z?.add(J),J.event}C.debounce=ce;function Se(W,$=0,Y){return C.debounce(W,(F,B)=>F?(F.push(B),F):[B],$,void 0,void 0,Y)}C.accumulate=Se;function x(W,$=(F,B)=>F===B,Y){let F=!0,B;return Z(W,z=>{const S=F||!$(z,B);return F=!1,B=z,S},Y)}C.latch=x;function De(W,$,Y){return[C.filter(W,$,Y),C.filter(W,F=>!$(F),Y)]}C.split=De;function se(W,$=!1,Y=[]){let F=Y.slice(),B=W(I=>{F?F.push(I):S.fire(I)});const z=()=>{F?.forEach(I=>S.fire(I)),F=null},S=new a({onWillAddFirstListener(){B||(B=W(I=>S.fire(I)))},onDidAddFirstListener(){F&&($?setTimeout(z):z())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return S.event}C.buffer=se;class Q{constructor($){this.event=$,this.c=new U.DisposableStore}map($){return new Q(V(this.event,$,this.c))}forEach($){return new Q(ge(this.event,$,this.c))}filter($){return new Q(Z(this.event,$,this.c))}reduce($,Y){return new Q(he(this.event,$,Y,this.c))}latch(){return new Q(x(this.event,void 0,this.c))}debounce($,Y=100,F=!1,B){return new Q(ce(this.event,$,Y,F,B,this.c))}on($,Y,F){return this.event($,Y,F)}once($,Y,F){return _(this.event)($,Y,F)}dispose(){this.c.dispose()}}function le(W){return new Q(W)}C.chain=le;function de(W,$,Y=F=>F){const F=(...I)=>S.fire(Y(...I)),B=()=>W.on($,F),z=()=>W.removeListener($,F),S=new a({onWillAddFirstListener:B,onDidRemoveLastListener:z});return S.event}C.fromNodeEventEmitter=de;function me(W,$,Y=F=>F){const F=(...I)=>S.fire(Y(...I)),B=()=>W.addEventListener($,F),z=()=>W.removeEventListener($,F),S=new a({onWillAddFirstListener:B,onDidRemoveLastListener:z});return S.event}C.fromDOMEventEmitter=me;function ee(W){return new Promise($=>_(W)($))}C.toPromise=ee;function k(W,$){return $(void 0),W(Y=>$(Y))}C.runAndSubscribe=k;function E(W,$){let Y=null;function F(z){Y?.dispose(),Y=new U.DisposableStore,$(z,Y)}F(void 0);const B=W(z=>F(z));return(0,U.toDisposable)(()=>{B.dispose(),Y?.dispose()})}C.runAndSubscribeWithStore=E;class g{constructor($,Y){this.obs=$,this.c=0,this.d=!1;const F={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||p(F),this.emitter=new a(F),Y&&Y.add(this.emitter)}beginUpdate($){this.c++}handleChange($,Y){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function R(W,$){return new g(W,$).emitter.event}C.fromObservable=R})(m=t.Event||(t.Event={}));class f{constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${f.c++}`,f.all.add(this)}start(p){this.d=new y.StopWatch(!0),this.listenerCount=p}stop(){if(this.d){const p=this.d.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=f,f.all=new Set,f.c=0;let M=-1;function o(C){const p=M;return M=C,{dispose(){M=p}}}t.setGlobalLeakWarningThreshold=o;class n{constructor(p,D=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=D,this.d=0}dispose(){this.c?.clear()}check(p,D){const _=this.threshold;if(_<=0||D<_)return;this.c||(this.c=new Map);const V=this.c.get(p.value)||0;if(this.c.set(p.value,V+1),this.d-=1,this.d<=0){this.d=_*.5;let ge,Z=0;for(const[ie,te]of this.c)(!ge||Z<te)&&(ge=ie,Z=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${Z}):`),console.warn(ge)}return()=>{const ge=this.c.get(p.value)||0;this.c.set(p.value,ge-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class s{constructor(p,D,_){this.callback=p,this.callbackThis=D,this.stack=_,this.subscription=new U.SafeDisposable}invoke(p){this.callback.call(this.callbackThis,p)}}class a{constructor(p){this.j=!1,this.d=p,this.f=M>0||this.d?.leakWarningThreshold?new n(this.d?.leakWarningThreshold??M):void 0,this.g=this.d?._profName?new f(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(w){const p=Array.from(this.q);queueMicrotask(()=>{for(const D of p)D.subscription.isset()&&(D.subscription.unset(),D.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(p,D,_)=>{if(this.q||(this.q=new H.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),U.Disposable.None;const V=this.q.isEmpty();V&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let ge,Z;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(Z=e.create(),ge=this.f.check(Z,this.q.size+1)),w&&(Z=Z??e.create());const ie=new s(p,D,Z),te=this.q.push(ie);V&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,p,D);const he=ie.subscription.set(()=>{ge?.(),this.j||(te(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return _ instanceof U.DisposableStore?_.add(he):Array.isArray(_)&&_.push(he),he}),this.l}fire(p){if(this.q){this.m||(this.m=new h);for(const D of this.q)this.m.push(this,D,p);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=a;class l{constructor(){this.c=new H.LinkedList}get size(){return this.c.size}push(p,D,_){this.c.push(new r(p,D,_))}clear(p){const D=new H.LinkedList;for(const _ of this.c)_.emitter!==p&&D.push(_);this.c=D}deliver(){for(;this.c.size>0;){const p=this.c.shift();try{p.listener.invoke(p.event)}catch(D){(0,v.onUnexpectedError)(D)}}}}t.EventDeliveryQueue=l;class h extends l{clear(p){this.c.clear()}}class r{constructor(p,D,_){this.emitter=p,this.listener=D,this.event=_}}class u extends a{async fireAsync(p,D,_){if(!!this.q){this.c||(this.c=new H.LinkedList);for(const V of this.q)this.c.push([V,p]);for(;this.c.size>0&&!D.isCancellationRequested;){const[V,ge]=this.c.shift(),Z=[],ie={...ge,token:D,waitUntil:te=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");_&&(te=_(te,V.callback)),Z.push(te)}};try{V.invoke(ie)}catch(te){(0,v.onUnexpectedError)(te);continue}Object.freeze(Z),await Promise.allSettled(Z).then(te=>{for(const he of te)he.status==="rejected"&&(0,v.onUnexpectedError)(he.reason)})}}}}t.AsyncEmitter=u;class b extends a{constructor(p){super(p),this.h=0,this.s=new H.LinkedList,this.t=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.t(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.q&&(this.h!==0?this.s.push(p):super.fire(p))}}t.PauseableEmitter=b;class A extends b{constructor(p){super(p),this.c=p.delay??100}fire(p){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(p)}}t.DebounceEmitter=A;class N extends a{constructor(p){super(p),this.c=[],this.h=p?.merge}fire(p){!this.hasListeners()||(this.c.push(p),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(D=>super.fire(D)),this.c=[]}))}}t.MicrotaskEmitter=N;class L{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(p){const D={event:p,listener:null};this.f.push(D),this.d&&this.j(D);const _=()=>{this.d&&this.k(D);const V=this.f.indexOf(D);this.f.splice(V,1)};return(0,U.toDisposable)((0,i.once)(_))}g(){this.d=!0,this.f.forEach(p=>this.j(p))}h(){this.d=!1,this.f.forEach(p=>this.k(p))}j(p){p.listener=p.event(D=>this.c.fire(D))}k(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=L;class T{constructor(){this.c=[]}wrapEvent(p){return(D,_,V)=>p(ge=>{const Z=this.c[this.c.length-1];Z?Z.push(()=>D.call(_,ge)):D.call(_,ge)},void 0,V)}bufferEvents(p){const D=[];this.c.push(D);const _=p();return this.c.pop(),D.forEach(V=>V()),_}}t.EventBufferer=T;class c{constructor(){this.c=!1,this.d=m.None,this.f=U.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(p){this.d=p,this.c&&(this.f.dispose(),this.f=p(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=c}),define(be[16],pe([1,0,3,2]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class U{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new v.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(u,b){this.a!==u&&(this.a=u)}getZoomFactor(){return this.b}setZoomFactor(u){this.b=u}setFullscreen(u){this.c!==u&&(this.c=u,this.d.fire())}isFullscreen(){return this.c}}U.INSTANCE=new U;class H extends i.Disposable{constructor(){super(),this.a=this.B(new v.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(u){this.c?.removeEventListener("change",this.b),this.c=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),u&&this.a.fire()}}class y extends i.Disposable{get value(){return this.b}constructor(){super(),this.a=this.B(new v.Emitter),this.onDidChange=this.a.event,this.b=this.c();const u=this.B(new H);this.B(u.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const u=document.createElement("canvas").getContext("2d"),b=window.devicePixelRatio||1,A=u.webkitBackingStorePixelRatio||u.mozBackingStorePixelRatio||u.msBackingStorePixelRatio||u.oBackingStorePixelRatio||u.backingStorePixelRatio||1;return b/A}}class w{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.markAsSingleton)(new y)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function d(r,u){typeof r=="string"&&(r=window.matchMedia(r)),r.addEventListener("change",u)}t.addMatchMediaChangeListener=d,t.PixelRatio=new w;function m(r,u){U.INSTANCE.setZoomLevel(r,u)}t.setZoomLevel=m;function f(){return U.INSTANCE.getZoomLevel()}t.getZoomLevel=f;function M(){return U.INSTANCE.getZoomFactor()}t.getZoomFactor=M;function o(r){U.INSTANCE.setZoomFactor(r)}t.setZoomFactor=o;function n(r){U.INSTANCE.setFullscreen(r)}t.setFullscreen=n;function e(){return U.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=U.INSTANCE.onDidChangeFullscreen;const s=navigator.userAgent;t.isFirefox=s.indexOf("Firefox")>=0,t.isWebKit=s.indexOf("AppleWebKit")>=0,t.isChrome=s.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&s.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=s.indexOf("Electron/")>=0,t.isAndroid=s.indexOf("Android")>=0;let a=!1;if(window.matchMedia){const r=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),u=window.matchMedia("(display-mode: fullscreen)");a=r.matches,d(r,({matches:b})=>{a&&u.matches||(a=b)})}function l(){return a}t.isStandalone=l;function h(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=h}),define(be[108],pe([1,0,16,5]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var U;(function(H){H[H.Always=0]="Always",H[H.FullScreen=1]="FullScreen",H[H.None=2]="None"})(U=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||v.isStandalone()?0:navigator.keyboard||v.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[19],pe([1,0,3]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{get event(){return this.a.event}constructor(H,y,w){const d=m=>this.a.fire(m);this.a=new v.Emitter({onWillAddFirstListener:()=>H.addEventListener(y,d,w),onDidRemoveLastListener:()=>H.removeEventListener(y,d,w)})}dispose(){this.a.dispose()}}t.DomEmitter=i}),define(be[17],pe([1,0,16,43,74,5]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function y(e){if(e.charCode){const a=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(a)}const s=e.keyCode;if(s===3)return 7;if(v.isFirefox){if(s===59)return 80;if(s===107)return 81;if(s===109)return 83;if(H.isMacintosh&&s===224)return 57}else if(v.isWebKit){if(s===91)return 57;if(H.isMacintosh&&s===93)return 57;if(!H.isMacintosh&&s===92)return 57}return i.EVENT_KEY_CODE_MAP[s]||0}const w=H.isMacintosh?256:2048,d=512,m=1024,f=H.isMacintosh?2048:256;function M(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=M;function o(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=o;class n{constructor(s){this._standardKeyboardEventBrand=!0;const a=s;this.browserEvent=a,this.target=a.target,this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,this.keyCode=y(a),this.code=a.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let a=0;return this.ctrlKey&&(a|=w),this.altKey&&(a|=d),this.shiftKey&&(a|=m),this.metaKey&&(a|=f),a|=s,a}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new U.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=n}),define(be[20],pe([1,0,16,67,5]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class H{constructor(m){this.timestamp=Date.now(),this.browserEvent=m,this.leftButton=m.button===0,this.middleButton=m.button===1,this.rightButton=m.button===2,this.buttons=m.buttons,this.target=m.target,this.detail=m.detail||1,m.type==="dblclick"&&(this.detail=2),this.ctrlKey=m.ctrlKey,this.shiftKey=m.shiftKey,this.altKey=m.altKey,this.metaKey=m.metaKey,typeof m.pageX=="number"?(this.posx=m.pageX,this.posy=m.pageY):(this.posx=m.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=m.clientY+document.body.scrollTop+document.documentElement.scrollTop);const f=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,m.view);this.posx-=f.left,this.posy-=f.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=H;class y extends H{constructor(m){super(m),this.dataTransfer=m.dataTransfer}}t.DragMouseEvent=y;class w{constructor(m,f=0,M=0){if(this.browserEvent=m||null,this.target=m?m.target||m.targetNode||m.srcElement:null,this.deltaY=M,this.deltaX=f,m){const o=m,n=m;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof n.VERTICAL_AXIS<"u"&&n.axis===n.VERTICAL_AXIS)this.deltaY=-n.detail/3;else if(m.type==="wheel"){const e=m;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!U.isMacintosh?this.deltaY=-m.deltaY/3:this.deltaY=-m.deltaY:this.deltaY=-m.deltaY/40}if(typeof o.wheelDeltaX<"u")v.isSafari&&U.isWindows?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof n.HORIZONTAL_AXIS<"u"&&n.axis===n.HORIZONTAL_AXIS)this.deltaX=-m.detail/3;else if(m.type==="wheel"){const e=m;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!U.isMacintosh?this.deltaX=-m.deltaX/3:this.deltaX=-m.deltaX:this.deltaX=-m.deltaX/40}this.deltaY===0&&this.deltaX===0&&m.wheelDelta&&(this.deltaY=m.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=w}),define(be[31],pe([1,0,3,2,103]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class H extends i.Disposable{constructor(o,n="",e="",s=!0,a){super(),this.h=this.B(new v.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=n,this.u=e,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,n){this.C&&await this.C(o)}}t.Action=H;class y extends i.Disposable{constructor(){super(...arguments),this.f=this.B(new v.Emitter),this.onWillRun=this.f.event,this.h=this.B(new v.Emitter),this.onDidRun=this.h.event}async run(o,n){if(!o.enabled)return;this.f.fire({action:o});let e;try{await this.runAction(o,n)}catch(s){e=s}this.h.fire({action:o,error:e})}async runAction(o,n){await o.run(n)}}t.ActionRunner=y;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let n=[];for(const e of o)e.length&&(n.length?n=[...n,new w,...e]:n=e);return n}async run(){}}t.Separator=w,w.ID="vs.actions.separator";class d{get actions(){return this.a}constructor(o,n,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=n,this.class=s,this.a=e}async run(){}}t.SubmenuAction=d;class m extends H{constructor(){super(m.ID,U.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=m,m.ID="vs.actions.empty";function f(M){return{id:M.id,label:M.label,class:void 0,enabled:M.enabled??!0,checked:M.checked??!1,run:async()=>M.run(),tooltip:M.label}}t.toAction=f}),define(be[26],pe([1,0,3]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(w,d){const m=setTimeout(w.bind(d),0);return{dispose(){clearTimeout(m)}}});var U;(function(w){function d(m){return m===w.None||m===w.Cancelled||m instanceof H?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}w.isCancellationToken=d,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(U=t.CancellationToken||(t.CancellationToken={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new v.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(d){this.a=void 0,this.b=void 0,this.b=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new H),this.a}cancel(){this.a?this.a instanceof H&&this.a.cancel():this.a=U.Cancelled}dispose(d=!1){d&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof H&&this.a.dispose():this.a=U.None}}t.CancellationTokenSource=y}),define(be[109],pe([1,0,26]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new v.CancellationTokenSource,d=this.b(w.token);return this.a={promise:d,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}t.Cache=i;class U{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const d=JSON.stringify(w);return this.b!==d&&(this.b=d,this.a=this.c(w)),this.a}}t.LRUCachedFunction=U;class H{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const d=this.b(w);return this.a.set(w,d),d}}t.CachedFunction=H}),define(be[49],pe([1,0,3,2]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var U;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(U=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class H{constructor(e,s,a,l,h,r,u){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,a=a|0,l=l|0,h=h|0,r=r|0,u=u|0),this.rawScrollLeft=l,this.rawScrollTop=u,s<0&&(s=0),l+s>a&&(l=a-s),l<0&&(l=0),h<0&&(h=0),u+h>r&&(u=r-h),u<0&&(u=0),this.width=s,this.scrollWidth=a,this.scrollLeft=l,this.height=h,this.scrollHeight=r,this.scrollTop=u}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const a=this.width!==e.width,l=this.scrollWidth!==e.scrollWidth,h=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,u=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:l,scrollLeftChanged:h,heightChanged:r,scrollHeightChanged:u,scrollTopChanged:b}}}t.ScrollState=H;class y extends i.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new v.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const a=this.g.withScrollDimensions(e,s);this.k(a,Boolean(this.h)),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const a=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===a.scrollLeft&&this.h.to.scrollTop===a.scrollTop)return;let l;s?l=new f(this.h.from,a,this.h.startTime,this.h.duration):l=this.h.combine(this.g,a,this.c),this.h.dispose(),this.h=l}else{const a=this.g.withScrollPosition(e);this.h=f.start(this.g,a,this.c)}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}j(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.k(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}}k(e,s){const a=this.g;a.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(a,s)))}}t.Scrollable=y;class w{constructor(e,s,a){this.scrollLeft=e,this.scrollTop=s,this.isDone=a}}t.SmoothScrollingUpdate=w;function d(n,e){const s=e-n;return function(a){return n+s*o(a)}}function m(n,e,s){return function(a){return a<s?n(a/s):e((a-s)/(1-s))}}class f{constructor(e,s,a,l){this.from=e,this.to=s,this.duration=l,this.startTime=a,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,a){if(Math.abs(e-s)>2.5*a){let h,r;return e<s?(h=e+.75*a,r=s-.75*a):(h=e-.75*a,r=s+.75*a),m(d(e,h),d(r,s),.33)}return d(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const a=this.c(s),l=this.d(s);return new w(a,l,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,a){return f.start(e,s,a)}static start(e,s,a){a=a+10;const l=Date.now()-10;return new f(e,s,l,a)}}t.SmoothScrollingOperation=f;function M(n){return Math.pow(n,3)}function o(n){return 1-M(1-n)}}),define(be[11],pe([1,0,109,44]),function(X,t,v,i){"use strict";var U;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function H(K){return!K||typeof K!="string"?!0:K.trim().length===0}t.isFalsyOrWhitespace=H;const y=/{(\d+)}/g;function w(K,...oe){return oe.length===0?K:K.replace(y,function(we,Ce){const Te=parseInt(Ce,10);return isNaN(Te)||Te<0||Te>=oe.length?we:oe[Te]})}t.format=w;const d=/{([^}]+)}/g;function m(K,oe){return K.replace(d,(we,Ce)=>oe[Ce]??we)}t.format2=m;function f(K){return K.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=f;function M(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=M;function o(K,oe){let we=0;const Ce=oe.charCodeAt(0);for(let Te=K.length-1;Te>=0;Te--)K.charCodeAt(Te)===Ce&&we++;return we}t.count=o;function n(K,oe,we="\u2026"){return K.length<=oe?K:`${K.substr(0,oe)}${we}`}t.truncate=n;function e(K,oe=" "){const we=s(K,oe);return a(we,oe)}t.trim=e;function s(K,oe){if(!K||!oe)return K;const we=oe.length;if(we===0||K.length===0)return K;let Ce=0;for(;K.indexOf(oe,Ce)===Ce;)Ce=Ce+we;return K.substring(Ce)}t.ltrim=s;function a(K,oe){if(!K||!oe)return K;const we=oe.length,Ce=K.length;if(we===0||Ce===0)return K;let Te=Ce,Oe=-1;for(;Oe=K.lastIndexOf(oe,Te-1),!(Oe===-1||Oe+we!==Te);){if(Oe===0)return"";Te=Oe}return K.substring(0,Te)}t.rtrim=a;function l(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=l;function h(K){return K.replace(/\*/g,"")}t.stripWildcards=h;function r(K,oe,we={}){if(!K)throw new Error("Cannot create regex from empty string");oe||(K=M(K)),we.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Ce="";return we.global&&(Ce+="g"),we.matchCase||(Ce+="i"),we.multiline&&(Ce+="m"),we.unicode&&(Ce+="u"),new RegExp(K,Ce)}t.createRegExp=r;function u(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}t.regExpLeadsToEndlessLoop=u;function b(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=b;function A(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}t.regExpFlags=A;function N(K){return K.split(/\r\n|\r|\n/)}t.splitLines=N;function L(K){for(let oe=0,we=K.length;oe<we;oe++){const Ce=K.charCodeAt(oe);if(Ce!==32&&Ce!==9)return oe}return-1}t.firstNonWhitespaceIndex=L;function T(K,oe=0,we=K.length){for(let Ce=oe;Ce<we;Ce++){const Te=K.charCodeAt(Ce);if(Te!==32&&Te!==9)return K.substring(oe,Ce)}return K.substring(oe,we)}t.getLeadingWhitespace=T;function c(K,oe=K.length-1){for(let we=oe;we>=0;we--){const Ce=K.charCodeAt(we);if(Ce!==32&&Ce!==9)return we}return-1}t.lastNonWhitespaceIndex=c;function C(K,oe,we){const Ce=[];let Te=0;for(const Oe of K.matchAll(oe)){if(Ce.push(K.slice(Te,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Te=Oe.index+Oe[0].length,Ce.push(we(Oe[0],...Oe.slice(1),Oe.index,K,Oe.groups))}return Ce.push(K.slice(Te)),Promise.all(Ce).then(Oe=>Oe.join(""))}t.replaceAsync=C;function p(K,oe){return K<oe?-1:K>oe?1:0}t.compare=p;function D(K,oe,we=0,Ce=K.length,Te=0,Oe=oe.length){for(;we<Ce&&Te<Oe;we++,Te++){const Me=K.charCodeAt(we),ne=oe.charCodeAt(Te);if(Me<ne)return-1;if(Me>ne)return 1}const $e=Ce-we,tt=Oe-Te;return $e<tt?-1:$e>tt?1:0}t.compareSubstring=D;function _(K,oe){return V(K,oe,0,K.length,0,oe.length)}t.compareIgnoreCase=_;function V(K,oe,we=0,Ce=K.length,Te=0,Oe=oe.length){for(;we<Ce&&Te<Oe;we++,Te++){let Me=K.charCodeAt(we),ne=oe.charCodeAt(Te);if(Me===ne)continue;if(Me>=128||ne>=128)return D(K.toLowerCase(),oe.toLowerCase(),we,Ce,Te,Oe);Z(Me)&&(Me-=32),Z(ne)&&(ne-=32);const Ae=Me-ne;if(Ae!==0)return Ae}const $e=Ce-we,tt=Oe-Te;return $e<tt?-1:$e>tt?1:0}t.compareSubstringIgnoreCase=V;function ge(K){return K>=48&&K<=57}t.isAsciiDigit=ge;function Z(K){return K>=97&&K<=122}t.isLowerAsciiLetter=Z;function ie(K){return K>=65&&K<=90}t.isUpperAsciiLetter=ie;function te(K,oe){return K.length===oe.length&&V(K,oe)===0}t.equalsIgnoreCase=te;function he(K,oe){const we=oe.length;return oe.length>K.length?!1:V(K,oe,0,we)===0}t.startsWithIgnoreCase=he;function re(K,oe){const we=Math.min(K.length,oe.length);let Ce;for(Ce=0;Ce<we;Ce++)if(K.charCodeAt(Ce)!==oe.charCodeAt(Ce))return Ce;return we}t.commonPrefixLength=re;function ce(K,oe){const we=Math.min(K.length,oe.length);let Ce;const Te=K.length-1,Oe=oe.length-1;for(Ce=0;Ce<we;Ce++)if(K.charCodeAt(Te-Ce)!==oe.charCodeAt(Oe-Ce))return Ce;return we}t.commonSuffixLength=ce;function Se(K){return 55296<=K&&K<=56319}t.isHighSurrogate=Se;function x(K){return 56320<=K&&K<=57343}t.isLowSurrogate=x;function De(K,oe){return(K-55296<<10)+(oe-56320)+65536}t.computeCodePoint=De;function se(K,oe,we){const Ce=K.charCodeAt(we);if(Se(Ce)&&we+1<oe){const Te=K.charCodeAt(we+1);if(x(Te))return De(Ce,Te)}return Ce}t.getNextCodePoint=se;function Q(K,oe){const we=K.charCodeAt(oe-1);if(x(we)&&oe>1){const Ce=K.charCodeAt(oe-2);if(Se(Ce))return De(Ce,we)}return we}class le{get offset(){return this.e}constructor(oe,we=0){this.c=oe,this.d=oe.length,this.e=we}setOffset(oe){this.e=oe}prevCodePoint(){const oe=Q(this.c,this.e);return this.e-=oe>=65536?2:1,oe}nextCodePoint(){const oe=se(this.c,this.d,this.e);return this.e+=oe>=65536?2:1,oe}eol(){return this.e>=this.d}}t.CodePointIterator=le;class de{get offset(){return this.c.offset}constructor(oe,we=0){this.c=new le(oe,we)}nextGraphemeLength(){const oe=je.getInstance(),we=this.c,Ce=we.offset;let Te=oe.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Oe=we.offset,$e=oe.getGraphemeBreakType(we.nextCodePoint());if(Pe(Te,$e)){we.setOffset(Oe);break}Te=$e}return we.offset-Ce}prevGraphemeLength(){const oe=je.getInstance(),we=this.c,Ce=we.offset;let Te=oe.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Oe=we.offset,$e=oe.getGraphemeBreakType(we.prevCodePoint());if(Pe($e,Te)){we.setOffset(Oe);break}Te=$e}return Ce-we.offset}eol(){return this.c.eol()}}t.GraphemeIterator=de;function me(K,oe){return new de(K,oe).nextGraphemeLength()}t.nextCharLength=me;function ee(K,oe){return new de(K,oe).prevGraphemeLength()}t.prevCharLength=ee;function k(K,oe){oe>0&&x(K.charCodeAt(oe))&&oe--;const we=oe+me(K,oe);return[we-ee(K,we),we]}t.getCharContainingOffset=k;function E(K){const oe=new de(K);let we=0;for(;!oe.eol();)we++,oe.nextGraphemeLength();return we}t.charCount=E;let g;function R(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(K){return g||(g=R()),g.test(K)}t.containsRTL=W;const $=/^[\t\n\r\x20-\x7E]*$/;function Y(K){return $.test(K)}t.isBasicASCII=Y,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function F(K){return t.UNUSUAL_LINE_TERMINATORS.test(K)}t.containsUnusualLineTerminators=F;function B(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}t.isFullWidthCharacter=B;function z(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}t.isEmojiImprecise=z;function S(K,oe){if(K.length<oe)return K;const we=/\b/g;let Ce=0;for(;we.test(K)&&!(K.length-we.lastIndex<oe);)Ce=we.lastIndex,we.lastIndex+=1;return K.substring(Ce).replace(/^\s/,"")}t.lcut=S;const I=/\x1B\x5B[12]?K/g,P=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function j(K){return K&&(K=K.replace(I,""),K=K.replace(P,""),K=K.replace(O,"")),K}t.removeAnsiEscapeCodes=j,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function J(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}t.startsWithUTF8BOM=J;function ae(K){return J(K)?K.substr(1):K}t.stripUTF8BOM=ae;function ue(K,oe){if(!K||!oe||K.length<oe.length)return!1;const we=oe.length,Ce=K.toLowerCase();let Te=0,Oe=-1;for(;Te<we;){const $e=Ce.indexOf(oe[Te],Oe+1);if($e<0)return!1;Oe=$e,Te++}return!0}t.fuzzyContains=ue;function ye(K,oe=!1){return K?(oe&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}t.containsUppercaseCharacter=ye;function Ee(K){return K.charAt(0).toUpperCase()+K.slice(1)}t.uppercaseFirstLetter=Ee;function Ie(K,oe=1){if(oe===0)return"";let we=-1;do we=K.indexOf(`
`,we+1),oe--;while(oe>0&&we>=0);return we===-1?K:(K[we-1]==="\r"&&we--,K.substr(0,we))}t.getNLines=Ie;function ke(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}t.singleLetterHash=ke;function ve(K){return je.getInstance().getGraphemeBreakType(K)}t.getGraphemeBreakType=ve;function Pe(K,oe){return K===0?oe!==5&&oe!==7:K===2&&oe===3?!1:K===4||K===2||K===3||oe===4||oe===2||oe===3?!0:!(K===8&&(oe===8||oe===9||oe===11||oe===12)||(K===11||K===9)&&(oe===9||oe===10)||(K===12||K===10)&&oe===10||oe===5||oe===13||oe===7||K===1||K===13&&oe===14||K===6&&oe===6)}var Re;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Re=t.GraphemeBreakType||(t.GraphemeBreakType={}));class je{static getInstance(){return je.c||(je.c=new je),je.c}constructor(){this.d=Ue()}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const we=this.d,Ce=we.length/3;let Te=1;for(;Te<=Ce;)if(oe<we[3*Te])Te=2*Te;else if(oe>we[3*Te+1])Te=2*Te+1;else return we[3*Te+2];return 0}}je.c=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(K,oe){if(K===0)return 0;const we=xe(K,oe);if(we!==void 0)return we;const Ce=new le(oe,K);return Ce.prevCodePoint(),Ce.offset}t.getLeftDeleteOffset=We;function xe(K,oe){const we=new le(oe,K);let Ce=we.prevCodePoint();for(;it(Ce)||Ce===65039||Ce===8419;){if(we.offset===0)return;Ce=we.prevCodePoint()}if(!z(Ce))return;let Te=we.offset;return Te>0&&we.prevCodePoint()===8205&&(Te=we.offset),Te}function it(K){return 127995<=K&&K<=127999}var Be;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.noBreakWhitespace="\xA0";class Ve{static getInstance(oe){return Ve.d.get(Array.from(oe))}static getLocales(){return Ve.e.getValue()}constructor(oe){this.f=oe}isAmbiguous(oe){return this.f.has(oe)}getPrimaryConfusable(oe){return this.f.get(oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=Ve,U=Ve,Ve.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ve.d=new v.LRUCachedFunction(K=>{function oe(ne){const Ae=new Map;for(let Ne=0;Ne<ne.length;Ne+=2)Ae.set(ne[Ne],ne[Ne+1]);return Ae}function we(ne,Ae){const Ne=new Map(ne);for(const[ze,Ge]of Ae)Ne.set(ze,Ge);return Ne}function Ce(ne,Ae){if(!ne)return Ae;const Ne=new Map;for(const[ze,Ge]of ne)Ae.has(ze)&&Ne.set(ze,Ge);return Ne}const Te=U.c.getValue();let Oe=K.filter(ne=>!ne.startsWith("_")&&ne in Te);Oe.length===0&&(Oe=["_default"]);let $e;for(const ne of Oe){const Ae=oe(Te[ne]);$e=Ce($e,Ae)}const tt=oe(Te._common),Me=we(tt,$e);return new Ve(Me)}),Ve.e=new i.Lazy(()=>Object.keys(Ve.c.getValue()).filter(K=>!K.startsWith("_")));class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(oe){return Ye.e().has(oe)}static get codePoints(){return Ye.e()}}t.InvisibleCharacters=Ye,Ye.d=void 0}),define(be[110],pe([1,0,21,5,11,6]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function y(c){return c===47||c===92}t.isPathSeparator=y;function w(c){return c.replace(/[\\/]/g,v.posix.sep)}t.toSlashes=w;function d(c){return c.indexOf("/")===-1&&(c=w(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}t.toPosixPath=d;function m(c,C=v.posix.sep){if(!c)return"";const p=c.length,D=c.charCodeAt(0);if(y(D)){if(y(c.charCodeAt(1))&&!y(c.charCodeAt(2))){let V=3;const ge=V;for(;V<p&&!y(c.charCodeAt(V));V++);if(ge!==V&&!y(c.charCodeAt(V+1))){for(V+=1;V<p;V++)if(y(c.charCodeAt(V)))return c.slice(0,V+1).replace(/[\\/]/g,C)}}return C}else if(l(D)&&c.charCodeAt(1)===58)return y(c.charCodeAt(2))?c.slice(0,2)+C:c.slice(0,2);let _=c.indexOf("://");if(_!==-1){for(_+=3;_<p;_++)if(y(c.charCodeAt(_)))return c.slice(0,_+1)}return""}t.getRoot=m;function f(c){if(!i.isWindows||!c||c.length<5)return!1;let C=c.charCodeAt(0);if(C!==92||(C=c.charCodeAt(1),C!==92))return!1;let p=2;const D=p;for(;p<c.length&&(C=c.charCodeAt(p),C!==92);p++);return!(D===p||(C=c.charCodeAt(p+1),isNaN(C)||C===92))}t.isUNC=f;const M=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,n=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(c,C=i.isWindows){const p=C?M:o;return!(!c||c.length===0||/^\s+$/.test(c)||(p.lastIndex=0,p.test(c))||C&&n.test(c)||c==="."||c===".."||C&&c[c.length-1]==="."||C&&c.length!==c.trim().length||c.length>255)}t.isValidBasename=e;function s(c,C,p){const D=c===C;return!p||D?D:!c||!C?!1:(0,U.equalsIgnoreCase)(c,C)}t.isEqual=s;function a(c,C,p,D=v.sep){if(c===C)return!0;if(!c||!C||C.length>c.length)return!1;if(p){if(!(0,U.startsWithIgnoreCase)(c,C))return!1;if(C.length===c.length)return!0;let V=C.length;return C.charAt(C.length-1)===D&&V--,c.charAt(V)===D}return C.charAt(C.length-1)!==D&&(C+=D),c.indexOf(C)===0}t.isEqualOrParent=a;function l(c){return c>=65&&c<=90||c>=97&&c<=122}t.isWindowsDriveLetter=l;function h(c,C){return i.isWindows&&c.endsWith(":")&&(c+=v.sep),(0,v.isAbsolute)(c)||(c=(0,v.join)(C,c)),c=(0,v.normalize)(c),i.isWindows?(c=(0,U.rtrim)(c,v.sep),c.endsWith(":")&&(c+=v.sep)):(c=(0,U.rtrim)(c,v.sep),c||(c=v.sep)),c}t.sanitizeFilePath=h;function r(c){const C=(0,v.normalize)(c);return i.isWindows?c.length>3?!1:u(C)&&(c.length===2||C.charCodeAt(2)===92):C===v.posix.sep}t.isRootOrDriveLetter=r;function u(c,C=i.isWindows){return C?l(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}t.hasDriveLetter=u;function b(c){return u(c)?c[0]:void 0}t.getDriveLetter=b;function A(c,C,p){return C.length>c.length?-1:c===C?0:(p&&(c=c.toLowerCase(),C=C.toLowerCase()),c.indexOf(C))}t.indexOfPath=A;function N(c){const C=c.split(":");let p,D,_;for(const V of C){const ge=Number(V);(0,H.isNumber)(ge)?D===void 0?D=ge:_===void 0&&(_=ge):p=p?[p,V].join(":"):V}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:D!==void 0?D:void 0,column:_!==void 0?_:D!==void 0?1:void 0}}t.parseLineAndColumnAware=N;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function T(c,C,p=8){let D="";for(let V=0;V<p;V++)D+=L.charAt(Math.floor(Math.random()*L.length));let _;return C?_=`${C}-${D}`:_=D,c?(0,v.join)(c,_):_}t.randomPath=T}),define(be[32],pe([1,0,75,11]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function U(...P){return function(O,j){for(let J=0,ae=P.length;J<ae;J++){const ue=P[J](O,j);if(ue)return ue}return null}}t.or=U,t.matchesStrictPrefix=H.bind(void 0,!1),t.matchesPrefix=H.bind(void 0,!0);function H(P,O,j){if(!j||j.length<O.length)return null;let J;return P?J=i.startsWithIgnoreCase(j,O):J=j.indexOf(O)===0,J?O.length>0?[{start:0,end:O.length}]:[]:null}function y(P,O){const j=O.toLowerCase().indexOf(P.toLowerCase());return j===-1?null:[{start:j,end:j+P.length}]}t.matchesContiguousSubString=y;function w(P,O){return d(P.toLowerCase(),O.toLowerCase(),0,0)}t.matchesSubString=w;function d(P,O,j,J){if(j===P.length)return[];if(J===O.length)return null;if(P[j]===O[J]){let ae=null;return(ae=d(P,O,j+1,J+1))?l({start:J,end:J+1},ae):null}return d(P,O,j,J+1)}function m(P){return 97<=P&&P<=122}function f(P){return 65<=P&&P<=90}t.isUpper=f;function M(P){return 48<=P&&P<=57}function o(P){return P===32||P===9||P===10||P===13}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(P=>n.add(P.charCodeAt(0)));function e(P){return o(P)||n.has(P)}function s(P,O){return P===O||e(P)&&e(O)}function a(P){return m(P)||f(P)||M(P)}function l(P,O){return O.length===0?O=[P]:P.end===O[0].start?O[0].start=P.start:O.unshift(P),O}function h(P,O){for(let j=O;j<P.length;j++){const J=P.charCodeAt(j);if(f(J)||M(J)||j>0&&!a(P.charCodeAt(j-1)))return j}return P.length}function r(P,O,j,J){if(j===P.length)return[];if(J===O.length)return null;if(P[j]!==O[J].toLowerCase())return null;{let ae=null,ue=J+1;for(ae=r(P,O,j+1,J+1);!ae&&(ue=h(O,ue))<O.length;)ae=r(P,O,j+1,ue),ue++;return ae===null?null:l({start:J,end:J+1},ae)}}function u(P){let O=0,j=0,J=0,ae=0,ue=0;for(let ve=0;ve<P.length;ve++)ue=P.charCodeAt(ve),f(ue)&&O++,m(ue)&&j++,a(ue)&&J++,M(ue)&&ae++;const ye=O/P.length,Ee=j/P.length,Ie=J/P.length,ke=ae/P.length;return{upperPercent:ye,lowerPercent:Ee,alphaPercent:Ie,numericPercent:ke}}function b(P){const{upperPercent:O,lowerPercent:j}=P;return j===0&&O>.6}function A(P){const{upperPercent:O,lowerPercent:j,alphaPercent:J,numericPercent:ae}=P;return j>.2&&O<.8&&J>.6&&ae<.2}function N(P){let O=0,j=0,J=0,ae=0;for(let ue=0;ue<P.length;ue++)J=P.charCodeAt(ue),f(J)&&O++,m(J)&&j++,o(J)&&ae++;return(O===0||j===0)&&ae===0?P.length<=30:O<=5}function L(P,O){if(!O||(O=O.trim(),O.length===0)||!N(P)||O.length>60)return null;const j=u(O);if(!A(j)){if(!b(j))return null;O=O.toLowerCase()}let J=null,ae=0;for(P=P.toLowerCase();ae<O.length&&(J=r(P,O,0,ae))===null;)ae=h(O,ae+1);return J}t.matchesCamelCase=L;function T(P,O,j=!1){if(!O||O.length===0)return null;let J=null,ae=0;for(P=P.toLowerCase(),O=O.toLowerCase();ae<O.length&&(J=c(P,O,0,ae,j))===null;)ae=C(O,ae+1);return J}t.matchesWords=T;function c(P,O,j,J,ae){if(j===P.length)return[];if(J===O.length)return null;if(s(P.charCodeAt(j),O.charCodeAt(J))){let ue=null,ye=J+1;if(ue=c(P,O,j+1,J+1,ae),!ae)for(;!ue&&(ye=C(O,ye))<O.length;)ue=c(P,O,j+1,ye,ae),ye++;return ue?P.charCodeAt(j)!==O.charCodeAt(J)?ue:l({start:J,end:J+1},ue):null}else return null}function C(P,O){for(let j=O;j<P.length;j++)if(e(P.charCodeAt(j))||j>0&&e(P.charCodeAt(j-1)))return j;return P.length}const p=U(t.matchesPrefix,L,y),D=U(t.matchesPrefix,L,w),_=new v.LRUCache(1e4);function V(P,O,j=!1){if(typeof P!="string"||typeof O!="string")return null;let J=_.get(P);J||(J=new RegExp(i.convertSimple2RegExpPattern(P),"i"),_.set(P,J));const ae=J.exec(O);return ae?[{start:ae.index,end:ae.index+ae[0].length}]:j?D(P,O):p(P,O)}t.matchesFuzzy=V;function ge(P,O){const j=$(P,P.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?ie(j):null}t.matchesFuzzy2=ge;function Z(P,O,j,J,ae,ue){const ye=Math.min(13,P.length);for(;j<ye;j++){const Ee=$(P,O,j,J,ae,ue,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ee)return Ee}return[0,ue]}t.anyScore=Z;function ie(P){if(typeof P>"u")return[];const O=[],j=P[1];for(let J=P.length-1;J>1;J--){const ae=P[J]+j,ue=O[O.length-1];ue&&ue.end===ae?ue.end=ae+1:O.push({start:ae,end:ae+1})}return O}t.createMatches=ie;const te=128;function he(){const P=[],O=[];for(let j=0;j<=te;j++)O[j]=0;for(let j=0;j<=te;j++)P.push(O.slice(0));return P}function re(P){const O=[];for(let j=0;j<=P;j++)O[j]=0;return O}const ce=re(2*te),Se=re(2*te),x=he(),De=he(),se=he(),Q=!1;function le(P,O,j,J,ae){function ue(Ee,Ie,ke=" "){for(;Ee.length<Ie;)Ee=ke+Ee;return Ee}let ye=` |   |${J.split("").map(Ee=>ue(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=j;Ee++)Ee===0?ye+=" |":ye+=`${O[Ee-1]}|`,ye+=P[Ee].slice(0,ae+1).map(Ie=>ue(Ie.toString(),3)).join("|")+`
`;return ye}function de(P,O,j,J){P=P.substr(O),j=j.substr(J),console.log(le(De,P,P.length,j,j.length)),console.log(le(se,P,P.length,j,j.length)),console.log(le(x,P,P.length,j,j.length))}function me(P,O){if(O<0||O>=P.length)return!1;const j=P.codePointAt(O);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(j)}}function ee(P,O){if(O<0||O>=P.length)return!1;switch(P.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function k(P,O,j){return O[P]!==j[P]}function E(P,O,j,J,ae,ue,ye=!1){for(;O<j&&ae<ue;)P[O]===J[ae]&&(ye&&(ce[O]=ae),O+=1),ae+=1;return O===j}t.isPatternInWord=E;var g;(function(P){P[P.Diag=1]="Diag",P[P.Left=2]="Left",P[P.LeftLeft=3]="LeftLeft"})(g||(g={}));var R;(function(P){P.Default=[-100,0];function O(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}P.isDefault=O})(R=t.FuzzyScore||(t.FuzzyScore={}));class W{constructor(O,j){this.firstMatchCanBeWeak=O,this.boostFullMatch=j}}t.FuzzyScoreOptions=W,W.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $(P,O,j,J,ae,ue,ye=W.default){const Ee=P.length>te?te:P.length,Ie=J.length>te?te:J.length;if(j>=Ee||ue>=Ie||Ee-j>Ie-ue||!E(O,j,Ee,ae,ue,Ie,!0))return;Y(Ee,Ie,j,ue,O,ae);let ke=1,ve=1,Pe=j,Re=ue;const je=[!1];for(ke=1,Pe=j;Pe<Ee;ke++,Pe++){const Be=ce[Pe],Ve=Se[Pe],Ye=Pe+1<Ee?Se[Pe+1]:Ie;for(ve=Be-ue+1,Re=Be;Re<Ye;ve++,Re++){let K=Number.MIN_SAFE_INTEGER,oe=!1;Re<=Ve&&(K=F(P,O,Pe,j,J,ae,Re,Ie,ue,x[ke-1][ve-1]===0,je));let we=0;K!==Number.MAX_SAFE_INTEGER&&(oe=!0,we=K+De[ke-1][ve-1]);const Ce=Re>Be,Te=Ce?De[ke][ve-1]+(x[ke][ve-1]>0?-5:0):0,Oe=Re>Be+1&&x[ke][ve-1]>0,$e=Oe?De[ke][ve-2]+(x[ke][ve-2]>0?-5:0):0;if(Oe&&(!Ce||$e>=Te)&&(!oe||$e>=we))De[ke][ve]=$e,se[ke][ve]=3,x[ke][ve]=0;else if(Ce&&(!oe||Te>=we))De[ke][ve]=Te,se[ke][ve]=2,x[ke][ve]=0;else if(oe)De[ke][ve]=we,se[ke][ve]=1,x[ke][ve]=x[ke-1][ve-1]+1;else throw new Error("not possible")}}if(Q&&de(P,j,J,ue),!je[0]&&!ye.firstMatchCanBeWeak)return;ke--,ve--;const Ue=[De[ke][ve],ue];let We=0,xe=0;for(;ke>=1;){let Be=ve;do{const Ve=se[ke][Be];if(Ve===3)Be=Be-2;else if(Ve===2)Be=Be-1;else break}while(Be>=1);We>1&&O[j+ke-1]===ae[ue+ve-1]&&!k(Be+ue-1,J,ae)&&We+1>x[ke][Be]&&(Be=ve),Be===ve?We++:We=1,xe||(xe=Be),ke--,ve=Be-1,Ue.push(ve)}Ie===Ee&&ye.boostFullMatch&&(Ue[0]+=2);const it=xe-Ee;return Ue[0]-=it,Ue}t.fuzzyScore=$;function Y(P,O,j,J,ae,ue){let ye=P-1,Ee=O-1;for(;ye>=j&&Ee>=J;)ae[ye]===ue[Ee]&&(Se[ye]=Ee,ye--),Ee--}function F(P,O,j,J,ae,ue,ye,Ee,Ie,ke,ve){if(O[j]!==ue[ye])return Number.MIN_SAFE_INTEGER;let Pe=1,Re=!1;return ye===j-J?Pe=P[j]===ae[ye]?7:5:k(ye,ae,ue)&&(ye===0||!k(ye-1,ae,ue))?(Pe=P[j]===ae[ye]?7:5,Re=!0):me(ue,ye)&&(ye===0||!me(ue,ye-1))?Pe=5:(me(ue,ye-1)||ee(ue,ye-1))&&(Pe=5,Re=!0),Pe>1&&j===J&&(ve[0]=!0),Re||(Re=k(ye,ae,ue)||me(ue,ye-1)||ee(ue,ye-1)),j===J?ye>Ie&&(Pe-=Re?3:5):ke?Pe+=Re?2:0:Pe+=Re?0:1,ye+1===Ee&&(Pe-=Re?3:5),Pe}function B(P,O,j,J,ae,ue,ye){return S(P,O,j,J,ae,ue,!0,ye)}t.fuzzyScoreGracefulAggressive=B;function z(P,O,j,J,ae,ue,ye){return S(P,O,j,J,ae,ue,!1,ye)}t.fuzzyScoreGraceful=z;function S(P,O,j,J,ae,ue,ye,Ee){let Ie=$(P,O,j,J,ae,ue,Ee);if(Ie&&!ye)return Ie;if(P.length>=3){const ke=Math.min(7,P.length-1);for(let ve=j+1;ve<ke;ve++){const Pe=I(P,ve);if(Pe){const Re=$(Pe,Pe.toLowerCase(),j,J,ae,ue,Ee);Re&&(Re[0]-=3,(!Ie||Re[0]>Ie[0])&&(Ie=Re))}}}return Ie}function I(P,O){if(O+1>=P.length)return;const j=P[O],J=P[O+1];if(j!==J)return P.slice(0,O)+J+j+P.slice(O+2)}}),define(be[111],pe([1,0,11]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(l){return U(l,0)}t.hash=i;function U(l,h){switch(typeof l){case"object":return l===null?H(349,h):Array.isArray(l)?d(l,h):m(l,h);case"string":return w(l,h);case"boolean":return y(l,h);case"number":return H(l,h);case"undefined":return H(937,h);default:return H(617,h)}}t.doHash=U;function H(l,h){return(h<<5)-h+l|0}t.numberHash=H;function y(l,h){return H(l?433:863,h)}function w(l,h){h=H(149417,h);for(let r=0,u=l.length;r<u;r++)h=H(l.charCodeAt(r),h);return h}t.stringHash=w;function d(l,h){return h=H(104579,h),l.reduce((r,u)=>U(u,r),h)}function m(l,h){return h=H(181387,h),Object.keys(l).sort().reduce((r,u)=>(r=w(u,r),U(l[u],r)),h)}class f{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=U(h,this.g),this.g}}t.Hasher=f;var M;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function o(l,h,r=32){const u=r-h,b=~((1<<u)-1);return(l<<h|(b&l)>>>u)>>>0}function n(l,h=0,r=l.byteLength,u=0){for(let b=0;b<r;b++)l[h+b]=u}function e(l,h,r="0"){for(;l.length<h;)l=r+l;return l}function s(l,h=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((l>>>0).toString(16),h/4)}t.toHexString=s;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const r=h.length;if(r===0)return;const u=this.p;let b=this.r,A=this.u,N,L;for(A!==0?(N=A,L=-1,A=0):(N=h.charCodeAt(0),L=0);;){let T=N;if(v.isHighSurrogate(N))if(L+1<r){const c=h.charCodeAt(L+1);v.isLowSurrogate(c)?(L++,T=v.computeCodePoint(N,c)):T=65533}else{A=N;break}else v.isLowSurrogate(N)&&(T=65533);if(b=this.w(u,b,T),L++,L<r)N=h.charCodeAt(L);else break}this.r=b,this.u=A}w(h,r,u){return u<128?h[r++]=u:u<2048?(h[r++]=192|(u&1984)>>>6,h[r++]=128|(u&63)>>>0):u<65536?(h[r++]=224|(u&61440)>>>12,h[r++]=128|(u&4032)>>>6,h[r++]=128|(u&63)>>>0):(h[r++]=240|(u&1835008)>>>18,h[r++]=128|(u&258048)>>>12,h[r++]=128|(u&4032)>>>6,h[r++]=128|(u&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,n(this.p,this.r),this.r>56&&(this.y(),n(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=a.g,r=this.q;for(let p=0;p<64;p+=4)h.setUint32(p,r.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)h.setUint32(p,o(h.getUint32(p-12,!1)^h.getUint32(p-32,!1)^h.getUint32(p-56,!1)^h.getUint32(p-64,!1),1),!1);let u=this.h,b=this.l,A=this.m,N=this.n,L=this.o,T,c,C;for(let p=0;p<80;p++)p<20?(T=b&A|~b&N,c=1518500249):p<40?(T=b^A^N,c=1859775393):p<60?(T=b&A|b&N|A&N,c=2400959708):(T=b^A^N,c=3395469782),C=o(u,5)+T+L+c+h.getUint32(p*4,!1)&4294967295,L=N,N=A,A=o(b,30),b=u,u=C;this.h=this.h+u&4294967295,this.l=this.l+b&4294967295,this.m=this.m+A&4294967295,this.n=this.n+N&4294967295,this.o=this.o+L&4294967295}}t.StringSHA1=a,a.g=new DataView(new ArrayBuffer(320))}),define(be[112],pe([1,0,71,111]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class U{constructor(o){this.a=o}getElements(){const o=this.a,n=new Int32Array(o.length);for(let e=0,s=o.length;e<s;e++)n[e]=o.charCodeAt(e);return n}}t.StringDiffSequence=U;function H(M,o,n){return new f(new U(M),new U(o)).ComputeDiff(n).changes}t.stringDiff=H;class y{static Assert(o,n){if(!o)throw new Error(n)}}class w{static Copy(o,n,e,s,a){for(let l=0;l<a;l++)e[s+l]=o[n+l]}static Copy2(o,n,e,s,a){for(let l=0;l<a;l++)e[s+l]=o[n+l]}}var d;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(d||(d={}));class m{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(o,n){this.b=Math.min(this.b,o),this.c=Math.min(this.c,n),this.d++}AddModifiedElement(o,n){this.b=Math.min(this.b,o),this.c=Math.min(this.c,n),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(o,n,e=null){this.a=e,this.b=o,this.c=n;const[s,a,l]=f.o(o),[h,r,u]=f.o(n);this.d=l&&u,this.e=s,this.f=a,this.g=h,this.h=r,this.k=[],this.m=[]}static n(o){return o.length>0&&typeof o[0]=="string"}static o(o){const n=o.getElements();if(f.n(n)){const e=new Int32Array(n.length);for(let s=0,a=n.length;s<a;s++)e[s]=(0,i.stringHash)(n[s],0);return[n,e,!0]}return n instanceof Int32Array?[[],n,!1]:[[],new Int32Array(n),!1]}p(o,n){return this.f[o]!==this.h[n]?!1:this.d?this.e[o]===this.g[n]:!0}q(o,n){if(!this.p(o,n))return!1;const e=f.r(this.b,o),s=f.r(this.c,n);return e===s}static r(o,n){return typeof o.getStrictElement=="function"?o.getStrictElement(n):null}s(o,n){return this.f[o]!==this.f[n]?!1:this.d?this.e[o]===this.e[n]:!0}u(o,n){return this.h[o]!==this.h[n]?!1:this.d?this.g[o]===this.g[n]:!0}ComputeDiff(o){return this.v(0,this.f.length-1,0,this.h.length-1,o)}v(o,n,e,s,a){const l=[!1];let h=this.w(o,n,e,s,l);return a&&(h=this.z(h)),{quitEarly:l[0],changes:h}}w(o,n,e,s,a){for(a[0]=!1;o<=n&&e<=s&&this.p(o,e);)o++,e++;for(;n>=o&&s>=e&&this.p(n,s);)n--,s--;if(o>n||e>s){let A;return e<=s?(y.Assert(o===n+1,"originalStart should only be one more than originalEnd"),A=[new v.DiffChange(o,0,e,s-e+1)]):o<=n?(y.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),A=[new v.DiffChange(o,n-o+1,e,0)]):(y.Assert(o===n+1,"originalStart should only be one more than originalEnd"),y.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),A=[]),A}const l=[0],h=[0],r=this.y(o,n,e,s,l,h,a),u=l[0],b=h[0];if(r!==null)return r;if(!a[0]){const A=this.w(o,u,e,b,a);let N=[];return a[0]?N=[new v.DiffChange(u+1,n-(u+1)+1,b+1,s-(b+1)+1)]:N=this.w(u+1,n,b+1,s,a),this.H(A,N)}return[new v.DiffChange(o,n-o+1,e,s-e+1)]}x(o,n,e,s,a,l,h,r,u,b,A,N,L,T,c,C,p,D){let _=null,V=null,ge=new m,Z=n,ie=e,te=L[0]-C[0]-s,he=-1073741824,re=this.k.length-1;do{const ce=te+o;ce===Z||ce<ie&&u[ce-1]<u[ce+1]?(A=u[ce+1],T=A-te-s,A<he&&ge.MarkNextChange(),he=A,ge.AddModifiedElement(A+1,T),te=ce+1-o):(A=u[ce-1]+1,T=A-te-s,A<he&&ge.MarkNextChange(),he=A-1,ge.AddOriginalElement(A,T+1),te=ce-1-o),re>=0&&(u=this.k[re],o=u[0],Z=1,ie=u.length-1)}while(--re>=-1);if(_=ge.getReverseChanges(),D[0]){let ce=L[0]+1,Se=C[0]+1;if(_!==null&&_.length>0){const x=_[_.length-1];ce=Math.max(ce,x.getOriginalEnd()),Se=Math.max(Se,x.getModifiedEnd())}V=[new v.DiffChange(ce,N-ce+1,Se,c-Se+1)]}else{ge=new m,Z=l,ie=h,te=L[0]-C[0]-r,he=1073741824,re=p?this.m.length-1:this.m.length-2;do{const ce=te+a;ce===Z||ce<ie&&b[ce-1]>=b[ce+1]?(A=b[ce+1]-1,T=A-te-r,A>he&&ge.MarkNextChange(),he=A+1,ge.AddOriginalElement(A+1,T+1),te=ce+1-a):(A=b[ce-1],T=A-te-r,A>he&&ge.MarkNextChange(),he=A,ge.AddModifiedElement(A+1,T+1),te=ce-1-a),re>=0&&(b=this.m[re],a=b[0],Z=1,ie=b.length-1)}while(--re>=-1);V=ge.getChanges()}return this.H(_,V)}y(o,n,e,s,a,l,h){let r=0,u=0,b=0,A=0,N=0,L=0;o--,e--,a[0]=0,l[0]=0,this.k=[],this.m=[];const T=n-o+(s-e),c=T+1,C=new Int32Array(c),p=new Int32Array(c),D=s-e,_=n-o,V=o-e,ge=n-s,ie=(_-D)%2===0;C[D]=o,p[_]=n,h[0]=!1;for(let te=1;te<=T/2+1;te++){let he=0,re=0;b=this.J(D-te,te,D,c),A=this.J(D+te,te,D,c);for(let Se=b;Se<=A;Se+=2){Se===b||Se<A&&C[Se-1]<C[Se+1]?r=C[Se+1]:r=C[Se-1]+1,u=r-(Se-D)-V;const x=r;for(;r<n&&u<s&&this.p(r+1,u+1);)r++,u++;if(C[Se]=r,r+u>he+re&&(he=r,re=u),!ie&&Math.abs(Se-_)<=te-1&&r>=p[Se])return a[0]=r,l[0]=u,x<=p[Se]&&1447>0&&te<=1447+1?this.x(D,b,A,V,_,N,L,ge,C,p,r,n,a,u,s,l,ie,h):null}const ce=(he-o+(re-e)-te)/2;if(this.a!==null&&!this.a(he,ce))return h[0]=!0,a[0]=he,l[0]=re,ce>0&&1447>0&&te<=1447+1?this.x(D,b,A,V,_,N,L,ge,C,p,r,n,a,u,s,l,ie,h):(o++,e++,[new v.DiffChange(o,n-o+1,e,s-e+1)]);N=this.J(_-te,te,_,c),L=this.J(_+te,te,_,c);for(let Se=N;Se<=L;Se+=2){Se===N||Se<L&&p[Se-1]>=p[Se+1]?r=p[Se+1]-1:r=p[Se-1],u=r-(Se-_)-ge;const x=r;for(;r>o&&u>e&&this.p(r,u);)r--,u--;if(p[Se]=r,ie&&Math.abs(Se-D)<=te&&r<=C[Se])return a[0]=r,l[0]=u,x>=C[Se]&&1447>0&&te<=1447+1?this.x(D,b,A,V,_,N,L,ge,C,p,r,n,a,u,s,l,ie,h):null}if(te<=1447){let Se=new Int32Array(A-b+2);Se[0]=D-b+1,w.Copy2(C,b,Se,1,A-b+1),this.k.push(Se),Se=new Int32Array(L-N+2),Se[0]=_-N+1,w.Copy2(p,N,Se,1,L-N+1),this.m.push(Se)}}return this.x(D,b,A,V,_,N,L,ge,C,p,r,n,a,u,s,l,ie,h)}z(o){for(let n=0;n<o.length;n++){const e=o[n],s=n<o.length-1?o[n+1].originalStart:this.f.length,a=n<o.length-1?o[n+1].modifiedStart:this.h.length,l=e.originalLength>0,h=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<a&&(!l||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!h||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const u=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!u)break;e.originalStart++,e.modifiedStart++}const r=[null];if(n<o.length-1&&this.I(o[n],o[n+1],r)){o[n]=r[0],o.splice(n+1,1),n--;continue}}for(let n=o.length-1;n>=0;n--){const e=o[n];let s=0,a=0;if(n>0){const A=o[n-1];s=A.originalStart+A.originalLength,a=A.modifiedStart+A.modifiedLength}const l=e.originalLength>0,h=e.modifiedLength>0;let r=0,u=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let A=1;;A++){const N=e.originalStart-A,L=e.modifiedStart-A;if(N<s||L<a||l&&!this.s(N,N+e.originalLength)||h&&!this.u(L,L+e.modifiedLength))break;const c=(N===s&&L===a?5:0)+this.G(N,e.originalLength,L,e.modifiedLength);c>u&&(u=c,r=A)}e.originalStart-=r,e.modifiedStart-=r;const b=[null];if(n>0&&this.I(o[n-1],o[n],b)){o[n-1]=b[0],o.splice(n,1),n++;continue}}if(this.d)for(let n=1,e=o.length;n<e;n++){const s=o[n-1],a=o[n],l=a.originalStart-s.originalStart-s.originalLength,h=s.originalStart,r=a.originalStart+a.originalLength,u=r-h,b=s.modifiedStart,A=a.modifiedStart+a.modifiedLength,N=A-b;if(l<5&&u<20&&N<20){const L=this.A(h,u,b,N,l);if(L){const[T,c]=L;(T!==s.originalStart+s.originalLength||c!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=T-s.originalStart,s.modifiedLength=c-s.modifiedStart,a.originalStart=T+l,a.modifiedStart=c+l,a.originalLength=r-a.originalStart,a.modifiedLength=A-a.modifiedStart)}}}return o}A(o,n,e,s,a){if(n<a||s<a)return null;const l=o+n-a+1,h=e+s-a+1;let r=0,u=0,b=0;for(let A=o;A<l;A++)for(let N=e;N<h;N++){const L=this.B(A,N,a);L>0&&L>r&&(r=L,u=A,b=N)}return r>0?[u,b]:null}B(o,n,e){let s=0;for(let a=0;a<e;a++){if(!this.p(o+a,n+a))return 0;s+=this.e[o+a].length}return s}C(o){return o<=0||o>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[o])}D(o,n){if(this.C(o)||this.C(o-1))return!0;if(n>0){const e=o+n;if(this.C(e-1)||this.C(e))return!0}return!1}E(o){return o<=0||o>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[o])}F(o,n){if(this.E(o)||this.E(o-1))return!0;if(n>0){const e=o+n;if(this.E(e-1)||this.E(e))return!0}return!1}G(o,n,e,s){const a=this.D(o,n)?1:0,l=this.F(e,s)?1:0;return a+l}H(o,n){const e=[];if(o.length===0||n.length===0)return n.length>0?n:o;if(this.I(o[o.length-1],n[0],e)){const s=new Array(o.length+n.length-1);return w.Copy(o,0,s,0,o.length-1),s[o.length-1]=e[0],w.Copy(n,1,s,o.length,n.length-1),s}else{const s=new Array(o.length+n.length);return w.Copy(o,0,s,0,o.length),w.Copy(n,0,s,o.length,n.length),s}}I(o,n,e){if(y.Assert(o.originalStart<=n.originalStart,"Left change is not less than or equal to right change"),y.Assert(o.modifiedStart<=n.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=n.originalStart||o.modifiedStart+o.modifiedLength>=n.modifiedStart){const s=o.originalStart;let a=o.originalLength;const l=o.modifiedStart;let h=o.modifiedLength;return o.originalStart+o.originalLength>=n.originalStart&&(a=n.originalStart+n.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=n.modifiedStart&&(h=n.modifiedStart+n.modifiedLength-o.modifiedStart),e[0]=new v.DiffChange(s,a,l,h),!0}else return e[0]=null,!1}J(o,n,e,s){if(o>=0&&o<s)return o;const a=e,l=s-e-1,h=n%2===0;if(o<0){const r=a%2===0;return h===r?0:1}else{const r=l%2===0;return h===r?s-1:s-2}}}t.LcsDiff=f}),define(be[33],pe([1,0,12,32,11]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const H="$(",y=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(v.CSSIcon.iconNameCharacter),d=new RegExp(`(\\\\)?${y.source}`,"g");function m(l){return l.replace(d,(h,r)=>r?h:`\\${h}`)}t.escapeIcons=m;const f=new RegExp(`\\\\${y.source}`,"g");function M(l){return l.replace(f,h=>`\\${h}`)}t.markdownEscapeEscapedIcons=M;const o=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function n(l){return l.indexOf(H)===-1?l:l.replace(o,(h,r,u,b)=>u?h:r||b||"")}t.stripIcons=n;function e(l){const h=l.indexOf(H);return h===-1?{text:l}:s(l,h)}t.parseLabelWithIcons=e;function s(l,h){const r=[];let u="";function b(D){if(D){u+=D;for(const _ of D)r.push(L)}}let A=-1,N="",L=0,T,c,C=h;const p=l.length;for(b(l.substr(0,h));C<p;)T=l[C],c=l[C+1],T===H[0]&&c===H[1]?(A=C,b(N),N=H,C++):T===")"&&A!==-1?(L+=C-A+1,A=-1,N=""):A!==-1?w.test(T)?N+=T:(b(N),A=-1,N=""):b(T),C++;return b(N),{text:u,iconOffsets:r}}function a(l,h,r=!1){const{text:u,iconOffsets:b}=h;if(!b||b.length===0)return(0,i.matchesFuzzy)(l,u,r);const A=(0,U.ltrim)(u," "),N=u.length-A.length,L=(0,i.matchesFuzzy)(l,A,r);if(L)for(const T of L){const c=b[T.start+N]+N;T.start+=c,T.end+=c}return L}t.matchesFuzzyIconAware=a}),define(be[113],pe([1,0,14,11]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class U{constructor(){this.b="",this.c=0}reset(n){return this.b=n,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(n){const e=n.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.StringIterator=U;class H{constructor(n=!0){this.e=n}reset(n){return this.b=n,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let n=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(n)this.c++;else break;else n=!1;return this}cmp(n){return this.e?(0,i.compareSubstring)(n,this.b,0,n.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=H;class y{constructor(n=!0,e=!0){this.f=n,this.g=e}reset(n){this.d=0,this.e=0,this.b=n,this.c=n.length;for(let e=n.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let n=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(n)this.d++;else break;else n=!1}return this}cmp(n){return this.g?(0,i.compareSubstring)(n,this.b,0,n.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=y;var w;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(w||(w={}));class d{constructor(n,e){this.f=n,this.g=e,this.d=[],this.e=0}reset(n){return this.c=n,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new y(!1,!this.f(n)),this.b.reset(n.path),this.b.value()&&this.d.push(3)),this.g(n)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(n){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(n,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(n,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(n);if(this.d[this.e]===4)return(0,i.compare)(n,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(n,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=d;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(f||(f={}));class M{static forUris(n=()=>!1,e=()=>!1){return new M(new d(n,e))}static forPaths(n=!1){return new M(new y(void 0,!n))}static forStrings(){return new M(new U)}static forConfigKeys(){return new M(new H)}constructor(n){this.b=n}clear(){this.c=void 0}fill(n,e){if(e){const s=e.slice(0);(0,v.shuffle)(s);for(const a of s)this.set(a,n)}else{const s=n.slice(0);(0,v.shuffle)(s);for(const a of s)this.set(a[0],a[1])}}set(n,e){const s=this.b.reset(n);let a;this.c||(this.c=new m,this.c.segment=s.value());const l=[];for(a=this.c;;){const r=s.cmp(a.segment);if(r>0)a.left||(a.left=new m,a.left.segment=s.value()),l.push([-1,a]),a=a.left;else if(r<0)a.right||(a.right=new m,a.right.segment=s.value()),l.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new m,a.mid.segment=s.value()),l.push([0,a]),a=a.mid;else break}const h=a.value;a.value=e,a.key=n;for(let r=l.length-1;r>=0;r--){const u=l[r][1];u.updateHeight();const b=u.balanceFactor();if(b<-1||b>1){const A=l[r][0],N=l[r+1][0];if(A===1&&N===1)l[r][1]=u.rotateLeft();else if(A===-1&&N===-1)l[r][1]=u.rotateRight();else if(A===1&&N===-1)u.right=l[r+1][1]=l[r+1][1].rotateRight(),l[r][1]=u.rotateLeft();else if(A===-1&&N===1)u.left=l[r+1][1]=l[r+1][1].rotateLeft(),l[r][1]=u.rotateRight();else throw new Error;if(r>0)switch(l[r-1][0]){case-1:l[r-1][1].left=l[r][1];break;case 1:l[r-1][1].right=l[r][1];break;case 0:l[r-1][1].mid=l[r][1];break}else this.c=l[0][1]}}return h}get(n){return this.d(n)?.value}d(n){const e=this.b.reset(n);let s=this.c;for(;s;){const a=e.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(n){const e=this.d(n);return!(e?.value===void 0&&e?.mid===void 0)}delete(n){return this.e(n,!1)}deleteSuperstr(n){return this.e(n,!0)}e(n,e){const s=this.b.reset(n),a=[];let l=this.c;for(;l;){const h=s.cmp(l.segment);if(h>0)a.push([-1,l]),l=l.left;else if(h<0)a.push([1,l]),l=l.right;else if(s.hasNext())s.next(),a.push([0,l]),l=l.mid;else break}if(!!l){if(e?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const h=this.f(l.right);if(h.key){const{key:r,value:u,segment:b}=h;this.e(h.key,!1),l.key=r,l.value=u,l.segment=b}}else{const h=l.left??l.right;if(a.length>0){const[r,u]=a[a.length-1];switch(r){case-1:u.left=h;break;case 0:u.mid=h;break;case 1:u.right=h;break}}else this.c=h}for(let h=a.length-1;h>=0;h--){const r=a[h][1];r.updateHeight();const u=r.balanceFactor();if(u>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),a[h][1]=r.rotateLeft()):u<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),a[h][1]=r.rotateRight()),h>0)switch(a[h-1][0]){case-1:a[h-1][1].left=a[h][1];break;case 1:a[h-1][1].right=a[h][1];break;case 0:a[h-1][1].mid=a[h][1];break}else this.c=a[0][1]}}}f(n){for(;n.left;)n=n.left;return n}findSubstr(n){const e=this.b.reset(n);let s=this.c,a;for(;s;){const l=e.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(e.hasNext())e.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(n){const e=this.b.reset(n);let s=this.c;for(;s;){const a=e.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else return s.mid?this.g(s.mid):void 0}}forEach(n){for(const[e,s]of this)n(s,e)}*[Symbol.iterator](){yield*this.g(this.c)}g(n){const e=[];return this.h(n,e),e[Symbol.iterator]()}h(n,e){!n||(n.left&&this.h(n.left,e),n.value&&e.push([n.key,n.value]),n.mid&&this.h(n.mid,e),n.right&&this.h(n.right,e))}_isBalanced(){const n=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:n(e.left)&&n(e.right)};return n(this.c)}}t.TernarySearchTree=M}),define(be[15],pe([1,0,21,5]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const U=/^\w[\w\d+.-]*$/,H=/^\//,y=/^\/\//;function w(L,T){if(!L.scheme&&T)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!U.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!H.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(L,T){return!L&&!T?"file":L}function m(L,T){switch(L){case"https":case"http":case"file":T?T[0]!==M&&(T=M+T):T=M;break}return T}const f="",M="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class n{static isUri(T){return T instanceof n?!0:T?typeof T.authority=="string"&&typeof T.fragment=="string"&&typeof T.path=="string"&&typeof T.query=="string"&&typeof T.scheme=="string"&&typeof T.fsPath=="string"&&typeof T.with=="function"&&typeof T.toString=="function":!1}constructor(T,c,C,p,D,_=!1){typeof T=="object"?(this.scheme=T.scheme||f,this.authority=T.authority||f,this.path=T.path||f,this.query=T.query||f,this.fragment=T.fragment||f):(this.scheme=d(T,_),this.authority=c||f,this.path=m(this.scheme,C||f),this.query=p||f,this.fragment=D||f,w(this,_))}get fsPath(){return r(this,!1)}with(T){if(!T)return this;let{scheme:c,authority:C,path:p,query:D,fragment:_}=T;return c===void 0?c=this.scheme:c===null&&(c=f),C===void 0?C=this.authority:C===null&&(C=f),p===void 0?p=this.path:p===null&&(p=f),D===void 0?D=this.query:D===null&&(D=f),_===void 0?_=this.fragment:_===null&&(_=f),c===this.scheme&&C===this.authority&&p===this.path&&D===this.query&&_===this.fragment?this:new s(c,C,p,D,_)}static parse(T,c=!1){const C=o.exec(T);return C?new s(C[2]||f,N(C[4]||f),N(C[5]||f),N(C[7]||f),N(C[9]||f),c):new s(f,f,f,f,f)}static file(T){let c=f;if(i.isWindows&&(T=T.replace(/\\/g,M)),T[0]===M&&T[1]===M){const C=T.indexOf(M,2);C===-1?(c=T.substring(2),T=M):(c=T.substring(2,C),T=T.substring(C)||M)}return new s("file",c,T,f,f)}static from(T){const c=new s(T.scheme,T.authority,T.path,T.query,T.fragment);return w(c,!0),c}static joinPath(T,...c){if(!T.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return i.isWindows&&T.scheme==="file"?C=n.file(v.win32.join(r(T,!0),...c)).path:C=v.posix.join(T.path,...c),T.with({path:C})}toString(T=!1){return u(this,T)}toJSON(){return this}static revive(T){if(T){if(T instanceof n)return T;{const c=new s(T);return c._formatted=T.external,c._fsPath=T._sep===e?T.fsPath:null,c}}else return T}}t.URI=n;const e=i.isWindows?1:void 0;class s extends n{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(T=!1){return T?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const T={$mid:1};return this._fsPath&&(T.fsPath=this._fsPath,T._sep=e),this._formatted&&(T.external=this._formatted),this.path&&(T.path=this.path),this.scheme&&(T.scheme=this.scheme),this.authority&&(T.authority=this.authority),this.query&&(T.query=this.query),this.fragment&&(T.fragment=this.fragment),T}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(L,T){let c,C=-1;for(let p=0;p<L.length;p++){const D=L.charCodeAt(p);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||T&&D===47)C!==-1&&(c+=encodeURIComponent(L.substring(C,p)),C=-1),c!==void 0&&(c+=L.charAt(p));else{c===void 0&&(c=L.substr(0,p));const _=a[D];_!==void 0?(C!==-1&&(c+=encodeURIComponent(L.substring(C,p)),C=-1),c+=_):C===-1&&(C=p)}}return C!==-1&&(c+=encodeURIComponent(L.substring(C))),c!==void 0?c:L}function h(L){let T;for(let c=0;c<L.length;c++){const C=L.charCodeAt(c);C===35||C===63?(T===void 0&&(T=L.substr(0,c)),T+=a[C]):T!==void 0&&(T+=L[c])}return T!==void 0?T:L}function r(L,T){let c;return L.authority&&L.path.length>1&&L.scheme==="file"?c=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?T?c=L.path.substr(1):c=L.path[1].toLowerCase()+L.path.substr(2):c=L.path,i.isWindows&&(c=c.replace(/\//g,"\\")),c}t.uriToFsPath=r;function u(L,T){const c=T?h:l;let C="",{scheme:p,authority:D,path:_,query:V,fragment:ge}=L;if(p&&(C+=p,C+=":"),(D||p==="file")&&(C+=M,C+=M),D){let Z=D.indexOf("@");if(Z!==-1){const ie=D.substr(0,Z);D=D.substr(Z+1),Z=ie.indexOf(":"),Z===-1?C+=c(ie,!1):(C+=c(ie.substr(0,Z),!1),C+=":",C+=c(ie.substr(Z+1),!1)),C+="@"}D=D.toLowerCase(),Z=D.indexOf(":"),Z===-1?C+=c(D,!1):(C+=c(D.substr(0,Z),!1),C+=D.substr(Z))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const Z=_.charCodeAt(1);Z>=65&&Z<=90&&(_=`/${String.fromCharCode(Z+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const Z=_.charCodeAt(0);Z>=65&&Z<=90&&(_=`${String.fromCharCode(Z+32)}:${_.substr(2)}`)}C+=c(_,!0)}return V&&(C+="?",C+=c(V,!1)),ge&&(C+="#",C+=T?ge:l(ge,!1)),C}function b(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+b(L.substr(3)):L}}const A=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(L){return L.match(A)?L.replace(A,T=>b(T)):L}}),define(be[50],pe([1,0,29,11,15]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function H(m){return JSON.stringify(m,w)}t.stringify=H;function y(m){let f=JSON.parse(m);return f=d(f),f}t.parse=y;function w(m,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:(0,i.regExpFlags)(f)}:f}function d(m,f=0){if(!m||f>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return U.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof v.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let M=0;M<m.length;++M)m[M]=d(m[M],f+1);else for(const M in m)Object.hasOwnProperty.call(m,M)&&(m[M]=d(m[M],f+1))}return m}t.revive=d}),define(be[34],pe([1,0,5,15]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var U;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebook="vscode-notebook",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(U=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class H{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${U.vscodeRemoteResource}`}set(m,f,M){this.a[m]=f,this.b[m]=M}setConnectionToken(m,f){this.c[m]=f}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)return this.e(m);const f=m.authority;let M=this.a[f];M&&M.indexOf(":")!==-1&&M.indexOf("[")===-1&&(M=`[${M}]`);const o=this.b[f],n=this.c[f];let e=`path=${encodeURIComponent(m.path)}`;return typeof n=="string"&&(e+=`&${t.connectionTokenQueryName}=${encodeURIComponent(n)}`),i.URI.from({scheme:v.isWeb?this.d:U.vscodeRemoteResource,authority:`${M}:${o}`,path:this.f,query:e})}}t.RemoteAuthorities=new H,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class y{asBrowserUri(m){const f=this.b(m,X);return this.uriToBrowserUri(f)}uriToBrowserUri(m){return m.scheme===U.vscodeRemote?t.RemoteAuthorities.rewrite(m):m.scheme===U.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${U.vscodeFileResource}://${y.a}`)?m.with({scheme:U.vscodeFileResource,authority:m.authority||y.a,query:null,fragment:null}):m}asFileUri(m){const f=this.b(m,X);return this.uriToFileUri(f)}uriToFileUri(m){return m.scheme===U.vscodeFileResource?m.with({scheme:U.file,authority:m.authority!==y.a?m.authority:null,query:null,fragment:null}):m}b(m,f){return i.URI.isUri(m)?m:i.URI.parse(f.toUrl(m))}}y.a="vscode-app",t.FileAccess=new y;var w;(function(d){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(m.get("3"));const f="vscode-coi";function M(n){let e;typeof n=="string"?e=new URL(n).searchParams:n instanceof URL?e=n.searchParams:i.URI.isUri(n)&&(e=new URL(n.toString(!0)).searchParams);const s=e?.get(f);if(!!s)return m.get(s)}d.getHeadersFromQuery=M;function o(n,e,s){if(!globalThis.crossOriginIsolated)return;const a=e&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(f,a):n[f]=a}d.addSearchParam=o})(w=t.COI||(t.COI={}))}),define(be[35],pe([1,0,110,34,21,5,11,15]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function d(n){return(0,w.uriToFsPath)(n,!0)}t.originalFSPath=d;class m{constructor(e){this.a=e}compare(e,s,a=!1){return e===s?0:(0,y.compare)(this.getComparisonKey(e,a),this.getComparisonKey(s,a))}isEqual(e,s,a=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,a)===this.getComparisonKey(s,a)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,a=!1){if(e.scheme===s.scheme){if(e.scheme===i.Schemas.file)return v.isEqualOrParent(d(e),d(s),this.a(e))&&e.query===s.query&&(a||e.fragment===s.fragment);if((0,t.isEqualAuthority)(e.authority,s.authority))return v.isEqualOrParent(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(a||e.fragment===s.fragment)}return!1}joinPath(e,...s){return w.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return U.posix.basename(e.path)}extname(e){return U.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===i.Schemas.file?s=w.URI.file(U.dirname(d(e))).path:(s=U.posix.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===i.Schemas.file?s=w.URI.file(U.normalize(d(e))).path:s=U.posix.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.isEqualAuthority)(e.authority,s.authority))return;if(e.scheme===i.Schemas.file){const h=U.relative(d(e),d(s));return H.isWindows?v.toSlashes(h):h}let a=e.path||"/";const l=s.path||"/";if(this.a(e)){let h=0;for(const r=Math.min(a.length,l.length);h<r&&!(a.charCodeAt(h)!==l.charCodeAt(h)&&a.charAt(h).toLowerCase()!==l.charAt(h).toLowerCase());h++);a=l.substr(0,h)+a.substr(h)}return U.posix.relative(a,l)}resolvePath(e,s){if(e.scheme===i.Schemas.file){const a=w.URI.file(U.resolve(d(e),s));return e.with({authority:a.authority,path:a.path})}return s=v.toPosixPath(s),e.with({path:U.posix.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,y.equalsIgnoreCase)(e,s)}hasTrailingPathSeparator(e,s=U.sep){if(e.scheme===i.Schemas.file){const a=d(e);return a.length>v.getRoot(a).length&&a[a.length-1]===s}else{const a=e.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=U.sep){return(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=U.sep){let a=!1;if(e.scheme===i.Schemas.file){const l=d(e);a=l!==void 0&&l.length===v.getRoot(l).length&&l[l.length-1]===s}else{s="/";const l=e.path;a=l.length===1&&l.charCodeAt(l.length-1)===47}return!a&&!(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path+"/"}):e}}t.ExtUri=m,t.extUri=new m(()=>!1),t.extUriBiasedIgnorePathCase=new m(n=>n.scheme===i.Schemas.file?!H.isLinux:!0),t.extUriIgnorePathCase=new m(n=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function f(n,e){const s=[];for(let a=0;a<n.length;a++){const l=e(n[a]);n.some((h,r)=>r===a?!1:(0,t.isEqualOrParent)(l,e(h)))||s.push(n[a])}return s}t.distinctParents=f;var M;(function(n){n.META_DATA_LABEL="label",n.META_DATA_DESCRIPTION="description",n.META_DATA_SIZE="size",n.META_DATA_MIME="mime";function e(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[u,b]=r.split(":");u&&b&&a.set(u,b)});const h=s.path.substring(0,s.path.indexOf(";"));return h&&a.set(n.META_DATA_MIME,h),a}n.parseMetaData=e})(M=t.DataUri||(t.DataUri={}));function o(n,e,s){if(e){let a=n.path;return a&&a[0]!==U.posix.sep&&(a=U.posix.sep+a),n.with({scheme:s,authority:e,path:a})}return n.with({scheme:s})}t.toLocalResource=o}),define(be[8],pe([1,0,26,9,3,2,35,5]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function d(k){return!!k&&typeof k.then=="function"}t.isThenable=d;function m(k){const E=new v.CancellationTokenSource,g=k(E.token),R=new Promise((W,$)=>{const Y=E.token.onCancellationRequested(()=>{Y.dispose(),E.dispose(),$(new i.CancellationError)});Promise.resolve(g).then(F=>{Y.dispose(),E.dispose(),W(F)},F=>{Y.dispose(),E.dispose(),$(F)})});return new class{cancel(){E.cancel()}then(W,$){return R.then(W,$)}catch(W){return this.then(void 0,W)}finally(W){return R.finally(W)}}}t.createCancelablePromise=m;function f(k,E,g){return new Promise((R,W)=>{const $=E.onCancellationRequested(()=>{$.dispose(),R(g)});k.then(R,W).finally(()=>$.dispose())})}t.raceCancellation=f;function M(k,E){return new Promise((g,R)=>{const W=E.onCancellationRequested(()=>{W.dispose(),R(new i.CancellationError)});k.then(g,R).finally(()=>W.dispose())})}t.raceCancellationError=M;async function o(k){let E=-1;const g=k.map((W,$)=>W.then(Y=>(E=$,Y))),R=await Promise.race(g);return k.forEach((W,$)=>{$!==E&&W.cancel()}),R}t.raceCancellablePromises=o;function n(k,E,g){let R;const W=setTimeout(()=>{R?.(void 0),g?.()},E);return Promise.race([k.finally(()=>clearTimeout(W)),new Promise($=>R=$)])}t.raceTimeout=n;function e(k){return new Promise((E,g)=>{const R=k();d(R)?R.then(E,g):E(R)})}t.asPromise=e;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(E){if(this.a){if(this.d=E,!this.b){const g=()=>{this.b=null;const R=this.queue(this.d);return this.d=null,R};this.b=new Promise(R=>{this.a.then(g,g).then(R)})}return new Promise((g,R)=>{this.b.then(g,R)})}return this.a=E(),new Promise((g,R)=>{this.a.then(W=>{this.a=null,g(W)},W=>{this.a=null,R(W)})})}}t.Throttler=s;class a{constructor(){this.a=Promise.resolve(null)}queue(E){return this.a=this.a.then(()=>E(),()=>E())}}t.Sequencer=a;class l{constructor(){this.a=new Map}queue(E,g){const W=(this.a.get(E)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.a.get(E)===W&&this.a.delete(E)});return this.a.set(E,W),W}}t.SequencerByKey=l;const h=(k,E)=>{let g=!0;const R=setTimeout(()=>{g=!1,E()},k);return{isTriggered:()=>g,dispose:()=>{clearTimeout(R),g=!1}}},r=k=>{let E=!0;return queueMicrotask(()=>{E&&(E=!1,k())}),{isTriggered:()=>E,dispose:()=>{E=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(E){this.defaultDelay=E,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(E,g=this.defaultDelay){this.g=E,this.h(),this.b||(this.b=new Promise((W,$)=>{this.d=W,this.f=$}).then(()=>{if(this.b=null,this.d=null,this.g){const W=this.g;return this.g=null,W()}}));const R=()=>{this.a=null,this.d?.(null)};return this.a=g===t.MicrotaskDelay?r(R):h(g,R),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=u;class b{constructor(E){this.a=new u(E),this.b=new s}trigger(E,g){return this.a.trigger(()=>this.b.queue(E),g)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=b;class A{constructor(){this.a=!1,this.b=new Promise((E,g)=>{this.d=E})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=A;class N extends A{constructor(E){super(),this.f=setTimeout(()=>this.open(),E)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=N;function L(k,E){return E?new Promise((g,R)=>{const W=setTimeout(()=>{$.dispose(),g()},k),$=E.onCancellationRequested(()=>{clearTimeout(W),$.dispose(),R(new i.CancellationError)})}):m(g=>L(k,g))}t.timeout=L;function T(k,E=0){const g=setTimeout(k,E);return(0,H.toDisposable)(()=>clearTimeout(g))}t.disposableTimeout=T;function c(k){const E=[];let g=0;const R=k.length;function W(){return g<R?k[g++]():null}function $(Y){Y!=null&&E.push(Y);const F=W();return F?F.then($):Promise.resolve(E)}return Promise.resolve(null).then($)}t.sequence=c;function C(k,E=R=>!!R,g=null){let R=0;const W=k.length,$=()=>{if(R>=W)return Promise.resolve(g);const Y=k[R++];return Promise.resolve(Y()).then(B=>E(B)?Promise.resolve(B):$())};return $()}t.first=C;function p(k,E=R=>!!R,g=null){if(k.length===0)return Promise.resolve(g);let R=k.length;const W=()=>{R=-1;for(const $ of k)$.cancel?.()};return new Promise(($,Y)=>{for(const F of k)F.then(B=>{--R>=0&&E(B)?(W(),$(B)):R===0&&$(g)}).catch(B=>{--R>=0&&(W(),Y(B))})})}t.firstParallel=p;class D{constructor(E){this.a=0,this.d=E,this.f=[],this.b=0,this.g=new U.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(E){return this.a++,new Promise((g,R)=>{this.f.push({factory:E,c:g,e:R}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const E=this.f.shift();this.b++;const g=E.factory();g.then(E.c,E.e),g.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=D;class _ extends D{constructor(){super(1)}}t.Queue=_;class V{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const E=new se;return this.b.add(E),E.p}d(){for(const[,E]of this.a)if(E.size>0)return!1;return!0}queueFor(E,g=y.extUri){const R=g.getComparisonKey(E);let W=this.a.get(R);return W||(W=new _,U.Event.once(W.onDrained)(()=>{W?.dispose(),this.a.delete(R),this.f()}),this.a.set(R,W)),W}f(){!this.d()||this.g()}g(){for(const E of this.b)E.complete();this.b.clear()}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),this.g()}}t.ResourceQueue=V;class ge{constructor(E,g){this.a=-1,typeof E=="function"&&typeof g=="number"&&this.setIfNotSet(E,g)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(E,g){this.cancel(),this.a=setTimeout(()=>{this.a=-1,E()},g)}setIfNotSet(E,g){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,E()},g))}}t.TimeoutTimer=ge;class Z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(E,g){this.cancel(),this.a=setInterval(()=>{E()},g)}}t.IntervalTimer=Z;class ie{constructor(E,g){this.b=-1,this.a=E,this.d=g,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(E=this.d){this.cancel(),this.b=setTimeout(this.f,E)}get delay(){return this.d}set delay(E){this.d=E}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=ie;class te{constructor(E,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.a=E,this.b=g,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(E=this.b){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(E/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=te;class he extends ie{constructor(E,g){super(E,g),this.j=[]}work(E){this.j.push(E),this.isScheduled()||this.schedule()}h(){const E=this.j;this.j=[],this.a?.(E)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=he;class re extends H.Disposable{constructor(E,g){super(),this.g=E,this.h=g,this.a=[],this.b=this.B(new H.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(E){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+E.length>this.g.maxBufferedWork)return!1}else if(this.pending+E.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...E),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ie(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=k=>{(0,w.setTimeout0)(()=>{if(E)return;const g=Date.now()+15;k(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,g-Date.now())}}))});let E=!1;return{dispose(){E||(E=!0)}}}:t.runWhenIdle=(k,E)=>{const g=requestIdleCallback(k,typeof E=="number"?{timeout:E}:void 0);let R=!1;return{dispose(){R||(R=!0,cancelIdleCallback(g))}}}}();class ce{constructor(E){this.d=!1,this.a=()=>{try{this.f=E()}catch(g){this.g=g}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=ce;async function Se(k,E,g){let R;for(let W=0;W<g;W++)try{return await k()}catch($){R=$,await L(E)}throw R}t.retry=Se;class x{hasPending(E){return this.a?typeof E=="number"?this.a.taskId===E:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(E,g,R){return this.a={taskId:E,cancel:()=>R?.(),promise:g},g.then(()=>this.d(E),()=>this.d(E)),g}d(E){this.a&&E===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const E=this.b;this.b=void 0,E.run().then(E.promiseResolve,E.promiseReject)}}setNext(E){if(this.b)this.b.run=E;else{let g,R;const W=new Promise(($,Y)=>{g=$,R=Y});this.b={run:E,promise:W,promiseResolve:g,promiseReject:R}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=x;class De{constructor(E,g=()=>Date.now()){this.d=E,this.f=g,this.a=0,this.b=0}increment(){const E=this.f();return E-this.a>this.d&&(this.a=E,this.b=0),this.b++,this.b}}t.IntervalCounter=De;class se{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((E,g)=>{this.a=E,this.b=g})}complete(E){return new Promise(g=>{this.a(E),this.f=!0,g()})}error(E){return new Promise(g=>{this.b(E),this.d=!0,g()})}cancel(){new Promise(E=>{this.b(new i.CancellationError),this.d=!0,E()})}}t.DeferredPromise=se;var Q;(function(k){async function E(R){let W;const $=await Promise.all(R.map(Y=>Y.then(F=>F,F=>{W||(W=F)})));if(typeof W<"u")throw W;return $}k.settled=E;function g(R){return new Promise(async(W,$)=>{try{await R(W,$)}catch(Y){$(Y)}})}k.withAsyncBody=g})(Q=t.Promises||(t.Promises={}));var le;(function(k){k[k.Initial=0]="Initial",k[k.DoneOK=1]="DoneOK",k[k.DoneError=2]="DoneError"})(le||(le={}));class de{static fromArray(E){return new de(g=>{g.emitMany(E)})}static fromPromise(E){return new de(async g=>{g.emitMany(await E)})}static fromPromises(E){return new de(async g=>{await Promise.all(E.map(async R=>g.emitOne(await R)))})}static merge(E){return new de(async g=>{await Promise.all(E.map(async R=>{for await(const W of R)g.emitOne(W)}))})}constructor(E){this.a=0,this.b=[],this.d=null,this.f=new U.Emitter,queueMicrotask(async()=>{const g={emitOne:R=>this.g(R),emitMany:R=>this.h(R),reject:R=>this.k(R)};try{await Promise.resolve(E(g)),this.j()}catch(R){this.k(R)}finally{g.emitOne=void 0,g.emitMany=void 0,g.reject=void 0}})}[Symbol.asyncIterator](){let E=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(E<this.b.length)return{done:!1,value:this.b[E++]};if(this.a===1)return{done:!0,value:void 0};await U.Event.toPromise(this.f.event)}while(!0)}}}static map(E,g){return new de(async R=>{for await(const W of E)R.emitOne(g(W))})}map(E){return de.map(this,E)}static filter(E,g){return new de(async R=>{for await(const W of E)g(W)&&R.emitOne(W)})}filter(E){return de.filter(this,E)}static coalesce(E){return de.filter(E,g=>!!g)}coalesce(){return de.coalesce(this)}static async toPromise(E){const g=[];for await(const R of E)g.push(R);return g}toPromise(){return de.toPromise(this)}g(E){this.a===0&&(this.b.push(E),this.f.fire())}h(E){this.a===0&&(this.b=this.b.concat(E),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(E){this.a===0&&(this.a=2,this.d=E,this.f.fire())}}t.AsyncIterableObject=de,de.EMPTY=de.fromArray([]);class me extends de{constructor(E,g){super(g),this.l=E}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=me;function ee(k){const E=new v.CancellationTokenSource,g=k(E.token);return new me(E,async R=>{const W=E.token.onCancellationRequested(()=>{W.dispose(),E.dispose(),R.reject(new i.CancellationError)});try{for await(const $ of g){if(E.token.isCancellationRequested)return;R.emitOne($)}W.dispose(),E.dispose()}catch($){W.dispose(),E.dispose(),R.reject($)}})}t.createCancelableAsyncIterable=ee}),define(be[4],pe([1,0,16,108,17,20,8,9,3,114,2,34,5,6,15]),function(X,t,v,i,U,H,y,w,d,m,f,M,o,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function s(G){for(;G.firstChild;)G.firstChild.remove()}t.clearNode=s;function a(G){return G?.isConnected??!1}t.isInDOM=a;class l{constructor(q,fe,Fe,Le){this.f=q,this.g=fe,this.d=Fe,this.j=Le||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){!this.d||(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function h(G,q,fe,Fe){return new l(G,q,fe,Fe)}t.addDisposableListener=h;function r(G){return function(q){return G(new H.StandardMouseEvent(q))}}function u(G){return function(q){return G(new U.StandardKeyboardEvent(q))}}const b=function(q,fe,Fe,Le){let Ke=Fe;return fe==="click"||fe==="mousedown"?Ke=r(Fe):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&(Ke=u(Fe)),h(q,fe,Ke,Le)};t.addStandardDisposableListener=b;const A=function(q,fe,Fe){const Le=r(fe);return L(q,Le,Fe)};t.addStandardDisposableGenericMouseDownListener=A;const N=function(q,fe,Fe){const Le=r(fe);return c(q,Le,Fe)};t.addStandardDisposableGenericMouseUpListener=N;function L(G,q,fe){return h(G,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,q,fe)}t.addDisposableGenericMouseDownListener=L;function T(G,q,fe){return h(G,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,q,fe)}t.addDisposableGenericMouseMoveListener=T;function c(G,q,fe){return h(G,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,q,fe)}t.addDisposableGenericMouseUpListener=c;class C{constructor(q,fe=0){this.d=q,this.priority=fe,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(q){(0,w.onUnexpectedError)(q)}}static sort(q,fe){return fe.priority-q.priority}}(function(){let G=[],q=null,fe=!1,Fe=!1;const Le=()=>{for(fe=!1,q=G,G=[],Fe=!0;q.length>0;)q.sort(C.sort),q.shift().execute();Fe=!1};t.scheduleAtNextAnimationFrame=(Ke,_e=0)=>{const Xe=new C(Ke,_e);return G.push(Xe),fe||(fe=!0,requestAnimationFrame(Le)),Xe},t.runAtThisOrScheduleAtNextAnimationFrame=(Ke,_e)=>{if(Fe){const Xe=new C(Ke,_e);return q.push(Xe),Xe}else return(0,t.scheduleAtNextAnimationFrame)(Ke,_e)}})();function p(G){return(0,t.scheduleAtNextAnimationFrame)(G,1e4)}t.measure=p;function D(G){return(0,t.scheduleAtNextAnimationFrame)(G,-1e4)}t.modify=D;const _=8,V=function(G,q){return q};class ge extends f.Disposable{constructor(q,fe,Fe,Le=V,Ke=_){super();let _e=null,Xe=0;const Je=this.B(new y.TimeoutTimer),gt=()=>{Xe=new Date().getTime(),Fe(_e),_e=null};this.B(h(q,fe,Tt=>{_e=Le(_e,Tt);const mt=new Date().getTime()-Xe;mt>=Ke?(Je.cancel(),gt()):Je.setIfNotSet(gt,Ke-mt)}))}}function Z(G,q,fe,Fe,Le){return new ge(G,q,fe,Fe,Le)}t.addDisposableThrottledListener=Z;function ie(G){return document.defaultView.getComputedStyle(G,null)}t.getComputedStyle=ie;function te(G){if(G!==document.body)return new re(G.clientWidth,G.clientHeight);if(o.isIOS&&window.visualViewport)return new re(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new re(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new re(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new re(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=te;class he{static d(q,fe){return parseFloat(fe)||0}static f(q,fe,Fe){const Le=ie(q),Ke=Le?Le.getPropertyValue(fe):"0";return he.d(q,Ke)}static getBorderLeftWidth(q){return he.f(q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(q){return he.f(q,"border-right-width","borderRightWidth")}static getBorderTopWidth(q){return he.f(q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(q){return he.f(q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(q){return he.f(q,"padding-left","paddingLeft")}static getPaddingRight(q){return he.f(q,"padding-right","paddingRight")}static getPaddingTop(q){return he.f(q,"padding-top","paddingTop")}static getPaddingBottom(q){return he.f(q,"padding-bottom","paddingBottom")}static getMarginLeft(q){return he.f(q,"margin-left","marginLeft")}static getMarginTop(q){return he.f(q,"margin-top","marginTop")}static getMarginRight(q){return he.f(q,"margin-right","marginRight")}static getMarginBottom(q){return he.f(q,"margin-bottom","marginBottom")}}class re{constructor(q,fe){this.width=q,this.height=fe}with(q=this.width,fe=this.height){return q!==this.width||fe!==this.height?new re(q,fe):this}static is(q){return typeof q=="object"&&typeof q.height=="number"&&typeof q.width=="number"}static lift(q){return q instanceof re?q:new re(q.width,q.height)}static equals(q,fe){return q===fe?!0:!q||!fe?!1:q.width===fe.width&&q.height===fe.height}}t.Dimension=re,re.None=new re(0,0);function ce(G){let q=G.offsetParent,fe=G.offsetTop,Fe=G.offsetLeft;for(;(G=G.parentNode)!==null&&G!==document.body&&G!==document.documentElement;){fe-=G.scrollTop;const Le=z(G)?null:ie(G);Le&&(Fe-=Le.direction!=="rtl"?G.scrollLeft:-G.scrollLeft),G===q&&(Fe+=he.getBorderLeftWidth(G),fe+=he.getBorderTopWidth(G),fe+=G.offsetTop,Fe+=G.offsetLeft,q=G.offsetParent)}return{left:Fe,top:fe}}t.getTopLeftOffset=ce;function Se(G,q,fe){typeof q=="number"&&(G.style.width=`${q}px`),typeof fe=="number"&&(G.style.height=`${fe}px`)}t.size=Se;function x(G,q,fe,Fe,Le,Ke="absolute"){typeof q=="number"&&(G.style.top=`${q}px`),typeof fe=="number"&&(G.style.right=`${fe}px`),typeof Fe=="number"&&(G.style.bottom=`${Fe}px`),typeof Le=="number"&&(G.style.left=`${Le}px`),G.style.position=Ke}t.position=x;function De(G){const q=G.getBoundingClientRect();return{left:q.left+window.scrollX,top:q.top+window.scrollY,width:q.width,height:q.height}}t.getDomNodePagePosition=De;function se(G){let q=G,fe=1;do{const Fe=ie(q).zoom;Fe!=null&&Fe!=="1"&&(fe*=Fe),q=q.parentElement}while(q!==null&&q!==document.documentElement);return fe}t.getDomNodeZoomLevel=se;function Q(G){const q=he.getMarginLeft(G)+he.getMarginRight(G);return G.offsetWidth+q}t.getTotalWidth=Q;function le(G){const q=he.getBorderLeftWidth(G)+he.getBorderRightWidth(G),fe=he.getPaddingLeft(G)+he.getPaddingRight(G);return G.offsetWidth-q-fe}t.getContentWidth=le;function de(G){const q=he.getMarginLeft(G)+he.getMarginRight(G);return G.scrollWidth+q}t.getTotalScrollWidth=de;function me(G){const q=he.getBorderTopWidth(G)+he.getBorderBottomWidth(G),fe=he.getPaddingTop(G)+he.getPaddingBottom(G);return G.offsetHeight-q-fe}t.getContentHeight=me;function ee(G){const q=he.getMarginTop(G)+he.getMarginBottom(G);return G.offsetHeight+q}t.getTotalHeight=ee;function k(G,q){if(G===null)return 0;const fe=ce(G),Fe=ce(q);return fe.left-Fe.left}function E(G,q){const fe=q.map(Le=>Math.max(de(Le),Q(Le))+k(Le,G)||0);return Math.max(...fe)}t.getLargestChildWidth=E;function g(G,q){for(;G;){if(G===q)return!0;G=G.parentNode}return!1}t.isAncestor=g;const R="parentFlowToElementId";function W(G,q){G.dataset[R]=q.id}t.setParentFlowTo=W;function $(G){const q=G.dataset[R];return typeof q=="string"?document.getElementById(q):null}function Y(G,q){let fe=G;for(;fe;){if(fe===q)return!0;if(fe instanceof HTMLElement){const Fe=$(fe);if(Fe){fe=Fe;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=Y;function F(G,q,fe){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G.classList.contains(q))return G;if(fe){if(typeof fe=="string"){if(G.classList.contains(fe))return null}else if(G===fe)return null}G=G.parentNode}return null}t.findParentWithClass=F;function B(G,q,fe){return!!F(G,q,fe)}t.hasParentWithClass=B;function z(G){return G&&!!G.host&&!!G.mode}t.isShadowRoot=z;function S(G){return!!I(G)}t.isInShadowDOM=S;function I(G){for(;G.parentNode;){if(G===document.body)return null;G=G.parentNode}return z(G)?G:null}t.getShadowRoot=I;function P(){let G=document.activeElement;for(;G?.shadowRoot;)G=G.shadowRoot.activeElement;return G}t.getActiveElement=P;function O(G=document.getElementsByTagName("head")[0]){const q=document.createElement("style");return q.type="text/css",q.media="screen",G.appendChild(q),q}t.createStyleSheet=O;function j(G=document.getElementsByTagName("head")[0]){const q=document.createElement("meta");return G.appendChild(q),q}t.createMetaElement=j;let J=null;function ae(){return J||(J=O()),J}function ue(G){return G?.sheet?.rules?G.sheet.rules:G?.sheet?.cssRules?G.sheet.cssRules:[]}function ye(G,q,fe=ae()){!fe||!q||fe.sheet.insertRule(G+"{"+q+"}",0)}t.createCSSRule=ye;function Ee(G,q=ae()){if(!q)return;const fe=ue(q),Fe=[];for(let Le=0;Le<fe.length;Le++)fe[Le].selectorText.indexOf(G)!==-1&&Fe.push(Le);for(let Le=Fe.length-1;Le>=0;Le--)q.sheet.deleteRule(Fe[Le])}t.removeCSSRulesContainingSelector=Ee;function Ie(G){return typeof HTMLElement=="object"?G instanceof HTMLElement:G&&typeof G=="object"&&G.nodeType===1&&typeof G.nodeName=="string"}t.isHTMLElement=Ie,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:v.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:(G,q)=>(G.preventDefault(),q&&G.stopPropagation(),G)};function ke(G){const q=[];for(let fe=0;G&&G.nodeType===G.ELEMENT_NODE;fe++)q[fe]=G.scrollTop,G=G.parentNode;return q}t.saveParentsScrollTop=ke;function ve(G,q){for(let fe=0;G&&G.nodeType===G.ELEMENT_NODE;fe++)G.scrollTop!==q[fe]&&(G.scrollTop=q[fe]),G=G.parentNode}t.restoreParentsScrollTop=ve;class Pe extends f.Disposable{static l(q){const fe=I(q),Fe=fe?fe.activeElement:document.activeElement;return g(Fe,q)}constructor(q){super(),this.f=this.B(new d.Emitter),this.onDidFocus=this.f.event,this.g=this.B(new d.Emitter),this.onDidBlur=this.g.event;let fe=Pe.l(q),Fe=!1;const Le=()=>{Fe=!1,fe||(fe=!0,this.f.fire())},Ke=()=>{fe&&(Fe=!0,window.setTimeout(()=>{Fe&&(Fe=!1,fe=!1,this.g.fire())},0))};this.j=()=>{Pe.l(q)!==fe&&(fe?Ke():Le())},this.B(h(q,t.EventType.FOCUS,Le,!0)),this.B(h(q,t.EventType.BLUR,Ke,!0)),this.B(h(q,t.EventType.FOCUS_IN,()=>this.j())),this.B(h(q,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function Re(G){return new Pe(G)}t.trackFocus=Re;function je(G,q){return G.after(q),q}t.after=je;function Ue(G,...q){if(G.append(...q),q.length===1&&typeof q[0]!="string")return q[0]}t.append=Ue;function We(G,q){return G.insertBefore(q,G.firstChild),q}t.prepend=We;function xe(G,...q){G.innerText="",Ue(G,...q)}t.reset=xe;const it=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Be;(function(G){G.HTML="http://www.w3.org/1999/xhtml",G.SVG="http://www.w3.org/2000/svg"})(Be=t.Namespace||(t.Namespace={}));function Ve(G,q,fe,...Fe){const Le=it.exec(q);if(!Le)throw new Error("Bad use of emmet");const Ke=Le[1]||"div";let _e;return G!==Be.HTML?_e=document.createElementNS(G,Ke):_e=document.createElement(Ke),Le[3]&&(_e.id=Le[3]),Le[4]&&(_e.className=Le[4].replace(/\./g," ").trim()),fe&&Object.entries(fe).forEach(([Xe,Je])=>{typeof Je>"u"||(/^on\w+$/.test(Xe)?_e[Xe]=Je:Xe==="selected"?Je&&_e.setAttribute(Xe,"true"):_e.setAttribute(Xe,Je))}),_e.append(...Fe),_e}function Ye(G,q,...fe){return Ve(Be.HTML,G,q,...fe)}t.$=Ye,Ye.SVG=function(G,q,...fe){return Ve(Be.SVG,G,q,...fe)};function K(G,q){const fe=[];return G.forEach((Fe,Le)=>{Le>0&&(q instanceof Node?fe.push(q.cloneNode()):fe.push(document.createTextNode(q))),fe.push(Fe)}),fe}t.join=K;function oe(...G){for(const q of G)q.style.display="",q.removeAttribute("aria-hidden")}t.show=oe;function we(...G){for(const q of G)q.style.display="none",q.setAttribute("aria-hidden","true")}t.hide=we;function Ce(G,q){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G instanceof HTMLElement&&G.hasAttribute(q))return G;G=G.parentNode}return null}function Te(G){!G||!G.hasAttribute("tabIndex")||(document.activeElement===G&&Ce(G.parentElement,"tabIndex")?.focus(),G.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Te;function Oe(G){return q=>{q.preventDefault(),q.stopPropagation(),G(q)}}t.finalHandler=Oe;function $e(){return new Promise(G=>{document.readyState==="complete"||document&&document.body!==null?G(void 0):window.addEventListener("DOMContentLoaded",G,!1)})}t.domContentLoaded=$e;function tt(G){const q=window.devicePixelRatio*G;return Math.max(1,Math.floor(q))/window.devicePixelRatio}t.computeScreenAwareSize=tt;function Me(G){window.open(G,"_blank","noopener")}t.windowOpenNoOpener=Me;const ne=780,Ae=640;function Ne(G){const q=Math.floor(window.screenLeft+window.innerWidth/2-ne/2),fe=Math.floor(window.screenTop+window.innerHeight/2-Ae/2);window.open(G,"_blank",`width=${ne},height=${Ae},top=${fe},left=${q}`)}t.windowOpenPopup=Ne;function ze(G,q=!0){const fe=window.open();return fe?(q&&(fe.opener=null),fe.location.href=G,!0):!1}t.windowOpenWithSuccess=ze;function Ge(G){const q=()=>{G(),fe=(0,t.scheduleAtNextAnimationFrame)(q)};let fe=(0,t.scheduleAtNextAnimationFrame)(q);return(0,f.toDisposable)(()=>fe.dispose())}t.animate=Ge,M.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Ze(G){return G?`url('${M.FileAccess.uriToBrowserUri(G).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Ze;function Qe(G){return`'${G.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=Qe;function nt(G,q){if(G!==void 0){const fe=G.match(/^\s*var\((.+)\)$/);if(fe){const Fe=fe[1].split(",",2);return Fe.length===2&&(q=nt(Fe[1].trim(),q)),`var(${Fe[0]}, ${q})`}return G}return q}t.asCssValueWithDefault=nt;function ct(G,q){let fe;if(e.URI.isUri(G))fe=G.toString(!0);else{const Le=new Blob([G]);fe=URL.createObjectURL(Le),setTimeout(()=>URL.revokeObjectURL(fe))}const Fe=document.createElement("a");document.body.appendChild(Fe),Fe.download=q,Fe.href=fe,Fe.click(),setTimeout(()=>document.body.removeChild(Fe))}t.triggerDownload=ct;function Et(){return new Promise(G=>{const q=document.createElement("input");document.body.appendChild(q),q.type="file",q.multiple=!0,d.Event.once(d.Event.fromDOMEventEmitter(q,"input"))(()=>{G((0,n.withNullAsUndefined)(q.files))}),q.click(),setTimeout(()=>document.body.removeChild(q))})}t.triggerUpload=Et;var dt;(function(G){G[G.DOCUMENT=1]="DOCUMENT",G[G.BROWSER=2]="BROWSER"})(dt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function zt(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(o.isMacintosh||o.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.detectFullscreen=zt;function Wt(G,q=!1){const fe=document.createElement("a");return m.addHook("afterSanitizeAttributes",Fe=>{for(const Le of["href","src"])if(Fe.hasAttribute(Le)){const Ke=Fe.getAttribute(Le);if(Le==="href"&&Ke.startsWith("#"))continue;if(fe.href=Ke,!G.includes(fe.protocol.replace(/:$/,""))){if(q&&Le==="src"&&fe.href.startsWith("data:"))continue;Fe.removeAttribute(Le)}}}),(0,f.toDisposable)(()=>{m.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Wt;const ui=[M.Schemas.http,M.Schemas.https,M.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const ci=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function di(G,q){const fe=Wt(ui);try{const Fe=m.sanitize(q,ci);G.innerHTML=Fe}finally{fe.dispose()}}t.safeInnerHtml=di;function fi(G){const q=new Uint16Array(G.length);for(let Le=0;Le<q.length;Le++)q[Le]=G.charCodeAt(Le);let fe="";const Fe=new Uint8Array(q.buffer);for(let Le=0;Le<Fe.length;Le++)fe+=String.fromCharCode(Fe[Le]);return fe}function gi(G){return btoa(fi(G))}t.multibyteAwareBtoa=gi;class ft extends d.Emitter{constructor(){super(),this.s=new f.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(h(window,"keydown",q=>{if(q.defaultPrevented)return;const fe=new U.StandardKeyboardEvent(q);if(!(fe.keyCode===6&&q.repeat)){if(q.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(q.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(q.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(q.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(fe.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=q.altKey,this.t.ctrlKey=q.ctrlKey,this.t.metaKey=q.metaKey,this.t.shiftKey=q.shiftKey,this.t.lastKeyPressed&&(this.t.event=q,this.fire(this.t))}},!0)),this.s.add(h(window,"keyup",q=>{q.defaultPrevented||(!q.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!q.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!q.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!q.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=q.altKey,this.t.ctrlKey=q.ctrlKey,this.t.metaKey=q.metaKey,this.t.shiftKey=q.shiftKey,this.t.lastKeyReleased&&(this.t.event=q,this.fire(this.t)))},!0)),this.s.add(h(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(h(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(h(document.body,"mousemove",q=>{q.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(h(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.u||(ft.u=new ft),ft.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=ft;function mi(G){const q=document.cookie.match("(^|[^;]+)\\s*"+G+"\\s*=\\s*([^;]+)");return q?q.pop():void 0}t.getCookieValue=mi;class bi extends f.Disposable{constructor(q,fe){super(),this.j=q,this.l=fe,this.f=0,this.g=0,this.m()}m(){this.B(h(this.j,t.EventType.DRAG_ENTER,q=>{this.f++,this.g=q.timeStamp,this.l.onDragEnter(q)})),this.B(h(this.j,t.EventType.DRAG_OVER,q=>{q.preventDefault(),this.l.onDragOver?.(q,q.timeStamp-this.g)})),this.B(h(this.j,t.EventType.DRAG_LEAVE,q=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(q))})),this.B(h(this.j,t.EventType.DRAG_END,q=>{this.f=0,this.g=0,this.l.onDragEnd(q)})),this.B(h(this.j,t.EventType.DROP,q=>{this.f=0,this.g=0,this.l.onDrop(q)}))}}t.DragAndDropObserver=bi;const pi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function wi(G,...q){let fe,Fe;Array.isArray(q[0])?(fe={},Fe=q[0]):(fe=q[0]||{},Fe=q[1]);const Le=pi.exec(G);if(!Le||!Le.groups)throw new Error("Bad use of h");const Ke=Le.groups.tag||"div",_e=document.createElement(Ke);Le.groups.id&&(_e.id=Le.groups.id),Le.groups.class&&(_e.className=Le.groups.class.replace(/\./g," ").trim());const Xe={};if(Le.groups.name&&(Xe[Le.groups.name]=_e),Fe)for(const Je of Fe)Je instanceof HTMLElement?_e.appendChild(Je):typeof Je=="string"?_e.append(Je):(Object.assign(Xe,Je),_e.appendChild(Je.root));for(const[Je,gt]of Object.entries(fe))if(Je==="style")for(const[Tt,mt]of Object.entries(gt))_e.style.setProperty(_t(Tt),typeof mt=="number"?mt+"px":""+mt);else Je==="tabIndex"?_e.tabIndex=gt:_e.setAttribute(_t(Je),gt.toString());return Xe.root=_e,Xe}t.h=wi;function _t(G){return G.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(be[51],pe([1,0,4,2,106]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class H extends i.Disposable{constructor(d,m){super(),this.B((0,v.addDisposableListener)(d,"dragover",f=>{f.preventDefault(),this.a||(this.a=setTimeout(()=>{m(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this.B((0,v.addDisposableListener)(d,f,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=H,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:U.Mimes.text};function y(w,d,m){const f=document.createElement("div");f.className=m,f.textContent=d,w.dataTransfer&&(document.body.appendChild(f),w.dataTransfer.setDragImage(f,-10,-10),setTimeout(()=>document.body.removeChild(f),0))}t.applyDragImage=y}),define(be[52],pe([1,0,4]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(o,n={}){const e=H(n);return e.textContent=o,e}t.renderText=i;function U(o,n={}){const e=H(n);return d(e,m(o,!!n.renderCodeSegments),n.actionHandler,n.renderCodeSegments),e}t.renderFormattedText=U;function H(o){const n=o.inline?"span":"div",e=document.createElement(n);return o.className&&(e.className=o.className),e}t.createElement=H;class y{constructor(n){this.b=n,this.c=0}eos(){return this.c>=this.b.length}next(){const n=this.peek();return this.advance(),n}peek(){return this.b[this.c]}advance(){this.c++}}var w;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(w||(w={}));function d(o,n,e,s){let a;if(n.type===2)a=document.createTextNode(n.content||"");else if(n.type===3)a=document.createElement("b");else if(n.type===4)a=document.createElement("i");else if(n.type===7&&s)a=document.createElement("code");else if(n.type===5&&e){const l=document.createElement("a");e.disposables.add(v.addStandardDisposableListener(l,"click",h=>{e.callback(String(n.index),h)})),a=l}else n.type===8?a=document.createElement("br"):n.type===1&&(a=o);a&&o!==a&&o.appendChild(a),a&&Array.isArray(n.children)&&n.children.forEach(l=>{d(a,l,e,s)})}function m(o,n){const e={type:1,children:[]};let s=0,a=e;const l=[],h=new y(o);for(;!h.eos();){let r=h.next();const u=r==="\\"&&M(h.peek(),n)!==0;if(u&&(r=h.next()),!u&&f(r,n)&&r===h.peek()){h.advance(),a.type===2&&(a=l.pop());const b=M(r,n);if(a.type===b||a.type===5&&b===6)a=l.pop();else{const A={type:b,children:[]};b===5&&(A.index=s,s++),a.children.push(A),l.push(a),a=A}}else if(r===`
`)a.type===2&&(a=l.pop()),a.children.push({type:8});else if(a.type!==2){const b={type:2,content:r};a.children.push(b),l.push(a),a=b}else a.content+=r}return a.type===2&&(a=l.pop()),l.length,e}function f(o,n){return M(o,n)!==0}function M(o,n){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return n?7:0;default:return 0}}}),define(be[53],pe([1,0,4,2]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class U{constructor(){this.a=new i.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(y,w){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const d=this.c;this.c=null,y&&d&&d(w)}isMonitoring(){return!!this.b}startMonitoring(y,w,d,m,f){this.isMonitoring()&&this.stopMonitoring(!1),this.b=m,this.c=f;let M=y;try{y.setPointerCapture(w),this.a.add((0,i.toDisposable)(()=>{try{y.releasePointerCapture(w)}catch{}}))}catch{M=window}this.a.add(v.addDisposableListener(M,v.EventType.POINTER_MOVE,o=>{if(o.buttons!==d){this.stopMonitoring(!0);return}o.preventDefault(),this.b(o)})),this.a.add(v.addDisposableListener(M,v.EventType.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=U});var qe=this&&this.__decorate||function(X,t,v,i){var U=arguments.length,H=U<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,v):i,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(X,t,v,i);else for(var w=X.length-1;w>=0;w--)(y=X[w])&&(H=(U<3?y(H):U>3?y(t,v,H):y(t,v))||H);return U>3&&H&&Object.defineProperty(t,v,H),H};define(be[22],pe([1,0,4,14,24,2,45]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var w;(function(m){m.Tap="-monaco-gesturetap",m.Change="-monaco-gesturechange",m.Start="-monaco-gesturestart",m.End="-monaco-gesturesend",m.Contextmenu="-monaco-gesturecontextmenu"})(w=t.EventType||(t.EventType={}));class d extends H.Disposable{constructor(){super(),this.f=!1,this.g=new y.LinkedList,this.h=new y.LinkedList,this.k={},this.j=null,this.l=0,this.B(v.addDisposableListener(document,"touchstart",f=>this.n(f),{passive:!1})),this.B(v.addDisposableListener(document,"touchend",f=>this.p(f))),this.B(v.addDisposableListener(document,"touchmove",f=>this.v(f),{passive:!1}))}static addTarget(f){if(!d.isTouchDevice())return H.Disposable.None;d.b||(d.b=new d);const M=d.b.g.push(f);return(0,H.toDisposable)(M)}static ignoreTarget(f){if(!d.isTouchDevice())return H.Disposable.None;d.b||(d.b=new d);const M=d.b.h.push(f);return(0,H.toDisposable)(M)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(f){const M=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let o=0,n=f.targetTouches.length;o<n;o++){const e=f.targetTouches.item(o);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:M,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[M],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const s=this.r(w.Start,e.target);s.pageX=e.pageX,s.pageY=e.pageY,this.s(s)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}p(f){const M=Date.now(),o=Object.keys(this.k).length;for(let n=0,e=f.changedTouches.length;n<e;n++){const s=f.changedTouches.item(n);if(!this.k.hasOwnProperty(String(s.identifier))){console.warn("move of an UNKNOWN touch",s);continue}const a=this.k[s.identifier],l=Date.now()-a.initialTimeStamp;if(l<d.c&&Math.abs(a.initialPageX-i.tail(a.rollingPageX))<30&&Math.abs(a.initialPageY-i.tail(a.rollingPageY))<30){const h=this.r(w.Tap,a.initialTarget);h.pageX=i.tail(a.rollingPageX),h.pageY=i.tail(a.rollingPageY),this.s(h)}else if(l>=d.c&&Math.abs(a.initialPageX-i.tail(a.rollingPageX))<30&&Math.abs(a.initialPageY-i.tail(a.rollingPageY))<30){const h=this.r(w.Contextmenu,a.initialTarget);h.pageX=i.tail(a.rollingPageX),h.pageY=i.tail(a.rollingPageY),this.s(h)}else if(o===1){const h=i.tail(a.rollingPageX),r=i.tail(a.rollingPageY),u=i.tail(a.rollingTimestamps)-a.rollingTimestamps[0],b=h-a.rollingPageX[0],A=r-a.rollingPageY[0],N=[...this.g].filter(L=>a.initialTarget instanceof Node&&L.contains(a.initialTarget));this.u(N,M,Math.abs(b)/u,b>0?1:-1,h,Math.abs(A)/u,A>0?1:-1,r)}this.s(this.r(w.End,a.initialTarget)),delete this.k[s.identifier]}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}r(f,M){const o=document.createEvent("CustomEvent");return o.initEvent(f,!1,!0),o.initialTarget=M,o.tapCount=0,o}s(f){if(f.type===w.Tap){const M=new Date().getTime();let o=0;M-this.l>d.m?o=1:o=2,this.l=M,f.tapCount=o}else(f.type===w.Change||f.type===w.Contextmenu)&&(this.l=0);if(f.initialTarget instanceof Node){for(const M of this.h)if(M.contains(f.initialTarget))return;for(const M of this.g)M.contains(f.initialTarget)&&(M.dispatchEvent(f),this.f=!0)}}u(f,M,o,n,e,s,a,l){this.j=v.scheduleAtNextAnimationFrame(()=>{const h=Date.now(),r=h-M;let u=0,b=0,A=!0;o+=d.a*r,s+=d.a*r,o>0&&(A=!1,u=n*o*r),s>0&&(A=!1,b=a*s*r);const N=this.r(w.Change);N.translationX=u,N.translationY=b,f.forEach(L=>L.dispatchEvent(N)),A||this.u(f,h,o,n,e+u,s,a,l+b)})}v(f){const M=Date.now();for(let o=0,n=f.changedTouches.length;o<n;o++){const e=f.changedTouches.item(o);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const s=this.k[e.identifier],a=this.r(w.Change,s.initialTarget);a.translationX=e.pageX-i.tail(s.rollingPageX),a.translationY=e.pageY-i.tail(s.rollingPageY),a.pageX=e.pageX,a.pageY=e.pageY,this.s(a),s.rollingPageX.length>3&&(s.rollingPageX.shift(),s.rollingPageY.shift(),s.rollingTimestamps.shift()),s.rollingPageX.push(e.pageX),s.rollingPageY.push(e.pageY),s.rollingTimestamps.push(M)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}}d.a=-.005,d.c=700,d.m=400,qe([U.memoize],d,"isTouchDevice",null),t.Gesture=d}),define(be[54],pe([1,0,4,5,83]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const U=2e4;let H,y,w,d,m;function f(e){H=document.createElement("div"),H.className="monaco-aria-container";const s=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),H.appendChild(l),l};y=s(),w=s();const a=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("role","complementary"),l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),H.appendChild(l),l};d=a(),m=a(),e.appendChild(H)}t.setARIAContainer=f;function M(e){!H||(y.textContent!==e?(v.clearNode(w),n(y,e)):(v.clearNode(y),n(w,e)))}t.alert=M;function o(e){!H||(i.isMacintosh?M(e):d.textContent!==e?(v.clearNode(m),n(d,e)):(v.clearNode(d),n(m,e)))}t.status=o;function n(e,s){v.clearNode(e),s.length>U&&(s=s.substr(0,U)),e.textContent=s,e.style.visibility="hidden",e.style.visibility="visible"}}),define(be[115],pe([1,0,4,12]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const U=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function H(w){const d=new Array;let m,f=0,M=0;for(;(m=U.exec(w))!==null;){M=m.index||0,f<M&&d.push(w.substring(f,M)),f=(m.index||0)+m[0].length;const[,o,n]=m;d.push(o?`$(${n})`:y({id:n}))}return f<w.length&&d.push(w.substring(f)),d}t.renderLabelWithIcons=H;function y(w){const d=v.$("span");return d.classList.add(...i.CSSIcon.asClassNameArray(w)),d}t.renderIcon=y}),define(be[116],pe([1,0,4]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(H){try{H.parentElement?.removeChild(H)}catch{}}class U{constructor(y){this.b=y,this.a=new Map}alloc(y){let w=this.d(y).pop();if(!w){const d=(0,v.$)(".monaco-list-row"),f=this.f(y).renderTemplate(d);w={domNode:d,templateId:y,templateData:f}}return w}release(y){!y||this.c(y)}c(y){const{domNode:w,templateId:d}=y;w&&(w.classList.remove("scrolling"),i(w)),this.d(d).push(y)}d(y){let w=this.a.get(y);return w||(w=[],this.a.set(y,w)),w}dispose(){this.a.forEach((y,w)=>{for(const d of y)this.f(w).disposeTemplate(d.templateData),d.templateData=null}),this.a.clear()}f(y){const w=this.b.get(y);if(!w)throw new Error(`No renderer found for ${y}`);return w}}t.RowCache=U}),define(be[117],pe([1,0,8,2]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class U extends i.Disposable{constructor(y,w,d){super(),this.a=y,this.b=w,this.c=d,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new v.TimeoutTimer)}setVisibility(y){this.a!==y&&(this.a=y,this.m())}setShouldBeVisible(y){this.g=y,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const y=this.l();this.h!==y&&(this.h=y,this.ensureVisibility())}setIsNeeded(y){this.i!==y&&(this.i=y,this.ensureVisibility())}setDomNode(y){this.f=y,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(y){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(y?" fade":"")))}}t.ScrollbarVisibilityController=U}),define(be[118],pe([1,0,4,22,14,3,2,5]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class d extends y.Disposable{constructor(f,M,o,n){super(),this.f=0,this.b=n||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.Emitter),this.h=o,this.i(),this.setOptions(f,M)}i(){this.B(i.Gesture.addTarget(this.a)),[i.EventType.Tap].forEach(f=>{this.B(v.addDisposableListener(this.a,f,M=>{this.a.focus()}))}),this.B(v.addStandardDisposableListener(this.a,"click",f=>{v.EventHelper.stop(f,!0)})),this.B(v.addStandardDisposableListener(this.a,"change",f=>{this.a.title=f.target.value,this.g.fire({index:f.target.selectedIndex,selected:f.target.value})})),this.B(v.addStandardDisposableListener(this.a,"keydown",f=>{let M=!1;w.isMacintosh?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(M=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(M=!0),M&&f.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(f,M){(!this.c||!U.equals(this.c,f))&&(this.c=f,this.a.options.length=0,this.c.forEach((o,n)=>{this.a.add(this.j(o.text,n,o.isDisabled))})),M!==void 0&&this.select(M)}select(f){this.c.length===0?this.f=0:f>=0&&f<this.c.length?this.f=f:f>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(f){this.b.ariaLabel=f,this.a.setAttribute("aria-label",f)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(f){this.a.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(f){this.h=f,this.applyStyles()}applyStyles(){if(this.a){const f=this.h.selectBackground?this.h.selectBackground.toString():"",M=this.h.selectForeground?this.h.selectForeground.toString():"",o=this.h.selectBorder?this.h.selectBorder.toString():"";this.a.style.backgroundColor=f,this.a.style.color=M,this.a.style.borderColor=o}}j(f,M,o){const n=document.createElement("option");return n.value=f,n.text=f,n.disabled=!!o,n}}t.SelectBoxNative=d}),define(be[55],pe([1,0,23,14,8,112,3,25]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function d(o){return typeof o=="object"&&"visibility"in o&&"data"in o}t.isFilterResult=d;function m(o){switch(o){case!0:return 1;case!1:return 0;default:return o}}t.getVisibleState=m;function f(o){return typeof o.collapsible=="boolean"}class M{constructor(n,e,s,a={}){this.o=n,this.p=e,this.rootRef=[],this.d=new y.EventBufferer,this.f=new y.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.Emitter,this.onDidSplice=this.l.event,this.m=new U.Delayer(U.MicrotaskDelay),this.h=typeof a.collapseByDefault>"u"?!1:a.collapseByDefault,this.j=a.filter,this.k=typeof a.autoExpandSingleChildren>"u"?!1:a.autoExpandSingleChildren,this.c={parent:void 0,element:s,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(n,e,s=w.Iterable.empty(),a={}){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");a.diffIdentityProvider?this.q(a.diffIdentityProvider,n,e,s,a):this.s(n,e,s,a)}q(n,e,s,a=w.Iterable.empty(),l,h=l.diffDepth??0){const{parentNode:r}=this.G(e);if(!r.lastDiffIds)return this.s(e,s,a,l);const u=[...a],b=e[e.length-1],A=new H.LcsDiff({getElements:()=>r.lastDiffIds},{getElements:()=>[...r.children.slice(0,b),...u,...r.children.slice(b+s)].map(C=>n.getId(C.element).toString())}).ComputeDiff(!1);if(A.quitEarly)return r.lastDiffIds=void 0,this.s(e,s,u,l);const N=e.slice(0,-1),L=(C,p,D)=>{if(h>0)for(let _=0;_<D;_++)C--,p--,this.q(n,[...N,C,0],Number.MAX_SAFE_INTEGER,u[p].children,l,h-1)};let T=Math.min(r.children.length,b+s),c=u.length;for(const C of A.changes.sort((p,D)=>D.originalStart-p.originalStart))L(T,c,T-(C.originalStart+C.originalLength)),T=C.originalStart,c=C.modifiedStart-b,this.s([...N,T],C.originalLength,w.Iterable.slice(u,c,c+C.modifiedLength),l);L(T,c,T)}s(n,e,s=w.Iterable.empty(),{onDidCreateNode:a,onDidDeleteNode:l,diffIdentityProvider:h}){const{parentNode:r,listIndex:u,revealed:b,visible:A}=this.G(n),N=[],L=w.Iterable.map(s,te=>this.w(te,r,r.visible?1:0,b,N,a)),T=n[n.length-1],c=r.children.length>0;let C=0;for(let te=T;te>=0&&te<r.children.length;te--){const he=r.children[te];if(he.visible){C=he.visibleChildIndex;break}}const p=[];let D=0,_=0;for(const te of L)p.push(te),_+=te.renderNodeCount,te.visible&&(te.visibleChildIndex=C+D++);const V=(0,i.splice)(r.children,T,e,p);h?r.lastDiffIds?(0,i.splice)(r.lastDiffIds,T,e,p.map(te=>h.getId(te.element).toString())):r.lastDiffIds=r.children.map(te=>h.getId(te.element).toString()):r.lastDiffIds=void 0;let ge=0;for(const te of V)te.visible&&ge++;if(ge!==0)for(let te=T+p.length;te<r.children.length;te++){const he=r.children[te];he.visible&&(he.visibleChildIndex-=ge)}if(r.visibleChildrenCount+=D-ge,b&&A){const te=V.reduce((he,re)=>he+(re.visible?re.renderNodeCount:0),0);this.B(r,_-te),this.p.splice(u,te,N)}if(V.length>0&&l){const te=he=>{l(he),he.children.forEach(te)};V.forEach(te)}this.l.fire({insertedNodes:p,deletedNodes:V});const Z=r.children.length>0;c!==Z&&this.setCollapsible(n.slice(0,-1),Z);let ie=r;for(;ie;){if(ie.visibility===2){this.m.trigger(()=>this.refilter());break}ie=ie.parent}}rerender(n){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");const{node:e,listIndex:s,revealed:a}=this.F(n);e.visible&&a&&this.p.splice(s,1,[e])}updateElementHeight(n,e){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");const{listIndex:s}=this.F(n);this.p.updateElementHeight(s,e)}has(n){return this.D(n)}getListIndex(n){const{listIndex:e,visible:s,revealed:a}=this.F(n);return s&&a?e:-1}getListRenderCount(n){return this.E(n).renderNodeCount}isCollapsible(n){return this.E(n).collapsible}setCollapsible(n,e){const s=this.E(n);typeof e>"u"&&(e=!s.collapsible);const a={collapsible:e};return this.d.bufferEvents(()=>this.t(n,a))}isCollapsed(n){return this.E(n).collapsed}setCollapsed(n,e,s){const a=this.E(n);typeof e>"u"&&(e=!a.collapsed);const l={collapsed:e,recursive:s||!1};return this.d.bufferEvents(()=>this.t(n,l))}t(n,e){const{node:s,listIndex:a,revealed:l}=this.F(n),h=this.u(s,a,l,e);if(s!==this.c&&this.k&&h&&!f(e)&&s.collapsible&&!s.collapsed&&!e.recursive){let r=-1;for(let u=0;u<s.children.length;u++)if(s.children[u].visible)if(r>-1){r=-1;break}else r=u;r>-1&&this.t([...n,r],e)}return h}u(n,e,s,a){const l=this.v(n,a,!1);if(!s||!n.visible||!l)return l;const h=n.renderNodeCount,r=this.x(n),u=h-(e===-1?0:1);return this.p.splice(e+1,u,r.slice(1)),l}v(n,e,s){let a;if(n===this.c?a=!1:(f(e)?(a=n.collapsible!==e.collapsible,n.collapsible=e.collapsible):n.collapsible?(a=n.collapsed!==e.collapsed,n.collapsed=e.collapsed):a=!1,a&&this.f.fire({node:n,deep:s})),!f(e)&&e.recursive)for(const l of n.children)a=this.v(l,e,!0)||a;return a}expandTo(n){this.d.bufferEvents(()=>{let e=this.E(n);for(;e.parent;)e=e.parent,n=n.slice(0,n.length-1),e.collapsed&&this.t(n,{collapsed:!1,recursive:!1})})}refilter(){const n=this.c.renderNodeCount,e=this.z(this.c);this.p.splice(0,n,e),this.m.cancel()}w(n,e,s,a,l,h){const r={parent:e,element:n.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof n.collapsible=="boolean"?n.collapsible:typeof n.collapsed<"u",collapsed:typeof n.collapsed>"u"?this.h:n.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},u=this.C(r,s);r.visibility=u,a&&l.push(r);const b=n.children||w.Iterable.empty(),A=a&&u!==0&&!r.collapsed;let N=0,L=1;for(const T of b){const c=this.w(T,r,u,A,l,h);r.children.push(c),L+=c.renderNodeCount,c.visible&&(c.visibleChildIndex=N++)}return r.collapsible=r.collapsible||r.children.length>0,r.visibleChildrenCount=N,r.visible=u===2?N>0:u===1,r.visible?r.collapsed||(r.renderNodeCount=L):(r.renderNodeCount=0,a&&l.pop()),h?.(r),r}x(n){const e=n.renderNodeCount,s=[];return this.y(n,s),this.B(n.parent,s.length-e),s}y(n,e){if(n.visible===!1)return 0;if(e.push(n),n.renderNodeCount=1,!n.collapsed)for(const s of n.children)n.renderNodeCount+=this.y(s,e);return this.g.fire(n),n.renderNodeCount}z(n){const e=n.renderNodeCount,s=[];return this.A(n,n.visible?1:0,s),this.B(n.parent,s.length-e),s}A(n,e,s,a=!0){let l;if(n!==this.c){if(l=this.C(n,e),l===0)return n.visible=!1,n.renderNodeCount=0,!1;a&&s.push(n)}const h=s.length;n.renderNodeCount=n===this.c?0:1;let r=!1;if(!n.collapsed||l!==0){let u=0;for(const b of n.children)r=this.A(b,l,s,a&&!n.collapsed)||r,b.visible&&(b.visibleChildIndex=u++);n.visibleChildrenCount=u}else n.visibleChildrenCount=0;return n!==this.c&&(n.visible=l===2?r:l===1,n.visibility=l),n.visible?n.collapsed||(n.renderNodeCount+=s.length-h):(n.renderNodeCount=0,a&&s.pop()),this.g.fire(n),n.visible}B(n,e){if(e!==0)for(;n;)n.renderNodeCount+=e,this.g.fire(n),n=n.parent}C(n,e){const s=this.j?this.j.filter(n.element,e):1;return typeof s=="boolean"?(n.filterData=void 0,s?1:0):d(s)?(n.filterData=s.data,m(s.visibility)):(n.filterData=void 0,m(s))}D(n,e=this.c){if(!n||n.length===0)return!0;const[s,...a]=n;return s<0||s>e.children.length?!1:this.D(a,e.children[s])}E(n,e=this.c){if(!n||n.length===0)return e;const[s,...a]=n;if(s<0||s>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");return this.E(a,e.children[s])}F(n){if(n.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:s,revealed:a,visible:l}=this.G(n),h=n[n.length-1];if(h<0||h>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");const r=e.children[h];return{node:r,listIndex:s,revealed:a,visible:l&&r.visible}}G(n,e=this.c,s=0,a=!0,l=!0){const[h,...r]=n;if(h<0||h>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");for(let u=0;u<h;u++)s+=e.children[u].renderNodeCount;return a=a&&!e.collapsed,l=l&&e.visible,r.length===0?{parentNode:e,listIndex:s,revealed:a,visible:l}:this.G(r,e.children[h],s+1,a,l)}getNode(n=[]){return this.E(n)}getNodeLocation(n){const e=[];let s=n;for(;s.parent;)e.push(s.parent.children.indexOf(s)),s=s.parent;return e.reverse()}getParentNodeLocation(n){if(n.length!==0)return n.length===1?[]:(0,i.tail2)(n)[0]}getFirstElementChild(n){const e=this.E(n);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(n=[]){const e=this.E(n);if(e.children.length!==0)return this.H(e)}H(n){return n.children.length===0?n.element:this.H(n.children[n.children.length-1])}}t.IndexTreeModel=M}),define(be[119],pe([1,0,55,23,25]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class H{get size(){return this.d.size}constructor(w,d,m={}){this.k=w,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.IndexTreeModel(w,d,null,m),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,m.sorter&&(this.j={compare(f,M){return m.sorter.compare(f.element,M.element)}}),this.h=m.identityProvider}setChildren(w,d=U.Iterable.empty(),m={}){const f=this.o(w);this.l(f,this.m(d),m)}l(w,d=U.Iterable.empty(),m){const f=new Set,M=new Set,o=e=>{if(e.element===null)return;const s=e;if(f.add(s.element),this.d.set(s.element,s),this.h){const a=this.h.getId(s.element).toString();M.add(a),this.f.set(a,s)}m.onDidCreateNode?.(s)},n=e=>{if(e.element===null)return;const s=e;if(f.has(s.element)||this.d.delete(s.element),this.h){const a=this.h.getId(s.element).toString();M.has(a)||this.f.delete(a)}m.onDidDeleteNode?.(s)};this.c.splice([...w,0],Number.MAX_VALUE,d,{...m,onDidCreateNode:o,onDidDeleteNode:n})}m(w=U.Iterable.empty()){return this.j&&(w=[...w].sort(this.j.compare.bind(this.j))),U.Iterable.map(w,d=>{let m=this.d.get(d.element);if(!m&&this.h){const o=this.h.getId(d.element).toString();m=this.f.get(o)}if(!m)return{...d,children:this.m(d.children)};const f=typeof d.collapsible=="boolean"?d.collapsible:m.collapsible,M=typeof d.collapsed<"u"?d.collapsed:m.collapsed;return{...d,collapsible:f,collapsed:M,children:this.m(d.children)}})}rerender(w){const d=this.o(w);this.c.rerender(d)}updateElementHeight(w,d){const m=this.o(w);this.c.updateElementHeight(m,d)}resort(w=null,d=!0){if(!this.j)return;const m=this.o(w),f=this.c.getNode(m);this.l(m,this.n(f,d),{})}n(w,d,m=!0){let f=[...w.children];return(d||m)&&(f=f.sort(this.j.compare.bind(this.j))),U.Iterable.map(f,M=>({element:M.element,collapsible:M.collapsible,collapsed:M.collapsed,children:this.n(M,d,!1)}))}getFirstElementChild(w=null){const d=this.o(w);return this.c.getFirstElementChild(d)}getLastElementAncestor(w=null){const d=this.o(w);return this.c.getLastElementAncestor(d)}has(w){return this.d.has(w)}getListIndex(w){const d=this.o(w);return this.c.getListIndex(d)}getListRenderCount(w){const d=this.o(w);return this.c.getListRenderCount(d)}isCollapsible(w){const d=this.o(w);return this.c.isCollapsible(d)}setCollapsible(w,d){const m=this.o(w);return this.c.setCollapsible(m,d)}isCollapsed(w){const d=this.o(w);return this.c.isCollapsed(d)}setCollapsed(w,d,m){const f=this.o(w);return this.c.setCollapsed(f,d,m)}expandTo(w){const d=this.o(w);this.c.expandTo(d)}refilter(){this.c.refilter()}getNode(w=null){if(w===null)return this.c.getNode(this.c.rootRef);const d=this.d.get(w);if(!d)throw new i.TreeError(this.k,`Tree element not found: ${w}`);return d}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new i.TreeError(this.k,"Invalid getParentNodeLocation call");const d=this.d.get(w);if(!d)throw new i.TreeError(this.k,`Tree element not found: ${w}`);const m=this.c.getNodeLocation(d),f=this.c.getParentNodeLocation(m);return this.c.getNode(f).element}o(w){if(w===null)return[];const d=this.d.get(w);if(!d)throw new i.TreeError(this.k,`Tree element not found: ${w}`);return this.c.getNodeLocation(d)}}t.ObjectTreeModel=H}),define(be[18],pe([1,0,4,17,20,22,2]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends y.Disposable{f(m,f){this.B(v.addDisposableListener(m,v.EventType.CLICK,M=>f(new U.StandardMouseEvent(M))))}j(m,f){this.B(v.addDisposableListener(m,v.EventType.MOUSE_DOWN,M=>f(new U.StandardMouseEvent(M))))}k(m,f){this.B(v.addDisposableListener(m,v.EventType.MOUSE_OVER,M=>f(new U.StandardMouseEvent(M))))}m(m,f){this.B(v.addDisposableListener(m,v.EventType.MOUSE_LEAVE,M=>f(new U.StandardMouseEvent(M))))}p(m,f){this.B(v.addDisposableListener(m,v.EventType.KEY_DOWN,M=>f(new i.StandardKeyboardEvent(M))))}u(m,f){this.B(v.addDisposableListener(m,v.EventType.KEY_UP,M=>f(new i.StandardKeyboardEvent(M))))}z(m,f){this.B(v.addDisposableListener(m,v.EventType.INPUT,f))}C(m,f){this.B(v.addDisposableListener(m,v.EventType.BLUR,f))}D(m,f){this.B(v.addDisposableListener(m,v.EventType.FOCUS,f))}F(m,f){this.B(v.addDisposableListener(m,v.EventType.CHANGE,f))}G(m){return H.Gesture.ignoreTarget(m)}}t.Widget=w}),define(be[36],pe([1,0,53,18,8,4]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends i.Widget{constructor(d){super(),this.a=d.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=d.bgWidth+"px",this.bgDomNode.style.height=d.bgHeight+"px",typeof d.top<"u"&&(this.bgDomNode.style.top="0px"),typeof d.left<"u"&&(this.bgDomNode.style.left="0px"),typeof d.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof d.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=d.className,this.domNode.classList.add(...d.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof d.top<"u"&&(this.domNode.style.top=d.top+"px"),typeof d.left<"u"&&(this.domNode.style.left=d.left+"px"),typeof d.bottom<"u"&&(this.domNode.style.bottom=d.bottom+"px"),typeof d.right<"u"&&(this.domNode.style.right=d.right+"px"),this.g=this.B(new v.GlobalPointerMoveMonitor),this.B(H.addStandardDisposableListener(this.bgDomNode,H.EventType.POINTER_DOWN,m=>this.h(m))),this.B(H.addStandardDisposableListener(this.domNode,H.EventType.POINTER_DOWN,m=>this.h(m))),this.b=this.B(new U.IntervalTimer),this.c=this.B(new U.TimeoutTimer)}h(d){if(!d.target||!(d.target instanceof Element))return;const m=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(m,200),this.g.startMonitoring(d.target,d.pointerId,d.buttons,f=>{},()=>{this.b.cancel(),this.c.cancel()}),d.preventDefault()}}t.ScrollbarArrow=y}),define(be[56],pe([1,0,4,39,53,36,117,18,5]),function(X,t,v,i,U,H,y,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const m=140;class f extends w.Widget{constructor(o){super(),this.g=o.lazyRender,this.a=o.host,this.b=o.scrollable,this.c=o.scrollByPage,this.h=o.scrollbarState,this.i=this.B(new y.ScrollbarVisibilityController(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new U.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.addDisposableListener(this.domNode.domNode,v.EventType.POINTER_DOWN,n=>this.y(n)))}r(o){const n=this.B(new H.ScrollbarArrow(o));this.domNode.domNode.appendChild(n.bgDomNode),this.domNode.domNode.appendChild(n.domNode)}s(o,n,e,s){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(n),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.addDisposableListener(this.slider.domNode,v.EventType.POINTER_DOWN,a=>{a.button===0&&(a.preventDefault(),this.I(a))})),this.f(this.slider.domNode,a=>{a.leftButton&&a.stopPropagation()})}t(o){return this.h.setVisibleSize(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(o){return this.h.setScrollSize(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(o){return this.h.setScrollPosition(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){!this.n||(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(o){o.target===this.domNode.domNode&&this.H(o)}delegatePointerDown(o){const n=this.domNode.domNode.getClientRects()[0].top,e=n+this.h.getSliderPosition(),s=n+this.h.getSliderPosition()+this.h.getSliderSize(),a=this.O(o);e<=a&&a<=s?o.button===0&&(o.preventDefault(),this.I(o)):this.H(o)}H(o){let n,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")n=o.offsetX,e=o.offsetY;else{const a=v.getDomNodePagePosition(this.domNode.domNode);n=o.pageX-a.left,e=o.pageY-a.top}const s=this.N(n,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),o.button===0&&(o.preventDefault(),this.I(o))}I(o){if(!o.target||!(o.target instanceof Element))return;const n=this.O(o),e=this.P(o),s=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(o.target,o.pointerId,o.buttons,a=>{const l=this.P(a),h=Math.abs(l-e);if(d.isWindows&&h>m){this.J(s.getScrollPosition());return}const u=this.O(a)-n;this.J(s.getDesiredScrollPositionFromDelta(u))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(o){const n={};this.writeScrollPosition(n,o),this.b.setScrollPositionNow(n)}updateScrollbarSize(o){this.Q(o),this.h.setScrollbarSize(o),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=f}),define(be[120],pe([1,0,20,56,36,40,12]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(m,f,M){const o=m.getScrollDimensions(),n=m.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:M,scrollbarState:new H.ScrollbarState(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,o.width,o.scrollWidth,n.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:m,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-U.ARROW_IMG_SIZE)/2,s=(f.horizontalScrollbarSize-U.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:y.Codicon.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:y.Codicon.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}M(m,f){this.slider.setWidth(m),this.slider.setLeft(f)}L(m,f){this.domNode.setWidth(m),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(m){return this.n=this.v(m.scrollWidth)||this.n,this.n=this.w(m.scrollLeft)||this.n,this.n=this.t(m.width)||this.n,this.n}N(m,f){return m}O(m){return m.pageX}P(m){return m.pageY}Q(m){this.slider.setHeight(m)}writeScrollPosition(m,f){m.scrollLeft=f}updateOptions(m){this.updateScrollbarSize(m.horizontal===2?0:m.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(m.vertical===2?0:m.verticalScrollbarSize),this.i.setVisibility(m.horizontal),this.c=m.scrollByPage}}t.HorizontalScrollbar=w}),define(be[121],pe([1,0,20,56,36,40,12]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(m,f,M){const o=m.getScrollDimensions(),n=m.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:M,scrollbarState:new H.ScrollbarState(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,o.height,o.scrollHeight,n.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:m,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-U.ARROW_IMG_SIZE)/2,s=(f.verticalScrollbarSize-U.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:y.Codicon.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:y.Codicon.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}M(m,f){this.slider.setHeight(m),this.slider.setTop(f)}L(m,f){this.domNode.setWidth(f),this.domNode.setHeight(m),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(m){return this.n=this.v(m.scrollHeight)||this.n,this.n=this.w(m.scrollTop)||this.n,this.n=this.t(m.height)||this.n,this.n}N(m,f){return f}O(m){return m.pageY}P(m){return m.pageX}Q(m){this.slider.setWidth(m)}writeScrollPosition(m,f){m.scrollTop=f}updateOptions(m){this.updateScrollbarSize(m.vertical===2?0:m.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(m.vertical),this.c=m.scrollByPage}}t.VerticalScrollbar=w}),define(be[57],pe([1,0,16,4,39,20,120,121,18,8,3,2,5,49,90]),function(X,t,v,i,U,H,y,w,d,m,f,M,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,s=50,a=!0;class l{constructor(T,c,C){this.timestamp=T,this.deltaX=c,this.deltaY=C,this.score=0}}class h{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let T=1,c=0,C=1,p=this.d;do{const D=p===this.c?T:Math.pow(2,-C);if(T-=D,c+=this.b[p].score*D,p===this.c)break;p=(this.a+p-1)%this.a,C++}while(!0);return c<=.5}accept(T,c,C){const p=new l(T,c,C);p.score=this.f(p),this.c===-1&&this.d===-1?(this.b[0]=p,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=p)}f(T){if(Math.abs(T.deltaX)>0&&Math.abs(T.deltaY)>0)return 1;let c=.5;const C=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(T.deltaX)||!this.g(T.deltaY))&&(c+=.25),Math.min(Math.max(c,0),1)}g(T){return Math.abs(Math.round(T)-T)<.01}}t.MouseWheelClassifier=h,h.INSTANCE=new h;class r extends d.Widget{get options(){return this.a}constructor(T,c,C){super(),this.I=this.B(new f.Emitter),this.onScroll=this.I.event,this.J=this.B(new f.Emitter),this.onWillScroll=this.J.event,T.style.overflow="hidden",this.a=N(c),this.b=C,this.B(this.b.onScroll(D=>{this.J.fire(D),this.N(D),this.I.fire(D)}));const p={onMouseWheel:D=>this.M(D),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.B(new w.VerticalScrollbar(this.b,this.a,p)),this.g=this.B(new y.HorizontalScrollbar(this.b,this.a,p)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(T),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,U.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,U.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,U.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,D=>this.S(D)),this.m(this.r,D=>this.R(D)),this.w=this.B(new m.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,M.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(T){this.c.delegatePointerDown(T)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(T){this.b.setScrollDimensions(T,!1)}updateClassName(T){this.a.className=T,o.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(T){typeof T.handleMouseWheel<"u"&&(this.a.handleMouseWheel=T.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof T.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=T.mouseWheelScrollSensitivity),typeof T.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=T.fastScrollSensitivity),typeof T.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=T.scrollPredominantAxis),typeof T.horizontal<"u"&&(this.a.horizontal=T.horizontal),typeof T.vertical<"u"&&(this.a.vertical=T.vertical),typeof T.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=T.horizontalScrollbarSize),typeof T.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=T.verticalScrollbarSize),typeof T.scrollByPage<"u"&&(this.a.scrollByPage=T.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(T){this.H=T}delegateScrollFromMouseWheelEvent(T){this.M(new H.StandardWheelEvent(T))}L(T){if(this.s.length>0!==T&&(this.s=(0,M.dispose)(this.s),T)){const C=p=>{this.M(new H.StandardWheelEvent(p))};this.s.push(i.addDisposableListener(this.r,i.EventType.MOUSE_WHEEL,C,{passive:!1}))}}M(T){const c=h.INSTANCE;if(a){const D=window.devicePixelRatio/(0,v.getZoomFactor)();o.isWindows||o.isLinux?c.accept(Date.now(),T.deltaX/D,T.deltaY/D):c.accept(Date.now(),T.deltaX,T.deltaY)}let C=!1;if(T.deltaY||T.deltaX){let D=T.deltaY*this.a.mouseWheelScrollSensitivity,_=T.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(D)>=Math.abs(_)?_=0:D=0),this.a.flipAxes&&([D,_]=[_,D]);const V=!o.isMacintosh&&T.browserEvent&&T.browserEvent.shiftKey;(this.a.scrollYToX||V)&&!_&&(_=D,D=0),T.browserEvent&&T.browserEvent.altKey&&(_=_*this.a.fastScrollSensitivity,D=D*this.a.fastScrollSensitivity);const ge=this.b.getFutureScrollPosition();let Z={};if(D){const ie=s*D,te=ge.scrollTop-(ie<0?Math.floor(ie):Math.ceil(ie));this.c.writeScrollPosition(Z,te)}if(_){const ie=s*_,te=ge.scrollLeft-(ie<0?Math.floor(ie):Math.ceil(ie));this.g.writeScrollPosition(Z,te)}Z=this.b.validateScrollPosition(Z),(ge.scrollLeft!==Z.scrollLeft||ge.scrollTop!==Z.scrollTop)&&(a&&this.a.mouseWheelSmoothScroll&&c.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(Z):this.b.setScrollPositionNow(Z),C=!0)}let p=C;!p&&this.a.alwaysConsumeMouseWheel&&(p=!0),!p&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(p=!0),p&&(T.preventDefault(),T.stopPropagation())}N(T){this.y=this.g.onDidScroll(T)||this.y,this.y=this.c.onDidScroll(T)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(!!this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const T=this.b.getCurrentScrollPosition(),c=T.scrollTop>0,C=T.scrollLeft>0,p=C?" left":"",D=c?" top":"",_=C||c?" top-left-corner":"";this.i.setClassName(`shadow${p}`),this.l.setClassName(`shadow${D}`),this.n.setClassName(`shadow${_}${D}${p}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(T){this.v=!1,this.W()}S(T){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.AbstractScrollableElement=r;class u extends r{constructor(T,c){c=c||{},c.mouseWheelSmoothScroll=!1;const C=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>i.scheduleAtNextAnimationFrame(p)});super(T,c,C),this.B(C)}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=u;class b extends r{constructor(T,c,C){super(T,c,C)}setScrollPosition(T){T.reuseAnimation?this.b.setScrollPositionSmooth(T,T.reuseAnimation):this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=b;class A extends r{constructor(T,c){c=c||{},c.mouseWheelSmoothScroll=!1;const C=new n.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>i.scheduleAtNextAnimationFrame(p)});super(T,c,C),this.B(C),this.Y=T,this.onScroll(p=>{p.scrollTopChanged&&(this.Y.scrollTop=p.scrollTop),p.scrollLeftChanged&&(this.Y.scrollLeft=p.scrollLeft)}),this.scanDomNode()}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.DomScrollableElement=A;function N(L){const T={lazyRender:typeof L.lazyRender<"u"?L.lazyRender:!1,className:typeof L.className<"u"?L.className:"",useShadows:typeof L.useShadows<"u"?L.useShadows:!0,handleMouseWheel:typeof L.handleMouseWheel<"u"?L.handleMouseWheel:!0,flipAxes:typeof L.flipAxes<"u"?L.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof L.consumeMouseWheelIfScrollbarIsNeeded<"u"?L.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof L.alwaysConsumeMouseWheel<"u"?L.alwaysConsumeMouseWheel:!1,scrollYToX:typeof L.scrollYToX<"u"?L.scrollYToX:!1,mouseWheelScrollSensitivity:typeof L.mouseWheelScrollSensitivity<"u"?L.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof L.fastScrollSensitivity<"u"?L.fastScrollSensitivity:5,scrollPredominantAxis:typeof L.scrollPredominantAxis<"u"?L.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof L.mouseWheelSmoothScroll<"u"?L.mouseWheelSmoothScroll:!0,arrowSize:typeof L.arrowSize<"u"?L.arrowSize:11,listenOnDomNode:typeof L.listenOnDomNode<"u"?L.listenOnDomNode:null,horizontal:typeof L.horizontal<"u"?L.horizontal:1,horizontalScrollbarSize:typeof L.horizontalScrollbarSize<"u"?L.horizontalScrollbarSize:10,horizontalSliderSize:typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:0,horizontalHasArrows:typeof L.horizontalHasArrows<"u"?L.horizontalHasArrows:!1,vertical:typeof L.vertical<"u"?L.vertical:1,verticalScrollbarSize:typeof L.verticalScrollbarSize<"u"?L.verticalScrollbarSize:10,verticalHasArrows:typeof L.verticalHasArrows<"u"?L.verticalHasArrows:!1,verticalSliderSize:typeof L.verticalSliderSize<"u"?L.verticalSliderSize:0,scrollByPage:typeof L.scrollByPage<"u"?L.scrollByPage:!1};return T.horizontalSliderSize=typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:T.horizontalScrollbarSize,T.verticalSliderSize=typeof L.verticalSliderSize<"u"?L.verticalSliderSize:T.verticalScrollbarSize,o.isMacintosh&&(T.className+=" mac"),T}}),define(be[58],pe([1,0,51,4,19,22,57,14,8,24,3,2,47,49,79,116,9]),function(X,t,v,i,U,H,y,w,d,m,f,M,o,n,e,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const l={CurrentDragAndDropData:void 0},h={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(T){return[T]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(c){this.d=c}constructor(c){this.elements=c}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=r;class u{constructor(c){this.elements=c}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=u;class b{constructor(){this.types=[],this.files=[]}update(c){if(c.types&&this.types.splice(0,this.types.length,...c.types),c.files){this.files.splice(0,this.files.length);for(let C=0;C<c.files.length;C++){const p=c.files.item(C);p&&(p.size||p.type)&&this.files.push(p)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=b;function A(T,c){return Array.isArray(T)&&Array.isArray(c)?(0,w.equals)(T,c):T===c}class N{constructor(c){c?.getSetSize?this.getSetSize=c.getSetSize.bind(c):this.getSetSize=(C,p,D)=>D,c?.getPosInSet?this.getPosInSet=c.getPosInSet.bind(c):this.getPosInSet=(C,p)=>p+1,c?.getRole?this.getRole=c.getRole.bind(c):this.getRole=C=>"listitem",c?.isChecked?this.isChecked=c.isChecked.bind(c):this.isChecked=C=>{}}}class L{get contentHeight(){return this.g.size}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get O(){return this.N}set O(c){if(c!==this.N){if(c&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.N=c,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.N){for(const C of this.d)this.X(C);this.U(),this.q.setScrollDimensions({width:(0,i.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(c,C,p,D=h){if(this.P=C,this.domId=`list_id_${++L.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new d.Delayer(50),this.v=!1,this.x=M.Disposable.None,this.y=0,this.G=!1,this.J=M.Disposable.None,this.K=M.Disposable.None,this.L=new M.DisposableStore,this.M=new f.Emitter,this.onDidChangeContentHeight=f.Event.latch(this.M.event,void 0,this.L),this.N=!1,D.horizontalScrolling&&D.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const V of p)this.j.set(V.templateId,V);this.h=this.L.add(new s.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof D.mouseSupport=="boolean"?D.mouseSupport:!0),this.N=D.horizontalScrolling??h.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.C=typeof D.additionalScrollHeight>"u"?0:D.additionalScrollHeight,this.D=new N(D.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(D.transformOptimization??h.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(H.Gesture.addTarget(this.o)),this.p=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:D.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,i.scheduleAtNextAnimationFrame)(V)}),this.q=this.L.add(new y.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:D.alwaysConsumeMouseWheel??h.alwaysConsumeMouseWheel,horizontal:1,vertical:D.verticalScrollMode??h.verticalScrollMode,useShadows:D.useShadows??h.useShadows,mouseWheelScrollSensitivity:D.mouseWheelScrollSensitivity,fastScrollSensitivity:D.fastScrollSensitivity},this.p)),this.domNode.appendChild(this.q.getDomNode()),c.appendChild(this.domNode),this.q.onScroll(this.fb,this,this.L),this.L.add((0,i.addDisposableListener)(this.o,H.EventType.Change,V=>this.gb(V))),this.L.add((0,i.addDisposableListener)(this.q.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.L.add((0,i.addDisposableListener)(this.domNode,"dragover",V=>this.ib(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"drop",V=>this.kb(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"dragleave",V=>this.jb(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"dragend",V=>this.lb(V))),this.z=D.setRowLineHeight??h.setRowLineHeight,this.A=D.setRowHeight??h.setRowHeight,this.B=D.supportDynamicHeights??h.supportDynamicHeights,this.F=D.dnd??h.dnd,this.layout(D.initialSize?.height,D.initialSize?.width)}updateOptions(c){c.additionalScrollHeight!==void 0&&(this.C=c.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),c.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(c.smoothScrolling?125:0),c.horizontalScrolling!==void 0&&(this.O=c.horizontalScrolling),c.mouseWheelScrollSensitivity!==void 0&&this.q.updateOptions({mouseWheelScrollSensitivity:c.mouseWheelScrollSensitivity}),c.fastScrollSensitivity!==void 0&&this.q.updateOptions({fastScrollSensitivity:c.fastScrollSensitivity})}delegateScrollFromMouseWheelEvent(c){this.q.delegateScrollFromMouseWheelEvent(c)}delegateVerticalScrollbarPointerDown(c){this.q.delegateVerticalScrollbarPointerDown(c)}updateElementHeight(c,C,p){if(c<0||c>=this.d.length)return;const D=this.d[c].size;if(typeof C>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[c].lastDynamicHeightWidth=void 0,C=D+this.tb(c)}if(D===C)return;const _=this.rb(this.k,this.m);let V=0;c<_.start||p!==null&&p>c&&p<=_.end?V=C-D:V=0,this.g.splice(c,1,[{size:C}]),this.d[c].size=C,this.V(_,Math.max(0,this.k+V),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.R(),this.B&&this.sb(this.k,this.m)}splice(c,C,p=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.Q(c,C,p)}finally{this.v=!1,this.M.fire(this.contentHeight)}}Q(c,C,p=[]){const D=this.rb(this.k,this.m),_={start:c,end:c+C},V=o.Range.intersect(D,_),ge=new Map;for(let ee=V.end-1;ee>=V.start;ee--){const k=this.d[ee];if(k.dragStartDisposable.dispose(),k.checkedDisposable.dispose(),k.row){let E=ge.get(k.templateId);E||(E=[],ge.set(k.templateId,E));const g=this.j.get(k.templateId);g&&g.disposeElement&&g.disposeElement(k.element,ee,k.row.templateData,k.size),E.push(k.row)}k.row=null}const Z={start:c+C,end:this.d.length},ie=o.Range.intersect(Z,D),te=o.Range.relativeComplement(Z,D),he=p.map(ee=>({id:String(this.f++),element:ee,templateId:this.P.getTemplateId(ee),size:this.P.getHeight(ee),width:void 0,hasDynamicHeight:!!this.P.hasDynamicHeight&&this.P.hasDynamicHeight(ee),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:M.Disposable.None,checkedDisposable:M.Disposable.None}));let re;c===0&&C>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,he),re=this.d,this.d=he):(this.g.splice(c,C,he),re=this.d.splice(c,C,...he));const ce=p.length-C,Se=this.rb(this.k,this.m),x=(0,e.shift)(ie,ce),De=o.Range.intersect(Se,x);for(let ee=De.start;ee<De.end;ee++)this.Y(this.d[ee],ee);const se=o.Range.relativeComplement(x,Se);for(const ee of se)for(let k=ee.start;k<ee.end;k++)this.Z(k);const Q=te.map(ee=>(0,e.shift)(ee,ce)),de=[{start:c,end:c+p.length},...Q].map(ee=>o.Range.intersect(Se,ee)),me=this.ub(de);for(const ee of de)for(let k=ee.start;k<ee.end;k++){const E=this.d[k],R=ge.get(E.templateId)?.pop();this.W(k,me,R)}for(const ee of ge.values())for(const k of ee)this.h.release(k);return this.R(),this.B&&this.sb(this.scrollTop,this.renderHeight),re.map(ee=>ee.element)}R(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,i.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.U(),this.t=null}))}S(){if(!this.O){this.u.cancel();return}this.u.trigger(()=>this.U())}U(){if(!this.O)return;let c=0;for(const C of this.d)typeof C.width<"u"&&(c=Math.max(c,C.width));this.E=c,this.q.setScrollDimensions({scrollWidth:c===0?0:c+10})}updateWidth(c){if(!this.O||typeof this.E>"u")return;const C=this.d[c];this.X(C),typeof C.width<"u"&&C.width>this.E&&(this.E=C.width,this.q.setScrollDimensions({scrollWidth:this.E+10}))}rerender(){if(!!this.B){for(const c of this.d)c.lastDynamicHeightWidth=void 0;this.sb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const c=this.rb(this.k,this.m),C=this.g.positionAt(c.start),p=this.g.positionAt(c.start+1);return p!==-1&&(p-C)/2+C<this.scrollTop?c.start+1:c.start}get lastVisibleIndex(){return this.rb(this.k,this.m).end-1}element(c){return this.d[c].element}indexOf(c){return this.d.findIndex(C=>C.element===c)}domElement(c){const C=this.d[c].row;return C&&C.domNode}elementHeight(c){return this.d[c].size}elementTop(c){return this.g.positionAt(c)}indexAt(c){return this.g.indexAt(c)}indexAfter(c){return this.g.indexAfter(c)}layout(c,C){const p={height:typeof c=="number"?c:(0,i.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,p.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(p),typeof C<"u"&&(this.n=C,this.B&&this.sb(this.scrollTop,this.renderHeight)),this.O&&this.q.setScrollDimensions({width:typeof C=="number"?C:(0,i.getContentWidth)(this.domNode)})}V(c,C,p,D,_,V=!1){const ge=this.rb(C,p),Z=o.Range.relativeComplement(ge,c),ie=o.Range.relativeComplement(c,ge),te=this.ub(Z);if(V){const he=o.Range.intersect(c,ge);for(let re=he.start;re<he.end;re++)this.Y(this.d[re],re)}for(const he of Z)for(let re=he.start;re<he.end;re++)this.W(re,te);for(const he of ie)for(let re=he.start;re<he.end;re++)this.Z(re);D!==void 0&&(this.o.style.left=`-${D}px`),this.o.style.top=`-${C}px`,this.O&&_!==void 0&&(this.o.style.width=`${Math.max(_,this.n)}px`),this.k=C,this.m=p}W(c,C,p){const D=this.d[c];D.row||(D.row=p??this.h.alloc(D.templateId));const _=this.D.getRole(D.element)||"listitem";D.row.domNode.setAttribute("role",_);const V=this.D.isChecked(D.element);if(typeof V=="boolean")D.row.domNode.setAttribute("aria-checked",String(!!V));else if(V){const ie=te=>D.row.domNode.setAttribute("aria-checked",String(!!te));ie(V.value),D.checkedDisposable=V.onDidChange(ie)}D.row.domNode.parentElement||(C?this.o.insertBefore(D.row.domNode,C):this.o.appendChild(D.row.domNode)),this.Y(D,c);const ge=this.j.get(D.templateId);if(!ge)throw new Error(`No renderer found for template id ${D.templateId}`);ge?.renderElement(D.element,c,D.row.templateData,D.size);const Z=this.F.getDragURI(D.element);D.dragStartDisposable.dispose(),D.row.domNode.draggable=!!Z,Z&&(D.dragStartDisposable=(0,i.addDisposableListener)(D.row.domNode,"dragstart",ie=>this.hb(D.element,Z,ie))),this.O&&(this.X(D),this.S())}X(c){if(!c.row||!c.row.domNode)return;c.row.domNode.style.width="fit-content",c.width=(0,i.getContentWidth)(c.row.domNode);const C=window.getComputedStyle(c.row.domNode);C.paddingLeft&&(c.width+=parseFloat(C.paddingLeft)),C.paddingRight&&(c.width+=parseFloat(C.paddingRight)),c.row.domNode.style.width=""}Y(c,C){c.row.domNode.style.top=`${this.elementTop(C)}px`,this.A&&(c.row.domNode.style.height=`${c.size}px`),this.z&&(c.row.domNode.style.lineHeight=`${c.size}px`),c.row.domNode.setAttribute("data-index",`${C}`),c.row.domNode.setAttribute("data-last-element",C===this.length-1?"true":"false"),c.row.domNode.setAttribute("data-parity",C%2===0?"even":"odd"),c.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(c.element,C,this.length))),c.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(c.element,C))),c.row.domNode.setAttribute("id",this.getElementDomId(C)),c.row.domNode.classList.toggle("drop-target",c.dropTarget)}Z(c){const C=this.d[c];if(C.dragStartDisposable.dispose(),C.checkedDisposable.dispose(),C.row){const p=this.j.get(C.templateId);p&&p.disposeElement&&p.disposeElement(C.element,c,C.row.templateData,C.size),this.h.release(C.row),C.row=null}this.O&&this.S()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(c,C){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:c,reuseAnimation:C})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(c){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:c})}get scrollTop(){return this.getScrollTop()}set scrollTop(c){this.setScrollTop(c)}get scrollHeight(){return this.s+(this.O?10:0)+this.C}get onMouseClick(){return f.Event.map(this.L.add(new U.DomEmitter(this.domNode,"click")).event,c=>this.ab(c),this.L)}get onMouseDblClick(){return f.Event.map(this.L.add(new U.DomEmitter(this.domNode,"dblclick")).event,c=>this.ab(c),this.L)}get onMouseMiddleClick(){return f.Event.filter(f.Event.map(this.L.add(new U.DomEmitter(this.domNode,"auxclick")).event,c=>this.ab(c),this.L),c=>c.browserEvent.button===1,this.L)}get onMouseUp(){return f.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mouseup")).event,c=>this.ab(c),this.L)}get onMouseDown(){return f.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mousedown")).event,c=>this.ab(c),this.L)}get onMouseOver(){return f.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mouseover")).event,c=>this.ab(c),this.L)}get onMouseMove(){return f.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mousemove")).event,c=>this.ab(c),this.L)}get onMouseOut(){return f.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mouseout")).event,c=>this.ab(c),this.L)}get onContextMenu(){return f.Event.any(f.Event.map(this.L.add(new U.DomEmitter(this.domNode,"contextmenu")).event,c=>this.ab(c),this.L),f.Event.map(this.L.add(new U.DomEmitter(this.domNode,H.EventType.Contextmenu)).event,c=>this.db(c),this.L))}get onTouchStart(){return f.Event.map(this.L.add(new U.DomEmitter(this.domNode,"touchstart")).event,c=>this.bb(c),this.L)}get onTap(){return f.Event.map(this.L.add(new U.DomEmitter(this.o,H.EventType.Tap)).event,c=>this.db(c),this.L)}ab(c){const C=this.qb(c.target||null),p=typeof C>"u"?void 0:this.d[C],D=p&&p.element;return{browserEvent:c,index:C,element:D}}bb(c){const C=this.qb(c.target||null),p=typeof C>"u"?void 0:this.d[C],D=p&&p.element;return{browserEvent:c,index:C,element:D}}db(c){const C=this.qb(c.initialTarget||null),p=typeof C>"u"?void 0:this.d[C],D=p&&p.element;return{browserEvent:c,index:C,element:D}}eb(c){const C=this.qb(c.target||null),p=typeof C>"u"?void 0:this.d[C],D=p&&p.element;return{browserEvent:c,index:C,element:D}}fb(c){try{const C=this.rb(this.k,this.m);this.V(C,c.scrollTop,c.height,c.scrollLeft,c.scrollWidth),this.B&&this.sb(c.scrollTop,c.height,c.inSmoothScrolling)}catch(C){throw console.error("Got bad scroll event:",c),C}}gb(c){c.preventDefault(),c.stopPropagation(),this.scrollTop-=c.translationY}hb(c,C,p){if(!p.dataTransfer)return;const D=this.F.getDragElements(c);if(p.dataTransfer.effectAllowed="copyMove",p.dataTransfer.setData(v.DataTransfers.TEXT,C),p.dataTransfer.setDragImage){let _;this.F.getDragLabel&&(_=this.F.getDragLabel(D,p)),typeof _>"u"&&(_=String(D.length));const V=(0,i.$)(".monaco-drag-image");V.textContent=_,document.body.appendChild(V),p.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>document.body.removeChild(V),0)}this.domNode.classList.add("dragging"),this.H=new r(D),l.CurrentDragAndDropData=new u(D),this.F.onDragStart?.(this.H,p)}ib(c){if(c.browserEvent.preventDefault(),this.K.dispose(),l.CurrentDragAndDropData&&l.CurrentDragAndDropData.getData()==="vscode-ui"||(this.nb(c.browserEvent),!c.browserEvent.dataTransfer))return!1;if(!this.H)if(l.CurrentDragAndDropData)this.H=l.CurrentDragAndDropData;else{if(!c.browserEvent.dataTransfer.types)return!1;this.H=new b}const C=this.F.onDragOver(this.H,c.element,c.index,c.browserEvent);if(this.G=typeof C=="boolean"?C:C.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;c.browserEvent.dataTransfer.dropEffect=typeof C!="boolean"&&C.effect===0?"copy":"move";let p;if(typeof C!="boolean"&&C.feedback?p=C.feedback:typeof c.index>"u"?p=[-1]:p=[c.index],p=(0,w.distinct)(p).filter(D=>D>=-1&&D<this.length).sort((D,_)=>D-_),p=p[0]===-1?[-1]:p,A(this.I,p))return!0;if(this.I=p,this.J.dispose(),p[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,M.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const D of p){const _=this.d[D];_.dropTarget=!0,_.row?.domNode.classList.add("drop-target")}this.J=(0,M.toDisposable)(()=>{for(const D of p){const _=this.d[D];_.dropTarget=!1,_.row?.domNode.classList.remove("drop-target")}})}return!0}jb(c){this.K.dispose(),this.K=(0,d.disposableTimeout)(()=>this.mb(),100),this.H&&this.F.onDragLeave?.(this.H,c.element,c.index,c.browserEvent)}kb(c){if(!this.G)return;const C=this.H;this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,l.CurrentDragAndDropData=void 0,!(!C||!c.browserEvent.dataTransfer)&&(c.browserEvent.preventDefault(),C.update(c.browserEvent.dataTransfer),this.F.drop(C,c.element,c.index,c.browserEvent))}lb(c){this.G=!1,this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,l.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(c)}mb(){this.I=void 0,this.J.dispose(),this.J=M.Disposable.None}nb(c){if(!this.w){const C=(0,i.getTopLeftOffset)(this.domNode).top;this.w=(0,i.animate)(this.ob.bind(this,C))}this.x.dispose(),this.x=(0,d.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=c.pageY}ob(c){if(this.y===void 0)return;const C=this.y-c,p=this.renderHeight-35;C<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(C-35))):C>p&&(this.scrollTop+=Math.min(14,Math.floor(.3*(C-p))))}pb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}qb(c){const C=this.q.getDomNode();let p=c;for(;p instanceof HTMLElement&&p!==this.o&&C.contains(p);){const D=p.getAttribute("data-index");if(D){const _=Number(D);if(!isNaN(_))return _}p=p.parentElement}}rb(c,C){return{start:this.g.indexAt(c),end:this.g.indexAfter(c+C-1)}}sb(c,C,p){const D=this.rb(c,C);let _,V;c===this.elementTop(D.start)?(_=D.start,V=0):D.end-D.start>1&&(_=D.start+1,V=this.elementTop(_)-c);let ge=0;for(;;){const Z=this.rb(c,C);let ie=!1;for(let te=Z.start;te<Z.end;te++){const he=this.tb(te);he!==0&&this.g.splice(te,1,[this.d[te]]),ge+=he,ie=ie||he!==0}if(!ie){ge!==0&&this.R();const te=o.Range.relativeComplement(D,Z);for(const re of te)for(let ce=re.start;ce<re.end;ce++)this.d[ce].row&&this.Z(ce);const he=o.Range.relativeComplement(Z,D);for(const re of he)for(let ce=re.start;ce<re.end;ce++){const Se=ce+1,x=Se<this.d.length?this.d[Se].row:null,De=x?x.domNode:null;this.W(ce,De)}for(let re=Z.start;re<Z.end;re++)this.d[re].row&&this.Y(this.d[re],re);if(typeof _=="number"){const re=this.p.getFutureScrollPosition().scrollTop-c,ce=this.elementTop(_)-V+re;this.setScrollTop(ce,p)}this.M.fire(this.contentHeight);return}}}tb(c){const C=this.d[c];if(this.P.getDynamicHeight){const V=this.P.getDynamicHeight(C.element);if(V!==null){const ge=C.size;return C.size=V,C.lastDynamicHeightWidth=this.n,V-ge}}if(!C.hasDynamicHeight||C.lastDynamicHeightWidth===this.n||!!this.P.hasDynamicHeight&&!this.P.hasDynamicHeight(C.element))return 0;const p=C.size;if(C.row)return C.row.domNode.style.height="",C.size=C.row.domNode.offsetHeight,C.lastDynamicHeightWidth=this.n,C.size-p;const D=this.h.alloc(C.templateId);D.domNode.style.height="",this.o.appendChild(D.domNode);const _=this.j.get(C.templateId);if(!_)throw new a.BugIndicatingError("Missing renderer for templateId: "+C.templateId);return _.renderElement(C.element,c,D.templateData,void 0),C.size=D.domNode.offsetHeight,_.disposeElement?.(C.element,c,D.templateData,void 0),this.P.setDynamicHeight?.(C.element,C.size),C.lastDynamicHeightWidth=this.n,this.o.removeChild(D.domNode),this.h.release(D),C.size-p}ub(c){const C=c[c.length-1];if(!C)return null;const p=this.d[C.end];return!p||!p.row?null:p.row.domNode}getElementDomId(c){return`${this.domId}_${c}`}dispose(){if(this.d){for(const c of this.d)if(c.row){const C=this.j.get(c.row.templateId);C&&(C.disposeElement?.(c.element,-1,c.row.templateData,void 0),C.disposeTemplate(c.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,M.dispose)(this.L)}}L.c=0,qe([m.memoize],L.prototype,"onMouseClick",null),qe([m.memoize],L.prototype,"onMouseDblClick",null),qe([m.memoize],L.prototype,"onMouseMiddleClick",null),qe([m.memoize],L.prototype,"onMouseUp",null),qe([m.memoize],L.prototype,"onMouseDown",null),qe([m.memoize],L.prototype,"onMouseOver",null),qe([m.memoize],L.prototype,"onMouseMove",null),qe([m.memoize],L.prototype,"onMouseOut",null),qe([m.memoize],L.prototype,"onContextMenu",null),qe([m.memoize],L.prototype,"onTouchStart",null),qe([m.memoize],L.prototype,"onTap",null),t.ListView=L}),define(be[59],pe([1,0,4,19,17,22,54,69,14,8,41,24,3,32,2,46,30,5,6,68,58,89]),function(X,t,v,i,U,H,y,w,d,m,f,M,o,n,e,s,a,l,h,r,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class b{constructor(g){this.d=g,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(g){return g}renderElement(g,R,W){const $=this.c.findIndex(Y=>Y.templateData===W);if($>=0){const Y=this.c[$];this.d.unrender(W),Y.index=R}else{const Y={index:R,templateData:W};this.c.push(Y)}this.d.renderIndex(R,W)}splice(g,R,W){const $=[];for(const Y of this.c)Y.index<g?$.push(Y):Y.index>=g+R&&$.push({index:Y.index+W-R,templateData:Y.templateData});this.c=$}renderIndexes(g){for(const{index:R,templateData:W}of this.c)g.indexOf(R)>-1&&this.d.renderIndex(R,W)}disposeTemplate(g){const R=this.c.findIndex(W=>W.templateData===g);R<0||this.c.splice(R,1)}}class A{get name(){return this.h}get renderer(){return new b(this)}constructor(g){this.h=g,this.c=0,this.d=[],this.f=[],this.g=new o.Emitter,this.onChange=this.g.event}splice(g,R,W){R=Math.max(0,Math.min(R,this.c-g));const $=W.length-R,Y=g+R,F=[...this.f.filter(z=>z<g),...W.map((z,S)=>z?S+g:-1).filter(z=>z!==-1),...this.f.filter(z=>z>=Y).map(z=>z+$)],B=this.c+$;if(this.f.length>0&&F.length===0&&B>0){const z=this.f.find(S=>S>=g)??B-1;F.push(Math.min(z,B-1))}this.renderer.splice(g,R,W.length),this.k(F,F),this.c=B}renderIndex(g,R){R.classList.toggle(this.h,this.contains(g))}unrender(g){g.classList.remove(this.h)}set(g,R){return this.k(g,[...g].sort(le),R)}k(g,R,W){const $=this.d,Y=this.f;this.d=g,this.f=R;const F=se(Y,g);return this.renderer.renderIndexes(F),this.g.fire({indexes:g,browserEvent:W}),$}get(){return this.d}contains(g){return(0,d.binarySearch)(this.f,g,le)>=0}dispose(){(0,e.dispose)(this.g)}}qe([M.memoize],A.prototype,"renderer",null);class N extends A{constructor(g){super("selected"),this.l=g}renderIndex(g,R){super.renderIndex(g,R),this.l&&(this.contains(g)?R.setAttribute("aria-selected","true"):R.setAttribute("aria-selected","false"))}}class L{constructor(g,R,W){this.c=g,this.d=R,this.f=W}splice(g,R,W){if(!this.f)return this.c.splice(g,R,W.map(()=>!1));const $=this.c.get().map(F=>this.f.getId(this.d.element(F)).toString()),Y=W.map(F=>$.indexOf(this.f.getId(F).toString())>-1);this.c.splice(g,R,Y)}}function T(E){return E.tagName==="INPUT"||E.tagName==="TEXTAREA"}t.isInputElement=T;function c(E){return E.classList.contains("monaco-editor")?!0:E.classList.contains("monaco-list")||!E.parentElement?!1:c(E.parentElement)}t.isMonacoEditor=c;function C(E){return E.tagName==="A"&&E.classList.contains("monaco-button")||E.tagName==="DIV"&&E.classList.contains("monaco-button-dropdown")?!0:E.classList.contains("monaco-list")||!E.parentElement?!1:C(E.parentElement)}t.isButton=C;class p{get f(){return this.c.add(o.Event.chain(this.c.add(new i.DomEmitter(this.h.domNode,"keydown")).event).filter(g=>!T(g.target)).map(g=>new U.StandardKeyboardEvent(g)))}constructor(g,R,W){this.g=g,this.h=R,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter($=>$.keyCode===3).on(this.k,this,this.c),this.f.filter($=>$.keyCode===16).on(this.l,this,this.c),this.f.filter($=>$.keyCode===18).on(this.o,this,this.c),this.f.filter($=>$.keyCode===11).on(this.p,this,this.c),this.f.filter($=>$.keyCode===12).on(this.q,this,this.c),this.f.filter($=>$.keyCode===9).on(this.t,this,this.c),W.multipleSelectionSupport!==!1&&this.f.filter($=>(l.isMacintosh?$.metaKey:$.ctrlKey)&&$.keyCode===31).on(this.s,this,this.d)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.d.clear(),g.multipleSelectionSupport&&this.f.filter(R=>(l.isMacintosh?R.metaKey:R.ctrlKey)&&R.keyCode===31).on(this.s,this,this.d))}k(g){g.preventDefault(),g.stopPropagation(),this.g.setSelection(this.g.getFocus(),g.browserEvent)}l(g){g.preventDefault(),g.stopPropagation(),this.g.focusPrevious(1,!1,g.browserEvent);const R=this.g.getFocus()[0];this.g.setAnchor(R),this.g.reveal(R),this.h.domNode.focus()}o(g){g.preventDefault(),g.stopPropagation(),this.g.focusNext(1,!1,g.browserEvent);const R=this.g.getFocus()[0];this.g.setAnchor(R),this.g.reveal(R),this.h.domNode.focus()}p(g){g.preventDefault(),g.stopPropagation(),this.g.focusPreviousPage(g.browserEvent);const R=this.g.getFocus()[0];this.g.setAnchor(R),this.g.reveal(R),this.h.domNode.focus()}q(g){g.preventDefault(),g.stopPropagation(),this.g.focusNextPage(g.browserEvent);const R=this.g.getFocus()[0];this.g.setAnchor(R),this.g.reveal(R),this.h.domNode.focus()}s(g){g.preventDefault(),g.stopPropagation(),this.g.setSelection((0,d.range)(this.g.length),g.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(g){this.g.getSelection().length&&(g.preventDefault(),g.stopPropagation(),this.g.setSelection([],g.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}qe([M.memoize],p.prototype,"f",null);var D;(function(E){E[E.Automatic=0]="Automatic",E[E.Trigger=1]="Trigger"})(D=t.TypeNavigationMode||(t.TypeNavigationMode={}));var _;(function(E){E[E.Idle=0]="Idle",E[E.Typing=1]="Typing"})(_||(_={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(E){return E.ctrlKey||E.metaKey||E.altKey?!1:E.keyCode>=31&&E.keyCode<=56||E.keyCode>=21&&E.keyCode<=30||E.keyCode>=93&&E.keyCode<=102||E.keyCode>=80&&E.keyCode<=90}};class V{constructor(g,R,W,$,Y){this.o=g,this.p=R,this.q=W,this.s=$,this.t=Y,this.c=!1,this.d=_.Idle,this.f=D.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(g.options)}updateOptions(g){g.typeNavigationEnabled??!0?this.u():this.v(),this.f=g.typeNavigationMode??D.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let g=!1;const R=this.k.add(o.Event.chain(this.k.add(new i.DomEmitter(this.p.domNode,"keydown")).event)).filter(Y=>!T(Y.target)).filter(()=>this.f===D.Automatic||this.g).map(Y=>new U.StandardKeyboardEvent(Y)).filter(Y=>g||this.s(Y)).filter(Y=>this.t.mightProducePrintableCharacter(Y)).forEach(Y=>v.EventHelper.stop(Y,!0)).map(Y=>Y.browserEvent.key).event,W=o.Event.debounce(R,()=>null,800,void 0,void 0,this.k);o.Event.reduce(o.Event.any(R,W),(Y,F)=>F===null?null:(Y||"")+F,void 0,this.k)(this.z,this,this.k),W(this.w,this,this.k),R(()=>g=!0,void 0,this.k),W(()=>g=!1,void 0,this.k),this.c=!0,this.g=!1}v(){!this.c||(this.k.clear(),this.c=!1,this.g=!1)}w(){const g=this.o.getFocus();if(g.length>0&&g[0]===this.h){const R=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(g[0]));R&&(0,y.alert)(R)}this.h=-1}z(g){if(!g){this.d=_.Idle,this.g=!1;return}const R=this.o.getFocus(),W=R.length>0?R[0]:0,$=this.d===_.Idle?1:0;this.d=_.Typing;for(let Y=0;Y<this.o.length;Y++){const F=(W+Y+$)%this.o.length,B=this.q.getKeyboardNavigationLabel(this.p.element(F)),z=B&&B.toString();if(typeof z>"u"||(0,n.matchesPrefix)(g,z)){this.h=W,this.o.setFocus([F]),this.o.reveal(F);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ge{constructor(g,R){this.d=g,this.f=R,this.c=new e.DisposableStore,this.c.add(o.Event.chain(this.c.add(new i.DomEmitter(R.domNode,"keydown")).event)).filter($=>!T($.target)).map($=>new U.StandardKeyboardEvent($)).filter($=>$.keyCode===2&&!$.ctrlKey&&!$.metaKey&&!$.shiftKey&&!$.altKey).on(this.g,this,this.c)}g(g){if(g.target!==this.f.domNode)return;const R=this.d.getFocus();if(R.length===0)return;const W=this.f.domElement(R[0]);if(!W)return;const $=W.querySelector("[tabIndex]");if(!$||!($ instanceof HTMLElement)||$.tabIndex===-1)return;const Y=window.getComputedStyle($);Y.visibility==="hidden"||Y.display==="none"||(g.preventDefault(),g.stopPropagation(),$.focus())}dispose(){this.c.dispose()}}function Z(E){return l.isMacintosh?E.browserEvent.metaKey:E.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Z;function ie(E){return E.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ie;function te(E){return E instanceof MouseEvent&&E.button===2}const he={isSelectionSingleChangeEvent:Z,isSelectionRangeChangeEvent:ie};class re{constructor(g){this.k=g,this.f=new e.DisposableStore,this.g=new o.Emitter,this.onPointer=this.g.event,g.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||he),this.d=typeof g.options.mouseSupport>"u"||!!g.options.mouseSupport,this.d&&(g.onMouseDown(this.s,this,this.f),g.onContextMenu(this.t,this,this.f),g.onMouseDblClick(this.v,this,this.f),g.onTouchStart(this.s,this,this.f),this.f.add(H.Gesture.addTarget(g.getHTMLElement()))),o.Event.any(g.onMouseClick,g.onMouseMiddleClick,g.onTap)(this.u,this,this.f)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.c=void 0,g.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||he))}o(g){return this.c?this.c.isSelectionSingleChangeEvent(g):!1}p(g){return this.c?this.c.isSelectionRangeChangeEvent(g):!1}q(g){return this.o(g)||this.p(g)}s(g){c(g.browserEvent.target)||document.activeElement!==g.browserEvent.target&&this.k.domFocus()}t(g){if(c(g.browserEvent.target))return;const R=typeof g.index>"u"?[]:[g.index];this.k.setFocus(R,g.browserEvent)}u(g){if(!this.d||T(g.browserEvent.target)||c(g.browserEvent.target))return;const R=g.index;if(typeof R>"u"){this.k.setFocus([],g.browserEvent),this.k.setSelection([],g.browserEvent),this.k.setAnchor(void 0);return}if(this.p(g))return this.w(g);if(this.q(g))return this.w(g);this.k.setFocus([R],g.browserEvent),this.k.setAnchor(R),te(g.browserEvent)||this.k.setSelection([R],g.browserEvent),this.g.fire(g)}v(g){if(T(g.browserEvent.target)||c(g.browserEvent.target)||this.q(g))return;const R=this.k.getFocus();this.k.setSelection(R,g.browserEvent)}w(g){const R=g.index;let W=this.k.getAnchor();if(this.p(g)){typeof W>"u"&&(W=this.k.getFocus()[0]??R,this.k.setAnchor(W));const $=Math.min(W,R),Y=Math.max(W,R),F=(0,d.range)($,Y+1),B=this.k.getSelection(),z=De(se(B,[W]),W);if(z.length===0)return;const S=se(F,Q(B,z));this.k.setSelection(S,g.browserEvent),this.k.setFocus([R],g.browserEvent)}else if(this.o(g)){const $=this.k.getSelection(),Y=$.filter(F=>F!==R);this.k.setFocus([R]),this.k.setAnchor(R),$.length===Y.length?this.k.setSelection([...Y,R],g.browserEvent):this.k.setSelection(Y,g.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=re;class ce{constructor(g,R){this.c=g,this.d=R}style(g){const R=this.d&&`.${this.d}`,W=[];g.listBackground&&(g.listBackground.isOpaque()?W.push(`.monaco-list${R} .monaco-list-rows { background: ${g.listBackground}; }`):l.isMacintosh||console.warn(`List with id '${this.d}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),g.listFocusBackground&&(W.push(`.monaco-list${R}:focus .monaco-list-row.focused { background-color: ${g.listFocusBackground}; }`),W.push(`.monaco-list${R}:focus .monaco-list-row.focused:hover { background-color: ${g.listFocusBackground}; }`)),g.listFocusForeground&&W.push(`.monaco-list${R}:focus .monaco-list-row.focused { color: ${g.listFocusForeground}; }`),g.listActiveSelectionBackground&&(W.push(`.monaco-list${R}:focus .monaco-list-row.selected { background-color: ${g.listActiveSelectionBackground}; }`),W.push(`.monaco-list${R}:focus .monaco-list-row.selected:hover { background-color: ${g.listActiveSelectionBackground}; }`)),g.listActiveSelectionForeground&&W.push(`.monaco-list${R}:focus .monaco-list-row.selected { color: ${g.listActiveSelectionForeground}; }`),g.listActiveSelectionIconForeground&&W.push(`.monaco-list${R}:focus .monaco-list-row.selected .codicon { color: ${g.listActiveSelectionIconForeground}; }`),g.listFocusAndSelectionOutline&&W.push(`.monaco-list${R}:focus .monaco-list-row.selected { outline-color: ${g.listFocusAndSelectionOutline} !important; }`),g.listFocusAndSelectionBackground&&W.push(`
				.monaco-drag-image,
				.monaco-list${R}:focus .monaco-list-row.selected.focused { background-color: ${g.listFocusAndSelectionBackground}; }
			`),g.listFocusAndSelectionForeground&&W.push(`
				.monaco-drag-image,
				.monaco-list${R}:focus .monaco-list-row.selected.focused { color: ${g.listFocusAndSelectionForeground}; }
			`),g.listInactiveFocusForeground&&(W.push(`.monaco-list${R} .monaco-list-row.focused { color:  ${g.listInactiveFocusForeground}; }`),W.push(`.monaco-list${R} .monaco-list-row.focused:hover { color:  ${g.listInactiveFocusForeground}; }`)),g.listInactiveSelectionIconForeground&&W.push(`.monaco-list${R} .monaco-list-row.focused .codicon { color:  ${g.listInactiveSelectionIconForeground}; }`),g.listInactiveFocusBackground&&(W.push(`.monaco-list${R} .monaco-list-row.focused { background-color:  ${g.listInactiveFocusBackground}; }`),W.push(`.monaco-list${R} .monaco-list-row.focused:hover { background-color:  ${g.listInactiveFocusBackground}; }`)),g.listInactiveSelectionBackground&&(W.push(`.monaco-list${R} .monaco-list-row.selected { background-color:  ${g.listInactiveSelectionBackground}; }`),W.push(`.monaco-list${R} .monaco-list-row.selected:hover { background-color:  ${g.listInactiveSelectionBackground}; }`)),g.listInactiveSelectionForeground&&W.push(`.monaco-list${R} .monaco-list-row.selected { color: ${g.listInactiveSelectionForeground}; }`),g.listHoverBackground&&W.push(`.monaco-list${R}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${g.listHoverBackground}; }`),g.listHoverForeground&&W.push(`.monaco-list${R}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${g.listHoverForeground}; }`),g.listSelectionOutline&&W.push(`.monaco-list${R} .monaco-list-row.selected { outline: 1px dotted ${g.listSelectionOutline}; outline-offset: -1px; }`),g.listFocusOutline&&W.push(`
				.monaco-drag-image,
				.monaco-list${R}:focus .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${R}.last-focused .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
			`),g.listInactiveFocusOutline&&W.push(`.monaco-list${R} .monaco-list-row.focused { outline: 1px dotted ${g.listInactiveFocusOutline}; outline-offset: -1px; }`),g.listHoverOutline&&W.push(`.monaco-list${R} .monaco-list-row:hover { outline: 1px dashed ${g.listHoverOutline}; outline-offset: -1px; }`),g.listDropBackground&&W.push(`
				.monaco-list${R}.drop-target,
				.monaco-list${R} .monaco-list-rows.drop-target,
				.monaco-list${R} .monaco-list-row.drop-target { background-color: ${g.listDropBackground} !important; color: inherit !important; }
			`),g.tableColumnsBorder&&W.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${g.tableColumnsBorder};
			}`),g.tableOddRowsBackgroundColor&&W.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${g.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=W.join(`
`)}}t.DefaultStyleController=ce;const Se={listFocusBackground:f.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:f.Color.fromHex("#0E639C"),listActiveSelectionForeground:f.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:f.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:f.Color.fromHex("#094771"),listFocusAndSelectionForeground:f.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:f.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listHoverBackground:f.Color.fromHex("#2A2D2E"),listDropBackground:f.Color.fromHex("#383B3D"),treeIndentGuidesStroke:f.Color.fromHex("#a9a9a9"),tableColumnsBorder:f.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:f.Color.fromHex("#cccccc").transparent(.04)},x={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function De(E,g){const R=E.indexOf(g);if(R===-1)return[];const W=[];let $=R-1;for(;$>=0&&E[$]===g-(R-$);)W.push(E[$--]);for(W.reverse(),$=R;$<E.length&&E[$]===g+($-R);)W.push(E[$++]);return W}function se(E,g){const R=[];let W=0,$=0;for(;W<E.length||$<g.length;)if(W>=E.length)R.push(g[$++]);else if($>=g.length)R.push(E[W++]);else if(E[W]===g[$]){R.push(E[W]),W++,$++;continue}else E[W]<g[$]?R.push(E[W++]):R.push(g[$++]);return R}function Q(E,g){const R=[];let W=0,$=0;for(;W<E.length||$<g.length;)if(W>=E.length)R.push(g[$++]);else if($>=g.length)R.push(E[W++]);else if(E[W]===g[$]){W++,$++;continue}else E[W]<g[$]?R.push(E[W++]):$++;return R}const le=(E,g)=>E-g;class de{constructor(g,R){this.c=g,this.d=R}get templateId(){return this.c}renderTemplate(g){return this.d.map(R=>R.renderTemplate(g))}renderElement(g,R,W,$){let Y=0;for(const F of this.d)F.renderElement(g,R,W[Y++],$)}disposeElement(g,R,W,$){let Y=0;for(const F of this.d)F.disposeElement?.(g,R,W[Y],$),Y+=1}disposeTemplate(g){let R=0;for(const W of this.d)W.disposeTemplate(g[R++])}}class me{constructor(g){this.c=g,this.templateId="a18n"}renderTemplate(g){return g}renderElement(g,R,W){const $=this.c.getAriaLabel(g);$?W.setAttribute("aria-label",$):W.removeAttribute("aria-label");const Y=this.c.getAriaLevel&&this.c.getAriaLevel(g);typeof Y=="number"?W.setAttribute("aria-level",`${Y}`):W.removeAttribute("aria-level")}disposeTemplate(g){}}class ee{constructor(g,R){this.c=g,this.d=R}getDragElements(g){const R=this.c.getSelectedElements();return R.indexOf(g)>-1?R:[g]}getDragURI(g){return this.d.getDragURI(g)}getDragLabel(g,R){if(this.d.getDragLabel)return this.d.getDragLabel(g,R)}onDragStart(g,R){this.d.onDragStart?.(g,R)}onDragOver(g,R,W,$){return this.d.onDragOver(g,R,W,$)}onDragLeave(g,R,W,$){this.d.onDragLeave?.(g,R,W,$)}onDragEnd(g){this.d.onDragEnd?.(g)}drop(g,R,W,$){this.d.drop(g,R,W,$)}}class k{get onDidChangeFocus(){return o.Event.map(this.g.wrapEvent(this.c.onChange),g=>this.H(g),this.A)}get onDidChangeSelection(){return o.Event.map(this.g.wrapEvent(this.d.onChange),g=>this.H(g),this.A)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let g=!1;const R=this.A.add(o.Event.chain(this.A.add(new i.DomEmitter(this.k.domNode,"keydown")).event)).map(Y=>new U.StandardKeyboardEvent(Y)).filter(Y=>g=Y.keyCode===58||Y.shiftKey&&Y.keyCode===68).map(Y=>v.EventHelper.stop(Y,!0)).filter(()=>!1).event,W=this.A.add(o.Event.chain(this.A.add(new i.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>g=!1).map(Y=>new U.StandardKeyboardEvent(Y)).filter(Y=>Y.keyCode===58||Y.shiftKey&&Y.keyCode===68).map(Y=>v.EventHelper.stop(Y,!0)).map(({browserEvent:Y})=>{const F=this.getFocus(),B=F.length?F[0]:void 0,z=typeof B<"u"?this.k.element(B):void 0,S=typeof B<"u"?this.k.domElement(B):this.k.domNode;return{index:B,element:z,anchor:S,browserEvent:Y}}).event,$=this.A.add(o.Event.chain(this.k.onContextMenu)).filter(Y=>!g).map(({element:Y,index:F,browserEvent:B})=>({element:Y,index:F,anchor:{x:B.pageX+1,y:B.pageY},browserEvent:B})).event;return o.Event.any(R,W,$)}get onKeyDown(){return this.A.add(new i.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.A.add(new i.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.A.add(new i.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.A.add(new i.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.A.add(new i.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(g,R,W,$,Y=x){this.C=g,this.D=Y,this.c=new A("focused"),this.f=new A("anchor"),this.g=new o.EventBufferer,this.z="",this.A=new e.DisposableStore,this.B=new o.Emitter,this.onDidDispose=this.B.event;const F=this.D.accessibilityProvider&&this.D.accessibilityProvider.getWidgetRole?this.D.accessibilityProvider?.getWidgetRole():"list";this.d=new N(F!=="listbox"),(0,a.mixin)(Y,Se,!1);const B=[this.c.renderer,this.d.renderer];this.u=Y.accessibilityProvider,this.u&&(B.push(new me(this.u)),this.u.onDidChangeActiveDescendant?.(this.J,this,this.A)),$=$.map(S=>new de(S.templateId,[...B,S]));const z={...Y,dnd:Y.dnd&&new ee(this,Y.dnd)};if(this.k=new u.ListView(R,W,$,z),this.k.domNode.setAttribute("role",F),Y.styleController)this.q=Y.styleController(this.k.domId);else{const S=(0,v.createStyleSheet)(this.k.domNode);this.q=new ce(S,this.k.domId)}if(this.o=new w.CombinedSpliceable([new L(this.c,this.k,Y.identityProvider),new L(this.d,this.k,Y.identityProvider),new L(this.f,this.k,Y.identityProvider),this.k]),this.A.add(this.c),this.A.add(this.d),this.A.add(this.f),this.A.add(this.k),this.A.add(this.B),this.A.add(new ge(this,this.k)),(typeof Y.keyboardSupport!="boolean"||Y.keyboardSupport)&&(this.v=new p(this,this.k,Y),this.A.add(this.v)),Y.keyboardNavigationLabelProvider){const S=Y.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new V(this,this.k,Y.keyboardNavigationLabelProvider,Y.keyboardNavigationEventFilter??(()=>!0),S),this.A.add(this.t)}this.w=this.E(Y),this.A.add(this.w),this.onDidChangeFocus(this.I,this,this.A),this.onDidChangeSelection(this.K,this,this.A),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.D.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}E(g){return new re(this)}updateOptions(g={}){this.D={...this.D,...g},this.t?.updateOptions(this.D),this.D.multipleSelectionController!==void 0&&(this.D.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(g),this.v?.updateOptions(g),this.k.updateOptions(g)}get options(){return this.D}splice(g,R,W=[]){if(g<0||g>this.k.length)throw new r.ListError(this.C,`Invalid start index: ${g}`);if(R<0)throw new r.ListError(this.C,`Invalid delete count: ${R}`);R===0&&W.length===0||this.g.bufferEvents(()=>this.o.splice(g,R,W))}updateWidth(g){this.k.updateWidth(g)}updateElementHeight(g,R){this.k.updateElementHeight(g,R,null)}rerender(){this.k.rerender()}element(g){return this.k.element(g)}indexOf(g){return this.k.indexOf(g)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get scrollTop(){return this.k.getScrollTop()}set scrollTop(g){this.k.setScrollTop(g)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(g){this.k.setScrollLeft(g)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.z}set ariaLabel(g){this.z=g,this.k.domNode.setAttribute("aria-label",g)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(g,R){this.k.layout(g,R)}triggerTypeNavigation(){this.t?.trigger()}setSelection(g,R){for(const W of g)if(W<0||W>=this.length)throw new r.ListError(this.C,`Invalid index ${W}`);this.d.set(g,R)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(g=>this.k.element(g))}setAnchor(g){if(typeof g>"u"){this.f.set([]);return}if(g<0||g>=this.length)throw new r.ListError(this.C,`Invalid index ${g}`);this.f.set([g])}getAnchor(){return(0,d.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const g=this.getAnchor();return typeof g>"u"?void 0:this.element(g)}setFocus(g,R){for(const W of g)if(W<0||W>=this.length)throw new r.ListError(this.C,`Invalid index ${W}`);this.c.set(g,R)}focusNext(g=1,R=!1,W,$){if(this.length===0)return;const Y=this.c.get(),F=this.F(Y.length>0?Y[0]+g:0,R,$);F>-1&&this.setFocus([F],W)}focusPrevious(g=1,R=!1,W,$){if(this.length===0)return;const Y=this.c.get(),F=this.G(Y.length>0?Y[0]-g:0,R,$);F>-1&&this.setFocus([F],W)}async focusNextPage(g,R){let W=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);W=W===0?0:W-1;const $=this.getFocus()[0];if($!==W&&($===void 0||W>$)){const Y=this.G(W,!1,R);Y>-1&&$!==Y?this.setFocus([Y],g):this.setFocus([W],g)}else{const Y=this.k.getScrollTop();let F=Y+this.k.renderHeight;W>$&&(F-=this.k.elementHeight(W)),this.k.setScrollTop(F),this.k.getScrollTop()!==Y&&(this.setFocus([]),await(0,m.timeout)(0),await this.focusNextPage(g,R))}}async focusPreviousPage(g,R){let W;const $=this.k.getScrollTop();$===0?W=this.k.indexAt($):W=this.k.indexAfter($-1);const Y=this.getFocus()[0];if(Y!==W&&(Y===void 0||Y>=W)){const F=this.F(W,!1,R);F>-1&&Y!==F?this.setFocus([F],g):this.setFocus([W],g)}else{const F=$;this.k.setScrollTop($-this.k.renderHeight),this.k.getScrollTop()!==F&&(this.setFocus([]),await(0,m.timeout)(0),await this.focusPreviousPage(g,R))}}focusLast(g,R){if(this.length===0)return;const W=this.G(this.length-1,!1,R);W>-1&&this.setFocus([W],g)}focusFirst(g,R){this.focusNth(0,g,R)}focusNth(g,R,W){if(this.length===0)return;const $=this.F(g,!1,W);$>-1&&this.setFocus([$],R)}F(g,R=!1,W){for(let $=0;$<this.length;$++){if(g>=this.length&&!R)return-1;if(g=g%this.length,!W||W(this.element(g)))return g;g++}return-1}G(g,R=!1,W){for(let $=0;$<this.length;$++){if(g<0&&!R)return-1;if(g=(this.length+g%this.length)%this.length,!W||W(this.element(g)))return g;g--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(g=>this.k.element(g))}reveal(g,R){if(g<0||g>=this.length)throw new r.ListError(this.C,`Invalid index ${g}`);const W=this.k.getScrollTop(),$=this.k.elementTop(g),Y=this.k.elementHeight(g);if((0,h.isNumber)(R)){const F=Y-this.k.renderHeight;this.k.setScrollTop(F*(0,s.clamp)(R,0,1)+$)}else{const F=$+Y,B=W+this.k.renderHeight;$<W&&F>=B||($<W||F>=B&&Y>=this.k.renderHeight?this.k.setScrollTop($):F>=B&&this.k.setScrollTop(F-this.k.renderHeight))}}getRelativeTop(g){if(g<0||g>=this.length)throw new r.ListError(this.C,`Invalid index ${g}`);const R=this.k.getScrollTop(),W=this.k.elementTop(g),$=this.k.elementHeight(g);if(W<R||W+$>R+this.k.renderHeight)return null;const Y=$-this.k.renderHeight;return Math.abs((R-W)/Y)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(g){return this.k.getElementDomId(g)}style(g){this.q.style(g)}H({indexes:g,browserEvent:R}){return{indexes:g,elements:g.map(W=>this.k.element(W)),browserEvent:R}}I(){const g=this.c.get();this.k.domNode.classList.toggle("element-focused",g.length>0),this.J()}J(){const g=this.c.get();if(g.length>0){let R;this.u?.getActiveDescendantId&&(R=this.u.getActiveDescendantId(this.k.element(g[0]))),this.k.domNode.setAttribute("aria-activedescendant",R||this.k.getElementDomId(g[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}K(){const g=this.d.get();this.k.domNode.classList.toggle("selection-none",g.length===0),this.k.domNode.classList.toggle("selection-single",g.length===1),this.k.domNode.classList.toggle("selection-multiple",g.length>1)}dispose(){this.B.fire(),this.A.dispose(),this.B.dispose()}}qe([M.memoize],k.prototype,"onDidChangeFocus",null),qe([M.memoize],k.prototype,"onDidChangeSelection",null),qe([M.memoize],k.prototype,"onContextMenu",null),qe([M.memoize],k.prototype,"onKeyDown",null),qe([M.memoize],k.prototype,"onKeyUp",null),qe([M.memoize],k.prototype,"onKeyPress",null),qe([M.memoize],k.prototype,"onDidFocus",null),qe([M.memoize],k.prototype,"onDidBlur",null),t.List=k}),define(be[60],pe([1,0,9,33,35,11,15]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(w=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class d{constructor(l="",h=!1){if(this.value=l,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(l,h=0){return this.value+=o(this.supportThemeIcons?(0,i.escapeIcons)(l):l).replace(/([ \t]+)/g,(r,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,h){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(l,h,r){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(l),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(l,h){const r=new RegExp((0,H.escapeRegExpCharacters)(h),"g");return l.replace(r,(u,b)=>l.charAt(b-1)!=="\\"?`\\${u}`:u)}}t.MarkdownString=d;function m(a){return f(a)?!a.value:Array.isArray(a)?a.every(m):!0}t.isEmptyMarkdownString=m;function f(a){return a instanceof d?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}t.isMarkdownString=f;function M(a,l){return a===l?!0:!a||!l?!1:a.value===l.value&&a.isTrusted===l.isTrusted&&a.supportThemeIcons===l.supportThemeIcons&&a.supportHtml===l.supportHtml&&(a.baseUri===l.baseUri||!!a.baseUri&&!!l.baseUri&&(0,U.isEqual)(y.URI.from(a.baseUri),y.URI.from(l.baseUri)))}t.markdownStringEqual=M;function o(a){return a.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=o;function n(a){return a.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=n;function e(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function s(a){const l=[],h=a.split("|").map(u=>u.trim());a=h[0];const r=h[1];if(r){const u=/height=(\d+)/.exec(r),b=/width=(\d+)/.exec(r),A=u?u[1]:"",N=b?b[1]:"",L=isFinite(parseInt(N)),T=isFinite(parseInt(A));L&&l.push(`width="${N}"`),T&&l.push(`height="${A}"`)}return{href:a,dimensions:l}}t.parseHrefAndDimensions=s}),define(be[122],pe([1,0,4,114,19,52,17,20,115,9,3,60,33,73,44,2,76,50,34,30,35,11,15]),function(X,t,v,i,U,H,y,w,d,m,f,M,o,n,e,s,a,l,h,r,u,b,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const N=Object.freeze({image:(Z,ie,te)=>{let he=[],re=[];return Z&&({href:Z,dimensions:he}=(0,M.parseHrefAndDimensions)(Z),re.push(`src="${(0,M.escapeDoubleQuotes)(Z)}"`)),te&&re.push(`alt="${(0,M.escapeDoubleQuotes)(te)}"`),ie&&re.push(`title="${(0,M.escapeDoubleQuotes)(ie)}"`),he.length&&(re=re.concat(he)),"<img "+re.join(" ")+">"},paragraph:Z=>`<p>${Z}</p>`,link:(Z,ie,te)=>typeof Z!="string"?"":(Z===te&&(te=(0,M.removeMarkdownEscapes)(te)),ie=typeof ie=="string"?(0,M.escapeDoubleQuotes)((0,M.removeMarkdownEscapes)(ie)):"",Z=(0,M.removeMarkdownEscapes)(Z),Z=Z.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Z}" title="${ie||Z}">${te}</a>`)});function L(Z,ie={},te={}){const he=new s.DisposableStore;let re=!1;const ce=(0,H.createElement)(ie),Se=function(ee){let k;try{k=(0,l.parse)(decodeURIComponent(ee))}catch{}return k?(k=(0,r.cloneAndChange)(k,E=>{if(Z.uris&&Z.uris[E])return A.URI.revive(Z.uris[E])}),encodeURIComponent(JSON.stringify(k))):ee},x=function(ee,k){const E=Z.uris&&Z.uris[ee];let g=A.URI.revive(E);return k?ee.startsWith(h.Schemas.data+":")?ee:(g||(g=A.URI.parse(ee)),h.FileAccess.uriToBrowserUri(g).toString(!0)):!g||A.URI.parse(ee).toString()===g.toString()?ee:(g.query&&(g=g.with({query:Se(g.query)})),g.toString())},De=new a.marked.Renderer;De.image=N.image,De.link=N.link,De.paragraph=N.paragraph;const se=[];if(ie.codeBlockRenderer&&(De.code=(ee,k)=>{const E=n.defaultGenerator.nextId(),g=ie.codeBlockRenderer(T(k),ee);return se.push(g.then(R=>[E,R])),`<div class="code" data-code="${E}">${(0,b.escape)(ee)}</div>`}),ie.actionHandler){const ee=function(g){let R=g.target;if(!(R.tagName!=="A"&&(R=R.parentElement,!R||R.tagName!=="A")))try{let W=R.dataset.href;W&&(Z.baseUri&&(W=c(A.URI.from(Z.baseUri),W)),ie.actionHandler.callback(W,g))}catch(W){(0,m.onUnexpectedError)(W)}finally{g.preventDefault()}},k=ie.actionHandler.disposables.add(new U.DomEmitter(ce,"click")),E=ie.actionHandler.disposables.add(new U.DomEmitter(ce,"auxclick"));ie.actionHandler.disposables.add(f.Event.any(k.event,E.event)(g=>{const R=new w.StandardMouseEvent(g);!R.leftButton&&!R.middleButton||ee(R)})),ie.actionHandler.disposables.add(v.addDisposableListener(ce,"keydown",g=>{const R=new y.StandardKeyboardEvent(g);!R.equals(10)&&!R.equals(3)||ee(R)}))}Z.supportHtml||(te.sanitizer=ee=>(Z.isTrusted?ee.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?ee:"",te.sanitize=!0,te.silent=!0),te.renderer=De;let Q=Z.value??"";Q.length>1e5&&(Q=`${Q.substr(0,1e5)}\u2026`),Z.supportThemeIcons&&(Q=(0,o.markdownEscapeEscapedIcons)(Q));let le=a.marked.parse(Q,te);Z.supportThemeIcons&&(le=(0,d.renderLabelWithIcons)(le).map(k=>typeof k=="string"?k:k.outerHTML).join(""));const me=new DOMParser().parseFromString(C(Z,le),"text/html");if(me.body.querySelectorAll("img").forEach(ee=>{const k=ee.getAttribute("src");if(k){let E=k;try{Z.baseUri&&(E=c(A.URI.from(Z.baseUri),E))}catch{}ee.src=x(E,!0)}}),me.body.querySelectorAll("a").forEach(ee=>{const k=ee.getAttribute("href");if(ee.setAttribute("href",""),!k||/^data:|javascript:/i.test(k)||/^command:/i.test(k)&&!Z.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(k))ee.replaceWith(...ee.childNodes);else{let E=x(k,!1);Z.baseUri&&(E=c(A.URI.from(Z.baseUri),k)),ee.dataset.href=E}}),ce.innerHTML=C(Z,me.body.innerHTML),se.length>0&&Promise.all(se).then(ee=>{if(re)return;const k=new Map(ee),E=ce.querySelectorAll("div[data-code]");for(const g of E){const R=k.get(g.dataset.code??"");R&&v.reset(g,R)}ie.asyncRenderCallback?.()}),ie.asyncRenderCallback)for(const ee of ce.getElementsByTagName("img")){const k=he.add(v.addDisposableListener(ee,"load",()=>{k.dispose(),ie.asyncRenderCallback()}))}return{element:ce,dispose:()=>{re=!0,he.dispose()}}}t.renderMarkdown=L;function T(Z){if(!Z)return"";const ie=Z.split(/[\s+|:|,|\{|\?]/,1);return ie.length?ie[0]:Z}function c(Z,ie){return/^\w[\w\d+.-]*:/.test(ie)?ie:Z.path.endsWith("/")?(0,u.resolvePath)(Z,ie).toString():(0,u.resolvePath)((0,u.dirname)(Z),ie).toString()}function C(Z,ie){const{config:te,allowedSchemes:he}=p(Z);i.addHook("uponSanitizeAttribute",(ce,Se)=>{if(Se.attrName==="style"||Se.attrName==="class"){if(ce.tagName==="SPAN"){if(Se.attrName==="style"){Se.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(Se.attrValue);return}else if(Se.attrName==="class"){Se.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Se.attrValue);return}}Se.keepAttr=!1;return}});const re=v.hookDomPurifyHrefAndSrcSanitizer(he);try{return i.sanitize(ie,{...te,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),re.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width"];function p(Z){const ie=[h.Schemas.http,h.Schemas.https,h.Schemas.mailto,h.Schemas.data,h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemote,h.Schemas.vscodeRemoteResource];return Z.isTrusted&&ie.push(h.Schemas.command),{config:{ALLOWED_TAGS:[...v.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ie}}function D(Z){return typeof Z=="string"?Z:_(Z)}t.renderStringAsPlaintext=D;function _(Z){let ie=Z.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`);const te=a.marked.parse(ie,{renderer:ge.getValue()}).replace(/&(#\d+|[a-zA-Z]+);/g,he=>V.get(he)??he);return C({isTrusted:!1},te).toString()}t.renderMarkdownAsPlaintext=_;const V=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),ge=new e.Lazy(()=>{const Z=new a.marked.Renderer;return Z.code=ie=>ie,Z.blockquote=ie=>ie,Z.html=ie=>"",Z.heading=(ie,te,he)=>ie+`
`,Z.hr=()=>"",Z.list=(ie,te)=>ie,Z.listitem=ie=>ie+`
`,Z.paragraph=ie=>ie+`
`,Z.table=(ie,te)=>ie+te+`
`,Z.tablerow=ie=>ie,Z.tablecell=(ie,te)=>ie+" ",Z.strong=ie=>ie,Z.em=ie=>ie,Z.codespan=ie=>ie,Z.br=()=>`
`,Z.del=ie=>ie,Z.image=(ie,te,he)=>"",Z.text=ie=>ie,Z.link=(ie,te,he)=>he,Z})}),define(be[123],pe([1,0,4,8,26,60,33,2,6,99]),function(X,t,v,i,U,H,y,w,d,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function f(n,e){(0,d.isString)(e)?n.title=(0,y.stripIcons)(e):e?.markdownNotSupportedFallback?n.title=e.markdownNotSupportedFallback:n.removeAttribute("title")}t.setupNativeHover=f;class M{constructor(e,s,a){this.c=e,this.d=s,this.f=a}async update(e,s,a){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let l;if(e===void 0||(0,d.isString)(e)||e instanceof HTMLElement)l=e;else if(!(0,d.isFunction)(e.markdown))l=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,m.localize)(0,null),s),this.b=new U.CancellationTokenSource;const h=this.b.token;if(l=await e.markdown(h),l===void 0&&(l=e.markdownNotSupportedFallback),this.isDisposed||h.isCancellationRequested)return}this.g(l,s,a)}g(e,s,a){const l=this.a;if(this.h(e)){const h={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!l,...a};this.a=this.c.showHover(h,s)}l?.dispose()}h(e){return e?(0,H.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function o(n,e,s,a){let l,h;const r=(L,T)=>{L&&(h?.dispose(),h=void 0),T&&(l?.dispose(),l=void 0),n.onDidHideHover?.()},u=(L,T,c)=>new i.TimeoutTimer(async()=>{(!h||h.isDisposed)&&(h=new M(n,c||e,L>0),await h.update(s,T,a))},L),b=()=>{if(l)return;const L=new w.DisposableStore,T=p=>r(!1,p.fromElement===e);L.add(v.addDisposableListener(e,v.EventType.MOUSE_LEAVE,T,!0));const c=()=>r(!0,!0);L.add(v.addDisposableListener(e,v.EventType.MOUSE_DOWN,c,!0));const C={targetElements:[e],dispose:()=>{}};if(n.placement===void 0||n.placement==="mouse"){const p=D=>{C.x=D.x+10,D.target instanceof HTMLElement&&D.target.classList.contains("action-label")&&r(!0,!0)};L.add(v.addDisposableListener(e,v.EventType.MOUSE_MOVE,p,!0))}L.add(u(n.delay,!1,C)),l=L},A=v.addDisposableListener(e,v.EventType.MOUSE_OVER,b,!0);return{show:L=>{r(!1,!0),u(0,L)},hide:()=>{r(!0,!0)},update:async(L,T)=>{s=L,await h?.update(s,void 0,T)},dispose:()=>{A.dispose(),r(!0,!0)}}}t.setupCustomHover=o}),define(be[124],pe([1,0,4,19,17,122,59,14,3,43,2,5,101,92]),function(X,t,v,i,U,H,y,w,d,m,f,M,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const n=v.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(h){const r=Object.create(null);return r.root=h,r.text=v.append(h,n(".option-text")),r.detail=v.append(h,n(".option-detail")),r.decoratorRight=v.append(h,n(".option-decorator-right")),r}renderElement(h,r,u){const b=u,A=h.text,N=h.detail,L=h.decoratorRight,T=h.isDisabled;b.text.textContent=A,b.detail.textContent=N||"",b.decoratorRight.innerText=L||"",T?b.root.classList.add("option-disabled"):b.root.classList.remove("option-disabled")}disposeTemplate(h){}}class a extends f.Disposable{constructor(h,r,u,b,A){super(),this.k=[],this.y=0,this.C=!1,this.F=!1,this.G=!1,this.f=!1,this.g=A||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=a.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new d.Emitter,this.B(this.m),this.n=b,this.I(),this.H(u),this.l=r||0,h&&this.setOptions(h,r)}getHeight(){return 18}getTemplateId(){return e}H(h){this.r=h,this.s=v.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.D=v.append(this.s,n(".select-box-details-pane"));const r=v.append(this.s,n(".select-box-dropdown-container-width-control")),u=v.append(r,n(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",v.append(u,this.w),this.z=0,this.t=v.createStyleSheet(this.s),this.s.setAttribute("draggable","true"),this.B(v.addDisposableListener(this.s,v.EventType.DRAG_START,b=>{v.EventHelper.stop(b,!0)}))}I(){this.B(v.addStandardDisposableListener(this.h,"change",r=>{this.l=r.target.selectedIndex,this.m.fire({index:r.target.selectedIndex,selected:r.target.value}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(v.addDisposableListener(this.h,v.EventType.CLICK,r=>{v.EventHelper.stop(r),this.f?this.O(!0):this.N()})),this.B(v.addDisposableListener(this.h,v.EventType.MOUSE_DOWN,r=>{v.EventHelper.stop(r)}));let h;this.B(v.addDisposableListener(this.h,"touchstart",r=>{h=this.f})),this.B(v.addDisposableListener(this.h,"touchend",r=>{v.EventHelper.stop(r),h?this.O(!0):this.N()})),this.B(v.addDisposableListener(this.h,v.EventType.KEY_DOWN,r=>{const u=new U.StandardKeyboardEvent(r);let b=!1;M.isMacintosh?(u.keyCode===18||u.keyCode===16||u.keyCode===10||u.keyCode===3)&&(b=!0):(u.keyCode===18&&u.altKey||u.keyCode===16&&u.altKey||u.keyCode===10||u.keyCode===3)&&(b=!0),b&&(this.N(),v.EventHelper.stop(r,!0))}))}get onDidSelect(){return this.m.event}setOptions(h,r){w.equals(this.k,h)||(this.k=h,this.h.options.length=0,this.C=!1,this.k.forEach((u,b)=>{this.h.add(this.M(u.text,b,u.isDisabled)),typeof u.description=="string"&&(this.C=!0)})),r!==void 0&&(this.select(r),this.y=this.l)}J(){this.u?.splice(0,this.u.length,this.k)}select(h){h>=0&&h<this.k.length?this.l=h:h>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(h){this.g.ariaLabel=h,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(h){this.h.tabIndex=h?0:-1}render(h){this.j=h,h.classList.add("select-container"),h.appendChild(this.h),this.applyStyles()}style(h){const r=[];this.n=h,this.n.listFocusBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&!this.n.selectBorder.equals(this.n.selectBackground)?(r.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=r.join(`
`),this.applyStyles()}applyStyles(){if(this.h){const h=this.n.selectBackground?this.n.selectBackground.toString():"",r=this.n.selectForeground?this.n.selectForeground.toString():"",u=this.n.selectBorder?this.n.selectBorder.toString():"";this.h.style.backgroundColor=h,this.h.style.color=r,this.h.style.borderColor=u}this.u&&this.L()}L(){if(this.u){const h=this.n.selectBackground?this.n.selectBackground.toString():"";this.u.style({});const r=this.n.selectListBackground?this.n.selectListBackground.toString():h;this.v.style.backgroundColor=r,this.D.style.backgroundColor=r;const u=this.n.focusBorder?this.n.focusBorder.toString():"";this.s.style.outlineColor=u,this.s.style.outlineOffset="-1px"}}M(h,r,u){const b=document.createElement("option");return b.value=h,b.text=h,b.disabled=!!u,b}N(){this.D.innerText="",!(!this.r||this.f)&&(this.U(this.s),this.J(),this.r.showContextView({getAnchor:()=>this.h,render:h=>this.P(h,!0),layout:()=>{this.R()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.O(!1),this.r.showContextView({getAnchor:()=>this.h,render:h=>this.P(h),layout:()=>this.R(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}O(h){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),h&&this.h.focus(),this.r.hideContextView())}P(h,r){return h.appendChild(this.s),this.R(r),{dispose:()=>{try{h.removeChild(this.s)}catch{}}}}Q(){let h=0;return this.k.forEach((r,u)=>{this.ab(u),this.D.offsetHeight>h&&(h=this.D.offsetHeight)}),h}R(h){if(this.F)return!1;if(this.u){this.s.classList.add("visible");const r=v.getDomNodePagePosition(this.h),u=getComputedStyle(this.h),b=parseFloat(u.getPropertyValue("--dropdown-padding-top"))+parseFloat(u.getPropertyValue("--dropdown-padding-bottom")),A=window.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),N=r.top-a.b,L=this.h.offsetWidth,T=this.S(this.w),c=Math.max(T,Math.round(L)).toString()+"px";this.s.style.width=c,this.u.getHTMLElement().style.height="",this.u.layout();let C=this.u.contentHeight;const p=this.C?this.Q():0,D=C+b+p,_=Math.floor((A-b-p)/this.getHeight()),V=Math.floor((N-b-p)/this.getHeight());if(h)return r.top+r.height>window.innerHeight-22||r.top<a.b||_<1&&V<1?!1:(_<a.c&&V>_&&this.k.length>_?(this.z=1,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.D),this.s.appendChild(this.v),this.D.classList.remove("border-top"),this.D.classList.add("border-bottom")):(this.z=0,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.v),this.s.appendChild(this.D),this.D.classList.remove("border-bottom"),this.D.classList.add("border-top")),!0);if(r.top+r.height>window.innerHeight-22||r.top<a.b||this.z===0&&_<1||this.z===1&&V<1)return this.O(!0),!1;if(this.z===0){if(this.f&&_+V<1)return this.O(!0),!1;D>A&&(C=_*this.getHeight())}else D>N&&(C=V*this.getHeight());return this.u.layout(C),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.C?(this.u.getHTMLElement().style.height=C+b+"px",this.s.style.height=""):this.s.style.height=C+b+"px",this.ab(this.l),this.s.style.width=c,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}S(h){let r=0;if(h){let u=0,b=0;this.k.forEach((A,N)=>{const L=A.detail?A.detail.length:0,T=A.decoratorRight?A.decoratorRight.length:0,c=A.text.length+L+T;c>b&&(u=N,b=c)}),h.textContent=this.k[u].text+(this.k[u].decoratorRight?this.k[u].decoratorRight+" ":""),r=v.getTotalWidth(h)}return r}U(h){if(this.u)return;this.v=v.append(h,n(".select-box-dropdown-list-container")),this.p=new s,this.u=new y.List("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:b=>{let A=b.text;return b.detail&&(A+=`. ${b.detail}`),b.decoratorRight&&(A+=`. ${b.decoratorRight}`),b.description&&(A+=`. ${b.description}`),A},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const r=this.B(new i.DomEmitter(this.v,"keydown")),u=d.Event.chain(r.event).filter(()=>this.u.length>0).map(b=>new U.StandardKeyboardEvent(b));this.B(u.filter(b=>b.keyCode===3).on(b=>this.cb(b),this)),this.B(u.filter(b=>b.keyCode===2).on(b=>this.cb(b),this)),this.B(u.filter(b=>b.keyCode===9).on(b=>this.bb(b),this)),this.B(u.filter(b=>b.keyCode===16).on(b=>this.eb(b),this)),this.B(u.filter(b=>b.keyCode===18).on(b=>this.db(b),this)),this.B(u.filter(b=>b.keyCode===12).on(this.gb,this)),this.B(u.filter(b=>b.keyCode===11).on(this.fb,this)),this.B(u.filter(b=>b.keyCode===14).on(this.hb,this)),this.B(u.filter(b=>b.keyCode===13).on(this.ib,this)),this.B(u.filter(b=>b.keyCode>=21&&b.keyCode<=56||b.keyCode>=80&&b.keyCode<=108).on(this.jb,this)),this.B(v.addDisposableListener(this.u.getHTMLElement(),v.EventType.POINTER_UP,b=>this.W(b))),this.B(this.u.onMouseOver(b=>typeof b.index<"u"&&this.u.setFocus([b.index]))),this.B(this.u.onDidChangeFocus(b=>this.Z(b))),this.B(v.addDisposableListener(this.s,v.EventType.FOCUS_OUT,b=>{!this.f||v.isAncestor(b.relatedTarget,this.s)||this.X()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.L()}W(h){if(!this.u.length)return;v.EventHelper.stop(h);const r=h.target;if(!r||r.classList.contains("slider"))return;const u=r.closest(".monaco-list-row");if(!u)return;const b=Number(u.getAttribute("data-index")),A=u.classList.contains("option-disabled");b>=0&&b<this.k.length&&!A&&(this.l=b,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.O(!0))}X(){this.G||(this.l!==this.y&&this.select(this.y),this.O(!1))}Y(h,r){const u=A=>{for(let N=0;N<A.childNodes.length;N++){const L=A.childNodes.item(N);(L.tagName&&L.tagName.toLowerCase())==="img"?A.removeChild(L):u(L)}},b=(0,H.renderMarkdown)({value:h,supportThemeIcons:!0},{actionHandler:r});return b.element.classList.add("select-box-description-markdown"),u(b.element),b.element}Z(h){!this.f||!this.C||this.ab(h.indexes[0])}ab(h){this.D.innerText="";const r=this.k[h],u=r?.description??"",b=r?.descriptionIsMarkdown??!1;if(u){if(b){const A=r.descriptionMarkdownActionHandler;this.D.appendChild(this.Y(u,A))}else this.D.innerText=u;this.D.style.display="block"}else this.D.style.display="none";this.F=!0,this.r.layout(),this.F=!1}bb(h){v.EventHelper.stop(h),this.select(this.y),this.O(!0)}cb(h){v.EventHelper.stop(h),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.O(!0)}db(h){if(this.l<this.k.length-1){v.EventHelper.stop(h,!0);const r=this.k[this.l+1].isDisabled;if(r&&this.k.length>this.l+2)this.l+=2;else{if(r)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}eb(h){this.l>0&&(v.EventHelper.stop(h,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}fb(h){v.EventHelper.stop(h),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}gb(h){v.EventHelper.stop(h),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}hb(h){v.EventHelper.stop(h),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}ib(h){v.EventHelper.stop(h),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}jb(h){const r=m.KeyCodeUtils.toString(h.keyCode);let u=-1;for(let b=0;b<this.k.length-1;b++)if(u=(b+this.l+1)%this.k.length,this.k[u].text.charAt(0).toUpperCase()===r&&!this.k[u].isDisabled){this.select(u),this.u.setFocus([u]),this.u.reveal(this.u.getFocus()[0]),v.EventHelper.stop(h);break}}dispose(){this.O(!1),super.dispose()}}t.SelectBoxList=a,a.a=32,a.b=2,a.c=3}),define(be[125],pe([1,0,124,118,18,41,30,5,91]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:H.Color.fromHex("#3C3C3C"),selectForeground:H.Color.fromHex("#F0F0F0"),selectBorder:H.Color.fromHex("#3C3C3C")};class d extends U.Widget{constructor(f,M,o,n=(0,y.deepClone)(t.defaultStyles),e){super(),w.isMacintosh&&!e?.useCustomDrawn?this.a=new i.SelectBoxNative(f,M,n,e):this.a=new v.SelectBoxList(f,M,o,n,e),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,M){this.a.setOptions(f,M)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}render(f){this.a.render(f)}style(f){this.a.style(f)}applyStyles(){this.a.applyStyles()}}t.SelectBox=d}),define(be[61],pe([1,0,16,51,4,22,123,125,31,2,5,6,96,48]),function(X,t,v,i,U,H,y,w,d,m,f,M,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class n extends m.Disposable{get action(){return this._action}constructor(l,h,r={}){super(),this.k=r,this._context=l||this,this._action=h,h instanceof d.Action&&this.B(h.onDidChange(u=>{!this.element||this.m(u)}))}m(l){l.enabled!==void 0&&this.t(),l.checked!==void 0&&this.updateChecked(),l.class!==void 0&&this.updateClass(),l.label!==void 0&&(this.updateLabel(),this.w()),l.tooltip!==void 0&&this.w()}get actionRunner(){return this.j||(this.j=this.B(new d.ActionRunner)),this.j}set actionRunner(l){this.j=l}isEnabled(){return this._action.enabled}setActionContext(l){this._context=l}render(l){const h=this.element=l;this.B(H.Gesture.addTarget(l));const r=this.k&&this.k.draggable;r&&(l.draggable=!0,v.isFirefox&&this.B((0,U.addDisposableListener)(l,U.EventType.DRAG_START,u=>u.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this.B((0,U.addDisposableListener)(h,H.EventType.Tap,u=>this.onClick(u,!0))),this.B((0,U.addDisposableListener)(h,U.EventType.MOUSE_DOWN,u=>{r||U.EventHelper.stop(u,!0),this._action.enabled&&u.button===0&&h.classList.add("active")})),f.isMacintosh&&this.B((0,U.addDisposableListener)(h,U.EventType.CONTEXT_MENU,u=>{u.button===0&&u.ctrlKey===!0&&this.onClick(u)})),this.B((0,U.addDisposableListener)(h,U.EventType.CLICK,u=>{U.EventHelper.stop(u,!0),this.k&&this.k.isMenu||this.onClick(u)})),this.B((0,U.addDisposableListener)(h,U.EventType.DBLCLICK,u=>{U.EventHelper.stop(u,!0)})),[U.EventType.MOUSE_UP,U.EventType.MOUSE_OUT].forEach(u=>{this.B((0,U.addDisposableListener)(h,u,b=>{U.EventHelper.stop(b),h.classList.remove("active")}))})}onClick(l,h=!1){U.EventHelper.stop(l,!0);const r=M.isUndefinedOrNull(this._context)?this.k?.useEventAsContext?l:{preserveFocus:h}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(l){this.element&&(this.element.tabIndex=l?0:-1)}get trapsArrowNavigation(){return!1}t(){}updateLabel(){}u(){return this.action.tooltip}w(){if(!this.element)return;const l=this.u()??"";this.z(),this.k.hoverDelegate?(this.element.title="",this.f?this.f.update(l):(this.f=(0,y.setupCustomHover)(this.k.hoverDelegate,this.element,l),this.q.add(this.f))):this.element.title=l}z(){if(this.element){const l=this.u()??"";this.element.setAttribute("aria-label",l)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=n;class e extends n{constructor(l,h,r){super(l,h,r),this.k=r,this.k.icon=r.icon!==void 0?r.icon:!1,this.k.label=r.label!==void 0?r.label:!0,this.C=""}render(l){super.render(l),this.element&&(this.g=(0,U.append)(this.element,(0,U.$)("a.action-label"))),this.g&&(this._action.id===d.Separator.ID?this.g.setAttribute("role","presentation"):this.k.isMenu?this.g.setAttribute("role","menuitem"):this.g.setAttribute("role","button")),this.k.label&&this.k.keybinding&&this.element&&((0,U.append)(this.element,(0,U.$)("span.keybinding")).textContent=this.k.keybinding),this.updateClass(),this.updateLabel(),this.w(),this.t(),this.updateChecked()}focus(){this.g&&(this.g.tabIndex=0,this.g.focus())}isFocused(){return!!this.g&&this.g?.tabIndex===0}blur(){this.g&&(this.g.tabIndex=-1)}setFocusable(l){this.g&&(this.g.tabIndex=l?0:-1)}updateLabel(){this.k.label&&this.g&&(this.g.textContent=this.action.label)}u(){let l=null;return this.action.tooltip?l=this.action.tooltip:!this.k.label&&this.action.label&&this.k.icon&&(l=this.action.label,this.k.keybinding&&(l=o.localize(0,null,l,this.k.keybinding))),l??void 0}updateClass(){this.C&&this.g&&this.g.classList.remove(...this.C.split(" ")),this.k.icon?(this.C=this.action.class,this.g&&(this.g.classList.add("codicon"),this.C&&this.g.classList.add(...this.C.split(" "))),this.t()):this.g?.classList.remove("codicon")}t(){this.action.enabled?(this.g&&(this.g.removeAttribute("aria-disabled"),this.g.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.g&&(this.g.setAttribute("aria-disabled","true"),this.g.classList.add("disabled")),this.element?.classList.add("disabled"))}z(){if(this.g){const l=this.u()??"";this.g.setAttribute("aria-label",l)}}updateChecked(){this.g&&(this.action.checked?this.g.classList.add("checked"):this.g.classList.remove("checked"))}}t.ActionViewItem=e;class s extends n{constructor(l,h,r,u,b,A){super(l,h),this.b=new w.SelectBox(r,u,b,void 0,A),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(l,h){this.b.setOptions(l,h)}select(l){this.b.select(l)}g(){this.B(this.b.onDidSelect(l=>this.n(l.selected,l.index)))}n(l,h){this.actionRunner.run(this._action,this.r(l,h))}r(l,h){return l}setFocusable(l){this.b.setFocusable(l)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(l){this.b.render(l)}}t.SelectActionViewItem=s}),define(be[62],pe([1,0,4,17,61,31,3,2,6,48]),function(X,t,v,i,U,H,y,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var m;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(m=t.ActionsOrientation||(t.ActionsOrientation={}));class f extends w.Disposable{constructor(n,e={}){super(),this.f=this.B(new w.DisposableStore),this.m=this.B(new w.DisposableMap),this.s=!1,this.t=!0,this.v=this.B(new y.Emitter),this.onDidBlur=this.v.event,this.w=this.B(new y.Emitter({onWillAddFirstListener:()=>this.y=!0})),this.onDidCancel=this.w.event,this.y=!1,this.z=this.B(new y.Emitter),this.onDidRun=this.z.event,this.C=this.B(new y.Emitter),this.onWillRun=this.C.event,this.b=e,this.g=e.context??null,this.j=this.b.orientation??0,this.l={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.c=this.b.actionRunner:(this.c=new H.ActionRunner,this.f.add(this.c)),this.f.add(this.c.onDidRun(l=>this.z.fire(l))),this.f.add(this.c.onWillRun(l=>this.C.fire(l))),this.viewItems=[],this.p=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,a;switch(this.j){case 0:s=[15],a=[17];break;case 1:s=[16],a=[18],this.domNode.className+=" vertical";break}this.B(v.addDisposableListener(this.domNode,v.EventType.KEY_DOWN,l=>{const h=new i.StandardKeyboardEvent(l);let r=!0;const u=typeof this.p=="number"?this.viewItems[this.p]:void 0;s&&(h.equals(s[0])||h.equals(s[1]))?r=this.L():a&&(h.equals(a[0])||h.equals(a[1]))?r=this.J():h.equals(9)&&this.y?this.w.fire():h.equals(14)?r=this.H():h.equals(13)?r=this.I():h.equals(2)&&u instanceof U.BaseActionViewItem&&u.trapsArrowNavigation?r=this.J():this.F(h)?this.l.keyDown?this.N(h):this.s=!0:r=!1,r&&(h.preventDefault(),h.stopPropagation())})),this.B(v.addDisposableListener(this.domNode,v.EventType.KEY_UP,l=>{const h=new i.StandardKeyboardEvent(l);this.F(h)?(!this.l.keyDown&&this.s&&(this.s=!1,this.N(h)),h.preventDefault(),h.stopPropagation()):(h.equals(2)||h.equals(1026))&&this.G()})),this.r=this.B(v.trackFocus(this.domNode)),this.B(this.r.onDidBlur(()=>{(v.getActiveElement()===this.domNode||!v.isAncestor(v.getActiveElement(),this.domNode))&&(this.v.fire(),this.p=void 0,this.n=void 0,this.s=!1)})),this.B(this.r.onDidFocus(()=>this.G())),this.u=document.createElement("ul"),this.u.className="actions-container",this.u.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.u.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.u),n.appendChild(this.domNode)}D(){this.length()>=2?this.u.setAttribute("role",this.b.ariaRole||"toolbar"):this.u.setAttribute("role","presentation")}setAriaLabel(n){n?this.u.setAttribute("aria-label",n):this.u.removeAttribute("aria-label")}setFocusable(n){if(this.t=n,this.t){const e=this.viewItems.find(s=>s instanceof U.BaseActionViewItem&&s.isEnabled());e instanceof U.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof U.BaseActionViewItem&&e.setFocusable(!1)})}F(n){let e=!1;return this.l.keys.forEach(s=>{e=e||n.equals(s)}),e}G(){for(let n=0;n<this.u.children.length;n++){const e=this.u.children[n];if(v.isAncestor(v.getActiveElement(),e)){this.p=n;break}}}get context(){return this.g}set context(n){this.g=n,this.viewItems.forEach(e=>e.setActionContext(n))}get actionRunner(){return this.c}set actionRunner(n){this.c=n,this.f.clear(),this.f.add(this.c.onDidRun(e=>this.z.fire(e))),this.f.add(this.c.onWillRun(e=>this.C.fire(e))),this.viewItems.forEach(e=>e.actionRunner=n)}getContainer(){return this.domNode}hasAction(n){return this.viewItems.findIndex(e=>e.action.id===n.id)!==-1}getAction(n){if(typeof n=="number")return this.viewItems[n]?.action;if(n instanceof HTMLElement){for(;n.parentElement!==this.u;){if(!n.parentElement)return;n=n.parentElement}for(let e=0;e<this.u.childNodes.length;e++)if(this.u.childNodes[e]===n)return this.viewItems[e].action}}push(n,e={}){const s=Array.isArray(n)?n:[n];let a=d.isNumber(e.index)?e.index:null;s.forEach(l=>{const h=document.createElement("li");h.className="action-item",h.setAttribute("role","presentation");let r;this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(l)),r||(r=new U.ActionViewItem(this.context,l,{hoverDelegate:this.b.hoverDelegate,...e})),this.b.allowContextMenu||this.m.set(r,v.addDisposableListener(h,v.EventType.CONTEXT_MENU,u=>{v.EventHelper.stop(u,!0)})),r.actionRunner=this.c,r.setActionContext(this.context),r.render(h),this.t&&r instanceof U.BaseActionViewItem&&this.viewItems.length===0&&r.setFocusable(!0),a===null||a<0||a>=this.u.children.length?(this.u.appendChild(h),this.viewItems.push(r)):(this.u.insertBefore(h,this.u.children[a]),this.viewItems.splice(a,0,r),a++)}),typeof this.p=="number"&&this.focus(this.p),this.D()}getWidth(n){if(n>=0&&n<this.u.children.length){const e=this.u.children.item(n);if(e)return e.clientWidth}return 0}getHeight(n){if(n>=0&&n<this.u.children.length){const e=this.u.children.item(n);if(e)return e.clientHeight}return 0}pull(n){n>=0&&n<this.viewItems.length&&(this.u.removeChild(this.u.childNodes[n]),this.m.deleteAndDispose(this.viewItems[n]),(0,w.dispose)(this.viewItems.splice(n,1)),this.D())}clear(){this.isEmpty()||(this.viewItems=(0,w.dispose)(this.viewItems),this.m.clearAndDisposeAll(),v.clearNode(this.u),this.D())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(n){let e=!1,s;if(n===void 0?e=!0:typeof n=="number"?s=n:typeof n=="boolean"&&(e=n),e&&typeof this.p>"u"){const a=this.viewItems.findIndex(l=>l.isEnabled());this.p=a===-1?void 0:a,this.M(void 0,void 0,!0)}else s!==void 0&&(this.p=s),this.M(void 0,void 0,!0)}H(){return this.p=this.length()-1,this.J(!0)}I(){return this.p=0,this.L(!0)}J(n){if(typeof this.p>"u")this.p=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.p;let s;do{if(!n&&this.b.preventLoopNavigation&&this.p+1>=this.viewItems.length)return this.p=e,!1;this.p=(this.p+1)%this.viewItems.length,s=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.Separator.ID));return this.M(),!0}L(n){if(typeof this.p>"u")this.p=0;else if(this.viewItems.length<=1)return!1;const e=this.p;let s;do{if(this.p=this.p-1,this.p<0){if(!n&&this.b.preventLoopNavigation)return this.p=e,!1;this.p=this.viewItems.length-1}s=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.Separator.ID));return this.M(!0),!0}M(n,e,s=!1){typeof this.p>"u"&&this.u.focus({preventScroll:e}),this.n!==void 0&&this.n!==this.p&&this.viewItems[this.n]?.blur();const a=this.p!==void 0&&this.viewItems[this.p];if(a){let l=!0;d.isFunction(a.focus)||(l=!1),this.b.focusOnlyEnabledItems&&d.isFunction(a.isEnabled)&&!a.isEnabled()&&(l=!1),a.action.id===H.Separator.ID&&(l=!1),l?(s||this.n!==this.p)&&(a.focus(n),this.n=this.p):(this.u.focus({preventScroll:e}),this.n=void 0)}}N(n){if(typeof this.p>"u")return;const e=this.viewItems[this.p];if(e instanceof U.BaseActionViewItem){const s=e._context===null||e._context===void 0?n:e._context;this.run(e._action,s)}}async run(n,e){await this.c.run(n,e)}dispose(){this.g=void 0,this.viewItems=(0,w.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=f;function M(o){if(!o.length)return o;let n=-1;for(let s=0;s<o.length;s++)if(o[s].id!==H.Separator.ID){n=s;break}if(n===-1)return[];o=o.slice(n);for(let s=o.length-1;s>=0&&o[s].id===H.Separator.ID;s--)o.splice(s,1);let e=!1;for(let s=o.length-1;s>=0;s--){const a=o[s].id===H.Separator.ID;a&&!e?o.splice(s,1):a?a&&(e=!1):e=!0}return o}t.prepareActions=M}),define(be[63],pe([1,0,4,19,52,62,54,57,18,3,78,100,88]),function(X,t,v,i,U,H,y,w,d,m,f,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const o=v.$;var n;(function(a){a[a.INFO=1]="INFO",a[a.WARNING=2]="WARNING",a[a.ERROR=3]="ERROR"})(n=t.MessageType||(t.MessageType={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class e extends d.Widget{constructor(l,h,r){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.B(new m.Emitter),this.onDidChange=this.I.event,this.J=this.B(new m.Emitter),this.onDidHeightChange=this.J.event,this.a=h,this.g=r,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=v.append(l,o(".monaco-inputbox.idle"));const u=this.g.flexibleHeight?"textarea":"input",b=v.append(this.element,o(".ibwrapper"));if(this.b=v.append(b,o(u+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.D(this.b,()=>this.element.classList.add("synthetic-focus")),this.C(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=v.append(b,o("div.mirror")),this.t.innerText="\xA0",this.H=new w.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),v.append(l,this.H.getDomNode()),this.B(this.H),this.B(this.H.onScroll(L=>this.b.scrollTop=L.scrollTop));const A=this.B(new i.DomEmitter(document,"selectionchange")),N=m.Event.filter(A.event,()=>document.getSelection()?.anchorNode===b);this.B(N(this.N,this)),this.B(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.z(this.b,()=>this.R()),this.C(this.b,()=>this.L()),this.D(this.b,()=>this.M()),this.B(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.B(new H.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(l){this.i=l,this.b.setAttribute("placeholder",l)}setTooltip(l){this.l=l,this.b.title=l}setAriaLabel(l){this.n=l,l?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(l){this.b.value!==l&&(this.b.value=l,this.R())}get step(){return this.b.step}set step(l){this.b.step=l}get height(){return typeof this.v=="number"?this.v:v.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(l=null){this.b.select(),l&&(this.b.setSelectionRange(l.start,l.end),l.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(l){l?this.enable():this.disable()}get width(){return v.getTotalWidth(this.b)}set width(l){if(this.g.flexibleHeight&&this.g.flexibleWidth){let h=0;if(this.t){const r=parseFloat(this.t.style.paddingLeft||"")||0,u=parseFloat(this.t.style.paddingRight||"")||0;h=r+u}this.b.style.width=l-h+"px"}else this.b.style.width=l+"px";this.t&&(this.t.style.width=l+"px")}set paddingRight(l){this.b.style.width=`calc(100% - ${l}px)`,this.t&&(this.t.style.paddingRight=l+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const l=this.w,h=this.v,r=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:l,height:h}),this.H.setScrollPosition({scrollTop:r})}showMessage(l,h){this.h=l,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(l.type));const r=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${v.asCssValueWithDefault(r.border,"transparent")}`,this.h.content&&(this.hasFocus()||h)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let l=null;return this.r&&(l=this.r(this.value),l?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(l)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),l?.type}stylesForType(l){const h=this.g.inputBoxStyles;switch(l){case 1:return{border:h.inputValidationInfoBorder,background:h.inputValidationInfoBackground,foreground:h.inputValidationInfoForeground};case 2:return{border:h.inputValidationWarningBorder,background:h.inputValidationWarningBackground,foreground:h.inputValidationWarningForeground};default:return{border:h.inputValidationErrorBorder,background:h.inputValidationErrorBackground,foreground:h.inputValidationErrorForeground}}}O(l){switch(l){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let l;const h=()=>l.style.width=v.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:u=>{if(!this.h)return null;l=v.append(u,o(".monaco-inputbox-container")),h();const b={inline:!0,className:"monaco-inputbox-message"},A=this.h.formatContent?(0,U.renderFormattedText)(this.h.content,b):(0,U.renderText)(this.h.content,b);A.classList.add(this.O(this.h.type));const N=this.stylesForType(this.h.type);return A.style.backgroundColor=N.background?N.background.toString():"",A.style.color=N.foreground?N.foreground.toString():"",A.style.border=N.border?`1px solid ${N.border}`:"",v.append(l,A),null},onHide:()=>{this.s="closed"},layout:h});let r;this.h.type===3?r=M.localize(0,null,this.h.content):this.h.type===2?r=M.localize(1,null,this.h.content):r=M.localize(2,null,this.h.content),y.alert(r),this.s="open"}Q(){!this.a||(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const l=this.value,r=l.charCodeAt(l.length-1)===10?" ":"";(l+r).replace(/\u000c/g,"")?this.t.textContent=l+r:this.t.innerText="\xA0",this.layout()}U(){const l=this.g.inputBoxStyles,h=l.inputBackground??"",r=l.inputForeground??"",u=l.inputBorder??"";this.element.style.backgroundColor=h,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,this.element.style.border=`1px solid ${v.asCssValueWithDefault(u,"transparent")}`}layout(){if(!this.t)return;const l=this.w;this.w=v.getTotalHeight(this.t),l!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(l){const h=this.inputElement,r=h.selectionStart,u=h.selectionEnd,b=h.value;r!==null&&u!==null&&(this.value=b.substr(0,r)+l+b.substr(u),h.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=e;class s extends e{constructor(l,h,r){const u=M.localize(3,null),b=` or \u21C5 ${u}`,A=` (\u21C5 ${u})`;super(l,h,r),this.Y=this.B(new m.Emitter),this.onDidFocus=this.Y.event,this.Z=this.B(new m.Emitter),this.onDidBlur=this.Z.event,this.W=new f.HistoryNavigator(r.history,100);const N=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.i.endsWith(b)&&!this.i.endsWith(A)&&this.W.getHistory().length){const L=this.i.endsWith(")")?b:A,T=this.i+L;r.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=T:this.setPlaceHolder(T)}};this.X=new MutationObserver((L,T)=>{L.forEach(c=>{c.target.textContent||N()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.D(this.b,()=>N()),this.C(this.b,()=>{const L=T=>{if(this.i.endsWith(T)){const c=this.i.slice(0,this.i.length-T.length);return r.showPlaceholderOnFocus?this.i=c:this.setPlaceHolder(c),!0}else return!1};L(A)||L(b)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(){this.value&&this.value!==this.cb()&&this.W.add(this.value)}getHistory(){return this.W.getHistory()}showNextValue(){this.W.has(this.value)||this.addToHistory();let l=this.eb();l&&(l=l===this.value?this.eb():l),l&&(this.value=l,y.status(this.value))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let l=this.db();l&&(l=l===this.value?this.db():l),l&&(this.value=l,y.status(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let l=this.W.current();return l||(l=this.W.last(),this.W.next()),l}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()||this.W.last()}}t.HistoryInputBox=s}),define(be[64],pe([1,0,61,18,12,3,93]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends v.BaseActionViewItem{constructor(f,M,o){super(f,M,o),this.a=this.B(new w({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.k.keybinding?`${this._action.label} (${this.k.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:o.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:o.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:o.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(f){this.element=f,this.element.appendChild(this.a.domNode)}t(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}updateChecked(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(f){this.a.domNode.tabIndex=f?0:-1}}t.ToggleActionViewItem=y;class w extends i.Widget{constructor(f){super(),this.a=this.B(new H.Emitter),this.onChange=this.a.event,this.b=this.B(new H.Emitter),this.onKeyDown=this.b.event,this.c=f,this.s=this.c.isChecked;const M=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,M.push(...U.CSSIcon.asClassNameArray(this.g))),this.c.actionClassName&&M.push(...this.c.actionClassName.split(" ")),this.s&&M.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...M),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,o=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),o.preventDefault())}),this.B(this.G(this.domNode)),this.p(this.domNode,o=>{if(o.keyCode===10||o.keyCode===3){this.checked=!this.s,this.a.fire(!0),o.preventDefault(),o.stopPropagation();return}this.b.fire(o)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(f){this.s=f,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(f){this.g&&this.domNode.classList.remove(...U.CSSIcon.asClassNameArray(this.g)),this.g=f,this.g&&this.domNode.classList.add(...U.CSSIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(f){this.domNode.title=f,this.domNode.setAttribute("aria-label",f)}}t.Toggle=w;class d extends i.Widget{constructor(f,M,o){super(),this.c=f,this.g=M,this.a=new w({title:this.c,isChecked:this.g,icon:U.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.a.domNode,this.b=o,this.h()}get checked(){return this.a.checked}set checked(f){this.a.checked=f}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.Checkbox=d}),define(be[126],pe([1,0,64,12,98]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const H=U.localize(0,null),y=U.localize(1,null),w=U.localize(2,null);class d extends v.Toggle{constructor(o){super({icon:i.Codicon.caseSensitive,title:H+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.CaseSensitiveToggle=d;class m extends v.Toggle{constructor(o){super({icon:i.Codicon.wholeWord,title:y+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.WholeWordsToggle=m;class f extends v.Toggle{constructor(o){super({icon:i.Codicon.regex,title:w+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.RegexToggle=f}),define(be[127],pe([1,0,4,126,63,18,3,97,2,87]),function(X,t,v,i,U,H,y,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const m=w.localize(0,null);class f extends H.Widget{constructor(o,n,e){super(),this.i=!0,this.l=!1,this.n=new d.DisposableStore,this.H=[],this.I=this.B(new y.Emitter),this.onDidOptionChange=this.I.event,this.J=this.B(new y.Emitter),this.onKeyDown=this.J.event,this.L=this.B(new y.Emitter),this.onMouseDown=this.L.event,this.M=this.B(new y.Emitter),this.onInput=this.M.event,this.N=this.B(new y.Emitter),this.onKeyUp=this.N.event,this.O=this.B(new y.Emitter),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.B(new y.Emitter),this.onRegexKeyDown=this.P.event,this.Q=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||m,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",a=e.appendWholeWordsLabel||"",l=e.appendRegexLabel||"",h=e.history||[],r=!!e.flexibleHeight,u=!!e.flexibleWidth,b=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new U.HistoryInputBox(this.domNode,n,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:h,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:u,flexibleMaxHeight:b,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new i.RegexToggle({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(N=>{this.I.fire(N),!N&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(N=>{this.P.fire(N)})),this.w=this.B(new i.WholeWordsToggle({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(N=>{this.I.fire(N),!N&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new i.CaseSensitiveToggle({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(N=>{this.I.fire(N),!N&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(N=>{this.O.fire(N)}));const A=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const L=A.indexOf(document.activeElement);if(L>=0){let T=-1;N.equals(17)?T=(L+1)%A.length:N.equals(15)&&(L===0?T=A.length-1:T=L-1),N.equals(9)?(A[L].blur(),this.inputBox.focus()):T>=0&&A[T].focus(),v.EventHelper.stop(N,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"block":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),o?.appendChild(this.domNode),this.B(v.addDisposableListener(this.inputBox.inputElement,"compositionstart",A=>{this.l=!0})),this.B(v.addDisposableListener(this.inputBox.inputElement,"compositionend",A=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,A=>this.J.fire(A)),this.u(this.inputBox.inputElement,A=>this.N.fire(A)),this.z(this.inputBox.inputElement,A=>this.M.fire()),this.j(this.inputBox.inputElement,A=>this.L.fire(A))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const o of this.H)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const o of this.H)o.disable()}setFocusInputOnOptionClick(o){this.i=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const n of this.H)n.domNode.remove();this.H=[],this.n.dispose(),this.n=new d.DisposableStore;for(const n of o??[])this.n.add(n),this.s.appendChild(n.domNode),this.n.add(n.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(n);this.H.length>0&&(this.s.style.display="block"),this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((n,e)=>n+e.width(),0)}clear(){this.R(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(o){this.y&&(this.y.checked=o)}getWholeWords(){return this.w?.checked??!1}setWholeWords(o){this.w&&(this.w.checked=o)}getRegex(){return this.v?.checked??!1}setRegex(o){this.v&&(this.v.checked=o,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Q),this.Q=1-this.Q,this.domNode.classList.add("highlight-"+this.Q)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}R(){this.inputBox.hideMessage()}}t.FindInput=f,f.OPTION_CHANGE="optionChange"}),define(be[128],pe([1,0,4,19,17,62,127,63,58,59,64,55,23,31,14,8,12,70,3,32,2,46,6,102,94]),function(X,t,v,i,U,H,y,w,d,m,f,M,o,n,e,s,a,l,h,r,u,b,A,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class L extends d.ElementsDragAndDropData{set context(k){this.c.context=k}get context(){return this.c.context}constructor(k){super(k.elements.map(E=>E.element)),this.c=k}}function T(ee){return ee instanceof d.ElementsDragAndDropData?new L(ee):ee}class c{constructor(k,E){this.c=k,this.d=E,this.b=u.Disposable.None}getDragURI(k){return this.d.getDragURI(k.element)}getDragLabel(k,E){if(this.d.getDragLabel)return this.d.getDragLabel(k.map(g=>g.element),E)}onDragStart(k,E){this.d.onDragStart?.(T(k),E)}onDragOver(k,E,g,R,W=!0){const $=this.d.onDragOver(T(k),E&&E.element,g,R),Y=this.a!==E;if(Y&&(this.b.dispose(),this.a=E),typeof E>"u")return $;if(Y&&typeof $!="boolean"&&$.autoExpand&&(this.b=(0,s.disposableTimeout)(()=>{const I=this.c(),P=I.getNodeLocation(E);I.isCollapsed(P)&&I.setCollapsed(P,!1),this.a=void 0},500)),typeof $=="boolean"||!$.accept||typeof $.bubble>"u"||$.feedback){if(!W){const I=typeof $=="boolean"?$:$.accept,P=typeof $=="boolean"?void 0:$.effect;return{accept:I,effect:P,feedback:[g]}}return $}if($.bubble===1){const I=this.c(),P=I.getNodeLocation(E),O=I.getParentNodeLocation(P),j=I.getNode(O),J=O&&I.getListIndex(O);return this.onDragOver(k,j,J,R,!1)}const F=this.c(),B=F.getNodeLocation(E),z=F.getListIndex(B),S=F.getListRenderCount(B);return{...$,feedback:(0,e.range)(z,z+S)}}drop(k,E,g,R){this.b.dispose(),this.a=void 0,this.d.drop(T(k),E&&E.element,g,R)}onDragEnd(k){this.d.onDragEnd?.(k)}}function C(ee,k){return k&&{...k,identityProvider:k.identityProvider&&{getId(E){return k.identityProvider.getId(E.element)}},dnd:k.dnd&&new c(ee,k.dnd),multipleSelectionController:k.multipleSelectionController&&{isSelectionSingleChangeEvent(E){return k.multipleSelectionController.isSelectionSingleChangeEvent({...E,element:E.element})},isSelectionRangeChangeEvent(E){return k.multipleSelectionController.isSelectionRangeChangeEvent({...E,element:E.element})}},accessibilityProvider:k.accessibilityProvider&&{...k.accessibilityProvider,getSetSize(E){const g=ee(),R=g.getNodeLocation(E),W=g.getParentNodeLocation(R);return g.getNode(W).visibleChildrenCount},getPosInSet(E){return E.visibleChildIndex+1},isChecked:k.accessibilityProvider&&k.accessibilityProvider.isChecked?E=>k.accessibilityProvider.isChecked(E.element):void 0,getRole:k.accessibilityProvider&&k.accessibilityProvider.getRole?E=>k.accessibilityProvider.getRole(E.element):()=>"treeitem",getAriaLabel(E){return k.accessibilityProvider.getAriaLabel(E.element)},getWidgetAriaLabel(){return k.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:k.accessibilityProvider&&k.accessibilityProvider.getWidgetRole?()=>k.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:k.accessibilityProvider&&k.accessibilityProvider.getAriaLevel?E=>k.accessibilityProvider.getAriaLevel(E.element):E=>E.depth,getActiveDescendantId:k.accessibilityProvider.getActiveDescendantId&&(E=>k.accessibilityProvider.getActiveDescendantId(E.element))},keyboardNavigationLabelProvider:k.keyboardNavigationLabelProvider&&{...k.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(E){return k.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(E.element)}}}}class p{constructor(k){this.a=k}getHeight(k){return this.a.getHeight(k.element)}getTemplateId(k){return this.a.getTemplateId(k.element)}hasDynamicHeight(k){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(k.element)}setDynamicHeight(k,E){this.a.setDynamicHeight?.(k.element,E)}}t.ComposedTreeDelegate=p;class D{static lift(k){return k instanceof D?k:new D(k)}static empty(k=0){return new D({focus:[],selection:[],expanded:Object.create(null),scrollTop:k})}constructor(k){if(this.focus=new Set(k.focus),this.selection=new Set(k.selection),k.expanded instanceof Array){this.expanded=Object.create(null);for(const E of k.expanded)this.expanded[E]=1}else this.expanded=k.expanded;this.expanded=k.expanded,this.scrollTop=k.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=D;var _;(function(ee){ee.None="none",ee.OnHover="onHover",ee.Always="always"})(_=t.RenderIndentGuides||(t.RenderIndentGuides={}));class V{get elements(){return this.b}constructor(k,E=[]){this.b=E,this.a=new u.DisposableStore,this.onDidChange=h.Event.forEach(k,g=>this.b=g,this.a)}dispose(){this.a.dispose()}}class ge{constructor(k,E,g,R,W,$={}){this.o=k,this.p=E,this.q=R,this.s=W,this.b=new Map,this.c=new Map,this.d=ge.a,this.f=!1,this.g=!1,this.j=new Set,this.k=u.Disposable.None,this.m=new u.DisposableStore,this.templateId=k.templateId,this.updateOptions($),h.Event.map(g,Y=>Y.node)(this.u,this,this.m),k.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(k={}){if(typeof k.indent<"u"){const E=(0,b.clamp)(k.indent,0,40);if(E!==this.d){this.d=E;for(const[g,R]of this.c)this.v(g,R)}}if(typeof k.renderIndentGuides<"u"){const E=k.renderIndentGuides!==_.None;if(E!==this.g&&(this.g=E,this.k.dispose(),E)){const g=new u.DisposableStore;this.q.onDidChange(this.w,this,g),this.k=g,this.w(this.q.elements)}}typeof k.hideTwistiesOfChildlessElements<"u"&&(this.f=k.hideTwistiesOfChildlessElements)}renderTemplate(k){const E=(0,v.append)(k,(0,v.$)(".monaco-tl-row")),g=(0,v.append)(E,(0,v.$)(".monaco-tl-indent")),R=(0,v.append)(E,(0,v.$)(".monaco-tl-twistie")),W=(0,v.append)(E,(0,v.$)(".monaco-tl-contents")),$=this.o.renderTemplate(W);return{container:k,indent:g,twistie:R,indentGuidesDisposable:u.Disposable.None,templateData:$}}renderElement(k,E,g,R){this.c.set(k,g),this.b.set(k.element,k),this.v(k,g),this.o.renderElement(k,E,g.templateData,R)}disposeElement(k,E,g,R){g.indentGuidesDisposable.dispose(),this.o.disposeElement?.(k,E,g.templateData,R),typeof R=="number"&&(this.c.delete(k),this.b.delete(k.element))}disposeTemplate(k){this.o.disposeTemplate(k.templateData)}t(k){const E=this.b.get(k);!E||this.u(E)}u(k){const E=this.c.get(k);!E||(this.w(this.q.elements),this.v(k,E))}v(k,E){const g=ge.a+(k.depth-1)*this.d;E.twistie.style.paddingLeft=`${g}px`,E.indent.style.width=`${g+this.d-16}px`,k.collapsible?E.container.setAttribute("aria-expanded",String(!k.collapsed)):E.container.removeAttribute("aria-expanded"),E.twistie.classList.remove(...a.Codicon.treeItemExpanded.classNamesArray);let R=!1;if(this.o.renderTwistie&&(R=this.o.renderTwistie(k.element,E.twistie)),k.collapsible&&(!this.f||k.visibleChildrenCount>0)?(R||E.twistie.classList.add(...a.Codicon.treeItemExpanded.classNamesArray),E.twistie.classList.add("collapsible"),E.twistie.classList.toggle("collapsed",k.collapsed)):E.twistie.classList.remove("collapsible","collapsed"),(0,v.clearNode)(E.indent),E.indentGuidesDisposable.dispose(),!this.g)return;const W=new u.DisposableStore,$=this.p();for(;;){const Y=$.getNodeLocation(k),F=$.getParentNodeLocation(Y);if(!F)break;const B=$.getNode(F),z=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(B)&&z.classList.add("active"),E.indent.childElementCount===0?E.indent.appendChild(z):E.indent.insertBefore(z,E.indent.firstElementChild),this.s.add(B,z),W.add((0,u.toDisposable)(()=>this.s.delete(B,z))),k=B}E.indentGuidesDisposable=W}w(k){if(!this.g)return;const E=new Set,g=this.p();k.forEach(R=>{const W=g.getNodeLocation(R);try{const $=g.getParentNodeLocation(W);R.collapsible&&R.children.length>0&&!R.collapsed?E.add(R):$&&E.add(g.getNode($))}catch{}}),this.j.forEach(R=>{E.has(R)||this.s.forEach(R,W=>W.classList.remove("active"))}),E.forEach(R=>{this.j.has(R)||this.s.forEach(R,W=>W.classList.add("active"))}),this.j=E}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,u.dispose)(this.m)}}ge.a=8;class Z{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(k){this.c=k,this.d=k.toLowerCase()}constructor(k,E,g){this.g=k,this.j=E,this.k=g,this.a=0,this.b=0,this.c="",this.d="",this.f=new u.DisposableStore,k.onWillRefilter(this.m,this,this.f)}filter(k,E){let g=1;if(this.k){const $=this.k.filter(k,E);if(typeof $=="boolean"?g=$?1:0:(0,M.isFilterResult)($)?g=(0,M.getVisibleState)($.visibility):g=$,g===0)return!1}if(this.a++,!this.c)return this.b++,{data:r.FuzzyScore.Default,visibility:g};const R=this.j.getKeyboardNavigationLabel(k),W=Array.isArray(R)?R:[R];for(const $ of W){const Y=$&&$.toString();if(typeof Y>"u")return{data:r.FuzzyScore.Default,visibility:g};const F=(0,r.fuzzyScore)(this.c,this.d,0,Y,Y.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(F)return this.b++,W.length===1?{data:F,visibility:g}:{data:{label:Y,score:F},visibility:g}}return this.g.findMode===he.Filter?2:{data:r.FuzzyScore.Default,visibility:g}}m(){this.a=0,this.b=0}dispose(){(0,u.dispose)(this.f)}}class ie extends f.Toggle{constructor(k){super({icon:a.Codicon.listFilter,title:(0,N.localize)(0,null),isChecked:k.isChecked??!1,inputActiveOptionBorder:k.inputActiveOptionBorder,inputActiveOptionForeground:k.inputActiveOptionForeground,inputActiveOptionBackground:k.inputActiveOptionBackground})}}t.ModeToggle=ie;const te={inputBoxStyles:w.unthemedInboxStyles,toggleStyles:f.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var he;(function(ee){ee[ee.Highlight=0]="Highlight",ee[ee.Filter=1]="Filter"})(he=t.TreeFindMode||(t.TreeFindMode={}));class re extends u.Disposable{set mode(k){this.b.checked=k===he.Filter,this.c.inputBox.setPlaceHolder(k===he.Filter?(0,N.localize)(1,null):(0,N.localize)(2,null))}get value(){return this.c.inputBox.value}set value(k){this.c.inputBox.value=k}constructor(k,E,g,R,W){super(),this.m=E,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.g=0,this.j=0,this.k=0,this._onDidDisable=new h.Emitter,this.onDidDisable=this._onDidDisable.event,k.appendChild(this.a.root),this.B((0,u.toDisposable)(()=>k.removeChild(this.a.root)));const $=W?.styles??te;$.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=$.listFilterWidgetBackground),$.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${$.listFilterWidgetShadow}`),this.b=this.B(new ie({...$.toggleStyles,isChecked:R===he.Filter})),this.onDidChangeMode=h.Event.map(this.b.onChange,()=>this.b.checked?he.Filter:he.Highlight,this.q),this.c=this.B(new y.FindInput(this.a.findInput,g,{label:(0,N.localize)(3,null),additionalToggles:[this.b],showCommonFindToggles:!1,inputBoxStyles:$.inputBoxStyles,toggleStyles:$.toggleStyles})),this.f=this.B(new H.ActionBar(this.a.actionbar)),this.mode=R;const Y=this.B(new i.DomEmitter(this.c.inputBox.inputElement,"keydown")),F=this.B(h.Event.chain(Y.event)).map(I=>new U.StandardKeyboardEvent(I)).event;this.B(F(I=>{switch(I.keyCode){case 18:I.preventDefault(),I.stopPropagation(),this.m.domFocus();return}}));const B=this.B(new n.Action("close",(0,N.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.f.push(B,{icon:!0,label:!1});const z=this.B(new i.DomEmitter(this.a.grab,"mousedown"));this.B(z.event(I=>{const P=new u.DisposableStore,O=P.add(new i.DomEmitter(window,"mousemove")),j=P.add(new i.DomEmitter(window,"mouseup")),J=this.j,ae=I.pageX,ue=this.k,ye=I.pageY;this.a.grab.classList.add("grabbing");const Ee=this.a.root.style.transition;this.a.root.style.transition="unset";const Ie=ke=>{const ve=ke.pageX-ae;this.j=J-ve;const Pe=ke.pageY-ye;this.k=ue+Pe,this.layout()};P.add(O.event(Ie)),P.add(j.event(ke=>{Ie(ke),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ee,P.dispose()}))}));const S=this.B(h.Event.chain(this.B(new i.DomEmitter(this.a.grab,"keydown")).event)).map(I=>new U.StandardKeyboardEvent(I)).event;this.B(S(I=>{let P,O;if(I.keyCode===15?P=Number.POSITIVE_INFINITY:I.keyCode===17?P=0:I.keyCode===10&&(P=this.j===0?Number.POSITIVE_INFINITY:0),I.keyCode===16?O=0:I.keyCode===18&&(O=Number.POSITIVE_INFINITY),P!==void 0&&(I.preventDefault(),I.stopPropagation(),this.j=P,this.layout()),O!==void 0){I.preventDefault(),I.stopPropagation(),this.k=O;const j=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=j},0)}})),this.onDidChangeValue=this.c.onDidChange}focus(){this.c.focus()}select(){this.c.select()}layout(k=this.g){this.g=k,this.j=(0,b.clamp)(this.j,0,Math.max(0,k-212)),this.a.root.style.right=`${this.j}px`,this.k=(0,b.clamp)(this.k,0,24),this.a.root.style.top=`${this.k}px`}showMessage(k){this.c.showMessage(k)}clearMessage(){this.c.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class ce{get pattern(){return this.a}get mode(){return this.c}set mode(k){k!==this.c&&(this.c=k,this.d&&(this.d.mode=this.c),this.p.refilter(),this.x(),this.g.fire(k))}constructor(k,E,g,R,W,$={}){this.p=k,this.q=g,this.s=R,this.t=W,this.u=$,this.a="",this.b="",this.f=0,this.g=new h.Emitter,this.onDidChangeMode=this.g.event,this.j=new h.Emitter,this.onDidChangePattern=this.j.event,this.k=new h.Emitter,this.onDidChangeOpenState=this.k.event,this.m=new u.DisposableStore,this.o=new u.DisposableStore,this.c=k.options.defaultFindMode??he.Highlight,E.onDidSplice(this.w,this,this.o)}open(){if(this.d){this.d.focus(),this.d.select();return}this.mode=this.p.options.defaultFindMode??he.Highlight,this.d=new re(this.q.getHTMLElement(),this.p,this.t,this.mode,this.u),this.m.add(this.d),this.d.onDidChangeValue(this.v,this,this.m),this.d.onDidChangeMode(k=>this.mode=k,void 0,this.m),this.d.onDidDisable(this.close,this,this.m),this.d.layout(this.f),this.d.focus(),this.d.value=this.b,this.d.select(),this.k.fire(!0)}close(){!this.d||(this.d=void 0,this.m.dispose(),this.m=new u.DisposableStore,this.b=this.pattern,this.v(""),this.p.domFocus(),this.k.fire(!1))}v(k){this.a=k,this.j.fire(k),this.s.pattern=k,this.p.refilter(),k&&this.p.focusNext(0,!0,void 0,g=>!r.FuzzyScore.isDefault(g.filterData));const E=this.p.getFocus();if(E.length>0){const g=E[0];this.p.getRelativeTop(g)===null&&this.p.reveal(g,.5)}this.x()}w(){!this.d||this.pattern.length===0||(this.p.refilter(),this.x())}x(){const k=this.s.totalCount>0&&this.s.matchCount===0;this.pattern&&k?this.p.options.showNotFoundMessage??!0?this.d?.showMessage({type:2,content:(0,N.localize)(5,null)}):this.d?.showMessage({type:2}):this.d?.clearMessage()}shouldAllowFocus(k){return!this.d||!this.pattern||this.c===he.Filter||this.s.totalCount>0&&this.s.matchCount<=1?!0:!r.FuzzyScore.isDefault(k.filterData)}layout(k){this.f=k,this.d?.layout(k)}dispose(){this.j.dispose(),this.m.dispose(),this.o.dispose()}}function Se(ee){let k=o.TreeMouseEventTarget.Unknown;return(0,v.hasParentWithClass)(ee.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?k=o.TreeMouseEventTarget.Twistie:(0,v.hasParentWithClass)(ee.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?k=o.TreeMouseEventTarget.Element:(0,v.hasParentWithClass)(ee.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(k=o.TreeMouseEventTarget.Filter),{browserEvent:ee.browserEvent,element:ee.element?ee.element.element:null,target:k}}function x(ee){return{element:ee.element?ee.element.element:null,browserEvent:ee.browserEvent,anchor:ee.anchor}}function De(ee,k){k(ee),ee.children.forEach(E=>De(E,k))}class se{get f(){return this.d||(this.d=this.m()),this.d}constructor(k,E){this.g=k,this.j=E,this.a=[],this.c=new h.Emitter,this.onDidChange=this.c.event}set(k,E){!E?.__forceEvent&&(0,e.equals)(this.a,k)||this.k(k,!1,E)}k(k,E,g){if(this.a=[...k],this.b=void 0,this.d=void 0,!E){const R=this;this.c.fire({get elements(){return R.get()},browserEvent:g})}}get(){return this.b||(this.b=this.a.map(k=>k.element)),[...this.b]}getNodes(){return this.a}has(k){return this.f.has(k)}onDidModelSplice({insertedNodes:k,deletedNodes:E}){if(!this.j){const F=this.m(),B=z=>F.delete(z);E.forEach(z=>De(z,B)),this.set([...F.values()]);return}const g=new Set,R=F=>g.add(this.j.getId(F.element).toString());E.forEach(F=>De(F,R));const W=new Map,$=F=>W.set(this.j.getId(F.element).toString(),F);k.forEach(F=>De(F,$));const Y=[];for(const F of this.a){const B=this.j.getId(F.element).toString();if(!g.has(B))Y.push(F);else{const S=W.get(B);S&&Y.push(S)}}if(this.a.length>0&&Y.length===0){const F=this.g();F&&Y.push(F)}this.k(Y,!0)}m(){const k=new Set;for(const E of this.a)k.add(E);return k}}class Q extends m.MouseController{constructor(k,E){super(k),this.z=E}u(k){if((0,m.isButton)(k.browserEvent.target)||(0,m.isInputElement)(k.browserEvent.target)||(0,m.isMonacoEditor)(k.browserEvent.target))return;const E=k.element;if(!E)return super.u(k);if(this.p(k)||this.o(k))return super.u(k);const g=k.browserEvent.target,R=g.classList.contains("monaco-tl-twistie")||g.classList.contains("monaco-icon-label")&&g.classList.contains("folder-icon")&&k.browserEvent.offsetX<16;let W=!1;if(typeof this.z.expandOnlyOnTwistieClick=="function"?W=this.z.expandOnlyOnTwistieClick(E.element):W=!!this.z.expandOnlyOnTwistieClick,W&&!R&&k.browserEvent.detail!==2)return super.u(k);if(!this.z.expandOnDoubleClick&&k.browserEvent.detail===2)return super.u(k);if(E.collapsible){const $=this.z.getNodeLocation(E),Y=k.browserEvent.altKey;if(this.z.setFocus([$]),this.z.toggleCollapsed($,Y),W&&R)return}super.u(k)}v(k){k.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.z.expandOnDoubleClick||super.v(k)}}class le extends m.List{constructor(k,E,g,R,W,$,Y,F){super(k,E,g,R,F),this.p=W,this.s=$,this.L=Y}E(k){return new Q(this,k.tree)}splice(k,E,g=[]){if(super.splice(k,E,g),g.length===0)return;const R=[],W=[];let $;g.forEach((Y,F)=>{this.p.has(Y)&&R.push(k+F),this.s.has(Y)&&W.push(k+F),this.L.has(Y)&&($=k+F)}),R.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...R])),W.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...W])),typeof $=="number"&&super.setAnchor($)}setFocus(k,E,g=!1){super.setFocus(k,E),g||this.p.set(k.map(R=>this.element(R)),E)}setSelection(k,E,g=!1){super.setSelection(k,E),g||this.s.set(k.map(R=>this.element(R)),E)}setAnchor(k,E=!1){super.setAnchor(k),E||(typeof k>"u"?this.L.set([]):this.L.set([this.element(k)]))}}class de{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return h.Event.map(this.j.onMouseClick,Se)}get onMouseDblClick(){return h.Event.filter(h.Event.map(this.j.onMouseDblClick,Se),k=>k.target!==o.TreeMouseEventTarget.Filter)}get onContextMenu(){return h.Event.map(this.j.onContextMenu,x)}get onTap(){return h.Event.map(this.j.onTap,Se)}get onPointer(){return h.Event.map(this.j.onPointer,Se)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return h.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??he.Highlight}set findMode(k){this.x&&(this.x.mode=k)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:h.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(k,E,g,R,W={}){this.D=k,this.E=W,this.w=new h.EventBufferer,this.onDidChangeFindOpenState=h.Event.None,this.A=new u.DisposableStore,this.B=new h.Emitter,this.onWillRefilter=this.B.event,this.C=new h.Emitter,this.onDidUpdateOptions=this.C.event;const $=new p(g),Y=new h.Relay,F=new h.Relay,B=this.A.add(new V(F.event)),z=new l.SetMap;this.k=R.map(P=>new ge(P,()=>this.o,Y.event,B,z,W));for(const P of this.k)this.A.add(P);let S;W.keyboardNavigationLabelProvider&&(S=new Z(this,W.keyboardNavigationLabelProvider,W.filter),W={...W,filter:S},this.A.add(S)),this.p=new se(()=>this.j.getFocusedElements()[0],W.identityProvider),this.q=new se(()=>this.j.getSelectedElements()[0],W.identityProvider),this.u=new se(()=>this.j.getAnchorElement(),W.identityProvider),this.j=new le(k,E,$,this.k,this.p,this.q,this.u,{...C(()=>this.o,W),tree:this}),this.o=this.I(k,this.j,W),Y.input=this.o.onDidChangeCollapseState;const I=h.Event.forEach(this.o.onDidSplice,P=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(P),this.q.onDidModelSplice(P)})},this.A);if(I(()=>null,null,this.A),F.input=h.Event.chain(h.Event.any(I,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const P=new Set;for(const O of this.p.getNodes())P.add(O);for(const O of this.q.getNodes())P.add(O);return[...P.values()]}).event,W.keyboardSupport!==!1){const P=h.Event.chain(this.j.onKeyDown).filter(O=>!(0,m.isInputElement)(O.target)).map(O=>new U.StandardKeyboardEvent(O));P.filter(O=>O.keyCode===15).on(this.F,this,this.A),P.filter(O=>O.keyCode===17).on(this.G,this,this.A),P.filter(O=>O.keyCode===10).on(this.H,this,this.A)}if((W.findWidgetEnabled??!0)&&W.keyboardNavigationLabelProvider&&W.contextViewProvider){const P=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new ce(this,this.o,this.j,S,W.contextViewProvider,P),this.y=O=>this.x.shouldAllowFocus(O),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode}else this.onDidChangeFindMode=h.Event.None;this.z=(0,v.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===_.Always)}updateOptions(k={}){this.E={...this.E,...k};for(const E of this.k)E.updateOptions(k);this.j.updateOptions(this.E),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===_.Always)}get options(){return this.E}updateWidth(k){const E=this.o.getListIndex(k);E!==-1&&this.j.updateWidth(E)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get scrollTop(){return this.j.scrollTop}set scrollTop(k){this.j.scrollTop=k}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(k){this.j.scrollLeft=k}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const k=this.j.firstVisibleIndex;return k<0||k>=this.j.length?void 0:this.j.element(k).element}get lastVisibleElement(){const k=this.j.lastVisibleIndex;return this.j.element(k).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(k){this.j.ariaLabel=k}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(k,E){this.j.layout(k,E),(0,A.isNumber)(E)&&this.x?.layout(E)}style(k){const E=`.${this.j.domId}`,g=[];k.treeIndentGuidesStroke&&(g.push(`.monaco-list${E}:hover .monaco-tl-indent > .indent-guide, .monaco-list${E}.always .monaco-tl-indent > .indent-guide  { border-color: ${k.treeIndentGuidesStroke.transparent(.4)}; }`),g.push(`.monaco-list${E} .monaco-tl-indent > .indent-guide.active { border-color: ${k.treeIndentGuidesStroke}; }`)),this.z.textContent=g.join(`
`),this.j.style(k)}getParentElement(k){const E=this.o.getParentNodeLocation(k);return this.o.getNode(E).element}getFirstElementChild(k){return this.o.getFirstElementChild(k)}getNode(k){return this.o.getNode(k)}getNodeLocation(k){return this.o.getNodeLocation(k)}collapse(k,E=!1){return this.o.setCollapsed(k,!0,E)}expand(k,E=!1){return this.o.setCollapsed(k,!1,E)}toggleCollapsed(k,E=!1){return this.o.setCollapsed(k,void 0,E)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(k){return this.o.isCollapsible(k)}setCollapsible(k,E){return this.o.setCollapsible(k,E)}isCollapsed(k){return this.o.isCollapsed(k)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(k){if(typeof k>"u")return this.j.setAnchor(void 0);const E=this.o.getNode(k);this.u.set([E]);const g=this.o.getListIndex(k);g>-1&&this.j.setAnchor(g,!0)}getAnchor(){return(0,e.firstOrDefault)(this.u.get(),void 0)}setSelection(k,E){const g=k.map(W=>this.o.getNode(W));this.q.set(g,E);const R=k.map(W=>this.o.getListIndex(W)).filter(W=>W>-1);this.j.setSelection(R,E,!0)}getSelection(){return this.q.get()}setFocus(k,E){const g=k.map(W=>this.o.getNode(W));this.p.set(g,E);const R=k.map(W=>this.o.getListIndex(W)).filter(W=>W>-1);this.j.setFocus(R,E,!0)}focusNext(k=1,E=!1,g,R=this.y){this.j.focusNext(k,E,g,R)}focusPrevious(k=1,E=!1,g,R=this.y){this.j.focusPrevious(k,E,g,R)}focusNextPage(k,E=this.y){return this.j.focusNextPage(k,E)}focusPreviousPage(k,E=this.y){return this.j.focusPreviousPage(k,E)}focusLast(k,E=this.y){this.j.focusLast(k,E)}focusFirst(k,E=this.y){this.j.focusFirst(k,E)}getFocus(){return this.p.get()}reveal(k,E){this.o.expandTo(k);const g=this.o.getListIndex(k);g!==-1&&this.j.reveal(g,E)}getRelativeTop(k){const E=this.o.getListIndex(k);return E===-1?null:this.j.getRelativeTop(E)}getViewState(k=this.options.identityProvider){if(!k)throw new o.TreeError(this.D,"Can't get tree view state without an identity provider");const E=$=>k.getId($).toString(),g=D.empty(this.scrollTop);for(const $ of this.getFocus())g.focus.add(E($));for(const $ of this.getSelection())g.selection.add(E($));const R=this.o.getNode(),W=[R];for(;W.length>0;){const $=W.shift();$!==R&&$.collapsible&&(g.expanded[E($.element)]=$.collapsed?0:1),W.push(...$.children)}return g}F(k){k.preventDefault(),k.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const g=E[0],R=this.o.getNodeLocation(g);if(!this.o.setCollapsed(R,!0)){const $=this.o.getParentNodeLocation(R);if(!$)return;const Y=this.o.getListIndex($);this.j.reveal(Y),this.j.setFocus([Y])}}G(k){k.preventDefault(),k.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const g=E[0],R=this.o.getNodeLocation(g);if(!this.o.setCollapsed(R,!1)){if(!g.children.some(F=>F.visible))return;const[$]=this.j.getFocus(),Y=$+1;this.j.reveal(Y),this.j.setFocus([Y])}}H(k){k.preventDefault(),k.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const g=E[0],R=this.o.getNodeLocation(g),W=k.browserEvent.altKey;this.o.setCollapsed(R,void 0,W)}navigate(k){return new me(this.j,this.o,k)}dispose(){(0,u.dispose)(this.A),this.j.dispose()}}t.AbstractTree=de;class me{constructor(k,E,g){this.b=k,this.c=E,g?this.a=this.c.getListIndex(g):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[129],pe([1,0,128,119,23,25]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class y extends v.AbstractTree{constructor(d,m,f,M,o,n={}){super(d,m,f,M,n),this.f=d,this.g=o,this.d=new Map,this.c=n.identityProvider}getInput(){return this.b}setInput(d,m){if(m&&!this.c)throw new U.TreeError(this.f,"Can't restore tree view state without an identity provider");if(this.b=d,!d){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!m){this.m(d);return}const f=[],M=[],o=e=>{const s=this.c.getId(e).toString();return!m.expanded[s]},n=e=>{const s=this.c.getId(e.element).toString();m.focus.has(s)&&f.push(e.element),m.selection.has(s)&&M.push(e.element)};this.m(d,o,n),this.setFocus(f),this.setSelection(M),m&&typeof m.scrollTop=="number"&&(this.scrollTop=m.scrollTop)}updateChildren(d=this.b){if(typeof this.b>"u")throw new U.TreeError(this.f,"Tree input not set");let m;this.c&&(m=f=>{const M=this.c.getId(f).toString(),o=this.d.get(M);if(!!o)return o.collapsed}),this.m(d,m)}resort(d=this.b,m=!0){this.o.resort(d===this.b?null:d,m)}refresh(d){if(d===void 0){this.j.rerender();return}this.o.rerender(d)}m(d,m,f){let M;if(this.c){const o=new Set,n=f;f=e=>{const s=this.c.getId(e.element).toString();o.add(s),this.d.set(s,e),n?.(e)},M=e=>{const s=this.c.getId(e.element).toString();o.has(s)||this.d.delete(s)}}this.o.setChildren(d===this.b?null:d,this.s(d,m).elements,{onDidCreateNode:f,onDidDeleteNode:M})}s(d,m){const f=[...this.g.getChildren(d)];return{elements:H.Iterable.map(f,o=>{const{elements:n,size:e}=this.s(o,m),s=this.g.hasChildren?this.g.hasChildren(o):void 0,a=e===0?void 0:m&&m(o);return{element:o,children:n,collapsible:s,collapsed:a}}),size:f.length}}I(d,m,f){return new i.ObjectTreeModel(d,m,f)}}t.DataTree=y}),define(be[37],pe([1,0,14,8,29,26,24,9,3,2,50,11,6]),function(X,t,v,i,U,H,y,w,d,m,f,M,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=void 0;var n;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(n||(n={}));function e(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(s||(s={}));function a(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(l||(l={}));class h{constructor(Q){this.b=Q,this.a=0}read(Q){const le=this.b.slice(this.a,this.a+Q);return this.a+=le.byteLength,le}}class r{constructor(){this.a=[]}get buffer(){return U.VSBuffer.concat(this.a)}write(Q){this.a.push(Q)}}var u;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object"})(u||(u={}));function b(se){const Q=U.VSBuffer.alloc(4);return Q.writeUInt32BE(se,0),Q}function A(se){return se.read(4).readUInt32BE(0)}function N(se){const Q=U.VSBuffer.alloc(1);return Q.writeUInt8(se,0),Q}const L={Undefined:N(u.Undefined),String:N(u.String),Buffer:N(u.Buffer),VSBuffer:N(u.VSBuffer),Array:N(u.Array),Object:N(u.Object)},T=typeof Buffer<"u";function c(se,Q){if(typeof Q>"u")se.write(L.Undefined);else if(typeof Q=="string"){const le=U.VSBuffer.fromString(Q);se.write(L.String),se.write(b(le.byteLength)),se.write(le)}else if(T&&Buffer.isBuffer(Q)){const le=U.VSBuffer.wrap(Q);se.write(L.Buffer),se.write(b(le.byteLength)),se.write(le)}else if(Q instanceof U.VSBuffer)se.write(L.VSBuffer),se.write(b(Q.byteLength)),se.write(Q);else if(Array.isArray(Q)){se.write(L.Array),se.write(b(Q.length));for(const le of Q)c(se,le)}else{const le=U.VSBuffer.fromString(JSON.stringify(Q));se.write(L.Object),se.write(b(le.byteLength)),se.write(le)}}function C(se){switch(se.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return se.read(A(se)).toString();case u.Buffer:return se.read(A(se)).buffer;case u.VSBuffer:return se.read(A(se));case u.Array:{const le=A(se),de=[];for(let me=0;me<le;me++)de.push(C(se));return de}case u.Object:return JSON.parse(se.read(A(se)).toString())}}class p{constructor(Q,le,de=null,me=1e3){this.h=Q,this.j=le,this.k=de,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.p(ee)),this.m({type:200})}registerChannel(Q,le){this.b.set(Q,le),setTimeout(()=>this.v(Q),0)}m(Q){switch(Q.type){case 200:{const le=this.n([Q.type]);this.k?.logOutgoing(le,0,1,a(Q.type));return}case 201:case 202:case 204:case 203:{const le=this.n([Q.type,Q.id],Q.data);this.k?.logOutgoing(le,Q.id,1,a(Q.type),Q.data);return}}}n(Q,le=void 0){const de=new r;return c(de,Q),c(de,le),this.o(de.buffer)}o(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}p(Q){const le=new h(Q),de=C(le),me=C(le),ee=de[0];switch(ee){case 100:return this.k?.logIncoming(Q.byteLength,de[1],1,`${e(ee)}: ${de[2]}.${de[3]}`,me),this.q({type:ee,id:de[1],channelName:de[2],name:de[3],arg:me});case 102:return this.k?.logIncoming(Q.byteLength,de[1],1,`${e(ee)}: ${de[2]}.${de[3]}`,me),this.s({type:ee,id:de[1],channelName:de[2],name:de[3],arg:me});case 101:return this.k?.logIncoming(Q.byteLength,de[1],1,`${e(ee)}`),this.t({type:ee,id:de[1]});case 103:return this.k?.logIncoming(Q.byteLength,de[1],1,`${e(ee)}`),this.t({type:ee,id:de[1]})}}q(Q){const le=this.b.get(Q.channelName);if(!le){this.u(Q);return}const de=new H.CancellationTokenSource;let me;try{me=le.call(this.j,Q.name,Q.arg,de.token)}catch(E){me=Promise.reject(E)}const ee=Q.id;me.then(E=>{this.m({id:ee,data:E,type:201}),this.d.delete(Q.id)},E=>{E instanceof Error?this.m({id:ee,data:{message:E.message,name:E.name,stack:E.stack?E.stack.split?E.stack.split(`
`):E.stack:void 0},type:202}):this.m({id:ee,data:E,type:203}),this.d.delete(Q.id)});const k=(0,m.toDisposable)(()=>de.cancel());this.d.set(Q.id,k)}s(Q){const le=this.b.get(Q.channelName);if(!le){this.u(Q);return}const de=Q.id,ee=le.listen(this.j,Q.name,Q.arg)(k=>this.m({id:de,data:k,type:204}));this.d.set(Q.id,ee)}t(Q){const le=this.d.get(Q.id);le&&(le.dispose(),this.d.delete(Q.id))}u(Q){let le=this.g.get(Q.channelName);le||(le=[],this.g.set(Q.channelName,le));const de=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);le.push({request:Q,timeoutTimer:de})}v(Q){const le=this.g.get(Q);if(le){for(const de of le)switch(clearTimeout(de.timeoutTimer),de.request.type){case 100:this.q(de.request);break;case 102:this.s(de.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=p;var D;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(D=t.RequestInitiator||(t.RequestInitiator={}));class _{constructor(Q,le=null){this.l=Q,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(de=>this.r(de)),this.j=le}getChannel(Q){const le=this;return{call(de,me,ee){return le.a?Promise.reject(new w.CancellationError):le.m(Q,de,me,ee)},listen(de,me){return le.a?d.Event.None:le.n(Q,de,me)}}}m(Q,le,de,me=H.CancellationToken.None){const ee=this.g++,E={id:ee,type:100,channelName:Q,name:le,arg:de};if(me.isCancellationRequested)return Promise.reject(new w.CancellationError);let g;return new Promise((W,$)=>{if(me.isCancellationRequested)return $(new w.CancellationError);const Y=()=>{const S=I=>{switch(I.type){case 201:this.f.delete(ee),W(I.data);break;case 202:{this.f.delete(ee);const P=new Error(I.data.message);P.stack=Array.isArray(I.data.stack)?I.data.stack.join(`
`):I.data.stack,P.name=I.data.name,$(P);break}case 203:this.f.delete(ee),$(I.data);break}};this.f.set(ee,S),this.o(E)};let F=null;this.b===l.Idle?Y():(F=(0,i.createCancelablePromise)(S=>this.t()),F.then(()=>{F=null,Y()}));const B=()=>{F?(F.cancel(),F=null):this.o({id:ee,type:101}),$(new w.CancellationError)},z=me.onCancellationRequested(B);g=(0,m.combinedDisposable)((0,m.toDisposable)(B),z),this.d.add(g)}).finally(()=>{this.d.delete(g)})}n(Q,le,de){const me=this.g++,k={id:me,type:102,channelName:Q,name:le,arg:de};let E=null;const g=new d.Emitter({onWillAddFirstListener:()=>{E=(0,i.createCancelablePromise)(W=>this.t()),E.then(()=>{E=null,this.d.add(g),this.o(k)})},onDidRemoveLastListener:()=>{E?(E.cancel(),E=null):(this.d.delete(g),this.o({id:me,type:103}))}}),R=W=>g.fire(W.data);return this.f.set(me,R),g.event}o(Q){switch(Q.type){case 100:case 102:{const le=this.p([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(le,Q.id,0,`${e(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const le=this.p([Q.type,Q.id]);this.j?.logOutgoing(le,Q.id,0,e(Q.type));return}}}p(Q,le=void 0){const de=new r;return c(de,Q),c(de,le),this.q(de.buffer)}q(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}r(Q){const le=new h(Q),de=C(le),me=C(le),ee=de[0];switch(ee){case 200:return this.j?.logIncoming(Q.byteLength,0,0,a(ee)),this.s({type:de[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,de[1],0,a(ee),me),this.s({type:de[0],id:de[1],data:me})}}s(Q){if(Q.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}t(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}qe([y.memoize],_.prototype,"onDidInitializePromise",null),t.ChannelClient=_;class V{get connections(){const Q=[];return this.f.forEach(le=>Q.push(le)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new d.Emitter,this.onDidAddConnection=this.g.event,this.h=new d.Emitter,this.onDidRemoveConnection=this.h.event,Q(({protocol:le,onDidClientDisconnect:de})=>{d.Event.once(le.onMessage)(ee=>{const k=new h(ee),E=C(k),g=new p(le,E),R=new _(le);this.a.forEach(($,Y)=>g.registerChannel(Y,$));const W={channelServer:g,channelClient:R,ctx:E};this.f.add(W),this.g.fire(W),de(()=>{g.dispose(),R.dispose(),this.f.delete(W),this.h.fire(W)})})})}getChannel(Q,le){const de=this;return{call(me,ee,k){let E;if((0,o.isFunction)(le)){const R=(0,v.getRandomElement)(de.connections.filter(le));E=R?Promise.resolve(R):d.Event.toPromise(d.Event.filter(de.onDidAddConnection,le))}else E=le.routeCall(de,me,ee);const g=E.then(R=>R.channelClient.getChannel(Q));return Z(g).call(me,ee,k)},listen(me,ee){if((0,o.isFunction)(le))return de.j(Q,le,me,ee);const k=le.routeEvent(de,me,ee).then(E=>E.channelClient.getChannel(Q));return Z(k).listen(me,ee)}}}j(Q,le,de,me){const ee=this;let k=new m.DisposableStore;const E=new d.Emitter({onWillAddFirstListener:()=>{k=new m.DisposableStore;const g=new d.EventMultiplexer,R=new Map,W=Y=>{const B=Y.channelClient.getChannel(Q).listen(de,me),z=g.add(B);R.set(Y,z)},$=Y=>{const F=R.get(Y);!F||(F.dispose(),R.delete(Y))};ee.connections.filter(le).forEach(W),d.Event.filter(ee.onDidAddConnection,le)(W,void 0,k),ee.onDidRemoveConnection($,void 0,k),g.event(E.fire,E,k),k.add(g)},onDidRemoveLastListener:()=>{k.dispose()}});return E.event}registerChannel(Q,le){this.a.set(Q,le),this.f.forEach(de=>{de.channelServer.registerChannel(Q,le)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=V;class ge{constructor(Q,le,de=null){const me=new r;c(me,le),Q.send(me.buffer),this.a=new _(Q,de),this.d=new p(Q,le,de)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,le){this.d.registerChannel(Q,le)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=ge;function Z(se){return{call(Q,le,de){return se.then(me=>me.call(Q,le,de))},listen(Q,le){const de=new d.Relay;return se.then(me=>de.input=me.listen(Q,le)),de.event}}}t.getDelayedChannel=Z;function ie(se){let Q=!1;return{call(le,de,me){return Q?se.call(le,de,me):(0,i.timeout)(0).then(()=>Q=!0).then(()=>se.call(le,de,me))},listen(le,de){if(Q)return se.listen(le,de);const me=new d.Relay;return(0,i.timeout)(0).then(()=>Q=!0).then(()=>me.input=se.listen(le,de)),me.event}}}t.getNextTickChannel=ie;class te{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const le of Q.connections)if(await Promise.resolve(this.a(le.ctx)))return Promise.resolve(le);return await d.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}t.StaticRouter=te;var he;(function(se){function Q(ee,k){const E=ee,g=k&&k.disableMarshalling,R=new Map;for(const W in E)de(W)&&R.set(W,d.Event.buffer(E[W],!0));return new class{listen(W,$,Y){const F=R.get($);if(F)return F;if(me($)){const B=E[$];if(typeof B=="function")return B.call(E,Y)}throw new Error(`Event not found: ${$}`)}call(W,$,Y){const F=E[$];if(typeof F=="function"){if(!g&&Array.isArray(Y))for(let B=0;B<Y.length;B++)Y[B]=(0,f.revive)(Y[B]);return F.apply(E,Y)}throw new Error(`Method not found: ${$}`)}}}se.fromService=Q;function le(ee,k){const E=k&&k.disableMarshalling;return new Proxy({},{get(g,R){if(typeof R=="string")return k?.properties?.has(R)?k.properties.get(R):me(R)?function(W){return ee.listen(R,W)}:de(R)?ee.listen(R):async function(...W){let $;k&&!(0,o.isUndefinedOrNull)(k.context)?$=[k.context,...W]:$=W;const Y=await ee.call(R,$);return E?Y:(0,f.revive)(Y)};throw new Error(`Property not found: ${String(R)}`)}})}se.toService=le;function de(ee){return ee[0]==="o"&&ee[1]==="n"&&M.isUpperAsciiLetter(ee.charCodeAt(2))}function me(ee){return/^onDynamic/.test(ee)&&M.isUpperAsciiLetter(ee.charCodeAt(9))}})(he=t.ProxyChannel||(t.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const Q=se.toString();if(Q!=="[object Object]")return Q}return se}function Se(se){return Array.isArray(se)?se.map(ce):ce(se)}function x(se,Q,le,de,me,ee,k){k=Se(k);const E=re[me],g=E[de%E.length];let R=[`%c[${se}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(le).padStart(5," ")}]%c${String(de).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(ee)?(R=R.concat(k),R.push(")")):R.push(k),console.log.apply(console,R)}class De{constructor(Q,le){this.d=Q,this.f=le,this.a=0,this.b=0}logOutgoing(Q,le,de,me,ee){this.b+=Q,x(this.d,this.b,Q,le,de,me,ee)}logIncoming(Q,le,de,me,ee){this.a+=Q,x(this.f,this.a,Q,le,de,me,ee)}}t.IPCLogger=De}),define(be[27],pe([1,0,5]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=v.globals.vscode.ipcRenderer,t.ipcMessagePort=v.globals.vscode.ipcMessagePort,t.webFrame=v.globals.vscode.webFrame,t.process=v.globals.vscode.process,t.context=v.globals.vscode.context}),define(be[130],pe([1,0,81,27]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let U=0;function H(w,d,m){const f=[],M=U++,o=`vscode:onContextMenu${M}`,n=(e,s,a)=>{f[s].click?.(a)};i.ipcRenderer.once(o,n),i.ipcRenderer.once(v.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===M&&(i.ipcRenderer.removeListener(o,n),m?.())}),i.ipcRenderer.send(v.CONTEXT_MENU_CHANNEL,M,w.map(e=>y(e,f)),o,d)}t.popup=H;function y(w,d){const m={id:d.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return d.push(w),Array.isArray(w.submenu)&&(m.submenu=w.submenu.map(f=>y(f,d))),m}}),define(be[131],pe([1,0,29,3,37,82,27]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends U.IPCClient{static f(){const m=i.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:message",(f,M)=>v.VSBuffer.wrap(M));return y.ipcRenderer.send("vscode:hello"),new H.Protocol(y.ipcRenderer,m)}constructor(m){const f=w.f();super(f,m),this.b=f}dispose(){this.b.disconnect()}}t.Client=w}),define(be[132],pe([13,10]),function(X,t){return X.create("vs/platform/files/common/files",t)}),define(be[133],pe([13,10]),function(X,t){return X.create("vs/platform/theme/common/iconRegistry",t)}),define(be[65],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class v{constructor(U,H=[],y=!1){this.ctor=U,this.staticArguments=H,this.supportsDelayedInstantiation=y}}t.SyncDescriptor=v}),define(be[134],pe([1,0,65]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const i=[];var U;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(U=t.InstantiationType||(t.InstantiationType={}));function H(w,d,m){d instanceof v.SyncDescriptor||(d=new v.SyncDescriptor(d,[],Boolean(m))),i.push([w,d])}t.registerSingleton=H;function y(){return i}t.getSingletonServiceDescriptors=y}),define(be[28],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var v;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function w(d){return d[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=w})(v=t._util||(t._util={})),t.IInstantiationService=U("instantiationService");function i(y,w,d){w[v.DI_TARGET]===w?w[v.DI_DEPENDENCIES].push({id:y,index:d}):(w[v.DI_DEPENDENCIES]=[{id:y,index:d}],w[v.DI_TARGET]=w)}function U(y){if(v.serviceIds.has(y))return v.serviceIds.get(y);const w=function(d,m,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(w,d,f)};return w.toString=()=>y,v.serviceIds.set(y,w),w}t.createDecorator=U;function H(y){return y}t.refineServiceDecorator=H}),define(be[135],pe([1,0,28]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,v.createDecorator)(t.ID);function i(H){return!!H.hostName&&!!H.errorMessage}t.isRemoteDiagnosticError=i;class U{async getPerformanceInfo(y,w){return{}}async getSystemInfo(y,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,w){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}t.NullDiagnosticsService=U}),define(be[136],pe([1,0,113,21,11,6,15,132,28]),function(X,t,v,i,U,H,y,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,d.createDecorator)("fileService");function m(x){return x.create===!0}t.isFileOpenForWriteOptions=m;var f;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(f=t.FileType||(t.FileType={}));var M;(function(x){x[x.Readonly=1]="Readonly"})(M=t.FilePermission||(t.FilePermission={}));var o;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileClone=32768]="FileClone"})(o=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function n(x){return!!(x.capabilities&2)}t.hasReadWriteCapability=n;function e(x){return!!(x.capabilities&8)}t.hasFileFolderCopyCapability=e;function s(x){return!!(x.capabilities&32768)}t.hasFileCloneCapability=s;function a(x){return!!(x.capabilities&4)}t.hasOpenReadWriteCloseCapability=a;function l(x){return!!(x.capabilities&16)}t.hasFileReadStreamCapability=l;function h(x){return n(x)?!!(x.capabilities&16384):!1}t.hasFileAtomicReadCapability=h;var r;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(r=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class u extends Error{constructor(De,se){super(De),this.code=se}}t.FileSystemProviderError=u;function b(x,De){const se=new u(x.toString(),De);return N(se,De),se}t.createFileSystemProviderError=b;function A(x){return x||b((0,w.localize)(0,null),r.Unknown)}t.ensureFileSystemProviderError=A;function N(x,De){return x.name=De?`${De} (FileSystemError)`:"FileSystemError",x}t.markAsFileSystemProviderError=N;function L(x){if(!x)return r.Unknown;if(x instanceof u)return x.code;const De=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!De)return r.Unknown;switch(De[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileExceedsMemoryLimit:return r.FileExceedsMemoryLimit;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}t.toFileSystemProviderErrorCode=L;function T(x){if(x instanceof V)return x.fileOperationResult;switch(L(x)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 10;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileExceedsMemoryLimit:return 9;case r.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=T;var c;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(c=t.FileOperation||(t.FileOperation={}));class C{constructor(De,se,Q){this.resource=De,this.operation=se,this.target=Q}isOperation(De){return this.operation===De}}t.FileOperationEvent=C;var p;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(p=t.FileChangeType||(t.FileChangeType={}));class D{constructor(De,se){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=De;const Q=new Map;for(const le of De){const de=Q.get(le.type);switch(de?de.push([le.resource,le]):Q.set(le.type,[[le.resource,le]]),le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}}for(const[le,de]of Q)switch(le){case 1:this.a=v.TernarySearchTree.forUris(()=>se),this.a.fill(de);break;case 0:this.b=v.TernarySearchTree.forUris(()=>se),this.b.fill(de);break;case 2:this.c=v.TernarySearchTree.forUris(()=>se),this.c.fill(de);break}}contains(De,...se){return this.d(De,{includeChildren:!1},...se)}affects(De,...se){return this.d(De,{includeChildren:!0},...se)}d(De,se,...Q){if(!De)return!1;const le=Q.length>0;return!!((!le||Q.includes(1))&&(this.a?.get(De)||se.includeChildren&&this.a?.findSuperstr(De))||(!le||Q.includes(0))&&(this.b?.get(De)||se.includeChildren&&this.b?.findSuperstr(De))||(!le||Q.includes(2))&&(this.c?.findSubstr(De)||se.includeChildren&&this.c?.findSuperstr(De)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=D;function _(x,De,se){return!x||!De||x===De||De.length>x.length?!1:(De.charAt(De.length-1)!==i.sep&&(De+=i.sep),se?(0,U.startsWithIgnoreCase)(x,De):x.indexOf(De)===0)}t.isParent=_;class V extends Error{constructor(De,se,Q){super(De),this.fileOperationResult=se,this.options=Q}}t.FileOperationError=V;class ge extends V{constructor(De,se,Q){super(De,2,Q),this.stat=se}}t.NotModifiedSinceFileOperationError=ge;var Z;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Z=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var ie;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(ie=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function te(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}t.etag=te;async function he(x,De){if(!De.hasProvider(y.URI.from({scheme:x.scheme})))return new Promise(se=>{const Q=De.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===x.scheme&&le.added&&(Q.dispose(),se())})})}t.whenProviderRegistered=he,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(De){return(0,H.isNumber)(De)||(De=0),De<re.KB?(0,w.localize)(1,null,De.toFixed(0)):De<re.MB?(0,w.localize)(2,null,(De/re.KB).toFixed(2)):De<re.GB?(0,w.localize)(3,null,(De/re.MB).toFixed(2)):De<re.TB?(0,w.localize)(4,null,(De/re.GB).toFixed(2)):(0,w.localize)(5,null,(De/re.TB).toFixed(2))}}t.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var ce;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(ce=t.Arch||(t.Arch={}));function Se(x){return{maxFileSize:x===0?300*re.MB:16*re.GB,maxHeapSize:x===0?700*re.MB:2*700*re.MB}}t.getPlatformLimits=Se}),define(be[137],pe([1,0,2,131]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class U extends v.Disposable{constructor(y){super(),this.a=this.B(new i.Client(`window:${y}`))}getChannel(y){return this.a.getChannel(y)}registerChannel(y,w){this.a.registerChannel(y,w)}}t.ElectronIPCMainProcessService=U});var wt=this&&this.__param||function(X,t){return function(v,i){t(v,i,X)}};define(be[138],pe([1,0,37,65,134,28]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class y{constructor(n,e,s,a){const l=s.getChannel(n);return w(e)?a.createInstance(new i.SyncDescriptor(e.channelClientCtor,[l])):v.ProxyChannel.toService(l,e?.proxyOptions)}}function w(o){return!!o?.channelClientCtor}t.IMainProcessService=(0,H.createDecorator)("mainProcessService");let d=class extends y{constructor(n,e,s,a){super(n,e,s,a)}};d=qe([wt(2,t.IMainProcessService),wt(3,H.IInstantiationService)],d);function m(o,n,e){(0,U.registerSingleton)(o,new i.SyncDescriptor(d,[n,e],!0))}t.registerMainProcessRemoteService=m,t.ISharedProcessService=(0,H.createDecorator)("sharedProcessService");let f=class extends y{constructor(n,e,s,a){super(n,e,s,a)}};f=qe([wt(2,t.ISharedProcessService),wt(3,H.IInstantiationService)],f);function M(o,n,e){(0,U.registerSingleton)(o,new i.SyncDescriptor(f,[n,e],!0))}t.registerSharedProcessRemoteService=M}),define(be[139],pe([1,0,37,138]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let U=class{constructor(y,w){return this.windowId=y,v.ProxyChannel.toService(w.getChannel("nativeHost"),{context:y,properties:(()=>{const d=new Map;return d.set("windowId",y),d})()})}};U=qe([wt(1,i.IMainProcessService)],U),t.NativeHostService=U}),define(be[38],pe([1,0,72,6]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class U{constructor(){this.a=new Map}add(y,w){v.ok(i.isString(y)),v.ok(i.isObject(w)),v.ok(!this.a.has(y),"There is already an extension with this id"),this.a.set(y,w)}knows(y){return this.a.has(y)}as(y){return this.a.get(y)||null}}t.Registry=new U}),define(be[140],pe([1,0,3,38]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function U(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class H{constructor(){this.b=new v.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,m){this.a[U(d)]=m,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const y=new H;i.Registry.add(t.Extensions.JSONContribution,y)}),define(be[141],pe([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var v;(function(H){H.DARK="dark",H.LIGHT="light",H.HIGH_CONTRAST_DARK="hcDark",H.HIGH_CONTRAST_LIGHT="hcLight"})(v=t.ColorScheme||(t.ColorScheme={}));function i(H){return H===v.HIGH_CONTRAST_DARK||H===v.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function U(H){return H===v.DARK||H===v.HIGH_CONTRAST_DARK}t.isDark=U}),define(be[66],pe([1,0,12,3,2,28,38,141]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,H.createDecorator)("themeService");var d;(function(a){function l(h){return h&&typeof h=="object"&&typeof h.id=="string"}a.isThemeColor=l})(d=t.ThemeColor||(t.ThemeColor={}));function m(a){return{id:a}}t.themeColorFromId=m;var f;(function(a){function l(T){return T&&typeof T=="object"&&typeof T.id=="string"&&(typeof T.color>"u"||d.isThemeColor(T.color))}a.isThemeIcon=l;const h=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function r(T){const c=h.exec(T);if(!c)return;const[,C]=c;return{id:C}}a.fromString=r;function u(T){return{id:T}}a.fromId=u;function b(T,c){let C=T.id;const p=C.lastIndexOf("~");return p!==-1&&(C=C.substring(0,p)),c&&(C=`${C}~${c}`),{id:C}}a.modify=b;function A(T){const c=T.id.lastIndexOf("~");if(c!==-1)return T.id.substring(c+1)}a.getModifier=A;function N(T,c){return T.id===c.id&&T.color?.id===c.color?.id}a.isEqual=N;function L(T,c){return{id:T.id,color:c?m(c):void 0}}a.asThemeIcon=L,a.asClassNameArray=v.CSSIcon.asClassNameArray,a.asClassName=v.CSSIcon.asClassName,a.asCSSSelector=v.CSSIcon.asCSSSelector})(f=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=v.Codicon.file,t.FolderThemeIcon=v.Codicon.folder;function M(a){switch(a){case w.ColorScheme.DARK:return"vs-dark";case w.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case w.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=M,t.Extensions={ThemingContribution:"base.contributions.theming"};class o{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,U.toDisposable)(()=>{const h=this.a.indexOf(l);this.a.splice(h,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const n=new o;y.Registry.add(t.Extensions.ThemingContribution,n);function e(a){return n.onColorThemeChange(a)}t.registerThemingParticipant=e;class s extends U.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(h=>this.n(h)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,h){let r=this.h.getColor(l);return r&&h&&(r=h(r,this.h)),r?r.toString():null}}t.Themable=s}),define(be[142],pe([1,0,8,12,3,6,15,133,140,38,66]),function(X,t,v,i,U,H,y,w,d,m,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var M;(function(u){function b(A,N){let L=A.defaults;for(;f.ThemeIcon.isThemeIcon(L);){const T=e.getIcon(L.id);if(!T)return;L=T.defaults}return L}u.getDefinition=b})(M=t.IconContribution||(t.IconContribution={}));var o;(function(u){function b(N){return{weight:N.weight,style:N.style,src:N.src.map(L=>({format:L.format,location:L.location.toString()}))}}u.toJSONObject=b;function A(N){const L=T=>(0,H.isString)(T)?T:void 0;if(N&&Array.isArray(N.src)&&N.src.every(T=>(0,H.isString)(T.format)&&(0,H.isString)(T.location)))return{weight:L(N.weight),style:L(N.style),src:N.src.map(T=>({format:T.format,location:y.URI.parse(T.location)}))}}u.fromJSONObject=A})(o=t.IconFontDefinition||(t.IconFontDefinition={}));class n{constructor(){this.a=new U.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,A,N,L){const T=this.b[b];if(T){if(N&&!T.description){T.description=N,this.d.properties[b].markdownDescription=`${N} $(${b})`;const p=this.e.enum.indexOf(b);p!==-1&&(this.e.enumDescriptions[p]=N),this.a.fire()}return T}const c={id:b,description:N,defaults:A,deprecationMessage:L};this.b[b]=c;const C={$ref:"#/definitions/icons"};return L&&(C.deprecationMessage=L),N&&(C.markdownDescription=`${N}: $(${b})`),this.d.properties[b]=C,this.e.enum.push(b),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const A=this.e.enum.indexOf(b);A!==-1&&(this.e.enum.splice(A,1),this.e.enumDescriptions.splice(A,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,A){const N=this.f[b];return N||(this.f[b]=A,this.a.fire(),A)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(T,c)=>T.id.localeCompare(c.id),A=T=>{for(;f.ThemeIcon.isThemeIcon(T.defaults);)T=this.b[T.defaults.id];return`codicon codicon-${T?T.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const L=Object.keys(this.b).map(T=>this.b[T]);for(const T of L.filter(c=>!!c.description).sort(b))N.push(`|<i class="${A(T)}"></i>|${T.id}|${f.ThemeIcon.isThemeIcon(T.defaults)?T.defaults.id:T.id}|${T.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const T of L.filter(c=>!f.ThemeIcon.isThemeIcon(c.defaults)).sort(b))N.push(`|<i class="${A(T)}"></i>|${T.id}|`);return N.join(`
`)}}const e=new n;m.Registry.add(t.Extensions.IconContribution,e);function s(u,b,A,N){return e.registerIcon(u,b,A,N)}t.registerIcon=s;function a(){return e}t.getIconRegistry=a;function l(){for(const u of i.Codicon.getAll())e.registerIcon(u.id,u.definition,u.description)}l(),t.iconsSchemaId="vscode://schemas/icons";const h=m.Registry.as(d.Extensions.JSONContribution);h.registerSchema(t.iconsSchemaId,e.getIconSchema());const r=new v.RunOnceScheduler(()=>h.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.widgetClose=s("widget-close",i.Codicon.close,(0,w.localize)(2,null)),t.gotoPreviousLocation=s("goto-previous-location",i.Codicon.arrowUp,(0,w.localize)(3,null)),t.gotoNextLocation=s("goto-next-location",i.Codicon.arrowDown,(0,w.localize)(4,null)),t.syncing=f.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=f.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(be[143],pe([1,0,4,3,142,66]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function y(d){const m=new i.Emitter,f=(0,U.getIconRegistry)();return f.onDidChange(()=>m.fire()),d?.onDidProductIconThemeChange(()=>m.fire()),{onDidChange:m.event,getCSS(){const M=d?d.getProductIconTheme():new w,o={},n=s=>{const a=M.getIcon(s);if(!a)return;const l=a.font;return l?(o[l.id]=l.definition,`.codicon-${s.id}:before { content: '${a.fontCharacter}'; font-family: ${(0,v.asCSSPropertyValue)(l.id)}; }`):`.codicon-${s.id}:before { content: '${a.fontCharacter}'; }`},e=[];for(const s of f.getIcons()){const a=n(s);a&&e.push(a)}for(const s in o){const a=o[s],l=a.weight?`font-weight: ${a.weight};`:"",h=a.style?`font-style: ${a.style};`:"",r=a.src.map(u=>`${(0,v.asCSSUrl)(u.location)} format('${u.format}')`).join(", ");e.push(`@font-face { src: ${r}; font-family: ${(0,v.asCSSPropertyValue)(s)};${l}${h} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=y;class w{getIcon(m){const f=(0,U.getIconRegistry)();let M=m.defaults;for(;H.ThemeIcon.isThemeIcon(M);){const o=f.getIcon(M.id);if(!o)return;M=o.defaults}return M}}t.UnthemedProductIconTheme=w}),define(be[144],pe([1,0,5]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(f){return!!f.workspaceUri}t.isWorkspaceToOpen=i;function U(f){return!!f.folderUri}t.isFolderToOpen=U;function H(f){return!!f.fileUri}t.isFileToOpen=H;function y(f){const M=w(f),o=f.getValue("window.menuBarVisibility");return o==="default"||M==="native"&&o==="compact"||v.isMacintosh&&v.isNative?"classic":o}t.getMenuBarVisibility=y;function w(f){if(v.isWeb)return"custom";const M=f.getValue("window");if(M){if(v.isMacintosh&&M.nativeTabs===!0||v.isMacintosh&&M.nativeFullScreen===!1)return"native";const e=M.titleBarStyle;if(e==="native"||e==="custom")return e}return v.isLinux?"native":"custom"}t.getTitleBarStyle=w;function d(f){if(!v.isWindows||v.isWeb||w(f)==="native")return!1;const M=f.getValue("window.experimental.windowControlsOverlay.enabled");return typeof M=="boolean"?M:!0}t.useWindowControlsOverlay=d;function m(f=0){return Math.pow(1.2,f)}t.zoomLevelToZoomFactor=m}),define(be[145],pe([1,0,16,27,144]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function H(d){i.webFrame.setZoomLevel(d),(0,v.setZoomFactor)((0,U.zoomLevelToZoomFactor)(d)),(0,v.setZoomLevel)(d,!1)}t.applyZoom=H;function y(){H((0,v.getZoomLevel)()+1)}t.zoomIn=y;function w(){H((0,v.getZoomLevel)()-1)}t.zoomOut=w}),define(be[146],pe([1,0,10,4,129,8,130,27,135,136,137,139,143,145,95,86]),function(X,t,v,i,U,H,y,w,d,m,f,M,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,s=/\s--(inspect|debug)-port=(\d+)/;class a{getHeight(D){return 22}getTemplateId(D){return L(D)?"process":A(D)?"machine":(0,d.isRemoteDiagnosticError)(D)?"error":N(D)?"header":""}}class l{hasChildren(D){return(0,d.isRemoteDiagnosticError)(D)?!1:L(D)?!!D.children?.length:!0}getChildren(D){return L(D)?D.children?D.children:[]:(0,d.isRemoteDiagnosticError)(D)?[]:N(D)?D.processRoots.length>1?D.processRoots:[D.processRoots[0].rootProcess]:A(D)?[D.rootProcess]:[D.processes]}}class h{constructor(){this.templateId="header"}renderTemplate(D){const _=Object.create(null),V=(0,i.append)(D,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_.CPU=(0,i.append)(V,(0,i.$)(".cpu")),_.memory=(0,i.append)(V,(0,i.$)(".memory")),_.PID=(0,i.append)(V,(0,i.$)(".pid")),_}renderElement(D,_,V,ge){V.name.textContent=(0,v.localize)(0,null),V.CPU.textContent=(0,v.localize)(1,null),V.PID.textContent=(0,v.localize)(2,null),V.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(D){}}class r{constructor(){this.templateId="machine"}renderTemplate(D){const _=Object.create(null),V=(0,i.append)(D,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_}renderElement(D,_,V,ge){V.name.textContent=D.element.name}disposeTemplate(D){}}class u{constructor(){this.templateId="error"}renderTemplate(D){const _=Object.create(null),V=(0,i.append)(D,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_}renderElement(D,_,V,ge){V.name.textContent=D.element.errorMessage}disposeTemplate(D){}}class b{constructor(D,_,V){this.a=D,this.b=_,this.c=V,this.templateId="process"}renderTemplate(D){const _=Object.create(null),V=(0,i.append)(D,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_.CPU=(0,i.append)(V,(0,i.$)(".cpu")),_.memory=(0,i.append)(V,(0,i.$)(".memory")),_.PID=(0,i.append)(V,(0,i.$)(".pid")),_}renderElement(D,_,V,ge){const{element:Z}=D;let ie=Z.name;ie==="window"&&(ie=this.c.get(Z.pid)!==void 0?`${ie} (${this.c.get(Z.pid)})`:ie);const te=Z.pid.toFixed(0);V.name.textContent=ie,V.name.title=Z.cmd,V.CPU.textContent=Z.load.toFixed(0),V.PID.textContent=te,V.PID.parentElement.id=`pid-${te}`;const he=this.a==="win32"?Z.mem:this.b*(Z.mem/100);V.memory.textContent=(he/m.ByteSize.MB).toFixed(0)}disposeTemplate(D){}}function A(p){return!!p.name&&!!p.rootProcess}function N(p){return!!p.processRoots}function L(p){return!!p.pid}class T{constructor(D,_){this.f=_,this.b=new Map;const V=new f.ElectronIPCMainProcessService(D);this.c=new M.NativeHostService(D,V),this.k(_.styles),this.g(_),w.ipcRenderer.on("vscode:windowsInfoResponse",(ge,Z)=>{this.b=new Map,Z.forEach(ie=>this.b.set(ie.pid,ie.title))}),w.ipcRenderer.on("vscode:listProcessesResponse",async(ge,Z)=>{Z.forEach((ie,te)=>{L(ie.rootProcess)&&(ie.rootProcess.name=te===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Z}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(Z),this.m(0)}),this.a=Date.now(),w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")}g(D){document.onkeydown=_=>{const V=D.platform==="darwin"?_.metaKey:_.ctrlKey;V&&_.keyCode===87&&(_.stopPropagation(),_.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),V&&_.keyCode===187&&(0,n.zoomIn)(),V&&_.keyCode===189&&(0,n.zoomOut)()}}async h(D){const _=document.getElementById("process-list");if(!_)return;const{totalmem:V}=await this.c.getOSStatistics(),ge=[new b(this.f.platform,V,this.b),new h,new r,new u];this.d=new U.DataTree("processExplorer",_,new a,ge,new l,{identityProvider:{getId:Z=>L(Z)?Z.pid.toString():(0,d.isRemoteDiagnosticError)(Z)?Z.hostName:N(Z)?"processes":A(Z)?Z.name:"header"}}),this.d.setInput({processes:{processRoots:D}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onContextMenu(Z=>{L(Z.element)&&this.l(Z.element,!0)}),_.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{_.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(D){const _=e.exec(D);return _&&_.length>=2||D.indexOf("node ")>=0||D.indexOf("node.exe")>=0}j(D){const _={type:"node",request:"attach",name:`process ${D.pid}`};let V=e.exec(D.cmd);V&&V.length>=2?(V.length===4&&V[3]&&(_.port=parseInt(V[3])),_.protocol=V[1]==="debug"?"legacy":"inspector"):_.processId=String(D.pid),V=s.exec(D.cmd),V&&V.length===3&&(_.port=parseInt(V[2])),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[_]})}k(D){const _=(0,i.createStyleSheet)(),V=[];D.listFocusBackground&&(V.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${D.listFocusBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${D.listFocusBackground}; }`)),D.listFocusForeground&&V.push(`.monaco-list:focus .monaco-list-row.focused { color: ${D.listFocusForeground}; }`),D.listActiveSelectionBackground&&(V.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${D.listActiveSelectionBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${D.listActiveSelectionBackground}; }`)),D.listActiveSelectionForeground&&V.push(`.monaco-list:focus .monaco-list-row.selected { color: ${D.listActiveSelectionForeground}; }`),D.listHoverBackground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${D.listHoverBackground}; }`),D.listHoverForeground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${D.listHoverForeground}; }`),D.listFocusOutline&&V.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${D.listFocusOutline}; outline-offset: -1px; }`),D.listHoverOutline&&V.push(`.monaco-list-row:hover { outline: 1px dashed ${D.listHoverOutline}; outline-offset: -1px; }`),D.scrollbarShadowColor&&V.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${D.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${D.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${D.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),D.scrollbarSliderBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${D.scrollbarSliderBackgroundColor};
				}
			`),D.scrollbarSliderHoverBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${D.scrollbarSliderHoverBackgroundColor};
				}
			`),D.scrollbarSliderActiveBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${D.scrollbarSliderActiveBackgroundColor};
				}
			`),_.textContent=V.join(`
`),D.color&&(document.body.style.color=D.color)}l(D,_){const V=[],ge=Number(D.pid);_&&(V.push({label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(ge,"SIGTERM")}}),V.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(ge,"SIGKILL")}}),V.push({type:"separator"})),V.push({label:(0,v.localize)(6,null),click:()=>{const Z=this.d?.getSelection()?.map(te=>{if(!(!te||!("pid"in te)))return te.pid}).filter(te=>!!te);Z?.includes(ge)||(Z.length=0,Z.push(ge));const ie=Z?.map(te=>document.getElementById(`pid-${te}`)).filter(te=>!!te);if(ie){const te=ie.map(he=>he.innerText).filter(he=>!!he);this.c.writeClipboardText(te.join(`
`))}}}),V.push({label:(0,v.localize)(7,null),click:()=>{const Z=document.getElementById("process-list");Z&&this.c.writeClipboardText(Z.innerText)}}),D&&_&&this.i(D.cmd)&&(V.push({type:"separator"}),V.push({label:(0,v.localize)(8,null),click:()=>{this.j(D)}})),(0,y.popup)(V)}m(D){setTimeout(()=>{const _=Date.now(),V=D+_-this.a;this.a=_,V>1e3?(w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.m(V)},200)}}function c(){const p=(0,i.createStyleSheet)();p.id="codiconStyles";const D=(0,o.getIconsStyleSheet)(void 0);function _(){p.textContent=D.getCSS()}const V=new H.RunOnceScheduler(_,0);D.onDidChange(()=>V.schedule()),V.schedule()}function C(p){const D=p.data.platform==="win32"?"windows":p.data.platform==="linux"?"linux":"mac";document.body.classList.add(D),c(),(0,n.applyZoom)(p.data.zoomLevel),new T(p.windowId,p.data)}t.startup=C})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
