/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(te){for(var e=[],n=0,T=te.length;n<T;n++)e[n]=Ie[te[n]];return e};define(Ie[78],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(C,R){const S=Object.create(null);for(const k of C){const O=R(k);let D=S[O];D||(D=S[O]=[]),D.push(k)}return S}e.groupBy=n;function T(C,R){const S=[],k=[];for(const O of C)R.has(O)||S.push(O);for(const O of R)C.has(O)||k.push(O);return{removed:S,added:k}}e.diffSets=T;function y(C,R){const S=[],k=[];for(const[O,D]of C)R.has(O)||S.push(D);for(const[O,D]of R)C.has(O)||k.push(D);return{removed:S,added:k}}e.diffMaps=y;class L{constructor(){this.a=new Map}add(R,S){let k=this.a.get(R);k||(k=new Set,this.a.set(R,k)),k.add(S)}delete(R,S){const k=this.a.get(R);!k||(k.delete(S),k.size===0&&this.a.delete(R))}forEach(R,S){const k=this.a.get(R);!k||k.forEach(S)}}e.SetMap=L}),define(Ie[60],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(C){return(R,S,k)=>{let O=null,D=null;if(typeof k.value=="function"?(O="value",D=k.value):typeof k.get=="function"&&(O="get",D=k.get),!D)throw new Error("not supported");k[O]=C(D,S)}}function T(C,R,S){let k=null,O=null;if(typeof S.value=="function"?(k="value",O=S.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",O=S.get),!O)throw new Error("not supported");const D=`$memoize$${R}`;S[k]=function(...f){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,f)}),this[D]}}e.memoize=T;function y(C,R,S){return n((k,O)=>{const D=`$debounce$${O}`,f=`$debounce$result$${O}`;return function(...v){this[f]||(this[f]=S?S():void 0),clearTimeout(this[D]),R&&(this[f]=R(this[f],...v),v=[this[f]]),this[D]=setTimeout(()=>{k.apply(this,v),this[f]=S?S():void 0},C)}})}e.debounce=y;function L(C,R,S){return n((k,O)=>{const D=`$throttle$timer$${O}`,f=`$throttle$result$${O}`,v=`$throttle$lastRun$${O}`,h=`$throttle$pending$${O}`;return function(...i){if(this[f]||(this[f]=S?S():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...i)),this[h])return;const o=this[v]+C;o<=Date.now()?(this[v]=Date.now(),k.apply(this,[this[f]]),this[f]=S?S():void 0):(this[h]=!0,this[D]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),k.apply(this,[this[f]]),this[f]=S?S():void 0},o-Date.now()))}})}e.throttle=L}),define(Ie[79],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(y){this.a=y,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Ie[107],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var T;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(s){s.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function C(s,r=!1){let a=0;const d=s.length;let c="",u=0,t=16,m=0;function p(M){let F=0,$=0;for(;F<M;){const z=s.charCodeAt(a);if(z>=48&&z<=57)$=$*16+z-48;else if(z>=65&&z<=70)$=$*16+z-65+10;else if(z>=97&&z<=102)$=$*16+z-97+10;else break;a++,F++}return F<M&&($=-1),$}function A(M){a=M,c="",u=0,t=16,m=0}function N(){const M=a;if(s.charCodeAt(a)===48)a++;else for(a++;a<s.length&&k(s.charCodeAt(a));)a++;if(a<s.length&&s.charCodeAt(a)===46)if(a++,a<s.length&&k(s.charCodeAt(a)))for(a++;a<s.length&&k(s.charCodeAt(a));)a++;else return m=3,s.substring(M,a);let F=a;if(a<s.length&&(s.charCodeAt(a)===69||s.charCodeAt(a)===101))if(a++,(a<s.length&&s.charCodeAt(a)===43||s.charCodeAt(a)===45)&&a++,a<s.length&&k(s.charCodeAt(a))){for(a++;a<s.length&&k(s.charCodeAt(a));)a++;F=a}else m=3;return s.substring(M,F)}function q(){let M="",F=a;for(;;){if(a>=d){M+=s.substring(F,a),m=2;break}const $=s.charCodeAt(a);if($===34){M+=s.substring(F,a),a++;break}if($===92){if(M+=s.substring(F,a),a++,a>=d){m=2;break}switch(s.charCodeAt(a++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const K=p(4);K>=0?M+=String.fromCharCode(K):m=4;break}default:m=5}F=a;continue}if($>=0&&$<=31)if(S($)){M+=s.substring(F,a),m=2;break}else m=6;a++}return M}function j(){if(c="",m=0,u=a,a>=d)return u=d,t=17;let M=s.charCodeAt(a);if(R(M)){do a++,c+=String.fromCharCode(M),M=s.charCodeAt(a);while(R(M));return t=15}if(S(M))return a++,c+=String.fromCharCode(M),M===13&&s.charCodeAt(a)===10&&(a++,c+=`
`),t=14;switch(M){case 123:return a++,t=1;case 125:return a++,t=2;case 91:return a++,t=3;case 93:return a++,t=4;case 58:return a++,t=6;case 44:return a++,t=5;case 34:return a++,c=q(),t=10;case 47:{const F=a-1;if(s.charCodeAt(a+1)===47){for(a+=2;a<d&&!S(s.charCodeAt(a));)a++;return c=s.substring(F,a),t=12}if(s.charCodeAt(a+1)===42){a+=2;const $=d-1;let z=!1;for(;a<$;){if(s.charCodeAt(a)===42&&s.charCodeAt(a+1)===47){a+=2,z=!0;break}a++}return z||(a++,m=1),c=s.substring(F,a),t=13}return c+=String.fromCharCode(M),a++,t=16}case 45:if(c+=String.fromCharCode(M),a++,a===d||!k(s.charCodeAt(a)))return t=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=N(),t=11;default:for(;a<d&&V(M);)a++,M=s.charCodeAt(a);if(u!==a){switch(c=s.substring(u,a),c){case"true":return t=8;case"false":return t=9;case"null":return t=7}return t=16}return c+=String.fromCharCode(M),a++,t=16}}function V(M){if(R(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function P(){let M;do M=j();while(M>=12&&M<=15);return M}return{setPosition:A,getPosition:()=>a,scan:r?P:j,getToken:()=>t,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>a-u,getTokenError:()=>m}}e.createScanner=C;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function k(s){return s>=48&&s<=57}var O;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(O||(O={}));function D(s,r){const a=[],d=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let t=!1;function m(p,A,N,q){u.value=p,u.offset=A,u.length=N,u.type=q,u.colonOffset=void 0,c=u}try{b(s,{onObjectBegin:(p,A)=>{if(r<=p)throw d;c=void 0,t=r>p,a.push("")},onObjectProperty:(p,A,N)=>{if(r<A||(m(p,A,N,"property"),a[a.length-1]=p,r<=A+N))throw d},onObjectEnd:(p,A)=>{if(r<=p)throw d;c=void 0,a.pop()},onArrayBegin:(p,A)=>{if(r<=p)throw d;c=void 0,a.push(0)},onArrayEnd:(p,A)=>{if(r<=p)throw d;c=void 0,a.pop()},onLiteralValue:(p,A,N)=>{if(r<A||(m(p,A,N,w(p)),r<=A+N))throw d},onSeparator:(p,A,N)=>{if(r<=A)throw d;if(p===":"&&c&&c.type==="property")c.colonOffset=A,t=!1,c=void 0;else if(p===","){const q=a[a.length-1];typeof q=="number"?a[a.length-1]=q+1:(t=!0,a[a.length-1]=""),c=void 0}}})}catch(p){if(p!==d)throw p}return{path:a,previousNode:c,isAtPropertyKey:t,matches:p=>{let A=0;for(let N=0;A<p.length&&N<a.length;N++)if(p[A]===a[N]||p[A]==="*")A++;else if(p[A]!=="**")return!1;return A===p.length}}}e.getLocation=D;function f(s,r=[],a=L.DEFAULT){let d=null,c=[];const u=[];function t(p){Array.isArray(c)?c.push(p):d!==null&&(c[d]=p)}return b(s,{onObjectBegin:()=>{const p={};t(p),u.push(c),c=p,d=null},onObjectProperty:p=>{d=p},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const p=[];t(p),u.push(c),c=p,d=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:t,onError:(p,A,N)=>{r.push({error:p,offset:A,length:N})}},a),c[0]}e.parse=f;function v(s,r=[],a=L.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(p){d.type==="property"&&(d.length=p-d.offset,d=d.parent)}function u(p){return d.children.push(p),p}b(s,{onObjectBegin:p=>{d=u({type:"object",offset:p,length:-1,parent:d,children:[]})},onObjectProperty:(p,A,N)=>{d=u({type:"property",offset:A,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:p,offset:A,length:N,parent:d})},onObjectEnd:(p,A)=>{d.length=p+A-d.offset,d=d.parent,c(p+A)},onArrayBegin:(p,A)=>{d=u({type:"array",offset:p,length:-1,parent:d,children:[]})},onArrayEnd:(p,A)=>{d.length=p+A-d.offset,d=d.parent,c(p+A)},onLiteralValue:(p,A,N)=>{u({type:w(p),offset:A,length:N,parent:d,value:p}),c(A+N)},onSeparator:(p,A,N)=>{d.type==="property"&&(p===":"?d.colonOffset=A:p===","&&c(A))},onError:(p,A,N)=>{r.push({error:p,offset:A,length:N})}},a);const m=d.children[0];return m&&delete m.parent,m}e.parseTree=v;function h(s,r){if(!s)return;let a=s;for(const d of r)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const u of a.children)if(Array.isArray(u.children)&&u.children[0].value===d){a=u.children[1],c=!0;break}if(!c)return}else{const c=d;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.findNodeAtLocation=h;function i(s){if(!s.parent||!s.parent.children)return[];const r=i(s.parent);if(s.parent.type==="property"){const a=s.parent.children[0].value;r.push(a)}else if(s.parent.type==="array"){const a=s.parent.children.indexOf(s);a!==-1&&r.push(a)}return r}e.getNodePath=i;function o(s){switch(s.type){case"array":return s.children.map(o);case"object":{const r=Object.create(null);for(const a of s.children){const d=a.children[1];d&&(r[a.children[0].value]=o(d))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=o;function l(s,r,a=!1){return r>=s.offset&&r<s.offset+s.length||a&&r===s.offset+s.length}e.contains=l;function E(s,r,a=!1){if(l(s,r,a)){const d=s.children;if(Array.isArray(d))for(let c=0;c<d.length&&d[c].offset<=r;c++){const u=E(d[c],r,a);if(u)return u}return s}}e.findNodeAtOffset=E;function b(s,r,a=L.DEFAULT){const d=C(s,!1);function c(ce){return ce?()=>ce(d.getTokenOffset(),d.getTokenLength()):()=>!0}function u(ce){return ce?fe=>ce(fe,d.getTokenOffset(),d.getTokenLength()):()=>!0}const t=c(r.onObjectBegin),m=u(r.onObjectProperty),p=c(r.onObjectEnd),A=c(r.onArrayBegin),N=c(r.onArrayEnd),q=u(r.onLiteralValue),j=u(r.onSeparator),V=c(r.onComment),P=u(r.onError),M=a&&a.disallowComments,F=a&&a.allowTrailingComma;function $(){for(;;){const ce=d.scan();switch(d.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:M||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ce){case 12:case 13:M?z(10):V();break;case 16:z(1);break;case 15:case 14:break;default:return ce}}}function z(ce,fe=[],Y=[]){if(P(ce),fe.length+Y.length>0){let ge=d.getToken();for(;ge!==17;){if(fe.indexOf(ge)!==-1){$();break}else if(Y.indexOf(ge)!==-1)break;ge=$()}}}function K(ce){const fe=d.getTokenValue();return ce?q(fe):m(fe),$(),!0}function X(){switch(d.getToken()){case 11:{let ce=0;try{ce=JSON.parse(d.getTokenValue()),typeof ce!="number"&&(z(2),ce=0)}catch{z(2)}q(ce);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return $(),!0}function Z(){return d.getToken()!==10?(z(3,[],[2,5]),!1):(K(!1),d.getToken()===6?(j(":"),$(),ue()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function he(){t(),$();let ce=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(ce||z(4,[],[]),j(","),$(),d.getToken()===2&&F)break}else ce&&z(6,[],[]);Z()||z(4,[],[2,5]),ce=!0}return p(),d.getToken()!==2?z(7,[2],[]):$(),!0}function oe(){A(),$();let ce=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(ce||z(4,[],[]),j(","),$(),d.getToken()===4&&F)break}else ce&&z(6,[],[]);ue()||z(4,[],[4,5]),ce=!0}return N(),d.getToken()!==4?z(8,[4],[]):$(),!0}function ue(){switch(d.getToken()){case 3:return oe();case 1:return he();case 10:return K(!0);default:return X()}}return $(),d.getToken()===17?a.allowEmptyContent?!0:(z(4,[],[]),!1):ue()?(d.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=b;function g(s,r){const a=C(s),d=[];let c,u=0,t;do switch(t=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:u!==t&&d.push(s.substring(u,t)),r!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,r)),u=a.getPosition();break}while(c!==17);return d.join("")}e.stripComments=g;function w(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(Ie[28],Ce([1,0]),function(te,e){"use strict";var n,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(h,i,o){let l=h.get(i);return l===void 0&&(l=o,h.set(i,l)),l}e.getOrSet=L;function C(h){const i=[];return h.forEach((o,l)=>{i.push(`${l} => ${o}`)}),`Map(${h.size}) {${i.join(", ")}}`}e.mapToString=C;function R(h){const i=[];return h.forEach(o=>{i.push(o)}),`Set(${h.size}) {${i.join(", ")}}`}e.setToString=R;class S{constructor(i,o){this.uri=i,this.value=o}}class k{constructor(i,o){this[n]="ResourceMap",i instanceof k?(this.b=new Map(i.b),this.c=o??k.a):(this.b=new Map,this.c=i??k.a)}set(i,o){return this.b.set(this.c(i),new S(i,o)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,o){typeof o<"u"&&(i=i.bind(o));for(const[l,E]of this.b)i(E.value,E.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.ResourceMap=k,k.a=h=>h.toString();class O{constructor(i,o){this[T]="ResourceSet",!i||typeof i=="function"?this.a=new k(i):(this.a=new k(o),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,o){this.a.forEach((l,E)=>i.call(o,E,E,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var D;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class f{constructor(){this[y]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,o=0){const l=this.a.get(i);if(!!l)return o!==0&&this.j(l,o),l.value}set(i,o,l=0){let E=this.a.get(i);if(E)E.value=o,l!==0&&this.j(E,l);else{switch(E={key:i,value:o,next:void 0,previous:void 0},l){case 0:this.h(E);break;case 1:this.g(E);break;case 2:this.h(E);break;default:this.h(E);break}this.a.set(i,E),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this.a.get(i);if(!!o)return this.a.delete(i),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,o){const l=this.e;let E=this.b;for(;E;){if(o?i.bind(o)(E.value,E.key,this):i(E.value,E.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const i=this,o=this.e;let l=this.b;const E={[Symbol.iterator](){return E},next(){if(i.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return E}values(){const i=this,o=this.e;let l=this.b;const E={[Symbol.iterator](){return E},next(){if(i.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return E}entries(){const i=this,o=this.e;let l=this.b;const E={[Symbol.iterator](){return E},next(){if(i.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return E}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this.b,l=this.size;for(;o&&l>i;)this.a.delete(o.key),o=o.next,l--;this.b=o,this.d=l,o&&(o.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const o=i.next,l=i.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}i.next=void 0,i.previous=void 0,this.e++}j(i,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this.b)return;const l=i.next,E=i.previous;i===this.c?(E.next=void 0,this.c=E):(l.previous=E,E.next=l),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(o===2){if(i===this.c)return;const l=i.next,E=i.previous;i===this.b?(l.previous=void 0,this.b=l):(l.previous=E,E.next=l),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((o,l)=>{i.push([l,o])}),i}fromJSON(i){this.clear();for(const[o,l]of i)this.set(o,l)}}e.LinkedMap=f;class v extends f{constructor(i,o=1){super(),this.k=i,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=v}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[108],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Te,De){for(var ke=0;ke<De.length;ke++){var re=De[ke];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Te,re.key,re)}}function n(Te,De,ke){return De&&e(Te.prototype,De),ke&&e(Te,ke),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function T(Te,De){if(!!Te){if(typeof Te=="string")return y(Te,De);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return y(Te,De)}}function y(Te,De){(De==null||De>Te.length)&&(De=Te.length);for(var ke=0,re=new Array(De);ke<De;ke++)re[ke]=Te[ke];return re}function L(Te,De){var ke=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=T(Te))||De&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var re=0;return function(){return re>=Te.length?{done:!0}:{done:!1,value:Te[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=C();function R(Te){te.defaults=Te}var S=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(De){return f[De]};function h(Te,De){if(De){if(S.test(Te))return Te.replace(k,v)}else if(O.test(Te))return Te.replace(D,v);return Te}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Te){return Te.replace(i,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var l=/(^|[^\[])\^/g;function E(Te,De){Te=typeof Te=="string"?Te:Te.source,De=De||"";var ke={replace:function(ae,J){return J=J.source||J,J=J.replace(l,"$1"),Te=Te.replace(ae,J),ke},getRegex:function(){return new RegExp(Te,De)}};return ke}var b=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Te,De,ke){if(Te){var re;try{re=decodeURIComponent(o(ke)).replace(b,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}De&&!g.test(ke)&&(ke=c(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var s={},r=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Te,De){s[" "+Te]||(r.test(Te)?s[" "+Te]=Te+"/":s[" "+Te]=p(Te,"/",!0)),Te=s[" "+Te];var ke=Te.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:Te.replace(a,"$1")+De:De.charAt(0)==="/"?ke?De:Te.replace(d,"$1")+De:Te+De}var u={exec:function(){}};function t(Te){for(var De=1,ke,re;De<arguments.length;De++){ke=arguments[De];for(re in ke)Object.prototype.hasOwnProperty.call(ke,re)&&(Te[re]=ke[re])}return Te}function m(Te,De){var ke=Te.replace(/\|/g,function(J,I,U){for(var H=!1,G=I;--G>=0&&U[G]==="\\";)H=!H;return H?"|":" |"}),re=ke.split(/ \|/),ae=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>De)re.splice(De);else for(;re.length<De;)re.push("");for(;ae<re.length;ae++)re[ae]=re[ae].trim().replace(/\\\|/g,"|");return re}function p(Te,De,ke){var re=Te.length;if(re===0)return"";for(var ae=0;ae<re;){var J=Te.charAt(re-ae-1);if(J===De&&!ke)ae++;else if(J!==De&&ke)ae++;else break}return Te.slice(0,re-ae)}function A(Te,De){if(Te.indexOf(De[1])===-1)return-1;for(var ke=Te.length,re=0,ae=0;ae<ke;ae++)if(Te[ae]==="\\")ae++;else if(Te[ae]===De[0])re++;else if(Te[ae]===De[1]&&(re--,re<0))return ae;return-1}function N(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function q(Te,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=Te),De>>=1,Te+=Te;return ke+Te}function j(Te,De,ke,re){var ae=De.href,J=De.title?h(De.title):null,I=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){re.state.inLink=!0;var U={type:"link",raw:ke,href:ae,title:J,text:I,tokens:re.inlineTokens(I)};return re.state.inLink=!1,U}return{type:"image",raw:ke,href:ae,title:J,text:h(I)}}function V(Te,De){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return De;var re=ke[1];return De.split(`
`).map(function(ae){var J=ae.match(/^\s+/);if(J===null)return ae;var I=J[0];return I.length>=re.length?ae.slice(re.length):ae}).join(`
`)}var P=function(){function Te(ke){this.options=ke||te.defaults}var De=Te.prototype;return De.space=function(re){var ae=this.rules.block.newline.exec(re);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},De.code=function(re){var ae=this.rules.block.code.exec(re);if(ae){var J=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?J:p(J,`
`)}}},De.fences=function(re){var ae=this.rules.block.fences.exec(re);if(ae){var J=ae[0],I=V(J,ae[3]||"");return{type:"code",raw:J,lang:ae[2]?ae[2].trim():ae[2],text:I}}},De.heading=function(re){var ae=this.rules.block.heading.exec(re);if(ae){var J=ae[2].trim();if(/#$/.test(J)){var I=p(J,"#");(this.options.pedantic||!I||/ $/.test(I))&&(J=I.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:J,tokens:this.lexer.inline(J)}}},De.hr=function(re){var ae=this.rules.block.hr.exec(re);if(ae)return{type:"hr",raw:ae[0]}},De.blockquote=function(re){var ae=this.rules.block.blockquote.exec(re);if(ae){var J=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},De.list=function(re){var ae=this.rules.block.list.exec(re);if(ae){var J,I,U,H,G,ee,le,Se,se,ve,be,$e,He=ae[1].trim(),tt=He.length>1,xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&($e=!1,!(!(ae=et.exec(re))||this.rules.block.hr.test(re)));){if(J=ae[0],re=re.substring(J.length),Se=ae[2].split(`
`,1)[0],se=re.split(`
`,1)[0],this.options.pedantic?(H=2,be=Se.trimLeft()):(H=ae[2].search(/[^ ]/),H=H>4?1:H,be=Se.slice(H),H+=ae[1].length),ee=!1,!Se&&/^ *$/.test(se)&&(J+=se+`
`,re=re.substring(se.length+1),$e=!0),!$e)for(var it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");re&&(ve=re.split(`
`,1)[0],Se=ve,this.options.pedantic&&(Se=Se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(Se)||st.test(Se)||it.test(Se)||dt.test(re)));){if(Se.search(/[^ ]/)>=H||!Se.trim())be+=`
`+Se.slice(H);else if(!ee)be+=`
`+Se;else break;!ee&&!Se.trim()&&(ee=!0),J+=ve+`
`,re=re.substring(ve.length+1)}xe.loose||(le?xe.loose=!0:/\n *\n *$/.test(J)&&(le=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(be),I&&(U=I[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:J,task:!!I,checked:U,loose:!1,text:be}),xe.raw+=J}xe.items[xe.items.length-1].raw=J.trimRight(),xe.items[xe.items.length-1].text=be.trimRight(),xe.raw=xe.raw.trimRight();var _=xe.items.length;for(G=0;G<_;G++){this.lexer.state.top=!1,xe.items[G].tokens=this.lexer.blockTokens(xe.items[G].text,[]);var Q=xe.items[G].tokens.filter(function(Ne){return Ne.type==="space"}),pe=Q.every(function(Ne){for(var Be=Ne.raw.split(""),je=0,Je=L(Be),nt;!(nt=Je()).done;){var vt=nt.value;if(vt===`
`&&(je+=1),je>1)return!0}return!1});!xe.loose&&Q.length&&pe&&(xe.loose=!0,xe.items[G].loose=!0)}return xe}},De.html=function(re){var ae=this.rules.block.html.exec(re);if(ae){var J={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ae[0]):h(ae[0]);J.type="paragraph",J.text=I,J.tokens=this.lexer.inline(I)}return J}},De.def=function(re){var ae=this.rules.block.def.exec(re);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var J=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ae[0],href:ae[2],title:ae[3]}}},De.table=function(re){var ae=this.rules.block.table.exec(re);if(ae){var J={type:"table",header:m(ae[1]).map(function(le){return{text:le}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ae[0];var I=J.align.length,U,H,G,ee;for(U=0;U<I;U++)/^ *-+: *$/.test(J.align[U])?J.align[U]="right":/^ *:-+: *$/.test(J.align[U])?J.align[U]="center":/^ *:-+ *$/.test(J.align[U])?J.align[U]="left":J.align[U]=null;for(I=J.rows.length,U=0;U<I;U++)J.rows[U]=m(J.rows[U],J.header.length).map(function(le){return{text:le}});for(I=J.header.length,H=0;H<I;H++)J.header[H].tokens=this.lexer.inline(J.header[H].text);for(I=J.rows.length,H=0;H<I;H++)for(ee=J.rows[H],G=0;G<ee.length;G++)ee[G].tokens=this.lexer.inline(ee[G].text);return J}}},De.lheading=function(re){var ae=this.rules.block.lheading.exec(re);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},De.paragraph=function(re){var ae=this.rules.block.paragraph.exec(re);if(ae){var J=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:J,tokens:this.lexer.inline(J)}}},De.text=function(re){var ae=this.rules.block.text.exec(re);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},De.escape=function(re){var ae=this.rules.inline.escape.exec(re);if(ae)return{type:"escape",raw:ae[0],text:h(ae[1])}},De.tag=function(re){var ae=this.rules.inline.tag.exec(re);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):h(ae[0]):ae[0]}},De.link=function(re){var ae=this.rules.inline.link.exec(re);if(ae){var J=ae[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var I=p(J.slice(0,-1),"\\");if((J.length-I.length)%2===0)return}else{var U=A(ae[2],"()");if(U>-1){var H=ae[0].indexOf("!")===0?5:4,G=H+ae[1].length+U;ae[2]=ae[2].substring(0,U),ae[0]=ae[0].substring(0,G).trim(),ae[3]=""}}var ee=ae[2],le="";if(this.options.pedantic){var Se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);Se&&(ee=Se[1],le=Se[3])}else le=ae[3]?ae[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(J)?ee=ee.slice(1):ee=ee.slice(1,-1)),j(ae,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:le&&le.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},De.reflink=function(re,ae){var J;if((J=this.rules.inline.reflink.exec(re))||(J=this.rules.inline.nolink.exec(re))){var I=(J[2]||J[1]).replace(/\s+/g," ");if(I=ae[I.toLowerCase()],!I||!I.href){var U=J[0].charAt(0);return{type:"text",raw:U,text:U}}return j(J,I,J[0],this.lexer)}},De.emStrong=function(re,ae,J){J===void 0&&(J="");var I=this.rules.inline.emStrong.lDelim.exec(re);if(!!I&&!(I[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=I[1]||I[2]||"";if(!U||U&&(J===""||this.rules.inline.punctuation.exec(J))){var H=I[0].length-1,G,ee,le=H,Se=0,se=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,ae=ae.slice(-1*re.length+H);(I=se.exec(ae))!=null;)if(G=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!G){if(ee=G.length,I[3]||I[4]){le+=ee;continue}else if((I[5]||I[6])&&H%3&&!((H+ee)%3)){Se+=ee;continue}if(le-=ee,!(le>0)){if(ee=Math.min(ee,ee+le+Se),Math.min(H,ee)%2){var ve=re.slice(1,H+I.index+ee);return{type:"em",raw:re.slice(0,H+I.index+ee+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var be=re.slice(2,H+I.index+ee-1);return{type:"strong",raw:re.slice(0,H+I.index+ee+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},De.codespan=function(re){var ae=this.rules.inline.code.exec(re);if(ae){var J=ae[2].replace(/\n/g," "),I=/[^ ]/.test(J),U=/^ /.test(J)&&/ $/.test(J);return I&&U&&(J=J.substring(1,J.length-1)),J=h(J,!0),{type:"codespan",raw:ae[0],text:J}}},De.br=function(re){var ae=this.rules.inline.br.exec(re);if(ae)return{type:"br",raw:ae[0]}},De.del=function(re){var ae=this.rules.inline.del.exec(re);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},De.autolink=function(re,ae){var J=this.rules.inline.autolink.exec(re);if(J){var I,U;return J[2]==="@"?(I=h(this.options.mangle?ae(J[1]):J[1]),U="mailto:"+I):(I=h(J[1]),U=I),{type:"link",raw:J[0],text:I,href:U,tokens:[{type:"text",raw:I,text:I}]}}},De.url=function(re,ae){var J;if(J=this.rules.inline.url.exec(re)){var I,U;if(J[2]==="@")I=h(this.options.mangle?ae(J[0]):J[0]),U="mailto:"+I;else{var H;do H=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(H!==J[0]);I=h(J[0]),J[1]==="www."?U="http://"+I:U=I}return{type:"link",raw:J[0],text:I,href:U,tokens:[{type:"text",raw:I,text:I}]}}},De.inlineText=function(re,ae){var J=this.rules.inline.text.exec(re);if(J){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):h(J[0]):J[0]:I=h(this.options.smartypants?ae(J[0]):J[0]),{type:"text",raw:J[0],text:I}}},Te}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=E(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=E(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=E(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=E(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=E(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=E(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=t({},M),M.gfm=t({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=E(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=E(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=t({},M.normal,{html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:E(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=E(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=E(M._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=E(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=E(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=E(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=E(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=E(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=E(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=E(F.reflink).replace("label",F._label).replace("ref",M._label).getRegex(),F.nolink=E(F.nolink).replace("ref",M._label).getRegex(),F.reflinkSearch=E(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=t({},F),F.pedantic=t({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=t({},F.normal,{escape:E(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=E(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=t({},F.gfm,{br:E(F.br).replace("{2,}","*").getRegex(),text:E(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Te){var De="",ke,re,ae=Te.length;for(ke=0;ke<ae;ke++)re=Te.charCodeAt(ke),Math.random()>.5&&(re="x"+re.toString(16)),De+="&#"+re+";";return De}var K=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||te.defaults,this.options.tokenizer=this.options.tokenizer||new P,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:M.normal,inline:F.normal};this.options.pedantic?(re.block=M.pedantic,re.inline=F.pedantic):this.options.gfm&&(re.block=M.gfm,this.options.breaks?re.inline=F.breaks:re.inline=F.gfm),this.tokenizer.rules=re}Te.lex=function(re,ae){var J=new Te(ae);return J.lex(re)},Te.lexInline=function(re,ae){var J=new Te(ae);return J.inlineTokens(re)};var De=Te.prototype;return De.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},De.blockTokens=function(re,ae){var J=this;ae===void 0&&(ae=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(le,Se,se){return Se+"    ".repeat(se.length)});for(var I,U,H,G;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(le){return(I=le.call({lexer:J},re,ae))?(re=re.substring(I.raw.length),ae.push(I),!0):!1}))){if(I=this.tokenizer.space(re)){re=re.substring(I.raw.length),I.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(I);continue}if(I=this.tokenizer.code(re)){re=re.substring(I.raw.length),U=ae[ae.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+I.raw,U.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):ae.push(I);continue}if(I=this.tokenizer.fences(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.heading(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.hr(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.blockquote(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.list(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.html(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.def(re)){re=re.substring(I.raw.length),U=ae[ae.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+I.raw,U.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.lheading(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(H=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var le=1/0,Se=re.slice(1),se=void 0;J.options.extensions.startBlock.forEach(function(ve){se=ve.call({lexer:this},Se),typeof se=="number"&&se>=0&&(le=Math.min(le,se))}),le<1/0&&le>=0&&(H=re.substring(0,le+1))}(),this.state.top&&(I=this.tokenizer.paragraph(H))){U=ae[ae.length-1],G&&U.type==="paragraph"?(U.raw+=`
`+I.raw,U.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):ae.push(I),G=H.length!==re.length,re=re.substring(I.raw.length);continue}if(I=this.tokenizer.text(re)){re=re.substring(I.raw.length),U=ae[ae.length-1],U&&U.type==="text"?(U.raw+=`
`+I.raw,U.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):ae.push(I);continue}if(re){var ee="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,ae},De.inline=function(re,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:re,tokens:ae}),ae},De.inlineTokens=function(re,ae){var J=this;ae===void 0&&(ae=[]);var I,U,H,G=re,ee,le,Se;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)se.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,ee.index)+"["+q("a",ee[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,ee.index)+"["+q("a",ee[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,ee.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(le||(Se=""),le=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(I=be.call({lexer:J},re,ae))?(re=re.substring(I.raw.length),ae.push(I),!0):!1}))){if(I=this.tokenizer.escape(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.tag(re)){re=re.substring(I.raw.length),U=ae[ae.length-1],U&&I.type==="text"&&U.type==="text"?(U.raw+=I.raw,U.text+=I.text):ae.push(I);continue}if(I=this.tokenizer.link(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(I.raw.length),U=ae[ae.length-1],U&&I.type==="text"&&U.type==="text"?(U.raw+=I.raw,U.text+=I.text):ae.push(I);continue}if(I=this.tokenizer.emStrong(re,G,Se)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.codespan(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.br(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.del(re)){re=re.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.autolink(re,z)){re=re.substring(I.raw.length),ae.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(re,z))){re=re.substring(I.raw.length),ae.push(I);continue}if(H=re,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,$e=re.slice(1),He=void 0;J.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},$e),typeof He=="number"&&He>=0&&(be=Math.min(be,He))}),be<1/0&&be>=0&&(H=re.substring(0,be+1))}(),I=this.tokenizer.inlineText(H,$)){re=re.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(Se=I.raw.slice(-1)),le=!0,U=ae[ae.length-1],U&&U.type==="text"?(U.raw+=I.raw,U.text+=I.text):ae.push(I);continue}if(re){var ve="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ae},n(Te,null,[{key:"rules",get:function(){return{block:M,inline:F}}}]),Te}(),X=function(){function Te(ke){this.options=ke||te.defaults}var De=Te.prototype;return De.code=function(re,ae,J){var I=(ae||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(re,I);U!=null&&U!==re&&(J=!0,re=U)}return re=re.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+h(I,!0)+'">'+(J?re:h(re,!0))+`</code></pre>
`:"<pre><code>"+(J?re:h(re,!0))+`</code></pre>
`},De.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},De.html=function(re){return re},De.heading=function(re,ae,J,I){if(this.options.headerIds){var U=this.options.headerPrefix+I.slug(J);return"<h"+ae+' id="'+U+'">'+re+"</h"+ae+`>
`}return"<h"+ae+">"+re+"</h"+ae+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(re,ae,J){var I=ae?"ol":"ul",U=ae&&J!==1?' start="'+J+'"':"";return"<"+I+U+`>
`+re+"</"+I+`>
`},De.listitem=function(re){return"<li>"+re+`</li>
`},De.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(re){return"<p>"+re+`</p>
`},De.table=function(re,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ae+`</table>
`},De.tablerow=function(re){return`<tr>
`+re+`</tr>
`},De.tablecell=function(re,ae){var J=ae.header?"th":"td",I=ae.align?"<"+J+' align="'+ae.align+'">':"<"+J+">";return I+re+("</"+J+`>
`)},De.strong=function(re){return"<strong>"+re+"</strong>"},De.em=function(re){return"<em>"+re+"</em>"},De.codespan=function(re){return"<code>"+re+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(re){return"<del>"+re+"</del>"},De.link=function(re,ae,J){if(re=w(this.options.sanitize,this.options.baseUrl,re),re===null)return J;var I='<a href="'+h(re)+'"';return ae&&(I+=' title="'+ae+'"'),I+=">"+J+"</a>",I},De.image=function(re,ae,J){if(re=w(this.options.sanitize,this.options.baseUrl,re),re===null)return J;var I='<img src="'+re+'" alt="'+J+'"';return ae&&(I+=' title="'+ae+'"'),I+=this.options.xhtml?"/>":">",I},De.text=function(re){return re},Te}(),Z=function(){function Te(){}var De=Te.prototype;return De.strong=function(re){return re},De.em=function(re){return re},De.codespan=function(re){return re},De.del=function(re){return re},De.html=function(re){return re},De.text=function(re){return re},De.link=function(re,ae,J){return""+J},De.image=function(re,ae,J){return""+J},De.br=function(){return""},Te}(),he=function(){function Te(){this.seen={}}var De=Te.prototype;return De.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(re,ae){var J=re,I=0;if(this.seen.hasOwnProperty(J)){I=this.seen[re];do I++,J=re+"-"+I;while(this.seen.hasOwnProperty(J))}return ae||(this.seen[re]=I,this.seen[J]=0),J},De.slug=function(re,ae){ae===void 0&&(ae={});var J=this.serialize(re);return this.getNextSafeSlug(J,ae.dryrun)},Te}(),oe=function(){function Te(ke){this.options=ke||te.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new he}Te.parse=function(re,ae){var J=new Te(ae);return J.parse(re)},Te.parseInline=function(re,ae){var J=new Te(ae);return J.parseInline(re)};var De=Te.prototype;return De.parse=function(re,ae){ae===void 0&&(ae=!0);var J="",I,U,H,G,ee,le,Se,se,ve,be,$e,He,tt,xe,et,it,dt,Fe,st,_=re.length;for(I=0;I<_;I++){if(be=re[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(st=this.options.extensions.renderers[be.type].call({parser:this},be),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){J+=st||"";continue}switch(be.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(be.tokens),be.depth,o(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(se="",Se="",G=be.header.length,U=0;U<G;U++)Se+=this.renderer.tablecell(this.parseInline(be.header[U].tokens),{header:!0,align:be.align[U]});for(se+=this.renderer.tablerow(Se),ve="",G=be.rows.length,U=0;U<G;U++){for(le=be.rows[U],Se="",ee=le.length,H=0;H<ee;H++)Se+=this.renderer.tablecell(this.parseInline(le[H].tokens),{header:!1,align:be.align[H]});ve+=this.renderer.tablerow(Se)}J+=this.renderer.table(se,ve);continue}case"blockquote":{ve=this.parse(be.tokens),J+=this.renderer.blockquote(ve);continue}case"list":{for($e=be.ordered,He=be.start,tt=be.loose,G=be.items.length,ve="",U=0;U<G;U++)et=be.items[U],it=et.checked,dt=et.task,xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):xe+=Fe),xe+=this.parse(et.tokens,tt),ve+=this.renderer.listitem(xe,dt,it);J+=this.renderer.list(ve,$e,He);continue}case"html":{J+=this.renderer.html(be.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(ve=be.tokens?this.parseInline(be.tokens):be.text;I+1<_&&re[I+1].type==="text";)be=re[++I],ve+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);J+=ae?this.renderer.paragraph(ve):ve;continue}default:{var Q='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return J},De.parseInline=function(re,ae){ae=ae||this.renderer;var J="",I,U,H,G=re.length;for(I=0;I<G;I++){if(U=re[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(H=this.options.extensions.renderers[U.type].call({parser:this},U),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){J+=H||"";continue}switch(U.type){case"escape":{J+=ae.text(U.text);break}case"html":{J+=ae.html(U.text);break}case"link":{J+=ae.link(U.href,U.title,this.parseInline(U.tokens,ae));break}case"image":{J+=ae.image(U.href,U.title,U.text);break}case"strong":{J+=ae.strong(this.parseInline(U.tokens,ae));break}case"em":{J+=ae.em(this.parseInline(U.tokens,ae));break}case"codespan":{J+=ae.codespan(U.text);break}case"br":{J+=ae.br();break}case"del":{J+=ae.del(this.parseInline(U.tokens,ae));break}case"text":{J+=ae.text(U.text);break}default:{var ee='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return J},Te}();function ue(Te,De,ke){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=t({},ue.defaults,De||{}),N(De),ke){var re=De.highlight,ae;try{ae=K.lex(Te,De)}catch(G){return ke(G)}var J=function(ee){var le;if(!ee)try{De.walkTokens&&ue.walkTokens(ae,De.walkTokens),le=oe.parse(ae,De)}catch(Se){ee=Se}return De.highlight=re,ee?ke(ee):ke(null,le)};if(!re||re.length<3||(delete De.highlight,!ae.length))return J();var I=0;ue.walkTokens(ae,function(G){G.type==="code"&&(I++,setTimeout(function(){re(G.text,G.lang,function(ee,le){if(ee)return J(ee);le!=null&&le!==G.text&&(G.text=le,G.escaped=!0),I--,I===0&&J()})},0))}),I===0&&J();return}function U(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+h(G.message+"",!0)+"</pre>";throw G}try{var H=K.lex(Te,De);if(De.walkTokens){if(De.async)return Promise.all(ue.walkTokens(H,De.walkTokens)).then(function(){return oe.parse(H,De)}).catch(U);ue.walkTokens(H,De.walkTokens)}return oe.parse(H,De)}catch(G){U(G)}}ue.options=ue.setOptions=function(Te){return t(ue.defaults,Te),R(ue.defaults),ue},ue.getDefaults=C,ue.defaults=te.defaults,ue.use=function(){for(var Te=arguments.length,De=new Array(Te),ke=0;ke<Te;ke++)De[ke]=arguments[ke];var re=t.apply(void 0,[{}].concat(De)),ae=ue.defaults.extensions||{renderers:{},childTokens:{}},J;De.forEach(function(I){if(I.extensions&&(J=!0,I.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var G=ae.renderers?ae.renderers[H.name]:null;G?ae.renderers[H.name]=function(){for(var ee=arguments.length,le=new Array(ee),Se=0;Se<ee;Se++)le[Se]=arguments[Se];var se=H.renderer.apply(this,le);return se===!1&&(se=G.apply(this,le)),se}:ae.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[H.level]?ae[H.level].unshift(H.tokenizer):ae[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ae.startBlock?ae.startBlock.push(H.start):ae.startBlock=[H.start]:H.level==="inline"&&(ae.startInline?ae.startInline.push(H.start):ae.startInline=[H.start]))}H.childTokens&&(ae.childTokens[H.name]=H.childTokens)})),I.renderer&&function(){var H=ue.defaults.renderer||new X,G=function(Se){var se=H[Se];H[Se]=function(){for(var ve=arguments.length,be=new Array(ve),$e=0;$e<ve;$e++)be[$e]=arguments[$e];var He=I.renderer[Se].apply(H,be);return He===!1&&(He=se.apply(H,be)),He}};for(var ee in I.renderer)G(ee);re.renderer=H}(),I.tokenizer&&function(){var H=ue.defaults.tokenizer||new P,G=function(Se){var se=H[Se];H[Se]=function(){for(var ve=arguments.length,be=new Array(ve),$e=0;$e<ve;$e++)be[$e]=arguments[$e];var He=I.tokenizer[Se].apply(H,be);return He===!1&&(He=se.apply(H,be)),He}};for(var ee in I.tokenizer)G(ee);re.tokenizer=H}(),I.walkTokens){var U=ue.defaults.walkTokens;re.walkTokens=function(H){var G=[];return G.push(I.walkTokens.call(this,H)),U&&(G=G.concat(U.call(this,H))),G}}J&&(re.extensions=ae),ue.setOptions(re)})},ue.walkTokens=function(Te,De){for(var ke=[],re=function(){var U=J.value;switch(ke=ke.concat(De.call(ue,U)),U.type){case"table":{for(var H=L(U.header),G;!(G=H()).done;){var ee=G.value;ke=ke.concat(ue.walkTokens(ee.tokens,De))}for(var le=L(U.rows),Se;!(Se=le()).done;)for(var se=Se.value,ve=L(se),be;!(be=ve()).done;){var $e=be.value;ke=ke.concat(ue.walkTokens($e.tokens,De))}break}case"list":{ke=ke.concat(ue.walkTokens(U.items,De));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[U.type]?ue.defaults.extensions.childTokens[U.type].forEach(function(He){ke=ke.concat(ue.walkTokens(U[He],De))}):U.tokens&&(ke=ke.concat(ue.walkTokens(U.tokens,De)))}},ae=L(Te),J;!(J=ae()).done;)re();return ke},ue.parseInline=function(Te,De){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");De=t({},ue.defaults,De||{}),N(De);try{var ke=K.lexInline(Te,De);return De.walkTokens&&ue.walkTokens(ke,De.walkTokens),oe.parseInline(ke,De)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+h(re.message+"",!0)+"</pre>";throw re}},ue.Parser=oe,ue.parser=oe.parse,ue.Renderer=X,ue.TextRenderer=Z,ue.Lexer=K,ue.lexer=K.lex,ue.Tokenizer=P,ue.Slugger=he,ue.parse=ue;var ce=ue.options,fe=ue.setOptions,Y=ue.use,ge=ue.walkTokens,we=ue.parseInline,Me=ue,We=oe.parse,Qe=K.lex;te.Lexer=K,te.Parser=oe,te.Renderer=X,te.Slugger=he,te.TextRenderer=Z,te.Tokenizer=P,te.getDefaults=C,te.lexer=Qe,te.marked=ue,te.options=ce,te.parse=Me,te.parseInline=we,te.parser=We,te.setOptions=fe,te.use=Y,te.walkTokens=ge,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ie[109],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(R,S,k){return Math.min(Math.max(R,S),k)}e.clamp=n;function T(R,S){return(S+R%S)%S}e.rot=T;class y{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=y;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const k=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function te(y){const L=[];typeof y=="number"&&L.push("code/timeOrigin",y);function C(S){L.push(S,Date.now())}function R(){const S=[];for(let k=0;k<L.length;k+=2)S.push({name:L[k],startTime:L[k+1]});return S}return{mark:C,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))L.push({name:C.name,startTime:Math.round(y+C.startTime)});return L}};if(typeof process=="object"){const y=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=n(T))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var T in n)(typeof exports=="object"?exports:te)[T]=n[T]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(T){if(e[T])return e[T].exports;var y=e[T]={i:T,l:!1,exports:{}};return te[T].call(y.exports,y,y.exports,n),y.l=!0,y.exports}return n.m=te,n.c=e,n.d=function(T,y,L){n.o(T,y)||Object.defineProperty(T,y,{enumerable:!0,get:L})},n.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},n.t=function(T,y){if(1&y&&(T=n(T)),8&y||4&y&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(n.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&y&&typeof T!="string")for(var C in T)n.d(L,C,function(R){return T[R]}.bind(null,C));return L},n.n=function(T){var y=T&&T.__esModule?function(){return T.default}:function(){return T};return n.d(y,"a",y),y},n.o=function(T,y){return Object.prototype.hasOwnProperty.call(T,y)},n.p="",n(n.s=0)}([function(te,e,n){(function(T){var y;e=te.exports=Y,y=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],k=0,O=k++;S[O]="0|[1-9]\\d*";var D=k++;S[D]="[0-9]+";var f=k++;S[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=k++;S[v]="("+S[O]+")\\.("+S[O]+")\\.("+S[O]+")";var h=k++;S[h]="("+S[D]+")\\.("+S[D]+")\\.("+S[D]+")";var i=k++;S[i]="(?:"+S[O]+"|"+S[f]+")";var o=k++;S[o]="(?:"+S[D]+"|"+S[f]+")";var l=k++;S[l]="(?:-("+S[i]+"(?:\\."+S[i]+")*))";var E=k++;S[E]="(?:-?("+S[o]+"(?:\\."+S[o]+")*))";var b=k++;S[b]="[0-9A-Za-z-]+";var g=k++;S[g]="(?:\\+("+S[b]+"(?:\\."+S[b]+")*))";var w=k++,s="v?"+S[v]+S[l]+"?"+S[g]+"?";S[w]="^"+s+"$";var r="[v=\\s]*"+S[h]+S[E]+"?"+S[g]+"?",a=k++;S[a]="^"+r+"$";var d=k++;S[d]="((?:<|>)?=?)";var c=k++;S[c]=S[D]+"|x|X|\\*";var u=k++;S[u]=S[O]+"|x|X|\\*";var t=k++;S[t]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[l]+")?"+S[g]+"?)?)?";var m=k++;S[m]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[E]+")?"+S[g]+"?)?)?";var p=k++;S[p]="^"+S[d]+"\\s*"+S[t]+"$";var A=k++;S[A]="^"+S[d]+"\\s*"+S[m]+"$";var N=k++;S[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=k++;S[q]="(?:~>?)";var j=k++;S[j]="(\\s*)"+S[q]+"\\s+",R[j]=new RegExp(S[j],"g");var V=k++;S[V]="^"+S[q]+S[t]+"$";var P=k++;S[P]="^"+S[q]+S[m]+"$";var M=k++;S[M]="(?:\\^)";var F=k++;S[F]="(\\s*)"+S[M]+"\\s+",R[F]=new RegExp(S[F],"g");var $=k++;S[$]="^"+S[M]+S[t]+"$";var z=k++;S[z]="^"+S[M]+S[m]+"$";var K=k++;S[K]="^"+S[d]+"\\s*("+r+")$|^$";var X=k++;S[X]="^"+S[d]+"\\s*("+s+")$|^$";var Z=k++;S[Z]="(\\s*)"+S[d]+"\\s*("+r+"|"+S[t]+")",R[Z]=new RegExp(S[Z],"g");var he=k++;S[he]="^\\s*("+S[t]+")\\s+-\\s+("+S[t]+")\\s*$";var oe=k++;S[oe]="^\\s*("+S[m]+")\\s+-\\s+("+S[m]+")\\s*$";var ue=k++;S[ue]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)y(ce,S[ce]),R[ce]||(R[ce]=new RegExp(S[ce]));function fe(se,ve){if(se instanceof Y)return se;if(typeof se!="string"||se.length>L||!(ve?R[a]:R[w]).test(se))return null;try{return new Y(se,ve)}catch{return null}}function Y(se,ve){if(se instanceof Y){if(se.loose===ve)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Y))return new Y(se,ve);y("SemVer",se,ve),this.loose=ve;var be=se.trim().match(ve?R[a]:R[w]);if(!be)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var He=+$e;if(He>=0&&He<C)return He}return $e}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=fe,e.valid=function(se,ve){var be=fe(se,ve);return be?be.version:null},e.clean=function(se,ve){var be=fe(se.trim().replace(/^[=v]+/,""),ve);return be?be.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(se){return y("SemVer.compare",this.version,this.loose,se),se instanceof Y||(se=new Y(se,this.loose)),this.compareMain(se)||this.comparePre(se)},Y.prototype.compareMain=function(se){return se instanceof Y||(se=new Y(se,this.loose)),we(this.major,se.major)||we(this.minor,se.minor)||we(this.patch,se.patch)},Y.prototype.comparePre=function(se){if(se instanceof Y||(se=new Y(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var ve=0;do{var be=this.prerelease[ve],$e=se.prerelease[ve];if(y("prerelease compare",ve,be,$e),be===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(be===void 0)return-1;if(be!==$e)return we(be,$e)}while(++ve)},Y.prototype.inc=function(se,ve){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,ve,be,$e){typeof be=="string"&&($e=be,be=void 0);try{return new Y(se,be).inc(ve,$e).version}catch{return null}},e.diff=function(se,ve){if(Te(se,ve))return null;var be=fe(se),$e=fe(ve);if(be.prerelease.length||$e.prerelease.length){for(var He in be)if((He==="major"||He==="minor"||He==="patch")&&be[He]!==$e[He])return"pre"+He;return"prerelease"}for(var He in be)if((He==="major"||He==="minor"||He==="patch")&&be[He]!==$e[He])return He},e.compareIdentifiers=we;var ge=/^[0-9]+$/;function we(se,ve){var be=ge.test(se),$e=ge.test(ve);return be&&$e&&(se=+se,ve=+ve),be&&!$e?-1:$e&&!be?1:se<ve?-1:se>ve?1:0}function Me(se,ve,be){return new Y(se,be).compare(new Y(ve,be))}function We(se,ve,be){return Me(se,ve,be)>0}function Qe(se,ve,be){return Me(se,ve,be)<0}function Te(se,ve,be){return Me(se,ve,be)===0}function De(se,ve,be){return Me(se,ve,be)!==0}function ke(se,ve,be){return Me(se,ve,be)>=0}function re(se,ve,be){return Me(se,ve,be)<=0}function ae(se,ve,be,$e){var He;switch(ve){case"===":typeof se=="object"&&(se=se.version),typeof be=="object"&&(be=be.version),He=se===be;break;case"!==":typeof se=="object"&&(se=se.version),typeof be=="object"&&(be=be.version),He=se!==be;break;case"":case"=":case"==":He=Te(se,be,$e);break;case"!=":He=De(se,be,$e);break;case">":He=We(se,be,$e);break;case">=":He=ke(se,be,$e);break;case"<":He=Qe(se,be,$e);break;case"<=":He=re(se,be,$e);break;default:throw new TypeError("Invalid operator: "+ve)}return He}function J(se,ve){if(se instanceof J){if(se.loose===ve)return se;se=se.value}if(!(this instanceof J))return new J(se,ve);y("comparator",se,ve),this.loose=ve,this.parse(se),this.semver===I?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(se,ve){return we(ve,se)},e.major=function(se,ve){return new Y(se,ve).major},e.minor=function(se,ve){return new Y(se,ve).minor},e.patch=function(se,ve){return new Y(se,ve).patch},e.compare=Me,e.compareLoose=function(se,ve){return Me(se,ve,!0)},e.rcompare=function(se,ve,be){return Me(ve,se,be)},e.sort=function(se,ve){return se.sort(function(be,$e){return e.compare(be,$e,ve)})},e.rsort=function(se,ve){return se.sort(function(be,$e){return e.rcompare(be,$e,ve)})},e.gt=We,e.lt=Qe,e.eq=Te,e.neq=De,e.gte=ke,e.lte=re,e.cmp=ae,e.Comparator=J;var I={};function U(se,ve){if(se instanceof U)return se.loose===ve?se:new U(se.raw,ve);if(se instanceof J)return new U(se.value,ve);if(!(this instanceof U))return new U(se,ve);if(this.loose=ve,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function H(se){return!se||se.toLowerCase()==="x"||se==="*"}function G(se,ve,be,$e,He,tt,xe,et,it,dt,Fe,st,_){return((ve=H(be)?"":H($e)?">="+be+".0.0":H(He)?">="+be+"."+$e+".0":">="+ve)+" "+(et=H(it)?"":H(dt)?"<"+(+it+1)+".0.0":H(Fe)?"<"+it+"."+(+dt+1)+".0":st?"<="+it+"."+dt+"."+Fe+"-"+st:"<="+et)).trim()}function ee(se,ve){for(var be=0;be<se.length;be++)if(!se[be].test(ve))return!1;if(ve.prerelease.length){for(be=0;be<se.length;be++)if(y(se[be].semver),se[be].semver!==I&&se[be].semver.prerelease.length>0){var $e=se[be].semver;if($e.major===ve.major&&$e.minor===ve.minor&&$e.patch===ve.patch)return!0}return!1}return!0}function le(se,ve,be){try{ve=new U(ve,be)}catch{return!1}return ve.test(se)}function Se(se,ve,be,$e){var He,tt,xe,et,it;switch(se=new Y(se,$e),ve=new U(ve,$e),be){case">":He=We,tt=re,xe=Qe,et=">",it=">=";break;case"<":He=Qe,tt=ke,xe=We,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(le(se,ve,$e))return!1;for(var dt=0;dt<ve.set.length;++dt){var Fe=ve.set[dt],st=null,_=null;if(Fe.forEach(function(Q){Q.semver===I&&(Q=new J(">=0.0.0")),st=st||Q,_=_||Q,He(Q.semver,st.semver,$e)?st=Q:xe(Q.semver,_.semver,$e)&&(_=Q)}),st.operator===et||st.operator===it||(!_.operator||_.operator===et)&&tt(se,_.semver)||_.operator===it&&xe(se,_.semver))return!1}return!0}J.prototype.parse=function(se){var ve=this.loose?R[K]:R[X],be=se.match(ve);if(!be)throw new TypeError("Invalid comparator: "+se);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Y(be[2],this.loose):this.semver=I},J.prototype.toString=function(){return this.value},J.prototype.test=function(se){return y("Comparator.test",se,this.loose),this.semver===I||(typeof se=="string"&&(se=new Y(se,this.loose)),ae(se,this.operator,this.semver,this.loose))},J.prototype.intersects=function(se,ve){if(!(se instanceof J))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new U(se.value,ve),le(this.value,be,ve);if(se.operator==="")return be=new U(this.value,ve),le(se.semver,be,ve);var $e=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),tt=this.semver.version===se.semver.version,xe=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),et=ae(this.semver,"<",se.semver,ve)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),it=ae(this.semver,">",se.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return $e||He||tt&&xe||et||it},e.Range=U,U.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},U.prototype.toString=function(){return this.range},U.prototype.parseRange=function(se){var ve=this.loose;se=se.trim(),y("range",se,ve);var be=ve?R[oe]:R[he];se=se.replace(be,G),y("hyphen replace",se),se=se.replace(R[Z],"$1$2$3"),y("comparator trim",se,R[Z]),se=(se=(se=se.replace(R[j],"$1~")).replace(R[F],"$1^")).split(/\s+/).join(" ");var $e=ve?R[K]:R[X],He=se.split(" ").map(function(tt){return function(xe,et){return y("comp",xe),xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,_){y("caret",st,_);var Q=_?R[z]:R[$];return st.replace(Q,function(pe,Ne,Be,je,Je){var nt;return y("caret",st,pe,Ne,Be,je,Je),H(Ne)?nt="":H(Be)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":H(je)?nt=Ne==="0"?">="+Ne+"."+Be+".0 <"+Ne+"."+(+Be+1)+".0":">="+Ne+"."+Be+".0 <"+(+Ne+1)+".0.0":Je?(y("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),nt=Ne==="0"?Be==="0"?">="+Ne+"."+Be+"."+je+Je+" <"+Ne+"."+Be+"."+(+je+1):">="+Ne+"."+Be+"."+je+Je+" <"+Ne+"."+(+Be+1)+".0":">="+Ne+"."+Be+"."+je+Je+" <"+(+Ne+1)+".0.0"):(y("no pr"),nt=Ne==="0"?Be==="0"?">="+Ne+"."+Be+"."+je+" <"+Ne+"."+Be+"."+(+je+1):">="+Ne+"."+Be+"."+je+" <"+Ne+"."+(+Be+1)+".0":">="+Ne+"."+Be+"."+je+" <"+(+Ne+1)+".0.0"),y("caret return",nt),nt})}(Fe,dt)}).join(" ")}(xe,et),y("caret",xe),xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,_){var Q=_?R[P]:R[V];return st.replace(Q,function(pe,Ne,Be,je,Je){var nt;return y("tilde",st,pe,Ne,Be,je,Je),H(Ne)?nt="":H(Be)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":H(je)?nt=">="+Ne+"."+Be+".0 <"+Ne+"."+(+Be+1)+".0":Je?(y("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),nt=">="+Ne+"."+Be+"."+je+Je+" <"+Ne+"."+(+Be+1)+".0"):nt=">="+Ne+"."+Be+"."+je+" <"+Ne+"."+(+Be+1)+".0",y("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(xe,et),y("tildes",xe),xe=function(it,dt){return y("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(st,_){st=st.trim();var Q=_?R[A]:R[p];return st.replace(Q,function(pe,Ne,Be,je,Je,nt){y("xRange",st,pe,Ne,Be,je,Je,nt);var vt=H(Be),wt=vt||H(je),Tt=wt||H(Je);return Ne==="="&&Tt&&(Ne=""),vt?pe=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&Tt?(wt&&(je=0),Tt&&(Je=0),Ne===">"?(Ne=">=",wt?(Be=+Be+1,je=0,Je=0):Tt&&(je=+je+1,Je=0)):Ne==="<="&&(Ne="<",wt?Be=+Be+1:je=+je+1),pe=Ne+Be+"."+je+"."+Je):wt?pe=">="+Be+".0.0 <"+(+Be+1)+".0.0":Tt&&(pe=">="+Be+"."+je+".0 <"+Be+"."+(+je+1)+".0"),y("xRange return",pe),pe})}(Fe,dt)}).join(" ")}(xe,et),y("xrange",xe),xe=function(it,dt){return y("replaceStars",it,dt),it.trim().replace(R[ue],"")}(xe,et),y("stars",xe),xe}(tt,ve)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match($e)})),He=He.map(function(tt){return new J(tt,ve)})},U.prototype.intersects=function(se,ve){if(!(se instanceof U))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function($e){return se.set.some(function(He){return He.every(function(tt){return $e.intersects(tt,ve)})})})})},e.toComparators=function(se,ve){return new U(se,ve).set.map(function(be){return be.map(function($e){return $e.value}).join(" ").trim().split(" ")})},U.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new Y(se,this.loose));for(var ve=0;ve<this.set.length;ve++)if(ee(this.set[ve],se))return!0;return!1},e.satisfies=le,e.maxSatisfying=function(se,ve,be){var $e=null,He=null;try{var tt=new U(ve,be)}catch{return null}return se.forEach(function(xe){tt.test(xe)&&($e&&He.compare(xe)!==-1||(He=new Y($e=xe,be)))}),$e},e.minSatisfying=function(se,ve,be){var $e=null,He=null;try{var tt=new U(ve,be)}catch{return null}return se.forEach(function(xe){tt.test(xe)&&($e&&He.compare(xe)!==1||(He=new Y($e=xe,be)))}),$e},e.validRange=function(se,ve){try{return new U(se,ve).range||"*"}catch{return null}},e.ltr=function(se,ve,be){return Se(se,ve,"<",be)},e.gtr=function(se,ve,be){return Se(se,ve,">",be)},e.outside=Se,e.prerelease=function(se,ve){var be=fe(se,ve);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(se,ve,be){return se=new U(se,be),ve=new U(ve,be),se.intersects(ve)},e.coerce=function(se){if(se instanceof Y)return se;if(typeof se!="string")return null;var ve=se.match(R[N]);return ve==null?null:fe((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,n(1))},function(te,e){var n,T,y=te.exports={};function L(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function R(o){if(n===setTimeout)return setTimeout(o,0);if((n===L||!n)&&setTimeout)return n=setTimeout,setTimeout(o,0);try{return n(o,0)}catch{try{return n.call(null,o,0)}catch{return n.call(this,o,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:L}catch{n=L}try{T=typeof clearTimeout=="function"?clearTimeout:C}catch{T=C}})();var S,k=[],O=!1,D=-1;function f(){O&&S&&(O=!1,S.length?k=S.concat(k):D=-1,k.length&&v())}function v(){if(!O){var o=R(f);O=!0;for(var l=k.length;l;){for(S=k,k=[];++D<l;)S&&S[D].run();D=-1,l=k.length}S=null,O=!1,function(E){if(T===clearTimeout)return clearTimeout(E);if((T===C||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(E);try{T(E)}catch{try{return T.call(null,E)}catch{return T.call(this,E)}}}(o)}}function h(o,l){this.fun=o,this.array=l}function i(){}y.nextTick=function(o){var l=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)l[E-1]=arguments[E];k.push(new h(o,l)),k.length!==1||O||R(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=i,y.addListener=i,y.once=i,y.off=i,y.removeListener=i,y.removeAllListeners=i,y.emit=i,y.prependListener=i,y.prependOnceListener=i,y.listeners=function(o){return[]},y.binding=function(o){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(o){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Ie[110],Ce([1,0,11,7]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(g){const w=g;return w?typeof w.read=="function":!1}e.isReadable=y;function L(g){const w=g;return w?[w.on,w.pause,w.resume,w.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=L;function C(g){const w=g;return w?L(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=C;function R(g,w){return new S(g,w)}e.newWriteableStream=R;class S{constructor(w,s){this.e=w,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(s=>s(w))}h(w){this.c.error.length===0?(0,n.onUnexpectedError)(w):this.c.error.slice(0).forEach(s=>s(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,s){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(w,s){if(this.a.destroyed)return;let r;switch(w){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const a=r.indexOf(s);a>=0&&r.splice(a,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(g,w){const s=[];let r;for(;(r=g.read())!==null;)s.push(r);return w(s)}e.consumeReadable=k;function O(g,w,s){const r=[];let a;for(;(a=g.read())!==null&&r.length<s;)r.push(a);return a===null&&r.length>0?w(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return g.read()}}}e.peekReadable=O;function D(g,w){return new Promise((s,r)=>{const a=[];f(g,{onData:d=>{w&&a.push(d)},onError:d=>{w?r(d):s(void 0)},onEnd:()=>{s(w?w(a):void 0)}})})}e.consumeStream=D;function f(g,w){let s=!1;return g.on("error",r=>{s||w.onError(r)}),g.on("end",()=>{s||w.onEnd()}),g.on("data",r=>{s||w.onData(r)}),(0,T.toDisposable)(()=>s=!0)}e.listenStream=f;function v(g,w){return new Promise((s,r)=>{const a=new T.DisposableStore,d=[],c=m=>{if(d.push(m),d.length>w)return a.dispose(),g.pause(),s({stream:g,buffer:d,ended:!1})},u=m=>r(m),t=()=>s({stream:g,buffer:d,ended:!0});a.add((0,T.toDisposable)(()=>g.removeListener("error",u))),g.on("error",u),a.add((0,T.toDisposable)(()=>g.removeListener("end",t))),g.on("end",t),a.add((0,T.toDisposable)(()=>g.removeListener("data",c))),g.on("data",c)})}e.peekStream=v;function h(g,w){const s=R(w);return s.end(g),s}e.toStream=h;function i(){const g=R(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=i;function o(g){let w=!1;return{read:()=>w?null:(w=!0,g)}}e.toReadable=o;function l(g,w,s){const r=R(s);return f(g,{onData:a=>r.write(w.data(a)),onError:a=>r.error(w.error?w.error(a):a),onEnd:()=>r.end()}),r}e.transform=l;function E(g,w,s){let r=!1;return{read:()=>{const a=w.read();return r?a:(r=!0,a!==null?s([g,a]):g)}}}e.prefixedReadable=E;function b(g,w,s){let r=!1;const a=R(s);return f(w,{onData:d=>r?a.write(d):(r=!0,a.write(s([g,d]))),onError:d=>a.error(d),onEnd:()=>{r||(r=!0,a.write(g)),a.end()}}),a}e.prefixedStream=b}),define(Ie[24],Ce([1,0,110]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let y,L;class C{static alloc(m){return T?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return T&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,p){return!(p?.dontUseNodeBuffer||!1)&&T?new C(Buffer.from(m)):(y||(y=new TextEncoder),new C(y.encode(m)))}static fromByteArray(m){const p=C.alloc(m.length);for(let A=0,N=m.length;A<N;A++)p.buffer[A]=m[A];return p}static concat(m,p){if(typeof p>"u"){p=0;for(let q=0,j=m.length;q<j;q++)p+=m[q].byteLength}const A=C.alloc(p);let N=0;for(let q=0,j=m.length;q<j;q++){const V=m[q];A.set(V,N),N+=V.byteLength}return A}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=C.alloc(this.byteLength);return m.set(this),m}toString(){return T?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(m,p){return new C(this.buffer.subarray(m,p))}set(m,p){if(m instanceof C)this.buffer.set(m.buffer,p);else if(m instanceof Uint8Array)this.buffer.set(m,p);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),p);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return k(this.buffer,m)}writeUInt32BE(m,p){O(this.buffer,m,p)}readUInt32LE(m){return D(this.buffer,m)}writeUInt32LE(m,p){f(this.buffer,m,p)}readUInt8(m){return v(this.buffer,m)}writeUInt8(m,p){h(this.buffer,m,p)}}e.VSBuffer=C;function R(t,m){return t[m+0]<<0>>>0|t[m+1]<<8>>>0}e.readUInt16LE=R;function S(t,m,p){t[p+0]=m&255,m=m>>>8,t[p+1]=m&255}e.writeUInt16LE=S;function k(t,m){return t[m]*2**24+t[m+1]*2**16+t[m+2]*2**8+t[m+3]}e.readUInt32BE=k;function O(t,m,p){t[p+3]=m,m=m>>>8,t[p+2]=m,m=m>>>8,t[p+1]=m,m=m>>>8,t[p]=m}e.writeUInt32BE=O;function D(t,m){return t[m+0]<<0>>>0|t[m+1]<<8>>>0|t[m+2]<<16>>>0|t[m+3]<<24>>>0}e.readUInt32LE=D;function f(t,m,p){t[p+0]=m&255,m=m>>>8,t[p+1]=m&255,m=m>>>8,t[p+2]=m&255,m=m>>>8,t[p+3]=m&255}e.writeUInt32LE=f;function v(t,m){return t[m]}e.readUInt8=v;function h(t,m,p){t[p]=m}e.writeUInt8=h;function i(t){return n.consumeReadable(t,m=>C.concat(m))}e.readableToBuffer=i;function o(t){return n.toReadable(t)}e.bufferToReadable=o;function l(t){return n.consumeStream(t,m=>C.concat(m))}e.streamToBuffer=l;async function E(t){return t.ended?C.concat(t.buffer):C.concat([...t.buffer,await l(t.stream)])}e.bufferedStreamToBuffer=E;function b(t){return n.toStream(t,m=>C.concat(m))}e.bufferToStream=b;function g(t){return n.transform(t,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}e.streamToBufferReadableStream=g;function w(t){return n.newWriteableStream(m=>C.concat(m),t)}e.newWriteableBufferStream=w;function s(t,m){return n.prefixedReadable(t,m,p=>C.concat(p))}e.prefixedBufferReadable=s;function r(t,m){return n.prefixedStream(t,m,p=>C.concat(p))}e.prefixedBufferStream=r;function a(t){let m=0,p=0,A=0;const N=new Uint8Array(Math.floor(t.length/4*3)),q=V=>{switch(p){case 3:N[A++]=m|V,p=0;break;case 2:N[A++]=m|V>>>2,m=V<<6,p=3;break;case 1:N[A++]=m|V>>>4,m=V<<4,p=2;break;default:m=V<<2,p=1}};for(let V=0;V<t.length;V++){const P=t.charCodeAt(V);if(P>=65&&P<=90)q(P-65);else if(P>=97&&P<=122)q(P-97+26);else if(P>=48&&P<=57)q(P-48+52);else if(P===43||P===45)q(62);else if(P===47||P===95)q(63);else{if(P===61)break;throw new SyntaxError(`Unexpected base64 character ${t[V]}`)}}const j=A;for(;p>0;)q(0);return C.wrap(N).slice(0,j)}e.decodeBase64=a;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:t},m=!0,p=!1){const A=p?c:d;let N="";const q=t.byteLength%3;let j=0;for(;j<t.byteLength-q;j+=3){const V=t[j+0],P=t[j+1],M=t[j+2];N+=A[V>>>2],N+=A[(V<<4|P>>>4)&63],N+=A[(P<<2|M>>>6)&63],N+=A[M&63]}if(q===1){const V=t[j+0];N+=A[V>>>2],N+=A[V<<4&63],m&&(N+="==")}else if(q===2){const V=t[j+0],P=t[j+1];N+=A[V>>>2],N+=A[(V<<4|P>>>4)&63],N+=A[P<<2&63],m&&(N+="=")}return N}e.encodeBase64=u}),define(Ie[34],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(y){return n.test(y)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const L=new Uint8Array(16),C=[];for(let R=0;R<256;R++)C.push(R.toString(16).padStart(2,"0"));return function(){y(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,k="";return k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k}}()}),define(Ie[111],Ce([1,0,16,34]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function y(R){return{id:(0,T.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=y;function L(R,S,k){return{id:(0,T.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:S,data:k}),value:void 0}}e.createFileDataTransferItem=L;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,k){const O=this.a.get(S);O?O.push(k):this.a.set(this.b(S),[k])}replace(S,k){this.a.set(this.b(S),[k])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,k]of this.a.entries())for(const O of k)yield[S,O]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[k,O]of this.entries())S(O,k)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:R=>(0,n.distinct)(R.map(S=>S.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(S=>!S.startsWith("#"))})}),define(Ie[112],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[113],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class T{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let S=0,k=R.notIn.length;S<k;S++)switch(R.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,S){if(R.getTokenCount()===0)return!0;const k=R.findTokenIndexAtOffset(S-2),O=R.getStandardTokenType(k);return this.isOK(O)}g(R,S){for(let k=R;k<=S;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=T;class y{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of R)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=y;function L(C,R,S){C.has(R)?C.get(R).push(S):C.set(R,[S])}}),define(Ie[114],Ce([17,18]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ie[115],Ce([1,0,114]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,y=T*60,L=y*24,C=L*7,R=L*30,S=L*365;function k(D,f,v){typeof D!="number"&&(D=D.getTime());const h=Math.round((new Date().getTime()-D)/1e3);if(h<-30)return(0,n.localize)(0,null,k(new Date().getTime()+h*1e3,!1));if(h<30)return(0,n.localize)(1,null);let i;return h<T?(i=h,f?i===1?v?(0,n.localize)(2,null,i):(0,n.localize)(3,null,i):v?(0,n.localize)(4,null,i):(0,n.localize)(5,null,i):i===1?v?(0,n.localize)(6,null,i):(0,n.localize)(7,null,i):v?(0,n.localize)(8,null,i):(0,n.localize)(9,null,i)):h<y?(i=Math.floor(h/T),f?i===1?v?(0,n.localize)(10,null,i):(0,n.localize)(11,null,i):v?(0,n.localize)(12,null,i):(0,n.localize)(13,null,i):i===1?v?(0,n.localize)(14,null,i):(0,n.localize)(15,null,i):v?(0,n.localize)(16,null,i):(0,n.localize)(17,null,i)):h<L?(i=Math.floor(h/y),f?i===1?v?(0,n.localize)(18,null,i):(0,n.localize)(19,null,i):v?(0,n.localize)(20,null,i):(0,n.localize)(21,null,i):i===1?v?(0,n.localize)(22,null,i):(0,n.localize)(23,null,i):v?(0,n.localize)(24,null,i):(0,n.localize)(25,null,i)):h<C?(i=Math.floor(h/L),f?i===1?(0,n.localize)(26,null,i):(0,n.localize)(27,null,i):i===1?(0,n.localize)(28,null,i):(0,n.localize)(29,null,i)):h<R?(i=Math.floor(h/C),f?i===1?v?(0,n.localize)(30,null,i):(0,n.localize)(31,null,i):v?(0,n.localize)(32,null,i):(0,n.localize)(33,null,i):i===1?v?(0,n.localize)(34,null,i):(0,n.localize)(35,null,i):v?(0,n.localize)(36,null,i):(0,n.localize)(37,null,i)):h<S?(i=Math.floor(h/R),f?i===1?v?(0,n.localize)(38,null,i):(0,n.localize)(39,null,i):v?(0,n.localize)(40,null,i):(0,n.localize)(41,null,i):i===1?v?(0,n.localize)(42,null,i):(0,n.localize)(43,null,i):v?(0,n.localize)(44,null,i):(0,n.localize)(45,null,i)):(i=Math.floor(h/S),f?i===1?v?(0,n.localize)(46,null,i):(0,n.localize)(47,null,i):v?(0,n.localize)(48,null,i):(0,n.localize)(49,null,i):i===1?v?(0,n.localize)(50,null,i):(0,n.localize)(51,null,i):v?(0,n.localize)(52,null,i):(0,n.localize)(53,null,i))}e.fromNow=k;function O(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ie[116],Ce([17,18]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ie[45],Ce([1,0,16,9,116]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(D,f){return f&&(D.stack||D.stacktrace)?y.localize(0,null,R(D),C(D.stack)||C(D.stacktrace)):R(D)}function C(D){return Array.isArray(D)?D.join(`
`):D}function R(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function S(D=null,f=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const v=n.coalesce(D),h=S(v[0],f);return v.length>1?y.localize(4,null,h,v.length):h}if(T.isString(D))return D;if(D.detail){const v=D.detail;if(v.error)return L(v.error,f);if(v.exception)return L(v.exception,f)}return D.stack?L(D,f):D.message?D.message:y.localize(5,null)}e.toErrorMessage=S;function k(D){const f=D;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=k;function O(D,f){let v;return typeof D=="string"?v=new Error(D):v=D,v.actions=f,v}e.createErrorWithActions=O}),define(Ie[61],Ce([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(O){const D=(0,n.extname)(O),f=T[D.toLowerCase()];return f!==void 0?f:C(O)}e.getMediaOrTextMime=L;function C(O){const D=(0,n.extname)(O);return y[D.toLowerCase()]}e.getMediaMime=C;function R(O){for(const D in y)if(y[D]===O)return D}e.getExtensionForMimeType=R;const S=/^(.+)\/(.+?)(;.+)?$/;function k(O,D){const f=S.exec(O);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:D?void 0:O}e.normalizeMimeType=k}),define(Ie[39],Ce([1,0,19,21,10,9]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(c){return c===47||c===92}e.isPathSeparator=C;function R(c){return c.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=R;function S(c){return c.indexOf("/")===-1&&(c=R(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=S;function k(c,u=n.posix.sep){if(!c)return"";const t=c.length,m=c.charCodeAt(0);if(C(m)){if(C(c.charCodeAt(1))&&!C(c.charCodeAt(2))){let A=3;const N=A;for(;A<t&&!C(c.charCodeAt(A));A++);if(N!==A&&!C(c.charCodeAt(A+1))){for(A+=1;A<t;A++)if(C(c.charCodeAt(A)))return c.slice(0,A+1).replace(/[\\/]/g,u)}}return u}else if(l(m)&&c.charCodeAt(1)===58)return C(c.charCodeAt(2))?c.slice(0,2)+u:c.slice(0,2);let p=c.indexOf("://");if(p!==-1){for(p+=3;p<t;p++)if(C(c.charCodeAt(p)))return c.slice(0,p+1)}return""}e.getRoot=k;function O(c){if(!T.isWindows||!c||c.length<5)return!1;let u=c.charCodeAt(0);if(u!==92||(u=c.charCodeAt(1),u!==92))return!1;let t=2;const m=t;for(;t<c.length&&(u=c.charCodeAt(t),u!==92);t++);return!(m===t||(u=c.charCodeAt(t+1),isNaN(u)||u===92))}e.isUNC=O;const D=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(c,u=T.isWindows){const t=u?D:f;return!(!c||c.length===0||/^\s+$/.test(c)||(t.lastIndex=0,t.test(c))||u&&v.test(c)||c==="."||c===".."||u&&c[c.length-1]==="."||u&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=h;function i(c,u,t){const m=c===u;return!t||m?m:!c||!u?!1:(0,y.equalsIgnoreCase)(c,u)}e.isEqual=i;function o(c,u,t,m=n.sep){if(c===u)return!0;if(!c||!u||u.length>c.length)return!1;if(t){if(!(0,y.startsWithIgnoreCase)(c,u))return!1;if(u.length===c.length)return!0;let A=u.length;return u.charAt(u.length-1)===m&&A--,c.charAt(A)===m}return u.charAt(u.length-1)!==m&&(u+=m),c.indexOf(u)===0}e.isEqualOrParent=o;function l(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=l;function E(c,u){return T.isWindows&&c.endsWith(":")&&(c+=n.sep),(0,n.isAbsolute)(c)||(c=(0,n.join)(u,c)),c=(0,n.normalize)(c),T.isWindows?(c=(0,y.rtrim)(c,n.sep),c.endsWith(":")&&(c+=n.sep)):(c=(0,y.rtrim)(c,n.sep),c||(c=n.sep)),c}e.sanitizeFilePath=E;function b(c){const u=(0,n.normalize)(c);return T.isWindows?c.length>3?!1:g(u)&&(c.length===2||u.charCodeAt(2)===92):u===n.posix.sep}e.isRootOrDriveLetter=b;function g(c,u=T.isWindows){return u?l(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function w(c){return g(c)?c[0]:void 0}e.getDriveLetter=w;function s(c,u,t){return u.length>c.length?-1:c===u?0:(t&&(c=c.toLowerCase(),u=u.toLowerCase()),c.indexOf(u))}e.indexOfPath=s;function r(c){const u=c.split(":");let t,m,p;for(const A of u){const N=Number(A);(0,L.isNumber)(N)?m===void 0?m=N:p===void 0&&(p=N):t=t?[t,A].join(":"):A}if(!t)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:t,line:m!==void 0?m:void 0,column:p!==void 0?p:m!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function d(c,u,t=8){let m="";for(let A=0;A<t;A++)m+=a.charAt(Math.floor(Math.random()*a.length));let p;return u?p=`${u}-${m}`:p=m,c?(0,n.join)(c,p):p}e.randomPath=d}),define(Ie[117],Ce([1,0,28,10]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...J){return function(I,U){for(let H=0,G=J.length;H<G;H++){const ee=J[H](I,U);if(ee)return ee}return null}}e.or=y,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(J,I,U){if(!U||U.length<I.length)return null;let H;return J?H=T.startsWithIgnoreCase(U,I):H=U.indexOf(I)===0,H?I.length>0?[{start:0,end:I.length}]:[]:null}function C(J,I){const U=I.toLowerCase().indexOf(J.toLowerCase());return U===-1?null:[{start:U,end:U+J.length}]}e.matchesContiguousSubString=C;function R(J,I){return S(J.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=R;function S(J,I,U,H){if(U===J.length)return[];if(H===I.length)return null;if(J[U]===I[H]){let G=null;return(G=S(J,I,U+1,H+1))?l({start:H,end:H+1},G):null}return S(J,I,U,H+1)}function k(J){return 97<=J&&J<=122}function O(J){return 65<=J&&J<=90}e.isUpper=O;function D(J){return 48<=J&&J<=57}function f(J){return J===32||J===9||J===10||J===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>v.add(J.charCodeAt(0)));function h(J){return f(J)||v.has(J)}function i(J,I){return J===I||h(J)&&h(I)}function o(J){return k(J)||O(J)||D(J)}function l(J,I){return I.length===0?I=[J]:J.end===I[0].start?I[0].start=J.start:I.unshift(J),I}function E(J,I){for(let U=I;U<J.length;U++){const H=J.charCodeAt(U);if(O(H)||D(H)||U>0&&!o(J.charCodeAt(U-1)))return U}return J.length}function b(J,I,U,H){if(U===J.length)return[];if(H===I.length)return null;if(J[U]!==I[H].toLowerCase())return null;{let G=null,ee=H+1;for(G=b(J,I,U+1,H+1);!G&&(ee=E(I,ee))<I.length;)G=b(J,I,U+1,ee),ee++;return G===null?null:l({start:H,end:H+1},G)}}function g(J){let I=0,U=0,H=0,G=0,ee=0;for(let be=0;be<J.length;be++)ee=J.charCodeAt(be),O(ee)&&I++,k(ee)&&U++,o(ee)&&H++,D(ee)&&G++;const le=I/J.length,Se=U/J.length,se=H/J.length,ve=G/J.length;return{upperPercent:le,lowerPercent:Se,alphaPercent:se,numericPercent:ve}}function w(J){const{upperPercent:I,lowerPercent:U}=J;return U===0&&I>.6}function s(J){const{upperPercent:I,lowerPercent:U,alphaPercent:H,numericPercent:G}=J;return U>.2&&I<.8&&H>.6&&G<.2}function r(J){let I=0,U=0,H=0,G=0;for(let ee=0;ee<J.length;ee++)H=J.charCodeAt(ee),O(H)&&I++,k(H)&&U++,f(H)&&G++;return(I===0||U===0)&&G===0?J.length<=30:I<=5}function a(J,I){if(!I||(I=I.trim(),I.length===0)||!r(J)||I.length>60)return null;const U=g(I);if(!s(U)){if(!w(U))return null;I=I.toLowerCase()}let H=null,G=0;for(J=J.toLowerCase();G<I.length&&(H=b(J,I,0,G))===null;)G=E(I,G+1);return H}e.matchesCamelCase=a;function d(J,I,U=!1){if(!I||I.length===0)return null;let H=null,G=0;for(J=J.toLowerCase(),I=I.toLowerCase();G<I.length&&(H=c(J,I,0,G,U))===null;)G=u(I,G+1);return H}e.matchesWords=d;function c(J,I,U,H,G){if(U===J.length)return[];if(H===I.length)return null;if(i(J.charCodeAt(U),I.charCodeAt(H))){let ee=null,le=H+1;if(ee=c(J,I,U+1,H+1,G),!G)for(;!ee&&(le=u(I,le))<I.length;)ee=c(J,I,U+1,le,G),le++;return ee?J.charCodeAt(U)!==I.charCodeAt(H)?ee:l({start:H,end:H+1},ee):null}else return null}function u(J,I){for(let U=I;U<J.length;U++)if(h(J.charCodeAt(U))||U>0&&h(J.charCodeAt(U-1)))return U;return J.length}const t=y(e.matchesPrefix,a,C),m=y(e.matchesPrefix,a,R),p=new n.LRUCache(1e4);function A(J,I,U=!1){if(typeof J!="string"||typeof I!="string")return null;let H=p.get(J);H||(H=new RegExp(T.convertSimple2RegExpPattern(J),"i"),p.set(J,H));const G=H.exec(I);return G?[{start:G.index,end:G.index+G[0].length}]:U?m(J,I):t(J,I)}e.matchesFuzzy=A;function N(J,I){const U=We(J,J.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?j(U):null}e.matchesFuzzy2=N;function q(J,I,U,H,G,ee){const le=Math.min(13,J.length);for(;U<le;U++){const Se=We(J,I,U,H,G,ee,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Se)return Se}return[0,ee]}e.anyScore=q;function j(J){if(typeof J>"u")return[];const I=[],U=J[1];for(let H=J.length-1;H>1;H--){const G=J[H]+U,ee=I[I.length-1];ee&&ee.end===G?ee.end=G+1:I.push({start:G,end:G+1})}return I}e.createMatches=j;const V=128;function P(){const J=[],I=[];for(let U=0;U<=V;U++)I[U]=0;for(let U=0;U<=V;U++)J.push(I.slice(0));return J}function M(J){const I=[];for(let U=0;U<=J;U++)I[U]=0;return I}const F=M(2*V),$=M(2*V),z=P(),K=P(),X=P(),Z=!1;function he(J,I,U,H,G){function ee(Se,se,ve=" "){for(;Se.length<se;)Se=ve+Se;return Se}let le=` |   |${H.split("").map(Se=>ee(Se,3)).join("|")}
`;for(let Se=0;Se<=U;Se++)Se===0?le+=" |":le+=`${I[Se-1]}|`,le+=J[Se].slice(0,G+1).map(se=>ee(se.toString(),3)).join("|")+`
`;return le}function oe(J,I,U,H){J=J.substr(I),U=U.substr(H),console.log(he(K,J,J.length,U,U.length)),console.log(he(X,J,J.length,U,U.length)),console.log(he(z,J,J.length,U,U.length))}function ue(J,I){if(I<0||I>=J.length)return!1;const U=J.codePointAt(I);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(U)}}function ce(J,I){if(I<0||I>=J.length)return!1;switch(J.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function fe(J,I,U){return I[J]!==U[J]}function Y(J,I,U,H,G,ee,le=!1){for(;I<U&&G<ee;)J[I]===H[G]&&(le&&(F[I]=G),I+=1),G+=1;return I===U}e.isPatternInWord=Y;var ge;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var we;(function(J){J.Default=[-100,0];function I(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}J.isDefault=I})(we=e.FuzzyScore||(e.FuzzyScore={}));class Me{constructor(I,U){this.firstMatchCanBeWeak=I,this.boostFullMatch=U}}e.FuzzyScoreOptions=Me,Me.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function We(J,I,U,H,G,ee,le=Me.default){const Se=J.length>V?V:J.length,se=H.length>V?V:H.length;if(U>=Se||ee>=se||Se-U>se-ee||!Y(I,U,Se,G,ee,se,!0))return;Qe(Se,se,U,ee,I,G);let ve=1,be=1,$e=U,He=ee;const tt=[!1];for(ve=1,$e=U;$e<Se;ve++,$e++){const Fe=F[$e],st=$[$e],_=$e+1<Se?$[$e+1]:se;for(be=Fe-ee+1,He=Fe;He<_;be++,He++){let Q=Number.MIN_SAFE_INTEGER,pe=!1;He<=st&&(Q=Te(J,I,$e,U,H,G,He,se,ee,z[ve-1][be-1]===0,tt));let Ne=0;Q!==Number.MAX_SAFE_INTEGER&&(pe=!0,Ne=Q+K[ve-1][be-1]);const Be=He>Fe,je=Be?K[ve][be-1]+(z[ve][be-1]>0?-5:0):0,Je=He>Fe+1&&z[ve][be-1]>0,nt=Je?K[ve][be-2]+(z[ve][be-2]>0?-5:0):0;if(Je&&(!Be||nt>=je)&&(!pe||nt>=Ne))K[ve][be]=nt,X[ve][be]=3,z[ve][be]=0;else if(Be&&(!pe||je>=Ne))K[ve][be]=je,X[ve][be]=2,z[ve][be]=0;else if(pe)K[ve][be]=Ne,X[ve][be]=1,z[ve][be]=z[ve-1][be-1]+1;else throw new Error("not possible")}}if(Z&&oe(J,U,H,ee),!tt[0]&&!le.firstMatchCanBeWeak)return;ve--,be--;const xe=[K[ve][be],ee];let et=0,it=0;for(;ve>=1;){let Fe=be;do{const st=X[ve][Fe];if(st===3)Fe=Fe-2;else if(st===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[U+ve-1]===G[ee+be-1]&&!fe(Fe+ee-1,H,G)&&et+1>z[ve][Fe]&&(Fe=be),Fe===be?et++:et=1,it||(it=Fe),ve--,be=Fe-1,xe.push(be)}se===Se&&le.boostFullMatch&&(xe[0]+=2);const dt=it-Se;return xe[0]-=dt,xe}e.fuzzyScore=We;function Qe(J,I,U,H,G,ee){let le=J-1,Se=I-1;for(;le>=U&&Se>=H;)G[le]===ee[Se]&&($[le]=Se,le--),Se--}function Te(J,I,U,H,G,ee,le,Se,se,ve,be){if(I[U]!==ee[le])return Number.MIN_SAFE_INTEGER;let $e=1,He=!1;return le===U-H?$e=J[U]===G[le]?7:5:fe(le,G,ee)&&(le===0||!fe(le-1,G,ee))?($e=J[U]===G[le]?7:5,He=!0):ue(ee,le)&&(le===0||!ue(ee,le-1))?$e=5:(ue(ee,le-1)||ce(ee,le-1))&&($e=5,He=!0),$e>1&&U===H&&(be[0]=!0),He||(He=fe(le,G,ee)||ue(ee,le-1)||ce(ee,le-1)),U===H?le>se&&($e-=He?3:5):ve?$e+=He?2:0:$e+=He?0:1,le+1===Se&&($e-=He?3:5),$e}function De(J,I,U,H,G,ee,le){return re(J,I,U,H,G,ee,!0,le)}e.fuzzyScoreGracefulAggressive=De;function ke(J,I,U,H,G,ee,le){return re(J,I,U,H,G,ee,!1,le)}e.fuzzyScoreGraceful=ke;function re(J,I,U,H,G,ee,le,Se){let se=We(J,I,U,H,G,ee,Se);if(se&&!le)return se;if(J.length>=3){const ve=Math.min(7,J.length-1);for(let be=U+1;be<ve;be++){const $e=ae(J,be);if($e){const He=We($e,$e.toLowerCase(),U,H,G,ee,Se);He&&(He[0]-=3,(!se||He[0]>se[0])&&(se=He))}}}return se}function ae(J,I){if(I+1>=J.length)return;const U=J[I],H=J[I+1];if(U!==H)return J.slice(0,I)+H+U+J.slice(I+2)}}),define(Ie[118],Ce([1,0,119,117,10]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",C=new RegExp(`\\$\\(${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(n.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${C.source}`,"g");function k(l){return l.replace(S,(E,b)=>b?E:`\\${E}`)}e.escapeIcons=k;const O=new RegExp(`\\\\${C.source}`,"g");function D(l){return l.replace(O,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=D;const f=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function v(l){return l.indexOf(L)===-1?l:l.replace(f,(E,b,g,w)=>g?E:b||w||"")}e.stripIcons=v;function h(l){const E=l.indexOf(L);return E===-1?{text:l}:i(l,E)}e.parseLabelWithIcons=h;function i(l,E){const b=[];let g="";function w(m){if(m){g+=m;for(const p of m)b.push(a)}}let s=-1,r="",a=0,d,c,u=E;const t=l.length;for(w(l.substr(0,E));u<t;)d=l[u],c=l[u+1],d===L[0]&&c===L[1]?(s=u,w(r),r=L,u++):d===")"&&s!==-1?(a+=u-s+1,s=-1,r=""):s!==-1?R.test(d)?r+=d:(w(r),s=-1,r=""):w(d),u++;return w(r),{text:g,iconOffsets:b}}function o(l,E,b=!1){const{text:g,iconOffsets:w}=E;if(!w||w.length===0)return(0,T.matchesFuzzy)(l,g,b);const s=(0,y.ltrim)(g," "),r=g.length-s.length,a=(0,T.matchesFuzzy)(l,s,b);if(a)for(const d of a){const c=w[d.start+r]+r;d.start+=c,d.end+=c}return a}e.matchesFuzzyIconAware=o}),define(Ie[29],Ce([1,0,10]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(T||(T={})),function(y){const L="error",C="warning",R="warn",S="info",k="ignore";function O(f){return f?n.equalsIgnoreCase(L,f)?y.Error:n.equalsIgnoreCase(C,f)||n.equalsIgnoreCase(R,f)?y.Warning:n.equalsIgnoreCase(S,f)?y.Info:y.Ignore:y.Ignore}y.fromValue=O;function D(f){switch(f){case y.Error:return L;case y.Warning:return C;case y.Info:return S;default:return k}}y.toString=D}(T||(T={})),e.default=T}),define(Ie[46],Ce([1,0,16,10]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const h=v.charCodeAt(0),i=this.b.charCodeAt(this.c);return h-i}value(){return this.b[this.c]}}e.StringIterator=y;class L{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,T.compareSubstring)(v,this.b,0,v.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class C{constructor(v=!0,h=!0){this.f=v,this.g=h}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let h=v.length-1;h>=0;h--,this.c--){const i=this.b.charCodeAt(h);if(!(i===47||this.f&&i===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,T.compareSubstring)(v,this.b,0,v.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var R;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(v,h){this.f=v,this.g=h,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(v,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,T.compare)(v,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(O||(O={}));class D{static forUris(v=()=>!1,h=()=>!1){return new D(new S(v,h))}static forPaths(v=!1){return new D(new C(void 0,!v))}static forStrings(){return new D(new y)}static forConfigKeys(){return new D(new L)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,h){if(h){const i=h.slice(0);(0,n.shuffle)(i);for(const o of i)this.set(o,v)}else{const i=v.slice(0);(0,n.shuffle)(i);for(const o of i)this.set(o[0],o[1])}}set(v,h){const i=this.b.reset(v);let o;this.c||(this.c=new k,this.c.segment=i.value());const l=[];for(o=this.c;;){const b=i.cmp(o.segment);if(b>0)o.left||(o.left=new k,o.left.segment=i.value()),l.push([-1,o]),o=o.left;else if(b<0)o.right||(o.right=new k,o.right.segment=i.value()),l.push([1,o]),o=o.right;else if(i.hasNext())i.next(),o.mid||(o.mid=new k,o.mid.segment=i.value()),l.push([0,o]),o=o.mid;else break}const E=o.value;o.value=h,o.key=v;for(let b=l.length-1;b>=0;b--){const g=l[b][1];g.updateHeight();const w=g.balanceFactor();if(w<-1||w>1){const s=l[b][0],r=l[b+1][0];if(s===1&&r===1)l[b][1]=g.rotateLeft();else if(s===-1&&r===-1)l[b][1]=g.rotateRight();else if(s===1&&r===-1)g.right=l[b+1][1]=l[b+1][1].rotateRight(),l[b][1]=g.rotateLeft();else if(s===-1&&r===1)g.left=l[b+1][1]=l[b+1][1].rotateLeft(),l[b][1]=g.rotateRight();else throw new Error;if(b>0)switch(l[b-1][0]){case-1:l[b-1][1].left=l[b][1];break;case 1:l[b-1][1].right=l[b][1];break;case 0:l[b-1][1].mid=l[b][1];break}else this.c=l[0][1]}}return E}get(v){return this.d(v)?.value}d(v){const h=this.b.reset(v);let i=this.c;for(;i;){const o=h.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(h.hasNext())h.next(),i=i.mid;else break}return i}has(v){const h=this.d(v);return!(h?.value===void 0&&h?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,h){const i=this.b.reset(v),o=[];let l=this.c;for(;l;){const E=i.cmp(l.segment);if(E>0)o.push([-1,l]),l=l.left;else if(E<0)o.push([1,l]),l=l.right;else if(i.hasNext())i.next(),o.push([0,l]),l=l.mid;else break}if(!!l){if(h?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const E=this.f(l.right);if(E.key){const{key:b,value:g,segment:w}=E;this.e(E.key,!1),l.key=b,l.value=g,l.segment=w}}else{const E=l.left??l.right;if(o.length>0){const[b,g]=o[o.length-1];switch(b){case-1:g.left=E;break;case 0:g.mid=E;break;case 1:g.right=E;break}}else this.c=E}for(let E=o.length-1;E>=0;E--){const b=o[E][1];b.updateHeight();const g=b.balanceFactor();if(g>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),o[E][1]=b.rotateLeft()):g<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),o[E][1]=b.rotateRight()),E>0)switch(o[E-1][0]){case-1:o[E-1][1].left=o[E][1];break;case 1:o[E-1][1].right=o[E][1];break;case 0:o[E-1][1].mid=o[E][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const h=this.b.reset(v);let i=this.c,o;for(;i;){const l=h.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(h.hasNext())h.next(),o=i.value||o,i=i.mid;else break}return i&&i.value||o}findSuperstr(v){const h=this.b.reset(v);let i=this.c;for(;i;){const o=h.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(h.hasNext())h.next(),i=i.mid;else return i.mid?this.g(i.mid):void 0}}forEach(v){for(const[h,i]of this)v(i,h)}*[Symbol.iterator](){yield*this.g(this.c)}g(v){const h=[];return this.h(v,h),h[Symbol.iterator]()}h(v,h){!v||(v.left&&this.h(v.left,h),v.value&&h.push([v.key,v.value]),v.mid&&this.h(v.mid,h),v.right&&this.h(v.right,h))}_isBalanced(){const v=h=>{if(!h)return!0;const i=h.balanceFactor();return i<-1||i>1?!1:v(h.left)&&v(h.right)};return v(this.c)}}e.TernarySearchTree=D}),define(Ie[80],Ce([1,0,24,10,2]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(k){return JSON.stringify(k,R)}e.stringify=L;function C(k){let O=JSON.parse(k);return O=S(O),O}e.parse=C;function R(k,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,T.regExpFlags)(O)}:O}function S(k,O=0){if(!k||O>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return y.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof n.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let D=0;D<k.length;++D)k[D]=S(k[D],O+1);else for(const D in k)Object.hasOwnProperty.call(k,D)&&(k[D]=S(k[D],O+1))}return k}e.revive=S}),define(Ie[13],Ce([1,0,21,2]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(k){this.d=k}setDelegate(k){this.e=k}setServerRootPath(k){this.f=`${k}/${y.vscodeRemoteResource}`}set(k,O,D){this.a[k]=O,this.b[k]=D}setConnectionToken(k,O){this.c[k]=O}getPreferredWebSchema(){return this.d}rewrite(k){if(this.e)return this.e(k);const O=k.authority;let D=this.a[O];D&&D.indexOf(":")!==-1&&D.indexOf("[")===-1&&(D=`[${D}]`);const f=this.b[O],v=this.c[O];let h=`path=${encodeURIComponent(k.path)}`;return typeof v=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),T.URI.from({scheme:n.isWeb?this.d:y.vscodeRemoteResource,authority:`${D}:${f}`,path:this.f,query:h})}}e.RemoteAuthorities=new L,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(k){const O=this.b(k,te);return this.uriToBrowserUri(O)}uriToBrowserUri(k){return k.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===y.file&&(n.isNative||n.isWebWorker&&n.globals.origin===`${y.vscodeFileResource}://${C.a}`)?k.with({scheme:y.vscodeFileResource,authority:k.authority||C.a,query:null,fragment:null}):k}asFileUri(k){const O=this.b(k,te);return this.uriToFileUri(O)}uriToFileUri(k){return k.scheme===y.vscodeFileResource?k.with({scheme:y.file,authority:k.authority!==C.a?k.authority:null,query:null,fragment:null}):k}b(k,O){return T.URI.isUri(k)?k:T.URI.parse(O.toUrl(k))}}C.a="vscode-app",e.FileAccess=new C;var R;(function(S){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(k.get("3"));const O="vscode-coi";function D(v){let h;typeof v=="string"?h=new URL(v).searchParams:v instanceof URL?h=v.searchParams:T.URI.isUri(v)&&(h=new URL(v.toString(!0)).searchParams);const i=h?.get(O);if(!!i)return k.get(i)}S.getHeadersFromQuery=D;function f(v,h,i){if(!globalThis.crossOriginIsolated)return;const o=h&&i?"3":i?"2":"1";v instanceof URLSearchParams?v.set(O,o):v[O]=o}S.addSearchParam=f})(R=e.COI||(e.COI={}))}),define(Ie[22],Ce([1,0,39,13,19,21,10,2]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(v){return(0,R.uriToFsPath)(v,!0)}e.originalFSPath=S;class k{constructor(h){this.a=h}compare(h,i,o=!1){return h===i?0:(0,C.compare)(this.getComparisonKey(h,o),this.getComparisonKey(i,o))}isEqual(h,i,o=!1){return h===i?!0:!h||!i?!1:this.getComparisonKey(h,o)===this.getComparisonKey(i,o)}getComparisonKey(h,i=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,i,o=!1){if(h.scheme===i.scheme){if(h.scheme===T.Schemas.file)return n.isEqualOrParent(S(h),S(i),this.a(h))&&h.query===i.query&&(o||h.fragment===i.fragment);if((0,e.isEqualAuthority)(h.authority,i.authority))return n.isEqualOrParent(h.path,i.path,this.a(h),"/")&&h.query===i.query&&(o||h.fragment===i.fragment)}return!1}joinPath(h,...i){return R.URI.joinPath(h,...i)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let i;return h.scheme===T.Schemas.file?i=R.URI.file(y.dirname(S(h))).path:(i=y.posix.dirname(h.path),h.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),i="/")),h.with({path:i})}normalizePath(h){if(!h.path.length)return h;let i;return h.scheme===T.Schemas.file?i=R.URI.file(y.normalize(S(h))).path:i=y.posix.normalize(h.path),h.with({path:i})}relativePath(h,i){if(h.scheme!==i.scheme||!(0,e.isEqualAuthority)(h.authority,i.authority))return;if(h.scheme===T.Schemas.file){const E=y.relative(S(h),S(i));return L.isWindows?n.toSlashes(E):E}let o=h.path||"/";const l=i.path||"/";if(this.a(h)){let E=0;for(const b=Math.min(o.length,l.length);E<b&&!(o.charCodeAt(E)!==l.charCodeAt(E)&&o.charAt(E).toLowerCase()!==l.charAt(E).toLowerCase());E++);o=l.substr(0,E)+o.substr(E)}return y.posix.relative(o,l)}resolvePath(h,i){if(h.scheme===T.Schemas.file){const o=R.URI.file(y.resolve(S(h),i));return h.with({authority:o.authority,path:o.path})}return i=n.toPosixPath(i),h.with({path:y.posix.resolve(h.path,i)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,i){return h===i||h!==void 0&&i!==void 0&&(0,C.equalsIgnoreCase)(h,i)}hasTrailingPathSeparator(h,i=y.sep){if(h.scheme===T.Schemas.file){const o=S(h);return o.length>n.getRoot(o).length&&o[o.length-1]===i}else{const o=h.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,i=y.sep){return(0,e.hasTrailingPathSeparator)(h,i)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,i=y.sep){let o=!1;if(h.scheme===T.Schemas.file){const l=S(h);o=l!==void 0&&l.length===n.getRoot(l).length&&l[l.length-1]===i}else{i="/";const l=h.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(h,i)?h.with({path:h.path+"/"}):h}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(v=>v.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new k(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(v,h){const i=[];for(let o=0;o<v.length;o++){const l=h(v[o]);v.some((E,b)=>b===o?!1:(0,e.isEqualOrParent)(l,h(E)))||i.push(v[o])}return i}e.distinctParents=O;var D;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(i){const o=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(b=>{const[g,w]=b.split(":");g&&w&&o.set(g,w)});const E=i.path.substring(0,i.path.indexOf(";"));return E&&o.set(v.META_DATA_MIME,E),o}v.parseMetaData=h})(D=e.DataUri||(e.DataUri={}));function f(v,h,i){if(h){let o=v.path;return o&&o[0]!==y.posix.sep&&(o=y.posix.sep+o),v.with({scheme:i,authority:h,path:o})}return v.with({scheme:i})}e.toLocalResource=f}),define(Ie[15],Ce([1,0,20,11,5,7,22,21]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=S;function k(fe){const Y=new n.CancellationTokenSource,ge=fe(Y.token),we=new Promise((Me,We)=>{const Qe=Y.token.onCancellationRequested(()=>{Qe.dispose(),Y.dispose(),We(new T.CancellationError)});Promise.resolve(ge).then(Te=>{Qe.dispose(),Y.dispose(),Me(Te)},Te=>{Qe.dispose(),Y.dispose(),We(Te)})});return new class{cancel(){Y.cancel()}then(Me,We){return we.then(Me,We)}catch(Me){return this.then(void 0,Me)}finally(Me){return we.finally(Me)}}}e.createCancelablePromise=k;function O(fe,Y,ge){return new Promise((we,Me)=>{const We=Y.onCancellationRequested(()=>{We.dispose(),we(ge)});fe.then(we,Me).finally(()=>We.dispose())})}e.raceCancellation=O;function D(fe,Y){return new Promise((ge,we)=>{const Me=Y.onCancellationRequested(()=>{Me.dispose(),we(new T.CancellationError)});fe.then(ge,we).finally(()=>Me.dispose())})}e.raceCancellationError=D;async function f(fe){let Y=-1;const ge=fe.map((Me,We)=>Me.then(Qe=>(Y=We,Qe))),we=await Promise.race(ge);return fe.forEach((Me,We)=>{We!==Y&&Me.cancel()}),we}e.raceCancellablePromises=f;function v(fe,Y,ge){let we;const Me=setTimeout(()=>{we?.(void 0),ge?.()},Y);return Promise.race([fe.finally(()=>clearTimeout(Me)),new Promise(We=>we=We)])}e.raceTimeout=v;function h(fe){return new Promise((Y,ge)=>{const we=fe();S(we)?we.then(Y,ge):Y(we)})}e.asPromise=h;class i{constructor(){this.a=null,this.b=null,this.d=null}queue(Y){if(this.a){if(this.d=Y,!this.b){const ge=()=>{this.b=null;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(ge,ge).then(we)})}return new Promise((ge,we)=>{this.b.then(ge,we)})}return this.a=Y(),new Promise((ge,we)=>{this.a.then(Me=>{this.a=null,ge(Me)},Me=>{this.a=null,we(Me)})})}}e.Throttler=i;class o{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.Sequencer=o;class l{constructor(){this.a=new Map}queue(Y,ge){const Me=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.a.get(Y)===Me&&this.a.delete(Y)});return this.a.set(Y,Me),Me}}e.SequencerByKey=l;const E=(fe,Y)=>{let ge=!0;const we=setTimeout(()=>{ge=!1,Y()},fe);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(we),ge=!1}}},b=fe=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,fe())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,ge=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((Me,We)=>{this.d=Me,this.f=We}).then(()=>{if(this.b=null,this.d=null,this.g){const Me=this.g;return this.g=null,Me()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=ge===e.MicrotaskDelay?b(we):E(ge,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=g;class w{constructor(Y){this.a=new g(Y),this.b=new i}trigger(Y,ge){return this.a.trigger(()=>this.b.queue(Y),ge)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class s{constructor(){this.a=!1,this.b=new Promise((Y,ge)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function a(fe,Y){return Y?new Promise((ge,we)=>{const Me=setTimeout(()=>{We.dispose(),ge()},fe),We=Y.onCancellationRequested(()=>{clearTimeout(Me),We.dispose(),we(new T.CancellationError)})}):k(ge=>a(fe,ge))}e.timeout=a;function d(fe,Y=0){const ge=setTimeout(fe,Y);return(0,L.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=d;function c(fe){const Y=[];let ge=0;const we=fe.length;function Me(){return ge<we?fe[ge++]():null}function We(Qe){Qe!=null&&Y.push(Qe);const Te=Me();return Te?Te.then(We):Promise.resolve(Y)}return Promise.resolve(null).then(We)}e.sequence=c;function u(fe,Y=we=>!!we,ge=null){let we=0;const Me=fe.length,We=()=>{if(we>=Me)return Promise.resolve(ge);const Qe=fe[we++];return Promise.resolve(Qe()).then(De=>Y(De)?Promise.resolve(De):We())};return We()}e.first=u;function t(fe,Y=we=>!!we,ge=null){if(fe.length===0)return Promise.resolve(ge);let we=fe.length;const Me=()=>{we=-1;for(const We of fe)We.cancel?.()};return new Promise((We,Qe)=>{for(const Te of fe)Te.then(De=>{--we>=0&&Y(De)?(Me(),We(De)):we===0&&We(ge)}).catch(De=>{--we>=0&&(Me(),Qe(De))})})}e.firstParallel=t;class m{constructor(Y){this.a=0,this.d=Y,this.f=[],this.b=0,this.g=new y.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Y){return this.a++,new Promise((ge,we)=>{this.f.push({factory:Y,c:ge,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Y=this.f.shift();this.b++;const ge=Y.factory();ge.then(Y.c,Y.e),ge.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=m;class p extends m{constructor(){super(1)}}e.Queue=p;class A{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Y=new X;return this.b.add(Y),Y.p}d(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueFor(Y,ge=C.extUri){const we=ge.getComparisonKey(Y);let Me=this.a.get(we);return Me||(Me=new p,y.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(we),this.f()}),this.a.set(we,Me)),Me}f(){!this.d()||this.g()}g(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.g()}}e.ResourceQueue=A;class N{constructor(Y,ge){this.a=-1,typeof Y=="function"&&typeof ge=="number"&&this.setIfNotSet(Y,ge)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,ge){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},ge)}setIfNotSet(Y,ge){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},ge))}}e.TimeoutTimer=N;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Y,ge){this.cancel(),this.a=setInterval(()=>{Y()},ge)}}e.IntervalTimer=q;class j{constructor(Y,ge){this.b=-1,this.a=Y,this.d=ge,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=j;class V{constructor(Y,ge){ge%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.a=Y,this.b=ge,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class P extends j{constructor(Y,ge){super(Y,ge),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=P;class M extends L.Disposable{constructor(Y,ge){super(),this.g=Y,this.h=ge,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...Y),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,R.setTimeout0)(()=>{if(Y)return;const ge=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(fe,Y)=>{const ge=requestIdleCallback(fe,typeof Y=="number"?{timeout:Y}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ge))}}}}();class F{constructor(Y){this.d=!1,this.a=()=>{try{this.f=Y()}catch(ge){this.g=ge}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function $(fe,Y,ge){let we;for(let Me=0;Me<ge;Me++)try{return await fe()}catch(We){we=We,await a(Y)}throw we}e.retry=$;class z{hasPending(Y){return this.a?typeof Y=="number"?this.a.taskId===Y:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Y,ge,we){return this.a={taskId:Y,cancel:()=>we?.(),promise:ge},ge.then(()=>this.d(Y),()=>this.d(Y)),ge}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this.b)this.b.run=Y;else{let ge,we;const Me=new Promise((We,Qe)=>{ge=We,we=Qe});this.b={run:Y,promise:Me,promiseResolve:ge,promiseReject:we}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class K{constructor(Y,ge=()=>Date.now()){this.d=Y,this.f=ge,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.IntervalCounter=K;class X{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Y,ge)=>{this.a=Y,this.b=ge})}complete(Y){return new Promise(ge=>{this.a(Y),this.f=!0,ge()})}error(Y){return new Promise(ge=>{this.b(Y),this.d=!0,ge()})}cancel(){new Promise(Y=>{this.b(new T.CancellationError),this.d=!0,Y()})}}e.DeferredPromise=X;var Z;(function(fe){async function Y(we){let Me;const We=await Promise.all(we.map(Qe=>Qe.then(Te=>Te,Te=>{Me||(Me=Te)})));if(typeof Me<"u")throw Me;return We}fe.settled=Y;function ge(we){return new Promise(async(Me,We)=>{try{await we(Me,We)}catch(Qe){We(Qe)}})}fe.withAsyncBody=ge})(Z=e.Promises||(e.Promises={}));var he;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(he||(he={}));class oe{static fromArray(Y){return new oe(ge=>{ge.emitMany(Y)})}static fromPromise(Y){return new oe(async ge=>{ge.emitMany(await Y)})}static fromPromises(Y){return new oe(async ge=>{await Promise.all(Y.map(async we=>ge.emitOne(await we)))})}static merge(Y){return new oe(async ge=>{await Promise.all(Y.map(async we=>{for await(const Me of we)ge.emitOne(Me)}))})}constructor(Y){this.a=0,this.b=[],this.d=null,this.f=new y.Emitter,queueMicrotask(async()=>{const ge={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(Y(ge)),this.j()}catch(we){this.k(we)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(Y,ge){return new oe(async we=>{for await(const Me of Y)we.emitOne(ge(Me))})}map(Y){return oe.map(this,Y)}static filter(Y,ge){return new oe(async we=>{for await(const Me of Y)ge(Me)&&we.emitOne(Me)})}filter(Y){return oe.filter(this,Y)}static coalesce(Y){return oe.filter(Y,ge=>!!ge)}coalesce(){return oe.coalesce(this)}static async toPromise(Y){const ge=[];for await(const we of Y)ge.push(we);return ge}toPromise(){return oe.toPromise(this)}g(Y){this.a===0&&(this.b.push(Y),this.f.fire())}h(Y){this.a===0&&(this.b=this.b.concat(Y),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Y){this.a===0&&(this.a=2,this.d=Y,this.f.fire())}}e.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class ue extends oe{constructor(Y,ge){super(ge),this.l=Y}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ue;function ce(fe){const Y=new n.CancellationTokenSource,ge=fe(Y.token);return new ue(Y,async we=>{const Me=Y.token.onCancellationRequested(()=>{Me.dispose(),Y.dispose(),we.reject(new T.CancellationError)});try{for await(const We of ge){if(Y.token.isCancellationRequested)return;we.emitOne(We)}Me.dispose(),Y.dispose()}catch(We){Me.dispose(),Y.dispose(),we.reject(We)}})}e.createCancelableAsyncIterable=ce}),define(Ie[120],Ce([1,0,15,19]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new n.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),L=new n.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new n.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(p,A,N=!1){const q=p||"",j=A||"",V=y.value.collator.compare(q,j);return y.value.collatorIsNumeric&&V===0&&q!==j?q<j?-1:1:V}e.compareFileNames=R;function S(p,A){const N=L.value.collator;return p=p||"",A=A||"",w(N,p,A)}e.compareFileNamesDefault=S;function k(p,A){const N=L.value.collator;return p=p||"",A=A||"",d(p,A)||w(N,p,A)}e.compareFileNamesUpper=k;function O(p,A){const N=L.value.collator;return p=p||"",A=A||"",a(p,A)||w(N,p,A)}e.compareFileNamesLower=O;function D(p,A){return p=p||"",A=A||"",p===A?0:p<A?-1:1}e.compareFileNamesUnicode=D;function f(p,A,N=!1){N||(p=p&&p.toLowerCase(),A=A&&A.toLowerCase());const[q,j]=b(p),[V,P]=b(A);return q!==V?q<V?-1:1:j===P?0:j<P?-1:1}e.noIntlCompareFileNames=f;function v(p,A){const[N,q]=b(p),[j,V]=b(A);let P=y.value.collator.compare(q,V);if(P===0){if(y.value.collatorIsNumeric&&q!==V)return q<V?-1:1;if(P=y.value.collator.compare(N,j),y.value.collatorIsNumeric&&P===0&&N!==j)return N<j?-1:1}return P}e.compareFileExtensions=v;function h(p,A){p=p||"",A=A||"";const N=g(p),q=g(A),j=L.value.collator,V=C.value.collator;return w(V,N,q)||w(j,p,A)}e.compareFileExtensionsDefault=h;function i(p,A){p=p||"",A=A||"";const N=g(p),q=g(A),j=L.value.collator,V=C.value.collator;return w(V,N,q)||d(p,A)||w(j,p,A)}e.compareFileExtensionsUpper=i;function o(p,A){p=p||"",A=A||"";const N=g(p),q=g(A),j=L.value.collator,V=C.value.collator;return w(V,N,q)||a(p,A)||w(j,p,A)}e.compareFileExtensionsLower=o;function l(p,A){p=p||"",A=A||"";const N=g(p).toLowerCase(),q=g(A).toLowerCase();return N!==q?N<q?-1:1:p!==A?p<A?-1:1:0}e.compareFileExtensionsUnicode=l;const E=/^(.*?)(\.([^.]*))?$/;function b(p,A=!1){const N=p?E.exec(p):[];let q=[N&&N[1]||"",N&&N[3]||""];return A&&(!q[0]&&q[1]||q[0]&&q[0].charAt(0)===".")&&(q=[q[0]+"."+q[1],""]),q}function g(p){const A=p?E.exec(p):[];return A&&A[1]&&A[1].charAt(0)!=="."&&A[3]||""}function w(p,A,N){const q=p.compare(A,N);return q!==0?q:A.length!==N.length?A.length<N.length?-1:1:0}function s(p){const A=p.charAt(0);return A.toLocaleUpperCase()!==A}function r(p){const A=p.charAt(0);return A.toLocaleLowerCase()!==A}function a(p,A){return s(p)&&r(A)?-1:r(p)&&s(A)?1:0}function d(p,A){return r(p)&&s(A)?-1:s(p)&&r(A)?1:0}function c(p,A,N=!1){return N||(p=p&&p.toLowerCase(),A=A&&A.toLowerCase()),p===A?0:p<A?-1:1}function u(p,A,N=!1){const q=p.split(T.sep),j=A.split(T.sep),V=q.length-1,P=j.length-1;let M,F;for(let $=0;;$++){if(M=V===$,F=P===$,M&&F)return R(q[$],j[$],N);if(M)return-1;if(F)return 1;const z=c(q[$],j[$],N);if(z!==0)return z}}e.comparePaths=u;function t(p,A,N){const q=p.toLowerCase(),j=A.toLowerCase(),V=m(p,A,N);if(V)return V;const P=q.endsWith(N),M=j.endsWith(N);if(P!==M)return P?-1:1;const F=R(q,j);return F!==0?F:q.localeCompare(j)}e.compareAnything=t;function m(p,A,N){const q=p.toLowerCase(),j=A.toLowerCase(),V=q.startsWith(N),P=j.startsWith(N);if(V!==P)return V?-1:1;if(V&&P){if(q.length<j.length)return-1;if(q.length>j.length)return 1}return 0}e.compareByPrefix=m}),define(Ie[35],Ce([1,0,16,15,39,28,19,21,10]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",D="[^/\\\\]",f=/\//g;function v(X,Z){switch(X){case 0:return"";case 1:return`${D}*?`;default:return`(?:${O}|${D}+${O}${Z?`|${O}${D}+`:""})*?`}}function h(X,Z){if(!X)return[];const he=[];let oe=!1,ue=!1,ce="";for(const fe of X){switch(fe){case Z:if(!oe&&!ue){he.push(ce),ce="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ce+=fe}return ce&&he.push(ce),he}e.splitGlobAware=h;function i(X){if(!X)return"";let Z="";const he=h(X,e.GLOB_SPLIT);if(he.every(oe=>oe===e.GLOBSTAR))Z=".*";else{let oe=!1;he.forEach((ue,ce)=>{if(ue===e.GLOBSTAR){if(oe)return;Z+=v(2,ce===he.length-1)}else{let fe=!1,Y="",ge=!1,we="";for(const Me of ue){if(Me!=="}"&&fe){Y+=Me;continue}if(ge&&(Me!=="]"||!we)){let We;Me==="-"?We=Me:(Me==="^"||Me==="!")&&!we?We="^":Me===e.GLOB_SPLIT?We="":We=(0,S.escapeRegExpCharacters)(Me),we+=We;continue}switch(Me){case"{":fe=!0;continue;case"[":ge=!0;continue;case"}":{Z+=`(?:${h(Y,",").map(Te=>i(Te)).join("|")})`,fe=!1,Y="";break}case"]":{Z+="["+we+"]",ge=!1,we="";break}case"?":Z+=D;continue;case"*":Z+=v(1);continue;default:Z+=(0,S.escapeRegExpCharacters)(Me)}}ce<he.length-1&&(he[ce+1]!==e.GLOBSTAR||ce+2<he.length)&&(Z+=O)}oe=ue===e.GLOBSTAR})}return Z}const o=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new L.LRUCache(1e4),r=function(){return!1},a=function(){return null};function d(X,Z){if(!X)return a;let he;typeof X!="string"?he=X.pattern:he=X,he=he.trim();const oe=`${he}_${!!Z.trimForExclusions}`;let ue=s.get(oe);if(ue)return c(ue,X);let ce;return o.test(he)?ue=t(he.substr(4),he):(ce=l.exec(u(he,Z)))?ue=m(ce[1],he):(Z.trimForExclusions?b:E).test(he)?ue=p(he,Z):(ce=g.exec(u(he,Z)))?ue=A(ce[1].substr(1),he,!0):(ce=w.exec(u(he,Z)))?ue=A(ce[1],he,!1):ue=N(he),s.set(oe,ue),c(ue,X)}function c(X,Z){if(typeof Z=="string")return X;const he=function(oe,ue){return(0,y.isEqualOrParent)(oe,Z.base,!R.isLinux)?X((0,S.ltrim)(oe.substr(Z.base.length),C.sep),ue):null};return he.allBasenames=X.allBasenames,he.allPaths=X.allPaths,he.basenames=X.basenames,he.patterns=X.patterns,he}function u(X,Z){return Z.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function t(X,Z){return function(he,oe){return typeof he=="string"&&he.endsWith(X)?Z:null}}function m(X,Z){const he=`/${X}`,oe=`\\${X}`,ue=function(fe,Y){return typeof fe!="string"?null:Y?Y===X?Z:null:fe===X||fe.endsWith(he)||fe.endsWith(oe)?Z:null},ce=[X];return ue.basenames=ce,ue.patterns=[Z],ue.allBasenames=ce,ue}function p(X,Z){const he=z(X.slice(1,-1).split(",").map(Y=>d(Y,Z)).filter(Y=>Y!==a),X),oe=he.length;if(!oe)return a;if(oe===1)return he[0];const ue=function(Y,ge){for(let we=0,Me=he.length;we<Me;we++)if(he[we](Y,ge))return X;return null},ce=he.find(Y=>!!Y.allBasenames);ce&&(ue.allBasenames=ce.allBasenames);const fe=he.reduce((Y,ge)=>ge.allPaths?Y.concat(ge.allPaths):Y,[]);return fe.length&&(ue.allPaths=fe),ue}function A(X,Z,he){const oe=C.sep===C.posix.sep,ue=oe?X:X.replace(f,C.sep),ce=C.sep+ue,fe=C.posix.sep+X;let Y;return he?Y=function(ge,we){return typeof ge=="string"&&(ge===ue||ge.endsWith(ce)||!oe&&(ge===X||ge.endsWith(fe)))?Z:null}:Y=function(ge,we){return typeof ge=="string"&&(ge===ue||!oe&&ge===X)?Z:null},Y.allPaths=[(he?"*/":"./")+X],Y}function N(X){try{const Z=new RegExp(`^${i(X)}$`);return function(he){return Z.lastIndex=0,typeof he=="string"&&Z.test(he)?X:null}}catch{return a}}function q(X,Z,he){return!X||typeof Z!="string"?!1:j(X)(Z,void 0,he)}e.match=q;function j(X,Z={}){if(!X)return r;if(typeof X=="string"||V(X)){const he=d(X,Z);if(he===a)return r;const oe=function(ue,ce){return!!he(ue,ce)};return he.allBasenames&&(oe.allBasenames=he.allBasenames),he.allPaths&&(oe.allPaths=he.allPaths),oe}return F(X,Z)}e.parse=j;function V(X){const Z=X;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.isRelativePattern=V;function P(X){return X.allBasenames||[]}e.getBasenameTerms=P;function M(X){return X.allPaths||[]}e.getPathTerms=M;function F(X,Z){const he=z(Object.getOwnPropertyNames(X).map(Y=>$(Y,X[Y],Z)).filter(Y=>Y!==a)),oe=he.length;if(!oe)return a;if(!he.some(Y=>!!Y.requiresSiblings)){if(oe===1)return he[0];const Y=function(Me,We){let Qe;for(let Te=0,De=he.length;Te<De;Te++){const ke=he[Te](Me,We);if(typeof ke=="string")return ke;(0,T.isThenable)(ke)&&(Qe||(Qe=[]),Qe.push(ke))}return Qe?(async()=>{for(const Te of Qe){const De=await Te;if(typeof De=="string")return De}return null})():null},ge=he.find(Me=>!!Me.allBasenames);ge&&(Y.allBasenames=ge.allBasenames);const we=he.reduce((Me,We)=>We.allPaths?Me.concat(We.allPaths):Me,[]);return we.length&&(Y.allPaths=we),Y}const ue=function(Y,ge,we){let Me,We;for(let Qe=0,Te=he.length;Qe<Te;Qe++){const De=he[Qe];De.requiresSiblings&&we&&(ge||(ge=(0,C.basename)(Y)),Me||(Me=ge.substr(0,ge.length-(0,C.extname)(Y).length)));const ke=De(Y,ge,Me,we);if(typeof ke=="string")return ke;(0,T.isThenable)(ke)&&(We||(We=[]),We.push(ke))}return We?(async()=>{for(const Qe of We){const Te=await Qe;if(typeof Te=="string")return Te}return null})():null},ce=he.find(Y=>!!Y.allBasenames);ce&&(ue.allBasenames=ce.allBasenames);const fe=he.reduce((Y,ge)=>ge.allPaths?Y.concat(ge.allPaths):Y,[]);return fe.length&&(ue.allPaths=fe),ue}function $(X,Z,he){if(Z===!1)return a;const oe=d(X,he);if(oe===a)return a;if(typeof Z=="boolean")return oe;if(Z){const ue=Z.when;if(typeof ue=="string"){const ce=(fe,Y,ge,we)=>{if(!we||!oe(fe,Y))return null;const Me=ue.replace("$(basename)",ge),We=we(Me);return(0,T.isThenable)(We)?We.then(Qe=>Qe?X:null):We?X:null};return ce.requiresSiblings=!0,ce}}return oe}function z(X,Z){const he=X.filter(Y=>!!Y.basenames);if(he.length<2)return X;const oe=he.reduce((Y,ge)=>{const we=ge.basenames;return we?Y.concat(we):Y},[]);let ue;if(Z){ue=[];for(let Y=0,ge=oe.length;Y<ge;Y++)ue.push(Z)}else ue=he.reduce((Y,ge)=>{const we=ge.patterns;return we?Y.concat(we):Y},[]);const ce=function(Y,ge){if(typeof Y!="string")return null;if(!ge){let Me;for(Me=Y.length;Me>0;Me--){const We=Y.charCodeAt(Me-1);if(We===47||We===92)break}ge=Y.substr(Me)}const we=oe.indexOf(ge);return we!==-1?ue[we]:null};ce.basenames=oe,ce.patterns=ue,ce.allBasenames=oe;const fe=X.filter(Y=>!Y.basenames);return fe.push(ce),fe}function K(X,Z){return(0,n.equals)(X,Z,(he,oe)=>typeof he=="string"&&typeof oe=="string"?he===oe:typeof he!="string"&&typeof oe!="string"?he.base===oe.base&&he.pattern===oe.pattern:!1)}e.patternsEquals=K}),define(Ie[81],Ce([1,0,11,118,22,10,2]),function(te,e,n,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(l="",E=!1){if(this.value=l,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=E.isTrusted??void 0,this.supportThemeIcons=E.supportThemeIcons??!1,this.supportHtml=E.supportHtml??!1)}appendText(l,E=0){return this.value+=f(this.supportThemeIcons?(0,T.escapeIcons)(l):l).replace(/([ \t]+)/g,(b,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,E){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}appendLink(l,E,b){return this.value+="[",this.value+=this.c(E,"]"),this.value+="](",this.value+=this.c(String(l),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(l,E){const b=new RegExp((0,L.escapeRegExpCharacters)(E),"g");return l.replace(b,(g,w)=>l.charAt(w-1)!=="\\"?`\\${g}`:g)}}e.MarkdownString=S;function k(o){return O(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function O(o){return o instanceof S?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function D(o,l){return o===l?!0:!o||!l?!1:o.value===l.value&&o.isTrusted===l.isTrusted&&o.supportThemeIcons===l.supportThemeIcons&&o.supportHtml===l.supportHtml&&(o.baseUri===l.baseUri||!!o.baseUri&&!!l.baseUri&&(0,y.isEqual)(C.URI.from(o.baseUri),C.URI.from(l.baseUri)))}e.markdownStringEqual=D;function f(o){return o.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function v(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=v;function h(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function i(o){const l=[],E=o.split("|").map(g=>g.trim());o=E[0];const b=E[1];if(b){const g=/height=(\d+)/.exec(b),w=/width=(\d+)/.exec(b),s=g?g[1]:"",r=w?w[1]:"",a=isFinite(parseInt(r)),d=isFinite(parseInt(s));a&&l.push(`width="${r}"`),d&&l.push(`height="${s}"`)}return{href:o,dimensions:l}}e.parseHrefAndDimensions=i}),define(Ie[82],Ce([1,0,16,39,19,21,22,10]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(a,d){const{os:c,tildify:u,relative:t}=d;if(t){const A=k(a,t,c);if(typeof A=="string")return A}let m=a.fsPath;if(c===1&&!L.isWindows?m=m.replace(/\//g,"\\"):c!==1&&L.isWindows&&(m=m.replace(/\\/g,"/")),c!==1&&u?.userHome){const A=u.userHome.fsPath;let N;a.scheme!==u.userHome.scheme&&a.path.startsWith(y.posix.sep)?N=u.userHome.with({path:a.path}).fsPath:N=a.fsPath,m=f(N,A,c)}return(c===1?y.win32:y.posix).normalize(O(m,c===1))}e.getPathLabel=S;function k(a,d,c){const u=c===1?y.win32:y.posix,t=c===3?C.extUri:C.extUriIgnorePathCase,m=d.getWorkspace(),p=(0,n.firstOrDefault)(m.folders);if(!p)return;a.scheme!==p.uri.scheme&&a.path.startsWith(y.posix.sep)&&(a=p.uri.with({path:a.path}));const A=d.getWorkspaceFolder(a);if(!A)return;let N;if(t.isEqual(A.uri,a)?N="":N=t.relativePath(A.uri,a)??"",N&&(N=u.normalize(N)),m.folders.length>1&&!d.noPrefix){const q=A.name?A.name:t.basenameOrAuthority(A.uri);N=N?`${q} \u2022 ${N}`:q}return N}function O(a,d=L.isWindows){return(0,T.hasDriveLetter)(a,d)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=O;let D=Object.create(null);function f(a,d,c=L.OS){if(c===1||!a||!d)return a;let u=D.original===d?D.normalized:void 0;u||(u=d,L.isWindows&&(u=(0,T.toSlashes)(u)),u=`${(0,R.rtrim)(u,y.posix.sep)}${y.posix.sep}`,D={original:d,normalized:u});let t=a;return L.isWindows&&(t=(0,T.toSlashes)(t)),(c===3?t.startsWith(u):(0,R.startsWithIgnoreCase)(t,u))?`~/${t.substr(u.length)}`:a}e.tildify=f;function v(a,d){return a.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=v;const h="\u2026",i="\\\\",o="~";function l(a,d=y.sep){const c=new Array(a.length);let u=!1;for(let t=0;t<a.length;t++){const m=a[t];if(m===""){c[t]=`.${d}`;continue}if(!m){c[t]=m;continue}u=!0;let p="",A=m;A.indexOf(i)===0?(p=A.substr(0,A.indexOf(i)+i.length),A=A.substr(A.indexOf(i)+i.length)):A.indexOf(d)===0?(p=A.substr(0,A.indexOf(d)+d.length),A=A.substr(A.indexOf(d)+d.length)):A.indexOf(o)===0&&(p=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length));const N=A.split(d);for(let q=1;u&&q<=N.length;q++)for(let j=N.length-q;u&&j>=0;j--){u=!1;let V=N.slice(j,j+q).join(d);for(let P=0;!u&&P<a.length;P++)if(P!==t&&a[P]&&a[P].indexOf(V)>-1){const M=j+q===N.length,F=j>0&&a[P].indexOf(d)>-1?d+V:V,$=a[P].endsWith(F);u=!M||$}if(!u){let P="";(N[0].endsWith(":")||p!=="")&&(j===1&&(j=0,q++,V=N[0]+d+V),j>0&&(P=N[0]+d),P=p+P),j>0&&(P=P+h+d),P=P+V,j+q<N.length&&(P=P+d+h),c[t]=P}}u&&(c[t]=m)}return c}e.shorten=l;var E;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(E||(E={}));function b(a,d=Object.create(null)){const c=[];let u=!1,t="";for(const m of a)if(m==="$"||u&&m==="{")t&&c.push({value:t,type:E.TEXT}),t="",u=!0;else if(m==="}"&&u){const p=d[t];if(typeof p=="string")p.length&&c.push({value:p,type:E.VARIABLE});else if(p){const A=c[c.length-1];(!A||A.type!==E.SEPARATOR)&&c.push({value:p.label,type:E.SEPARATOR})}t="",u=!1}else t+=m;return t&&!u&&c.push({value:t,type:E.TEXT}),c.filter((m,p)=>{if(m.type===E.SEPARATOR){const A=c[p-1],N=c[p+1];return[A,N].every(q=>q&&(q.type===E.VARIABLE||q.type===E.TEXT)&&q.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=b;function g(a,d){return L.isMacintosh||d?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function w(a,d){return L.isMacintosh||d?a.replace(/\(&&\w\)|&&/g,""):L.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function s(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(a){const d=a.indexOf("/")!==-1?y.posix:y.win32,c=d.basename(a),u=d.dirname(a);return c.length?{name:c,parentPath:u}:{name:u,parentPath:""}}e.splitName=r}),define(Ie[121],Ce([1,0,2]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(O){return O.toJSON()}class y{constructor(D){this.a=D}transformIncoming(D){const f=this.a.transformIncoming(D);return f===D?D:T(n.URI.from(f))}transformOutgoing(D){const f=this.a.transformOutgoing(D);return f===D?D:T(n.URI.from(f))}transformOutgoingURI(D){const f=this.a.transformOutgoing(D);return f===D?D:n.URI.from(f)}transformOutgoingScheme(D){return this.a.transformOutgoingScheme(D)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function L(O,D,f){if(!O||f>200)return null;if(typeof O=="object"){if(O instanceof n.URI)return D.transformOutgoing(O);for(const v in O)if(Object.hasOwnProperty.call(O,v)){const h=L(O[v],D,f+1);h!==null&&(O[v]=h)}}return null}function C(O,D){const f=L(O,D,0);return f===null?O:f}e.transformOutgoingURIs=C;function R(O,D,f,v){if(!O||v>200)return null;if(typeof O=="object"){if(O.$mid===1)return f?n.URI.revive(D.transformIncoming(O)):D.transformIncoming(O);for(const h in O)if(Object.hasOwnProperty.call(O,h)){const i=R(O[h],D,f,v+1);i!==null&&(O[h]=i)}}return null}function S(O,D){const f=R(O,D,!1,0);return f===null?O:f}e.transformIncomingURIs=S;function k(O,D){const f=R(O,D,!0,0);return f===null?O:f}e.transformAndReviveIncomingURIs=k}),define(Ie[122],Ce([1,0,35,19]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(L,C,R,S,k,O){if(Array.isArray(L)){let D=0;for(const f of L){const v=y(f,C,R,S,k,O);if(v===10)return v;v>D&&(D=v)}return D}else{if(typeof L=="string")return S?L==="*"?5:L===R?10:0:0;if(L){const{language:D,pattern:f,scheme:v,hasAccessToAllModels:h,notebookType:i}=L;if(!S&&!h)return 0;i&&k&&(C=k);let o=0;if(v)if(v===C.scheme)o=10;else if(v==="*")o=5;else return 0;if(D)if(D===R)o=10;else if(D==="*")o=Math.max(o,5);else return 0;if(i)if(i===O)o=10;else if(i==="*"&&O!==void 0)o=Math.max(o,5);else return 0;if(f){let l;if(typeof f=="string"?l=f:l={...f,base:(0,T.normalize)(f.base)},l===C.fsPath||(0,n.match)(l,C.fsPath))o=10;else return 0}return o}else return 0}}e.score=y}),define(Ie[83],Ce([1,0,24,21]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(y||(y={}));function L(D){for(let f=0,v=D.length;f<v;f+=4){const h=D[f+0],i=D[f+1],o=D[f+2],l=D[f+3];D[f+0]=l,D[f+1]=o,D[f+2]=i,D[f+3]=h}}function C(D){const f=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return T.isLittleEndian()||L(f),n.VSBuffer.wrap(f)}function R(D){const f=D.buffer;if(T.isLittleEndian()||L(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const v=new Uint8Array(f.byteLength);return v.set(f),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function S(D){const f=new Uint32Array(k(D));let v=0;if(f[v++]=D.id,D.type==="full")f[v++]=1,f[v++]=D.data.length,f.set(D.data,v),v+=D.data.length;else{f[v++]=2,f[v++]=D.deltas.length;for(const h of D.deltas)f[v++]=h.start,f[v++]=h.deleteCount,h.data?(f[v++]=h.data.length,f.set(h.data,v),v+=h.data.length):f[v++]=0}return C(f)}e.encodeSemanticTokensDto=S;function k(D){let f=0;if(f+=1+1,D.type==="full")f+=1+D.data.length;else{f+=1,f+=(1+1+1)*D.deltas.length;for(const v of D.deltas)v.data&&(f+=v.data.length)}return f}function O(D){const f=R(D);let v=0;const h=f[v++];if(f[v++]===1){const E=f[v++],b=f.subarray(v,v+E);return v+=E,{id:h,type:"full",data:b}}const o=f[v++],l=[];for(let E=0;E<o;E++){const b=f[v++],g=f[v++],w=f[v++];let s;w>0&&(s=f.subarray(v,v+w),v+=w),l[E]={start:b,deleteCount:g,data:s}}return{id:h,type:"delta",deltas:l}}e.decodeSemanticTokensDto=O}),define(Ie[123],Ce([17,18]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ie[124],Ce([1,0,123,21,125,16,23,112]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class D{constructor(Q,pe,Ne,Be){this.id=Q,this.name=pe,this.defaultValue=Ne,this.schema=Be}applyUpdate(Q,pe){return v(Q,pe)}compute(Q,pe,Ne){return Ne}}class f{constructor(Q,pe){this.newValue=Q,this.didChange=pe}}e.ApplyUpdateResult=f;function v(_,Q){if(typeof _!="object"||typeof Q!="object"||!_||!Q)return new f(Q,_!==Q);if(Array.isArray(_)||Array.isArray(Q)){const Ne=Array.isArray(_)&&Array.isArray(Q)&&L.equals(_,Q);return new f(Q,!Ne)}let pe=!1;for(const Ne in Q)if(Q.hasOwnProperty(Ne)){const Be=v(_[Ne],Q[Ne]);Be.didChange&&(_[Ne]=Be.newValue,pe=!0)}return new f(_,pe)}class h{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,pe){return v(Q,pe)}validate(Q){return this.defaultValue}}class i{constructor(Q,pe,Ne,Be){this.id=Q,this.name=pe,this.defaultValue=Ne,this.schema=Be}applyUpdate(Q,pe){return v(Q,pe)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,pe,Ne){return Ne}}function o(_,Q){return typeof _>"u"?Q:_==="false"?!1:Boolean(_)}e.boolean=o;class l extends i{constructor(Q,pe,Ne,Be=void 0){typeof Be<"u"&&(Be.type="boolean",Be.default=Ne),super(Q,pe,Ne,Be)}validate(Q){return o(Q,this.defaultValue)}}function E(_,Q,pe,Ne){if(typeof _>"u")return Q;let Be=parseInt(_,10);return isNaN(Be)?Q:(Be=Math.max(pe,Be),Be=Math.min(Ne,Be),Be|0)}e.clampedInt=E;class b extends i{static clampedInt(Q,pe,Ne,Be){return E(Q,pe,Ne,Be)}constructor(Q,pe,Ne,Be,je,Je=void 0){typeof Je<"u"&&(Je.type="integer",Je.default=Ne,Je.minimum=Be,Je.maximum=je),super(Q,pe,Ne,Je),this.minimum=Be,this.maximum=je}validate(Q){return b.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class g extends i{static clamp(Q,pe,Ne){return Q<pe?pe:Q>Ne?Ne:Q}static float(Q,pe){if(typeof Q=="number")return Q;if(typeof Q>"u")return pe;const Ne=parseFloat(Q);return isNaN(Ne)?pe:Ne}constructor(Q,pe,Ne,Be,je){typeof je<"u"&&(je.type="number",je.default=Ne),super(Q,pe,Ne,je),this.validationFn=Be}validate(Q){return this.validationFn(g.float(Q,this.defaultValue))}}class w extends i{static string(Q,pe){return typeof Q!="string"?pe:Q}constructor(Q,pe,Ne,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.default=Ne),super(Q,pe,Ne,Be)}validate(Q){return w.string(Q,this.defaultValue)}}function s(_,Q,pe){return typeof _!="string"||pe.indexOf(_)===-1?Q:_}e.stringSet=s;class r extends i{constructor(Q,pe,Ne,Be,je=void 0){typeof je<"u"&&(je.type="string",je.enum=Be,je.default=Ne),super(Q,pe,Ne,je),this.c=Be}validate(Q){return s(Q,this.defaultValue,this.c)}}class a extends D{constructor(Q,pe,Ne,Be,je,Je,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=je,nt.default=Be),super(Q,pe,Ne,nt),this.c=je,this.d=Je}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function d(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,pe,Ne){return Ne===0?Q.accessibilitySupport:Ne}}class u extends D{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:n.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var t;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(t=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function A(_){switch(_){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=A;function N(_){switch(_){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class q extends h{constructor(){super(133)}compute(Q,pe,Ne){const Be=["monaco-editor"];return pe.get(34)&&Be.push(pe.get(34)),Q.extraEditorClassName&&Be.push(Q.extraEditorClassName),pe.get(68)==="default"?Be.push("mouse-default"):pe.get(68)==="copy"&&Be.push("mouse-copy"),pe.get(103)&&Be.push("showUnused"),pe.get(131)&&Be.push("showDeprecated"),Be.join(" ")}}class j extends l{constructor(){super(33,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(Q,pe,Ne){return Ne&&Q.emptySelectionClipboard}}class V extends D{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:n.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:n.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class P extends D{constructor(){super(46,"fontLigatures",P.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?P.OFF:Q==="true"?P.ON:Q:Boolean(Q)?P.ON:P.OFF}}e.EditorFontLigatures=P,P.OFF='"liga" off, "calt" off',P.ON='"liga" on, "calt" on';class M extends D{constructor(){super(49,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?M.OFF:Q==="true"?M.TRANSLATE:Q:Boolean(Q)?M.TRANSLATE:M.OFF}compute(Q,pe,Ne){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=M,M.OFF="normal",M.TRANSLATE="translate";class F extends h{constructor(){super(45)}compute(Q,pe,Ne){return Q.fontInfo}}class $ extends i{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(Q){const pe=g.float(Q,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(pe,6,100)}compute(Q,pe,Ne){return Q.fontInfo.fontSize}}class z extends D{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(b.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class K extends D{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ne,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ne,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ne,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ne,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ne,description:n.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends D{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:n.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:b.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),above:o(pe.above,this.defaultValue.above)}}}var Z;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Z=e.RenderMinimap||(e.RenderMinimap={}));class he extends h{constructor(){super(136)}compute(Q,pe,Ne){return he.computeLayout(pe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const pe=Q.height/Q.lineHeight,Ne=Q.scrollBeyondLastLine?pe-1:0,Be=(Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),je=Math.floor(Q.viewLineCount/Be);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ne,desiredRatio:Be,minimapLineCount:je}}static c(Q,pe){const Ne=Q.outerWidth,Be=Q.outerHeight,je=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Je=pe.stableMinimapLayoutInput,nt=Je&&Q.outerHeight===Je.outerHeight&&Q.lineHeight===Je.lineHeight&&Q.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Je.pixelRatio&&Q.scrollBeyondLastLine===Je.scrollBeyondLastLine&&Q.minimap.enabled===Je.minimap.enabled&&Q.minimap.side===Je.minimap.side&&Q.minimap.size===Je.minimap.size&&Q.minimap.showSlider===Je.minimap.showSlider&&Q.minimap.renderCharacters===Je.minimap.renderCharacters&&Q.minimap.maxColumn===Je.minimap.maxColumn&&Q.minimap.scale===Je.minimap.scale&&Q.verticalScrollbarWidth===Je.verticalScrollbarWidth&&Q.isViewportWrapping===Je.isViewportWrapping,vt=Q.lineHeight,wt=Q.typicalHalfwidthCharacterWidth,Tt=Q.scrollBeyondLastLine,lt=Q.minimap.renderCharacters;let at=je>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Ut=Q.minimap.maxColumn,Ft=Q.minimap.size,Mt=Q.minimap.side,ft=Q.verticalScrollbarWidth,Ct=Q.viewLineCount,Bt=Q.remainingWidth,Nt=Q.isViewportWrapping,Ge=lt?2:3;let Rt=Math.floor(je*Be);const Lt=Rt/je;let Ht=!1,mt=!1,At=Ge*at,ye=at/je,Pe=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:It,desiredRatio:bt,minimapLineCount:kt}=he.computeContainedMinimapLineCount({viewLineCount:Ct,scrollBeyondLastLine:Tt,height:Be,lineHeight:vt,pixelRatio:je});if(Ct/kt>1)Ht=!0,mt=!0,at=1,At=1,ye=at/je;else{let pt=!1,St=at+1;if(Ft==="fit"){const $t=Math.ceil((Ct+It)*At);Nt&&nt&&Bt<=pe.stableFitRemainingWidth?(pt=!0,St=pe.stableFitMaxMinimapScale):pt=$t>Rt}if(Ft==="fill"||pt){Ht=!0;const $t=at;At=Math.min(vt*je,Math.max(1,Math.floor(1/bt))),Nt&&nt&&Bt<=pe.stableFitRemainingWidth&&(St=pe.stableFitMaxMinimapScale),at=Math.min(St,Math.max(1,Math.floor(At/Ge))),at>$t&&(Pe=Math.min(2,at/$t)),ye=at/je/Pe,Rt=Math.ceil(Math.max(Ze,Ct+It)*At),Nt?(pe.stableMinimapLayoutInput=Q,pe.stableFitRemainingWidth=Bt,pe.stableFitMaxMinimapScale=at):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const me=Math.floor(Ut*ye),x=Math.min(me,Math.max(0,Math.floor((Bt-ft-2)*ye/(wt+ye)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(je*x);const Le=Ae/je;Ae=Math.floor(Ae*Pe);const Xe=lt?1:2,ze=Mt==="left"?0:Ne-x-ft;return{renderMinimap:Xe,minimapLeft:ze,minimapWidth:x,minimapHeightIsEditorHeight:Ht,minimapIsSampling:mt,minimapScale:at,minimapLineHeight:At,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Lt}}static computeLayout(Q,pe){const Ne=pe.outerWidth|0,Be=pe.outerHeight|0,je=pe.lineHeight|0,Je=pe.lineNumbersDigitCount|0,nt=pe.typicalHalfwidthCharacterWidth,vt=pe.maxDigitWidth,wt=pe.pixelRatio,Tt=pe.viewLineCount,lt=Q.get(128),at=lt==="inherit"?Q.get(127):lt,Ut=at==="inherit"?Q.get(123):at,Ft=Q.get(126),Mt=pe.isDominatedByLongLines,ft=Q.get(52),Ct=Q.get(62).renderType!==0,Bt=Q.get(63),Nt=Q.get(97),Ge=Q.get(67),Rt=Q.get(95),Lt=Rt.verticalScrollbarSize,Ht=Rt.verticalHasArrows,mt=Rt.arrowSize,At=Rt.horizontalScrollbarSize,ye=Q.get(38),Pe=Q.get(102)!=="never";let me=Q.get(60);ye&&Pe&&(me+=16);let x=0;if(Ct){const Et=Math.max(Je,Bt);x=Math.round(Et*vt)}let Ae=0;ft&&(Ae=je);let Le=0,Xe=Le+Ae,ze=Xe+x,Ze=ze+me;const It=Ne-Ae-x-me;let bt=!1,kt=!1,gt=-1;at==="inherit"&&Mt?(bt=!0,kt=!0):Ut==="on"||Ut==="bounded"?kt=!0:Ut==="wordWrapColumn"&&(gt=Ft);const pt=he.c({outerWidth:Ne,outerHeight:Be,lineHeight:je,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:Nt,minimap:Ge,verticalScrollbarWidth:Lt,viewLineCount:Tt,remainingWidth:It,isViewportWrapping:kt},pe.memory||new O);pt.renderMinimap!==0&&pt.minimapLeft===0&&(Le+=pt.minimapWidth,Xe+=pt.minimapWidth,ze+=pt.minimapWidth,Ze+=pt.minimapWidth);const St=It-pt.minimapWidth,$t=Math.max(1,Math.floor((St-Lt-2)/nt)),Xt=Ht?mt:0;return kt&&(gt=Math.max(1,$t),Ut==="bounded"&&(gt=Math.min(gt,Ft))),{width:Ne,height:Be,glyphMarginLeft:Le,glyphMarginWidth:Ae,lineNumbersLeft:Xe,lineNumbersWidth:x,decorationsLeft:ze,decorationsWidth:me,contentLeft:Ze,contentWidth:St,minimap:pt,viewportColumn:$t,isWordWrapMinified:bt,isViewportWrapping:kt,wrappingColumn:gt,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:At,overviewRuler:{top:Xt,width:Lt,height:Be-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=he;class oe extends D{constructor(){super(130,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(Q){return s(Q,"simple",["simple","advanced"])}compute(Q,pe,Ne){return pe.get(2)===2?"advanced":Ne}}class ue extends D{constructor(){const Q={enabled:!0};super(59,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:n.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class ce extends D{constructor(){const Q={enabled:!1,maxLineCount:5};super(107,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class fe extends D{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(132,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:n.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class Y extends D{constructor(){super(60,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):b.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,pe,Ne){return Ne<0?b.clampedInt(-Ne*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ne}}class ge extends g{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>g.clamp(Q,0,150),{markdownDescription:n.localize(60,null)})}compute(Q,pe,Ne){return Q.fontInfo.lineHeight}}class we extends D{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:Q.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:n.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(pe.scale,1,1,3),maxColumn:b.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Me(_){return _==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class We extends D{constructor(){super(78,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{top:b.clampedInt(pe.top,0,0,1e3),bottom:b.clampedInt(pe.bottom,0,0,1e3)}}}class Qe extends D{constructor(){const Q={enabled:!0,cycle:!1};super(79,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:n.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class Te extends h{constructor(){super(134)}compute(Q,pe,Ne){return Q.pixelRatio}}class De extends D{constructor(){const Q={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(82,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Q.strings,description:n.localize(79,null)},comments:{anyOf:pe,default:Q.comments,description:n.localize(80,null)},other:{anyOf:pe,default:Q.other,description:n.localize(81,null)}},default:Q,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const wt=Q?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:pe,comments:Ne,strings:Be}=Q,je=["on","inline","off"];let Je,nt,vt;return typeof pe=="boolean"?Je=pe?"on":"off":Je=s(pe,this.defaultValue.other,je),typeof Ne=="boolean"?nt=Ne?"on":"off":nt=s(Ne,this.defaultValue.comments,je),typeof Be=="boolean"?vt=Be?"on":"off":vt=s(Be,this.defaultValue.strings,je),{other:Je,comments:nt,strings:vt}}}var ke;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class re extends D{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(Q){let pe=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(pe=4,Ne=Q):Q==="interval"?pe=3:Q==="relative"?pe=2:Q==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ne}}}function ae(_){const Q=_.get(90);return Q==="editable"?_.get(84):Q!=="on"}e.filterValidationDecorations=ae;class J extends D{constructor(){const Q=[],pe={type:"number",description:n.localize(88,null)};super(94,"rulers",Q,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:Q,description:n.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const pe=[];for(const Ne of Q)if(typeof Ne=="number")pe.push({column:b.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Be=Ne;pe.push({column:b.clampedInt(Be.column,0,0,1e4),color:Be.color})}return pe.sort((Ne,Be)=>Ne.column-Be.column),pe}return this.defaultValue}}function I(_,Q){if(typeof _!="string")return Q;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends D{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(95,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:n.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q,Ne=b.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=b.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(pe.vertical,this.defaultValue.vertical),horizontal:I(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:b.clampedInt(pe.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:b.clampedInt(pe.verticalSliderSize,Be,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends D{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(117,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:n.localize(108,null)}})}applyUpdate(Q,pe){let Ne=!1;pe.allowedCharacters&&Q&&(C.equals(Q.allowedCharacters,pe.allowedCharacters)||(Q={...Q,allowedCharacters:pe.allowedCharacters},Ne=!0)),pe.allowedLocales&&Q&&(C.equals(Q.allowedLocales,pe.allowedLocales)||(Q={...Q,allowedLocales:pe.allowedLocales},Ne=!0));const Be=super.applyUpdate(Q,pe);return Ne?new f(Be.newValue,!0):Be}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{nonBasicASCII:Se(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Se(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Se(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,pe){if(typeof Q!="object"||!Q)return pe;const Ne={};for(const[Be,je]of Object.entries(Q))je===!0&&(Ne[Be]=!0);return Ne}}class G extends D{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:n.localize(109,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends D{constructor(){const Q={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:n.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:n.localize(111,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class le extends D{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(112,null),n.localize(113,null),n.localize(114,null)],default:Q.bracketPairs,description:n.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(116,null),n.localize(117,null),n.localize(118,null)],default:Q.bracketPairsHorizontal,description:n.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:n.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:n.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(122,null),n.localize(123,null),n.localize(124,null)],default:Q.highlightActiveIndentation,description:n.localize(125,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{bracketPairs:Se(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Se(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Se(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Se(_,Q,pe){const Ne=pe.indexOf(_);return Ne===-1?Q:pe[Ne]}class se extends D{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(110,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(126,null),n.localize(127,null)],default:Q.insertMode,description:n.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:n.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:n.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:n.localize(131,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:n.localize(132,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:n.localize(133,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:n.localize(134,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:n.localize(135,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:n.localize(136,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(137,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(138,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(139,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(140,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(141,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(142,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(143,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(144,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(145,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(146,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:o(pe.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class ve extends D{constructor(){super(105,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(169,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class be extends h{constructor(){super(135)}compute(Q,pe,Ne){return pe.get(84)?!0:Q.tabFocusMode}}var $e;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})($e=e.WrappingIndent||(e.WrappingIndent={}));class He extends D{constructor(){super(129,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(170,null),n.localize(171,null),n.localize(172,null),n.localize(173,null)],description:n.localize(174,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,pe,Ne){return pe.get(2)===2?0:Ne}}class tt extends h{constructor(){super(137)}compute(Q,pe,Ne){const Be=pe.get(136);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}class xe extends D{constructor(){const Q={enabled:!0};super(32,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:n.localize(175,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?it:T.isLinux?dt:et,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.autoClosingBrackets=5]="autoClosingBrackets",_[_.autoClosingDelete=6]="autoClosingDelete",_[_.autoClosingOvertype=7]="autoClosingOvertype",_[_.autoClosingQuotes=8]="autoClosingQuotes",_[_.autoIndent=9]="autoIndent",_[_.automaticLayout=10]="automaticLayout",_[_.autoSurround=11]="autoSurround",_[_.bracketPairColorization=12]="bracketPairColorization",_[_.guides=13]="guides",_[_.codeLens=14]="codeLens",_[_.codeLensFontFamily=15]="codeLensFontFamily",_[_.codeLensFontSize=16]="codeLensFontSize",_[_.colorDecorators=17]="colorDecorators",_[_.columnSelection=18]="columnSelection",_[_.comments=19]="comments",_[_.contextmenu=20]="contextmenu",_[_.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",_[_.cursorBlinking=22]="cursorBlinking",_[_.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",_[_.cursorStyle=24]="cursorStyle",_[_.cursorSurroundingLines=25]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",_[_.cursorWidth=27]="cursorWidth",_[_.disableLayerHinting=28]="disableLayerHinting",_[_.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",_[_.domReadOnly=30]="domReadOnly",_[_.dragAndDrop=31]="dragAndDrop",_[_.dropIntoEditor=32]="dropIntoEditor",_[_.emptySelectionClipboard=33]="emptySelectionClipboard",_[_.extraEditorClassName=34]="extraEditorClassName",_[_.fastScrollSensitivity=35]="fastScrollSensitivity",_[_.find=36]="find",_[_.fixedOverflowWidgets=37]="fixedOverflowWidgets",_[_.folding=38]="folding",_[_.foldingStrategy=39]="foldingStrategy",_[_.foldingHighlight=40]="foldingHighlight",_[_.foldingImportsByDefault=41]="foldingImportsByDefault",_[_.foldingMaximumRegions=42]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=44]="fontFamily",_[_.fontInfo=45]="fontInfo",_[_.fontLigatures=46]="fontLigatures",_[_.fontSize=47]="fontSize",_[_.fontWeight=48]="fontWeight",_[_.fontVariations=49]="fontVariations",_[_.formatOnPaste=50]="formatOnPaste",_[_.formatOnType=51]="formatOnType",_[_.glyphMargin=52]="glyphMargin",_[_.gotoLocation=53]="gotoLocation",_[_.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",_[_.hover=55]="hover",_[_.inDiffEditor=56]="inDiffEditor",_[_.inlineSuggest=57]="inlineSuggest",_[_.letterSpacing=58]="letterSpacing",_[_.lightbulb=59]="lightbulb",_[_.lineDecorationsWidth=60]="lineDecorationsWidth",_[_.lineHeight=61]="lineHeight",_[_.lineNumbers=62]="lineNumbers",_[_.lineNumbersMinChars=63]="lineNumbersMinChars",_[_.linkedEditing=64]="linkedEditing",_[_.links=65]="links",_[_.matchBrackets=66]="matchBrackets",_[_.minimap=67]="minimap",_[_.mouseStyle=68]="mouseStyle",_[_.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=70]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",_[_.multiCursorModifier=72]="multiCursorModifier",_[_.multiCursorPaste=73]="multiCursorPaste",_[_.multiCursorLimit=74]="multiCursorLimit",_[_.occurrencesHighlight=75]="occurrencesHighlight",_[_.overviewRulerBorder=76]="overviewRulerBorder",_[_.overviewRulerLanes=77]="overviewRulerLanes",_[_.padding=78]="padding",_[_.parameterHints=79]="parameterHints",_[_.peekWidgetDefaultFocus=80]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=81]="definitionLinkOpensInPeek",_[_.quickSuggestions=82]="quickSuggestions",_[_.quickSuggestionsDelay=83]="quickSuggestionsDelay",_[_.readOnly=84]="readOnly",_[_.renameOnType=85]="renameOnType",_[_.renderControlCharacters=86]="renderControlCharacters",_[_.renderFinalNewline=87]="renderFinalNewline",_[_.renderLineHighlight=88]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=89]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=90]="renderValidationDecorations",_[_.renderWhitespace=91]="renderWhitespace",_[_.revealHorizontalRightPadding=92]="revealHorizontalRightPadding",_[_.roundedSelection=93]="roundedSelection",_[_.rulers=94]="rulers",_[_.scrollbar=95]="scrollbar",_[_.scrollBeyondLastColumn=96]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=97]="scrollBeyondLastLine",_[_.scrollPredominantAxis=98]="scrollPredominantAxis",_[_.selectionClipboard=99]="selectionClipboard",_[_.selectionHighlight=100]="selectionHighlight",_[_.selectOnLineNumbers=101]="selectOnLineNumbers",_[_.showFoldingControls=102]="showFoldingControls",_[_.showUnused=103]="showUnused",_[_.snippetSuggestions=104]="snippetSuggestions",_[_.smartSelect=105]="smartSelect",_[_.smoothScrolling=106]="smoothScrolling",_[_.stickyScroll=107]="stickyScroll",_[_.stickyTabStops=108]="stickyTabStops",_[_.stopRenderingLineAfter=109]="stopRenderingLineAfter",_[_.suggest=110]="suggest",_[_.suggestFontSize=111]="suggestFontSize",_[_.suggestLineHeight=112]="suggestLineHeight",_[_.suggestOnTriggerCharacters=113]="suggestOnTriggerCharacters",_[_.suggestSelection=114]="suggestSelection",_[_.tabCompletion=115]="tabCompletion",_[_.tabIndex=116]="tabIndex",_[_.unicodeHighlighting=117]="unicodeHighlighting",_[_.unusualLineTerminators=118]="unusualLineTerminators",_[_.useShadowDOM=119]="useShadowDOM",_[_.useTabStops=120]="useTabStops",_[_.wordBreak=121]="wordBreak",_[_.wordSeparators=122]="wordSeparators",_[_.wordWrap=123]="wordWrap",_[_.wordWrapBreakAfterCharacters=124]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=125]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=126]="wordWrapColumn",_[_.wordWrapOverride1=127]="wordWrapOverride1",_[_.wordWrapOverride2=128]="wordWrapOverride2",_[_.wrappingIndent=129]="wrappingIndent",_[_.wrappingStrategy=130]="wrappingStrategy",_[_.showDeprecated=131]="showDeprecated",_[_.inlayHints=132]="inlayHints",_[_.editorClassName=133]="editorClassName",_[_.pixelRatio=134]="pixelRatio",_[_.tabFocusMode=135]="tabFocusMode",_[_.layoutInfo=136]="layoutInfo",_[_.wrappingInfo=137]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(176,null)})),acceptSuggestionOnEnter:Fe(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(177,null),""],markdownDescription:n.localize(178,null)})),accessibilitySupport:Fe(new c),accessibilityPageSize:Fe(new b(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(179,null),tags:["accessibility"]})),ariaLabel:Fe(new w(4,"ariaLabel",n.localize(180,null))),autoClosingBrackets:Fe(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(181,null),n.localize(182,null),""],description:n.localize(183,null)})),autoClosingDelete:Fe(new r(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(184,null),""],description:n.localize(185,null)})),autoClosingOvertype:Fe(new r(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(186,null),""],description:n.localize(187,null)})),autoClosingQuotes:Fe(new r(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(188,null),n.localize(189,null),""],description:n.localize(190,null)})),autoIndent:Fe(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[n.localize(191,null),n.localize(192,null),n.localize(193,null),n.localize(194,null),n.localize(195,null)],description:n.localize(196,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new r(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(197,null),n.localize(198,null),n.localize(199,null),""],description:n.localize(200,null)})),bracketPairColorization:Fe(new ee),bracketPairGuides:Fe(new le),stickyTabStops:Fe(new l(108,"stickyTabStops",!1,{description:n.localize(201,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:n.localize(202,null)})),codeLensFontFamily:Fe(new w(15,"codeLensFontFamily","",{description:n.localize(203,null)})),codeLensFontSize:Fe(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(204,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:n.localize(205,null)})),columnSelection:Fe(new l(18,"columnSelection",!1,{description:n.localize(206,null)})),comments:Fe(new u),contextmenu:Fe(new l(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(21,"copyWithSyntaxHighlighting",!0,{description:n.localize(207,null)})),cursorBlinking:Fe(new a(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:n.localize(208,null)})),cursorSmoothCaretAnimation:Fe(new l(23,"cursorSmoothCaretAnimation",!1,{description:n.localize(209,null)})),cursorStyle:Fe(new a(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:n.localize(210,null)})),cursorSurroundingLines:Fe(new b(25,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(211,null)})),cursorSurroundingLinesStyle:Fe(new r(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(212,null),n.localize(213,null)],description:n.localize(214,null)})),cursorWidth:Fe(new b(27,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(215,null)})),disableLayerHinting:Fe(new l(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(30,"domReadOnly",!1)),dragAndDrop:Fe(new l(31,"dragAndDrop",!0,{description:n.localize(216,null)})),emptySelectionClipboard:Fe(new j),dropIntoEditor:Fe(new xe),stickyScroll:Fe(new ce),extraEditorClassName:Fe(new w(34,"extraEditorClassName","")),fastScrollSensitivity:Fe(new g(35,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:n.localize(217,null)})),find:Fe(new V),fixedOverflowWidgets:Fe(new l(37,"fixedOverflowWidgets",!1)),folding:Fe(new l(38,"folding",!0,{description:n.localize(218,null)})),foldingStrategy:Fe(new r(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(219,null),n.localize(220,null)],description:n.localize(221,null)})),foldingHighlight:Fe(new l(40,"foldingHighlight",!0,{description:n.localize(222,null)})),foldingImportsByDefault:Fe(new l(41,"foldingImportsByDefault",!1,{description:n.localize(223,null)})),foldingMaximumRegions:Fe(new b(42,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(224,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(43,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(225,null)})),fontFamily:Fe(new w(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(226,null)})),fontInfo:Fe(new F),fontLigatures2:Fe(new P),fontSize:Fe(new $),fontWeight:Fe(new z),fontVariations:Fe(new M),formatOnPaste:Fe(new l(50,"formatOnPaste",!1,{description:n.localize(227,null)})),formatOnType:Fe(new l(51,"formatOnType",!1,{description:n.localize(228,null)})),glyphMargin:Fe(new l(52,"glyphMargin",!0,{description:n.localize(229,null)})),gotoLocation:Fe(new K),hideCursorInOverviewRuler:Fe(new l(54,"hideCursorInOverviewRuler",!1,{description:n.localize(230,null)})),hover:Fe(new X),inDiffEditor:Fe(new l(56,"inDiffEditor",!1)),letterSpacing:Fe(new g(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>g.clamp(_,-5,20),{description:n.localize(231,null)})),lightbulb:Fe(new ue),lineDecorationsWidth:Fe(new Y),lineHeight:Fe(new ge),lineNumbers:Fe(new re),lineNumbersMinChars:Fe(new b(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(64,"linkedEditing",!1,{description:n.localize(232,null)})),links:Fe(new l(65,"links",!0,{description:n.localize(233,null)})),matchBrackets:Fe(new r(66,"matchBrackets","always",["always","near","never"],{description:n.localize(234,null)})),minimap:Fe(new we),mouseStyle:Fe(new r(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new g(69,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:n.localize(235,null)})),mouseWheelZoom:Fe(new l(70,"mouseWheelZoom",!1,{markdownDescription:n.localize(236,null)})),multiCursorMergeOverlapping:Fe(new l(71,"multiCursorMergeOverlapping",!0,{description:n.localize(237,null)})),multiCursorModifier:Fe(new a(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Me,{markdownEnumDescriptions:[n.localize(238,null),n.localize(239,null)],markdownDescription:n.localize(240,null)})),multiCursorPaste:Fe(new r(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(241,null),n.localize(242,null)],markdownDescription:n.localize(243,null)})),multiCursorLimit:Fe(new b(74,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(244,null)})),occurrencesHighlight:Fe(new l(75,"occurrencesHighlight",!0,{description:n.localize(245,null)})),overviewRulerBorder:Fe(new l(76,"overviewRulerBorder",!0,{description:n.localize(246,null)})),overviewRulerLanes:Fe(new b(77,"overviewRulerLanes",3,0,3)),padding:Fe(new We),parameterHints:Fe(new Qe),peekWidgetDefaultFocus:Fe(new r(80,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(247,null),n.localize(248,null)],description:n.localize(249,null)})),definitionLinkOpensInPeek:Fe(new l(81,"definitionLinkOpensInPeek",!1,{description:n.localize(250,null)})),quickSuggestions:Fe(new De),quickSuggestionsDelay:Fe(new b(83,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(251,null)})),readOnly:Fe(new l(84,"readOnly",!1)),renameOnType:Fe(new l(85,"renameOnType",!1,{description:n.localize(252,null),markdownDeprecationMessage:n.localize(253,null)})),renderControlCharacters:Fe(new l(86,"renderControlCharacters",!0,{description:n.localize(254,null),restricted:!0})),renderFinalNewline:Fe(new l(87,"renderFinalNewline",!0,{description:n.localize(255,null)})),renderLineHighlight:Fe(new r(88,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(256,null)],description:n.localize(257,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(89,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(258,null)})),renderValidationDecorations:Fe(new r(90,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new r(91,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(259,null),n.localize(260,null),n.localize(261,null),""],description:n.localize(262,null)})),revealHorizontalRightPadding:Fe(new b(92,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(93,"roundedSelection",!0,{description:n.localize(263,null)})),rulers:Fe(new J),scrollbar:Fe(new U),scrollBeyondLastColumn:Fe(new b(96,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(264,null)})),scrollBeyondLastLine:Fe(new l(97,"scrollBeyondLastLine",!0,{description:n.localize(265,null)})),scrollPredominantAxis:Fe(new l(98,"scrollPredominantAxis",!0,{description:n.localize(266,null)})),selectionClipboard:Fe(new l(99,"selectionClipboard",!0,{description:n.localize(267,null),included:T.isLinux})),selectionHighlight:Fe(new l(100,"selectionHighlight",!0,{description:n.localize(268,null)})),selectOnLineNumbers:Fe(new l(101,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new r(102,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(269,null),n.localize(270,null),n.localize(271,null)],description:n.localize(272,null)})),showUnused:Fe(new l(103,"showUnused",!0,{description:n.localize(273,null)})),showDeprecated:Fe(new l(131,"showDeprecated",!0,{description:n.localize(274,null)})),inlayHints:Fe(new fe),snippetSuggestions:Fe(new r(104,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(275,null),n.localize(276,null),n.localize(277,null),n.localize(278,null)],description:n.localize(279,null)})),smartSelect:Fe(new ve),smoothScrolling:Fe(new l(106,"smoothScrolling",!1,{description:n.localize(280,null)})),stopRenderingLineAfter:Fe(new b(109,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new se),inlineSuggest:Fe(new G),suggestFontSize:Fe(new b(111,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(281,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new b(112,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(282,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(113,"suggestOnTriggerCharacters",!0,{description:n.localize(283,null)})),suggestSelection:Fe(new r(114,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(284,null),n.localize(285,null),n.localize(286,null)],description:n.localize(287,null)})),tabCompletion:Fe(new r(115,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(288,null),n.localize(289,null),n.localize(290,null)],description:n.localize(291,null)})),tabIndex:Fe(new b(116,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new H),unusualLineTerminators:Fe(new r(118,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(292,null),n.localize(293,null),n.localize(294,null)],description:n.localize(295,null)})),useShadowDOM:Fe(new l(119,"useShadowDOM",!0)),useTabStops:Fe(new l(120,"useTabStops",!0,{description:n.localize(296,null)})),wordBreak:Fe(new r(121,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(297,null),n.localize(298,null)],description:n.localize(299,null)})),wordSeparators:Fe(new w(122,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:n.localize(300,null)})),wordWrap:Fe(new r(123,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(301,null),n.localize(302,null),n.localize(303,null),n.localize(304,null)],description:n.localize(305,null)})),wordWrapBreakAfterCharacters:Fe(new w(124,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new w(125,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new b(126,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(306,null)})),wordWrapOverride1:Fe(new r(127,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new r(128,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new q),pixelRatio:Fe(new Te),tabFocusMode:Fe(new be),layoutInfo:Fe(new he),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new oe)}}),define(Ie[126],Ce([17,18]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[127],Ce([17,18]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[128],Ce([17,18]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[129],Ce([17,18]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ie[130],Ce([17,18]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ie[131],Ce([17,18]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ie[132],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[133],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[134],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[135],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[136],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[137],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[138],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[139],Ce([17,18]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ie[140],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[141],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[142],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[143],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[144],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[145],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[146],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[147],Ce([1,0,11]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this.a=new Map}register(L,C){this.a.set(L,C)}updateManifest(L){if(!(typeof L.main>"u"&&typeof L.browser>"u")&&(L.activationEvents===void 0&&Object.assign(L,{activationEvents:[]}),!(!Array.isArray(L.activationEvents)||!L.contributes)))for(const C in L.contributes){const R=this.a.get(C);if(!R)continue;const S=L.contributes[C],k=Array.isArray(S)?S:[S];try{R(k,L.activationEvents)}catch(O){(0,n.onUnexpectedError)(O)}}}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(Ie[148],Ce([1,0,22,29,128,248]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||C.test(l)}e.isValidVersionStr=S;function k(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const E=l.match(C);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=k;function O(l){if(!l)return null;const E=l.majorBase,b=l.majorMustEqual,g=l.minorBase;let w=l.minorMustEqual;const s=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(E===0||(w=!1),r=!1);let a=0;if(l.preRelease){const d=R.exec(l.preRelease);if(d){const[,c,u,t]=d;a=Date.UTC(Number(c),Number(u)-1,Number(t))}}return{majorBase:E,majorMustEqual:b,minorBase:g,minorMustEqual:w,patchBase:s,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=O;function D(l,E,b){let g;typeof l=="string"?g=O(k(l)):g=l;let w;E instanceof Date?w=E.getTime():typeof E=="string"&&(w=new Date(E).getTime());let s;if(typeof b=="string"?s=O(k(b)):s=b,!g||!s)return!1;const r=g.majorBase,a=g.minorBase,d=g.patchBase;let c=s.majorBase,u=s.minorBase,t=s.patchBase;const m=s.notBefore;let p=s.majorMustEqual,A=s.minorMustEqual,N=s.patchMustEqual;return s.isMinimum?r>c?!0:r<c?!1:a>u?!0:a<u||w&&w<m?!1:d>=t:(r===1&&c===0&&(!p||!A||!N)&&(c=1,u=0,t=0,p=!0,A=!1,N=!1),r<c?!1:r>c?!p:a<u?!1:a>u?!A:d<t?!1:d>t?!N:!(w&&w<m))}e.isValidVersion=D;function f(l,E,b,g,w){const s=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return s.push([T.default.Error,y.localize(0,null)]),s;if(typeof g.name!="string")return s.push([T.default.Error,y.localize(1,null,"name")]),s;if(typeof g.version!="string")return s.push([T.default.Error,y.localize(2,null,"version")]),s;if(!g.engines)return s.push([T.default.Error,y.localize(3,null,"engines")]),s;if(typeof g.engines.vscode!="string")return s.push([T.default.Error,y.localize(4,null,"engines.vscode")]),s;if(typeof g.extensionDependencies<"u"&&!o(g.extensionDependencies))return s.push([T.default.Error,y.localize(5,null,"extensionDependencies")]),s;if(typeof g.activationEvents<"u"){if(!o(g.activationEvents))return s.push([T.default.Error,y.localize(6,null,"activationEvents")]),s;if(typeof g.main>"u"&&typeof g.browser>"u")return s.push([T.default.Error,y.localize(7,null,"activationEvents","main")]),s}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&s.push([T.default.Warning,y.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return s.push([T.default.Error,y.localize(9,null,"main")]),s;{const d=(0,n.joinPath)(b,g.main);(0,n.isEqualOrParent)(d,b)||s.push([T.default.Warning,y.localize(10,null,d.path,b.path)])}if(typeof g.activationEvents>"u")return s.push([T.default.Error,y.localize(11,null,"activationEvents","main")]),s}if(typeof g.browser<"u"){if(typeof g.browser!="string")return s.push([T.default.Error,y.localize(12,null,"browser")]),s;{const d=(0,n.joinPath)(b,g.browser);(0,n.isEqualOrParent)(d,b)||s.push([T.default.Warning,y.localize(13,null,d.path,b.path)])}if(typeof g.activationEvents>"u")return s.push([T.default.Error,y.localize(14,null,"activationEvents","browser")]),s}if(!L.valid(g.version))return s.push([T.default.Error,y.localize(15,null)]),s;const r=[];if(!v(l,E,g,w,r))for(const d of r)s.push([T.default.Error,d]);return s}e.validateExtensionManifest=f;function v(l,E,b,g,w){return g||typeof b.main>"u"&&typeof b.browser>"u"?!0:i(l,E,b.engines.vscode,w)}e.isValidExtensionVersion=v;function h(l,E,b){return l==="*"||i(E,b,l)}e.isEngineValid=h;function i(l,E,b,g=[]){const w=O(k(b));if(!w)return g.push(y.localize(16,null,b)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return g.push(y.localize(17,null,b)),!1}else if(!w.majorMustEqual)return g.push(y.localize(18,null,b)),!1;return D(l,E,w)?!0:(g.push(y.localize(19,null,l,b)),!1)}function o(l){if(!Array.isArray(l))return!1;for(let E=0,b=l.length;E<b;E++)if(typeof l[E]!="string")return!1;return!0}}),define(Ie[84],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(y,L=[],C=!1){this.ctor=y,this.staticArguments=L,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=n}),define(Ie[62],Ce([1,0,84]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var y;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(y=e.InstantiationType||(e.InstantiationType={}));function L(R,S,k){S instanceof n.SyncDescriptor||(S=new n.SyncDescriptor(S,[],Boolean(k))),T.push([R,S])}e.registerSingleton=L;function C(){return T}e.getSingletonServiceDescriptors=C}),define(Ie[149],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(L,C){this.key=L,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const C of this.a.values())C.outgoing.size===0&&L.push(C);return L}insertEdge(L,C){const R=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(C);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(L){const C=this.b(L);this.a.delete(C);for(const R of this.a.values())R.outgoing.delete(C),R.incoming.delete(C)}lookupOrInsertNode(L){const C=this.b(L);let R=this.a.get(C);return R||(R=new n(C,L),this.a.set(C,R)),R}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[C,R]of this.a)L.push(`${C}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,C]of this.a){const R=new Set([L]),S=this.c(C,R);if(S)return S}}c(L,C){for(const[R,S]of L.outgoing){if(C.has(R))return[...C,R].join(" -> ");C.add(R);const k=this.c(S,C);if(k)return k;C.delete(R)}}}e.Graph=T}),define(Ie[3],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=R})(n=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function T(C,R,S){R[n.DI_TARGET]===R?R[n.DI_DEPENDENCIES].push({id:C,index:S}):(R[n.DI_DEPENDENCIES]=[{id:C,index:S}],R[n.DI_TARGET]=R)}function y(C){if(n.serviceIds.has(C))return n.serviceIds.get(C);const R=function(S,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(R,S,O)};return R.toString=()=>C,n.serviceIds.set(C,R),R}e.createDecorator=y;function L(C){return C}e.refineServiceDecorator=L}),define(Ie[40],Ce([1,0,9,2,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationOverrides=L;function C(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=C;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function k(l,E){const b=Object.create(null);for(const g in l)O(b,g,l[g],E);return b}e.toValuesTree=k;function O(l,E,b,g){const w=E.split("."),s=w.pop();let r=l;for(let a=0;a<w.length;a++){const d=w[a];let c=r[d];switch(typeof c){case"undefined":c=r[d]=Object.create(null);break;case"object":break;default:g(`Ignoring ${E} as ${w.slice(0,a+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[s]=b}catch{g(`Ignoring ${E} as ${w.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${E} as ${w.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=O;function D(l,E){const b=E.split(".");f(l,b)}e.removeFromValueTree=D;function f(l,E){const b=E.shift();if(E.length===0){delete l[b];return}if(Object.keys(l).indexOf(b)!==-1){const g=l[b];typeof g=="object"&&!Array.isArray(g)&&(f(g,E),Object.keys(g).length===0&&delete l[b])}}function v(l,E,b){function g(r,a){let d=r;for(const c of a){if(typeof d!="object"||d===null)return;d=d[c]}return d}const w=E.split("."),s=g(l,w);return typeof s>"u"?b:s}e.getConfigurationValue=v;function h(l,E,b){Object.keys(E).forEach(g=>{g!=="__proto__"&&(g in l?n.isObject(l[g])&&n.isObject(E[g])?h(l[g],E[g],b):b&&(l[g]=E[g]):l[g]=E[g])})}e.merge=h;function i(l,E,b){const g=l.inspect(E),w=l.inspect(b);return typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:g.defaultValue}e.getMigratedSettingValue=i;function o(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(Ie[41],Ce([1,0,21,10,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",n.isMacintosh),L.set("isLinux",n.isLinux),L.set("isWindows",n.isWindows),L.set("isWeb",n.isWeb),L.set("isMacNative",n.isMacintosh&&!n.isWeb),L.set("isEdge",n.isEdge),L.set("isFirefox",n.isFirefox),L.set("isChrome",n.isChrome),L.set("isSafari",n.isSafari);const C=Object.prototype.hasOwnProperty;var R;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return D.INSTANCE}static true(){return f.INSTANCE}static has(P){return v.create(P)}static equals(P,M){return h.create(P,M)}static notEquals(P,M){return l.create(P,M)}static regex(P,M){return a.create(P,M)}static in(P,M){return i.create(P,M)}static notIn(P,M){return o.create(P,M)}static not(P){return E.create(P)}static and(...P){return u.create(P,null,!0)}static or(...P){return t.create(P,null,!0)}static greater(P,M){return g.create(P,M)}static greaterEquals(P,M){return w.create(P,M)}static smaller(P,M){return s.create(P,M)}static smallerEquals(P,M){return r.create(P,M)}static deserialize(P,M=!1){if(!!P)return this.c(P,M)}static c(P,M){const F=P.split("||");return t.create(F.map($=>this.d($,M)),null,!0)}static d(P,M){const F=P.split("&&");return u.create(F.map($=>this.f($,M)),null,!0)}static f(P,M){if(P=P.trim(),P.indexOf("!=")>=0){const F=P.split("!=");return l.create(F[0].trim(),this.g(F[1],M))}if(P.indexOf("==")>=0){const F=P.split("==");return h.create(F[0].trim(),this.g(F[1],M))}if(P.indexOf("=~")>=0){const F=P.split("=~");return a.create(F[0].trim(),this.h(F[1],M))}if(P.indexOf(" not in ")>=0){const F=P.split(" not in ");return o.create(F[0].trim(),this.g(F[1],M))}if(P.indexOf(" in ")>=0){const F=P.split(" in ");return i.create(F[0].trim(),this.g(F[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(P)){const F=P.split(">=");return w.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(P)){const F=P.split(">");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(P)){const F=P.split("<=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(P)){const F=P.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(P)?E.create(P.substr(1).trim()):v.create(P)}static g(P,M){if(P=P.trim(),P==="true")return!0;if(P==="false")return!1;const F=/^'([^']*)'$/.exec(P);return F?F[1].trim():P}static h(P,M){if((0,T.isFalsyOrWhitespace)(P)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=P.indexOf("/"),$=P.lastIndexOf("/");if(F===$||F<0){if(M)throw new Error(`bad regexp-value '${P}', missing /-enclosure`);return console.warn(`bad regexp-value '${P}', missing /-enclosure`),null}const z=P.slice(F+1,$),K=P[$+1]==="i"?"i":"";try{return new RegExp(z,K)}catch(X){if(M)throw new Error(`bad regexp-value '${P}', parse error: ${X}`);return console.warn(`bad regexp-value '${P}', parse error: ${X}`),null}}}e.ContextKeyExpr=S;function k(V,P){const M=V?V.substituteConstants():void 0,F=P?P.substituteConstants():void 0;return!M&&!F?!0:!M||!F?!1:M.equals(F)}e.expressionsAreEqualWithConstantSubstitution=k;function O(V,P){return V.cmp(P)}class D{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class f{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class v{static create(P,M=null){const F=L.get(P);return typeof F=="boolean"?F?f.INSTANCE:D.INSTANCE:new v(P,M)}constructor(P,M){this.key=P,this.c=M,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:p(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=L.get(this.key);return typeof P=="boolean"?P?f.INSTANCE:D.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=E.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=v;class h{static create(P,M,F=null){if(typeof M=="boolean")return M?v.create(P,F):E.create(P,F);const $=L.get(P);return typeof $=="boolean"?M===($?"true":"false")?f.INSTANCE:D.INSTANCE:new h(P,M,F)}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=L.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?f.INSTANCE:D.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class i{static create(P,M){return new i(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:A(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.f),F=P.getValue(this.d);return Array.isArray(M)?M.includes(F):typeof F=="string"&&typeof M=="object"&&M!==null?C.call(M,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=i;class o{static create(P,M){return new o(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=11,this.c=i.create(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class l{static create(P,M,F=null){if(typeof M=="boolean")return M?E.create(P,F):v.create(P,F);const $=L.get(P);return typeof $=="boolean"?M===($?"true":"false")?D.INSTANCE:f.INSTANCE:new l(P,M,F)}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=L.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?D.INSTANCE:f.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class E{static create(P,M=null){const F=L.get(P);return typeof F=="boolean"?F?D.INSTANCE:f.INSTANCE:new E(P,M)}constructor(P,M){this.c=P,this.d=M,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:p(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=L.get(this.c);return typeof P=="boolean"?P?D.INSTANCE:f.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.ContextKeyNotExpr=E;function b(V,P){if(typeof V=="string"){const M=parseFloat(V);isNaN(M)||(V=M)}return typeof V=="string"||typeof V=="number"?P(V):D.INSTANCE}class g{static create(P,M,F=null){return b(M,$=>new g(P,$,F))}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=g;class w{static create(P,M,F=null){return b(M,$=>new w(P,$,F))}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class s{static create(P,M,F=null){return b(M,$=>new s(P,$,F))}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class r{static create(P,M,F=null){return b(M,$=>new r(P,$,F))}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class a{static create(P,M){return new a(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const M=this.f?this.f.source:"",F=P.f?P.f.source:"";return M<F?-1:M>F?1:0}equals(P){if(P.type===this.type){const M=this.f?this.f.source:"",F=P.f?P.f.source:"";return this.d===P.d&&M===F}return!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=d.create(this)),this.c}}e.ContextKeyRegexExpr=a;class d{static create(P){return new d(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(P){return new d(this.c.map(P))}negate(){return this.c}}e.ContextKeyNotRegexExpr=d;function c(V){let P=null;for(let M=0,F=V.length;M<F;M++){const $=V[M].substituteConstants();if(V[M]!==$&&P===null){P=[];for(let z=0;z<M;z++)P[z]=V[z]}P!==null&&(P[M]=$)}return P===null?V:P}class u{static create(P,M,F){return u.d(P,M,F)}constructor(P,M){this.expr=P,this.c=M,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const $=O(this.expr[M],P.expr[M]);if($!==0)return $}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=c(this.expr);return P===this.expr?this:u.create(P,this.c,!1)}evaluate(P){for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static d(P,M,F){const $=[];let z=!1;for(const K of P)if(!!K){if(K.type===1){z=!0;continue}if(K.type===0)return D.INSTANCE;if(K.type===6){$.push(...K.expr);continue}$.push(K)}if($.length===0&&z)return f.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(O);for(let K=1;K<$.length;K++)$[K-1].equals($[K])&&($.splice(K,1),K--);if($.length===1)return $[0];for(;$.length>1;){const K=$[$.length-1];if(K.type!==9)break;$.pop();const X=$.pop(),Z=$.length===0,he=t.create(K.expr.map(oe=>u.create([oe,X],null,F)),null,Z);he&&($.push(he),$.sort(O))}if($.length===1)return $[0];if(F){for(let K=0;K<$.length;K++)for(let X=K+1;X<$.length;X++)if($[K].negate().equals($[X]))return D.INSTANCE;if($.length===1)return $[0]}return new u($,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new u(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());this.c=t.create(P,this,!0)}return this.c}}class t{static create(P,M,F){return t.d(P,M,F)}constructor(P,M){this.expr=P,this.c=M,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const $=O(this.expr[M],P.expr[M]);if($!==0)return $}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=c(this.expr);return P===this.expr?this:t.create(P,this.c,!1)}evaluate(P){for(let M=0,F=this.expr.length;M<F;M++)if(this.expr[M].evaluate(P))return!0;return!1}static d(P,M,F){let $=[],z=!1;if(P){for(let K=0,X=P.length;K<X;K++){const Z=P[K];if(!!Z){if(Z.type===0){z=!0;continue}if(Z.type===1)return f.INSTANCE;if(Z.type===9){$=$.concat(Z.expr);continue}$.push(Z)}}if($.length===0&&z)return D.INSTANCE;$.sort(O)}if($.length!==0){if($.length===1)return $[0];for(let K=1;K<$.length;K++)$[K-1].equals($[K])&&($.splice(K,1),K--);if($.length===1)return $[0];if(F){for(let K=0;K<$.length;K++)for(let X=K+1;X<$.length;X++)if($[K].negate().equals($[X]))return f.INSTANCE;if($.length===1)return $[0]}return new t($,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new t(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),F=P.shift(),$=[];for(const z of j(M))for(const K of j(F))$.push(u.create([z,K],null,!1));P.unshift(t.create($,null,!1))}this.c=t.create(P,this,!0)}return this.c}}class m extends v{static all(){return m.d.values()}constructor(P,M,F){super(P,null),this.f=M,typeof F=="object"?m.d.push({...F,key:P}):F!==!0&&m.d.push({key:P,description:F,type:M!=null?typeof M:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return h.create(this.key,P)}notEqualsTo(P){return l.create(this.key,P)}}e.RawContextKey=m,m.d=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(V,P){return V<P?-1:V>P?1:0}function A(V,P,M,F){return V<M?-1:V>M?1:P<F?-1:P>F?1:0}function N(V,P){if(V.type===0||P.type===1)return!0;if(V.type===9)return P.type===9?q(V.expr,P.expr):!1;if(P.type===9){for(const M of P.expr)if(N(V,M))return!0;return!1}if(V.type===6){if(P.type===6)return q(P.expr,V.expr);for(const M of V.expr)if(N(M,P))return!0;return!1}return V.equals(P)}e.implies=N;function q(V,P){let M=0,F=0;for(;M<V.length&&F<P.length;){const $=V[M].cmp(P[F]);if($<0)return!1;$===0&&M++,F++}return M===V.length}function j(V){return V.type===9?V.expr:[V]}}),define(Ie[150],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[85],Ce([1,0,127,3]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function C(l,E){switch(l){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function R(l,E){return E==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function S(l,E,b){return R(E,b)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===b?!0:k(b).includes(l)}e.isTargetPlatformCompatible=S;function k(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function O(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=O;var D;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var f;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var i;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(i=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(E,b){super(E),this.code=b,this.name=b}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[36],Ce([1,0,46,19,10,9,2,129,3]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var O;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var D;(function(z){z[z.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var f;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=v;function h(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=h;function i(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=i;function o(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function l(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=l;function E(z){return v(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var b;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(K,X){super(K),this.code=X}}e.FileSystemProviderError=g;function w(z,K){const X=new g(z.toString(),K);return r(X,K),X}e.createFileSystemProviderError=w;function s(z){return z||w((0,R.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function r(z,K){return z.name=K?`${K} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=r;function a(z){if(!z)return b.Unknown;if(z instanceof g)return z.code;const K=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!K)return b.Unknown;switch(K[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=a;function d(z){if(z instanceof A)return z.fileOperationResult;switch(a(z)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=d;var c;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class u{constructor(K,X,Z){this.resource=K,this.operation=X,this.target=Z}isOperation(K){return this.operation===K}}e.FileOperationEvent=u;var t;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(t=e.FileChangeType||(e.FileChangeType={}));class m{constructor(K,X){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=K;const Z=new Map;for(const he of K){const oe=Z.get(he.type);switch(oe?oe.push([he.resource,he]):Z.set(he.type,[[he.resource,he]]),he.type){case 1:this.rawAdded.push(he.resource);break;case 0:this.rawUpdated.push(he.resource);break;case 2:this.rawDeleted.push(he.resource);break}}for(const[he,oe]of Z)switch(he){case 1:this.a=n.TernarySearchTree.forUris(()=>X),this.a.fill(oe);break;case 0:this.b=n.TernarySearchTree.forUris(()=>X),this.b.fill(oe);break;case 2:this.c=n.TernarySearchTree.forUris(()=>X),this.c.fill(oe);break}}contains(K,...X){return this.d(K,{includeChildren:!1},...X)}affects(K,...X){return this.d(K,{includeChildren:!0},...X)}d(K,X,...Z){if(!K)return!1;const he=Z.length>0;return!!((!he||Z.includes(1))&&(this.a?.get(K)||X.includeChildren&&this.a?.findSuperstr(K))||(!he||Z.includes(0))&&(this.b?.get(K)||X.includeChildren&&this.b?.findSuperstr(K))||(!he||Z.includes(2))&&(this.c?.findSubstr(K)||X.includeChildren&&this.c?.findSuperstr(K)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=m;function p(z,K,X){return!z||!K||z===K||K.length>z.length?!1:(K.charAt(K.length-1)!==T.sep&&(K+=T.sep),X?(0,y.startsWithIgnoreCase)(z,K):z.indexOf(K)===0)}e.isParent=p;class A extends Error{constructor(K,X,Z){super(K),this.fileOperationResult=X,this.options=Z}}e.FileOperationError=A;class N extends A{constructor(K,X,Z){super(K,2,Z),this.stat=X}}e.NotModifiedSinceFileOperationError=N;var q;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var j;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(j=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=V;async function P(z,K){if(!K.hasProvider(C.URI.from({scheme:z.scheme})))return new Promise(X=>{const Z=K.onDidChangeFileSystemProviderRegistrations(he=>{he.scheme===z.scheme&&he.added&&(Z.dispose(),X())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(K){return(0,L.isNumber)(K)||(K=0),K<M.KB?(0,R.localize)(1,null,K.toFixed(0)):K<M.MB?(0,R.localize)(2,null,(K/M.KB).toFixed(2)):K<M.GB?(0,R.localize)(3,null,(K/M.MB).toFixed(2)):K<M.TB?(0,R.localize)(4,null,(K/M.GB).toFixed(2)):(0,R.localize)(5,null,(K/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var F;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(z){return{maxFileSize:z===0?300*M.MB:16*M.GB,maxHeapSize:z===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=$}),define(Ie[63],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...y){this.a=new Map;for(const[L,C]of y)this.set(L,C)}set(y,L){const C=this.a.get(y);return this.a.set(y,L),C}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.ServiceCollection=n}),define(Ie[151],Ce([1,0,15,11,7,84,149,3,63,152]),function(te,e,n,T,y,L,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class D extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class f{constructor(o=new S.ServiceCollection,l=!1,E,b=O){this.f=o,this.g=l,this.h=E,this.i=b,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=b?E?._globalGraph??new C.Graph(g=>g):void 0}createChild(o){return new f(o,this.g,this,this.i)}invokeFunction(o,...l){const E=h.traceInvocation(this.i,o);let b=!1;try{return o({get:w=>{if(b)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(w,E);if(!s)throw new Error(`[invokeFunction] unknown service '${w}'`);return s}},...l)}finally{b=!0,E.stop()}}createInstance(o,...l){let E,b;return o instanceof L.SyncDescriptor?(E=h.traceCreation(this.i,o.ctor),b=this.j(o.ctor,o.staticArguments.concat(l),E)):(E=h.traceCreation(this.i,o),b=this.j(o,l,E)),E.stop(),b}j(o,l=[],E){const b=R._util.getServiceDependencies(o).sort((s,r)=>s.index-r.index),g=[];for(const s of b){const r=this.m(s.id,E);r||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${s.id}.`,!1),g.push(r)}const w=b.length>0?b[0].index:l.length;if(l.length!==w){console.trace(`[createInstance] First service dependency of ${o.name} at position ${w+1} conflicts with ${l.length} static arguments`);const s=w-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,w)}return Reflect.construct(o,l.concat(g))}k(o,l){if(this.f.get(o)instanceof L.SyncDescriptor)this.f.set(o,l);else if(this.h)this.h.k(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const l=this.f.get(o);return!l&&this.h?this.h.l(o):l}m(o,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const E=this.l(o);return E instanceof L.SyncDescriptor?this.q(o,E,l.branch(o,!0)):(l.branch(o,!1),E)}q(o,l,E){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,l,E)}finally{this.o.delete(o)}}r(o,l,E){const b=new C.Graph(s=>s.id.toString());let g=0;const w=[{id:o,desc:l,_trace:E}];for(;w.length;){const s=w.pop();if(b.lookupOrInsertNode(s),g++>1e3)throw new D(b);for(const r of R._util.getServiceDependencies(s.desc.ctor)){const a=this.l(r.id);if(a||this.u(`[createInstance] ${o} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(r.id)),a instanceof L.SyncDescriptor){const d={id:r.id,desc:a,_trace:s._trace.branch(r.id,!0)};b.insertEdge(s,d),w.push(d)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new D(b);break}for(const{data:r}of s){if(this.l(r.id)instanceof L.SyncDescriptor){const d=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,d)}b.removeNode(r)}}return this.l(o)}s(o,l,E=[],b,g){if(this.f.get(o)instanceof L.SyncDescriptor)return this.t(o,l,E,b,g);if(this.h)return this.h.s(o,l,E,b,g);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(o,l,E=[],b,g){if(b){const w=new f(void 0,this.g,this,this.i);w.c=String(o);const s=new Map,r=new n.IdleValue(()=>{const a=w.j(l,E,g);for(const[d,c]of s){const u=a[d];if(typeof u=="function")for(const t of c)u.apply(a,t)}return s.clear(),a});return new Proxy(Object.create(null),{get(a,d){if(!r.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let t=s.get(d);return t||(t=new k.LinkedList,s.set(d,t)),(p,A,N)=>{const q=t.push([p,A,N]);return(0,y.toDisposable)(q)}}if(d in a)return a[d];const c=r.value;let u=c[d];return typeof u!="function"||(u=u.bind(c),a[d]=u),u},set(a,d,c){return r.value[d]=c,!0},getPrototypeOf(a){return l.prototype}})}else return this.j(l,E,g)}u(o,l){if(l&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=f;var v;(function(i){i[i.Creation=0]="Creation",i[i.Invocation=1]="Invocation",i[i.Branch=2]="Branch"})(v||(v={}));class h{static traceInvocation(o,l){return o?new h(1,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(o,l){return o?new h(0,l.name):h.c}constructor(o,l){this.type=o,this.name=l,this.g=Date.now(),this.h=[]}branch(o,l){const E=new h(2,o.toString());return this.h.push([o,l,E]),E}stop(){const o=Date.now()-this.g;h.f+=o;let l=!1;function E(g,w){const s=[],r=new Array(g+1).join("	");for(const[a,d,c]of w.h)if(d&&c){l=!0,s.push(`${r}CREATES -> ${a}`);const u=E(g+1,c);u&&s.push(u)}else s.push(`${r}uses -> ${a}`);return s.join(`
`)}const b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(o>2||l)&&h.all.add(b.join(`
`))}}e.Trace=h,h.all=new Set,h.c=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h.f=0}),define(Ie[12],Ce([1,0,45,5,7,28,21,2,3]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function k(){return new Date().toISOString()}var O;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(O=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=O.Info;function D(u,t,m){switch(t){case O.Trace:u.trace(m);break;case O.Debug:u.debug(m);break;case O.Info:u.info(m);break;case O.Warning:u.warn(m);break;case O.Error:u.error(m);break;case O.Off:break;default:throw new Error(`Invalid log level ${t}`)}}e.log=D;function f(u){let t="";for(let m=0;m<u.length;m++){let p=u[m];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}t+=(m>0?" ":"")+p}return t}e.format=f;class v extends y.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(t){this.b!==t&&(this.b=t,this.c.fire(this.b))}getLevel(){return this.b}f(t){return this.b!==O.Off&&this.b<=t}}e.AbstractLogger=v;class h extends v{constructor(t){super(),this.h=t}f(t){return this.h||super.f(t)}trace(t,...m){this.f(O.Trace)&&this.g(O.Trace,f([t,...m]))}debug(t,...m){this.f(O.Debug)&&this.g(O.Debug,f([t,...m]))}info(t,...m){this.f(O.Info)&&this.g(O.Info,f([t,...m]))}warn(t,...m){this.f(O.Warning)&&this.g(O.Warning,f([t,...m]))}error(t,...m){if(this.f(O.Error))if(t instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=t.stack,this.g(O.Error,f(p))}else this.g(O.Error,f([t,...m]))}flush(){}}e.AbstractMessageLogger=h;class i extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.g=!C.isWindows}trace(t,...m){this.f(O.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,t,...m):console.log(`[main ${k()}]`,t,...m))}debug(t,...m){this.f(O.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,t,...m):console.log(`[main ${k()}]`,t,...m))}info(t,...m){this.f(O.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,t,...m):console.log(`[main ${k()}]`,t,...m))}warn(t,...m){this.f(O.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,t,...m):console.warn(`[main ${k()}]`,t,...m))}error(t,...m){this.f(O.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,t,...m):console.error(`[main ${k()}]`,t,...m))}dispose(){}flush(){}}e.ConsoleMainLogger=i;class o extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...m){this.f(O.Trace)&&console.log("%cTRACE","color: #888",t,...m)}debug(t,...m){this.f(O.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",t,...m)}info(t,...m){this.f(O.Info)&&console.log("%c INFO","color: #33f",t,...m)}warn(t,...m){this.f(O.Warning)&&console.log("%c WARN","color: #993",t,...m)}error(t,...m){this.f(O.Error)&&console.log("%c  ERR","color: #f33",t,...m)}dispose(){}flush(){}}e.ConsoleLogger=o;class l extends v{constructor(t,m=e.DEFAULT_LOG_LEVEL){super(),this.g=t,this.setLevel(m)}trace(t,...m){this.f(O.Trace)&&this.g.log(O.Trace,[this.h(t),...m])}debug(t,...m){this.f(O.Debug)&&this.g.log(O.Debug,[this.h(t),...m])}info(t,...m){this.f(O.Info)&&this.g.log(O.Info,[this.h(t),...m])}warn(t,...m){this.f(O.Warning)&&this.g.log(O.Warning,[this.h(t),...m])}error(t,...m){this.f(O.Error)&&this.g.log(O.Error,[this.h(t),...m])}h(t){return typeof t=="string"?t:(0,n.toErrorMessage)(t,this.f(O.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class E extends v{constructor(t){super(),this.g=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const m of this.g)m.setLevel(t);super.setLevel(t)}trace(t,...m){for(const p of this.g)p.trace(t,...m)}debug(t,...m){for(const p of this.g)p.debug(t,...m)}info(t,...m){for(const p of this.g)p.info(t,...m)}warn(t,...m){for(const p of this.g)p.warn(t,...m)}error(t,...m){for(const p of this.g)p.error(t,...m)}flush(){for(const t of this.g)t.flush()}dispose(){for(const t of this.g)t.dispose()}}e.MultiplexLogService=E;class b extends y.Disposable{constructor(t){super(),this.b=t,this.B(t)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(t){this.b.setLevel(t)}getLevel(){return this.b.getLevel()}trace(t,...m){this.b.trace(t,...m)}debug(t,...m){this.b.debug(t,...m)}info(t,...m){this.b.info(t,...m)}warn(t,...m){this.b.warn(t,...m)}error(t,...m){this.b.error(t,...m)}flush(){this.b.flush()}}e.LogService=b;class g extends y.Disposable{constructor(t,m){super(),this.c=t,this.b=new L.ResourceMap,this.B(m(p=>this.setLevel(p)))}getLoggers(){return[...this.b.values()].map(({logger:t})=>t)}getLogger(t){return this.b.get(t)?.logger}createLogger(t,m,p){let A=this.b.get(t)?.logger;return A||(p=m?.always?O.Trace:p,A=this.f(t,p??this.c,m),this.b.set(t,{logger:A,logLevel:p})),A}setLevel(t,m){const p=R.URI.isUri(t)?t:void 0,A=p?m:t;if(p){const N=this.b.get(p);N&&N.logLevel!==A&&(N.logLevel=A,N.logger.setLevel(A))}else this.c=A,this.b.forEach(({logLevel:N,logger:q})=>{N===void 0&&q.setLevel(this.c)})}getLogLevel(t){return this.b.get(t)?.logLevel}dispose(){this.b.forEach(({logger:t})=>t.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=g;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return O.Info}trace(t,...m){}debug(t,...m){}info(t,...m){}warn(t,...m){}error(t,...m){}critical(t,...m){}dispose(){}flush(){}}e.NullLogger=w;class s extends w{}e.NullLogService=s;class r extends g{constructor(){super(O.Info,T.Event.None)}f(t,m,p){return new w}}e.NullLoggerService=r;function a(u){if(u.verbose)return O.Trace;if(typeof u.logLevel=="string"){const t=c(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function d(u){switch(u){case O.Trace:return"trace";case O.Debug:return"debug";case O.Info:return"info";case O.Warning:return"warn";case O.Error:return"error";case O.Off:return"off"}}e.LogLevelToString=d;function c(u){switch(u){case"trace":return O.Trace;case"debug":return O.Debug;case"info":return O.Info;case"warn":return O.Warning;case"error":return O.Error;case"critical":return O.Error;case"off":return O.Off}}e.parseLogLevel=c}),define(Ie[86],Ce([1,0,29,130,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(h,i){return i-h}S.compare=k;const O=Object.create(null);O[S.Error]=(0,T.localize)(0,null),O[S.Warning]=(0,T.localize)(1,null),O[S.Info]=(0,T.localize)(2,null);function D(h){return O[h]||""}S.toString=D;function f(h){switch(h){case n.default.Error:return S.Error;case n.default.Warning:return S.Warning;case n.default.Info:return S.Info;case n.default.Ignore:return S.Hint}}S.fromSeverity=f;function v(h){switch(h){case S.Error:return n.default.Error;case S.Warning:return n.default.Warning;case S.Info:return n.default.Info;case S.Hint:return n.default.Ignore}}S.toSeverity=v}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(S){const k="";function O(f){return D(f,!0)}S.makeKey=O;function D(f,v){const h=[k];return f.source?h.push(f.source.replace("\xA6","\\\xA6")):h.push(k),f.code?typeof f.code=="string"?h.push(f.code.replace("\xA6","\\\xA6")):h.push(f.code.value.replace("\xA6","\\\xA6")):h.push(k),f.severity!==void 0&&f.severity!==null?h.push(C.toString(f.severity)):h.push(k),f.message&&v?h.push(f.message.replace("\xA6","\\\xA6")):h.push(k),f.startLineNumber!==void 0&&f.startLineNumber!==null?h.push(f.startLineNumber.toString()):h.push(k),f.startColumn!==void 0&&f.startColumn!==null?h.push(f.startColumn.toString()):h.push(k),f.endLineNumber!==void 0&&f.endLineNumber!==null?h.push(f.endLineNumber.toString()):h.push(k),f.endColumn!==void 0&&f.endColumn!==null?h.push(f.endColumn.toString()):h.push(k),h.push(k),h.join("\xA6")}S.makeKeyOptionalMessage=D})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(Ie[153],Ce([1,0,5,29,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,y.createDecorator)("notificationService");var L;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new S,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=R;class S{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=S}),define(Ie[87],Ce([1,0,10,2,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function L(k,O){return T.URI.isUri(k)?(0,n.equalsIgnoreCase)(k.scheme,O):(0,n.startsWithIgnoreCase)(k,O+":")}e.matchesScheme=L;function C(k,...O){return O.some(D=>L(k,D))}e.matchesSomeScheme=C;function R(k,O){return k.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=R;function S(k){let O;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return D&&(O={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},k=k.with({fragment:""})),{selection:O,uri:k}}e.extractSelection=S}),define(Ie[154],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(te,e,n,T){var y=arguments.length,L=y<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,n):T,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(te,e,n,T);else for(var R=te.length-1;R>=0;R--)(C=te[R])&&(L=(y<3?C(L):y>3?C(e,n,L):C(e,n))||L);return y>3&&L&&Object.defineProperty(e,n,L),L},Ve=this&&this.__param||function(te,e){return function(n,T){e(n,T,te)}};define(Ie[155],Ce([1,0,15,20,7,3]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var C;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(D){this.b=D}report(D){this.a=D,this.b(this.a)}}e.Progress=R,R.None=Object.freeze({report(){}});let S=class extends y.Disposable{constructor(D,f){super(),this.a=new n.DeferredPromise,f.withProgress(D,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,y.toDisposable)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};S=qe([Ve(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends y.Disposable{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new y.DisposableStore)}start(D){this.stop();const f=++this.a,v=new T.CancellationTokenSource;return this.f=setTimeout(()=>{f===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,y.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,y.toDisposable)(()=>v.cancel())),this.b.add((0,y.toDisposable)(()=>this.c?this.c.done():void 0)),{id:f,token:v.token,stop:()=>this.h(f),isCurrent:()=>this.a===f}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Ie[30],Ce([1,0,47,9]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.a=new Map}add(C,R){n.ok(T.isString(C)),n.ok(T.isObject(R)),n.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,R)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new y}),define(Ie[88],Ce([1,0,5,30]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,k){this.a[y(S)]=k,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new L;T.Registry.add(e.Extensions.JSONContribution,C)}),define(Ie[89],Ce([1,0,16,5,9,126,40,88,30]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=S.Registry.as(R.Extensions.JSONContribution);class f{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const a=this.k(s,r);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(s){const r=this.l(s);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:s,remove:r}){const a=[];a.push(...this.l(r)),a.push(...this.k(s,!1)),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,n.distinct)(a)})}registerDefaultConfigurations(s){const r=[],a=[];for(const{overrides:d,source:c}of s)for(const u in d)if(r.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const t=this.a.get(u),m=t?.valuesSources??new Map;if(c)for(const q of Object.keys(d[u]))m.set(q,c);const p={...t?.value||{},...d[u]};this.a.set(u,{source:c,value:p,valuesSources:m});const A=(0,C.getLanguageTagSettingPlainKey)(u),N={type:"object",default:p,description:L.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:y.isString(c)?void 0:c,defaultValueSource:c};a.push(...i(u)),this.d[u]=N,this.b.properties[u]=N}else{this.a.set(u,{value:d[u],source:c});const t=this.d[u];t&&(this.s(u,t),this.o(u,t))}this.registerOverrideIdentifiers(a),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:a,source:d}of s)for(const c in a){const u=this.a.get(c),t=y.isString(d)?d:d?.id,m=y.isString(u?.source)?u?.source:u?.source?.id;if(t===m)if(r.push(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const p=this.d[c];p&&(this.s(c,p),this.o(c,p))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){for(const r of s)this.h.add(r);this.q()}k(s,r){const a=[];return s.forEach(d=>{a.push(...this.m(d,r,d.extensionInfo,d.restrictedProperties)),this.c.push(d),this.n(d)}),a}l(s){const r=[],a=d=>{if(d.properties)for(const c in d.properties){r.push(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.p(c,d.properties[c])}d.allOf?.forEach(c=>a(c))};for(const d of s){a(d);const c=this.c.indexOf(d);c!==-1&&this.c.splice(c,1)}return r}m(s,r=!0,a,d,c=3){c=y.isUndefinedOrNull(s.scope)?c:s.scope;const u=[],t=s.properties;if(t)for(const p in t){const A=t[p];if(r&&b(p,A)){delete t[p];continue}if(A.source=a,A.defaultDefaultValue=t[p].default,this.s(p,A),e.OVERRIDE_PROPERTY_REGEX.test(p)?A.scope=void 0:(A.scope=y.isUndefinedOrNull(A.scope)?c:A.scope,A.restricted=y.isUndefinedOrNull(A.restricted)?!!d?.includes(p):A.restricted),t[p].hasOwnProperty("included")&&!t[p].included){this.f[p]=t[p],delete t[p];continue}else this.d[p]=t[p],t[p].policy?.name&&this.e.set(t[p].policy.name,p);!t[p].deprecationMessage&&t[p].markdownDeprecationMessage&&(t[p].deprecationMessage=t[p].markdownDeprecationMessage),u.push(p)}const m=s.allOf;if(m)for(const p of m)u.push(...this.m(p,r,a,d,c));return u}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(s){const r=a=>{const d=a.properties;if(d)for(const u in d)this.o(u,d[u]);a.allOf?.forEach(r)};r(s)}o(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.g.properties[s]=r;break}}p(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}q(){for(const s of this.h.values()){const r=`[${s}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this.i.fire()}r(){const s={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}s(s,r){const a=this.a.get(s);let d=a?.value,c=a?.source;y.isUndefined(d)&&(d=r.defaultDefaultValue,c=void 0),y.isUndefined(d)&&(d=l(r.type)),r.default=d,r.defaultValueSource=c}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function i(w){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let r=h.exec(w);for(;r?.length;){const a=r[1].trim();a&&s.push(a),r=h.exec(w)}}return(0,n.distinct)(s)}e.overrideIdentifiersFromKey=i;function o(w){return w.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=o;function l(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const E=new f;S.Registry.add(e.Extensions.Configuration,E);function b(w,s){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?L.localize(7,null,w):E.getConfigurationProperties()[w]!==void 0?L.localize(8,null,w):s.policy?.name&&E.getPolicyConfigurations().get(s.policy?.name)!==void 0?L.localize(9,null,w,s.policy?.name,E.getPolicyConfigurations().get(s.policy?.name)):null:L.localize(6,null)}e.validateProperty=b;function g(){const w=[],s=E.getConfigurationProperties();for(const r of Object.keys(s))w.push([r,s[r].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=g}),define(Ie[156],Ce([1,0,16,5,107,7,28,23,9,2,40,89,30]),function(te,e,n,T,y,L,C,R,S,k,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(r={},a=[],d=[],c){this.c=r,this.d=a,this.f=d,this.raw=c,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof v)return a;const d=new h("");return d.parseRaw(a),d.configurationModel});this.g=r.reduce((a,d)=>d===a?d:a.merge(d),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const d=this.rawConfiguration.getValue(r),c=a?this.rawConfiguration.getOverrideValue(r,a):void 0,u=a?this.rawConfiguration.override(a).getValue(r):d;return{value:d,override:c,merged:u}}getOverrideValue(r,a){const d=this.l(a);return d?r?(0,O.getConfigurationValue)(d,r):d:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const d of this.overrides)d.identifiers.includes(r)&&a.push(...d.keys);return n.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return n.distinct(r)}override(r){let a=this.b.get(r);return a||(a=this.h(r),this.b.set(r,a)),a}merge(...r){const a=R.deepClone(this.contents),d=R.deepClone(this.overrides),c=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const t of r)if(u.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.j(a,t.contents);for(const m of t.overrides){const[p]=d.filter(A=>n.equals(A.identifiers,m.identifiers));p?(this.j(p.contents,m.contents),p.keys.push(...m.keys),p.keys=n.distinct(p.keys)):d.push(R.deepClone(m))}for(const m of t.keys)c.indexOf(m)===-1&&c.push(m)}return new v(a,c,d,u.every(t=>t instanceof v)?void 0:u)}freeze(){return this.a=!0,this}clone(){return new v(R.deepClone(this.contents),[...this.keys],R.deepClone(this.overrides))}h(r){const a=this.l(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const d={};for(const c of n.distinct([...Object.keys(this.contents),...Object.keys(a)])){let u=this.contents[c];const t=a[c];t&&(typeof u=="object"&&typeof t=="object"?(u=R.deepClone(u),this.j(u,t)):u=t),d[c]=u}return new v(d,this.keys,this.overrides)}j(r,a){for(const d of Object.keys(a)){if(d in r&&S.isObject(r[d])&&S.isObject(a[d])){this.j(r[d],a[d]);continue}r[d]=R.deepClone(a[d])}}k(r){return this.a&&!Object.isFrozen(r)?R.deepFreeze(r):r}l(r){let a=null,d=null;const c=u=>{u&&(d?this.j(d,u):d=R.deepClone(u))};for(const u of this.overrides)n.equals(u.identifiers,[r])?a=u.contents:u.identifiers.includes(r)&&c(u.contents);return c(a),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,a){this.m(r),(0,O.addToValueTree)(this.contents,r,a,d=>{throw new Error(d)})}removeValue(r){this.n(r)&&(0,O.removeFromValueTree)(this.contents,r)}m(r){let a=this.keys.length;for(let d=0;d<a;d++)r.indexOf(this.keys[d])===0&&(a=d);this.keys.splice(a,1,r)}n(r){const a=this.keys.indexOf(r);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,a){if(!S.isUndefinedOrNull(r)){const d=this.g(r);this.parseRaw(d,a)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,a){this.a=r;const{contents:d,keys:c,overrides:u,restricted:t,hasExcludedProperties:m}=this.h(r,a);this.b=new v(d,c,u,m?[r]:void 0),this.c=t||[]}g(r){let a={},d=null,c=[];const u=[],t=[];function m(A){Array.isArray(c)?c.push(A):d!==null&&(c[d]=A)}const p={onObjectBegin:()=>{const A={};m(A),u.push(c),c=A,d=null},onObjectProperty:A=>{d=A},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const A=[];m(A),u.push(c),c=A,d=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:m,onError:(A,N,q)=>{t.push({error:A,offset:N,length:q})}};if(r)try{y.visit(r,p),a=c[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return a}h(r,a){const d=f.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),c=this.j(r,d,!0,a);r=c.raw;const u=(0,O.toValuesTree)(r,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),t=Object.keys(r),m=this.l(r,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:u,keys:t,overrides:m,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(r,a,d,c){let u=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:u};const t={},m=[];for(const p in r)if(D.OVERRIDE_PROPERTY_REGEX.test(p)&&d){const A=this.j(r[p],a,!1,c);t[p]=A.raw,u=u||A.hasExcludedProperties,m.push(...A.restricted)}else{const A=a[p],N=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&m.push(p),(N===void 0||c.scopes===void 0||c.scopes.includes(N))&&!(c.skipRestricted&&A?.restricted)?t[p]=r[p]:u=!0}return{raw:t,restricted:m,hasExcludedProperties:u}}l(r,a){const d=[];for(const c of Object.keys(r))if(D.OVERRIDE_PROPERTY_REGEX.test(c)){const u={};for(const t in r[c])u[t]=r[c][t];d.push({identifiers:(0,D.overrideIdentifiersFromKey)(c),keys:Object.keys(u),contents:(0,O.toValuesTree)(u,a)})}return d}}e.ConfigurationModelParser=h;class i extends L.Disposable{constructor(r,a,d,c){super(),this.f=r,this.g=a,this.h=c,this.c=this.B(new T.Emitter),this.onDidChange=this.c.event,this.a=new h(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(d.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(T.Event.any(T.Event.filter(this.h.onDidFilesChange,u=>u.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&d.isEqual(u.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new v}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=i;class o{constructor(r,a,d,c,u,t,m,p,A,N,q,j,V){this.a=r,this.b=a,this.value=d,this.overrideIdentifiers=c,this.c=u,this.d=t,this.f=m,this.g=p,this.h=A,this.j=N,this.k=q,this.l=j,this.m=V}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(r,a,d,c,u=new v,t=new v,m=new C.ResourceMap,p=new v,A=new C.ResourceMap,N=!0){this.c=r,this.d=a,this.f=d,this.g=c,this.h=u,this.j=t,this.l=m,this.m=p,this.n=A,this.p=N,this.a=null,this.b=new C.ResourceMap,this.q=null}getValue(r,a,d){return this.s(r,a,d).getValue(r)}updateValue(r,a,d={}){let c;d.resource?(c=this.n.get(d.resource),c||(c=new v,this.n.set(d.resource,c))):c=this.m,a===void 0?c.removeValue(r):c.setValue(r,a),d.resource||(this.a=null)}inspect(r,a,d){const c=this.s(r,a,d),u=n.distinct(c.overrides.map(p=>p.identifiers).flat()).filter(p=>c.getOverrideValue(r,p)!==void 0),t=this.w(a.resource,d),m=a.resource?this.n.get(a.resource)||this.m:this.m;return new o(r,a,c.getValue(r),u.length?u:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),d?this.j.freeze():void 0,t?t.freeze():void 0,m.inspect(r,a.overrideIdentifier))}keys(r){const a=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,a){this.l.set(r,a),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const d=[];if(!a){const{added:c,updated:u,removed:t}=g(this.c,r);a=[...c,...u,...t]}for(const c of a)for(const u of(0,D.overrideIdentifiersFromKey)(c)){const t=this.c.getKeysForOverrideIdentifier(u),m=r.getKeysForOverrideIdentifier(u),p=[...m.filter(A=>t.indexOf(A)===-1),...t.filter(A=>m.indexOf(A)===-1),...t.filter(A=>!R.equals(this.c.override(u).getValue(A),r.override(u).getValue(A)))];d.push([u,p])}return this.updateDefaultConfiguration(r),{keys:a,overrides:d}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:d,removed:c}=g(this.d,r),u=[...a,...d,...c];return u.length&&this.updatePolicyConfiguration(r),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=g(this.applicationConfiguration,r),t=[...a,...d,...c];return t.length&&this.updateApplicationConfiguration(r),{keys:t,overrides:u}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=g(this.localUserConfiguration,r),t=[...a,...d,...c];return t.length&&this.updateLocalUserConfiguration(r),{keys:t,overrides:u}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=g(this.remoteUserConfiguration,r),t=[...a,...d,...c];return t.length&&this.updateRemoteUserConfiguration(r),{keys:t,overrides:u}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=g(this.workspaceConfiguration,r),t=[...a,...d,...c];return t.length&&this.updateWorkspaceConfiguration(r),{keys:t,overrides:u}}compareAndUpdateFolderConfiguration(r,a){const d=this.r.get(r),{added:c,updated:u,removed:t,overrides:m}=g(d,a),p=[...c,...u,...t];return(p.length||!d)&&this.updateFolderConfiguration(r,a),{keys:p,overrides:m}}compareAndDeleteFolderConfiguration(r){const a=this.r.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:d,updated:c,removed:u,overrides:t}=g(a,void 0);return{keys:[...d,...c,...u],overrides:t}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,a,d){let c=this.t(a,d);return a.overrideIdentifier&&(c=c.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}t({resource:r},a){let d=this.u();if(a&&r){const c=a.getFolder(r);c&&(d=this.v(c.uri)||d);const u=this.n.get(r);u&&(d=d.merge(u))}return d}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let a=this.b.get(r);if(!a){const d=this.u(),c=this.l.get(r);c?(a=d.merge(c),this.p&&(a=a.freeze()),this.b.set(r,a)):a=d}return a}w(r,a){if(a&&r){const d=a.getFolder(r);if(d)return this.l.get(d.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,a)=>{const{contents:d,overrides:c,keys:u}=this.l.get(a);return r.push([a,{contents:d,overrides:c,keys:u}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(a=>r.add(a)),this.userConfiguration.freeze().keys.forEach(a=>r.add(a)),this.j.freeze().keys.forEach(a=>r.add(a)),this.l.forEach(a=>a.freeze().keys.forEach(d=>r.add(d))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.j.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.l.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(d=>r.add(d))),[...r.values()]}y(r){const a=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(d=>a.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(d=>a.add(d)),this.j.getKeysForOverrideIdentifier(r).forEach(d=>a.add(d)),this.l.forEach(d=>d.getKeysForOverrideIdentifier(r).forEach(c=>a.add(c))),[...a.values()]}static parse(r){const a=this.z(r.defaults),d=this.z(r.policy),c=this.z(r.application),u=this.z(r.user),t=this.z(r.workspace),m=r.folders.reduce((p,A)=>(p.set(k.URI.revive(A[0]),this.z(A[1])),p),new C.ResourceMap);return new l(a,d,c,u,new v,t,m,new v,new C.ResourceMap,!1)}static z(r){return new v(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function E(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,a=new Map;for(const c of s)c.keys.forEach(u=>r.add(u)),c.overrides.forEach(([u,t])=>{const m=(0,C.getOrSet)(a,u,new Set);t.forEach(p=>m.add(p))});const d=[];return a.forEach((c,u)=>d.push([u,[...c.values()]])),{keys:[...r.values()],overrides:d}}e.mergeChanges=E;class b{constructor(r,a,d,c){this.change=r,this.b=a,this.c=d,this.d=c,this.f=void 0;const u=new Set;r.keys.forEach(m=>u.add(m)),r.overrides.forEach(([,m])=>m.forEach(p=>u.add(p))),this.affectedKeys=[...u.values()];const t=new v;this.affectedKeys.forEach(m=>t.setValue(m,{})),this.a=t.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(r,a){if(this.g(this.a,r)){if(a){const d=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.b?.workspace):void 0,c=this.c.getValue(r,a,this.d);return!R.equals(d,c)}return!0}return!1}g(r,a){let d=(0,O.toValuesTree)({[a]:!0},()=>{}),c;for(;typeof d=="object"&&(c=Object.keys(d)[0]);){if(r=r[c],!r)return!1;d=d[c]}return!0}}e.ConfigurationChangeEvent=b;function g(s,r){const{added:a,removed:d,updated:c}=w(r?.rawConfiguration,s?.rawConfiguration),u=[],t=s?.getAllOverrideIdentifiers()||[],m=r?.getAllOverrideIdentifiers()||[];if(r){const p=m.filter(A=>!t.includes(A));for(const A of p)u.push([A,r.getKeysForOverrideIdentifier(A)])}if(s){const p=t.filter(A=>!m.includes(A));for(const A of p)u.push([A,s.getKeysForOverrideIdentifier(A)])}if(r&&s){for(const p of t)if(m.includes(p)){const A=w({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)});u.push([p,[...A.added,...A.removed,...A.updated]])}}return{added:a,removed:d,updated:c,overrides:u}}function w(s,r){const a=s?r?s.keys.filter(u=>r.keys.indexOf(u)===-1):[...s.keys]:[],d=r?s?r.keys.filter(u=>s.keys.indexOf(u)===-1):[...r.keys]:[],c=[];if(s&&r){for(const u of r.keys)if(s.keys.indexOf(u)!==-1){const t=(0,O.getConfigurationValue)(r.contents,u),m=(0,O.getConfigurationValue)(s.contents,u);R.equals(t,m)||c.push(u)}}return{added:a,removed:d,updated:c}}}),define(Ie[90],Ce([1,0,11,3]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var y;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends n.ErrorNoTelemetry{static isNotAvailable(R){return R instanceof L&&R._code===y.NotAvailable}static isTemporarilyNotAvailable(R){return R instanceof L&&R._code===y.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof L&&R._code===y.NoResolverFound}static isHandled(R){return R instanceof L&&R.isHandled}constructor(R,S=y.Unknown,k){super(R),this._message=R,this._code=S,this._detail=k,this.isHandled=S===y.NotAvailable&&k===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(Ie[48],Ce([1,0,13]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(k){return k.scheme===n.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=T;function y(k){if(!k)return;const O=k.indexOf("+");return O<0?k:k.substr(0,O)}e.getRemoteName=y;function L(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=L;function C(k){const{host:O,port:D}=S(k);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:D}}e.parseAuthorityWithPort=C;function R(k,O){let{host:D,port:f}=S(k);return typeof f>"u"&&(f=O),{host:D,port:f}}e.parseAuthorityWithOptionalPort=R;function S(k){const O=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const D=k.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const f=k.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:k,port:void 0}}}),define(Ie[26],Ce([1,0,10,3,48]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=L;function C(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var S;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(i){this.value=i,this.c=i.toLowerCase()}static equals(i,o){if(typeof i>"u"||i===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof i=="string"||typeof o=="string"){const l=typeof i=="string"?i:i.value,E=typeof o=="string"?o:o.value;return n.equalsIgnoreCase(l,E)}return i.c===o.c}static toKey(i){return typeof i=="string"?i.toLowerCase():i.c}}e.ExtensionIdentifier=k;function O(h){return D(h)}e.isApplicationScopedExtension=O;function D(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function f(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function v(h,i){if(i){const o=`onResolveRemoteAuthority:${(0,y.getRemoteName)(i)}`;return h.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[157],Ce([1,0,10,85,26,21,2,11,49]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,n.compareIgnoreCase)(r.id,a.id)===0}e.areSameExtensions=k;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class D{static create(a){const d=a.manifest?a.manifest.version:a.version,c=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new D(a.identifier,d,c)}static parse(a){const d=O.exec(a);return d&&d[1]&&d[2]?new D({id:d[1]},d[2],d[4]||void 0):null}constructor(a,d,c="undefined"){this.version=d,this.targetPlatform=c,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof D?k(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=D;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const a=f.exec(r);return a&&a[1]?[i(a[1]),a[2]]:[i(r),void 0]}e.getIdAndVersion=v;function h(r,a){return`${r}.${a}`}e.getExtensionId=h;function i(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=i;function o(r,a){return i(h(r,a))}e.getGalleryExtensionId=o;function l(r,a){const d=[],c=u=>{for(const t of d)if(t.some(m=>k(a(m),a(u))))return t;return null};for(const u of r){const t=c(u);t?t.push(u):d.push([u])}return d}e.groupByExtension=l;function E(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function b(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function g(r,a){const d=[],c=a.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const u=c.shift();if(u&&d.every(t=>!k(t.identifier,{id:u}))){const t=r.filter(m=>k(m.identifier,{id:u}));t.length===1&&(d.push(t[0]),c.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=g;async function w(r,a){if(!L.isLinux)return!1;let d;try{d=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){a.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(u))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=w;async function s(r,a){const d=await w(r,a),c=(0,T.getTargetPlatform)(d?"alpine":L.platform,S.arch);return a.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=s}),define(Ie[158],Ce([1,0,21,49,2,34]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(k){if(n.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function R(k,O,D,f,v,h,i,o,l,E){const b=Object.create(null);b["common.machineId"]=i,b.sessionID=(0,L.generateUuid)()+Date.now(),b.commitHash=v,b.version=h,b["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,n.PlatformToString)(n.platform),b["common.nodePlatform"]=T.platform,b["common.nodeArch"]=f,b["common.product"]=E||"desktop",o&&(b["common.msftInternal"]=o);let g=0;const w=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),n.isLinuxSnap&&(b["common.snap"]="true");const s=C(D);s&&(b["common.platformDetail"]=s);try{const r=await k.readFile(y.URI.file(l));b["common.source"]=r.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=R;function S(k){const O=T.env.USERDNSDOMAIN;if(!O)return!1;const D=O.toLowerCase();return k.some(f=>D===f)}e.verifyMicrosoftInternalDomain=S}),define(Ie[159],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[91],Ce([1,0,23,9,40,48,158,159]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(u){this.value=u}}e.TrustedTelemetryValue=S;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(u,t){return Promise.resolve(void 0)}publicLog2(u,t){return this.publicLog(u,t)}publicLogError(u,t){return Promise.resolve(void 0)}publicLogError2(u,t){return this.publicLogError(u,t)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class O{async publicLog(u,t,m){}async publicLogError(u,t,m){}}e.NullEndpointTelemetryService=O,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(c,u){return u.onDidChangeConfiguration(t=>{t.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,y.ConfigurationTargetToString)(t.source),configurationKeys:b(t.sourceConfig)})})}e.configurationTelemetry=D;function f(c,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!c.enableTelemetry||u.extensionTestsLocationURI)}e.supportsTelemetry=f;function v(c,u){return!(u.isBuilt||u.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=v;function h(c){const u=c.getValue(R.TELEMETRY_SETTING_ID),t=c.getValue("telemetry.enableCrashReporter");if(c.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=h;function i(c){const u={},t={},m={};E(c,m);for(let p in m){p=p.length>150?p.substr(p.length-149):p;const A=m[p];typeof A=="number"?t[p]=A:typeof A=="boolean"?t[p]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${A.length}`),u[p]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(u[p]=A)}return{properties:u,measurements:t}}e.validateTelemetryData=i;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(c){if(!c)return"none";const u=(0,L.getRemoteName)(c);return o.has(u)?u:"other"}e.cleanRemoteAuthority=l;function E(c,u,t=0,m){if(!!c)for(const p of Object.getOwnPropertyNames(c)){const A=c[p],N=m?m+p:p;Array.isArray(A)?u[N]=(0,n.safeStringify)(A):A instanceof Date?u[N]=A.toISOString():(0,T.isObject)(A)?t<2?E(A,u,t+1,N+"."):u[N]=(0,n.safeStringify)(A):u[N]=A}}function b(c){if(!c)return[];const u=[];return g(u,"",c),u}function g(c,u,t){t&&typeof t=="object"&&!Array.isArray(t)?Object.keys(t).forEach(m=>g(c,u?`${u}.${m}`:m,t[m])):c.push(u)}function w(c,u){const t=c.msftInternalDomains||[],m=u.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(t)||m}e.isInternalTelemetry=w;function s(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=s;function r(c,u){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let t=c;const m=[];for(const q of u)for(;;){const j=q.exec(c);if(!j)break;m.push([j.index,q.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(t="";;){const q=A.exec(c);if(!q)break;const j=m.some(([V,P])=>q.index<P&&V<A.lastIndex);!p.test(q[0])&&!j&&(t+=c.substring(N,q.index)+"<REDACTED: user-file-path>",N=A.lastIndex)}return N<c.length&&(t+=c.substr(N)),t}function a(c){if(!c)return c;const u=c.toLowerCase(),t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of t)if(m.regex.test(u))return`<REDACTED: ${m.label}>`;return c}function d(c,u){return(0,n.cloneAndChange)(c,t=>{if(t instanceof S)return t.value;if(typeof t=="string"){let m=t.replaceAll("%20"," ");m=r(m,u);for(const p of u)m=m.replace(p,"");return m=a(m),m}})}e.cleanData=d}),define(Ie[160],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(y){this.b=y,this.a=new Map}dispose(){for(const y of this.a.values())y.dispose()}startBuffering(y,L,C=5){const R=L(S=>{const k=typeof S=="string"?S:S.data;let O=this.a.get(y);if(O){O.data.push(k);return}const D=setTimeout(()=>this.flushBuffer(y),C);O={data:[k],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(y),R.dispose()}},this.a.set(y,O)});return R}stopBuffering(y){this.a.get(y)?.dispose()}flushBuffer(y){const L=this.a.get(y);L&&(this.a.delete(y),this.b(y,L.data.join("")))}}e.TerminalDataBufferer=n}),define(Ie[161],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var n;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(n=e.ColorScheme||(e.ColorScheme={}));function T(L){return L===n.HIGH_CONTRAST_DARK||L===n.HIGH_CONTRAST_LIGHT}e.isHighContrast=T;function y(L){return L===n.DARK||L===n.HIGH_CONTRAST_DARK}e.isDark=y}),define(Ie[64],Ce([1,0,119,5,7,3,30,161]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var S;(function(o){function l(E){return E&&typeof E=="object"&&typeof E.id=="string"}o.isThemeColor=l})(S=e.ThemeColor||(e.ThemeColor={}));function k(o){return{id:o}}e.themeColorFromId=k;var O;(function(o){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||S.isThemeColor(d.color))}o.isThemeIcon=l;const E=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function b(d){const c=E.exec(d);if(!c)return;const[,u]=c;return{id:u}}o.fromString=b;function g(d){return{id:d}}o.fromId=g;function w(d,c){let u=d.id;const t=u.lastIndexOf("~");return t!==-1&&(u=u.substring(0,t)),c&&(u=`${u}~${c}`),{id:u}}o.modify=w;function s(d){const c=d.id.lastIndexOf("~");if(c!==-1)return d.id.substring(c+1)}o.getModifier=s;function r(d,c){return d.id===c.id&&d.color?.id===c.color?.id}o.isEqual=r;function a(d,c){return{id:d.id,color:c?k(c):void 0}}o.asThemeIcon=a,o.asClassNameArray=n.CSSIcon.asClassNameArray,o.asClassName=n.CSSIcon.asClassName,o.asCSSSelector=n.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function D(o){switch(o){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.a=[],this.a=[],this.b=new T.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,y.toDisposable)(()=>{const E=this.a.indexOf(l);this.a.splice(E,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const v=new f;C.Registry.add(e.Extensions.ThemingContribution,v);function h(o){return v.onColorThemeChange(o)}e.registerThemingParticipant=h;class i extends y.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(E=>this.n(E)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,E){let b=this.h.getColor(l);return b&&E&&(b=E(b,this.h)),b?b.toString():null}}e.Themable=i}),define(Ie[162],Ce([1,0,5,40,3,12]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var C;(function(i){i.Http="http",i.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(i){return e.LOCALHOST_ADDRESSES.indexOf(i)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(i){return e.ALL_INTERFACES_ADDRESSES.indexOf(i)>=0}e.isAllInterfaces=D;function f(i,o,l,E){if(l===1)return!1;if(l===2&&D(o)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(E);if(b?.length===4&&parseInt(b[1])>=18)return!1}return i<1024}e.isPortPrivileged=f;class v{constructor(o,l,E){this.remoteAddress=o,this.localAddress=l,this.b=E,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=v;let h=class{constructor(o,l){this.i=o,this.j=l,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],l=Array.from(this.d.values());for(const E of l){const b=Array.from(E.values());for(const g of b){const w=await g.value;w&&o.push(w)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:l}of o.values())await l.then(E=>E?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,l,E,b,g){this.o(o,l,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:l,localAddress:E,privacy:b,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,l){(D(o)||O(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const E=this.q(o,l);if(E)return++E.refcount,E.value}openTunnel(o,l,E,b,g=!1,w,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${E} on local port ${b}.`),!o)return;if(l||(l="localhost"),this.e&&this.h.has(E)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(o,l,E,b,g,w,s);return r?r.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,E);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.m(a);return(a.tunnelRemoteHost!==l||a.tunnelRemotePort!==E)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(d),d}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const l=this.d.get(o.tunnelRemoteHost);if(l){const E=l.get(o.tunnelRemotePort);E&&(E.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,E))}}}}async n(o,l,E){if(E.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${l}.`);const b=E.value.then(async g=>{g&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(l),b}}async closeTunnel(o,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${l} `);const E=this.d.get(o);if(E&&E.has(l)){const b=E.get(l);b.refcount=0,await this.n(o,l,b)}}o(o,l,E){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(l,{refcount:1,value:E})}async p(o,l){const E=this.d.get(o);E&&(await E.get(l)||E.delete(l),E.size===0&&this.d.delete(o))}q(o,l){const E=[o];O(o)?(E.push(...e.LOCALHOST_ADDRESSES),E.push(...e.ALL_INTERFACES_ADDRESSES)):D(o)&&E.push(...e.ALL_INTERFACES_ADDRESSES);const b=E.map(g=>this.d.get(g));for(const g of b){const w=g?.get(l);if(w)return w}}canTunnel(o){return!!k(o)}s(o,l,E,b,g,w,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${E} on local port ${b}.`);const r=E;this.h.add(r);const a=b===void 0?E:b,d={elevationRequired:g?this.isPortPrivileged(a):!1},c={remoteAddress:{host:l,port:E},localAddressPort:b,privacy:w,public:w?w!==R.Private:void 0,protocol:s},u=o.forwardPort(c,d);return u?(this.o(l,E,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),u}};h=qe([Ve(0,L.ILogService),Ve(1,T.IConfigurationService)],h),e.AbstractTunnelService=h}),define(Ie[163],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var T;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(T=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[164],Ce([1,0,13]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(S){return S.scheme!==n.Schemas.file&&S.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=T;function y(S){if(S.folders.length)return S.folders.every(k=>T(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function L(S){return y(S)?.scheme}e.getVirtualWorkspaceScheme=L;function C(S){return y(S)?.authority}e.getVirtualWorkspaceAuthority=C;function R(S){return y(S)!==void 0}e.isVirtualWorkspace=R}),define(Ie[50],Ce([1,0,131,19,46,22,2,3,13]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function k(r){const a=r;return typeof a?.id=="string"&&C.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(r,a){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,T.basename)(r)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const d=r;if(d.configuration)return{id:d.id,configPath:d.configuration};if(d.folders.length===1)return{id:d.id,uri:d.folders[0].uri}}e.toWorkspaceIdentifier=O;function D(r){const a=r;return typeof a?.id=="string"&&C.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=D;function f(r){const a=r;if(a?.uri)return{id:a.id,uri:C.URI.revive(a.uri)};const d=r;if(d?.configPath)return{id:d.id,configPath:C.URI.revive(d.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=f;var v;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=h;function i(r){const a=r;return!!(a&&typeof a=="object"&&C.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=i;class o{constructor(a,d,c,u,t){this.h=a,this.j=c,this.k=u,this.l=t,this.c=y.TernarySearchTree.forUris(this.l,()=>!0),this.folders=d}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=y.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class l{constructor(a,d){this.raw=d,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,L.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function E(r){return new l({uri:r,index:0,name:(0,L.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(r,a){return L.extUriBiasedIgnorePathCase.isEqualOrParent(r,a.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function g(r){let a;return C.URI.isUri(r)?a=r:a=r.configuration,a?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=g;function w(r,a){return!b(r,a)&&!g(r)}e.isSavedWorkspace=w;function s(r){return(typeof r=="string"?(0,T.extname)(r):(0,L.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Ie[51],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(y){this.d=y,this.b=new Map,this.c=1}add(y){const L=this.c++;return this.b.set(L,y),this.e(),L}get(y,L){return this.b.has(y)?this.b.get(y)[L]:void 0}delete(y){this.b.delete(y),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=n,n.a=!1}),define(Ie[37],Ce([1,0,13,22,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new T.ExtUri(R=>{const S=this.b.get(R.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(R,S){S===null?this.b.delete(R.scheme):this.b.set(R.scheme,S)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Ie[165],Ce([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(C,R,S){this.h=new Map,this.a=C,this.b=R,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new n.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of k.values())O.complete()}catch(O){for(const D of k.values())D.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,R){let S=this.f[C];return typeof S>"u"&&(S=R),S}update(C,R){this.f[C]=R;const S=this.h.get(C);if(S!==void 0)return S.p;const k=new n.DeferredPromise;return this.h.set(C,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=T;class y extends T{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,R){super(C.identifier.value,!0,R),this.j=C}}e.ExtensionGlobalMemento=y}),define(Ie[166],Ce([1,0,5,2]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(C){this.c=C,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,R,S,k){const D=this.c.getNotebookDocument(T.URI.revive(C)).acceptModelChanged(R.value,S,k);this.b.fire(D)}$acceptDirtyStateChanged(C,R){this.c.getNotebookDocument(T.URI.revive(C)).acceptDirty(R)}$acceptModelSaved(C){const R=this.c.getNotebookDocument(T.URI.revive(C));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(Ie[14],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=T});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Ie[167],Ce([1,0,26,5]),function(te,e,n,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(R,S){y.set(this,void 0),this.b=new T.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(R.identifier),Ye(this,y,S,"f"),Re(this,y,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(R){return Re(this,y,"f").get(this.a,R)}store(R,S){return Re(this,y,"f").store(this.a,R,S)}delete(R){return Re(this,y,"f").delete(this.a,R)}}e.ExtensionSecrets=L,y=new WeakMap}),define(Ie[65],Ce([1,0,3,162,5,14]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function k(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:D.protocol}}S.fromApiTunnel=k;function O(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==T.TunnelPrivacyId.ConstantPrivate&&D.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}S.fromServiceTunnel=O})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let R=class{constructor(k){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,O){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,O){return{dispose:()=>{}}}async $providePortAttributes(k,O,D,f,v){return[]}async $forwardPort(k,O){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=qe([Ve(0,L.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(Ie[52],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=T}),define(Ie[168],Ce([1,0,24]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function y(R,S){if(S.serializeBuffersForPostMessage){const k=new T,O=(v,h)=>{if(h instanceof ArrayBuffer){const i=k.add(h);return{$$vscode_array_buffer_reference$$:!0,index:i}}else if(ArrayBuffer.isView(h)){const i=L(h);if(i){const o=k.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:i,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},D=JSON.stringify(R,O),f=k.buffers.map(v=>{const h=new Uint8Array(v);return n.VSBuffer.wrap(h)});return{message:D,buffers:f}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=y;function L(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(R,S){const k=S.map(f=>{const v=new ArrayBuffer(f.byteLength);return new Uint8Array(v).set(f.buffer),v}),O=S.length?(f,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const h=v,{index:i}=h,o=k[i];if(h.view)switch(h.view.type){case 1:return new Int8Array(o,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(R,O),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(Ie[92],Ce([1,0,139,9,2,7,3,30,36,13]),function(te,e,n,T,y,L,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var O;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(O=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var D;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(D=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(X){const Z=X;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.isEditorPaneWithSelection=f;function v(X,Z,he){for(const oe of he.visibleEditorPanes)if(oe.group.id===Z&&X.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=v;function h(X){if(c(X))return!1;const Z=X;return y.URI.isUri(Z?.resource)}e.isResourceEditorInput=h;function i(X){if(c(X))return!1;const Z=X;return Z?.original!==void 0&&Z.modified!==void 0}e.isResourceDiffEditorInput=i;function o(X){if(c(X)||i(X))return!1;const Z=X;return Z?.primary!==void 0&&Z.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function l(X){if(c(X))return!1;const Z=X;return Z?Z.resource===void 0||Z.resource.scheme===k.Schemas.untitled||Z.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;const E=/Untitled-\d+/;function b(X){return X.scheme===k.Schemas.untitled&&X.path.length>1&&!E.test(X.path)}e.isUntitledWithAssociatedResource=b;function g(X){if(c(X))return!1;const Z=X;return y.URI.isUri(Z?.base?.resource)&&y.URI.isUri(Z?.input1?.resource)&&y.URI.isUri(Z?.input2?.resource)&&y.URI.isUri(Z?.result?.resource)}e.isResourceMergeEditorInput=g;var w;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var s;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.a=new Map}registerSource(Z,he){let oe=this.a.get(Z);return oe||(oe={source:Z,label:he},this.a.set(Z,oe)),oe.source}getSourceLabel(Z){return this.a.get(Z)?.label??Z}}e.SaveSourceRegistry=new r;var a;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends L.Disposable{}e.AbstractEditorInput=d;function c(X){return X instanceof d}e.isEditorInput=c;function u(X){const Z=X;return y.URI.isUri(Z?.preferredResource)}function t(X){const Z=X;return c(Z?.primary)&&c(Z?.secondary)}e.isSideBySideEditorInput=t;function m(X){const Z=X;return c(Z?.modified)&&c(Z?.original)}e.isDiffEditorInput=m;function p(X){return c(X?.editor)}e.isEditorInputWithOptions=p;function A(X){const Z=X;return p(X)&&Z?.group!==void 0}e.isEditorInputWithOptionsAndGroup=A;function N(X){const Z=X;return typeof Z?.groupId=="number"&&c(Z.editor)}e.isEditorIdentifier=N;var q;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(q=e.EditorCloseContext||(e.EditorCloseContext={}));var j;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(j=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var V;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(V=e.SideBySideEditor||(e.SideBySideEditor={}));class P{getOriginalUri(Z,he){if(!Z)return;if(g(Z))return e.EditorResourceAccessor.getOriginalUri(Z.result,he);if(he?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(Z);if(ue&&ce){if(he?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:he.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===V.ANY)return this.getOriginalUri(ue,{filterByScheme:he.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:he.filterByScheme});Z=he.supportSideBySide===V.PRIMARY?ue:ce}}if(i(Z)||o(Z)||g(Z))return;const oe=u(Z)?Z.preferredResource:Z.resource;return!oe||!he||!he.filterByScheme?oe:this.b(oe,he.filterByScheme)}a(Z){return t(Z)||o(Z)?{primary:Z.primary,secondary:Z.secondary}:m(Z)||i(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,he){if(!Z)return;if(g(Z))return e.EditorResourceAccessor.getCanonicalUri(Z.result,he);if(he?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(Z);if(ue&&ce){if(he?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:he.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===V.ANY)return this.getCanonicalUri(ue,{filterByScheme:he.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:he.filterByScheme});Z=he.supportSideBySide===V.PRIMARY?ue:ce}}if(i(Z)||o(Z)||g(Z))return;const oe=Z.resource;return!oe||!he||!he.filterByScheme?oe:this.b(oe,he.filterByScheme)}b(Z,he){if(Array.isArray(he)){if(he.some(oe=>Z.scheme===oe))return Z}else if(he===Z.scheme)return Z}}e.EditorResourceAccessor=new P;var M;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(Z){const he=this.a=Z.get(C.IInstantiationService);for(const[oe,ue]of this.c)this.e(oe,ue,he);this.c.clear()}e(Z,he,oe){const ue=oe.createInstance(he);this.d.set(Z,ue)}registerFileEditorFactory(Z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Z}getFileEditorFactory(){return(0,T.assertIsDefined)(this.b)}registerEditorSerializer(Z,he){if(this.c.has(Z)||this.d.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.a?this.e(Z,he,this.a):this.c.set(Z,he),(0,L.toDisposable)(()=>{this.c.delete(Z),this.d.delete(Z)})}getEditorSerializer(Z){return this.d.get(typeof Z=="string"?Z:Z.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new F);async function $(X,Z,he){return!X||!X.length?[]:await Promise.all(X.map(async oe=>{const ue=y.URI.revive(oe.fileUri);if(!ue){he.info("Cannot resolve the path because it is not valid.",oe);return}if(!await Z.canHandleResource(ue)){he.info("Cannot resolve the path because it cannot be handled",oe);return}let fe=oe.exists,Y=oe.type;if(typeof fe!="boolean"||typeof Y!="number")try{Y=(await Z.stat(ue)).isDirectory?S.FileType.Directory:S.FileType.Unknown,fe=!0}catch(we){he.error(we),fe=!1}if(!fe&&oe.openOnlyIfExists){he.info("Cannot resolve the path because it does not exist",oe);return}if(Y===S.FileType.Directory){he.info("Cannot resolve the path because it is a directory",oe);return}const ge={...oe.options,pinned:!0};return fe?{resource:ue,options:ge}:{resource:ue,options:ge,forceUntitled:!0}}))}e.pathsToEditors=$;var z;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function K(X){const Z=X;if(!Z)return!1;const he=Z;if(he.modified)return K(he.modified);const oe=Z;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=K}),define(Ie[169],Ce([1,0,5,15,140]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,S,k,O){const D={command:R};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.s("request",D),typeof O=="number"){const f=setTimeout(()=>{clearTimeout(f);const v=this.f.get(D.seq);if(v){this.f.delete(D.seq);const h={type:"response",seq:0,request_seq:D.seq,success:!1,command:R,message:(0,y.localize)(0,null,O,R)};v(h)}},O)}return k&&this.f.set(D.seq,k),D.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,S){return R.type!=="event"||S.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,T.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const S=R,k=this.f.get(S.request_seq);k&&(this.f.delete(S.request_seq),k(S));break}}}}s(R,S){S.type=R,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((S,k)=>R.set(k,S)),await(0,T.timeout)(500),R.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(Ie[170],Ce([1,0,141,41,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(49,null)});const L=f=>n.localize(50,null,f);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(51,null)};var C;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(C=e.State||(e.State={}));function R(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var S;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,y.createDecorator)("debugService");var D;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(D=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[171],Ce([1,0,10,2,19,23,13]),function(te,e,n,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function S(a,d,c){return a.replace(R,function(u,t){return d&&t.length>0&&t[0]!=="_"?u:c&&c.hasOwnProperty(t)?c[t]:u})}e.formatPII=S;function k(a){const d={};for(const c of Object.keys(a))c.startsWith("!")||(d[c]=a[c]);return d}e.filterExceptionsFromTelemetry=k;function O(a){return a.configuration.request==="attach"&&!D(a)&&(!a.parentSession||O(a.parentSession))}e.isSessionAttach=O;function D(a){let d=a.configuration.type;if(!!d)return d==="vslsShare"&&(d=a.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(d,"extensionhost")||(0,n.equalsIgnoreCase)(d,"pwa-extensionhost")?a:a.parentSession?D(a.parentSession):void 0}e.getExtensionHostDebugSession=D;function f(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=f;function v(a,d,c){let u,t=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=m.exec(a);){const A=p.index+1,N=A+p[0].length;if(A<=d&&N>=c){u=p[0],t=A;break}}if(u){const A=/\w+/g;let N=null;for(;(N=A.exec(u))&&!(N.index+1+t+N[0].length>=c););N&&(u=u.substring(0,A.lastIndex))}return u?{start:t,end:t+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=v;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(a){return!!(a&&a.match(h))}e.isUri=i;function o(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(i(a.path))return T.URI.parse(a.path);if((0,y.isAbsolute)(a.path))return T.URI.file(a.path)}return a.path}function l(a){if(typeof a.path=="object"){const d=T.URI.revive(a.path);if(d)return d.scheme===C.Schemas.file?d.fsPath:d.toString()}return a.path}function E(a,d){const c=d?o:l,u=(0,L.deepClone)(a);return g(u,(t,m)=>{t&&m&&(m.path=c(m))}),u}e.convertToDAPaths=E;function b(a,d){const c=d?o:l,u=(0,L.deepClone)(a);return g(u,(t,m)=>{!t&&m&&(m.path=c(m))}),u}e.convertToVSCPaths=b;function g(a,d){switch(a.type){case"event":{const c=a;switch(c.event){case"output":d(!1,c.body.source);break;case"loadedSource":d(!1,c.body.source);break;case"breakpoint":d(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=a;switch(c.command){case"setBreakpoints":d(!0,c.arguments.source);break;case"breakpointLocations":d(!0,c.arguments.source);break;case"source":d(!0,c.arguments.source);break;case"gotoTargets":d(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(u=>d(!1,u));break;default:break}break}case"response":{const c=a;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(u=>d(!1,u.source));break;case"loadedSources":c.body.sources.forEach(u=>d(!1,u));break;case"scopes":c.body.scopes.forEach(u=>d(!1,u.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(u=>d(!1,u.source));break;case"setBreakpoints":c.body.breakpoints.forEach(u=>d(!1,u.source));break;case"disassemble":c.body?.instructions.forEach(t=>d(!1,t.location));break;default:break}break}}}function w(a){return a.filter(d=>!d.presentation?.hidden).sort((d,c)=>d.presentation?c.presentation?d.presentation.group?c.presentation.group?d.presentation.group!==c.presentation.group?d.presentation.group.localeCompare(c.presentation.group):s(d.presentation.order,c.presentation.order):-1:c.presentation.group?1:s(d.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=w;function s(a,d){return typeof a!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:a-d}async function r(a,d){const c=a.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(c!=="none"&&(await d.saveAll(),c==="allEditorsInActiveGroup")){const u=d.activeEditorPane;u&&u.input.resource?.scheme===C.Schemas.untitled&&await d.save({editor:u.input,groupId:u.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(Ie[66],Ce([1,0,24,35,172,61,13,19,21,41]),function(te,e,n,T,y,L,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var f;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(f=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var v;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(v=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var h;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(h=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var i;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(i=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var l;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var E;(function($){$.scheme=C.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],K=new RegExp(`^[${z.join("")}]+`),X=7;function Z(Y,ge){const we=ge.toString(X),We=`${we.length<z.length?z[we.length-1]:"z"}${we}s${(0,n.encodeBase64)(n.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:$.scheme,fragment:We})}$.generate=Z;function he(Y){if(Y.scheme!==$.scheme)return;const ge=Y.fragment.indexOf("s");if(ge<0)return;const we=parseInt(Y.fragment.substring(0,ge).replace(K,""),X),Me=(0,n.decodeBase64)(Y.fragment.substring(ge+1)).toString();if(!isNaN(we))return{handle:we,notebook:Y.with({scheme:Me,fragment:null})}}$.parse=he;function oe(Y,ge){return Y.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${Y.scheme!==C.Schemas.file?Y.scheme:""}`})}$.generateCellOutputUri=oe;function ue(Y){if(Y.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!ge)return;const we=ge[1]&&ge[1]!==""?ge[1]:void 0,Me=ge[2];return{outputId:we,notebook:Y.with({scheme:Me||C.Schemas.file,fragment:null})}}$.parseCellOutputUri=ue;function ce(Y,ge,we){return $.generate(Y,ge).with({scheme:we})}$.generateCellPropertyUri=ce;function fe(Y,ge){if(Y.scheme===ge)return $.parse(Y.with({scheme:$.scheme}))}$.parseCellPropertyUri=fe})(E=e.CellUri||(e.CellUri={}));const b=$=>S.isWindows?$.replace(/\//g,"\\"):$;class g{constructor(z=[],K=e.NOTEBOOK_DISPLAY_ORDER){this.e=K,this.d=[...new Set(z)].map(X=>({pattern:X,matches:T.parse(b(X))}))}sort(z){const K=new Map(y.Iterable.map(z,Z=>[Z,b(Z)]));let X=[];for(const{matches:Z}of this.d)for(const[he,oe]of K)if(Z(oe)){X.push(he),K.delete(he);break}return K.size&&(X=X.concat([...K.keys()].sort((Z,he)=>this.e.indexOf(Z)-this.e.indexOf(he)))),X}prioritize(z,K){const X=this.f(z);if(X===-1){this.d.unshift({pattern:z,matches:T.parse(b(z))});return}const Z=new Set(K.map(oe=>this.f(oe,X)));Z.delete(-1);const he=Array.from(Z).sort();this.d.splice(X+1,0,...he.map(oe=>this.d[oe]));for(let oe=he.length-1;oe>=0;oe--)this.d.splice(he[oe],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,K=this.d.length){const X=b(z);for(let Z=0;Z<K;Z++)if(this.d[Z].matches(X))return Z;return-1}}e.MimeTypeDisplayOrder=g;function w($,z,K,X=(Z,he)=>Z===he){const Z=[];function he(ce,fe,Y){if(fe===0&&Y.length===0)return;const ge=Z[Z.length-1];ge&&ge.start+ge.deleteCount===ce?(ge.deleteCount+=fe,ge.toInsert.push(...Y)):Z.push({start:ce,deleteCount:fe,toInsert:Y})}let oe=0,ue=0;for(;;){if(oe===$.length){he(oe,0,z.slice(ue));break}if(ue===z.length){he(oe,$.length-oe,[]);break}const ce=$[oe],fe=z[ue];if(X(ce,fe)){oe+=1,ue+=1;continue}K(fe)?(he(oe,1,[]),oe+=1):(he(oe,0,[fe]),ue+=1)}return Z}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function($){$.default="default",$.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r($){const z=$;return!!((typeof z.include=="string"||T.isRelativePattern(z.include))&&(typeof z.exclude=="string"||T.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=r;function a($,z,K){if(Array.isArray($.viewType)&&$.viewType.indexOf(z)>=0||$.viewType===z)return!0;if($.filenamePattern){const X=r($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,Z=r($.filenamePattern)?$.filenamePattern.exclude:void 0;if(T.match(X,(0,R.basename)(K.fsPath).toLowerCase()))return!(Z&&T.match(Z,(0,R.basename)(K.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var d;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(z){return`${c.d}${z}`}static parse(z){if(z.startsWith(c.d))return z.substring(c.d.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c.d="notebook/";function u($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=u;const t=new TextDecoder;function m($){const z=[];let K=!1;for(const X of $)(z.length===0||K)&&(z.push(X),K=!0);return q(z),F(n.VSBuffer.concat(z.map(X=>n.VSBuffer.wrap(X))))}e.compressOutputItemStreams=m;const p=`${String.fromCharCode(27)}[A`,A=p.split("").map($=>$.charCodeAt(0)),N=10;function q($){$.forEach((z,K)=>{if(K===0||z.length<p.length)return;const X=$[K-1],Z=z.subarray(0,p.length);if(Z[0]===A[0]&&Z[1]===A[1]&&Z[2]===A[2]){const he=X.lastIndexOf(N);if(he===-1)return;$[K-1]=X.subarray(0,he),$[K]=z.subarray(p.length)}})}function j($){let z=$;do $=z,z=$.replace(/[^\n]\x08/gm,"");while(z.length<$.length);return $}function V($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const z=$.match(/^(.*)\r+/m)[1];let K=$.match(/\r+(.*)$/m)[1];K=K+z.slice(K.length,z.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,K)}return $}const P="\b".charCodeAt(0),M="\r".charCodeAt(0);function F($){return!$.buffer.includes(P)&&!$.buffer.includes(M)?$:n.VSBuffer.fromString(V(j(t.decode($.buffer))))}}),define(Ie[173],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Ie[174],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=n;function T(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=T;function y(C){return Array.from(C.entries()).map(R=>[R[0],n(R[1].map)])}e.serializeEnvironmentVariableCollections=y;function L(C){return new Map(C.map(R=>[R[0],{map:T(R[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(Ie[42],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(L){L.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class y{static fromExtHostTestItem(C,R,S=C.parent){if(C._isRoot)return new y([R]);const k=[C.id];for(let O=S;O&&O.id!==R;O=O.parent)k.push(O.id);return k.push(R),new y(k.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const R=C.indexOf("\0");return R===-1?C:C.slice(0,R)}static fromString(C){return new y(C.split("\0"))}static join(C,R){return new y([...C.path,R])}static joinToString(C,R){return C.toString()+"\0"+R}static parentId(C){const R=C.lastIndexOf("\0");return R===-1?void 0:C.slice(0,R)}static compare(C,R){return C===R?0:R.startsWith(C+"\0")?2:C.startsWith(R+"\0")?3:1}constructor(C,R=C.length){if(this.path=C,this.d=R,C.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new y(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new y(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new y(this.path,C)}compare(C){if(typeof C=="string")return y.compare(this.toString(),C);for(let R=0;R<C.d&&R<this.d;R++)if(C.path[R]!==this.path[R])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=y}),define(Ie[53],Ce([1,0,2,54,42]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var L;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(L=e.TestResultState||(e.TestResultState={}));var C;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var R;(function(u){u.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),u.deserialize=t=>({range:T.Range.lift(t.range),uri:n.URI.revive(t.uri)})})(R=e.IRichLocation||(e.IRichLocation={}));var S;(function(u){u[u.Error=0]="Error",u[u.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var k;(function(u){u.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&R.serialize(t.location)}),u.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&R.deserialize(t.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const O=(u,t)=>`${t?"s":"e"}${u}`;e.getMarkId=O;var D;(function(u){u.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&R.serialize(t.location)}),u.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&R.deserialize(t.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var f;(function(u){u.serialize=t=>t.type===0?k.serialize(t):D.serialize(t),u.deserialize=t=>t.type===0?k.deserialize(t):D.deserialize(t)})(f=e.ITestMessage||(e.ITestMessage={}));var v;(function(u){u.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),u.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(f.serialize)}),u.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(f.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const h="\0",i=(u,t)=>u+h+t;e.namespaceTestTag=i;const o=u=>{const t=u.indexOf(h);return{ctrlId:u.slice(0,t),tagId:u.slice(t+1)}};e.denamespaceTestTag=o;var l;(function(u){u.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),u.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?n.URI.revive(t.uri):void 0,range:t.range?T.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(l=e.ITestItem||(e.ITestItem={}));var E;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var b;(function(u){u.serialize=t=>({expand:t.expand,item:l.serialize(t.item)}),u.deserialize=t=>({controllerId:y.TestId.root(t.item.extId),expand:t.expand,item:l.deserialize(t.item)})})(b=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(u){u.serialize=t=>{let m;return t.item&&(m={},t.item.label!==void 0&&(m.label=t.item.label),t.item.tags!==void 0&&(m.tags=t.item.tags),t.item.busy!==void 0&&(m.busy=t.item.busy),t.item.uri!==void 0&&(m.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(m.range=t.item.range?.toJSON()),t.item.description!==void 0&&(m.description=t.item.description),t.item.error!==void 0&&(m.error=t.item.error),t.item.sortText!==void 0&&(m.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:m}},u.deserialize=t=>{let m;return t.item&&(m={},t.item.label!==void 0&&(m.label=t.item.label),t.item.tags!==void 0&&(m.tags=t.item.tags),t.item.busy!==void 0&&(m.busy=t.item.busy),t.item.range!==void 0&&(m.range=t.item.range?T.Range.lift(t.item.range):null),t.item.description!==void 0&&(m.description=t.item.description),t.item.error!==void 0&&(m.error=t.item.error),t.item.sortText!==void 0&&(m.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:m}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(u,t)=>{t.expand!==void 0&&(u.expand=t.expand),t.item!==void 0&&(u.item=u.item?Object.assign(u.item,t.item):t.item)};e.applyTestItemUpdate=w;var s;(function(u){u.serializeWithoutMessages=t=>({...b.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(v.serializeWithoutMessages),retired:t.retired}),u.serialize=t=>({...b.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(v.serialize),retired:t.retired}),u.deserialize=t=>({...b.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(v.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var a;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.DocumentSynced=2]="DocumentSynced",u[u.Remove=3]="Remove",u[u.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",u[u.Retire=5]="Retire",u[u.AddTag=6]="AddTag",u[u.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(u){u.deserialize=t=>t.op===0?{op:t.op,item:b.deserialize(t.item)}:t.op===1?{op:t.op,item:g.deserialize(t.item)}:t.op===2?{op:t.op,uri:n.URI.revive(t.uri),docv:t.docv}:t,u.serialize=t=>t.op===0?{op:t.op,item:b.serialize(t.item)}:t.op===1?{op:t.op,item:g.serialize(t.item)}:t})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(t){const m=this.o();for(const p of t)switch(p.op){case 0:this.j(b.deserialize(p.item),m);break;case 1:this.k(g.deserialize(p.item),m);break;case 3:this.l(p.itemId,m);break;case 5:this.m(p.itemId);break;case 4:this.updatePendingRoots(p.amount);break;case 6:this.c.set(p.tag.id,p.tag);break;case 7:this.c.delete(p.id);break}m.complete?.()}j(t,m){const p=y.TestId.parentId(t.item.extId)?.toString();let A;if(!p)A=this.p(t),this.f.add(A),this.d.set(t.item.extId,A);else if(this.d.has(p)){const N=this.d.get(p);N.children.add(t.item.extId),A=this.p(t,N),this.d.set(t.item.extId,A)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return m.add?.(A),t.expand===2&&this.g++,A}k(t,m){const p=this.d.get(t.extId);if(!!p)return t.expand!==void 0&&(p.expand===2&&this.g--,t.expand===2&&this.g++),(0,e.applyTestItemUpdate)(p,t),m.update?.(p),p}l(t,m){const p=this.d.get(t);if(!p)return;const A=y.TestId.parentId(p.item.extId)?.toString();A?this.d.get(A).children.delete(p.item.extId):this.f.delete(p);const N=[[t]];for(;N.length;)for(const q of N.pop()){const j=this.d.get(q);j&&(N.push(j.children),this.d.delete(q),m.remove?.(j,j!==p),j.expand===2&&this.g--)}}m(t){}updatePendingRoots(t){this.h+=t}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(Ie[67],Ce([1,0,15,5,7,47,53,42]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(E){E[E.Upsert=0]="Upsert",E[E.SetTags=1]="SetTags",E[E.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",E[E.RemoveChild=3]="RemoveChild",E[E.SetProp=4]="SetProp",E[E.Bulk=5]="Bulk",E[E.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(E,b)=>E===b,D=Object.entries({range:(E,b)=>E===b?!0:!E||!b?!1:E.equalsRange(b),busy:k,label:k,description:k,error:k,sortText:k,tags:(E,b)=>!(E.length!==b.length||E.some(g=>!b.includes(g)))}),f=(E,b)=>{let g;for(const[w,s]of D)s(E[w],b[w])||(g?g[w]=b[w]:g={[w]:b[w]});return g};class v extends y.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new T.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const g of this.tree.values())this.G(g)}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const g of this.k)if(g.op===2&&g.uri===b.uri){g.docv=b.docv;return}break}case 1:{const g=this.k[this.k.length-1];if(g){if(g.op===1&&g.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(g.item,b.item);return}if(g.op===0&&g.item.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(g.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,g){const w=this.tree.get(b);if(!!w){if((w.expandLevels===void 0||g>w.expandLevels)&&(w.expandLevels=g),w.expand===1){const s=this.I(w);return s.isOpen()?this.H(w,g-1):s.wait().then(()=>this.H(w,g-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,g-1)):this.H(w,g-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,g){switch(g.op){case 3:this.L(R.TestId.joinToString(b.fullId,g.id));break;case 0:this.u(g.item,b);break;case 5:for(const w of g.ops)this.p(b,w);break;case 1:this.w(g.new,g.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:g.update}});break;case 6:this.s(b.actual.uri);break;default:(0,L.assertNever)(g)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,g){const w=R.TestId.fromExtHostTestItem(b,this.root.id,g?.actual),s=this.m.getApiFor(b);s.parent&&s.parent!==g?.actual&&this.m.getChildren(s.parent).delete(b.id);let r=this.tree.get(w.toString());if(!r){r={fullId:w,actual:b,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(r.fullId.toString(),r),this.C(b,g),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:r.expand,item:this.m.toITestItem(b)}}),this.F(b,r,g);return}if(r.actual===b){this.D(b,r,g);return}if(r.actual.uri?.toString()!==b.uri?.toString())return this.L(w.toString()),this.u(b,g);const a=this.m.getChildren(r.actual),d=r.actual,c=f(this.m.toITestItem(d),this.m.toITestItem(b));this.m.getApiFor(d).listener=void 0,r.actual=b,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(b.tags,d.tags,w.toString()),delete c.tags),this.p(r,{op:4,update:c})),this.F(b,r,g);for(const[u,t]of a)this.m.getChildren(b).get(t.id)||this.L(R.TestId.joinToString(w,t.id));this.s(r.actual.uri)}w(b,g,w){const s=new Set(g.map(r=>r.id));for(const r of b)s.delete(r.id)||this.y(r);this.pushDiff({op:1,item:{extId:w,item:{tags:b.map(r=>(0,C.namespaceTestTag)(this.m.controllerId,r.id))}}}),s.forEach(this.z,this)}y(b){const g=this.j.get(b.id);g?g.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const g=this.j.get(b);g&&!--g.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,b)}))}C(b,g){this.m.getApiFor(b).parent=g&&g.actual!==this.root?g.actual:void 0}D(b,g,w){this.C(b,w);const s=this.m.getApiFor(b);s.parent=w?.actual,s.listener=r=>this.p(g,r),this.G(g)}F(b,g,w){this.D(b,g,w);for(const[s,r]of this.m.getChildren(b))this.u(r,g)}G(b){let g;this.h?b.resolveBarrier?g=b.resolveBarrier.isOpen()?3:2:g=b.actual.canResolveChildren?1:0:g=0,g!==b.expand&&(b.expand=g,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:g}}),g===1&&b.expandLevels!==void 0&&this.I(b))}H(b,g){if(g<0)return;const w=[];for(const[s,r]of this.m.getChildren(b.actual)){const a=this.expand(R.TestId.joinToString(b.fullId,r.id),g);(0,n.isThenable)(a)&&w.push(a)}if(w.length)return Promise.all(w).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const r=new n.Barrier;return r.open(),r}b.expand=2,this.J(b);const g=b.resolveBarrier=new n.Barrier,w=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,r)};let s;try{s=this.h(b.actual===this.root?void 0:b.actual)}catch(r){w(r)}return(0,n.isThenable)(s)?s.catch(w).then(()=>{g.open(),this.G(b)}):(g.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const g=this.tree.get(b);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const w=[g];for(;w.length;){const s=w.pop();if(!!s){this.m.getApiFor(s.actual).listener=void 0;for(const r of s.actual.tags)this.z(r.id);this.tree.delete(s.fullId.toString());for(const[r,a]of this.m.getChildren(s.actual))w.push(this.tree.get(R.TestId.joinToString(s.fullId,a.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=v;class h extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=h;class i extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=i;class o extends Error{constructor(b,g,w){super(`TestItem with ID "${b}" is from controller "${g}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=o;const l=(E,b,g)=>{let w=new Map;return{get size(){return w.size},forEach(s,r){for(const a of w.values())s.call(r,a,this)},[Symbol.iterator](){return w.entries()},replace(s){const r=new Map,a=new Set(w.keys()),d={op:5,ops:[]};for(const c of s){if(!(c instanceof g))throw new i(c.id);const u=b(c).controllerId;if(u!==E.controllerId)throw new o(c.id,u,E.controllerId);if(r.has(c.id))throw new h(c.id);r.set(c.id,c),a.delete(c.id),d.ops.push({op:0,item:c})}for(const c of a.keys())d.ops.push({op:3,id:c});E.listener?.(d),w=r},add(s){if(!(s instanceof g))throw new i(s.id);w.set(s.id,s),E.listener?.({op:0,item:s})},delete(s){w.delete(s)&&E.listener?.({op:3,id:s})},get(s){return w.get(s)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=l}),define(Ie[93],Ce([1,0,67]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,y=(C,R)=>{const S={controllerId:R};return T.set(C,S),S};e.createPrivateApiFor=y;const L=C=>{const R=T.get(C);if(!R)throw new n.InvalidTestItemError(C?.id||"<unknown>");return R};e.getPrivateApiFor=L}),define(Ie[68],Ce([1,0,13,2]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(R,S){return R.scheme===n.Schemas.http||R.scheme===n.Schemas.https?R:(S&&S.authority&&S.isRemote&&R.scheme===n.Schemas.file&&(R=T.URI.from({scheme:n.Schemas.vscodeRemote,authority:S.authority,path:R.path})),T.URI.from({scheme:n.Schemas.https,authority:`${R.scheme}+${L(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=y;function L(R){return R.replace(/./g,S=>{const k=S.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?S:"-"+k.toString(16).padStart(4,"0")})}function C(R){return R.replace(/-([0-9a-f]{4})/g,(S,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=C}),define(Ie[175],Ce([1,0,5,7,68]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(R,S,k){this.d=R,this.e=S,this.f=k,this.a=0,this.b=new T.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const O=S.getVisibleTextEditors();for(const D of this.c.values())O.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,S,k,O,D){let f;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===R){f=b;break}if(!f)throw new Error("not a visible editor");const v=this,h=this.a++,i=new n.Emitter,o=new n.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,y.asWebviewUri)(b,v.f)}get cspSource(){return y.webviewGenericCspSource}set options(b){this.b=b,v.d.$setOptions(h,b)}get options(){return this.b}set html(b){this.a=b,v.d.$setHtml(h,b)}get html(){return this.a}get onDidReceiveMessage(){return i.event}postMessage(b){return v.d.$postMessage(h,b)}},E=new class{constructor(){this.editor=R,this.line=S,this.height=k,this.webview=l,this.onDidDispose=o.event}dispose(){v.c.has(h)&&(v.c.delete(h),v.d.$disposeEditorInset(h),o.fire(),o.dispose(),i.dispose())}};return this.d.$createEditorInset(h,f.id,f.value.document.uri,S+1,k,O||{},D.identifier,D.extensionLocation),this.c.set(h,{editor:R,inset:E,onDidReceiveMessage:i}),E}$onDidDispose(R){const S=this.c.get(R);S&&S.inset.dispose()}$onDidReceiveMessage(R,S){this.c.get(R)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=L}),define(Ie[176],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T=e.VariableKind||(e.VariableKind={}));class y extends Error{constructor(C,R){super(R),this.variable=C}}e.VariableError=y}),define(Ie[177],Ce([1,0,19,49,9,23,21,82,144,176,10]),function(te,e,n,T,y,L,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(v,h,i,o){this.g=new Map,this.a=v,this.b=h,this.d=i,o&&(this.c=o.then(l=>this.h(l)))}h(v){if(C.isWindows){const h=Object.create(null);return Object.keys(v).forEach(i=>{h[i.toLowerCase()]=v[i]}),h}return v}resolveWithEnvironment(v,h,i){return this.j({env:this.h(v),userHome:void 0},h?h.uri:void 0,i)}async resolveAsync(v,h){const i={env:await this.c,userHome:await this.d};return this.j(i,v?v.uri:void 0,h)}async i(v,h,i,o){const l=L.deepClone(h);C.isWindows&&l.windows?Object.keys(l.windows).forEach(b=>l[b]=l.windows[b]):C.isMacintosh&&l.osx?Object.keys(l.osx).forEach(b=>l[b]=l.osx[b]):C.isLinux&&l.linux&&Object.keys(l.linux).forEach(b=>l[b]=l.linux[b]),delete l.windows,delete l.osx,delete l.linux;const E={env:await this.c,userHome:await this.d};return this.j(E,v?v.uri:void 0,l,i,o)}async resolveAnyAsync(v,h,i){return this.i(v,h,i)}async resolveAnyMap(v,h,i){const o=new Map;return{newConfig:await this.i(v,h,i,o),resolvedVariables:o}}resolveWithInteractionReplace(v,h,i,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,h,i,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,h){if(this.g.has(v))throw new Error("Variable "+v+" is contributed twice.");this.g.set(v,h)}async j(v,h,i,o,l){if(y.isString(i))return this.l(v,h,i,o,l);if(Array.isArray(i))return Promise.all(i.map(E=>this.j(v,h,E,o,l)));if(y.isObject(i)){const E=Object.create(null),b=await Promise.all(Object.keys(i).map(async g=>[await this.l(v,h,g,o,l),await this.j(v,h,i[g],o,l)]));for(const[g,w]of b)E[g]=w;return E}return i}l(v,h,i,o,l){return(0,O.replaceAsync)(i,D.VARIABLE_REGEXP,async(E,b)=>{if(b.includes(D.VARIABLE_LHS))return E;let g=await this.n(v,E,b,h,o);return l?.set(b,g),g!==E&&y.isString(g)&&g.match(D.VARIABLE_REGEXP)&&(g=await this.l(v,h,g,o,l)),g})}m(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async n(v,h,i,o,l){let E;const b=i.split(":");b.length>1&&(i=b[0],E=b[1]);const g=r=>{const a=this.a.getFilePath();if(a)return a;throw new k.VariableError(r,(0,S.localize)(0,null,h))},w=r=>{const a=g(r);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return d}throw new k.VariableError(r,(0,S.localize)(1,null,h,n.basename(a)))},s=r=>{if(E){const a=this.a.getFolderUri(E);if(a)return a;throw new k.VariableError(r,(0,S.localize)(2,null,h,E))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(r,(0,S.localize)(3,null,h)):new k.VariableError(r,(0,S.localize)(4,null,h))};switch(i){case"env":if(E){if(v.env){const r=v.env[C.isWindows?E.toLowerCase():E];if(y.isString(r))return r}return""}throw new k.VariableError(k.VariableKind.Env,(0,S.localize)(5,null,h));case"config":if(E){const r=this.a.getConfigurationValue(o,E);if(y.isUndefinedOrNull(r))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(6,null,h,E));if(y.isObject(r))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(7,null,h,E));return r}throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(8,null,h));case"command":return this.o(k.VariableKind.Command,h,E,l,"command");case"input":return this.o(k.VariableKind.Input,h,E,l,"input");case"extensionInstallFolder":if(E){const r=await this.a.getExtension(E);if(!r)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,h,E));return this.m(r.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,h));default:switch(i){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(s(k.VariableKind.WorkspaceFolder)));case"cwd":return o||E?(0,R.normalizeDriveLetter)(this.m(s(k.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return n.basename(this.m(s(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(v.userHome)return v.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,S.localize)(11,null,h))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new k.VariableError(k.VariableKind.LineNumber,(0,S.localize)(12,null,h))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new k.VariableError(k.VariableKind.SelectedText,(0,S.localize)(13,null,h))}case"file":return g(k.VariableKind.File);case"fileWorkspaceFolder":return w(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||E?n.relative(this.m(s(k.VariableKind.RelativeFile)),g(k.VariableKind.RelativeFile)):g(k.VariableKind.RelativeFile);case"relativeFileDirname":{const r=n.dirname(g(k.VariableKind.RelativeFileDirname));if(o||E){const a=n.relative(this.m(s(k.VariableKind.RelativeFileDirname)),r);return a.length===0?".":a}return r}case"fileDirname":return n.dirname(g(k.VariableKind.FileDirname));case"fileExtname":return n.extname(g(k.VariableKind.FileExtname));case"fileBasename":return n.basename(g(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=n.basename(g(k.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-n.extname(r).length)}case"fileDirnameBasename":return n.basename(n.dirname(g(k.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||h}case"execInstallFolder":{const r=this.a.getAppRoot();return r||h}case"pathSeparator":return n.sep;default:try{const r=E?`${i}:${E}`:i;return this.o(k.VariableKind.Unknown,h,r,l,void 0)}catch{return h}}}}o(v,h,i,o,l){if(i&&o){const E=l===void 0?o[i]:o[l+":"+i];if(typeof E=="string")return E;throw new k.VariableError(v,(0,S.localize)(14,null,h))}return h}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[94],Ce([1,0,3,92]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var y;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var L;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var R;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function k(h){const i=h;return(0,T.isEditorInput)(i?.editor)&&(0,T.isEditorInput)(i?.replacement)}e.isEditorReplacement=k;var O;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function f(h){const i=h;return!!i&&typeof i.id=="number"&&Array.isArray(i.editors)}e.isEditorGroup=f;function v(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(Ie[178],Ce([1,0,3,94]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(L){const C=L;return typeof L=="number"||(0,T.isEditorGroup)(C)}e.isPreferredGroup=y}),define(Ie[179],Ce([1,0,3,150]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(T.IEnvironmentService)}),define(Ie[180],Ce([1,0,26,5,19]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(D){this.removedDueToLooping=D}}e.DeltaExtensionsResult=L;class C{constructor(D){this.c=new T.Emitter,this.onDidChange=this.c.event,this.d=D,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const D of this.d){if(this.e.has(n.ExtensionIdentifier.toKey(D.identifier))){console.error("Extension `"+D.identifier.value+"` is already registered");continue}if(this.e.set(n.ExtensionIdentifier.toKey(D.identifier),D),this.f.push(D),Array.isArray(D.activationEvents))for(let f of D.activationEvents)f==="onUri"&&(f=`onUri:${n.ExtensionIdentifier.toKey(D.identifier)}`),this.g.has(f)||this.g.set(f,[]),this.g.get(f).push(D)}}set(D){this.d=D,this.h(),this.c.fire(void 0)}deltaExtensions(D,f){this.d=k(this.d,f),this.d=this.d.concat(D);const v=C.j(this.d);return this.d=k(this.d,v.map(h=>h.identifier)),this.h(),this.c.fire(void 0),new L(v)}static j(D){const f=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,E){this.addNode(l),this.addNode(E),this.c.has(l)?this.c.get(l).push(E):this.c.set(l,[E])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,E){const b=f.getArcs(l);for(let g=0;g<b.length;g++)if(!E.has(b[g]))return!1;return!0}getNodes(){return this.e}},v=new Map;for(const l of D){const E=n.ExtensionIdentifier.toKey(l.identifier);if(v.set(E,l),l.extensionDependencies)for(const b of l.extensionDependencies){const g=n.ExtensionIdentifier.toKey(b);f.addArc(E,g)}}const h=new Set;f.getNodes().filter(l=>f.getArcs(l).length===0).forEach(l=>h.add(l));const i=f.getNodes().filter(l=>!h.has(l));let o;do{o=!1;for(let l=0;l<i.length;l++){const E=i[l];f.hasOnlyGoodArcs(E,h)&&(i.splice(l,1),l--,h.add(E),o=!0)}}while(o);return i.map(l=>v.get(l))}containsActivationEvent(D){return this.g.has(D)}containsExtension(D){return this.e.has(n.ExtensionIdentifier.toKey(D))}getExtensionDescriptionsForActivationEvent(D){const f=this.g.get(D);return f?f.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(D){const f=this.e.get(n.ExtensionIdentifier.toKey(D));return f||void 0}getExtensionDescriptionByUUID(D){for(const f of this.f)if(f.uuid===D)return f}getExtensionDescriptionByIdOrUUID(D,f){return this.getExtensionDescription(D)??(f?this.getExtensionDescriptionByUUID(f):void 0)}}e.ExtensionDescriptionRegistry=C;var R;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(R||(R={}));function S(O,D){const f=O.isBuiltin?0:O.isUnderDevelopment?2:1,v=D.isBuiltin?0:D.isUnderDevelopment?2:1;if(f!==v)return f-v;const h=y.posix.basename(O.extensionLocation.path),i=y.posix.basename(D.extensionLocation.path);return h<i?-1:h>i?1:0}function k(O,D){const f=new Set;return D.forEach(v=>f.add(n.ExtensionIdentifier.toKey(v))),O.filter(v=>!f.has(n.ExtensionIdentifier.toKey(v.identifier)))}}),define(Ie[69],Ce([1,0,24]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function C(k){const O=n.VSBuffer.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=C;function R(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=R;var S;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[70],Ce([1,0,3,5,12,27,69,48,91,23,2]),function(te,e,n,T,y,L,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let D=class{constructor(i,o){this.i=i,this.a=new T.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new T.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=o.createLogger(O.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(i,o){const l=this.getTelemetryDetails(),E=new f(o,i,this.g,this.f,this.getBuiltInCommonProperties(i),{isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled});return this.h.set(i.identifier.value,E),E.apiTelemetryLogger}$initializeTelemetryLevel(i,o,l){this.d=i,this.f=o,this.c=l??{usage:!0,error:!0}}getBuiltInCommonProperties(i){const o={};switch(o["common.extname"]=i.name,o["common.extversion"]=i.version,o["common.vscodemachineid"]=this.i.telemetryInfo.machineId,o["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,o["common.vscodeversion"]=this.i.version,o["common.isnewappinstall"]=v(this.i.telemetryInfo.firstSessionDate),o["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:o["common.uikind"]="web";break;case C.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,R.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),o}$onDidChangeTelemetryLevel(i){this.e=this.getTelemetryConfiguration(),this.d=i;const o=this.getTelemetryDetails();this.h.forEach(l=>{l.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(i,o){const l=this.h.get(i.value);return l?(l.logError(o),!0):!1}};D=qe([Ve(0,L.IExtHostInitDataService),Ve(1,y.ILoggerService)],D),e.ExtHostTelemetry=D;class f{constructor(i,o,l,E,b,g){this.e=o,this.f=l,this.g=E,this.h=b,this.b=new T.Emitter,this.a=i,this.c={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(i,o){this.d&&(this.c={isUsageEnabled:i,isErrorsEnabled:o},this.b.fire(this.d))}mixInCommonPropsAndCleanData(i){let o=i.properties??i;return o=(0,S.cleanData)(o,[]),this.a.additionalCommonProperties&&(o=(0,k.mixin)(o,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(o=(0,k.mixin)(o,this.h)),i.properties?i.properties=o:i=o,i}i(i,o){this.e.publisher==="vscode"?i=this.e.name+"/"+i:i=this.e.identifier.value+"/"+i,o=this.mixInCommonPropsAndCleanData(o||{}),this.g||this.a.logEvent(i,o),this.f.trace(i,o)}logUsage(i,o){!this.c.isUsageEnabled||this.i(i,o)}logError(i,o){!this.c.isErrorsEnabled||(typeof i=="string"?this.i(i,o):this.a.logException(i,o))}get apiTelemetryLogger(){if(!this.d){const i=this,o={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.c.isUsageEnabled},get isErrorsEnabled(){return i.c.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.b.event.bind(i)};this.d=Object.freeze(o)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=f;function v(h){const i=Date.now()-new Date(h).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.isNewAppInstall=v,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Ie[25],Ce([1,0,5,2,3,26,157]),function(te,e,n,T,y,L,C){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class S{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class k{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class O{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class D{constructor(u){this.dependency=u}}e.MissingExtensionDependency=D;var f;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(f=e.ExtensionHostKind||(e.ExtensionHostKind={}));function v(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=v;class h{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,t){const m=[],p=[],A=[],N=[],q=l(this.c),j=l(u),V=($,z)=>$.extensionLocation.toString()===z.extensionLocation.toString()||$.isBuiltin===z.isBuiltin||$.isUserBuiltin===z.isUserBuiltin||$.isUnderDevelopment===z.isUnderDevelopment;for(const $ of this.c){const z=j.get(L.ExtensionIdentifier.toKey($.identifier));if(!z){m.push($.identifier),q.delete(L.ExtensionIdentifier.toKey($.identifier));continue}if(!V($,z)){m.push($.identifier),q.delete(L.ExtensionIdentifier.toKey($.identifier));continue}}for(const $ of u){const z=q.get(L.ExtensionIdentifier.toKey($.identifier));if(!z){p.push($);continue}if(!V(z,$)){m.push(z.identifier),q.delete(L.ExtensionIdentifier.toKey(z.identifier));continue}}const P=o(this.d),M=o(t);for(const $ of this.d)M.has(L.ExtensionIdentifier.toKey($))||A.push($);for(const $ of t)P.has(L.ExtensionIdentifier.toKey($))||N.push($);const F={toRemove:m,toAdd:p,myToRemove:A,myToAdd:N};return this.delta(F),F}delta(u){const{toRemove:t,toAdd:m,myToRemove:p,myToAdd:A}=u,N=o(t),q=o(p);for(let j=0;j<this.c.length;j++)N.has(L.ExtensionIdentifier.toKey(this.c[j].identifier))&&(this.c.splice(j,1),j--);for(let j=0;j<this.d.length;j++)q.has(L.ExtensionIdentifier.toKey(this.d[j]))&&(this.d.splice(j,1),j--);for(const j of m)this.c.push(j);for(const j of A)this.d.push(j)}containsExtension(u){for(const t of this.d)if(L.ExtensionIdentifier.equals(t,u))return!0;return!1}}e.ExtensionHostExtensions=h;class i{constructor(u){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=L.ExtensionIdentifier.toKey,u)for(const t of u)this.add(t)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,t){this.c.forEach(m=>u.call(t,m,m,this))}*entries(){for(const[u,t]of this.c)yield[t,t]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=i;function o(c){const u=new Set;for(const t of c)u.add(L.ExtensionIdentifier.toKey(t));return u}e.extensionIdentifiersArrayToSet=o;function l(c){const u=new Map;for(const t of c)u.set(L.ExtensionIdentifier.toKey(t.identifier),t);return u}function E(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=E;function b(c,u){if(!E(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=b;class g{constructor(u,t,m,p){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=m,this.activationReason=p}}e.ActivationTimes=g;class w{constructor(u,t){this.description=u,this.value=t}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function a(c,u){return{identifier:new L.ExtensionIdentifier((0,C.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=a;class d{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,t){return Promise.resolve(0)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=d}),define(Ie[181],Ce([1,0,11,26,25,12,15]),function(te,e,n,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class R{constructor(o,l,E,b){this.startup=o,this.codeLoadingTime=l,this.activateCallTime=E,this.activateResolvedTime=b}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class S{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,l){return o===-1||l===-1?-1:l-o}build(){return new R(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=S;class k{constructor(o,l,E,b,g,w){this.activationFailed=o,this.activationFailedError=l,this.activationTimes=E,this.module=b,this.exports=g,this.subscriptions=w}}e.ActivatedExtension=k;class O extends k{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class D extends k{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=D;class f extends k{constructor(o){super(!0,o,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,l,E,b,g){this.h=g,this.a=o,this.b=new Set,l.forEach(w=>this.b.add(T.ExtensionIdentifier.toKey(w))),this.c=new Map,E.forEach(w=>this.c.set(T.ExtensionIdentifier.toKey(w),w)),this.d=b,this.f=new Map,this.g=Object.create(null)}dispose(){for(const[o,l]of this.f)l.dispose()}isActivated(o){const l=this.f.get(T.ExtensionIdentifier.toKey(o));return Boolean(l&&l.value)}getActivatedExtension(o){const l=this.f.get(T.ExtensionIdentifier.toKey(o));if(!l||!l.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return l.value}async activateByEvent(o,l){if(this.g[o])return;const E=this.a.getExtensionDescriptionsForActivationEvent(o);await this.j(E.map(b=>({id:b.identifier,reason:{startup:l,extensionId:b.identifier,activationEvent:o}}))),this.g[o]=!0}activateById(o,l){const E=this.a.getExtensionDescription(o);if(!E)throw new Error(`Extension '${o}' is not known`);return this.j([{id:E.identifier,reason:l}])}async j(o){const l=o.filter(E=>!this.isActivated(E.id)).map(E=>this.k(E));await Promise.all(l.map(E=>E.wait()))}k(o){if(this.f.has(T.ExtensionIdentifier.toKey(o.id)))return this.f.get(T.ExtensionIdentifier.toKey(o.id));if(this.c.has(T.ExtensionIdentifier.toKey(o.id)))return this.l(o,null,[],null);const l=this.a.getExtensionDescription(o.id);if(!l){const g=new Error(`Cannot activate unknown extension '${o.id.value}'`),w=this.l(o,null,[],new f(g));return this.d.onExtensionActivationError(o.id,g,new y.MissingExtensionDependency(o.id.value)),w}const E=[],b=typeof l.extensionDependencies>"u"?[]:l.extensionDependencies;for(const g of b){if(this.b.has(T.ExtensionIdentifier.toKey(g)))continue;const w=this.f.get(T.ExtensionIdentifier.toKey(g));if(w){E.push(w);continue}if(this.c.has(T.ExtensionIdentifier.toKey(g))){E.push(this.k({id:this.c.get(T.ExtensionIdentifier.toKey(g)),reason:o.reason}));continue}const s=this.a.getExtensionDescription(g);if(s){if(!s.main&&!s.browser)continue;E.push(this.k({id:s.identifier,reason:o.reason}));continue}const r=l.displayName||l.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${g}'`),d=this.l(o,l.displayName,[],new f(a));return this.d.onExtensionActivationError(l.identifier,a,new y.MissingExtensionDependency(g)),d}return this.l(o,l.displayName,E,null)}l(o,l,E,b){const g=new h(o.id,l,o.reason,E,b,this.d,this.h);return this.f.set(T.ExtensionIdentifier.toKey(o.id),g),g}};v=qe([Ve(4,L.ILogService)],v),e.ExtensionsActivator=v;let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,l,E,b,g,w,s){this.c=o,this.d=l,this.f=E,this.g=b,this.h=g,this.j=w,this.k=s,this.a=new C.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const l=this.g[o];if(l.value&&!l.value.activationFailed){this.g.splice(o,1),o--;continue}if(l.value&&l.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${l.friendlyName}' failed to activate`);E.detail=l.value.activationFailedError,this.h=new f(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const l=new Error;if(o&&o.name&&(l.name=o.name),o&&o.message?l.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:l.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(l.stack=o.stack),this.h=new f(l),this.b&&n.isCancellationError(o))return;this.j.onExtensionActivationError(this.c,l,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};h=qe([Ve(6,L.ILogService)],h)}),define(Ie[182],Ce([1,0,12,27,25]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends n.LogService{constructor(R,S){super(R.createLogger(S.logFile,{name:y.ExtensionHostLogFileName}))}};L=qe([Ve(0,n.ILoggerService),Ve(1,T.IExtHostInitDataService)],L),e.ExtHostLogService=L});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Ie[6],Ce([1,0,16,11,81,28,61,10,9,2,34,36,90,66,25]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h){"use strict";var i,o,l,E,b,g,w,s,r,a,d,c,u,t,m,p,A,N,q,j,V,P,M;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(W){return Object.assign(W,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(W,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(W,[]);{const[ie,...Ee]=arguments;return Reflect.construct(W,Ee,ie.constructor)}}})}var $;(function(W){W.top="top",W.bottom="bottom"})($=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(W){W.command="command",W.opener="opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let K=g=class{static from(...B){let ie=B;return new g(function(){if(ie){for(const Ee of ie)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ie=void 0}})}constructor(B){i.set(this,void 0),Ye(this,i,B,"f")}dispose(){typeof Re(this,i,"f")=="function"&&(Re(this,i,"f").call(this),Ye(this,i,void 0,"f"))}};i=new WeakMap,K=g=qe([F],K),e.Disposable=K;let X=w=class{static Min(...B){if(B.length===0)throw new TypeError;let ie=B[0];for(let Ee=1;Ee<B.length;Ee++){const Ke=B[Ee];Ke.isBefore(ie)&&(ie=Ke)}return ie}static Max(...B){if(B.length===0)throw new TypeError;let ie=B[0];for(let Ee=1;Ee<B.length;Ee++){const Ke=B[Ee];Ke.isAfter(ie)&&(ie=Ke)}return ie}static isPosition(B){if(!B)return!1;if(B instanceof w)return!0;const{line:ie,character:Ee}=B;return typeof ie=="number"&&typeof Ee=="number"}static of(B){if(B instanceof w)return B;if(this.isPosition(B))return new w(B.line,B.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(B,ie){if(B<0)throw(0,T.illegalArgument)("line must be non-negative");if(ie<0)throw(0,T.illegalArgument)("character must be non-negative");this.c=B,this.e=ie}isBefore(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<B.e}isBeforeOrEqual(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<=B.e}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this.c===B.c&&this.e===B.e}compareTo(B){return this.c<B.c?-1:this.c>B.line?1:this.e<B.e?-1:this.e>B.e?1:0}translate(B,ie=0){if(B===null||ie===null)throw(0,T.illegalArgument)();let Ee;return typeof B>"u"?Ee=0:typeof B=="number"?Ee=B:(Ee=typeof B.lineDelta=="number"?B.lineDelta:0,ie=typeof B.characterDelta=="number"?B.characterDelta:0),Ee===0&&ie===0?this:new w(this.line+Ee,this.character+ie)}with(B,ie=this.character){if(B===null||ie===null)throw(0,T.illegalArgument)();let Ee;return typeof B>"u"?Ee=this.line:typeof B=="number"?Ee=B:(Ee=typeof B.line=="number"?B.line:this.line,ie=typeof B.character=="number"?B.character:this.character),Ee===this.line&&ie===this.character?this:new w(Ee,ie)}toJSON(){return{line:this.line,character:this.character}}};X=w=qe([F],X),e.Position=X;let Z=s=class{static isRange(B){return B instanceof s?!0:B?X.isPosition(B.start)&&X.isPosition(B.end):!1}static of(B){if(B instanceof s)return B;if(this.isRange(B))return new s(B.start,B.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(B,ie,Ee,Ke){let _e,ot;if(typeof B=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(_e=new X(B,ie),ot=new X(Ee,Ke)):X.isPosition(B)&&X.isPosition(ie)&&(_e=X.of(B),ot=X.of(ie)),!_e||!ot)throw new Error("Invalid arguments");_e.isBefore(ot)?(this.c=_e,this.e=ot):(this.c=ot,this.e=_e)}contains(B){return s.isRange(B)?this.contains(B.start)&&this.contains(B.end):X.isPosition(B)?!(X.of(B).isBefore(this.c)||this.e.isBefore(B)):!1}isEqual(B){return this.c.isEqual(B.c)&&this.e.isEqual(B.e)}intersection(B){const ie=X.Max(B.start,this.c),Ee=X.Min(B.end,this.e);if(!ie.isAfter(Ee))return new s(ie,Ee)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const ie=X.Min(B.start,this.c),Ee=X.Max(B.end,this.end);return new s(ie,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(B,ie=this.end){if(B===null||ie===null)throw(0,T.illegalArgument)();let Ee;return B?X.isPosition(B)?Ee=B:(Ee=B.start||this.start,ie=B.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&ie.isEqual(this.end)?this:new s(Ee,ie)}toJSON(){return[this.start,this.end]}};Z=s=qe([F],Z),e.Range=Z;let he=r=class extends Z{static isSelection(B){return B instanceof r?!0:B?Z.isRange(B)&&X.isPosition(B.anchor)&&X.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(B,ie,Ee,Ke){let _e,ot;if(typeof B=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(_e=new X(B,ie),ot=new X(Ee,Ke)):X.isPosition(B)&&X.isPosition(ie)&&(_e=X.of(B),ot=X.of(ie)),!_e||!ot)throw new Error("Invalid arguments");super(_e,ot),this.f=_e,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};he=r=qe([F],he),e.Selection=he;class oe{constructor(B,ie,Ee){if(typeof B!="string"||B.length===0)throw(0,T.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,T.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z_\-]+$/.test(Ee)))throw(0,T.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(ie),this.connectionToken=Ee}}e.ResolvedAuthority=oe;class ue extends Error{static NotAvailable(B,ie){return new ue(B,f.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(B){return new ue(B,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(B,ie=f.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(B),this._message=B,this._code=ie,this._detail=Ee,Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var ce;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(ce=e.EndOfLine||(e.EndOfLine={}));var fe;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(fe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Y=a=class{static isTextEdit(B){return B instanceof a?!0:B?Z.isRange(B)&&typeof B.newText=="string":!1}static replace(B,ie){return new a(B,ie)}static insert(B,ie){return a.replace(new Z(B,B),ie)}static delete(B){return a.replace(B,"")}static setEndOfLine(B){const ie=new a(new Z(new X(0,0),new X(0,0)),"");return ie.newEol=B,ie}get range(){return this.c}set range(B){if(B&&!Z.isRange(B))throw(0,T.illegalArgument)("range");this.c=B}get newText(){return this.e||""}set newText(B){if(B&&typeof B!="string")throw(0,T.illegalArgument)("newText");this.e=B}get newEol(){return this.f}set newEol(B){if(B&&typeof B!="number")throw(0,T.illegalArgument)("newEol");this.f=B}constructor(B,ie){this.c=B,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};Y=a=qe([F],Y),e.TextEdit=Y;let ge=d=class{static isNotebookCellEdit(B){return B instanceof d?!0:B?Gt.isNotebookRange(B)&&Array.isArray(B.newCells):!1}static replaceCells(B,ie){return new d(B,ie)}static insertCells(B,ie){return new d(new Gt(B,B),ie)}static deleteCells(B){return new d(B,[])}static updateCellMetadata(B,ie){const Ee=new d(new Gt(B,B),[]);return Ee.newCellMetadata=ie,Ee}static updateNotebookMetadata(B){const ie=new d(new Gt(0,0),[]);return ie.newNotebookMetadata=B,ie}constructor(B,ie){this.range=B,this.newCells=ie}};ge=d=qe([F],ge),e.NotebookEdit=ge;class we{static isSnippetTextEdit(B){return B instanceof we?!0:B?Z.isRange(B.range)&&Qe.isSnippetString(B.snippet):!1}static replace(B,ie){return new we(B,ie)}static insert(B,ie){return we.replace(new Z(B,B),ie)}constructor(B,ie){this.range=B,this.snippet=ie}}e.SnippetTextEdit=we;var Me;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(Me=e.FileEditType||(e.FileEditType={}));let We=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(B,ie,Ee,Ke){this.c.push({_type:1,from:B,to:ie,options:Ee,metadata:Ke})}createFile(B,ie,Ee){this.c.push({_type:1,from:void 0,to:B,options:ie,metadata:Ee})}deleteFile(B,ie,Ee){this.c.push({_type:1,from:B,to:void 0,options:ie,metadata:Ee})}e(B,ie,Ee){this.c.push({_type:3,metadata:Ee,uri:B,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(B,ie,Ee,Ke){const _e=ie.start,ot=ie.end;(_e!==ot||Ee.length>0)&&this.c.push({_type:5,uri:B,index:_e,count:ot-_e,cells:Ee,metadata:Ke})}g(B,ie,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:B,edit:{editType:8,index:ie,metadata:Ee}})}replace(B,ie,Ee,Ke){this.c.push({_type:2,uri:B,edit:new Y(ie,Ee),metadata:Ke})}insert(B,ie,Ee,Ke){this.replace(B,new Z(ie,ie),Ee,Ke)}delete(B,ie,Ee){this.replace(B,ie,"",Ee)}has(B){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===B.toString())}set(B,ie){if(ie)for(const Ee of ie){if(!Ee)continue;let Ke,_e;Array.isArray(Ee)?(Ke=Ee[0],_e=Ee[1]):Ke=Ee,ge.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(B,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(B,Ke.newNotebookMetadata,_e):this.f(B,Ke.range,Ke.newCells,_e):we.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:B,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:B,edit:Ke,metadata:_e})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===B.toString()&&(this.c[Ee]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(B){const ie=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===B.toString()&&ie.push(Ee.edit);return ie}entries(){const B=new L.ResourceMap;for(const ie of this.c)if(ie._type===2){let Ee=B.get(ie.uri);Ee||(Ee=[ie.uri,[]],B.set(ie.uri,Ee)),Ee[1].push(ie.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};We=qe([F],We),e.WorkspaceEdit=We;let Qe=c=class{static isSnippetString(B){return B instanceof c?!0:B?typeof B.value=="string":!1}static c(B){return B.replace(/\$|}|\\/g,"\\$&")}constructor(B){this.e=1,this.value=B||""}appendText(B){return this.value+=c.c(B),this}appendTabstop(B=this.e++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,ie=this.e++){if(typeof B=="function"){const Ee=new c;Ee.e=this.e,B(Ee),this.e=Ee.e,B=Ee.value}else B=c.c(B);return this.value+="${",this.value+=ie,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,ie=this.e++){const Ee=B.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(B,ie){if(typeof ie=="function"){const Ee=new c;Ee.e=this.e,ie(Ee),this.e=Ee.e,ie=Ee.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Qe=c=qe([F],Qe),e.SnippetString=Qe;var Te;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var De;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(De=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=u=class{static isLocation(B){return B instanceof u?!0:B?Z.isRange(B.range)&&k.URI.isUri(B.uri):!1}constructor(B,ie){if(this.uri=B,ie)if(Z.isRange(ie))this.range=Z.of(ie);else if(X.isPosition(ie))this.range=new Z(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=u=qe([F],ke),e.Location=ke;let re=class{static is(B){return B?typeof B.message=="string"&&B.location&&Z.isRange(B.location.range)&&k.URI.isUri(B.location.uri):!1}constructor(B,ie){this.location=B,this.message=ie}static isEqual(B,ie){return B===ie?!0:!B||!ie?!1:B.message===ie.message&&B.location.range.isEqual(ie.location.range)&&B.location.uri.toString()===ie.location.uri.toString()}};re=qe([F],re),e.DiagnosticRelatedInformation=re;let ae=class{constructor(B,ie,Ee=De.Error){if(!Z.isRange(B))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=B,this.message=ie,this.severity=Ee}toJSON(){return{severity:De[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,ie){return B===ie?!0:!B||!ie?!1:B.message===ie.message&&B.severity===ie.severity&&B.code===ie.code&&B.severity===ie.severity&&B.source===ie.source&&B.range.isEqual(ie.range)&&(0,n.equals)(B.tags,ie.tags)&&(0,n.equals)(B.relatedInformation,ie.relatedInformation,re.isEqual)}};ae=qe([F],ae),e.Diagnostic=ae;let J=class{constructor(B,ie){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=ie}};J=qe([F],J),e.Hover=J;var I;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let U=class{constructor(B,ie=I.Text){this.range=B,this.kind=ie}toJSON(){return{range:this.range,kind:I[this.kind]}}};U=qe([F],U),e.DocumentHighlight=U;var H;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(H=e.SymbolKind||(e.SymbolKind={}));var G;(function(W){W[W.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ee=t=class{static validate(B){if(!B.name)throw new Error("name must not be falsy")}constructor(B,ie,Ee,Ke,_e){this.name=B,this.kind=ie,this.containerName=_e,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof ke?this.location=Ke:Ee instanceof Z&&(this.location=new ke(Ke,Ee)),t.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};ee=t=qe([F],ee),e.SymbolInformation=ee;let le=m=class{static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children?.forEach(m.validate)}constructor(B,ie,Ee,Ke,_e){this.name=B,this.detail=ie,this.kind=Ee,this.range=Ke,this.selectionRange=_e,this.children=[],m.validate(this)}};le=m=qe([F],le),e.DocumentSymbol=le;var Se;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(Se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(B,ie){this.title=B,this.kind=ie}};se=qe([F],se),e.CodeAction=se;let ve=p=class{constructor(B){this.value=B}append(B){return new p(this.value?this.value+p.c+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+p.c)}};ve.c=".",ve=p=qe([F],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let be=class{constructor(B,ie){if(this.range=B,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=qe([F],be),e.SelectionRange=be;class $e{constructor(B,ie,Ee,Ke,_e,ot){this.kind=B,this.name=ie,this.detail=Ee,this.uri=Ke,this.range=_e,this.selectionRange=ot}}e.CallHierarchyItem=$e;class He{constructor(B,ie){this.fromRanges=ie,this.from=B}}e.CallHierarchyIncomingCall=He;class tt{constructor(B,ie){this.fromRanges=ie,this.to=B}}e.CallHierarchyOutgoingCall=tt;var xe;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(B,ie){this.range=B,this.command=ie}get isResolved(){return!!this.command}};et=qe([F],et),e.CodeLens=et;let it=A=class{static isMarkdownString(B){return B instanceof A?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}constructor(B,ie=!1){o.set(this,void 0),Ye(this,o,new y.MarkdownString(B,{supportThemeIcons:ie}),"f")}get value(){return Re(this,o,"f").value}set value(B){Re(this,o,"f").value=B}get isTrusted(){return Re(this,o,"f").isTrusted}set isTrusted(B){Re(this,o,"f").isTrusted=B}get supportThemeIcons(){return Re(this,o,"f").supportThemeIcons}set supportThemeIcons(B){Re(this,o,"f").supportThemeIcons=B}get supportHtml(){return Re(this,o,"f").supportHtml}set supportHtml(B){Re(this,o,"f").supportHtml=B}get baseUri(){return Re(this,o,"f").baseUri}set baseUri(B){Re(this,o,"f").baseUri=B}appendText(B){return Re(this,o,"f").appendText(B),this}appendMarkdown(B){return Re(this,o,"f").appendMarkdown(B),this}appendCodeblock(B,ie){return Re(this,o,"f").appendCodeblock(ie??"",B),this}};o=new WeakMap,it=A=qe([F],it),e.MarkdownString=it;let dt=class{constructor(B,ie){this.label=B,this.documentation=ie}};dt=qe([F],dt),e.ParameterInformation=dt;let Fe=class{constructor(B,ie){this.label=B,this.documentation=ie,this.parameters=[]}};Fe=qe([F],Fe),e.SignatureInformation=Fe;let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};st=qe([F],st),e.SignatureHelp=st;var _;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(_=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let pe=class{constructor(B){this.value=B}};pe=qe([F],pe),e.InlayHintLabelPart=pe;let Ne=class{constructor(B,ie,Ee){this.position=B,this.label=ie,this.kind=Ee}};Ne=qe([F],Ne),e.InlayHint=Ne;var Be;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var Je;(function(W){W[W.Deprecated=1]="Deprecated"})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(B,ie){this.label=B,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([F],nt),e.CompletionItem=nt;let vt=class{constructor(B=[],ie=!1){this.items=B,this.isIncomplete=ie}};vt=qe([F],vt),e.CompletionList=vt;let wt=class{constructor(B,ie,Ee){this.insertText=B,this.range=ie,this.command=Ee}};wt=qe([F],wt),e.InlineSuggestion=wt;let Tt=class{constructor(B){this.commands=void 0,this.items=B}};Tt=qe([F],Tt),e.InlineSuggestionList=Tt;var lt;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var at;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ut;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(Ut=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ft;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Mt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Mt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ct;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(Ct=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function B(ie){switch(ie){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=B}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(B,ie){if(ie&&!k.URI.isUri(ie))throw(0,T.illegalArgument)("target");if(!Z.isRange(B)||B.isEmpty)throw(0,T.illegalArgument)("range");this.range=B,this.target=ie}};Nt=qe([F],Nt),e.DocumentLink=Nt;let Ge=class{constructor(B,ie,Ee,Ke){this.red=B,this.green=ie,this.blue=Ee,this.alpha=Ke}};Ge=qe([F],Ge),e.Color=Ge;let Rt=class{constructor(B,ie){if(ie&&!(ie instanceof Ge))throw(0,T.illegalArgument)("color");if(!Z.isRange(B)||B.isEmpty)throw(0,T.illegalArgument)("range");this.range=B,this.color=ie}};Rt=qe([F],Rt),e.ColorInformation=Rt;let Lt=class{constructor(B){if(!B||typeof B!="string")throw(0,T.illegalArgument)("label");this.label=B}};Lt=qe([F],Lt),e.ColorPresentation=Lt;var Ht;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ht=e.ColorFormat||(e.ColorFormat={}));var mt;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(mt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var At;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(At=e.TerminalExitReason||(e.TerminalExitReason={}));class ye{constructor(B,ie,Ee){if(this.startIndex=B,this.length=ie,this.tooltip=Ee,typeof B!="number"||B<0)throw(0,T.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,T.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=ye;var Pe;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(Pe=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(B){if(this.options=B,typeof B!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=me;var x;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(x=e.TaskRevealKind||(e.TaskRevealKind={}));var Ae;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(Ae=e.TaskPanelKind||(e.TaskPanelKind={}));let Le=N=class{static from(B){switch(B){case"clean":return N.Clean;case"build":return N.Build;case"rebuild":return N.Rebuild;case"test":return N.Test;default:return}}constructor(B,ie){if(this.label=ie,typeof B!="string"||typeof ie!="string")throw(0,T.illegalArgument)("name");this.c=B}get id(){return this.c}};Le.Clean=new N("clean","Clean"),Le.Build=new N("build","Build"),Le.Rebuild=new N("rebuild","Rebuild"),Le.Test=new N("test","Test"),Le=N=qe([F],Le),e.TaskGroup=Le;function Xe(W){let B="";for(let ie=0;ie<W.length;ie++)B+=W[ie].replace(/,/g,",,")+",";return B}let ze=class{constructor(B,ie,Ee){if(typeof B!="string")throw(0,T.illegalArgument)("process");this.e=[],this.c=B,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=Ee):this.f=ie)}get process(){return this.c}set process(B){if(typeof B!="string")throw(0,T.illegalArgument)("process");this.c=B}get args(){return this.e}set args(B){Array.isArray(B)||(B=[]),this.e=B}get options(){return this.f}set options(B){this.f=B}computeId(){const B=[];if(B.push("process"),this.c!==void 0&&B.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)B.push(ie);return Xe(B)}};ze=qe([F],ze),e.ProcessExecution=ze;let Ze=class{constructor(B,ie,Ee){if(this.f=[],Array.isArray(ie)){if(!B)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,T.illegalArgument)("command");this.e=B,this.f=ie,this.g=Ee}else{if(typeof B!="string")throw(0,T.illegalArgument)("commandLine");this.c=B,this.g=ie}}get commandLine(){return this.c}set commandLine(B){if(typeof B!="string")throw(0,T.illegalArgument)("commandLine");this.c=B}get command(){return this.e?this.e:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,T.illegalArgument)("command");this.e=B}get args(){return this.f}set args(B){this.f=B||[]}get options(){return this.g}set options(B){this.g=B}computeId(){const B=[];if(B.push("shell"),this.c!==void 0&&B.push(this.c),this.e!==void 0&&B.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)B.push(typeof ie=="string"?ie:ie.value);return Xe(B)}};Ze=qe([F],Ze),e.ShellExecution=Ze;var It;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class kt{constructor(B){this.c=B}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(B){this.c=B}get callback(){return this.c}}e.CustomExecution=kt;let gt=q=class{constructor(B,ie,Ee,Ke,_e,ot){this.j=!1,this.k=this.definition=B;let ut;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=Ee,this.execution=Ke,ut=_e,this.j=!0):ie===bt.Global||ie===bt.Workspace?(this.target=ie,this.m=this.name=Ee,this.t=this.source=Ke,this.execution=_e,ut=ot):(this.target=ie,this.m=this.name=Ee,this.t=this.source=Ke,this.execution=_e,ut=ot),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(B){this.h=B}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ze?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof Ze?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof kt?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(B){if(B==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=B}get scope(){return this.l}set target(B){this.y(),this.l=B}get name(){return this.m}set name(B){if(typeof B!="string")throw(0,T.illegalArgument)("name");this.y(),this.m=B}get execution(){return this.n}set execution(B){B===null&&(B=void 0),this.y(),this.n=B;const ie=this.k.type;(q.g===ie||q.e===ie||q.f===ie||q.c===ie)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(B){if(Array.isArray(B))this.y(),this.o=B,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.y(),this.r=B}get source(){return this.t}set source(B){if(typeof B!="string"||B.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.y(),this.t=B}get group(){return this.u}set group(B){B===null&&(B=void 0),this.y(),this.u=B}get detail(){return this.x}set detail(B){B===null&&(B=void 0),this.x=B}get presentationOptions(){return this.v}set presentationOptions(B){B==null&&(B=Object.create(null)),this.y(),this.v=B}get runOptions(){return this.w}set runOptions(B){B==null&&(B=Object.create(null)),this.y(),this.w=B}};gt.c="customExecution",gt.e="process",gt.f="shell",gt.g="$empty",gt=q=qe([F],gt),e.Task=gt;var pt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(pt=e.ProgressLocation||(e.ProgressLocation={}));var St;(function(W){function B(ie){const Ee=ie;return(0,S.isNumber)(Ee.value)?Ee.tooltip&&!(0,S.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}W.isViewBadge=B})(St=e.ViewBadge||(e.ViewBadge={}));let $t=j=class{static isTreeItem(B,ie){if(B instanceof j)return!0;const Ee=B;if(Ee.label!==void 0&&!(0,S.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,S.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,S.isString)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,S.isString)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}if(Ee.description!==void 0&&!(0,S.isString)(Ee.description)&&typeof Ee.description!="boolean")return console.log("INVALID tree item, invalid description",Ee.description),!1;if(Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1;if(Ee.tooltip!==void 0&&!(0,S.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1;if(Ee.command!==void 0&&!Ee.command.command)return console.log("INVALID tree item, invalid command",Ee.command),!1;if(Ee.collapsibleState!==void 0&&Ee.collapsibleState<Xt.None&&Ee.collapsibleState>Xt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1;if(Ee.contextValue!==void 0&&!(0,S.isString)(Ee.contextValue))return console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1;if(Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1;if(Ee.checkboxState!==void 0){(0,h.checkProposedApiEnabled)(ie,"treeItemCheckbox");const Ke=(0,S.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,S.isObject)(Ee.checkboxState)&&(0,S.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,_e=!(0,S.isNumber)(Ee.checkboxState)&&(0,S.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Et.Checked&&Ke!==Et.Unchecked||_e!==void 0&&!(0,S.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}return!0}constructor(B,ie=Xt.None){this.collapsibleState=ie,k.URI.isUri(B)?this.resourceUri=B:this.label=B}};$t=j=qe([F],$t),e.TreeItem=$t;var Xt;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Xt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Et;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(Et=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let si=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(B,ie){this.value=B,this.id=ie??(0,O.generateUuid)()}};si=qe([F],si),e.DataTransferItem=si;let oi=class{constructor(B){l.set(this,new Map);for(const[ie,Ee]of B??[]){const Ke=Re(this,l,"f").get(ie);Ke?Ke.push(Ee):Re(this,l,"f").set(ie,[Ee])}}get(B){return Re(this,l,"f").get(B)?.[0]}set(B,ie){Re(this,l,"f").set(B,[ie])}forEach(B,ie){for(const[Ee,Ke]of Re(this,l,"f"))for(const _e of Ke)B.call(ie,_e,Ee,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[B,ie]of Re(this,l,"f"))for(const Ee of ie)yield[B,Ee]}};oi=qe([F],oi),e.DataTransfer=oi;let Zt=class{constructor(B){this.insertText=B}};Zt=qe([F],Zt),e.DocumentDropEdit=Zt;let pi=class{constructor(B){this.insertText=B}};pi=qe([F],pi),e.DocumentPasteEdit=pi;let yt=class{constructor(B,ie){this.id=B,this.color=ie}static isThemeIcon(B){return typeof B.id!="string"?(console.log("INVALID ThemeIcon, invalid id",B.id),!1):!0}};yt=qe([F],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let ai=class{constructor(B){this.id=B}};ai=qe([F],ai),e.ThemeColor=ai;var Oi;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(Oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(B){this.c=B,this.e=k.URI.file(B)}get baseUri(){return this.e}set baseUri(B){this.e=B,this.c=B.fsPath}constructor(B,ie){if(typeof B!="string"&&(!B||!k.URI.isUri(B)&&!k.URI.isUri(B.uri)))throw(0,T.illegalArgument)("base");if(typeof ie!="string")throw(0,T.illegalArgument)("pattern");typeof B=="string"?this.baseUri=k.URI.file(B):k.URI.isUri(B)?this.baseUri=B:this.baseUri=B.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([F],ei),e.RelativePattern=ei;let Vt=class{constructor(B,ie,Ee,Ke){this.enabled=typeof B=="boolean"?B:!0,typeof ie=="string"&&(this.condition=ie),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,O.generateUuid)()),this.c}};Vt=qe([F],Vt),e.Breakpoint=Vt;let ct=class extends Vt{constructor(B,ie,Ee,Ke,_e){if(super(ie,Ee,Ke,_e),B===null)throw(0,T.illegalArgument)("location");this.location=B}};ct=qe([F],ct),e.SourceBreakpoint=ct;let vi=class extends Vt{constructor(B,ie,Ee,Ke,_e){super(ie,Ee,Ke,_e),this.functionName=B}};vi=qe([F],vi),e.FunctionBreakpoint=vi;let jt=class extends Vt{constructor(B,ie,Ee,Ke,_e,ot,ut){if(super(Ke,_e,ot,ut),!ie)throw(0,T.illegalArgument)("dataId");this.label=B,this.dataId=ie,this.canPersist=Ee}};jt=qe([F],jt),e.DataBreakpoint=jt;let Qt=class{constructor(B,ie,Ee){this.command=B,this.args=ie||[],this.options=Ee}};Qt=qe([F],Qt),e.DebugAdapterExecutable=Qt;let ci=class{constructor(B,ie){this.port=B,this.host=ie}};ci=qe([F],ci),e.DebugAdapterServer=ci;let bi=class{constructor(B){this.path=B}};bi=qe([F],bi),e.DebugAdapterNamedPipeServer=bi;let ui=class{constructor(B){this.implementation=B}};ui=qe([F],ui),e.DebugAdapterInlineImplementation=ui;let Ei=class{constructor(B,ie){this.range=B,this.expression=ie}};Ei=qe([F],Ei),e.EvaluatableExpression=Ei;var Ci;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(Ci=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(B,ie){this.range=B,this.text=ie}};ti=qe([F],ti),e.InlineValueText=ti;let wi=class{constructor(B,ie,Ee=!0){this.range=B,this.variableName=ie,this.caseSensitiveLookup=Ee}};wi=qe([F],wi),e.InlineValueVariableLookup=wi;let ni=class{constructor(B,ie){this.range=B,this.expression=ie}};ni=qe([F],ni),e.InlineValueEvaluatableExpression=ni;let ri=class{constructor(B,ie){this.frameId=B,this.stoppedLocation=ie}};ri=qe([F],ri),e.InlineValueContext=ri;var Fi;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Fi=e.FileChangeType||(e.FileChangeType={}));let Si=V=class extends Error{static FileExists(B){return new V(B,D.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(B){return new V(B,D.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(B){return new V(B,D.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(B){return new V(B,D.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(B){return new V(B,D.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(B){return new V(B,D.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(B,ie=D.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(B)?B.toString(!0):B),this.code=Ee?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};Si=V=qe([F],Si),e.FileSystemError=Si;let _t=class{constructor(B,ie,Ee){this.start=B,this.end=ie,this.kind=Ee}};_t=qe([F],_t),e.FoldingRange=_t;var Mi;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Mi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ni;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Ni=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Li;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(Li=e.CommentMode||(e.CommentMode={}));var Ui;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(Ui=e.CommentThreadState||(e.CommentThreadState={}));class Bi{constructor(B,ie=[]){this.tokenTypes=B,this.tokenModifiers=ie}}e.SemanticTokensLegend=Bi;function yi(W){return typeof W>"u"||(0,S.isStringArray)(W)}class li{constructor(B){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,B){this.l=!0;for(let ie=0,Ee=B.tokenTypes.length;ie<Ee;ie++)this.j.set(B.tokenTypes[ie],ie);for(let ie=0,Ee=B.tokenModifiers.length;ie<Ee;ie++)this.k.set(B.tokenModifiers[ie],ie)}}push(B,ie,Ee,Ke,_e){if(typeof B=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(B,ie,Ee,Ke,_e);if(Z.isRange(B)&&typeof ie=="string"&&yi(Ee))return this.m(B,ie,Ee);throw(0,T.illegalArgument)()}m(B,ie,Ee){if(!this.l)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ke=B.start.line,_e=B.start.character,ot=B.end.character-B.start.character,ut=this.j.get(ie);let Ot=0;if(Ee)for(const Wt of Ee){if(!this.k.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Wt);Ot|=1<<qt>>>0}this.n(Ke,_e,ot,ut,Ot)}n(B,ie,Ee,Ke,_e){if(this.f&&(B<this.c||B===this.c&&ie<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Wt=0,qt=0;for(let xt=0;xt<Ot;xt++){let Yt=this.g[5*xt],Di=this.g[5*xt+1];Yt===0?(Yt=Wt,Di+=qt):Yt+=Wt,this.g[5*xt]=Yt,this.g[5*xt+1]=Di,Wt=Yt,qt=Di}}let ot=B,ut=ie;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ut-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ut,this.g[this.h++]=Ee,this.g[this.h++]=Ke,this.g[this.h++]=_e,this.c=B,this.e=ie}static o(B){const ie=[],Ee=B.length/5|0;for(let ut=0;ut<Ee;ut++)ie[ut]=ut;ie.sort((ut,Ot)=>{const Wt=B[5*ut],qt=B[5*Ot];if(Wt===qt){const xt=B[5*ut+1],Yt=B[5*Ot+1];return xt-Yt}return Wt-qt});const Ke=new Uint32Array(B.length);let _e=0,ot=0;for(let ut=0;ut<Ee;ut++){const Ot=5*ie[ut],Wt=B[Ot+0],qt=B[Ot+1],xt=B[Ot+2],Yt=B[Ot+3],Di=B[Ot+4],en=Wt-_e,Cn=en===0?qt-ot:qt,Ii=5*ut;Ke[Ii+0]=en,Ke[Ii+1]=Cn,Ke[Ii+2]=xt,Ke[Ii+3]=Yt,Ke[Ii+4]=Di,_e=Wt,ot=qt}return Ke}build(B){return this.f?new di(new Uint32Array(this.g),B):new di(li.o(this.g),B)}}e.SemanticTokensBuilder=li;class di{constructor(B,ie){this.resultId=ie,this.data=B}}e.SemanticTokens=di;class Ue{constructor(B,ie,Ee){this.start=B,this.deleteCount=ie,this.data=Ee}}e.SemanticTokensEdit=Ue;class Kt{constructor(B,ie){this.resultId=ie,this.edits=B}}e.SemanticTokensEdits=Kt;var ki;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(ki=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ht=class{constructor(){}};ht.Back={iconPath:new yt("arrow-left")},ht=qe([F],ht),e.QuickInputButtons=ht;var $i;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})($i=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(zi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ti;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(Ti=e.ExtensionKind||(e.ExtensionKind={}));class Wi{static validate(B){if(typeof B.badge=="string"){let ie=(0,R.nextCharLength)(B.badge,0);if(ie<B.badge.length&&(ie+=(0,R.nextCharLength)(B.badge,ie)),B.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(B.badge&&!yt.isThemeIcon(B.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty");return!0}constructor(B,ie,Ee){this.badge=B,this.tooltip=ie,this.color=Ee}}e.FileDecoration=Wi;let ii=class{constructor(B){this.kind=B}};ii=qe([F],ii),e.ColorTheme=ii;var Hi;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(Hi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(B){return B instanceof Gt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(B,ie){if(B<0)throw(0,T.illegalArgument)("start must be positive");if(ie<0)throw(0,T.illegalArgument)("end must be positive");B<=ie?(this.c=B,this.e=ie):(this.c=ie,this.e=B)}with(B){let ie=this.c,Ee=this.e;return B.start!==void 0&&(ie=B.start),B.end!==void 0&&(Ee=B.end),ie===this.c&&Ee===this.e?this:new Gt(ie,Ee)}}e.NotebookRange=Gt;class hi{static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(ie=>hi.isNotebookCellData(ie))}static isNotebookCellData(B){return!0}constructor(B,ie,Ee,Ke,_e,ot,ut){this.kind=B,this.value=ie,this.languageId=Ee,this.mime=Ke,this.outputs=_e??[],this.metadata=ot,this.executionSummary=ut,hi.validate(this)}}e.NotebookCellData=hi;class Pi{constructor(B){this.cells=B}}e.NotebookData=Pi;class zt{static isNotebookCellOutputItem(B){return B instanceof zt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const ie={name:B.name,message:B.message,stack:B.stack};return zt.json(ie,"application/vnd.code.notebook.error")}static stdout(B){return zt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return zt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,ie="application/octet-stream"){return new zt(B,ie)}static text(B,ie=C.Mimes.text){const Ee=Re(zt,E,"f",b).encode(String(B));return new zt(Ee,ie)}static json(B,ie="text/x-json"){const Ee=JSON.stringify(B,void 0,"	");return zt.text(Ee,ie)}constructor(B,ie){this.data=B,this.mime=ie;const Ee=(0,C.normalizeMimeType)(ie,!0);if(!Ee)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.NotebookCellOutputItem=zt,E=zt,b={value:new TextEncoder};class fi{static isNotebookCellOutput(B){return B instanceof fi?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&Array.isArray(B.items)}static ensureUniqueMimeTypes(B,ie=!1){const Ee=new Set,Ke=new Set;for(let _e=0;_e<B.length;_e++){const ot=B[_e],ut=(0,C.normalizeMimeType)(ot.mime);if(!Ee.has(ut)||(0,v.isTextStreamMime)(ut)){Ee.add(ut);continue}Ke.add(_e),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?B:B.filter((_e,ot)=>!Ke.has(ot))}constructor(B,ie,Ee){this.items=fi.ensureUniqueMimeTypes(B,!0),typeof ie=="string"?(this.id=ie,this.metadata=Ee):(this.id=(0,O.generateUuid)(),this.metadata=ie??Ee)}}e.NotebookCellOutput=fi;var Vi;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(Vi=e.NotebookCellKind||(e.NotebookCellKind={}));var ji;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(ji=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var qi;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(qi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ki;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ki=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ne{constructor(B,ie){this.text=B,this.alignment=ie}}e.NotebookCellStatusBarItem=ne;var de;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(de=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Oe;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(Oe=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rt{constructor(B,ie=[]){this.uri=B,this.provides=(0,n.asArray)(ie)}}e.NotebookRendererScript=rt;class Dt{constructor(B){this.label=B}}e.NotebookKernelSourceAction=Dt;let Pt=class{constructor(B,ie){this.label=B,this.timestamp=ie}};Pt=qe([F],Pt),e.TimelineItem=Pt;var sn;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(sn=e.ExtensionMode||(e.ExtensionMode={}));var on;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(on=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class cn{constructor(B,ie){this.ranges=B,this.wordPattern=ie}}e.LinkedEditingRanges=cn;class un{constructor(B,ie){this.c=B,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=un;var ln;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(ln=e.TestResultState||(e.TestResultState={}));var dn;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(dn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Gi=class{constructor(B=void 0,ie=void 0,Ee=void 0){this.include=B,this.exclude=ie,this.profile=Ee}};Gi=qe([F],Gi),e.TestRunRequest=Gi;let xi=P=class{static diff(B,ie,Ee){const Ke=new P(B);return Ke.expectedOutput=ie,Ke.actualOutput=Ee,Ke}constructor(B){this.message=B}};xi=P=qe([F],xi),e.TestMessage=xi;let Xi=class{constructor(B){this.id=B}};Xi=qe([F],Xi),e.TestTag=Xi;let mi=class{constructor(B,ie){this.covered=B,this.total=ie}};mi=qe([F],mi),e.CoveredCount=mi;let Qi=M=class{static fromDetails(B,ie){const Ee=new mi(0,0),Ke=new mi(0,0),_e=new mi(0,0);for(const ut of ie)if("branches"in ut){Ee.total+=1,Ee.covered+=ut.executionCount>0?1:0;for(const Ot of ut.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else _e.total+=1,_e.covered+=ut.executionCount>0?1:0;const ot=new M(B,Ee,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return ot.detailedCoverage=ie,ot}constructor(B,ie,Ee,Ke){this.uri=B,this.statementCoverage=ie,this.branchCoverage=Ee,this.functionCoverage=Ke}};Qi=M=qe([F],Qi),e.FileCoverage=Qi;let _i=class{constructor(B,ie,Ee=[]){this.executionCount=B,this.location=ie,this.branches=Ee}};_i=qe([F],_i),e.StatementCoverage=_i;let Yi=class{constructor(B,ie){this.executionCount=B,this.location=ie}};Yi=qe([F],Yi),e.BranchCoverage=Yi;let Ji=class{constructor(B,ie){this.executionCount=B,this.location=ie}};Ji=qe([F],Ji),e.FunctionCoverage=Ji;var hn;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mn;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gn{constructor(B,ie,Ee,Ke,_e,ot){this.kind=B,this.name=ie,this.detail=Ee,this.uri=Ke,this.range=_e,this.selectionRange=ot}}e.TypeHierarchyItem=gn;class pn{constructor(B){this.uri=B}}e.TextTabInput=pn;class vn{constructor(B,ie){this.original=B,this.modified=ie}}e.TextDiffTabInput=vn;class bn{constructor(B,ie,Ee,Ke){this.base=B,this.input1=ie,this.input2=Ee,this.result=Ke}}e.TextMergeTabInput=bn;class En{constructor(B,ie){this.uri=B,this.viewType=ie}}e.CustomEditorTabInput=En;class wn{constructor(B){this.viewType=B}}e.WebviewEditorTabInput=wn;class Sn{constructor(B,ie){this.uri=B,this.notebookType=ie}}e.NotebookEditorTabInput=Sn;class yn{constructor(B,ie,Ee){this.original=B,this.modified=ie,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=yn;class Dn{constructor(){}}e.TerminalEditorTabInput=Dn;class In{constructor(B,ie){this.uri=B,this.inputBoxUri=ie}}e.InteractiveWindowInput=In}),define(Ie[95],Ce([1,0,47,13,10,249,125,6,16]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function O(h,i){i?k.set(h,i):k.delete(h)}e.setWordDefinitionFor=O;function D(h){return k.get(h)}class f extends L.MirrorTextModel{constructor(i,o,l,E,b,g,w,s){super(o,l,E,b),this.m=i,this.p=g,this.q=w,this.notebook=s,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(i){return(0,S.equals)(this.d,i)}get document(){if(!this.a){const i=this;this.a={get uri(){return i.c},get fileName(){return i.c.fsPath},get isUntitled(){return i.c.scheme===T.Schemas.untitled},get languageId(){return i.p},get version(){return i.g},get isClosed(){return i.b},get isDirty(){return i.q},save(){return i.r()},getText(o){return o?i.s(o):i.getText()},get eol(){return i.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return i.d.length},lineAt(o){return i.t(o)},offsetAt(o){return i.u(o)},positionAt(o){return i.v(o)},validateRange(o){return i.w(o)},validatePosition(o){return i.x(o)},getWordRangeAtPosition(o,l){return i.y(o,l)}}}return Object.freeze(this.a)}_acceptLanguageId(i){(0,n.ok)(!this.b),this.p=i}_acceptIsDirty(i){(0,n.ok)(!this.b),this.q=i}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(i){const o=this.w(i);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const l=this.f,E=o.start.line,b=o.end.line,g=[];g.push(this.d[E].substring(o.start.character));for(let w=E+1;w<b;w++)g.push(this.d[w]);return g.push(this.d[b].substring(0,o.end.character)),g.join(l)}t(i){let o;if(i instanceof R.Position?o=i.line:typeof i=="number"&&(o=i),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.d[o],o===this.d.length-1)}u(i){return i=this.x(i),this.k(),this.h.getPrefixSum(i.line-1)+i.character}v(i){i=Math.floor(i),i=Math.max(0,i),this.k();const o=this.h.getIndexOf(i),l=this.d[o.index].length;return new R.Position(o.index,Math.min(o.remainder,l))}w(i){if(!(i instanceof R.Range))throw new Error("Invalid argument");const o=this.x(i.start),l=this.x(i.end);return o===i.start&&l===i.end?i:new R.Range(o.line,o.character,l.line,l.character)}x(i){if(!(i instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return i.with(0,0);let{line:o,character:l}=i,E=!1;if(o<0)o=0,l=0,E=!0;else if(o>=this.d.length)o=this.d.length-1,l=this.d[o].length,E=!0;else{const b=this.d[o].length;l<0?(l=0,E=!0):l>b&&(l=b,E=!0)}return E?new R.Position(o,l):i}y(i,o){const l=this.x(i);if(!o)o=D(this.p);else if((0,y.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const E=(0,C.getWordAtText)(l.character+1,(0,C.ensureValidWordDefinition)(o),this.d[l.line],0);if(E)return new R.Range(l.line,E.startColumn-1,l.line,E.endColumn-1)}}e.ExtHostDocumentData=f;class v{constructor(i,o,l){this.a=i,this.b=o,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=v}),define(Ie[183],Ce([1,0,6,14,5]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(R){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new y.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let S;switch(R){case"light":S=n.ColorThemeKind.Light;break;case"hcDark":S=n.ColorThemeKind.HighContrast;break;case"hcLight":S=n.ColorThemeKind.HighContrastLight;break;default:S=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};L=qe([Ve(0,T.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(Ie[8],Ce([1,0,16,24,111,184,81,28,108,80,61,23,9,2,54,71,86,93,92,66,42,53,178,6]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b,g,w,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ye){function Pe(x){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:Xe,positionColumn:ze}=x,Ze=new r.Position(Ae-1,Le-1),It=new r.Position(Xe-1,ze-1);return new r.Selection(Ze,It)}ye.to=Pe;function me(x){const{anchor:Ae,active:Le}=x;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ye.from=me})(a=e.Selection||(e.Selection={}));var d;(function(ye){function Pe(x){if(!x)return;const{start:Ae,end:Le}=x;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ye.from=Pe;function me(x){if(!x)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:Xe,endColumn:ze}=x;return new r.Range(Ae-1,Le-1,Xe-1,ze-1)}ye.to=me})(d=e.Range||(e.Range={}));var c;(function(ye){function Pe(me){switch(me){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}ye.to=Pe})(c=e.TokenType||(e.TokenType={}));var u;(function(ye){function Pe(x){return new r.Position(x.lineNumber-1,x.column-1)}ye.to=Pe;function me(x){return{lineNumber:x.line+1,column:x.character+1}}ye.from=me})(u=e.Position||(e.Position={}));var t;(function(ye){function Pe(Ae,Le){return(0,n.coalesce)((0,n.asArray)(Ae).map(Xe=>me(Xe,Le)))}ye.from=Pe;function me(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:x(Ae.scheme,Le),pattern:Q.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function x(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(t=e.DocumentSelector||(e.DocumentSelector={}));var m;(function(ye){function Pe(x){switch(x){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}ye.from=Pe;function me(x){switch(x){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}ye.to=me})(m=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(ye){function Pe(x){let Ae;return x.code&&((0,f.isString)(x.code)||(0,f.isNumber)(x.code)?Ae=String(x.code):Ae={value:String(x.code.value),target:x.code.target}),{...d.from(x.range),message:x.message,source:x.source,code:Ae,severity:N.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(A.from),tags:Array.isArray(x.tags)?(0,n.coalesce)(x.tags.map(m.from)):void 0}}ye.from=Pe;function me(x){const Ae=new r.Diagnostic(d.to(x),x.message,N.to(x.severity));return Ae.source=x.source,Ae.code=(0,f.isString)(x.code)?x.code:x.code?.value,Ae.relatedInformation=x.relatedInformation&&x.relatedInformation.map(A.to),Ae.tags=x.tags&&(0,n.coalesce)(x.tags.map(m.to)),Ae}ye.to=me})(p=e.Diagnostic||(e.Diagnostic={}));var A;(function(ye){function Pe(x){return{...d.from(x.location.range),message:x.message,resource:x.location.uri}}ye.from=Pe;function me(x){return new r.DiagnosticRelatedInformation(new r.Location(x.resource,d.to(x)),x.message)}ye.to=me})(A=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var N;(function(ye){function Pe(x){switch(x){case r.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}ye.from=Pe;function me(x){switch(x){case o.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}ye.to=me})(N=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var q;(function(ye){function Pe(x){return typeof x=="number"&&x>=r.ViewColumn.One?x-1:x===r.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}ye.from=Pe;function me(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=me})(q=e.ViewColumn||(e.ViewColumn={}));function j(ye){return typeof ye.range<"u"}function V(ye){return ye.length===0?!0:!!j(ye[0])}e.isDecorationOptionsArr=V;var P;(function(ye){function Pe(ze){return ze.map(ye.from)}ye.fromMany=Pe;function me(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function x(ze){let Ze;if(me(ze)){const{language:gt,value:pt}=ze;Ze={value:"```"+gt+`
`+pt+"\n```\n"}}else r.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const It=Object.create(null);Ze.uris=It;const bt=gt=>{try{let pt=v.URI.parse(gt,!0);pt=pt.with({query:Ae(pt.query,It)}),It[gt]=pt}catch{}return""},kt=new S.marked.Renderer;return kt.link=bt,kt.image=gt=>typeof gt=="string"?bt(C.parseHrefAndDimensions(gt).href):"",(0,S.marked)(Ze.value,{renderer:kt}),Ze}ye.from=x;function Ae(ze,Ze){if(!ze)return ze;let It;try{It=(0,k.parse)(ze)}catch{}if(!It)return ze;let bt=!1;return It=(0,D.cloneAndChange)(It,kt=>{if(v.URI.isUri(kt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[gt]=kt,bt=!0,gt}else return}),bt?JSON.stringify(It):ze}function Le(ze){const Ze=new r.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?v.URI.from(ze.baseUri):void 0,Ze}ye.to=Le;function Xe(ze){if(!!ze)return typeof ze=="string"?ze:ye.from(ze)}ye.fromStrict=Xe})(P=e.MarkdownString||(e.MarkdownString={}));function M(ye){return V(ye)?ye.map(Pe=>({range:d.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?P.fromMany(Pe.hoverMessage):Pe.hoverMessage?P.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):ye.map(Pe=>({range:d.from(Pe)}))}e.fromRangeOrRangeWithMessage=M;function F(ye){return typeof ye>"u"?ye:typeof ye=="string"?v.URI.file(ye):ye}e.pathOrURIToURI=F;var $;(function(ye){function Pe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?F(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}ye.from=Pe})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(ye){function Pe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?F(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}ye.from=Pe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(ye){function Pe(me){if(typeof me>"u")return me;switch(me){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Pe})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var X;(function(ye){function Pe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?K.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?z.from(me.light):void 0,dark:me.dark?z.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?F(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}ye.from=Pe})(X=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Z;(function(ye){function Pe(x){return{text:x.newText,eol:x.newEol&&it.from(x.newEol),range:d.from(x.range)}}ye.from=Pe;function me(x){const Ae=new r.TextEdit(d.to(x.range),x.text);return Ae.newEol=typeof x.eol>"u"?void 0:it.to(x.eol),Ae}ye.to=me})(Z=e.TextEdit||(e.TextEdit={}));var he;(function(ye){function Pe(x,Ae){const Le={edits:[]};if(x instanceof r.WorkspaceEdit){const Xe=new R.ResourceSet;for(const ze of x._allEntries())ze._type===1&&v.URI.isUri(ze.to)&&ze.from===void 0&&Xe.add(ze.to);for(const ze of x._allEntries())ze._type===1?Le.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,T.encodeBase64)(T.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Le.edits.push({resource:ze.uri,textEdit:Z.from(ze.edit),versionId:Xe.has(ze.uri)?void 0:Ae?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Le.edits.push({resource:ze.uri,textEdit:{range:d.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Xe.has(ze.uri)?void 0:Ae?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Le.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Le.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(vt.from)}})}return Le}ye.from=Pe;function me(x){const Ae=new r.WorkspaceEdit;for(const Le of x.edits)Le.textEdit?Ae.replace(v.URI.revive(Le.resource),d.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(v.URI.revive(Le.oldResource),v.URI.revive(Le.newResource),Le.options);return Ae}ye.to=me})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var oe;(function(ye){const Pe=Object.create(null);Pe[r.SymbolKind.File]=0,Pe[r.SymbolKind.Module]=1,Pe[r.SymbolKind.Namespace]=2,Pe[r.SymbolKind.Package]=3,Pe[r.SymbolKind.Class]=4,Pe[r.SymbolKind.Method]=5,Pe[r.SymbolKind.Property]=6,Pe[r.SymbolKind.Field]=7,Pe[r.SymbolKind.Constructor]=8,Pe[r.SymbolKind.Enum]=9,Pe[r.SymbolKind.Interface]=10,Pe[r.SymbolKind.Function]=11,Pe[r.SymbolKind.Variable]=12,Pe[r.SymbolKind.Constant]=13,Pe[r.SymbolKind.String]=14,Pe[r.SymbolKind.Number]=15,Pe[r.SymbolKind.Boolean]=16,Pe[r.SymbolKind.Array]=17,Pe[r.SymbolKind.Object]=18,Pe[r.SymbolKind.Key]=19,Pe[r.SymbolKind.Null]=20,Pe[r.SymbolKind.EnumMember]=21,Pe[r.SymbolKind.Struct]=22,Pe[r.SymbolKind.Event]=23,Pe[r.SymbolKind.Operator]=24,Pe[r.SymbolKind.TypeParameter]=25;function me(Ae){return typeof Pe[Ae]=="number"?Pe[Ae]:6}ye.from=me;function x(Ae){for(const Le in Pe)if(Pe[Le]===Ae)return Number(Le);return r.SymbolKind.Property}ye.to=x})(oe=e.SymbolKind||(e.SymbolKind={}));var ue;(function(ye){function Pe(x){switch(x){case r.SymbolTag.Deprecated:return 1}}ye.from=Pe;function me(x){switch(x){case 1:return r.SymbolTag.Deprecated}}ye.to=me})(ue=e.SymbolTag||(e.SymbolTag={}));var ce;(function(ye){function Pe(x){return{name:x.name,kind:oe.from(x.kind),tags:x.tags&&x.tags.map(ue.from),containerName:x.containerName,location:Me.from(x.location)}}ye.from=Pe;function me(x){const Ae=new r.SymbolInformation(x.name,oe.to(x.kind),x.containerName,Me.to(x.location));return Ae.tags=x.tags&&x.tags.map(ue.to),Ae}ye.to=me})(ce=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var fe;(function(ye){function Pe(x){const Ae={name:x.name||"!!MISSING: name!!",detail:x.detail,range:d.from(x.range),selectionRange:d.from(x.selectionRange),kind:oe.from(x.kind),tags:x.tags?.map(ue.from)??[]};return x.children&&(Ae.children=x.children.map(Pe)),Ae}ye.from=Pe;function me(x){const Ae=new r.DocumentSymbol(x.name,x.detail,oe.to(x.kind),d.to(x.range),d.to(x.selectionRange));return(0,n.isNonEmptyArray)(x.tags)&&(Ae.tags=x.tags.map(ue.to)),x.children&&(Ae.children=x.children.map(me)),Ae}ye.to=me})(fe=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(ye){function Pe(x){const Ae=new r.CallHierarchyItem(oe.to(x.kind),x.name,x.detail||"",v.URI.revive(x.uri),d.to(x.range),d.to(x.selectionRange));return Ae._sessionId=x._sessionId,Ae._itemId=x._itemId,Ae}ye.to=Pe;function me(x,Ae,Le){if(Ae=Ae??x._sessionId,Le=Le??x._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:x.name,detail:x.detail,kind:oe.from(x.kind),uri:x.uri,range:d.from(x.range),selectionRange:d.from(x.selectionRange),tags:x.tags?.map(ue.from)}}ye.from=me})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ge;(function(ye){function Pe(me){return new r.CallHierarchyIncomingCall(Y.to(me.from),me.fromRanges.map(x=>d.to(x)))}ye.to=Pe})(ge=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var we;(function(ye){function Pe(me){return new r.CallHierarchyOutgoingCall(Y.to(me.to),me.fromRanges.map(x=>d.to(x)))}ye.to=Pe})(we=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Me;(function(ye){function Pe(x){return{range:x.range&&d.from(x.range),uri:x.uri}}ye.from=Pe;function me(x){return new r.Location(v.URI.revive(x.uri),d.to(x.range))}ye.to=me})(Me=e.location||(e.location={}));var We;(function(ye){function Pe(x){const Ae=x,Le=x;return{originSelectionRange:Ae.originSelectionRange?d.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:d.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?d.from(Ae.targetSelectionRange):void 0}}ye.from=Pe;function me(x){return{targetUri:v.URI.revive(x.uri),targetRange:d.to(x.range),targetSelectionRange:x.targetSelectionRange?d.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?d.to(x.originSelectionRange):void 0}}ye.to=me})(We=e.DefinitionLink||(e.DefinitionLink={}));var Qe;(function(ye){function Pe(x){return{range:d.from(x.range),contents:P.fromMany(x.contents)}}ye.from=Pe;function me(x){return new r.Hover(x.contents.map(P.to),d.to(x.range))}ye.to=me})(Qe=e.Hover||(e.Hover={}));var Te;(function(ye){function Pe(x){return{range:d.from(x.range),expression:x.expression}}ye.from=Pe;function me(x){return new r.EvaluatableExpression(d.to(x.range),x.expression)}ye.to=me})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var De;(function(ye){function Pe(x){if(x instanceof r.InlineValueText)return{type:"text",range:d.from(x.range),text:x.text};if(x instanceof r.InlineValueVariableLookup)return{type:"variable",range:d.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Pe;function me(x){switch(x.type){case"text":return{range:d.to(x.range),text:x.text};case"variable":return{range:d.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:d.to(x.range),expression:x.expression}}}ye.to=me})(De=e.InlineValue||(e.InlineValue={}));var ke;(function(ye){function Pe(x){return{frameId:x.frameId,stoppedLocation:d.from(x.stoppedLocation)}}ye.from=Pe;function me(x){return new r.InlineValueContext(x.frameId,d.to(x.stoppedLocation))}ye.to=me})(ke=e.InlineValueContext||(e.InlineValueContext={}));var re;(function(ye){function Pe(x){return{range:d.from(x.range),kind:x.kind}}ye.from=Pe;function me(x){return new r.DocumentHighlight(d.to(x.range),x.kind)}ye.to=me})(re=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(ye){function Pe(me){switch(me){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}ye.to=Pe})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(ye){function Pe(me){return{triggerKind:ae.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}ye.to=Pe})(J=e.CompletionContext||(e.CompletionContext={}));var I;(function(ye){function Pe(x){switch(x){case r.CompletionItemTag.Deprecated:return 1}}ye.from=Pe;function me(x){switch(x){case 1:return r.CompletionItemTag.Deprecated}}ye.to=me})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(ye){const Pe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function me(Le){return Pe.get(Le)??9}ye.from=me;const x=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ae(Le){return x.get(Le)??r.CompletionItemKind.Property}ye.to=Ae})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(ye){function Pe(me,x){const Ae=new r.CompletionItem(me.label);return Ae.insertText=me.insertText,Ae.kind=U.to(me.kind),Ae.tags=me.tags?.map(I.to),Ae.detail=me.detail,Ae.documentation=C.isMarkdownString(me.documentation)?P.to(me.documentation):me.documentation,Ae.sortText=me.sortText,Ae.filterText=me.filterText,Ae.preselect=me.preselect,Ae.commitCharacters=me.commitCharacters,h.Range.isIRange(me.range)?Ae.range=d.to(me.range):typeof me.range=="object"&&(Ae.range={inserting:d.to(me.range.insert),replacing:d.to(me.range.replace)}),Ae.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Ae.insertText=new r.SnippetString(me.insertText):(Ae.insertText=me.insertText,Ae.textEdit=Ae.range instanceof r.Range?new r.TextEdit(Ae.range,Ae.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ae.additionalTextEdits=me.additionalTextEdits.map(Le=>Z.to(Le))),Ae.command=x&&me.command?x.fromInternal(me.command):void 0,Ae}ye.to=Pe})(H=e.CompletionItem||(e.CompletionItem={}));var G;(function(ye){function Pe(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:P.fromStrict(x.documentation)}}ye.from=Pe;function me(x){return{label:x.label,documentation:C.isMarkdownString(x.documentation)?P.to(x.documentation):x.documentation}}ye.to=me})(G=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(ye){function Pe(x){return{label:x.label,documentation:P.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(G.from):[],activeParameter:x.activeParameter}}ye.from=Pe;function me(x){return{label:x.label,documentation:C.isMarkdownString(x.documentation)?P.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(G.to):[],activeParameter:x.activeParameter}}ye.to=me})(ee=e.SignatureInformation||(e.SignatureInformation={}));var le;(function(ye){function Pe(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ee.from):[]}}ye.from=Pe;function me(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ee.to):[]}}ye.to=me})(le=e.SignatureHelp||(e.SignatureHelp={}));var Se;(function(ye){function Pe(me,x){const Ae=new r.InlayHint(u.to(x.position),typeof x.label=="string"?x.label:x.label.map(se.to.bind(void 0,me)),x.kind&&ve.to(x.kind));return Ae.textEdits=x.textEdits&&x.textEdits.map(Z.to),Ae.tooltip=C.isMarkdownString(x.tooltip)?P.to(x.tooltip):x.tooltip,Ae.paddingLeft=x.paddingLeft,Ae.paddingRight=x.paddingRight,Ae}ye.to=Pe})(Se=e.InlayHint||(e.InlayHint={}));var se;(function(ye){function Pe(me,x){const Ae=new r.InlayHintLabelPart(x.label);return Ae.tooltip=C.isMarkdownString(x.tooltip)?P.to(x.tooltip):x.tooltip,i.Command.is(x.command)&&(Ae.command=me.fromInternal(x.command)),x.location&&(Ae.location=Me.to(x.location)),Ae}ye.to=Pe})(se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(ye){function Pe(x){return x}ye.from=Pe;function me(x){return x}ye.to=me})(ve=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(ye){function Pe(x){return{range:d.from(x.range),url:x.target,tooltip:x.tooltip}}ye.from=Pe;function me(x){let Ae;if(x.url)try{Ae=typeof x.url=="string"?v.URI.parse(x.url,!0):v.URI.revive(x.url)}catch{}return new r.DocumentLink(d.to(x.range),Ae)}ye.to=me})(be=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ye){function Pe(x){const Ae=new r.ColorPresentation(x.label);return x.textEdit&&(Ae.textEdit=Z.to(x.textEdit)),x.additionalTextEdits&&(Ae.additionalTextEdits=x.additionalTextEdits.map(Le=>Z.to(Le))),Ae}ye.to=Pe;function me(x){return{label:x.label,textEdit:x.textEdit?Z.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Ae=>Z.from(Ae)):void 0}}ye.from=me})($e=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(ye){function Pe(x){return new r.Color(x[0],x[1],x[2],x[3])}ye.to=Pe;function me(x){return[x.red,x.green,x.blue,x.alpha]}ye.from=me})(He=e.Color||(e.Color={}));var tt;(function(ye){function Pe(x){return{range:d.from(x.range)}}ye.from=Pe;function me(x){return new r.SelectionRange(d.to(x.range))}ye.to=me})(tt=e.SelectionRange||(e.SelectionRange={}));var xe;(function(ye){function Pe(me){switch(me){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}ye.to=Pe})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(ye){function Pe(x){switch(x){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Pe;function me(x){switch(x){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}ye.to=me})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(ye){function Pe(x){if(x===r.EndOfLine.CRLF)return 1;if(x===r.EndOfLine.LF)return 0}ye.from=Pe;function me(x){if(x===1)return r.EndOfLine.CRLF;if(x===0)return r.EndOfLine.LF}ye.to=me})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(ye){function Pe(me){if(typeof me=="object")return me.viewId;switch(me){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(ye){function Pe(me){const x={start:me.start+1,end:me.end+1};return me.kind&&(x.kind=st.from(me.kind)),x}ye.from=Pe})(Fe=e.FoldingRange||(e.FoldingRange={}));var st;(function(ye){function Pe(me){if(me)switch(me){case r.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}ye.from=Pe})(st=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _;(function(ye){function Pe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?d.from(me.selection):void 0,override:typeof me.override=="boolean"?E.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Pe})(_=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(ye){function Pe(Le){return Le instanceof r.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||x(Le)?new r.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}ye.from=Pe;function me(Le){const Xe=Le;return Xe?v.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function x(Le){const Xe=Le;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new r.RelativePattern(v.URI.revive(Le.baseUri),Le.pattern)}ye.to=Ae})(Q=e.GlobPattern||(e.GlobPattern={}));var pe;(function(ye){function Pe(me){if(me){if(Array.isArray(me))return me.map(Pe);if(typeof me=="string")return me;{const x=me;return{language:x.language,scheme:x.scheme,pattern:Q.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}ye.from=Pe})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(ye){function Pe(x){return{start:x.start,end:x.end}}ye.from=Pe;function me(x){return new r.NotebookRange(x.start,x.end)}ye.to=me})(Ne=e.NotebookRange||(e.NotebookRange={}));var Be;(function(ye){function Pe(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}ye.to=Pe;function me(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}ye.from=me})(Be=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(ye){function Pe(me){if(me===b.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(me===b.NotebookCellExecutionState.Pending)return;if(me===b.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}ye.to=Pe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Je;(function(ye){function Pe(x){switch(x){case r.NotebookCellKind.Markup:return b.CellKind.Markup;case r.NotebookCellKind.Code:default:return b.CellKind.Code}}ye.from=Pe;function me(x){switch(x){case b.CellKind.Markup:return r.NotebookCellKind.Markup;case b.CellKind.Code:default:return r.NotebookCellKind.Code}}ye.to=me})(Je=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(ye){function Pe(x){const Ae={metadata:x.metadata??Object.create(null),cells:[]};for(const Le of x.cells)r.NotebookCellData.validate(Le),Ae.cells.push(vt.from(Le));return Ae}ye.from=Pe;function me(x){const Ae=new r.NotebookData(x.cells.map(vt.to));return(0,f.isEmptyObject)(x.metadata)||(Ae.metadata=x.metadata),Ae}ye.to=me})(nt=e.NotebookData||(e.NotebookData={}));var vt;(function(ye){function Pe(x){return{cellKind:Je.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:Be.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(Tt.from):[]}}ye.from=Pe;function me(x){return new r.NotebookCellData(Je.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(Tt.to):void 0,x.metadata,x.internalMetadata?Be.to(x.internalMetadata):void 0)}ye.to=me})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(ye){function Pe(x){return{mime:x.mime,valueBytes:T.VSBuffer.wrap(x.data)}}ye.from=Pe;function me(x){return new r.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}ye.to=me})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Tt;(function(ye){function Pe(x){return{outputId:x.id,items:x.items.map(wt.from),metadata:x.metadata}}ye.from=Pe;function me(x){const Ae=x.items.map(wt.to);return new r.NotebookCellOutput(Ae,x.outputId,x.metadata)}ye.to=me})(Tt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(ye){function Pe(Ae){return x(Ae)?{include:(0,f.withNullAsUndefined)(Q.from(Ae.include)),exclude:(0,f.withNullAsUndefined)(Q.from(Ae.exclude))}:(0,f.withNullAsUndefined)(Q.from(Ae))}ye.from=Pe;function me(Ae){return x(Ae)?{include:Q.to(Ae.include),exclude:Q.to(Ae.exclude)}:Q.to(Ae)}ye.to=me;function x(Ae){const Le=Ae;return Le?!(0,f.isUndefinedOrNull)(Le.include)&&!(0,f.isUndefinedOrNull)(Le.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(ye){function Pe(me,x,Ae){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Le,Ae),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}ye.from=Pe})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ut;(function(ye){function Pe(me,x,Ae){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:x.toInternal(Le,Ae),label:me.label,description:me.description,detail:me.detail}}ye.from=Pe})(Ut=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ft;(function(ye){function Pe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}ye.from=Pe})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Mt;(function(ye){function Pe(x){return{uri:x.uri,provides:x.provides}}ye.from=Pe;function me(x){return new r.NotebookRendererScript(v.URI.revive(x.uri),x.provides)}ye.to=me})(Mt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(ye){function Pe(x){return{message:P.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:d.from(x.location.range),uri:x.location.uri}}}ye.from=Pe;function me(x){const Ae=new r.TestMessage(typeof x.message=="string"?x.message:P.to(x.message));return Ae.actualOutput=x.actual,Ae.expectedOutput=x.expected,Ae.location=x.location?Me.to(x.location):void 0,Ae}ye.to=me})(ft=e.TestMessage||(e.TestMessage={}));var Ct;(function(ye){ye.namespace=w.namespaceTestTag,ye.denamespace=w.denamespaceTestTag})(Ct=e.TestTag||(e.TestTag={}));var Bt;(function(ye){function Pe(x){const Ae=(0,l.getPrivateApiFor)(x).controllerId;return{extId:g.TestId.fromExtHostTestItem(x,Ae).toString(),label:x.label,uri:v.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(Le=>Ct.namespace(Ae,Le.id)),range:h.Range.lift(d.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&P.fromStrict(x.error)||null}}ye.from=Pe;function me(x){return{parent:void 0,error:void 0,id:g.TestId.fromString(x.extId).localId,label:x.label,uri:v.URI.revive(x.uri),tags:(x.tags||[]).map(Ae=>{const{tagId:Le}=Ct.denamespace(Ae);return new r.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}ye.toPlain=me})(Bt=e.TestItem||(e.TestItem={})),function(ye){function Pe(x){return{id:x.id}}ye.from=Pe;function me(x){return new r.TestTag(x.id)}ye.to=me}(Ct=e.TestTag||(e.TestTag={}));var Nt;(function(ye){const Pe=(x,Ae)=>{const Le=[];for(const[ze,Ze]of Ae)g.TestId.compare(Ze.item.extId,ze)===2&&(Ae.delete(ze),Le.push(Ze));const Xe={...Bt.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:Le.map(ze=>Pe(ze,Ae))};for(const ze of Xe.children)ze.parent=Xe;return Xe};function me(x){const Ae=[],Le=new Map;for(const Xe of x.items){Le.set(Xe.item.extId,Xe);const ze=g.TestId.root(Xe.item.extId);x.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(Xe.item.extId))&&Ae.push(Xe)}return{completedAt:x.completedAt,results:Ae.map(Xe=>Pe(Xe,Le))}}ye.to=me})(Nt=e.TestResults||(e.TestResults={}));var Ge;(function(ye){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?u.from(Le):d.from(Le)}function x(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&me(Xe.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}ye.fromDetailed=x;function Ae(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(x)}}ye.fromFile=Ae})(Ge=e.TestCoverage||(e.TestCoverage={}));var Rt;(function(ye){function Pe(me){switch(me){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}ye.to=Pe})(Rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(ye){function Pe(x){const Ae=new r.TypeHierarchyItem(oe.to(x.kind),x.name,x.detail||"",v.URI.revive(x.uri),d.to(x.range),d.to(x.selectionRange));return Ae._sessionId=x._sessionId,Ae._itemId=x._itemId,Ae}ye.to=Pe;function me(x,Ae,Le){if(Ae=Ae??x._sessionId,Le=Le??x._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:oe.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:d.from(x.range),selectionRange:d.from(x.selectionRange),tags:x.tags?.map(ue.from)}}ye.from=me})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ht;(function(ye){function Pe(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}ye.from=Pe})(Ht=e.ViewBadge||(e.ViewBadge={}));var mt;(function(ye){function Pe(Le,Xe,ze){const Ze=Xe.fileData;return Ze?new class extends r.DataTransferItem{asFile(){return{name:Ze.name,uri:v.URI.revive(Ze.uri),data:(0,L.once)(()=>ze())}}}("",Xe.id):Le===O.Mimes.uriList&&Xe.uriListData?new r.DataTransferItem(Ae(Xe.uriListData)):new r.DataTransferItem(Xe.asString)}ye.to=Pe;async function me(Le,Xe){const ze=await Xe.asString();if(Le===O.Mimes.uriList)return{id:Xe.id,asString:"",fileData:void 0,uriListData:x(ze)};const Ze=Xe.asFile();return{id:Xe.id,asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}ye.from=me;function x(Le){return y.UriList.split(Le).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return v.URI.parse(Xe)}catch{}return Xe})}function Ae(Le){return y.UriList.create(Le.map(Xe=>typeof Xe=="string"?Xe:v.URI.revive(Xe)))}})(mt=e.DataTransferItem||(e.DataTransferItem={}));var At;(function(ye){function Pe(x,Ae){const Le=x.items.map(([Xe,ze])=>[Xe,mt.to(Xe,ze,()=>Ae(ze.id))]);return new r.DataTransfer(Le)}ye.toDataTransfer=Pe;async function me(x){const Ae={items:[]},Le=[];return x.forEach((Xe,ze)=>{Le.push((async()=>{Ae.items.push([ze,await mt.from(ze,Xe)])})())}),await Promise.all(Le),Ae}ye.toDataTransferDTO=me})(At=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[185],Ce([1,0,2,11,6,8,152]),function(te,e,n,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(k,O,D,f={timeout:1500,errors:3}){this.c=k,this.d=O,this.f=D,this.g=f,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(O,D,f)=>{const h={dispose:this.a.push([O,D,k])};return Array.isArray(f)&&f.push(h),h}}async $participateInSave(k,O){const D=n.URI.revive(k);let f=!1;const v=setTimeout(()=>f=!0,this.g.timeout),h=[];try{for(const i of[...this.a]){if(f)break;const o=this.d.getDocument(D),l=await this.h(i,{document:o,reason:L.TextDocumentSaveReason.to(O)});h.push(l)}}finally{clearTimeout(v)}return h}h([k,O,D],f){const v=this.b.get(k);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(D,k,O,f).then(()=>!0,h=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const i=this.b.get(k);this.b.set(k,i?i+1:1),typeof i=="number"&&i>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,O,D,f){const v=[],h=Date.now(),{document:i,reason:o}=f,{version:l}=i,E=Object.freeze({document:i,reason:o,waitUntil(b){if(Object.isFrozen(v))throw(0,T.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(b))}});try{O.apply(D,[E])}catch(b){return Promise.reject(b)}return Object.freeze(v),new Promise((b,g)=>{const w=setTimeout(()=>g(new Error("timeout")),this.g.timeout);return Promise.all(v).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(w),b(s)}).catch(s=>{clearTimeout(w),g(s)})}).then(b=>{const g={edits:[]};for(const w of b)if(Array.isArray(w)&&w.every(s=>s instanceof y.TextEdit))for(const{newText:s,newEol:r,range:a}of w)g.edits.push({resource:i.uri,versionId:void 0,textEdit:{range:a&&L.Range.from(a),text:s,eol:r&&L.EndOfLine.from(r)}});if(g.edits.length!==0)return l===i.version?this.f.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(Ie[186],Ce([1,0,13,2,8,6,66]),function(te,e,n,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(D,f,v,h){this.start=D,this.deletedCount=f,this.deletedItems=v,this.items=h}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(D,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,f,v){this.notebook=D,this.h=f,this.j=v,this.handle=v.handle,this.uri=T.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(y.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(y.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:y.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return D.g},set mime(h){D.g=h},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(v)}return this.f}setOutputs(D){this.a=D.map(y.NotebookCellOutput.to)}setOutputItems(D,f,v){const h=v.map(y.NotebookCellOutputItem.to),i=this.a.find(o=>o.id===D);if(i&&(f||(i.items.length=0),i.items.push(...h),i.items.length>1&&i.items.every(o=>C.isTextStreamMime(o.mime)))){const o=new Map,l=[];i.items.forEach(E=>{let b;o.has(E.mime)?b=o.get(E.mime):(b=[],o.set(E.mime,b),l.push(E.mime)),b.push(E.data)}),i.items.length=0,l.forEach(E=>{const b=C.compressOutputItemStreams(o.get(E));i.items.push({mime:E,data:b.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(y.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=S;class k{constructor(D,f,v,h,i){this.k=D,this.l=f,this.m=v,this.uri=h,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=i.viewType,this.f=Object.freeze(i.metadata??Object.create(null)),this.r([[0,0,i.cells]],!0,void 0),this.g=i.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const D=this,f={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===n.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(v){return v=D.n(v),D.b[v].apiCell},getCells(v){return(v?D.p(v):D.b).map(i=>i.apiCell)},save(){return D.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,f,v){this.g=D.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:v});const h={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},i=[];for(const l of D.rawEvents)l.kind===C.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,h.contentChanges):l.kind===C.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,h.contentChanges):l.kind===C.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),i.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),i.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),i.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===C.NotebookCellsChangeType.ChangeCellContent?i.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),i.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),i.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const o=new Map;for(let l=0;l<i.length;l++){const E=i[l],b=o.get(E.cell);if(b===void 0){const g=h.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...E});o.set(E.cell,g-1)}else h.cellChanges[b]={...h.cellChanges[b],...E}}return Object.freeze(h),Object.freeze(h.cellChanges),Object.freeze(h.contentChanges),h}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let f=D.start|0,v=D.end|0;return f<0&&(f=0),v>this.b.length&&(v=this.b.length),D.with({start:f,end:v})}p(D){D=this.o(D);const f=[];for(let v=D.start;v<D.end;v++)f.push(this.b[v]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,f,v){if(this.j)return;const h=[],i=[],o=[];if(D.reverse().forEach(l=>{const b=l[2].map(s=>{const r=new S(this,this.l,s);return f||i.push(S.asModelAddData(this.apiNotebook,s)),r}),g=new R(l[0],l[1],[],b),w=this.b.splice(l[0],l[1],...b);for(const s of w)o.push(s.uri),g.deletedItems.push(s.apiCell);h.push(g)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:i,removedDocuments:o}),v)for(const l of h)v.push(l.asApiEvent())}s(D,f,v,h){const i=this.b.splice(D,f);this.b.splice(v,0,...i);const o=[new R(D,f,i.map(l=>l.apiCell),[]),new R(v,0,[],i)];for(const l of o)h.push(l.asApiEvent())}t(D,f){this.b[D].setOutputs(f)}u(D,f,v,h){this.b[D].setOutputItems(f,v,h)}v(D,f){const v=this.b[D];v.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(v.uri,f)}w(D,f){const v=this.b[D];v.apiCell.mime=f}x(D,f){this.b[D].setMetadata(f)}y(D,f){this.b[D].setInternalMetadata(f)}getCellFromApiCell(D){return this.b.find(f=>f.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(f=>f.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.ExtHostNotebookDocument=k,k.a=0}),define(Ie[96],Ce([1,0,11,8,6]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(R,S,k,O,D,f){this.id=R,this.f=S,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=O,this.c=f}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(S){this.selections=[S]},get selections(){return R.a},set selections(S){if(!Array.isArray(S)||!S.every(y.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");R.a=S,R.g(S)},get visibleRanges(){return R.b},revealRange(S,k){R.f.$tryRevealRange(R.id,T.NotebookRange.from(S),k??y.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(T.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(Ie[187],Ce([1,0,5,12,8]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(R,S){this.c=R,this.d=S,this.a=new n.Emitter,this.b=new n.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,S);const k=this.d.getEditorById(R);S.visibleRanges&&k._acceptVisibleRanges(S.visibleRanges.ranges.map(y.NotebookRange.to)),S.selections&&k._acceptSelections(S.selections.selections.map(y.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const S in R)this.d.getEditorById(S)._acceptViewColumn(y.ViewColumn.to(R[S]))}};L=qe([Ve(0,T.ILogService)],L),e.ExtHostNotebookEditors=L}),define(Ie[188],Ce([1,0,8,155,134,20,60,11]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,v,h){const i=this.b++,{title:o,location:l,cancellable:E}=v,b={label:(0,y.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(i,{location:n.ProgressLocation.from(l),title:o,source:b,cancellable:E},f.isUnderDevelopment?void 0:f.identifier.value).catch(R.onUnexpectedExternalError),this.d(i,h,!!E)}d(f,v,h){let i;h&&(i=new L.CancellationTokenSource,this.c.set(f,i));const o=E=>{this.a.$progressEnd(E),this.c.delete(E),i?.dispose()};let l;try{l=v(new O(this.a,f),h&&i?i.token:L.CancellationToken.None)}catch(E){throw o(f),E}return l.then(E=>o(f),E=>o(f)),l}$acceptProgressCanceled(f){const v=this.c.get(f);v&&(v.cancel(),this.c.delete(f))}}e.ExtHostProgress=S;function k(D,f){return D.message=f.message,typeof f.increment=="number"&&(typeof D.increment=="number"?D.increment+=f.increment:D.increment=f.increment),D}class O extends T.Progress{constructor(f,v){super(h=>this.throttledReport(h)),this.c=f,this.d=v}throttledReport(f){this.c.$progressReport(this.d,f)}}qe([(0,C.throttle)(100,(D,f)=>k(D,f),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ie[97],Ce([1,0,54,93,42,67,53,8,2]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(b,g,w,s)=>{let r=g;return{enumerable:!0,configurable:!1,get(){return r},set(a){if(!w(r,a)){const d=r;r=a,b.listener?.(s(a,d))}}}},O=(b,g)=>b===g,D={range:(b,g)=>b===g?!0:!b||!g?!1:b.isEqual(g),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(b,g)=>!(b.length!==g.length||b.some(w=>!g.find(s=>w.id===s.id)))},f=b=>g=>({op:4,update:b(g)}),v=(b,g)=>({range:(()=>{let w;const s=f(r=>({range:n.Range.lift(R.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return w},set(r){b.listener?.({op:6}),D.range(w,r)||(w=r,b.listener?.(s(r)))}}})(),label:k(b,g,D.label,f(w=>({label:w}))),description:k(b,void 0,D.description,f(w=>({description:w}))),sortText:k(b,void 0,D.sortText,f(w=>({sortText:w}))),canResolveChildren:k(b,!1,D.canResolveChildren,w=>({op:2,state:w})),busy:k(b,!1,D.busy,f(w=>({busy:w}))),error:k(b,void 0,D.error,f(w=>({error:R.MarkdownString.fromStrict(w)||null}))),tags:k(b,[],D.tags,(w,s)=>({op:1,new:w.map(R.TestTag.from),old:s.map(R.TestTag.from)}))}),h=b=>{const g=y.TestId.fromString(b.extId),w=new o(g.controllerId,g.localId,b.label,S.URI.revive(b.uri)||void 0);return w.range=R.Range.to(b.range||void 0),w.description=b.description||void 0,w.sortText=b.sortText||void 0,w.tags=b.tags.map(s=>R.TestTag.to({id:(0,C.denamespaceTestTag)(s).tagId})),w},i=b=>{let g;for(const w of b.tests){const s=h(w.item);(0,T.getPrivateApiFor)(s).parent=g,g=s}return g};e.toItemFromContext=i;class o{constructor(g,w,s,r){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const a=(0,T.createPrivateApiFor)(this,g);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof l?void 0:a.parent}},children:{value:(0,L.createTestItemChildren)(a,T.getPrivateApiFor,o),enumerable:!0,writable:!1},...v(a,s)})}}e.TestItemImpl=o;class l extends o{constructor(g,w){super(g,g,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class E extends L.TestItemCollection{constructor(g,w,s){super({controllerId:g,getDocumentVersion:r=>r&&s.getDocument(r)?.version,getApiFor:T.getPrivateApiFor,getChildren:r=>r.children,root:new l(g,w),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=E}),define(Ie[98],Ce([1,0,47,11,79,8,6]),function(te,e,n,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class R{constructor(f,v,h){const i=R.c.nextId();f.$registerTextEditorDecorationType(v.identifier,i,L.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:i,dispose(){f.$removeTextEditorDecorationType(i)}})}}e.TextEditorDecorationType=R,R.c=new y.IdGenerator("TextEditorDecorationType");class S{constructor(f,v){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,v){this.k();let h=null;if(f instanceof C.Position)h=new C.Range(f,f);else if(f instanceof C.Range)h=f;else throw new Error("Unrecognized location");this.l(h,v,!1)}insert(f,v){this.k(),this.l(new C.Range(f,f),v,!0)}delete(f){this.k();let v=null;if(f instanceof C.Range)v=f;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(f,v,h){const i=this.c.validateRange(f);this.g.push({range:i,text:v,forceMoveMarkers:h})}setEndOfLine(f){if(this.k(),f!==C.EndOfLine.LF&&f!==C.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this.h=f}}e.TextEditorEdit=S;class k{constructor(f,v,h,i){this.c=f,this.d=v,this._accept(h),this.e=i;const o=this;this.value={get tabSize(){return o.f},set tabSize(l){o.m(l)},get indentSize(){return o.g},set indentSize(l){o.o(l)},get insertSpaces(){return o.h},set insertSpaces(l){o.q(l)},get cursorStyle(){return o.j},set cursorStyle(l){o.s(l)},get lineNumbers(){return o.k},set lineNumbers(l){o.t(l)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const v=Math.floor(f);return v>0?v:null}if(typeof f=="string"){const v=parseInt(f,10);return isNaN(v)?null:v>0?v:null}return null}m(f){const v=this.l(f);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const v=Math.floor(f);return v>0?v:null}if(typeof f=="string"){const v=parseInt(f,10);return isNaN(v)?null:v>0?v:null}return null}o(f){const v=this.n(f);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}q(f){const v=this.p(f);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(f)})))}assign(f){const v={};let h=!1;if(typeof f.tabSize<"u"){const i=this.l(f.tabSize);i==="auto"?(h=!0,v.tabSize=i):typeof i=="number"&&this.f!==i&&(this.f=i,h=!0,v.tabSize=i)}if(typeof f.indentSize<"u"){const i=this.n(f.indentSize);i==="tabSize"?(h=!0,v.indentSize=i):typeof i=="number"&&this.g!==i&&(this.g=i,h=!0,v.indentSize=i)}if(typeof f.insertSpaces<"u"){const i=this.p(f.insertSpaces);i==="auto"?(h=!0,v.insertSpaces=i):this.h!==i&&(this.h=i,h=!0,v.insertSpaces=i)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,h=!0,v.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,h=!0,v.lineNumbers=L.TextEditorLineNumbersStyle.from(f.lineNumbers)),h&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(f,v){v.catch(h=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(h)})}}e.ExtHostTextEditorOptions=k;class O{constructor(f,v,h,i,o,l,E,b){this.id=f,this.j=v,this.k=h,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,l,h),this.e=E,this.f=b;const g=this;this.value=Object.freeze({get document(){return i.getValue()},set document(w){throw(0,T.readonly)("document")},get selection(){return g.c&&g.c[0]},set selection(w){if(!(w instanceof C.Selection))throw(0,T.illegalArgument)("selection");g.c=[w],g.l()},get selections(){return g.c},set selections(w){if(!Array.isArray(w)||w.some(s=>!(s instanceof C.Selection)))throw(0,T.illegalArgument)("selections");g.c=w,g.l()},get visibleRanges(){return g.e},set visibleRanges(w){throw(0,T.readonly)("visibleRanges")},get options(){return g.d.value},set options(w){g.g||g.d.assign(w)},get viewColumn(){return g.f},set viewColumn(w){throw(0,T.readonly)("viewColumn")},edit(w,s={undoStopBefore:!0,undoStopAfter:!0}){if(g.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new S(i.getValue(),s);return w(r),g.m(r)},insertSnippet(w,s,r={undoStopBefore:!0,undoStopAfter:!0}){if(g.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!s||Array.isArray(s)&&s.length===0)a=g.c.map(d=>L.Range.from(d));else if(s instanceof C.Position){const{lineNumber:d,column:c}=L.Position.from(s);a=[{startLineNumber:d,startColumn:c,endLineNumber:d,endColumn:c}]}else if(s instanceof C.Range)a=[L.Range.from(s)];else{a=[];for(const d of s)if(d instanceof C.Range)a.push(L.Range.from(d));else{const{lineNumber:c,column:u}=L.Position.from(d);a.push({startLineNumber:c,startColumn:u,endLineNumber:c,endColumn:u})}}return v.$tryInsertSnippet(f,i.getValue().version,w.value,a,r)},setDecorations(w,s){const r=s.length===0;r&&!g.h.has(w.key)||(r?g.h.delete(w.key):g.h.add(w.key),g.n(()=>{if(L.isDecorationOptionsArr(s))return v.$trySetDecorations(f,w.key,L.fromRangeOrRangeWithMessage(s));{const a=new Array(4*s.length);for(let d=0,c=s.length;d<c;d++){const u=s[d];a[4*d]=u.start.line+1,a[4*d+1]=u.start.character+1,a[4*d+2]=u.end.line+1,a[4*d+3]=u.end.character+1}return v.$trySetDecorationsFast(f,w.key,a)}}))},revealRange(w,s){g.n(()=>v.$tryRevealRange(f,L.Range.from(w),s||C.TextEditorRevealType.Default))},show(w){v.$tryShowEditor(f,L.ViewColumn.from(w))},hide(){v.$tryHideEditor(f)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,n.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,n.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,n.ok)(!this.g),this.f=f}_acceptSelections(f){(0,n.ok)(!this.g),this.c=f}async l(){const f=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const v=f.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const h=v.edits.map(o=>o.range);h.sort((o,l)=>o.end.line===l.end.line?o.end.character===l.end.character?o.start.line===l.start.line?o.start.character-l.start.character:o.start.line-l.start.line:o.end.character-l.end.character:o.end.line-l.end.line);for(let o=0,l=h.length-1;o<l;o++){const E=h[o].end;if(h[o+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const i=v.edits.map(o=>({range:L.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,i,{setEndOfLine:typeof v.setEndOfLine=="number"?L.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.ExtHostTextEditor=O}),define(Ie[189],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[190],Ce([1,0,145,11,29,85,88,30,26,189,154,147]),function(te,e,n,T,y,L,C,R,S,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const f=R.Registry.as(C.Extensions.JSONContribution);class v{constructor(w,s,r){this.a=w,this.b=s,this.c=r}d(w,s){this.a({type:w,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(y.default.Error,w)}warn(w){this.d(y.default.Warning,w)}info(w){this.d(y.default.Info,w)}}e.ExtensionMessageCollector=v;class h{static a(w){const s=new Set;for(let r=0,a=w.length;r<a;r++)s.add(S.ExtensionIdentifier.toKey(w[r].description.identifier));return s}static compute(w,s){if(!w||!w.length)return new h(s,[]);if(!s||!s.length)return new h([],w);const r=this.a(w),a=this.a(s),d=s.filter(u=>!r.has(S.ExtensionIdentifier.toKey(u.description.identifier))),c=w.filter(u=>!a.has(S.ExtensionIdentifier.toKey(u.description.identifier)));return new h(d,c)}constructor(w,s){this.added=w,this.removed=s}}e.ExtensionPointUserDelta=h;class i{constructor(w,s){this.name=w,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=h.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,T.onUnexpectedError)(w)}}}e.ExtensionPoint=i;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:n.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(30,null)},{label:"onUri",body:"onUri",description:n.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(35,null)},{label:"onRenderer",description:n.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(37,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(39,null)},{label:"*",description:n.localize(40,null),body:"*"}]}},badges:{type:"array",description:n.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(42,null)},href:{type:"string",description:n.localize(43,null)},description:{type:"string",description:n.localize(44,null)}}}},markdown:{type:"string",description:n.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(49,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(50,null)},{body:["workspace"],description:n.localize(51,null)},{body:["ui","workspace"],description:n.localize(52,null)},{body:["workspace","ui"],description:n.localize(53,null)},{body:[],description:n.localize(54,null)}]},capabilities:{description:n.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(58,null),n.localize(59,null),n.localize(60,null)]},description:{type:"string",markdownDescription:n.localize(61,null)}}},untrustedWorkspaces:{description:n.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(64,null),n.localize(65,null),n.localize(66,null)]},restrictedConfigurations:{description:n.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(68,null)}}}}},sponsor:{description:n.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(71,null),type:"string"},"vscode:uninstall":{description:n.localize(72,null),type:"string"}}},icon:{type:"string",description:n.localize(73,null)},l10n:{type:"string",description:n.localize(74,null)}}};class E{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const s=new i(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,s),w.activationEventsGenerator&&D.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,f.registerSchema(l,e.schema),s}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=E;const b={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(b.ExtensionsRegistry,new E),e.ExtensionsRegistry=R.Registry.as(b.ExtensionsRegistry),f.registerSchema(l,e.schema),f.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ie[191],Ce([1,0,142,9,23,190,41,5]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var k;(function(f){function v(h,i,o){if(!h)return;const l=T.isString(h.type)?h.type:void 0;if(!l||l.length===0){o.error(n.localize(3,null));return}const E=[];if(Array.isArray(h.required))for(const b of h.required)T.isString(b)&&E.push(b);return{extensionId:i.value,taskType:l,required:E,properties:h.properties?y.deepClone(h.properties):{},when:h.when?C.ContextKeyExpr.deserialize(h.when):void 0}}f.from=v})(k||(k={}));const O=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:n.localize(4,null),type:"array",items:S}});class D{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,h)=>{O.setHandler((i,o)=>{this.c=void 0;try{for(const l of o.removed){const E=l.value;for(const b of E)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const l of o.added){const E=l.value;for(const b of E){const g=k.from(b,l.description.identifier,l.collector);g&&(this.a[g.taskType]=g)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const h of this.all()){const i={type:"object",additionalProperties:!1};h.required.length>0&&(i.required=h.required.slice(0)),h.properties!==void 0?i.properties=y.deepClone(h.properties):i.properties=Object.create(null),i.properties.type={type:"string",enum:[h.taskType]},v.push(i)}this.c={oneOf:v}}return this.c}}e.TaskDefinitionRegistry=new D}),define(Ie[192],Ce([1,0,143,9,22,23,41,191]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function $(z){if(!z)return F.Strong;switch(z.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=$}(S=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var O;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(F){function $(z){switch(z.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=$}(O=e.RevealKind||(e.RevealKind={}));var D;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(D=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function $(z){switch(z.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=$}(D=e.RevealProblemKind||(e.RevealProblemKind={}));var f;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(f=e.PanelKind||(e.PanelKind={})),function(F){function $(z){switch(z.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=$}(f=e.PanelKind||(e.PanelKind={}));var v;(function(F){F.defaults={echo:!0,reveal:O.Always,revealProblems:D.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(v=e.PresentationOptions||(e.PresentationOptions={}));var h;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(h=e.RuntimeType||(e.RuntimeType={})),function(F){function $(K){switch(K.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=$;function z(K){switch(K){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=z}(h=e.RuntimeType||(e.RuntimeType={}));var i;(function(F){function $(z){return T.isString(z)?z:z.value}F.value=$})(i=e.CommandString||(e.CommandString={}));var o;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function $(K){return K===F.Clean._id||K===F.Build._id||K===F.Rebuild._id||K===F.Test._id}F.is=$;function z(K){if(K!==void 0)return T.isString(K)?$(K)?{_id:K,isDefault:!1}:void 0:K}F.from=z})(o=e.TaskGroup||(e.TaskGroup={}));var l;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var E;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function $(z){switch(z){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=$})(E=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(F){F.parallel="parallel",F.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var g;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(g=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:g.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class s{constructor($,z,K,X,Z,he){this._label="",this._id=$,z&&(this._label=z),K&&(this.type=K),this.runOptions=X,this.configurationProperties=Z,this._source=he}getDefinition($){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const $={folder:this.d(),id:this._id};return JSON.stringify($)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches($,z=!1){if($===void 0)return!1;if(T.isString($))return $===this._label||$===this.configurationProperties.identifier||z&&$===this._id;const K=this.getDefinition(!0);return K!==void 0&&K._key===$._key}getQualifiedLabel(){const $=this.getWorkspaceFolder();return $?`${this._label} (${$.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages($){this.c===void 0&&(this.c=[]),$&&(this.c=this.c.concat($))}get taskLoadMessages(){return this.c}}e.CommonTask=s;class r extends s{constructor($,z,K,X,Z,he,oe,ue){super($,K,void 0,oe,ue,z),this.command={},this._source=z,this.hasDefinedMatchers=he,Z&&(this.command=Z)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition($=!1){if($&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case h.Shell:z="shell";break;case h.Process:z="process";break;case h.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is($){return $ instanceof r}getMapKey(){const $=this._source.config.workspaceFolder;return $?`${$.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===E.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let z=this.configurationProperties.identifier;this._source.kind!==E.Workspace&&(z+=this._source.kind);const K={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:z};return JSON.stringify(K)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f($){return new r($._id,$._source,$._label,$.type,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.CustomTask=r;class a extends s{constructor($,z,K,X,Z,he,oe){super($,K,X,he,oe,z),this._source=z,this.configures=Z}static is($){return $ instanceof a}f($){return $}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===E.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let z=this.configurationProperties.identifier;this._source.kind!==E.Workspace&&(z+=this._source.kind);const K={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:z};return JSON.stringify(K)}}e.ConfiguringTask=a;class d extends s{constructor($,z,K,X,Z,he,oe,ue,ce){super($,K,X,ue,ce,z),this.defines=Z,this.hasDefinedMatchers=oe,this.command=he,this.icon=ce.icon,this.hide=ce.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is($){return $ instanceof d}getMapKey(){const $=this._source.workspaceFolder;return $?`${this._source.scope.toString()}|${$.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const $={type:"contributed",scope:this._source.scope,id:this._id};return $.folder=this.d(),JSON.stringify($)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f($){return new d($._id,$._source,$._label,$.type,$.defines,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.ContributedTask=d;class c extends s{constructor($,z,K,X,Z,he){super($,K,X,Z,he,z),this._source=z}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is($){return $ instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f($){return new c($._id,$._source,$._label,$.type,$.runOptions,$.configurationProperties)}}e.InMemoryTask=c;var u;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var t;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(t=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class m{constructor($){this.c=new Map;for(let z=0;z<$.length;z++)this.c.set($[z].uri.toString(),z)}compare($,z){const K=$.getWorkspaceFolder(),X=z.getWorkspaceFolder();if(K&&X){let Z=this.c.get(K.uri.toString());Z=Z===void 0?0:Z+1;let he=this.c.get(X.uri.toString());return he=he===void 0?0:he+1,Z===he?$._label.localeCompare(z._label):Z-he}else return!K&&X?-1:K&&!X?1:0}}e.TaskSorter=m;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var A;(function(F){F.SingleRun="singleRun",F.Background="background"})(A=e.TaskRunType||(e.TaskRunType={}));var N;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(N=e.TaskRunSource||(e.TaskRunSource={}));var q;(function(F){function $(z,K,X,Z){if(K){const he={kind:z,taskId:K._id,taskName:K.configurationProperties.name,runType:K.configurationProperties.isBackground?"background":"singleRun",group:K.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:X,__task:K};return z==="start"?he.resolvedVariables=Z:z==="processStarted"?he.processId=Z:z==="processEnded"&&(he.exitCode=Z),Object.freeze(he)}else return Object.freeze({kind:"changed"})}F.create=$})(q=e.TaskEvent||(e.TaskEvent={}));var j;(function(F){function $(K){const X=Object.keys(K).sort();let Z="";for(const he of X){let oe=K[he];oe instanceof Object?oe=$(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),Z+=he+","+oe+","}return Z}function z(K){const Z={_key:$(K),type:K.taskType};return Object.assign(Z,K),Z}F.create=z})(j=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var P;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(P=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var M;(function(F){function $(z,K){const X=R.TaskDefinitionRegistry.get(z.type);if(X===void 0){const ue=L.deepClone(z);return delete ue._key,j.create(ue)}const Z=Object.create(null);Z.type=X.taskType;const he=new Set;X.required.forEach(ue=>he.add(ue));const oe=X.properties;for(const ue of Object.keys(oe)){const ce=z[ue];if(ce!=null)Z[ue]=ce;else if(he.has(ue)){const fe=oe[ue];if(fe.default!==void 0)Z[ue]=L.deepClone(fe.default);else switch(fe.type){case"boolean":Z[ue]=!1;break;case"number":case"integer":Z[ue]=0;break;case"string":Z[ue]="";break;default:K.error(n.localize(2,null,JSON.stringify(z,void 0,0),ue));return}}}return j.create(Z)}F.createTaskIdentifier=$})(M=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[193],Ce([1,0,11]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,R)=>{this.b=C,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,n.onUnexpectedError)(C))}then(C,R){return this.j().then(C,R)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=T;class y extends T{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=y}),define(Ie[43],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++n.count}}e.ProxyIdentifier=n,n.count=0;const T=[];function y(R){const S=new n(R);return T[S.nid]=S,S}e.createProxyIdentifier=y;function L(R){return T[R].sid}e.getStringIdentifierForProxy=L;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(Ie[4],Ce([1,0,43]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(i){i[i.Default=0]="Default",i[i.InCenter=1]="InCenter",i[i.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",i[i.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(i){i[i.UnknownInput=0]="UnknownInput",i[i.TextInput=1]="TextInput",i[i.TextDiffInput=2]="TextDiffInput",i[i.TextMergeInput=3]="TextMergeInput",i[i.NotebookInput=4]="NotebookInput",i[i.NotebookDiffInput=5]="NotebookDiffInput",i[i.CustomEditorInput=6]="CustomEditorInput",i[i.WebviewEditorInput=7]="WebviewEditorInput",i[i.TerminalEditorInput=8]="TerminalEditorInput",i[i.InteractiveEditorInput=9]="InteractiveEditorInput"})(y=e.TabInputKind||(e.TabInputKind={}));var L;(function(i){i[i.TAB_OPEN=0]="TAB_OPEN",i[i.TAB_CLOSE=1]="TAB_CLOSE",i[i.TAB_UPDATE=2]="TAB_UPDATE",i[i.TAB_MOVE=3]="TAB_MOVE"})(L=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(i){i[i.Editable=0]="Editable",i[i.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(i){i[i.Int8Array=1]="Int8Array",i[i.Uint8Array=2]="Uint8Array",i[i.Uint8ClampedArray=3]="Uint8ClampedArray",i[i.Int16Array=4]="Int16Array",i[i.Uint16Array=5]="Uint16Array",i[i.Int32Array=6]="Int32Array",i[i.Uint32Array=7]="Uint32Array",i[i.Float32Array=8]="Float32Array",i[i.Float64Array=9]="Float64Array",i[i.BigInt64Array=10]="BigInt64Array",i[i.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(i){i[i.Text=1]="Text",i[i.Error=2]="Error",i[i.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(i){i[i.Default=0]="Default",i[i.InCenter=1]="InCenter",i[i.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",i[i.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(i){i[i.None=0]="None",i[i.Process=1]="Process",i[i.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(o){return o._id=D.a++,o}}e.IdObject=D,D.a=0;var f;(function(i){i.label="a",i.kind="b",i.detail="c",i.documentation="d",i.sortText="e",i.filterText="f",i.preselect="g",i.insertText="h",i.insertTextRules="i",i.range="j",i.commitCharacters="k",i.additionalTextEdits="l",i.kindModifier="m",i.commandIdent="n",i.commandId="o",i.commandArguments="p"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(i){i.defaultRanges="a",i.completions="b",i.isIncomplete="c",i.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(i){i[i.Workspace=0]="Workspace",i[i.TextDocument=1]="TextDocument"})(h=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[72],Ce([1,0,3,12,4,14]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,k){this.c=k,this.a=new Set,this.b=S.getProxy(y.MainContext.MainThreadTelemetry)}report(S,k,O){const D=this.d(S,k);this.a.has(D)||(this.a.add(D),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}d(S,k){return`${S}-${k.identifier.value}`}};C=qe([Ve(0,L.IExtHostRpcService),Ve(1,T.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(R,S,k){}})}),define(Ie[194],Ce([1,0,5,4,6,26]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,k,O,D={}){const f=L.ExtensionIdentifier.toKey(S.identifier),v=this.f.get(f)||[],h=[...O].sort().join(" ");let i=v.find(o=>o.providerId===k&&o.scopes===h);if(i)return i.result;{const o=this.g(S,f,k,O,D);i={providerId:k,scopes:h,result:o},v.push(i),this.f.set(f,v);try{await o}finally{const l=v.findIndex(E=>E.providerId===k&&E.scopes===h);l>-1&&(v.splice(l),this.f.set(f,v))}return o}}async g(S,k,O,D,f={}){await this.a.$ensureProvider(O);const v=S.displayName||S.name;return this.a.$getSession(O,D,k,v,f)}async removeSession(S,k){const O=this.b.get(S);return O?O.provider.removeSession(k):this.a.$removeSession(S,k)}registerAuthenticationProvider(S,k,O,D){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:k,provider:O,options:D??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===S)||this.c.push({id:S,label:k});const f=O.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(S,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(S,k,D?.supportsMultipleAccounts??!1),new y.Disposable(()=>{f.dispose(),this.b.delete(S);const v=this.c.findIndex(h=>h.id===S);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const O=this.b.get(S);if(O)return Promise.resolve(O.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const O=this.b.get(S);if(O)return Promise.resolve(O.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const O=this.b.get(S);if(O)return Promise.resolve(O.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this.d.fire({provider:{id:S,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ie[195],Ce([1,0,4,14,8]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(R,S){this.a=R.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>S.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,S,k){const O=y.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};L=qe([Ve(0,T.IExtHostRpcService)],L),e.ExtHostBulkEdits=L}),define(Ie[196],Ce([1,0,4]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(L){const C=L.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(R){return C.$writeText(R)}})}}e.ExtHostClipboard=T});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Ie[38],Ce([1,0,9,6,8,23,4,16,12,80,54,250,2,7,3,14,97,24,43,45]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b){"use strict";var g,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(t,m){g.set(this,void 0),this.b=new Map,this.c=new Map,w.set(this,void 0),Ye(this,g,t.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=m,Ye(this,w,t.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new r(this,p=>{const A=this.c.get(p);return A?.result===d.Void?A:void 0},m),this.f=[{processArgument(p){return(0,k.revive)(p)}},{processArgument(p){return(0,L.cloneAndChange)(p,function(A){if(O.Range.isIRange(A))return y.Range.to(A);if(D.Position.isIPosition(A))return y.Position.to(A);if(O.Range.isIRange(A.range)&&f.URI.isUri(A.uri))return y.location.to(A);if(A instanceof l.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(t){this.f.push(t)}registerApiCommand(t){const m=this.registerCommand(!1,t.id,async(...p)=>{const A=t.args.map((q,j)=>{if(!q.validate(p[j]))throw new Error(`Invalid argument '${q.name}' when running '${t.id}', received: ${p[j]}`);return q.convert(p[j])}),N=await this.executeCommand(t.internalId,...A);return t.result.convert(N,p,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this.c.set(t.id,t),new T.Disposable(()=>{m.dispose(),this.c.delete(t.id)})}registerCommand(t,m,p,A,N,q){if(this.d.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this.b.has(m))throw new Error(`command '${m}' already exists`);return this.b.set(m,{callback:p,thisArg:A,description:N,extension:q}),t&&Re(this,g,"f").$registerCommand(m),new T.Disposable(()=>{this.b.delete(m)&&t&&Re(this,g,"f").$unregisterCommand(m)})}executeCommand(t,...m){return this.d.trace("ExtHostCommands#executeCommand",t),this.g(t,m,!0)}async g(t,m,p){if(this.b.has(t))return Re(this,g,"f").$fireCommandActivationEvent(t),this.h(t,m,!1);{let A=!1;const N=(0,L.cloneAndChange)(m,function(q){if(q instanceof T.Position)return y.Position.from(q);if(q instanceof T.Range)return y.Range.from(q);if(q instanceof T.Location)return y.location.from(q);if(T.NotebookRange.isNotebookRange(q))return y.NotebookRange.from(q);if(q instanceof ArrayBuffer)return A=!0,l.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return A=!0,l.VSBuffer.wrap(q);if(q instanceof l.VSBuffer)return A=!0,q;if(!Array.isArray(q))return q});try{const q=await Re(this,g,"f").$executeCommand(t,A?new E.SerializableObjectWithBuffers(N):N,p);return(0,k.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(t,m,!1);throw q}}}async h(t,m,p){const A=this.b.get(t);if(!A)throw new Error("Unknown command");const{callback:N,thisArg:q,description:j}=A;if(j)for(let P=0;P<j.args.length;P++)try{(0,n.validateConstraint)(m[P],j.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${j.args[P].name}' - ${j.args[P].description}`)}const V=Date.now();try{return await N.apply(q,m)}catch(P){if(t===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...m);M&&(t=M.command)}throw this.d.error(P,t,A.extension?.identifier),p?new class extends Error{constructor(){super((0,b.toErrorMessage)(P)),this.id=t,this.source=A.extension?.displayName??A.extension?.name}}:P}finally{this.j(A,t,Date.now()-V)}}j(t,m,p){!t.extension||t.extension.isBuiltin||Re(this,w,"f").$publicLog2("Extension:ActionExecuted",{extensionId:t.extension.identifier.value,id:m,duration:p})}$executeContributedCommand(t,...m){return this.d.trace("ExtHostCommands#$executeContributedCommand",t),this.b.has(t)?(m=m.map(p=>this.f.reduce((A,N)=>N.processArgument(A),p)),this.h(t,m,!0)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this.d.trace("ExtHostCommands#getCommands",t),Re(this,g,"f").$getCommands().then(m=>(t&&(m=m.filter(p=>p[0]!=="_")),m))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(const[m,p]of this.b){const{description:A}=p;A&&(t[m]=A)}return Promise.resolve(t)}};g=new WeakMap,w=new WeakMap,s=qe([Ve(0,i.IExtHostRpcService),Ve(1,S.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class r{constructor(t,m,p){this.d=t,this.f=m,this.g=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(t,m){if(!t)return;const p={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return p;const A=this.f(t.command);if(A)p.id=A.internalId,p.arguments=A.args.map((N,q)=>N.convert(t.arguments&&t.arguments[q]));else if((0,R.isNonEmptyArray)(t.arguments)){const N=`${t.command}/${++this.c}`;this.b.set(N,t),m.add((0,v.toDisposable)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),p.$ident=N,p.id=this.delegatingCommandId,p.arguments=[N],this.g.trace("CommandsConverter#CREATE",t.command,N)}return p}fromInternal(t){return typeof t.$ident=="string"?this.b.get(t.$ident):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this.b.get(t[0])}h(...t){const m=this.getActualCommand(...t);return this.g.trace("CommandsConverter#EXECUTE",t[0],m?m.command:"MISSING"),m?this.d.executeCommand(m.command,...m.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${t[0]}`)}}e.CommandsConverter=r;class a{constructor(t,m,p,A){this.name=t,this.description=m,this.validate=p,this.convert=A}optional(){return new a(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,m){return new a(t??this.name,m??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",u=>f.URI.isUri(u),u=>u),a.Position=new a("position","A position in a text document",u=>T.Position.isPosition(u),y.Position.from),a.Range=new a("range","A range in a text document",u=>T.Range.isRange(u),y.Range.from),a.Selection=new a("selection","A selection in a text document",u=>T.Selection.isSelection(u),y.Selection.from),a.Number=new a("number","",u=>typeof u=="number",u=>u),a.String=new a("string","",u=>typeof u=="string",u=>u),a.CallHierarchyItem=new a("item","A call hierarchy item",u=>u instanceof T.CallHierarchyItem,y.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",u=>u instanceof T.TypeHierarchyItem,y.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",u=>u instanceof o.TestItemImpl,y.TestItem.from);class d{constructor(t,m){this.description=t,this.convert=m}}e.ApiCommandResult=d,d.Void=new d("no result",u=>u);class c{constructor(t,m,p,A,N){this.id=t,this.internalId=m,this.description=p,this.args=A,this.result=N}}e.ApiCommand=c}),define(Ie[197],Ce([1,0,2,8,6,71,38,16,83,87,13]),function(te,e,n,T,y,L,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",v(T.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,o)=>{if((0,R.isFalsyOrEmpty)(i))return;class l extends y.SymbolInformation{static to(b){const g=new l(b.name,T.SymbolKind.to(b.kind),b.containerName||"",new y.Location(o[0],T.Range.to(b.range)));return g.detail=b.detail,g.range=g.location.range,g.selectionRange=T.Range.to(b.selectionRange),g.children=b.children?b.children.map(l.to):[],g}}return i.map(l.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new C.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(T.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(T.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(o=>y.Position.isPosition(o)),i=>i.map(T.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(o=>{let l;for(const E of o.reverse())l=new y.SelectionRange(T.Range.to(E),l);return l}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(T.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(T.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(T.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(T.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:T.Range.to(i.range),placeholder:i.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return T.WorkspaceEdit.to(i)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(T.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new y.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const o=(0,S.decodeSemanticTokensDto)(i);if(o.type==="full")return new y.SemanticTokens(o.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new y.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const o=(0,S.decodeSemanticTokensDto)(i);if(o.type==="full")return new y.SemanticTokens(o.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,o,l)=>{if(!i)return new y.CompletionList([]);const E=i.suggestions.map(b=>T.CompletionItem.to(b,l));return new y.CompletionList(E,i.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return T.SignatureHelp.to(i)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,o,l)=>v(E=>new y.CodeLens(T.Range.to(E.range),E.command&&l.fromInternal(E.command)))(i))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>y.Range.isRange(i),i=>y.Selection.isSelection(i)?T.Selection.from(i):T.Range.from(i)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,o,l)=>v(E=>{if(E._isSynthetic){if(!E.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(E.command)}else{const b=new y.CodeAction(E.title,E.kind?new y.CodeActionKind(E.kind):void 0);return E.edit&&(b.edit=T.WorkspaceEdit.to(E.edit)),E.command&&(b.command=l.fromInternal(E.command)),b.isPreferred=E.isPreferred,b}})(i))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(o=>new y.ColorInformation(T.Range.to(o.range),T.Color.to(o.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",i=>i instanceof y.Color,T.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:T.Range.from(i.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(T.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,o,l)=>i.map(T.InlayHint.to.bind(void 0,l)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(o=>T.NotebookExclusiveDocumentPattern.to(o))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(T.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",i=>n.URI.isUri(i)||typeof i=="string"&&(0,k.matchesSomeScheme)(i,O.Schemas.http,O.Schemas.https),i=>i),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[T.ViewColumn.from(i),void 0]:[T.ViewColumn.from(i.viewColumn),T.TextEditorOpenOptions.from(i)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[T.ViewColumn.from(i),void 0]:[T.ViewColumn.from(i.viewColumn),T.TextEditorOpenOptions.from(i)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[T.ViewColumn.from(i.viewColumn),T.TextEditorOpenOptions.from(i)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void)];class f{static register(o){D.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=f;function v(i){return o=>{if(Array.isArray(o))return o.map(i)}}function h(i){if(!Array.isArray(i))return;const o=[];for(const l of i)L.isLocationLink(l)?o.push(T.DefinitionLink.to(l)):o.push(T.location.to(l));return o}}),define(Ie[198],Ce([1,0,15,60,5,7,2,71,26,8,6,25,4]),function(te,e,n,T,y,L,C,R,S,k,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(h,i,o){const l=h.getProxy(f.MainContext.MainThreadComments);class E{constructor(){this.b=new Map,this.c=new Map,i.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const t=this.b.get(u.handle);return t?t.value:u}else if(u&&u.$mid===7){const t=this.b.get(u.commentControlHandle);if(!t)return u;const m=t.getCommentThread(u.commentThreadHandle);return m?m.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const t=this.b.get(u.thread.commentControlHandle);if(!t)return u;const m=t.getCommentThread(u.thread.commentThreadHandle);return m?u.$mid===8?m.value:{thread:m.value,text:u.text}:u}else if(u&&u.$mid===10){const t=this.b.get(u.thread.commentControlHandle);if(!t)return u;const m=t.getCommentThread(u.thread.commentThreadHandle);if(!m)return u;const p=u.commentUniqueId,A=m.getCommentByUniqueId(p);return A||u}else if(u&&u.$mid===11){const t=this.b.get(u.thread.commentControlHandle);if(!t)return u;const m=t.getCommentThread(u.thread.commentThreadHandle);if(!m)return u;const p=u.text,A=u.commentUniqueId,N=m.getCommentByUniqueId(A);return N?(typeof N.body=="string"?N.body=p:N.body.value=p,N):u}return u}})}createCommentController(u,t,m){const p=E.a++,A=new g(u,p,t,m);this.b.set(A.handle,A);const N=this.c.get(S.ExtensionIdentifier.toKey(u.identifier))||[];return N.push(A),this.c.set(S.ExtensionIdentifier.toKey(u.identifier),N),A.value}$createCommentThreadTemplate(u,t,m){const p=this.b.get(u);!p||p.$createCommentThreadTemplate(t,m)}async $updateCommentThreadTemplate(u,t,m){const p=this.b.get(u);!p||p.$updateCommentThreadTemplate(t,m)}$deleteCommentThread(u,t){this.b.get(u)?.$deleteCommentThread(t)}$provideCommentingRanges(u,t,m){const p=this.b.get(u);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const A=o.getDocument(C.URI.revive(t));return(0,n.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(A,m)).then(N=>N?N.map(q=>k.Range.from(q)):void 0)}$toggleReaction(u,t,m,p,A){const N=this.b.get(u);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const q=N.getCommentThread(t);if(q){const j=q.getCommentByUniqueId(p.uniqueIdInThread);if(N!==void 0&&j&&N.reactionHandler)return N.reactionHandler(j,r(A))}return Promise.resolve(void 0)})}dispose(){}}E.a=0;class b{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){u.isEqual(this.p)||(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(u){(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,t,m,p,A,N,q,j){this.m=t,this.n=m,this.o=p,this.p=A,this.q=N,this.extensionDescription=q,this.r=j,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new y.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${u}.${this.handle}`),l.$createCommentThread(t,this.handle,this.n,this.o,k.Range.from(this.p),q.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this.i.push({dispose:()=>{l.$deleteCommentThread(t,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(P){V.range=P},get comments(){return V.comments},set comments(P){V.comments=P},get collapsibleState(){return V.collapsibleState},set collapsibleState(P){V.collapsibleState=P},get canReply(){return V.canReply},set canReply(P){V.canReply=P},get contextValue(){return V.contextValue},set contextValue(P){V.contextValue=P},get label(){return V.label},set label(P){V.label=P},get state(){return V.state},set state(P){V.state=P},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const u=m=>Object.prototype.hasOwnProperty.call(this.b,m),t={};u("range")&&(t.range=k.Range.from(this.p)),u("label")&&(t.label=this.label),u("contextValue")&&(t.contextValue=this.contextValue??null),u("comments")&&(t.comments=this.q.map(m=>w(this,m,this.k))),u("collapsibleState")&&(t.collapseState=a(this.g)),u("canReply")&&(t.canReply=this.canReply),u("state")&&(t.state=d(this.h)),u("isTemplate")&&(t.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,t)}getCommentByUniqueId(u){for(const t of this.k){const m=t[0],p=t[1];if(u===p)return m}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}b.a=0,qe([(0,T.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class g{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,l.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,t,m,p){this.f=u,this.g=t,this.h=m,this.i=p,this.a=new Map,l.$registerCommentController(this.handle,m,p);const A=this;this.value=Object.freeze({id:A.id,label:A.label,get options(){return A.options},set options(N){A.options=N},get commentingRangeProvider(){return A.commentingRangeProvider},set commentingRangeProvider(N){A.commentingRangeProvider=N},get reactionHandler(){return A.reactionHandler},set reactionHandler(N){A.reactionHandler=N},createCommentThread(N,q,j){return A.createCommentThread(N,q,j).value},dispose:()=>{A.dispose()}}),this.e=[],this.e.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(u,t,m,p){if(typeof u=="string"){const A=new b(this.id,this.handle,u,t,m,p,this.f,!1);return this.a.set(A.handle,A),A}else{const A=new b(this.id,this.handle,void 0,u,t,m,this.f,!1);return this.a.set(A.handle,A),A}}$createCommentThreadTemplate(u,t){const m=new b(this.id,this.handle,void 0,C.URI.revive(u),k.Range.to(t),[],this.f,!0);return m.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(m.handle,m),m}$updateCommentThreadTemplate(u,t){const m=this.a.get(u);m&&(m.range=k.Range.to(t))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function w(c,u,t){let m=t.get(u);m||(m=++c.commentHandle,t.set(u,m));const p=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:m,body:typeof u.body=="string"?u.body:k.MarkdownString.from(u.body),userName:u.author.name,userIconPath:p,label:u.label,commentReactions:u.reactions?u.reactions.map(A=>s(A)):void 0,timestamp:u.timestamp?.toJSON()}}function s(c){return{label:c.label,iconPath:c.iconPath?k.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?C.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function a(c){if(c!==void 0)switch(c){case O.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function d(c){if(c!==void 0)switch(c){case O.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new E}e.createExtHostComments=v}),define(Ie[199],Ce([1,0,23,4,27,14]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(O,D){this.a=O.getProxy(T.MainContext.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,D){const f=this,v=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){f.e(O,D,v,arguments)}})}e(O,D,f,v){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:S(v,this.b)}),this.c&&this.f(O,f,v)}};C=qe([Ve(0,L.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const R=1e5;function S(k,O){const D=[];if(k.length)for(let f=0;f<k.length;f++){let v=k[f];if(typeof v>"u")v="undefined";else if(v instanceof Error){const h=v;h.stack?v=h.stack:v=h.toString()}D.push(v)}if(O){const f=new Error().stack;f&&D.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,n.safeStringify)(D);return f.length>R?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Ie[99],Ce([1,0,2,4,6,3,14,12,16,10,19,25]),function(te,e,n,T,y,L,C,R,S,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let f=class Ai{constructor(h,i){this.h=i,this.f=new Map,this.g=h.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,i){const o=Ai.c++;this.f.set(o,{provider:h,extensionDescription:i}),this.g.$registerDecorationProvider(o,i.identifier.value);const l=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(E=>{if(!E){this.g.$onDidChange(o,null);return}const b=(0,S.asArray)(E);if(b.length<=Ai.d){this.g.$onDidChange(o,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",i.identifier.value,b.length);const g=b.map(r=>({uri:r,rank:(0,k.count)(r.path,"/")})),w=(0,S.groupBy)(g,(r,a)=>r.rank-a.rank||(0,k.compare)(r.uri.path,a.uri.path)),s=[];e:for(const r of w){let a;for(const d of r){const c=(0,O.dirname)(d.uri.path);if(a!==c&&(a=c,s.push(d.uri)>=Ai.d))break e}}this.g.$onDidChange(o,s)});return new y.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(h,i,o){if(!this.f.has(h))return Object.create(null);const l=Object.create(null),{provider:E,extensionDescription:b}=this.f.get(h);return await Promise.all(i.map(async g=>{try{const{uri:w,id:s}=g,r=await Promise.resolve(E.provideFileDecoration(n.URI.revive(w),o));if(!r)return;try{y.FileDecoration.validate(r),r.badge&&typeof r.badge!="string"&&(0,D.checkProposedApiEnabled)(b,"codiconDecoration"),l[s]=[r.propagate,r.tooltip,r.badge,r.color]}catch(a){this.h.warn(`INVALID decoration from extension '${b}': ${a}`)}}catch(w){this.h.error(w)}})),l}};f.c=0,f.d=250,f=qe([Ve(0,C.IExtHostRpcService),Ve(1,R.ILogService)],f),e.ExtHostDecorations=f,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Ie[200],Ce([1,0,132,86,2,4,6,8,5,12,28,37]),function(te,e,n,T,y,L,C,R,S,k,O,D){"use strict";var f,v,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class i{constructor(E,b,g,w,s,r,a){this.d=E,this.e=b,this.f=g,this.g=w,f.set(this,void 0),v.set(this,void 0),h.set(this,void 0),this.c=!1,Ye(this,h,new O.ResourceMap(d=>s.getComparisonKey(d)),"f"),Ye(this,f,r,"f"),Ye(this,v,a,"f")}dispose(){this.c||(Re(this,v,"f").fire([...Re(this,h,"f").keys()]),Re(this,f,"f")?.$clear(this.e),Re(this,h,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(E,b){if(!E){this.clear();return}this.h();let g=[];if(y.URI.isUri(E)){if(!b){this.delete(E);return}Re(this,h,"f").set(E,b.slice()),g=[E]}else if(Array.isArray(E)){g=[];let s;E=[...E].sort(i.j);for(const r of E){const[a,d]=r;if((!s||a.toString()!==s.toString())&&(s&&Re(this,h,"f").get(s).length===0&&Re(this,h,"f").delete(s),s=a,g.push(a),Re(this,h,"f").set(a,[])),d)Re(this,h,"f").get(a)?.push(...d);else{const c=Re(this,h,"f").get(a);c&&(c.length=0)}}}if(Re(this,v,"f").fire(g),!Re(this,f,"f"))return;const w=[];for(const s of g){let r=[];const a=Re(this,h,"f").get(s);if(a)if(a.length>this.f){r=[];const d=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const u of a)if(u.severity===d[c]&&r.push({...R.Diagnostic.from(u),modelVersionId:this.g(s)})===this.f)break e;r.push({severity:T.MarkerSeverity.Info,message:(0,n.localize)(0,null,a.length-this.f),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=a.map(d=>({...R.Diagnostic.from(d),modelVersionId:this.g(s)}));w.push([s,r])}Re(this,f,"f").$changeMany(this.e,w)}delete(E){this.h(),Re(this,v,"f").fire([E]),Re(this,h,"f").delete(E),Re(this,f,"f")?.$changeMany(this.e,[[E,void 0]])}clear(){this.h(),Re(this,v,"f").fire([...Re(this,h,"f").keys()]),Re(this,h,"f").clear(),Re(this,f,"f")?.$clear(this.e)}forEach(E,b){this.h();for(const[g,w]of this)E.call(b,g,w,this)}*[(f=new WeakMap,v=new WeakMap,h=new WeakMap,Symbol.iterator)](){this.h();for(const E of Re(this,h,"f").keys())yield[E,this.get(E)]}get(E){this.h();const b=Re(this,h,"f").get(E);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(E){return this.h(),Array.isArray(Re(this,h,"f").get(E))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(E,b){return E[0].toString()<b[0].toString()?-1:E[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=i;let o=class gi{static _mapper(E){const b=new O.ResourceMap;for(const g of E)b.set(g,g);return{uris:Object.freeze(Array.from(b.values()))}}constructor(E,b,g,w){this.h=b,this.j=g,this.k=w,this.f=new Map,this.g=new S.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,gi._mapper),this.e=E.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(E,b){const{f:g,e:w,g:s,h:r,j:a,k:d}=this,c=new class{$changeMany(m,p){w.$changeMany(m,p),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",E.value,m,p.length===0?"CLEARING":p)}$clear(m){w.$clear(m),r.trace("[DiagnosticCollection] remove all (extension, owner)",E.value,m)}dispose(){w.dispose()}};let u;if(!b)b="_generated_diagnostic_collection_name_#"+gi.c++,u=b;else if(!g.has(b))u=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do u=b+gi.c++;while(g.has(u))}return new class extends i{constructor(){super(b,u,gi.d,m=>d.getDocument(m)?.version,a.extUri,c,s),g.set(u,this)}dispose(){super.dispose(),g.delete(u)}}}getDiagnostics(E){if(E)return this.l(E);{const b=new Map,g=[];for(const w of this.f.values())w.forEach((s,r)=>{let a=b.get(s.toString());typeof a>"u"&&(a=g.length,b.set(s.toString(),a),g.push([s,[]])),g[a][1]=g[a][1].concat(...r)});return g}}l(E){let b=[];for(const g of this.f.values())g.has(E)&&(b=b.concat(g.get(E)));return b}$acceptMarkersChange(E){if(!this.m){const b="_generated_mirror",g=new i(b,b,gi.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(b,g),this.m=g}for(const[b,g]of E)this.m.set(y.URI.revive(b),g.map(R.Diagnostic.to))}};o.c=0,o.d=1e3,o=qe([Ve(1,k.ILogService),Ve(2,D.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(Ie[201],Ce([1,0,2,4]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(C){this.a=C.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(R=>R?R.map(S=>n.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(R=>R?n.URI.revive(R):void 0)}}e.ExtHostDialogs=y}),define(Ie[202],Ce([1,0,11,2,6,4,13,20,10]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(D,f,v){this.d=f,this.e=v,this.b=new Map,this.c=D.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,f){if(Object.keys(C.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const v=k.a++;this.b.set(v,f),this.c.$registerTextContentProvider(v,D);let h;return typeof f.onDidChange=="function"&&(h=f.onDidChange(i=>{if(i.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${i.scheme}' which will be IGNORED`);return}this.d.getDocument(i)&&this.$provideTextDocumentContent(v,i).then(o=>{if(!o&&typeof o!="string")return;const l=this.d.getDocument(i);if(!l)return;const E=(0,S.splitLines)(o);if(!l.equalLines(E))return this.c.$onVirtualDocumentChange(i,o)},n.onUnexpectedError)})),new y.Disposable(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(D,f){const v=this.b.get(D);return v?Promise.resolve(v.provideTextDocumentContent(T.URI.revive(f),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=k,k.a=0}),define(Ie[203],Ce([1,0,5,7,2,4,95,8,9,23,6]),function(te,e,n,T,y,L,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(v,h){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.DisposableStore,this.h=new Map,this.f=v.getProxy(L.MainContext.MainThreadDocuments),this.g=h,this.g.onDidRemoveDocuments(i=>{for(const o of i)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(i=>{for(const o of i)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const h=this.g.getDocument(v);if(h)return h}getDocument(v){const h=this.getDocumentData(v);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return h.document}ensureDocumentData(v){const h=this.g.getDocument(v);if(h)return Promise.resolve(h);let i=this.h.get(v.toString());return i||(i=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const l=y.URI.revive(o);return(0,S.assertIsDefined)(this.g.getDocument(l))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),i)),i}createDocumentData(v){return this.f.$tryCreateDocument(v).then(h=>y.URI.revive(h))}$acceptModelLanguageChanged(v,h){const i=y.URI.revive(v),o=this.g.getDocument(i);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(h),this.a.fire(o.document)}$acceptModelSaved(v){const h=y.URI.revive(v),i=this.g.getDocument(h);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(i.document)}$acceptDirtyStateChanged(v,h){const i=y.URI.revive(v),o=this.g.getDocument(i);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,h,i){const o=y.URI.revive(v),l=this.g.getDocument(o);if(!l)throw new Error("unknown document");l._acceptIsDirty(i),l.onEvents(h);let E;h.isUndoing?E=O.TextDocumentChangeReason.Undo:h.isRedoing&&(E=O.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:l.document,contentChanges:h.changes.map(b=>({range:R.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:E}))}setWordDefinitionFor(v,h){(0,C.setWordDefinitionFor)(v,h)}}e.ExtHostDocuments=D}),define(Ie[55],Ce([1,0,47,5,7,2,3,4,95,14,98,8,12,28,13,172,204]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(g){this.value=g,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let E=class{constructor(g,w){this.h=g,this.i=w,this.a=null,this.b=new Map,this.c=new v.ResourceMap,this.d=new T.Emitter,this.e=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const w=[],s=[],r=[];if(g.removedDocuments)for(const a of g.removedDocuments){const d=L.URI.revive(a),c=this.c.get(d);c?.unref()&&(this.c.delete(d),w.push(c.value))}if(g.addedDocuments)for(const a of g.addedDocuments){const d=L.URI.revive(a.uri);let c=this.c.get(d);if(c&&d.scheme!==h.Schemas.vscodeNotebookCell&&d.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);c||(c=new l(new S.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(d,c),s.push(c.value)),c.ref()}if(g.removedEditors)for(const a of g.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&r.push(d)}if(g.addedEditors)for(const a of g.addedEditors){const d=L.URI.revive(a.documentUri);n.ok(this.c.has(d),`document '${d}' does not exist`),n.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const c=this.c.get(d).value,u=new O.ExtHostTextEditor(a.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>c.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(t=>D.Range.to(t)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,u)}g.newActiveEditor!==void 0&&(n.ok(g.newActiveEditor===null||this.b.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this.a=g.newActiveEditor),(0,y.dispose)(w),(0,y.dispose)(r),g.removedDocuments&&this.e.fire(w),g.addedDocuments&&this.d.fire(s),(g.removedEditors||g.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),g.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(g){return this.c.get(g)?.value}allDocuments(){return i.Iterable.map(this.c.values(),g=>g.value)}getEditor(g){return this.b.get(g)}activeEditor(g){if(!this.a)return;const w=this.b.get(this.a);return g?w:w?.value}allEditors(){return[...this.b.values()]}};E=qe([Ve(0,k.IExtHostRpcService),Ve(1,f.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[56],Ce([1,0,8,4,2,5,3,6,14,9,78]),function(te,e,n,T,y,L,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class D{constructor(o,l,E){this.e=E,this.d=l,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(y.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(y.URI.revive(this.b.input.base),y.URI.revive(this.b.input.input1),y.URI.revive(this.b.input.input2),y.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(y.URI.revive(this.b.input.uri),y.URI.revive(this.b.input.inputBoxUri));default:return}}}class f{constructor(o,l){this.c=[],this.d="",this.b=o,this.e=l;for(const E of o.tabs)E.isActive&&(this.d=E.id),this.c.push(new D(E,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return n.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(E=>E.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(E=>E.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const E=new D(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,E),o.tabDto.isActive&&(this.d=E.tabId),E}else if(o.kind===1){const E=this.c.splice(o.index,1)[0];if(!E)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return E.tabId===this.d&&(this.d=""),E}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const E=this.c.splice(o.oldIndex,1)[0];if(!E)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,E),E}const l=this.c.find(E=>E.tabId===o.tabDto.id);if(!l)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(o.tabDto),l}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=o.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,l={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(E=>E.apiObject))},get activeTabGroup(){const E=o.d;return(0,k.assertIsDefined)(o.e.find(g=>g.groupId===E)?.apiObject)},close:async(E,b)=>{const g=Array.isArray(E)?E:[E];return g.length?h(g[0])?this.j(g,b):this.i(g,b):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(o){const l=new Set(this.e.map(a=>a.groupId)),E=new Set(o.map(a=>a.groupId)),b=(0,O.diffSets)(l,E),g=this.e.filter(a=>b.removed.includes(a.groupId)).map(a=>a.apiObject),w=[],s=[];this.e=o.map(a=>{const d=new f(a,()=>this.d);return b.added.includes(d.groupId)?w.push(d.apiObject):s.push(d.apiObject),d});const r=(0,k.assertIsDefined)(o.find(a=>a.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:w,closed:g,changed:s}))}$acceptTabGroupUpdate(o){const l=this.e.find(E=>E.groupId===o.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const l=this.e.find(b=>b.groupId===o.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const E=l.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[E.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[E.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[E.apiObject]}));return}}g(o){for(const l of this.e)for(const E of l.tabs)if(E.apiObject===o)return E}h(o){return this.e.find(l=>l.apiObject===o)}async i(o,l){const E=[];for(const b of o){const g=this.g(b);if(!g)throw new Error("Tab close: Invalid tab not found!");E.push(g.tabId)}return this.a.$closeTab(E,l)}async j(o,l){const E=[];for(const b of o){const g=this.h(b);if(!g)throw new Error("Group close: Invalid group not found!");E.push(g.groupId)}return this.a.$closeGroup(E,l)}};v=qe([Ve(0,S.IExtHostRpcService)],v),e.ExtHostEditorTabs=v;function h(i){return i.tabs!==void 0}}),define(Ie[205],Ce([1,0,2,4,7,6,8,251,10,24,25]),function(te,e,n,T,y,L,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const i=this.a.indexOf(h);i>=0&&(this.a.splice(i,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),i=[];let o,l,E=14,b=14;for(const g of h){let w=o?(0,S.commonPrefixLength)(o,g):0;for(w===0?l=1:l=b;w<g.length;w++)w+1===g.length?(E=b,b=9):b+=1,i.push([l,g.toUpperCase().charCodeAt(w),b]),i.push([l,g.toLowerCase().charCodeAt(w),b]),l=b;o=g,b=E}i.push([9,58,10]),i.push([10,47,12]),this.b=new R.StateMachine(i)}}provideDocumentLinks(h){this.c();const i=[],o=R.LinkComputer.computeLinks({getLineContent(l){return h.lineAt(l-1).text},getLineCount(){return h.lineCount}},this.b);for(const l of o){const E=C.DocumentLink.to(l);E.target&&i.push(E)}return i}}class f{constructor(h,i){this.i=i,this.b=new D,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,i,o,l={}){if(this.d.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const E=this.h++;this.b.add(i),this.d.add(i),this.c.set(E,o);let b=2;l.isCaseSensitive&&(b+=1024),l.isReadonly&&(b+=2048),typeof o.copy=="function"&&(b+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,O.checkProposedApiEnabled)(h,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(E,i,b).catch(w=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${i}`),console.error(w)});const g=o.onDidChangeFile(w=>{const s=[];for(const r of w){const{uri:a,type:d}=r;if(a.scheme!==i)continue;let c;switch(d){case L.FileChangeType.Changed:c=0;break;case L.FileChangeType.Created:c=1;break;case L.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:a,type:c})}this.a.$onFileSystemChange(E,s)});return(0,y.toDisposable)(()=>{g.dispose(),this.b.delete(i),this.d.delete(i),this.c.delete(E),this.a.$unregisterProvider(E)})}static j(h){const{type:i,ctime:o,mtime:l,size:E,permissions:b}=h;return{type:i,ctime:o,mtime:l,size:E,permissions:b}}$stat(h,i){return Promise.resolve(this.k(h).stat(n.URI.revive(i))).then(o=>f.j(o))}$readdir(h,i){return Promise.resolve(this.k(h).readDirectory(n.URI.revive(i)))}$readFile(h,i){return Promise.resolve(this.k(h).readFile(n.URI.revive(i))).then(o=>k.VSBuffer.wrap(o))}$writeFile(h,i,o,l){return Promise.resolve(this.k(h).writeFile(n.URI.revive(i),o.buffer,l))}$delete(h,i,o){return Promise.resolve(this.k(h).delete(n.URI.revive(i),o))}$rename(h,i,o,l){return Promise.resolve(this.k(h).rename(n.URI.revive(i),n.URI.revive(o),l))}$copy(h,i,o,l){const E=this.k(h);if(!E.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(E.copy(n.URI.revive(i),n.URI.revive(o),l))}$mkdir(h,i){return Promise.resolve(this.k(h).createDirectory(n.URI.revive(i)))}$watch(h,i,o,l){const E=this.k(h).watch(n.URI.revive(o),l);this.f.set(i,E)}$unwatch(h,i){const o=this.f.get(i);o&&(o.dispose(),this.f.delete(i))}$open(h,i,o){const l=this.k(h);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(n.URI.revive(i),o))}$close(h,i){const o=this.k(h);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(i))}$read(h,i,o,l){const E=this.k(h);if(!E.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(l);return Promise.resolve(E.read(i,o,b.buffer,0,l)).then(g=>b.slice(0,g))}$write(h,i,o,l){const E=this.k(h);if(!E.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(E.write(i,o,l.buffer,0,l.byteLength))}k(h){const i=this.c.get(h);if(!i){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return i}}e.ExtHostFileSystem=f}),define(Ie[57],Ce([1,0,4,36,6,24,3,14,37,7]),function(te,e,n,T,y,L,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Jt{constructor(f,v){this.b=new Map,this.a=f.getProxy(n.MainContext.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(i){try{const o=h.b.get(i.scheme);if(!o)return await h.a.$stat(i);await h.a.$ensureActivation(i.scheme);const l=await o.stat(i);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(o){Jt.c(o)}},async readDirectory(i){try{const o=h.b.get(i.scheme);return o?(await h.a.$ensureActivation(i.scheme),(await o.readDirectory(i)).slice()):await h.a.$readdir(i)}catch(o){return Jt.c(o)}},async createDirectory(i){try{return await h.a.$mkdir(i)}catch(o){return Jt.c(o)}},async readFile(i){try{const o=h.b.get(i.scheme);return o?(await h.a.$ensureActivation(i.scheme),(await o.readFile(i)).slice()):(await h.a.$readFile(i)).buffer}catch(o){return Jt.c(o)}},async writeFile(i,o){try{return await h.a.$writeFile(i,L.VSBuffer.wrap(o))}catch(l){return Jt.c(l)}},async delete(i,o){try{const l=h.b.get(i.scheme);return l?(await h.a.$ensureActivation(i.scheme),await l.delete(i,{recursive:!1,...o})):await h.a.$delete(i,{recursive:!1,useTrash:!1,...o})}catch(l){return Jt.c(l)}},async rename(i,o,l){try{return await h.a.$rename(i,o,{overwrite:!1,...l})}catch(E){return Jt.c(E)}},async copy(i,o,l){try{return await h.a.$copy(i,o,{overwrite:!1,...l})}catch(E){return Jt.c(E)}},isWritableFileSystem(i){const o=v.getCapabilities(i);if(typeof o=="number")return!(o&2048)}})}static c(f){if(f instanceof y.FileSystemError)throw f;if(!(f instanceof Error))throw new y.FileSystemError(String(f));if(f.name==="ENOPRO")throw y.FileSystemError.Unavailable(f.message);switch(f.name){case T.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(f.message);default:throw new y.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,v){return this.b.set(f,v),(0,k.toDisposable)(()=>this.b.delete(f))}};O=qe([Ve(0,R.IExtHostRpcService),Ve(1,S.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[206],Ce([1,0,5,35,2,4,8,6]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(D,f,v,h,i,o,l,E){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const b=this.h(D,v,i);this.g=0,o&&(this.g+=1),l&&(this.g+=2),E&&(this.g+=4);const g=(0,T.parse)(i),w=typeof i=="string",s=h(r=>{if(!o)for(const a of r.created){const d=y.URI.revive(a);g(d.fsPath)&&(!w||f.getWorkspaceFolder(d))&&this.a.fire(d)}if(!l)for(const a of r.changed){const d=y.URI.revive(a);g(d.fsPath)&&(!w||f.getWorkspaceFolder(d))&&this.b.fire(d)}if(!E)for(const a of r.deleted){const d=y.URI.revive(a);g(d.fsPath)&&(!w||f.getWorkspaceFolder(d))&&this.c.fire(d)}});this.d=R.Disposable.from(b,this.a,this.b,this.c,s)}h(D,f,v){const h=R.Disposable.from();if(typeof v=="string")return h;const i=D.getProxy(L.MainContext.MainThreadFileSystem);let o=!1;(v.pattern.includes(T.GLOBSTAR)||v.pattern.includes(T.GLOB_SPLIT))&&(o=!0);const l=Math.random();return i.$watch(f.identifier.value,l,v.baseUri,{recursive:o,excludes:[]}),R.Disposable.from({dispose:()=>i.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(D,f,v){this.j=D,this.k=f,this.l=v,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,f,v,h,i,o){return new S(this.j,D,f,this.a.event,C.GlobPattern.from(v),h,i,o)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,f){switch(D){case 2:this.b.fire(Object.freeze({files:f.map(v=>({oldUri:y.URI.revive(v.source),newUri:y.URI.revive(v.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(v=>y.URI.revive(v.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(v=>y.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,f){return(v,h,i)=>{const o=function(E){v.call(h,E)};return o.extension=D,f.event(o,void 0,i)}}async $onWillRunFileOperation(D,f,v,h){switch(D){case 2:return await this.n(this.g,{files:f.map(i=>({oldUri:y.URI.revive(i.source),newUri:y.URI.revive(i.target)}))},v,h);case 1:return await this.n(this.i,{files:f.map(i=>y.URI.revive(i.target))},v,h);case 0:case 3:return await this.n(this.h,{files:f.map(i=>y.URI.revive(i.target))},v,h)}}async n(D,f,v,h){const i=new Set,o=[];if(await D.fireAsync(f,h,async(E,b)=>{const g=Date.now(),w=await Promise.resolve(E);w instanceof R.WorkspaceEdit&&(o.push([b.extension,w]),i.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-g>v&&this.k.warn("SLOW file-participant",b.extension.identifier)}),h.isCancellationRequested||o.length===0)return;const l={edits:[]};for(const[,E]of o){const{edits:b}=C.WorkspaceEdit.from(E,{getTextDocumentVersion:g=>this.l.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(b)}return{edit:l,extensionNames:Array.from(i)}}}e.ExtHostFileSystemEventService=k}),define(Ie[207],Ce([1,0,2,38]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(C,R,S,k,O){this.a=R,this.b=S,this.c=k;const D=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new T.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new T.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new T.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new T.ApiCommandResult("Notebook and input URI",f=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const v=this.a.getEditorById(f.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri),notebookEditor:v.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(C,R,S,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=y}),define(Ie[208],Ce([1,0,7,4]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(C){this.b=0,this.a=C.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,C),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=y}),define(Ie[209],Ce([1,0,2,23,8,6,71,4,10,54,16,9,252,20,7,83,79,51,210,11,15,25]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(I,U){this.d=I,this.e=U}async provideDocumentSymbols(I,U){const H=this.d.getDocument(I),G=await this.e.provideDocumentSymbols(H,U);if(!(0,O.isFalsyOrEmpty)(G))return G[0]instanceof L.DocumentSymbol?G.map(y.DocumentSymbol.from):s.f(G)}static f(I){I=I.slice(0).sort((G,ee)=>{let le=G.location.range.start.compareTo(ee.location.range.start);return le===0&&(le=ee.location.range.end.compareTo(G.location.range.end)),le});const U=[],H=[];for(const G of I){const ee={name:G.name||"!!MISSING: name!!",kind:y.SymbolKind.from(G.kind),tags:G.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:y.Range.from(G.location.range),selectionRange:y.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(ee),U.push(ee);break}const le=H[H.length-1];if(k.Range.containsRange(le.range,ee.range)&&!k.Range.equalsRange(le.range,ee.range)){le.children?.push(ee),H.push(ee);break}H.pop()}}return U}}class r{constructor(I,U,H){this.g=I,this.h=U,this.j=H,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,U){const H=this.g.getDocument(I),G=await this.j.provideCodeLenses(H,U);if(!G||U.isCancellationRequested)return;const ee=this.e.add(G),le=new h.DisposableStore;this.f.set(ee,le);const Se={cacheId:ee,lenses:[]};for(let se=0;se<G.length;se++)Se.lenses.push({cacheId:[ee,se],range:y.Range.from(G[se].range),command:this.h.toInternal(G[se].command,le)});return Se}async resolveCodeLens(I,U){const H=I.cacheId&&this.e.get(...I.cacheId);if(!H)return;let G;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.j.resolveCodeLens(H,U),G||(G=H),U.isCancellationRequested)return;const ee=I.cacheId&&this.f.get(I.cacheId[0]);if(!!ee)return I.command=this.h.toInternal(G.command??r.d,ee),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}r.d={command:"missing",title:"!!MISSING: command!!"};function a(J){return Array.isArray(J)?J.map(y.DefinitionLink.from):J?[y.DefinitionLink.from(J)]:[]}class d{constructor(I,U){this.d=I,this.e=U}async provideDefinition(I,U,H){const G=this.d.getDocument(I),ee=y.Position.to(U),le=await this.e.provideDefinition(G,ee,H);return a(le)}}class c{constructor(I,U){this.d=I,this.e=U}async provideDeclaration(I,U,H){const G=this.d.getDocument(I),ee=y.Position.to(U),le=await this.e.provideDeclaration(G,ee,H);return a(le)}}class u{constructor(I,U){this.d=I,this.e=U}async provideImplementation(I,U,H){const G=this.d.getDocument(I),ee=y.Position.to(U),le=await this.e.provideImplementation(G,ee,H);return a(le)}}class t{constructor(I,U){this.d=I,this.e=U}async provideTypeDefinition(I,U,H){const G=this.d.getDocument(I),ee=y.Position.to(U),le=await this.e.provideTypeDefinition(G,ee,H);return a(le)}}class m{constructor(I,U){this.d=I,this.e=U}async provideHover(I,U,H){const G=this.d.getDocument(I),ee=y.Position.to(U),le=await this.e.provideHover(G,ee,H);if(!(!le||(0,O.isFalsyOrEmpty)(le.contents)))return le.range||(le.range=G.getWordRangeAtPosition(ee)),le.range||(le.range=new L.Range(ee,ee)),y.Hover.from(le)}}class p{constructor(I,U){this.d=I,this.e=U}async provideEvaluatableExpression(I,U,H){const G=this.d.getDocument(I),ee=y.Position.to(U),le=await this.e.provideEvaluatableExpression(G,ee,H);if(le)return y.EvaluatableExpression.from(le)}}class A{constructor(I,U){this.d=I,this.e=U}async provideInlineValues(I,U,H,G){const ee=this.d.getDocument(I),le=await this.e.provideInlineValues(ee,y.Range.to(U),y.InlineValueContext.to(H),G);if(Array.isArray(le))return le.map(Se=>y.InlineValue.from(Se))}}class N{constructor(I,U){this.d=I,this.e=U}async provideDocumentHighlights(I,U,H){const G=this.d.getDocument(I),ee=y.Position.to(U),le=await this.e.provideDocumentHighlights(G,ee,H);if(Array.isArray(le))return le.map(y.DocumentHighlight.from)}}class q{constructor(I,U){this.d=I,this.e=U}async provideLinkedEditingRanges(I,U,H){const G=this.d.getDocument(I),ee=y.Position.to(U),le=await this.e.provideLinkedEditingRanges(G,ee,H);if(le&&Array.isArray(le.ranges))return{ranges:(0,O.coalesce)(le.ranges.map(y.Range.from)),wordPattern:le.wordPattern}}}class j{constructor(I,U){this.d=I,this.e=U}async provideReferences(I,U,H,G){const ee=this.d.getDocument(I),le=y.Position.to(U),Se=await this.e.provideReferences(ee,le,H,G);if(Array.isArray(Se))return Se.map(y.location.from)}}class V{constructor(I,U,H,G,ee,le,Se){this.g=I,this.h=U,this.j=H,this.k=G,this.l=ee,this.m=le,this.n=Se,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,U,H,G){const ee=this.g.getDocument(I),le=f.Selection.isISelection(U)?y.Selection.to(U):y.Range.to(U),Se=[];for(const tt of this.j.getDiagnostics(I))if(le.intersection(tt.range)&&Se.push(tt)>V.d)break;const se={diagnostics:Se,only:H.only?new L.CodeActionKind(H.only):void 0,triggerKind:y.CodeActionTriggerKind.to(H.trigger)},ve=await this.k.provideCodeActions(ee,le,se,G);if(!(0,O.isNonEmptyArray)(ve)||G.isCancellationRequested)return;const be=this.e.add(ve),$e=new h.DisposableStore;this.f.set(be,$e);const He=[];for(let tt=0;tt<ve.length;tt++){const xe=ve[tt];!xe||(V.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,$e)})):(se.only&&(xe.kind?se.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${se.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${se.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[be,tt],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,$e),diagnostics:xe.diagnostics&&xe.diagnostics.map(y.Diagnostic.from),edit:xe.edit&&y.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,disabled:xe.disabled?.reason})))}return{cacheId:be,actions:He}}async resolveCodeAction(I,U){const[H,G]=I,ee=this.e.get(H,G);if(!ee||V.o(ee)||!this.k.resolveCodeAction)return;const le=await this.k.resolveCodeAction(ee,U)??ee;return le?.edit?y.WorkspaceEdit.from(le.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}V.d=1e3;class P{constructor(I,U,H,G){this.d=I,this.e=U,this.f=H,this.g=G}async prepareDocumentPaste(I,U,H,G){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(I),le=U.map(se=>y.Range.to(se)),Se=y.DataTransfer.toDataTransfer(H,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(ee,le,Se,G),y.DataTransfer.toDataTransferDTO(Se)}async providePasteEdits(I,U,H,G,ee){const le=this.e.getDocument(U),Se=H.map(be=>y.Range.to(be)),se=y.DataTransfer.toDataTransfer(G,async be=>(await this.d.$resolvePasteFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentPasteEdits(le,Se,se,ee);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?y.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class M{constructor(I,U){this.d=I,this.e=U}async provideDocumentFormattingEdits(I,U,H){const G=this.d.getDocument(I),ee=await this.e.provideDocumentFormattingEdits(G,U,H);if(Array.isArray(ee))return ee.map(y.TextEdit.from)}}class F{constructor(I,U){this.d=I,this.e=U}async provideDocumentRangeFormattingEdits(I,U,H,G){const ee=this.d.getDocument(I),le=y.Range.to(U),Se=await this.e.provideDocumentRangeFormattingEdits(ee,le,H,G);if(Array.isArray(Se))return Se.map(y.TextEdit.from)}}class ${constructor(I,U){this.d=I,this.e=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,U,H,G,ee){const le=this.d.getDocument(I),Se=y.Position.to(U),se=await this.e.provideOnTypeFormattingEdits(le,Se,H,G,ee);if(Array.isArray(se))return se.map(y.TextEdit.from)}}class z{constructor(I,U){this.e=I,this.f=U,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,U){const H=await this.e.provideWorkspaceSymbols(I,U);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const G=this.d.add(H),ee={cacheId:G,symbols:[]};for(let le=0;le<H.length;le++){const Se=H[le];if(!Se||!Se.name){this.f.warn("INVALID SymbolInformation",Se);continue}ee.symbols.push({...y.WorkspaceSymbol.from(Se),cacheId:[G,le]})}return ee}async resolveWorkspaceSymbol(I,U){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this.d.get(...I.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,U);return G&&(0,T.mixin)(I,y.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class K{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,U,H){this.d=I,this.e=U,this.f=H}async provideRenameEdits(I,U,H,G){const ee=this.d.getDocument(I),le=y.Position.to(U);try{const Se=await this.e.provideRenameEdits(ee,le,H,G);return Se?y.WorkspaceEdit.from(Se):void 0}catch(Se){const se=K.g(Se);return se?{rejectReason:se,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation(I,U,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(I),ee=y.Position.to(U);try{const le=await this.e.prepareRename(G,ee,H);let Se,se;if(L.Range.isRange(le)?(Se=le,se=G.getText(le)):(0,D.isObject)(le)&&(Se=le.range,se=le.placeholder),!Se||!se)return;if(Se.start.line>ee.line||Se.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(Se),text:se}}catch(le){const Se=K.g(le);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(le)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class X{constructor(I,U){this.resultId=I,this.tokens=U}}class Z{constructor(I,U){this.f=I,this.g=U,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,U,H){const G=this.f.getDocument(I),ee=U!==0?this.d.get(U):null;let le=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,ee.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return ee&&this.d.delete(U),le?(le=Z.h(le),this.o(Z.n(ee,le),le)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return Z.j(I)?Z.k(I)?I:new L.SemanticTokens(new Uint32Array(I.data),I.resultId):Z.l(I)?Z.m(I)?I:new L.SemanticTokensEdits(I.edits.map(U=>new L.SemanticTokensEdit(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const U of I.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static n(I,U){if(!Z.j(U)||!I||!I.tokens)return U;const H=I.tokens,G=H.length,ee=U.data,le=ee.length;let Se=0;const se=Math.min(G,le);for(;Se<se&&H[Se]===ee[Se];)Se++;if(Se===G&&Se===le)return new L.SemanticTokensEdits([],U.resultId);let ve=0;const be=se-Se;for(;ve<be&&H[G-ve-1]===ee[le-ve-1];)ve++;return new L.SemanticTokensEdits([{start:Se,deleteCount:G-Se-ve,data:ee.subarray(Se,le-ve)}],U.resultId)}o(I,U){if(Z.j(I)){const H=this.e++;return this.d.set(H,new X(I.resultId,I.data)),(0,i.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(Z.l(I)){const H=this.e++;return Z.j(U)?this.d.set(H,new X(U.resultId,U.data)):this.d.set(H,new X(I.resultId)),(0,i.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class he{constructor(I,U){this.d=I,this.e=U}async provideDocumentRangeSemanticTokens(I,U,H){const G=this.d.getDocument(I),ee=await this.e.provideDocumentRangeSemanticTokens(G,y.Range.to(U),H);return ee?this.f(ee):null}f(I){return(0,i.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class oe{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,U,H,G,ee){this.f=I,this.g=U,this.h=H,this.j=G,this.k=ee,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,U,H,G){const ee=this.f.getDocument(I),le=y.Position.to(U),Se=ee.getWordRangeAtPosition(le)||new L.Range(le,le),se=Se.with({end:le}),ve=new E.StopWatch(!0),be=await this.h.provideCompletionItems(ee,le,G,y.CompletionContext.to(H));if(!be||G.isCancellationRequested)return;const $e=Array.isArray(be)?new L.CompletionList(be):be,He=oe.supportsResolving(this.h)?this.d.add($e.items):this.d.add([]),tt=new h.DisposableStore;this.e.set(He,tt);const xe=[],et={x:He,b:xe,a:{replace:y.Range.from(Se),insert:y.Range.from(se)},c:$e.isIncomplete||void 0,d:ve.elapsed()};for(let it=0;it<$e.items.length;it++){const dt=$e.items[it],Fe=this.l(dt,[He,it],se,Se);xe.push(Fe)}return et}async resolveCompletionItem(I,U){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...I);if(!H)return;const G=await this.h.resolveCompletionItem(H,U);if(!!G)return this.l(G,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,U,H,G){const ee=this.e.get(U[0]);if(!ee)throw Error("DisposableStore is missing...");const le=this.g.toInternal(I.command,ee),Se={x:U,a:I.label,b:I.kind!==void 0?y.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(y.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:y.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(y.TextEdit.from),n:le?.$ident,o:le?.id,p:le?.$ident?void 0:le?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Se.h=I.textEdit.newText):typeof I.insertText=="string"?Se.h=I.insertText:I.insertText instanceof L.SnippetString&&(Se.h=I.insertText.value,Se.i|=4);let se;return I.textEdit?se=I.textEdit.range:I.range&&(se=I.range),L.Range.isRange(se)?Se.j=y.Range.from(se):se&&(!H?.isEqual(se.inserting)||!G?.isEqual(se.replacing))&&(Se.j={insert:y.Range.from(se.inserting),replace:y.Range.from(se.replacing)}),Se}}class ue{async provideInlineCompletions(I,U,H,G){}disposeCompletions(I){}handleDidShowCompletionItem(I,U){}}class ce extends ue{constructor(I,U,H,G){super(),this.f=I,this.g=U,this.h=H,this.j=G,this.d=new fe,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,U,H,G){const ee=this.g.getDocument(I),le=y.Position.to(U),Se=await this.h.provideInlineCompletionItems(ee,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:y.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!Se||G.isCancellationRequested)return;const se=Array.isArray(Se)?Se:Se.items,ve=this.e?Array.isArray(Se)?[]:Se.commands||[]:[];let be;return{pid:this.d.createReferenceId({dispose(){be?.dispose()},items:se}),items:se.map((He,tt)=>{let xe;He.command&&(be||(be=new h.DisposableStore),xe=this.j.toInternal(He.command,be));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?y.Range.from(He.range):void 0,command:xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:ve.map(He=>(be||(be=new h.DisposableStore),this.j.toInternal(He,be)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,U){const H=this.d.get(I)?.items[U];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}}class fe{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const U=this.e++;return this.d.set(U,I),U}disposeReferenceId(I){const U=this.d.get(I);return this.d.delete(I),U}get(I){return this.d.get(I)}}class Y{constructor(I,U){this.e=I,this.f=U,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(I,U,H,G){const ee=this.e.getDocument(I),le=y.Position.to(U),Se=this.g(H),se=await this.f.provideSignatureHelp(ee,le,G,Se);if(se){const ve=this.d.add([se]);return{...y.SignatureHelp.from(se),id:ve}}}g(I){let U;if(I.activeSignatureHelp){const H=y.SignatureHelp.to(I.activeSignatureHelp),G=this.d.get(I.activeSignatureHelp.id,0);G?(U=G,U.activeSignature=H.activeSignature,U.activeParameter=H.activeParameter):U=H}return{...I,activeSignatureHelp:U}}releaseSignatureHelp(I){this.d.delete(I)}}class ge{constructor(I,U,H,G,ee){this.f=I,this.g=U,this.h=H,this.j=G,this.k=ee,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,U,H){const G=this.f.getDocument(I),ee=y.Range.to(U),le=await this.h.provideInlayHints(G,ee,H);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${U}`);return}if(H.isCancellationRequested)return;const Se=this.d.add(le);this.e.set(Se,new h.DisposableStore);const se={hints:[],cacheId:Se};for(let ve=0;ve<le.length;ve++)this.l(le[ve],ee)&&se.hints.push(this.m(le[ve],[Se,ve]));return this.j.trace(`[InlayHints] ${se.hints.length} inlay hints from '${this.k.identifier.value}' for ${U}`),se}async resolveInlayHint(I,U){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...I);if(!H)return;const G=await this.h.resolveInlayHint(H,U);if(!!G&&!!this.l(G))return this.m(G,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,U){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(U&&!U.contains(I.position))}m(I,U){const H=this.e.get(U[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:U,tooltip:y.MarkdownString.fromStrict(I.tooltip),position:y.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(y.TextEdit.from),kind:I.kind&&y.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?G.label=I.label:G.label=I.label.map(ee=>{const le={label:ee.value};return le.tooltip=y.MarkdownString.fromStrict(ee.tooltip),L.Location.isLocation(ee.location)&&(le.location=y.location.from(ee.location)),ee.command&&(le.command=this.g.toInternal(ee.command,H)),le}),G}}class we{constructor(I,U){this.e=I,this.f=U,this.d=new l.Cache("DocumentLink")}async provideLinks(I,U){const H=this.e.getDocument(I),G=await this.f.provideDocumentLinks(H,U);if(!(!Array.isArray(G)||G.length===0)&&!U.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(we.g).map(y.DocumentLink.from)};{const ee=this.d.add(G),le={links:[],cacheId:ee};for(let Se=0;Se<G.length;Se++){if(!we.g(G[Se]))continue;const se=y.DocumentLink.from(G[Se]);se.cacheId=[ee,Se],le.links.push(se)}return le}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,U){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...I);if(!H)return;const G=await this.f.resolveDocumentLink(H,U);if(!(!G||!we.g(G)))return y.DocumentLink.from(G)}releaseLinks(I){this.d.delete(I)}}class Me{constructor(I,U){this.d=I,this.e=U}async provideColors(I,U){const H=this.d.getDocument(I),G=await this.e.provideDocumentColors(H,U);return Array.isArray(G)?G.map(le=>({color:y.Color.from(le.color),range:y.Range.from(le.range)})):[]}async provideColorPresentations(I,U,H){const G=this.d.getDocument(I),ee=y.Range.to(U.range),le=y.Color.to(U.color),Se=await this.e.provideColorPresentations(le,{document:G,range:ee},H);if(!!Array.isArray(Se))return Se.map(y.ColorPresentation.from)}}class We{constructor(I,U){this.d=I,this.e=U}async provideFoldingRanges(I,U,H){const G=this.d.getDocument(I),ee=await this.e.provideFoldingRanges(G,U,H);if(!!Array.isArray(ee))return ee.map(y.FoldingRange.from)}}class Qe{constructor(I,U,H){this.d=I,this.e=U,this.f=H}async provideSelectionRanges(I,U,H){const G=this.d.getDocument(I),ee=U.map(y.Position.to),le=await this.e.provideSelectionRanges(G,ee,H);if(!(0,O.isNonEmptyArray)(le))return[];if(le.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let se=0;se<ee.length;se++){const ve=[];Se.push(ve);let be=ee[se],$e=le[se];for(;;){if(!$e.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(y.SelectionRange.from($e)),!$e.parent)break;be=$e.range,$e=$e.parent}}return Se}}class Te{constructor(I,U){this.f=I,this.g=U,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,U,H){const G=this.f.getDocument(I),ee=y.Position.to(U),le=await this.g.prepareCallHierarchy(G,ee,H);if(!le)return;const Se=this.d.nextId();return this.e.set(Se,new Map),Array.isArray(le)?le.map(se=>this.h(Se,se)):[this.h(Se,le)]}async provideCallsTo(I,U,H){const G=this.j(I,U);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(G,H);if(!!ee)return ee.map(le=>({from:this.h(I,le.from),fromRanges:le.fromRanges.map(Se=>y.Range.from(Se))}))}async provideCallsFrom(I,U,H){const G=this.j(I,U);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(!!ee)return ee.map(le=>({to:this.h(I,le.to),fromRanges:le.fromRanges.map(Se=>y.Range.from(Se))}))}releaseSession(I){this.e.delete(I)}h(I,U){const H=this.e.get(I),G=y.CallHierarchyItem.from(U,I,H.size.toString(36));return H.set(G._itemId,U),G}j(I,U){return this.e.get(I)?.get(U)}}class De{constructor(I,U){this.f=I,this.g=U,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,U,H){const G=this.f.getDocument(I),ee=y.Position.to(U),le=await this.g.prepareTypeHierarchy(G,ee,H);if(!le)return;const Se=this.d.nextId();return this.e.set(Se,new Map),Array.isArray(le)?le.map(se=>this.h(Se,se)):[this.h(Se,le)]}async provideSupertypes(I,U,H){const G=this.j(I,U);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(G,H);if(!!ee)return ee.map(le=>this.h(I,le))}async provideSubtypes(I,U,H){const G=this.j(I,U);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(G,H);if(!!ee)return ee.map(le=>this.h(I,le))}releaseSession(I){this.e.delete(I)}h(I,U){const H=this.e.get(I),G=y.TypeHierarchyItem.from(U,I,H.size.toString(36));return H.set(G._itemId,U),G}j(I,U){return this.e.get(I)?.get(U)}}class ke{constructor(I,U,H,G){this.d=I,this.e=U,this.f=H,this.g=G}async provideDocumentOnDropEdits(I,U,H,G,ee){const le=this.e.getDocument(U),Se=y.Position.to(H),se=y.DataTransfer.toDataTransfer(G,async be=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentDropEdits(le,Se,se,ee);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?y.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class re{constructor(I,U){this.adapter=I,this.extension=U}}class ae{constructor(I,U,H,G,ee,le,Se,se){this.g=U,this.h=H,this.j=G,this.k=ee,this.l=le,this.m=Se,this.n=se,this.f=new Map,this.e=I.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(I){return y.DocumentSelector.from(I,this.g)}p(I){return new L.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ae.d++}async s(I,U,H,G,ee,le=!1){const Se=this.f.get(I);if(!Se||!(Se.adapter instanceof U))return G;const se=Date.now();le||this.l.trace(`[${Se.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ve=H(Se.adapter,Se.extension);return Promise.resolve(ve).catch(be=>{(0,b.isCancellationError)(be)||(this.l.error(`[${Se.extension.identifier.value}] provider FAILED`),this.l.error(be),this.n.onExtensionError(Se.extension.identifier,be))}).finally(()=>{le||this.l.trace(`[${Se.extension.identifier.value}] provider DONE after ${Date.now()-se}ms`)}),v.CancellationToken.isCancellationToken(ee)?(0,g.raceCancellationError)(ve,ee):ve}t(I,U){const H=this.q();return this.f.set(H,new re(I,U)),H}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,U,H,G){const ee=this.t(new s(this.h,H),I),le=G&&G.label||ae.u(I);return this.e.$registerDocumentSymbolProvider(ee,this.o(U),le),this.p(ee)}$provideDocumentSymbols(I,U,H){return this.s(I,s,G=>G.provideDocumentSymbols(n.URI.revive(U),H),void 0,H)}registerCodeLensProvider(I,U,H){const G=this.q(),ee=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new re(new r(this.h,this.j.converter,H),I)),this.e.$registerCodeLensSupport(G,this.o(U),ee);let le=this.p(G);if(ee!==void 0){const Se=H.onDidChangeCodeLenses(se=>this.e.$emitCodeLensEvent(ee));le=L.Disposable.from(le,Se)}return le}$provideCodeLenses(I,U,H){return this.s(I,r,G=>G.provideCodeLenses(n.URI.revive(U),H),void 0,H)}$resolveCodeLens(I,U,H){return this.s(I,r,G=>G.resolveCodeLens(U,H),void 0,void 0)}$releaseCodeLenses(I,U){this.s(I,r,H=>Promise.resolve(H.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(I,U,H){const G=this.t(new d(this.h,H),I);return this.e.$registerDefinitionSupport(G,this.o(U)),this.p(G)}$provideDefinition(I,U,H,G){return this.s(I,d,ee=>ee.provideDefinition(n.URI.revive(U),H,G),[],G)}registerDeclarationProvider(I,U,H){const G=this.t(new c(this.h,H),I);return this.e.$registerDeclarationSupport(G,this.o(U)),this.p(G)}$provideDeclaration(I,U,H,G){return this.s(I,c,ee=>ee.provideDeclaration(n.URI.revive(U),H,G),[],G)}registerImplementationProvider(I,U,H){const G=this.t(new u(this.h,H),I);return this.e.$registerImplementationSupport(G,this.o(U)),this.p(G)}$provideImplementation(I,U,H,G){return this.s(I,u,ee=>ee.provideImplementation(n.URI.revive(U),H,G),[],G)}registerTypeDefinitionProvider(I,U,H){const G=this.t(new t(this.h,H),I);return this.e.$registerTypeDefinitionSupport(G,this.o(U)),this.p(G)}$provideTypeDefinition(I,U,H,G){return this.s(I,t,ee=>ee.provideTypeDefinition(n.URI.revive(U),H,G),[],G)}registerHoverProvider(I,U,H,G){const ee=this.t(new m(this.h,H),I);return this.e.$registerHoverProvider(ee,this.o(U)),this.p(ee)}$provideHover(I,U,H,G){return this.s(I,m,ee=>ee.provideHover(n.URI.revive(U),H,G),void 0,G)}registerEvaluatableExpressionProvider(I,U,H,G){const ee=this.t(new p(this.h,H),I);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(U)),this.p(ee)}$provideEvaluatableExpression(I,U,H,G){return this.s(I,p,ee=>ee.provideEvaluatableExpression(n.URI.revive(U),H,G),void 0,G)}registerInlineValuesProvider(I,U,H,G){const ee=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,le=this.t(new A(this.h,H),I);this.e.$registerInlineValuesProvider(le,this.o(U),ee);let Se=this.p(le);if(ee!==void 0){const se=H.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(ee));Se=L.Disposable.from(Se,se)}return Se}$provideInlineValues(I,U,H,G,ee){return this.s(I,A,le=>le.provideInlineValues(n.URI.revive(U),H,G,ee),void 0,ee)}registerDocumentHighlightProvider(I,U,H){const G=this.t(new N(this.h,H),I);return this.e.$registerDocumentHighlightProvider(G,this.o(U)),this.p(G)}$provideDocumentHighlights(I,U,H,G){return this.s(I,N,ee=>ee.provideDocumentHighlights(n.URI.revive(U),H,G),void 0,G)}registerLinkedEditingRangeProvider(I,U,H){const G=this.t(new q(this.h,H),I);return this.e.$registerLinkedEditingRangeProvider(G,this.o(U)),this.p(G)}$provideLinkedEditingRanges(I,U,H,G){return this.s(I,q,async ee=>{const le=await ee.provideLinkedEditingRanges(n.URI.revive(U),H,G);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?ae.w(le.wordPattern):void 0}},void 0,G)}registerReferenceProvider(I,U,H){const G=this.t(new j(this.h,H),I);return this.e.$registerReferenceSupport(G,this.o(U)),this.p(G)}$provideReferences(I,U,H,G,ee){return this.s(I,j,le=>le.provideReferences(n.URI.revive(U),H,G,ee),void 0,ee)}registerCodeActionProvider(I,U,H,G){const ee=new h.DisposableStore,le=this.t(new V(this.h,this.j.converter,this.k,H,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(le,this.o(U),{providedKinds:G?.providedCodeActionKinds?.map(Se=>Se.value),documentation:G?.documentation?.map(Se=>({kind:Se.kind.value,command:this.j.converter.toInternal(Se.command,ee)}))},ae.u(I),Boolean(H.resolveCodeAction)),ee.add(this.p(le)),ee}$provideCodeActions(I,U,H,G,ee){return this.s(I,V,le=>le.provideCodeActions(n.URI.revive(U),H,G,ee),void 0,ee)}$resolveCodeAction(I,U,H){return this.s(I,V,G=>G.resolveCodeAction(U,H),void 0,void 0)}$releaseCodeActions(I,U){this.s(I,V,H=>Promise.resolve(H.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(I,U,H){const G=this.t(new M(this.h,H),I);return this.e.$registerDocumentFormattingSupport(G,this.o(U),I.identifier,I.displayName||I.name),this.p(G)}$provideDocumentFormattingEdits(I,U,H,G){return this.s(I,M,ee=>ee.provideDocumentFormattingEdits(n.URI.revive(U),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(I,U,H){const G=this.t(new F(this.h,H),I);return this.e.$registerRangeFormattingSupport(G,this.o(U),I.identifier,I.displayName||I.name),this.p(G)}$provideDocumentRangeFormattingEdits(I,U,H,G,ee){return this.s(I,F,le=>le.provideDocumentRangeFormattingEdits(n.URI.revive(U),H,G,ee),void 0,ee)}registerOnTypeFormattingEditProvider(I,U,H,G){const ee=this.t(new $(this.h,H),I);return this.e.$registerOnTypeFormattingSupport(ee,this.o(U),G,I.identifier),this.p(ee)}$provideOnTypeFormattingEdits(I,U,H,G,ee,le){return this.s(I,$,Se=>Se.provideOnTypeFormattingEdits(n.URI.revive(U),H,G,ee,le),void 0,le)}registerWorkspaceSymbolProvider(I,U){const H=this.t(new z(U,this.l),I);return this.e.$registerNavigateTypeSupport(H,typeof U.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(I,U,H){return this.s(I,z,G=>G.provideWorkspaceSymbols(U,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,U,H){return this.s(I,z,G=>G.resolveWorkspaceSymbol(U,H),void 0,void 0)}$releaseWorkspaceSymbols(I,U){this.s(I,z,H=>H.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(I,U,H){const G=this.t(new K(this.h,H,this.l),I);return this.e.$registerRenameSupport(G,this.o(U),K.supportsResolving(H)),this.p(G)}$provideRenameEdits(I,U,H,G,ee){return this.s(I,K,le=>le.provideRenameEdits(n.URI.revive(U),H,G,ee),void 0,ee)}$resolveRenameLocation(I,U,H,G){return this.s(I,K,ee=>ee.resolveRenameLocation(n.URI.revive(U),H,G),void 0,G)}registerDocumentSemanticTokensProvider(I,U,H,G){const ee=this.t(new Z(this.h,H),I),le=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(U),G,le);let Se=this.p(ee);if(le){const se=H.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(le));Se=L.Disposable.from(Se,se)}return Se}$provideDocumentSemanticTokens(I,U,H,G){return this.s(I,Z,ee=>ee.provideDocumentSemanticTokens(n.URI.revive(U),H,G),null,G)}$releaseDocumentSemanticTokens(I,U){this.s(I,Z,H=>H.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,U,H,G){const ee=this.t(new he(this.h,H),I);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(U),G),this.p(ee)}$provideDocumentRangeSemanticTokens(I,U,H,G){return this.s(I,he,ee=>ee.provideDocumentRangeSemanticTokens(n.URI.revive(U),H,G),null,G)}registerCompletionItemProvider(I,U,H,G){const ee=this.t(new oe(this.h,this.j.converter,H,this.m,I),I);return this.e.$registerCompletionsProvider(ee,this.o(U),G,oe.supportsResolving(H),`${I.identifier.value}(${G.join("")})`),this.p(ee)}$provideCompletionItems(I,U,H,G,ee){return this.s(I,oe,le=>le.provideCompletionItems(n.URI.revive(U),H,G,ee),void 0,ee)}$resolveCompletionItem(I,U,H){return this.s(I,oe,G=>G.resolveCompletionItem(U,H),void 0,H)}$releaseCompletionItems(I,U){this.s(I,oe,H=>H.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(I,U,H){const G=new ce(I,this.h,H,this.j.converter),ee=this.t(G,I);return this.e.$registerInlineCompletionsSupport(ee,this.o(U),G.supportsHandleDidShowCompletionItem),this.p(ee)}$provideInlineCompletions(I,U,H,G,ee){return this.s(I,ue,le=>le.provideInlineCompletions(n.URI.revive(U),H,G,ee),void 0,ee)}$handleInlineCompletionDidShow(I,U,H){this.s(I,ue,async G=>{G.handleDidShowCompletionItem(U,H)},void 0,void 0)}$freeInlineCompletionsList(I,U){this.s(I,ue,async H=>{H.disposeCompletions(U)},void 0,void 0)}registerSignatureHelpProvider(I,U,H,G){const ee=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,le=this.t(new Y(this.h,H),I);return this.e.$registerSignatureHelpProvider(le,this.o(U),ee),this.p(le)}$provideSignatureHelp(I,U,H,G,ee){return this.s(I,Y,le=>le.provideSignatureHelp(n.URI.revive(U),H,G,ee),void 0,ee)}$releaseSignatureHelp(I,U){this.s(I,Y,H=>H.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(I,U,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ge(this.h,this.j.converter,H,this.l,I),I);this.e.$registerInlayHintsProvider(ee,this.o(U),typeof H.resolveInlayHint=="function",G,ae.u(I));let le=this.p(ee);if(G!==void 0){const Se=H.onDidChangeInlayHints(se=>this.e.$emitInlayHintsEvent(G));le=L.Disposable.from(le,Se)}return le}$provideInlayHints(I,U,H,G){return this.s(I,ge,ee=>ee.provideInlayHints(n.URI.revive(U),H,G),void 0,G)}$resolveInlayHint(I,U,H){return this.s(I,ge,G=>G.resolveInlayHint(U,H),void 0,H)}$releaseInlayHints(I,U){this.s(I,ge,H=>H.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(I,U,H){const G=this.t(new we(this.h,H),I);return this.e.$registerDocumentLinkProvider(G,this.o(U),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(I,U,H){return this.s(I,we,G=>G.provideLinks(n.URI.revive(U),H),void 0,H,U.scheme==="output")}$resolveDocumentLink(I,U,H){return this.s(I,we,G=>G.resolveLink(U,H),void 0,void 0,!0)}$releaseDocumentLinks(I,U){this.s(I,we,H=>H.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(I,U,H){const G=this.t(new Me(this.h,H),I);return this.e.$registerDocumentColorProvider(G,this.o(U)),this.p(G)}$provideDocumentColors(I,U,H){return this.s(I,Me,G=>G.provideColors(n.URI.revive(U),H),[],H)}$provideColorPresentations(I,U,H,G){return this.s(I,Me,ee=>ee.provideColorPresentations(n.URI.revive(U),H,G),void 0,G)}registerFoldingRangeProvider(I,U,H){const G=this.q(),ee=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new re(new We(this.h,H),I)),this.e.$registerFoldingRangeProvider(G,this.o(U),I.identifier,ee);let le=this.p(G);if(ee!==void 0){const Se=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));le=L.Disposable.from(le,Se)}return le}$provideFoldingRanges(I,U,H,G){return this.s(I,We,ee=>ee.provideFoldingRanges(n.URI.revive(U),H,G),void 0,G)}registerSelectionRangeProvider(I,U,H){const G=this.t(new Qe(this.h,H,this.l),I);return this.e.$registerSelectionRangeProvider(G,this.o(U)),this.p(G)}$provideSelectionRanges(I,U,H,G){return this.s(I,Qe,ee=>ee.provideSelectionRanges(n.URI.revive(U),H,G),[],G)}registerCallHierarchyProvider(I,U,H){const G=this.t(new Te(this.h,H),I);return this.e.$registerCallHierarchyProvider(G,this.o(U)),this.p(G)}$prepareCallHierarchy(I,U,H,G){return this.s(I,Te,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(U),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(I,U,H,G){return this.s(I,Te,ee=>ee.provideCallsTo(U,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(I,U,H,G){return this.s(I,Te,ee=>ee.provideCallsFrom(U,H,G),void 0,G)}$releaseCallHierarchy(I,U){this.s(I,Te,H=>Promise.resolve(H.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(I,U,H){const G=this.t(new De(this.h,H),I);return this.e.$registerTypeHierarchyProvider(G,this.o(U)),this.p(G)}$prepareTypeHierarchy(I,U,H,G){return this.s(I,De,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(U),H,G)),void 0,G)}$provideTypeHierarchySupertypes(I,U,H,G){return this.s(I,De,ee=>ee.provideSupertypes(U,H,G),void 0,G)}$provideTypeHierarchySubtypes(I,U,H,G){return this.s(I,De,ee=>ee.provideSubtypes(U,H,G),void 0,G)}$releaseTypeHierarchy(I,U){this.s(I,De,H=>Promise.resolve(H.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(I,U,H){const G=this.q();return this.f.set(G,new re(new ke(this.e,this.h,H,G),I)),this.e.$registerDocumentOnDropEditProvider(G,this.o(U)),this.p(G)}$provideDocumentOnDropEdits(I,U,H,G,ee,le){return this.s(I,ke,Se=>Promise.resolve(Se.provideDocumentOnDropEdits(U,n.URI.revive(H),G,ee,le)),void 0,void 0)}registerDocumentPasteEditProvider(I,U,H,G){const ee=this.q();return this.f.set(ee,new re(new P(this.e,this.h,H,ee),I)),this.e.$registerPasteEditProvider(ee,this.o(U),!!H.prepareDocumentPaste,G.pasteMimeTypes),this.p(ee)}$prepareDocumentPaste(I,U,H,G,ee){return this.s(I,P,le=>le.prepareDocumentPaste(n.URI.revive(U),H,G,ee),void 0,ee)}$providePasteEdits(I,U,H,G,ee,le){return this.s(I,P,Se=>Se.providePasteEdits(U,n.URI.revive(H),G,ee,le),void 0,le)}static w(I){return{pattern:I.source,flags:(0,S.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ae.w(I.decreaseIndentPattern),increaseIndentPattern:ae.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ae.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ae.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ae.w(I.beforeText),afterText:I.afterText?ae.w(I.afterText):void 0,previousLineText:I.previousLineText?ae.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ae.z)}setLanguageConfiguration(I,U,H){const{wordPattern:G}=H;if(G&&(0,S.regExpLeadsToEndlessLoop)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(U,G):this.h.setWordDefinitionFor(U,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const ee=this.q(),le={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ae.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ae.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ae.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(ee,U,le),this.p(ee)}$setWordDefinitions(I){for(const U of I)this.h.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.ExtHostLanguageFeatures=ae,ae.d=0}),define(Ie[211],Ce([1,0,4,8,6,29,15,7]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(O,D,f,v){this.c=D,this.d=f,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,D){await this.a.$changeLanguage(O,D);const f=this.c.getDocumentData(O);if(!f)throw new Error(`document '${O.toString()}' NOT found`);return f.document}async tokenAtPosition(O,D){const f=O.version,v=T.Position.from(D),h=await this.a.$tokensAtPosition(O.uri,v),i={type:y.StandardTokenType.Other,range:O.getWordRangeAtPosition(D)??new y.Range(D.line,D.character,D.line,D.character)};if(!h)return i;const o={range:T.Range.to(h.range),type:T.TokenType.to(h.type)};return!o.range.contains(D)||f!==O.version?i:o}createLanguageStatusItem(O,D,f){const v=this.f++,h=this.a,i=this.g,o=`${O.identifier.value}/${D}`;if(i.has(o))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);i.add(o);const l={selector:f,id:D,name:O.displayName??O.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let E;const b=new R.DisposableStore,g=()=>{E?.dispose(),E=(0,C.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(v,{id:o,name:l.name??O.displayName??O.name,source:O.displayName??O.name,selector:T.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===y.LanguageStatusSeverity.Error?L.default.Error:l.severity===y.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:l.command&&this.d.toInternal(l.command,b),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},w={dispose(){b.dispose(),E?.dispose(),h.$removeLanguageStatus(v),i.delete(o)},get id(){return l.id},get name(){return l.name},set name(s){l.name=s,g()},get selector(){return l.selector},set selector(s){l.selector=s,g()},get text(){return l.text},set text(s){l.text=s,g()},get detail(){return l.detail},set detail(s){l.detail=s,g()},get severity(){return l.severity},set severity(s){l.severity=s,g()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(s){l.accessibilityInformation=s,g()},get command(){return l.command},set command(s){l.command=s,g()},get busy(){return l.busy},set busy(s){l.busy=s,g()}};return g(),w}}e.ExtHostLanguages=S}),define(Ie[73],Ce([1,0,21,10,2,3,12,4,27,14]),function(te,e,n,T,y,L,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(f,v,h){this.f=h,this.d=new Map,this.a=v.getProxy(R.MainContext.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(f,v){const{message:h,args:i,comment:o}=v;if(this.c)return(0,T.format2)(h,i??{});let l=h;o&&o.length>0&&(l+=`/${Array.isArray(o)?o.join():o}`);const E=this.d.get(f)?.contents[l];return E||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,T.format2)(E??h,i??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let v;const h=await this.g(f);if(!h){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const i=await this.a.$fetchBundleContents(h),o=JSON.parse(i);v=f.isBuiltin?o.contents?.bundle:o}catch(i){this.f.error(`Failed to load translations for ${f.identifier.value} from ${h}: ${i.message}`);return}v&&this.d.set(f.identifier.value,{contents:v,uri:h})}async g(f){if(f.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(f.identifier.value);return y.URI.revive(v)}return f.l10n?y.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=qe([Ve(0,S.IExtHostInitDataService),Ve(1,k.IExtHostRpcService),Ve(2,C.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Ie[212],Ce([1,0,12,4,27,14,2,5,9]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends n.AbstractLoggerService{constructor(f,v){super(v.logLevel,R.Event.None),this.g=f.getProxy(T.MainContext.MainThreadLogger)}$setLevel(f,v){v?this.setLevel(C.URI.revive(v),f):(0,S.isUndefined)(f)||this.setLevel(f)}f(f,v,h){return new O(this.g,f,v,h)}};k=qe([Ve(0,L.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class O extends n.AbstractMessageLogger{constructor(f,v,h,i){super(i?.always),this.m=f,this.n=v,this.k=!1,this.l=[],this.setLevel(h),this.m.$createLogger(v,i).then(()=>{this.r(this.l),this.k=!0})}g(f,v){const h=[[f,v]];this.k?this.r(h):this.l.push(...h)}r(f){this.m.$log(this.n,f)}}}),define(Ie[213],Ce([1,0,4,12,25]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(R){return R&&R.title}let C=class{constructor(S,k){this.b=k,this.a=S.getProxy(n.MainContext.MainThreadMessageService)}showMessage(S,k,O,D,f){const v={source:{identifier:S.identifier,label:S.displayName||S.name}};let h;typeof D=="string"||L(D)?h=[D,...f]:(v.modal=D?.modal,v.useCustom=D?.useCustom,v.detail=D?.detail,h=f),v.useCustom&&(0,y.checkProposedApiEnabled)(S,"resolvers");const i=[];for(let o=0;o<h.length;o++){const l=h[o];if(typeof l=="string")i.push({title:l,handle:o,isCloseAffordance:!1});else if(typeof l=="object"){const{title:E,isCloseAffordance:b}=l;i.push({title:E,isCloseAffordance:!!b,handle:o})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(k,O,v,i).then(o=>{if(typeof o=="number")return h[o]})}};C=qe([Ve(1,T.ILogService)],C),e.ExtHostMessageService=C}),define(Ie[214],Ce([1,0,24,5,7,28,10,9,2,51,4,38,8,6,43,186,96]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,g,w,s){this.q=w,this.r=s,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new T.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new T.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new T.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(O.MainContext.MainThreadNotebook),this.c=b.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const a=r.notebookEditor?.notebookUri,d=r.cell.handle,u=this.g.get(a)?.getCell(d);if(u)return u.apiCell}if(r&&r.$mid===14){const a=r.uri,d=this.g.get(a);if(d)return d.apiNotebook}return r}}),l.x(g)}getEditorById(b){const g=this.h.get(b);if(!g)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(b){for(const[g,w]of this.h)if(w.apiEditor===b)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,g){const w=this.g.get(b);if(!w&&!g)throw new Error(`NO notebook document for '${b}'`);return w}static s(b,g){if(!g)return;const w=g.filenamePattern.map(s=>f.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(g.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:g.displayName,filenamePattern:w,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,g,w){const s=l.a++,r=typeof w.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(s,w),this.b.$registerNotebookCellStatusBarItemProvider(s,r,g);let a;return r!==void 0&&(a=w.onDidChangeCellStatusBarItems(d=>this.b.$emitCellStatusBarEvent(r))),new v.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,r),a?.dispose()})}async createNotebookDocument(b){const g=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&f.NotebookData.from(b.content)});return S.URI.revive(g)}async openNotebookDocument(b){const g=this.g.get(b);if(g)return g.apiNotebook;const w=await this.c.$tryOpenNotebook(b),s=this.g.get(S.URI.revive(w));return(0,R.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(b,g){S.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let w;typeof g=="object"?w={position:f.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(f.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:w={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,w),r=s&&this.h.get(s)?.apiEditor;if(r)return r;throw s?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,g,w,s){const r=this.f.get(b),a=S.URI.revive(g),d=this.g.get(a);if(!d||!r)return;const c=d.getCellFromIndex(w);if(!c)return;const u=await r.provideCellStatusBarItems(c.apiCell,s);if(!u)return;const t=new y.DisposableStore,m=this.p.add([t]),A=(Array.isArray(u)?u:[u]).map(N=>f.NotebookStatusBarItem.from(N,this.i,t));return{cacheId:m,items:A}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,g,w,s,r){if((0,C.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,w),this.b.$registerNotebookSerializer(a,{id:b.identifier,location:b.extensionLocation},g,f.NotebookDocumentContentOptions.from(s),l.s(b,r)),(0,y.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(b,g,w){const s=this.u.get(b);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(g.buffer,w);return new h.SerializableObjectWithBuffers(f.NotebookData.from(r))}async $notebookToData(b,g,w){const s=this.u.get(b);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(f.NotebookData.to(g.value),w);return n.VSBuffer.wrap(r)}w(b,g,w){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const s=new o.ExtHostNotebookEditor(g,this.d,b,w.visibleRanges.map(f.NotebookRange.to),w.selections.map(f.NotebookRange.to),typeof w.viewColumn=="number"?f.ViewColumn.to(w.viewColumn):void 0);this.h.set(g,s)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const w of b.value.removedDocuments){const s=S.URI.revive(w),r=this.g.get(s);r&&(r.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(r.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===s.toString()&&this.h.delete(a.id)}if(b.value.addedDocuments){const w=[];for(const s of b.value.addedDocuments){const r=S.URI.revive(s.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const a=new i.ExtHostNotebookDocument(this.c,this.q,this.r,r,s);w.push(...s.cells.map(d=>i.ExtHostCell.asModelAddData(a.apiNotebook,d))),this.g.get(r)?.dispose(),this.g.set(r,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(a.apiNotebook)}}if(b.value.addedEditors)for(const w of b.value.addedEditors){if(this.h.has(w.id))return;const s=S.URI.revive(w.documentUri),r=this.g.get(s);r&&this.w(r,w.id,w)}const g=[];if(b.value.removedEditors)for(const w of b.value.removedEditors){const s=this.h.get(w);s&&(this.h.delete(w),this.k?.id===s.id&&(this.k=void 0),g.push(s))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const w=new Set;this.l.forEach(s=>w.add(s.id));for(const s of this.h.values()){const r=w.has(s.id);s._acceptVisibility(r)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const g=D.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new D.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>n.VSBuffer.wrap(r))],new D.ApiCommandResult("Notebook Data",r=>f.NotebookData.to(r.value))),s=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new h.SerializableObjectWithBuffers(f.NotebookData.from(r)))],new D.ApiCommandResult("Bytes",r=>r.buffer));b.registerApiCommand(w),b.registerApiCommand(s)}}e.ExtHostNotebookController=l,l.a=0}),define(Ie[215],Ce([1,0,16,15,20,5,7,28,2,26,12,51,4,38,8,6,68,173,25,43]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let g=class{constructor(c,u,t,m,p){this.k=u,this.l=t,this.m=m,this.n=p,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new D.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(f.MainContext.MainThreadNotebookKernels);const A=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const q=this.l.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:q}}else if(N&&"notebookEditor"in N){const q=this.l.getIdByEditor(N.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return N})],v.ApiCommandResult.Void);this.m.registerApiCommand(A)}createNotebookController(c,u,t,m,p,A){for(const ue of this.h.values())if(ue.controller.id===u&&k.ExtensionIdentifier.equals(c.identifier,ue.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const N=this.i++,q=this;this.n.trace(`NotebookController[${N}], CREATED by ${c.identifier.value}, ${u}`);const j=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${c.identifier}'`);let V=!1;const P=new C.DisposableStore,M=new L.Emitter,F=new L.Emitter,$={id:a(c.identifier,u),notebookType:t,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:m||c.identifier.value,preloads:A?A.map(h.NotebookRendererScript.from):[]};let z=p??j,K;this.a.$addKernel(N,$).catch(ue=>{console.log(ue),V=!0});let X=0;const Z=()=>{if(V)return;const ue=++X;Promise.resolve().then(()=>{ue===X&&this.a.$updateKernel(N,$)})},he=new R.ResourceMap,oe={get id(){return u},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return $.label},set label(ue){$.label=ue??c.displayName??c.name,Z()},get detail(){return $.detail??""},set detail(ue){$.detail=ue,Z()},get description(){return $.description??""},set description(ue){$.description=ue,Z()},get kind(){return(0,E.checkProposedApiEnabled)(c,"notebookControllerKind"),$.kind??""},set kind(ue){(0,E.checkProposedApiEnabled)(c,"notebookControllerKind"),$.kind=ue,Z()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(ue){$.supportedLanguages=ue,Z()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){$.supportsExecutionOrder=ue,Z()},get rendererScripts(){return $.preloads?$.preloads.map(h.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ue){z=ue??j},get interruptHandler(){return K},set interruptHandler(ue){K=ue,$.supportsInterrupt=Boolean(ue),Z()},createNotebookCellExecution(ue){if(V)throw new Error("notebook controller is DISPOSED");if(!he.has(ue.notebook.uri))throw q.n.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return q._createNotebookCellExecution(ue,a(c.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${N}], DISPOSED`),V=!0,this.h.delete(N),P.dispose(),M.dispose(),F.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ue,ce){ce===i.NotebookControllerAffinity2.Hidden&&(0,E.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(N,ue.uri,ce)},onDidReceiveMessage:F.event,postMessage(ue,ce){return(0,E.checkProposedApiEnabled)(c,"notebookMessaging"),q.a.$postMessage(N,ce&&q.l.getIdByEditor(ce),ue)},asWebviewUri(ue){return(0,E.checkProposedApiEnabled)(c,"notebookMessaging"),(0,o.asWebviewUri)(ue,q.k.remote)}};return this.h.set(N,{extensionId:c.identifier,controller:oe,onDidReceiveMessage:F,onDidChangeSelection:M,associatedNotebooks:he}),oe}getIdByController(c){for(const[u,t]of this.h)if(t.controller===c)return a(t.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,u){const t=this.d++,m=this;this.n.trace(`NotebookControllerDetectionTask[${t}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(t,u);const p={dispose:()=>{this.c.delete(t),m.a.$removeKernelDetectionTask(t)}};return this.c.set(t,p),p}registerKernelSourceActionProvider(c,u,t){const m=this.f++,p=this;return this.e.set(m,t),this.n.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(m,u),{dispose:()=>{this.e.delete(m),p.a.$removeKernelSourceActionProvider(m)}}}async $provideKernelSourceActions(c,u){const t=this.e.get(c);if(t){const m=new C.DisposableStore;return this.g.add([m]),(await t.provideNotebookKernelSourceActions(u)??[]).map(A=>h.NotebookKernelSourceAction.from(A,this.m.converter,m))}return[]}$acceptNotebookAssociation(c,u,t){const m=this.h.get(c);if(m){const p=this.l.getNotebookDocument(S.URI.revive(u));t?m.associatedNotebooks.set(p.uri,!0):m.associatedNotebooks.delete(p.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,p.uri.toString(),t),m.onDidChangeSelection.fire({selected:t,notebook:p.apiNotebook})}}async $executeCells(c,u,t){const m=this.h.get(c);if(!m)return;const p=this.l.getNotebookDocument(S.URI.revive(u)),A=[];for(const N of t){const q=p.getCell(N);q&&A.push(q.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,p.uri.toString(),A.length),await m.controller.executeHandler.call(m.controller,A,p.apiNotebook,m.controller)}catch(N){this.n.error(`NotebookController[${c}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(c,u,t){const m=this.h.get(c);if(!m)return;const p=this.l.getNotebookDocument(S.URI.revive(u));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,p.apiNotebook);else for(const A of t){const N=p.getCell(A);N&&this.b.get(N.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,u,t){const m=this.h.get(c);if(!m)return;const p=this.l.getEditorById(u);m.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:t}))}$cellExecutionChanged(c,u,t){const p=this.l.getNotebookDocument(S.URI.revive(c)).getCell(u);if(p){const A=t?h.NotebookCellExecutionState.to(t):i.NotebookCellExecutionState.Idle;A!==void 0&&this.j.fire({cell:p.apiCell,state:A})}}_createNotebookCellExecution(c,u){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const p=new s(u,m,this.a);this.b.set(m.uri,p);const A=p.onDidChangeState(()=>{p.state===w.Resolved&&(p.dispose(),A.dispose(),this.b.delete(m.uri))});return p.asApiObject()}};g=qe([Ve(4,O.ILogService)],g),e.ExtHostNotebookKernels=g;var w;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(w||(w={}));class s extends C.Disposable{get state(){return this.f}constructor(c,u,t){super(),this.j=u,this.k=t,this.b=s.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new y.CancellationTokenSource),this.h=new r(10,m=>this.m(m)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const u=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(u))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let u=this.j;if(c&&(u=this.j.notebook.getCellFromApiCell(c)),!u)throw new Error("INVALID cell");return u.handle}s(c){return c.map(u=>{const t=i.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return t===u.items?h.NotebookCellOutput.from(u):h.NotebookCellOutput.from({items:t,id:u.id,metadata:u.metadata})})}async t(c,u,t){const m=this.r(u),p=this.s((0,n.asArray)(c));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:m,append:t,outputs:p})}async w(c,u,t){return c=i.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(c),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:c.map(h.NotebookCellOutputItem.from),outputId:u.id,append:t})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(t){c.i=t,c.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(t){if(c.f===w.Resolved||c.f===w.Started)throw new Error("Cannot call start again");c.f=w.Started,c.c.fire(),c.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,m){if(c.f===w.Resolved)throw new Error("Cannot call resolve twice");c.f=w.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new b.SerializableObjectWithBuffers({runEndTime:m,lastRunSuccess:t}))},clearOutput(t){return c.n(),c.t([],t,!1)},appendOutput(t,m){return c.n(),c.t(t,m,!0)},replaceOutput(t,m){return c.n(),c.t(t,m,!1)},appendOutputItems(t,m){return c.n(),c.w(t,m,!0)},replaceOutputItems(t,m){return c.n(),c.w(t,m,!1)}})}}s.a=0;class r{constructor(c,u){this.d=c,this.e=u,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new T.DeferredPromise,this.b=Date.now(),(0,T.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const u=this.a;return this.a=[],this.e(u).finally(()=>c.complete())}}function a(d,c){return`${d.value}/${c}`}e.createKernelId=a}),define(Ie[216],Ce([1,0,5,4,96]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(R,S){this.c=S,this.a=new Map,this.b=R.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,S,k){const O=this.c.getEditorById(R);this.a.get(S)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(R,S){if(!R.contributes?.notebookRenderer?.some(O=>O.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(O,D,f)=>this.d(S).event(O,D,f),postMessage:(O,D)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,D]=[D,O]);const f=D&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.b.$postMessage(f?.id,S,O)}}}d(R){let S=this.a.get(R);return S||(S=new n.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(R)}}),this.a.set(R,S),S)}}e.ExtHostNotebookRenderers=L}),define(Ie[217],Ce([1,0,7,2,25,4]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class C{constructor(S){this.b=new Map,this.a=S.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,k,O){if((0,y.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.b.set(k,O),this.a.$registerProfileContentHandler(k,O.name,S.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(k),this.a.$unregisterProfileContentHandler(k)})}async $saveProfile(S,k,O,D){const f=this.b.get(S);if(!f)throw new Error(`Unknown handler with id: ${S}`);return f.saveProfile(k,O,D)}async $readProfile(S,k,O){const D=this.b.get(S);if(!D)throw new Error(`Unknown handler with id: ${S}`);return D.readProfile(T.URI.revive(k),O)}}e.ExtHostProfileContentHandlers=C}),define(Ie[218],Ce([1,0,20,5,7,4,2,6,11,16,29,64]),function(te,e,n,T,y,L,C,R,S,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(v,h,i){const o=v.getProxy(L.MainContext.MainThreadQuickOpen);class l{constructor(c,u){this.e=new Map,this.f=0,this.a=c,this.b=u}showQuickPick(c,u,t=n.CancellationToken.None){this.c=void 0;const m=Promise.resolve(c),p=++this.f,A=o.$show(p,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},t),N={},q=A.then(()=>N);return Promise.race([q,m]).then(j=>{if(j!==N)return m.then(V=>{const P=[];for(let M=0;M<V.length;M++){const F=V[M];typeof F=="string"?P.push({label:F,handle:M}):F.kind===R.QuickPickItemKind.Separator?P.push({type:"separator",label:F.label}):P.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:M})}return u&&typeof u.onDidSelectItem=="function"&&(this.c=M=>{u.onDidSelectItem(V[M])}),o.$setItems(p,P),A.then(M=>{if(typeof M=="number")return V[M];if(Array.isArray(M))return M.map(F=>V[F])})})}).then(void 0,j=>{if(!(0,S.isCancellationError)(j))return o.$setError(p,j),Promise.reject(j)})}$onItemSelected(c){this.c?.(c)}showInput(c,u=n.CancellationToken.None){return this.d=c?.validateInput,o.$input(c,typeof this.d=="function",u).then(void 0,t=>{if(!(0,S.isCancellationError)(t))return Promise.reject(t)})}async $validateInput(c){if(!this.d)return;const u=await this.d(c);if(!u||typeof u=="string")return u;let t;switch(u.severity){case R.InputBoxValidationSeverity.Info:t=O.default.Info;break;case R.InputBoxValidationSeverity.Warning:t=O.default.Warning;break;case R.InputBoxValidationSeverity.Error:t=O.default.Error;break;default:t=u.message?O.default.Error:O.default.Ignore;break}return{content:u.message,severity:t}}async showWorkspaceFolderPick(c,u=n.CancellationToken.None){const t=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!t)return;const m=await this.a.getWorkspaceFolders2();if(!!m)return m.find(p=>p.uri.toString()===t.uri.toString())}createQuickPick(c){const u=new r(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(c){const u=new a(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(c,u){this.e.get(c)?._fireDidChangeValue(u)}$onDidAccept(c){this.e.get(c)?._fireDidAccept()}$onDidChangeActive(c,u){const t=this.e.get(c);t instanceof r&&t._fireDidChangeActive(u)}$onDidChangeSelection(c,u){const t=this.e.get(c);t instanceof r&&t._fireDidChangeSelection(u)}$onDidTriggerButton(c,u){this.e.get(c)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(c,u,t){const m=this.e.get(c);m instanceof r&&m._fireDidTriggerItemButton(u,t)}$onDidHide(c){this.e.get(c)?._fireDidHide()}}class E{constructor(c,u){this.x=c,this.y=u,this._id=r.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.Emitter,this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(c){this.b=c,this.z({title:c})}get step(){return this.c}set step(c){this.c=c,this.z({step:c})}get totalSteps(){return this.d}set totalSteps(c){this.d=c,this.z({totalSteps:c})}get enabled(){return this.g}set enabled(c){this.g=c,this.z({enabled:c})}get busy(){return this.j}set busy(c){this.j=c,this.z({busy:c})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(c){this.k=c,this.z({ignoreFocusOut:c})}get value(){return this.l}set value(c){this.l=c,this.z({value:c})}get placeholder(){return this.m}set placeholder(c){this.m=c,this.z({placeholder:c})}get buttons(){return this.n}set buttons(c){this.n=c.slice(),this.o.clear(),c.forEach((u,t)=>{const m=u===R.QuickInputButtons.Back?-1:t;this.o.set(m,u)}),this.z({buttons:c.map((u,t)=>({...s(u),tooltip:u.tooltip,handle:u===R.QuickInputButtons.Back?-1:t}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(c){this.l=c,this.q.fire(c)}_fireDidTriggerButton(c){const u=this.o.get(c);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,y.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),o.$dispose(this._id))}z(c){if(!this.v){for(const u of Object.keys(c)){const t=c[u];this.u[u]=t===void 0?null:t}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){o.$createOrUpdate(this.u),this.u={id:this._id}}}E.a=1;function b(d){if(d instanceof R.ThemeIcon)return{id:d.id};const c=w(d),u=g(d);return{dark:typeof c=="string"?C.URI.file(c):c,light:typeof u=="string"?C.URI.file(u):u}}function g(d){return typeof d=="object"&&"light"in d?d.light:d}function w(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const c=b(d.iconPath);let u,t;return"id"in c?t=D.ThemeIcon.asClassName(c):u=c,{iconPath:u,iconClass:t}}class r extends E{constructor(c,u){super(c.identifier,u),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.Emitter,this.L=[],this.M=new T.Emitter,this.N=new T.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(c){this.B=c.slice(),this.C.clear(),this.D.clear(),c.forEach((t,m)=>{this.C.set(m,t),this.D.set(t,m)});const u=[];for(let t=0;t<c.length;t++){const m=c[t];m.kind===R.QuickPickItemKind.Separator?u.push({type:"separator",label:m.label}):u.push({handle:t,label:m.label,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons?.map((p,A)=>({...s(p),tooltip:p.tooltip,handle:A}))})}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(c){this.E=c,this.z({canSelectMany:c})}get matchOnDescription(){return this.F}set matchOnDescription(c){this.F=c,this.z({matchOnDescription:c})}get matchOnDetail(){return this.G}set matchOnDetail(c){this.G=c,this.z({matchOnDetail:c})}get sortByLabel(){return this.H}set sortByLabel(c){this.H=c,this.z({sortByLabel:c})}get keepScrollPosition(){return this.I}set keepScrollPosition(c){this.I=c,this.z({keepScrollPosition:c})}get activeItems(){return this.J}set activeItems(c){this.J=c.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(c){this.L=c.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(c){const u=(0,k.coalesce)(c.map(t=>this.C.get(t)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(c){const u=(0,k.coalesce)(c.map(t=>this.C.get(t)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(c,u){const t=this.C.get(c);if(!t||!t.buttons||!t.buttons.length)return;const m=t.buttons[u];m&&this.N.fire({button:m,item:t})}}class a extends E{constructor(c,u){super(c.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(c){this.B=c,this.z({password:c})}get prompt(){return this.C}set prompt(c){this.C=c,this.z({prompt:c})}get valueSelection(){return this.D}set valueSelection(c){this.D=c,this.z({valueSelection:c})}get validationMessage(){return this.E}set validationMessage(c){this.E=c,c?typeof c=="string"?this.z({validationMessage:c,severity:O.default.Error}):this.z({validationMessage:c.message,severity:c.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new l(h,i)}e.createExtHostQuickOpen=f});var Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n};define(Ie[219],Ce([1,0,2,5,60,7,15,4,16,120,12,26,64,8,25]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(m){if(m)return typeof m.iconPath=="string"?n.URI.file(m.iconPath):n.URI.isUri(m.iconPath)||f.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function E(m,p){if(!m.iconPath&&!p.iconPath)return 0;if(m.iconPath){if(!p.iconPath)return 1}else return-1;const A=typeof m.iconPath=="string"?m.iconPath:n.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,N=typeof p.iconPath=="string"?p.iconPath:n.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,k.comparePaths)(A,N)}function b(m,p){let A=0;if(m.strikeThrough!==p.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==p.faded)return m.faded?1:-1;if(m.tooltip!==p.tooltip)return(m.tooltip||"").localeCompare(p.tooltip||"");if(A=E(m,p),A!==0)return A;if(m.light&&p.light)A=E(m.light,p.light);else{if(m.light)return 1;if(p.light)return-1}if(A!==0)return A;if(m.dark&&p.dark)A=E(m.dark,p.dark);else{if(m.dark)return 1;if(p.dark)return-1}return A}function g(m,p){if(m.command!==p.command)return m.command<p.command?-1:1;if(m.title!==p.title)return m.title<p.title?-1:1;if(m.tooltip!==p.tooltip){if(m.tooltip!==void 0&&p.tooltip!==void 0)return m.tooltip<p.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(m.arguments===p.arguments)return 0;if(m.arguments)if(p.arguments){if(m.arguments.length!==p.arguments.length)return m.arguments.length-p.arguments.length}else return 1;else return-1;for(let A=0;A<m.arguments.length;A++){const N=m.arguments[A],q=p.arguments[A];if(N!==q)return N<q?-1:1}return 0}function w(m,p){let A=(0,k.comparePaths)(m.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(A!==0)return A;if(m.command&&p.command)A=g(m.command,p.command);else{if(m.command)return 1;if(p.command)return-1}if(A!==0)return A;if(m.decorations&&p.decorations)A=b(m.decorations,p.decorations);else{if(m.decorations)return 1;if(p.decorations)return-1}return A}function s(m,p){for(let A=0;A<m.length;A++)if(m[A]!==p[A])return!1;return!0}function r(m,p){return m.command===p.command&&m.title===p.title&&m.tooltip===p.tooltip&&(m.arguments&&p.arguments?s(m.arguments,p.arguments):m.arguments===p.arguments)}function a(m,p){return(0,S.equals)(m,p,r)}class d{get value(){return this.d}set value(p){p=p??"",Re(this,i,"f").$setInputBoxValue(this.l,p),this.m(p)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(p){Re(this,i,"f").$setInputBoxPlaceholder(this.l,p),this.f=p}get validateInput(){return(0,h.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(p){if((0,h.checkProposedApiEnabled)(this.k,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=p,Re(this,i,"f").$setValidationProviderIsEnabled(this.l,!!p)}get enabled(){return this.h}set enabled(p){p=!!p,this.h!==p&&(this.h=p,Re(this,i,"f").$setInputBoxEnablement(this.l,p))}get visible(){return this.j}set visible(p){p=!!p,this.j!==p&&(this.j=p,Re(this,i,"f").$setInputBoxVisibility(this.l,p))}constructor(p,A,N){this.k=p,this.l=N,i.set(this,void 0),this.d="",this.e=new T.Emitter,this.f="",this.h=!0,this.j=!0,Ye(this,i,A,"f")}showValidationMessage(p,A){(0,h.checkProposedApiEnabled)(this.k,"scmValidation"),Re(this,i,"f").$showValidationMessage(this.l,p,A)}$onInputBoxValueChange(p){this.m(p)}m(p){this.d=p,this.e.fire(p)}}e.ExtHostSCMInputBox=d,i=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(p){this.v=p,this.q.$updateGroupLabel(this.t,this.handle,p)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(p){this.p=p,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(p){this.f=[...p],this.k.fire()}constructor(p,A,N,q,j){this.q=p,this.s=A,this.t=N,this.u=q,this.v=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(p){return this.g.get(p)}$executeResourceCommand(p,A){const N=this.h.get(p);return N?(0,C.asPromise)(()=>this.s.executeCommand(N.command,...N.arguments||[],A)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this.f].sort(w),N=(0,S.sortedDiff)(this.o,p,w).map(V=>{const P=V.toInsert.map(M=>{const F=this.e++;this.g.set(F,M);const $=M.resourceUri;let z;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const ge=new L.DisposableStore;z=this.s.converter.toInternal(M.command,ge),this.j.set(F,ge)}else this.h.set(F,M.command);const K=l(M.decorations),X=M.decorations&&l(M.decorations.light)||K,Z=M.decorations&&l(M.decorations.dark)||K,he=[X,Z],oe=M.decorations&&M.decorations.tooltip||"",ue=M.decorations&&!!M.decorations.strikeThrough,ce=M.decorations&&!!M.decorations.faded,fe=M.contextValue||"";return{rawResource:[F,$,he,oe,ue,ce,fe,z],handle:F}});return{start:V.start,deleteCount:V.deleteCount,toInsert:P}}),q=N.map(({start:V,deleteCount:P,toInsert:M})=>[V,P,M.map(F=>F.rawResource)]),j=N.reverse();for(const{start:V,deleteCount:P,toInsert:M}of j){const F=M.map(z=>z.handle),$=this.n.splice(V,P,...F);for(const z of $)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=p,q}dispose(){this.l=!0,this.m.fire()}}c.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(p){this.g!==p&&(this.g=p,Re(this,o,"f").$updateSourceControl(this.t,{count:p}))}get quickDiffProvider(){return this.h}set quickDiffProvider(p){this.h=p,Re(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this.j}set commitTemplate(p){p!==this.j&&(this.j=p,Re(this,o,"f").$updateSourceControl(this.t,{commitTemplate:p}))}get acceptInputCommand(){return this.l}set acceptInputCommand(p){this.k.value=new L.DisposableStore,this.l=p;const A=this.v.converter.toInternal(p,this.k.value);Re(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:A})}get actionButton(){return(0,h.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(p){(0,h.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=p;const A=p!==void 0?{command:this.v.converter.toInternal(p.command,this.m.value),secondaryCommands:p.secondaryCommands?.map(N=>N.map(q=>this.v.converter.toInternal(q,this.m.value))),description:p.description,enabled:p.enabled}:void 0;Re(this,o,"f").$updateSourceControl(this.t,{actionButton:A??null})}get statusBarCommands(){return this.p}set statusBarCommands(p){if(this.p&&p&&a(this.p,p))return;this.o.value=new L.DisposableStore,this.p=p;const A=(p||[]).map(N=>this.v.converter.toInternal(N,this.o.value));Re(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:A})}get selected(){return this.q}constructor(p,A,N,q,j,V){this.u=p,this.v=N,this.w=q,this.x=j,this.y=V,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new T.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,Ye(this,o,A,"f"),this.f=new d(p,Re(this,o,"f"),this.t),Re(this,o,"f").$registerSourceControl(this.t,q,j,V)}createResourceGroup(p,A){const N=new c(Re(this,o,"f"),this.v,this.t,p,A),q=T.Event.once(N.onDidDispose)(()=>this.z.delete(N));return this.z.set(N,q),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const p=[],A=[];for(const[N,q]of this.z){q.dispose();const j=N.onDidUpdateResourceStates(()=>{this.A.add(N),this.eventuallyUpdateResourceStates()});T.Event.once(N.onDidDispose)(()=>{this.A.delete(N),j.dispose(),this.e.delete(N.handle),Re(this,o,"f").$unregisterGroup(this.t,N.handle)}),p.push([N.handle,N.id,N.label,N.features]);const V=N._takeResourceStateSnapshot();V.length>0&&A.push([N.handle,V]),this.e.set(N.handle,N)}Re(this,o,"f").$registerGroups(this.t,p,A),this.z.clear()}eventuallyUpdateResourceStates(){const p=[];this.A.forEach(A=>{const N=A._takeResourceStateSnapshot();N.length!==0&&p.push([A.handle,N])}),p.length>0&&Re(this,o,"f").$spliceResourceStates(this.t,p),this.A.clear()}getResourceGroup(p){return this.e.get(p)}setSelectionState(p){this.q=p,this.s.fire(p)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(p=>p.dispose()),Re(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,u.d=0,qe([(0,y.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),qe([(0,y.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let t=class tn{get onDidChangeActiveProvider(){return this.j.event}constructor(p,A,N){this.l=A,this.m=N,this.g=new Map,this.h=new Map,this.j=new T.Emitter,this.e=p.getProxy(R.MainContext.MainThreadSCM),this.f=p.getProxy(R.MainContext.MainThreadTelemetry),A.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const j=this.g.get(q.sourceControlHandle);if(!j)return q;const V=j.getResourceGroup(q.groupHandle);return V?V.getResourceState(q.handle):q}else if(q&&q.$mid===4){const j=this.g.get(q.sourceControlHandle);return j?j.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const j=this.g.get(q.handle);return j||q}return q}})}createSourceControl(p,A,N,q){this.m.trace("ExtHostSCM#createSourceControl",p.identifier.value,A,N,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const j=tn.d++,V=new u(p,this.e,this.l,A,N,q);this.g.set(j,V);const P=this.h.get(D.ExtensionIdentifier.toKey(p.identifier))||[];return P.push(V),this.h.set(D.ExtensionIdentifier.toKey(p.identifier),P),V}getLastInputBox(p){this.m.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const A=this.h.get(D.ExtensionIdentifier.toKey(p.identifier)),N=A&&A[A.length-1];return N&&N.inputBox}$provideOriginalResource(p,A,N){const q=n.URI.revive(A);this.m.trace("ExtHostSCM#$provideOriginalResource",p,q.toString());const j=this.g.get(p);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>j.quickDiffProvider.provideOriginalResource(q,N)).then(V=>V||null)}$onInputBoxValueChange(p,A){this.m.trace("ExtHostSCM#$onInputBoxValueChange",p);const N=this.g.get(p);return N&&N.inputBox.$onInputBoxValueChange(A),Promise.resolve(void 0)}$executeResourceCommand(p,A,N,q){this.m.trace("ExtHostSCM#$executeResourceCommand",p,A,N);const j=this.g.get(p);if(!j)return Promise.resolve(void 0);const V=j.getResourceGroup(A);return V?V.$executeResourceCommand(N,q):Promise.resolve(void 0)}$validateInput(p,A,N){this.m.trace("ExtHostSCM#$validateInput",p);const q=this.g.get(p);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>q.inputBox.validateInput(A,N)).then(j=>{if(!j)return Promise.resolve(void 0);const V=v.MarkdownString.fromStrict(j.message);return V?Promise.resolve([V,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this.g.get(p)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=p,Promise.resolve(void 0)}};t.d=0,t=qe([Ve(2,O.ILogService)],t),e.ExtHostSCM=t}),define(Ie[74],Ce([1,0,4,5,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(R){this.b=new T.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,S){return this.a.$getPassword(R,S)}store(R,S,k){return this.a.$setPassword(R,S,k)}delete(R,S){return this.a.$deletePassword(R,S)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Ie[220],Ce([1,0,6,4,135,7,8,9]),function(te,e,n,T,y,L,C,R){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(h,i,o,l,E=n.StatusBarAlignment.Left,b){S.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new L.DisposableStore,Ye(this,S,h,"f"),Ye(this,k,i,"f"),this.c=O.a++,this.e=o,this.f=l,this.g=E,this.h=this.t(b)}t(h){if(!!(0,R.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(h){this.k=h,this.u()}set name(h){this.m=h,this.u()}set tooltip(h){this.l=h,this.u()}set color(h){this.n=h,this.u()}set backgroundColor(h){h&&!O.b.has(h.id)&&(h=void 0),this.o=h,this.u()}set command(h){this.q?.fromApi!==h&&(this.p.clear(),typeof h=="string"?this.q={fromApi:h,internal:Re(this,k,"f").toInternal({title:"",command:h},this.p)}:h?this.q={fromApi:h,internal:Re(this,k,"f").toInternal(h,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(h){this.s=h,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Re(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let h;this.e?this.f?h=`${this.e.identifier.value}.${this.f}`:h=this.e.identifier.value:h=this.f;let i;this.m?i=this.m:i=(0,y.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=O.b.get(this.o.id));const l=C.MarkdownString.fromStrict(this.l);Re(this,S,"f").$setEntry(this.c,h,i,this.k,l,this.q?.internal,o,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=O,S=new WeakMap,k=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(h){this.b=[],this.a=h.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,y.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(h){const i={message:h};return this.b.unshift(i),this.c(),new n.Disposable(()=>{const o=this.b.indexOf(i);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class f{constructor(h,i){this.a=h.getProxy(T.MainContext.MainThreadStatusBar),this.b=i,this.c=new D(this)}createStatusBarEntry(h,i,o,l){return new O(this.a,this.b,h,i,o,l)}setStatusBarMessage(h,i){const o=this.c.setMessage(h);let l;return typeof i=="number"?l=setTimeout(()=>o.dispose(),i):typeof i<"u"&&i.then(()=>o.dispose(),()=>o.dispose()),new n.Disposable(()=>{o.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=f}),define(Ie[75],Ce([1,0,4,5,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(R,S){this.c=S,this.b=new T.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,S){this.a.$registerExtensionStorageKeysToSync(R,S)}async initializeExtensionStorage(R,S,k){const O=await this.a.$initializeExtensionStorage(R,S);let D;return O&&(D=this.d(R,S,O)),D||k}setValue(R,S,k){return this.a.$setValue(R,S,k)}$acceptValue(R,S,k){const O=this.d(R,S,k);O&&this.b.fire({shared:R,key:S,value:O})}d(R,S,k){try{return JSON.parse(k)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${R}): ${O}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(Ie[76],Ce([1,0,3,27,12,57,2]),function(te,e,n,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let R=class{constructor(k,O,D){this.d=O,this.f=D,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(k){return C.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,O=await this.g(k);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(C.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(k){if(this.c)return C.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return C.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=qe([Ve(0,T.IExtHostInitDataService),Ve(1,y.ILogService),Ve(2,L.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(Ie[58],Ce([1,0,5,4,3,2,14,7,6,136,11,174,20,34,160,64,9,15,8]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class b{constructor(t,m,p,A){this.k=t,this._id=m,this.l=p,this.m=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(q=>this.f=q);const N=this;this.value={get name(){return N.m||""},get processId(){return N.b},get creationOptions(){return N.l},get exitStatus(){return N.h},get state(){return N.j},sendText(q,j=!0){N.o(),N.k.$sendText(N._id,q,j)},show(q){N.o(),N.k.$show(N._id,q)},hide(){N.o(),N.k.$hide(N._id)},dispose(){N.a||(N.a=!0,N.k.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(t,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:t.name,shellPath:(0,o.withNullAsUndefined)(t.shellPath),shellArgs:(0,o.withNullAsUndefined)(t.shellArgs),cwd:(0,o.withNullAsUndefined)(t.cwd),env:(0,o.withNullAsUndefined)(t.env),icon:(0,o.withNullAsUndefined)(d(t.iconPath)),color:i.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,o.withNullAsUndefined)(t.message),strictEnv:(0,o.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(m?.useShellEnvironment),location:m?.location||this.n(t.location,m?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,m,p,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:p,color:i.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.n(t,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(t,m){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in t?{viewColumn:E.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus}:void 0:t}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(t){this.m=t}setExitStatus(t,m){this.h=Object.freeze({code:t,reason:m})}setDimensions(t,m){return t===this.d&&m===this.g||t===0||m===0?!1:(this.d=t,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(t){this.f?(this.f(t),this.f=void 0):this.b.then(m=>{m!==t&&(this.b=Promise.resolve(t))})}}e.ExtHostTerminal=b;class g{get onProcessReady(){return this.b.event}constructor(t){this.g=t,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(t){this.g.handleInput?.(t)}resize(t,m){this.g.setDimensions?.({columns:t,rows:m})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(t||void 0),t&&this.g.setDimensions?.(t),this.b.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=g;let w=1,s=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(t=>t.value)}get onDidWriteTerminalData(){return this.I.event}constructor(t,m){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new n.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new n.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=m.getProxy(T.MainContext.MainThreadTerminalService),this.s=new h.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(t),this.B({dispose:()=>{for(const[p,A]of this.g)A.shutdown(!0)}})}getDefaultShell(t){return(t?this.n:this.m)?.path||""}getDefaultShellArgs(t){return(t?this.n:this.m)?.args||[]}createExtensionTerminal(t,m){const p=new b(this.a,(0,v.generateUuid)(),t,t.name),A=new g(t.pty);return p.createExtensionTerminal(t.location,this.L(t,m).resolvedExtHostIdentifier,d(t.iconPath),c(t.color)).then(N=>{const q=this.M(N,A);this.h[N]=q}),this.f.push(p),p.value}L(t,m){if(m=m||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const p=t.location.parentTerminal;if(p){const A=this.f.find(N=>N.value===p);A&&(m.resolvedExtHostIdentifier=A._id)}}else t.location&&typeof t.location!="object"?m.location=t.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(t,m){if(!this.O(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const A=new g(m),N=this.M(t,A);this.h[t]=N}async $acceptActiveTerminalChanged(t){const m=this.b;if(t===null){this.b=void 0,m!==this.b&&this.F.fire(this.b);return}const p=this.O(t);p&&(this.b=p,m!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(t,m){const p=this.O(t);p&&this.I.fire({terminal:p.value,data:m})}async $acceptTerminalDimensions(t,m,p){const A=this.O(t);A&&A.setDimensions(m,p)&&this.G.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptTerminalMaximumDimensions(t,m,p){this.g.get(t)?.resize(m,p)}async $acceptTerminalTitleChange(t,m){const p=this.O(t);p&&(p.name=m)}async $acceptTerminalClosed(t,m,p){const A=this.Q(this.f,t);if(A!==null){const N=this.f.splice(A,1)[0];N.setExitStatus(m,p),this.C.fire(N.value)}}$acceptTerminalOpened(t,m,p,A){if(m){const j=this.Q(this.f,m);if(j!==null){this.f[j]._id=t,this.D.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const N={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:L.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},q=new b(this.a,t,N,p);this.f.push(q),this.D.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(t,m){this.O(t)?._setProcessId(m)}async $startExtensionTerminal(t,m){const p=this.O(t);if(!p)return{message:(0,k.localize)(0,null,t)};p.isOpen||await new Promise(N=>{const q=this.onDidOpenTerminal(async j=>{j===p.value&&(q.dispose(),N())})});const A=this.g.get(t);A?A.startSendingEvents(m):this.j[t]={initialDimensions:m}}M(t,m){const p=new R.DisposableStore;p.add(m.onProcessReady(N=>this.a.$sendProcessReady(t,N.pid,N.cwd))),p.add(m.onDidChangeProperty(N=>this.a.$sendProcessProperty(t,N))),this.s.startBuffering(t,m.onProcessData),p.add(m.onProcessExit(N=>this.N(t,N))),this.g.set(t,m);const A=this.j[t];return A&&m instanceof g&&(m.startSendingEvents(A.initialDimensions),delete this.j[t]),p}$acceptProcessAckDataEvent(t,m){this.g.get(t)?.acknowledgeDataEvent(m)}$acceptProcessInput(t,m){this.g.get(t)?.input(m)}$acceptTerminalInteraction(t){const m=this.O(t);m?.setInteractedWith()&&this.H.fire(m.value)}$acceptProcessResize(t,m,p){try{this.g.get(t)?.resize(m,p)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(t,m){this.g.get(t)?.shutdown(m)}$acceptProcessRequestInitialCwd(t){this.g.get(t)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(t,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(t){this.g.get(t)?.getCwd().then(m=>this.a.$sendProcessProperty(t,{type:"cwd",value:m}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this.u.add(t),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(t),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(t,m,p){if(this.v.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.v.set(m,p),this.a.$registerProfileProvider(m,t.identifier.value),new S.Disposable(()=>{this.v.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(t,m,p){if(this.w.has(t))throw new Error(`Terminal quick fix provider "${t}" is already registered`);return this.w.set(t,p),this.a.$registerQuickFixProvider(t,m),new S.Disposable(()=>{this.w.delete(t),this.a.$unregisterQuickFixProvider(t)})}async $provideTerminalQuickFixes(t,m){const p=new f.CancellationTokenSource().token;if(p.isCancellationRequested)return;const A=this.w.get(t);if(!!A)return A.provideTerminalQuickFixes(m,p)}async $createContributedProfileTerminal(t,m){const p=new f.CancellationTokenSource().token;let A=await this.v.get(t)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,m);return}this.createTerminalFromOptions(A.options,m)}}async $provideLinks(t,m){const p=this.O(t);if(!p)return[];this.y.delete(t),this.z.get(t)?.dispose(!0);const N=new f.CancellationTokenSource;this.z.set(t,N);const q=[],j={terminal:p.value,line:m},V=[];for(const F of this.u)V.push(l.Promises.withAsyncBody(async $=>{N.token.onCancellationRequested(()=>$({provider:F,links:[]}));const z=await F.provideTerminalLinks(j,N.token)||[];N.token.isCancellationRequested||$({provider:F,links:z})}));const P=await Promise.all(V);if(N.token.isCancellationRequested)return[];const M=new Map;for(const F of P)F&&F.links.length>0&&q.push(...F.links.map($=>{const z={id:w++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return M.set(z.id,{provider:F.provider,link:$}),z}));return this.y.set(t,M),q}$activateLink(t,m){const p=this.y.get(t)?.get(m);!p||p.provider.handleTerminalLink(p.link)}N(t,m){this.s.stopBuffering(t),this.g.delete(t),delete this.j[t];const p=this.h[t];p&&(p.dispose(),delete this.h[t]),this.a.$sendProcessExit(t,m)}O(t){return this.P(this.f,t)}P(t,m){const p=this.Q(t,m);return p!==null?t[p]:null}Q(t,m){let p=null;return t.some((A,N)=>A._id===m?(p=N,!0):!1),p}getEnvironmentVariableCollection(t){let m=this.l.get(t.identifier.value);return m||(m=new r,this.S(t.identifier.value,m)),m}R(t,m){const p=(0,D.serializeEnvironmentVariableCollection)(m.map);this.a.$setEnvironmentVariableCollection(t,m.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(t){t.forEach(m=>{const p=m[0],A=new r(m[1]);this.S(p,A)})}$acceptDefaultProfile(t,m){const p=this.m;this.m=t,this.n=m,p?.path!==t.path&&this.J.fire(t.path)}S(t,m){this.l.set(t,m),m.onDidChangeCollection(()=>{this.R(t,m)})}};s=qe([Ve(1,C.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class r{get persistent(){return this.a}set persistent(t){this.a=t,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(t){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(t)}get size(){return this.map.size}replace(t,m){this.d(t,{value:m,type:S.EnvironmentVariableMutatorType.Replace})}append(t,m){this.d(t,{value:m,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,m){this.d(t,{value:m,type:S.EnvironmentVariableMutatorType.Prepend})}d(t,m){const p=this.map.get(t);(!p||p.value!==m.value||p.type!==m.type)&&(this.map.set(t,m),this.b.fire())}get(t){return this.map.get(t)}forEach(t,m){this.map.forEach((p,A)=>t.call(m,A,p,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}e.EnvironmentVariableCollection=r;let a=class extends s{constructor(t){super(!1,t)}createTerminal(t,m,p){throw new O.NotSupportedError}createTerminalFromOptions(t,m){throw new O.NotSupportedError}};a=qe([Ve(0,C.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function d(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function c(u){return i.ThemeColor.isThemeColor(u)?u:void 0}});var Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n};define(Ie[221],Ce([1,0,16,24,20,5,184,222,7,23,9,34,4,14,97,8,6,42,67,53]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b){"use strict";var g,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(j,V,P){this.j=P,this.c=new L.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=j.getProxy(f.MainContext.MainThreadTesting),this.h=new p(this.f),this.g=new a(this.f),V.registerArgumentProcessor({processArgument:M=>{if(M?.$mid!==15)return M;const F=M,$=F.tests[F.tests.length-1].item.extId;return this.d.get(l.TestId.root($))?.collection.tree.get($)?.actual??(0,h.toItemFromContext)(M)}})}createTestController(j,V,P){if(this.d.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const M=new S.DisposableStore,F=M.add(new h.ExtHostTestItemCollection(j,V,this.j));F.root.label=V;const $=new Map,z=this.f,K={items:F.root.children,get label(){return V},set label(Z){V=Z,F.root.label=Z,z.$updateController(j,{label:V})},get refreshHandler(){return P},set refreshHandler(Z){P=Z,z.$updateController(j,{canRefresh:!!Z})},get id(){return j},createRunProfile:(Z,he,oe,ue,ce)=>{let fe=(0,R.hash)(Z);for(;$.has(fe);)fe++;return new A(this.f,$,j,fe,Z,he,oe,ue,ce)},createTestItem(Z,he,oe){return new h.TestItemImpl(j,Z,he,oe)},createTestRun:(Z,he,oe=!0)=>this.g.createTestRun(j,F,Z,he,oe),set resolveHandler(Z){F.resolveHandler=Z},get resolveHandler(){return F.resolveHandler},dispose:()=>{M.dispose()}};z.$registerTestController(j,V,!!P),M.add((0,S.toDisposable)(()=>z.$unregisterTestController(j)));const X={controller:K,collection:F,profiles:$};return this.d.set(j,X),M.add((0,S.toDisposable)(()=>this.d.delete(j))),M.add(F.onDidGenerateDiff(Z=>z.$publishDiff(j,Z.map(b.TestsDiffOp.serialize)))),K}createTestObserver(){return this.h.checkout()}async runTests(j,V=y.CancellationToken.None){const P=d(j);if(!P)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.d.get(P.controllerId);if(!M)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(F=>l.TestId.fromExtHostTestItem(F,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:N[P.kind],profileId:P.profileId,controllerId:P.controllerId}],exclude:j.exclude?.map(F=>F.id)},V)}$syncTests(){for(const{collection:j}of this.d.values())j.flushDiff();return Promise.resolve()}$provideFileCoverage(j,V,P){return(0,n.mapFind)(this.g.trackers,F=>F.id===j?F.getCoverage(V):void 0)?.provideFileCoverage(P)??Promise.resolve([])}$resolveFileCoverage(j,V,P,M){return(0,n.mapFind)(this.g.trackers,$=>$.id===j?$.getCoverage(V):void 0)?.resolveFileCoverage(P,M)??Promise.resolve([])}$configureRunProfile(j,V){this.d.get(j)?.profiles.get(V)?.configureHandler?.()}async $refreshTests(j,V){await this.d.get(j)?.controller.refreshHandler?.(V)}$publishTestResults(j){this.results=Object.freeze(j.map(V=>(0,k.deepFreeze)(i.TestResults.to(V))).concat(this.results).sort((V,P)=>P.completedAt-V.completedAt).slice(0,32)),this.c.fire()}async $expandTest(j,V){const P=this.d.get(l.TestId.fromString(j).controllerId)?.collection;P&&(await P.expand(j,V<0?1/0:V),P.flushDiff())}$acceptDiff(j){this.h.applyDiff(j.map(b.TestsDiffOp.deserialize))}async $runControllerTests(j,V){return Promise.all(j.map(P=>this.runControllerTestRequest(P,V)))}async runControllerTestRequest(j,V){const P=this.d.get(j.controllerId);if(!P)return{};const{collection:M,profiles:F}=P,$=F.get(j.profileId);if(!$)return{};const z=j.testIds.map(he=>M.tree.get(he)).filter(O.isDefined),K=j.excludeExtIds.map(he=>P.collection.tree.get(he)).filter(O.isDefined).filter(he=>z.some(oe=>oe.fullId.compare(he.fullId)===2));if(!z.length)return{};const X=new o.TestRunRequest(z.some(he=>he.actual instanceof h.TestItemRootImpl)?void 0:z.map(he=>he.actual),K.map(he=>he.actual),$),Z=this.g.prepareForMainThreadTestRun(X,c.fromInternal(j,P.collection),V);try{return await $.runHandler(X,V),{}}catch(he){return{error:String(he)}}finally{Z.isRunning&&!V.isCancellationRequested&&await L.Event.toPromise(Z.onEnd),Z.dispose()}}$cancelExtensionTestRun(j){j===void 0?this.g.cancelAllRuns():this.g.cancelRunById(j)}};s=qe([Ve(0,v.IExtHostRpcService)],s),e.ExtHostTesting=s;class r extends S.Disposable{get isRunning(){return this.c.size>0}get id(){return this.k.id}constructor(j,V,P){super(),this.k=j,this.l=V,this.c=new Map,this.f=new Set,this.h=this.B(new L.Emitter),this.j=!1,this.onEnd=this.h.event,this.g=this.B(new y.CancellationTokenSource(P)),this.B(this.g.token.onCancellationRequested(()=>{for(const{run:M}of this.c.values())M.end()}))}getCoverage(j){return this.c.get(j)?.coverage}createRun(j){const V=this.k.id,P=this.k.controllerId,M=(0,D.generateUuid)(),F=new u(this.l,V,M),$=Z=>(he,...oe)=>{if(K){console.warn(`Setting the state of test "${he.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(he)||(this.m(he),Z(he,...oe))},z=(Z,he)=>{const oe=he instanceof Array?he.map(i.TestMessage.from):[i.TestMessage.from(he)];if(Z.uri&&Z.range){const ue={range:i.Range.from(Z.range),uri:Z.uri};for(const ce of oe)ce.location=ce.location||ue}this.l.$appendTestMessagesInRun(V,M,l.TestId.fromExtHostTestItem(Z,P).toString(),oe)};let K=!1;const X={isPersisted:this.k.isPersisted,token:this.g.token,name:j,get coverageProvider(){return F.coverageProvider},set coverageProvider(Z){F.coverageProvider=Z},enqueued:$(Z=>{this.l.$updateTestStateInRun(V,M,l.TestId.fromExtHostTestItem(Z,P).toString(),1)}),skipped:$(Z=>{this.l.$updateTestStateInRun(V,M,l.TestId.fromExtHostTestItem(Z,P).toString(),5)}),started:$(Z=>{this.l.$updateTestStateInRun(V,M,l.TestId.fromExtHostTestItem(Z,P).toString(),2)}),errored:$((Z,he,oe)=>{z(Z,he),this.l.$updateTestStateInRun(V,M,l.TestId.fromExtHostTestItem(Z,P).toString(),6,oe)}),failed:$((Z,he,oe)=>{z(Z,he),this.l.$updateTestStateInRun(V,M,l.TestId.fromExtHostTestItem(Z,P).toString(),4,oe)}),passed:$((Z,he)=>{this.l.$updateTestStateInRun(V,M,l.TestId.fromExtHostTestItem(Z,this.k.controllerId).toString(),3,he)}),appendOutput:(Z,he,oe)=>{K||(oe&&(this.k.isIncluded(oe)?this.m(oe):oe=void 0),this.l.$appendOutputToRun(V,M,T.VSBuffer.fromString(Z),he&&i.location.from(he),oe&&l.TestId.fromExtHostTestItem(oe,P).toString()))},end:()=>{K||(K=!0,this.l.$finishedTestRunTask(V,M),this.c.delete(M),this.isRunning||this.dispose())}};return this.c.set(M,{run:X,coverage:F}),this.l.$startedTestRunTask(V,{id:M,name:j,running:!0}),X}dispose(){this.j||(this.j=!0,this.h.fire(),this.g.cancel(),super.dispose())}m(j){if(!(j instanceof h.TestItemImpl))throw new E.InvalidTestItemError(j.id);if(this.f.has(l.TestId.fromExtHostTestItem(j,this.k.controllerId).toString()))return;const V=[],P=this.k.colllection.root;for(;;){const M=i.TestItem.from(j);if(V.unshift(M),this.f.has(M.extId)||(this.f.add(M.extId),j===P))break;j=j.parent||P}this.l.$addTestsToRun(this.k.controllerId,this.k.id,V)}}class a{get trackers(){return this.c.values()}constructor(j){this.d=j,this.c=new Map}prepareForMainThreadTestRun(j,V,P){return this.f(j,V,P)}cancelRunById(j){for(const V of this.c.values())if(V.id===j){V.dispose();return}}cancelAllRuns(){for(const j of this.c.values())j.dispose()}createTestRun(j,V,P,M,F){const $=this.c.get(P);if($)return $.createRun(M);const z=c.fromPublic(j,V,P,F),K=d(P);this.d.$startedExtensionTestRun({controllerId:j,profile:K&&{group:N[K.kind],id:K.profileId},exclude:P.exclude?.map(Z=>l.TestId.fromExtHostTestItem(Z,V.root.id).toString())??[],id:z.id,include:P.include?.map(Z=>l.TestId.fromExtHostTestItem(Z,V.root.id).toString())??[V.root.id],persist:F});const X=this.f(P,z);return X.onEnd(()=>this.d.$finishedExtensionTestRun(z.id)),X.createRun(M)}f(j,V,P){const M=new r(V,this.d,P);return this.c.set(j,M),M.onEnd(()=>this.c.delete(j)),M}}e.TestRunCoordinator=a;const d=q=>{if(!!q.profile){if(!(q.profile instanceof A))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class c{static fromPublic(j,V,P,M){return new c(j,(0,D.generateUuid)(),P.include?.map(F=>l.TestId.fromExtHostTestItem(F,j).toString())??[j],P.exclude?.map(F=>l.TestId.fromExtHostTestItem(F,j).toString())??[],M,V)}static fromInternal(j,V){return new c(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,V)}constructor(j,V,P,M,F,$){this.controllerId=j,this.id=V,this.isPersisted=F,this.colllection=$,this.c=P.map(z=>z+"\0"),this.d=M.map(z=>z+"\0")}isIncluded(j){const V=l.TestId.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const P of this.d)if(V===P||V.startsWith(P))return!1;for(const P of this.c)if(V===P||V.startsWith(P))return!0;return!1}}e.TestRunDto=c;class u{set coverageProvider(j){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!j||(this.c=j,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(j,V,P){this.f=j,this.g=V,this.h=P}async provideFileCoverage(j){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(j))());try{return(await this.d)?.map(i.TestCoverage.fromFile)??[]}catch(V){throw this.d=void 0,V}}async resolveFileCoverage(j,V){const P=await this.d;let M=P?.[j];return!this.c||!P||!M?[]:(M.detailedCoverage||(M=P[j]=await this.c.resolveFileCoverage?.(M,V)??M),M.detailedCoverage?.map(i.TestCoverage.fromDetailed)??[])}}class t{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(j){this.h=j,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,i.TestItem.toPlain(j.item)),this.c.has(j)||this.d.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.d.delete(j);const V=l.TestId.parentId(j.item.extId);if(V&&this.g.has(V.toString())){this.g.add(j.item.extId);return}this.f.add(j)}getChangeEvent(){const{c:j,d:V,f:P}=this;return{get added(){return[...j].map(M=>M.revived)},get updated(){return[...V].map(M=>M.revived)},get removed(){return[...P].map(M=>M.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class m extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new L.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(j){return this.d.get(j)}getMirroredTestDataByReference(j){return this.d.get(j.id)}p(j,V){return{...j,revived:i.TestItem.toPlain(j.item),depth:V?V.depth+1:0,children:new Set}}o(){return new t(this.q)}}e.MirroredTestCollection=m;class p{constructor(j){this.d=j}checkout(){this.c||(this.c=this.f());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(V=>V.revived)},dispose:(0,C.once)(()=>{--j.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}f(){const j=new m;return this.d.$subscribeToDiffs(),{observers:0,tests:j}}}class A{get label(){return this.d}set label(j){j!==this.d&&(this.d=j,Re(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:j}))}get isDefault(){return this.f}set isDefault(j){j!==this.f&&(this.f=j,Re(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,Re(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:j?i.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,Re(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!j}))}constructor(j,V,P,M,F,$,z,K=!1,X=void 0){this.controllerId=P,this.profileId=M,this.d=F,this.kind=$,this.runHandler=z,this.f=K,this._tag=X,g.set(this,void 0),w.set(this,void 0),Ye(this,g,j,"f"),Ye(this,w,V,"f"),V.set(M,this);const Z=N[$];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Re(this,g,"f").$publishTestRunProfile({profileId:M,controllerId:P,tag:X?i.TestTag.namespace(this.controllerId,X.id):null,label:F,group:Z,isDefault:K,hasConfigurationHandler:!1})}dispose(){Re(this,w,"f")?.delete(this.profileId)&&(Ye(this,w,void 0,"f"),Re(this,g,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=A,g=new WeakMap,w=new WeakMap;const N={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ie[223],Ce([1,0,16,5,4,98,8,6]),function(te,e,n,T,y,L,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(O,D){this.i=D,this.a=new T.Emitter,this.b=new T.Emitter,this.c=new T.Emitter,this.d=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(y.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(f=>this.g.fire(f)),this.i.onDidChangeActiveTextEditor(f=>this.f.fire(f))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const D=this.i.allEditors();return O?D:D.map(f=>f.value)}async showTextDocument(O,D,f){let v;typeof D=="number"?v={position:C.ViewColumn.from(D),preserveFocus:f}:typeof D=="object"?v={position:C.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?C.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:v={preserveFocus:!1};const h=await this.h.$tryShowTextDocument(O.uri,v),i=h&&this.i.getEditor(h);if(i)return i.value;throw h?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,D){return new L.TextEditorDecorationType(this.h,O,D).value}$acceptEditorPropertiesChanged(O,D){const f=this.i.getEditor(O);if(!f)throw new Error("unknown text editor");if(D.options&&f._acceptOptions(D.options),D.selections){const v=D.selections.selections.map(C.Selection.to);f._acceptSelections(v)}if(D.visibleRanges){const v=n.coalesce(D.visibleRanges.map(C.Range.to));f._acceptVisibleRanges(v)}if(D.options&&this.b.fire({textEditor:f.value,options:{...D.options,lineNumbers:C.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const v=R.TextEditorSelectionChangeKind.fromValue(D.selections.source),h=D.selections.selections.map(C.Selection.to);this.a.fire({textEditor:f.value,selections:h,kind:v})}if(D.visibleRanges){const v=n.coalesce(D.visibleRanges.map(C.Range.to));this.c.fire({textEditor:f.value,visibleRanges:v})}}$acceptEditorPositionData(O){for(const D in O){const f=this.i.getEditor(D);if(!f)throw new Error("Unknown text editor");const v=C.ViewColumn.to(O[D]);f.value.viewColumn!==v&&(f._acceptViewColumn(v),this.d.fire({textEditor:f.value,viewColumn:v}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.ExtHostEditors=S}),define(Ie[224],Ce([1,0,2,3,4,7,6,8,9]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class k{constructor(f,v){this.b=new Map,this.c=new Map,this.a=f.getProxy(y.MainContext.MainThreadTimeline),v.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===12){const i=h.uri===void 0?void 0:n.URI.revive(h.uri);return this.c.get(h.source)?.get(O(i))?.get(h.handle)}return h}})}async $getTimeline(f,v,h,i){return this.b.get(f)?.provideTimeline(n.URI.revive(v),h,i)}registerTimelineProvider(f,v,h,i){const o=new L.DisposableStore,l=this.d(v.id,i,o).bind(this);let E;v.onDidChange&&(E=v.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:v.id}),this));const b=this.c;return this.f({...v,scheme:f,onDidChange:void 0,async provideTimeline(g,w,s){w?.resetCache&&(o.clear(),b.get(v.id)?.clear());const r=await v.provideTimeline(g,w,s);if(r==null)return;const a=l(g,w);return{...r,source:v.id,items:r.items.map(a)}},dispose(){for(const g of b.values())g.get(v.id)?.clear();E?.dispose(),o.dispose()}})}d(f,v,h){return(i,o)=>{let l;if(o?.cacheResults){let E=this.c.get(f);E===void 0&&(E=new Map,this.c.set(f,E));const b=O(i);l=E.get(b),l===void 0&&(l=new Map,E.set(b,l))}return E=>{const{iconPath:b,...g}=E,w=`${f}|${E.id??E.timestamp}`;l?.set(w,E);let s,r,a;E.iconPath&&(b instanceof C.ThemeIcon?a={id:b.id,color:b.color}:n.URI.isUri(b)?(s=b,r=b):{light:s,dark:r}=b);let d;return C.MarkdownString.isMarkdownString(g.tooltip)?d=R.MarkdownString.from(g.tooltip):(0,S.isString)(g.tooltip)?d=g.tooltip:C.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=R.MarkdownString.from(g.detail)):(0,S.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=g.detail),{...g,id:g.id??void 0,handle:w,source:f,command:E.command?v.toInternal(E.command,h):void 0,icon:s,iconDark:r,themeIcon:a,tooltip:d,accessibilityInformation:E.accessibilityInformation}}}}f(f){if(this.b.get(f.id))throw new Error(`Timeline Provider ${f.id} already exists.`);return this.a.$registerTimelineProvider({id:f.id,label:f.label,scheme:f.scheme}),this.b.set(f.id,f),(0,L.toDisposable)(()=>{for(const h of this.c.values())h.get(f.id)?.clear();this.b.delete(f.id),this.a.$unregisterTimelineProvider(f.id),f.dispose()})}}e.ExtHostTimeline=k;function O(D){return D?.toString()}}),define(Ie[225],Ce([1,0,7,13,2,4]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,O,D){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const f=D.schemes.find(v=>!C.a.has(v));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(k,O),this.b.$registerUriOpener(k,D.schemes,S,D.label),(0,n.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(S,k,O){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const f=y.URI.revive(k);return D.canOpenExternalUri(f,O)}async $openUri(S,k,O){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(y.URI.revive(k.resolvedUri),{sourceUri:y.URI.revive(k.sourceUri)},O)}}e.ExtHostUriOpeners=C,C.a=new Set([T.Schemas.http,T.Schemas.https])}),define(Ie[226],Ce([1,0,4,2,7,11,26]),function(te,e,n,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(k,O){if(this.c.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const D=R.a++;return this.c.add(C.ExtensionIdentifier.toKey(k)),this.d.set(D,O),this.b.$registerUriHandler(D,k),(0,y.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(k)),this.d.delete(D),this.b.$unregisterUriHandler(D)})}$handleExternalUri(k,O){const D=this.d.get(k);if(!D)return Promise.resolve(void 0);try{D.handleUri(T.URI.revive(O))}catch(f){(0,L.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this.b.$createAppUri(k))}}e.ExtHostUrls=R,R.a=0});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Ie[59],Ce([1,0,5,13,23,2,148,168,68,4]),function(te,e,n,T,y,L,C,R,S,k){"use strict";var O,D,f,v,h,i,o,l,E,b,g,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class r{constructor(N,q,j,V,P,M,F){O.set(this,void 0),D.set(this,void 0),f.set(this,void 0),v.set(this,void 0),h.set(this,void 0),i.set(this,void 0),o.set(this,""),l.set(this,void 0),E.set(this,!1),b.set(this,!1),g.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new n.Emitter),this._onDidDispose=Re(this,s,"f").event,Ye(this,O,N,"f"),Ye(this,D,q,"f"),Ye(this,l,j,"f"),Ye(this,v,V,"f"),Ye(this,h,P,"f"),Ye(this,i,M,"f"),Ye(this,g,a(M),"f"),Ye(this,w,d(M),"f"),Ye(this,f,F,"f")}dispose(){Ye(this,E,!0,"f"),Re(this,s,"f").fire(),Re(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(N){return Ye(this,b,!0,"f"),(0,S.asWebviewUri)(N,Re(this,v,"f"))}get cspSource(){const N=Re(this,i,"f").extensionLocation;if(N.scheme===T.Schemas.https||N.scheme===T.Schemas.http){let q=N.toString();return q.endsWith("/")||(q+="/"),q+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Re(this,o,"f")}set html(N){this.a(),Re(this,o,"f")!==N&&(Ye(this,o,N,"f"),Re(this,w,"f")&&!Re(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(N)&&(Ye(this,b,!0,"f"),Re(this,f,"f").report("Webview vscode-resource: uris",Re(this,i,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,D,"f").$setHtml(Re(this,O,"f"),this.b(N)))}get options(){return this.a(),Re(this,l,"f")}set options(N){this.a(),y.equals(Re(this,l,"f"),N)||Re(this,D,"f").$setOptions(Re(this,O,"f"),t(Re(this,i,"f"),Re(this,h,"f"),N)),Ye(this,l,N,"f")}async postMessage(N){if(Re(this,E,"f"))return!1;const q=(0,R.serializeWebviewMessage)(N,{serializeBuffersForPostMessage:Re(this,g,"f")});return Re(this,D,"f").$postMessage(Re(this,O,"f"),q.message,...q.buffers)}a(){if(Re(this,E,"f"))throw new Error("Webview is disposed")}b(N){if(!Re(this,w,"f"))return N;const q=Re(this,i,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,j=Re(this,i,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Re(this,i,"f").extensionLocation.authority:void 0;return N.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,P,M,F,$,z)=>{const K=L.URI.from({scheme:F||"file",path:decodeURIComponent($)}),X=(0,S.asWebviewUri)(K,{isRemote:q,authority:j}).toString();return`${P}${X}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,P,M,F,$,z)=>{const K=L.URI.from({scheme:F||"file",path:decodeURIComponent($)}),X=(0,S.asWebviewUri)(K,{isRemote:q,authority:j}).toString();return`${P}${X}${z}`})}}e.ExtHostWebview=r,O=new WeakMap,D=new WeakMap,f=new WeakMap,v=new WeakMap,h=new WeakMap,i=new WeakMap,o=new WeakMap,l=new WeakMap,E=new WeakMap,b=new WeakMap,g=new WeakMap,w=new WeakMap,s=new WeakMap;function a(A){try{const N=(0,C.normalizeVersion)((0,C.parseVersion)(A.engines.vscode));return!!N&&N.majorBase>=1&&N.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function d(A){try{const N=(0,C.normalizeVersion)((0,C.parseVersion)(A.engines.vscode));return N?N.majorBase<1||N.majorBase===1&&N.minorBase<60:!1}catch{return!1}}class c{constructor(N,q,j,V,P){this.c=q,this.d=j,this.e=V,this.f=P,this.b=new Map,this.a=N.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(N,q,j){const V=this.g(N);if(V){const{message:P}=(0,R.deserializeWebviewMessage)(q,j.value);V._onMessageEmitter.fire(P)}}$onMissingCsp(N,q){this.e.warn(`${q} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(N,q,j){const V=new r(N,this.a,m(q),this.c,this.d,j,this.f);return this.b.set(N,V),V._onDidDispose(()=>{this.b.delete(N)}),V}deleteWebview(N){this.b.delete(N)}g(N){return this.b.get(N)}}e.ExtHostWebviews=c;function u(A){return{id:A.identifier,location:A.extensionLocation}}e.toExtensionData=u;function t(A,N,q){return{enableCommandUris:q.enableCommandUris,enableScripts:q.enableScripts,enableForms:q.enableForms,portMapping:q.portMapping,localResourceRoots:q.localResourceRoots||p(A,N)}}e.serializeWebviewOptions=t;function m(A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,enableForms:A.enableForms,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots?.map(N=>L.URI.from(N))}}function p(A,N){return[...(N?.getWorkspaceFolders()||[]).map(q=>q.uri),A.extensionLocation]}}),define(Ie[227],Ce([1,0,20,222,7,13,22,2,8,59,51,4,6]),function(te,e,n,T,y,L,C,R,S,k,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class v{constructor(r,a){this.document=r,this.b=a,this.a=1,this.c=new O.Cache("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,a){await this.f(r).undo(),a||this.disposeBackup()}async redo(r,a){await this.f(r).redo(),a||this.disposeBackup()}disposeEdits(r){for(const a of r)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=w(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const a=this.c.get(r,0);if(!a)throw new Error("No edit found");return a}}class h{constructor(){this.a=new Map}get(r,a){return this.a.get(this.b(r,a))}add(r,a,d){const c=this.b(r,a.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${a.uri}`);const u=new v(a,d);return this.a.set(c,u),u}delete(r,a){const d=this.b(r,a.uri);this.a.delete(d)}b(r,a){return`${r}@@@${a}`}}var i;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(i||(i={}));class o{constructor(){this.a=new Map}addTextProvider(r,a,d){return this.b(0,r,a,d)}addCustomProvider(r,a,d){return this.b(1,r,a,d)}get(r){return this.a.get(r)}b(r,a,d,c){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:r,extension:d,provider:c}),new f.Disposable(()=>this.a.delete(a))}}class l{constructor(r,a,d,c,u){this.d=a,this.f=d,this.g=c,this.h=u,this.b=new o,this.c=new h,this.a=r.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,a,d,c){const u=new y.DisposableStore;return b(d)?(u.add(this.b.addTextProvider(a,r,d)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(r),a,c.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(r))):(u.add(this.b.addCustomProvider(a,r,d)),E(d)&&u.add(d.onDidChangeCustomDocument(t=>{const m=this.i(a,t.document.uri);if(g(t)){const p=m.addEdit(t);this.a.$onDidEdit(t.document.uri,a,p,t.label)}else this.a.$onContentChange(t.document.uri,a)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(r),a,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(r))),f.Disposable.from(u,new f.Disposable(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(r,a,d,c,u){const t=this.b.get(a);if(!t)throw new Error(`No provider found for '${a}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${a}'`);const m=R.URI.revive(r),p=await t.provider.openCustomDocument(m,{backupId:d,untitledDocumentData:c?.buffer},u);let A;return E(t.provider)&&this.f&&(A=this.f.workspaceValue(t.extension)??this.f.globalValue(t.extension)),this.c.add(a,p,A),{editable:E(t.provider)}}async $disposeCustomDocument(r,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const c=R.URI.revive(r),{document:u}=this.i(a,c);this.c.delete(a,u),u.dispose()}async $resolveWebviewEditor(r,a,d,c,u,t){const m=this.b.get(d);if(!m)throw new Error(`No provider found for '${d}'`);const p=S.ViewColumn.to(u),A=this.g.createNewWebview(a,c.contentOptions,m.extension),N=this.h.createNewWebviewPanel(a,d,c.title,p,c.options,A,!0),q=R.URI.revive(r);switch(m.type){case 1:{const{document:j}=this.i(d,q);return m.provider.resolveCustomEditor(j,N,t)}case 0:{const j=this.d.getDocument(q);return m.provider.resolveCustomTextEditor(j,N,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,a,d){this.i(a,r).disposeEdits(d)}async $onMoveCustomEditor(r,a,d){const c=this.b.get(d);if(!c)throw new Error(`No provider found for '${d}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const u=this.h.getWebviewPanel(r);if(!u)throw new Error("No webview found");const t=R.URI.revive(a),m=this.d.getDocument(t);await c.provider.moveCustomTextEditor(m,u,n.CancellationToken.None)}async $undo(r,a,d,c){return this.i(a,r).undo(d,c)}async $redo(r,a,d,c){return this.i(a,r).redo(d,c)}async $revert(r,a,d){const c=this.i(a,r);await this.j(a).revertCustomDocument(c.document,d),c.disposeBackup()}async $onSave(r,a,d){const c=this.i(a,r);await this.j(a).saveCustomDocument(c.document,d),c.disposeBackup()}async $onSaveAs(r,a,d,c){const u=this.i(a,r);return this.j(a).saveCustomDocumentAs(u.document,R.URI.revive(d),c)}async $backup(r,a,d){const c=this.i(a,r),t=await this.j(a).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},d);return c.updateBackup(t),t.id}i(r,a){const d=this.c.get(r,R.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(r){const d=this.b.get(r)?.provider;if(!d||!E(d))throw new Error("Custom document is not editable");return d}}e.ExtHostCustomEditors=l;function E(s){return!!s.onDidChangeCustomDocument}function b(s){return typeof s.resolveCustomTextEditor=="function"}function g(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function w(s){const r=s.scheme===L.Schemas.file||s.scheme===L.Schemas.untitled?s.fsPath:s.toString();return(0,T.hash)(r)+""}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Ie[228],Ce([1,0,5,7,2,34,8,59,4,6]),function(te,e,n,T,y,L,C,R,S,k){"use strict";var O,D,f,v,h,i,o,l,E,b,g,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends T.Disposable{constructor(u,t,m,p){super(),O.set(this,void 0),D.set(this,void 0),f.set(this,void 0),v.set(this,void 0),h.set(this,void 0),i.set(this,void 0),o.set(this,void 0),l.set(this,void 0),E.set(this,!0),b.set(this,void 0),g.set(this,!1),w.set(this,this.B(new n.Emitter)),this.onDidDispose=Re(this,w,"f").event,s.set(this,this.B(new n.Emitter)),this.onDidChangeViewState=Re(this,s,"f").event,Ye(this,O,u,"f"),Ye(this,D,t,"f"),Ye(this,v,m,"f"),Ye(this,f,p.viewType,"f"),Ye(this,h,p.panelOptions,"f"),Ye(this,l,p.viewColumn,"f"),Ye(this,i,p.title,"f"),Ye(this,b,p.active,"f")}dispose(){Re(this,g,"f")||(Ye(this,g,!0,"f"),Re(this,w,"f").fire(),Re(this,D,"f").$disposeWebview(Re(this,O,"f")),Re(this,v,"f").dispose(),super.dispose())}get webview(){return this.c(),Re(this,v,"f")}get viewType(){return this.c(),Re(this,f,"f")}get title(){return this.c(),Re(this,i,"f")}set title(u){this.c(),Re(this,i,"f")!==u&&(Ye(this,i,u,"f"),Re(this,D,"f").$setTitle(Re(this,O,"f"),u))}get iconPath(){return this.c(),Re(this,o,"f")}set iconPath(u){this.c(),Re(this,o,"f")!==u&&(Ye(this,o,u,"f"),Re(this,D,"f").$setIconPath(Re(this,O,"f"),y.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Re(this,h,"f")}get viewColumn(){if(this.c(),!(typeof Re(this,l,"f")=="number"&&Re(this,l,"f")<0))return Re(this,l,"f")}get active(){return this.c(),Re(this,b,"f")}get visible(){return this.c(),Re(this,E,"f")}_updateViewState(u){Re(this,g,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Ye(this,b,u.active,"f"),Ye(this,E,u.visible,"f"),Ye(this,l,u.viewColumn,"f"),Re(this,s,"f").fire({webviewPanel:this}))}reveal(u,t){this.c(),Re(this,D,"f").$reveal(Re(this,O,"f"),{viewColumn:typeof u>"u"?void 0:C.ViewColumn.from(u),preserveFocus:!!t})}c(){if(Re(this,g,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,D=new WeakMap,f=new WeakMap,v=new WeakMap,h=new WeakMap,i=new WeakMap,o=new WeakMap,l=new WeakMap,E=new WeakMap,b=new WeakMap,g=new WeakMap,w=new WeakMap,s=new WeakMap;class a{static c(){return(0,L.generateUuid)()}constructor(u,t,m){this.g=t,this.h=m,this.e=new Map,this.f=new Map,this.d=u.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,t,m,p,A={}){const N=typeof p=="object"?p.viewColumn:p,q={viewColumn:C.ViewColumn.from(N),preserveFocus:typeof p=="object"&&!!p.preserveFocus},j=(0,R.shouldSerializeBuffersForPostMessage)(u),V=a.c();this.d.$createWebviewPanel((0,R.toExtensionData)(u),V,t,{title:m,panelOptions:d(A),webviewOptions:(0,R.serializeWebviewOptions)(u,this.h,A),serializeBuffersForPostMessage:j},q);const P=this.g.createNewWebview(V,A,u);return this.createNewWebviewPanel(V,t,m,N,A,P,!0)}$onDidChangeWebviewPanelViewStates(u){const t=Object.keys(u);t.sort((m,p)=>{const A=u[m],N=u[p];return A.active?1:N.active?-1:+A.visible-+N.visible});for(const m of t){const p=this.getWebviewPanel(m);if(!p)continue;const A=u[m];p._updateViewState({active:A.active,visible:A.visible,viewColumn:C.ViewColumn.to(A.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.e.delete(u),this.g.deleteWebview(u)}registerWebviewPanelSerializer(u,t,m){if(this.f.has(t))throw new Error(`Serializer for '${t}' already registered`);return this.f.set(t,{serializer:m,extension:u}),this.d.$registerSerializer(t,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(u)}),new k.Disposable(()=>{this.f.delete(t),this.d.$unregisterSerializer(t)})}async $deserializeWebviewPanel(u,t,m,p){const A=this.f.get(t);if(!A)throw new Error(`No serializer found for '${t}'`);const{serializer:N,extension:q}=A,j=this.g.createNewWebview(u,m.webviewOptions,q),V=this.createNewWebviewPanel(u,t,m.title,p,m.panelOptions,j,m.active);await N.deserializeWebviewPanel(V,m.state)}createNewWebviewPanel(u,t,m,p,A,N,q){const j=new r(u,this.d,N,{viewType:t,title:m,viewColumn:p,panelOptions:A,active:q});return this.e.set(u,j),j}getWebviewPanel(u){return this.e.get(u)}}e.ExtHostWebviewPanels=a;function d(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Ie[229],Ce([1,0,5,7,59,8,4,6]),function(te,e,n,T,y,L,C,R){"use strict";var S,k,O,D,f,v,h,i,o,l,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends T.Disposable{constructor(s,r,a,d,c,u){super(),S.set(this,void 0),k.set(this,void 0),O.set(this,void 0),D.set(this,void 0),f.set(this,!1),v.set(this,void 0),h.set(this,void 0),i.set(this,void 0),o.set(this,void 0),l.set(this,this.B(new n.Emitter)),this.onDidChangeVisibility=Re(this,l,"f").event,E.set(this,this.B(new n.Emitter)),this.onDidDispose=Re(this,E,"f").event,Ye(this,O,a,"f"),Ye(this,h,d,"f"),Ye(this,S,s,"f"),Ye(this,k,r,"f"),Ye(this,D,c,"f"),Ye(this,v,u,"f")}dispose(){Re(this,f,"f")||(Ye(this,f,!0,"f"),Re(this,E,"f").fire(),Re(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Re(this,h,"f")}set title(s){this.a(),Re(this,h,"f")!==s&&(Ye(this,h,s,"f"),Re(this,k,"f").$setWebviewViewTitle(Re(this,S,"f"),s))}get description(){return this.a(),Re(this,i,"f")}set description(s){this.a(),Re(this,i,"f")!==s&&(Ye(this,i,s,"f"),Re(this,k,"f").$setWebviewViewDescription(Re(this,S,"f"),s))}get visible(){return Re(this,v,"f")}get webview(){return Re(this,D,"f")}get viewType(){return Re(this,O,"f")}_setVisible(s){s===Re(this,v,"f")||Re(this,f,"f")||(Ye(this,v,s,"f"),Re(this,l,"f").fire())}get badge(){return this.a(),Re(this,o,"f")}set badge(s){this.a(),!(s?.value===Re(this,o,"f")?.value&&s?.tooltip===Re(this,o,"f")?.tooltip)&&(Ye(this,o,L.ViewBadge.from(s),"f"),Re(this,k,"f").$setWebviewViewBadge(Re(this,S,"f"),s))}show(s){this.a(),Re(this,k,"f").$show(Re(this,S,"f"),!!s)}a(){if(Re(this,f,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,k=new WeakMap,O=new WeakMap,D=new WeakMap,f=new WeakMap,v=new WeakMap,h=new WeakMap,i=new WeakMap,o=new WeakMap,l=new WeakMap,E=new WeakMap;class g{constructor(s,r){this.d=r,this.b=new Map,this.c=new Map,this.a=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,r,a,d){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:a,extension:s}),this.a.$registerWebviewViewProvider((0,y.toExtensionData)(s),r,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(s)}),new R.Disposable(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(s,r,a,d,c){const u=this.b.get(r);if(!u)throw new Error(`No view provider found for '${r}'`);const{provider:t,extension:m}=u,p=this.d.createNewWebview(s,{},m),A=new b(s,this.a,r,a,p,!0);this.c.set(s,A),await t.resolveWebviewView(A,{state:d},c)}async $onDidChangeWebviewViewVisibility(s,r){this.e(s)._setVisible(r)}async $disposeWebviewView(s){const r=this.e(s);this.c.delete(s),r.dispose(),this.d.deleteWebview(s)}e(s){const r=this.c.get(s);if(!r)throw new Error("No webview found");return r}}e.ExtHostWebviewViews=g}),define(Ie[100],Ce([1,0,5,4,2,13,10,3,14]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class nn{get state(){return this.d}constructor(D){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=nn.a,this.b=D.getProxy(T.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}$onDidChangeWindowFocus(D){D!==this.d.focused&&(this.d={...this.d,focused:D},this.c.fire(this.d))}openUri(D,f){let v;if(typeof D=="string"){v=D;try{D=y.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,C.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this.b.$openUri(D,v,f)}async asExternalUri(D,f){if((0,C.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(D,f);return y.URI.from(v)}};k.a={focused:!0},k=qe([Ve(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(Ie[230],Ce([1,0,199,27,14]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends n.AbstractExtHostConsoleForwarder{constructor(R,S){super(R,S)}f(R,S,k){S.apply(console,k)}};L=qe([Ve(0,y.IExtHostRpcService),Ve(1,T.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(Ie[231],Ce([1,0,15,24,20,11,5,7,121,193,43]),function(te,e,n,T,y,L,C,R,S,k,O){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(A,N){try{return JSON.stringify(A,N)}catch{return"null"}}const v="$$ref$$",h={[v]:-1};class i{constructor(N,q){this.jsonString=N,this.referencedBuffers=q}}function o(A,N=null,q=!1){const j=[];return{jsonString:(q?f:JSON.stringify)(A,(P,M)=>{if(typeof M>"u")return h;if(typeof M=="object"){if(M instanceof T.VSBuffer){const F=j.push(M)-1;return{[v]:F}}if(N)return N(P,M)}return M}),referencedBuffers:j}}e.stringifyJsonWithBufferRefs=o;function l(A,N,q){return JSON.parse(A,(j,V)=>{if(V){const P=V[v];if(typeof P=="number")return N[P];if(q&&V.$mid===1)return q.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=l;function E(A,N){return JSON.stringify(A,N)}function b(A){return A?(N,q)=>q&&q.$mid===1?A.transformOutgoing(q):q:null}var g;(function(A){A[A.LocalSide=0]="LocalSide",A[A.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(A){A[A.Responsive=0]="Responsive",A[A.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},r=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends R.Disposable{constructor(N,q=null,j=null){super(),this[D]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=q,this.g=j,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,P=O.ProxyIdentifier.count;V<P;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new n.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(N=>{this.s[N].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(N){this.u===0&&(this.v=Date.now()+d.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(N){this.v=Date.now()+d.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(N){this.t!==N&&(this.t=N,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(N){return this.g?(0,S.transformIncomingURIs)(N,this.g):N}getProxy(N){const{nid:q,sid:j}=N;return this.l[q]||(this.l[q]=this.F(q,j)),this.l[q]}F(N,q){const j={get:(V,P)=>(typeof P=="string"&&!V[P]&&P.charCodeAt(0)===36&&(V[P]=(...M)=>this.O(N,P,M)),P===a?q:V[P])};return new Proxy(Object.create(null),j)}set(N,q){return this.k[N.nid]=q,q}assertRegistered(N){for(let q=0,j=N.length;q<j;q++){const V=N[q];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(N){if(this.j)return;const q=N.byteLength,j=c.read(N,0),V=j.readUInt8(),P=j.readUInt32();switch(V){case 1:case 2:{let{rpcId:M,method:F,args:$}=t.deserializeRequestJSONArgs(j);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.H(q,P,M,F,$,V===2);break}case 3:case 4:{let{rpcId:M,method:F,args:$}=t.deserializeRequestMixedArgs(j);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.H(q,P,M,F,$,V===4);break}case 5:{this.f?.logIncoming(q,P,0,"ack"),this.z(P);break}case 6:{this.I(q,P);break}case 7:{this.J(q,P,void 0);break}case 9:{let M=t.deserializeReplyOKJSON(j);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.J(q,P,M);break}case 10:{const M=t.deserializeReplyOKJSONWithBuffers(j,this.g);this.J(q,P,M);break}case 8:{const M=t.deserializeReplyOKVSBuffer(j);this.J(q,P,M);break}case 11:{let M=t.deserializeReplyErrError(j);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.L(q,P,M);break}case 12:{this.L(q,P,void 0);break}default:console.error("received unexpected message"),console.error(N)}}H(N,q,j,V,P,M){this.f?.logIncoming(N,q,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(j)}.${V}(`,P);const F=String(q);let $,z;if(M){const X=new y.CancellationTokenSource;P.push(X.token),$=this.M(j,V,P),z=()=>X.cancel()}else $=this.M(j,V,P),z=s;this.p[F]=z;const K=t.serializeAcknowledged(q);this.f?.logOutgoing(K.byteLength,q,1,"ack"),this.c.send(K),$.then(X=>{delete this.p[F];const Z=t.serializeReplyOK(q,X,this.h);this.f?.logOutgoing(Z.byteLength,q,1,"reply:",X),this.c.send(Z)},X=>{delete this.p[F];const Z=t.serializeReplyErr(q,X);this.f?.logOutgoing(Z.byteLength,q,1,"replyErr:",X),this.c.send(Z)})}I(N,q){this.f?.logIncoming(N,q,1,"receiveCancel");const j=String(q);this.p[j]?.()}J(N,q,j){this.f?.logIncoming(N,q,0,"receiveReply:",j);const V=String(q);if(!this.s.hasOwnProperty(V))return;const P=this.s[V];delete this.s[V],P.resolveOk(j)}L(N,q,j){this.f?.logIncoming(N,q,0,"receiveReplyErr:",j);const V=String(q);if(!this.s.hasOwnProperty(V))return;const P=this.s[V];delete this.s[V];let M;j&&(j.$isError?(M=new Error,M.name=j.name,M.message=j.message,M.stack=j.stack):M=j),P.resolveErr(M)}M(N,q,j){try{return Promise.resolve(this.N(N,q,j))}catch(V){return Promise.reject(V)}}N(N,q,j){const V=this.k[N];if(!V)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(N));const P=V[q];if(typeof P!="function")throw new Error("Unknown method "+q+" on actor "+(0,O.getStringIdentifierForProxy)(N));return P.apply(V,j)}O(N,q,j){if(this.j)return new k.CanceledLazyPromise;let V=null;if(j.length>0&&y.CancellationToken.isCancellationToken(j[j.length-1])&&(V=j.pop()),V&&V.isCancellationRequested)return Promise.reject(L.canceled());const P=t.serializeRequestArguments(j,this.h),M=++this.m,F=String(M),$=new k.LazyPromise;V&&V.onCancellationRequested(()=>{const K=t.serializeCancel(M);this.f?.logOutgoing(K.byteLength,M,0,"cancel"),this.c.send(t.serializeCancel(M))}),this.s[F]=$,this.y(M);const z=t.serializeRequest(M,N,q,P,!!V);return this.f?.logOutgoing(z.byteLength,M,0,`request: ${(0,O.getStringIdentifierForProxy)(N)}.${q}(`,j),this.c.send(z),$}}e.RPCProtocol=d,D=r,d.a=3*1e3;class c{static alloc(N,q,j){const V=new c(T.VSBuffer.alloc(j+1+4),0);return V.writeUInt8(N),V.writeUInt32(q),V}static read(N,q){return new c(N,q)}get buffer(){return this.a}constructor(N,q){this.a=N,this.b=q}static sizeUInt8(){return 1}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+N);return this.b+=N,q}static sizeMixedArray(N){let q=0;q+=1;for(let j=0,V=N.length;j<V;j++){const P=N[j];switch(q+=1,P.type){case 1:q+=this.sizeLongString(P.value);break;case 2:q+=this.sizeVSBuffer(P.value);break;case 3:q+=this.sizeUInt32,q+=this.sizeLongString(P.value);for(let M=0;M<P.buffers.length;++M)q+=this.sizeVSBuffer(P.buffers[M]);break;case 4:break}}return q}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let q=0,j=N.length;q<j;q++){const V=N[q];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let P=0;P<V.buffers.length;++P)this.writeBuffer(V.buffers[P]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const q=new Array(N);for(let j=0;j<N;j++)switch(this.readUInt8()){case 1:q[j]=this.readLongString();break;case 2:q[j]=this.readVSBuffer();break;case 3:{const P=this.readUInt32(),M=this.readLongString(),F=[];for(let $=0;$<P;++$)F.push(this.readVSBuffer());q[j]=new O.SerializableObjectWithBuffers(l(M,F,null));break}case 4:q[j]=void 0;break}return q}}c.sizeUInt32=4;var u;(function(A){A[A.Simple=0]="Simple",A[A.Mixed=1]="Mixed"})(u||(u={}));class t{static a(N){for(let q=0,j=N.length;q<j;q++)if(N[q]instanceof T.VSBuffer||N[q]instanceof O.SerializableObjectWithBuffers||typeof N[q]>"u")return!0;return!1}static serializeRequestArguments(N,q){if(this.a(N)){const j=[];for(let V=0,P=N.length;V<P;V++){const M=N[V];if(M instanceof T.VSBuffer)j[V]={type:2,value:M};else if(typeof M>"u")j[V]={type:4};else if(M instanceof O.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:$}=o(M.value,q);j[V]={type:3,value:T.VSBuffer.fromString(F),buffers:$}}else j[V]={type:1,value:T.VSBuffer.fromString(E(M,q))}}return{type:1,args:j}}return{type:0,args:E(N,q)}}static serializeRequest(N,q,j,V,P){switch(V.type){case 0:return this.b(N,q,j,V.args,P);case 1:return this.c(N,q,j,V.args,P)}}static b(N,q,j,V,P){const M=T.VSBuffer.fromString(j),F=T.VSBuffer.fromString(V);let $=0;$+=c.sizeUInt8(),$+=c.sizeShortString(M),$+=c.sizeLongString(F);const z=c.alloc(P?2:1,N,$);return z.writeUInt8(q),z.writeShortString(M),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(N){const q=N.readUInt8(),j=N.readShortString(),V=N.readLongString();return{rpcId:q,method:j,args:JSON.parse(V)}}static c(N,q,j,V,P){const M=T.VSBuffer.fromString(j);let F=0;F+=c.sizeUInt8(),F+=c.sizeShortString(M),F+=c.sizeMixedArray(V);const $=c.alloc(P?4:3,N,F);return $.writeUInt8(q),$.writeShortString(M),$.writeMixedArray(V),$.buffer}static deserializeRequestMixedArgs(N){const q=N.readUInt8(),j=N.readShortString(),V=N.readMixedArray(),P=new Array(V.length);for(let M=0,F=V.length;M<F;M++){const $=V[M];typeof $=="string"?P[M]=JSON.parse($):P[M]=$}return{rpcId:q,method:j,args:P}}static serializeAcknowledged(N){return c.alloc(5,N,0).buffer}static serializeCancel(N){return c.alloc(6,N,0).buffer}static serializeReplyOK(N,q,j){if(typeof q>"u")return this.d(N);if(q instanceof T.VSBuffer)return this.e(N,q);if(q instanceof O.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:P}=o(q.value,j,!0);return this.g(N,V,P)}else return this.f(N,f(q,j))}static d(N){return c.alloc(7,N,0).buffer}static e(N,q){let j=0;j+=c.sizeVSBuffer(q);const V=c.alloc(8,N,j);return V.writeVSBuffer(q),V.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,q){const j=T.VSBuffer.fromString(q);let V=0;V+=c.sizeLongString(j);const P=c.alloc(9,N,V);return P.writeLongString(j),P.buffer}static g(N,q,j){const V=T.VSBuffer.fromString(q);let P=0;P+=c.sizeUInt32,P+=c.sizeLongString(V);for(const F of j)P+=c.sizeVSBuffer(F);const M=c.alloc(10,N,P);M.writeUInt32(j.length),M.writeLongString(V);for(const F of j)M.writeBuffer(F);return M.buffer}static deserializeReplyOKJSON(N){const q=N.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(N,q){const j=N.readUInt32(),V=N.readLongString(),P=[];for(let M=0;M<j;++M)P.push(N.readVSBuffer());return new O.SerializableObjectWithBuffers(l(V,P,q))}static serializeReplyErr(N,q){const j=q?f(L.transformErrorForSerialization(q),null):void 0;if(typeof j!="string")return this.h(N);const V=T.VSBuffer.fromString(j);let P=0;P+=c.sizeLongString(V);const M=c.alloc(11,N,P);return M.writeLongString(V),M.buffer}static deserializeReplyErrError(N){const q=N.readLongString();return JSON.parse(q)}static h(N){return c.alloc(12,N,0).buffer}}var m;(function(A){A[A.RequestJSONArgs=1]="RequestJSONArgs",A[A.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",A[A.RequestMixedArgs=3]="RequestMixedArgs",A[A.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",A[A.Acknowledged=5]="Acknowledged",A[A.Cancel=6]="Cancel",A[A.ReplyOKEmpty=7]="ReplyOKEmpty",A[A.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",A[A.ReplyOKJSON=9]="ReplyOKJSON",A[A.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",A[A.ReplyErrError=11]="ReplyErrError",A[A.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var p;(function(A){A[A.String=1]="String",A[A.VSBuffer=2]="VSBuffer",A[A.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",A[A.Undefined=4]="Undefined"})(p||(p={}))}),define(Ie[232],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(L){const C=R=>{self.removeEventListener("message",C);const S=R.data;Object.defineProperties(self,{postMessage:{value(k,O){S.postMessage(k,O)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",C)}.toString();class T extends EventTarget{constructor(L,C,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${n})('${C}'))`,k=new Blob([S],{type:"application/javascript"}),O=URL.createObjectURL(k),D=new MessageChannel,f=O,v={type:"_newWorker",id:f,port:D.port2,url:O,options:R};L(v,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:f}),URL.revokeObjectURL(O),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(h){D.port1.onmessage=h}},onmessageerror:{get(){return D.port1.onmessageerror},set(h){D.port1.onmessageerror=h}}}),D.port1.addEventListener("messageerror",h=>{const i=new MessageEvent("messageerror",{data:h.data});this.dispatchEvent(i)}),D.port1.addEventListener("message",h=>{const i=new MessageEvent("message",{data:h.data});this.dispatchEvent(i)}),D.port1.start()}}e.NestedWorker=T}),define(Ie[233],Ce([1,0,5,30,41,3,36,11,15]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(h){this.a.has(h.id)||(this.a.set(h.id,h),this.b.fire(h.id))}getChannels(){const h=[];return this.a.forEach(i=>h.push(i)),h}getChannel(h){return this.a.get(h)}removeChannel(h){this.a.delete(h),this.c.fire(h)}}T.Registry.add(e.Extensions.OutputChannels,new O);function D(v,h,i,o,l){return(0,S.createCancelablePromise)(async E=>{await(0,C.whenProviderRegistered)(i,o);const b=T.Registry.as(e.Extensions.OutputChannels);try{await f(i,1,o,l,E),b.registerChannel({id:v,label:h,file:i,log:!0})}catch(g){(0,R.isCancellationError)(g)||l.error("Error while registering log channel",i.toString(),(0,R.getErrorMessage)(g))}})}e.registerLogChannel=D;async function f(v,h,i,o,l){if(!await i.exists(v)){if(l.isCancellationRequested)throw new R.CancellationError;if(h>10)throw new Error("Timed out while waiting for file to be created");o.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",v.toString()),await(0,S.timeout)(1e3,l),await f(v,h+1,i,o,l)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(Ie[101],Ce([1,0,4,3,14,26,12,233,57,27,37,115,24,9,36,5,7]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(w,s,r,a,d){super(),this.id=w,this.name=s,this.m=r,this.n=a,this.extension=d,this.k=0,this.l=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,w)}replace(w){const s=this.k;this.info(w),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,s),this.visible&&this.m.flush()}show(w,s){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:s))}hide(){this.n.$close(this.id)}g(w,s){this.k+=f.VSBuffer.fromString(s).byteLength,(0,C.log)(this.m,w,s),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class E extends l{appendLine(w){this.append(w)}}let b=class{constructor(w,s,r,a,d,c){this.i=s,this.j=r,this.k=a,this.l=d,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[s,r]of this.g)r.visible=s===this.h}createOutputChannel(w,s,r){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const a=typeof s=="object"&&s.log,d=(0,v.isString)(s)?s:void 0;if((0,v.isString)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const u=this.i.environment.extensionLogLevel?.find(([m])=>L.ExtensionIdentifier.equals(r.identifier,m))?.[1];u&&(c=(0,C.parseLogLevel)(u));const t=a?this.o(w,c,r):this.n(w,d,r);return t.then(m=>{this.g.set(m.id,m),m.visible=m.id===this.h}),a?this.r(w,c??this.m.getLevel(),t):this.q(w,t)}async n(w,s,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(d,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.a.$register(w,d,!1,s,r.identifier.value);return new l(u,w,c,this.a,r)}async o(w,s,r){const a=await this.p(r),d=this.k.extUri.joinPath(a,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(d,{name:w},s),u=await this.a.$register(w,d,!0,void 0,r.identifier.value);return new E(u,w,c,this.a,r)}p(w){let s=this.d.get(w.identifier.value);if(!s){const r=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(r)}catch(a){if((0,h.toFileSystemProviderErrorCode)(a)!==h.FileSystemProviderErrorCode.FileExists)throw a}return r})())}return s}q(w,s){let r=!1;const a=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return w},append(d){a(),s.then(c=>c.append(d))},appendLine(d){a(),s.then(c=>c.appendLine(d))},clear(){a(),s.then(d=>d.clear())},replace(d){a(),s.then(c=>c.replace(d))},show(d,c){a(),s.then(u=>u.show(d,c))},hide(){a(),s.then(d=>d.hide())},dispose(){r=!0,s.then(d=>d.dispose())}}}r(w,s,r){const a=new o.DisposableStore,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},c=a.add(new i.Emitter);return r.then(u=>{a.add(u),a.add(u.onDidChangeLogLevel(t=>{s=t,c.fire(t)}))}),{...this.q(w,r),get logLevel(){return s},onDidChangeLogLevel:c.event,trace(u,...t){d(),r.then(m=>m.trace(u,...t))},debug(u,...t){d(),r.then(m=>m.debug(u,...t))},info(u,...t){d(),r.then(m=>m.info(u,...t))},warn(u,...t){d(),r.then(m=>m.warn(u,...t))},error(u,...t){d(),r.then(m=>m.error(u,...t))},dispose(){a.dispose()}}}};b=qe([Ve(0,y.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,S.IExtHostConsumerFileSystem),Ve(3,O.IExtHostFileSystemInfo),Ve(4,C.ILoggerService),Ve(5,C.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(Ie[234],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Ie[235],Ce([1,0,39,13,19,21,22,2,3,164,50,179,234]),function(te,e,n,T,y,L,C,R,S,k,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let v=class rn{constructor(i,o,l,E){this.d=i,this.e=o,this.f=l,this.g=E,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??i})()}hasValidBasename(i,o,l){return typeof o=="string"||typeof o>"u"?this.a.then(E=>this.h(i,E,o)):this.h(i,o,l)}h(i,o,l){return i.scheme===T.Schemas.file||i.scheme===T.Schemas.vscodeRemote?(0,n.isValidBasename)(l??(0,C.basename)(i),o===1):!0}get defaultUriScheme(){return rn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(i,o){if(i.remoteAuthority)return T.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(l)return l;const E=o.getWorkspace().folders[0];if(E)return E.uri.scheme;const b=o.getWorkspace().configuration;return b?b.scheme:T.Schemas.file}userHome(i){return i?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(i=>i===1?y.win32:y.posix)}async fileURI(i){let o="";if(await this.a===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const E=i.indexOf("/",2);E===-1?(o=i.substring(2),i="/"):(o=i.substring(2,E),i=i.substring(E)||"/")}return R.URI.from({scheme:T.Schemas.file,authority:o,path:i,query:"",fragment:""})}};v=qe([Ve(1,f.IRemoteAgentService),Ve(2,D.IWorkbenchEnvironmentService),Ve(3,O.IWorkspaceContextService)],v),e.AbstractPathService=v}),define(Ie[102],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(C,R){this.line=C,this.character=R}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,R){return new n(0,0)}with(C){return new n(0,0)}}e.Position=n;class T{constructor(C,R,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(C,R),this.end=new n(S,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new T(0,0,0,0)}with(C){return new T(0,0,0,0)}}e.Range=T;var y;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[44],Ce([1,0,16,35,23,39,10,3,19,11,102,15]),function(te,e,n,T,y,L,C,R,S,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",v=" characters skipped \u27EB",h=(f.length+v.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var i;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(i=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function l(oe){return!!oe.preview}e.resultIsMatch=l;function E(oe){return!!oe.resource}e.isFileMatch=E;function b(oe){return!!oe.message}e.isProgressMessage=b;var g;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(g=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=w;class s{constructor(ue,ce,fe){this.ranges=ce;const Y=Array.isArray(ce)?ce:[ce];if(fe&&fe.matchLines===1&&r(Y)){ue=(0,C.getNLines)(ue,fe.matchLines);let ge="",we=0,Me=0;const We=Math.floor(fe.charsPerLine/5),Qe=[];for(const Te of Y){const De=Math.max(Te.startColumn-We,0),ke=Te.startColumn+fe.charsPerLine;if(De>Me+We+h){const re=f+(De-Me)+v;ge+=re+ue.slice(De,ke),we+=De-(Me+re.length)}else ge+=ue.slice(Me,ke);Qe.push(new d(0,Te.startColumn-we,Te.endColumn-we)),Me=ke}this.preview={text:ge,matches:Array.isArray(this.ranges)?Qe:Qe[0]}}else{const ge=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:ue,matches:(0,n.mapArrayOrNot)(ce,we=>new a(we.startLineNumber-ge,we.startColumn,we.endLineNumber-ge,we.endColumn))}}}}e.TextSearchMatch=s;function r(oe){const ue=oe[0].startLineNumber;for(const ce of oe)if(ce.startLineNumber!==ue||ce.endLineNumber!==ue)return!1;return!0}class a{constructor(ue,ce,fe,Y){this.startLineNumber=ue,this.startColumn=ce,this.endLineNumber=fe,this.endColumn=Y}}e.SearchRange=a;class d extends a{constructor(ue,ce,fe){super(ue,ce,ue,fe)}}e.OneLineRange=d;var c;(function(oe){oe.List="list",oe.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var u;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function t(oe,ue=!0){const ce=oe&&oe.files&&oe.files.exclude,fe=ue&&oe&&oe.search&&oe.search.exclude;if(!ce&&!fe)return;if(!ce||!fe)return ce||fe;let Y=Object.create(null);return Y=y.mixin(Y,y.deepClone(ce)),Y=y.mixin(Y,y.deepClone(fe),!0),Y}e.getExcludes=t;function m(oe,ue){return oe.excludePattern&&T.match(oe.excludePattern,ue)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&T.match(oe.includePattern,ue)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ce=>{const fe=ce.folder.fsPath;if(L.isEqualOrParent(ue,fe)){const Y=S.relative(fe,ue);return!ce.includePattern||!!T.match(ce.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var p;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(ue,ce){super(ue),this.code=ce}}e.SearchError=A;function N(oe){const ue=oe.message;if((0,k.isCancellationError)(oe))return new A(ue,p.canceled);try{const ce=JSON.parse(ue);return new A(ce.message,ce.code)}catch{return new A(ue,p.other)}}e.deserializeSearchError=N;function q(oe){const ue={message:oe.message,code:oe.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=q;function j(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=j;function V(oe){return oe.type==="success"}e.isSerializedSearchSuccess=V;function P(oe){return!!oe.path}e.isSerializedFileMatch=P;function M(oe,ue){const ce=oe.searchPath?oe.searchPath:oe.relativePath;return(0,C.fuzzyContains)(ce,ue)}e.isFilePatternMatch=M;class F{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function $(oe,ue){const ce={...oe||{},...ue||{}};return Object.keys(ce).filter(fe=>{const Y=ce[fe];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=$;class z{constructor(ue,ce){this.c=null,this.a={...ue.excludePattern||{},...ce.excludePattern||{}},this.b=T.parse(this.a);let fe=ue.includePattern;ce.includePattern&&(fe?fe={...fe,...ce.includePattern}:fe=ce.includePattern),fe&&(this.c=T.parse(fe))}matchesExcludesSync(ue,ce,fe){return!!(this.b&&this.b(ue,ce,fe))}includedInQuerySync(ue,ce,fe){return!(this.b&&this.b(ue,ce,fe)||this.c&&!this.c(ue,ce,fe))}includedInQuery(ue,ce,fe){const Y=this.b(ue,ce,fe),ge=()=>this.c?!!this.c(ue,ce,fe):!0;return(0,D.isThenable)(Y)?Y.then(we=>we?!1:ge()):ge()}hasSiblingExcludeClauses(){return K(this.a)}}e.QueryGlobTester=z;function K(oe){for(const ue in oe)if(typeof oe[ue]!="boolean")return!0;return!1}function X(oe){if(!oe)return;let ue;return ce=>(ue||(ue=(oe()||Promise.resolve([])).then(fe=>fe?he(fe):{})),ue.then(fe=>!!fe[ce]))}e.hasSiblingPromiseFn=X;function Z(oe){if(!oe)return;let ue;return ce=>{if(!ue){const fe=oe();ue=fe?he(fe):{}}return!!ue[ce]}}e.hasSiblingFn=Z;function he(oe){const ue={};for(const ce of oe)ue[ce]=!0;return ue}}),define(Ie[31],Ce([1,0,16,15,20,5,7,46,13,109,22,10,9,2,138,3,12,153,50,37,27,14,8,6,52,44,4]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b,g,w,s,r,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(V,P,M){return new O.ExtUri(F=>A(F,M)).isEqual(V,P)}function t(V,P,M){return u(V.uri,P.uri,M)?0:(0,D.compare)(V.uri.toString(),P.uri.toString())}function m(V,P,M){return V.index!==P.index?V.index<P.index?-1:1:u(V.uri,P.uri,M)?(0,D.compare)(V.name,P.name):(0,D.compare)(V.uri.toString(),P.uri.toString())}function p(V,P,M,F){const $=V.slice(0).sort((K,X)=>M(K,X,F)),z=P.slice(0).sort((K,X)=>M(K,X,F));return(0,n.delta)($,z,(K,X)=>M(K,X,F))}function A(V,P){const M=P.getCapabilities(V.scheme);return!(M&&M&1024)}class N extends E.Workspace{static toExtHostWorkspace(P,M,F,$){if(!P)return{workspace:null,added:[],removed:[]};const{id:z,name:K,folders:X,configuration:Z,transient:he,isUntitled:oe}=P,ue=[],ce=M;M?X.forEach((we,Me)=>{const We=v.URI.revive(we.uri),Qe=N.e(F||M,We,$);Qe?(Qe.name=we.name,Qe.index=we.index,ue.push(Qe)):ue.push({uri:We,name:we.name,index:Me})}):ue.push(...X.map(({uri:we,name:Me,index:We})=>({uri:v.URI.revive(we),name:Me,index:We}))),ue.sort((we,Me)=>we.index<Me.index?-1:1);const fe=new N(z,K,ue,!!he,Z?v.URI.revive(Z):null,!!oe,we=>A(we,$)),{added:Y,removed:ge}=p(ce?ce.workspaceFolders:[],fe.workspaceFolders,t,$);return{workspace:fe,added:Y,removed:ge}}static e(P,M,F){for(let $=0;$<P.folders.length;$++){const z=P.workspaceFolders[$];if(u(z.uri,M,F))return z}}constructor(P,M,F,$,z,K,X){super(P,F.map(Z=>new E.WorkspaceFolder(Z)),$,z,X),this.s=M,this.t=K,this.o=[],this.q=R.TernarySearchTree.forUris(X),F.forEach(Z=>{this.o.push(Z),this.q.set(Z.uri,Z)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(P,M){return M&&this.q.get(P)&&(P=(0,O.dirname)(P)),this.q.findSubstr(P)}resolveWorkspaceFolder(P){return this.q.get(P)}}let q=class{constructor(P,M,F,$,z){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new L.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=$,this.q=F,this.s=z,this.h=new k.Counter,this.j=new T.Barrier,this.n=P.getProxy(c.MainContext.MainThreadWorkspace),this.o=P.getProxy(c.MainContext.MainThreadMessageService);const K=M.workspace;this.k=K?new N(K.id,K.name,[],!!K.transient,K.configuration?v.URI.revive(K.configuration):null,!!K.isUntitled,X=>A(X,F)):void 0}$initializeWorkspace(P,M){this.u=M,this.$acceptWorkspaceData(P),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?v.URI.from({scheme:S.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(P,M,F,...$){const z=[];if(Array.isArray($)&&$.forEach(oe=>{v.URI.isUri(oe.uri)&&!z.some(ue=>u(ue.uri,oe.uri,this.q))&&z.push({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri)})}),this.l||[M,F].some(oe=>typeof oe!="number"||oe<0)||F===0&&z.length===0)return!1;const K=this.w?this.w.workspaceFolders:[];if(M+F>K.length)return!1;const X=K.slice(0);X.splice(M,F,...z.map(oe=>({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<X.length;oe++){const ue=X[oe];if(X.some((ce,fe)=>fe!==oe&&u(ue.uri,ce.uri,this.q)))return!1}X.forEach((oe,ue)=>oe.index=ue);const{added:Z,removed:he}=p(K,X,m,this.q);if(Z.length===0&&he.length===0)return!1;if(this.n){const oe=P.displayName||P.name;this.n.$updateWorkspaceFolders(oe,M,F,z).then(void 0,ue=>{this.l=void 0;const ce={source:{identifier:P.identifier,label:P.displayName||P.name}};this.o.$showMessage(l.Severity.Error,(0,h.localize)(0,null,oe,ue.toString()),ce,[])})}return this.x(X),!0}getWorkspaceFolder(P,M){if(!!this.w)return this.w.getWorkspaceFolder(P,M)}async getWorkspaceFolder2(P,M){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(P,M)}async resolveWorkspaceFolder(P){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(P)}getPath(){if(!this.w)return;const{folders:P}=this.w;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,M){let F,$="";if(typeof P=="string"?(F=v.URI.file(P),$=P):typeof P<"u"&&(F=P,$=P.fsPath),!F)return $;const z=this.getWorkspaceFolder(F,!0);if(!z)return $;typeof M>"u"&&this.w&&(M=this.w.folders.length>1);let K=(0,O.relativePath)(z.uri,F);return M&&z.name&&(K=`${z.name}/${K}`),K}x(P){this.w&&(this.l=N.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:P,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:M,added:F,removed:$}=N.toExtHostWorkspace(P,this.k,this.l,this.q);this.k=M||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:$}))}findFiles(P,M,F,$,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let K;if(M===null?K=!1:M&&(typeof M=="string"?K=M:K=M.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:Z}=j(s.GlobPattern.from(P));return this.n.$startFileSearch((0,f.withUndefinedAsNull)(X),(0,f.withUndefinedAsNull)(Z),(0,f.withUndefinedAsNull)(K),(0,f.withUndefinedAsNull)(F),z).then(he=>Array.isArray(he)?he.map(oe=>v.URI.revive(oe)):[])}async findTextInFiles(P,M,F,$,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const K=this.h.getNext(),X=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:Z,folder:he}=j(s.GlobPattern.from(M.include)),oe=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ue={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:X,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:Z,excludePattern:oe},ce=!1;if(this.t[K]=fe=>{if(ce)return;const Y=v.URI.revive(fe.resource);fe.results.forEach(ge=>{(0,d.resultIsMatch)(ge)?F({uri:Y,preview:{text:ge.preview.text,matches:(0,n.mapArrayOrNot)(ge.preview.matches,we=>new r.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,n.mapArrayOrNot)(ge.ranges,we=>new r.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):F({uri:Y,text:ge.text,lineNumber:ge.lineNumber})})},z.isCancellationRequested)return{};try{const fe=await this.n.$startTextSearch(P,(0,f.withUndefinedAsNull)(he),ue,K,z);return delete this.t[K],fe||{}}catch(fe){throw delete this.t[K],fe}}$handleTextSearchResult(P,M){this.t[M]?.(P)}saveAll(P){return this.n.$saveAll(P)}resolveProxy(P){return this.n.$resolveProxy(P)}get trusted(){return this.u}requestWorkspaceTrust(P){return this.n.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(P,M){if(this.v.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this.v.set(P,M);const F=this.s.transformOutgoingScheme(P),$=this.y++;return this.n.$registerEditSessionIdentityProvider($,F),(0,C.toDisposable)(()=>{this.v.delete(P),this.n.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(P,M){this.g.info("Getting edit session identifier for workspaceFolder",P);const F=await this.resolveWorkspaceFolder(v.URI.revive(P));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const $=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!$),!$)return;const z=await $.provideEditSessionIdentity(F,M);if(this.g.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(P,M,F,$){this.g.info("Getting edit session identifier for workspaceFolder",P);const z=await this.resolveWorkspaceFolder(v.URI.revive(P));if(!z){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const K=this.v.get(z.uri.scheme);if(this.g.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!K),!K)return;const X=await K.provideEditSessionIdentityMatch?.(M,F,$);if(this.g.info("Provider returned edit session identifier match result: ",X),!!X)return X}};q=qe([Ve(0,w.IExtHostRpcService),Ve(1,g.IExtHostInitDataService),Ve(2,b.IExtHostFileSystemInfo),Ve(3,o.ILogService),Ve(4,a.IURITransformerService)],q),e.ExtHostWorkspace=q,e.IExtHostWorkspace=(0,i.createDecorator)("IExtHostWorkspace");function j(V){let P,M;return V&&(typeof V=="string"?P=V:(P=V.pattern,M=v.URI.revive(V.baseUri))),{includePattern:P,folder:M}}}),define(Ie[32],Ce([1,0,23,5,31,4,6,156,89,9,15,3,14,12,2]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function i(r,a){if(a){const d=a.split(".");let c=r;for(let u=0;c&&u<d.length;u++)c=c[d[u]];return c}}function o(r){return r instanceof h.URI}function l(r){return r&&r.uri instanceof h.URI&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&r.uri instanceof h.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function g(r){if(o(r))return{resource:r};if(l(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(E(r))return{overrideIdentifier:r.languageId};if(b(r))return{resource:r.uri};if(r===null)return{resource:null}}let w=class{constructor(a,d,c){this.a=a.getProxy(L.MainContext.MainThreadConfiguration),this.c=d,this.b=c,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new s(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,d))}};w=qe([Ve(0,f.IExtHostRpcService),Ve(1,y.IExtHostWorkspace),Ve(2,v.ILogService)],w),e.ExtHostConfiguration=w;class s{constructor(a,d,c,u){this.a=new T.Emitter,this.b=a,this.f=u,this.c=d,this.e=R.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,c))}getConfiguration(a,d,c){const u=g(d)||{},t=this.g(a?i(this.e.getValue(void 0,u,this.c.workspace),a):this.e.getValue(void 0,u,this.c.workspace));a&&this.h(a,u,c?.identifier);function m(A){if(A==null)return null;if(typeof A=="boolean")return A?2:5;switch(A){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(A){return typeof i(t,A)<"u"},get:(A,N)=>{this.h(a?`${a}.${A}`:A,u,c?.identifier);let q=i(t,A);if(typeof q>"u")q=N;else{let j;const V=(P,M)=>{let F;const $=()=>{j=j||(0,n.deepClone)(t),F=F||i(j,M)};return(0,k.isObject)(P)?new Proxy(P,{get:(z,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return $(),()=>F;if(j)return F=F||i(j,M),F[K];const X=z[K];return typeof K=="string"?V(X,`${M}.${K}`):X},set:(z,K,X)=>($(),F&&(F[K]=X),!0),deleteProperty:(z,K)=>($(),F&&delete F[K],!0),defineProperty:(z,K,X)=>($(),F&&Object.defineProperty(F,K,X),!0)}):P};q=V(q,A)}return q},update:(A,N,q,j)=>{A=a?`${a}.${A}`:A;const V=m(q);return N!==void 0?this.b.$updateConfigurationOption(V,A,N,u,j):this.b.$removeConfigurationOption(V,A,u,j)},inspect:A=>{A=a?`${a}.${A}`:A;const N=this.e.inspect(A,u,this.c.workspace);if(N)return{key:A,defaultValue:(0,n.deepClone)(N.policy?.value??N.default?.value),globalValue:(0,n.deepClone)(N.user?.value??N.application?.value),workspaceValue:(0,n.deepClone)(N.workspace?.value),workspaceFolderValue:(0,n.deepClone)(N.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(N.default?.override),globalLanguageValue:(0,n.deepClone)(N.user?.override??N.application?.override),workspaceLanguageValue:(0,n.deepClone)(N.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(N.workspaceFolder?.override),languageIds:(0,n.deepClone)(N.overrideIdentifiers)}}};return typeof t=="object"&&(0,n.mixin)(p,t,!1),Object.freeze(p)}g(a){const d=c=>(0,k.isObject)(c)?new Proxy(c,{get:(u,t)=>d(u[t]),set:(u,t,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(t)}' of object`)},deleteProperty:(u,t)=>{throw new Error(`TypeError: Cannot delete read only property '${String(t)}' of object`)},defineProperty:(u,t)=>{throw new Error(`TypeError: Cannot define property '${String(t)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return d(a)}h(a,d,c){const u=S.OVERRIDE_PROPERTY_REGEX.test(a)?4:this.d.get(a),t=c?`[${c.value}] `:"";if(u===4){typeof d?.resource>"u"&&this.f.warn(`${t}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){d?.resource&&this.f.warn(`${t}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const c=new R.ConfigurationChangeEvent(a,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,t)=>c.affectsConfiguration(u,g(t))})}k(a){return a.reduce((d,c)=>(d.set(c[0],c[1]),d),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Ie[103],Ce([1,0,2,15,5,4,6,31,55,32,20,58,14,27,3,13,21,12,72,192,11]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b,g){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(P){function M($){if($!=null)return $}P.from=M;function F($){if($!=null)return $}P.to=F})(s||(s={}));var r;(function(P){function M($){if($!=null)return $}P.from=M;function F($){if($!=null)return $}P.to=F})(r||(r={}));var a;(function(P){function M($){if($!=null)return $}P.from=M;function F($){if($!=null)return $}P.to=F})(a||(a={}));var d;(function(P){function M(z){if(z){const K=z;return K&&!!K.process}else return!1}P.is=M;function F(z){if(z==null)return;const K={process:z.process,args:z.args};return z.options&&(K.options=a.from(z.options)),K}P.from=F;function $(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}P.to=$})(d||(d={}));var c;(function(P){function M($){if($!=null)return $}P.from=M;function F($){if($!=null)return $}P.to=F})(c||(c={}));var u;(function(P){function M(z){if(z){const K=z;return K&&(!!K.commandLine||!!K.command)}else return!1}P.is=M;function F(z){if(z==null)return;const K={};return z.commandLine!==void 0?K.commandLine=z.commandLine:(K.command=z.command,K.args=z.args),z.options&&(K.options=c.from(z.options)),K}P.from=F;function $(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}P.to=$})(u||(u={}));var t;(function(P){function M(z){if(z){const K=z;return K&&K.customExecution==="customExecution"}else return!1}P.is=M;function F(z){return{customExecution:"customExecution"}}P.from=F;function $(z,K){return K.get(z)}P.to=$})(t=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(P){function M(F,$){let z;return F.scope!==void 0&&typeof F.scope!="number"?z=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===C.TaskScope.Workspace&&$&&$.workspaceFile?z=$.workspaceFile:z=b.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:z}}P.from=M})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(P){function M(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}P.from=M})(p||(p={}));var A;(function(P){function M(z,K){if(z==null)return[];const X=[];for(const Z of z){const he=F(Z,K);he&&X.push(he)}return X}P.fromMany=M;function F(z,K){if(z==null)return;let X;z.execution instanceof C.ProcessExecution?X=d.from(z.execution):z.execution instanceof C.ShellExecution?X=u.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(X=t.from(z.execution));const Z=s.from(z.definition);let he;return z.scope?typeof z.scope=="number"?he=z.scope:he=z.scope.uri:he=C.TaskScope.Workspace,!Z||!he?void 0:{_id:z._id,definition:Z,name:z.name,source:{extensionId:K.identifier.value,label:z.source,scope:he},execution:X,isBackground:z.isBackground,group:p.from(z.group),presentationOptions:r.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}P.from=F;async function $(z,K,X){if(z==null)return;let Z;d.is(z.execution)?Z=d.to(z.execution):u.is(z.execution)?Z=u.to(z.execution):t.is(z.execution)&&(Z=t.to(z._id,X));const he=s.to(z.definition);let oe;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?oe=z.source.scope:oe=await K.resolveWorkspaceFolder(n.URI.revive(z.source.scope)):oe=C.TaskScope.Workspace),!he||!oe)return;const ue=new C.Task(he,oe,z.name,z.source.label,Z,z.problemMatchers);return z.isBackground!==void 0&&(ue.isBackground=z.isBackground),z.group!==void 0&&(ue.group=C.TaskGroup.from(z.group._id),ue.group&&z.group.isDefault&&(ue.group=new C.TaskGroup(ue.group.id,ue.group.label),z.group.isDefault===!0&&(ue.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ue.presentationOptions=r.to(z.presentationOptions)),z._id&&(ue._id=z._id),z.detail&&(ue.detail=z.detail),ue}P.to=$})(A=e.TaskDTO||(e.TaskDTO={}));var N;(function(P){function M($){return $}P.from=M;function F($){if(!!$)return Object.assign(Object.create(null),$)}P.to=F})(N||(N={}));class q{constructor(M,F,$){this._id=F,this.a=$,w.set(this,void 0),Ye(this,w,M,"f")}get task(){return this.a}terminate(){Re(this,w,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}w=new WeakMap;let j=class{constructor(M,F,$,z,K,X,Z,he){this.q=new y.Emitter,this.r=new y.Emitter,this.s=new y.Emitter,this.t=new y.Emitter,this.a=M.getProxy(L.MainContext.MainThreadTask),this.b=$,this.c=z,this.d=K,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Z,this.g=he,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,F,$){if(!$)return new C.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:F,provider:$,extension:M}),this.a.$registerTaskProvider(z,F),new C.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(M,F){this.a.$registerTaskSystem(M,F)}fetchTasks(M){return this.a.$fetchTasks(N.from(M)).then(async F=>{const $=[];for(const z of F){const K=await A.to(z,this.b,this.m);K&&$.push(K)}return $})}get taskExecutions(){const M=[];return this.k.forEach(F=>M.push(F)),M}terminateTask(M){if(!(M instanceof q))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,F,$){const z=this.m.get(M.id);z&&(this.o.set(M.id,z),this.e.attachPtyToTerminal(F,await z.callback($))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const F=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const F=await this.y(M.id);this.s.fire({execution:F,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const F=await this.y(M.id);this.t.fire({execution:F,exitCode:M.exitCode})}$provideTasks(M,F){const $=this.j.get(M);if(!$)return Promise.reject(new Error("no handler found"));const z=[],K=(0,T.asPromise)(()=>$.provider.provideTasks(O.CancellationToken.None)).then(X=>this.u(F,z,$,X));return new Promise(X=>{K.then(Z=>{Promise.all(z).then(()=>{X(Z)})})})}async $resolveTask(M,F){const $=this.j.get(M);if(!$)return Promise.reject(new Error("no handler found"));if(F.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${$.type}].`);const z=await A.to(F,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const K=await $.provider.resolveTask(z,O.CancellationToken.None);if(!K)return;this.z(K,$);const X=A.from(K,$.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return t.is(X.execution)&&await this.x(X,K,!0),await this.v(X)}w(){return this.h++}async x(M,F,$){const z=await this.a.$createTaskId(M);!$&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,F.execution)),this.m.set(z,F.execution)}async y(M,F){if(typeof M=="string"){const K=this.l.get(M);if(!K)throw new g.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return K}const $=this.l.get(M.id);if($)return $;const z=new Promise((K,X)=>{function Z(he,oe,ue){ue?K(new q(he,oe.id,ue)):X("Unexpected: Task does not exist.")}F?Z(this,M,F):A.to(M.task,this.b,this.m).then(he=>Z(this,M,he))});return this.l.set(M.id,z),z.then(K=>(this.k.set(M.id,K),K),K=>Promise.reject(K))}z(M,F){M._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const $=this.n.values();let z=$.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=$.next()}};j=qe([Ve(0,f.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,E.IExtHostApiDeprecationService)],j),e.ExtHostTaskBase=j;let V=class extends j{constructor(M,F,$,z,K,X,Z,he){super(M,F,$,z,K,X,Z,he),this.registerTaskSystem(i.Schemas.vscodeRemote,{scheme:i.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(M,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const $=A.from(F,M);if($===void 0)throw new Error("Task is not valid");if(t.is($.execution))await this.x($,F,!1);else throw new g.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution($),F);return this.a.$executeTask($).catch(K=>{throw new Error(K)}),z}u(M,F,$,z){const K=[];if(z)for(const X of z){this.z(X,$),(!X.definition||!M[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const Z=A.from(X,$.extension);Z&&t.is(Z.execution)?(K.push(Z),F.push(this.x(Z,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:$.extension}}async v(M){if(t.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,F,$){}};V=qe([Ve(0,f.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,E.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(Ie[236],Ce([1,0,19,20,45,35,22,210,44]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(f,v,h){this.k=f,this.l=v,this.o=h,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&L.parse(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&L.parse(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const v=this.k.folderQueries||[];return new Promise((h,i)=>{const o=l=>{this.f++,f(l)};if(this.g)return h({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const E=l.toString(),b=n.basename(E);this.j&&this.j(E,b)||this.v(o,{base:l,basename:b})}),Promise.all(v.map(l=>this.p(l,o))).then(l=>{h({limitHit:this.e,stats:l[0]||void 0})},l=>{i(new Error((0,y.toErrorMessage)(l)))})})}async p(f,v){const h=new T.CancellationTokenSource,i=this.q(f),o=this.r(),l=new S.QueryGlobTester(this.k,f),E=!l.hasSiblingExcludeClauses();let b;try{this.h.add(h),b=R.StopWatch.create();const g=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},i,h.token),w=b.elapsed(),s=R.StopWatch.create();return this.g&&!this.e||(g&&g.forEach(r=>{const a=n.posix.relative(f.folder.path,r.path);if(E){const d=n.basename(r.path);this.v(v,{base:f.folder,relativePath:a,basename:d});return}this.s(o,f.folder,a,v)}),this.g&&!this.e)?null:(this.u(o,l,v),{providerTime:w,postProcessTime:s.elapsed()})}finally{h.dispose(),this.h.delete(h)}}q(f){const v=(0,S.resolvePatternsForProvider)(this.k.includePattern,f.includePattern),h=(0,S.resolvePatternsForProvider)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:h,includes:v,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},v,h,i){if(h===this.a){const l=n.basename(this.a);this.v(i,{base:v,relativePath:this.a,basename:l})}function o(l){const E=n.basename(l),b=n.dirname(l);let g=f[b];g||(g=f[b]=[],o(b)),g.push({base:v,relativePath:l,basename:E})}o(h)}u({rootEntries:f,pathToEntries:v},h,i){const o=this,l=this.a;function E(b){const g=(0,S.hasSiblingFn)(()=>b.map(w=>w.basename));for(let w=0,s=b.length;w<s;w++){const r=b[w],{relativePath:a,basename:d}=r;if(h.matchesExcludesSync(a,d,l!==d?g:void 0))continue;const c=v[a];if(c)E(c);else{if(a===l)continue;o.v(i,r)}if(o.e)break}}E(f)}v(f,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(v))}}class O{constructor(){this.b=new Map}fileSearch(f,v,h,i){const o=this.c(f.cacheKey),l=new k(f,v,o&&o.token);let E=0;const b=g=>{E+=g.length,h(g.map(w=>this.d(w)))};return this.e(l,O.a,b,i).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:g.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(!!f)return this.b.has(f)||this.b.set(f,new T.CancellationTokenSource),this.b.get(f)}d(f){return f.relativePath?{resource:C.joinPath(f.base,f.relativePath)}:{resource:f.base}}e(f,v,h,i){i.onCancellationRequested(()=>{f.cancel()});const o=E=>{E&&(l.push(E),v>0&&l.length>=v&&(h(l),l=[]))};let l=[];return f.search(o).then(E=>(l.length&&h(l),E),E=>(l.length&&h(l),Promise.reject(E)))}}e.FileSearchManager=O,O.a=512}),define(Ie[237],Ce([1,0,16,78,35,82,28,13,19,22,10,9,2,253,146,40,12,50,94,235,44]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(p,A,N,q,j){this.a=p,this.b=A,this.c=N,this.d=q,this.e=j}text(p,A,N={}){p=this.f(p,N);const q=this.a.getValue(),j=A&&A.some(P=>!this.a.getValue({resource:P}).search.useRipgrep);return{...this.h(A?.map(l.toWorkspaceFolder),N),type:2,contentPattern:p,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:q.search.usePCRE2||j||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(p,A){const N=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const q={...p,wordSeparators:N.editor.wordSeparators};return this.j(p,A)&&(q.isCaseSensitive=!0),this.k(p)&&(q.isMultiline=!0),q}file(p,A={}){return{...this.h(p,A),type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey}}g(p,A){return p?(p=Array.isArray(p)?p.map(c):c(p),A?this.parseSearchPaths(p):{pattern:r(...Array.isArray(p)?p:[p])}):{}}h(p=[],A={}){const N=this.g(A.includePattern,A.expandPatterns),q=this.g(A.excludePattern,A.expandPatterns),j=p.length>1,V=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(F=>this.q(F,A,q)):p.map(F=>this.r(F,A,q,j))).filter(F=>!!F),P={_reason:A._reason,folderQueries:V,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:q.pattern,includePattern:N.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const F=n.coalesce(n.flatten(this.c.groups.map(K=>K.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const $=F.filter(K=>(0,g.pathIncludedInQuery)(P,K.fsPath)),z=this.i($);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...P,...z}}const M=A.extraFileResources&&A.extraFileResources.filter(F=>(0,g.pathIncludedInQuery)(P,F.fsPath));return P.extraFileResources=M&&M.length?M:void 0,P}i(p){const A=[],N=new C.ResourceMap,q={};let j=!1;return p.forEach(V=>{if(V.scheme===R.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(V)){const M=this.b.getWorkspaceFolder(V)?.uri??V.with({path:S.dirname(V.fsPath)});let F=N.get(M);F||(j=!0,F={folder:M,includePattern:{}},A.push(F),N.set(M,F));const $=S.relative(M.fsPath,V.fsPath);(0,D.assertIsDefined)(F.includePattern)[$.replace(/\\/g,"/")]=!0}else V.fsPath&&(j=!0,q[V.fsPath]=!0)}),{folderQueries:A,includePattern:q,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(p,A){if(A.isSmartCase){if(p.isRegExp){if(O.containsUppercaseCharacter(p.pattern,!0))return!0}else if(O.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,v.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const A=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),q=(Array.isArray(p)?p:a(p)).map(z=>{const K=this.e.resolvedUserHome;return K?(0,L.untildify)(z,K.scheme===R.Schemas.file?K.fsPath:K.path):z}),j=T.groupBy(q,z=>A(z)?"searchPaths":"exprSegments"),V=(j.exprSegments||[]).map(z=>O.rtrim(z,"/")).map(z=>O.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),d(z))),P={},M=this.m(j.searchPaths||[]);M&&M.length&&(P.searchPaths=M);const F=n.flatten(V),$=r(...F);return $&&(P.pattern=$),P}l(p,A){return A.disregardExcludeSettings?void 0:(0,g.getExcludes)(p,!A.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const A=n.flatten(p.map(q=>{let{pathPortion:j,globPortion:V}=s(q);V&&(V=u(V));const P=this.n(j);return n.flatten(P.map(M=>this.o(M,V)))})),N=new Map;return A.forEach(q=>{const j=q.searchPath.toString(),V=N.get(j);V?q.pattern&&(V.pattern=V.pattern||{},V.pattern[q.pattern]=!0):N.set(j,{searchPath:q.searchPath,pattern:q.pattern?r(q.pattern):void 0})}),Array.from(N.values())}n(p){if(S.isAbsolute(p)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==R.Schemas.file?[{searchPath:A[0].uri.with({path:p})}]:[{searchPath:f.URI.file(S.normalize(p))}]}if(this.b.getWorkbenchState()===2){const A=this.b.getWorkspace().folders[0].uri;if(p=c(p),p.startsWith("../")||p===".."){const q=S.posix.resolve(A.path,p);return[{searchPath:A.with({path:q})}]}const N=u(p);return[{searchPath:A,pattern:N}]}else{if(p==="./"||p===".\\")return[];{const A=p.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(j=>{const V=A.match(new RegExp(`^${O.escapeRegExpCharacters(j.name)}(?:/(.*)|$)`));return V?{match:V,folder:j}:null}).filter(D.isDefined);if(q.length)return q.map(j=>{const V=j.match[1];return{searchPath:j.folder.uri,pattern:V&&u(V)}});{const j=p.match(/\.[\/\\](.+)[\/\\]?/),V=j?j[1]:p,P=h.localize(0,null,V);throw new Error(P)}}}}o(p,A){const N=p.pattern&&A?`${p.pattern}/${A}`:p.pattern||A,q=[{searchPath:p.searchPath,pattern:N}];return N&&!N.endsWith("**")&&q.push({searchPath:p.searchPath,pattern:N+"/**"}),q}q(p,A,N){const q=this.r((0,l.toWorkspaceFolder)(p.searchPath),A,N,!1);return q?{...q,includePattern:p.pattern}:null}r(p,A,N,q){let j;const V=f.URI.isUri(p)?p:p.uri;if(N.searchPaths){const z=N.searchPaths.filter(K=>(0,k.isEqual)(K.searchPath,V))[0];if(z&&!z.pattern)return null;z&&(j=z.pattern)}const P=this.a.getValue({resource:V}),F={...this.l(P,A)||{},...j||{}},$=f.URI.isUri(p)?(0,k.basename)(p):p.name;return{folder:V,folderName:q?$:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:P.files&&P.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!P.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!P.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!P.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!P.search.followSymlinks}}};w=qe([Ve(0,i.IConfigurationService),Ve(1,l.IWorkspaceContextService),Ve(2,E.IEditorGroupsService),Ve(3,o.ILogService),Ve(4,b.IPathService)],w),e.QueryBuilder=w;function s(m){const p=m.match(/[\*\{\}\(\)\[\]\?]/);if(p){const A=p.index,N=m.substr(0,A).match(/[/|\\][^/\\]*$/);if(N){let q=m.substr(0,N.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:m.substr((N.index||0)+1)}}}return{pathPortion:m}}function r(...m){return m.length?m.reduce((p,A)=>(p[A]=!0,p),Object.create(null)):void 0}function a(m){return y.splitGlobAware(m,",").map(p=>p.trim()).filter(p=>!!p.length)}function d(m){return[`**/${m}/**`,`**/${m}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function c(m){return m.replace(/\\/g,"/")}function u(m){return c(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function t(m,p){m=n.distinct(m,q=>q.toString());const A=[],N=p.getWorkspace();return m&&m.forEach(q=>{let j;if(p.getWorkbenchState()===2)j=(0,k.relativePath)(N.folders[0].uri,q),j&&j!=="."&&(j="./"+j);else{const V=p.getWorkspaceFolder(q);if(V){const P=V.name;if(N.folders.filter(F=>F.name===P).length===1){const F=(0,k.relativePath)(V.uri,q);F===""?j=`./${V.name}`:j=`./${V.name}/${F}`}else j=q.fsPath}}j&&A.push(j)}),A}e.resolveResourcesForSearchIncludes=t}),define(Ie[238],Ce([1,0,22,2,20,11,3,237,44,50]),function(te,e,n,T,y,L,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function D(i,o){const l=o.activationEvents;if(!l)return Promise.resolve(void 0);const E=[],b=[];for(const d of l)if(/^workspaceContains:/.test(d)){const c=d.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||i.forceUsingSearch?b.push(c):E.push(c)}if(E.length===0&&b.length===0)return Promise.resolve(void 0);let g;const w=new Promise((d,c)=>{g=d}),s=d=>g({activationEvent:d}),r=Promise.all(E.map(d=>f(i,d,s))).then(()=>{}),a=v(i,o.identifier,b,s);return Promise.all([r,a]).then(()=>{g(void 0)}),w}e.checkActivateWorkspaceContainsExtension=D;async function f(i,o,l){for(const E of i.folders)if(await i.exists(n.joinPath(T.URI.revive(E),o))){l(`workspaceContains:${o}`);return}}async function v(i,o,l,E){if(l.length===0)return Promise.resolve(void 0);const b=new y.CancellationTokenSource,g=i.checkExists(i.folders,l,b.token),w=setTimeout(async()=>{b.cancel(),i.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},O);let s=!1;try{s=await g}catch(r){L.isCancellationError(r)||L.onUnexpectedError(r)}b.dispose(),clearTimeout(w),s&&E(`workspaceContains:${l.join(",")}`)}function h(i,o,l,E){const b=i.get(C.IInstantiationService),g=i.get(S.ISearchService),s=b.createInstance(R.QueryBuilder).file(o.map(r=>(0,k.toWorkspaceFolder)(T.URI.revive(r))),{_reason:"checkExists",includePattern:l,exists:!0});return g.fileSearch(s,E).then(r=>!!r.limitHit,r=>L.isCancellationError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=h});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Ie[33],Ce([1,0,133,19,77,22,15,7,46,2,12,4,32,181,75,31,25,180,11,26,24,165,6,90,3,27,76,14,63,65,58,5,238,74,167,13,73]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b,g,w,s,r,a,d,c,u,t,m,p,A,N,q,j,V,P){"use strict";var M,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let z=class Ri extends R.Disposable{constructor(ce,fe,Y,ge,we,Me,We,Qe,Te,De,ke){super(),this.a=this.B(new A.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=fe,this.g=Y,this.f=We,this.j=ge,this.k=we,this.l=Me,this.m=Te,this.p=De,this.s=ke,this.t=this.g.getProxy(D.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(D.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(D.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const re=(0,o.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(Z(this.F,re)),this.G=new h.ExtHostStorage(this.g,this.l),this.H=new q.ExtHostSecretState(this.g),this.I=Qe,this.h=ce.createChild(new t.ServiceCollection([h.IExtHostStorage,this.G],[q.IExtHostSecretState,this.H]));const ae=this.f.allExtensions.filter(U=>!U.main&&!U.browser).map(U=>U.identifier),J=this.f.allExtensions.filter(U=>!re.has(b.ExtensionIdentifier.toKey(U.identifier.value))).filter(U=>(U.main||U.browser)&&U.api==="none").map(U=>U.identifier),I=(0,o.extensionIdentifiersArrayToSet)(J);this.J=this.B(new v.ExtensionsActivator(this.D,ae,J,{onExtensionActivationError:(U,H,G)=>{this.v.$onExtensionActivationError(U,E.transformErrorForSerialization(H),G)},actualActivateExtension:async(U,H)=>{if(I.has(b.ExtensionIdentifier.toKey(U)))return await this.v.$activateExtension(U,H),new v.HostExtension;const G=this.D.getExtensionDescription(U);return this.Y(G,H)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),y.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(ce){E.onUnexpectedError(ce)}}async Q(){this.I.onWillDeactivateAll();let ce=[];try{ce=this.D.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.X(we))}catch{}await Promise.all(ce)}terminate(ce,fe=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${ce}`),this.l.flush(),this.p.dispose(),this.J.dispose(),E.setUnexpectedErrorHandler(ge=>{this.l.error(ge)}),this.g.dispose();const Y=this.Q();Promise.race([(0,C.timeout)(5e3),Y]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${fe}`):this.l.info(`Extension host exiting with code ${fe}`),this.l.flush(),this.l.dispose(),this.c.exit(fe)})}isActivated(ce){return this.z.isOpen()?this.J.isActivated(ce):!1}async getExtension(ce){const fe=await this.v.$getExtension(ce);let Y;if(fe?.browserNlsBundleUris){Y={};for(const ge of Object.keys(fe.browserNlsBundleUris))Y[ge]=k.URI.revive(fe.browserNlsBundleUris[ge])}return fe&&{...fe,identifier:new b.ExtensionIdentifier(fe.identifier.value),extensionLocation:k.URI.revive(fe.extensionLocation),browserNlsBundleUris:Y}}R(ce,fe){return this.J.activateByEvent(ce,fe)}S(ce,fe){return this.J.activateById(ce,fe)}activateByIdWithErrors(ce,fe){return this.S(ce,fe).then(()=>{const Y=this.J.getActivatedExtension(ce);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(ce=>this.D)}getExtensionExports(ce){return this.z.isOpen()?this.J.getActivatedExtension(ce).exports:null}async U(ce){if(ce.scheme!==V.Schemas.file)return ce;const fe=await this.c.realpath(ce.fsPath);return k.URI.file(fe)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(ce=>new oe(ce))),this.L}async W(ce){const fe=S.TernarySearchTree.forUris(Y=>L.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(ce.map(async Y=>{if(this.ob(Y)){const ge=await this.U(Y.extensionLocation);fe.set(ge,Y)}})),fe}X(ce){let fe=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(ce))return fe;const Y=this.J.getActivatedExtension(ce);if(!Y)return fe;try{typeof Y.module.deactivate=="function"&&(fe=Promise.resolve(Y.module.deactivate()).then(void 0,ge=>(this.l.error(ge),Promise.resolve(void 0))))}catch(ge){this.l.error(`An error occurred when deactivating the extension '${ce.value}':`),this.l.error(ge)}try{(0,R.dispose)(Y.subscriptions)}catch(ge){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ce.value}':`),this.l.error(ge)}return fe}async Y(ce,fe){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ce.identifier):await this.v.$onWillActivateExtension(ce.identifier),this.ab(ce,fe).then(Y=>{const ge=Y.activationTimes;return this.v.$onDidActivateExtension(ce.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,fe),this.Z(ce,fe,"success",ge),Y},Y=>{throw this.Z(ce,fe,"failure"),Y})}Z(ce,fe,Y,ge){const we=K(ce,fe);this.u.$publicLog2("extensionActivationTimes",{...we,...ge||{},outcome:Y})}ab(ce,fe){const Y=K(ce,fe);this.u.$publicLog2("activatePlugin",Y);const ge=this.ob(ce);if(!ge)return Promise.resolve(new v.EmptyExtension(v.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ce.identifier.value}, startup: ${fe.startup}, activationEvent: '${fe.activationEvent}'${ce.identifier.value!==fe.extensionId.value?`, root cause: ${fe.extensionId.value}`:""}`),this.l.flush();const we=new v.ExtensionActivationTimesBuilder(fe.startup);return Promise.all([this.pb(ce,(0,L.joinPath)(ce.extensionLocation,ge),we),this.bb(ce)]).then(Me=>(y.mark(`code/extHost/willActivateExtension/${ce.identifier.value}`),Ri.cb(this.l,ce.identifier,Me[0],Me[1],we))).then(Me=>(y.mark(`code/extHost/didActivateExtension/${ce.identifier.value}`),Me))}bb(ce){const fe=new w.ExtensionGlobalMemento(ce,this.G),Y=new w.ExtensionMemento(ce.identifier.value,!1,this.G),ge=new j.ExtensionSecrets(ce,this.H),we=ce.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Me=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ce.identifier.value}`),Promise.all([fe.whenReady,Y.whenReady,this.I.whenReady]).then(()=>{const We=this;let Qe,Te;const De=(0,o.isProposedApiEnabled)(ce,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(ce.identifier)):void 0;return Object.freeze({globalState:fe,workspaceState:Y,secrets:ge,subscriptions:[],get extensionUri(){return ce.extensionLocation},get extensionPath(){return ce.extensionLocation.fsPath},asAbsolutePath(ke){return T.join(ce.extensionLocation.fsPath,ke)},get storagePath(){return We.I.workspaceValue(ce)?.fsPath},get globalStoragePath(){return We.I.globalValue(ce).fsPath},get logPath(){return T.join(We.f.logsLocation.fsPath,ce.identifier.value)},get logUri(){return k.URI.joinPath(We.f.logsLocation,ce.identifier.value)},get storageUri(){return We.I.workspaceValue(ce)},get globalStorageUri(){return We.I.globalValue(ce)},get extensionMode(){return we},get extension(){return Qe===void 0&&(Qe=new X(We,ce.identifier,ce,Me,!1)),Qe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(ce,"extensionRuntime"),We.extensionRuntime},get environmentVariableCollection(){return We.p.getEnvironmentVariableCollection(ce)},get messagePassingProtocol(){if(!Te){if(!De)return;const ke=A.Event.buffer(A.Event.fromDOMEventEmitter(De,"message",re=>re.data));De.start(),Te={onDidReceiveMessage:ke,postMessage:De.postMessage.bind(De)}}return Te}})})}static cb(ce,fe,Y,ge,we){return Y=Y||{activate:void 0,deactivate:void 0},this.db(ce,fe,Y,ge,we).then(Me=>new v.ActivatedExtension(!1,null,we.build(),Y,Me,ge.subscriptions))}static db(ce,fe,Y,ge,we){if(typeof Y.activate=="function")try{we.activateCallStart(),ce.trace(`ExtensionService#_callActivateOptional ${fe.value}`);const Me=typeof global=="object"?global:self,We=Y.activate.apply(Me,[ge]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(We).then(Qe=>(we.activateResolveStop(),Qe))}catch(Me){return Promise.reject(Me)}else return Promise.resolve(Y)}eb(ce,fe){this.S(ce.identifier,{startup:!1,extensionId:ce.identifier,activationEvent:fe}).then(void 0,Y=>{this.l.error(Y)})}fb(){this.v.$setPerformanceMarks(y.getMarks());for(const ce of this.D.getAllExtensionDescriptions())if(ce.activationEvents)for(const fe of ce.activationEvents)fe==="onStartupFinished"&&this.eb(ce,fe)}gb(){const ce=this.R("*",!0).then(void 0,we=>{this.l.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.hb(we.added)));const fe=this.j.workspace?this.j.workspace.folders:[],Y=this.hb(fe),ge=Promise.all([ce,Y]).then(()=>{});return Promise.race([ge,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),ge}hb(ce){return ce.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(fe=>this.ib(ce,fe))).then(()=>{})}async ib(ce,fe){if(this.isActivated(fe.identifier))return;const Y=!this.f.remote.isRemote&&!!this.f.remote.authority,ge={logService:this.l,folders:ce.map(Me=>Me.uri),forceUsingSearch:Y,exists:Me=>this.c.exists(Me.fsPath),checkExists:(Me,We,Qe)=>this.t.$checkExists(Me,We,Qe)},we=await(0,N.checkActivateWorkspaceContainsExtension)(ge,fe);if(!!we)return this.S(fe.identifier,{startup:!0,extensionId:fe.identifier,activationEvent:we.activationEvent}).then(void 0,Me=>this.l.error(Me))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(ce){throw console.error(ce),ce}}async jb(){const{extensionDevelopmentLocationURI:ce,extensionTestsLocationURI:fe}=this.f.environment;if(!ce||!fe)throw new Error(n.localize(0,null));const Y=await this.pb(null,fe,new v.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(n.localize(1,null,fe.toString()));return new Promise((ge,we)=>{const Me=(Te,De)=>{Te?we(Te):ge(typeof De=="number"&&De>0?1:0)},We=(0,L.originalFSPath)(fe),Qe=Y.run(We,Me);Qe&&Qe.then&&Qe.then(()=>{ge(0)}).catch(Te=>{we(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ce,fe){return this.M[ce]=fe,(0,R.toDisposable)(()=>{delete this.M[ce]})}async lb(ce){const fe=ce.indexOf("+");if(fe===-1)throw new Error("Not an authority that can be resolved!");const Y=ce.substr(0,fe);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this.M[Y]}}async $resolveAuthority(ce,fe){this.l.info(`$resolveAuthority invoked for authority (${he(ce)})`);const{authorityPrefix:Y,resolver:ge}=await this.lb(ce);if(!ge)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(ge)),y.mark(`code/extHost/willResolveAuthority/${Y}`);const we=await ge.resolve(ce,{resolveAttempt:fe});y.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const Me={authority:ce,host:we.host,port:we.port,connectionToken:we.connectionToken},We={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Me,options:We,tunnelInformation:{environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures}}}}catch(we){if(y.mark(`code/extHost/didResolveAuthorityError/${Y}`),we instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}async $getCanonicalURI(ce,fe){this.l.info(`$getCanonicalURI invoked for authority (${he(ce)})`);const{resolver:Y}=await this.lb(ce);if(!Y)return null;const ge=k.URI.revive(fe);if(typeof Y.getCanonicalURI>"u")return ge;const we=await(0,C.asPromise)(()=>Y.getCanonicalURI(ge));return we||ge}static mb(ce,fe,Y){const ge=new l.ExtensionDescriptionRegistry(ce.getAllExtensionDescriptions());ge.deltaExtensions(Y.toAdd,Y.toRemove);const we=(0,o.extensionIdentifiersArrayToSet)(fe.getAllExtensionDescriptions().map(We=>We.identifier));for(const We of Y.myToRemove)we.delete(b.ExtensionIdentifier.toKey(We));for(const We of Y.myToAdd)we.add(b.ExtensionIdentifier.toKey(We));const Me=Z(ge,we);return{globalRegistry:ge,myExtensions:Me}}$startExtensionHost(ce){ce.toAdd.forEach(ge=>ge.extensionLocation=k.URI.revive(ge.extensionLocation));const{globalRegistry:fe,myExtensions:Y}=Ri.mb(this.F,this.D,ce);return this.F.set(fe.getAllExtensionDescriptions()),this.D.set(Y),this.kb()}$activateByEvent(ce,fe){return fe===1?this.R(ce,!1):this.z.wait().then(Y=>this.R(ce,!1))}async $activate(ce,fe){return await this.z.wait(),this.D.getExtensionDescription(ce)?(await this.S(ce,fe),!0):!1}async $deltaExtensions(ce){ce.toAdd.forEach(Me=>Me.extensionLocation=k.URI.revive(Me.extensionLocation));const{globalRegistry:fe,myExtensions:Y}=Ri.mb(this.F,this.D,ce),ge=await this.W(Y);return(await this.getExtensionPathIndex()).setSearchTree(ge),this.F.set(fe.getAllExtensionDescriptions()),this.D.set(Y),Promise.resolve(void 0)}async $test_latency(ce){return ce}async $test_up(ce){return ce.byteLength}async $test_down(ce){const fe=g.VSBuffer.alloc(ce),Y=Math.random()%256;for(let ge=0;ge<ce;ge++)fe.writeUInt8(Y,ge);return fe}async $updateRemoteConnectionData(ce){this.P=ce,this.a.fire()}};z=qe([Ve(0,a.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,u.IExtHostRpcService),Ve(3,i.IExtHostWorkspace),Ve(4,f.IExtHostConfiguration),Ve(5,O.ILogService),Ve(6,d.IExtHostInitDataService),Ve(7,c.IExtensionStoragePaths),Ve(8,m.IExtHostTunnelService),Ve(9,p.IExtHostTerminalService),Ve(10,P.IExtHostLocalizationService)],z),e.AbstractExtHostExtensionService=z;function K(ue,ce){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:ce.activationEvent,reasonId:ce.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class X{constructor(ce,fe,Y,ge,we){M.set(this,void 0),F.set(this,void 0),$.set(this,void 0),Ye(this,M,ce,"f"),Ye(this,F,fe,"f"),Ye(this,$,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=T.normalize((0,L.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=ge,this.isFromDifferentExtensionHost=we}get isActive(){return Re(this,M,"f").isActivated(Re(this,$,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Re(this,M,"f").getExtensionExports(Re(this,$,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Re(this,M,"f").activateByIdWithErrors(Re(this,$,"f"),{startup:!1,extensionId:Re(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=X,M=new WeakMap,F=new WeakMap,$=new WeakMap;function Z(ue,ce){return ue.getAllExtensionDescriptions().filter(fe=>ce.has(b.ExtensionIdentifier.toKey(fe.identifier)))}function he(ue){const ce=ue.indexOf("+");return ce===-1?ue:ue.substring(0,ce)}class oe{constructor(ce){this.a=ce}setSearchTree(ce){this.a=ce}findSubstr(ce){return this.a.findSubstr(ce)}forEach(ce){return this.a.forEach(ce)}}e.ExtensionPaths=oe}),define(Ie[239],Ce([1,0,77,2,4,32,25,26,14,27,3,33,49,12,10]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let i=class{constructor(w,s,r,a,d,c,u){this.c=w,this.d=s,this.e=r,this.f=a,this.g=d,this.h=c,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new l(this.c,s,this.d,w,this.i)),this.register(this.e.createInstance(E,s)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,s,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const s of w.nodeModuleName)this.a.set(s,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(s=>w.alternativeModuleName(s))}};i=qe([Ve(2,O.IInstantiationService),Ve(3,L.IExtHostConfiguration),Ve(4,D.IExtHostExtensionService),Ve(5,k.IExtHostInitDataService),Ve(6,v.ILogService)],i),e.RequireInterceptor=i;let o=class Zi{constructor(w){if(w.environment.appRoot&&Zi.a.size){const s=(0,h.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),r="[a-z0-9_.-]",a=`@${r}+\\/${r}+|${r}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const s=this.b.exec(this.c(w));if(!s)return;const[,r,a,d]=s,c=Zi.a.get(a);if(c!==void 0)return console.warn(`${a} as been renamed to ${c}, please update your imports`),r+c+d}c(w){return w.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=qe([Ve(0,k.IExtHostInitDataService)],o);class l{constructor(w,s,r,a,d){this.c=w,this.d=s,this.e=r,this.f=a,this.g=d,this.nodeModuleName="vscode",this.a=new Map}load(w,s){const r=this.d.findSubstr(s);if(r){let a=this.a.get(R.ExtensionIdentifier.toKey(r.identifier));return a||(a=this.c(r,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(r.identifier),a)),a}if(!this.b){let a="";this.d.forEach((d,c)=>a+=`	${c} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${a}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let E=class{constructor(w,s,r){this.d=w,this.nodeModuleName="keytar",this.a=s.getProxy(y.MainContext.MainThreadTelemetry);const{environment:a}=r,d=s.getProxy(y.MainContext.MainThreadKeytar);if(a.appRoot){let c=a.appRoot.fsPath;f.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,u)=>d.$getPassword(c,u),setPassword:(c,u,t)=>d.$setPassword(c,u,t),deletePassword:(c,u)=>d.$deletePassword(c,u),findPassword:c=>d.$findPassword(c),findCredentials(c){return d.$findCredentials(c)}}}load(w,s){const r=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:r?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const s=w.length;if(s<=7||!this.b)return;const r=s-7;if((w.charAt(r)==="/"||w.charAt(r)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};E=qe([Ve(1,S.IExtHostRpcService),Ve(2,k.IExtHostInitDataService)],E);let b=class{constructor(w,s,r){this.e=w,this.f=s,this.nodeModuleName=["open","opn"],this.d=r.getProxy(y.MainContext.MainThreadTelemetry);const a=r.getProxy(y.MainContext.MainThreadWindow);this.c=(d,c)=>{const u=T.URI.parse(d);return c?this.g(d,c):u.scheme==="http"||u.scheme==="https"?a.$openUri(u,d,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?a.$openUri(u,d,{}):this.g(d,c)}}load(w,s,r){const a=this.e.findSubstr(s);return a&&(this.a=a.identifier.value,this.h()),this.b=r(w),this.c}g(w,s){return this.i(),this.b(w,s)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([Ve(2,S.IExtHostRpcService)],b)}),define(Ie[104],Ce([1,0,204,7,19,49,3,55,56,33,6,31,177,32]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class h extends f.AbstractVariableResolverService{constructor(l,E,b,g,w,s,r){function a(){if(b){const d=b.activeEditor();if(d)return d.document.uri;const c=g.tabGroups.all.find(u=>u.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof O.TextDiffTabInput||c.input instanceof O.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof O.TextTabInput||c.input instanceof O.NotebookEditorTabInput||c.input instanceof O.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:d=>{const c=s.folders.filter(u=>u.name===d);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(d,c)=>w.getConfiguration(void 0,d).get(c),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return y.normalize(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(E){const d=a();if(d){const c=E.getWorkspaceFolder(d);if(c)return y.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(b){const d=b.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(b){const d=b.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>l.getExtension(d)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(L.env))}}let i=class extends T.Disposable{constructor(l,E,b,g,w){super(),this.b=l,this.c=E,this.g=b,this.h=g,this.i=w,this.a=new n.Lazy(async()=>{const s=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new h(this.b,this.c,this.g,this.i,s,a,this.j())})}getResolver(){return this.a.getValue()}j(){}};i=qe([Ve(0,k.IExtHostExtensionService),Ve(1,D.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,v.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs)],i),e.ExtHostVariableResolverProviderService=i}),define(Ie[105],Ce([1,0,15,5,9,2,3,4,56,33,14,6,31,169,171,32,104]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,d,c,u,t,m){this.D=d,this.E=c,this.F=u,this.G=t,this.H=m,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new T.Emitter,this.n=new T.Emitter,this.o=new T.Emitter,this.u=new T.Emitter,this.k=a.getProxy(R.MainContext.MainThreadDebugService),this.z=new T.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(p=>{p.onDidChange(A=>{this.I(p)}),this.I(p)})}asDebugSourceUri(a,d){const c=a;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let u=`debug:${encodeURIComponent(c.path||"")}`,t="?";return d&&(u+=`${t}session=${encodeURIComponent(d.id)}`,t="&"),u+=`${t}ref=${c.sourceReference}`,L.URI.parse(u)}else{if(c.path)return L.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(a){const d=[];for(const c of a.getAllExtensionDescriptions())if(c.contributes){const u=c.contributes.debuggers;if(u&&u.length>0)for(const t of u)(0,h.isDebuggerMainContribution)(t)&&d.push(t.type)}this.k.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const a=[];return this.w.forEach(d=>a.push(d)),a}addBreakpoints(a){this.T();const d=a.filter(t=>{const m=t.id;return this.w.has(m)?!1:(this.w.set(m,t),!0)});this.U(d,[],[]);const c=[],u=new Map;for(const t of d)if(t instanceof D.SourceBreakpoint){let m=u.get(t.location.uri.toString());m||(m={type:"sourceMulti",uri:t.location.uri,lines:[]},u.set(t.location.uri.toString(),m),c.push(m)),m.lines.push({id:t.id,enabled:t.enabled,condition:t.condition,hitCondition:t.hitCondition,logMessage:t.logMessage,line:t.location.range.start.line,character:t.location.range.start.character})}else t instanceof D.FunctionBreakpoint&&c.push({type:"function",id:t.id,enabled:t.enabled,hitCondition:t.hitCondition,logMessage:t.logMessage,condition:t.condition,functionName:t.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(a){this.T();const d=a.filter(m=>this.w.delete(m.id));this.U([],d,[]);const c=d.filter(m=>m instanceof D.SourceBreakpoint).map(m=>m.id),u=d.filter(m=>m instanceof D.FunctionBreakpoint).map(m=>m.id),t=d.filter(m=>m instanceof D.DataBreakpoint).map(m=>m.id);return this.k.$unregisterBreakpoints(c,u,t)}startDebugging(a,d,c){return this.k.$startDebugging(a?a.uri:void 0,d,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,d,c){if(!d)return new D.Disposable(()=>{});const u=this.d++;return this.f.push({type:a,handle:u,provider:d}),this.k.$registerDebugConfigurationProvider(a,c,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,u),new D.Disposable(()=>{this.f=this.f.filter(t=>t.provider!==d),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(a,d,c){if(!c)return new D.Disposable(()=>{});if(!this.P(a,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.M(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:d,handle:u,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(d,u),new D.Disposable(()=>{this.h=this.h.filter(t=>t.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(a,d){if(!d)return new D.Disposable(()=>{});const c=this.i++;return this.j.push({type:a,handle:c,factory:d}),new D.Disposable(()=>{this.j=this.j.filter(u=>u.factory!==d)})}async $runInTerminal(a,d){return Promise.resolve(void 0)}async $substituteVariables(a,d){let c;const u=await this.W(a);return u&&(c={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(c,d)}J(a,d){if(a.type==="implementation")return new w(a.implementation)}K(){}async $startDASession(a,d){const c=this,u=await this.V(d);return this.R(this.M(u.type),u).then(t=>{if(!t)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const m=this.L(t),p=this.J(m,u);if(!p)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const A=p;return this.A.set(a,A),this.Q(u).then(N=>(N&&this.B.set(a,N),A.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const j=q,V={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const P=await this.C.sign(j.arguments.value);V.body={signature:P},A.sendResponse(V)}else throw new Error("no signer")}catch(P){V.success=!1,V.message=P.message,A.sendResponse(V)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(q),q=(0,h.convertToVSCPaths)(q,!0),c.k.$acceptDAMessage(a,q)}),A.onError(q=>{N&&N.onError&&N.onError(q),this.k.$acceptDAError(a,q.name,q.message,q.stack)}),A.onExit(q=>{N&&N.onExit&&N.onExit((0,y.withNullAsUndefined)(q),void 0),this.k.$acceptDAExit(a,(0,y.withNullAsUndefined)(q),void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),A.startSession()))})}$sendDAMessage(a,d){d=(0,h.convertToDAPaths)(d,!1);const c=this.B.get(a);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(d),this.A.get(a)?.sendMessage(d)}$stopDASession(a){const d=this.B.get(a);this.B.delete(a),d&&d.onWillStopSession&&d.onWillStopSession();const c=this.A.get(a);return this.A.delete(a),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const d=[],c=[],u=[];if(a.added)for(const t of a.added){const m=t.id;if(m&&!this.w.has(m)){let p;if(t.type==="function")p=new D.FunctionBreakpoint(t.functionName,t.enabled,t.condition,t.hitCondition,t.logMessage);else if(t.type==="data")p=new D.DataBreakpoint(t.label,t.dataId,t.canPersist,t.enabled,t.hitCondition,t.condition,t.logMessage);else{const A=L.URI.revive(t.uri);p=new D.SourceBreakpoint(new D.Location(A,new D.Position(t.line,t.character)),t.enabled,t.condition,t.hitCondition,t.logMessage)}p._id=m,this.w.set(m,p),d.push(p)}}if(a.removed)for(const t of a.removed){const m=this.w.get(t);m&&(this.w.delete(t),c.push(m))}if(a.changed){for(const t of a.changed)if(t.id){const m=this.w.get(t.id);if(m){if(m instanceof D.FunctionBreakpoint&&t.type==="function"){const p=m;p.enabled=t.enabled,p.condition=t.condition,p.hitCondition=t.hitCondition,p.logMessage=t.logMessage,p.functionName=t.functionName}else if(m instanceof D.SourceBreakpoint&&t.type==="source"){const p=m;p.enabled=t.enabled,p.condition=t.condition,p.hitCondition=t.hitCondition,p.logMessage=t.logMessage,p.location=new D.Location(L.URI.revive(t.uri),new D.Position(t.line,t.character))}u.push(m)}}}this.U(d,c,u)}$provideDebugConfigurations(a,d,c){return(0,n.asPromise)(async()=>{const u=this.O(a);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const t=await this.W(d);return u.provideDebugConfigurations(t,c)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(a,d,c,u){return(0,n.asPromise)(async()=>{const t=this.O(a);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const m=await this.W(d);return t.resolveDebugConfiguration(m,c,u)})}$resolveDebugConfigurationWithSubstitutedVariables(a,d,c,u){return(0,n.asPromise)(async()=>{const t=this.O(a);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const m=await this.W(d);return t.resolveDebugConfigurationWithSubstitutedVariables(m,c,u)})}async $provideDebugAdapter(a,d){const c=this.N(a);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(d);return this.R(c,u).then(t=>{if(!t)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.L(t)})}async $acceptDebugSessionStarted(a){const d=await this.V(a);this.m.fire(d)}async $acceptDebugSessionTerminated(a){const d=await this.V(a);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,d){(await this.V(a))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(a,d){const u={session:await this.V(a),event:d.event,body:d.body};this.u.fire(u)}L(a){if(a instanceof D.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof D.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}M(a){const d=this.h.filter(c=>c.type===a);if(d.length>0)return d[0].factory}N(a){const d=this.h.filter(c=>c.handle===a);if(d.length>0)return d[0].factory}O(a){const d=this.f.filter(c=>c.handle===a);if(d.length>0)return d[0].provider}P(a,d){if(a.contributes){const c=a.contributes.debuggers;if(c&&c.length>0){for(const u of c)if(u.label&&u.type&&u.type===d)return!0}}return!1}Q(a){const c=a.configuration.type,u=this.j.filter(t=>t.type===c||t.type==="*").map(t=>(0,n.asPromise)(()=>t.factory.createDebugAdapterTracker(a)).then(m=>m,m=>null));return Promise.race([Promise.all(u).then(t=>{const m=t.filter(p=>!!p);if(m.length>0)return new g(m)}),new Promise(t=>setTimeout(()=>t(void 0),1e3))]).catch(t=>{})}async R(a,d){const c=d.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new D.DebugAdapterServer(c));if(a){const t=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>a.createDebugAdapterDescriptor(d,this.S(d,t))).then(m=>{if(m)return m})}const u=await this.E.getExtensionRegistry();return Promise.resolve(this.S(d,u))}S(a,d){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(a,d,c){(a.length>0||d.length>0||c.length>0)&&this.z.fire(Object.freeze({added:a,removed:d,changed:c}))}async V(a){if(a)if(typeof a=="string"){const d=this.l.get(a);if(d)return d}else{let d=this.l.get(a.id);if(!d){const c=await this.W(a.folderUri),u=a.parent?this.l.get(a.parent):void 0;d=new E(this.k,a.id,a.type,a.name,c,a.configuration,u),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(a){if(a){const d=L.URI.revive(a);return this.D.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};l=qe([Ve(0,O.IExtHostRpcService),Ve(1,f.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,i.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class E{constructor(a,d,c,u,t,m,p){this.d=a,this.f=d,this.g=c,this.h=u,this.i=t,this.j=m,this.k=p}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,d){return this.d.$customDebugAdapterRequest(this.f,a,d)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.ExtHostDebugSession=E;class b{constructor(a){this.value=Object.freeze({append(d){a.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=b;class g{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(d=>d.onError?d.onError(a):void 0)}onExit(a,d){this.d.forEach(c=>c.onExit?c.onExit(a,d):void 0)}}class w extends v.AbstractDebugAdapter{constructor(a){super(),this.h=a,a.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends l{constructor(a,d,c,u,t,m){super(a,d,c,u,t,m)}};s=qe([Ve(0,O.IExtHostRpcService),Ve(1,f.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,i.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(Ie[240],Ce([1,0,11,77,2,4,231,12,62,63,27,151,14,52,33,70]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(b){const g=b.get(R.ILogService),s=b.get(f.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(r=>{g.error(r);const a=n.transformErrorForSerialization(r);s.$onUnexpectedError(a)})}static async installFullHandler(b){const g=b.get(R.ILogService),w=b.get(f.IExtHostRpcService),s=b.get(h.IExtHostExtensionService),r=b.get(i.IExtHostTelemetry),a=w.getProxy(L.MainContext.MainThreadExtensionService),d=w.getProxy(L.MainContext.MainThreadErrors),c=await s.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(t,m)=>{let p="",A,N;for(const q of m)p+=`
	at ${q.toString()}`,N=q.getFileName(),!A&&N&&(A=c.findSubstr(y.URI.file(N)));return u.set(t,A?.identifier),`${t.name||"Error"}: ${t.message||""}${p}`},n.setUnexpectedErrorHandler(t=>{g.error(t);const m=n.transformErrorForSerialization(t),p=u.get(t);if(!p){d.$onUnexpectedError(m);return}a.$onExtensionRuntimeError(p,m);const A=r.onExtensionError(p,t);g.trace("forwarded error to extension?",A,p)})}}Error.stackTraceLimit=100;class l{constructor(b,g,w,s,r){this.a=w,this.b=new C.RPCProtocol(b,null,s),g=l.e(g,this.b);const a=new k.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());a.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:r}),a.set(f.IExtHostRpcService,new f.ExtHostRpcService(this.b)),a.set(v.IURITransformerService,new v.URITransformerService(s)),a.set(h.IHostUtils,w);const d=new D.InstantiationService(a,!0);d.invokeFunction(o.installEarlyHandler),this.d=d.invokeFunction(c=>c.get(R.ILogService)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",g),this.c=d.invokeFunction(c=>c.get(h.IExtHostExtensionService)),this.c.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(b){const g=this.b.getProxy(L.MainContext.MainThreadExtensionService);return y.URI.revive(await g.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,g){b.allExtensions.forEach(s=>{s.extensionLocation=y.URI.revive(g.transformIncomingURIs(s.extensionLocation));const r={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(a=>r[a]=y.URI.revive(g.transformIncomingURIs(s.browserNlsBundleUris[a]))),s.browserNlsBundleUris=r)}),b.environment.appRoot=y.URI.revive(g.transformIncomingURIs(b.environment.appRoot));const w=b.environment.extensionDevelopmentLocationURI;return w&&(b.environment.extensionDevelopmentLocationURI=w.map(s=>y.URI.revive(g.transformIncomingURIs(s)))),b.environment.extensionTestsLocationURI=y.URI.revive(g.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=y.URI.revive(g.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=y.URI.revive(g.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=y.URI.revive(g.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=y.URI.revive(g.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=y.URI.revive(g.transformIncomingURIs(b.logsLocation)),b.logFile=y.URI.revive(g.transformIncomingURIs(b.logFile)),b.workspace=g.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=l}),define(Ie[241],Ce([1,0,16,15,20,45,13,19,22,2,44]),function(te,e,n,T,y,L,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(E,b,g,w){this.d=E,this.e=b,this.f=g,this.g=w,this.a=null,this.b=!1,this.c=0}search(E,b){const g=this.d.folderQueries||[],w=new y.CancellationTokenSource;return b.onCancellationRequested(()=>w.cancel()),new Promise((s,r)=>{this.a=new v(E);let a=!1;const d=(c,u)=>{if(!a&&!this.b){const t=this.h(c);i(c)&&typeof this.d.maxResults=="number"&&this.c+t>this.d.maxResults&&(this.b=!0,a=!0,w.cancel(),c=this.j(c,this.d.maxResults-this.c));const m=this.h(c);this.c+=m,(m>0||!i(c))&&this.a.add(c,u)}};Promise.all(g.map((c,u)=>this.k(c,t=>d(t,u),w.token))).then(c=>{w.dispose(),this.a.flush();const u=c.some(t=>!!t&&!!t.limitHit);s({limitHit:this.b||u,messages:(0,n.flatten)(c.map(t=>t?.message?Array.isArray(t.message)?t.message:[t.message]:[])),stats:{type:this.g}})},c=>{w.dispose();const u=(0,L.toErrorMessage)(c);r(new Error(u))})})}h(E){return i(E)?Array.isArray(E.ranges)?E.ranges.length:1:0}j(E,b){const g=Array.isArray(E.ranges)?E.ranges:[E.ranges],w=Array.isArray(E.preview.matches)?E.preview.matches:[E.preview.matches];return{ranges:g.slice(0,b),preview:{matches:w.slice(0,b),text:E.preview.text},uri:E.uri}}async k(E,b,g){const w=new O.QueryGlobTester(this.d,E),s=[],r={report:c=>{if(!this.l(c))return;const u=E.folder.scheme===C.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(c.uri))):void 0,t=S.relativePath(E.folder,c.uri);if(t){const m=w.includedInQuery(t,R.basename(t),u);(0,T.isThenable)(m)?s.push(m.then(p=>{p&&b(c)})):m&&b(c)}}},a=this.n(E),d=await this.e.provideTextSearchResults(f(this.d.contentPattern),a,r,g);return s.length&&await Promise.all(s),d}l(E){if(i(E)){if(Array.isArray(E.ranges)){if(!Array.isArray(E.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(E.preview.matches.length!==E.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(E.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(E){const b=(0,O.resolvePatternsForProvider)(this.d.includePattern,E.includePattern),g=(0,O.resolvePatternsForProvider)(this.d.excludePattern,E.excludePattern),w={folder:k.URI.from(E.folder),excludes:g,includes:b,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,encoding:E.fileEncoding&&this.f.toCanonicalName(E.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=D;function f(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class v{constructor(E){this.e=E,this.b=-1,this.d=null,this.a=new o(512,b=>this.g(b))}add(E,b){this.d&&(this.b!==b||!S.isEqual(this.c,E.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:E.uri,results:[]}),this.d.results.push(h(E))}f(){const E=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,E)}flush(){this.f(),this.a.flush()}g(E){this.e(E)}}e.TextSearchResultsCollector=v;function h(l){return i(l)?{preview:{matches:(0,n.mapArrayOrNot)(l.preview.matches,E=>({startLineNumber:E.start.line,startColumn:E.start.character,endLineNumber:E.end.line,endColumn:E.end.character})),text:l.preview.text},ranges:(0,n.mapArrayOrNot)(l.ranges,E=>({startLineNumber:E.start.line,startColumn:E.start.character,endLineNumber:E.end.line,endColumn:E.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function i(l){return!!l.preview}e.extensionResultIsMatch=i;class o{constructor(E,b){this.g=E,this.h=b,this.c=0,this.d=[],this.e=0}addItem(E,b){!E||this.j(E,b)}addItems(E,b){!E||this.k(E,b)}j(E,b){this.d.push(E),this.e+=b,this.l()}k(E,b){this.d=this.d.concat(E),this.e+=b,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=o,o.a=4e3,o.b=50}),define(Ie[106],Ce([1,0,7,4,3,236,14,52,12,2,241]),function(te,e,n,T,y,L,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let D=class{constructor(i,o,l){this.k=i,this.l=o,this.n=l,this.c=this.k.getProxy(T.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(i){return this.l.transformOutgoingScheme(i)}registerTextSearchProvider(i,o){if(this.g.has(i))throw new Error(`a text search provider for the scheme '${i}' is already registered`);this.g.add(i);const l=this.d++;return this.e.set(l,o),this.c.$registerTextSearchProvider(l,this.o(i)),(0,n.toDisposable)(()=>{this.g.delete(i),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(i,o){if(this.i.has(i))throw new Error(`a file search provider for the scheme '${i}' is already registered`);this.i.add(i);const l=this.d++;return this.h.set(l,o),this.c.$registerFileSearchProvider(l,this.o(i)),(0,n.toDisposable)(()=>{this.i.delete(i),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(i,o,l,E){const b=f(l),g=this.h.get(i);if(g)return this.j.fileSearch(b,g,w=>{this.c.$handleFileMatch(i,o,w.map(s=>s.resource))},E);throw new Error("unknown provider: "+i)}$clearCache(i){return this.j.clearCache(i),Promise.resolve(void 0)}$provideTextSearchResults(i,o,l,E){const b=this.e.get(i);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${i}`);const g=f(l);return this.q(g,b).search(s=>this.c.$handleTextMatch(i,o,s),E)}$enableExtensionHostSearch(){}q(i,o){return new O.TextSearchManager(i,o,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};D=qe([Ve(0,C.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,S.ILogService)],D),e.ExtHostSearch=D;function f(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(v),extraFileResources:h.extraFileResources&&h.extraFileResources.map(i=>k.URI.revive(i))}}e.reviveQuery=f;function v(h){return{...h,folder:k.URI.revive(h.folder)}}}),define(Ie[242],Ce([1,0,62,101,31,99,32,38,55,58,103,105,106,75,65,72,100,57,37,74,70,56,212,12,182,104,73]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b,g,w,s,r,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,n.registerSingleton)(r.ILoggerService,s.ExtHostLoggerService,1),(0,n.registerSingleton)(r.ILogService,a.ExtHostLogService,1),(0,n.registerSingleton)(i.IExtHostApiDeprecationService,i.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,n.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,n.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,n.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,n.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,n.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,0),(0,n.registerSingleton)(v.IExtHostStorage,v.ExtHostStorage,0),(0,n.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,n.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService,0),(0,n.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,n.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,n.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,n.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry,0),(0,n.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,n.registerSingleton)(d.IExtHostVariableResolverProvider,d.ExtHostVariableResolverProviderService,0)}),define(Ie[243],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(y){if(y&&this.a.has(y)){const L=this.a.get(y);return this.a.delete(y),L}}addDragOperationTransfer(y,L){this.a.set(y,L)}getRenderedTreeElement(y){if(this.b.has(y))return this.b.get(y)}addRenderedTreeItemElement(y,L){this.b.set(y,L)}removeRenderedTreeItemElement(y){this.b.has(y)&&this.b.delete(y)}}e.TreeviewsService=n}),define(Ie[244],Ce([1,0,137,6,22,2,5,7,15,6,9,16,8,20,243,25]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(b,g){if((0,O.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let w;return Array.isArray(b.highlights)&&(w=b.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),w=w.length?w:void 0),{label:b.label,highlights:w}}}class l{constructor(g,w,s){this.d=g,this.e=w,this.f=s,this.a=new Map,this.b=new h.TreeviewsService;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:a=>r(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(d=>r(d)?this.i(d):d):a})}registerTreeDataProvider(g,w,s){const r=this.createTreeView(g,{treeDataProvider:w},s);return{dispose:()=>r.dispose()}}createTreeView(g,w,s){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=w.dragAndDropController?.dropMimeTypes??[],a=w.dragAndDropController?.dragMimeTypes??[],d=!!w.dragAndDropController?.handleDrag,c=!!w.dragAndDropController?.handleDrop,u=this.h(g,w,s),t=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:d,hasHandleDrop:c});return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,i.checkProposedApiEnabled)(s,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(m){u.message=m},get title(){return u.title},set title(m){u.title=m},get description(){return u.description},set description(m){u.description=m},get badge(){return u.badge},set badge(m){m!==void 0&&k.ViewBadge.isViewBadge(m)?u.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(u.badge=void 0)},reveal:(m,p)=>u.reveal(m,p),dispose:async()=>{await t,this.a.delete(g),u.dispose()}}}$getChildren(g,w){const s=this.a.get(g);return s?s.getChildren(w):Promise.reject(new Error((0,n.localize)(0,null,g)))}async $handleDrop(g,w,s,r,a,d,c,u){const t=this.a.get(g);if(!t)return Promise.reject(new Error((0,n.localize)(1,null,g)));const m=f.DataTransfer.toDataTransfer(s,async p=>(await this.d.$resolveDropFileData(g,w,p)).buffer);return c===g&&u&&await this.g(m,t,u,a,d),t.onDrop(m,r,a)}async g(g,w,s,r,a){const d=this.b.removeDragOperationTransfer(a);if(d)(await d)?.forEach((c,u)=>{c&&g.set(u,c)});else if(a&&w.handleDrag){const c=w.handleDrag(s,g,r);this.b.addDragOperationTransfer(a,c),await c}return g}async $handleDrag(g,w,s,r){const a=this.a.get(g);if(!a)return Promise.reject(new Error((0,n.localize)(2,null,g)));const d=await this.g(new T.DataTransfer,a,w,r,s);if(!!d)return f.DataTransfer.toDataTransferDTO(d)}async $hasResolve(g){const w=this.a.get(g);if(!w)throw new Error((0,n.localize)(3,null,g));return w.hasResolve}$resolve(g,w,s){const r=this.a.get(g);if(!r)throw new Error((0,n.localize)(4,null,g));return r.resolveTreeItem(w,s)}$setExpanded(g,w,s){const r=this.a.get(g);if(!r)throw new Error((0,n.localize)(5,null,g));r.setExpanded(w,s)}$setSelection(g,w){const s=this.a.get(g);if(!s)throw new Error((0,n.localize)(6,null,g));s.setSelection(w)}$setFocus(g,w){const s=this.a.get(g);if(!s)throw new Error((0,n.localize)(7,null,g));s.setFocus(w)}$setVisible(g,w){const s=this.a.get(g);if(!s)throw new Error((0,n.localize)(8,null,g));s.setVisible(w)}$changeCheckboxState(g,w){const s=this.a.get(g);if(!s)throw new Error((0,n.localize)(9,null,g));s.setCheckboxState(w)}h(g,w,s){const r=new E(g,w,this.d,this.e.converter,this.f,s);return this.a.set(g,r),r}i(g){const w=this.a.get(g.$treeViewId);return w&&"$treeItemHandle"in g?w.getExtensionElement(g.$treeItemHandle):w&&"$focusedTreeItem"in g&&g.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=l;class E extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,O.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,w,s,r,a,d){if(super(),this.C=g,this.D=s,this.F=r,this.G=a,this.H=d,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new v.CancellationTokenSource,d.contributes&&d.contributes.views)for(const t in d.contributes.views)for(const m of d.contributes.views[t])m.id===g&&(this.J=m.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(t=>this.w.fire({message:!1,element:t})));let c,u;this.B(C.Event.debounce(this.w.event,(t,m)=>(t||(t={message:!1,elements:[]}),m.element!==!1&&(c||(c=new Promise(p=>u=p),this.y=this.y.then(()=>c)),Array.isArray(m.element)?t.elements.push(...m.element):t.elements.push(m.element)),m.message&&(t.message=!0),t),200,!0)(({message:t,elements:m})=>{m.length&&(this.z=this.z.then(()=>{const p=u;return c=null,this.U(m).then(()=>p())})),t&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const w=g?this.getExtensionElement(g):void 0;if(g&&!w)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let s=this.Q(g);return s||(s=await this.R(w)),s?s.map(r=>r.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,w){w=w||{select:!0,focus:!1};const s=(0,O.isUndefinedOrNull)(w.select)?!0:w.select,r=(0,O.isUndefinedOrNull)(w.focus)?!1:w.focus,a=(0,O.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(d=>this.P(g,d[d.length-1]).then(c=>this.D.$reveal(this.C,{item:c.item,parentChain:d.map(u=>u.item)},{select:s,focus:r,expand:a})),d=>this.G.error(d)):this.D.$reveal(this.C,void 0,{select:s,focus:r,expand:a})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=f.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,w){const s=this.getExtensionElement(g);s&&(w?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(g){(0,D.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const w=(await Promise.all(g.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);w.forEach(s=>{s.treeItem.checkboxState=s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(s=>[s.extensionItem,s.newState])})}async handleDrag(g,w,s){const r=[];for(const a of g){const d=this.getExtensionElement(a);d&&r.push(d)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,w,s),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,w,s){const r=w?this.getExtensionElement(w):void 0;if(!(!r&&w||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,g,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,w){if(!this.f.resolveTreeItem)return;const s=this.i.get(g);if(s){const r=this.j.get(s);if(r){const a=await this.f.resolveTreeItem(r.extensionItem,s,w)??r.extensionItem;return this.db(a),r.item.tooltip=this.ab(a.tooltip),r.item.command=this.bb(r.disposableStore,a.command),r.item}}}N(g){return this.O(g).then(w=>w?this.N(w).then(s=>this.P(w,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}O(g){const w=this.j.get(g);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(g))}P(g,w){const s=this.j.get(g);return s?Promise.resolve(s):(0,S.asPromise)(()=>this.f.getTreeItem(g)).then(r=>this.gb(g,r,w,!0)).then(r=>this.getChildren(w?w.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const d=this.j.get(a);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(g){if(g){let w;if(typeof g=="string"){const s=this.getExtensionElement(g);w=s?this.j.get(s):void 0}else w=g;return w&&w.children||void 0}return this.h}async R(g){this.nb(g);const w=new v.CancellationTokenSource(this.S.token);try{const s=g?this.j.get(g):void 0,r=await this.f.getChildren(g);if(w.token.isCancellationRequested)return;const a=await Promise.all((0,D.coalesce)(r||[]).map(async d=>{const c=await this.f.getTreeItem(d);return c&&!w.token.isCancellationRequested?this.Z(d,c,s):null}));return w.token.isCancellationRequested?void 0:(0,D.coalesce)(a)}finally{w.dispose()}}U(g){if(g.some(s=>!s))return this.S.dispose(!0),this.S=new v.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(g);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(g){const w=new Set,s=g.map(a=>this.j.get(a));for(const a of s)if(a&&!w.has(a.item.handle)){let d=a;for(;d&&d.parent&&s.findIndex(c=>d&&d.parent&&c&&c.item.handle===d.parent.item.handle)===-1;){const c=this.i.get(d.parent.item.handle);d=c?this.j.get(c):void 0}d&&!d.parent&&w.add(a.item.handle)}const r=[];return w.forEach(a=>{const d=this.i.get(a);if(d){const c=this.j.get(d);c&&(!c.parent||!w.has(c.parent.item.handle))&&r.push(a)}}),r}X(g){const w={};return Promise.all(g.map(s=>this.Y(s).then(r=>{r&&(w[s]=r.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(g){const w=this.getExtensionElement(g);if(w){const s=this.j.get(w);if(s)return this.nb(w),(0,S.asPromise)(()=>this.f.getTreeItem(w)).then(r=>{if(r){const a=this.eb(w,r,s.parent);return this.lb(w,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}Z(g,w,s){const r=this.eb(g,w,s);if(w.id&&this.i.has(r.item.handle))throw new Error((0,n.localize)(10,null,w.id));return this.kb(g,r),this.mb(r,s),r}ab(g){return k.MarkdownString.isMarkdownString(g)?f.MarkdownString.from(g):g}bb(g,w){return w?{...this.F.toInternal(w,g),originalId:w.command}:void 0}cb(g){if(!g.checkboxState)return;let w,s;return typeof g.checkboxState=="number"?w=g.checkboxState:(w=g.checkboxState.state,s=g.checkboxState.tooltip),{isChecked:w===k.TreeItemCheckboxState.Checked,tooltip:s}}db(g){if(!k.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,w,s){this.db(w);const r=new R.DisposableStore,a=this.gb(g,w,s),d=this.hb(w);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:o(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(r,w.command),contextValue:w.contextValue,icon:d,iconDark:this.ib(w)||d,themeIcon:this.fb(w),collapsibleState:(0,O.isUndefinedOrNull)(w.collapsibleState)?k.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(g){return g.iconPath instanceof k.ThemeIcon?g.iconPath:void 0}gb(g,{id:w,label:s,resourceUri:r},a,d){if(w)return`${E.b}/${w}`;const c=o(s,this.H),u=a?a.item.handle:E.a;let t=c?c.label:r?(0,y.basename)(r):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const m=this.j.has(g)?this.j.get(g).item.handle:void 0,p=this.Q(a)||[];let A,N=0;do{if(A=`${u}/${N}:${t}`,d||!this.i.has(A)||m===A)break;N++}while(N<=p.length);return A}hb(g){if(g.iconPath&&!(g.iconPath instanceof k.ThemeIcon))return typeof g.iconPath=="string"||L.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof k.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return L.URI.isUri(g)?g:L.URI.file(g)}kb(g,w){this.i.set(w.item.handle,g),this.j.set(g,w)}lb(g,w,s,r){this.i.delete(w.item.handle),this.j.delete(g),w.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(g,w);const a=this.Q(r)||[],d=a.filter(c=>c.item.handle===s.item.handle)[0];d&&a.splice(a.indexOf(d),1,w)}mb(g,w){w?(w.children||(w.children=[]),w.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const w=this.j.get(g);if(w){if(w.children)for(const s of w.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}w.children=void 0}}else this.pb()}ob(g){const w=this.j.get(g);if(w){if(w.children)for(const s of w.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}this.j.delete(g),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}E.a="0",E.b="1"}),define(Ie[245],Ce([1,0,20,11,5,29,2,124,254,113,122,36,4,69,197,196,38,198,32,200,201,202,185,203,55,33,205,206,209,211,213,101,188,218,219,220,75,58,223,244,8,6,91,226,59,100,31,175,208,48,99,103,105,106,12,52,14,27,214,183,65,72,194,224,76,57,229,227,228,195,37,221,225,74,56,70,215,102,216,13,87,187,166,207,7,25,170,73,163,217]),function(te,e,n,T,y,L,C,R,S,k,O,D,f,v,h,i,o,l,E,b,g,w,s,r,a,d,c,u,t,m,p,A,N,q,j,V,P,M,F,$,z,K,X,Z,he,oe,ue,ce,fe,Y,ge,we,Me,We,Qe,Te,De,ke,re,ae,J,I,U,H,G,ee,le,Se,se,ve,be,$e,He,tt,xe,et,it,dt,Fe,st,_,Q,pe,Ne,Be,je,Je,nt,vt,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Tt(lt){const at=lt.get(ke.IExtHostInitDataService),Ut=lt.get(be.IExtHostFileSystemInfo),Ft=lt.get(ee.IExtHostConsumerFileSystem),Mt=lt.get(d.IExtHostExtensionService),ft=lt.get(ue.IExtHostWorkspace),Ct=lt.get(et.IExtHostTelemetry),Bt=lt.get(E.IExtHostConfiguration),Nt=lt.get(Te.IURITransformerService),Ge=lt.get(De.IExtHostRpcService),Rt=lt.get(P.IExtHostStorage),Lt=lt.get(G.IExtensionStoragePaths),Ht=lt.get(Qe.ILoggerService),mt=lt.get(Qe.ILogService),At=lt.get(J.IExtHostTunnelService),ye=lt.get(I.IExtHostApiDeprecationService),Pe=lt.get(oe.IExtHostWindow),me=lt.get(tt.IExtHostSecretState),x=lt.get(xe.IExtHostEditorTabs);Ge.set(f.ExtHostContext.ExtHostFileSystemInfo,Ut),Ge.set(f.ExtHostContext.ExtHostLogLevelServiceShape,Ht),Ge.set(f.ExtHostContext.ExtHostWorkspace,ft),Ge.set(f.ExtHostContext.ExtHostConfiguration,Bt),Ge.set(f.ExtHostContext.ExtHostExtensionService,Mt),Ge.set(f.ExtHostContext.ExtHostStorage,Rt),Ge.set(f.ExtHostContext.ExtHostTunnelService,At),Ge.set(f.ExtHostContext.ExtHostWindow,Pe),Ge.set(f.ExtHostContext.ExtHostSecretState,me),Ge.set(f.ExtHostContext.ExtHostTelemetry,Ct),Ge.set(f.ExtHostContext.ExtHostEditorTabs,x);const Ae=Ge.set(f.ExtHostContext.ExtHostDecorations,lt.get(ge.IExtHostDecorations)),Le=Ge.set(f.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(a.IExtHostDocumentsAndEditors)),Xe=Ge.set(f.ExtHostContext.ExtHostCommands,lt.get(o.IExtHostCommands)),ze=Ge.set(f.ExtHostContext.ExtHostTerminalService,lt.get(M.IExtHostTerminalService)),Ze=Ge.set(f.ExtHostContext.ExtHostDebugService,lt.get(Me.IExtHostDebugService)),It=Ge.set(f.ExtHostContext.ExtHostSearch,lt.get(We.IExtHostSearch)),bt=Ge.set(f.ExtHostContext.ExtHostTask,lt.get(we.IExtHostTask)),kt=Ge.set(f.ExtHostContext.ExtHostOutputService,lt.get(A.IExtHostOutputService)),gt=Ge.set(f.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),pt=Ge.set(f.ExtHostContext.ExtHostUrls,new Z.ExtHostUrls(Ge)),St=Ge.set(f.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(Ge,Le)),$t=Ge.set(f.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ge,Le,mt)),Xt=Ge.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(mt,St,Ge.getProxy(f.MainContext.MainThreadBulkEdits))),Et=Ge.set(f.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(Ge,Xe,Le,St)),si=Ge.set(f.ExtHostContext.ExtHostNotebookDocuments,new pe.ExtHostNotebookDocuments(Et)),oi=Ge.set(f.ExtHostContext.ExtHostNotebookEditors,new Q.ExtHostNotebookEditors(mt,Et)),Zt=Ge.set(f.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,at,Et,Xe,mt)),pi=Ge.set(f.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,Et)),yt=Ge.set(f.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ge,Le)),ai=Ge.set(f.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(Ge.getProxy(f.MainContext.MainThreadTreeViews),Xe,mt)),Oi=Ge.set(f.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(Ge.getProxy(f.MainContext.MainThreadEditorInsets),yt,at.remote)),ei=Ge.set(f.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Ge,mt,Ut,Le)),Vt=Ge.set(f.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(Ge,St,Xe.converter,Nt)),ct=Ge.set(f.ExtHostContext.ExtHostLanguageFeatures,new t.ExtHostLanguageFeatures(Ge,Nt,St,Xe,ei,mt,ye,Ct)),vi=Ge.set(f.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ge,ct)),jt=Ge.set(f.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Ge,mt,Le)),Qt=Ge.set(f.ExtHostContext.ExtHostQuickOpen,(0,q.createExtHostQuickOpen)(Ge,ft,Xe)),ci=Ge.set(f.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(Ge,Xe,mt)),bi=Ge.set(f.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,Xe,St)),ui=Ge.set(f.ExtHostContext.ExtHostProgress,new N.ExtHostProgress(Ge.getProxy(f.MainContext.MainThreadProgress))),Ei=Ge.set(f.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(Ge)),Ci=Ge.set(f.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ge)),ti=Ge.set(f.ExtHostContext.ExtHostAuthentication,new U.ExtHostAuthentication(Ge)),wi=Ge.set(f.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(Ge,Xe)),ni=Ge.set(f.ExtHostContext.ExtHostWebviews,new he.ExtHostWebviews(Ge,at.remote,ft,mt,ye)),ri=Ge.set(f.ExtHostContext.ExtHostWebviewPanels,new se.ExtHostWebviewPanels(Ge,ni,ft)),Fi=Ge.set(f.ExtHostContext.ExtHostCustomEditors,new Se.ExtHostCustomEditors(Ge,St,Lt,ni,ri)),Si=Ge.set(f.ExtHostContext.ExtHostWebviewViews,new le.ExtHostWebviewViews(Ge,ni)),_t=Ge.set(f.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(Ge,Xe,Le)),Mi=Ge.set(f.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),Ni=Ge.set(f.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(Ge));Ge.set(f.ExtHostContext.ExtHostInteractive,new Ne.ExtHostInteractive(Ge,Et,Le,Xe,mt));const Li=Object.values(f.ExtHostContext);Ge.assertRegistered(Li);const Ui=new ve.ExtHostBulkEdits(Ge,Le),Bi=new i.ExtHostClipboard(Ge),yi=new p.ExtHostMessageService(Ge,mt),li=new g.ExtHostDialogs(Ge),di=new V.ExtHostStatusBar(Ge,Xe.converter);return h.ExtHostApiCommands.register(Xe),function(Ue,Kt,ki){const ht=function(){let ne=!Ue.isUnderDevelopment;function de(){ne||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(rt){if(Array.isArray(rt))rt.forEach(Oe);else if(typeof rt=="string")de();else{const Dt=rt;typeof Dt.scheme>"u"&&de(),typeof Dt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),$i={getSession(ne,de,Oe){return ti.getSession(Ue,ne,de,Oe)},async hasSession(ne,de){return(0,je.checkProposedApiEnabled)(Ue,"authSession"),!!await ti.getSession(Ue,ne,de,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ne,de,Oe,rt){return ti.registerAuthenticationProvider(ne,de,Oe,rt)}},zi={registerCommand(ne,de,Oe){return Xe.registerCommand(!0,ne,de,Oe,void 0,Ue)},registerTextEditorCommand(ne,de,Oe){return Xe.registerCommand(!0,ne,(...rt)=>{const Dt=yt.getActiveTextEditor();if(!Dt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(Pt=>{de.apply(Oe,[Dt,Pt,...rt])}).then(Pt=>{Pt||mt.warn("Edits from command "+ne+" were not applied.")},Pt=>{mt.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,de,Oe)=>((0,je.checkProposedApiEnabled)(Ue,"diffCommand"),Xe.registerCommand(!0,ne,async(...rt)=>{const Dt=Le.activeEditor(!0);if(!Dt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await yt.getDiffInformation(Dt.id);de.apply(Oe,[Pt,...rt])},void 0,void 0,Ue)),executeCommand(ne,...de){return Xe.executeCommand(ne,...de)},getCommands(ne=!1){return Xe.getCommands(ne)}},Ti={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return Bi.value},get shell(){return ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Ue,"envShellEvent"),ze.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,je.checkProposedApiEnabled)(Ue,"telemetryLogger"),Ct.instantiateLogger(Ue,ne)},openExternal(ne,de){return Pe.openUri(ne,{allowTunneling:!!at.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===at.environment.appUriScheme)return pt.createAppUri(ne);try{return await Pe.asExternalUri(ne,{allowTunneling:!!at.remote.authority})}catch(de){if((0,_.matchesScheme)(ne,st.Schemas.http)||(0,_.matchesScheme)(ne,st.Schemas.https))return ne;throw de}},get remoteName(){return(0,Y.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return mt.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(Ti);const Wi={createTestController(ne,de,Oe){return _t.createTestController(ne,de,Oe)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.createTestObserver()},runTests(ne){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.runTests(ne)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.results}},ii=at.remote.isRemote?K.ExtensionKind.Workspace:K.ExtensionKind.UI,Hi={getExtension(ne,de){(0,je.isProposedApiEnabled)(Ue,"extensionsAny")||(de=!1);const Oe=Kt.mine.getExtensionDescription(ne);if(Oe)return new d.Extension(Mt,Ue.identifier,Oe,ii,!1);if(de){const rt=Kt.all.getExtensionDescription(ne);if(rt)return new d.Extension(Mt,Ue.identifier,rt,ii,!0)}},get all(){const ne=[];for(const de of Kt.mine.getAllExtensionDescriptions())ne.push(new d.Extension(Mt,Ue.identifier,de,ii,!1));return ne},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new je.ExtensionIdentifierSet(Kt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),de=[];for(const Oe of Kt.all.getAllExtensionDescriptions()){const rt=!ne.has(Oe.identifier);de.push(new d.Extension(Mt,Ue.identifier,Oe,ii,rt))}return de},get onDidChange(){return(0,je.isProposedApiEnabled)(Ue,"extensionsAny")?y.Event.any(Kt.mine.onDidChange,Kt.all.onDidChange):Kt.mine.onDidChange}},Gt={createDiagnosticCollection(ne){return ei.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:ne=>ei.getDiagnostics(ne),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(ne,de){return Vt.changeLanguage(ne.uri,de)},match(ne,de){const Oe=St.getDocumentData(de.uri)?.notebook;return(0,O.score)(z.LanguageSelector.from(ne),de.uri,de.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ne,de,Oe){return ct.registerCodeActionProvider(Ue,ht(ne),de,Oe)},registerDocumentPasteEditProvider(ne,de,Oe){return(0,je.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,ht(ne),de,Oe)},registerCodeLensProvider(ne,de){return ct.registerCodeLensProvider(Ue,ht(ne),de)},registerDefinitionProvider(ne,de){return ct.registerDefinitionProvider(Ue,ht(ne),de)},registerDeclarationProvider(ne,de){return ct.registerDeclarationProvider(Ue,ht(ne),de)},registerImplementationProvider(ne,de){return ct.registerImplementationProvider(Ue,ht(ne),de)},registerTypeDefinitionProvider(ne,de){return ct.registerTypeDefinitionProvider(Ue,ht(ne),de)},registerHoverProvider(ne,de){return ct.registerHoverProvider(Ue,ht(ne),de,Ue.identifier)},registerEvaluatableExpressionProvider(ne,de){return ct.registerEvaluatableExpressionProvider(Ue,ht(ne),de,Ue.identifier)},registerInlineValuesProvider(ne,de){return ct.registerInlineValuesProvider(Ue,ht(ne),de,Ue.identifier)},registerDocumentHighlightProvider(ne,de){return ct.registerDocumentHighlightProvider(Ue,ht(ne),de)},registerLinkedEditingRangeProvider(ne,de){return ct.registerLinkedEditingRangeProvider(Ue,ht(ne),de)},registerReferenceProvider(ne,de){return ct.registerReferenceProvider(Ue,ht(ne),de)},registerRenameProvider(ne,de){return ct.registerRenameProvider(Ue,ht(ne),de)},registerDocumentSymbolProvider(ne,de,Oe){return ct.registerDocumentSymbolProvider(Ue,ht(ne),de,Oe)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,de){return ct.registerDocumentFormattingEditProvider(Ue,ht(ne),de)},registerDocumentRangeFormattingEditProvider(ne,de){return ct.registerDocumentRangeFormattingEditProvider(Ue,ht(ne),de)},registerOnTypeFormattingEditProvider(ne,de,Oe,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,ht(ne),de,[Oe].concat(rt))},registerDocumentSemanticTokensProvider(ne,de,Oe){return ct.registerDocumentSemanticTokensProvider(Ue,ht(ne),de,Oe)},registerDocumentRangeSemanticTokensProvider(ne,de,Oe){return ct.registerDocumentRangeSemanticTokensProvider(Ue,ht(ne),de,Oe)},registerSignatureHelpProvider(ne,de,Oe,...rt){return typeof Oe=="object"?ct.registerSignatureHelpProvider(Ue,ht(ne),de,Oe):ct.registerSignatureHelpProvider(Ue,ht(ne),de,typeof Oe>"u"?[]:[Oe,...rt])},registerCompletionItemProvider(ne,de,...Oe){return ct.registerCompletionItemProvider(Ue,ht(ne),de,Oe)},registerInlineCompletionItemProvider(ne,de){return de.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,ht(ne),de)},registerDocumentLinkProvider(ne,de){return ct.registerDocumentLinkProvider(Ue,ht(ne),de)},registerColorProvider(ne,de){return ct.registerColorProvider(Ue,ht(ne),de)},registerFoldingRangeProvider(ne,de){return ct.registerFoldingRangeProvider(Ue,ht(ne),de)},registerSelectionRangeProvider(ne,de){return ct.registerSelectionRangeProvider(Ue,ne,de)},registerCallHierarchyProvider(ne,de){return ct.registerCallHierarchyProvider(Ue,ne,de)},registerTypeHierarchyProvider(ne,de){return ct.registerTypeHierarchyProvider(Ue,ne,de)},setLanguageConfiguration:(ne,de)=>ct.setLanguageConfiguration(Ue,ne,de),getTokenInformationAtPosition(ne,de){return(0,je.checkProposedApiEnabled)(Ue,"tokenInformation"),Vt.tokenAtPosition(ne,de)},registerInlayHintsProvider(ne,de){return ct.registerInlayHintsProvider(Ue,ne,de)},createLanguageStatusItem(ne,de){return Vt.createLanguageStatusItem(Ue,ne,de)},registerDocumentDropEditProvider(ne,de){return ct.registerDocumentOnDropEditProvider(Ue,ne,de)}},hi={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ze.activeTerminal},get terminals(){return ze.terminals},async showTextDocument(ne,de,Oe){const rt=await(C.URI.isUri(ne)?Promise.resolve(Pi.openTextDocument(ne)):Promise.resolve(ne));return yt.showTextDocument(rt,de,Oe)},createTextEditorDecorationType(ne){return yt.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,de,Oe){return yt.onDidChangeActiveTextEditor(ne,de,Oe)},onDidChangeVisibleTextEditors(ne,de,Oe){return yt.onDidChangeVisibleTextEditors(ne,de,Oe)},onDidChangeTextEditorSelection(ne,de,Oe){return yt.onDidChangeTextEditorSelection(ne,de,Oe)},onDidChangeTextEditorOptions(ne,de,Oe){return yt.onDidChangeTextEditorOptions(ne,de,Oe)},onDidChangeTextEditorVisibleRanges(ne,de,Oe){return yt.onDidChangeTextEditorVisibleRanges(ne,de,Oe)},onDidChangeTextEditorViewColumn(ne,de,Oe){return yt.onDidChangeTextEditorViewColumn(ne,de,Oe)},onDidCloseTerminal(ne,de,Oe){return ze.onDidCloseTerminal(ne,de,Oe)},onDidOpenTerminal(ne,de,Oe){return ze.onDidOpenTerminal(ne,de,Oe)},onDidChangeActiveTerminal(ne,de,Oe){return ze.onDidChangeActiveTerminal(ne,de,Oe)},onDidChangeTerminalDimensions(ne,de,Oe){return(0,je.checkProposedApiEnabled)(Ue,"terminalDimensions"),ze.onDidChangeTerminalDimensions(ne,de,Oe)},onDidChangeTerminalState(ne,de,Oe){return ze.onDidChangeTerminalState(ne,de,Oe)},onDidWriteTerminalData(ne,de,Oe){return(0,je.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),ze.onDidWriteTerminalData(ne,de,Oe)},get state(){return Pe.state},onDidChangeWindowState(ne,de,Oe){return Pe.onDidChangeWindowState(ne,de,Oe)},showInformationMessage(ne,...de){return yi.showMessage(Ue,L.default.Info,ne,de[0],de.slice(1))},showWarningMessage(ne,...de){return yi.showMessage(Ue,L.default.Warning,ne,de[0],de.slice(1))},showErrorMessage(ne,...de){return yi.showMessage(Ue,L.default.Error,ne,de[0],de.slice(1))},showQuickPick(ne,de,Oe){return Qt.showQuickPick(ne,de,Oe)},showWorkspaceFolderPick(ne){return Qt.showWorkspaceFolderPick(ne)},showInputBox(ne,de){return Qt.showInput(ne,de)},showOpenDialog(ne){return li.showOpenDialog(ne)},showSaveDialog(ne){return li.showSaveDialog(ne)},createStatusBarItem(ne,de,Oe){let rt,Dt,Pt;return typeof ne=="string"?(rt=ne,Dt=de,Pt=Oe):(Dt=ne,Pt=de),di.createStatusBarEntry(Ue,rt,Dt,Pt)},setStatusBarMessage(ne,de){return di.setStatusBarMessage(ne,de)},withScmProgress(ne){return ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ui.withProgress(Ue,{location:K.ProgressLocation.SourceControl},(de,Oe)=>ne({report(rt){}}))},withProgress(ne,de){return ui.withProgress(Ue,ne,de)},createOutputChannel(ne,de){return kt.createOutputChannel(ne,de,Ue)},createWebviewPanel(ne,de,Oe,rt){return ri.createWebviewPanel(Ue,ne,de,Oe,rt)},createWebviewTextEditorInset(ne,de,Oe,rt){return(0,je.checkProposedApiEnabled)(Ue,"editorInsets"),Oi.createWebviewEditorInset(ne,de,Oe,rt,Ue)},createTerminal(ne,de,Oe){return typeof ne=="object"?"pty"in ne?ze.createExtensionTerminal(ne):ze.createTerminalFromOptions(ne):ze.createTerminal(ne,de,Oe)},registerTerminalLinkProvider(ne){return ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,de){return ze.registerProfileProvider(Ue,ne,de)},registerTerminalQuickFixProvider(ne,de){return(0,je.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),ze.registerTerminalQuickFixProvider(ne,Ue.identifier.value,de)},registerTreeDataProvider(ne,de){return ai.registerTreeDataProvider(ne,de,Ue)},createTreeView(ne,de){return ai.createTreeView(ne,de,Ue)},registerWebviewPanelSerializer:(ne,de)=>ri.registerWebviewPanelSerializer(Ue,ne,de),registerCustomEditorProvider:(ne,de,Oe={})=>Fi.registerCustomEditorProvider(Ue,ne,de,Oe),registerFileDecorationProvider(ne){return Ae.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return pt.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return Ci.activeColorTheme},onDidChangeActiveColorTheme(ne,de,Oe){return Ci.onDidChangeActiveColorTheme(ne,de,Oe)},registerWebviewViewProvider(ne,de,Oe){return Si.registerWebviewViewProvider(Ue,ne,de,Oe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,de,Oe){return Et.onDidChangeActiveNotebookEditor(ne,de,Oe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,de,Oe){return oi.onDidChangeNotebookEditorSelection(ne,de,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,de,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(ne,de,Oe)},showNotebookDocument(ne,de){return Et.showNotebookDocument(ne,de)},registerExternalUriOpener(ne,de,Oe){return(0,je.checkProposedApiEnabled)(Ue,"externalUriOpener"),Mi.registerExternalUriOpener(Ue.identifier,ne,de,Oe)},registerProfileContentHandler(ne,de){return(0,je.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Ni.registrProfileContentHandler(Ue,ne,de)},get tabGroups(){return x.tabGroups}},Pi={get rootPath(){return ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw T.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw T.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw T.readonly()},updateWorkspaceFolders:(ne,de,...Oe)=>ft.updateWorkspaceFolders(Ue,ne,de||0,...Oe),onDidChangeWorkspaceFolders:function(ne,de,Oe){return ft.onDidChangeWorkspace(ne,de,Oe)},asRelativePath:(ne,de)=>ft.getRelativePath(ne,de),findFiles:(ne,de,Oe,rt)=>ft.findFiles(ne,de,Oe,Ue.identifier,rt),findTextInFiles:(ne,de,Oe,rt)=>{(0,je.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Pt;return typeof de=="object"?(Dt=de,Pt=Oe):(Dt={},Pt=de,rt=Oe),ft.findTextInFiles(ne,Dt||{},Pt,Ue.identifier,rt)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,de){return Ui.applyWorkspaceEdit(ne,Ue,de)},createFileSystemWatcher:(ne,de,Oe,rt)=>jt.createFileSystemWatcher(ft,Ue,ne,de,Oe,rt),get textDocuments(){return St.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw T.readonly()},openTextDocument(ne){let de;const Oe=ne;if(typeof ne=="string")de=Promise.resolve(C.URI.file(ne));else if(C.URI.isUri(ne))de=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")de=St.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>St.ensureDocumentData(rt).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,de,Oe)=>St.onDidAddDocument(ne,de,Oe),onDidCloseTextDocument:(ne,de,Oe)=>St.onDidRemoveDocument(ne,de,Oe),onDidChangeTextDocument:(ne,de,Oe)=>St.onDidChangeDocument(ne,de,Oe),onDidSaveTextDocument:(ne,de,Oe)=>St.onDidSaveDocument(ne,de,Oe),onWillSaveTextDocument:(ne,de,Oe)=>Xt.getOnWillSaveTextDocumentEvent(Ue)(ne,de,Oe),get notebookDocuments(){return Et.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,de){let Oe;if(C.URI.isUri(ne))Oe=ne,await Et.openNotebookDocument(ne);else if(typeof ne=="string")Oe=C.URI.revive(await Et.createNotebookDocument({viewType:ne,content:de}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,de,Oe){return si.onDidSaveNotebookDocument(ne,de,Oe)},onDidChangeNotebookDocument(ne,de,Oe){return si.onDidChangeNotebookDocument(ne,de,Oe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ne,de,Oe,rt){return Et.registerNotebookSerializer(Ue,ne,de,Oe,(0,je.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,de,Oe)=>ki.onDidChangeConfiguration(ne,de,Oe),getConfiguration(ne,de){return de=arguments.length===1?void 0:de,ki.getConfiguration(ne,de,Ue)},registerTextDocumentContentProvider(ne,de){return $t.registerTextDocumentContentProvider(ne,de)},registerTaskProvider:(ne,de)=>(ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Ue,ne,de)),registerFileSystemProvider(ne,de,Oe){return(0,Be.combinedDisposable)(vi.registerFileSystemProvider(Ue,ne,de,Oe),Ft.addFileSystemProvider(ne,de))},get fs(){return Ft.value},registerFileSearchProvider:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"fileSearchProvider"),It.registerFileSearchProvider(ne,de)),registerTextSearchProvider:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"textSearchProvider"),It.registerTextSearchProvider(ne,de)),registerRemoteAuthorityResolver:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Mt.registerRemoteAuthorityResolver(ne,de)),registerResourceLabelFormatter:ne=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Ei.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,de,Oe)=>jt.onDidCreateFile(ne,de,Oe),onDidDeleteFiles:(ne,de,Oe)=>jt.onDidDeleteFile(ne,de,Oe),onDidRenameFiles:(ne,de,Oe)=>jt.onDidRenameFile(ne,de,Oe),onWillCreateFiles:(ne,de,Oe)=>jt.getOnWillCreateFileEvent(Ue)(ne,de,Oe),onWillDeleteFiles:(ne,de,Oe)=>jt.getOnWillDeleteFileEvent(Ue)(ne,de,Oe),onWillRenameFiles:(ne,de,Oe)=>jt.getOnWillRenameFileEvent(Ue)(ne,de,Oe),openTunnel:ne=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),At.openTunnel(Ue,ne).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,je.checkProposedApiEnabled)(Ue,"tunnels"),At.getTunnels()},onDidChangeTunnels:(ne,de,Oe)=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),At.onDidChangeTunnels(ne,de,Oe)),registerPortAttributesProvider:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"portsAttributes"),At.registerPortsAttributesProvider(ne,de)),registerTimelineProvider:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"timeline"),wi.registerTimelineProvider(ne,de,Ue.identifier,Xe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,je.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,de,Oe)=>ft.onDidGrantWorkspaceTrust(ne,de,Oe),registerEditSessionIdentityProvider:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,de))},zt={get inputBox(){return ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Ue)},createSourceControl(ne,de,Oe){return ci.createSourceControl(Ue,ne,de,Oe)}},fi={createCommentController(ne,de){return bi.createCommentController(Ue,ne,de)}},Vi={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,de,Oe){return Ze.onDidStartDebugSession(ne,de,Oe)},onDidTerminateDebugSession(ne,de,Oe){return Ze.onDidTerminateDebugSession(ne,de,Oe)},onDidChangeActiveDebugSession(ne,de,Oe){return Ze.onDidChangeActiveDebugSession(ne,de,Oe)},onDidReceiveDebugSessionCustomEvent(ne,de,Oe){return Ze.onDidReceiveDebugSessionCustomEvent(ne,de,Oe)},onDidChangeBreakpoints(ne,de,Oe){return Ze.onDidChangeBreakpoints(ne,de,Oe)},registerDebugConfigurationProvider(ne,de,Oe){return Ze.registerDebugConfigurationProvider(ne,de,Oe||Je.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,de){return Ze.registerDebugAdapterDescriptorFactory(Ue,ne,de)},registerDebugAdapterTrackerFactory(ne,de){return Ze.registerDebugAdapterTrackerFactory(ne,de)},startDebugging(ne,de,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Ze.startDebugging(ne,de,{parentSession:Oe}):Ze.startDebugging(ne,de,Oe||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,de){return Ze.asDebugSourceUri(ne,de)}},ji={registerTaskProvider:(ne,de)=>bt.registerTaskProvider(Ue,ne,de),fetchTasks:ne=>bt.fetchTasks(ne),executeTask:ne=>bt.executeTask(Ue,ne),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(ne,de,Oe)=>bt.onDidStartTask(ne,de,Oe),onDidEndTask:(ne,de,Oe)=>bt.onDidEndTask(ne,de,Oe),onDidStartTaskProcess:(ne,de,Oe)=>bt.onDidStartTaskProcess(ne,de,Oe),onDidEndTaskProcess:(ne,de,Oe)=>bt.onDidEndTaskProcess(ne,de,Oe)},qi={createNotebookController(ne,de,Oe,rt,Dt){return Zt.createNotebookController(Ue,ne,de,Oe,rt,(0,je.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,de)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ne,de),createRendererMessaging(ne){return pi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,de){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,ne,de)},onDidChangeNotebookCellExecutionState(ne,de,Oe){return(0,je.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ne,de,Oe)}},Ki={t(...ne){if(typeof ne[0]=="string"){const de=ne.shift(),Oe=!ne||typeof ne[0]!="object"?ne:ne[0];return gt.getMessage(Ue.identifier.value,{message:de,args:Oe})}return gt.getMessage(Ue.identifier.value,ne[0])},get bundle(){return gt.getBundle(Ue.identifier.value)},get uri(){return gt.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:$i,commands:zi,comments:fi,debug:Vi,env:Ti,extensions:Hi,l10n:Ki,languages:Gt,notebooks:qi,scm:zt,tasks:ji,tests:Wi,window:hi,workspace:Pi,Breakpoint:K.Breakpoint,TerminalOutputAnchor:K.TerminalOutputAnchor,CallHierarchyIncomingCall:K.CallHierarchyIncomingCall,CallHierarchyItem:K.CallHierarchyItem,CallHierarchyOutgoingCall:K.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:K.CodeAction,CodeActionKind:K.CodeActionKind,CodeActionTriggerKind:K.CodeActionTriggerKind,CodeLens:K.CodeLens,Color:K.Color,ColorInformation:K.ColorInformation,ColorPresentation:K.ColorPresentation,ColorThemeKind:K.ColorThemeKind,CommentMode:K.CommentMode,CommentThreadCollapsibleState:K.CommentThreadCollapsibleState,CommentThreadState:K.CommentThreadState,CompletionItem:K.CompletionItem,CompletionItemKind:K.CompletionItemKind,CompletionItemTag:K.CompletionItemTag,CompletionList:K.CompletionList,CompletionTriggerKind:K.CompletionTriggerKind,ConfigurationTarget:K.ConfigurationTarget,CustomExecution:K.CustomExecution,DebugAdapterExecutable:K.DebugAdapterExecutable,DebugAdapterInlineImplementation:K.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:K.DebugAdapterNamedPipeServer,DebugAdapterServer:K.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Je.DebugConfigurationProviderTriggerKind,DebugConsoleMode:K.DebugConsoleMode,DecorationRangeBehavior:K.DecorationRangeBehavior,Diagnostic:K.Diagnostic,DiagnosticRelatedInformation:K.DiagnosticRelatedInformation,DiagnosticSeverity:K.DiagnosticSeverity,DiagnosticTag:K.DiagnosticTag,Disposable:K.Disposable,DocumentHighlight:K.DocumentHighlight,DocumentHighlightKind:K.DocumentHighlightKind,DocumentLink:K.DocumentLink,DocumentSymbol:K.DocumentSymbol,EndOfLine:K.EndOfLine,EnvironmentVariableMutatorType:K.EnvironmentVariableMutatorType,EvaluatableExpression:K.EvaluatableExpression,InlineValueText:K.InlineValueText,InlineValueVariableLookup:K.InlineValueVariableLookup,InlineValueEvaluatableExpression:K.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:K.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:K.ExtensionKind,ExtensionMode:K.ExtensionMode,ExternalUriOpenerPriority:K.ExternalUriOpenerPriority,FileChangeType:K.FileChangeType,FileDecoration:K.FileDecoration,FileDecoration2:K.FileDecoration,FileSystemError:K.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:K.FoldingRange,FoldingRangeKind:K.FoldingRangeKind,FunctionBreakpoint:K.FunctionBreakpoint,InlineCompletionItem:K.InlineSuggestion,InlineCompletionList:K.InlineSuggestionList,Hover:K.Hover,IndentAction:k.IndentAction,Location:K.Location,MarkdownString:K.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:K.ParameterInformation,PortAutoForwardAction:K.PortAutoForwardAction,Position:K.Position,ProcessExecution:K.ProcessExecution,ProgressLocation:K.ProgressLocation,QuickInputButtons:K.QuickInputButtons,Range:K.Range,RelativePattern:K.RelativePattern,Selection:K.Selection,SelectionRange:K.SelectionRange,SemanticTokens:K.SemanticTokens,SemanticTokensBuilder:K.SemanticTokensBuilder,SemanticTokensEdit:K.SemanticTokensEdit,SemanticTokensEdits:K.SemanticTokensEdits,SemanticTokensLegend:K.SemanticTokensLegend,ShellExecution:K.ShellExecution,ShellQuoting:K.ShellQuoting,SignatureHelp:K.SignatureHelp,SignatureHelpTriggerKind:K.SignatureHelpTriggerKind,SignatureInformation:K.SignatureInformation,SnippetString:K.SnippetString,SourceBreakpoint:K.SourceBreakpoint,StandardTokenType:K.StandardTokenType,StatusBarAlignment:K.StatusBarAlignment,SymbolInformation:K.SymbolInformation,SymbolKind:K.SymbolKind,SymbolTag:K.SymbolTag,Task:K.Task,TaskGroup:K.TaskGroup,TaskPanelKind:K.TaskPanelKind,TaskRevealKind:K.TaskRevealKind,TaskScope:K.TaskScope,TerminalLink:K.TerminalLink,TerminalLocation:K.TerminalLocation,TerminalProfile:K.TerminalProfile,TerminalExitReason:K.TerminalExitReason,TerminalQuickFixType:K.TerminalQuickFixType,TextDocumentSaveReason:K.TextDocumentSaveReason,TextEdit:K.TextEdit,SnippetTextEdit:K.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:K.TextEditorLineNumbersStyle,TextEditorRevealType:K.TextEditorRevealType,TextEditorSelectionChangeKind:K.TextEditorSelectionChangeKind,TextDocumentChangeReason:K.TextDocumentChangeReason,ThemeColor:K.ThemeColor,ThemeIcon:K.ThemeIcon,TreeItem:K.TreeItem,TreeItem2:K.TreeItem,TreeItemCheckboxState:K.TreeItemCheckboxState,TreeItemCollapsibleState:K.TreeItemCollapsibleState,TypeHierarchyItem:K.TypeHierarchyItem,UIKind:v.UIKind,Uri:C.URI,ViewColumn:K.ViewColumn,WorkspaceEdit:K.WorkspaceEdit,DocumentDropEdit:K.DocumentDropEdit,DocumentPasteEdit:K.DocumentPasteEdit,InlayHint:K.InlayHint,InlayHintLabelPart:K.InlayHintLabelPart,InlayHintKind:K.InlayHintKind,RemoteAuthorityResolverError:K.RemoteAuthorityResolverError,ResolvedAuthority:K.ResolvedAuthority,SourceControlInputBoxValidationType:K.SourceControlInputBoxValidationType,ExtensionRuntime:K.ExtensionRuntime,TimelineItem:K.TimelineItem,NotebookRange:K.NotebookRange,NotebookCellKind:K.NotebookCellKind,NotebookCellExecutionState:K.NotebookCellExecutionState,NotebookCellData:K.NotebookCellData,NotebookData:K.NotebookData,NotebookRendererScript:K.NotebookRendererScript,NotebookCellStatusBarAlignment:K.NotebookCellStatusBarAlignment,NotebookEditorRevealType:K.NotebookEditorRevealType,NotebookCellOutput:K.NotebookCellOutput,NotebookCellOutputItem:K.NotebookCellOutputItem,NotebookCellStatusBarItem:K.NotebookCellStatusBarItem,NotebookControllerAffinity:K.NotebookControllerAffinity,NotebookControllerAffinity2:K.NotebookControllerAffinity2,NotebookEdit:K.NotebookEdit,NotebookKernelSourceAction:K.NotebookKernelSourceAction,PortAttributes:K.PortAttributes,LinkedEditingRanges:K.LinkedEditingRanges,TestResultState:K.TestResultState,TestRunRequest:K.TestRunRequest,TestMessage:K.TestMessage,TestTag:K.TestTag,TestRunProfileKind:K.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:K.DataTransfer,DataTransferItem:K.DataTransferItem,CoveredCount:K.CoveredCount,FileCoverage:K.FileCoverage,StatementCoverage:K.StatementCoverage,BranchCoverage:K.BranchCoverage,FunctionCoverage:K.FunctionCoverage,WorkspaceTrustState:K.WorkspaceTrustState,LanguageStatusSeverity:K.LanguageStatusSeverity,QuickPickItemKind:K.QuickPickItemKind,InputBoxValidationSeverity:K.InputBoxValidationSeverity,TabInputText:K.TextTabInput,TabInputTextDiff:K.TextDiffTabInput,TabInputTextMerge:K.TextMergeTabInput,TabInputCustom:K.CustomEditorTabInput,TabInputNotebook:K.NotebookEditorTabInput,TabInputNotebookDiff:K.NotebookDiffEditorTabInput,TabInputWebview:K.WebviewEditorTabInput,TabInputTerminal:K.TerminalEditorTabInput,TabInputInteractiveWindow:K.InteractiveWindowInput,TrustedTelemetryValue:X.TrustedTelemetryValue,LogLevel:Qe.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Tt}),define(Ie[246],Ce([1,0,245,33,2,239,6,15,230]),function(te,e,n,T,y,L,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends L.RequireInterceptor{j(){}getModule(v,h){for(const i of this.b){const o=i(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(S.ExtHostConsoleForwarder);const v=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,v,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(v){return v.browser}async pb(v,h,i){h=h.with({path:D(h.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const l=y.URI.revive(await this.v.$asBrowserUri(h)),E=await fetch(l.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),E.status!==200)throw new Error(E.statusText);const b=await E.text(),g=`${h.toString(!0)}#vscode-extension`,w=`${b}
//# sourceURL=${g}`;let s;try{s=new Function("module","exports","require",w)}catch(c){throw console.error(o?`Loading code for extension ${o} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${h.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}v&&await this.s.initializeLocalizedMessages(v);const r={},a={exports:r},d=c=>{const u=this.r.getModule(c,h);if(u===void 0)throw new Error(`Cannot load module '${c}'`);return u};try{return i.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),s(a,r,d),a.exports!==r?a.exports:r}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),i.codeLoadingStop()}}async $setRemoteEnvironment(v){}async tb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+v;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=O;function D(f,v){return f.endsWith(v)?f:f+v}}),define(Ie[247],Ce([1,0,62,33,76,246]),function(te,e,n,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(T.IExtHostExtensionService,L.ExtHostExtensionService,0),(0,n.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths,0)}),define(Ie[255],Ce([1,0,24,5,69,240,232,19,77,13,2,242,247]),function(te,e,n,T,y,L,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(s){return/^(file|vscode-remote):/i.test(s)}const h=fetch.bind(self);function i(s){self.fetch=async function(r,a){return r instanceof Request||v(String(r))&&(r=(await s(O.URI.parse(String(r)))).toString(!0)),h(r,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,a,d,c,u){(async()=>(v(a.toString())&&(a=(await s(O.URI.parse(a.toString()))).toString(!0)),super.open(r,a,d??!0,c,u)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(r,a){if(/^file:/i.test(r.toString()))r=k.FileAccess.uriToBrowserUri(O.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(p){function A(j){return typeof j=="string"||j instanceof URL?String(j).replace(/^file:\/\//i,"vscode-file://vscode-app"):j}const N=fetch.bind(self);self.fetch=function(j,V){return j instanceof Request?N(j,V):N(A(j),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(j,V,P,M,F){return super.open(j,A(V),P??!0,M,F)}};const q=importScripts.bind(self);self.importScripts=(...j)=>{q(...j.map(A))},q(p)}.toString()}('${r}'))`;a=a||{},a.name=a.name||R.basename(r.toString());const u=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(u);return new s(t,a)}}else self.Worker=class extends C.NestedWorker{constructor(s,r){super(f,s,{name:R.basename(s.toString()),...r})}};const o=new class{constructor(){this.pid=void 0}exit(s){D()}async exists(s){return!0}async realpath(s){return s}};class l{constructor(){const r=new MessageChannel,a=new T.Emitter;let d=!1;f(r.port2,[r.port2]),r.port1.onmessage=c=>{const{data:u}=c;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const t=n.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,y.isMessageOfType)(t,2)){d=!0,b("received terminate message from renderer");return}a.fire(t)},this.protocol={onMessage:a.event,send:c=>{if(!d){const u=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);r.port1.postMessage(u,[u])}}}}}function E(s){return new Promise(r=>{const a=s.onMessage(d=>{a.dispose();const c=JSON.parse(d.toString());s.send((0,y.createMessageOfType)(0)),r({protocol:s,initData:c})});s.send((0,y.createMessageOfType)(1))})}let b=s=>D();function g(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function w(){S.mark("code/extHost/willConnectToRenderer");const s=new l;return{onmessage(r){!g(r)||E(s.protocol).then(a=>{S.mark("code/extHost/didWaitForInitData");const d=new L.ExtensionHostMain(a.protocol,a.initData,o,null,r.data);i(c=>d.asBrowserUri(c)),b=c=>d.terminate(c)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/api/worker/extensionHostWorker.js.map
